/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0142
#ifndef __be2_gen_api_enum_h__
#define __be2_gen_api_enum_h__
#include "setypes.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- BE2_GEN_LINK_IF_TYPE_ENUM ---
#define BE2_GEN_LINK_IF_CX4             (0)       // CX4 interface 
#define BE2_GEN_LINK_IF_XFP             (1)       // XFP interface 
#define BE2_GEN_LINK_IF_SFP             (2)       // SFP interface 
#define BE2_GEN_LINK_IF_SFP_PLUS        (3)       // SFP+ interface 
#define BE2_GEN_LINK_IF_KR              (4)       // KR interface 
#define BE2_GEN_LINK_IF_KX4             (5)       // KX4 interface 

typedef enum {
   ENUM_BE2_GEN_LINK_IF_CX4 = 0x0UL,
   ENUM_BE2_GEN_LINK_IF_XFP = 0x1UL,
   ENUM_BE2_GEN_LINK_IF_SFP = 0x2UL,
   ENUM_BE2_GEN_LINK_IF_SFP_PLUS = 0x3UL,
   ENUM_BE2_GEN_LINK_IF_KR = 0x4UL,
   ENUM_BE2_GEN_LINK_IF_KX4 = 0x5UL
} BE2_GEN_LINK_IF_TYPE_ENUM;

// --- BE2_GEN_PHY_TYPE_ENUM ---
#define BE2_GEN_PHY_XAUI                (0)       // Internal XAUI PHY 
#define BE2_GEN_PHY_AEL2020             (1)       // Aeleuros 2020 PHY 
#define BE2_GEN_PHY_LSI_BRCM1           (2)       // PHY on Peak pre-production board 
#define BE2_GEN_PHY_LSI_BRCM2           (3)       // PHY on Peak production board 
#define BE2_GEN_PHY_SOLARFLARE          (4)       // Solarflare PHY 
#define BE2_GEN_PHY_QT2025              (5)       // AMCC PHY 
#define BE2_GEN_PHY_QT2225              (6)       // AMCC PHY 
#define BE2_GEN_PHY_BRCM_5931           (7)       // BCM PHY(LOM) 

typedef enum {
   ENUM_BE2_GEN_PHY_XAUI = 0x0UL,
   ENUM_BE2_GEN_PHY_AEL2020 = 0x1UL,
   ENUM_BE2_GEN_PHY_LSI_BRCM1 = 0x2UL,
   ENUM_BE2_GEN_PHY_LSI_BRCM2 = 0x3UL,
   ENUM_BE2_GEN_PHY_SOLARFLARE = 0x4UL,
   ENUM_BE2_GEN_PHY_QT2025 = 0x5UL,
   ENUM_BE2_GEN_PHY_QT2225 = 0x6UL,
   ENUM_BE2_GEN_PHY_BRCM_5931 = 0x7UL
} BE2_GEN_PHY_TYPE_ENUM;

// --- BE2_GEN_RSS_INTERFACE_ENUM ---
#define BE2_GEN_RSS_INTERFACE_0         (0)       // RSS interface 0. 
#define BE2_GEN_RSS_INTERFACE_1         (1)       // RSS interface 1. 
#define BE2_GEN_RSS_INTERFACE_NONE      (3)       // No RSS interface. 

typedef enum {
   ENUM_BE2_GEN_RSS_INTERFACE_0 = 0x0UL,
   ENUM_BE2_GEN_RSS_INTERFACE_1 = 0x1UL,
   ENUM_BE2_GEN_RSS_INTERFACE_NONE = 0x3UL
} BE2_GEN_RSS_INTERFACE_ENUM;

// --- BE_GEN_ENUM_GPIO_MODE ---
#define BE_GEN_GPIO_IN_MODE             (0)       // GPIO input mode (buffer/tri-state) 
#define BE_GEN_GPIO_OUT_MODE            (1)       // GPIO output mode (buffer/drive) 

typedef enum {
   ENUM_BE_GEN_GPIO_IN_MODE = 0x0UL,
   ENUM_BE_GEN_GPIO_OUT_MODE = 0x1UL
} BE_GEN_ENUM_GPIO_MODE;

// --- BE_GEN_ENUM_GPIO_BITS ---
#define BE_GEN_GPIO_BIT_MDIO_DATA       (4)       // MDIO data 
#define BE_GEN_GPIO_BIT_MDIO_CLOCK      (5)       // MDIO clock 
#define BE_GEN_GPIO_BIT_TRANSMITTER_ENABLE_PORTA (8) // Port0 transmitter enabled 
#define BE_GEN_GPIO_BIT_TRANSMITTER_ENABLE_PORTB (9) // Port1 transmitter enabled 
#define BE_GEN_GPIO_BIT_MODULE_DETECT_PORTA (14)  // Port0 module detected 
#define BE_GEN_GPIO_BIT_MODULE_DETECT_PORTB (15)  // Port1 module detected 

typedef enum {
   ENUM_BE_GEN_GPIO_BIT_MDIO_DATA = 0x4UL,
   ENUM_BE_GEN_GPIO_BIT_MDIO_CLOCK = 0x5UL,
   ENUM_BE_GEN_GPIO_BIT_TRANSMITTER_ENABLE_PORTA = 0x8UL,
   ENUM_BE_GEN_GPIO_BIT_TRANSMITTER_ENABLE_PORTB = 0x9UL,
   ENUM_BE_GEN_GPIO_BIT_MODULE_DETECT_PORTA = 0xeUL,
   ENUM_BE_GEN_GPIO_BIT_MODULE_DETECT_PORTB = 0xfUL
} BE_GEN_ENUM_GPIO_BITS;

// --- BE_GEN_ENUM_MDIO_MODE ---
#define BE_GEN_MDIO_OP_10G              (0)       // MDIO 10G mode 
#define BE_GEN_MDIO_OP_1G               (1)       // MDIO 1G mode 

typedef enum {
   ENUM_BE_GEN_MDIO_OP_10G = 0x0UL,
   ENUM_BE_GEN_MDIO_OP_1G = 0x1UL
} BE_GEN_ENUM_MDIO_MODE;

// --- BE2_GEN_CHIP_REVS_ENUM ---
#define BE2_GEN_ASIC_REV_MAX            (10)      // Maximum expected ASIC revision.
                                                  // Everything larger is assumed to be an
                                                  // FPGA. 
#define BE2_GEN_FPGA_A1_REV_MIN         (18432)   // Minimum FPGA A1 revision. Everything
                                                  // below this number but above the ASIC
                                                  // maximum is assumed an FPGA A0
                                                  // revision. 

typedef enum {
   ENUM_BE2_GEN_ASIC_REV_MAX = 0xaUL,
   ENUM_BE2_GEN_FPGA_A1_REV_MIN = 0x4800UL
} BE2_GEN_CHIP_REVS_ENUM;

// --- BE2_GEN_MAX_FRAME_SIZES_ENUM ---
#define BE2_GEN_TX_MAX_FRAME_SIZE       (9200)    // 9200 bytes maximum transmit frame
                                                  // size. This is a software imposed
                                                  // limitation to keep symmetry with the
                                                  // receive frame size maximum, which is
                                                  // a BE2 RXF FIFO limit. 
#define BE2_GEN_RX_MAX_FRAME_SIZE       (9200)    // 9200 bytes maximum receive frame
                                                  // size. This is a BE2 RXF FIFO size
                                                  // limit. 

typedef enum {
   ENUM_BE2_GEN_TX_MAX_FRAME_SIZE = 0x23f0UL,
   ENUM_BE2_GEN_RX_MAX_FRAME_SIZE = 0x23f0UL
} BE2_GEN_MAX_FRAME_SIZES_ENUM;

// --- BE2_GEN_EP_MEM_SIZES_ENUM ---
#define BE2_GEN_EP_IRAM_BYTE_SIZE       (4096)    // IRAM byte size: 4kB 
#define BE2_GEN_EP_DRAM_BYTE_SIZE       (16384)   // DRAM byte size: 16kB 

typedef enum {
   ENUM_BE2_GEN_EP_IRAM_BYTE_SIZE = 0x1000UL,
   ENUM_BE2_GEN_EP_DRAM_BYTE_SIZE = 0x4000UL
} BE2_GEN_EP_MEM_SIZES_ENUM;

#endif // __be2_gen_api_enum_h__

