/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __be3nic_v1_amap_h__
#define __be3nic_v1_amap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
typedef struct { BE_BIT native[8]; } BE_u8_V1_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_u16_V1_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_u32_V1_AMAP; // native

typedef struct { BE_BIT native[64]; } BE_u64_V1_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_void_V1_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_BOOLEAN_V1_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_EXACT8_V1_AMAP; // native

typedef struct { BE_BIT native[8]; } BE_UEXACT8_V1_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_EXACT16_V1_AMAP; // native

typedef struct { BE_BIT native[16]; } BE_UEXACT16_V1_AMAP; // native

typedef struct { BE_BIT native[32]; } BE_UEXACT32_V1_AMAP; // native

typedef struct { BE_BIT native[64]; } BE_UEXACT64_V1_AMAP; // native

typedef struct {
   BE_BIT lo[32];                                 // DWORD 0
   BE_BIT hi[32];                                 // DWORD 1
} SG_PACK BE_PHYS_ADDR_V1_AMAP;
typedef struct { u32 dw[2]; } PHYS_ADDR_V1_AMAP, *PPHYS_ADDR_V1_AMAP;


typedef struct {
   BE_UEXACT8_V1_AMAP opcode;
   BE_UEXACT8_V1_AMAP subsystem;
   BE_UEXACT8_V1_AMAP port_number;
   BE_UEXACT8_V1_AMAP domain;
   BE_UEXACT32_V1_AMAP timeout;
   BE_UEXACT32_V1_AMAP request_length;
   BE_UEXACT8_V1_AMAP version;
   BE_BIT rsvd0[3][8];                            // DWORD 3
} SG_PACK BE_IOCTL_REQUEST_HEADER_V1_AMAP;
typedef struct { u32 dw[4]; } IOCTL_REQUEST_HEADER_V1_AMAP, *PIOCTL_REQUEST_HEADER_V1_AMAP;


typedef struct {
   BE_UEXACT8_V1_AMAP opcode;
   BE_UEXACT8_V1_AMAP subsystem;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_V1_AMAP domain;
   BE_UEXACT8_V1_AMAP status;
   BE_UEXACT8_V1_AMAP additional_status;
   BE_BIT rsvd1[16];                              // DWORD 1
   BE_UEXACT32_V1_AMAP response_length;
   BE_UEXACT32_V1_AMAP actual_response_length;
} SG_PACK BE_IOCTL_RESPONSE_HEADER_V1_AMAP;
typedef struct { u32 dw[4]; } IOCTL_RESPONSE_HEADER_V1_AMAP, *PIOCTL_RESPONSE_HEADER_V1_AMAP;


typedef union {
   BE_IOCTL_REQUEST_HEADER_V1_AMAP request;
   BE_IOCTL_RESPONSE_HEADER_V1_AMAP response;
} SG_PACK BE_IOCTL_HEADER_V1_AMAP;
typedef struct { u32 dw[4]; } IOCTL_HEADER_V1_AMAP, *PIOCTL_HEADER_V1_AMAP;


typedef struct {
   BE_BIT qid[9];                                 // DWORD 0
   BE_BIT ClearInt;                               // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT num_popped[13];                         // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT r2i_dly_mult_enc[2];                    // DWORD 0
} SG_PACK BE_EQ_DB_V1_AMAP;
typedef struct { u32 dw[1]; } EQ_DB_V1_AMAP, *PEQ_DB_V1_AMAP;


typedef struct {
   BE_BIT qid[10];                                // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT num_popped[13];                         // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT irpt;                                   // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
} SG_PACK BE_CQ_DB_V1_AMAP;
typedef struct { u32 dw[1]; } CQ_DB_V1_AMAP, *PCQ_DB_V1_AMAP;


typedef struct {
   BE_BIT vlan_tag[16];                           // DWORD 0
   BE_BIT pktsize[14];                            // DWORD 0
   BE_BIT vtp;                                    // DWORD 0
   BE_BIT ip_opt;                                 // DWORD 0
   BE_BIT err;                                    // DWORD 1
   BE_BIT rsshp;                                  // DWORD 1
   BE_BIT ipf;                                    // DWORD 1
   BE_BIT tcpf;                                   // DWORD 1
   BE_BIT udpf;                                   // DWORD 1
   BE_BIT ipcksm;                                 // DWORD 1
   BE_BIT l4_cksm;                                // DWORD 1
   BE_BIT ip_version;                             // DWORD 1
   BE_BIT macdst[7];                              // DWORD 1
   BE_BIT rsvd0;                                  // DWORD 1
   BE_BIT fragndx[10];                            // DWORD 1
   BE_BIT ct[2];                                  // DWORD 1
   BE_BIT sw;                                     // DWORD 1
   BE_BIT numfrags[3];                            // DWORD 1
   BE_BIT rss_flush;                              // DWORD 2
   BE_BIT cast_enc[2];                            // DWORD 2
   BE_BIT QnQ;                                    // DWORD 2
   BE_BIT rss_bank;                               // DWORD 2
   BE_BIT port[2];                                // DWORD 2
   BE_BIT vntagp;                                 // DWORD 2
   BE_BIT header_len[8];                          // DWORD 2
   BE_BIT header_split[2];                        // DWORD 2
   BE_BIT rsvd1[13];                              // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT rsshash[32];                            // DWORD 3
} SG_PACK BE_ETH_RX_COMPL_V1_AMAP;
typedef struct { u32 dw[4]; } ETH_RX_COMPL_V1_AMAP, *PETH_RX_COMPL_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   union {
      struct {
         BE_UEXACT16_V1_AMAP cq_id;
         BE_UEXACT8_V1_AMAP frag_size;
         BE_UEXACT8_V1_AMAP num_pages;
         BE_PHYS_ADDR_V1_AMAP pages[2];
         BE_UEXACT32_V1_AMAP interface_id;
         BE_UEXACT16_V1_AMAP max_frame_size;
         BE_BIT rsvd0[16];                        // DWORD 10
         BE_UEXACT32_V1_AMAP rss_queue;
         BE_UEXACT8_V1_AMAP header_split;
         BE_UEXACT8_V1_AMAP header_dma;
         BE_UEXACT8_V1_AMAP split_location;
         BE_UEXACT8_V1_AMAP dca;
         BE_UEXACT16_V1_AMAP header_size;
         BE_UEXACT16_V1_AMAP backfill;
         BE_UEXACT16_V1_AMAP fixed_split_location;
         BE_BIT rsvd1[16];                        // DWORD 14
      } request;
      struct {
         BE_UEXACT16_V1_AMAP id;
         BE_UEXACT8_V1_AMAP cpu_id;
         BE_UEXACT8_V1_AMAP ep_based_ring;
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_RX_CREATE_V1_AMAP;
typedef struct { u32 dw[15]; } IOCTL_ETH_RX_CREATE_V1_AMAP, *PIOCTL_ETH_RX_CREATE_V1_AMAP;


typedef struct {
   BE_BIT rx_bytes_lsd[32];                       // DWORD 0
   BE_BIT rx_bytes_msd[32];                       // DWORD 1
   BE_BIT rx_ipv4_bytes_lsd[32];                  // DWORD 2
   BE_BIT rx_ipv4_bytes_msd[32];                  // DWORD 3
   BE_BIT rx_ipv6_bytes_lsd[32];                  // DWORD 4
   BE_BIT rx_ipv6_bytes_msd[32];                  // DWORD 5
   BE_BIT tx_bytes_lsd[32];                       // DWORD 6
   BE_BIT tx_bytes_msd[32];                       // DWORD 7
   BE_BIT rx_total_frames[32];                    // DWORD 8
   BE_BIT rx_non_switched_unicast_frames[32];     // DWORD 9
   BE_BIT rx_non_switched_multicast_frames[32];   // DWORD 10
   BE_BIT rx_non_switched_broadcast_frames[32];   // DWORD 11
   BE_BIT rx_crc_errors[32];                      // DWORD 12
   BE_BIT rx_alignment_symbol_errors[32];         // DWORD 13
   BE_BIT rx_pause_frames[32];                    // DWORD 14
   BE_BIT rx_priority_pause_frames[32];           // DWORD 15
   BE_BIT rx_control_frames[32];                  // DWORD 16
   BE_BIT rx_in_range_errors[32];                 // DWORD 17
   BE_BIT rx_out_range_errors[32];                // DWORD 18
   BE_BIT rx_frame_too_long[32];                  // DWORD 19
   BE_BIT rx_address_match_errors[32];            // DWORD 20
   BE_BIT rx_dropped_too_small[32];               // DWORD 21
   BE_BIT rx_dropped_too_short[32];               // DWORD 22
   BE_BIT rx_dropped_header_too_small[32];        // DWORD 23
   BE_BIT rx_dropped_tcp_length[32];              // DWORD 24
   BE_BIT rx_dropped_runt[32];                    // DWORD 25
   BE_BIT rx_64_byte_packets[32];                 // DWORD 26
   BE_BIT rx_65_127_byte_packets[32];             // DWORD 27
   BE_BIT rx_128_256_byte_packets[32];            // DWORD 28
   BE_BIT rx_256_511_byte_packets[32];            // DWORD 29
   BE_BIT rx_512_1023_byte_packets[32];           // DWORD 30
   BE_BIT rx_1024_1518_byte_packets[32];          // DWORD 31
   BE_BIT rx_1519_2047_byte_packets[32];          // DWORD 32
   BE_BIT rx_2048_4095_byte_packets[32];          // DWORD 33
   BE_BIT rx_4096_8191_byte_packets[32];          // DWORD 34
   BE_BIT rx_8192_9216_byte_packets[32];          // DWORD 35
   BE_BIT rx_ip_checksum_errs[32];                // DWORD 36
   BE_BIT rx_tcp_checksum_errs[32];               // DWORD 37
   BE_BIT rx_udp_checksum_errs[32];               // DWORD 38
   BE_BIT rx_non_rss_packets[32];                 // DWORD 39
   BE_BIT rx_ipv4_packets[32];                    // DWORD 40
   BE_BIT rx_ipv6_packets[32];                    // DWORD 41
   BE_BIT rx_chute1_packets[32];                  // DWORD 42
   BE_BIT rx_chute2_packets[32];                  // DWORD 43
   BE_BIT rx_chute3_packets[32];                  // DWORD 44
   BE_BIT rx_management_packets[32];              // DWORD 45
   BE_BIT rx_switched_unicast_packets[32];        // DWORD 46
   BE_BIT rx_switched_multicast_packets[32];      // DWORD 47
   BE_BIT rx_switched_broadcast_packets[32];      // DWORD 48
   BE_BIT tx_unicastframes[32];                   // DWORD 49
   BE_BIT tx_multicastframes[32];                 // DWORD 50
   BE_BIT tx_broadcastframes[32];                 // DWORD 51
   BE_BIT tx_pauseframes[32];                     // DWORD 52
   BE_BIT tx_priority_pauseframes[32];            // DWORD 53
   BE_BIT tx_controlframes[32];                   // DWORD 54
   BE_BIT tx_64_byte_packets[32];                 // DWORD 55
   BE_BIT tx_65_127_byte_packets[32];             // DWORD 56
   BE_BIT tx_128_256_byte_packets[32];            // DWORD 57
   BE_BIT tx_256_511_byteb_packets[32];           // DWORD 58
   BE_BIT tx_512_1023_byte_packets[32];           // DWORD 59
   BE_BIT tx_1024_1518_byte_packets[32];          // DWORD 60
   BE_BIT tx_1519_2047_byte_packets[32];          // DWORD 61
   BE_BIT tx_2048_4095_byte_packets[32];          // DWORD 62
   BE_BIT tx_4096_8191_byte_packets[32];          // DWORD 63
   BE_BIT tx_8192_9216_byte_packets[32];          // DWORD 64
   BE_BIT rxpp_fifo_overflow_drop[32];            // DWORD 65
   BE_BIT rx_input_fifo_overflow_drop[32];        // DWORD 66
   BE_BIT pmem_fifo_overflow_drop[32];            // DWORD 67
   BE_BIT jabber_events[32];                      // DWORD 68
   BE_BIT vntag_wrong_dir[32];                    // DWORD 69
   BE_BIT vntag_exceeds_vif[32];                  // DWORD 70
   BE_BIT vntag_exceeds_vif_list[32];             // DWORD 71
} SG_PACK BE_BE2_PORT_RXF_STATS_V1_AMAP;
typedef struct { u32 dw[72]; } BE2_PORT_RXF_STATS_V1_AMAP, *PBE2_PORT_RXF_STATS_V1_AMAP;


typedef struct {
   BE_BIT fcoe_bytes_received_lsd[32];            // DWORD 0
   BE_BIT fcoe_bytes_received_msd[32];            // DWORD 1
   BE_BIT rx_drops_payload_size[32];              // DWORD 2
   BE_BIT rx_drops_crc[32];                       // DWORD 3
   BE_BIT rx_drops_clipped_header[32];            // DWORD 4
   BE_BIT fcoe_frames_received[32];               // DWORD 5
} SG_PACK BE_BE2_FCOE_PORT_STATS_V1_AMAP;
typedef struct { u32 dw[6]; } BE2_FCOE_PORT_STATS_V1_AMAP, *PBE2_FCOE_PORT_STATS_V1_AMAP;


typedef struct {
   BE_BE2_PORT_RXF_STATS_V1_AMAP port[4];
   BE_BIT management_rx_port_bytes[32];           // DWORD 288
   BE_BIT management_tx_port_bytes[32];           // DWORD 289
   BE_BIT rx_drops_no_pbuf[32];                   // DWORD 290
   BE_BIT rx_drops_no_txpb[32];                   // DWORD 291
   BE_BIT rx_drops_no_erx_descr[32];              // DWORD 292
   BE_BIT rx_drops_no_tpre_descr[32];             // DWORD 293
   BE_BIT management_rx_port_packets[32];         // DWORD 294
   BE_BIT management_rx_port_pause_frames[32];    // DWORD 295
   BE_BIT management_rx_port_errors[32];          // DWORD 296
   BE_BIT management_tx_port_packets[32];         // DWORD 297
   BE_BIT management_tx_port_pause[32];           // DWORD 298
   BE_BIT mgmt_rx_port_pmem_fifo_overflow[32];    // DWORD 299
   BE_BIT rx_drops_too_many_frags[32];            // DWORD 300
   BE_BIT rx_drops_invalid_ring[32];              // DWORD 301
   BE_BIT forwarded_packets[32];                  // DWORD 302
   BE_BIT rx_drops_mtu[32];                       // DWORD 303
   BE_BIT mgmt_rx_port_rxpp_fifo_overflow[32];    // DWORD 304
   BE_BIT rxpp_drops_too_big_for_mgmt[32];        // DWORD 305
   BE_BE2_FCOE_PORT_STATS_V1_AMAP fcoe_port[2];
} SG_PACK BE_BE2_RXF_STATS_V1_AMAP;
typedef struct { u32 dw[318]; } BE2_RXF_STATS_V1_AMAP, *PBE2_RXF_STATS_V1_AMAP;


typedef struct {
   BE_BIT packets[32];                            // DWORD 0
   BE_BIT lsd[32];                                // DWORD 1
   BE_BIT msd[32];                                // DWORD 2
} SG_PACK BE_BE2_TXP_SW_STAT_V1_AMAP;
typedef struct { u32 dw[3]; } BE2_TXP_SW_STAT_V1_AMAP, *PBE2_TXP_SW_STAT_V1_AMAP;


typedef struct {
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt0_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt0_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt0_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt0_rexmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt1_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt1_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt1_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct1pt1_rexmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt0_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt0_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt0_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt0_rexmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt1_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt1_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt1_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_V1_AMAP ct2pt1_rexmt_ipv6_ctrs;
} SG_PACK BE_BE2_TXP_SW_COUNTERS_V1_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP_SW_COUNTERS_V1_AMAP, *PBE2_TXP_SW_COUNTERS_V1_AMAP;


typedef struct {
   BE_BIT rx_drops_no_fragments[68][32];          // DWORD 0
   BE_BIT debug_wdma_sent_hold[32];               // DWORD 68
   BE_BIT debug_wdma_pbfree_sent_hold[32];        // DWORD 69
   BE_BIT debug_wdma_zerobyte_pbfree_sent_hold[32]; // DWORD 70
   BE_BIT debug_pmem_pbuf_dealloc[32];            // DWORD 71
} SG_PACK BE_BE2_ERX_STATS_V1_AMAP;
typedef struct { u32 dw[72]; } BE2_ERX_STATS_V1_AMAP, *PBE2_ERX_STATS_V1_AMAP;


typedef struct {
   BE_u32_V1_AMAP eth_red_drops;
   BE_u32_V1_AMAP lro_red_drops;
   BE_u32_V1_AMAP ulp0_red_drops;
   BE_u32_V1_AMAP ulp1_red_drops;
   BE_BIT rsvd0[32];                              // DWORD 4
   BE_u32_V1_AMAP global_red_drops;
} SG_PACK BE_BE2_PMEM_STATS_V1_AMAP;
typedef struct { u32 dw[6]; } BE2_PMEM_STATS_V1_AMAP, *PBE2_PMEM_STATS_V1_AMAP;


typedef struct {
   BE_u16_V1_AMAP perf_idle_average;
   BE_u16_V1_AMAP perf_loading_average;
   BE_u16_V1_AMAP perf_busy_average;
   BE_u16_V1_AMAP perf_unloading_average;
   BE_u16_V1_AMAP perf_wt4bank_average;
   BE_u16_V1_AMAP perf_wt4unload_average;
} SG_PACK BE_BE2_EP_STATS_V1_AMAP;
typedef struct { u32 dw[3]; } BE2_EP_STATS_V1_AMAP, *PBE2_EP_STATS_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_MIB_ETH_STATISTICS_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[1]; } MIB_ETH_STATISTICS_PARAMS_IN_V1_AMAP, *PMIB_ETH_STATISTICS_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_BE2_RXF_STATS_V1_AMAP rxf;
   BE_BE2_TXP_SW_COUNTERS_V1_AMAP txp;
   BE_BE2_ERX_STATS_V1_AMAP erx;
   BE_BE2_PMEM_STATS_V1_AMAP pmem;
   BE_BE2_EP_STATS_V1_AMAP ep[6];
} SG_PACK BE_BE2_HARDWARE_STATS_V1_AMAP;
typedef struct { u32 dw[462]; } BE2_HARDWARE_STATS_V1_AMAP, *PBE2_HARDWARE_STATS_V1_AMAP;


typedef union {
   BE_MIB_ETH_STATISTICS_PARAMS_IN_V1_AMAP request;
   BE_BE2_HARDWARE_STATS_V1_AMAP response;
} SG_PACK BE_MIB_ETH_STATISTICS_PARAMS_V1_AMAP;
typedef struct { u32 dw[462]; } MIB_ETH_STATISTICS_PARAMS_V1_AMAP, *PMIB_ETH_STATISTICS_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_MIB_ETH_STATISTICS_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_ETH_GET_STATISTICS_V1_AMAP;
typedef struct { u32 dw[466]; } IOCTL_ETH_GET_STATISTICS_V1_AMAP, *PIOCTL_ETH_GET_STATISTICS_V1_AMAP;


typedef struct {
   BE_UEXACT32_V1_AMAP valid_capability_flags;
   BE_UEXACT32_V1_AMAP capability_flags;
   BE_UEXACT8_V1_AMAP sbz[212];
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_UEXACT32_V1_AMAP valid_capability_flags;
   BE_UEXACT32_V1_AMAP capability_flags;
   BE_UEXACT8_V1_AMAP sbz[212];
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_V1_AMAP request;
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1_AMAP, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_UEXACT32_V1_AMAP privilege_mask;
} SG_PACK BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP request;
   BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP;
typedef struct { u32 dw[1]; } GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP, *PGET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_GET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V1_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V1_AMAP, *PIOCTL_COMMON_GET_FUNCTION_PRIVILEGES_V1_AMAP;


typedef struct {
   BE_UEXACT32_V1_AMAP privilege_mask;
} SG_PACK BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[1]; } SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_UEXACT32_V1_AMAP old_privilege_mask;
} SG_PACK BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[1]; } SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_IN_V1_AMAP request;
   BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP;
typedef struct { u32 dw[1]; } SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP, *PSET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_SET_FUNCTION_PRIVILEGE_CATEGORY_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V1_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V1_AMAP, *PIOCTL_COMMON_SET_FUNCTION_PRIVILEGES_V1_AMAP;


typedef struct {
   BE_BIT intf_pport_id[16];                      // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT pvid_valid;                             // DWORD 0
   BE_BIT pport;                                  // DWORD 0
   BE_BIT ingress_vlan_type[3];                   // DWORD 1
   BE_BIT egress_vlan_type[3];                    // DWORD 1
   BE_BIT port_fwd_type[3];                       // DWORD 1
   BE_BIT idp_valid;                              // DWORD 1
   BE_BIT rx_sniffer_valid;                       // DWORD 1
   BE_BIT tx_sniffer_valid;                       // DWORD 1
   BE_BIT promisc;                                // DWORD 1
   BE_BIT vlan_check;                             // DWORD 1
   BE_BIT mac_spoof_check;                        // DWORD 1
   BE_BIT uplink_port;                            // DWORD 1
   BE_BIT pvid[16];                               // DWORD 1
   BE_UEXACT16_V1_AMAP rx_sniffer_cq_id;
   BE_UEXACT16_V1_AMAP rx_sniffer_iface_id;
   BE_UEXACT16_V1_AMAP tx_sniffer_cq_id;
   BE_UEXACT16_V1_AMAP tx_sniffer_iface_id;
   BE_UEXACT16_V1_AMAP idp_cq_id;
   BE_UEXACT16_V1_AMAP promisc_cq_id;
} SG_PACK BE_SET_HSW_CONFIG_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[5]; } SET_HSW_CONFIG_PARAMS_IN_V1_AMAP, *PSET_HSW_CONFIG_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_HSW_CONFIG_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[1]; } SET_HSW_CONFIG_PARAMS_OUT_V1_AMAP, *PSET_HSW_CONFIG_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_SET_HSW_CONFIG_PARAMS_IN_V1_AMAP request;
   BE_SET_HSW_CONFIG_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_SET_HSW_CONFIG_PARAMS_V1_AMAP;
typedef struct { u32 dw[5]; } SET_HSW_CONFIG_PARAMS_V1_AMAP, *PSET_HSW_CONFIG_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_SET_HSW_CONFIG_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_HSW_CONFIG_V1_AMAP;
typedef struct { u32 dw[9]; } IOCTL_COMMON_SET_HSW_CONFIG_V1_AMAP, *PIOCTL_COMMON_SET_HSW_CONFIG_V1_AMAP;


typedef struct {
   BE_BIT intf_pport_id[16];                      // DWORD 0
   BE_BIT rsvd0[14];                              // DWORD 0
   BE_BIT pvid_valid;                             // DWORD 0
   BE_BIT pport;                                  // DWORD 0
} SG_PACK BE_GET_HSW_CONFIG_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[1]; } GET_HSW_CONFIG_PARAMS_IN_V1_AMAP, *PGET_HSW_CONFIG_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_BIT ingress_vlan_type[3];                   // DWORD 0
   BE_BIT egress_vlan_type[3];                    // DWORD 0
   BE_BIT port_fwd_type[3];                       // DWORD 0
   BE_BIT idp_valid;                              // DWORD 0
   BE_BIT rx_sniffer_valid;                       // DWORD 0
   BE_BIT tx_sniffer_valid;                       // DWORD 0
   BE_BIT promisc;                                // DWORD 0
   BE_BIT vlan_check;                             // DWORD 0
   BE_BIT mac_spoof_check;                        // DWORD 0
   BE_BIT uplink_port;                            // DWORD 0
   BE_BIT pvid[16];                               // DWORD 0
   BE_UEXACT16_V1_AMAP rx_sniffer_cq_id;
   BE_UEXACT16_V1_AMAP rx_sniffer_iface_id;
   BE_UEXACT16_V1_AMAP tx_sniffer_cq_id;
   BE_UEXACT16_V1_AMAP tx_sniffer_iface_id;
   BE_UEXACT16_V1_AMAP idp_cq_id;
   BE_UEXACT16_V1_AMAP promisc_cq_id;
} SG_PACK BE_GET_HSW_CONFIG_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[4]; } GET_HSW_CONFIG_PARAMS_OUT_V1_AMAP, *PGET_HSW_CONFIG_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_GET_HSW_CONFIG_PARAMS_IN_V1_AMAP request;
   BE_GET_HSW_CONFIG_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_GET_HSW_CONFIG_PARAMS_V1_AMAP;
typedef struct { u32 dw[4]; } GET_HSW_CONFIG_PARAMS_V1_AMAP, *PGET_HSW_CONFIG_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_GET_HSW_CONFIG_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_HSW_CONFIG_V1_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_GET_HSW_CONFIG_V1_AMAP, *PIOCTL_COMMON_GET_HSW_CONFIG_V1_AMAP;


typedef struct {
   BE_UEXACT8_V1_AMAP physical_port;
   BE_UEXACT8_V1_AMAP virtual_port;
   BE_UEXACT8_V1_AMAP mac_speed;
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_LINK_SPEED_SET_V1_AMAP;
typedef struct { u32 dw[1]; } LINK_SPEED_SET_V1_AMAP, *PLINK_SPEED_SET_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_LINK_SPEED_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[1]; } SET_LINK_SPEED_PARAMS_OUT_V1_AMAP, *PSET_LINK_SPEED_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_LINK_SPEED_SET_V1_AMAP request;
   BE_SET_LINK_SPEED_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_SET_LINK_SPEED_PARAMS_V1_AMAP;
typedef struct { u32 dw[1]; } SET_LINK_SPEED_PARAMS_V1_AMAP, *PSET_LINK_SPEED_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_SET_LINK_SPEED_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_SET_LINK_SPEED_V1_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_NTWK_SET_LINK_SPEED_V1_AMAP, *PIOCTL_COMMON_NTWK_SET_LINK_SPEED_V1_AMAP;


typedef struct {
   BE_UEXACT8_V1_AMAP physical_port;
   BE_UEXACT8_V1_AMAP virtual_port;
   BE_UEXACT16_V1_AMAP mac_speed;
   BE_UEXACT16_V1_AMAP dac_cable_length;
   BE_BIT rsvd0[16];                              // DWORD 1
} SG_PACK BE_LINK_SPEED_SET_V1_V1_AMAP;
typedef struct { u32 dw[2]; } LINK_SPEED_SET_V1_V1_AMAP, *PLINK_SPEED_SET_V1_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_LINK_SPEED_PARAMS_OUT_V1_V1_AMAP;
typedef struct { u32 dw[1]; } SET_LINK_SPEED_PARAMS_OUT_V1_V1_AMAP, *PSET_LINK_SPEED_PARAMS_OUT_V1_V1_AMAP;


typedef union {
   BE_LINK_SPEED_SET_V1_V1_AMAP request;
   BE_SET_LINK_SPEED_PARAMS_OUT_V1_V1_AMAP response;
} SG_PACK BE_SET_LINK_SPEED_PARAMS_V1_V1_AMAP;
typedef struct { u32 dw[2]; } SET_LINK_SPEED_PARAMS_V1_V1_AMAP, *PSET_LINK_SPEED_PARAMS_V1_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_SET_LINK_SPEED_PARAMS_V1_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_SET_LINK_SPEED_V1_V1_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_NTWK_SET_LINK_SPEED_V1_V1_AMAP, *PIOCTL_COMMON_NTWK_SET_LINK_SPEED_V1_V1_AMAP;


typedef struct {
   BE_UEXACT32_V1_AMAP phy_addr;
   BE_UEXACT32_V1_AMAP canceller_state;
} SG_PACK BE_SET_EMI_CANCELLER_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[2]; } SET_EMI_CANCELLER_PARAMS_IN_V1_AMAP, *PSET_EMI_CANCELLER_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_EMI_CANCELLER_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[1]; } SET_EMI_CANCELLER_PARAMS_OUT_V1_AMAP, *PSET_EMI_CANCELLER_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_SET_EMI_CANCELLER_PARAMS_IN_V1_AMAP request;
   BE_SET_EMI_CANCELLER_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_SET_EMI_CANCELLER_PARAMS_V1_AMAP;
typedef struct { u32 dw[2]; } SET_EMI_CANCELLER_PARAMS_V1_AMAP, *PSET_EMI_CANCELLER_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_SET_EMI_CANCELLER_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_DIAG_SET_EMI_CANCELLER_V1_AMAP;
typedef struct { u32 dw[6]; } IOCTL_DIAG_SET_EMI_CANCELLER_V1_AMAP, *PIOCTL_DIAG_SET_EMI_CANCELLER_V1_AMAP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_PHY_DETAILS_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[1]; } GET_PHY_DETAILS_PARAMS_IN_V1_AMAP, *PGET_PHY_DETAILS_PARAMS_IN_V1_AMAP;


typedef struct {
   BE_UEXACT16_V1_AMAP phy_type;
   BE_UEXACT16_V1_AMAP interface_type;
   BE_UEXACT32_V1_AMAP misc_params;
   BE_UEXACT16_V1_AMAP extended_phy_details;
   BE_UEXACT16_V1_AMAP future_details;
   BE_UEXACT16_V1_AMAP auto_speeds_supported;
   BE_UEXACT16_V1_AMAP fixed_speeds_supported;
   BE_UEXACT32_V1_AMAP future_use[2];
} SG_PACK BE_GET_PHY_DETAILS_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[6]; } GET_PHY_DETAILS_PARAMS_OUT_V1_AMAP, *PGET_PHY_DETAILS_PARAMS_OUT_V1_AMAP;


typedef union {
   BE_GET_PHY_DETAILS_PARAMS_IN_V1_AMAP request;
   BE_GET_PHY_DETAILS_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_GET_PHY_DETAILS_PARAMS_V1_AMAP;
typedef struct { u32 dw[6]; } GET_PHY_DETAILS_PARAMS_V1_AMAP, *PGET_PHY_DETAILS_PARAMS_V1_AMAP;


typedef struct {
   BE_IOCTL_HEADER_V1_AMAP header;
   BE_GET_PHY_DETAILS_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PHY_DETAILS_V1_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_GET_PHY_DETAILS_V1_AMAP, *PIOCTL_COMMON_GET_PHY_DETAILS_V1_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __be3nic_v1_amap_h__

