/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   beclib_stats.h

@brief
   
CVS Header Information:
   $Header: $
*/
#ifndef __beclib_stats_h__
#define __beclib_stats_h__

typedef struct _BECLIB_FUNCTION_STATS {

    union {
        
        u32 dw[32]; // Reserve space in struct for a fixed number of stats.

        struct {
            u32 mailbox_wrbs;
            u32 emulated_wrbs;

            // Pertain to WRBs posted to ring only
            u32 synchronous_wrbs;
            u32 posted_wrbs;            
            u32 consumed_wrbs;
            u32 completed_wrbs;

            // SW queueing
            u32 queued_wrbs;
            u32 queue_length;
            u32 max_queue_length;    
            u32 pended_queue_driving;
            
            // MCC CQ
            u32 processed_cq;
            u32 cq_entries;
            u32 async_events;            
            u32 ignored_async_events;

            // Locks
            u32 post_lock_acquires;            
            u32 cq_lock_acquires;
            u64 post_lock_ticks;
            u64 cq_lock_ticks;
        };
    };

} BECLIB_FUNCTION_STATS, *PBECLIB_FUNCTION_STATS;

#endif // __beclib_stats_h__

