/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */


#ifndef __PHYIF_H__
#define __PHYIF_H__

#define PHY_STATUS_LINK             (1<<2)
#define PHY_STATUS_ANEN_COMPLETE    (1<<5)
#define PHY_STATUS_EXT_STATUS       (1<<8)
#define PHY_STATUS_10M_HD           (1<<11)
#define PHY_STATUS_10M_FD           (1<<12)
#define PHY_STATUS_100M_HD          (1<<13)
#define PHY_STATUS_100M_FD          (1<<14)


#define PHY_EXTSTATUS_1000BT_HD     (1<<12)
#define PHY_EXTSTATUS_1000BT_FD     (1<<13)
#define PHY_EXTSTATUS_1000BX_HD     (1<<14)
#define PHY_EXTSTATUS_1000BX_FD     (1<<15)


#define PHY_EXTCTRLSTATUS_RESOLVED  (1<<11)

#define PHY_EXTCTRLSTATUS_SPEED     0xc000

#define PHY_EXTCTRLSTATUS_1000MBPS  0x8000
#define PHY_EXTCTRLSTATUS_100MBPS   0x4000
#define PHY_EXTCTRLSTATUS_10MBPS    0x0000

#define PHY_EXTCTRLSTATUS_DUPLEX    (1<<13)
#define PHY_EXTCTRLSTATUS_LINK      (1<<10)


#define LINK_DUPLEX_NONE    0
#define LINK_DUPLEX_HALF    1
#define LINK_DUPLEX_FULL    2


#endif
