/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __armddr_bmap_h__
#define __armddr_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Memory initialization register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_MEMINIT {
         union {
            struct { 
               u32 r_mrsadd : 16;                 // DWORD 0
               u32 r_init_mrs : 1;                // DWORD 0
               u32 r_init_pre_all : 1;            // DWORD 0
               u32 r_cke_enable : 1;              // DWORD 0
               u32 r_memenable : 1;               // DWORD 0
               u32 r_start_meminit : 1;           // DWORD 0
               u32 r_strb_win0 : 2;               // DWORD 0
               u32 r_strb_shift_enable0 : 1;      // DWORD 0
               u32 adconhold : 3;                 // DWORD 0
               u32 odtres : 2;                    // DWORD 0
               u32 r_board_delay2 : 1;            // DWORD 0
               u32 r_board_delay1 : 1;            // DWORD 0
               u32 r_board_delay : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_MEMINIT, *PARMDDR_MEMINIT;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMINIT, sizeof (ARMDDR_MEMINIT) == 4);

   #else
      typedef struct _ARMDDR_MEMINIT {
         u32 r_mrsadd : 16;                       // DWORD 0
         u32 r_init_mrs : 1;                      // DWORD 0
         u32 r_init_pre_all : 1;                  // DWORD 0
         u32 r_cke_enable : 1;                    // DWORD 0
         u32 r_memenable : 1;                     // DWORD 0
         u32 r_start_meminit : 1;                 // DWORD 0
         u32 r_strb_win0 : 2;                     // DWORD 0
         u32 r_strb_shift_enable0 : 1;            // DWORD 0
         u32 adconhold : 3;                       // DWORD 0
         u32 odtres : 2;                          // DWORD 0
         u32 r_board_delay2 : 1;                  // DWORD 0
         u32 r_board_delay1 : 1;                  // DWORD 0
         u32 r_board_delay : 1;                   // DWORD 0
      } SG_PACK ARMDDR_MEMINIT, *PARMDDR_MEMINIT;

      typedef union _ARMDDR_MEMINIT_UNION {
         ARMDDR_MEMINIT bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_MEMINIT_UNION, *PARMDDR_MEMINIT_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMINIT_UNION, sizeof (ARMDDR_MEMINIT_UNION) == 4);
   #endif


#else
   // Memory initialization register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_MEMINIT {
         union {
            struct { 
               u32 r_board_delay : 1;             // DWORD 0
               u32 r_board_delay1 : 1;            // DWORD 0
               u32 r_board_delay2 : 1;            // DWORD 0
               u32 odtres : 2;                    // DWORD 0
               u32 adconhold : 3;                 // DWORD 0
               u32 r_strb_shift_enable0 : 1;      // DWORD 0
               u32 r_strb_win0 : 2;               // DWORD 0
               u32 r_start_meminit : 1;           // DWORD 0
               u32 r_memenable : 1;               // DWORD 0
               u32 r_cke_enable : 1;              // DWORD 0
               u32 r_init_pre_all : 1;            // DWORD 0
               u32 r_init_mrs : 1;                // DWORD 0
               u32 r_mrsadd : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_MEMINIT, *PARMDDR_MEMINIT;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMINIT, sizeof (ARMDDR_MEMINIT) == 4);

   #else
      typedef struct _ARMDDR_MEMINIT {
         u32 r_board_delay : 1;                   // DWORD 0
         u32 r_board_delay1 : 1;                  // DWORD 0
         u32 r_board_delay2 : 1;                  // DWORD 0
         u32 odtres : 2;                          // DWORD 0
         u32 adconhold : 3;                       // DWORD 0
         u32 r_strb_shift_enable0 : 1;            // DWORD 0
         u32 r_strb_win0 : 2;                     // DWORD 0
         u32 r_start_meminit : 1;                 // DWORD 0
         u32 r_memenable : 1;                     // DWORD 0
         u32 r_cke_enable : 1;                    // DWORD 0
         u32 r_init_pre_all : 1;                  // DWORD 0
         u32 r_init_mrs : 1;                      // DWORD 0
         u32 r_mrsadd : 16;                       // DWORD 0
      } SG_PACK ARMDDR_MEMINIT, *PARMDDR_MEMINIT;

      typedef union _ARMDDR_MEMINIT_UNION {
         ARMDDR_MEMINIT bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_MEMINIT_UNION, *PARMDDR_MEMINIT_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMINIT_UNION, sizeof (ARMDDR_MEMINIT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DQS delays for lower 32 bits of memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DQSDEL0 {
         union {
            struct { 
               u32 r_dqsdelay_31_30 : 2;          // DWORD 0
               u32 r_dqsdelay_29_20 : 10;         // DWORD 0
               u32 r_dqsdelay_19_10 : 10;         // DWORD 0
               u32 r_dqsdelay_9_0 : 10;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DQSDEL0, *PARMDDR_DQSDEL0;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL0, sizeof (ARMDDR_DQSDEL0) == 4);

   #else
      typedef struct _ARMDDR_DQSDEL0 {
         u32 r_dqsdelay_31_30 : 2;                // DWORD 0
         u32 r_dqsdelay_29_20 : 10;               // DWORD 0
         u32 r_dqsdelay_19_10 : 10;               // DWORD 0
         u32 r_dqsdelay_9_0 : 10;                 // DWORD 0
      } SG_PACK ARMDDR_DQSDEL0, *PARMDDR_DQSDEL0;

      typedef union _ARMDDR_DQSDEL0_UNION {
         ARMDDR_DQSDEL0 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DQSDEL0_UNION, *PARMDDR_DQSDEL0_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL0_UNION, sizeof (ARMDDR_DQSDEL0_UNION) == 4);
   #endif


#else
   // DQS delays for lower 32 bits of memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DQSDEL0 {
         union {
            struct { 
               u32 r_dqsdelay_9_0 : 10;           // DWORD 0
               u32 r_dqsdelay_19_10 : 10;         // DWORD 0
               u32 r_dqsdelay_29_20 : 10;         // DWORD 0
               u32 r_dqsdelay_31_30 : 2;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DQSDEL0, *PARMDDR_DQSDEL0;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL0, sizeof (ARMDDR_DQSDEL0) == 4);

   #else
      typedef struct _ARMDDR_DQSDEL0 {
         u32 r_dqsdelay_9_0 : 10;                 // DWORD 0
         u32 r_dqsdelay_19_10 : 10;               // DWORD 0
         u32 r_dqsdelay_29_20 : 10;               // DWORD 0
         u32 r_dqsdelay_31_30 : 2;                // DWORD 0
      } SG_PACK ARMDDR_DQSDEL0, *PARMDDR_DQSDEL0;

      typedef union _ARMDDR_DQSDEL0_UNION {
         ARMDDR_DQSDEL0 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DQSDEL0_UNION, *PARMDDR_DQSDEL0_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL0_UNION, sizeof (ARMDDR_DQSDEL0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DQS delays for lower 32 bits and ECC bits of memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DQSDEL1 {
         union {
            struct { 
               u32 rsvd0 : 3;                     // DWORD 0
               u32 r_debug_mux_sel_b : 5;         // DWORD 0
               u32 r_debug_mux_sel_a : 6;         // DWORD 0
               u32 r_dqsdelay_17_8 : 10;          // DWORD 0
               u32 r_dqsdelay_7_0 : 8;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DQSDEL1, *PARMDDR_DQSDEL1;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL1, sizeof (ARMDDR_DQSDEL1) == 4);

   #else
      typedef struct _ARMDDR_DQSDEL1 {
         u32 rsvd0 : 3;                           // DWORD 0
         u32 r_debug_mux_sel_b : 5;               // DWORD 0
         u32 r_debug_mux_sel_a : 6;               // DWORD 0
         u32 r_dqsdelay_17_8 : 10;                // DWORD 0
         u32 r_dqsdelay_7_0 : 8;                  // DWORD 0
      } SG_PACK ARMDDR_DQSDEL1, *PARMDDR_DQSDEL1;

      typedef union _ARMDDR_DQSDEL1_UNION {
         ARMDDR_DQSDEL1 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DQSDEL1_UNION, *PARMDDR_DQSDEL1_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL1_UNION, sizeof (ARMDDR_DQSDEL1_UNION) == 4);
   #endif


#else
   // DQS delays for lower 32 bits and ECC bits of memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DQSDEL1 {
         union {
            struct { 
               u32 r_dqsdelay_7_0 : 8;            // DWORD 0
               u32 r_dqsdelay_17_8 : 10;          // DWORD 0
               u32 r_debug_mux_sel_a : 6;         // DWORD 0
               u32 r_debug_mux_sel_b : 5;         // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DQSDEL1, *PARMDDR_DQSDEL1;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL1, sizeof (ARMDDR_DQSDEL1) == 4);

   #else
      typedef struct _ARMDDR_DQSDEL1 {
         u32 r_dqsdelay_7_0 : 8;                  // DWORD 0
         u32 r_dqsdelay_17_8 : 10;                // DWORD 0
         u32 r_debug_mux_sel_a : 6;               // DWORD 0
         u32 r_debug_mux_sel_b : 5;               // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
      } SG_PACK ARMDDR_DQSDEL1, *PARMDDR_DQSDEL1;

      typedef union _ARMDDR_DQSDEL1_UNION {
         ARMDDR_DQSDEL1 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DQSDEL1_UNION, *PARMDDR_DQSDEL1_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DQSDEL1_UNION, sizeof (ARMDDR_DQSDEL1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DDR2 system, error and status bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DSSYSES {
         union {
            struct { 
               u32 r_calibrate_ecc : 1;           // DWORD 0
               u32 r_ref_times_dma32 : 3;         // DWORD 0
               u32 r_wr_after_exp_dma32 : 1;      // DWORD 0
               u32 r_strobe_override : 1;         // DWORD 0
               u32 r_strobe_delay1 : 1;           // DWORD 0
               u32 r_strobe_delay : 1;            // DWORD 0
               u32 r_overlap_enable : 1;          // DWORD 0
               u32 lasterrorlog : 1;              // DWORD 0
               u32 r_read_opt_ul : 1;             // DWORD 0
               u32 r_read_opt_fl : 1;             // DWORD 0
               u32 r_ref_times : 3;               // DWORD 0
               u32 r_wr_after_exp : 1;            // DWORD 0
               u32 r_wr_high_pri_th : 2;          // DWORD 0
               u32 r_wr_low_pri_th : 2;           // DWORD 0
               u32 r_wr_combining : 1;            // DWORD 0
               u32 r_writepostingenabled : 1;     // DWORD 0
               u32 r_inject_error : 1;            // DWORD 0
               u32 enable_multiple_bit : 1;       // DWORD 0
               u32 enable_single_bit : 1;         // DWORD 0
               u32 multiple_bit_error : 1;        // DWORD 0
               u32 single_bit_error : 1;          // DWORD 0
               u32 r_scrub_enable : 1;            // DWORD 0
               u32 r_ecc_correction : 1;          // DWORD 0
               u32 r_ecc_mode : 1;                // DWORD 0
               u32 IS_667_MODE : 1;               // DWORD 0
               u32 r_datawidth32 : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DSSYSES, *PARMDDR_DSSYSES;

      SG_C_ASSERT(__sizeof__ARMDDR_DSSYSES, sizeof (ARMDDR_DSSYSES) == 4);

   #else
      typedef struct _ARMDDR_DSSYSES {
         u32 r_calibrate_ecc : 1;                 // DWORD 0
         u32 r_ref_times_dma32 : 3;               // DWORD 0
         u32 r_wr_after_exp_dma32 : 1;            // DWORD 0
         u32 r_strobe_override : 1;               // DWORD 0
         u32 r_strobe_delay1 : 1;                 // DWORD 0
         u32 r_strobe_delay : 1;                  // DWORD 0
         u32 r_overlap_enable : 1;                // DWORD 0
         u32 lasterrorlog : 1;                    // DWORD 0
         u32 r_read_opt_ul : 1;                   // DWORD 0
         u32 r_read_opt_fl : 1;                   // DWORD 0
         u32 r_ref_times : 3;                     // DWORD 0
         u32 r_wr_after_exp : 1;                  // DWORD 0
         u32 r_wr_high_pri_th : 2;                // DWORD 0
         u32 r_wr_low_pri_th : 2;                 // DWORD 0
         u32 r_wr_combining : 1;                  // DWORD 0
         u32 r_writepostingenabled : 1;           // DWORD 0
         u32 r_inject_error : 1;                  // DWORD 0
         u32 enable_multiple_bit : 1;             // DWORD 0
         u32 enable_single_bit : 1;               // DWORD 0
         u32 multiple_bit_error : 1;              // DWORD 0
         u32 single_bit_error : 1;                // DWORD 0
         u32 r_scrub_enable : 1;                  // DWORD 0
         u32 r_ecc_correction : 1;                // DWORD 0
         u32 r_ecc_mode : 1;                      // DWORD 0
         u32 IS_667_MODE : 1;                     // DWORD 0
         u32 r_datawidth32 : 1;                   // DWORD 0
      } SG_PACK ARMDDR_DSSYSES, *PARMDDR_DSSYSES;

      typedef union _ARMDDR_DSSYSES_UNION {
         ARMDDR_DSSYSES bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DSSYSES_UNION, *PARMDDR_DSSYSES_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DSSYSES_UNION, sizeof (ARMDDR_DSSYSES_UNION) == 4);
   #endif


#else
   // DDR2 system, error and status bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DSSYSES {
         union {
            struct { 
               u32 r_datawidth32 : 1;             // DWORD 0
               u32 IS_667_MODE : 1;               // DWORD 0
               u32 r_ecc_mode : 1;                // DWORD 0
               u32 r_ecc_correction : 1;          // DWORD 0
               u32 r_scrub_enable : 1;            // DWORD 0
               u32 single_bit_error : 1;          // DWORD 0
               u32 multiple_bit_error : 1;        // DWORD 0
               u32 enable_single_bit : 1;         // DWORD 0
               u32 enable_multiple_bit : 1;       // DWORD 0
               u32 r_inject_error : 1;            // DWORD 0
               u32 r_writepostingenabled : 1;     // DWORD 0
               u32 r_wr_combining : 1;            // DWORD 0
               u32 r_wr_low_pri_th : 2;           // DWORD 0
               u32 r_wr_high_pri_th : 2;          // DWORD 0
               u32 r_wr_after_exp : 1;            // DWORD 0
               u32 r_ref_times : 3;               // DWORD 0
               u32 r_read_opt_fl : 1;             // DWORD 0
               u32 r_read_opt_ul : 1;             // DWORD 0
               u32 lasterrorlog : 1;              // DWORD 0
               u32 r_overlap_enable : 1;          // DWORD 0
               u32 r_strobe_delay : 1;            // DWORD 0
               u32 r_strobe_delay1 : 1;           // DWORD 0
               u32 r_strobe_override : 1;         // DWORD 0
               u32 r_wr_after_exp_dma32 : 1;      // DWORD 0
               u32 r_ref_times_dma32 : 3;         // DWORD 0
               u32 r_calibrate_ecc : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DSSYSES, *PARMDDR_DSSYSES;

      SG_C_ASSERT(__sizeof__ARMDDR_DSSYSES, sizeof (ARMDDR_DSSYSES) == 4);

   #else
      typedef struct _ARMDDR_DSSYSES {
         u32 r_datawidth32 : 1;                   // DWORD 0
         u32 IS_667_MODE : 1;                     // DWORD 0
         u32 r_ecc_mode : 1;                      // DWORD 0
         u32 r_ecc_correction : 1;                // DWORD 0
         u32 r_scrub_enable : 1;                  // DWORD 0
         u32 single_bit_error : 1;                // DWORD 0
         u32 multiple_bit_error : 1;              // DWORD 0
         u32 enable_single_bit : 1;               // DWORD 0
         u32 enable_multiple_bit : 1;             // DWORD 0
         u32 r_inject_error : 1;                  // DWORD 0
         u32 r_writepostingenabled : 1;           // DWORD 0
         u32 r_wr_combining : 1;                  // DWORD 0
         u32 r_wr_low_pri_th : 2;                 // DWORD 0
         u32 r_wr_high_pri_th : 2;                // DWORD 0
         u32 r_wr_after_exp : 1;                  // DWORD 0
         u32 r_ref_times : 3;                     // DWORD 0
         u32 r_read_opt_fl : 1;                   // DWORD 0
         u32 r_read_opt_ul : 1;                   // DWORD 0
         u32 lasterrorlog : 1;                    // DWORD 0
         u32 r_overlap_enable : 1;                // DWORD 0
         u32 r_strobe_delay : 1;                  // DWORD 0
         u32 r_strobe_delay1 : 1;                 // DWORD 0
         u32 r_strobe_override : 1;               // DWORD 0
         u32 r_wr_after_exp_dma32 : 1;            // DWORD 0
         u32 r_ref_times_dma32 : 3;               // DWORD 0
         u32 r_calibrate_ecc : 1;                 // DWORD 0
      } SG_PACK ARMDDR_DSSYSES, *PARMDDR_DSSYSES;

      typedef union _ARMDDR_DSSYSES_UNION {
         ARMDDR_DSSYSES bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DSSYSES_UNION, *PARMDDR_DSSYSES_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DSSYSES_UNION, sizeof (ARMDDR_DSSYSES_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Memory timing register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_MEMTIMING {
         union {
            struct { 
               u32 r_testmeminit : 1;             // DWORD 0
               u32 r_sr_exit_ref_delay : 1;       // DWORD 0
               u32 r_sr_exit_com_delay : 1;       // DWORD 0
               u32 r_bank_opt : 1;                // DWORD 0
               u32 r_eapd2rdslow : 1;             // DWORD 0
               u32 r_wr2pre_del : 1;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 r_wr2wr_del : 2;               // DWORD 0
               u32 r_rd2pre_del : 1;              // DWORD 0
               u32 r_tRFC : 2;                    // DWORD 0
               u32 r_act2act_del : 1;             // DWORD 0
               u32 r_trc : 2;                     // DWORD 0
               u32 r_trp : 2;                     // DWORD 0
               u32 r_trcd : 2;                    // DWORD 0
               u32 r_rd2wr_del : 2;               // DWORD 0
               u32 r_act2sbact_del : 2;           // DWORD 0
               u32 r_act2pre_del : 2;             // DWORD 0
               u32 r_wr2rd_del : 2;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 r_rd2rd_del : 2;               // DWORD 0
               u32 r_CL : 2;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_MEMTIMING, *PARMDDR_MEMTIMING;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMTIMING, sizeof (ARMDDR_MEMTIMING) == 4);

   #else
      typedef struct _ARMDDR_MEMTIMING {
         u32 r_testmeminit : 1;                   // DWORD 0
         u32 r_sr_exit_ref_delay : 1;             // DWORD 0
         u32 r_sr_exit_com_delay : 1;             // DWORD 0
         u32 r_bank_opt : 1;                      // DWORD 0
         u32 r_eapd2rdslow : 1;                   // DWORD 0
         u32 r_wr2pre_del : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 r_wr2wr_del : 2;                     // DWORD 0
         u32 r_rd2pre_del : 1;                    // DWORD 0
         u32 r_tRFC : 2;                          // DWORD 0
         u32 r_act2act_del : 1;                   // DWORD 0
         u32 r_trc : 2;                           // DWORD 0
         u32 r_trp : 2;                           // DWORD 0
         u32 r_trcd : 2;                          // DWORD 0
         u32 r_rd2wr_del : 2;                     // DWORD 0
         u32 r_act2sbact_del : 2;                 // DWORD 0
         u32 r_act2pre_del : 2;                   // DWORD 0
         u32 r_wr2rd_del : 2;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 r_rd2rd_del : 2;                     // DWORD 0
         u32 r_CL : 2;                            // DWORD 0
      } SG_PACK ARMDDR_MEMTIMING, *PARMDDR_MEMTIMING;

      typedef union _ARMDDR_MEMTIMING_UNION {
         ARMDDR_MEMTIMING bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_MEMTIMING_UNION, *PARMDDR_MEMTIMING_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMTIMING_UNION, sizeof (ARMDDR_MEMTIMING_UNION) == 4);
   #endif


#else
   // Memory timing register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_MEMTIMING {
         union {
            struct { 
               u32 r_CL : 2;                      // DWORD 0
               u32 r_rd2rd_del : 2;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 r_wr2rd_del : 2;               // DWORD 0
               u32 r_act2pre_del : 2;             // DWORD 0
               u32 r_act2sbact_del : 2;           // DWORD 0
               u32 r_rd2wr_del : 2;               // DWORD 0
               u32 r_trcd : 2;                    // DWORD 0
               u32 r_trp : 2;                     // DWORD 0
               u32 r_trc : 2;                     // DWORD 0
               u32 r_act2act_del : 1;             // DWORD 0
               u32 r_tRFC : 2;                    // DWORD 0
               u32 r_rd2pre_del : 1;              // DWORD 0
               u32 r_wr2wr_del : 2;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 r_wr2pre_del : 1;              // DWORD 0
               u32 r_eapd2rdslow : 1;             // DWORD 0
               u32 r_bank_opt : 1;                // DWORD 0
               u32 r_sr_exit_com_delay : 1;       // DWORD 0
               u32 r_sr_exit_ref_delay : 1;       // DWORD 0
               u32 r_testmeminit : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_MEMTIMING, *PARMDDR_MEMTIMING;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMTIMING, sizeof (ARMDDR_MEMTIMING) == 4);

   #else
      typedef struct _ARMDDR_MEMTIMING {
         u32 r_CL : 2;                            // DWORD 0
         u32 r_rd2rd_del : 2;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 r_wr2rd_del : 2;                     // DWORD 0
         u32 r_act2pre_del : 2;                   // DWORD 0
         u32 r_act2sbact_del : 2;                 // DWORD 0
         u32 r_rd2wr_del : 2;                     // DWORD 0
         u32 r_trcd : 2;                          // DWORD 0
         u32 r_trp : 2;                           // DWORD 0
         u32 r_trc : 2;                           // DWORD 0
         u32 r_act2act_del : 1;                   // DWORD 0
         u32 r_tRFC : 2;                          // DWORD 0
         u32 r_rd2pre_del : 1;                    // DWORD 0
         u32 r_wr2wr_del : 2;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 r_wr2pre_del : 1;                    // DWORD 0
         u32 r_eapd2rdslow : 1;                   // DWORD 0
         u32 r_bank_opt : 1;                      // DWORD 0
         u32 r_sr_exit_com_delay : 1;             // DWORD 0
         u32 r_sr_exit_ref_delay : 1;             // DWORD 0
         u32 r_testmeminit : 1;                   // DWORD 0
      } SG_PACK ARMDDR_MEMTIMING, *PARMDDR_MEMTIMING;

      typedef union _ARMDDR_MEMTIMING_UNION {
         ARMDDR_MEMTIMING bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_MEMTIMING_UNION, *PARMDDR_MEMTIMING_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_MEMTIMING_UNION, sizeof (ARMDDR_MEMTIMING_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Refresh control and power down register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_REFRESHPOWERDOWN {
         union {
            struct { 
               u32 qempty_counter : 8;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 r_enable_lp_opt_opt : 1;       // DWORD 0
               u32 r_enable_lp_opt : 1;           // DWORD 0
               u32 r_clk_tristate : 1;            // DWORD 0
               u32 r_con_tristate : 1;            // DWORD 0
               u32 r_add_tristate : 1;            // DWORD 0
               u32 low_power_status : 1;          // DWORD 0
               u32 low_power_state : 1;           // DWORD 0
               u32 r_self_refresh_mode : 1;       // DWORD 0
               u32 r_active_power_mode : 1;       // DWORD 0
               u32 r_enable_refresh : 1;          // DWORD 0
               u32 r_reset_refresh : 1;           // DWORD 0
               u32 r_refresh_interval : 12;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_REFRESHPOWERDOWN, *PARMDDR_REFRESHPOWERDOWN;

      SG_C_ASSERT(__sizeof__ARMDDR_REFRESHPOWERDOWN, sizeof (ARMDDR_REFRESHPOWERDOWN) == 4);

   #else
      typedef struct _ARMDDR_REFRESHPOWERDOWN {
         u32 qempty_counter : 8;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 r_enable_lp_opt_opt : 1;             // DWORD 0
         u32 r_enable_lp_opt : 1;                 // DWORD 0
         u32 r_clk_tristate : 1;                  // DWORD 0
         u32 r_con_tristate : 1;                  // DWORD 0
         u32 r_add_tristate : 1;                  // DWORD 0
         u32 low_power_status : 1;                // DWORD 0
         u32 low_power_state : 1;                 // DWORD 0
         u32 r_self_refresh_mode : 1;             // DWORD 0
         u32 r_active_power_mode : 1;             // DWORD 0
         u32 r_enable_refresh : 1;                // DWORD 0
         u32 r_reset_refresh : 1;                 // DWORD 0
         u32 r_refresh_interval : 12;             // DWORD 0
      } SG_PACK ARMDDR_REFRESHPOWERDOWN, *PARMDDR_REFRESHPOWERDOWN;

      typedef union _ARMDDR_REFRESHPOWERDOWN_UNION {
         ARMDDR_REFRESHPOWERDOWN bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_REFRESHPOWERDOWN_UNION, *PARMDDR_REFRESHPOWERDOWN_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_REFRESHPOWERDOWN_UNION, sizeof (ARMDDR_REFRESHPOWERDOWN_UNION) == 4);
   #endif


#else
   // Refresh control and power down register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_REFRESHPOWERDOWN {
         union {
            struct { 
               u32 r_refresh_interval : 12;       // DWORD 0
               u32 r_reset_refresh : 1;           // DWORD 0
               u32 r_enable_refresh : 1;          // DWORD 0
               u32 r_active_power_mode : 1;       // DWORD 0
               u32 r_self_refresh_mode : 1;       // DWORD 0
               u32 low_power_state : 1;           // DWORD 0
               u32 low_power_status : 1;          // DWORD 0
               u32 r_add_tristate : 1;            // DWORD 0
               u32 r_con_tristate : 1;            // DWORD 0
               u32 r_clk_tristate : 1;            // DWORD 0
               u32 r_enable_lp_opt : 1;           // DWORD 0
               u32 r_enable_lp_opt_opt : 1;       // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 qempty_counter : 8;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_REFRESHPOWERDOWN, *PARMDDR_REFRESHPOWERDOWN;

      SG_C_ASSERT(__sizeof__ARMDDR_REFRESHPOWERDOWN, sizeof (ARMDDR_REFRESHPOWERDOWN) == 4);

   #else
      typedef struct _ARMDDR_REFRESHPOWERDOWN {
         u32 r_refresh_interval : 12;             // DWORD 0
         u32 r_reset_refresh : 1;                 // DWORD 0
         u32 r_enable_refresh : 1;                // DWORD 0
         u32 r_active_power_mode : 1;             // DWORD 0
         u32 r_self_refresh_mode : 1;             // DWORD 0
         u32 low_power_state : 1;                 // DWORD 0
         u32 low_power_status : 1;                // DWORD 0
         u32 r_add_tristate : 1;                  // DWORD 0
         u32 r_con_tristate : 1;                  // DWORD 0
         u32 r_clk_tristate : 1;                  // DWORD 0
         u32 r_enable_lp_opt : 1;                 // DWORD 0
         u32 r_enable_lp_opt_opt : 1;             // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 qempty_counter : 8;                  // DWORD 0
      } SG_PACK ARMDDR_REFRESHPOWERDOWN, *PARMDDR_REFRESHPOWERDOWN;

      typedef union _ARMDDR_REFRESHPOWERDOWN_UNION {
         ARMDDR_REFRESHPOWERDOWN bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_REFRESHPOWERDOWN_UNION, *PARMDDR_REFRESHPOWERDOWN_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_REFRESHPOWERDOWN_UNION, sizeof (ARMDDR_REFRESHPOWERDOWN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Compensation register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_COMPENSATION {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 r_clk_csel : 1;                // DWORD 0
               u32 r_map_l_to_u : 1;              // DWORD 0
               u32 r_map_u_to_l : 1;              // DWORD 0
               u32 queues_are_empty : 1;          // DWORD 0
               u32 r_empty_queues : 1;            // DWORD 0
               u32 r_inv_clock_pol : 1;           // DWORD 0
               u32 r_odt_enable : 1;              // DWORD 0
               u32 r_row_type0 : 2;               // DWORD 0
               u32 r_present_rows : 1;            // DWORD 0
               u32 r_sp_applycomputed : 1;        // DWORD 0
               u32 r_sp_readcomputed : 1;         // DWORD 0
               u32 r_sp_recompute : 1;            // DWORD 0
               u32 r_sp_reg_value : 5;            // DWORD 0
               u32 r_sn_applycomputed : 1;        // DWORD 0
               u32 r_sn_readcomputed : 1;         // DWORD 0
               u32 r_sn_recompute : 1;            // DWORD 0
               u32 r_sn_reg_value : 5;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_COMPENSATION, *PARMDDR_COMPENSATION;

      SG_C_ASSERT(__sizeof__ARMDDR_COMPENSATION, sizeof (ARMDDR_COMPENSATION) == 4);

   #else
      typedef struct _ARMDDR_COMPENSATION {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 r_clk_csel : 1;                      // DWORD 0
         u32 r_map_l_to_u : 1;                    // DWORD 0
         u32 r_map_u_to_l : 1;                    // DWORD 0
         u32 queues_are_empty : 1;                // DWORD 0
         u32 r_empty_queues : 1;                  // DWORD 0
         u32 r_inv_clock_pol : 1;                 // DWORD 0
         u32 r_odt_enable : 1;                    // DWORD 0
         u32 r_row_type0 : 2;                     // DWORD 0
         u32 r_present_rows : 1;                  // DWORD 0
         u32 r_sp_applycomputed : 1;              // DWORD 0
         u32 r_sp_readcomputed : 1;               // DWORD 0
         u32 r_sp_recompute : 1;                  // DWORD 0
         u32 r_sp_reg_value : 5;                  // DWORD 0
         u32 r_sn_applycomputed : 1;              // DWORD 0
         u32 r_sn_readcomputed : 1;               // DWORD 0
         u32 r_sn_recompute : 1;                  // DWORD 0
         u32 r_sn_reg_value : 5;                  // DWORD 0
      } SG_PACK ARMDDR_COMPENSATION, *PARMDDR_COMPENSATION;

      typedef union _ARMDDR_COMPENSATION_UNION {
         ARMDDR_COMPENSATION bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_COMPENSATION_UNION, *PARMDDR_COMPENSATION_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_COMPENSATION_UNION, sizeof (ARMDDR_COMPENSATION_UNION) == 4);
   #endif


#else
   // Compensation register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_COMPENSATION {
         union {
            struct { 
               u32 r_sn_reg_value : 5;            // DWORD 0
               u32 r_sn_recompute : 1;            // DWORD 0
               u32 r_sn_readcomputed : 1;         // DWORD 0
               u32 r_sn_applycomputed : 1;        // DWORD 0
               u32 r_sp_reg_value : 5;            // DWORD 0
               u32 r_sp_recompute : 1;            // DWORD 0
               u32 r_sp_readcomputed : 1;         // DWORD 0
               u32 r_sp_applycomputed : 1;        // DWORD 0
               u32 r_present_rows : 1;            // DWORD 0
               u32 r_row_type0 : 2;               // DWORD 0
               u32 r_odt_enable : 1;              // DWORD 0
               u32 r_inv_clock_pol : 1;           // DWORD 0
               u32 r_empty_queues : 1;            // DWORD 0
               u32 queues_are_empty : 1;          // DWORD 0
               u32 r_map_u_to_l : 1;              // DWORD 0
               u32 r_map_l_to_u : 1;              // DWORD 0
               u32 r_clk_csel : 1;                // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_COMPENSATION, *PARMDDR_COMPENSATION;

      SG_C_ASSERT(__sizeof__ARMDDR_COMPENSATION, sizeof (ARMDDR_COMPENSATION) == 4);

   #else
      typedef struct _ARMDDR_COMPENSATION {
         u32 r_sn_reg_value : 5;                  // DWORD 0
         u32 r_sn_recompute : 1;                  // DWORD 0
         u32 r_sn_readcomputed : 1;               // DWORD 0
         u32 r_sn_applycomputed : 1;              // DWORD 0
         u32 r_sp_reg_value : 5;                  // DWORD 0
         u32 r_sp_recompute : 1;                  // DWORD 0
         u32 r_sp_readcomputed : 1;               // DWORD 0
         u32 r_sp_applycomputed : 1;              // DWORD 0
         u32 r_present_rows : 1;                  // DWORD 0
         u32 r_row_type0 : 2;                     // DWORD 0
         u32 r_odt_enable : 1;                    // DWORD 0
         u32 r_inv_clock_pol : 1;                 // DWORD 0
         u32 r_empty_queues : 1;                  // DWORD 0
         u32 queues_are_empty : 1;                // DWORD 0
         u32 r_map_u_to_l : 1;                    // DWORD 0
         u32 r_map_l_to_u : 1;                    // DWORD 0
         u32 r_clk_csel : 1;                      // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
      } SG_PACK ARMDDR_COMPENSATION, *PARMDDR_COMPENSATION;

      typedef union _ARMDDR_COMPENSATION_UNION {
         ARMDDR_COMPENSATION bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_COMPENSATION_UNION, *PARMDDR_COMPENSATION_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_COMPENSATION_UNION, sizeof (ARMDDR_COMPENSATION_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DDR2 address bits for error injection.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DERRINJADD {
         union {
            struct { 
               u32 r_error_address;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DERRINJADD, *PARMDDR_DERRINJADD;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRINJADD, sizeof (ARMDDR_DERRINJADD) == 4);

   #else
      typedef struct _ARMDDR_DERRINJADD {
         u32 r_error_address;                     // DWORD 0
      } SG_PACK ARMDDR_DERRINJADD, *PARMDDR_DERRINJADD;

      typedef union _ARMDDR_DERRINJADD_UNION {
         ARMDDR_DERRINJADD bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DERRINJADD_UNION, *PARMDDR_DERRINJADD_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRINJADD_UNION, sizeof (ARMDDR_DERRINJADD_UNION) == 4);
   #endif


#else
   // DDR2 address bits for error injection.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DERRINJADD {
         union {
            struct { 
               u32 r_error_address;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DERRINJADD, *PARMDDR_DERRINJADD;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRINJADD, sizeof (ARMDDR_DERRINJADD) == 4);

   #else
      typedef struct _ARMDDR_DERRINJADD {
         u32 r_error_address;                     // DWORD 0
      } SG_PACK ARMDDR_DERRINJADD, *PARMDDR_DERRINJADD;

      typedef union _ARMDDR_DERRINJADD_UNION {
         ARMDDR_DERRINJADD bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DERRINJADD_UNION, *PARMDDR_DERRINJADD_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRINJADD_UNION, sizeof (ARMDDR_DERRINJADD_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DDR2 error address for read.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DERRRDADD {
         union {
            struct { 
               u32 ceaddress;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DERRRDADD, *PARMDDR_DERRRDADD;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRRDADD, sizeof (ARMDDR_DERRRDADD) == 4);

   #else
      typedef struct _ARMDDR_DERRRDADD {
         u32 ceaddress;                           // DWORD 0
      } SG_PACK ARMDDR_DERRRDADD, *PARMDDR_DERRRDADD;

      typedef union _ARMDDR_DERRRDADD_UNION {
         ARMDDR_DERRRDADD bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DERRRDADD_UNION, *PARMDDR_DERRRDADD_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRRDADD_UNION, sizeof (ARMDDR_DERRRDADD_UNION) == 4);
   #endif


#else
   // DDR2 error address for read.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DERRRDADD {
         union {
            struct { 
               u32 ceaddress;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DERRRDADD, *PARMDDR_DERRRDADD;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRRDADD, sizeof (ARMDDR_DERRRDADD) == 4);

   #else
      typedef struct _ARMDDR_DERRRDADD {
         u32 ceaddress;                           // DWORD 0
      } SG_PACK ARMDDR_DERRRDADD, *PARMDDR_DERRRDADD;

      typedef union _ARMDDR_DERRRDADD_UNION {
         ARMDDR_DERRRDADD bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DERRRDADD_UNION, *PARMDDR_DERRRDADD_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DERRRDADD_UNION, sizeof (ARMDDR_DERRRDADD_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DDR2 syndrome bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DSRC {
         union {
            struct { 
               u32 r_ecc_calib_bits : 8;          // DWORD 0
               u32 ddr_syndrome_bits : 8;         // DWORD 0
               u32 r_wr_high_pri_th_dma32 : 3;    // DWORD 0
               u32 r_wr_low_pri_th_dma32 : 3;     // DWORD 0
               u32 r_wr_combining_dma32 : 1;      // DWORD 0
               u32 r_writepostingenabled_dma32 : 1; // DWORD 0
               u32 r_error_vector_eccpar : 8;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DSRC, *PARMDDR_DSRC;

      SG_C_ASSERT(__sizeof__ARMDDR_DSRC, sizeof (ARMDDR_DSRC) == 4);

   #else
      typedef struct _ARMDDR_DSRC {
         u32 r_ecc_calib_bits : 8;                // DWORD 0
         u32 ddr_syndrome_bits : 8;               // DWORD 0
         u32 r_wr_high_pri_th_dma32 : 3;          // DWORD 0
         u32 r_wr_low_pri_th_dma32 : 3;           // DWORD 0
         u32 r_wr_combining_dma32 : 1;            // DWORD 0
         u32 r_writepostingenabled_dma32 : 1;     // DWORD 0
         u32 r_error_vector_eccpar : 8;           // DWORD 0
      } SG_PACK ARMDDR_DSRC, *PARMDDR_DSRC;

      typedef union _ARMDDR_DSRC_UNION {
         ARMDDR_DSRC bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DSRC_UNION, *PARMDDR_DSRC_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DSRC_UNION, sizeof (ARMDDR_DSRC_UNION) == 4);
   #endif


#else
   // DDR2 syndrome bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_DSRC {
         union {
            struct { 
               u32 r_error_vector_eccpar : 8;     // DWORD 0
               u32 r_writepostingenabled_dma32 : 1; // DWORD 0
               u32 r_wr_combining_dma32 : 1;      // DWORD 0
               u32 r_wr_low_pri_th_dma32 : 3;     // DWORD 0
               u32 r_wr_high_pri_th_dma32 : 3;    // DWORD 0
               u32 ddr_syndrome_bits : 8;         // DWORD 0
               u32 r_ecc_calib_bits : 8;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_DSRC, *PARMDDR_DSRC;

      SG_C_ASSERT(__sizeof__ARMDDR_DSRC, sizeof (ARMDDR_DSRC) == 4);

   #else
      typedef struct _ARMDDR_DSRC {
         u32 r_error_vector_eccpar : 8;           // DWORD 0
         u32 r_writepostingenabled_dma32 : 1;     // DWORD 0
         u32 r_wr_combining_dma32 : 1;            // DWORD 0
         u32 r_wr_low_pri_th_dma32 : 3;           // DWORD 0
         u32 r_wr_high_pri_th_dma32 : 3;          // DWORD 0
         u32 ddr_syndrome_bits : 8;               // DWORD 0
         u32 r_ecc_calib_bits : 8;                // DWORD 0
      } SG_PACK ARMDDR_DSRC, *PARMDDR_DSRC;

      typedef union _ARMDDR_DSRC_UNION {
         ARMDDR_DSRC bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_DSRC_UNION, *PARMDDR_DSRC_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_DSRC_UNION, sizeof (ARMDDR_DSRC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Error vector lower 32 bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_ERRVTRLO {
         union {
            struct { 
               u32 r_error_vector;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_ERRVTRLO, *PARMDDR_ERRVTRLO;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRLO, sizeof (ARMDDR_ERRVTRLO) == 4);

   #else
      typedef struct _ARMDDR_ERRVTRLO {
         u32 r_error_vector;                      // DWORD 0
      } SG_PACK ARMDDR_ERRVTRLO, *PARMDDR_ERRVTRLO;

      typedef union _ARMDDR_ERRVTRLO_UNION {
         ARMDDR_ERRVTRLO bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_ERRVTRLO_UNION, *PARMDDR_ERRVTRLO_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRLO_UNION, sizeof (ARMDDR_ERRVTRLO_UNION) == 4);
   #endif


#else
   // Error vector lower 32 bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_ERRVTRLO {
         union {
            struct { 
               u32 r_error_vector;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_ERRVTRLO, *PARMDDR_ERRVTRLO;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRLO, sizeof (ARMDDR_ERRVTRLO) == 4);

   #else
      typedef struct _ARMDDR_ERRVTRLO {
         u32 r_error_vector;                      // DWORD 0
      } SG_PACK ARMDDR_ERRVTRLO, *PARMDDR_ERRVTRLO;

      typedef union _ARMDDR_ERRVTRLO_UNION {
         ARMDDR_ERRVTRLO bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_ERRVTRLO_UNION, *PARMDDR_ERRVTRLO_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRLO_UNION, sizeof (ARMDDR_ERRVTRLO_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Error vector higher 32 bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_ERRVTRHI {
         union {
            struct { 
               u32 r_error_vector;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_ERRVTRHI, *PARMDDR_ERRVTRHI;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRHI, sizeof (ARMDDR_ERRVTRHI) == 4);

   #else
      typedef struct _ARMDDR_ERRVTRHI {
         u32 r_error_vector;                      // DWORD 0
      } SG_PACK ARMDDR_ERRVTRHI, *PARMDDR_ERRVTRHI;

      typedef union _ARMDDR_ERRVTRHI_UNION {
         ARMDDR_ERRVTRHI bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_ERRVTRHI_UNION, *PARMDDR_ERRVTRHI_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRHI_UNION, sizeof (ARMDDR_ERRVTRHI_UNION) == 4);
   #endif


#else
   // Error vector higher 32 bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_ERRVTRHI {
         union {
            struct { 
               u32 r_error_vector;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_ERRVTRHI, *PARMDDR_ERRVTRHI;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRHI, sizeof (ARMDDR_ERRVTRHI) == 4);

   #else
      typedef struct _ARMDDR_ERRVTRHI {
         u32 r_error_vector;                      // DWORD 0
      } SG_PACK ARMDDR_ERRVTRHI, *PARMDDR_ERRVTRHI;

      typedef union _ARMDDR_ERRVTRHI_UNION {
         ARMDDR_ERRVTRHI bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_ERRVTRHI_UNION, *PARMDDR_ERRVTRHI_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_ERRVTRHI_UNION, sizeof (ARMDDR_ERRVTRHI_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Streamer AHBDMA Arbiter Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_STRAHBDMAARB {
         union {
            struct { 
               u32 r_max_no_of_dmards_per_ahbrds : 3; // DWORD 0
               u32 r_honour_gr_hi_pri : 1;        // DWORD 0
               u32 overlap_disable_ahbdma_st : 1; // DWORD 0
               u32 max_posted_refreshes : 2;      // DWORD 0
               u32 allow_high_pri_refresh : 1;    // DWORD 0
               u32 r_max_no_of_rds_per_wrs : 4;   // DWORD 0
               u32 r_max_no_of_dmawrs_per_ahbwrs : 3; // DWORD 0
               u32 r_max_no_of_str_strds : 3;     // DWORD 0
               u32 r_max_no_of_ahbdma_stwrs : 3;  // DWORD 0
               u32 r_max_no_of_ahb_strds : 3;     // DWORD 0
               u32 r_max_no_of_dma_strds : 3;     // DWORD 0
               u32 r_max_no_of_str_rds_per_ahbdma_rds : 5; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_STRAHBDMAARB, *PARMDDR_STRAHBDMAARB;

      SG_C_ASSERT(__sizeof__ARMDDR_STRAHBDMAARB, sizeof (ARMDDR_STRAHBDMAARB) == 4);

   #else
      typedef struct _ARMDDR_STRAHBDMAARB {
         u32 r_max_no_of_dmards_per_ahbrds : 3;   // DWORD 0
         u32 r_honour_gr_hi_pri : 1;              // DWORD 0
         u32 overlap_disable_ahbdma_st : 1;       // DWORD 0
         u32 max_posted_refreshes : 2;            // DWORD 0
         u32 allow_high_pri_refresh : 1;          // DWORD 0
         u32 r_max_no_of_rds_per_wrs : 4;         // DWORD 0
         u32 r_max_no_of_dmawrs_per_ahbwrs : 3;   // DWORD 0
         u32 r_max_no_of_str_strds : 3;           // DWORD 0
         u32 r_max_no_of_ahbdma_stwrs : 3;        // DWORD 0
         u32 r_max_no_of_ahb_strds : 3;           // DWORD 0
         u32 r_max_no_of_dma_strds : 3;           // DWORD 0
         u32 r_max_no_of_str_rds_per_ahbdma_rds : 5; // DWORD 0
      } SG_PACK ARMDDR_STRAHBDMAARB, *PARMDDR_STRAHBDMAARB;

      typedef union _ARMDDR_STRAHBDMAARB_UNION {
         ARMDDR_STRAHBDMAARB bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_STRAHBDMAARB_UNION, *PARMDDR_STRAHBDMAARB_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_STRAHBDMAARB_UNION, sizeof (ARMDDR_STRAHBDMAARB_UNION) == 4);
   #endif


#else
   // Streamer AHBDMA Arbiter Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_STRAHBDMAARB {
         union {
            struct { 
               u32 r_max_no_of_str_rds_per_ahbdma_rds : 5; // DWORD 0
               u32 r_max_no_of_dma_strds : 3;     // DWORD 0
               u32 r_max_no_of_ahb_strds : 3;     // DWORD 0
               u32 r_max_no_of_ahbdma_stwrs : 3;  // DWORD 0
               u32 r_max_no_of_str_strds : 3;     // DWORD 0
               u32 r_max_no_of_dmawrs_per_ahbwrs : 3; // DWORD 0
               u32 r_max_no_of_rds_per_wrs : 4;   // DWORD 0
               u32 allow_high_pri_refresh : 1;    // DWORD 0
               u32 max_posted_refreshes : 2;      // DWORD 0
               u32 overlap_disable_ahbdma_st : 1; // DWORD 0
               u32 r_honour_gr_hi_pri : 1;        // DWORD 0
               u32 r_max_no_of_dmards_per_ahbrds : 3; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_STRAHBDMAARB, *PARMDDR_STRAHBDMAARB;

      SG_C_ASSERT(__sizeof__ARMDDR_STRAHBDMAARB, sizeof (ARMDDR_STRAHBDMAARB) == 4);

   #else
      typedef struct _ARMDDR_STRAHBDMAARB {
         u32 r_max_no_of_str_rds_per_ahbdma_rds : 5; // DWORD 0
         u32 r_max_no_of_dma_strds : 3;           // DWORD 0
         u32 r_max_no_of_ahb_strds : 3;           // DWORD 0
         u32 r_max_no_of_ahbdma_stwrs : 3;        // DWORD 0
         u32 r_max_no_of_str_strds : 3;           // DWORD 0
         u32 r_max_no_of_dmawrs_per_ahbwrs : 3;   // DWORD 0
         u32 r_max_no_of_rds_per_wrs : 4;         // DWORD 0
         u32 allow_high_pri_refresh : 1;          // DWORD 0
         u32 max_posted_refreshes : 2;            // DWORD 0
         u32 overlap_disable_ahbdma_st : 1;       // DWORD 0
         u32 r_honour_gr_hi_pri : 1;              // DWORD 0
         u32 r_max_no_of_dmards_per_ahbrds : 3;   // DWORD 0
      } SG_PACK ARMDDR_STRAHBDMAARB, *PARMDDR_STRAHBDMAARB;

      typedef union _ARMDDR_STRAHBDMAARB_UNION {
         ARMDDR_STRAHBDMAARB bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_STRAHBDMAARB_UNION, *PARMDDR_STRAHBDMAARB_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_STRAHBDMAARB_UNION, sizeof (ARMDDR_STRAHBDMAARB_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt status register0.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_INTERRUPTSTATUSREGISTER0 {
         union {
            struct { 
               u32 err_debug0;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_INTERRUPTSTATUSREGISTER0, *PARMDDR_INTERRUPTSTATUSREGISTER0;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTSTATUSREGISTER0, sizeof (ARMDDR_INTERRUPTSTATUSREGISTER0) == 4);

   #else
      typedef struct _ARMDDR_INTERRUPTSTATUSREGISTER0 {
         u32 err_debug0;                          // DWORD 0
      } SG_PACK ARMDDR_INTERRUPTSTATUSREGISTER0, *PARMDDR_INTERRUPTSTATUSREGISTER0;

      typedef union _ARMDDR_INTERRUPTSTATUSREGISTER0_UNION {
         ARMDDR_INTERRUPTSTATUSREGISTER0 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_INTERRUPTSTATUSREGISTER0_UNION, *PARMDDR_INTERRUPTSTATUSREGISTER0_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTSTATUSREGISTER0_UNION, sizeof (ARMDDR_INTERRUPTSTATUSREGISTER0_UNION) == 4);
   #endif


#else
   // Interrupt status register0.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_INTERRUPTSTATUSREGISTER0 {
         union {
            struct { 
               u32 err_debug0;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_INTERRUPTSTATUSREGISTER0, *PARMDDR_INTERRUPTSTATUSREGISTER0;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTSTATUSREGISTER0, sizeof (ARMDDR_INTERRUPTSTATUSREGISTER0) == 4);

   #else
      typedef struct _ARMDDR_INTERRUPTSTATUSREGISTER0 {
         u32 err_debug0;                          // DWORD 0
      } SG_PACK ARMDDR_INTERRUPTSTATUSREGISTER0, *PARMDDR_INTERRUPTSTATUSREGISTER0;

      typedef union _ARMDDR_INTERRUPTSTATUSREGISTER0_UNION {
         ARMDDR_INTERRUPTSTATUSREGISTER0 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_INTERRUPTSTATUSREGISTER0_UNION, *PARMDDR_INTERRUPTSTATUSREGISTER0_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTSTATUSREGISTER0_UNION, sizeof (ARMDDR_INTERRUPTSTATUSREGISTER0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt enable register0.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_INTERRUPTENREGISTER0 {
         union {
            struct { 
               u32 err_en0;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_INTERRUPTENREGISTER0, *PARMDDR_INTERRUPTENREGISTER0;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTENREGISTER0, sizeof (ARMDDR_INTERRUPTENREGISTER0) == 4);

   #else
      typedef struct _ARMDDR_INTERRUPTENREGISTER0 {
         u32 err_en0;                             // DWORD 0
      } SG_PACK ARMDDR_INTERRUPTENREGISTER0, *PARMDDR_INTERRUPTENREGISTER0;

      typedef union _ARMDDR_INTERRUPTENREGISTER0_UNION {
         ARMDDR_INTERRUPTENREGISTER0 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_INTERRUPTENREGISTER0_UNION, *PARMDDR_INTERRUPTENREGISTER0_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTENREGISTER0_UNION, sizeof (ARMDDR_INTERRUPTENREGISTER0_UNION) == 4);
   #endif


#else
   // Interrupt enable register0.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_INTERRUPTENREGISTER0 {
         union {
            struct { 
               u32 err_en0;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_INTERRUPTENREGISTER0, *PARMDDR_INTERRUPTENREGISTER0;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTENREGISTER0, sizeof (ARMDDR_INTERRUPTENREGISTER0) == 4);

   #else
      typedef struct _ARMDDR_INTERRUPTENREGISTER0 {
         u32 err_en0;                             // DWORD 0
      } SG_PACK ARMDDR_INTERRUPTENREGISTER0, *PARMDDR_INTERRUPTENREGISTER0;

      typedef union _ARMDDR_INTERRUPTENREGISTER0_UNION {
         ARMDDR_INTERRUPTENREGISTER0 bits;
         u32 dw; // dword union
      } SG_PACK ARMDDR_INTERRUPTENREGISTER0_UNION, *PARMDDR_INTERRUPTENREGISTER0_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_INTERRUPTENREGISTER0_UNION, sizeof (ARMDDR_INTERRUPTENREGISTER0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The ARMDDR_CSRMAP defines the layout of the ARM DDR Memory Controller Registers.
   // They may be accessed directly from the ARM, or via CSR using the MPU_DDR_ADDR_CSR
   // and MPU_DDR_RWDATA_CSR registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_CSRMAP {
         union {
            struct { 
               ARMDDR_MEMINIT meminit;
               ARMDDR_DQSDEL0 dqsdel0;
               ARMDDR_DQSDEL1 dqsdel1;
               ARMDDR_DSSYSES dssyses;
               ARMDDR_MEMTIMING memtiming;
               ARMDDR_REFRESHPOWERDOWN refreshpowerdown;
               ARMDDR_COMPENSATION compensation;
               ARMDDR_DERRINJADD derrinjadd;
               ARMDDR_DERRRDADD derrrdadd;
               ARMDDR_DSRC dsrc;
               ARMDDR_ERRVTRLO errvtrlo;
               ARMDDR_ERRVTRHI errvtrhi;
               ARMDDR_STRAHBDMAARB strahbdmaarb;
               u32 rsvd0[3];                      // DWORDS 13 to 15
               ARMDDR_INTERRUPTSTATUSREGISTER0 interruptstatusregister0;
               ARMDDR_INTERRUPTENREGISTER0 interruptenregister0;
               u32 rsvd1[238];                    // DWORDS 18 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_CSRMAP, *PARMDDR_CSRMAP;

      SG_C_ASSERT(__sizeof__ARMDDR_CSRMAP, sizeof (ARMDDR_CSRMAP) == 1024);

   #else
      typedef struct _ARMDDR_CSRMAP {
         ARMDDR_MEMINIT meminit;
         ARMDDR_DQSDEL0 dqsdel0;
         ARMDDR_DQSDEL1 dqsdel1;
         ARMDDR_DSSYSES dssyses;
         ARMDDR_MEMTIMING memtiming;
         ARMDDR_REFRESHPOWERDOWN refreshpowerdown;
         ARMDDR_COMPENSATION compensation;
         ARMDDR_DERRINJADD derrinjadd;
         ARMDDR_DERRRDADD derrrdadd;
         ARMDDR_DSRC dsrc;
         ARMDDR_ERRVTRLO errvtrlo;
         ARMDDR_ERRVTRHI errvtrhi;
         ARMDDR_STRAHBDMAARB strahbdmaarb;
         u32 rsvd0[3];                            // DWORDS 13 to 15
         ARMDDR_INTERRUPTSTATUSREGISTER0 interruptstatusregister0;
         ARMDDR_INTERRUPTENREGISTER0 interruptenregister0;
         u32 rsvd1[238];                          // DWORDS 18 to 255
      } SG_PACK ARMDDR_CSRMAP, *PARMDDR_CSRMAP;

      typedef union _ARMDDR_CSRMAP_UNION {
         ARMDDR_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK ARMDDR_CSRMAP_UNION, *PARMDDR_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_CSRMAP_UNION, sizeof (ARMDDR_CSRMAP_UNION) == 1024);
   #endif


#else
   // The ARMDDR_CSRMAP defines the layout of the ARM DDR Memory Controller Registers.
   // They may be accessed directly from the ARM, or via CSR using the MPU_DDR_ADDR_CSR
   // and MPU_DDR_RWDATA_CSR registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMDDR_CSRMAP {
         union {
            struct { 
               ARMDDR_MEMINIT meminit;
               ARMDDR_DQSDEL0 dqsdel0;
               ARMDDR_DQSDEL1 dqsdel1;
               ARMDDR_DSSYSES dssyses;
               ARMDDR_MEMTIMING memtiming;
               ARMDDR_REFRESHPOWERDOWN refreshpowerdown;
               ARMDDR_COMPENSATION compensation;
               ARMDDR_DERRINJADD derrinjadd;
               ARMDDR_DERRRDADD derrrdadd;
               ARMDDR_DSRC dsrc;
               ARMDDR_ERRVTRLO errvtrlo;
               ARMDDR_ERRVTRHI errvtrhi;
               ARMDDR_STRAHBDMAARB strahbdmaarb;
               u32 rsvd0[3];                      // DWORDS 13 to 15
               ARMDDR_INTERRUPTSTATUSREGISTER0 interruptstatusregister0;
               ARMDDR_INTERRUPTENREGISTER0 interruptenregister0;
               u32 rsvd1[238];                    // DWORDS 18 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ARMDDR_CSRMAP, *PARMDDR_CSRMAP;

      SG_C_ASSERT(__sizeof__ARMDDR_CSRMAP, sizeof (ARMDDR_CSRMAP) == 1024);

   #else
      typedef struct _ARMDDR_CSRMAP {
         ARMDDR_MEMINIT meminit;
         ARMDDR_DQSDEL0 dqsdel0;
         ARMDDR_DQSDEL1 dqsdel1;
         ARMDDR_DSSYSES dssyses;
         ARMDDR_MEMTIMING memtiming;
         ARMDDR_REFRESHPOWERDOWN refreshpowerdown;
         ARMDDR_COMPENSATION compensation;
         ARMDDR_DERRINJADD derrinjadd;
         ARMDDR_DERRRDADD derrrdadd;
         ARMDDR_DSRC dsrc;
         ARMDDR_ERRVTRLO errvtrlo;
         ARMDDR_ERRVTRHI errvtrhi;
         ARMDDR_STRAHBDMAARB strahbdmaarb;
         u32 rsvd0[3];                            // DWORDS 13 to 15
         ARMDDR_INTERRUPTSTATUSREGISTER0 interruptstatusregister0;
         ARMDDR_INTERRUPTENREGISTER0 interruptenregister0;
         u32 rsvd1[238];                          // DWORDS 18 to 255
      } SG_PACK ARMDDR_CSRMAP, *PARMDDR_CSRMAP;

      typedef union _ARMDDR_CSRMAP_UNION {
         ARMDDR_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK ARMDDR_CSRMAP_UNION, *PARMDDR_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__ARMDDR_CSRMAP_UNION, sizeof (ARMDDR_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __armddr_bmap_h__

