/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __asyncmesg_bmap_h__
#define __asyncmesg_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "nativedefs_bmap.h"
#include "ioctl_common_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The last 4 bytes of the async events have this common format. It allows the driver
   // to distinguish MCC_CQ_ENTRY structs from asynchronous events. Both arrive on the
   // same completion queue. This structure also contains the common fields used to decode
   // the async event. 
   typedef struct _ASYNC_EVENT_TRAILER {
      u32 valid : 1;                              // DWORD 0
      u32 async_event : 1;                        // DWORD 0
      u32 rsvd1 : 6;                              // DWORD 0
      u32 event_type : 8;                         // DWORD 0
      u32 event_code : 8;                         // DWORD 0
      u32 rsvd0 : 8;                              // DWORD 0
   } SG_PACK ASYNC_EVENT_TRAILER, *PASYNC_EVENT_TRAILER;



#else
   // The last 4 bytes of the async events have this common format. It allows the driver
   // to distinguish MCC_CQ_ENTRY structs from asynchronous events. Both arrive on the
   // same completion queue. This structure also contains the common fields used to decode
   // the async event. 
   typedef struct _ASYNC_EVENT_TRAILER {
      u32 rsvd0 : 8;                              // DWORD 0
      u32 event_code : 8;                         // DWORD 0
      u32 event_type : 8;                         // DWORD 0
      u32 rsvd1 : 6;                              // DWORD 0
      u32 async_event : 1;                        // DWORD 0
      u32 valid : 1;                              // DWORD 0
   } SG_PACK ASYNC_EVENT_TRAILER, *PASYNC_EVENT_TRAILER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   //  Note Applicable in Initiator, Target and TOE modes.  A link state async event is
   // seen by all device drivers as soon they create an MCC ring. Thereafter, anytime the
   // link status changes the drivers will receive a link state async event. Notifications
   // continue to be sent until a driver destroys its MCC ring. A link down event is
   // reported when a client's port loses link. A link up event is reported when that port
   // regains link. 
   typedef struct _ASYNC_EVENT_LINK_STATE {
      UEXACT8 physical_port;
      UEXACT8 port_link_status;
      UEXACT8 port_duplex;
      UEXACT8 port_speed;
      UEXACT8 port_fault;
      UEXACT8 event_reason;
      UEXACT16 qos_link_speed;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_LINK_STATE, *PASYNC_EVENT_LINK_STATE;



#else
   //  Note Applicable in Initiator, Target and TOE modes.  A link state async event is
   // seen by all device drivers as soon they create an MCC ring. Thereafter, anytime the
   // link status changes the drivers will receive a link state async event. Notifications
   // continue to be sent until a driver destroys its MCC ring. A link down event is
   // reported when a client's port loses link. A link up event is reported when that port
   // regains link. 
   typedef struct _ASYNC_EVENT_LINK_STATE {
      UEXACT8 physical_port;
      UEXACT8 port_link_status;
      UEXACT8 port_duplex;
      UEXACT8 port_speed;
      UEXACT8 port_fault;
      UEXACT8 event_reason;
      UEXACT16 qos_link_speed;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_LINK_STATE, *PASYNC_EVENT_LINK_STATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ASYNC_EVENT_GRP_5_QOS_SPEED {
      UEXACT8 physical_port;
      UEXACT8 rsvd0;
      UEXACT8 rsvd1;
      UEXACT8 rsvd2;
      UEXACT8 rsvd3;
      UEXACT8 rsvd4;
      UEXACT16 qos_link_speed;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_QOS_SPEED, *PASYNC_EVENT_GRP_5_QOS_SPEED;



#else
   
   typedef struct _ASYNC_EVENT_GRP_5_QOS_SPEED {
      UEXACT8 physical_port;
      UEXACT8 rsvd0;
      UEXACT8 rsvd1;
      UEXACT8 rsvd2;
      UEXACT8 rsvd3;
      UEXACT8 rsvd4;
      UEXACT16 qos_link_speed;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_QOS_SPEED, *PASYNC_EVENT_GRP_5_QOS_SPEED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ASYNC_EVENT_GRP_5_PVID_STATE {
      UEXACT8 enabled;
      UEXACT8 rsvd0;
      UEXACT16 tag;
      UEXACT32 event_tag;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_PVID_STATE, *PASYNC_EVENT_GRP_5_PVID_STATE;



#else
   
   typedef struct _ASYNC_EVENT_GRP_5_PVID_STATE {
      UEXACT8 enabled;
      UEXACT8 rsvd0;
      UEXACT16 tag;
      UEXACT32 event_tag;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_PVID_STATE, *PASYNC_EVENT_GRP_5_PVID_STATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ASYNC_EVENT_GRP_5_COS_PRIORITY {
      UEXACT8 physical_port;
      UEXACT8 available_priority_bmap;
      UEXACT8 reco_default_priority;
      UEXACT8 valid;
      u32 rsvd0 : 26;                             // DWORD 1
      u32 app : 1;                                // DWORD 1
      u32 app_v : 1;                              // DWORD 1
      u32 pfc : 1;                                // DWORD 1
      u32 pfc_v : 1;                              // DWORD 1
      u32 pg : 1;                                 // DWORD 1
      u32 pg_v : 1;                               // DWORD 1
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_COS_PRIORITY, *PASYNC_EVENT_GRP_5_COS_PRIORITY;



#else
   
   typedef struct _ASYNC_EVENT_GRP_5_COS_PRIORITY {
      UEXACT8 physical_port;
      UEXACT8 available_priority_bmap;
      UEXACT8 reco_default_priority;
      UEXACT8 valid;
      u32 pg_v : 1;                               // DWORD 1
      u32 pg : 1;                                 // DWORD 1
      u32 pfc_v : 1;                              // DWORD 1
      u32 pfc : 1;                                // DWORD 1
      u32 app_v : 1;                              // DWORD 1
      u32 app : 1;                                // DWORD 1
      u32 rsvd0 : 26;                             // DWORD 1
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_COS_PRIORITY, *PASYNC_EVENT_GRP_5_COS_PRIORITY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Drivers must subscribe to async event group MCC_ASYNC_GROUP_DEBUG to receive this
   // message. If subscribed, the driver will immediately receive this message after the
   // async CQ is activated, and additional messages will arrive when the outer VLAN tag
   // value changes.  Both virtual and physical function drivers will receive this
   // message. Only networking drivers will receive this message.  This message is a debug
   // feature allowing the driver knowledge of the configured outer VLAN tag. It is not
   // required for drivers. 
   typedef struct _ASYNC_EVENT_QNQ {
      UEXACT8 enabled;
      UEXACT8 rsvd0;
      UEXACT16 vlan_tag;
      UEXACT32 event_tag;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_QNQ, *PASYNC_EVENT_QNQ;



#else
   // Drivers must subscribe to async event group MCC_ASYNC_GROUP_DEBUG to receive this
   // message. If subscribed, the driver will immediately receive this message after the
   // async CQ is activated, and additional messages will arrive when the outer VLAN tag
   // value changes.  Both virtual and physical function drivers will receive this
   // message. Only networking drivers will receive this message.  This message is a debug
   // feature allowing the driver knowledge of the configured outer VLAN tag. It is not
   // required for drivers. 
   typedef struct _ASYNC_EVENT_QNQ {
      UEXACT8 enabled;
      UEXACT8 rsvd0;
      UEXACT16 vlan_tag;
      UEXACT32 event_tag;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_QNQ, *PASYNC_EVENT_QNQ;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP {
      UEXACT8 priority0_classq;
      UEXACT8 priority1_classq;
      UEXACT8 priority2_classq;
      UEXACT8 priority3_classq;
      UEXACT8 priority4_classq;
      UEXACT8 priority5_classq;
      UEXACT8 priority6_classq;
      UEXACT8 priority7_classq;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP, *PASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP;



#else
   
   typedef struct _ASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP {
      UEXACT8 priority0_classq;
      UEXACT8 priority1_classq;
      UEXACT8 priority2_classq;
      UEXACT8 priority3_classq;
      UEXACT8 priority4_classq;
      UEXACT8 priority5_classq;
      UEXACT8 priority6_classq;
      UEXACT8 priority7_classq;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP, *PASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The (Initiator) firmware has discovered new Targets through the iSCSI disovery
   // services.  Note Applicable in Initiator mode only. 
   typedef struct _ASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED {
      UEXACT32 session_handle;
      u32 rsvd0[2];                               // DWORDS 1 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED, *PASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED;



#else
   // The (Initiator) firmware has discovered new Targets through the iSCSI disovery
   // services.  Note Applicable in Initiator mode only. 
   typedef struct _ASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED {
      UEXACT32 session_handle;
      u32 rsvd0[2];                               // DWORDS 1 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED, *PASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The (Initiator) firmware has established a new iSCSI connection with a target. The
   // driver can use the session and connection handles to offload this connection.  Note
   // Applicable in Initiator mode only. 
   typedef struct _ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED {
      UEXACT16 connection_handle;
      UEXACT16 rsvd0;
      UEXACT32 session_handle;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED, *PASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED;



#else
   // The (Initiator) firmware has established a new iSCSI connection with a target. The
   // driver can use the session and connection handles to offload this connection.  Note
   // Applicable in Initiator mode only. 
   typedef struct _ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED {
      UEXACT16 connection_handle;
      UEXACT16 rsvd0;
      UEXACT32 session_handle;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED, *PASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The (Initiator) firmware has established a new TCP connection for a Target which was
   // configured to use multiple connections-per-session. The driver can use the session
   // and connection IDs to issue a call to IOCTL_ISCSI_INI_DRIVER_REOPEN_A_SESSION.  Note
   // Applicable in Initiator mode only. 
   typedef struct _ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED {
      UEXACT16 connection_handle;
      UEXACT16 rsvd0;
      UEXACT32 session_handle;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED, *PASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED;



#else
   // The (Initiator) firmware has established a new TCP connection for a Target which was
   // configured to use multiple connections-per-session. The driver can use the session
   // and connection IDs to issue a call to IOCTL_ISCSI_INI_DRIVER_REOPEN_A_SESSION.  Note
   // Applicable in Initiator mode only. 
   typedef struct _ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED {
      UEXACT16 connection_handle;
      UEXACT16 rsvd0;
      UEXACT32 session_handle;
      u32 rsvd1[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED, *PASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // A new TCP connection has been accepted on the listen port. The Target driver is
   // expected to issue IOCTL_ISCSI_TGT_GET_CONNECTION_INFO to get the source/destination
   // IP Address and port numbers for this connection.  Note Applicable in Target mode
   // only. 
   typedef struct _ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED {
      UEXACT32 connection_handle;
      u32 rsvd0[2];                               // DWORDS 1 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED, *PASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED;



#else
   // A new TCP connection has been accepted on the listen port. The Target driver is
   // expected to issue IOCTL_ISCSI_TGT_GET_CONNECTION_INFO to get the source/destination
   // IP Address and port numbers for this connection.  Note Applicable in Target mode
   // only. 
   typedef struct _ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED {
      UEXACT32 connection_handle;
      u32 rsvd0[2];                               // DWORDS 1 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED, *PASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // A DHCP or a Stateless IP operation was requested in non blocking mode, and it is
   // completed now. the ioctl was completed earlier when the call was made, this message
   // carries. the status, addnl status and interface handle. 
   typedef struct _ASYNC_EVENT_STATELESS_OPERATION_COMPLETE {
      UEXACT8 status;
      UEXACT8 additional_status;
      UEXACT16 padd;
      UEXACT32 interface_handle;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_STATELESS_OPERATION_COMPLETE, *PASYNC_EVENT_STATELESS_OPERATION_COMPLETE;



#else
   // A DHCP or a Stateless IP operation was requested in non blocking mode, and it is
   // completed now. the ioctl was completed earlier when the call was made, this message
   // carries. the status, addnl status and interface handle. 
   typedef struct _ASYNC_EVENT_STATELESS_OPERATION_COMPLETE {
      UEXACT8 status;
      UEXACT8 additional_status;
      UEXACT16 padd;
      UEXACT32 interface_handle;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_STATELESS_OPERATION_COMPLETE, *PASYNC_EVENT_STATELESS_OPERATION_COMPLETE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // An IPv6 router can advertise the link MTU with router advertisement messages, if the
   // router advertises a lesser MTU than what is set on this port, firmware will raise
   // this event with advertised mtu for host to take action.. 
   typedef struct _ASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED {
      UEXACT32 new_link_mtu;
      UEXACT32 padd;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED, *PASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED;



#else
   // An IPv6 router can advertise the link MTU with router advertisement messages, if the
   // router advertises a lesser MTU than what is set on this port, firmware will raise
   // this event with advertised mtu for host to take action.. 
   typedef struct _ASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED {
      UEXACT32 new_link_mtu;
      UEXACT32 padd;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED, *PASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // An IPv6 router can advertise the link MTU with router advertisement messages, if the
   // router advertises a lesser MTU than what is set on this port, firmware will raise
   // this event with advertised mtu for host to take action.. 
   typedef struct _ASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD {
      UEXACT32 interface_handle;
      UEXACT8 err_code;
      UEXACT8 padd1;
      UEXACT16 padd2;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD, *PASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD;



#else
   // An IPv6 router can advertise the link MTU with router advertisement messages, if the
   // router advertises a lesser MTU than what is set on this port, firmware will raise
   // this event with advertised mtu for host to take action.. 
   typedef struct _ASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD {
      UEXACT32 interface_handle;
      UEXACT8 err_code;
      UEXACT8 padd1;
      UEXACT16 padd2;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD, *PASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Firmware indicates to iSCSI Driver that a session level recovery is required on this
   // function. 
   typedef struct _ASYNC_EVENT_INITIATOR_START_RECOVERY {
      UEXACT32 padd1;
      UEXACT32 padd2;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_INITIATOR_START_RECOVERY, *PASYNC_EVENT_INITIATOR_START_RECOVERY;



#else
   // Firmware indicates to iSCSI Driver that a session level recovery is required on this
   // function. 
   typedef struct _ASYNC_EVENT_INITIATOR_START_RECOVERY {
      UEXACT32 padd1;
      UEXACT32 padd2;
      u32 rsvd0[1];                               // DWORDS 2 to 2
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_INITIATOR_START_RECOVERY, *PASYNC_EVENT_INITIATOR_START_RECOVERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // DCBX TLV TTL expired in the Control State machine. DCBX is determined to be disabled
   // on the peer. 
   typedef struct _ASYNC_EVENT_DCBX_TTL_EXPIRED {
      UEXACT32 TLV_TTL;
      u32 rsvd0[1];                               // DWORDS 1 to 1
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_DCBX_TTL_EXPIRED, *PASYNC_EVENT_DCBX_TTL_EXPIRED;



#else
   // DCBX TLV TTL expired in the Control State machine. DCBX is determined to be disabled
   // on the peer. 
   typedef struct _ASYNC_EVENT_DCBX_TTL_EXPIRED {
      UEXACT32 TLV_TTL;
      u32 rsvd0[1];                               // DWORDS 1 to 1
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_DCBX_TTL_EXPIRED, *PASYNC_EVENT_DCBX_TTL_EXPIRED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // An asynchronous event is sent by the ARM firmware in the following cases  - A new
   // FCF is discovered (using FIP)  - An FCF currently logged-into, has stopped
   // responding to heartbeat  - A newly discoved FCF could not be added to the FCF table
   // since it is full. Use the IOCTL_FCOE_DELETE_FCF to delete stale/unwanted entries.  -
   // One or more FCF parameters were modified by the FCF (via FCF Advertisement). 
   typedef struct _ASYNC_EVENT_FCOE {
      UEXACT32 ref_index;
      UEXACT16 fcf_count;
      UEXACT16 event_type;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_FCOE, *PASYNC_EVENT_FCOE;



#else
   // An asynchronous event is sent by the ARM firmware in the following cases  - A new
   // FCF is discovered (using FIP)  - An FCF currently logged-into, has stopped
   // responding to heartbeat  - A newly discoved FCF could not be added to the FCF table
   // since it is full. Use the IOCTL_FCOE_DELETE_FCF to delete stale/unwanted entries.  -
   // One or more FCF parameters were modified by the FCF (via FCF Advertisement). 
   typedef struct _ASYNC_EVENT_FCOE {
      UEXACT32 ref_index;
      UEXACT16 fcf_count;
      UEXACT16 event_type;
      UEXACT32 event_tag;
      ASYNC_EVENT_TRAILER trailer;
   } SG_PACK ASYNC_EVENT_FCOE, *PASYNC_EVENT_FCOE;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __asyncmesg_bmap_h__

