/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __dal_context_bmap_h__
#define __dal_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "be_common_bmap.h"
#include "descriptors_bmap.h"
#include "ulp_context_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // DAL TX context structure
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TX_CONTEXT {
         union {
            struct { 
               u32 cq_id : 10;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 cidx : 14;                     // DWORD 0
               u32 pdid_valid : 1;                // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 pci_func : 8;                  // DWORD 1
               u32 pidx : 14;                     // DWORD 1
               u32 error_code;                    // DWORD 2
               u32 rsvd2[1];                      // DWORDS 3 to 3
               u32 cached_pe_length;              // DWORD 4
               u32 cached_pe_stag;                // DWORD 5
               u32 rsvd3 : 29;                    // DWORD 6
               u32 cached_pe_tes_in_ctx : 1;      // DWORD 6
               u32 cached_pe_cached : 1;          // DWORD 6
               u32 cached_pe_caching : 1;         // DWORD 6
               u32 cached_pe_te_addr;             // DWORD 7
               u32 rsvd4[1];                      // DWORDS 8 to 8
               u32 rsvd5[1];                      // DWORDS 9 to 9
               u32 rsvd6[1];                      // DWORDS 10 to 10
               u32 rsvd7[1];                      // DWORDS 11 to 11
               u32 rsvd8[1];                      // DWORDS 12 to 12
               u32 rsvd9[1];                      // DWORDS 13 to 13
               u32 rsvd10[1];                     // DWORDS 14 to 14
               u32 rsvd11[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TX_CONTEXT, *PDAL_TX_CONTEXT;

      SG_C_ASSERT(__sizeof__DAL_TX_CONTEXT, sizeof (DAL_TX_CONTEXT) == 64);

   #else
      typedef struct _DAL_TX_CONTEXT {
         u32 cq_id : 10;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 cidx : 14;                           // DWORD 0
         u32 pdid_valid : 1;                      // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 pci_func : 8;                        // DWORD 1
         u32 pidx : 14;                           // DWORD 1
         u32 error_code;                          // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
         u32 cached_pe_length;                    // DWORD 4
         u32 cached_pe_stag;                      // DWORD 5
         u32 rsvd3 : 29;                          // DWORD 6
         u32 cached_pe_tes_in_ctx : 1;            // DWORD 6
         u32 cached_pe_cached : 1;                // DWORD 6
         u32 cached_pe_caching : 1;               // DWORD 6
         u32 cached_pe_te_addr;                   // DWORD 7
         u32 rsvd4[1];                            // DWORDS 8 to 8
         u32 rsvd5[1];                            // DWORDS 9 to 9
         u32 rsvd6[1];                            // DWORDS 10 to 10
         u32 rsvd7[1];                            // DWORDS 11 to 11
         u32 rsvd8[1];                            // DWORDS 12 to 12
         u32 rsvd9[1];                            // DWORDS 13 to 13
         u32 rsvd10[1];                           // DWORDS 14 to 14
         u32 rsvd11[1];                           // DWORDS 15 to 15
      } SG_PACK DAL_TX_CONTEXT, *PDAL_TX_CONTEXT;

      typedef union _DAL_TX_CONTEXT_UNION {
         DAL_TX_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_TX_CONTEXT_UNION, *PDAL_TX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__DAL_TX_CONTEXT_UNION, sizeof (DAL_TX_CONTEXT_UNION) == 64);
   #endif


#else
   // DAL TX context structure
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TX_CONTEXT {
         union {
            struct { 
               u32 cidx : 14;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 cq_id : 10;                    // DWORD 0
               u32 pidx : 14;                     // DWORD 1
               u32 pci_func : 8;                  // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 pdid_valid : 1;                // DWORD 1
               u32 error_code;                    // DWORD 2
               u32 rsvd2[1];                      // DWORDS 3 to 3
               u32 cached_pe_length;              // DWORD 4
               u32 cached_pe_stag;                // DWORD 5
               u32 cached_pe_caching : 1;         // DWORD 6
               u32 cached_pe_cached : 1;          // DWORD 6
               u32 cached_pe_tes_in_ctx : 1;      // DWORD 6
               u32 rsvd3 : 29;                    // DWORD 6
               u32 cached_pe_te_addr;             // DWORD 7
               u32 rsvd4[1];                      // DWORDS 8 to 8
               u32 rsvd5[1];                      // DWORDS 9 to 9
               u32 rsvd6[1];                      // DWORDS 10 to 10
               u32 rsvd7[1];                      // DWORDS 11 to 11
               u32 rsvd8[1];                      // DWORDS 12 to 12
               u32 rsvd9[1];                      // DWORDS 13 to 13
               u32 rsvd10[1];                     // DWORDS 14 to 14
               u32 rsvd11[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TX_CONTEXT, *PDAL_TX_CONTEXT;

      SG_C_ASSERT(__sizeof__DAL_TX_CONTEXT, sizeof (DAL_TX_CONTEXT) == 64);

   #else
      typedef struct _DAL_TX_CONTEXT {
         u32 cidx : 14;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 cq_id : 10;                          // DWORD 0
         u32 pidx : 14;                           // DWORD 1
         u32 pci_func : 8;                        // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 pdid_valid : 1;                      // DWORD 1
         u32 error_code;                          // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
         u32 cached_pe_length;                    // DWORD 4
         u32 cached_pe_stag;                      // DWORD 5
         u32 cached_pe_caching : 1;               // DWORD 6
         u32 cached_pe_cached : 1;                // DWORD 6
         u32 cached_pe_tes_in_ctx : 1;            // DWORD 6
         u32 rsvd3 : 29;                          // DWORD 6
         u32 cached_pe_te_addr;                   // DWORD 7
         u32 rsvd4[1];                            // DWORDS 8 to 8
         u32 rsvd5[1];                            // DWORDS 9 to 9
         u32 rsvd6[1];                            // DWORDS 10 to 10
         u32 rsvd7[1];                            // DWORDS 11 to 11
         u32 rsvd8[1];                            // DWORDS 12 to 12
         u32 rsvd9[1];                            // DWORDS 13 to 13
         u32 rsvd10[1];                           // DWORDS 14 to 14
         u32 rsvd11[1];                           // DWORDS 15 to 15
      } SG_PACK DAL_TX_CONTEXT, *PDAL_TX_CONTEXT;

      typedef union _DAL_TX_CONTEXT_UNION {
         DAL_TX_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_TX_CONTEXT_UNION, *PDAL_TX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__DAL_TX_CONTEXT_UNION, sizeof (DAL_TX_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Map from udp port number to queue pair numbers 
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TPRE_UDP_PORT_MAP {
         union {
            struct { 
               u32 qp_map;                        // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 1
               u32 udp_port : 16;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TPRE_UDP_PORT_MAP, *PDAL_TPRE_UDP_PORT_MAP;

      SG_C_ASSERT(__sizeof__DAL_TPRE_UDP_PORT_MAP, sizeof (DAL_TPRE_UDP_PORT_MAP) == 8);

   #else
      typedef struct _DAL_TPRE_UDP_PORT_MAP {
         u32 qp_map;                              // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 1
         u32 udp_port : 16;                       // DWORD 1
      } SG_PACK DAL_TPRE_UDP_PORT_MAP, *PDAL_TPRE_UDP_PORT_MAP;

      typedef union _DAL_TPRE_UDP_PORT_MAP_UNION {
         DAL_TPRE_UDP_PORT_MAP bits;
         u32 dw[2]; // dword union
      } SG_PACK DAL_TPRE_UDP_PORT_MAP_UNION, *PDAL_TPRE_UDP_PORT_MAP_UNION;

      SG_C_ASSERT(__sizeof__DAL_TPRE_UDP_PORT_MAP_UNION, sizeof (DAL_TPRE_UDP_PORT_MAP_UNION) == 8);
   #endif


#else
   // Map from udp port number to queue pair numbers 
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TPRE_UDP_PORT_MAP {
         union {
            struct { 
               u32 qp_map;                        // DWORD 0
               u32 udp_port : 16;                 // DWORD 1
               u32 rsvd0 : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TPRE_UDP_PORT_MAP, *PDAL_TPRE_UDP_PORT_MAP;

      SG_C_ASSERT(__sizeof__DAL_TPRE_UDP_PORT_MAP, sizeof (DAL_TPRE_UDP_PORT_MAP) == 8);

   #else
      typedef struct _DAL_TPRE_UDP_PORT_MAP {
         u32 qp_map;                              // DWORD 0
         u32 udp_port : 16;                       // DWORD 1
         u32 rsvd0 : 16;                          // DWORD 1
      } SG_PACK DAL_TPRE_UDP_PORT_MAP, *PDAL_TPRE_UDP_PORT_MAP;

      typedef union _DAL_TPRE_UDP_PORT_MAP_UNION {
         DAL_TPRE_UDP_PORT_MAP bits;
         u32 dw[2]; // dword union
      } SG_PACK DAL_TPRE_UDP_PORT_MAP_UNION, *PDAL_TPRE_UDP_PORT_MAP_UNION;

      SG_C_ASSERT(__sizeof__DAL_TPRE_UDP_PORT_MAP_UNION, sizeof (DAL_TPRE_UDP_PORT_MAP_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DAL TPRE context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TPRE_CONTEXT {
         union {
            struct { 
               DAL_TPRE_UDP_PORT_MAP port_map[32];
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TPRE_CONTEXT, *PDAL_TPRE_CONTEXT;

      SG_C_ASSERT(__sizeof__DAL_TPRE_CONTEXT, sizeof (DAL_TPRE_CONTEXT) == 256);

   #else
      typedef struct _DAL_TPRE_CONTEXT {
         DAL_TPRE_UDP_PORT_MAP port_map[32];
      } SG_PACK DAL_TPRE_CONTEXT, *PDAL_TPRE_CONTEXT;

      typedef union _DAL_TPRE_CONTEXT_UNION {
         DAL_TPRE_CONTEXT bits;
         u32 dw[64]; // dword union
      } SG_PACK DAL_TPRE_CONTEXT_UNION, *PDAL_TPRE_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__DAL_TPRE_CONTEXT_UNION, sizeof (DAL_TPRE_CONTEXT_UNION) == 256);
   #endif


#else
   // DAL TPRE context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TPRE_CONTEXT {
         union {
            struct { 
               DAL_TPRE_UDP_PORT_MAP port_map[32];
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TPRE_CONTEXT, *PDAL_TPRE_CONTEXT;

      SG_C_ASSERT(__sizeof__DAL_TPRE_CONTEXT, sizeof (DAL_TPRE_CONTEXT) == 256);

   #else
      typedef struct _DAL_TPRE_CONTEXT {
         DAL_TPRE_UDP_PORT_MAP port_map[32];
      } SG_PACK DAL_TPRE_CONTEXT, *PDAL_TPRE_CONTEXT;

      typedef union _DAL_TPRE_CONTEXT_UNION {
         DAL_TPRE_CONTEXT bits;
         u32 dw[64]; // dword union
      } SG_PACK DAL_TPRE_CONTEXT_UNION, *PDAL_TPRE_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__DAL_TPRE_CONTEXT_UNION, sizeof (DAL_TPRE_CONTEXT_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DAL Queue Pair context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_RX_CONTEXT {
         union {
            struct { 
               u32 cq_id : 10;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rx_ring_size : 4;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dal_ctx_valid : 1;             // DWORD 0
               u32 ring_cidx : 14;                // DWORD 0
               u32 dal_pdid_valid : 1;            // DWORD 1
               u32 ring_pdid : 9;                 // DWORD 1
               u32 rx_pci_func : 8;               // DWORD 1
               u32 ring_pidx : 14;                // DWORD 1
               u32 ctx_addr_part2;                // DWORD 2
               u32 ctx_addr_part1;                // DWORD 3
               u32 cached_pe_length;              // DWORD 4
               u32 cached_pe_stag;                // DWORD 5
               u32 rsvd2 : 19;                    // DWORD 6
               u32 buf_size : 10;                 // DWORD 6
               u32 cached_pe_tes_in_ctx : 1;      // DWORD 6
               u32 cached_pe_cached : 1;          // DWORD 6
               u32 cached_pe_caching : 1;         // DWORD 6
               u32 cached_pe_te_addr;             // DWORD 7
               WCON_D wcon_d;
               u32 rsvd3[1];                      // DWORDS 14 to 14
               u32 rsvd4[1];                      // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_RX_CONTEXT, *PDAL_RX_CONTEXT;

      SG_C_ASSERT(__sizeof__DAL_RX_CONTEXT, sizeof (DAL_RX_CONTEXT) == 64);

   #else
      typedef struct _DAL_RX_CONTEXT {
         u32 cq_id : 10;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rx_ring_size : 4;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dal_ctx_valid : 1;                   // DWORD 0
         u32 ring_cidx : 14;                      // DWORD 0
         u32 dal_pdid_valid : 1;                  // DWORD 1
         u32 ring_pdid : 9;                       // DWORD 1
         u32 rx_pci_func : 8;                     // DWORD 1
         u32 ring_pidx : 14;                      // DWORD 1
         u32 ctx_addr_part2;                      // DWORD 2
         u32 ctx_addr_part1;                      // DWORD 3
         u32 cached_pe_length;                    // DWORD 4
         u32 cached_pe_stag;                      // DWORD 5
         u32 rsvd2 : 19;                          // DWORD 6
         u32 buf_size : 10;                       // DWORD 6
         u32 cached_pe_tes_in_ctx : 1;            // DWORD 6
         u32 cached_pe_cached : 1;                // DWORD 6
         u32 cached_pe_caching : 1;               // DWORD 6
         u32 cached_pe_te_addr;                   // DWORD 7
         WCON_D wcon_d;
         u32 rsvd3[1];                            // DWORDS 14 to 14
         u32 rsvd4[1];                            // DWORDS 15 to 15
      } SG_PACK DAL_RX_CONTEXT, *PDAL_RX_CONTEXT;

      typedef union _DAL_RX_CONTEXT_UNION {
         DAL_RX_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_RX_CONTEXT_UNION, *PDAL_RX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__DAL_RX_CONTEXT_UNION, sizeof (DAL_RX_CONTEXT_UNION) == 64);
   #endif


#else
   // DAL Queue Pair context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_RX_CONTEXT {
         union {
            struct { 
               u32 ring_cidx : 14;                // DWORD 0
               u32 dal_ctx_valid : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 rx_ring_size : 4;              // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 cq_id : 10;                    // DWORD 0
               u32 ring_pidx : 14;                // DWORD 1
               u32 rx_pci_func : 8;               // DWORD 1
               u32 ring_pdid : 9;                 // DWORD 1
               u32 dal_pdid_valid : 1;            // DWORD 1
               u32 ctx_addr_part2;                // DWORD 2
               u32 ctx_addr_part1;                // DWORD 3
               u32 cached_pe_length;              // DWORD 4
               u32 cached_pe_stag;                // DWORD 5
               u32 cached_pe_caching : 1;         // DWORD 6
               u32 cached_pe_cached : 1;          // DWORD 6
               u32 cached_pe_tes_in_ctx : 1;      // DWORD 6
               u32 buf_size : 10;                 // DWORD 6
               u32 rsvd2 : 19;                    // DWORD 6
               u32 cached_pe_te_addr;             // DWORD 7
               WCON_D wcon_d;
               u32 rsvd3[1];                      // DWORDS 14 to 14
               u32 rsvd4[1];                      // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_RX_CONTEXT, *PDAL_RX_CONTEXT;

      SG_C_ASSERT(__sizeof__DAL_RX_CONTEXT, sizeof (DAL_RX_CONTEXT) == 64);

   #else
      typedef struct _DAL_RX_CONTEXT {
         u32 ring_cidx : 14;                      // DWORD 0
         u32 dal_ctx_valid : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 rx_ring_size : 4;                    // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 cq_id : 10;                          // DWORD 0
         u32 ring_pidx : 14;                      // DWORD 1
         u32 rx_pci_func : 8;                     // DWORD 1
         u32 ring_pdid : 9;                       // DWORD 1
         u32 dal_pdid_valid : 1;                  // DWORD 1
         u32 ctx_addr_part2;                      // DWORD 2
         u32 ctx_addr_part1;                      // DWORD 3
         u32 cached_pe_length;                    // DWORD 4
         u32 cached_pe_stag;                      // DWORD 5
         u32 cached_pe_caching : 1;               // DWORD 6
         u32 cached_pe_cached : 1;                // DWORD 6
         u32 cached_pe_tes_in_ctx : 1;            // DWORD 6
         u32 buf_size : 10;                       // DWORD 6
         u32 rsvd2 : 19;                          // DWORD 6
         u32 cached_pe_te_addr;                   // DWORD 7
         WCON_D wcon_d;
         u32 rsvd3[1];                            // DWORDS 14 to 14
         u32 rsvd4[1];                            // DWORDS 15 to 15
      } SG_PACK DAL_RX_CONTEXT, *PDAL_RX_CONTEXT;

      typedef union _DAL_RX_CONTEXT_UNION {
         DAL_RX_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_RX_CONTEXT_UNION, *PDAL_RX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__DAL_RX_CONTEXT_UNION, sizeof (DAL_RX_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_RX_TABLE {
         union {
            struct { 
               u32 index[32];                     // DWORDS 0 to 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK DAL_RX_TABLE, *PDAL_RX_TABLE;

      SG_C_ASSERT(__sizeof__DAL_RX_TABLE, sizeof (DAL_RX_TABLE) == 128);

   #else
      typedef struct _DAL_RX_TABLE {
         u32 index[32];                           // DWORDS 0 to 31
      } SG_PACK DAL_RX_TABLE, *PDAL_RX_TABLE;

      typedef union _DAL_RX_TABLE_UNION {
         DAL_RX_TABLE bits;
         u32 dw[32]; // dword union
      } SG_PACK DAL_RX_TABLE_UNION, *PDAL_RX_TABLE_UNION;

      SG_C_ASSERT(__sizeof__DAL_RX_TABLE_UNION, sizeof (DAL_RX_TABLE_UNION) == 128);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_RX_TABLE {
         union {
            struct { 
               u32 index[32];                     // DWORDS 0 to 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK DAL_RX_TABLE, *PDAL_RX_TABLE;

      SG_C_ASSERT(__sizeof__DAL_RX_TABLE, sizeof (DAL_RX_TABLE) == 128);

   #else
      typedef struct _DAL_RX_TABLE {
         u32 index[32];                           // DWORDS 0 to 31
      } SG_PACK DAL_RX_TABLE, *PDAL_RX_TABLE;

      typedef union _DAL_RX_TABLE_UNION {
         DAL_RX_TABLE bits;
         u32 dw[32]; // dword union
      } SG_PACK DAL_RX_TABLE_UNION, *PDAL_RX_TABLE_UNION;

      SG_C_ASSERT(__sizeof__DAL_RX_TABLE_UNION, sizeof (DAL_RX_TABLE_UNION) == 128);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __dal_context_bmap_h__

