/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __daltx_exp_bmap_h__
#define __daltx_exp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DALTX_STATS {
         union {
            struct { 
               u32 eth_driver_requests;           // DWORD 0
               u32 dal_driver_requests;           // DWORD 1
               u32 dal_context_invalid_errors;    // DWORD 2
               u32 dal_uc_response_errors;        // DWORD 3
               u32 dal_pe_invalid_errors;         // DWORD 4
               u32 dal_pe_pdid_errors;            // DWORD 5
               u32 dal_pe_stag_errors;            // DWORD 6
               u32 dal_pe_range_errors;           // DWORD 7
               u32 dal_wqe_invalid_errors;        // DWORD 8
               u32 dal_wqe_mss_errors;            // DWORD 9
               u32 rsvd0[246];                    // DWORDS 10 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_DALTX_STATS, *PBE_DALTX_STATS;

      SG_C_ASSERT(__sizeof__BE_DALTX_STATS, sizeof (BE_DALTX_STATS) == 1024);

   #else
      typedef struct _BE_DALTX_STATS {
         u32 eth_driver_requests;                 // DWORD 0
         u32 dal_driver_requests;                 // DWORD 1
         u32 dal_context_invalid_errors;          // DWORD 2
         u32 dal_uc_response_errors;              // DWORD 3
         u32 dal_pe_invalid_errors;               // DWORD 4
         u32 dal_pe_pdid_errors;                  // DWORD 5
         u32 dal_pe_stag_errors;                  // DWORD 6
         u32 dal_pe_range_errors;                 // DWORD 7
         u32 dal_wqe_invalid_errors;              // DWORD 8
         u32 dal_wqe_mss_errors;                  // DWORD 9
         u32 rsvd0[246];                          // DWORDS 10 to 255
      } SG_PACK BE_DALTX_STATS, *PBE_DALTX_STATS;

      typedef union _BE_DALTX_STATS_UNION {
         BE_DALTX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_DALTX_STATS_UNION, *PBE_DALTX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_DALTX_STATS_UNION, sizeof (BE_DALTX_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DALTX_STATS {
         union {
            struct { 
               u32 eth_driver_requests;           // DWORD 0
               u32 dal_driver_requests;           // DWORD 1
               u32 dal_context_invalid_errors;    // DWORD 2
               u32 dal_uc_response_errors;        // DWORD 3
               u32 dal_pe_invalid_errors;         // DWORD 4
               u32 dal_pe_pdid_errors;            // DWORD 5
               u32 dal_pe_stag_errors;            // DWORD 6
               u32 dal_pe_range_errors;           // DWORD 7
               u32 dal_wqe_invalid_errors;        // DWORD 8
               u32 dal_wqe_mss_errors;            // DWORD 9
               u32 rsvd0[246];                    // DWORDS 10 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_DALTX_STATS, *PBE_DALTX_STATS;

      SG_C_ASSERT(__sizeof__BE_DALTX_STATS, sizeof (BE_DALTX_STATS) == 1024);

   #else
      typedef struct _BE_DALTX_STATS {
         u32 eth_driver_requests;                 // DWORD 0
         u32 dal_driver_requests;                 // DWORD 1
         u32 dal_context_invalid_errors;          // DWORD 2
         u32 dal_uc_response_errors;              // DWORD 3
         u32 dal_pe_invalid_errors;               // DWORD 4
         u32 dal_pe_pdid_errors;                  // DWORD 5
         u32 dal_pe_stag_errors;                  // DWORD 6
         u32 dal_pe_range_errors;                 // DWORD 7
         u32 dal_wqe_invalid_errors;              // DWORD 8
         u32 dal_wqe_mss_errors;                  // DWORD 9
         u32 rsvd0[246];                          // DWORDS 10 to 255
      } SG_PACK BE_DALTX_STATS, *PBE_DALTX_STATS;

      typedef union _BE_DALTX_STATS_UNION {
         BE_DALTX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_DALTX_STATS_UNION, *PBE_DALTX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_DALTX_STATS_UNION, sizeof (BE_DALTX_STATS_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __daltx_exp_bmap_h__

