/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __dbuf_bmap_h__
#define __dbuf_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Free Buffers Register. This register provide general status of the buffer free list.
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_FREELIST_CSR {
         union {
            struct { 
               u32 rsvd1 : 14;                    // DWORD 0
               u32 dealloc_error : 1;             // DWORD 0
               u32 alloc_error : 1;               // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 freelist_cnt : 11;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_FREELIST_CSR, *PDBUF_FREELIST_CSR;

      SG_C_ASSERT(__sizeof__DBUF_FREELIST_CSR, sizeof (DBUF_FREELIST_CSR) == 4);

   #else
      typedef struct _DBUF_FREELIST_CSR {
         u32 rsvd1 : 14;                          // DWORD 0
         u32 dealloc_error : 1;                   // DWORD 0
         u32 alloc_error : 1;                     // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 freelist_cnt : 11;                   // DWORD 0
      } SG_PACK DBUF_FREELIST_CSR, *PDBUF_FREELIST_CSR;

      typedef union _DBUF_FREELIST_CSR_UNION {
         DBUF_FREELIST_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_FREELIST_CSR_UNION, *PDBUF_FREELIST_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_FREELIST_CSR_UNION, sizeof (DBUF_FREELIST_CSR_UNION) == 4);
   #endif


#else
   // Free Buffers Register. This register provide general status of the buffer free list.
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_FREELIST_CSR {
         union {
            struct { 
               u32 freelist_cnt : 11;             // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 alloc_error : 1;               // DWORD 0
               u32 dealloc_error : 1;             // DWORD 0
               u32 rsvd1 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_FREELIST_CSR, *PDBUF_FREELIST_CSR;

      SG_C_ASSERT(__sizeof__DBUF_FREELIST_CSR, sizeof (DBUF_FREELIST_CSR) == 4);

   #else
      typedef struct _DBUF_FREELIST_CSR {
         u32 freelist_cnt : 11;                   // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 alloc_error : 1;                     // DWORD 0
         u32 dealloc_error : 1;                   // DWORD 0
         u32 rsvd1 : 14;                          // DWORD 0
      } SG_PACK DBUF_FREELIST_CSR, *PDBUF_FREELIST_CSR;

      typedef union _DBUF_FREELIST_CSR_UNION {
         DBUF_FREELIST_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_FREELIST_CSR_UNION, *PDBUF_FREELIST_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_FREELIST_CSR_UNION, sizeof (DBUF_FREELIST_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allocation Floor Register. Sets the count of free DMA descriptor buffers at which
   // client requests continue to be serviced. When the number of free buffers is less
   // than or equal to the client floor value, the client buffer allocation request is
   // stalled. This feature is meant to prevent chip lockup when available buffers become
   // scarce. By programming active clients with different floor values (higher priority
   // clients have lower floor values), chip lockup may be avoided.
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_ALLOC_FLOOR_CSR {
         union {
            struct { 
               u32 rsvd1 : 5;                     // DWORD 0
               u32 alloc_floor1 : 11;             // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 alloc_floor0 : 11;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_ALLOC_FLOOR_CSR, *PDBUF_ALLOC_FLOOR_CSR;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_FLOOR_CSR, sizeof (DBUF_ALLOC_FLOOR_CSR) == 4);

   #else
      typedef struct _DBUF_ALLOC_FLOOR_CSR {
         u32 rsvd1 : 5;                           // DWORD 0
         u32 alloc_floor1 : 11;                   // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 alloc_floor0 : 11;                   // DWORD 0
      } SG_PACK DBUF_ALLOC_FLOOR_CSR, *PDBUF_ALLOC_FLOOR_CSR;

      typedef union _DBUF_ALLOC_FLOOR_CSR_UNION {
         DBUF_ALLOC_FLOOR_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_ALLOC_FLOOR_CSR_UNION, *PDBUF_ALLOC_FLOOR_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_FLOOR_CSR_UNION, sizeof (DBUF_ALLOC_FLOOR_CSR_UNION) == 4);
   #endif


#else
   // Allocation Floor Register. Sets the count of free DMA descriptor buffers at which
   // client requests continue to be serviced. When the number of free buffers is less
   // than or equal to the client floor value, the client buffer allocation request is
   // stalled. This feature is meant to prevent chip lockup when available buffers become
   // scarce. By programming active clients with different floor values (higher priority
   // clients have lower floor values), chip lockup may be avoided.
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_ALLOC_FLOOR_CSR {
         union {
            struct { 
               u32 alloc_floor0 : 11;             // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 alloc_floor1 : 11;             // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_ALLOC_FLOOR_CSR, *PDBUF_ALLOC_FLOOR_CSR;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_FLOOR_CSR, sizeof (DBUF_ALLOC_FLOOR_CSR) == 4);

   #else
      typedef struct _DBUF_ALLOC_FLOOR_CSR {
         u32 alloc_floor0 : 11;                   // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 alloc_floor1 : 11;                   // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
      } SG_PACK DBUF_ALLOC_FLOOR_CSR, *PDBUF_ALLOC_FLOOR_CSR;

      typedef union _DBUF_ALLOC_FLOOR_CSR_UNION {
         DBUF_ALLOC_FLOOR_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_ALLOC_FLOOR_CSR_UNION, *PDBUF_ALLOC_FLOOR_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_FLOOR_CSR_UNION, sizeof (DBUF_ALLOC_FLOOR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DBUF Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 dbuf_dealloc_err_ue_source : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_UE_SOURCE_CSR, *PDBUF_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__DBUF_UE_SOURCE_CSR, sizeof (DBUF_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _DBUF_UE_SOURCE_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 dbuf_dealloc_err_ue_source : 1;      // DWORD 0
      } SG_PACK DBUF_UE_SOURCE_CSR, *PDBUF_UE_SOURCE_CSR;

      typedef union _DBUF_UE_SOURCE_CSR_UNION {
         DBUF_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_UE_SOURCE_CSR_UNION, *PDBUF_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_UE_SOURCE_CSR_UNION, sizeof (DBUF_UE_SOURCE_CSR_UNION) == 4);
   #endif


#else
   // DBUF Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_UE_SOURCE_CSR {
         union {
            struct { 
               u32 dbuf_dealloc_err_ue_source : 1; // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_UE_SOURCE_CSR, *PDBUF_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__DBUF_UE_SOURCE_CSR, sizeof (DBUF_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _DBUF_UE_SOURCE_CSR {
         u32 dbuf_dealloc_err_ue_source : 1;      // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK DBUF_UE_SOURCE_CSR, *PDBUF_UE_SOURCE_CSR;

      typedef union _DBUF_UE_SOURCE_CSR_UNION {
         DBUF_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_UE_SOURCE_CSR_UNION, *PDBUF_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_UE_SOURCE_CSR_UNION, sizeof (DBUF_UE_SOURCE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DBUF Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 dbuf_dealloc_err_ue_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_UE_ENABLE_CSR, *PDBUF_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__DBUF_UE_ENABLE_CSR, sizeof (DBUF_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _DBUF_UE_ENABLE_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 dbuf_dealloc_err_ue_enable : 1;      // DWORD 0
      } SG_PACK DBUF_UE_ENABLE_CSR, *PDBUF_UE_ENABLE_CSR;

      typedef union _DBUF_UE_ENABLE_CSR_UNION {
         DBUF_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_UE_ENABLE_CSR_UNION, *PDBUF_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_UE_ENABLE_CSR_UNION, sizeof (DBUF_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // DBUF Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_UE_ENABLE_CSR {
         union {
            struct { 
               u32 dbuf_dealloc_err_ue_enable : 1; // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_UE_ENABLE_CSR, *PDBUF_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__DBUF_UE_ENABLE_CSR, sizeof (DBUF_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _DBUF_UE_ENABLE_CSR {
         u32 dbuf_dealloc_err_ue_enable : 1;      // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK DBUF_UE_ENABLE_CSR, *PDBUF_UE_ENABLE_CSR;

      typedef union _DBUF_UE_ENABLE_CSR_UNION {
         DBUF_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_UE_ENABLE_CSR_UNION, *PDBUF_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_UE_ENABLE_CSR_UNION, sizeof (DBUF_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allocation/De-allocation Error Information Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_ALLOC_ERR_CSR {
         union {
            struct { 
               u32 dealloc_client : 4;            // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 dealloc_index : 10;            // DWORD 0
               u32 alloc_client : 4;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 alloc_index : 10;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_ALLOC_ERR_CSR, *PDBUF_ALLOC_ERR_CSR;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_ERR_CSR, sizeof (DBUF_ALLOC_ERR_CSR) == 4);

   #else
      typedef struct _DBUF_ALLOC_ERR_CSR {
         u32 dealloc_client : 4;                  // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 dealloc_index : 10;                  // DWORD 0
         u32 alloc_client : 4;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 alloc_index : 10;                    // DWORD 0
      } SG_PACK DBUF_ALLOC_ERR_CSR, *PDBUF_ALLOC_ERR_CSR;

      typedef union _DBUF_ALLOC_ERR_CSR_UNION {
         DBUF_ALLOC_ERR_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_ALLOC_ERR_CSR_UNION, *PDBUF_ALLOC_ERR_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_ERR_CSR_UNION, sizeof (DBUF_ALLOC_ERR_CSR_UNION) == 4);
   #endif


#else
   // Allocation/De-allocation Error Information Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_ALLOC_ERR_CSR {
         union {
            struct { 
               u32 alloc_index : 10;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 alloc_client : 4;              // DWORD 0
               u32 dealloc_index : 10;            // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 dealloc_client : 4;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DBUF_ALLOC_ERR_CSR, *PDBUF_ALLOC_ERR_CSR;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_ERR_CSR, sizeof (DBUF_ALLOC_ERR_CSR) == 4);

   #else
      typedef struct _DBUF_ALLOC_ERR_CSR {
         u32 alloc_index : 10;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 alloc_client : 4;                    // DWORD 0
         u32 dealloc_index : 10;                  // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 dealloc_client : 4;                  // DWORD 0
      } SG_PACK DBUF_ALLOC_ERR_CSR, *PDBUF_ALLOC_ERR_CSR;

      typedef union _DBUF_ALLOC_ERR_CSR_UNION {
         DBUF_ALLOC_ERR_CSR bits;
         u32 dw; // dword union
      } SG_PACK DBUF_ALLOC_ERR_CSR_UNION, *PDBUF_ALLOC_ERR_CSR_UNION;

      SG_C_ASSERT(__sizeof__DBUF_ALLOC_ERR_CSR_UNION, sizeof (DBUF_ALLOC_ERR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DMA Descriptor Buffer Management Registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_CSRMAP {
         union {
            struct { 
               DBUF_FREELIST_CSR index_cnt;
               DBUF_ALLOC_ERR_CSR index_err;
               DBUF_ALLOC_FLOOR_CSR tpostcev_floor;
               DBUF_ALLOC_FLOOR_CSR mpuerx_floor;
               DBUF_ALLOC_FLOOR_CSR rxulp2ptc_floor;
               DBUF_ALLOC_FLOOR_CSR rxulp0rxulp1_floor;
               DBUF_ALLOC_FLOOR_CSR txulp1txp_floor;
               DBUF_ALLOC_FLOOR_CSR uctxulp0_floor;
               DBUF_ALLOC_FLOOR_CSR txulp2_floor;
               DBUF_UE_SOURCE_CSR ue_source;
               DBUF_UE_ENABLE_CSR ue_enable;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[242];                    // DWORDS 14 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK DBUF_CSRMAP, *PDBUF_CSRMAP;

      SG_C_ASSERT(__sizeof__DBUF_CSRMAP, sizeof (DBUF_CSRMAP) == 1024);

   #else
      typedef struct _DBUF_CSRMAP {
         DBUF_FREELIST_CSR index_cnt;
         DBUF_ALLOC_ERR_CSR index_err;
         DBUF_ALLOC_FLOOR_CSR tpostcev_floor;
         DBUF_ALLOC_FLOOR_CSR mpuerx_floor;
         DBUF_ALLOC_FLOOR_CSR rxulp2ptc_floor;
         DBUF_ALLOC_FLOOR_CSR rxulp0rxulp1_floor;
         DBUF_ALLOC_FLOOR_CSR txulp1txp_floor;
         DBUF_ALLOC_FLOOR_CSR uctxulp0_floor;
         DBUF_ALLOC_FLOOR_CSR txulp2_floor;
         DBUF_UE_SOURCE_CSR ue_source;
         DBUF_UE_ENABLE_CSR ue_enable;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[242];                          // DWORDS 14 to 255
      } SG_PACK DBUF_CSRMAP, *PDBUF_CSRMAP;

      typedef union _DBUF_CSRMAP_UNION {
         DBUF_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK DBUF_CSRMAP_UNION, *PDBUF_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__DBUF_CSRMAP_UNION, sizeof (DBUF_CSRMAP_UNION) == 1024);
   #endif


#else
   // DMA Descriptor Buffer Management Registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _DBUF_CSRMAP {
         union {
            struct { 
               DBUF_FREELIST_CSR index_cnt;
               DBUF_ALLOC_ERR_CSR index_err;
               DBUF_ALLOC_FLOOR_CSR tpostcev_floor;
               DBUF_ALLOC_FLOOR_CSR mpuerx_floor;
               DBUF_ALLOC_FLOOR_CSR rxulp2ptc_floor;
               DBUF_ALLOC_FLOOR_CSR rxulp0rxulp1_floor;
               DBUF_ALLOC_FLOOR_CSR txulp1txp_floor;
               DBUF_ALLOC_FLOOR_CSR uctxulp0_floor;
               DBUF_ALLOC_FLOOR_CSR txulp2_floor;
               DBUF_UE_SOURCE_CSR ue_source;
               DBUF_UE_ENABLE_CSR ue_enable;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[242];                    // DWORDS 14 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK DBUF_CSRMAP, *PDBUF_CSRMAP;

      SG_C_ASSERT(__sizeof__DBUF_CSRMAP, sizeof (DBUF_CSRMAP) == 1024);

   #else
      typedef struct _DBUF_CSRMAP {
         DBUF_FREELIST_CSR index_cnt;
         DBUF_ALLOC_ERR_CSR index_err;
         DBUF_ALLOC_FLOOR_CSR tpostcev_floor;
         DBUF_ALLOC_FLOOR_CSR mpuerx_floor;
         DBUF_ALLOC_FLOOR_CSR rxulp2ptc_floor;
         DBUF_ALLOC_FLOOR_CSR rxulp0rxulp1_floor;
         DBUF_ALLOC_FLOOR_CSR txulp1txp_floor;
         DBUF_ALLOC_FLOOR_CSR uctxulp0_floor;
         DBUF_ALLOC_FLOOR_CSR txulp2_floor;
         DBUF_UE_SOURCE_CSR ue_source;
         DBUF_UE_ENABLE_CSR ue_enable;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[242];                          // DWORDS 14 to 255
      } SG_PACK DBUF_CSRMAP, *PDBUF_CSRMAP;

      typedef union _DBUF_CSRMAP_UNION {
         DBUF_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK DBUF_CSRMAP_UNION, *PDBUF_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__DBUF_CSRMAP_UNION, sizeof (DBUF_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __dbuf_bmap_h__

