/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __eeprom_bmap_h__
#define __eeprom_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _FLASH_ROM {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK FLASH_ROM, *PFLASH_ROM;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // The FLASH ROM is used to store static data such as register initialization data,
      // software constants, processor and BIOS firmware. 
      #if defined(SG_BMAP_UNION)
         typedef struct _FLASH_ROM {
            union {
               struct { 
                  u32 registers[8192];            // DWORDS 0 to 8191
                  u32 boot_code[256];             // DWORDS 8192 to 8447
                  u32 Redboot[57216];             // DWORDS 8448 to 65663
                  u32 rsvd0[196480];              // DWORDS 65664 to 262143
                  u32 fw_primary[655360];         // DWORDS 262144 to 917503
                  u32 fw_backup[655360];          // DWORDS 917504 to 1572863
                  u32 fw_config[262144];          // DWORDS 1572864 to 1835007
                  u32 bios[131072];               // DWORDS 1835008 to 1966079
                  u32 eventlog[65536];            // DWORDS 1966080 to 2031615
                  u32 redboot_script[32768];      // DWORDS 2031616 to 2064383
                  u32 redboot_directory[32768];   // DWORDS 2064384 to 2097151
               } SG_PACK ; // unnamed struct
               u32 dw[2097152]; // dword union
            }; // unnamed union
         } SG_PACK FLASH_ROM, *PFLASH_ROM;

         SG_C_ASSERT(__sizeof__FLASH_ROM, sizeof (FLASH_ROM) == 8388608);

      #else
         typedef struct _FLASH_ROM {
            u32 registers[8192];                  // DWORDS 0 to 8191
            u32 boot_code[256];                   // DWORDS 8192 to 8447
            u32 Redboot[57216];                   // DWORDS 8448 to 65663
            u32 rsvd0[196480];                    // DWORDS 65664 to 262143
            u32 fw_primary[655360];               // DWORDS 262144 to 917503
            u32 fw_backup[655360];                // DWORDS 917504 to 1572863
            u32 fw_config[262144];                // DWORDS 1572864 to 1835007
            u32 bios[131072];                     // DWORDS 1835008 to 1966079
            u32 eventlog[65536];                  // DWORDS 1966080 to 2031615
            u32 redboot_script[32768];            // DWORDS 2031616 to 2064383
            u32 redboot_directory[32768];         // DWORDS 2064384 to 2097151
         } SG_PACK FLASH_ROM, *PFLASH_ROM;

         typedef union _FLASH_ROM_UNION {
            FLASH_ROM bits;
            u32 dw[2097152]; // dword union
         } SG_PACK FLASH_ROM_UNION, *PFLASH_ROM_UNION;

         SG_C_ASSERT(__sizeof__FLASH_ROM_UNION, sizeof (FLASH_ROM_UNION) == 8388608);
      #endif


   #else
      // The FLASH ROM is used to store static data such as register initialization data,
      // software constants, processor and BIOS firmware. 
      #if defined(SG_BMAP_UNION)
         typedef struct _FLASH_ROM {
            union {
               struct { 
                  u32 registers[8192];            // DWORDS 0 to 8191
                  u32 boot_code[256];             // DWORDS 8192 to 8447
                  u32 Redboot[57216];             // DWORDS 8448 to 65663
                  u32 rsvd0[196480];              // DWORDS 65664 to 262143
                  u32 fw_primary[655360];         // DWORDS 262144 to 917503
                  u32 fw_backup[655360];          // DWORDS 917504 to 1572863
                  u32 fw_config[262144];          // DWORDS 1572864 to 1835007
                  u32 bios[131072];               // DWORDS 1835008 to 1966079
                  u32 eventlog[65536];            // DWORDS 1966080 to 2031615
                  u32 redboot_script[32768];      // DWORDS 2031616 to 2064383
                  u32 redboot_directory[32768];   // DWORDS 2064384 to 2097151
               } SG_PACK ; // unnamed struct
               u32 dw[2097152]; // dword union
            }; // unnamed union
         } SG_PACK FLASH_ROM, *PFLASH_ROM;

         SG_C_ASSERT(__sizeof__FLASH_ROM, sizeof (FLASH_ROM) == 8388608);

      #else
         typedef struct _FLASH_ROM {
            u32 registers[8192];                  // DWORDS 0 to 8191
            u32 boot_code[256];                   // DWORDS 8192 to 8447
            u32 Redboot[57216];                   // DWORDS 8448 to 65663
            u32 rsvd0[196480];                    // DWORDS 65664 to 262143
            u32 fw_primary[655360];               // DWORDS 262144 to 917503
            u32 fw_backup[655360];                // DWORDS 917504 to 1572863
            u32 fw_config[262144];                // DWORDS 1572864 to 1835007
            u32 bios[131072];                     // DWORDS 1835008 to 1966079
            u32 eventlog[65536];                  // DWORDS 1966080 to 2031615
            u32 redboot_script[32768];            // DWORDS 2031616 to 2064383
            u32 redboot_directory[32768];         // DWORDS 2064384 to 2097151
         } SG_PACK FLASH_ROM, *PFLASH_ROM;

         typedef union _FLASH_ROM_UNION {
            FLASH_ROM bits;
            u32 dw[2097152]; // dword union
         } SG_PACK FLASH_ROM_UNION, *PFLASH_ROM_UNION;

         SG_C_ASSERT(__sizeof__FLASH_ROM_UNION, sizeof (FLASH_ROM_UNION) == 8388608);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#if defined(SG_REVERSE_ENDIAN)
   // This is the general EEPROM header format used for all regions.
   typedef struct _EEPROM_REGION_HEADER {
      u32 eod : 1;                                // DWORD 0
      u32 regionType : 3;                         // DWORD 0
   } SG_PACK EEPROM_REGION_HEADER, *PEEPROM_REGION_HEADER;



#else
   // This is the general EEPROM header format used for all regions.
   typedef struct _EEPROM_REGION_HEADER {
      u32 regionType : 3;                         // DWORD 0
      u32 eod : 1;                                // DWORD 0
   } SG_PACK EEPROM_REGION_HEADER, *PEEPROM_REGION_HEADER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Null region header. This type of region is used for padding and general purpose data
   // storage. No CRC follows this region data. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EEPROM_NULL_REGION_HEADER {
         union {
            struct { 
               u32 region_header_eod : 1;         // DWORD 0
               u32 region_header_regionType : 3;  // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 length : 16;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EEPROM_NULL_REGION_HEADER, *PEEPROM_NULL_REGION_HEADER;

      SG_C_ASSERT(__sizeof__EEPROM_NULL_REGION_HEADER, sizeof (EEPROM_NULL_REGION_HEADER) == 4);

   #else
      typedef struct _EEPROM_NULL_REGION_HEADER {
         u32 region_header_eod : 1;               // DWORD 0
         u32 region_header_regionType : 3;        // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 length : 16;                         // DWORD 0
      } SG_PACK EEPROM_NULL_REGION_HEADER, *PEEPROM_NULL_REGION_HEADER;

      typedef union _EEPROM_NULL_REGION_HEADER_UNION {
         EEPROM_NULL_REGION_HEADER bits;
         u32 dw; // dword union
      } SG_PACK EEPROM_NULL_REGION_HEADER_UNION, *PEEPROM_NULL_REGION_HEADER_UNION;

      SG_C_ASSERT(__sizeof__EEPROM_NULL_REGION_HEADER_UNION, sizeof (EEPROM_NULL_REGION_HEADER_UNION) == 4);
   #endif


#else
   // Null region header. This type of region is used for padding and general purpose data
   // storage. No CRC follows this region data. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EEPROM_NULL_REGION_HEADER {
         union {
            struct { 
               u32 length : 16;                   // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 region_header_regionType : 3;  // DWORD 0
               u32 region_header_eod : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EEPROM_NULL_REGION_HEADER, *PEEPROM_NULL_REGION_HEADER;

      SG_C_ASSERT(__sizeof__EEPROM_NULL_REGION_HEADER, sizeof (EEPROM_NULL_REGION_HEADER) == 4);

   #else
      typedef struct _EEPROM_NULL_REGION_HEADER {
         u32 length : 16;                         // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 region_header_regionType : 3;        // DWORD 0
         u32 region_header_eod : 1;               // DWORD 0
      } SG_PACK EEPROM_NULL_REGION_HEADER, *PEEPROM_NULL_REGION_HEADER;

      typedef union _EEPROM_NULL_REGION_HEADER_UNION {
         EEPROM_NULL_REGION_HEADER bits;
         u32 dw; // dword union
      } SG_PACK EEPROM_NULL_REGION_HEADER_UNION, *PEEPROM_NULL_REGION_HEADER_UNION;

      SG_C_ASSERT(__sizeof__EEPROM_NULL_REGION_HEADER_UNION, sizeof (EEPROM_NULL_REGION_HEADER_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   //  The register region consists of header/address and data pairs that describe
   // register initialization data. The region is consumed by the LPC Initialization State
   // Machine (LPC ISM). The register initialization data is terminated by a EEPROM region
   // header with the regionType field indicationg End-of-Region (EEPROM_REGION_TYPE_EOR).
   // The End-of-Region header is followed by a 32-bit CRC for data integrity checking. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EEPROM_REGISTER_REGION_FORMAT {
         union {
            struct { 
               struct {
                  u32 devnumU1 : 1;               // DWORD 0
                  u32 regionType : 3;             // DWORD 0
                  u32 cycType : 2;                // DWORD 0
                  u32 funcNum : 3;                // DWORD 0
                  u32 barNum : 3;                 // DWORD 0
                  u32 devnumL4 : 4;               // DWORD 0
                  u32 regAddr : 16;               // DWORD 0
               } address;
               struct {
                  u32 value;                      // DWORD 1
               } data;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK EEPROM_REGISTER_REGION_FORMAT, *PEEPROM_REGISTER_REGION_FORMAT;

      SG_C_ASSERT(__sizeof__EEPROM_REGISTER_REGION_FORMAT, sizeof (EEPROM_REGISTER_REGION_FORMAT) == 8);

   #else
      typedef struct _EEPROM_REGISTER_REGION_FORMAT {
         struct {
            u32 devnumU1 : 1;                     // DWORD 0
            u32 regionType : 3;                   // DWORD 0
            u32 cycType : 2;                      // DWORD 0
            u32 funcNum : 3;                      // DWORD 0
            u32 barNum : 3;                       // DWORD 0
            u32 devnumL4 : 4;                     // DWORD 0
            u32 regAddr : 16;                     // DWORD 0
         } address;
         struct {
            u32 value;                            // DWORD 1
         } data;
      } SG_PACK EEPROM_REGISTER_REGION_FORMAT, *PEEPROM_REGISTER_REGION_FORMAT;

      typedef union _EEPROM_REGISTER_REGION_FORMAT_UNION {
         EEPROM_REGISTER_REGION_FORMAT bits;
         u32 dw[2]; // dword union
      } SG_PACK EEPROM_REGISTER_REGION_FORMAT_UNION, *PEEPROM_REGISTER_REGION_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__EEPROM_REGISTER_REGION_FORMAT_UNION, sizeof (EEPROM_REGISTER_REGION_FORMAT_UNION) == 8);
   #endif


#else
   //  The register region consists of header/address and data pairs that describe
   // register initialization data. The region is consumed by the LPC Initialization State
   // Machine (LPC ISM). The register initialization data is terminated by a EEPROM region
   // header with the regionType field indicationg End-of-Region (EEPROM_REGION_TYPE_EOR).
   // The End-of-Region header is followed by a 32-bit CRC for data integrity checking. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EEPROM_REGISTER_REGION_FORMAT {
         union {
            struct { 
               struct {
                  u32 regAddr : 16;               // DWORD 0
                  u32 devnumL4 : 4;               // DWORD 0
                  u32 barNum : 3;                 // DWORD 0
                  u32 funcNum : 3;                // DWORD 0
                  u32 cycType : 2;                // DWORD 0
                  u32 regionType : 3;             // DWORD 0
                  u32 devnumU1 : 1;               // DWORD 0
               } address;
               struct {
                  u32 value;                      // DWORD 1
               } data;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK EEPROM_REGISTER_REGION_FORMAT, *PEEPROM_REGISTER_REGION_FORMAT;

      SG_C_ASSERT(__sizeof__EEPROM_REGISTER_REGION_FORMAT, sizeof (EEPROM_REGISTER_REGION_FORMAT) == 8);

   #else
      typedef struct _EEPROM_REGISTER_REGION_FORMAT {
         struct {
            u32 regAddr : 16;                     // DWORD 0
            u32 devnumL4 : 4;                     // DWORD 0
            u32 barNum : 3;                       // DWORD 0
            u32 funcNum : 3;                      // DWORD 0
            u32 cycType : 2;                      // DWORD 0
            u32 regionType : 3;                   // DWORD 0
            u32 devnumU1 : 1;                     // DWORD 0
         } address;
         struct {
            u32 value;                            // DWORD 1
         } data;
      } SG_PACK EEPROM_REGISTER_REGION_FORMAT, *PEEPROM_REGISTER_REGION_FORMAT;

      typedef union _EEPROM_REGISTER_REGION_FORMAT_UNION {
         EEPROM_REGISTER_REGION_FORMAT bits;
         u32 dw[2]; // dword union
      } SG_PACK EEPROM_REGISTER_REGION_FORMAT_UNION, *PEEPROM_REGISTER_REGION_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__EEPROM_REGISTER_REGION_FORMAT_UNION, sizeof (EEPROM_REGISTER_REGION_FORMAT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each firmware image that is stored in the firmware region is preceeded by a firmware
   // region header. The firmware region header provides the length of the firmware image
   // as well as length of the individual firmware sections in the image (ie. instruction
   // RAM data RAM, and banked memories). It also provides the processor ID the firmware
   // is for, and version information about the firmware image. The firmware region is
   // terminated by a EEPROM region header with the regionType field indicationg
   // End-of-Region (EEPROM_REGION_TYPE_EOR). No CRC-32 follows the firmware region. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EEPROM_FIRMWARE_REGION_HEADER {
         union {
            struct { 
               u32 region_header_eod : 1;         // DWORD 0
               u32 region_header_regionType : 3;  // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 cpuID : 4;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 length : 16;                   // DWORD 0
               u32 dram_length : 16;              // DWORD 1
               u32 iram_length : 16;              // DWORD 1
               u32 build_number : 16;             // DWORD 2
               u32 bank2_length : 8;              // DWORD 2
               u32 bank1_length : 8;              // DWORD 2
               u32 major_ver : 16;                // DWORD 3
               u32 minor_ver : 16;                // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK EEPROM_FIRMWARE_REGION_HEADER, *PEEPROM_FIRMWARE_REGION_HEADER;

      SG_C_ASSERT(__sizeof__EEPROM_FIRMWARE_REGION_HEADER, sizeof (EEPROM_FIRMWARE_REGION_HEADER) == 16);

   #else
      typedef struct _EEPROM_FIRMWARE_REGION_HEADER {
         u32 region_header_eod : 1;               // DWORD 0
         u32 region_header_regionType : 3;        // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 cpuID : 4;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 length : 16;                         // DWORD 0
         u32 dram_length : 16;                    // DWORD 1
         u32 iram_length : 16;                    // DWORD 1
         u32 build_number : 16;                   // DWORD 2
         u32 bank2_length : 8;                    // DWORD 2
         u32 bank1_length : 8;                    // DWORD 2
         u32 major_ver : 16;                      // DWORD 3
         u32 minor_ver : 16;                      // DWORD 3
      } SG_PACK EEPROM_FIRMWARE_REGION_HEADER, *PEEPROM_FIRMWARE_REGION_HEADER;

      typedef union _EEPROM_FIRMWARE_REGION_HEADER_UNION {
         EEPROM_FIRMWARE_REGION_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK EEPROM_FIRMWARE_REGION_HEADER_UNION, *PEEPROM_FIRMWARE_REGION_HEADER_UNION;

      SG_C_ASSERT(__sizeof__EEPROM_FIRMWARE_REGION_HEADER_UNION, sizeof (EEPROM_FIRMWARE_REGION_HEADER_UNION) == 16);
   #endif


#else
   // Each firmware image that is stored in the firmware region is preceeded by a firmware
   // region header. The firmware region header provides the length of the firmware image
   // as well as length of the individual firmware sections in the image (ie. instruction
   // RAM data RAM, and banked memories). It also provides the processor ID the firmware
   // is for, and version information about the firmware image. The firmware region is
   // terminated by a EEPROM region header with the regionType field indicationg
   // End-of-Region (EEPROM_REGION_TYPE_EOR). No CRC-32 follows the firmware region. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EEPROM_FIRMWARE_REGION_HEADER {
         union {
            struct { 
               u32 length : 16;                   // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 cpuID : 4;                     // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 region_header_regionType : 3;  // DWORD 0
               u32 region_header_eod : 1;         // DWORD 0
               u32 iram_length : 16;              // DWORD 1
               u32 dram_length : 16;              // DWORD 1
               u32 bank1_length : 8;              // DWORD 2
               u32 bank2_length : 8;              // DWORD 2
               u32 build_number : 16;             // DWORD 2
               u32 minor_ver : 16;                // DWORD 3
               u32 major_ver : 16;                // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK EEPROM_FIRMWARE_REGION_HEADER, *PEEPROM_FIRMWARE_REGION_HEADER;

      SG_C_ASSERT(__sizeof__EEPROM_FIRMWARE_REGION_HEADER, sizeof (EEPROM_FIRMWARE_REGION_HEADER) == 16);

   #else
      typedef struct _EEPROM_FIRMWARE_REGION_HEADER {
         u32 length : 16;                         // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cpuID : 4;                           // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 region_header_regionType : 3;        // DWORD 0
         u32 region_header_eod : 1;               // DWORD 0
         u32 iram_length : 16;                    // DWORD 1
         u32 dram_length : 16;                    // DWORD 1
         u32 bank1_length : 8;                    // DWORD 2
         u32 bank2_length : 8;                    // DWORD 2
         u32 build_number : 16;                   // DWORD 2
         u32 minor_ver : 16;                      // DWORD 3
         u32 major_ver : 16;                      // DWORD 3
      } SG_PACK EEPROM_FIRMWARE_REGION_HEADER, *PEEPROM_FIRMWARE_REGION_HEADER;

      typedef union _EEPROM_FIRMWARE_REGION_HEADER_UNION {
         EEPROM_FIRMWARE_REGION_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK EEPROM_FIRMWARE_REGION_HEADER_UNION, *PEEPROM_FIRMWARE_REGION_HEADER_UNION;

      SG_C_ASSERT(__sizeof__EEPROM_FIRMWARE_REGION_HEADER_UNION, sizeof (EEPROM_FIRMWARE_REGION_HEADER_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __eeprom_bmap_h__

