/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ep_bmap_h__
#define __ep_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // General Control and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_CONTROL_CSR {
         union {
            struct { 
               u32 CPU_reset : 1;                 // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
               u32 ep_ram_init_status : 1;        // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 m2_RxPbuf : 1;                 // DWORD 0
               u32 m1_RxPbuf : 1;                 // DWORD 0
               u32 m0_RxPbuf : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_CONTROL_CSR, *PEP_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_CONTROL_CSR, sizeof (EP_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_CONTROL_CSR {
         u32 CPU_reset : 1;                       // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
         u32 ep_ram_init_status : 1;              // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 m2_RxPbuf : 1;                       // DWORD 0
         u32 m1_RxPbuf : 1;                       // DWORD 0
         u32 m0_RxPbuf : 1;                       // DWORD 0
      } SG_PACK EP_CONTROL_CSR, *PEP_CONTROL_CSR;

      typedef union _EP_CONTROL_CSR_UNION {
         EP_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_CONTROL_CSR_UNION, *PEP_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_CONTROL_CSR_UNION, sizeof (EP_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // General Control and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_CONTROL_CSR {
         union {
            struct { 
               u32 m0_RxPbuf : 1;                 // DWORD 0
               u32 m1_RxPbuf : 1;                 // DWORD 0
               u32 m2_RxPbuf : 1;                 // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 ep_ram_init_status : 1;        // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
               u32 CPU_reset : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_CONTROL_CSR, *PEP_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_CONTROL_CSR, sizeof (EP_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_CONTROL_CSR {
         u32 m0_RxPbuf : 1;                       // DWORD 0
         u32 m1_RxPbuf : 1;                       // DWORD 0
         u32 m2_RxPbuf : 1;                       // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 ep_ram_init_status : 1;              // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
         u32 CPU_reset : 1;                       // DWORD 0
      } SG_PACK EP_CONTROL_CSR, *PEP_CONTROL_CSR;

      typedef union _EP_CONTROL_CSR_UNION {
         EP_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_CONTROL_CSR_UNION, *PEP_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_CONTROL_CSR_UNION, sizeof (EP_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction RAM Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_INSTR_RAM_ADDR_CSR {
         union {
            struct { 
               u32 rsvd1 : 17;                    // DWORD 0
               u32 instr_ram_addr : 13;           // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_INSTR_RAM_ADDR_CSR, *PEP_INSTR_RAM_ADDR_CSR;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_ADDR_CSR, sizeof (EP_INSTR_RAM_ADDR_CSR) == 4);

   #else
      typedef struct _EP_INSTR_RAM_ADDR_CSR {
         u32 rsvd1 : 17;                          // DWORD 0
         u32 instr_ram_addr : 13;                 // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK EP_INSTR_RAM_ADDR_CSR, *PEP_INSTR_RAM_ADDR_CSR;

      typedef union _EP_INSTR_RAM_ADDR_CSR_UNION {
         EP_INSTR_RAM_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_INSTR_RAM_ADDR_CSR_UNION, *PEP_INSTR_RAM_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_ADDR_CSR_UNION, sizeof (EP_INSTR_RAM_ADDR_CSR_UNION) == 4);
   #endif


#else
   // Instruction RAM Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_INSTR_RAM_ADDR_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 instr_ram_addr : 13;           // DWORD 0
               u32 rsvd1 : 17;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_INSTR_RAM_ADDR_CSR, *PEP_INSTR_RAM_ADDR_CSR;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_ADDR_CSR, sizeof (EP_INSTR_RAM_ADDR_CSR) == 4);

   #else
      typedef struct _EP_INSTR_RAM_ADDR_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 instr_ram_addr : 13;                 // DWORD 0
         u32 rsvd1 : 17;                          // DWORD 0
      } SG_PACK EP_INSTR_RAM_ADDR_CSR, *PEP_INSTR_RAM_ADDR_CSR;

      typedef union _EP_INSTR_RAM_ADDR_CSR_UNION {
         EP_INSTR_RAM_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_INSTR_RAM_ADDR_CSR_UNION, *PEP_INSTR_RAM_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_ADDR_CSR_UNION, sizeof (EP_INSTR_RAM_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction RAM Read/Write Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_INSTR_RAM_RWDATA_CSR {
         union {
            struct { 
               u32 instr_ram_data;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_INSTR_RAM_RWDATA_CSR, *PEP_INSTR_RAM_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_RWDATA_CSR, sizeof (EP_INSTR_RAM_RWDATA_CSR) == 4);

   #else
      typedef struct _EP_INSTR_RAM_RWDATA_CSR {
         u32 instr_ram_data;                      // DWORD 0
      } SG_PACK EP_INSTR_RAM_RWDATA_CSR, *PEP_INSTR_RAM_RWDATA_CSR;

      typedef union _EP_INSTR_RAM_RWDATA_CSR_UNION {
         EP_INSTR_RAM_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_INSTR_RAM_RWDATA_CSR_UNION, *PEP_INSTR_RAM_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_RWDATA_CSR_UNION, sizeof (EP_INSTR_RAM_RWDATA_CSR_UNION) == 4);
   #endif


#else
   // Instruction RAM Read/Write Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_INSTR_RAM_RWDATA_CSR {
         union {
            struct { 
               u32 instr_ram_data;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_INSTR_RAM_RWDATA_CSR, *PEP_INSTR_RAM_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_RWDATA_CSR, sizeof (EP_INSTR_RAM_RWDATA_CSR) == 4);

   #else
      typedef struct _EP_INSTR_RAM_RWDATA_CSR {
         u32 instr_ram_data;                      // DWORD 0
      } SG_PACK EP_INSTR_RAM_RWDATA_CSR, *PEP_INSTR_RAM_RWDATA_CSR;

      typedef union _EP_INSTR_RAM_RWDATA_CSR_UNION {
         EP_INSTR_RAM_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_INSTR_RAM_RWDATA_CSR_UNION, *PEP_INSTR_RAM_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_INSTR_RAM_RWDATA_CSR_UNION, sizeof (EP_INSTR_RAM_RWDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data RAM Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_DATA_RAM_ADDR_CSR {
         union {
            struct { 
               u32 rsvd1 : 19;                    // DWORD 0
               u32 data_ram_addr : 11;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_DATA_RAM_ADDR_CSR, *PEP_DATA_RAM_ADDR_CSR;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_ADDR_CSR, sizeof (EP_DATA_RAM_ADDR_CSR) == 4);

   #else
      typedef struct _EP_DATA_RAM_ADDR_CSR {
         u32 rsvd1 : 19;                          // DWORD 0
         u32 data_ram_addr : 11;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK EP_DATA_RAM_ADDR_CSR, *PEP_DATA_RAM_ADDR_CSR;

      typedef union _EP_DATA_RAM_ADDR_CSR_UNION {
         EP_DATA_RAM_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_DATA_RAM_ADDR_CSR_UNION, *PEP_DATA_RAM_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_ADDR_CSR_UNION, sizeof (EP_DATA_RAM_ADDR_CSR_UNION) == 4);
   #endif


#else
   // Data RAM Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_DATA_RAM_ADDR_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 data_ram_addr : 11;            // DWORD 0
               u32 rsvd1 : 19;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_DATA_RAM_ADDR_CSR, *PEP_DATA_RAM_ADDR_CSR;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_ADDR_CSR, sizeof (EP_DATA_RAM_ADDR_CSR) == 4);

   #else
      typedef struct _EP_DATA_RAM_ADDR_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 data_ram_addr : 11;                  // DWORD 0
         u32 rsvd1 : 19;                          // DWORD 0
      } SG_PACK EP_DATA_RAM_ADDR_CSR, *PEP_DATA_RAM_ADDR_CSR;

      typedef union _EP_DATA_RAM_ADDR_CSR_UNION {
         EP_DATA_RAM_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_DATA_RAM_ADDR_CSR_UNION, *PEP_DATA_RAM_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_ADDR_CSR_UNION, sizeof (EP_DATA_RAM_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data RAM Read/Write Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_DATA_RAM_RWDATA_CSR {
         union {
            struct { 
               u32 data_ram_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_DATA_RAM_RWDATA_CSR, *PEP_DATA_RAM_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_RWDATA_CSR, sizeof (EP_DATA_RAM_RWDATA_CSR) == 4);

   #else
      typedef struct _EP_DATA_RAM_RWDATA_CSR {
         u32 data_ram_data;                       // DWORD 0
      } SG_PACK EP_DATA_RAM_RWDATA_CSR, *PEP_DATA_RAM_RWDATA_CSR;

      typedef union _EP_DATA_RAM_RWDATA_CSR_UNION {
         EP_DATA_RAM_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_DATA_RAM_RWDATA_CSR_UNION, *PEP_DATA_RAM_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_RWDATA_CSR_UNION, sizeof (EP_DATA_RAM_RWDATA_CSR_UNION) == 4);
   #endif


#else
   // Data RAM Read/Write Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_DATA_RAM_RWDATA_CSR {
         union {
            struct { 
               u32 data_ram_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_DATA_RAM_RWDATA_CSR, *PEP_DATA_RAM_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_RWDATA_CSR, sizeof (EP_DATA_RAM_RWDATA_CSR) == 4);

   #else
      typedef struct _EP_DATA_RAM_RWDATA_CSR {
         u32 data_ram_data;                       // DWORD 0
      } SG_PACK EP_DATA_RAM_RWDATA_CSR, *PEP_DATA_RAM_RWDATA_CSR;

      typedef union _EP_DATA_RAM_RWDATA_CSR_UNION {
         EP_DATA_RAM_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_DATA_RAM_RWDATA_CSR_UNION, *PEP_DATA_RAM_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_DATA_RAM_RWDATA_CSR_UNION, sizeof (EP_DATA_RAM_RWDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // EP Prefetch FIFO Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_PREFETCH_ADDR_CSR {
         union {
            struct { 
               u32 rsvd1 : 23;                    // DWORD 0
               u32 ep_prefetch_addr : 7;          // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_PREFETCH_ADDR_CSR, *PEP_PREFETCH_ADDR_CSR;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_ADDR_CSR, sizeof (EP_PREFETCH_ADDR_CSR) == 4);

   #else
      typedef struct _EP_PREFETCH_ADDR_CSR {
         u32 rsvd1 : 23;                          // DWORD 0
         u32 ep_prefetch_addr : 7;                // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK EP_PREFETCH_ADDR_CSR, *PEP_PREFETCH_ADDR_CSR;

      typedef union _EP_PREFETCH_ADDR_CSR_UNION {
         EP_PREFETCH_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_PREFETCH_ADDR_CSR_UNION, *PEP_PREFETCH_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_ADDR_CSR_UNION, sizeof (EP_PREFETCH_ADDR_CSR_UNION) == 4);
   #endif


#else
   // EP Prefetch FIFO Address Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_PREFETCH_ADDR_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ep_prefetch_addr : 7;          // DWORD 0
               u32 rsvd1 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_PREFETCH_ADDR_CSR, *PEP_PREFETCH_ADDR_CSR;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_ADDR_CSR, sizeof (EP_PREFETCH_ADDR_CSR) == 4);

   #else
      typedef struct _EP_PREFETCH_ADDR_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ep_prefetch_addr : 7;                // DWORD 0
         u32 rsvd1 : 23;                          // DWORD 0
      } SG_PACK EP_PREFETCH_ADDR_CSR, *PEP_PREFETCH_ADDR_CSR;

      typedef union _EP_PREFETCH_ADDR_CSR_UNION {
         EP_PREFETCH_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_PREFETCH_ADDR_CSR_UNION, *PEP_PREFETCH_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_ADDR_CSR_UNION, sizeof (EP_PREFETCH_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Prefetch FIFO Read Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_PREFETCH_RDATA_CSR {
         union {
            struct { 
               u32 ep_prefetch_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_PREFETCH_RDATA_CSR, *PEP_PREFETCH_RDATA_CSR;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_RDATA_CSR, sizeof (EP_PREFETCH_RDATA_CSR) == 4);

   #else
      typedef struct _EP_PREFETCH_RDATA_CSR {
         u32 ep_prefetch_data;                    // DWORD 0
      } SG_PACK EP_PREFETCH_RDATA_CSR, *PEP_PREFETCH_RDATA_CSR;

      typedef union _EP_PREFETCH_RDATA_CSR_UNION {
         EP_PREFETCH_RDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_PREFETCH_RDATA_CSR_UNION, *PEP_PREFETCH_RDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_RDATA_CSR_UNION, sizeof (EP_PREFETCH_RDATA_CSR_UNION) == 4);
   #endif


#else
   // Prefetch FIFO Read Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_PREFETCH_RDATA_CSR {
         union {
            struct { 
               u32 ep_prefetch_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_PREFETCH_RDATA_CSR, *PEP_PREFETCH_RDATA_CSR;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_RDATA_CSR, sizeof (EP_PREFETCH_RDATA_CSR) == 4);

   #else
      typedef struct _EP_PREFETCH_RDATA_CSR {
         u32 ep_prefetch_data;                    // DWORD 0
      } SG_PACK EP_PREFETCH_RDATA_CSR, *PEP_PREFETCH_RDATA_CSR;

      typedef union _EP_PREFETCH_RDATA_CSR_UNION {
         EP_PREFETCH_RDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_PREFETCH_RDATA_CSR_UNION, *PEP_PREFETCH_RDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_RDATA_CSR_UNION, sizeof (EP_PREFETCH_RDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Prefetch FIFO Read/Write Parameters Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_PREFETCH_PARAMS_CSR {
         union {
            struct { 
               u32 rsvd2 : 9;                     // DWORD 0
               u32 prefetch_numfilled : 7;        // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 ep_prefetch_complete : 1;      // DWORD 0
               u32 ep_bank_ctx_wr : 1;            // DWORD 0
               u32 ep_bank_desc_wr : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ep_prefetch_param_addr : 7;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_PREFETCH_PARAMS_CSR, *PEP_PREFETCH_PARAMS_CSR;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_PARAMS_CSR, sizeof (EP_PREFETCH_PARAMS_CSR) == 4);

   #else
      typedef struct _EP_PREFETCH_PARAMS_CSR {
         u32 rsvd2 : 9;                           // DWORD 0
         u32 prefetch_numfilled : 7;              // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 ep_prefetch_complete : 1;            // DWORD 0
         u32 ep_bank_ctx_wr : 1;                  // DWORD 0
         u32 ep_bank_desc_wr : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ep_prefetch_param_addr : 7;          // DWORD 0
      } SG_PACK EP_PREFETCH_PARAMS_CSR, *PEP_PREFETCH_PARAMS_CSR;

      typedef union _EP_PREFETCH_PARAMS_CSR_UNION {
         EP_PREFETCH_PARAMS_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_PREFETCH_PARAMS_CSR_UNION, *PEP_PREFETCH_PARAMS_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_PARAMS_CSR_UNION, sizeof (EP_PREFETCH_PARAMS_CSR_UNION) == 4);
   #endif


#else
   // Prefetch FIFO Read/Write Parameters Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_PREFETCH_PARAMS_CSR {
         union {
            struct { 
               u32 ep_prefetch_param_addr : 7;    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ep_bank_desc_wr : 1;           // DWORD 0
               u32 ep_bank_ctx_wr : 1;            // DWORD 0
               u32 ep_prefetch_complete : 1;      // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 prefetch_numfilled : 7;        // DWORD 0
               u32 rsvd2 : 9;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_PREFETCH_PARAMS_CSR, *PEP_PREFETCH_PARAMS_CSR;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_PARAMS_CSR, sizeof (EP_PREFETCH_PARAMS_CSR) == 4);

   #else
      typedef struct _EP_PREFETCH_PARAMS_CSR {
         u32 ep_prefetch_param_addr : 7;          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ep_bank_desc_wr : 1;                 // DWORD 0
         u32 ep_bank_ctx_wr : 1;                  // DWORD 0
         u32 ep_prefetch_complete : 1;            // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 prefetch_numfilled : 7;              // DWORD 0
         u32 rsvd2 : 9;                           // DWORD 0
      } SG_PACK EP_PREFETCH_PARAMS_CSR, *PEP_PREFETCH_PARAMS_CSR;

      typedef union _EP_PREFETCH_PARAMS_CSR_UNION {
         EP_PREFETCH_PARAMS_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_PREFETCH_PARAMS_CSR_UNION, *PEP_PREFETCH_PARAMS_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_PREFETCH_PARAMS_CSR_UNION, sizeof (EP_PREFETCH_PARAMS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Queue Weight Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_INPUT_QUE_WEIGHT_CSR {
         union {
            struct { 
               u32 iq7 : 4;                       // DWORD 0
               u32 iq6 : 4;                       // DWORD 0
               u32 iq5 : 4;                       // DWORD 0
               u32 iq4 : 4;                       // DWORD 0
               u32 iq3 : 4;                       // DWORD 0
               u32 iq2 : 4;                       // DWORD 0
               u32 iq1 : 4;                       // DWORD 0
               u32 iq0 : 4;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_INPUT_QUE_WEIGHT_CSR, *PEP_INPUT_QUE_WEIGHT_CSR;

      SG_C_ASSERT(__sizeof__EP_INPUT_QUE_WEIGHT_CSR, sizeof (EP_INPUT_QUE_WEIGHT_CSR) == 4);

   #else
      typedef struct _EP_INPUT_QUE_WEIGHT_CSR {
         u32 iq7 : 4;                             // DWORD 0
         u32 iq6 : 4;                             // DWORD 0
         u32 iq5 : 4;                             // DWORD 0
         u32 iq4 : 4;                             // DWORD 0
         u32 iq3 : 4;                             // DWORD 0
         u32 iq2 : 4;                             // DWORD 0
         u32 iq1 : 4;                             // DWORD 0
         u32 iq0 : 4;                             // DWORD 0
      } SG_PACK EP_INPUT_QUE_WEIGHT_CSR, *PEP_INPUT_QUE_WEIGHT_CSR;

      typedef union _EP_INPUT_QUE_WEIGHT_CSR_UNION {
         EP_INPUT_QUE_WEIGHT_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_INPUT_QUE_WEIGHT_CSR_UNION, *PEP_INPUT_QUE_WEIGHT_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_INPUT_QUE_WEIGHT_CSR_UNION, sizeof (EP_INPUT_QUE_WEIGHT_CSR_UNION) == 4);
   #endif


#else
   // Input Queue Weight Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_INPUT_QUE_WEIGHT_CSR {
         union {
            struct { 
               u32 iq0 : 4;                       // DWORD 0
               u32 iq1 : 4;                       // DWORD 0
               u32 iq2 : 4;                       // DWORD 0
               u32 iq3 : 4;                       // DWORD 0
               u32 iq4 : 4;                       // DWORD 0
               u32 iq5 : 4;                       // DWORD 0
               u32 iq6 : 4;                       // DWORD 0
               u32 iq7 : 4;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_INPUT_QUE_WEIGHT_CSR, *PEP_INPUT_QUE_WEIGHT_CSR;

      SG_C_ASSERT(__sizeof__EP_INPUT_QUE_WEIGHT_CSR, sizeof (EP_INPUT_QUE_WEIGHT_CSR) == 4);

   #else
      typedef struct _EP_INPUT_QUE_WEIGHT_CSR {
         u32 iq0 : 4;                             // DWORD 0
         u32 iq1 : 4;                             // DWORD 0
         u32 iq2 : 4;                             // DWORD 0
         u32 iq3 : 4;                             // DWORD 0
         u32 iq4 : 4;                             // DWORD 0
         u32 iq5 : 4;                             // DWORD 0
         u32 iq6 : 4;                             // DWORD 0
         u32 iq7 : 4;                             // DWORD 0
      } SG_PACK EP_INPUT_QUE_WEIGHT_CSR, *PEP_INPUT_QUE_WEIGHT_CSR;

      typedef union _EP_INPUT_QUE_WEIGHT_CSR_UNION {
         EP_INPUT_QUE_WEIGHT_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_INPUT_QUE_WEIGHT_CSR_UNION, *PEP_INPUT_QUE_WEIGHT_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_INPUT_QUE_WEIGHT_CSR_UNION, sizeof (EP_INPUT_QUE_WEIGHT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Queue Fetch Control 0 Register. This register contains information pertinent
   // to fetching memory region1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL0_CSR {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 length1 : 11;                  // DWORD 0
               u32 offset1 : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL0_CSR, *PEP_QCTRL0_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL0_CSR, sizeof (EP_QCTRL0_CSR) == 4);

   #else
      typedef struct _EP_QCTRL0_CSR {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 length1 : 11;                        // DWORD 0
         u32 offset1 : 16;                        // DWORD 0
      } SG_PACK EP_QCTRL0_CSR, *PEP_QCTRL0_CSR;

      typedef union _EP_QCTRL0_CSR_UNION {
         EP_QCTRL0_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL0_CSR_UNION, *PEP_QCTRL0_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL0_CSR_UNION, sizeof (EP_QCTRL0_CSR_UNION) == 4);
   #endif


#else
   // Input Queue Fetch Control 0 Register. This register contains information pertinent
   // to fetching memory region1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL0_CSR {
         union {
            struct { 
               u32 offset1 : 16;                  // DWORD 0
               u32 length1 : 11;                  // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL0_CSR, *PEP_QCTRL0_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL0_CSR, sizeof (EP_QCTRL0_CSR) == 4);

   #else
      typedef struct _EP_QCTRL0_CSR {
         u32 offset1 : 16;                        // DWORD 0
         u32 length1 : 11;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK EP_QCTRL0_CSR, *PEP_QCTRL0_CSR;

      typedef union _EP_QCTRL0_CSR_UNION {
         EP_QCTRL0_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL0_CSR_UNION, *PEP_QCTRL0_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL0_CSR_UNION, sizeof (EP_QCTRL0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Queue Fetch Control 1 Register. This register contains information pertinent
   // to fetching memory region1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL1_CSR {
         union {
            struct { 
               u32 rsvd2 : 5;                     // DWORD 0
               u32 b2b_group : 3;                 // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 b2b : 1;                       // DWORD 0
               u32 lb_cfg : 3;                    // DWORD 0
               u32 src1 : 2;                      // DWORD 0
               u32 dst1 : 1;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 field_loc1 : 6;                // DWORD 0
               u32 field_len1 : 5;                // DWORD 0
               u32 stride1 : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL1_CSR, *PEP_QCTRL1_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL1_CSR, sizeof (EP_QCTRL1_CSR) == 4);

   #else
      typedef struct _EP_QCTRL1_CSR {
         u32 rsvd2 : 5;                           // DWORD 0
         u32 b2b_group : 3;                       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 b2b : 1;                             // DWORD 0
         u32 lb_cfg : 3;                          // DWORD 0
         u32 src1 : 2;                            // DWORD 0
         u32 dst1 : 1;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 field_loc1 : 6;                      // DWORD 0
         u32 field_len1 : 5;                      // DWORD 0
         u32 stride1 : 3;                         // DWORD 0
      } SG_PACK EP_QCTRL1_CSR, *PEP_QCTRL1_CSR;

      typedef union _EP_QCTRL1_CSR_UNION {
         EP_QCTRL1_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL1_CSR_UNION, *PEP_QCTRL1_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL1_CSR_UNION, sizeof (EP_QCTRL1_CSR_UNION) == 4);
   #endif


#else
   // Input Queue Fetch Control 1 Register. This register contains information pertinent
   // to fetching memory region1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL1_CSR {
         union {
            struct { 
               u32 stride1 : 3;                   // DWORD 0
               u32 field_len1 : 5;                // DWORD 0
               u32 field_loc1 : 6;                // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dst1 : 1;                      // DWORD 0
               u32 src1 : 2;                      // DWORD 0
               u32 lb_cfg : 3;                    // DWORD 0
               u32 b2b : 1;                       // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 b2b_group : 3;                 // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL1_CSR, *PEP_QCTRL1_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL1_CSR, sizeof (EP_QCTRL1_CSR) == 4);

   #else
      typedef struct _EP_QCTRL1_CSR {
         u32 stride1 : 3;                         // DWORD 0
         u32 field_len1 : 5;                      // DWORD 0
         u32 field_loc1 : 6;                      // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dst1 : 1;                            // DWORD 0
         u32 src1 : 2;                            // DWORD 0
         u32 lb_cfg : 3;                          // DWORD 0
         u32 b2b : 1;                             // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 b2b_group : 3;                       // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
      } SG_PACK EP_QCTRL1_CSR, *PEP_QCTRL1_CSR;

      typedef union _EP_QCTRL1_CSR_UNION {
         EP_QCTRL1_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL1_CSR_UNION, *PEP_QCTRL1_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL1_CSR_UNION, sizeof (EP_QCTRL1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Queue Fetch Control 2 Register. This register contains information pertinent
   // to fetching memory region2
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL2_CSR {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 length2 : 11;                  // DWORD 0
               u32 offset2 : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL2_CSR, *PEP_QCTRL2_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL2_CSR, sizeof (EP_QCTRL2_CSR) == 4);

   #else
      typedef struct _EP_QCTRL2_CSR {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 length2 : 11;                        // DWORD 0
         u32 offset2 : 16;                        // DWORD 0
      } SG_PACK EP_QCTRL2_CSR, *PEP_QCTRL2_CSR;

      typedef union _EP_QCTRL2_CSR_UNION {
         EP_QCTRL2_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL2_CSR_UNION, *PEP_QCTRL2_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL2_CSR_UNION, sizeof (EP_QCTRL2_CSR_UNION) == 4);
   #endif


#else
   // Input Queue Fetch Control 2 Register. This register contains information pertinent
   // to fetching memory region2
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL2_CSR {
         union {
            struct { 
               u32 offset2 : 16;                  // DWORD 0
               u32 length2 : 11;                  // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL2_CSR, *PEP_QCTRL2_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL2_CSR, sizeof (EP_QCTRL2_CSR) == 4);

   #else
      typedef struct _EP_QCTRL2_CSR {
         u32 offset2 : 16;                        // DWORD 0
         u32 length2 : 11;                        // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK EP_QCTRL2_CSR, *PEP_QCTRL2_CSR;

      typedef union _EP_QCTRL2_CSR_UNION {
         EP_QCTRL2_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL2_CSR_UNION, *PEP_QCTRL2_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL2_CSR_UNION, sizeof (EP_QCTRL2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Input Queue Fetch Control 3 Register. This register contains information pertinent
   // to fetching memory region1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL3_CSR {
         union {
            struct { 
               u32 rsvd1 : 3;                     // DWORD 0
               u32 af_start : 5;                  // DWORD 0
               u32 af_len : 5;                    // DWORD 0
               u32 src2 : 2;                      // DWORD 0
               u32 dst2 : 1;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 field_loc2 : 6;                // DWORD 0
               u32 field_len2 : 5;                // DWORD 0
               u32 stride2 : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL3_CSR, *PEP_QCTRL3_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL3_CSR, sizeof (EP_QCTRL3_CSR) == 4);

   #else
      typedef struct _EP_QCTRL3_CSR {
         u32 rsvd1 : 3;                           // DWORD 0
         u32 af_start : 5;                        // DWORD 0
         u32 af_len : 5;                          // DWORD 0
         u32 src2 : 2;                            // DWORD 0
         u32 dst2 : 1;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 field_loc2 : 6;                      // DWORD 0
         u32 field_len2 : 5;                      // DWORD 0
         u32 stride2 : 3;                         // DWORD 0
      } SG_PACK EP_QCTRL3_CSR, *PEP_QCTRL3_CSR;

      typedef union _EP_QCTRL3_CSR_UNION {
         EP_QCTRL3_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL3_CSR_UNION, *PEP_QCTRL3_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL3_CSR_UNION, sizeof (EP_QCTRL3_CSR_UNION) == 4);
   #endif


#else
   // Input Queue Fetch Control 3 Register. This register contains information pertinent
   // to fetching memory region1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCTRL3_CSR {
         union {
            struct { 
               u32 stride2 : 3;                   // DWORD 0
               u32 field_len2 : 5;                // DWORD 0
               u32 field_loc2 : 6;                // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dst2 : 1;                      // DWORD 0
               u32 src2 : 2;                      // DWORD 0
               u32 af_len : 5;                    // DWORD 0
               u32 af_start : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCTRL3_CSR, *PEP_QCTRL3_CSR;

      SG_C_ASSERT(__sizeof__EP_QCTRL3_CSR, sizeof (EP_QCTRL3_CSR) == 4);

   #else
      typedef struct _EP_QCTRL3_CSR {
         u32 stride2 : 3;                         // DWORD 0
         u32 field_len2 : 5;                      // DWORD 0
         u32 field_loc2 : 6;                      // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dst2 : 1;                            // DWORD 0
         u32 src2 : 2;                            // DWORD 0
         u32 af_len : 5;                          // DWORD 0
         u32 af_start : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
      } SG_PACK EP_QCTRL3_CSR, *PEP_QCTRL3_CSR;

      typedef union _EP_QCTRL3_CSR_UNION {
         EP_QCTRL3_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCTRL3_CSR_UNION, *PEP_QCTRL3_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCTRL3_CSR_UNION, sizeof (EP_QCTRL3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug Bank Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_BANK_CONTROL_CSR {
         union {
            struct { 
               u32 rsvd2 : 3;                     // DWORD 0
               u32 y_status : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 x_status : 5;                  // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 b : 1;                         // DWORD 0
               u32 s : 1;                         // DWORD 0
               u32 f : 1;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_BANK_CONTROL_CSR, *PEP_BANK_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_BANK_CONTROL_CSR, sizeof (EP_BANK_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_BANK_CONTROL_CSR {
         u32 rsvd2 : 3;                           // DWORD 0
         u32 y_status : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 x_status : 5;                        // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 b : 1;                               // DWORD 0
         u32 s : 1;                               // DWORD 0
         u32 f : 1;                               // DWORD 0
      } SG_PACK EP_BANK_CONTROL_CSR, *PEP_BANK_CONTROL_CSR;

      typedef union _EP_BANK_CONTROL_CSR_UNION {
         EP_BANK_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_BANK_CONTROL_CSR_UNION, *PEP_BANK_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_BANK_CONTROL_CSR_UNION, sizeof (EP_BANK_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // Debug Bank Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_BANK_CONTROL_CSR {
         union {
            struct { 
               u32 f : 1;                         // DWORD 0
               u32 s : 1;                         // DWORD 0
               u32 b : 1;                         // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 x_status : 5;                  // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 y_status : 5;                  // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_BANK_CONTROL_CSR, *PEP_BANK_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_BANK_CONTROL_CSR, sizeof (EP_BANK_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_BANK_CONTROL_CSR {
         u32 f : 1;                               // DWORD 0
         u32 s : 1;                               // DWORD 0
         u32 b : 1;                               // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 x_status : 5;                        // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 y_status : 5;                        // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
      } SG_PACK EP_BANK_CONTROL_CSR, *PEP_BANK_CONTROL_CSR;

      typedef union _EP_BANK_CONTROL_CSR_UNION {
         EP_BANK_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_BANK_CONTROL_CSR_UNION, *PEP_BANK_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_BANK_CONTROL_CSR_UNION, sizeof (EP_BANK_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Output Queue Credit Grant CSR (0-3) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITA_CSR {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 oq3 : 5;                       // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 oq2 : 5;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 oq1 : 5;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 oq0 : 5;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITA_CSR, *PEP_QCREDITA_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITA_CSR, sizeof (EP_QCREDITA_CSR) == 4);

   #else
      typedef struct _EP_QCREDITA_CSR {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 oq3 : 5;                             // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 oq2 : 5;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 oq1 : 5;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 oq0 : 5;                             // DWORD 0
      } SG_PACK EP_QCREDITA_CSR, *PEP_QCREDITA_CSR;

      typedef union _EP_QCREDITA_CSR_UNION {
         EP_QCREDITA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITA_CSR_UNION, *PEP_QCREDITA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITA_CSR_UNION, sizeof (EP_QCREDITA_CSR_UNION) == 4);
   #endif


#else
   // Output Queue Credit Grant CSR (0-3) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITA_CSR {
         union {
            struct { 
               u32 oq0 : 5;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 oq1 : 5;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 oq2 : 5;                       // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 oq3 : 5;                       // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITA_CSR, *PEP_QCREDITA_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITA_CSR, sizeof (EP_QCREDITA_CSR) == 4);

   #else
      typedef struct _EP_QCREDITA_CSR {
         u32 oq0 : 5;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 oq1 : 5;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 oq2 : 5;                             // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 oq3 : 5;                             // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK EP_QCREDITA_CSR, *PEP_QCREDITA_CSR;

      typedef union _EP_QCREDITA_CSR_UNION {
         EP_QCREDITA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITA_CSR_UNION, *PEP_QCREDITA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITA_CSR_UNION, sizeof (EP_QCREDITA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Output Queue Credit Grant CSR (4-7) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITB_CSR {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 oq7 : 5;                       // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 oq6 : 5;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 oq5 : 5;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 oq4 : 5;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITB_CSR, *PEP_QCREDITB_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITB_CSR, sizeof (EP_QCREDITB_CSR) == 4);

   #else
      typedef struct _EP_QCREDITB_CSR {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 oq7 : 5;                             // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 oq6 : 5;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 oq5 : 5;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 oq4 : 5;                             // DWORD 0
      } SG_PACK EP_QCREDITB_CSR, *PEP_QCREDITB_CSR;

      typedef union _EP_QCREDITB_CSR_UNION {
         EP_QCREDITB_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITB_CSR_UNION, *PEP_QCREDITB_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITB_CSR_UNION, sizeof (EP_QCREDITB_CSR_UNION) == 4);
   #endif


#else
   // Output Queue Credit Grant CSR (4-7) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITB_CSR {
         union {
            struct { 
               u32 oq4 : 5;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 oq5 : 5;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 oq6 : 5;                       // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 oq7 : 5;                       // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITB_CSR, *PEP_QCREDITB_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITB_CSR, sizeof (EP_QCREDITB_CSR) == 4);

   #else
      typedef struct _EP_QCREDITB_CSR {
         u32 oq4 : 5;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 oq5 : 5;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 oq6 : 5;                             // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 oq7 : 5;                             // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK EP_QCREDITB_CSR, *PEP_QCREDITB_CSR;

      typedef union _EP_QCREDITB_CSR_UNION {
         EP_QCREDITB_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITB_CSR_UNION, *PEP_QCREDITB_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITB_CSR_UNION, sizeof (EP_QCREDITB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Output Queue Credit Grant CSR (8-11) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITC_CSR {
         union {
            struct { 
               u32 rsvd3 : 3;                     // DWORD 0
               u32 oq11 : 5;                      // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 oq10 : 5;                      // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 oq9 : 5;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 oq8 : 5;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITC_CSR, *PEP_QCREDITC_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITC_CSR, sizeof (EP_QCREDITC_CSR) == 4);

   #else
      typedef struct _EP_QCREDITC_CSR {
         u32 rsvd3 : 3;                           // DWORD 0
         u32 oq11 : 5;                            // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 oq10 : 5;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 oq9 : 5;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 oq8 : 5;                             // DWORD 0
      } SG_PACK EP_QCREDITC_CSR, *PEP_QCREDITC_CSR;

      typedef union _EP_QCREDITC_CSR_UNION {
         EP_QCREDITC_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITC_CSR_UNION, *PEP_QCREDITC_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITC_CSR_UNION, sizeof (EP_QCREDITC_CSR_UNION) == 4);
   #endif


#else
   // Output Queue Credit Grant CSR (8-11) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITC_CSR {
         union {
            struct { 
               u32 oq8 : 5;                       // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 oq9 : 5;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 oq10 : 5;                      // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
               u32 oq11 : 5;                      // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITC_CSR, *PEP_QCREDITC_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITC_CSR, sizeof (EP_QCREDITC_CSR) == 4);

   #else
      typedef struct _EP_QCREDITC_CSR {
         u32 oq8 : 5;                             // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 oq9 : 5;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 oq10 : 5;                            // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
         u32 oq11 : 5;                            // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
      } SG_PACK EP_QCREDITC_CSR, *PEP_QCREDITC_CSR;

      typedef union _EP_QCREDITC_CSR_UNION {
         EP_QCREDITC_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITC_CSR_UNION, *PEP_QCREDITC_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITC_CSR_UNION, sizeof (EP_QCREDITC_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Output Queue Credit Grant CSR (12) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITD_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 oq12 : 5;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITD_CSR, *PEP_QCREDITD_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITD_CSR, sizeof (EP_QCREDITD_CSR) == 4);

   #else
      typedef struct _EP_QCREDITD_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 oq12 : 5;                            // DWORD 0
      } SG_PACK EP_QCREDITD_CSR, *PEP_QCREDITD_CSR;

      typedef union _EP_QCREDITD_CSR_UNION {
         EP_QCREDITD_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITD_CSR_UNION, *PEP_QCREDITD_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITD_CSR_UNION, sizeof (EP_QCREDITD_CSR_UNION) == 4);
   #endif


#else
   // Output Queue Credit Grant CSR (12) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_QCREDITD_CSR {
         union {
            struct { 
               u32 oq12 : 5;                      // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_QCREDITD_CSR, *PEP_QCREDITD_CSR;

      SG_C_ASSERT(__sizeof__EP_QCREDITD_CSR, sizeof (EP_QCREDITD_CSR) == 4);

   #else
      typedef struct _EP_QCREDITD_CSR {
         u32 oq12 : 5;                            // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK EP_QCREDITD_CSR, *PEP_QCREDITD_CSR;

      typedef union _EP_QCREDITD_CSR_UNION {
         EP_QCREDITD_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_QCREDITD_CSR_UNION, *PEP_QCREDITD_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_QCREDITD_CSR_UNION, sizeof (EP_QCREDITD_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Semaphore Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_SEMAPHORE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_SEMAPHORE_CSR, *PEP_SEMAPHORE_CSR;

      SG_C_ASSERT(__sizeof__EP_SEMAPHORE_CSR, sizeof (EP_SEMAPHORE_CSR) == 4);

   #else
      typedef struct _EP_SEMAPHORE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK EP_SEMAPHORE_CSR, *PEP_SEMAPHORE_CSR;

      typedef union _EP_SEMAPHORE_CSR_UNION {
         EP_SEMAPHORE_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_SEMAPHORE_CSR_UNION, *PEP_SEMAPHORE_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_SEMAPHORE_CSR_UNION, sizeof (EP_SEMAPHORE_CSR_UNION) == 4);
   #endif


#else
   // Semaphore Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_SEMAPHORE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_SEMAPHORE_CSR, *PEP_SEMAPHORE_CSR;

      SG_C_ASSERT(__sizeof__EP_SEMAPHORE_CSR, sizeof (EP_SEMAPHORE_CSR) == 4);

   #else
      typedef struct _EP_SEMAPHORE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK EP_SEMAPHORE_CSR, *PEP_SEMAPHORE_CSR;

      typedef union _EP_SEMAPHORE_CSR_UNION {
         EP_SEMAPHORE_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_SEMAPHORE_CSR_UNION, *PEP_SEMAPHORE_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_SEMAPHORE_CSR_UNION, sizeof (EP_SEMAPHORE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPC Overflow Register. This controls how IPCs overflow into CTX memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IPC_OV_CSR {
         union {
            struct { 
               u32 flush : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 base_addr : 20;                // DWORD 0
               u32 amount : 10;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IPC_OV_CSR, *PEP_IPC_OV_CSR;

      SG_C_ASSERT(__sizeof__EP_IPC_OV_CSR, sizeof (EP_IPC_OV_CSR) == 4);

   #else
      typedef struct _EP_IPC_OV_CSR {
         u32 flush : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 base_addr : 20;                      // DWORD 0
         u32 amount : 10;                         // DWORD 0
      } SG_PACK EP_IPC_OV_CSR, *PEP_IPC_OV_CSR;

      typedef union _EP_IPC_OV_CSR_UNION {
         EP_IPC_OV_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_IPC_OV_CSR_UNION, *PEP_IPC_OV_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_IPC_OV_CSR_UNION, sizeof (EP_IPC_OV_CSR_UNION) == 4);
   #endif


#else
   // IPC Overflow Register. This controls how IPCs overflow into CTX memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IPC_OV_CSR {
         union {
            struct { 
               u32 amount : 10;                   // DWORD 0
               u32 base_addr : 20;                // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 flush : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IPC_OV_CSR, *PEP_IPC_OV_CSR;

      SG_C_ASSERT(__sizeof__EP_IPC_OV_CSR, sizeof (EP_IPC_OV_CSR) == 4);

   #else
      typedef struct _EP_IPC_OV_CSR {
         u32 amount : 10;                         // DWORD 0
         u32 base_addr : 20;                      // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 flush : 1;                           // DWORD 0
      } SG_PACK EP_IPC_OV_CSR, *PEP_IPC_OV_CSR;

      typedef union _EP_IPC_OV_CSR_UNION {
         EP_IPC_OV_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_IPC_OV_CSR_UNION, *PEP_IPC_OV_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_IPC_OV_CSR_UNION, sizeof (EP_IPC_OV_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Xtensa Related Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _XTENSA_UE_ENABLE_CR {
         union {
            struct { 
               u32 rsvd0 : 9;                     // DWORD 0
               u32 xt_iram_init_error_enable : 1; // DWORD 0
               u32 xt_iram_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_iram_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_iram_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_iram_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_fixed_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_fixed_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_fixed_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_fixed_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_shadow_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_shadow_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_shadow_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_shadow_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_data_ram_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_data_ram_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_bank_y_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_bank_y_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_bank_x_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_bank_x_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_xlmi_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_xlmi_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_xlmi_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_xlmi_core2xt_underrun_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK XTENSA_UE_ENABLE_CR, *PXTENSA_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__XTENSA_UE_ENABLE_CR, sizeof (XTENSA_UE_ENABLE_CR) == 4);

   #else
      typedef struct _XTENSA_UE_ENABLE_CR {
         u32 rsvd0 : 9;                           // DWORD 0
         u32 xt_iram_init_error_enable : 1;       // DWORD 0
         u32 xt_iram_xt2core_overrun_enable : 1;  // DWORD 0
         u32 xt_iram_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_iram_core2xt_overrun_enable : 1;  // DWORD 0
         u32 xt_iram_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_fixed_xt2core_overrun_enable : 1; // DWORD 0
         u32 xt_fixed_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_fixed_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_fixed_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_shadow_xt2core_overrun_enable : 1; // DWORD 0
         u32 xt_shadow_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_shadow_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_shadow_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_data_ram_xt2core_overrun_enable : 1; // DWORD 0
         u32 xt_data_ram_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_bank_y_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_bank_y_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_bank_x_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_bank_x_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_xlmi_xt2core_overrun_enable : 1;  // DWORD 0
         u32 xt_xlmi_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_xlmi_core2xt_overrun_enable : 1;  // DWORD 0
         u32 xt_xlmi_core2xt_underrun_enable : 1; // DWORD 0
      } SG_PACK XTENSA_UE_ENABLE_CR, *PXTENSA_UE_ENABLE_CR;

      typedef union _XTENSA_UE_ENABLE_CR_UNION {
         XTENSA_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK XTENSA_UE_ENABLE_CR_UNION, *PXTENSA_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__XTENSA_UE_ENABLE_CR_UNION, sizeof (XTENSA_UE_ENABLE_CR_UNION) == 4);
   #endif


#else
   // Xtensa Related Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _XTENSA_UE_ENABLE_CR {
         union {
            struct { 
               u32 xt_xlmi_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_xlmi_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_xlmi_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_xlmi_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_bank_x_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_bank_x_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_bank_y_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_bank_y_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_data_ram_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_data_ram_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_shadow_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_shadow_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_shadow_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_shadow_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_fixed_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_fixed_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_fixed_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_fixed_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_iram_core2xt_underrun_enable : 1; // DWORD 0
               u32 xt_iram_core2xt_overrun_enable : 1; // DWORD 0
               u32 xt_iram_xt2core_underrun_enable : 1; // DWORD 0
               u32 xt_iram_xt2core_overrun_enable : 1; // DWORD 0
               u32 xt_iram_init_error_enable : 1; // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK XTENSA_UE_ENABLE_CR, *PXTENSA_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__XTENSA_UE_ENABLE_CR, sizeof (XTENSA_UE_ENABLE_CR) == 4);

   #else
      typedef struct _XTENSA_UE_ENABLE_CR {
         u32 xt_xlmi_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_xlmi_core2xt_overrun_enable : 1;  // DWORD 0
         u32 xt_xlmi_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_xlmi_xt2core_overrun_enable : 1;  // DWORD 0
         u32 xt_bank_x_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_bank_x_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_bank_y_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_bank_y_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_data_ram_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_data_ram_xt2core_overrun_enable : 1; // DWORD 0
         u32 xt_shadow_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_shadow_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_shadow_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_shadow_xt2core_overrun_enable : 1; // DWORD 0
         u32 xt_fixed_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_fixed_core2xt_overrun_enable : 1; // DWORD 0
         u32 xt_fixed_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_fixed_xt2core_overrun_enable : 1; // DWORD 0
         u32 xt_iram_core2xt_underrun_enable : 1; // DWORD 0
         u32 xt_iram_core2xt_overrun_enable : 1;  // DWORD 0
         u32 xt_iram_xt2core_underrun_enable : 1; // DWORD 0
         u32 xt_iram_xt2core_overrun_enable : 1;  // DWORD 0
         u32 xt_iram_init_error_enable : 1;       // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
      } SG_PACK XTENSA_UE_ENABLE_CR, *PXTENSA_UE_ENABLE_CR;

      typedef union _XTENSA_UE_ENABLE_CR_UNION {
         XTENSA_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK XTENSA_UE_ENABLE_CR_UNION, *PXTENSA_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__XTENSA_UE_ENABLE_CR_UNION, sizeof (XTENSA_UE_ENABLE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Xtensa Related Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _XTENSA_UE_SOURCE_SR {
         union {
            struct { 
               u32 rsvd0 : 9;                     // DWORD 0
               u32 xt_iram_init_error_status : 1; // DWORD 0
               u32 xt_iram_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_iram_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_iram_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_iram_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_fixed_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_fixed_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_fixed_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_fixed_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_shadow_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_shadow_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_shadow_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_shadow_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_data_ram_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_data_ram_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_bank_y_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_bank_y_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_bank_x_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_bank_x_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_xlmi_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_xlmi_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_xlmi_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_xlmi_core2xt_underrun_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK XTENSA_UE_SOURCE_SR, *PXTENSA_UE_SOURCE_SR;

      SG_C_ASSERT(__sizeof__XTENSA_UE_SOURCE_SR, sizeof (XTENSA_UE_SOURCE_SR) == 4);

   #else
      typedef struct _XTENSA_UE_SOURCE_SR {
         u32 rsvd0 : 9;                           // DWORD 0
         u32 xt_iram_init_error_status : 1;       // DWORD 0
         u32 xt_iram_xt2core_overrun_status : 1;  // DWORD 0
         u32 xt_iram_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_iram_core2xt_overrun_status : 1;  // DWORD 0
         u32 xt_iram_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_fixed_xt2core_overrun_status : 1; // DWORD 0
         u32 xt_fixed_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_fixed_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_fixed_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_shadow_xt2core_overrun_status : 1; // DWORD 0
         u32 xt_shadow_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_shadow_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_shadow_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_data_ram_xt2core_overrun_status : 1; // DWORD 0
         u32 xt_data_ram_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_bank_y_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_bank_y_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_bank_x_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_bank_x_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_xlmi_xt2core_overrun_status : 1;  // DWORD 0
         u32 xt_xlmi_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_xlmi_core2xt_overrun_status : 1;  // DWORD 0
         u32 xt_xlmi_core2xt_underrun_status : 1; // DWORD 0
      } SG_PACK XTENSA_UE_SOURCE_SR, *PXTENSA_UE_SOURCE_SR;

      typedef union _XTENSA_UE_SOURCE_SR_UNION {
         XTENSA_UE_SOURCE_SR bits;
         u32 dw; // dword union
      } SG_PACK XTENSA_UE_SOURCE_SR_UNION, *PXTENSA_UE_SOURCE_SR_UNION;

      SG_C_ASSERT(__sizeof__XTENSA_UE_SOURCE_SR_UNION, sizeof (XTENSA_UE_SOURCE_SR_UNION) == 4);
   #endif


#else
   // Xtensa Related Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _XTENSA_UE_SOURCE_SR {
         union {
            struct { 
               u32 xt_xlmi_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_xlmi_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_xlmi_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_xlmi_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_bank_x_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_bank_x_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_bank_y_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_bank_y_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_data_ram_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_data_ram_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_shadow_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_shadow_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_shadow_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_shadow_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_fixed_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_fixed_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_fixed_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_fixed_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_iram_core2xt_underrun_status : 1; // DWORD 0
               u32 xt_iram_core2xt_overrun_status : 1; // DWORD 0
               u32 xt_iram_xt2core_underrun_status : 1; // DWORD 0
               u32 xt_iram_xt2core_overrun_status : 1; // DWORD 0
               u32 xt_iram_init_error_status : 1; // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK XTENSA_UE_SOURCE_SR, *PXTENSA_UE_SOURCE_SR;

      SG_C_ASSERT(__sizeof__XTENSA_UE_SOURCE_SR, sizeof (XTENSA_UE_SOURCE_SR) == 4);

   #else
      typedef struct _XTENSA_UE_SOURCE_SR {
         u32 xt_xlmi_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_xlmi_core2xt_overrun_status : 1;  // DWORD 0
         u32 xt_xlmi_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_xlmi_xt2core_overrun_status : 1;  // DWORD 0
         u32 xt_bank_x_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_bank_x_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_bank_y_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_bank_y_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_data_ram_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_data_ram_xt2core_overrun_status : 1; // DWORD 0
         u32 xt_shadow_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_shadow_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_shadow_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_shadow_xt2core_overrun_status : 1; // DWORD 0
         u32 xt_fixed_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_fixed_core2xt_overrun_status : 1; // DWORD 0
         u32 xt_fixed_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_fixed_xt2core_overrun_status : 1; // DWORD 0
         u32 xt_iram_core2xt_underrun_status : 1; // DWORD 0
         u32 xt_iram_core2xt_overrun_status : 1;  // DWORD 0
         u32 xt_iram_xt2core_underrun_status : 1; // DWORD 0
         u32 xt_iram_xt2core_overrun_status : 1;  // DWORD 0
         u32 xt_iram_init_error_status : 1;       // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
      } SG_PACK XTENSA_UE_SOURCE_SR, *PXTENSA_UE_SOURCE_SR;

      typedef union _XTENSA_UE_SOURCE_SR_UNION {
         XTENSA_UE_SOURCE_SR bits;
         u32 dw; // dword union
      } SG_PACK XTENSA_UE_SOURCE_SR_UNION, *PXTENSA_UE_SOURCE_SR_UNION;

      SG_C_ASSERT(__sizeof__XTENSA_UE_SOURCE_SR_UNION, sizeof (XTENSA_UE_SOURCE_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Initiate a read, update, or initialization to a register in the EP Stats Ram.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_STATS_RW_CONTROL_CSR {
         union {
            struct { 
               u32 ep_stats_init : 1;             // DWORD 0
               u32 ep_stats_read : 1;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ep_stats_addr : 8;             // DWORD 0
               u32 ep_stats_be : 4;               // DWORD 0
               u32 ep_stats_inc_data : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_STATS_RW_CONTROL_CSR, *PEP_STATS_RW_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_STATS_RW_CONTROL_CSR, sizeof (EP_STATS_RW_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_STATS_RW_CONTROL_CSR {
         u32 ep_stats_init : 1;                   // DWORD 0
         u32 ep_stats_read : 1;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ep_stats_addr : 8;                   // DWORD 0
         u32 ep_stats_be : 4;                     // DWORD 0
         u32 ep_stats_inc_data : 16;              // DWORD 0
      } SG_PACK EP_STATS_RW_CONTROL_CSR, *PEP_STATS_RW_CONTROL_CSR;

      typedef union _EP_STATS_RW_CONTROL_CSR_UNION {
         EP_STATS_RW_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_STATS_RW_CONTROL_CSR_UNION, *PEP_STATS_RW_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_STATS_RW_CONTROL_CSR_UNION, sizeof (EP_STATS_RW_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // Initiate a read, update, or initialization to a register in the EP Stats Ram.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_STATS_RW_CONTROL_CSR {
         union {
            struct { 
               u32 ep_stats_inc_data : 16;        // DWORD 0
               u32 ep_stats_be : 4;               // DWORD 0
               u32 ep_stats_addr : 8;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ep_stats_read : 1;             // DWORD 0
               u32 ep_stats_init : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_STATS_RW_CONTROL_CSR, *PEP_STATS_RW_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_STATS_RW_CONTROL_CSR, sizeof (EP_STATS_RW_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_STATS_RW_CONTROL_CSR {
         u32 ep_stats_inc_data : 16;              // DWORD 0
         u32 ep_stats_be : 4;                     // DWORD 0
         u32 ep_stats_addr : 8;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ep_stats_read : 1;                   // DWORD 0
         u32 ep_stats_init : 1;                   // DWORD 0
      } SG_PACK EP_STATS_RW_CONTROL_CSR, *PEP_STATS_RW_CONTROL_CSR;

      typedef union _EP_STATS_RW_CONTROL_CSR_UNION {
         EP_STATS_RW_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_STATS_RW_CONTROL_CSR_UNION, *PEP_STATS_RW_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_STATS_RW_CONTROL_CSR_UNION, sizeof (EP_STATS_RW_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data RAM Read Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_STATS_READ_DATA_CSR {
         union {
            struct { 
               u32 ep_stats_rd_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_STATS_READ_DATA_CSR, *PEP_STATS_READ_DATA_CSR;

      SG_C_ASSERT(__sizeof__EP_STATS_READ_DATA_CSR, sizeof (EP_STATS_READ_DATA_CSR) == 4);

   #else
      typedef struct _EP_STATS_READ_DATA_CSR {
         u32 ep_stats_rd_data;                    // DWORD 0
      } SG_PACK EP_STATS_READ_DATA_CSR, *PEP_STATS_READ_DATA_CSR;

      typedef union _EP_STATS_READ_DATA_CSR_UNION {
         EP_STATS_READ_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_STATS_READ_DATA_CSR_UNION, *PEP_STATS_READ_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_STATS_READ_DATA_CSR_UNION, sizeof (EP_STATS_READ_DATA_CSR_UNION) == 4);
   #endif


#else
   // Data RAM Read Data Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_STATS_READ_DATA_CSR {
         union {
            struct { 
               u32 ep_stats_rd_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_STATS_READ_DATA_CSR, *PEP_STATS_READ_DATA_CSR;

      SG_C_ASSERT(__sizeof__EP_STATS_READ_DATA_CSR, sizeof (EP_STATS_READ_DATA_CSR) == 4);

   #else
      typedef struct _EP_STATS_READ_DATA_CSR {
         u32 ep_stats_rd_data;                    // DWORD 0
      } SG_PACK EP_STATS_READ_DATA_CSR, *PEP_STATS_READ_DATA_CSR;

      typedef union _EP_STATS_READ_DATA_CSR_UNION {
         EP_STATS_READ_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_STATS_READ_DATA_CSR_UNION, *PEP_STATS_READ_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_STATS_READ_DATA_CSR_UNION, sizeof (EP_STATS_READ_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Embedded Processor Specific Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_CSRMAP {
         union {
            struct { 
               EP_CONTROL_CSR ep_control;
               EP_INSTR_RAM_ADDR_CSR ep_instr_ram_addr;
               EP_INSTR_RAM_RWDATA_CSR ep_instr_ram_rwdata;
               EP_DATA_RAM_ADDR_CSR ep_data_ram_addr;
               EP_DATA_RAM_RWDATA_CSR ep_data_ram_rwdata;
               EP_PREFETCH_ADDR_CSR ep_prefetch_addr;
               EP_PREFETCH_RDATA_CSR ep_prefetch_rdata;
               EP_PREFETCH_PARAMS_CSR ep_prefetch_params;
               EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
               struct {
                  EP_QCTRL0_CSR ep_qctrl0;
                  EP_QCTRL1_CSR ep_qctrl1;
                  EP_QCTRL2_CSR ep_qctrl2;
                  EP_QCTRL3_CSR ep_qctrl3;
               } input_queue[8];
               EP_BANK_CONTROL_CSR ep_bank_control;
               EP_QCREDITA_CSR ep_qcreditA;
               EP_QCREDITB_CSR ep_qcreditB;
               EP_QCREDITC_CSR ep_qcreditC;
               EP_QCREDITD_CSR ep_qcreditD;
               EP_SEMAPHORE_CSR ep_semaphore;
               EP_IPC_OV_CSR ep_ipc_ov;
               XTENSA_UE_ENABLE_CR xt_ue_enable;
               XTENSA_UE_SOURCE_SR xt_ue_source;
               EP_STATS_RW_CONTROL_CSR ep_stats_control;
               EP_STATS_READ_DATA_CSR ep_stats_read_data;
               u32 rsvd0[12];                     // DWORDS 24 to 35
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK EP_CSRMAP, *PEP_CSRMAP;

      SG_C_ASSERT(__sizeof__EP_CSRMAP, sizeof (EP_CSRMAP) == 256);

   #else
      typedef struct _EP_CSRMAP {
         EP_CONTROL_CSR ep_control;
         EP_INSTR_RAM_ADDR_CSR ep_instr_ram_addr;
         EP_INSTR_RAM_RWDATA_CSR ep_instr_ram_rwdata;
         EP_DATA_RAM_ADDR_CSR ep_data_ram_addr;
         EP_DATA_RAM_RWDATA_CSR ep_data_ram_rwdata;
         EP_PREFETCH_ADDR_CSR ep_prefetch_addr;
         EP_PREFETCH_RDATA_CSR ep_prefetch_rdata;
         EP_PREFETCH_PARAMS_CSR ep_prefetch_params;
         EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
         struct {
            EP_QCTRL0_CSR ep_qctrl0;
            EP_QCTRL1_CSR ep_qctrl1;
            EP_QCTRL2_CSR ep_qctrl2;
            EP_QCTRL3_CSR ep_qctrl3;
         } input_queue[8];
         EP_BANK_CONTROL_CSR ep_bank_control;
         EP_QCREDITA_CSR ep_qcreditA;
         EP_QCREDITB_CSR ep_qcreditB;
         EP_QCREDITC_CSR ep_qcreditC;
         EP_QCREDITD_CSR ep_qcreditD;
         EP_SEMAPHORE_CSR ep_semaphore;
         EP_IPC_OV_CSR ep_ipc_ov;
         XTENSA_UE_ENABLE_CR xt_ue_enable;
         XTENSA_UE_SOURCE_SR xt_ue_source;
         EP_STATS_RW_CONTROL_CSR ep_stats_control;
         EP_STATS_READ_DATA_CSR ep_stats_read_data;
         u32 rsvd0[12];                           // DWORDS 24 to 35
      } SG_PACK EP_CSRMAP, *PEP_CSRMAP;

      typedef union _EP_CSRMAP_UNION {
         EP_CSRMAP bits;
         u32 dw[64]; // dword union
      } SG_PACK EP_CSRMAP_UNION, *PEP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__EP_CSRMAP_UNION, sizeof (EP_CSRMAP_UNION) == 256);
   #endif


#else
   // Embedded Processor Specific Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_CSRMAP {
         union {
            struct { 
               EP_CONTROL_CSR ep_control;
               EP_INSTR_RAM_ADDR_CSR ep_instr_ram_addr;
               EP_INSTR_RAM_RWDATA_CSR ep_instr_ram_rwdata;
               EP_DATA_RAM_ADDR_CSR ep_data_ram_addr;
               EP_DATA_RAM_RWDATA_CSR ep_data_ram_rwdata;
               EP_PREFETCH_ADDR_CSR ep_prefetch_addr;
               EP_PREFETCH_RDATA_CSR ep_prefetch_rdata;
               EP_PREFETCH_PARAMS_CSR ep_prefetch_params;
               EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
               struct {
                  EP_QCTRL0_CSR ep_qctrl0;
                  EP_QCTRL1_CSR ep_qctrl1;
                  EP_QCTRL2_CSR ep_qctrl2;
                  EP_QCTRL3_CSR ep_qctrl3;
               } input_queue[8];
               EP_BANK_CONTROL_CSR ep_bank_control;
               EP_QCREDITA_CSR ep_qcreditA;
               EP_QCREDITB_CSR ep_qcreditB;
               EP_QCREDITC_CSR ep_qcreditC;
               EP_QCREDITD_CSR ep_qcreditD;
               EP_SEMAPHORE_CSR ep_semaphore;
               EP_IPC_OV_CSR ep_ipc_ov;
               XTENSA_UE_ENABLE_CR xt_ue_enable;
               XTENSA_UE_SOURCE_SR xt_ue_source;
               EP_STATS_RW_CONTROL_CSR ep_stats_control;
               EP_STATS_READ_DATA_CSR ep_stats_read_data;
               u32 rsvd0[12];                     // DWORDS 24 to 35
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK EP_CSRMAP, *PEP_CSRMAP;

      SG_C_ASSERT(__sizeof__EP_CSRMAP, sizeof (EP_CSRMAP) == 256);

   #else
      typedef struct _EP_CSRMAP {
         EP_CONTROL_CSR ep_control;
         EP_INSTR_RAM_ADDR_CSR ep_instr_ram_addr;
         EP_INSTR_RAM_RWDATA_CSR ep_instr_ram_rwdata;
         EP_DATA_RAM_ADDR_CSR ep_data_ram_addr;
         EP_DATA_RAM_RWDATA_CSR ep_data_ram_rwdata;
         EP_PREFETCH_ADDR_CSR ep_prefetch_addr;
         EP_PREFETCH_RDATA_CSR ep_prefetch_rdata;
         EP_PREFETCH_PARAMS_CSR ep_prefetch_params;
         EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
         struct {
            EP_QCTRL0_CSR ep_qctrl0;
            EP_QCTRL1_CSR ep_qctrl1;
            EP_QCTRL2_CSR ep_qctrl2;
            EP_QCTRL3_CSR ep_qctrl3;
         } input_queue[8];
         EP_BANK_CONTROL_CSR ep_bank_control;
         EP_QCREDITA_CSR ep_qcreditA;
         EP_QCREDITB_CSR ep_qcreditB;
         EP_QCREDITC_CSR ep_qcreditC;
         EP_QCREDITD_CSR ep_qcreditD;
         EP_SEMAPHORE_CSR ep_semaphore;
         EP_IPC_OV_CSR ep_ipc_ov;
         XTENSA_UE_ENABLE_CR xt_ue_enable;
         XTENSA_UE_SOURCE_SR xt_ue_source;
         EP_STATS_RW_CONTROL_CSR ep_stats_control;
         EP_STATS_READ_DATA_CSR ep_stats_read_data;
         u32 rsvd0[12];                           // DWORDS 24 to 35
      } SG_PACK EP_CSRMAP, *PEP_CSRMAP;

      typedef union _EP_CSRMAP_UNION {
         EP_CSRMAP bits;
         u32 dw[64]; // dword union
      } SG_PACK EP_CSRMAP_UNION, *PEP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__EP_CSRMAP_UNION, sizeof (EP_CSRMAP_UNION) == 256);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ep_bmap_h__

