/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ep_minirom_bmap_h__
#define __ep_minirom_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // minirom data word at address 0
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR0 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR0, *PEP_IROM_CSR0;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR0, sizeof (EP_IROM_CSR0) == 4);

   #else
      typedef struct _EP_IROM_CSR0 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR0, *PEP_IROM_CSR0;

      typedef union _EP_IROM_CSR0_UNION {
         EP_IROM_CSR0 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR0_UNION, *PEP_IROM_CSR0_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR0_UNION, sizeof (EP_IROM_CSR0_UNION) == 4);
   #endif


#else
   // minirom data word at address 0
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR0 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR0, *PEP_IROM_CSR0;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR0, sizeof (EP_IROM_CSR0) == 4);

   #else
      typedef struct _EP_IROM_CSR0 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR0, *PEP_IROM_CSR0;

      typedef union _EP_IROM_CSR0_UNION {
         EP_IROM_CSR0 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR0_UNION, *PEP_IROM_CSR0_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR0_UNION, sizeof (EP_IROM_CSR0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // minirom data word at address 1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR1 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR1, *PEP_IROM_CSR1;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR1, sizeof (EP_IROM_CSR1) == 4);

   #else
      typedef struct _EP_IROM_CSR1 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR1, *PEP_IROM_CSR1;

      typedef union _EP_IROM_CSR1_UNION {
         EP_IROM_CSR1 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR1_UNION, *PEP_IROM_CSR1_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR1_UNION, sizeof (EP_IROM_CSR1_UNION) == 4);
   #endif


#else
   // minirom data word at address 1
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR1 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR1, *PEP_IROM_CSR1;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR1, sizeof (EP_IROM_CSR1) == 4);

   #else
      typedef struct _EP_IROM_CSR1 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR1, *PEP_IROM_CSR1;

      typedef union _EP_IROM_CSR1_UNION {
         EP_IROM_CSR1 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR1_UNION, *PEP_IROM_CSR1_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR1_UNION, sizeof (EP_IROM_CSR1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // minirom data word at address 2
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR2 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR2, *PEP_IROM_CSR2;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR2, sizeof (EP_IROM_CSR2) == 4);

   #else
      typedef struct _EP_IROM_CSR2 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR2, *PEP_IROM_CSR2;

      typedef union _EP_IROM_CSR2_UNION {
         EP_IROM_CSR2 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR2_UNION, *PEP_IROM_CSR2_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR2_UNION, sizeof (EP_IROM_CSR2_UNION) == 4);
   #endif


#else
   // minirom data word at address 2
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR2 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR2, *PEP_IROM_CSR2;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR2, sizeof (EP_IROM_CSR2) == 4);

   #else
      typedef struct _EP_IROM_CSR2 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR2, *PEP_IROM_CSR2;

      typedef union _EP_IROM_CSR2_UNION {
         EP_IROM_CSR2 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR2_UNION, *PEP_IROM_CSR2_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR2_UNION, sizeof (EP_IROM_CSR2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // minirom data word at address 3
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR3 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR3, *PEP_IROM_CSR3;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR3, sizeof (EP_IROM_CSR3) == 4);

   #else
      typedef struct _EP_IROM_CSR3 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR3, *PEP_IROM_CSR3;

      typedef union _EP_IROM_CSR3_UNION {
         EP_IROM_CSR3 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR3_UNION, *PEP_IROM_CSR3_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR3_UNION, sizeof (EP_IROM_CSR3_UNION) == 4);
   #endif


#else
   // minirom data word at address 3
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_IROM_CSR3 {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_IROM_CSR3, *PEP_IROM_CSR3;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR3, sizeof (EP_IROM_CSR3) == 4);

   #else
      typedef struct _EP_IROM_CSR3 {
         u32 data;                                // DWORD 0
      } SG_PACK EP_IROM_CSR3, *PEP_IROM_CSR3;

      typedef union _EP_IROM_CSR3_UNION {
         EP_IROM_CSR3 bits;
         u32 dw; // dword union
      } SG_PACK EP_IROM_CSR3_UNION, *PEP_IROM_CSR3_UNION;

      SG_C_ASSERT(__sizeof__EP_IROM_CSR3_UNION, sizeof (EP_IROM_CSR3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The Embedded processor's mini ROM.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_MINIROM_CSRMAP {
         union {
            struct { 
               EP_IROM_CSR0 irom_csr0;
               EP_IROM_CSR1 irom_csr1;
               EP_IROM_CSR2 irom_csr2;
               EP_IROM_CSR3 irom_csr3;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK EP_MINIROM_CSRMAP, *PEP_MINIROM_CSRMAP;

      SG_C_ASSERT(__sizeof__EP_MINIROM_CSRMAP, sizeof (EP_MINIROM_CSRMAP) == 16);

   #else
      typedef struct _EP_MINIROM_CSRMAP {
         EP_IROM_CSR0 irom_csr0;
         EP_IROM_CSR1 irom_csr1;
         EP_IROM_CSR2 irom_csr2;
         EP_IROM_CSR3 irom_csr3;
      } SG_PACK EP_MINIROM_CSRMAP, *PEP_MINIROM_CSRMAP;

      typedef union _EP_MINIROM_CSRMAP_UNION {
         EP_MINIROM_CSRMAP bits;
         u32 dw[4]; // dword union
      } SG_PACK EP_MINIROM_CSRMAP_UNION, *PEP_MINIROM_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__EP_MINIROM_CSRMAP_UNION, sizeof (EP_MINIROM_CSRMAP_UNION) == 16);
   #endif


#else
   // The Embedded processor's mini ROM.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_MINIROM_CSRMAP {
         union {
            struct { 
               EP_IROM_CSR0 irom_csr0;
               EP_IROM_CSR1 irom_csr1;
               EP_IROM_CSR2 irom_csr2;
               EP_IROM_CSR3 irom_csr3;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK EP_MINIROM_CSRMAP, *PEP_MINIROM_CSRMAP;

      SG_C_ASSERT(__sizeof__EP_MINIROM_CSRMAP, sizeof (EP_MINIROM_CSRMAP) == 16);

   #else
      typedef struct _EP_MINIROM_CSRMAP {
         EP_IROM_CSR0 irom_csr0;
         EP_IROM_CSR1 irom_csr1;
         EP_IROM_CSR2 irom_csr2;
         EP_IROM_CSR3 irom_csr3;
      } SG_PACK EP_MINIROM_CSRMAP, *PEP_MINIROM_CSRMAP;

      typedef union _EP_MINIROM_CSRMAP_UNION {
         EP_MINIROM_CSRMAP bits;
         u32 dw[4]; // dword union
      } SG_PACK EP_MINIROM_CSRMAP_UNION, *PEP_MINIROM_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__EP_MINIROM_CSRMAP_UNION, sizeof (EP_MINIROM_CSRMAP_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ep_minirom_bmap_h__

