/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fat_header_bmap_h__
#define __fat_header_bmap_h__
#include "setypes.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This is the header that will indicate 1) presence of a header; 2) the version and
   // size of that header; 3) the data collection capabilities understood by the firmware
   // doing the data collection; 4) any revision information that might be useful in
   // debugging the collected problem. 
   typedef struct _FAT_HEADER {
      UEXACT32 fixed_signature;
      UEXACT32 total_file_size;
      UEXACT32 header_version;
      UEXACT32 header_size;
      UEXACT16 build_version[4];
      UEXACT16 driver_version[4];
      UEXACT32 board_id;
      UEXACT16 pci_ids[4];
      UEXACT16 be_config;
      UEXACT16 completion_deciseconds;
      UEXACT32 be_chip_revision;
      UEXACT32 be_chip_uid[8];
      UEXACT32 rsvd0[4];
      UEXACT32 compressed_size;
      UEXACT32 failure_seconds;
      UEXACT32 rsvd1;
   } SG_PACK FAT_HEADER, *PFAT_HEADER;



#else
   // This is the header that will indicate 1) presence of a header; 2) the version and
   // size of that header; 3) the data collection capabilities understood by the firmware
   // doing the data collection; 4) any revision information that might be useful in
   // debugging the collected problem. 
   typedef struct _FAT_HEADER {
      UEXACT32 fixed_signature;
      UEXACT32 total_file_size;
      UEXACT32 header_version;
      UEXACT32 header_size;
      UEXACT16 build_version[4];
      UEXACT16 driver_version[4];
      UEXACT32 board_id;
      UEXACT16 pci_ids[4];
      UEXACT16 be_config;
      UEXACT16 completion_deciseconds;
      UEXACT32 be_chip_revision;
      UEXACT32 be_chip_uid[8];
      UEXACT32 rsvd0[4];
      UEXACT32 compressed_size;
      UEXACT32 failure_seconds;
      UEXACT32 rsvd1;
   } SG_PACK FAT_HEADER, *PFAT_HEADER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each data collection type will have its own data section. Initially, one type will
   // be defined that will be our current FAT CSR data collection. Each data collection
   // type can be individually versioned so that the collected data can change. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_DATA_SECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 ep_id;
               UEXACT32 data_type;
               UEXACT32 version;
               UEXACT32 section_total_size;
               UEXACT32 delta_deciseconds;
               UEXACT32 data_header_version;
               u32 rsvd0 : 30;                    // DWORD 7
               u32 subsections_present : 1;       // DWORD 7
               u32 compressed : 1;                // DWORD 7
               UEXACT32 rsvd1[8];
               UEXACT32 start_of_data;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK FAT_DATA_SECTION, *PFAT_DATA_SECTION;

      SG_C_ASSERT(__sizeof__FAT_DATA_SECTION, sizeof (FAT_DATA_SECTION) == 68);

   #else
      typedef struct _FAT_DATA_SECTION {
         UEXACT32 signature;
         UEXACT32 ep_id;
         UEXACT32 data_type;
         UEXACT32 version;
         UEXACT32 section_total_size;
         UEXACT32 delta_deciseconds;
         UEXACT32 data_header_version;
         u32 rsvd0 : 30;                          // DWORD 7
         u32 subsections_present : 1;             // DWORD 7
         u32 compressed : 1;                      // DWORD 7
         UEXACT32 rsvd1[8];
         UEXACT32 start_of_data;
      } SG_PACK FAT_DATA_SECTION, *PFAT_DATA_SECTION;

      typedef union _FAT_DATA_SECTION_UNION {
         FAT_DATA_SECTION bits;
         u32 dw[17]; // dword union
      } SG_PACK FAT_DATA_SECTION_UNION, *PFAT_DATA_SECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_DATA_SECTION_UNION, sizeof (FAT_DATA_SECTION_UNION) == 68);
   #endif


#else
   // Each data collection type will have its own data section. Initially, one type will
   // be defined that will be our current FAT CSR data collection. Each data collection
   // type can be individually versioned so that the collected data can change. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_DATA_SECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 ep_id;
               UEXACT32 data_type;
               UEXACT32 version;
               UEXACT32 section_total_size;
               UEXACT32 delta_deciseconds;
               UEXACT32 data_header_version;
               u32 compressed : 1;                // DWORD 7
               u32 subsections_present : 1;       // DWORD 7
               u32 rsvd0 : 30;                    // DWORD 7
               UEXACT32 rsvd1[8];
               UEXACT32 start_of_data;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK FAT_DATA_SECTION, *PFAT_DATA_SECTION;

      SG_C_ASSERT(__sizeof__FAT_DATA_SECTION, sizeof (FAT_DATA_SECTION) == 68);

   #else
      typedef struct _FAT_DATA_SECTION {
         UEXACT32 signature;
         UEXACT32 ep_id;
         UEXACT32 data_type;
         UEXACT32 version;
         UEXACT32 section_total_size;
         UEXACT32 delta_deciseconds;
         UEXACT32 data_header_version;
         u32 compressed : 1;                      // DWORD 7
         u32 subsections_present : 1;             // DWORD 7
         u32 rsvd0 : 30;                          // DWORD 7
         UEXACT32 rsvd1[8];
         UEXACT32 start_of_data;
      } SG_PACK FAT_DATA_SECTION, *PFAT_DATA_SECTION;

      typedef union _FAT_DATA_SECTION_UNION {
         FAT_DATA_SECTION bits;
         u32 dw[17]; // dword union
      } SG_PACK FAT_DATA_SECTION_UNION, *PFAT_DATA_SECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_DATA_SECTION_UNION, sizeof (FAT_DATA_SECTION_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the selected data that is pulled from the seeprom. 
   typedef struct _FAT_SEEPROM_DATA {
      UEXACT8 seeprom_version[2];
      UEXACT16 board_id;
      UEXACT8 emulex_serial_number[12];
      UEXACT8 oem_serial_number[24];
      UEXACT8 interface_10Gb_type;
      UEXACT8 interface_1Gb_type;
      UEXACT8 PHY_type_10Gb;
      UEXACT8 PHY_type_1Gb;
      UEXACT16 ipl_file_number;
      UEXACT8 ipl_file_version;
      UEXACT8 rsvd0;
      UEXACT32 rsvd1[7];
   } SG_PACK FAT_SEEPROM_DATA, *PFAT_SEEPROM_DATA;



#else
   // This is the selected data that is pulled from the seeprom. 
   typedef struct _FAT_SEEPROM_DATA {
      UEXACT8 seeprom_version[2];
      UEXACT16 board_id;
      UEXACT8 emulex_serial_number[12];
      UEXACT8 oem_serial_number[24];
      UEXACT8 interface_10Gb_type;
      UEXACT8 interface_1Gb_type;
      UEXACT8 PHY_type_10Gb;
      UEXACT8 PHY_type_1Gb;
      UEXACT16 ipl_file_number;
      UEXACT8 ipl_file_version;
      UEXACT8 rsvd0;
      UEXACT32 rsvd1[7];
   } SG_PACK FAT_SEEPROM_DATA, *PFAT_SEEPROM_DATA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the data collected from the EPs after a UE is detected. 
   typedef struct _FAT_EP_IMAGE {
      UEXACT16 ep_image_version;
      UEXACT8 number_of_ep_cores;
      UEXACT8 number_of_data_banks;
      UEXACT32 size_of_processor_image;
      UEXACT32 size_of_fixed_ram;
      UEXACT32 starting_address_of_fixed_ram;
      UEXACT16 size_of_banked_ram;
      UEXACT16 banked_ram_consistent;
      UEXACT16 size_of_shared_fixed_ram;
      UEXACT16 size_of_non_shared_fixed_ram;
      UEXACT16 size_of_iram;
      UEXACT16 rsvd0;
      UEXACT32 rsvd1;
   } SG_PACK FAT_EP_IMAGE, *PFAT_EP_IMAGE;



#else
   // This is the data collected from the EPs after a UE is detected. 
   typedef struct _FAT_EP_IMAGE {
      UEXACT16 ep_image_version;
      UEXACT8 number_of_ep_cores;
      UEXACT8 number_of_data_banks;
      UEXACT32 size_of_processor_image;
      UEXACT32 size_of_fixed_ram;
      UEXACT32 starting_address_of_fixed_ram;
      UEXACT16 size_of_banked_ram;
      UEXACT16 banked_ram_consistent;
      UEXACT16 size_of_shared_fixed_ram;
      UEXACT16 size_of_non_shared_fixed_ram;
      UEXACT16 size_of_iram;
      UEXACT16 rsvd0;
      UEXACT32 rsvd1;
   } SG_PACK FAT_EP_IMAGE, *PFAT_EP_IMAGE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the fencing that precedes each EP data section. 
   typedef struct _FAT_EP_SUBSECTION {
      UEXACT32 ep_subsection_signature;
      UEXACT8 ep_subsection_type;
      UEXACT8 ep_total_of_type;
      UEXACT8 ep_which_of_type;
      UEXACT8 ep_subsection_version;
      UEXACT32 ep_subsection_size;
      UEXACT32 ep_sub_delta_deciseconds;
      UEXACT32 rsvd0[4];
   } SG_PACK FAT_EP_SUBSECTION, *PFAT_EP_SUBSECTION;



#else
   // This is the fencing that precedes each EP data section. 
   typedef struct _FAT_EP_SUBSECTION {
      UEXACT32 ep_subsection_signature;
      UEXACT8 ep_subsection_type;
      UEXACT8 ep_total_of_type;
      UEXACT8 ep_which_of_type;
      UEXACT8 ep_subsection_version;
      UEXACT32 ep_subsection_size;
      UEXACT32 ep_sub_delta_deciseconds;
      UEXACT32 rsvd0[4];
   } SG_PACK FAT_EP_SUBSECTION, *PFAT_EP_SUBSECTION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the processor state collected for the BE3. Based on EP configuration for
   // T1050.4 built 11/18/2005. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_EP_BE3_PROCESSOR_STATE {
         union {
            struct { 
               UEXACT8 version;
               UEXACT8 number_of_address_regs;
               UEXACT16 rsvd0;
               UEXACT32 ar[32];
               UEXACT32 ccount;
               UEXACT32 debug_cause;
               UEXACT32 debug_output_data_register;
               UEXACT32 epc[4];
               UEXACT32 eps[3];
               UEXACT32 exc_cause;
               UEXACT32 exc_save[4];
               UEXACT32 instruction_count;
               UEXACT32 icountlevel;
               UEXACT32 intenable;
               UEXACT32 loop_begin;
               UEXACT32 loop_count;
               UEXACT32 loop_end;
               UEXACT32 program_counter;
               UEXACT32 pr_id;
               UEXACT32 ps;
               UEXACT32 sar;
               UEXACT32 windowbase;
               UEXACT32 windowstart;
               UEXACT32 depc;
               UEXACT32 rasid;
               UEXACT32 ccompare0;
               UEXACT32 dbreaka[2];
               UEXACT32 ibreaka[2];
               UEXACT32 a[16];
               UEXACT32 ur[22];
               UEXACT32 rsvd1[15];
            } SG_PACK ; // unnamed struct
            u32 dw[120]; // dword union
         }; // unnamed union
      } SG_PACK FAT_EP_BE3_PROCESSOR_STATE, *PFAT_EP_BE3_PROCESSOR_STATE;

      SG_C_ASSERT(__sizeof__FAT_EP_BE3_PROCESSOR_STATE, sizeof (FAT_EP_BE3_PROCESSOR_STATE) == 480);

   #else
      typedef struct _FAT_EP_BE3_PROCESSOR_STATE {
         UEXACT8 version;
         UEXACT8 number_of_address_regs;
         UEXACT16 rsvd0;
         UEXACT32 ar[32];
         UEXACT32 ccount;
         UEXACT32 debug_cause;
         UEXACT32 debug_output_data_register;
         UEXACT32 epc[4];
         UEXACT32 eps[3];
         UEXACT32 exc_cause;
         UEXACT32 exc_save[4];
         UEXACT32 instruction_count;
         UEXACT32 icountlevel;
         UEXACT32 intenable;
         UEXACT32 loop_begin;
         UEXACT32 loop_count;
         UEXACT32 loop_end;
         UEXACT32 program_counter;
         UEXACT32 pr_id;
         UEXACT32 ps;
         UEXACT32 sar;
         UEXACT32 windowbase;
         UEXACT32 windowstart;
         UEXACT32 depc;
         UEXACT32 rasid;
         UEXACT32 ccompare0;
         UEXACT32 dbreaka[2];
         UEXACT32 ibreaka[2];
         UEXACT32 a[16];
         UEXACT32 ur[22];
         UEXACT32 rsvd1[15];
      } SG_PACK FAT_EP_BE3_PROCESSOR_STATE, *PFAT_EP_BE3_PROCESSOR_STATE;

      typedef union _FAT_EP_BE3_PROCESSOR_STATE_UNION {
         FAT_EP_BE3_PROCESSOR_STATE bits;
         u32 dw[120]; // dword union
      } SG_PACK FAT_EP_BE3_PROCESSOR_STATE_UNION, *PFAT_EP_BE3_PROCESSOR_STATE_UNION;

      SG_C_ASSERT(__sizeof__FAT_EP_BE3_PROCESSOR_STATE_UNION, sizeof (FAT_EP_BE3_PROCESSOR_STATE_UNION) == 480);
   #endif


#else
   // This is the processor state collected for the BE3. Based on EP configuration for
   // T1050.4 built 11/18/2005. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_EP_BE3_PROCESSOR_STATE {
         union {
            struct { 
               UEXACT8 version;
               UEXACT8 number_of_address_regs;
               UEXACT16 rsvd0;
               UEXACT32 ar[32];
               UEXACT32 ccount;
               UEXACT32 debug_cause;
               UEXACT32 debug_output_data_register;
               UEXACT32 epc[4];
               UEXACT32 eps[3];
               UEXACT32 exc_cause;
               UEXACT32 exc_save[4];
               UEXACT32 instruction_count;
               UEXACT32 icountlevel;
               UEXACT32 intenable;
               UEXACT32 loop_begin;
               UEXACT32 loop_count;
               UEXACT32 loop_end;
               UEXACT32 program_counter;
               UEXACT32 pr_id;
               UEXACT32 ps;
               UEXACT32 sar;
               UEXACT32 windowbase;
               UEXACT32 windowstart;
               UEXACT32 depc;
               UEXACT32 rasid;
               UEXACT32 ccompare0;
               UEXACT32 dbreaka[2];
               UEXACT32 ibreaka[2];
               UEXACT32 a[16];
               UEXACT32 ur[22];
               UEXACT32 rsvd1[15];
            } SG_PACK ; // unnamed struct
            u32 dw[120]; // dword union
         }; // unnamed union
      } SG_PACK FAT_EP_BE3_PROCESSOR_STATE, *PFAT_EP_BE3_PROCESSOR_STATE;

      SG_C_ASSERT(__sizeof__FAT_EP_BE3_PROCESSOR_STATE, sizeof (FAT_EP_BE3_PROCESSOR_STATE) == 480);

   #else
      typedef struct _FAT_EP_BE3_PROCESSOR_STATE {
         UEXACT8 version;
         UEXACT8 number_of_address_regs;
         UEXACT16 rsvd0;
         UEXACT32 ar[32];
         UEXACT32 ccount;
         UEXACT32 debug_cause;
         UEXACT32 debug_output_data_register;
         UEXACT32 epc[4];
         UEXACT32 eps[3];
         UEXACT32 exc_cause;
         UEXACT32 exc_save[4];
         UEXACT32 instruction_count;
         UEXACT32 icountlevel;
         UEXACT32 intenable;
         UEXACT32 loop_begin;
         UEXACT32 loop_count;
         UEXACT32 loop_end;
         UEXACT32 program_counter;
         UEXACT32 pr_id;
         UEXACT32 ps;
         UEXACT32 sar;
         UEXACT32 windowbase;
         UEXACT32 windowstart;
         UEXACT32 depc;
         UEXACT32 rasid;
         UEXACT32 ccompare0;
         UEXACT32 dbreaka[2];
         UEXACT32 ibreaka[2];
         UEXACT32 a[16];
         UEXACT32 ur[22];
         UEXACT32 rsvd1[15];
      } SG_PACK FAT_EP_BE3_PROCESSOR_STATE, *PFAT_EP_BE3_PROCESSOR_STATE;

      typedef union _FAT_EP_BE3_PROCESSOR_STATE_UNION {
         FAT_EP_BE3_PROCESSOR_STATE bits;
         u32 dw[120]; // dword union
      } SG_PACK FAT_EP_BE3_PROCESSOR_STATE_UNION, *PFAT_EP_BE3_PROCESSOR_STATE_UNION;

      SG_C_ASSERT(__sizeof__FAT_EP_BE3_PROCESSOR_STATE_UNION, sizeof (FAT_EP_BE3_PROCESSOR_STATE_UNION) == 480);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_EP_PROC_OP {
         union {
            struct { 
               UEXACT8 operation;
               UEXACT8 altreg;
               UEXACT8 addrreg;
               UEXACT8 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FAT_EP_PROC_OP, *PFAT_EP_PROC_OP;

      SG_C_ASSERT(__sizeof__FAT_EP_PROC_OP, sizeof (FAT_EP_PROC_OP) == 4);

   #else
      typedef struct _FAT_EP_PROC_OP {
         UEXACT8 operation;
         UEXACT8 altreg;
         UEXACT8 addrreg;
         UEXACT8 rsvd0;
      } SG_PACK FAT_EP_PROC_OP, *PFAT_EP_PROC_OP;

      typedef union _FAT_EP_PROC_OP_UNION {
         FAT_EP_PROC_OP bits;
         u32 dw; // dword union
      } SG_PACK FAT_EP_PROC_OP_UNION, *PFAT_EP_PROC_OP_UNION;

      SG_C_ASSERT(__sizeof__FAT_EP_PROC_OP_UNION, sizeof (FAT_EP_PROC_OP_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_EP_PROC_OP {
         union {
            struct { 
               UEXACT8 operation;
               UEXACT8 altreg;
               UEXACT8 addrreg;
               UEXACT8 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FAT_EP_PROC_OP, *PFAT_EP_PROC_OP;

      SG_C_ASSERT(__sizeof__FAT_EP_PROC_OP, sizeof (FAT_EP_PROC_OP) == 4);

   #else
      typedef struct _FAT_EP_PROC_OP {
         UEXACT8 operation;
         UEXACT8 altreg;
         UEXACT8 addrreg;
         UEXACT8 rsvd0;
      } SG_PACK FAT_EP_PROC_OP, *PFAT_EP_PROC_OP;

      typedef union _FAT_EP_PROC_OP_UNION {
         FAT_EP_PROC_OP bits;
         u32 dw; // dword union
      } SG_PACK FAT_EP_PROC_OP_UNION, *PFAT_EP_PROC_OP_UNION;

      SG_C_ASSERT(__sizeof__FAT_EP_PROC_OP_UNION, sizeof (FAT_EP_PROC_OP_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_TXP_STATS {
         union {
            struct { 
               UEXACT32 stat_packets;
               UEXACT32 stat_bytes_l;
               UEXACT32 stat_bytes_u;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FAT_TXP_STATS, *PFAT_TXP_STATS;

      SG_C_ASSERT(__sizeof__FAT_TXP_STATS, sizeof (FAT_TXP_STATS) == 12);

   #else
      typedef struct _FAT_TXP_STATS {
         UEXACT32 stat_packets;
         UEXACT32 stat_bytes_l;
         UEXACT32 stat_bytes_u;
      } SG_PACK FAT_TXP_STATS, *PFAT_TXP_STATS;

      typedef union _FAT_TXP_STATS_UNION {
         FAT_TXP_STATS bits;
         u32 dw[3]; // dword union
      } SG_PACK FAT_TXP_STATS_UNION, *PFAT_TXP_STATS_UNION;

      SG_C_ASSERT(__sizeof__FAT_TXP_STATS_UNION, sizeof (FAT_TXP_STATS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_TXP_STATS {
         union {
            struct { 
               UEXACT32 stat_packets;
               UEXACT32 stat_bytes_l;
               UEXACT32 stat_bytes_u;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FAT_TXP_STATS, *PFAT_TXP_STATS;

      SG_C_ASSERT(__sizeof__FAT_TXP_STATS, sizeof (FAT_TXP_STATS) == 12);

   #else
      typedef struct _FAT_TXP_STATS {
         UEXACT32 stat_packets;
         UEXACT32 stat_bytes_l;
         UEXACT32 stat_bytes_u;
      } SG_PACK FAT_TXP_STATS, *PFAT_TXP_STATS;

      typedef union _FAT_TXP_STATS_UNION {
         FAT_TXP_STATS bits;
         u32 dw[3]; // dword union
      } SG_PACK FAT_TXP_STATS_UNION, *PFAT_TXP_STATS_UNION;

      SG_C_ASSERT(__sizeof__FAT_TXP_STATS_UNION, sizeof (FAT_TXP_STATS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_TXD_DATA {
         union {
            struct { 
               UEXACT32 txd_dword[12];
               UEXACT32 txd_state;
               UEXACT32 pu_size;
               UEXACT32 je_size;
               UEXACT32 bd_size;
               UEXACT32 signature;
               UEXACT32 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[20]; // dword union
         }; // unnamed union
      } SG_PACK FAT_TXD_DATA, *PFAT_TXD_DATA;

      SG_C_ASSERT(__sizeof__FAT_TXD_DATA, sizeof (FAT_TXD_DATA) == 80);

   #else
      typedef struct _FAT_TXD_DATA {
         UEXACT32 txd_dword[12];
         UEXACT32 txd_state;
         UEXACT32 pu_size;
         UEXACT32 je_size;
         UEXACT32 bd_size;
         UEXACT32 signature;
         UEXACT32 rsvd0[3];
      } SG_PACK FAT_TXD_DATA, *PFAT_TXD_DATA;

      typedef union _FAT_TXD_DATA_UNION {
         FAT_TXD_DATA bits;
         u32 dw[20]; // dword union
      } SG_PACK FAT_TXD_DATA_UNION, *PFAT_TXD_DATA_UNION;

      SG_C_ASSERT(__sizeof__FAT_TXD_DATA_UNION, sizeof (FAT_TXD_DATA_UNION) == 80);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_TXD_DATA {
         union {
            struct { 
               UEXACT32 txd_dword[12];
               UEXACT32 txd_state;
               UEXACT32 pu_size;
               UEXACT32 je_size;
               UEXACT32 bd_size;
               UEXACT32 signature;
               UEXACT32 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[20]; // dword union
         }; // unnamed union
      } SG_PACK FAT_TXD_DATA, *PFAT_TXD_DATA;

      SG_C_ASSERT(__sizeof__FAT_TXD_DATA, sizeof (FAT_TXD_DATA) == 80);

   #else
      typedef struct _FAT_TXD_DATA {
         UEXACT32 txd_dword[12];
         UEXACT32 txd_state;
         UEXACT32 pu_size;
         UEXACT32 je_size;
         UEXACT32 bd_size;
         UEXACT32 signature;
         UEXACT32 rsvd0[3];
      } SG_PACK FAT_TXD_DATA, *PFAT_TXD_DATA;

      typedef union _FAT_TXD_DATA_UNION {
         FAT_TXD_DATA bits;
         u32 dw[20]; // dword union
      } SG_PACK FAT_TXD_DATA_UNION, *PFAT_TXD_DATA_UNION;

      SG_C_ASSERT(__sizeof__FAT_TXD_DATA_UNION, sizeof (FAT_TXD_DATA_UNION) == 80);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_RXF_SUBSECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 type;
               UEXACT32 subsize;
               u32 flags;                         // DWORD 3
               UEXACT32 delta_deciseconds;
               UEXACT32 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FAT_RXF_SUBSECTION, *PFAT_RXF_SUBSECTION;

      SG_C_ASSERT(__sizeof__FAT_RXF_SUBSECTION, sizeof (FAT_RXF_SUBSECTION) == 32);

   #else
      typedef struct _FAT_RXF_SUBSECTION {
         UEXACT32 signature;
         UEXACT32 type;
         UEXACT32 subsize;
         u32 flags;                               // DWORD 3
         UEXACT32 delta_deciseconds;
         UEXACT32 rsvd0[3];
      } SG_PACK FAT_RXF_SUBSECTION, *PFAT_RXF_SUBSECTION;

      typedef union _FAT_RXF_SUBSECTION_UNION {
         FAT_RXF_SUBSECTION bits;
         u32 dw[8]; // dword union
      } SG_PACK FAT_RXF_SUBSECTION_UNION, *PFAT_RXF_SUBSECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_RXF_SUBSECTION_UNION, sizeof (FAT_RXF_SUBSECTION_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_RXF_SUBSECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 type;
               UEXACT32 subsize;
               u32 flags;                         // DWORD 3
               UEXACT32 delta_deciseconds;
               UEXACT32 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FAT_RXF_SUBSECTION, *PFAT_RXF_SUBSECTION;

      SG_C_ASSERT(__sizeof__FAT_RXF_SUBSECTION, sizeof (FAT_RXF_SUBSECTION) == 32);

   #else
      typedef struct _FAT_RXF_SUBSECTION {
         UEXACT32 signature;
         UEXACT32 type;
         UEXACT32 subsize;
         u32 flags;                               // DWORD 3
         UEXACT32 delta_deciseconds;
         UEXACT32 rsvd0[3];
      } SG_PACK FAT_RXF_SUBSECTION, *PFAT_RXF_SUBSECTION;

      typedef union _FAT_RXF_SUBSECTION_UNION {
         FAT_RXF_SUBSECTION bits;
         u32 dw[8]; // dword union
      } SG_PACK FAT_RXF_SUBSECTION_UNION, *PFAT_RXF_SUBSECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_RXF_SUBSECTION_UNION, sizeof (FAT_RXF_SUBSECTION_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_DMA_SUBSECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 status_count;
               UEXACT32 additional_data_size;
               UEXACT32 rsvd0[5];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FAT_DMA_SUBSECTION, *PFAT_DMA_SUBSECTION;

      SG_C_ASSERT(__sizeof__FAT_DMA_SUBSECTION, sizeof (FAT_DMA_SUBSECTION) == 32);

   #else
      typedef struct _FAT_DMA_SUBSECTION {
         UEXACT32 signature;
         UEXACT32 status_count;
         UEXACT32 additional_data_size;
         UEXACT32 rsvd0[5];
      } SG_PACK FAT_DMA_SUBSECTION, *PFAT_DMA_SUBSECTION;

      typedef union _FAT_DMA_SUBSECTION_UNION {
         FAT_DMA_SUBSECTION bits;
         u32 dw[8]; // dword union
      } SG_PACK FAT_DMA_SUBSECTION_UNION, *PFAT_DMA_SUBSECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_DMA_SUBSECTION_UNION, sizeof (FAT_DMA_SUBSECTION_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_DMA_SUBSECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 status_count;
               UEXACT32 additional_data_size;
               UEXACT32 rsvd0[5];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FAT_DMA_SUBSECTION, *PFAT_DMA_SUBSECTION;

      SG_C_ASSERT(__sizeof__FAT_DMA_SUBSECTION, sizeof (FAT_DMA_SUBSECTION) == 32);

   #else
      typedef struct _FAT_DMA_SUBSECTION {
         UEXACT32 signature;
         UEXACT32 status_count;
         UEXACT32 additional_data_size;
         UEXACT32 rsvd0[5];
      } SG_PACK FAT_DMA_SUBSECTION, *PFAT_DMA_SUBSECTION;

      typedef union _FAT_DMA_SUBSECTION_UNION {
         FAT_DMA_SUBSECTION bits;
         u32 dw[8]; // dword union
      } SG_PACK FAT_DMA_SUBSECTION_UNION, *PFAT_DMA_SUBSECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_DMA_SUBSECTION_UNION, sizeof (FAT_DMA_SUBSECTION_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_GEN_SUBSECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 type;
               UEXACT32 subsize;
               u32 flags;                         // DWORD 3
               UEXACT32 delta_deciseconds;
               UEXACT16 data_version;
               UEXACT16 data_header_version;
               UEXACT32 item_count;
               UEXACT32 rsvd0[9];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FAT_GEN_SUBSECTION, *PFAT_GEN_SUBSECTION;

      SG_C_ASSERT(__sizeof__FAT_GEN_SUBSECTION, sizeof (FAT_GEN_SUBSECTION) == 64);

   #else
      typedef struct _FAT_GEN_SUBSECTION {
         UEXACT32 signature;
         UEXACT32 type;
         UEXACT32 subsize;
         u32 flags;                               // DWORD 3
         UEXACT32 delta_deciseconds;
         UEXACT16 data_version;
         UEXACT16 data_header_version;
         UEXACT32 item_count;
         UEXACT32 rsvd0[9];
      } SG_PACK FAT_GEN_SUBSECTION, *PFAT_GEN_SUBSECTION;

      typedef union _FAT_GEN_SUBSECTION_UNION {
         FAT_GEN_SUBSECTION bits;
         u32 dw[16]; // dword union
      } SG_PACK FAT_GEN_SUBSECTION_UNION, *PFAT_GEN_SUBSECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_GEN_SUBSECTION_UNION, sizeof (FAT_GEN_SUBSECTION_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_GEN_SUBSECTION {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT32 type;
               UEXACT32 subsize;
               u32 flags;                         // DWORD 3
               UEXACT32 delta_deciseconds;
               UEXACT16 data_version;
               UEXACT16 data_header_version;
               UEXACT32 item_count;
               UEXACT32 rsvd0[9];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FAT_GEN_SUBSECTION, *PFAT_GEN_SUBSECTION;

      SG_C_ASSERT(__sizeof__FAT_GEN_SUBSECTION, sizeof (FAT_GEN_SUBSECTION) == 64);

   #else
      typedef struct _FAT_GEN_SUBSECTION {
         UEXACT32 signature;
         UEXACT32 type;
         UEXACT32 subsize;
         u32 flags;                               // DWORD 3
         UEXACT32 delta_deciseconds;
         UEXACT16 data_version;
         UEXACT16 data_header_version;
         UEXACT32 item_count;
         UEXACT32 rsvd0[9];
      } SG_PACK FAT_GEN_SUBSECTION, *PFAT_GEN_SUBSECTION;

      typedef union _FAT_GEN_SUBSECTION_UNION {
         FAT_GEN_SUBSECTION bits;
         u32 dw[16]; // dword union
      } SG_PACK FAT_GEN_SUBSECTION_UNION, *PFAT_GEN_SUBSECTION_UNION;

      SG_C_ASSERT(__sizeof__FAT_GEN_SUBSECTION_UNION, sizeof (FAT_GEN_SUBSECTION_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_DATA_FOOTER {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT16 version;
               UEXACT16 total_collection_time;
               UEXACT32 total_data_written;
               UEXACT32 pre_compress_data_size;
               UEXACT32 post_compress_data_size;
               UEXACT32 rsvd0[11];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FAT_DATA_FOOTER, *PFAT_DATA_FOOTER;

      SG_C_ASSERT(__sizeof__FAT_DATA_FOOTER, sizeof (FAT_DATA_FOOTER) == 64);

   #else
      typedef struct _FAT_DATA_FOOTER {
         UEXACT32 signature;
         UEXACT16 version;
         UEXACT16 total_collection_time;
         UEXACT32 total_data_written;
         UEXACT32 pre_compress_data_size;
         UEXACT32 post_compress_data_size;
         UEXACT32 rsvd0[11];
      } SG_PACK FAT_DATA_FOOTER, *PFAT_DATA_FOOTER;

      typedef union _FAT_DATA_FOOTER_UNION {
         FAT_DATA_FOOTER bits;
         u32 dw[16]; // dword union
      } SG_PACK FAT_DATA_FOOTER_UNION, *PFAT_DATA_FOOTER_UNION;

      SG_C_ASSERT(__sizeof__FAT_DATA_FOOTER_UNION, sizeof (FAT_DATA_FOOTER_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_DATA_FOOTER {
         union {
            struct { 
               UEXACT32 signature;
               UEXACT16 version;
               UEXACT16 total_collection_time;
               UEXACT32 total_data_written;
               UEXACT32 pre_compress_data_size;
               UEXACT32 post_compress_data_size;
               UEXACT32 rsvd0[11];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FAT_DATA_FOOTER, *PFAT_DATA_FOOTER;

      SG_C_ASSERT(__sizeof__FAT_DATA_FOOTER, sizeof (FAT_DATA_FOOTER) == 64);

   #else
      typedef struct _FAT_DATA_FOOTER {
         UEXACT32 signature;
         UEXACT16 version;
         UEXACT16 total_collection_time;
         UEXACT32 total_data_written;
         UEXACT32 pre_compress_data_size;
         UEXACT32 post_compress_data_size;
         UEXACT32 rsvd0[11];
      } SG_PACK FAT_DATA_FOOTER, *PFAT_DATA_FOOTER;

      typedef union _FAT_DATA_FOOTER_UNION {
         FAT_DATA_FOOTER bits;
         u32 dw[16]; // dword union
      } SG_PACK FAT_DATA_FOOTER_UNION, *PFAT_DATA_FOOTER_UNION;

      SG_C_ASSERT(__sizeof__FAT_DATA_FOOTER_UNION, sizeof (FAT_DATA_FOOTER_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_VQ_REGS {
         union {
            struct { 
               UEXACT32 vq_stats[5];
               UEXACT32 rsvd0[7];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK FAT_VQ_REGS, *PFAT_VQ_REGS;

      SG_C_ASSERT(__sizeof__FAT_VQ_REGS, sizeof (FAT_VQ_REGS) == 48);

   #else
      typedef struct _FAT_VQ_REGS {
         UEXACT32 vq_stats[5];
         UEXACT32 rsvd0[7];
      } SG_PACK FAT_VQ_REGS, *PFAT_VQ_REGS;

      typedef union _FAT_VQ_REGS_UNION {
         FAT_VQ_REGS bits;
         u32 dw[12]; // dword union
      } SG_PACK FAT_VQ_REGS_UNION, *PFAT_VQ_REGS_UNION;

      SG_C_ASSERT(__sizeof__FAT_VQ_REGS_UNION, sizeof (FAT_VQ_REGS_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_VQ_REGS {
         union {
            struct { 
               UEXACT32 vq_stats[5];
               UEXACT32 rsvd0[7];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK FAT_VQ_REGS, *PFAT_VQ_REGS;

      SG_C_ASSERT(__sizeof__FAT_VQ_REGS, sizeof (FAT_VQ_REGS) == 48);

   #else
      typedef struct _FAT_VQ_REGS {
         UEXACT32 vq_stats[5];
         UEXACT32 rsvd0[7];
      } SG_PACK FAT_VQ_REGS, *PFAT_VQ_REGS;

      typedef union _FAT_VQ_REGS_UNION {
         FAT_VQ_REGS bits;
         u32 dw[12]; // dword union
      } SG_PACK FAT_VQ_REGS_UNION, *PFAT_VQ_REGS_UNION;

      SG_C_ASSERT(__sizeof__FAT_VQ_REGS_UNION, sizeof (FAT_VQ_REGS_UNION) == 48);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fat_header_bmap_h__

