/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __gencommon_bmap_h__
#define __gencommon_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Starting CID number for chute (if chute is for CIDs 10-20, then this should be 10)
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_CID_CSR {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 consel_cid_start : 10;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_CID_CSR, *PTXULP_CONSEL_CID_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CID_CSR, sizeof (TXULP_CONSEL_CID_CSR) == 4);

   #else
      typedef struct _TXULP_CONSEL_CID_CSR {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 consel_cid_start : 10;               // DWORD 0
      } SG_PACK TXULP_CONSEL_CID_CSR, *PTXULP_CONSEL_CID_CSR;

      typedef union _TXULP_CONSEL_CID_CSR_UNION {
         TXULP_CONSEL_CID_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_CID_CSR_UNION, *PTXULP_CONSEL_CID_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CID_CSR_UNION, sizeof (TXULP_CONSEL_CID_CSR_UNION) == 4);
   #endif


#else
   // Starting CID number for chute (if chute is for CIDs 10-20, then this should be 10)
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_CID_CSR {
         union {
            struct { 
               u32 consel_cid_start : 10;         // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_CID_CSR, *PTXULP_CONSEL_CID_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CID_CSR, sizeof (TXULP_CONSEL_CID_CSR) == 4);

   #else
      typedef struct _TXULP_CONSEL_CID_CSR {
         u32 consel_cid_start : 10;               // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK TXULP_CONSEL_CID_CSR, *PTXULP_CONSEL_CID_CSR;

      typedef union _TXULP_CONSEL_CID_CSR_UNION {
         TXULP_CONSEL_CID_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_CID_CSR_UNION, *PTXULP_CONSEL_CID_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CID_CSR_UNION, sizeof (TXULP_CONSEL_CID_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of CTX Interface. Writing to this location clears Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _GEN_CTXIF_DEBUG {
         union {
            struct { 
               u32 requestors : 16;               // DWORD 0
               u32 write_len_inflight : 3;        // DWORD 0
               u32 write_inflight : 3;            // DWORD 0
               u32 read_inflight : 2;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 write_len_underflow : 1;       // DWORD 0
               u32 write_len_overflow : 1;        // DWORD 0
               u32 write_underflow : 1;           // DWORD 0
               u32 write_overflow : 1;            // DWORD 0
               u32 read_underflow : 1;            // DWORD 0
               u32 read_overflow : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GEN_CTXIF_DEBUG, *PGEN_CTXIF_DEBUG;

      SG_C_ASSERT(__sizeof__GEN_CTXIF_DEBUG, sizeof (GEN_CTXIF_DEBUG) == 4);

   #else
      typedef struct _GEN_CTXIF_DEBUG {
         u32 requestors : 16;                     // DWORD 0
         u32 write_len_inflight : 3;              // DWORD 0
         u32 write_inflight : 3;                  // DWORD 0
         u32 read_inflight : 2;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 write_len_underflow : 1;             // DWORD 0
         u32 write_len_overflow : 1;              // DWORD 0
         u32 write_underflow : 1;                 // DWORD 0
         u32 write_overflow : 1;                  // DWORD 0
         u32 read_underflow : 1;                  // DWORD 0
         u32 read_overflow : 1;                   // DWORD 0
      } SG_PACK GEN_CTXIF_DEBUG, *PGEN_CTXIF_DEBUG;

      typedef union _GEN_CTXIF_DEBUG_UNION {
         GEN_CTXIF_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK GEN_CTXIF_DEBUG_UNION, *PGEN_CTXIF_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__GEN_CTXIF_DEBUG_UNION, sizeof (GEN_CTXIF_DEBUG_UNION) == 4);
   #endif


#else
   // Debug of CTX Interface. Writing to this location clears Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _GEN_CTXIF_DEBUG {
         union {
            struct { 
               u32 read_overflow : 1;             // DWORD 0
               u32 read_underflow : 1;            // DWORD 0
               u32 write_overflow : 1;            // DWORD 0
               u32 write_underflow : 1;           // DWORD 0
               u32 write_len_overflow : 1;        // DWORD 0
               u32 write_len_underflow : 1;       // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 read_inflight : 2;             // DWORD 0
               u32 write_inflight : 3;            // DWORD 0
               u32 write_len_inflight : 3;        // DWORD 0
               u32 requestors : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GEN_CTXIF_DEBUG, *PGEN_CTXIF_DEBUG;

      SG_C_ASSERT(__sizeof__GEN_CTXIF_DEBUG, sizeof (GEN_CTXIF_DEBUG) == 4);

   #else
      typedef struct _GEN_CTXIF_DEBUG {
         u32 read_overflow : 1;                   // DWORD 0
         u32 read_underflow : 1;                  // DWORD 0
         u32 write_overflow : 1;                  // DWORD 0
         u32 write_underflow : 1;                 // DWORD 0
         u32 write_len_overflow : 1;              // DWORD 0
         u32 write_len_underflow : 1;             // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 read_inflight : 2;                   // DWORD 0
         u32 write_inflight : 3;                  // DWORD 0
         u32 write_len_inflight : 3;              // DWORD 0
         u32 requestors : 16;                     // DWORD 0
      } SG_PACK GEN_CTXIF_DEBUG, *PGEN_CTXIF_DEBUG;

      typedef union _GEN_CTXIF_DEBUG_UNION {
         GEN_CTXIF_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK GEN_CTXIF_DEBUG_UNION, *PGEN_CTXIF_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__GEN_CTXIF_DEBUG_UNION, sizeof (GEN_CTXIF_DEBUG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of UC Interface. Writing to this location clears Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _GEN_UCIF_DEBUG {
         union {
            struct { 
               u32 requestors : 8;                // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 vl3_numfifo : 3;               // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 vl2_numfifo : 3;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 vl1_numfifo : 3;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vl0_numfifo : 3;               // DWORD 0
               u32 vl3_underflow : 1;             // DWORD 0
               u32 vl2_underflow : 1;             // DWORD 0
               u32 vl1_underflow : 1;             // DWORD 0
               u32 vl0_underflow : 1;             // DWORD 0
               u32 vl3_overflow : 1;              // DWORD 0
               u32 vl2_overflow : 1;              // DWORD 0
               u32 vl1_overflow : 1;              // DWORD 0
               u32 vl0_overflow : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GEN_UCIF_DEBUG, *PGEN_UCIF_DEBUG;

      SG_C_ASSERT(__sizeof__GEN_UCIF_DEBUG, sizeof (GEN_UCIF_DEBUG) == 4);

   #else
      typedef struct _GEN_UCIF_DEBUG {
         u32 requestors : 8;                      // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 vl3_numfifo : 3;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 vl2_numfifo : 3;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 vl1_numfifo : 3;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vl0_numfifo : 3;                     // DWORD 0
         u32 vl3_underflow : 1;                   // DWORD 0
         u32 vl2_underflow : 1;                   // DWORD 0
         u32 vl1_underflow : 1;                   // DWORD 0
         u32 vl0_underflow : 1;                   // DWORD 0
         u32 vl3_overflow : 1;                    // DWORD 0
         u32 vl2_overflow : 1;                    // DWORD 0
         u32 vl1_overflow : 1;                    // DWORD 0
         u32 vl0_overflow : 1;                    // DWORD 0
      } SG_PACK GEN_UCIF_DEBUG, *PGEN_UCIF_DEBUG;

      typedef union _GEN_UCIF_DEBUG_UNION {
         GEN_UCIF_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK GEN_UCIF_DEBUG_UNION, *PGEN_UCIF_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__GEN_UCIF_DEBUG_UNION, sizeof (GEN_UCIF_DEBUG_UNION) == 4);
   #endif


#else
   // Debug of UC Interface. Writing to this location clears Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _GEN_UCIF_DEBUG {
         union {
            struct { 
               u32 vl0_overflow : 1;              // DWORD 0
               u32 vl1_overflow : 1;              // DWORD 0
               u32 vl2_overflow : 1;              // DWORD 0
               u32 vl3_overflow : 1;              // DWORD 0
               u32 vl0_underflow : 1;             // DWORD 0
               u32 vl1_underflow : 1;             // DWORD 0
               u32 vl2_underflow : 1;             // DWORD 0
               u32 vl3_underflow : 1;             // DWORD 0
               u32 vl0_numfifo : 3;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vl1_numfifo : 3;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 vl2_numfifo : 3;               // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 vl3_numfifo : 3;               // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 requestors : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GEN_UCIF_DEBUG, *PGEN_UCIF_DEBUG;

      SG_C_ASSERT(__sizeof__GEN_UCIF_DEBUG, sizeof (GEN_UCIF_DEBUG) == 4);

   #else
      typedef struct _GEN_UCIF_DEBUG {
         u32 vl0_overflow : 1;                    // DWORD 0
         u32 vl1_overflow : 1;                    // DWORD 0
         u32 vl2_overflow : 1;                    // DWORD 0
         u32 vl3_overflow : 1;                    // DWORD 0
         u32 vl0_underflow : 1;                   // DWORD 0
         u32 vl1_underflow : 1;                   // DWORD 0
         u32 vl2_underflow : 1;                   // DWORD 0
         u32 vl3_underflow : 1;                   // DWORD 0
         u32 vl0_numfifo : 3;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vl1_numfifo : 3;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 vl2_numfifo : 3;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 vl3_numfifo : 3;                     // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 requestors : 8;                      // DWORD 0
      } SG_PACK GEN_UCIF_DEBUG, *PGEN_UCIF_DEBUG;

      typedef union _GEN_UCIF_DEBUG_UNION {
         GEN_UCIF_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK GEN_UCIF_DEBUG_UNION, *PGEN_UCIF_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__GEN_UCIF_DEBUG_UNION, sizeof (GEN_UCIF_DEBUG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Revision ID of Build.
   #if defined(SG_BMAP_UNION)
      typedef struct _REV_ID {
         union {
            struct { 
               u32 rev_id0;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK REV_ID, *PREV_ID;

      SG_C_ASSERT(__sizeof__REV_ID, sizeof (REV_ID) == 4);

   #else
      typedef struct _REV_ID {
         u32 rev_id0;                             // DWORD 0
      } SG_PACK REV_ID, *PREV_ID;

      typedef union _REV_ID_UNION {
         REV_ID bits;
         u32 dw; // dword union
      } SG_PACK REV_ID_UNION, *PREV_ID_UNION;

      SG_C_ASSERT(__sizeof__REV_ID_UNION, sizeof (REV_ID_UNION) == 4);
   #endif


#else
   // Revision ID of Build.
   #if defined(SG_BMAP_UNION)
      typedef struct _REV_ID {
         union {
            struct { 
               u32 rev_id0;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK REV_ID, *PREV_ID;

      SG_C_ASSERT(__sizeof__REV_ID, sizeof (REV_ID) == 4);

   #else
      typedef struct _REV_ID {
         u32 rev_id0;                             // DWORD 0
      } SG_PACK REV_ID, *PREV_ID;

      typedef union _REV_ID_UNION {
         REV_ID bits;
         u32 dw; // dword union
      } SG_PACK REV_ID_UNION, *PREV_ID_UNION;

      SG_C_ASSERT(__sizeof__REV_ID_UNION, sizeof (REV_ID_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPC Debug.
   #if defined(SG_BMAP_UNION)
      typedef struct _GEN_IPC_DEBUG {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 data : 24;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GEN_IPC_DEBUG, *PGEN_IPC_DEBUG;

      SG_C_ASSERT(__sizeof__GEN_IPC_DEBUG, sizeof (GEN_IPC_DEBUG) == 4);

   #else
      typedef struct _GEN_IPC_DEBUG {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 data : 24;                           // DWORD 0
      } SG_PACK GEN_IPC_DEBUG, *PGEN_IPC_DEBUG;

      typedef union _GEN_IPC_DEBUG_UNION {
         GEN_IPC_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK GEN_IPC_DEBUG_UNION, *PGEN_IPC_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__GEN_IPC_DEBUG_UNION, sizeof (GEN_IPC_DEBUG_UNION) == 4);
   #endif


#else
   // IPC Debug.
   #if defined(SG_BMAP_UNION)
      typedef struct _GEN_IPC_DEBUG {
         union {
            struct { 
               u32 data : 24;                     // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GEN_IPC_DEBUG, *PGEN_IPC_DEBUG;

      SG_C_ASSERT(__sizeof__GEN_IPC_DEBUG, sizeof (GEN_IPC_DEBUG) == 4);

   #else
      typedef struct _GEN_IPC_DEBUG {
         u32 data : 24;                           // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK GEN_IPC_DEBUG, *PGEN_IPC_DEBUG;

      typedef union _GEN_IPC_DEBUG_UNION {
         GEN_IPC_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK GEN_IPC_DEBUG_UNION, *PGEN_IPC_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__GEN_IPC_DEBUG_UNION, sizeof (GEN_IPC_DEBUG_UNION) == 4);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __gencommon_bmap_h__

