/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_bmap_h__
#define __ioctl_common_iscsi_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"
#include "ioctl_common_iscsi_ntwk_bmap.h"
#include "ioctl_common_iscsi_discovery_bmap.h"
#include "ioctl_common_iscsi_ipsec_bmap.h"
#include "ioctl_iscsi_tgt_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_NIC_STATISTICS {
         union {
            struct { 
               UEXACT32 pdu_transmitted;
               UEXACT32 pdu_received;
               UEXACT32 byte_transmitted;
               UEXACT32 byte_received;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MIB_NIC_STATISTICS, *PMIB_NIC_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_NIC_STATISTICS, sizeof (MIB_NIC_STATISTICS) == 16);

   #else
      typedef struct _MIB_NIC_STATISTICS {
         UEXACT32 pdu_transmitted;
         UEXACT32 pdu_received;
         UEXACT32 byte_transmitted;
         UEXACT32 byte_received;
      } SG_PACK MIB_NIC_STATISTICS, *PMIB_NIC_STATISTICS;

      typedef union _MIB_NIC_STATISTICS_UNION {
         MIB_NIC_STATISTICS bits;
         u32 dw[4]; // dword union
      } SG_PACK MIB_NIC_STATISTICS_UNION, *PMIB_NIC_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_NIC_STATISTICS_UNION, sizeof (MIB_NIC_STATISTICS_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_NIC_STATISTICS {
         union {
            struct { 
               UEXACT32 pdu_transmitted;
               UEXACT32 pdu_received;
               UEXACT32 byte_transmitted;
               UEXACT32 byte_received;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MIB_NIC_STATISTICS, *PMIB_NIC_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_NIC_STATISTICS, sizeof (MIB_NIC_STATISTICS) == 16);

   #else
      typedef struct _MIB_NIC_STATISTICS {
         UEXACT32 pdu_transmitted;
         UEXACT32 pdu_received;
         UEXACT32 byte_transmitted;
         UEXACT32 byte_received;
      } SG_PACK MIB_NIC_STATISTICS, *PMIB_NIC_STATISTICS;

      typedef union _MIB_NIC_STATISTICS_UNION {
         MIB_NIC_STATISTICS bits;
         u32 dw[4]; // dword union
      } SG_PACK MIB_NIC_STATISTICS_UNION, *PMIB_NIC_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_NIC_STATISTICS_UNION, sizeof (MIB_NIC_STATISTICS_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS {
      IOCTL_HEADER header;
      MIB_NIC_STATISTICS params;
   } SG_PACK IOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS, *PIOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS;



#else
   
   typedef struct _IOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS {
      IOCTL_HEADER header;
      MIB_NIC_STATISTICS params;
   } SG_PACK IOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS, *PIOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_NODE_PORTAL_ATTRIB {
         union {
            struct { 
               UEXACT32 node_portal_id;
               UEXACT32 node_portal_status;
               UEXACT8 node_portal_role;
               UEXACT8 node_portal_protocol;
               EXACT8 node_portal_address_type;
               UEXACT8 node_port;
               UEXACT16 node_portal_tag;
               UEXACT16 rsvd0;
               IP_ADDRESS_FORMAT node_portal_address;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK MIB_NODE_PORTAL_ATTRIB, *PMIB_NODE_PORTAL_ATTRIB;

      SG_C_ASSERT(__sizeof__MIB_NODE_PORTAL_ATTRIB, sizeof (MIB_NODE_PORTAL_ATTRIB) == 40);

   #else
      typedef struct _MIB_NODE_PORTAL_ATTRIB {
         UEXACT32 node_portal_id;
         UEXACT32 node_portal_status;
         UEXACT8 node_portal_role;
         UEXACT8 node_portal_protocol;
         EXACT8 node_portal_address_type;
         UEXACT8 node_port;
         UEXACT16 node_portal_tag;
         UEXACT16 rsvd0;
         IP_ADDRESS_FORMAT node_portal_address;
      } SG_PACK MIB_NODE_PORTAL_ATTRIB, *PMIB_NODE_PORTAL_ATTRIB;

      typedef union _MIB_NODE_PORTAL_ATTRIB_UNION {
         MIB_NODE_PORTAL_ATTRIB bits;
         u32 dw[10]; // dword union
      } SG_PACK MIB_NODE_PORTAL_ATTRIB_UNION, *PMIB_NODE_PORTAL_ATTRIB_UNION;

      SG_C_ASSERT(__sizeof__MIB_NODE_PORTAL_ATTRIB_UNION, sizeof (MIB_NODE_PORTAL_ATTRIB_UNION) == 40);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_NODE_PORTAL_ATTRIB {
         union {
            struct { 
               UEXACT32 node_portal_id;
               UEXACT32 node_portal_status;
               UEXACT8 node_portal_role;
               UEXACT8 node_portal_protocol;
               EXACT8 node_portal_address_type;
               UEXACT8 node_port;
               UEXACT16 node_portal_tag;
               UEXACT16 rsvd0;
               IP_ADDRESS_FORMAT node_portal_address;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK MIB_NODE_PORTAL_ATTRIB, *PMIB_NODE_PORTAL_ATTRIB;

      SG_C_ASSERT(__sizeof__MIB_NODE_PORTAL_ATTRIB, sizeof (MIB_NODE_PORTAL_ATTRIB) == 40);

   #else
      typedef struct _MIB_NODE_PORTAL_ATTRIB {
         UEXACT32 node_portal_id;
         UEXACT32 node_portal_status;
         UEXACT8 node_portal_role;
         UEXACT8 node_portal_protocol;
         EXACT8 node_portal_address_type;
         UEXACT8 node_port;
         UEXACT16 node_portal_tag;
         UEXACT16 rsvd0;
         IP_ADDRESS_FORMAT node_portal_address;
      } SG_PACK MIB_NODE_PORTAL_ATTRIB, *PMIB_NODE_PORTAL_ATTRIB;

      typedef union _MIB_NODE_PORTAL_ATTRIB_UNION {
         MIB_NODE_PORTAL_ATTRIB bits;
         u32 dw[10]; // dword union
      } SG_PACK MIB_NODE_PORTAL_ATTRIB_UNION, *PMIB_NODE_PORTAL_ATTRIB_UNION;

      SG_C_ASSERT(__sizeof__MIB_NODE_PORTAL_ATTRIB_UNION, sizeof (MIB_NODE_PORTAL_ATTRIB_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_NODE_ATTRIB {
         union {
            struct { 
               UEXACT32 node_id;
               EXACT16 node_roles;
               EXACT16 node_portal_count;
               EXACT8 node_name[224];
               EXACT8 node_alias[224];
               EXACT8 node_transport_type[256];
               MIB_NODE_PORTAL_ATTRIB node_portal[1];
            } SG_PACK ; // unnamed struct
            u32 dw[188]; // dword union
         }; // unnamed union
      } SG_PACK MIB_NODE_ATTRIB, *PMIB_NODE_ATTRIB;

      SG_C_ASSERT(__sizeof__MIB_NODE_ATTRIB, sizeof (MIB_NODE_ATTRIB) == 752);

   #else
      typedef struct _MIB_NODE_ATTRIB {
         UEXACT32 node_id;
         EXACT16 node_roles;
         EXACT16 node_portal_count;
         EXACT8 node_name[224];
         EXACT8 node_alias[224];
         EXACT8 node_transport_type[256];
         MIB_NODE_PORTAL_ATTRIB node_portal[1];
      } SG_PACK MIB_NODE_ATTRIB, *PMIB_NODE_ATTRIB;

      typedef union _MIB_NODE_ATTRIB_UNION {
         MIB_NODE_ATTRIB bits;
         u32 dw[188]; // dword union
      } SG_PACK MIB_NODE_ATTRIB_UNION, *PMIB_NODE_ATTRIB_UNION;

      SG_C_ASSERT(__sizeof__MIB_NODE_ATTRIB_UNION, sizeof (MIB_NODE_ATTRIB_UNION) == 752);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_NODE_ATTRIB {
         union {
            struct { 
               UEXACT32 node_id;
               EXACT16 node_roles;
               EXACT16 node_portal_count;
               EXACT8 node_name[224];
               EXACT8 node_alias[224];
               EXACT8 node_transport_type[256];
               MIB_NODE_PORTAL_ATTRIB node_portal[1];
            } SG_PACK ; // unnamed struct
            u32 dw[188]; // dword union
         }; // unnamed union
      } SG_PACK MIB_NODE_ATTRIB, *PMIB_NODE_ATTRIB;

      SG_C_ASSERT(__sizeof__MIB_NODE_ATTRIB, sizeof (MIB_NODE_ATTRIB) == 752);

   #else
      typedef struct _MIB_NODE_ATTRIB {
         UEXACT32 node_id;
         EXACT16 node_roles;
         EXACT16 node_portal_count;
         EXACT8 node_name[224];
         EXACT8 node_alias[224];
         EXACT8 node_transport_type[256];
         MIB_NODE_PORTAL_ATTRIB node_portal[1];
      } SG_PACK MIB_NODE_ATTRIB, *PMIB_NODE_ATTRIB;

      typedef union _MIB_NODE_ATTRIB_UNION {
         MIB_NODE_ATTRIB bits;
         u32 dw[188]; // dword union
      } SG_PACK MIB_NODE_ATTRIB_UNION, *PMIB_NODE_ATTRIB_UNION;

      SG_C_ASSERT(__sizeof__MIB_NODE_ATTRIB_UNION, sizeof (MIB_NODE_ATTRIB_UNION) == 752);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ISCSI_NODE_ATTRIB_PARAMS {
         union {
            struct { 
               UEXACT32 node_count;
               UEXACT32 rsvd0;
               MIB_NODE_ATTRIB node_attrib[1];
            } SG_PACK ; // unnamed struct
            u32 dw[190]; // dword union
         }; // unnamed union
      } SG_PACK GET_ISCSI_NODE_ATTRIB_PARAMS, *PGET_ISCSI_NODE_ATTRIB_PARAMS;

      SG_C_ASSERT(__sizeof__GET_ISCSI_NODE_ATTRIB_PARAMS, sizeof (GET_ISCSI_NODE_ATTRIB_PARAMS) == 760);

   #else
      typedef struct _GET_ISCSI_NODE_ATTRIB_PARAMS {
         UEXACT32 node_count;
         UEXACT32 rsvd0;
         MIB_NODE_ATTRIB node_attrib[1];
      } SG_PACK GET_ISCSI_NODE_ATTRIB_PARAMS, *PGET_ISCSI_NODE_ATTRIB_PARAMS;

      typedef union _GET_ISCSI_NODE_ATTRIB_PARAMS_UNION {
         GET_ISCSI_NODE_ATTRIB_PARAMS bits;
         u32 dw[190]; // dword union
      } SG_PACK GET_ISCSI_NODE_ATTRIB_PARAMS_UNION, *PGET_ISCSI_NODE_ATTRIB_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_ISCSI_NODE_ATTRIB_PARAMS_UNION, sizeof (GET_ISCSI_NODE_ATTRIB_PARAMS_UNION) == 760);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ISCSI_NODE_ATTRIB_PARAMS {
         union {
            struct { 
               UEXACT32 node_count;
               UEXACT32 rsvd0;
               MIB_NODE_ATTRIB node_attrib[1];
            } SG_PACK ; // unnamed struct
            u32 dw[190]; // dword union
         }; // unnamed union
      } SG_PACK GET_ISCSI_NODE_ATTRIB_PARAMS, *PGET_ISCSI_NODE_ATTRIB_PARAMS;

      SG_C_ASSERT(__sizeof__GET_ISCSI_NODE_ATTRIB_PARAMS, sizeof (GET_ISCSI_NODE_ATTRIB_PARAMS) == 760);

   #else
      typedef struct _GET_ISCSI_NODE_ATTRIB_PARAMS {
         UEXACT32 node_count;
         UEXACT32 rsvd0;
         MIB_NODE_ATTRIB node_attrib[1];
      } SG_PACK GET_ISCSI_NODE_ATTRIB_PARAMS, *PGET_ISCSI_NODE_ATTRIB_PARAMS;

      typedef union _GET_ISCSI_NODE_ATTRIB_PARAMS_UNION {
         GET_ISCSI_NODE_ATTRIB_PARAMS bits;
         u32 dw[190]; // dword union
      } SG_PACK GET_ISCSI_NODE_ATTRIB_PARAMS_UNION, *PGET_ISCSI_NODE_ATTRIB_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_ISCSI_NODE_ATTRIB_PARAMS_UNION, sizeof (GET_ISCSI_NODE_ATTRIB_PARAMS_UNION) == 760);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES {
      IOCTL_HEADER header;
      GET_ISCSI_NODE_ATTRIB_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES, *PIOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES;



#else
   
   typedef struct _IOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES {
      IOCTL_HEADER header;
      GET_ISCSI_NODE_ATTRIB_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES, *PIOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Maps pages of physical memory to be used for SGLs for each command. The num_pages
   // may be larger the the pages array shown below, if a non-embedded command is used. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 page_offset;
            UEXACT32 rsvd0;
            PHYS_ADDR pages[26];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
      u32 rsvd0[1];                               // DWORDS 58 to 58
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES, *PIOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES;



#else
   // Maps pages of physical memory to be used for SGLs for each command. The num_pages
   // may be larger the the pages array shown below, if a non-embedded command is used. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 page_offset;
            UEXACT32 rsvd0;
            PHYS_ADDR pages[26];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
      u32 rsvd0[1];                               // DWORDS 58 to 58
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES, *PIOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unmaps all pages of physical memory used for SGLs. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES, *PIOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES;



#else
   // Unmaps all pages of physical memory used for SGLs. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES, *PIOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Posts out-of-order (OOO) buffers. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 final;
            PHYS_ADDR pages[27];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS, *PIOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS;



#else
   // Posts out-of-order (OOO) buffers. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 final;
            PHYS_ADDR pages[27];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS, *PIOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Removes all the posted out-of-order buffers. This should be done after all iSCSI
   // connections are destroyed. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS, *PIOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS;



#else
   // Removes all the posted out-of-order buffers. This should be done after all iSCSI
   // connections are destroyed. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS, *PIOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ADD_8BYTE_LUN_PARAMS_IN {
         union {
            struct { 
               UEXACT16 index;
               UEXACT16 rsvd0;
               UEXACT8 LUN[8];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_IN, *PADD_8BYTE_LUN_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_IN, sizeof (ADD_8BYTE_LUN_PARAMS_IN) == 12);

   #else
      typedef struct _ADD_8BYTE_LUN_PARAMS_IN {
         UEXACT16 index;
         UEXACT16 rsvd0;
         UEXACT8 LUN[8];
      } SG_PACK ADD_8BYTE_LUN_PARAMS_IN, *PADD_8BYTE_LUN_PARAMS_IN;

      typedef union _ADD_8BYTE_LUN_PARAMS_IN_UNION {
         ADD_8BYTE_LUN_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_IN_UNION, *PADD_8BYTE_LUN_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_IN_UNION, sizeof (ADD_8BYTE_LUN_PARAMS_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ADD_8BYTE_LUN_PARAMS_IN {
         union {
            struct { 
               UEXACT16 index;
               UEXACT16 rsvd0;
               UEXACT8 LUN[8];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_IN, *PADD_8BYTE_LUN_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_IN, sizeof (ADD_8BYTE_LUN_PARAMS_IN) == 12);

   #else
      typedef struct _ADD_8BYTE_LUN_PARAMS_IN {
         UEXACT16 index;
         UEXACT16 rsvd0;
         UEXACT8 LUN[8];
      } SG_PACK ADD_8BYTE_LUN_PARAMS_IN, *PADD_8BYTE_LUN_PARAMS_IN;

      typedef union _ADD_8BYTE_LUN_PARAMS_IN_UNION {
         ADD_8BYTE_LUN_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_IN_UNION, *PADD_8BYTE_LUN_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_IN_UNION, sizeof (ADD_8BYTE_LUN_PARAMS_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ADD_8BYTE_LUN_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_OUT, *PADD_8BYTE_LUN_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_OUT, sizeof (ADD_8BYTE_LUN_PARAMS_OUT) == 4);

   #else
      typedef struct _ADD_8BYTE_LUN_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK ADD_8BYTE_LUN_PARAMS_OUT, *PADD_8BYTE_LUN_PARAMS_OUT;

      typedef union _ADD_8BYTE_LUN_PARAMS_OUT_UNION {
         ADD_8BYTE_LUN_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_OUT_UNION, *PADD_8BYTE_LUN_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_OUT_UNION, sizeof (ADD_8BYTE_LUN_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ADD_8BYTE_LUN_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_OUT, *PADD_8BYTE_LUN_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_OUT, sizeof (ADD_8BYTE_LUN_PARAMS_OUT) == 4);

   #else
      typedef struct _ADD_8BYTE_LUN_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK ADD_8BYTE_LUN_PARAMS_OUT, *PADD_8BYTE_LUN_PARAMS_OUT;

      typedef union _ADD_8BYTE_LUN_PARAMS_OUT_UNION {
         ADD_8BYTE_LUN_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ADD_8BYTE_LUN_PARAMS_OUT_UNION, *PADD_8BYTE_LUN_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ADD_8BYTE_LUN_PARAMS_OUT_UNION, sizeof (ADD_8BYTE_LUN_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS {
         union {
            union { 
               ADD_8BYTE_LUN_PARAMS_IN request;
               ADD_8BYTE_LUN_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS, sizeof (IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS) == 12);

   #else
      typedef union _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS {
         ADD_8BYTE_LUN_PARAMS_IN request;
         ADD_8BYTE_LUN_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS;

      typedef union _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION {
         IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION, sizeof (IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS {
         union {
            union { 
               ADD_8BYTE_LUN_PARAMS_IN request;
               ADD_8BYTE_LUN_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS, sizeof (IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS) == 12);

   #else
      typedef union _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS {
         ADD_8BYTE_LUN_PARAMS_IN request;
         ADD_8BYTE_LUN_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS;

      typedef union _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION {
         IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION, sizeof (IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // By default, the iSCSI microcode (EP firmware) only supports single level LUNs. The
   // EP's context memory allows for upto 1024 multilevel LUN numbers to be programmed. If
   // a target LUN has an heirarchical (multi-level) LUN number, iSCSI drivers (Initiator
   // or Target) should request the ARM to populate one of the 1024 slots in context
   // memory with this 8 byte LUN number. All iSCSI WRBs for that LUN should reference the
   // slot/index number used in this IOCTL. It is the responsibility of host drivers to
   // manage the array of 1024 entries. The ARM and EP firmware make no attempt to verify
   // their allocation or usage. There is no need to 'delete' an entry. The host driver
   // should simply stop referencing an index if it is no longer used. Similarly, to reuse
   // an entry, it should overwrite any exisiting LUN information with newer data. 
   typedef struct _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN {
      IOCTL_HEADER header;
      IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN;



#else
   // By default, the iSCSI microcode (EP firmware) only supports single level LUNs. The
   // EP's context memory allows for upto 1024 multilevel LUN numbers to be programmed. If
   // a target LUN has an heirarchical (multi-level) LUN number, iSCSI drivers (Initiator
   // or Target) should request the ARM to populate one of the 1024 slots in context
   // memory with this 8 byte LUN number. All iSCSI WRBs for that LUN should reference the
   // slot/index number used in this IOCTL. It is the responsibility of host drivers to
   // manage the array of 1024 entries. The ARM and EP firmware make no attempt to verify
   // their allocation or usage. There is no need to 'delete' an entry. The host driver
   // should simply stop referencing an index if it is no longer used. Similarly, to reuse
   // an entry, it should overwrite any exisiting LUN information with newer data. 
   typedef struct _IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN {
      IOCTL_HEADER header;
      IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_IN {
         union {
            struct { 
               UEXACT32 num_bits;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_IN, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_IN, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_IN) == 4);

   #else
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_IN {
         UEXACT32 num_bits;
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_IN, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN;

      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_IN bits;
         u32 dw; // dword union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_IN {
         union {
            struct { 
               UEXACT32 num_bits;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_IN, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_IN, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_IN) == 4);

   #else
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_IN {
         UEXACT32 num_bits;
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_IN, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN;

      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_IN bits;
         u32 dw; // dword union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT) == 4);

   #else
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT;

      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT) == 4);

   #else
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT;

      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS {
         union {
            union { 
               SET_FRAGNUM_BITS_FOR_SGL_CRA_IN request;
               SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS) == 4);

   #else
      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_IN request;
         SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT response;
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS;

      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS {
         union {
            union { 
               SET_FRAGNUM_BITS_FOR_SGL_CRA_IN request;
               SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS) == 4);

   #else
      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_IN request;
         SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT response;
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS;

      typedef union _SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION {
         SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION, sizeof (SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Overrides the number of bits used for frag_num in ISCSI_SGL_CRA structure. By
   // default EP firmware uses 5 bits for frag_num. If host drivers need to support more
   // than 32 scatter gather elements per I/O, it can allocate memory for more ISCSI_SGEs
   // and set num_bits accordingly to notify the EP firmware of the increased size for the
   // SGL. Other than the default value, EP firmware currently supports 8 bits for
   // frag_num to get a total of 256 scatter gather elements for every SGL. 
   typedef struct _IOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA {
      IOCTL_HEADER header;
      SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA, *PIOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA;



#else
   // Overrides the number of bits used for frag_num in ISCSI_SGL_CRA structure. By
   // default EP firmware uses 5 bits for frag_num. If host drivers need to support more
   // than 32 scatter gather elements per I/O, it can allocate memory for more ISCSI_SGEs
   // and set num_bits accordingly to notify the EP firmware of the increased size for the
   // SGL. Other than the default value, EP firmware currently supports 8 bits for
   // frag_num to get a total of 256 scatter gather elements for every SGL. 
   typedef struct _IOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA {
      IOCTL_HEADER header;
      SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA, *PIOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMAND_TABLE {
         union {
            struct { 
               UEXACT16 icd;
               UEXACT16 cid;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMAND_TABLE, *PINVALIDATE_COMMAND_TABLE;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMAND_TABLE, sizeof (INVALIDATE_COMMAND_TABLE) == 4);

   #else
      typedef struct _INVALIDATE_COMMAND_TABLE {
         UEXACT16 icd;
         UEXACT16 cid;
      } SG_PACK INVALIDATE_COMMAND_TABLE, *PINVALIDATE_COMMAND_TABLE;

      typedef union _INVALIDATE_COMMAND_TABLE_UNION {
         INVALIDATE_COMMAND_TABLE bits;
         u32 dw; // dword union
      } SG_PACK INVALIDATE_COMMAND_TABLE_UNION, *PINVALIDATE_COMMAND_TABLE_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMAND_TABLE_UNION, sizeof (INVALIDATE_COMMAND_TABLE_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMAND_TABLE {
         union {
            struct { 
               UEXACT16 icd;
               UEXACT16 cid;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMAND_TABLE, *PINVALIDATE_COMMAND_TABLE;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMAND_TABLE, sizeof (INVALIDATE_COMMAND_TABLE) == 4);

   #else
      typedef struct _INVALIDATE_COMMAND_TABLE {
         UEXACT16 icd;
         UEXACT16 cid;
      } SG_PACK INVALIDATE_COMMAND_TABLE, *PINVALIDATE_COMMAND_TABLE;

      typedef union _INVALIDATE_COMMAND_TABLE_UNION {
         INVALIDATE_COMMAND_TABLE bits;
         u32 dw; // dword union
      } SG_PACK INVALIDATE_COMMAND_TABLE_UNION, *PINVALIDATE_COMMAND_TABLE_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMAND_TABLE_UNION, sizeof (INVALIDATE_COMMAND_TABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMANDS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 ref_handle;
               UEXACT32 icd_count;
               INVALIDATE_COMMAND_TABLE table[128];
               UEXACT16 cleanup_type;
               UEXACT16 unused;
            } SG_PACK ; // unnamed struct
            u32 dw[131]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_IN, *PINVALIDATE_COMMANDS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_IN, sizeof (INVALIDATE_COMMANDS_PARAMS_IN) == 524);

   #else
      typedef struct _INVALIDATE_COMMANDS_PARAMS_IN {
         UEXACT32 ref_handle;
         UEXACT32 icd_count;
         INVALIDATE_COMMAND_TABLE table[128];
         UEXACT16 cleanup_type;
         UEXACT16 unused;
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_IN, *PINVALIDATE_COMMANDS_PARAMS_IN;

      typedef union _INVALIDATE_COMMANDS_PARAMS_IN_UNION {
         INVALIDATE_COMMANDS_PARAMS_IN bits;
         u32 dw[131]; // dword union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_IN_UNION, *PINVALIDATE_COMMANDS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_IN_UNION, sizeof (INVALIDATE_COMMANDS_PARAMS_IN_UNION) == 524);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMANDS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 ref_handle;
               UEXACT32 icd_count;
               INVALIDATE_COMMAND_TABLE table[128];
               UEXACT16 cleanup_type;
               UEXACT16 unused;
            } SG_PACK ; // unnamed struct
            u32 dw[131]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_IN, *PINVALIDATE_COMMANDS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_IN, sizeof (INVALIDATE_COMMANDS_PARAMS_IN) == 524);

   #else
      typedef struct _INVALIDATE_COMMANDS_PARAMS_IN {
         UEXACT32 ref_handle;
         UEXACT32 icd_count;
         INVALIDATE_COMMAND_TABLE table[128];
         UEXACT16 cleanup_type;
         UEXACT16 unused;
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_IN, *PINVALIDATE_COMMANDS_PARAMS_IN;

      typedef union _INVALIDATE_COMMANDS_PARAMS_IN_UNION {
         INVALIDATE_COMMANDS_PARAMS_IN bits;
         u32 dw[131]; // dword union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_IN_UNION, *PINVALIDATE_COMMANDS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_IN_UNION, sizeof (INVALIDATE_COMMANDS_PARAMS_IN_UNION) == 524);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMANDS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 ref_handle;
               UEXACT32 icd_count;
               UEXACT32 icd_status[128];
            } SG_PACK ; // unnamed struct
            u32 dw[130]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_OUT, *PINVALIDATE_COMMANDS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_OUT, sizeof (INVALIDATE_COMMANDS_PARAMS_OUT) == 520);

   #else
      typedef struct _INVALIDATE_COMMANDS_PARAMS_OUT {
         UEXACT32 ref_handle;
         UEXACT32 icd_count;
         UEXACT32 icd_status[128];
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_OUT, *PINVALIDATE_COMMANDS_PARAMS_OUT;

      typedef union _INVALIDATE_COMMANDS_PARAMS_OUT_UNION {
         INVALIDATE_COMMANDS_PARAMS_OUT bits;
         u32 dw[130]; // dword union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_OUT_UNION, *PINVALIDATE_COMMANDS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_OUT_UNION, sizeof (INVALIDATE_COMMANDS_PARAMS_OUT_UNION) == 520);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMANDS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 ref_handle;
               UEXACT32 icd_count;
               UEXACT32 icd_status[128];
            } SG_PACK ; // unnamed struct
            u32 dw[130]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_OUT, *PINVALIDATE_COMMANDS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_OUT, sizeof (INVALIDATE_COMMANDS_PARAMS_OUT) == 520);

   #else
      typedef struct _INVALIDATE_COMMANDS_PARAMS_OUT {
         UEXACT32 ref_handle;
         UEXACT32 icd_count;
         UEXACT32 icd_status[128];
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_OUT, *PINVALIDATE_COMMANDS_PARAMS_OUT;

      typedef union _INVALIDATE_COMMANDS_PARAMS_OUT_UNION {
         INVALIDATE_COMMANDS_PARAMS_OUT bits;
         u32 dw[130]; // dword union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_OUT_UNION, *PINVALIDATE_COMMANDS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_OUT_UNION, sizeof (INVALIDATE_COMMANDS_PARAMS_OUT_UNION) == 520);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMANDS_PARAMS {
         union {
            union { 
               INVALIDATE_COMMANDS_PARAMS_IN request;
               INVALIDATE_COMMANDS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[131]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS, *PINVALIDATE_COMMANDS_PARAMS;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS, sizeof (INVALIDATE_COMMANDS_PARAMS) == 524);

   #else
      typedef union _INVALIDATE_COMMANDS_PARAMS {
         INVALIDATE_COMMANDS_PARAMS_IN request;
         INVALIDATE_COMMANDS_PARAMS_OUT response;
      } SG_PACK INVALIDATE_COMMANDS_PARAMS, *PINVALIDATE_COMMANDS_PARAMS;

      typedef union _INVALIDATE_COMMANDS_PARAMS_UNION {
         INVALIDATE_COMMANDS_PARAMS bits;
         u32 dw[131]; // dword union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_UNION, *PINVALIDATE_COMMANDS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_UNION, sizeof (INVALIDATE_COMMANDS_PARAMS_UNION) == 524);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INVALIDATE_COMMANDS_PARAMS {
         union {
            union { 
               INVALIDATE_COMMANDS_PARAMS_IN request;
               INVALIDATE_COMMANDS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[131]; // dword union
         }; // unnamed union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS, *PINVALIDATE_COMMANDS_PARAMS;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS, sizeof (INVALIDATE_COMMANDS_PARAMS) == 524);

   #else
      typedef union _INVALIDATE_COMMANDS_PARAMS {
         INVALIDATE_COMMANDS_PARAMS_IN request;
         INVALIDATE_COMMANDS_PARAMS_OUT response;
      } SG_PACK INVALIDATE_COMMANDS_PARAMS, *PINVALIDATE_COMMANDS_PARAMS;

      typedef union _INVALIDATE_COMMANDS_PARAMS_UNION {
         INVALIDATE_COMMANDS_PARAMS bits;
         u32 dw[131]; // dword union
      } SG_PACK INVALIDATE_COMMANDS_PARAMS_UNION, *PINVALIDATE_COMMANDS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__INVALIDATE_COMMANDS_PARAMS_UNION, sizeof (INVALIDATE_COMMANDS_PARAMS_UNION) == 524);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl can be used to  <ol>  - Invalidate one or more iSCSI commands.  - Request
   // the EP firmware to force a command 'free' and release an SGL-ICD. Refer to the
   // Initiator or .Target I/O flow documents for usage. </ol> 
   typedef struct _IOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS {
      IOCTL_HEADER header;
      INVALIDATE_COMMANDS_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS, *PIOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS;



#else
   // This Ioctl can be used to  <ol>  - Invalidate one or more iSCSI commands.  - Request
   // the EP firmware to force a command 'free' and release an SGL-ICD. Refer to the
   // Initiator or .Target I/O flow documents for usage. </ol> 
   typedef struct _IOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS {
      IOCTL_HEADER header;
      INVALIDATE_COMMANDS_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS, *PIOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CLEANUP_PARAMS_IN {
         union {
            struct { 
               UEXACT16 chute;
               UEXACT8 hdr_ring_id;
               UEXACT8 data_ring_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CLEANUP_PARAMS_IN, *PISCSI_CLEANUP_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_IN, sizeof (ISCSI_CLEANUP_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_CLEANUP_PARAMS_IN {
         UEXACT16 chute;
         UEXACT8 hdr_ring_id;
         UEXACT8 data_ring_id;
      } SG_PACK ISCSI_CLEANUP_PARAMS_IN, *PISCSI_CLEANUP_PARAMS_IN;

      typedef union _ISCSI_CLEANUP_PARAMS_IN_UNION {
         ISCSI_CLEANUP_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_CLEANUP_PARAMS_IN_UNION, *PISCSI_CLEANUP_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_IN_UNION, sizeof (ISCSI_CLEANUP_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CLEANUP_PARAMS_IN {
         union {
            struct { 
               UEXACT16 chute;
               UEXACT8 hdr_ring_id;
               UEXACT8 data_ring_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CLEANUP_PARAMS_IN, *PISCSI_CLEANUP_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_IN, sizeof (ISCSI_CLEANUP_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_CLEANUP_PARAMS_IN {
         UEXACT16 chute;
         UEXACT8 hdr_ring_id;
         UEXACT8 data_ring_id;
      } SG_PACK ISCSI_CLEANUP_PARAMS_IN, *PISCSI_CLEANUP_PARAMS_IN;

      typedef union _ISCSI_CLEANUP_PARAMS_IN_UNION {
         ISCSI_CLEANUP_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_CLEANUP_PARAMS_IN_UNION, *PISCSI_CLEANUP_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_IN_UNION, sizeof (ISCSI_CLEANUP_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CLEANUP_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CLEANUP_PARAMS_OUT, *PISCSI_CLEANUP_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_OUT, sizeof (ISCSI_CLEANUP_PARAMS_OUT) == 4);

   #else
      typedef struct _ISCSI_CLEANUP_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK ISCSI_CLEANUP_PARAMS_OUT, *PISCSI_CLEANUP_PARAMS_OUT;

      typedef union _ISCSI_CLEANUP_PARAMS_OUT_UNION {
         ISCSI_CLEANUP_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_CLEANUP_PARAMS_OUT_UNION, *PISCSI_CLEANUP_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_OUT_UNION, sizeof (ISCSI_CLEANUP_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CLEANUP_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CLEANUP_PARAMS_OUT, *PISCSI_CLEANUP_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_OUT, sizeof (ISCSI_CLEANUP_PARAMS_OUT) == 4);

   #else
      typedef struct _ISCSI_CLEANUP_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK ISCSI_CLEANUP_PARAMS_OUT, *PISCSI_CLEANUP_PARAMS_OUT;

      typedef union _ISCSI_CLEANUP_PARAMS_OUT_UNION {
         ISCSI_CLEANUP_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_CLEANUP_PARAMS_OUT_UNION, *PISCSI_CLEANUP_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_OUT_UNION, sizeof (ISCSI_CLEANUP_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CLEANUP_PARAMS {
         union {
            union { 
               ISCSI_CLEANUP_PARAMS_IN request;
               ISCSI_CLEANUP_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CLEANUP_PARAMS, *PISCSI_CLEANUP_PARAMS;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS, sizeof (ISCSI_CLEANUP_PARAMS) == 4);

   #else
      typedef union _ISCSI_CLEANUP_PARAMS {
         ISCSI_CLEANUP_PARAMS_IN request;
         ISCSI_CLEANUP_PARAMS_OUT response;
      } SG_PACK ISCSI_CLEANUP_PARAMS, *PISCSI_CLEANUP_PARAMS;

      typedef union _ISCSI_CLEANUP_PARAMS_UNION {
         ISCSI_CLEANUP_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_CLEANUP_PARAMS_UNION, *PISCSI_CLEANUP_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_UNION, sizeof (ISCSI_CLEANUP_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CLEANUP_PARAMS {
         union {
            union { 
               ISCSI_CLEANUP_PARAMS_IN request;
               ISCSI_CLEANUP_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CLEANUP_PARAMS, *PISCSI_CLEANUP_PARAMS;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS, sizeof (ISCSI_CLEANUP_PARAMS) == 4);

   #else
      typedef union _ISCSI_CLEANUP_PARAMS {
         ISCSI_CLEANUP_PARAMS_IN request;
         ISCSI_CLEANUP_PARAMS_OUT response;
      } SG_PACK ISCSI_CLEANUP_PARAMS, *PISCSI_CLEANUP_PARAMS;

      typedef union _ISCSI_CLEANUP_PARAMS_UNION {
         ISCSI_CLEANUP_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_CLEANUP_PARAMS_UNION, *PISCSI_CLEANUP_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CLEANUP_PARAMS_UNION, sizeof (ISCSI_CLEANUP_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl should be issued by iSCSI drivers (Initiator or Target) before an
   // unload/disable to allow the embedded processors to cleanup their data structures.
   // This process is required only when the driver is expected to be reloaded without a
   // power-cycle or reset. 
   typedef struct _IOCTL_COMMON_ISCSI_CLEANUP {
      IOCTL_HEADER header;
      ISCSI_CLEANUP_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_CLEANUP, *PIOCTL_COMMON_ISCSI_CLEANUP;



#else
   // This Ioctl should be issued by iSCSI drivers (Initiator or Target) before an
   // unload/disable to allow the embedded processors to cleanup their data structures.
   // This process is required only when the driver is expected to be reloaded without a
   // power-cycle or reset. 
   typedef struct _IOCTL_COMMON_ISCSI_CLEANUP {
      IOCTL_HEADER header;
      ISCSI_CLEANUP_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_CLEANUP, *PIOCTL_COMMON_ISCSI_CLEANUP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG {
      IOCTL_HEADER header;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG, *PIOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG;



#else
   
   typedef struct _IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG {
      IOCTL_HEADER header;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG, *PIOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _READ_EVENT_LOG_PARAMS_IN {
         union {
            struct { 
               UEXACT32 seq_number;
               UEXACT32 table_type;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK READ_EVENT_LOG_PARAMS_IN, *PREAD_EVENT_LOG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_IN, sizeof (READ_EVENT_LOG_PARAMS_IN) == 8);

   #else
      typedef struct _READ_EVENT_LOG_PARAMS_IN {
         UEXACT32 seq_number;
         UEXACT32 table_type;
      } SG_PACK READ_EVENT_LOG_PARAMS_IN, *PREAD_EVENT_LOG_PARAMS_IN;

      typedef union _READ_EVENT_LOG_PARAMS_IN_UNION {
         READ_EVENT_LOG_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK READ_EVENT_LOG_PARAMS_IN_UNION, *PREAD_EVENT_LOG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_IN_UNION, sizeof (READ_EVENT_LOG_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _READ_EVENT_LOG_PARAMS_IN {
         union {
            struct { 
               UEXACT32 seq_number;
               UEXACT32 table_type;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK READ_EVENT_LOG_PARAMS_IN, *PREAD_EVENT_LOG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_IN, sizeof (READ_EVENT_LOG_PARAMS_IN) == 8);

   #else
      typedef struct _READ_EVENT_LOG_PARAMS_IN {
         UEXACT32 seq_number;
         UEXACT32 table_type;
      } SG_PACK READ_EVENT_LOG_PARAMS_IN, *PREAD_EVENT_LOG_PARAMS_IN;

      typedef union _READ_EVENT_LOG_PARAMS_IN_UNION {
         READ_EVENT_LOG_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK READ_EVENT_LOG_PARAMS_IN_UNION, *PREAD_EVENT_LOG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_IN_UNION, sizeof (READ_EVENT_LOG_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _READ_EVENT_LOG_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 seq_number;
               UEXACT32 event_entry_count;
               EVENT_LOG event_entries[1];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK READ_EVENT_LOG_PARAMS_OUT, *PREAD_EVENT_LOG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_OUT, sizeof (READ_EVENT_LOG_PARAMS_OUT) == 72);

   #else
      typedef struct _READ_EVENT_LOG_PARAMS_OUT {
         UEXACT32 seq_number;
         UEXACT32 event_entry_count;
         EVENT_LOG event_entries[1];
      } SG_PACK READ_EVENT_LOG_PARAMS_OUT, *PREAD_EVENT_LOG_PARAMS_OUT;

      typedef union _READ_EVENT_LOG_PARAMS_OUT_UNION {
         READ_EVENT_LOG_PARAMS_OUT bits;
         u32 dw[18]; // dword union
      } SG_PACK READ_EVENT_LOG_PARAMS_OUT_UNION, *PREAD_EVENT_LOG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_OUT_UNION, sizeof (READ_EVENT_LOG_PARAMS_OUT_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _READ_EVENT_LOG_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 seq_number;
               UEXACT32 event_entry_count;
               EVENT_LOG event_entries[1];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK READ_EVENT_LOG_PARAMS_OUT, *PREAD_EVENT_LOG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_OUT, sizeof (READ_EVENT_LOG_PARAMS_OUT) == 72);

   #else
      typedef struct _READ_EVENT_LOG_PARAMS_OUT {
         UEXACT32 seq_number;
         UEXACT32 event_entry_count;
         EVENT_LOG event_entries[1];
      } SG_PACK READ_EVENT_LOG_PARAMS_OUT, *PREAD_EVENT_LOG_PARAMS_OUT;

      typedef union _READ_EVENT_LOG_PARAMS_OUT_UNION {
         READ_EVENT_LOG_PARAMS_OUT bits;
         u32 dw[18]; // dword union
      } SG_PACK READ_EVENT_LOG_PARAMS_OUT_UNION, *PREAD_EVENT_LOG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_OUT_UNION, sizeof (READ_EVENT_LOG_PARAMS_OUT_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _READ_EVENT_LOG_PARAMS {
         union {
            union { 
               READ_EVENT_LOG_PARAMS_IN request;
               READ_EVENT_LOG_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK READ_EVENT_LOG_PARAMS, *PREAD_EVENT_LOG_PARAMS;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS, sizeof (READ_EVENT_LOG_PARAMS) == 72);

   #else
      typedef union _READ_EVENT_LOG_PARAMS {
         READ_EVENT_LOG_PARAMS_IN request;
         READ_EVENT_LOG_PARAMS_OUT response;
      } SG_PACK READ_EVENT_LOG_PARAMS, *PREAD_EVENT_LOG_PARAMS;

      typedef union _READ_EVENT_LOG_PARAMS_UNION {
         READ_EVENT_LOG_PARAMS bits;
         u32 dw[18]; // dword union
      } SG_PACK READ_EVENT_LOG_PARAMS_UNION, *PREAD_EVENT_LOG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_UNION, sizeof (READ_EVENT_LOG_PARAMS_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _READ_EVENT_LOG_PARAMS {
         union {
            union { 
               READ_EVENT_LOG_PARAMS_IN request;
               READ_EVENT_LOG_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK READ_EVENT_LOG_PARAMS, *PREAD_EVENT_LOG_PARAMS;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS, sizeof (READ_EVENT_LOG_PARAMS) == 72);

   #else
      typedef union _READ_EVENT_LOG_PARAMS {
         READ_EVENT_LOG_PARAMS_IN request;
         READ_EVENT_LOG_PARAMS_OUT response;
      } SG_PACK READ_EVENT_LOG_PARAMS, *PREAD_EVENT_LOG_PARAMS;

      typedef union _READ_EVENT_LOG_PARAMS_UNION {
         READ_EVENT_LOG_PARAMS bits;
         u32 dw[18]; // dword union
      } SG_PACK READ_EVENT_LOG_PARAMS_UNION, *PREAD_EVENT_LOG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__READ_EVENT_LOG_PARAMS_UNION, sizeof (READ_EVENT_LOG_PARAMS_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each entry will be returned with a sequence number generated by the firmware. The
   // utility should supply the next sequence number from where it wants to read the next
   // log entry. If the requested sequence number is not available (may have been
   // overwritten),the firmware searches for the next sequence number available in it's
   // log buffer.The firmware then returns all entries starting from this number upto it's
   // own write index pointer. The number of events (NumEvents) can be set by the utility.
   // If it is set to zero, the firmware will return all entries that fits into 64k
   // (scatter/gather limitation). If NumEvents is non-zero, then the firmware will return
   // entries equal to NumEvents. SeqNumber starts from 1. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG {
      IOCTL_HEADER header;
      READ_EVENT_LOG_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG, *PIOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG;



#else
   // Each entry will be returned with a sequence number generated by the firmware. The
   // utility should supply the next sequence number from where it wants to read the next
   // log entry. If the requested sequence number is not available (may have been
   // overwritten),the firmware searches for the next sequence number available in it's
   // log buffer.The firmware then returns all entries starting from this number upto it's
   // own write index pointer. The number of events (NumEvents) can be set by the utility.
   // If it is set to zero, the firmware will return all entries that fits into 64k
   // (scatter/gather limitation). If NumEvents is non-zero, then the firmware will return
   // entries equal to NumEvents. SeqNumber starts from 1. 
   typedef struct _IOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG {
      IOCTL_HEADER header;
      READ_EVENT_LOG_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG, *PIOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating iSCSI WRB ring. An iSCSI WRB (transmit) ring must be at least 128
   // entries deep (corresponding to 1 page) and at most 2k entries deep (corresponding to
   // 4 pages). When the connection is offloaded, the encoded ring size in the context
   // must result in a ring fitting within the number of pages posted with this IOCTL. The
   // IOCTL may fail with the following status/additional_status codes:  -  -
   // MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the byte offset specified in
   // the additional status response is invalid.  - MGMT_STATUS_UNAUTHORIZED_REQUEST --
   // the client is not authorized to create this ring type.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this ring type is either unavailable or
   // all rings are already created. 
   typedef struct _IOCTL_COMMON_ISCSI_WRBQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_WRBQ_CREATE, *PIOCTL_COMMON_ISCSI_WRBQ_CREATE;



#else
   // IOCTL for creating iSCSI WRB ring. An iSCSI WRB (transmit) ring must be at least 128
   // entries deep (corresponding to 1 page) and at most 2k entries deep (corresponding to
   // 4 pages). When the connection is offloaded, the encoded ring size in the context
   // must result in a ring fitting within the number of pages posted with this IOCTL. The
   // IOCTL may fail with the following status/additional_status codes:  -  -
   // MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the byte offset specified in
   // the additional status response is invalid.  - MGMT_STATUS_UNAUTHORIZED_REQUEST --
   // the client is not authorized to create this ring type.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this ring type is either unavailable or
   // all rings are already created. 
   typedef struct _IOCTL_COMMON_ISCSI_WRBQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_WRBQ_CREATE, *PIOCTL_COMMON_ISCSI_WRBQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying an iSCSI WRB (transmit) ring. Use opcode
   // OPCODE_COMMON_ISCSI_WRBQ_DESTROY. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client
   // is not authorized to destroy this ring. 
   typedef struct _IOCTL_COMMON_ISCSI_WRBQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 id;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_WRBQ_DESTROY, *PIOCTL_COMMON_ISCSI_WRBQ_DESTROY;



#else
   // IOCTL for destroying an iSCSI WRB (transmit) ring. Use opcode
   // OPCODE_COMMON_ISCSI_WRBQ_DESTROY. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client
   // is not authorized to destroy this ring. 
   typedef struct _IOCTL_COMMON_ISCSI_WRBQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 id;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_WRBQ_DESTROY, *PIOCTL_COMMON_ISCSI_WRBQ_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating iSCSI default PDU ring. Use opcode
   // OPCODE_COMMON_ISCSI_DEFQ_CREATE.  An iSCSI default PDU ring must be at least 512
   // entries deep (corresponding to 1 page) and at most 4k entries deep (corresponding to
   // 8 pages). The IOCTL may fail with the following status/additional_status codes:  - 
   // - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the byte offset specified in
   // the additional status response is invalid.  - MGMT_STATUS_UNAUTHORIZED_REQUEST --
   // the client is not authorized to create this ring type.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this ring type is either unavailable or
   // all rings are already created. 
   typedef struct _IOCTL_COMMON_ISCSI_DEFQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            ISCSI_DEFAULT_PDU_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_DEFQ_CREATE, *PIOCTL_COMMON_ISCSI_DEFQ_CREATE;



#else
   // IOCTL for creating iSCSI default PDU ring. Use opcode
   // OPCODE_COMMON_ISCSI_DEFQ_CREATE.  An iSCSI default PDU ring must be at least 512
   // entries deep (corresponding to 1 page) and at most 4k entries deep (corresponding to
   // 8 pages). The IOCTL may fail with the following status/additional_status codes:  - 
   // - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the byte offset specified in
   // the additional status response is invalid.  - MGMT_STATUS_UNAUTHORIZED_REQUEST --
   // the client is not authorized to create this ring type.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- this ring type is either unavailable or
   // all rings are already created. 
   typedef struct _IOCTL_COMMON_ISCSI_DEFQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT8 ulp_num;
            UEXACT8 rsvd0;
            ISCSI_DEFAULT_PDU_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_DEFQ_CREATE, *PIOCTL_COMMON_ISCSI_DEFQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying an iSCSI default PDU ring. Use opcode
   // OPCODE_COMMON_ISCSI_DEFQ_DESTROY. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client
   // is not authorized to destroy this ring. 
   typedef struct _IOCTL_COMMON_ISCSI_DEFQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 id;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_DEFQ_DESTROY, *PIOCTL_COMMON_ISCSI_DEFQ_DESTROY;



#else
   // IOCTL for destroying an iSCSI default PDU ring. Use opcode
   // OPCODE_COMMON_ISCSI_DEFQ_DESTROY. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_UNAUTHORIZED_REQUEST -- the client
   // is not authorized to destroy this ring. 
   typedef struct _IOCTL_COMMON_ISCSI_DEFQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 id;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ISCSI_DEFQ_DESTROY, *PIOCTL_COMMON_ISCSI_DEFQ_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_IN {
         union {
            struct { 
               IP_ADDRESS_FORMAT ip_address;
               UEXACT16 tcp_port;
               UEXACT16 cid;
               UEXACT16 cq_id;
               UEXACT16 defq_id;
               PHYS_ADDR dataout_template_pa;
               UEXACT16 hdr_ring_id;
               UEXACT16 data_ring_id;
               UEXACT8 do_offload;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_IN, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_IN, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_IN) == 48);

   #else
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_IN {
         IP_ADDRESS_FORMAT ip_address;
         UEXACT16 tcp_port;
         UEXACT16 cid;
         UEXACT16 cq_id;
         UEXACT16 defq_id;
         PHYS_ADDR dataout_template_pa;
         UEXACT16 hdr_ring_id;
         UEXACT16 data_ring_id;
         UEXACT8 do_offload;
         UEXACT8 rsvd0[3];
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_IN, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN;

      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION {
         TCP_CONNECT_AND_OFFLOAD_PARAMS_IN bits;
         u32 dw[12]; // dword union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_IN {
         union {
            struct { 
               IP_ADDRESS_FORMAT ip_address;
               UEXACT16 tcp_port;
               UEXACT16 cid;
               UEXACT16 cq_id;
               UEXACT16 defq_id;
               PHYS_ADDR dataout_template_pa;
               UEXACT16 hdr_ring_id;
               UEXACT16 data_ring_id;
               UEXACT8 do_offload;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_IN, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_IN, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_IN) == 48);

   #else
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_IN {
         IP_ADDRESS_FORMAT ip_address;
         UEXACT16 tcp_port;
         UEXACT16 cid;
         UEXACT16 cq_id;
         UEXACT16 defq_id;
         PHYS_ADDR dataout_template_pa;
         UEXACT16 hdr_ring_id;
         UEXACT16 data_ring_id;
         UEXACT8 do_offload;
         UEXACT8 rsvd0[3];
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_IN, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN;

      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION {
         TCP_CONNECT_AND_OFFLOAD_PARAMS_IN bits;
         u32 dw[12]; // dword union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Returned values after a iSCSI connection and offload completes
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT) == 8);

   #else
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 rsvd0;
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT;

      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION {
         TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION) == 8);
   #endif


#else
   // Returned values after a iSCSI connection and offload completes
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 connection_handle;
               UEXACT16 cid;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT) == 8);

   #else
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT {
         UEXACT32 connection_handle;
         UEXACT16 cid;
         UEXACT16 rsvd0;
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT;

      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION {
         TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS {
         union {
            union { 
               TCP_CONNECT_AND_OFFLOAD_PARAMS_IN request;
               TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS, *PTCP_CONNECT_AND_OFFLOAD_PARAMS;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS) == 48);

   #else
      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS {
         TCP_CONNECT_AND_OFFLOAD_PARAMS_IN request;
         TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT response;
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS, *PTCP_CONNECT_AND_OFFLOAD_PARAMS;

      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION {
         TCP_CONNECT_AND_OFFLOAD_PARAMS bits;
         u32 dw[12]; // dword union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_CONNECT_AND_OFFLOAD_PARAMS {
         union {
            union { 
               TCP_CONNECT_AND_OFFLOAD_PARAMS_IN request;
               TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS, *PTCP_CONNECT_AND_OFFLOAD_PARAMS;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS) == 48);

   #else
      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS {
         TCP_CONNECT_AND_OFFLOAD_PARAMS_IN request;
         TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT response;
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS, *PTCP_CONNECT_AND_OFFLOAD_PARAMS;

      typedef union _TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION {
         TCP_CONNECT_AND_OFFLOAD_PARAMS bits;
         u32 dw[12]; // dword union
      } SG_PACK TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION, sizeof (TCP_CONNECT_AND_OFFLOAD_PARAMS_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl is used by drivers to request the ARM firmware to open a TCP connection
   // to the specified IP and tcp port number. Once the TCP connection is established, it
   // can be optionally offloaded.  Originator(s) : Driver  Implemented in: Firmware 
   // Return Values :  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED  -
   // MGMT_STATUS_INVALID_CONNECTION 
   typedef struct _IOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD {
      IOCTL_HEADER header;
      TCP_CONNECT_AND_OFFLOAD_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD, *PIOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD;



#else
   // This Ioctl is used by drivers to request the ARM firmware to open a TCP connection
   // to the specified IP and tcp port number. Once the TCP connection is established, it
   // can be optionally offloaded.  Originator(s) : Driver  Implemented in: Firmware 
   // Return Values :  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED  -
   // MGMT_STATUS_INVALID_CONNECTION 
   typedef struct _IOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD {
      IOCTL_HEADER header;
      TCP_CONNECT_AND_OFFLOAD_PARAMS params;
   } SG_PACK IOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD, *PIOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_DISCONNECT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TCP_DISCONNECT_PARAMS_IN, *PTCP_DISCONNECT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_IN, sizeof (TCP_DISCONNECT_PARAMS_IN) == 4);

   #else
      typedef struct _TCP_DISCONNECT_PARAMS_IN {
         UEXACT32 connection_handle;
      } SG_PACK TCP_DISCONNECT_PARAMS_IN, *PTCP_DISCONNECT_PARAMS_IN;

      typedef union _TCP_DISCONNECT_PARAMS_IN_UNION {
         TCP_DISCONNECT_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK TCP_DISCONNECT_PARAMS_IN_UNION, *PTCP_DISCONNECT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_IN_UNION, sizeof (TCP_DISCONNECT_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_DISCONNECT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 connection_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TCP_DISCONNECT_PARAMS_IN, *PTCP_DISCONNECT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_IN, sizeof (TCP_DISCONNECT_PARAMS_IN) == 4);

   #else
      typedef struct _TCP_DISCONNECT_PARAMS_IN {
         UEXACT32 connection_handle;
      } SG_PACK TCP_DISCONNECT_PARAMS_IN, *PTCP_DISCONNECT_PARAMS_IN;

      typedef union _TCP_DISCONNECT_PARAMS_IN_UNION {
         TCP_DISCONNECT_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK TCP_DISCONNECT_PARAMS_IN_UNION, *PTCP_DISCONNECT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_IN_UNION, sizeof (TCP_DISCONNECT_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_DISCONNECT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TCP_DISCONNECT_PARAMS_OUT, *PTCP_DISCONNECT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_OUT, sizeof (TCP_DISCONNECT_PARAMS_OUT) == 4);

   #else
      typedef struct _TCP_DISCONNECT_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK TCP_DISCONNECT_PARAMS_OUT, *PTCP_DISCONNECT_PARAMS_OUT;

      typedef union _TCP_DISCONNECT_PARAMS_OUT_UNION {
         TCP_DISCONNECT_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK TCP_DISCONNECT_PARAMS_OUT_UNION, *PTCP_DISCONNECT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_OUT_UNION, sizeof (TCP_DISCONNECT_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_DISCONNECT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TCP_DISCONNECT_PARAMS_OUT, *PTCP_DISCONNECT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_OUT, sizeof (TCP_DISCONNECT_PARAMS_OUT) == 4);

   #else
      typedef struct _TCP_DISCONNECT_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK TCP_DISCONNECT_PARAMS_OUT, *PTCP_DISCONNECT_PARAMS_OUT;

      typedef union _TCP_DISCONNECT_PARAMS_OUT_UNION {
         TCP_DISCONNECT_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK TCP_DISCONNECT_PARAMS_OUT_UNION, *PTCP_DISCONNECT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_PARAMS_OUT_UNION, sizeof (TCP_DISCONNECT_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_DISCONNECT {
         union {
            union { 
               TCP_DISCONNECT_PARAMS_IN request;
               TCP_DISCONNECT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TCP_DISCONNECT, *PTCP_DISCONNECT;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT, sizeof (TCP_DISCONNECT) == 4);

   #else
      typedef union _TCP_DISCONNECT {
         TCP_DISCONNECT_PARAMS_IN request;
         TCP_DISCONNECT_PARAMS_OUT response;
      } SG_PACK TCP_DISCONNECT, *PTCP_DISCONNECT;

      typedef union _TCP_DISCONNECT_UNION {
         TCP_DISCONNECT bits;
         u32 dw; // dword union
      } SG_PACK TCP_DISCONNECT_UNION, *PTCP_DISCONNECT_UNION;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_UNION, sizeof (TCP_DISCONNECT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_DISCONNECT {
         union {
            union { 
               TCP_DISCONNECT_PARAMS_IN request;
               TCP_DISCONNECT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TCP_DISCONNECT, *PTCP_DISCONNECT;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT, sizeof (TCP_DISCONNECT) == 4);

   #else
      typedef union _TCP_DISCONNECT {
         TCP_DISCONNECT_PARAMS_IN request;
         TCP_DISCONNECT_PARAMS_OUT response;
      } SG_PACK TCP_DISCONNECT, *PTCP_DISCONNECT;

      typedef union _TCP_DISCONNECT_UNION {
         TCP_DISCONNECT bits;
         u32 dw; // dword union
      } SG_PACK TCP_DISCONNECT_UNION, *PTCP_DISCONNECT_UNION;

      SG_C_ASSERT(__sizeof__TCP_DISCONNECT_UNION, sizeof (TCP_DISCONNECT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl is used by Drivers to request the ARM firmware to close an opened TCP
   // connection.  Originator(s) : Driver  Implemented in: Firmware  Return Values :  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED  - MGMT_STATUS_INVALID_CONNECTION 
   typedef struct _IOCTL_COMMON_ISCSI_TCP_DISCONNECT {
      IOCTL_HEADER header;
      TCP_DISCONNECT params;
   } SG_PACK IOCTL_COMMON_ISCSI_TCP_DISCONNECT, *PIOCTL_COMMON_ISCSI_TCP_DISCONNECT;



#else
   // This Ioctl is used by Drivers to request the ARM firmware to close an opened TCP
   // connection.  Originator(s) : Driver  Implemented in: Firmware  Return Values :  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED  - MGMT_STATUS_INVALID_CONNECTION 
   typedef struct _IOCTL_COMMON_ISCSI_TCP_DISCONNECT {
      IOCTL_HEADER header;
      TCP_DISCONNECT params;
   } SG_PACK IOCTL_COMMON_ISCSI_TCP_DISCONNECT, *PIOCTL_COMMON_ISCSI_TCP_DISCONNECT;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_iscsi_bmap_h__

