/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_dal_bmap_h__
#define __ioctl_dal_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_GET_PARAMETERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
            UEXACT16 vendor_id;
            UEXACT16 hw_ver;
            UEXACT16 max_qp;
            UEXACT16 max_qp_wr;
            UEXACT16 max_raw_ethy_qp;
            UEXACT16 max_sge;
            UEXACT16 max_pd;
            UEXACT16 max_cq;
            UEXACT16 max_mr;
            UEXACT16 page_size_cap;
            UEXACT32 max_mr_size;
            UEXACT32 max_mr_cacheable_size;
            UEXACT16 max_mcast_grp;
            UEXACT16 max_mcast_qp_attach;
            UEXACT16 max_total_mcast_qp_attach;
            UEXACT16 max_ah;
            UEXACT16 max_mrs_per_qp;
            UEXACT16 max_qps_per_port;
            UEXACT16 max_ports_per_group;
            UEXACT8 guid[16];
         } response;
      } params;
   } SG_PACK IOCTL_DAL_GET_PARAMETERS, *PIOCTL_DAL_GET_PARAMETERS;



#else
   
   typedef struct _IOCTL_DAL_GET_PARAMETERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
            UEXACT16 vendor_id;
            UEXACT16 hw_ver;
            UEXACT16 max_qp;
            UEXACT16 max_qp_wr;
            UEXACT16 max_raw_ethy_qp;
            UEXACT16 max_sge;
            UEXACT16 max_pd;
            UEXACT16 max_cq;
            UEXACT16 max_mr;
            UEXACT16 page_size_cap;
            UEXACT32 max_mr_size;
            UEXACT32 max_mr_cacheable_size;
            UEXACT16 max_mcast_grp;
            UEXACT16 max_mcast_qp_attach;
            UEXACT16 max_total_mcast_qp_attach;
            UEXACT16 max_ah;
            UEXACT16 max_mrs_per_qp;
            UEXACT16 max_qps_per_port;
            UEXACT16 max_ports_per_group;
            UEXACT8 guid[16];
         } response;
      } params;
   } SG_PACK IOCTL_DAL_GET_PARAMETERS, *PIOCTL_DAL_GET_PARAMETERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_DRIVER_LOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 num_te_pages;
            UEXACT32 rsvd0;
            PHYS_ADDR pe_page;
            PHYS_ADDR te_pages[64];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_DRIVER_LOAD, *PIOCTL_DAL_DRIVER_LOAD;



#else
   
   typedef struct _IOCTL_DAL_DRIVER_LOAD {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 num_te_pages;
            UEXACT32 rsvd0;
            PHYS_ADDR pe_page;
            PHYS_ADDR te_pages[64];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_DRIVER_LOAD, *PIOCTL_DAL_DRIVER_LOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_QP_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 rsvd0;
            UEXACT16 pd_num;
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_CREATE, *PIOCTL_DAL_QP_CREATE;



#else
   
   typedef struct _IOCTL_DAL_QP_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 rsvd0;
            UEXACT16 pd_num;
         } request;
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_CREATE, *PIOCTL_DAL_QP_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_QP_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_DESTROY, *PIOCTL_DAL_QP_DESTROY;



#else
   
   typedef struct _IOCTL_DAL_QP_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_DESTROY, *PIOCTL_DAL_QP_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_MR_REGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 rsvd0;
            UEXACT16 rsvd1;
            UEXACT16 page_size;
            UEXACT16 num_pages;
            UEXACT32 total_length;
            UEXACT16 pd_num;
            UEXACT16 rsvd2;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
            UEXACT32 stag;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MR_REGISTER, *PIOCTL_DAL_MR_REGISTER;



#else
   
   typedef struct _IOCTL_DAL_MR_REGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 rsvd0;
            UEXACT16 rsvd1;
            UEXACT16 page_size;
            UEXACT16 num_pages;
            UEXACT32 total_length;
            UEXACT16 pd_num;
            UEXACT16 rsvd2;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
            UEXACT32 stag;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MR_REGISTER, *PIOCTL_DAL_MR_REGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_MR_UNREGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 rsvd0;
            UEXACT16 rsvd1;
            UEXACT32 stag;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MR_UNREGISTER, *PIOCTL_DAL_MR_UNREGISTER;



#else
   
   typedef struct _IOCTL_DAL_MR_UNREGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 rsvd0;
            UEXACT16 rsvd1;
            UEXACT32 stag;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MR_UNREGISTER, *PIOCTL_DAL_MR_UNREGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_QP_MODIFY_RTS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            DAL_TX_CONTEXT daltxctx;
            UEXACT32 num_pages;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_MODIFY_RTS, *PIOCTL_DAL_QP_MODIFY_RTS;



#else
   
   typedef struct _IOCTL_DAL_QP_MODIFY_RTS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            DAL_TX_CONTEXT daltxctx;
            UEXACT32 num_pages;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_MODIFY_RTS, *PIOCTL_DAL_QP_MODIFY_RTS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_QP_MODIFY_RTR {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            DAL_RX_CONTEXT dalrxctx;
            UEXACT32 num_pages;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_MODIFY_RTR, *PIOCTL_DAL_QP_MODIFY_RTR;



#else
   
   typedef struct _IOCTL_DAL_QP_MODIFY_RTR {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 rsvd0;
            DAL_RX_CONTEXT dalrxctx;
            UEXACT32 num_pages;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_QP_MODIFY_RTR, *PIOCTL_DAL_QP_MODIFY_RTR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_MULTICAST_JOIN {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 udp_port;
            UEXACT16 rsvd0;
            UEXACT8 mac_addr[6];
            NTWK_INTERFACE_VLAN_TAG vlan_tag;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MULTICAST_JOIN, *PIOCTL_DAL_MULTICAST_JOIN;



#else
   
   typedef struct _IOCTL_DAL_MULTICAST_JOIN {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 udp_port;
            UEXACT16 rsvd0;
            UEXACT8 mac_addr[6];
            NTWK_INTERFACE_VLAN_TAG vlan_tag;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MULTICAST_JOIN, *PIOCTL_DAL_MULTICAST_JOIN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DAL_MULTICAST_LEAVE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 udp_port;
            UEXACT16 rsvd0;
            UEXACT8 mac_addr[6];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MULTICAST_LEAVE, *PIOCTL_DAL_MULTICAST_LEAVE;



#else
   
   typedef struct _IOCTL_DAL_MULTICAST_LEAVE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 cid;
            UEXACT16 udp_port;
            UEXACT16 rsvd0;
            UEXACT8 mac_addr[6];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DAL_MULTICAST_LEAVE, *PIOCTL_DAL_MULTICAST_LEAVE;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_dal_bmap_h__

