/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_diag_bmap_h__
#define __ioctl_diag_bmap_h__
#include "setypes.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_common_bmap.h"
#include "host_struct_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_DMA_RESPONSE {
         union {
            struct { 
               u32 bytes_per_write_dma;
               u32 bytes_per_read_dma;
               u32 num_write_dma;
               u32 num_read_dma;
               u32 start_stamp;
               u32 end_stamp;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_DMA_RESPONSE, *PIOCTL_DIAG_DMA_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_DMA_RESPONSE, sizeof (IOCTL_DIAG_DMA_RESPONSE) == 24);

   #else
      typedef struct _IOCTL_DIAG_DMA_RESPONSE {
         u32 bytes_per_write_dma;
         u32 bytes_per_read_dma;
         u32 num_write_dma;
         u32 num_read_dma;
         u32 start_stamp;
         u32 end_stamp;
      } SG_PACK IOCTL_DIAG_DMA_RESPONSE, *PIOCTL_DIAG_DMA_RESPONSE;

      typedef union _IOCTL_DIAG_DMA_RESPONSE_UNION {
         IOCTL_DIAG_DMA_RESPONSE bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_DIAG_DMA_RESPONSE_UNION, *PIOCTL_DIAG_DMA_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_DMA_RESPONSE_UNION, sizeof (IOCTL_DIAG_DMA_RESPONSE_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_DMA_RESPONSE {
         union {
            struct { 
               u32 bytes_per_write_dma;
               u32 bytes_per_read_dma;
               u32 num_write_dma;
               u32 num_read_dma;
               u32 start_stamp;
               u32 end_stamp;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_DMA_RESPONSE, *PIOCTL_DIAG_DMA_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_DMA_RESPONSE, sizeof (IOCTL_DIAG_DMA_RESPONSE) == 24);

   #else
      typedef struct _IOCTL_DIAG_DMA_RESPONSE {
         u32 bytes_per_write_dma;
         u32 bytes_per_read_dma;
         u32 num_write_dma;
         u32 num_read_dma;
         u32 start_stamp;
         u32 end_stamp;
      } SG_PACK IOCTL_DIAG_DMA_RESPONSE, *PIOCTL_DIAG_DMA_RESPONSE;

      typedef union _IOCTL_DIAG_DMA_RESPONSE_UNION {
         IOCTL_DIAG_DMA_RESPONSE bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_DIAG_DMA_RESPONSE_UNION, *PIOCTL_DIAG_DMA_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_DMA_RESPONSE_UNION, sizeof (IOCTL_DIAG_DMA_RESPONSE_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows running a DMA test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_DMA {
      IOCTL_HEADER header;
      union {
         struct {
            u32 dma_mode;
            u32 num_dma;
            u32 buffer_bytes;
            PHYS_ADDR pa[2];
         } request;
         IOCTL_DIAG_DMA_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_DMA, *PIOCTL_DIAG_DMA;



#else
   // This IOCTL allows running a DMA test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_DMA {
      IOCTL_HEADER header;
      union {
         struct {
            u32 dma_mode;
            u32 num_dma;
            u32 buffer_bytes;
            PHYS_ADDR pa[2];
         } request;
         IOCTL_DIAG_DMA_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_DMA, *PIOCTL_DIAG_DMA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_MDIO_RESPONSE {
         union {
            struct { 
               u32 write;
               u32 port;
               u32 reg_no;
               u32 phy_add;
               u32 data;
               u32 type;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_MDIO_RESPONSE, *PIOCTL_DIAG_MDIO_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_MDIO_RESPONSE, sizeof (IOCTL_DIAG_MDIO_RESPONSE) == 24);

   #else
      typedef struct _IOCTL_DIAG_MDIO_RESPONSE {
         u32 write;
         u32 port;
         u32 reg_no;
         u32 phy_add;
         u32 data;
         u32 type;
      } SG_PACK IOCTL_DIAG_MDIO_RESPONSE, *PIOCTL_DIAG_MDIO_RESPONSE;

      typedef union _IOCTL_DIAG_MDIO_RESPONSE_UNION {
         IOCTL_DIAG_MDIO_RESPONSE bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_DIAG_MDIO_RESPONSE_UNION, *PIOCTL_DIAG_MDIO_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_MDIO_RESPONSE_UNION, sizeof (IOCTL_DIAG_MDIO_RESPONSE_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_MDIO_RESPONSE {
         union {
            struct { 
               u32 write;
               u32 port;
               u32 reg_no;
               u32 phy_add;
               u32 data;
               u32 type;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_MDIO_RESPONSE, *PIOCTL_DIAG_MDIO_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_MDIO_RESPONSE, sizeof (IOCTL_DIAG_MDIO_RESPONSE) == 24);

   #else
      typedef struct _IOCTL_DIAG_MDIO_RESPONSE {
         u32 write;
         u32 port;
         u32 reg_no;
         u32 phy_add;
         u32 data;
         u32 type;
      } SG_PACK IOCTL_DIAG_MDIO_RESPONSE, *PIOCTL_DIAG_MDIO_RESPONSE;

      typedef union _IOCTL_DIAG_MDIO_RESPONSE_UNION {
         IOCTL_DIAG_MDIO_RESPONSE bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_DIAG_MDIO_RESPONSE_UNION, *PIOCTL_DIAG_MDIO_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_MDIO_RESPONSE_UNION, sizeof (IOCTL_DIAG_MDIO_RESPONSE_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows running a MDIO test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_MDIO {
      IOCTL_HEADER header;
      union {
         struct {
            u32 write;
            u32 port;
            u32 reg_no;
            u32 phy_add;
            u32 data;
            u32 type;
         } request;
         IOCTL_DIAG_MDIO_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_MDIO, *PIOCTL_DIAG_MDIO;



#else
   // This IOCTL allows running a MDIO test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_MDIO {
      IOCTL_HEADER header;
      union {
         struct {
            u32 write;
            u32 port;
            u32 reg_no;
            u32 phy_add;
            u32 data;
            u32 type;
         } request;
         IOCTL_DIAG_MDIO_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_MDIO, *PIOCTL_DIAG_MDIO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_NLB_RESPONSE {
         union {
            struct { 
               u32 packets_outstanding;
               u32 packets_txmit;
               u32 packets_rcvd;
               u32 rsvd0[4];
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_NLB_RESPONSE, *PIOCTL_DIAG_NLB_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_NLB_RESPONSE, sizeof (IOCTL_DIAG_NLB_RESPONSE) == 28);

   #else
      typedef struct _IOCTL_DIAG_NLB_RESPONSE {
         u32 packets_outstanding;
         u32 packets_txmit;
         u32 packets_rcvd;
         u32 rsvd0[4];
      } SG_PACK IOCTL_DIAG_NLB_RESPONSE, *PIOCTL_DIAG_NLB_RESPONSE;

      typedef union _IOCTL_DIAG_NLB_RESPONSE_UNION {
         IOCTL_DIAG_NLB_RESPONSE bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_DIAG_NLB_RESPONSE_UNION, *PIOCTL_DIAG_NLB_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_NLB_RESPONSE_UNION, sizeof (IOCTL_DIAG_NLB_RESPONSE_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_NLB_RESPONSE {
         union {
            struct { 
               u32 packets_outstanding;
               u32 packets_txmit;
               u32 packets_rcvd;
               u32 rsvd0[4];
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_NLB_RESPONSE, *PIOCTL_DIAG_NLB_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_NLB_RESPONSE, sizeof (IOCTL_DIAG_NLB_RESPONSE) == 28);

   #else
      typedef struct _IOCTL_DIAG_NLB_RESPONSE {
         u32 packets_outstanding;
         u32 packets_txmit;
         u32 packets_rcvd;
         u32 rsvd0[4];
      } SG_PACK IOCTL_DIAG_NLB_RESPONSE, *PIOCTL_DIAG_NLB_RESPONSE;

      typedef union _IOCTL_DIAG_NLB_RESPONSE_UNION {
         IOCTL_DIAG_NLB_RESPONSE bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_DIAG_NLB_RESPONSE_UNION, *PIOCTL_DIAG_NLB_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_NLB_RESPONSE_UNION, sizeof (IOCTL_DIAG_NLB_RESPONSE_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows running a Network Loop back test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_NLB {
      IOCTL_HEADER header;
      union {
         struct {
            u32 no_of_sgs;
            u32 src_port;
            u32 dst_port;
            PHYS_ADDR pa[2];
         } request;
         IOCTL_DIAG_NLB_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_NLB, *PIOCTL_DIAG_NLB;



#else
   // This IOCTL allows running a Network Loop back test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_NLB {
      IOCTL_HEADER header;
      union {
         struct {
            u32 no_of_sgs;
            u32 src_port;
            u32 dst_port;
            PHYS_ADDR pa[2];
         } request;
         IOCTL_DIAG_NLB_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_NLB, *PIOCTL_DIAG_NLB;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_ATT_RESPONSE {
         union {
            struct { 
               u32 start_stamp;
               u32 end_stamp;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_ATT_RESPONSE, *PIOCTL_DIAG_ATT_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_ATT_RESPONSE, sizeof (IOCTL_DIAG_ATT_RESPONSE) == 8);

   #else
      typedef struct _IOCTL_DIAG_ATT_RESPONSE {
         u32 start_stamp;
         u32 end_stamp;
      } SG_PACK IOCTL_DIAG_ATT_RESPONSE, *PIOCTL_DIAG_ATT_RESPONSE;

      typedef union _IOCTL_DIAG_ATT_RESPONSE_UNION {
         IOCTL_DIAG_ATT_RESPONSE bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_DIAG_ATT_RESPONSE_UNION, *PIOCTL_DIAG_ATT_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_ATT_RESPONSE_UNION, sizeof (IOCTL_DIAG_ATT_RESPONSE_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_DIAG_ATT_RESPONSE {
         union {
            struct { 
               u32 start_stamp;
               u32 end_stamp;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_DIAG_ATT_RESPONSE, *PIOCTL_DIAG_ATT_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_ATT_RESPONSE, sizeof (IOCTL_DIAG_ATT_RESPONSE) == 8);

   #else
      typedef struct _IOCTL_DIAG_ATT_RESPONSE {
         u32 start_stamp;
         u32 end_stamp;
      } SG_PACK IOCTL_DIAG_ATT_RESPONSE, *PIOCTL_DIAG_ATT_RESPONSE;

      typedef union _IOCTL_DIAG_ATT_RESPONSE_UNION {
         IOCTL_DIAG_ATT_RESPONSE bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_DIAG_ATT_RESPONSE_UNION, *PIOCTL_DIAG_ATT_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_DIAG_ATT_RESPONSE_UNION, sizeof (IOCTL_DIAG_ATT_RESPONSE_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows running a ARM timer test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_ATT {
      IOCTL_HEADER header;
      union {
         struct {
            u32 delay_time;
         } request;
         IOCTL_DIAG_ATT_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_ATT, *PIOCTL_DIAG_ATT;



#else
   // This IOCTL allows running a ARM timer test in the ARM firmware. 
   typedef struct _IOCTL_DIAG_ATT {
      IOCTL_HEADER header;
      union {
         struct {
            u32 delay_time;
         } request;
         IOCTL_DIAG_ATT_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_ATT, *PIOCTL_DIAG_ATT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_DIAG_GETMAC_RESPONSE {
      u8 macaddr[6];
   } SG_PACK IOCTL_DIAG_GETMAC_RESPONSE, *PIOCTL_DIAG_GETMAC_RESPONSE;



#else
   
   typedef struct _IOCTL_DIAG_GETMAC_RESPONSE {
      u8 macaddr[6];
   } SG_PACK IOCTL_DIAG_GETMAC_RESPONSE, *PIOCTL_DIAG_GETMAC_RESPONSE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is for getting the mac address. 
   typedef struct _IOCTL_DIAG_GETMAC {
      IOCTL_HEADER header;
      union {
         struct {
            u32 portno;
         } request;
         IOCTL_DIAG_GETMAC_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_GETMAC, *PIOCTL_DIAG_GETMAC;



#else
   // This IOCTL is for getting the mac address. 
   typedef struct _IOCTL_DIAG_GETMAC {
      IOCTL_HEADER header;
      union {
         struct {
            u32 portno;
         } request;
         IOCTL_DIAG_GETMAC_RESPONSE response;
      } params;
   } SG_PACK IOCTL_DIAG_GETMAC, *PIOCTL_DIAG_GETMAC;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is for Phy Reset. 
   typedef struct _IOCTL_DIAG_RESET_PHY {
      IOCTL_HEADER header;
      union {
         struct {
            u32 port_num;
         } request;
         struct {
            u32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DIAG_RESET_PHY, *PIOCTL_DIAG_RESET_PHY;



#else
   // This IOCTL is for Phy Reset. 
   typedef struct _IOCTL_DIAG_RESET_PHY {
      IOCTL_HEADER header;
      union {
         struct {
            u32 port_num;
         } request;
         struct {
            u32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_DIAG_RESET_PHY, *PIOCTL_DIAG_RESET_PHY;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_diag_bmap_h__

