/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_eventlog_bmap_h__
#define __ioctl_eventlog_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _EVENTLOG_ENTRY {
      UEXACT32 p1;
      UEXACT32 p2;
      UEXACT32 p3;
      UEXACT32 p4;
      UEXACT32 p5;
   } SG_PACK EVENTLOG_ENTRY, *PEVENTLOG_ENTRY;



#else
   
   typedef struct _EVENTLOG_ENTRY {
      UEXACT32 p1;
      UEXACT32 p2;
      UEXACT32 p3;
      UEXACT32 p4;
      UEXACT32 p5;
   } SG_PACK EVENTLOG_ENTRY, *PEVENTLOG_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EVENTLOG_ENTRY_UNION {
         union {
            union { 
               EVENTLOG_ENTRY event_entry;
               EXACT8 err_str[48];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK EVENTLOG_ENTRY_UNION, *PEVENTLOG_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__EVENTLOG_ENTRY_UNION, sizeof (EVENTLOG_ENTRY_UNION) == 48);

   #else
      typedef union _EVENTLOG_ENTRY_UNION {
         EVENTLOG_ENTRY event_entry;
         EXACT8 err_str[48];
      } SG_PACK EVENTLOG_ENTRY_UNION, *PEVENTLOG_ENTRY_UNION;

      typedef union _EVENTLOG_ENTRY_UNION_UNION {
         EVENTLOG_ENTRY_UNION bits;
         u32 dw[12]; // dword union
      } SG_PACK EVENTLOG_ENTRY_UNION_UNION, *PEVENTLOG_ENTRY_UNION_UNION;

      SG_C_ASSERT(__sizeof__EVENTLOG_ENTRY_UNION_UNION, sizeof (EVENTLOG_ENTRY_UNION_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EVENTLOG_ENTRY_UNION {
         union {
            union { 
               EVENTLOG_ENTRY event_entry;
               EXACT8 err_str[48];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK EVENTLOG_ENTRY_UNION, *PEVENTLOG_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__EVENTLOG_ENTRY_UNION, sizeof (EVENTLOG_ENTRY_UNION) == 48);

   #else
      typedef union _EVENTLOG_ENTRY_UNION {
         EVENTLOG_ENTRY event_entry;
         EXACT8 err_str[48];
      } SG_PACK EVENTLOG_ENTRY_UNION, *PEVENTLOG_ENTRY_UNION;

      typedef union _EVENTLOG_ENTRY_UNION_UNION {
         EVENTLOG_ENTRY_UNION bits;
         u32 dw[12]; // dword union
      } SG_PACK EVENTLOG_ENTRY_UNION_UNION, *PEVENTLOG_ENTRY_UNION_UNION;

      SG_C_ASSERT(__sizeof__EVENTLOG_ENTRY_UNION_UNION, sizeof (EVENTLOG_ENTRY_UNION_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _EVENT_LOG {
      UEXACT16 error_code;
      UEXACT16 padding1;
      UEXACT32 time_stamp;
      UEXACT32 seq_number;
      UEXACT16 severity_level;
      UEXACT16 padding2;
      EVENTLOG_ENTRY_UNION event;
   } SG_PACK EVENT_LOG, *PEVENT_LOG;



#else
   
   typedef struct _EVENT_LOG {
      UEXACT16 error_code;
      UEXACT16 padding1;
      UEXACT32 time_stamp;
      UEXACT32 seq_number;
      UEXACT16 severity_level;
      UEXACT16 padding2;
      EVENTLOG_ENTRY_UNION event;
   } SG_PACK EVENT_LOG, *PEVENT_LOG;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_eventlog_bmap_h__

