/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_extfat_bmap_h__
#define __ioctl_extfat_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _EXT_FAT_MODE {
      UEXACT8 mode;
      UEXACT8 rsvd0;
      UEXACT16 port_mask;
      UEXACT32 trace_level;
      UEXACT64 function_mask;
   } SG_PACK EXT_FAT_MODE, *PEXT_FAT_MODE;



#else
   
   typedef struct _EXT_FAT_MODE {
      UEXACT8 mode;
      UEXACT8 rsvd0;
      UEXACT16 port_mask;
      UEXACT32 trace_level;
      UEXACT64 function_mask;
   } SG_PACK EXT_FAT_MODE, *PEXT_FAT_MODE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _EXT_FAT_MODULE {
      UEXACT8 module_str[32];
      UEXACT32 module_id;
      UEXACT32 num_modes;
      EXT_FAT_MODE mode_trace_level[1];
   } SG_PACK EXT_FAT_MODULE, *PEXT_FAT_MODULE;



#else
   
   typedef struct _EXT_FAT_MODULE {
      UEXACT8 module_str[32];
      UEXACT32 module_id;
      UEXACT32 num_modes;
      EXT_FAT_MODE mode_trace_level[1];
   } SG_PACK EXT_FAT_MODULE, *PEXT_FAT_MODULE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _EXT_FAT_CONFIG_PARAMS {
      UEXACT32 max_log_entries;
      UEXACT32 log_entry_size;
      UEXACT8 logging_type;
      UEXACT8 max_logging_functions;
      UEXACT8 max_logging_ports;
      UEXACT8 rsvd0;
      UEXACT32 supported_modes;
      UEXACT32 num_modules;
      EXT_FAT_MODULE debug_module[1];
   } SG_PACK EXT_FAT_CONFIG_PARAMS, *PEXT_FAT_CONFIG_PARAMS;



#else
   
   typedef struct _EXT_FAT_CONFIG_PARAMS {
      UEXACT32 max_log_entries;
      UEXACT32 log_entry_size;
      UEXACT8 logging_type;
      UEXACT8 max_logging_functions;
      UEXACT8 max_logging_ports;
      UEXACT8 rsvd0;
      UEXACT32 supported_modes;
      UEXACT32 num_modules;
      EXT_FAT_MODULE debug_module[1];
   } SG_PACK EXT_FAT_CONFIG_PARAMS, *PEXT_FAT_CONFIG_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 parameter_type;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_IN, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_IN, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_IN {
         UEXACT32 parameter_type;
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_IN, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN;

      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION {
         GET_EXT_FAT_CAPABILITES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 parameter_type;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_IN, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_IN, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_IN {
         UEXACT32 parameter_type;
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_IN, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN;

      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION {
         GET_EXT_FAT_CAPABILITES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_OUT {
         union {
            struct { 
               EXT_FAT_CONFIG_PARAMS config;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_OUT, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_OUT, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_OUT) == 76);

   #else
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_OUT {
         EXT_FAT_CONFIG_PARAMS config;
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_OUT, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT;

      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION {
         GET_EXT_FAT_CAPABILITES_PARAMS_OUT bits;
         u32 dw[19]; // dword union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION) == 76);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_OUT {
         union {
            struct { 
               EXT_FAT_CONFIG_PARAMS config;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_OUT, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_OUT, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_OUT) == 76);

   #else
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS_OUT {
         EXT_FAT_CONFIG_PARAMS config;
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_OUT, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT;

      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION {
         GET_EXT_FAT_CAPABILITES_PARAMS_OUT bits;
         u32 dw[19]; // dword union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_OUT_UNION) == 76);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS {
         union {
            union { 
               GET_EXT_FAT_CAPABILITES_PARAMS_IN request;
               GET_EXT_FAT_CAPABILITES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS, *PGET_EXT_FAT_CAPABILITES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS) == 76);

   #else
      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS {
         GET_EXT_FAT_CAPABILITES_PARAMS_IN request;
         GET_EXT_FAT_CAPABILITES_PARAMS_OUT response;
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS, *PGET_EXT_FAT_CAPABILITES_PARAMS;

      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS_UNION {
         GET_EXT_FAT_CAPABILITES_PARAMS bits;
         u32 dw[19]; // dword union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_UNION, *PGET_EXT_FAT_CAPABILITES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_UNION, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_UNION) == 76);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_EXT_FAT_CAPABILITES_PARAMS {
         union {
            union { 
               GET_EXT_FAT_CAPABILITES_PARAMS_IN request;
               GET_EXT_FAT_CAPABILITES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS, *PGET_EXT_FAT_CAPABILITES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS) == 76);

   #else
      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS {
         GET_EXT_FAT_CAPABILITES_PARAMS_IN request;
         GET_EXT_FAT_CAPABILITES_PARAMS_OUT response;
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS, *PGET_EXT_FAT_CAPABILITES_PARAMS;

      typedef union _GET_EXT_FAT_CAPABILITES_PARAMS_UNION {
         GET_EXT_FAT_CAPABILITES_PARAMS bits;
         u32 dw[19]; // dword union
      } SG_PACK GET_EXT_FAT_CAPABILITES_PARAMS_UNION, *PGET_EXT_FAT_CAPABILITES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_EXT_FAT_CAPABILITES_PARAMS_UNION, sizeof (GET_EXT_FAT_CAPABILITES_PARAMS_UNION) == 76);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl should be issued by management software to get the current ARM Log
   // settings from the ARM firmware. Two types of parameters can retrieved  - Default
   // parameters  - Parameter set by the management software earlier using the
   // IOCTL_ARM_LOG_SET_CAP The ioctl STATUS returned is MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_GET_EXT_FAT_CAPABILITES {
      IOCTL_HEADER header;
      GET_EXT_FAT_CAPABILITES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_EXT_FAT_CAPABILITES, *PIOCTL_COMMON_GET_EXT_FAT_CAPABILITES;



#else
   // This Ioctl should be issued by management software to get the current ARM Log
   // settings from the ARM firmware. Two types of parameters can retrieved  - Default
   // parameters  - Parameter set by the management software earlier using the
   // IOCTL_ARM_LOG_SET_CAP The ioctl STATUS returned is MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_GET_EXT_FAT_CAPABILITES {
      IOCTL_HEADER header;
      GET_EXT_FAT_CAPABILITES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_EXT_FAT_CAPABILITES, *PIOCTL_COMMON_GET_EXT_FAT_CAPABILITES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_EXT_FAT_CAPABILITES_PARAMS_IN {
         union {
            struct { 
               EXT_FAT_CONFIG_PARAMS config;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_IN, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS_IN, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS_IN) == 76);

   #else
      typedef struct _SET_EXT_FAT_CAPABILITES_PARAMS_IN {
         EXT_FAT_CONFIG_PARAMS config;
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_IN, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN;

      typedef union _SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION {
         SET_EXT_FAT_CAPABILITES_PARAMS_IN bits;
         u32 dw[19]; // dword union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION) == 76);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_EXT_FAT_CAPABILITES_PARAMS_IN {
         union {
            struct { 
               EXT_FAT_CONFIG_PARAMS config;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_IN, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS_IN, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS_IN) == 76);

   #else
      typedef struct _SET_EXT_FAT_CAPABILITES_PARAMS_IN {
         EXT_FAT_CONFIG_PARAMS config;
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_IN, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN;

      typedef union _SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION {
         SET_EXT_FAT_CAPABILITES_PARAMS_IN bits;
         u32 dw[19]; // dword union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS_IN_UNION) == 76);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_EXT_FAT_CAPABILITES_PARAMS {
         union {
            union { 
               SET_EXT_FAT_CAPABILITES_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS, *PSET_EXT_FAT_CAPABILITES_PARAMS;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS) == 76);

   #else
      typedef union _SET_EXT_FAT_CAPABILITES_PARAMS {
         SET_EXT_FAT_CAPABILITES_PARAMS_IN request;
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS, *PSET_EXT_FAT_CAPABILITES_PARAMS;

      typedef union _SET_EXT_FAT_CAPABILITES_PARAMS_UNION {
         SET_EXT_FAT_CAPABILITES_PARAMS bits;
         u32 dw[19]; // dword union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_UNION, *PSET_EXT_FAT_CAPABILITES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS_UNION, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS_UNION) == 76);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_EXT_FAT_CAPABILITES_PARAMS {
         union {
            union { 
               SET_EXT_FAT_CAPABILITES_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS, *PSET_EXT_FAT_CAPABILITES_PARAMS;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS) == 76);

   #else
      typedef union _SET_EXT_FAT_CAPABILITES_PARAMS {
         SET_EXT_FAT_CAPABILITES_PARAMS_IN request;
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS, *PSET_EXT_FAT_CAPABILITES_PARAMS;

      typedef union _SET_EXT_FAT_CAPABILITES_PARAMS_UNION {
         SET_EXT_FAT_CAPABILITES_PARAMS bits;
         u32 dw[19]; // dword union
      } SG_PACK SET_EXT_FAT_CAPABILITES_PARAMS_UNION, *PSET_EXT_FAT_CAPABILITES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_EXT_FAT_CAPABILITES_PARAMS_UNION, sizeof (SET_EXT_FAT_CAPABILITES_PARAMS_UNION) == 76);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl should be issued by management software to set user defined logging
   // parameters to ARM Firmware The ioctl STATUS returned is MGMT_STATUS_SUCCESS. If ARM
   // firmware does not support a particular setting due to resource constraints or for
   // any other reason, status will be set to MGMT_STATUS_ILLEGAL_FIELD. 
   typedef struct _IOCTL_COMMON_SET_EXT_FAT_CAPABILITES {
      IOCTL_HEADER header;
      SET_EXT_FAT_CAPABILITES_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_EXT_FAT_CAPABILITES, *PIOCTL_COMMON_SET_EXT_FAT_CAPABILITES;



#else
   // This Ioctl should be issued by management software to set user defined logging
   // parameters to ARM Firmware The ioctl STATUS returned is MGMT_STATUS_SUCCESS. If ARM
   // firmware does not support a particular setting due to resource constraints or for
   // any other reason, status will be set to MGMT_STATUS_ILLEGAL_FIELD. 
   typedef struct _IOCTL_COMMON_SET_EXT_FAT_CAPABILITES {
      IOCTL_HEADER header;
      SET_EXT_FAT_CAPABILITES_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_EXT_FAT_CAPABILITES, *PIOCTL_COMMON_SET_EXT_FAT_CAPABILITES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure represents an individual ARM trace record entry. 
   typedef struct _ARM_TRACE_RECORD {
      UEXACT8 version;
      UEXACT8 phy_port;
      UEXACT16 fid;
      UEXACT32 trace_level;
      UEXACT64 module_mask;
      UEXACT32 trace_table_index;
      UEXACT32 timestamp;
      UEXACT8 str_data[16];
      UEXACT32 data[6];
   } SG_PACK ARM_TRACE_RECORD, *PARM_TRACE_RECORD;



#else
   // This structure represents an individual ARM trace record entry. 
   typedef struct _ARM_TRACE_RECORD {
      UEXACT8 version;
      UEXACT8 phy_port;
      UEXACT16 fid;
      UEXACT32 trace_level;
      UEXACT64 module_mask;
      UEXACT32 trace_table_index;
      UEXACT32 timestamp;
      UEXACT8 str_data[16];
      UEXACT32 data[6];
   } SG_PACK ARM_TRACE_RECORD, *PARM_TRACE_RECORD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 total_log_entries;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT, sizeof (ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT) == 4);

   #else
      typedef struct _ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT {
         UEXACT32 total_log_entries;
      } SG_PACK ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT;

      typedef union _ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION {
         ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION, sizeof (ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 total_log_entries;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT, sizeof (ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT) == 4);

   #else
      typedef struct _ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT {
         UEXACT32 total_log_entries;
      } SG_PACK ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT;

      typedef union _ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION {
         ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION, sizeof (ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_LOG_CREATE_SNAPSHOT_PARAMS {
         union {
            union { 
               ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_LOG_CREATE_SNAPSHOT_PARAMS, *PARM_LOG_CREATE_SNAPSHOT_PARAMS;

      SG_C_ASSERT(__sizeof__ARM_LOG_CREATE_SNAPSHOT_PARAMS, sizeof (ARM_LOG_CREATE_SNAPSHOT_PARAMS) == 4);

   #else
      typedef union _ARM_LOG_CREATE_SNAPSHOT_PARAMS {
         ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT response;
      } SG_PACK ARM_LOG_CREATE_SNAPSHOT_PARAMS, *PARM_LOG_CREATE_SNAPSHOT_PARAMS;

      typedef union _ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION {
         ARM_LOG_CREATE_SNAPSHOT_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION, *PARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION, sizeof (ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_LOG_CREATE_SNAPSHOT_PARAMS {
         union {
            union { 
               ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_LOG_CREATE_SNAPSHOT_PARAMS, *PARM_LOG_CREATE_SNAPSHOT_PARAMS;

      SG_C_ASSERT(__sizeof__ARM_LOG_CREATE_SNAPSHOT_PARAMS, sizeof (ARM_LOG_CREATE_SNAPSHOT_PARAMS) == 4);

   #else
      typedef union _ARM_LOG_CREATE_SNAPSHOT_PARAMS {
         ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT response;
      } SG_PACK ARM_LOG_CREATE_SNAPSHOT_PARAMS, *PARM_LOG_CREATE_SNAPSHOT_PARAMS;

      typedef union _ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION {
         ARM_LOG_CREATE_SNAPSHOT_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION, *PARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION, sizeof (ARM_LOG_CREATE_SNAPSHOT_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl should be issued by management software to create a new snaphot. The
   // ioctl STATUS returned is MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT {
      IOCTL_HEADER header;
      ARM_LOG_CREATE_SNAPSHOT_PARAMS params;
   } SG_PACK IOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT, *PIOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT;



#else
   // This Ioctl should be issued by management software to create a new snaphot. The
   // ioctl STATUS returned is MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT {
      IOCTL_HEADER header;
      ARM_LOG_CREATE_SNAPSHOT_PARAMS params;
   } SG_PACK IOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT, *PIOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 snapshot_mode;
               UEXACT32 start_index;
               UEXACT32 num_log_entries;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN) == 12);

   #else
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN {
         UEXACT32 snapshot_mode;
         UEXACT32 start_index;
         UEXACT32 num_log_entries;
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN;

      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 snapshot_mode;
               UEXACT32 start_index;
               UEXACT32 num_log_entries;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN) == 12);

   #else
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN {
         UEXACT32 snapshot_mode;
         UEXACT32 start_index;
         UEXACT32 num_log_entries;
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN;

      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 num_log_entries;
               ARM_TRACE_RECORD trace[1];
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT) == 68);

   #else
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT {
         UEXACT32 num_log_entries;
         ARM_TRACE_RECORD trace[1];
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT;

      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT bits;
         u32 dw[17]; // dword union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION) == 68);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 num_log_entries;
               ARM_TRACE_RECORD trace[1];
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT) == 68);

   #else
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT {
         UEXACT32 num_log_entries;
         ARM_TRACE_RECORD trace[1];
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT;

      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT bits;
         u32 dw[17]; // dword union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS {
         union {
            union { 
               EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN request;
               EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS) == 68);

   #else
      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN request;
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT response;
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS;

      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS bits;
         u32 dw[17]; // dword union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION) == 68);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS {
         union {
            union { 
               EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN request;
               EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS) == 68);

   #else
      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN request;
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT response;
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS;

      typedef union _EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION {
         EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS bits;
         u32 dw[17]; // dword union
      } SG_PACK EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION, sizeof (EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl should be issued by management software to retrieve a snapshot The ioctl
   // STATUS returned is MGMT_STATUS_SUCCESS. If there are no more records to be
   // reirieved, firmware will return MGMT_STATUS_END_OF_LOG If the start index is invalid
   // on the current snapshot, firmware will return MGMT_STATUS_ILLEGAL_FIELD If the
   // request length set in ioctl header is not sufficient to get all entries specified in
   // num_log_entries, the firmware will return MGMT_STATUS_INSIFFICIENT_BUFFER. 
   typedef struct _IOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT {
      IOCTL_HEADER header;
      EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS params;
   } SG_PACK IOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT, *PIOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT;



#else
   // This Ioctl should be issued by management software to retrieve a snapshot The ioctl
   // STATUS returned is MGMT_STATUS_SUCCESS. If there are no more records to be
   // reirieved, firmware will return MGMT_STATUS_END_OF_LOG If the start index is invalid
   // on the current snapshot, firmware will return MGMT_STATUS_ILLEGAL_FIELD If the
   // request length set in ioctl header is not sufficient to get all entries specified in
   // num_log_entries, the firmware will return MGMT_STATUS_INSIFFICIENT_BUFFER. 
   typedef struct _IOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT {
      IOCTL_HEADER header;
      EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS params;
   } SG_PACK IOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT, *PIOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_READ_STRING_TABLE_IN {
         union {
            struct { 
               UEXACT32 byte_offset;
               UEXACT32 num_bytes;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_READ_STRING_TABLE_IN, *PEXT_FAT_READ_STRING_TABLE_IN;

      SG_C_ASSERT(__sizeof__EXT_FAT_READ_STRING_TABLE_IN, sizeof (EXT_FAT_READ_STRING_TABLE_IN) == 8);

   #else
      typedef struct _EXT_FAT_READ_STRING_TABLE_IN {
         UEXACT32 byte_offset;
         UEXACT32 num_bytes;
      } SG_PACK EXT_FAT_READ_STRING_TABLE_IN, *PEXT_FAT_READ_STRING_TABLE_IN;

      typedef union _EXT_FAT_READ_STRING_TABLE_IN_UNION {
         EXT_FAT_READ_STRING_TABLE_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK EXT_FAT_READ_STRING_TABLE_IN_UNION, *PEXT_FAT_READ_STRING_TABLE_IN_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_READ_STRING_TABLE_IN_UNION, sizeof (EXT_FAT_READ_STRING_TABLE_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EXT_FAT_READ_STRING_TABLE_IN {
         union {
            struct { 
               UEXACT32 byte_offset;
               UEXACT32 num_bytes;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK EXT_FAT_READ_STRING_TABLE_IN, *PEXT_FAT_READ_STRING_TABLE_IN;

      SG_C_ASSERT(__sizeof__EXT_FAT_READ_STRING_TABLE_IN, sizeof (EXT_FAT_READ_STRING_TABLE_IN) == 8);

   #else
      typedef struct _EXT_FAT_READ_STRING_TABLE_IN {
         UEXACT32 byte_offset;
         UEXACT32 num_bytes;
      } SG_PACK EXT_FAT_READ_STRING_TABLE_IN, *PEXT_FAT_READ_STRING_TABLE_IN;

      typedef union _EXT_FAT_READ_STRING_TABLE_IN_UNION {
         EXT_FAT_READ_STRING_TABLE_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK EXT_FAT_READ_STRING_TABLE_IN_UNION, *PEXT_FAT_READ_STRING_TABLE_IN_UNION;

      SG_C_ASSERT(__sizeof__EXT_FAT_READ_STRING_TABLE_IN_UNION, sizeof (EXT_FAT_READ_STRING_TABLE_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _EXT_FAT_READ_STRING_TABLE_OUT {
      UEXACT32 num_returned_bytes;
      UEXACT32 num_remaining_bytes;
      UEXACT8 table_data[1];
   } SG_PACK EXT_FAT_READ_STRING_TABLE_OUT, *PEXT_FAT_READ_STRING_TABLE_OUT;



#else
   
   typedef struct _EXT_FAT_READ_STRING_TABLE_OUT {
      UEXACT32 num_returned_bytes;
      UEXACT32 num_remaining_bytes;
      UEXACT8 table_data[1];
   } SG_PACK EXT_FAT_READ_STRING_TABLE_OUT, *PEXT_FAT_READ_STRING_TABLE_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef union _EXT_FAT_READ_STRING_TABLE {
      EXT_FAT_READ_STRING_TABLE_IN request;
      EXT_FAT_READ_STRING_TABLE_OUT response;
   } SG_PACK EXT_FAT_READ_STRING_TABLE, *PEXT_FAT_READ_STRING_TABLE;



#else
   
   typedef union _EXT_FAT_READ_STRING_TABLE {
      EXT_FAT_READ_STRING_TABLE_IN request;
      EXT_FAT_READ_STRING_TABLE_OUT response;
   } SG_PACK EXT_FAT_READ_STRING_TABLE, *PEXT_FAT_READ_STRING_TABLE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl should be issued by management software to retrieve the string table. The
   // ioctl STATUS returned is MGMT_STATUS_SUCCESS. If there are no more data to be
   // reirieved, firmware will return MGMT_STATUS_END_OF_LOG If the byte_offset is invalid
   // on the current snapshot, firmware will return MGMT_STATUS_ILLEGAL_FIELD If the
   // request length set in ioctl header is not sufficient to get all entries specified in
   // num_log_entries, the firmware will return MGMT_STATUS_INSIFFICIENT_BUFFER. 
   typedef struct _IOCTL_COMMON_EXT_FAT_READ_STRING_TABLE {
      IOCTL_HEADER header;
      EXT_FAT_READ_STRING_TABLE params;
   } SG_PACK IOCTL_COMMON_EXT_FAT_READ_STRING_TABLE, *PIOCTL_COMMON_EXT_FAT_READ_STRING_TABLE;



#else
   // This Ioctl should be issued by management software to retrieve the string table. The
   // ioctl STATUS returned is MGMT_STATUS_SUCCESS. If there are no more data to be
   // reirieved, firmware will return MGMT_STATUS_END_OF_LOG If the byte_offset is invalid
   // on the current snapshot, firmware will return MGMT_STATUS_ILLEGAL_FIELD If the
   // request length set in ioctl header is not sufficient to get all entries specified in
   // num_log_entries, the firmware will return MGMT_STATUS_INSIFFICIENT_BUFFER. 
   typedef struct _IOCTL_COMMON_EXT_FAT_READ_STRING_TABLE {
      IOCTL_HEADER header;
      EXT_FAT_READ_STRING_TABLE params;
   } SG_PACK IOCTL_COMMON_EXT_FAT_READ_STRING_TABLE, *PIOCTL_COMMON_EXT_FAT_READ_STRING_TABLE;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_extfat_bmap_h__

