/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_ibft_bmap_h__
#define __ioctl_ibft_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IBFT_STANDARD_STRUCTURE_HEADER {
      UEXACT8 structure_id;
      UEXACT8 version;
      UEXACT16 length;
      UEXACT8 index;
      UEXACT8 flags;
   } SG_PACK IBFT_STANDARD_STRUCTURE_HEADER, *PIBFT_STANDARD_STRUCTURE_HEADER;



#else
   
   typedef struct _IBFT_STANDARD_STRUCTURE_HEADER {
      UEXACT8 structure_id;
      UEXACT8 version;
      UEXACT16 length;
      UEXACT8 index;
      UEXACT8 flags;
   } SG_PACK IBFT_STANDARD_STRUCTURE_HEADER, *PIBFT_STANDARD_STRUCTURE_HEADER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IBFT_TABLE_HEADER {
         union {
            struct { 
               EXACT8 signature[4];
               UEXACT32 length;
               UEXACT8 revision;
               UEXACT8 checksum;
               EXACT8 oem_id[6];
               EXACT8 oem_table_id[8];
               UEXACT8 rsvd0[24];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK IBFT_TABLE_HEADER, *PIBFT_TABLE_HEADER;

      SG_C_ASSERT(__sizeof__IBFT_TABLE_HEADER, sizeof (IBFT_TABLE_HEADER) == 48);

   #else
      typedef struct _IBFT_TABLE_HEADER {
         EXACT8 signature[4];
         UEXACT32 length;
         UEXACT8 revision;
         UEXACT8 checksum;
         EXACT8 oem_id[6];
         EXACT8 oem_table_id[8];
         UEXACT8 rsvd0[24];
      } SG_PACK IBFT_TABLE_HEADER, *PIBFT_TABLE_HEADER;

      typedef union _IBFT_TABLE_HEADER_UNION {
         IBFT_TABLE_HEADER bits;
         u32 dw[12]; // dword union
      } SG_PACK IBFT_TABLE_HEADER_UNION, *PIBFT_TABLE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IBFT_TABLE_HEADER_UNION, sizeof (IBFT_TABLE_HEADER_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IBFT_TABLE_HEADER {
         union {
            struct { 
               EXACT8 signature[4];
               UEXACT32 length;
               UEXACT8 revision;
               UEXACT8 checksum;
               EXACT8 oem_id[6];
               EXACT8 oem_table_id[8];
               UEXACT8 rsvd0[24];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK IBFT_TABLE_HEADER, *PIBFT_TABLE_HEADER;

      SG_C_ASSERT(__sizeof__IBFT_TABLE_HEADER, sizeof (IBFT_TABLE_HEADER) == 48);

   #else
      typedef struct _IBFT_TABLE_HEADER {
         EXACT8 signature[4];
         UEXACT32 length;
         UEXACT8 revision;
         UEXACT8 checksum;
         EXACT8 oem_id[6];
         EXACT8 oem_table_id[8];
         UEXACT8 rsvd0[24];
      } SG_PACK IBFT_TABLE_HEADER, *PIBFT_TABLE_HEADER;

      typedef union _IBFT_TABLE_HEADER_UNION {
         IBFT_TABLE_HEADER bits;
         u32 dw[12]; // dword union
      } SG_PACK IBFT_TABLE_HEADER_UNION, *PIBFT_TABLE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IBFT_TABLE_HEADER_UNION, sizeof (IBFT_TABLE_HEADER_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IBFT_CONTROL_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT16 extensions;
      UEXACT16 initiator_offset;
      UEXACT16 nic0_offset;
      UEXACT16 target0_offset;
      UEXACT16 nic1_offset;
      UEXACT16 target1_offset;
   } SG_PACK IBFT_CONTROL_STRUCTURE, *PIBFT_CONTROL_STRUCTURE;



#else
   
   typedef struct _IBFT_CONTROL_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT16 extensions;
      UEXACT16 initiator_offset;
      UEXACT16 nic0_offset;
      UEXACT16 target0_offset;
      UEXACT16 nic1_offset;
      UEXACT16 target1_offset;
   } SG_PACK IBFT_CONTROL_STRUCTURE, *PIBFT_CONTROL_STRUCTURE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IBFT_INITIATOR_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT8 isns_server[16];
      UEXACT8 slp_server[16];
      UEXACT8 pri_radius_server[16];
      UEXACT8 sec_radius_server[16];
      UEXACT16 initiator_name_length;
      UEXACT16 initiator_name_offset;
   } SG_PACK IBFT_INITIATOR_STRUCTURE, *PIBFT_INITIATOR_STRUCTURE;



#else
   
   typedef struct _IBFT_INITIATOR_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT8 isns_server[16];
      UEXACT8 slp_server[16];
      UEXACT8 pri_radius_server[16];
      UEXACT8 sec_radius_server[16];
      UEXACT16 initiator_name_length;
      UEXACT16 initiator_name_offset;
   } SG_PACK IBFT_INITIATOR_STRUCTURE, *PIBFT_INITIATOR_STRUCTURE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IBFT_NIC_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT8 ip_address[16];
      UEXACT8 subnet_mask_prefix;
      UEXACT8 origin;
      UEXACT8 gateway_addreess[16];
      UEXACT8 pri_dns_address[16];
      UEXACT8 sec_dns_address[16];
      UEXACT8 dhcp_ip_address[16];
      UEXACT16 vlan_id;
      UEXACT8 mac_address[6];
      UEXACT16 pci_bdf;
      UEXACT16 host_name_length;
      UEXACT16 host_name_offset;
   } SG_PACK IBFT_NIC_STRUCTURE, *PIBFT_NIC_STRUCTURE;



#else
   
   typedef struct _IBFT_NIC_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT8 ip_address[16];
      UEXACT8 subnet_mask_prefix;
      UEXACT8 origin;
      UEXACT8 gateway_addreess[16];
      UEXACT8 pri_dns_address[16];
      UEXACT8 sec_dns_address[16];
      UEXACT8 dhcp_ip_address[16];
      UEXACT16 vlan_id;
      UEXACT8 mac_address[6];
      UEXACT16 pci_bdf;
      UEXACT16 host_name_length;
      UEXACT16 host_name_offset;
   } SG_PACK IBFT_NIC_STRUCTURE, *PIBFT_NIC_STRUCTURE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IBFT_TARGET_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT8 ip_address[16];
      UEXACT16 portnum;
      UEXACT8 boot_lun[8];
      UEXACT8 chap_method;
      UEXACT8 nic_assosiation;
      UEXACT16 target_name_length;
      UEXACT16 target_name_offset;
      UEXACT16 chap_name_length;
      UEXACT16 chap_name_offset;
      UEXACT16 chap_secret_length;
      UEXACT16 chap_secret_offset;
      UEXACT16 rchap_name_length;
      UEXACT16 rchap_name_offset;
      UEXACT16 rchap_secret_length;
      UEXACT16 rchap_secret_offset;
   } SG_PACK IBFT_TARGET_STRUCTURE, *PIBFT_TARGET_STRUCTURE;



#else
   
   typedef struct _IBFT_TARGET_STRUCTURE {
      IBFT_STANDARD_STRUCTURE_HEADER header;
      UEXACT8 ip_address[16];
      UEXACT16 portnum;
      UEXACT8 boot_lun[8];
      UEXACT8 chap_method;
      UEXACT8 nic_assosiation;
      UEXACT16 target_name_length;
      UEXACT16 target_name_offset;
      UEXACT16 chap_name_length;
      UEXACT16 chap_name_offset;
      UEXACT16 chap_secret_length;
      UEXACT16 chap_secret_offset;
      UEXACT16 rchap_name_length;
      UEXACT16 rchap_name_offset;
      UEXACT16 rchap_secret_length;
      UEXACT16 rchap_secret_offset;
   } SG_PACK IBFT_TARGET_STRUCTURE, *PIBFT_TARGET_STRUCTURE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IBFT_HEAP {
         union {
            struct { 
               EXACT8 initiator_name[256];
               EXACT8 target_name[256];
               EXACT8 chap_name[256];
               EXACT8 chap_secret[256];
               EXACT8 rchap_name[256];
               EXACT8 rchap_secret[256];
               EXACT8 host_name[256];
            } SG_PACK ; // unnamed struct
            u32 dw[448]; // dword union
         }; // unnamed union
      } SG_PACK IBFT_HEAP, *PIBFT_HEAP;

      SG_C_ASSERT(__sizeof__IBFT_HEAP, sizeof (IBFT_HEAP) == 1792);

   #else
      typedef struct _IBFT_HEAP {
         EXACT8 initiator_name[256];
         EXACT8 target_name[256];
         EXACT8 chap_name[256];
         EXACT8 chap_secret[256];
         EXACT8 rchap_name[256];
         EXACT8 rchap_secret[256];
         EXACT8 host_name[256];
      } SG_PACK IBFT_HEAP, *PIBFT_HEAP;

      typedef union _IBFT_HEAP_UNION {
         IBFT_HEAP bits;
         u32 dw[448]; // dword union
      } SG_PACK IBFT_HEAP_UNION, *PIBFT_HEAP_UNION;

      SG_C_ASSERT(__sizeof__IBFT_HEAP_UNION, sizeof (IBFT_HEAP_UNION) == 1792);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IBFT_HEAP {
         union {
            struct { 
               EXACT8 initiator_name[256];
               EXACT8 target_name[256];
               EXACT8 chap_name[256];
               EXACT8 chap_secret[256];
               EXACT8 rchap_name[256];
               EXACT8 rchap_secret[256];
               EXACT8 host_name[256];
            } SG_PACK ; // unnamed struct
            u32 dw[448]; // dword union
         }; // unnamed union
      } SG_PACK IBFT_HEAP, *PIBFT_HEAP;

      SG_C_ASSERT(__sizeof__IBFT_HEAP, sizeof (IBFT_HEAP) == 1792);

   #else
      typedef struct _IBFT_HEAP {
         EXACT8 initiator_name[256];
         EXACT8 target_name[256];
         EXACT8 chap_name[256];
         EXACT8 chap_secret[256];
         EXACT8 rchap_name[256];
         EXACT8 rchap_secret[256];
         EXACT8 host_name[256];
      } SG_PACK IBFT_HEAP, *PIBFT_HEAP;

      typedef union _IBFT_HEAP_UNION {
         IBFT_HEAP bits;
         u32 dw[448]; // dword union
      } SG_PACK IBFT_HEAP_UNION, *PIBFT_HEAP_UNION;

      SG_C_ASSERT(__sizeof__IBFT_HEAP_UNION, sizeof (IBFT_HEAP_UNION) == 1792);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IBFT_TABLE {
         union {
            struct { 
               IBFT_TABLE_HEADER header;
               IBFT_CONTROL_STRUCTURE control;
               IBFT_INITIATOR_STRUCTURE initiator;
               IBFT_NIC_STRUCTURE nic;
               IBFT_TARGET_STRUCTURE target;
               IBFT_HEAP heap;
            } SG_PACK ; // unnamed struct
            u32 dw[522]; // dword union
         }; // unnamed union
      } SG_PACK IBFT_TABLE, *PIBFT_TABLE;

      SG_C_ASSERT(__sizeof__IBFT_TABLE, sizeof (IBFT_TABLE) == 2088);

   #else
      typedef struct _IBFT_TABLE {
         IBFT_TABLE_HEADER header;
         IBFT_CONTROL_STRUCTURE control;
         IBFT_INITIATOR_STRUCTURE initiator;
         IBFT_NIC_STRUCTURE nic;
         IBFT_TARGET_STRUCTURE target;
         IBFT_HEAP heap;
      } SG_PACK IBFT_TABLE, *PIBFT_TABLE;

      typedef union _IBFT_TABLE_UNION {
         IBFT_TABLE bits;
         u32 dw[522]; // dword union
      } SG_PACK IBFT_TABLE_UNION, *PIBFT_TABLE_UNION;

      SG_C_ASSERT(__sizeof__IBFT_TABLE_UNION, sizeof (IBFT_TABLE_UNION) == 2088);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IBFT_TABLE {
         union {
            struct { 
               IBFT_TABLE_HEADER header;
               IBFT_CONTROL_STRUCTURE control;
               IBFT_INITIATOR_STRUCTURE initiator;
               IBFT_NIC_STRUCTURE nic;
               IBFT_TARGET_STRUCTURE target;
               IBFT_HEAP heap;
            } SG_PACK ; // unnamed struct
            u32 dw[522]; // dword union
         }; // unnamed union
      } SG_PACK IBFT_TABLE, *PIBFT_TABLE;

      SG_C_ASSERT(__sizeof__IBFT_TABLE, sizeof (IBFT_TABLE) == 2088);

   #else
      typedef struct _IBFT_TABLE {
         IBFT_TABLE_HEADER header;
         IBFT_CONTROL_STRUCTURE control;
         IBFT_INITIATOR_STRUCTURE initiator;
         IBFT_NIC_STRUCTURE nic;
         IBFT_TARGET_STRUCTURE target;
         IBFT_HEAP heap;
      } SG_PACK IBFT_TABLE, *PIBFT_TABLE;

      typedef union _IBFT_TABLE_UNION {
         IBFT_TABLE bits;
         u32 dw[522]; // dword union
      } SG_PACK IBFT_TABLE_UNION, *PIBFT_TABLE_UNION;

      SG_C_ASSERT(__sizeof__IBFT_TABLE_UNION, sizeof (IBFT_TABLE_UNION) == 2088);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_ibft_bmap_h__

