/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mili_tmd_bmap_h__
#define __ioctl_mili_tmd_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_ADD_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 target_name[224];
               UEXACT8 target_alias[224];
               UEXACT8 auth_method_type;
               UEXACT8 pad[3];
               MGMT_CHAP_NAME_SECRET target_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[183]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_ADD_TARGET_IN, *PIOCTL_MILI_TMD_ADD_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_TARGET_IN, sizeof (IOCTL_MILI_TMD_ADD_TARGET_IN) == 732);

   #else
      typedef struct _IOCTL_MILI_TMD_ADD_TARGET_IN {
         UEXACT32 target_key;
         UEXACT8 target_name[224];
         UEXACT8 target_alias[224];
         UEXACT8 auth_method_type;
         UEXACT8 pad[3];
         MGMT_CHAP_NAME_SECRET target_chap;
      } SG_PACK IOCTL_MILI_TMD_ADD_TARGET_IN, *PIOCTL_MILI_TMD_ADD_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_ADD_TARGET_IN_UNION {
         IOCTL_MILI_TMD_ADD_TARGET_IN bits;
         u32 dw[183]; // dword union
      } SG_PACK IOCTL_MILI_TMD_ADD_TARGET_IN_UNION, *PIOCTL_MILI_TMD_ADD_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_ADD_TARGET_IN_UNION) == 732);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_ADD_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 target_name[224];
               UEXACT8 target_alias[224];
               UEXACT8 auth_method_type;
               UEXACT8 pad[3];
               MGMT_CHAP_NAME_SECRET target_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[183]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_ADD_TARGET_IN, *PIOCTL_MILI_TMD_ADD_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_TARGET_IN, sizeof (IOCTL_MILI_TMD_ADD_TARGET_IN) == 732);

   #else
      typedef struct _IOCTL_MILI_TMD_ADD_TARGET_IN {
         UEXACT32 target_key;
         UEXACT8 target_name[224];
         UEXACT8 target_alias[224];
         UEXACT8 auth_method_type;
         UEXACT8 pad[3];
         MGMT_CHAP_NAME_SECRET target_chap;
      } SG_PACK IOCTL_MILI_TMD_ADD_TARGET_IN, *PIOCTL_MILI_TMD_ADD_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_ADD_TARGET_IN_UNION {
         IOCTL_MILI_TMD_ADD_TARGET_IN bits;
         u32 dw[183]; // dword union
      } SG_PACK IOCTL_MILI_TMD_ADD_TARGET_IN_UNION, *PIOCTL_MILI_TMD_ADD_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_ADD_TARGET_IN_UNION) == 732);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Add Target instance with specified iSCSI name and alias. This IOCTL returns one of
   // the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED This IOCTL returns one of the following additional status values
   // in the response NOTE: these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_TMD_ADD_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_ADD_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_ADD_TARGET, *PIOCTL_MILI_TMD_ADD_TARGET;



#else
   // Add Target instance with specified iSCSI name and alias. This IOCTL returns one of
   // the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED This IOCTL returns one of the following additional status values
   // in the response NOTE: these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_TMD_ADD_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_ADD_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_ADD_TARGET, *PIOCTL_MILI_TMD_ADD_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DELETE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 target_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[57]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET_IN, *PIOCTL_MILI_TMD_DELETE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_TARGET_IN, sizeof (IOCTL_MILI_TMD_DELETE_TARGET_IN) == 228);

   #else
      typedef struct _IOCTL_MILI_TMD_DELETE_TARGET_IN {
         UEXACT32 target_key;
         UEXACT8 target_name[224];
      } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET_IN, *PIOCTL_MILI_TMD_DELETE_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION {
         IOCTL_MILI_TMD_DELETE_TARGET_IN bits;
         u32 dw[57]; // dword union
      } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION, *PIOCTL_MILI_TMD_DELETE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION) == 228);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DELETE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 target_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[57]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET_IN, *PIOCTL_MILI_TMD_DELETE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_TARGET_IN, sizeof (IOCTL_MILI_TMD_DELETE_TARGET_IN) == 228);

   #else
      typedef struct _IOCTL_MILI_TMD_DELETE_TARGET_IN {
         UEXACT32 target_key;
         UEXACT8 target_name[224];
      } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET_IN, *PIOCTL_MILI_TMD_DELETE_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION {
         IOCTL_MILI_TMD_DELETE_TARGET_IN bits;
         u32 dw[57]; // dword union
      } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION, *PIOCTL_MILI_TMD_DELETE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_DELETE_TARGET_IN_UNION) == 228);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Removes an iSCSI target instance. MILI should make sure that target is not bound to
   // initiators or LUN maps. This IOCTL returns one of the following status values in the
   // response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the
   // following additional status values in the response NOTE: these additional status
   // codes are based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DELETE_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DELETE_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET, *PIOCTL_MILI_TMD_DELETE_TARGET;



#else
   // Removes an iSCSI target instance. MILI should make sure that target is not bound to
   // initiators or LUN maps. This IOCTL returns one of the following status values in the
   // response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the
   // following additional status values in the response NOTE: these additional status
   // codes are based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DELETE_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DELETE_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_DELETE_TARGET, *PIOCTL_MILI_TMD_DELETE_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 auth_method_type;
               UEXACT8 pad[3];
               MGMT_CHAP_NAME_SECRET target_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[71]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN, sizeof (IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN) == 284);

   #else
      typedef struct _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN {
         UEXACT32 target_key;
         UEXACT8 auth_method_type;
         UEXACT8 pad[3];
         MGMT_CHAP_NAME_SECRET target_chap;
      } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN;

      typedef union _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION {
         IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN bits;
         u32 dw[71]; // dword union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION, sizeof (IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION) == 284);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 auth_method_type;
               UEXACT8 pad[3];
               MGMT_CHAP_NAME_SECRET target_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[71]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN, sizeof (IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN) == 284);

   #else
      typedef struct _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN {
         UEXACT32 target_key;
         UEXACT8 auth_method_type;
         UEXACT8 pad[3];
         MGMT_CHAP_NAME_SECRET target_chap;
      } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN;

      typedef union _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION {
         IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN bits;
         u32 dw[71]; // dword union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION, sizeof (IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN_UNION) == 284);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Update the authentication parameters for a Target. This IOCTL returns one of the
   // following status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED
   // This IOCTL returns one of the following additional status values in the response
   // NOTE: these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS;



#else
   // Update the authentication parameters for a Target. This IOCTL returns one of the
   // following status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED
   // This IOCTL returns one of the following additional status values in the response
   // NOTE: these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS, *PIOCTL_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_ADD_INITIATOR_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT8 initiator_name[224];
               UEXACT8 initiator_alias[224];
               UEXACT32 initiator_chap_secret_enabled;
               MGMT_CHAP_NAME_SECRET initiator_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[183]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR_IN, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_INITIATOR_IN, sizeof (IOCTL_MILI_TMD_ADD_INITIATOR_IN) == 732);

   #else
      typedef struct _IOCTL_MILI_TMD_ADD_INITIATOR_IN {
         UEXACT32 initiator_key;
         UEXACT8 initiator_name[224];
         UEXACT8 initiator_alias[224];
         UEXACT32 initiator_chap_secret_enabled;
         MGMT_CHAP_NAME_SECRET initiator_chap;
      } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR_IN, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN;

      typedef union _IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION {
         IOCTL_MILI_TMD_ADD_INITIATOR_IN bits;
         u32 dw[183]; // dword union
      } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION, sizeof (IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION) == 732);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_ADD_INITIATOR_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT8 initiator_name[224];
               UEXACT8 initiator_alias[224];
               UEXACT32 initiator_chap_secret_enabled;
               MGMT_CHAP_NAME_SECRET initiator_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[183]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR_IN, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_INITIATOR_IN, sizeof (IOCTL_MILI_TMD_ADD_INITIATOR_IN) == 732);

   #else
      typedef struct _IOCTL_MILI_TMD_ADD_INITIATOR_IN {
         UEXACT32 initiator_key;
         UEXACT8 initiator_name[224];
         UEXACT8 initiator_alias[224];
         UEXACT32 initiator_chap_secret_enabled;
         MGMT_CHAP_NAME_SECRET initiator_chap;
      } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR_IN, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN;

      typedef union _IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION {
         IOCTL_MILI_TMD_ADD_INITIATOR_IN bits;
         u32 dw[183]; // dword union
      } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION, *PIOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION, sizeof (IOCTL_MILI_TMD_ADD_INITIATOR_IN_UNION) == 732);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Add an Initiator. Bind this to one or more targets using
   // IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET. This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response NOTE:
   // these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_TMD_ADD_INITIATOR {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_ADD_INITIATOR_IN request;
   } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR, *PIOCTL_MILI_TMD_ADD_INITIATOR;



#else
   // Add an Initiator. Bind this to one or more targets using
   // IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET. This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response NOTE:
   // these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_TMD_ADD_INITIATOR {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_ADD_INITIATOR_IN request;
   } SG_PACK IOCTL_MILI_TMD_ADD_INITIATOR, *PIOCTL_MILI_TMD_ADD_INITIATOR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DELETE_INITIATOR_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT8 initiator_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[57]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR_IN, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_INITIATOR_IN, sizeof (IOCTL_MILI_TMD_DELETE_INITIATOR_IN) == 228);

   #else
      typedef struct _IOCTL_MILI_TMD_DELETE_INITIATOR_IN {
         UEXACT32 initiator_key;
         UEXACT8 initiator_name[224];
      } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR_IN, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN;

      typedef union _IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION {
         IOCTL_MILI_TMD_DELETE_INITIATOR_IN bits;
         u32 dw[57]; // dword union
      } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION, sizeof (IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION) == 228);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DELETE_INITIATOR_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT8 initiator_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[57]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR_IN, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_INITIATOR_IN, sizeof (IOCTL_MILI_TMD_DELETE_INITIATOR_IN) == 228);

   #else
      typedef struct _IOCTL_MILI_TMD_DELETE_INITIATOR_IN {
         UEXACT32 initiator_key;
         UEXACT8 initiator_name[224];
      } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR_IN, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN;

      typedef union _IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION {
         IOCTL_MILI_TMD_DELETE_INITIATOR_IN bits;
         u32 dw[57]; // dword union
      } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION, *PIOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION, sizeof (IOCTL_MILI_TMD_DELETE_INITIATOR_IN_UNION) == 228);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Remove Initiator. TMD deletes the initiator. MILI should make sure that no target or
   // LUN maps are bound to the initiator. This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response NOTE: these
   // additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DELETE_INITIATOR {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DELETE_INITIATOR_IN request;
   } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR, *PIOCTL_MILI_TMD_DELETE_INITIATOR;



#else
   // Remove Initiator. TMD deletes the initiator. MILI should make sure that no target or
   // LUN maps are bound to the initiator. This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response NOTE: these
   // additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DELETE_INITIATOR {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DELETE_INITIATOR_IN request;
   } SG_PACK IOCTL_MILI_TMD_DELETE_INITIATOR, *PIOCTL_MILI_TMD_DELETE_INITIATOR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT32 initiator_chap_secret_enabled;
               MGMT_CHAP_NAME_SECRET initiator_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[71]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN, sizeof (IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN) == 284);

   #else
      typedef struct _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN {
         UEXACT32 initiator_key;
         UEXACT32 initiator_chap_secret_enabled;
         MGMT_CHAP_NAME_SECRET initiator_chap;
      } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN;

      typedef union _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION {
         IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN bits;
         u32 dw[71]; // dword union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION, sizeof (IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION) == 284);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT32 initiator_chap_secret_enabled;
               MGMT_CHAP_NAME_SECRET initiator_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[71]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN, sizeof (IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN) == 284);

   #else
      typedef struct _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN {
         UEXACT32 initiator_key;
         UEXACT32 initiator_chap_secret_enabled;
         MGMT_CHAP_NAME_SECRET initiator_chap;
      } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN;

      typedef union _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION {
         IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN bits;
         u32 dw[71]; // dword union
      } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION, sizeof (IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN_UNION) == 284);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Update the Initiators authentication parameters after an initiator has already been
   // added. This IOCTL may also be used to disable mutual authentication between this
   // initiator and a target. This IOCTL returns one of the following status values in the
   // response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the
   // following additional status values in the response NOTE: these additional status
   // codes are based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS;



#else
   // Update the Initiators authentication parameters after an initiator has already been
   // added. This IOCTL may also be used to disable mutual authentication between this
   // initiator and a target. This IOCTL returns one of the following status values in the
   // response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the
   // following additional status values in the response NOTE: these additional status
   // codes are based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS, *PIOCTL_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN {
         union {
            struct { 
               UEXACT32 it_nexus_key;
               UEXACT32 initiator_key;
               UEXACT32 target_key;
               UEXACT8 lun_map_name[224];
               UEXACT8 it_nexus_name[224];
               UEXACT8 initiator_specific_target_chap;
               UEXACT8 pad[3];
               MGMT_CHAP_NAME_SECRET target_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[185]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN, sizeof (IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN) == 740);

   #else
      typedef struct _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN {
         UEXACT32 it_nexus_key;
         UEXACT32 initiator_key;
         UEXACT32 target_key;
         UEXACT8 lun_map_name[224];
         UEXACT8 it_nexus_name[224];
         UEXACT8 initiator_specific_target_chap;
         UEXACT8 pad[3];
         MGMT_CHAP_NAME_SECRET target_chap;
      } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION {
         IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN bits;
         u32 dw[185]; // dword union
      } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION) == 740);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN {
         union {
            struct { 
               UEXACT32 it_nexus_key;
               UEXACT32 initiator_key;
               UEXACT32 target_key;
               UEXACT8 lun_map_name[224];
               UEXACT8 it_nexus_name[224];
               UEXACT8 initiator_specific_target_chap;
               UEXACT8 pad[3];
               MGMT_CHAP_NAME_SECRET target_chap;
            } SG_PACK ; // unnamed struct
            u32 dw[185]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN, sizeof (IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN) == 740);

   #else
      typedef struct _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN {
         UEXACT32 it_nexus_key;
         UEXACT32 initiator_key;
         UEXACT32 target_key;
         UEXACT8 lun_map_name[224];
         UEXACT8 it_nexus_name[224];
         UEXACT8 initiator_specific_target_chap;
         UEXACT8 pad[3];
         MGMT_CHAP_NAME_SECRET target_chap;
      } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION {
         IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN bits;
         u32 dw[185]; // dword union
      } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN_UNION) == 740);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Create Initiator-Target binding (nexus) and identify the nexus with a key. Note that
   // 'nexus' in this context refers to This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response NOTE: these
   // additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET;



#else
   // Create Initiator-Target binding (nexus) and identify the nexus with a key. Note that
   // 'nexus' in this context refers to This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response NOTE: these
   // additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INITIATOR_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET, *PIOCTL_MILI_TMD_BIND_INITIATOR_TO_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN {
         union {
            struct { 
               UEXACT32 it_nexus_key;
               UEXACT8 it_nexus_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[57]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN, sizeof (IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN) == 228);

   #else
      typedef struct _IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN {
         UEXACT32 it_nexus_key;
         UEXACT8 it_nexus_name[224];
      } SG_PACK IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN;

      typedef union _IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION {
         IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN bits;
         u32 dw[57]; // dword union
      } SG_PACK IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION, sizeof (IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION) == 228);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN {
         union {
            struct { 
               UEXACT32 it_nexus_key;
               UEXACT8 it_nexus_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[57]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN, sizeof (IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN) == 228);

   #else
      typedef struct _IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN {
         UEXACT32 it_nexus_key;
         UEXACT8 it_nexus_name[224];
      } SG_PACK IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN;

      typedef union _IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION {
         IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN bits;
         u32 dw[57]; // dword union
      } SG_PACK IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION, *PIOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION, sizeof (IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN_UNION) == 228);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Delete IT. MILI should make sure that IT nexus is not bound to any LUN map. This
   // IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response NOTE: these additional status codes are
   // based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_ITBINDING_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DELETE_IT_BINDING {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN request;
   } SG_PACK IOCTL_MILI_TMD_DELETE_IT_BINDING, *PIOCTL_MILI_TMD_DELETE_IT_BINDING;



#else
   // Delete IT. MILI should make sure that IT nexus is not bound to any LUN map. This
   // IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response NOTE: these additional status codes are
   // based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_ITBINDING_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DELETE_IT_BINDING {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DELETE_IT_NEXUS_IN request;
   } SG_PACK IOCTL_MILI_TMD_DELETE_IT_BINDING, *PIOCTL_MILI_TMD_DELETE_IT_BINDING;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_ACTIVATE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ACTIVATE_TARGET_IN, sizeof (IOCTL_MILI_TMD_ACTIVATE_TARGET_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_TMD_ACTIVATE_TARGET_IN {
         UEXACT32 target_key;
      } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION {
         IOCTL_MILI_TMD_ACTIVATE_TARGET_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_ACTIVATE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ACTIVATE_TARGET_IN, sizeof (IOCTL_MILI_TMD_ACTIVATE_TARGET_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_TMD_ACTIVATE_TARGET_IN {
         UEXACT32 target_key;
      } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION {
         IOCTL_MILI_TMD_ACTIVATE_TARGET_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION, *PIOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_ACTIVATE_TARGET_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL notifies TMD that configuration for the specified target is complete. PTL
   // will notify the TMD upon receiving Login requests for this Target. This IOCTL
   // returns one of the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED This IOCTL returns one of the following additional status values
   // in the response NOTE: these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_ACTIVATE_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_ACTIVATE_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET, *PIOCTL_MILI_TMD_ACTIVATE_TARGET;



#else
   // This IOCTL notifies TMD that configuration for the specified target is complete. PTL
   // will notify the TMD upon receiving Login requests for this Target. This IOCTL
   // returns one of the following status values in the response  - MGMT_STATUS_SUCCESS  -
   // MGMT_STATUS_FAILED This IOCTL returns one of the following additional status values
   // in the response NOTE: these additional status codes are based on reference TMD.  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_ACTIVATE_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_ACTIVATE_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_ACTIVATE_TARGET, *PIOCTL_MILI_TMD_ACTIVATE_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN, sizeof (IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN {
         UEXACT32 target_key;
      } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION {
         IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN, sizeof (IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN {
         UEXACT32 target_key;
      } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN;

      typedef union _IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION {
         IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION, sizeof (IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Once deactivated, this target will no longer entertain any login requests from
   // Initiators. This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response NOTE: these additional status codes are
   // based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DEACTIVATE_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET;



#else
   // Once deactivated, this target will no longer entertain any login requests from
   // Initiators. This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response NOTE: these additional status codes are
   // based on reference TMD.  - <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_TMD_DEACTIVATE_TARGET {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_DEACTIVATE_TARGET_IN request;
   } SG_PACK IOCTL_MILI_TMD_DEACTIVATE_TARGET, *PIOCTL_MILI_TMD_DEACTIVATE_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT8 QoS_category;
               UEXACT8 pad1[3];
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN, sizeof (IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN) == 8);

   #else
      typedef struct _IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN {
         UEXACT32 initiator_key;
         UEXACT8 QoS_category;
         UEXACT8 pad1[3];
      } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN;

      typedef union _IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION {
         IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION, sizeof (IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN {
         union {
            struct { 
               UEXACT32 initiator_key;
               UEXACT8 QoS_category;
               UEXACT8 pad1[3];
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN, sizeof (IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN) == 8);

   #else
      typedef struct _IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN {
         UEXACT32 initiator_key;
         UEXACT8 QoS_category;
         UEXACT8 pad1[3];
      } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN;

      typedef union _IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION {
         IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION, sizeof (IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Assigns a QoS category for a specific Initiator. Sessions between this Initiator and
   // any Target instance will share this bandwidth defined by this category. The TMD
   // should communicate this Qos category to PTL through a PTL-TMD API. QoS categories
   // can be changed at run time. By default all Initiators and sessions are assigned to
   // QoS category 0. 
   typedef struct _IOCTL_MILI_TMD_SET_INITIATOR_QOS {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN request;
   } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS;



#else
   // Assigns a QoS category for a specific Initiator. Sessions between this Initiator and
   // any Target instance will share this bandwidth defined by this category. The TMD
   // should communicate this Qos category to PTL through a PTL-TMD API. QoS categories
   // can be changed at run time. By default all Initiators and sessions are assigned to
   // QoS category 0. 
   typedef struct _IOCTL_MILI_TMD_SET_INITIATOR_QOS {
      IOCTL_HEADER header;
      IOCTL_MILI_TMD_SET_INITIATOR_QOS_IN request;
   } SG_PACK IOCTL_MILI_TMD_SET_INITIATOR_QOS, *PIOCTL_MILI_TMD_SET_INITIATOR_QOS;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_mili_tmd_bmap_h__

