/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_types_bmap_h__
#define __ioctl_types_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_defs_bmap.h"
#include "host_struct_bmap.h"
#include "ioctl_eventlog_bmap.h"
#include "ioctl_flash_types_bmap.h"
#include "descriptors_bmap.h"
#include "ipc_fw_impl_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // MAC address format 
   typedef struct _MAC_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT8 MACAddress[6];
   } SG_PACK MAC_ADDRESS_FORMAT, *PMAC_ADDRESS_FORMAT;



#else
   // MAC address format 
   typedef struct _MAC_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT8 MACAddress[6];
   } SG_PACK MAC_ADDRESS_FORMAT, *PMAC_ADDRESS_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IP address format - handles both IPv4 and IPv6 
   typedef struct _IP_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT8 Reserved;
      UEXACT8 IPType;
      UEXACT8 IPAddress[16];
      UEXACT32 rsvd0;
   } SG_PACK IP_ADDRESS_FORMAT, *PIP_ADDRESS_FORMAT;



#else
   // IP address format - handles both IPv4 and IPv6 
   typedef struct _IP_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT8 Reserved;
      UEXACT8 IPType;
      UEXACT8 IPAddress[16];
      UEXACT32 rsvd0;
   } SG_PACK IP_ADDRESS_FORMAT, *PIP_ADDRESS_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IP address and Subnet Mask format 
   typedef struct _IP_ADDRESS_SUBNET_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT8 IPType;
      UEXACT8 IPv6_Prefix_Length;
      UEXACT8 IPAddress[16];
      UEXACT8 SubNetMask[16];
      UEXACT32 rsvd0;
   } SG_PACK IP_ADDRESS_SUBNET_FORMAT, *PIP_ADDRESS_SUBNET_FORMAT;



#else
   // IP address and Subnet Mask format 
   typedef struct _IP_ADDRESS_SUBNET_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT8 IPType;
      UEXACT8 IPv6_Prefix_Length;
      UEXACT8 IPAddress[16];
      UEXACT8 SubNetMask[16];
      UEXACT32 rsvd0;
   } SG_PACK IP_ADDRESS_SUBNET_FORMAT, *PIP_ADDRESS_SUBNET_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // WWN (Fibre Channel) Format 
   typedef struct _WWN_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT16 Reserved;
      UEXACT8 WWN[8];
      UEXACT32 rsvd0;
   } SG_PACK WWN_ADDRESS_FORMAT, *PWWN_ADDRESS_FORMAT;



#else
   // WWN (Fibre Channel) Format 
   typedef struct _WWN_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT16 Reserved;
      UEXACT8 WWN[8];
      UEXACT32 rsvd0;
   } SG_PACK WWN_ADDRESS_FORMAT, *PWWN_ADDRESS_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // URL or World Wide Unique ID Format 
   typedef struct _URL_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT16 Reserved;
      EXACT8 URL[256];
      UEXACT32 rsvd0;
   } SG_PACK URL_ADDRESS_FORMAT, *PURL_ADDRESS_FORMAT;



#else
   // URL or World Wide Unique ID Format 
   typedef struct _URL_ADDRESS_FORMAT {
      UEXACT16 SizeOfStructure;
      UEXACT16 Reserved;
      EXACT8 URL[256];
      UEXACT32 rsvd0;
   } SG_PACK URL_ADDRESS_FORMAT, *PURL_ADDRESS_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_CHAP_NAME_SECRET {
         union {
            struct { 
               EXACT8 chap_name[256];
               EXACT8 secret[16];
               UEXACT16 chap_name_length;
               UEXACT16 secret_length;
            } SG_PACK ; // unnamed struct
            u32 dw[69]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_CHAP_NAME_SECRET, *PMGMT_CHAP_NAME_SECRET;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_NAME_SECRET, sizeof (MGMT_CHAP_NAME_SECRET) == 276);

   #else
      typedef struct _MGMT_CHAP_NAME_SECRET {
         EXACT8 chap_name[256];
         EXACT8 secret[16];
         UEXACT16 chap_name_length;
         UEXACT16 secret_length;
      } SG_PACK MGMT_CHAP_NAME_SECRET, *PMGMT_CHAP_NAME_SECRET;

      typedef union _MGMT_CHAP_NAME_SECRET_UNION {
         MGMT_CHAP_NAME_SECRET bits;
         u32 dw[69]; // dword union
      } SG_PACK MGMT_CHAP_NAME_SECRET_UNION, *PMGMT_CHAP_NAME_SECRET_UNION;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_NAME_SECRET_UNION, sizeof (MGMT_CHAP_NAME_SECRET_UNION) == 276);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_CHAP_NAME_SECRET {
         union {
            struct { 
               EXACT8 chap_name[256];
               EXACT8 secret[16];
               UEXACT16 chap_name_length;
               UEXACT16 secret_length;
            } SG_PACK ; // unnamed struct
            u32 dw[69]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_CHAP_NAME_SECRET, *PMGMT_CHAP_NAME_SECRET;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_NAME_SECRET, sizeof (MGMT_CHAP_NAME_SECRET) == 276);

   #else
      typedef struct _MGMT_CHAP_NAME_SECRET {
         EXACT8 chap_name[256];
         EXACT8 secret[16];
         UEXACT16 chap_name_length;
         UEXACT16 secret_length;
      } SG_PACK MGMT_CHAP_NAME_SECRET, *PMGMT_CHAP_NAME_SECRET;

      typedef union _MGMT_CHAP_NAME_SECRET_UNION {
         MGMT_CHAP_NAME_SECRET bits;
         u32 dw[69]; // dword union
      } SG_PACK MGMT_CHAP_NAME_SECRET_UNION, *PMGMT_CHAP_NAME_SECRET_UNION;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_NAME_SECRET_UNION, sizeof (MGMT_CHAP_NAME_SECRET_UNION) == 276);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_CHAP_FORMAT {
      UEXACT32 flags;
      EXACT8 intr_chap_name[256];
      EXACT8 intr_secret[16];
      EXACT8 target_chap_name[256];
      EXACT8 target_secret[16];
      UEXACT16 intr_chap_name_length;
      UEXACT16 intr_secret_length;
      UEXACT16 target_chap_name_length;
      UEXACT16 target_secret_length;
   } SG_PACK MGMT_CHAP_FORMAT, *PMGMT_CHAP_FORMAT;



#else
   
   typedef struct _MGMT_CHAP_FORMAT {
      UEXACT32 flags;
      EXACT8 intr_chap_name[256];
      EXACT8 intr_secret[16];
      EXACT8 target_chap_name[256];
      EXACT8 target_secret[16];
      UEXACT16 intr_chap_name_length;
      UEXACT16 intr_secret_length;
      UEXACT16 target_chap_name_length;
      UEXACT16 target_secret_length;
   } SG_PACK MGMT_CHAP_FORMAT, *PMGMT_CHAP_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_CHAP_SRP_FORMAT {
         union {
            union { 
               MGMT_CHAP_FORMAT chap;
            } SG_PACK ; // unnamed struct
            u32 dw[139]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_CHAP_SRP_FORMAT, *PMGMT_CHAP_SRP_FORMAT;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_SRP_FORMAT, sizeof (MGMT_CHAP_SRP_FORMAT) == 556);

   #else
      typedef union _MGMT_CHAP_SRP_FORMAT {
         MGMT_CHAP_FORMAT chap;
      } SG_PACK MGMT_CHAP_SRP_FORMAT, *PMGMT_CHAP_SRP_FORMAT;

      typedef union _MGMT_CHAP_SRP_FORMAT_UNION {
         MGMT_CHAP_SRP_FORMAT bits;
         u32 dw[139]; // dword union
      } SG_PACK MGMT_CHAP_SRP_FORMAT_UNION, *PMGMT_CHAP_SRP_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_SRP_FORMAT_UNION, sizeof (MGMT_CHAP_SRP_FORMAT_UNION) == 556);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_CHAP_SRP_FORMAT {
         union {
            union { 
               MGMT_CHAP_FORMAT chap;
            } SG_PACK ; // unnamed struct
            u32 dw[139]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_CHAP_SRP_FORMAT, *PMGMT_CHAP_SRP_FORMAT;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_SRP_FORMAT, sizeof (MGMT_CHAP_SRP_FORMAT) == 556);

   #else
      typedef union _MGMT_CHAP_SRP_FORMAT {
         MGMT_CHAP_FORMAT chap;
      } SG_PACK MGMT_CHAP_SRP_FORMAT, *PMGMT_CHAP_SRP_FORMAT;

      typedef union _MGMT_CHAP_SRP_FORMAT_UNION {
         MGMT_CHAP_SRP_FORMAT bits;
         u32 dw[139]; // dword union
      } SG_PACK MGMT_CHAP_SRP_FORMAT_UNION, *PMGMT_CHAP_SRP_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__MGMT_CHAP_SRP_FORMAT_UNION, sizeof (MGMT_CHAP_SRP_FORMAT_UNION) == 556);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_AUTH_METHOD_FORMAT {
      UEXACT8 auth_method_type;
      UEXACT8 padding[3];
      MGMT_CHAP_SRP_FORMAT chap_srp_format;
   } SG_PACK MGMT_AUTH_METHOD_FORMAT, *PMGMT_AUTH_METHOD_FORMAT;



#else
   
   typedef struct _MGMT_AUTH_METHOD_FORMAT {
      UEXACT8 auth_method_type;
      UEXACT8 padding[3];
      MGMT_CHAP_SRP_FORMAT chap_srp_format;
   } SG_PACK MGMT_AUTH_METHOD_FORMAT, *PMGMT_AUTH_METHOD_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_CONN_LOGIN_OPTIONS {
      UEXACT8 flags;
      UEXACT8 header_digest;
      UEXACT8 data_digest;
      UEXACT8 rsvd0;
      UEXACT32 max_recv_datasegment_len_ini;
      UEXACT32 max_recv_datasegment_len_tgt;
      UEXACT32 tcp_mss;
      UEXACT32 tcp_window_size;
      MGMT_AUTH_METHOD_FORMAT auth_data;
   } SG_PACK MGMT_CONN_LOGIN_OPTIONS, *PMGMT_CONN_LOGIN_OPTIONS;



#else
   
   typedef struct _MGMT_CONN_LOGIN_OPTIONS {
      UEXACT8 flags;
      UEXACT8 header_digest;
      UEXACT8 data_digest;
      UEXACT8 rsvd0;
      UEXACT32 max_recv_datasegment_len_ini;
      UEXACT32 max_recv_datasegment_len_tgt;
      UEXACT32 tcp_mss;
      UEXACT32 tcp_window_size;
      MGMT_AUTH_METHOD_FORMAT auth_data;
   } SG_PACK MGMT_CONN_LOGIN_OPTIONS, *PMGMT_CONN_LOGIN_OPTIONS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_SESSION_LOGIN_OPTIONS {
      UEXACT8 flags;
      UEXACT8 error_recovery_level;
      UEXACT16 rsvd0;
      UEXACT32 first_burst_length;
      UEXACT32 max_burst_length;
      UEXACT16 max_connections;
      UEXACT16 max_outstanding_r2t;
      UEXACT16 default_time2wait;
      UEXACT16 default_time2retain;
   } SG_PACK MGMT_SESSION_LOGIN_OPTIONS, *PMGMT_SESSION_LOGIN_OPTIONS;



#else
   
   typedef struct _MGMT_SESSION_LOGIN_OPTIONS {
      UEXACT8 flags;
      UEXACT8 error_recovery_level;
      UEXACT16 rsvd0;
      UEXACT32 first_burst_length;
      UEXACT32 max_burst_length;
      UEXACT16 max_connections;
      UEXACT16 max_outstanding_r2t;
      UEXACT16 default_time2wait;
      UEXACT16 default_time2retain;
   } SG_PACK MGMT_SESSION_LOGIN_OPTIONS, *PMGMT_SESSION_LOGIN_OPTIONS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_TARGET_LOGIN_OPTIONS {
      MGMT_SESSION_LOGIN_OPTIONS sess_login_opts;
      UEXACT8 conn_flags;
      UEXACT8 data_digest;
      UEXACT8 header_digest;
      UEXACT8 rsvd0;
      UEXACT32 max_recv_datasegment_len_tgt;
   } SG_PACK MGMT_TARGET_LOGIN_OPTIONS, *PMGMT_TARGET_LOGIN_OPTIONS;



#else
   
   typedef struct _MGMT_TARGET_LOGIN_OPTIONS {
      MGMT_SESSION_LOGIN_OPTIONS sess_login_opts;
      UEXACT8 conn_flags;
      UEXACT8 data_digest;
      UEXACT8 header_digest;
      UEXACT8 rsvd0;
      UEXACT32 max_recv_datasegment_len_tgt;
   } SG_PACK MGMT_TARGET_LOGIN_OPTIONS, *PMGMT_TARGET_LOGIN_OPTIONS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_LOGIN_OPTIONS {
      MGMT_SESSION_LOGIN_OPTIONS sess_login_opts;
      MGMT_CONN_LOGIN_OPTIONS conn_login_opts;
   } SG_PACK MGMT_LOGIN_OPTIONS, *PMGMT_LOGIN_OPTIONS;



#else
   
   typedef struct _MGMT_LOGIN_OPTIONS {
      MGMT_SESSION_LOGIN_OPTIONS sess_login_opts;
      MGMT_CONN_LOGIN_OPTIONS conn_login_opts;
   } SG_PACK MGMT_LOGIN_OPTIONS, *PMGMT_LOGIN_OPTIONS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_CONN_INFO {
      UEXACT32 connection_handle;
      UEXACT32 connection_status;
      UEXACT16 src_port;
      UEXACT16 dest_port;
      UEXACT16 dest_port_redirected;
      UEXACT16 cid;
      UEXACT32 estimated_throughput;
      IP_ADDRESS_FORMAT src_ipaddr;
      IP_ADDRESS_FORMAT dest_ipaddr;
      IP_ADDRESS_FORMAT dest_ipaddr_redirected;
      MGMT_CONN_LOGIN_OPTIONS negotiated_login_options;
   } SG_PACK MGMT_CONN_INFO, *PMGMT_CONN_INFO;



#else
   
   typedef struct _MGMT_CONN_INFO {
      UEXACT32 connection_handle;
      UEXACT32 connection_status;
      UEXACT16 src_port;
      UEXACT16 dest_port;
      UEXACT16 dest_port_redirected;
      UEXACT16 cid;
      UEXACT32 estimated_throughput;
      IP_ADDRESS_FORMAT src_ipaddr;
      IP_ADDRESS_FORMAT dest_ipaddr;
      IP_ADDRESS_FORMAT dest_ipaddr_redirected;
      MGMT_CONN_LOGIN_OPTIONS negotiated_login_options;
   } SG_PACK MGMT_CONN_INFO, *PMGMT_CONN_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_SESSION_INFO {
      UEXACT32 session_handle;
      UEXACT32 status;
      UEXACT8 isid[6];
      UEXACT16 tsih;
      UEXACT32 session_flags;
      UEXACT16 conn_count;
      UEXACT16 pad;
      EXACT8 target_name[224];
      EXACT8 initiator_iscsiname[224];
      MGMT_SESSION_LOGIN_OPTIONS negotiated_login_options;
      MGMT_CONN_INFO conn_list[1];
   } SG_PACK MGMT_SESSION_INFO, *PMGMT_SESSION_INFO;



#else
   
   typedef struct _MGMT_SESSION_INFO {
      UEXACT32 session_handle;
      UEXACT32 status;
      UEXACT8 isid[6];
      UEXACT16 tsih;
      UEXACT32 session_flags;
      UEXACT16 conn_count;
      UEXACT16 pad;
      EXACT8 target_name[224];
      EXACT8 initiator_iscsiname[224];
      MGMT_SESSION_LOGIN_OPTIONS negotiated_login_options;
      MGMT_CONN_INFO conn_list[1];
   } SG_PACK MGMT_SESSION_INFO, *PMGMT_SESSION_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _CONNECTION_DATA {
      UEXACT32 connection_handle;
      UEXACT32 conn_status;
      UEXACT32 conn_iscsi_cid;
      UEXACT32 estimated_throughput;
      UEXACT32 header_digest;
      UEXACT32 data_digest;
   } SG_PACK CONNECTION_DATA, *PCONNECTION_DATA;



#else
   
   typedef struct _CONNECTION_DATA {
      UEXACT32 connection_handle;
      UEXACT32 conn_status;
      UEXACT32 conn_iscsi_cid;
      UEXACT32 estimated_throughput;
      UEXACT32 header_digest;
      UEXACT32 data_digest;
   } SG_PACK CONNECTION_DATA, *PCONNECTION_DATA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_CONN_LB_INFO {
      UEXACT32 session_handle;
      UEXACT16 conn_count;
      UEXACT16 pad;
      CONNECTION_DATA conn_list[1];
   } SG_PACK MGMT_CONN_LB_INFO, *PMGMT_CONN_LB_INFO;



#else
   
   typedef struct _MGMT_CONN_LB_INFO {
      UEXACT32 session_handle;
      UEXACT16 conn_count;
      UEXACT16 pad;
      CONNECTION_DATA conn_list[1];
   } SG_PACK MGMT_CONN_LB_INFO, *PMGMT_CONN_LB_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_LUN_MAPPING {
      UEXACT8 lun[8];
      UEXACT16 os_lun;
      UEXACT8 boot_order;
      UEXACT8 pad1;
      UEXACT32 pad2;
   } SG_PACK MGMT_LUN_MAPPING, *PMGMT_LUN_MAPPING;



#else
   
   typedef struct _MGMT_LUN_MAPPING {
      UEXACT8 lun[8];
      UEXACT16 os_lun;
      UEXACT8 boot_order;
      UEXACT8 pad1;
      UEXACT32 pad2;
   } SG_PACK MGMT_LUN_MAPPING, *PMGMT_LUN_MAPPING;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_BTL_MAPPING {
      UEXACT32 session_handle;
      UEXACT32 session_status;
      UEXACT32 session_flags;
      UEXACT8 dev_addr_mode;
      UEXACT8 flags;
      UEXACT16 os_bus;
      UEXACT16 os_target;
      UEXACT16 lun_count;
      MGMT_LUN_MAPPING lun_mapping[1];
   } SG_PACK MGMT_BTL_MAPPING, *PMGMT_BTL_MAPPING;



#else
   
   typedef struct _MGMT_BTL_MAPPING {
      UEXACT32 session_handle;
      UEXACT32 session_status;
      UEXACT32 session_flags;
      UEXACT8 dev_addr_mode;
      UEXACT8 flags;
      UEXACT16 os_bus;
      UEXACT16 os_target;
      UEXACT16 lun_count;
      MGMT_LUN_MAPPING lun_mapping[1];
   } SG_PACK MGMT_BTL_MAPPING, *PMGMT_BTL_MAPPING;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_OS_BT {
      UEXACT16 os_bus;
      UEXACT16 os_target;
      UEXACT32 session_handle;
   } SG_PACK MGMT_OS_BT, *PMGMT_OS_BT;



#else
   
   typedef struct _MGMT_OS_BT {
      UEXACT16 os_bus;
      UEXACT16 os_target;
      UEXACT32 session_handle;
   } SG_PACK MGMT_OS_BT, *PMGMT_OS_BT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_PORTAL {
      IP_ADDRESS_FORMAT ip_address;
      UEXACT16 port_number;
      UEXACT16 flags;
   } SG_PACK MGMT_PORTAL, *PMGMT_PORTAL;



#else
   
   typedef struct _MGMT_PORTAL {
      IP_ADDRESS_FORMAT ip_address;
      UEXACT16 port_number;
      UEXACT16 flags;
   } SG_PACK MGMT_PORTAL, *PMGMT_PORTAL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_PERSISTENT_LOGIN {
      EXACT8 target_name[224];
      UEXACT32 target_id;
      UEXACT32 flags;
      UEXACT32 iscsi_security_flags;
      MGMT_PORTAL portal;
      MGMT_LOGIN_OPTIONS specified_login_options;
      MGMT_BTL_MAPPING btl_mapping;
   } SG_PACK MGMT_PERSISTENT_LOGIN, *PMGMT_PERSISTENT_LOGIN;



#else
   
   typedef struct _MGMT_PERSISTENT_LOGIN {
      EXACT8 target_name[224];
      UEXACT32 target_id;
      UEXACT32 flags;
      UEXACT32 iscsi_security_flags;
      MGMT_PORTAL portal;
      MGMT_LOGIN_OPTIONS specified_login_options;
      MGMT_BTL_MAPPING btl_mapping;
   } SG_PACK MGMT_PERSISTENT_LOGIN, *PMGMT_PERSISTENT_LOGIN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_TGTID_PORTAL {
      UEXACT32 target_id;
      MGMT_PORTAL portal;
   } SG_PACK MGMT_TGTID_PORTAL, *PMGMT_TGTID_PORTAL;



#else
   
   typedef struct _MGMT_TGTID_PORTAL {
      UEXACT32 target_id;
      MGMT_PORTAL portal;
   } SG_PACK MGMT_TGTID_PORTAL, *PMGMT_TGTID_PORTAL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_SLP_PARAMS {
      UEXACT16 flags;
      UEXACT16 rsvd0;
      EXACT8 scopes[256];
      EXACT8 querylist[256];
      UEXACT32 multicast_maxwait;
      UEXACT32 multicast_timeout[5];
      UEXACT32 multicast_ttl;
   } SG_PACK MGMT_SLP_PARAMS, *PMGMT_SLP_PARAMS;



#else
   
   typedef struct _MGMT_SLP_PARAMS {
      UEXACT16 flags;
      UEXACT16 rsvd0;
      EXACT8 scopes[256];
      EXACT8 querylist[256];
      UEXACT32 multicast_maxwait;
      UEXACT32 multicast_timeout[5];
      UEXACT32 multicast_ttl;
   } SG_PACK MGMT_SLP_PARAMS, *PMGMT_SLP_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_ISNS_SERVER {
      IP_ADDRESS_FORMAT ipaddr;
      UEXACT16 tcp_port;
      UEXACT16 udp_port;
   } SG_PACK MGMT_ISNS_SERVER, *PMGMT_ISNS_SERVER;



#else
   
   typedef struct _MGMT_ISNS_SERVER {
      IP_ADDRESS_FORMAT ipaddr;
      UEXACT16 tcp_port;
      UEXACT16 udp_port;
   } SG_PACK MGMT_ISNS_SERVER, *PMGMT_ISNS_SERVER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_ISNS_ENTITY {
         union {
            union { 
               EXACT8 initiator_iscsiname[224];
               EXACT8 isns_entity_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[56]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_ISNS_ENTITY, *PMGMT_ISNS_ENTITY;

      SG_C_ASSERT(__sizeof__MGMT_ISNS_ENTITY, sizeof (MGMT_ISNS_ENTITY) == 224);

   #else
      typedef union _MGMT_ISNS_ENTITY {
         EXACT8 initiator_iscsiname[224];
         EXACT8 isns_entity_name[224];
      } SG_PACK MGMT_ISNS_ENTITY, *PMGMT_ISNS_ENTITY;

      typedef union _MGMT_ISNS_ENTITY_UNION {
         MGMT_ISNS_ENTITY bits;
         u32 dw[56]; // dword union
      } SG_PACK MGMT_ISNS_ENTITY_UNION, *PMGMT_ISNS_ENTITY_UNION;

      SG_C_ASSERT(__sizeof__MGMT_ISNS_ENTITY_UNION, sizeof (MGMT_ISNS_ENTITY_UNION) == 224);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_ISNS_ENTITY {
         union {
            union { 
               EXACT8 initiator_iscsiname[224];
               EXACT8 isns_entity_name[224];
            } SG_PACK ; // unnamed struct
            u32 dw[56]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_ISNS_ENTITY, *PMGMT_ISNS_ENTITY;

      SG_C_ASSERT(__sizeof__MGMT_ISNS_ENTITY, sizeof (MGMT_ISNS_ENTITY) == 224);

   #else
      typedef union _MGMT_ISNS_ENTITY {
         EXACT8 initiator_iscsiname[224];
         EXACT8 isns_entity_name[224];
      } SG_PACK MGMT_ISNS_ENTITY, *PMGMT_ISNS_ENTITY;

      typedef union _MGMT_ISNS_ENTITY_UNION {
         MGMT_ISNS_ENTITY bits;
         u32 dw[56]; // dword union
      } SG_PACK MGMT_ISNS_ENTITY_UNION, *PMGMT_ISNS_ENTITY_UNION;

      SG_C_ASSERT(__sizeof__MGMT_ISNS_ENTITY_UNION, sizeof (MGMT_ISNS_ENTITY_UNION) == 224);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_ISNS_PARAMS {
      UEXACT16 flags;
      UEXACT16 rsvd0;
      MGMT_ISNS_ENTITY entity;
      UEXACT32 srv_count;
      MGMT_ISNS_SERVER srv_list[4];
   } SG_PACK MGMT_ISNS_PARAMS, *PMGMT_ISNS_PARAMS;



#else
   
   typedef struct _MGMT_ISNS_PARAMS {
      UEXACT16 flags;
      UEXACT16 rsvd0;
      MGMT_ISNS_ENTITY entity;
      UEXACT32 srv_count;
      MGMT_ISNS_SERVER srv_list[4];
   } SG_PACK MGMT_ISNS_PARAMS, *PMGMT_ISNS_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_PORTAL_ENTRY {
      MGMT_PORTAL portal;
      UEXACT32 iscsi_security_flags;
      UEXACT32 preshared_keysize;
      UEXACT8 preshared_key[256];
      UEXACT8 isns_sym_name[256];
   } SG_PACK MGMT_PORTAL_ENTRY, *PMGMT_PORTAL_ENTRY;



#else
   
   typedef struct _MGMT_PORTAL_ENTRY {
      MGMT_PORTAL portal;
      UEXACT32 iscsi_security_flags;
      UEXACT32 preshared_keysize;
      UEXACT8 preshared_key[256];
      UEXACT8 isns_sym_name[256];
   } SG_PACK MGMT_PORTAL_ENTRY, *PMGMT_PORTAL_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_PORTAL_GROUP {
      UEXACT16 pg_tag;
      UEXACT16 portal_count;
      MGMT_PORTAL_ENTRY portal_list[1];
   } SG_PACK MGMT_PORTAL_GROUP, *PMGMT_PORTAL_GROUP;



#else
   
   typedef struct _MGMT_PORTAL_GROUP {
      UEXACT16 pg_tag;
      UEXACT16 portal_count;
      MGMT_PORTAL_ENTRY portal_list[1];
   } SG_PACK MGMT_PORTAL_GROUP, *PMGMT_PORTAL_GROUP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_TARGET_INFO {
      UEXACT32 target_id;
      EXACT8 target_name[224];
      EXACT8 target_alias[32];
      UEXACT32 pg_count;
      MGMT_PORTAL_GROUP pg_list[1];
   } SG_PACK MGMT_TARGET_INFO, *PMGMT_TARGET_INFO;



#else
   
   typedef struct _MGMT_TARGET_INFO {
      UEXACT32 target_id;
      EXACT8 target_name[224];
      EXACT8 target_alias[32];
      UEXACT32 pg_count;
      MGMT_PORTAL_GROUP pg_list[1];
   } SG_PACK MGMT_TARGET_INFO, *PMGMT_TARGET_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_DNS_SERVERS {
      IP_ADDRESS_FORMAT preferred_dns_server;
      IP_ADDRESS_FORMAT alternate_dns_server;
   } SG_PACK MGMT_DNS_SERVERS, *PMGMT_DNS_SERVERS;



#else
   
   typedef struct _MGMT_DNS_SERVERS {
      IP_ADDRESS_FORMAT preferred_dns_server;
      IP_ADDRESS_FORMAT alternate_dns_server;
   } SG_PACK MGMT_DNS_SERVERS, *PMGMT_DNS_SERVERS;



#endif

typedef MGMT_DNS_SERVERS DNS_SERVERS;

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IP_ADDRESS_VLAN_FORMAT {
      IP_ADDRESS_SUBNET_FORMAT ip_address_subnet;
      UEXACT8 vlan_priority_valid;
      UEXACT8 rsvd0;
      UEXACT16 vlan_priority;
   } SG_PACK IP_ADDRESS_VLAN_FORMAT, *PIP_ADDRESS_VLAN_FORMAT;



#else
   
   typedef struct _IP_ADDRESS_VLAN_FORMAT {
      IP_ADDRESS_SUBNET_FORMAT ip_address_subnet;
      UEXACT8 vlan_priority_valid;
      UEXACT8 rsvd0;
      UEXACT16 vlan_priority;
   } SG_PACK IP_ADDRESS_VLAN_FORMAT, *PIP_ADDRESS_VLAN_FORMAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _TCPIP_CONFIGURATION {
      DNS_SERVERS dns_servers;
      IP_ADDRESS_FORMAT default_gateway_address;
      UEXACT8 use_link_local_address;
      UEXACT8 dhcp_flags;
      UEXACT8 use_dhcp_for_dns;
      UEXACT8 supported_ipversions;
      UEXACT8 rsvd0;
      UEXACT8 rsvd1;
      UEXACT8 rsvd2;
      UEXACT8 ipaddress_count;
      IP_ADDRESS_VLAN_FORMAT ipaddress_vlan_list[1];
   } SG_PACK TCPIP_CONFIGURATION, *PTCPIP_CONFIGURATION;



#else
   
   typedef struct _TCPIP_CONFIGURATION {
      DNS_SERVERS dns_servers;
      IP_ADDRESS_FORMAT default_gateway_address;
      UEXACT8 use_link_local_address;
      UEXACT8 dhcp_flags;
      UEXACT8 use_dhcp_for_dns;
      UEXACT8 supported_ipversions;
      UEXACT8 rsvd0;
      UEXACT8 rsvd1;
      UEXACT8 rsvd2;
      UEXACT8 ipaddress_count;
      IP_ADDRESS_VLAN_FORMAT ipaddress_vlan_list[1];
   } SG_PACK TCPIP_CONFIGURATION, *PTCPIP_CONFIGURATION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_NIC_PORT_INFO {
      UEXACT32 speed;
      UEXACT32 max_speed;
      UEXACT32 link_state;
      UEXACT32 max_frame_size;
      MAC_ADDRESS_FORMAT mac_address;
   } SG_PACK MGMT_NIC_PORT_INFO, *PMGMT_NIC_PORT_INFO;



#else
   
   typedef struct _MGMT_NIC_PORT_INFO {
      UEXACT32 speed;
      UEXACT32 max_speed;
      UEXACT32 link_state;
      UEXACT32 max_frame_size;
      MAC_ADDRESS_FORMAT mac_address;
   } SG_PACK MGMT_NIC_PORT_INFO, *PMGMT_NIC_PORT_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_HBA_ATTRIBUTES {
      EXACT8 flashrom_version_string[32];
      EXACT8 manufacturer_name[32];
      UEXACT32 supported_modes;
      EXACT8 seeprom_version_lo;
      EXACT8 seeprom_version_hi;
      EXACT8 rsvd0[2];
      UEXACT32 ioctl_data_struct_version;
      UEXACT32 ep_fw_data_struct_version;
      UEXACT8 ncsi_version_string[12];
      UEXACT32 default_extended_timeout;
      EXACT8 controller_model_number[32];
      EXACT8 controller_description[64];
      EXACT8 controller_serial_number[32];
      EXACT8 ip_version_string[32];
      EXACT8 firmware_version_string[32];
      EXACT8 bios_version_string[32];
      EXACT8 redboot_version_string[32];
      EXACT8 driver_version_string[32];
      EXACT8 fw_on_flash_version_string[32];
      UEXACT32 functionalities_supported;
      UEXACT16 max_cdblength;
      UEXACT8 asic_revision;
      UEXACT8 generational_guid[16];
      UEXACT8 hba_port_count;
      UEXACT16 default_link_down_timeout;
      UEXACT8 iscsi_ver_min_max;
      UEXACT8 multifunction_device;
      UEXACT8 cache_valid;
      UEXACT8 hba_status;
      UEXACT8 max_domains_supported;
      UEXACT8 phy_port;
      UEXACT32 firmware_post_status;
      UEXACT32 hba_mtu[8];
      UEXACT8 iSCSI_features;
      UEXACT8 asic_generation;
      UEXACT8 future_u8[2];
      UEXACT32 future_u32[3];
   } SG_PACK MGMT_HBA_ATTRIBUTES, *PMGMT_HBA_ATTRIBUTES;



#else
   
   typedef struct _MGMT_HBA_ATTRIBUTES {
      EXACT8 flashrom_version_string[32];
      EXACT8 manufacturer_name[32];
      UEXACT32 supported_modes;
      EXACT8 seeprom_version_lo;
      EXACT8 seeprom_version_hi;
      EXACT8 rsvd0[2];
      UEXACT32 ioctl_data_struct_version;
      UEXACT32 ep_fw_data_struct_version;
      UEXACT8 ncsi_version_string[12];
      UEXACT32 default_extended_timeout;
      EXACT8 controller_model_number[32];
      EXACT8 controller_description[64];
      EXACT8 controller_serial_number[32];
      EXACT8 ip_version_string[32];
      EXACT8 firmware_version_string[32];
      EXACT8 bios_version_string[32];
      EXACT8 redboot_version_string[32];
      EXACT8 driver_version_string[32];
      EXACT8 fw_on_flash_version_string[32];
      UEXACT32 functionalities_supported;
      UEXACT16 max_cdblength;
      UEXACT8 asic_revision;
      UEXACT8 generational_guid[16];
      UEXACT8 hba_port_count;
      UEXACT16 default_link_down_timeout;
      UEXACT8 iscsi_ver_min_max;
      UEXACT8 multifunction_device;
      UEXACT8 cache_valid;
      UEXACT8 hba_status;
      UEXACT8 max_domains_supported;
      UEXACT8 phy_port;
      UEXACT32 firmware_post_status;
      UEXACT32 hba_mtu[8];
      UEXACT8 iSCSI_features;
      UEXACT8 asic_generation;
      UEXACT8 future_u8[2];
      UEXACT32 future_u32[3];
   } SG_PACK MGMT_HBA_ATTRIBUTES, *PMGMT_HBA_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_CONTROLLER_ATTRIBUTES {
      MGMT_HBA_ATTRIBUTES hba_attribs;
      UEXACT16 pci_vendor_id;
      UEXACT16 pci_device_id;
      UEXACT16 pci_sub_vendor_id;
      UEXACT16 pci_sub_system_id;
      UEXACT8 pci_bus_number;
      UEXACT8 pci_device_number;
      UEXACT8 pci_function_number;
      UEXACT8 interface_type;
      UEXACT64 unique_identifier;
      UEXACT8 netfilters;
      UEXACT8 rsvd0[3];
      UEXACT32 future_u32[4];
   } SG_PACK MGMT_CONTROLLER_ATTRIBUTES, *PMGMT_CONTROLLER_ATTRIBUTES;



#else
   
   typedef struct _MGMT_CONTROLLER_ATTRIBUTES {
      MGMT_HBA_ATTRIBUTES hba_attribs;
      UEXACT16 pci_vendor_id;
      UEXACT16 pci_device_id;
      UEXACT16 pci_sub_vendor_id;
      UEXACT16 pci_sub_system_id;
      UEXACT8 pci_bus_number;
      UEXACT8 pci_device_number;
      UEXACT8 pci_function_number;
      UEXACT8 interface_type;
      UEXACT64 unique_identifier;
      UEXACT8 netfilters;
      UEXACT8 rsvd0[3];
      UEXACT32 future_u32[4];
   } SG_PACK MGMT_CONTROLLER_ATTRIBUTES, *PMGMT_CONTROLLER_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_PCIE_INFO {
      UEXACT8 current_link_width;
      UEXACT8 max_link_width;
      UEXACT8 current_link_speed;
      UEXACT8 max_link_speed;
   } SG_PACK MGMT_PCIE_INFO, *PMGMT_PCIE_INFO;



#else
   
   typedef struct _MGMT_PCIE_INFO {
      UEXACT8 current_link_width;
      UEXACT8 max_link_width;
      UEXACT8 current_link_speed;
      UEXACT8 max_link_speed;
   } SG_PACK MGMT_PCIE_INFO, *PMGMT_PCIE_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_BUS_ADDRESS32 {
      UEXACT32 address_lo;
      UEXACT32 address_hi;
   } SG_PACK MGMT_BUS_ADDRESS32, *PMGMT_BUS_ADDRESS32;



#else
   
   typedef struct _MGMT_BUS_ADDRESS32 {
      UEXACT32 address_lo;
      UEXACT32 address_hi;
   } SG_PACK MGMT_BUS_ADDRESS32, *PMGMT_BUS_ADDRESS32;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_BUS_ADDRESS64 {
      UEXACT64 address;
   } SG_PACK MGMT_BUS_ADDRESS64, *PMGMT_BUS_ADDRESS64;



#else
   
   typedef struct _MGMT_BUS_ADDRESS64 {
      UEXACT64 address;
   } SG_PACK MGMT_BUS_ADDRESS64, *PMGMT_BUS_ADDRESS64;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_BUS_ADDRESS_U {
         union {
            union { 
               MGMT_BUS_ADDRESS32 a32;
               MGMT_BUS_ADDRESS64 a64;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_BUS_ADDRESS_U, *PMGMT_BUS_ADDRESS_U;

      SG_C_ASSERT(__sizeof__MGMT_BUS_ADDRESS_U, sizeof (MGMT_BUS_ADDRESS_U) == 8);

   #else
      typedef union _MGMT_BUS_ADDRESS_U {
         MGMT_BUS_ADDRESS32 a32;
         MGMT_BUS_ADDRESS64 a64;
      } SG_PACK MGMT_BUS_ADDRESS_U, *PMGMT_BUS_ADDRESS_U;

      typedef union _MGMT_BUS_ADDRESS_U_UNION {
         MGMT_BUS_ADDRESS_U bits;
         u32 dw[2]; // dword union
      } SG_PACK MGMT_BUS_ADDRESS_U_UNION, *PMGMT_BUS_ADDRESS_U_UNION;

      SG_C_ASSERT(__sizeof__MGMT_BUS_ADDRESS_U_UNION, sizeof (MGMT_BUS_ADDRESS_U_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_BUS_ADDRESS_U {
         union {
            union { 
               MGMT_BUS_ADDRESS32 a32;
               MGMT_BUS_ADDRESS64 a64;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MGMT_BUS_ADDRESS_U, *PMGMT_BUS_ADDRESS_U;

      SG_C_ASSERT(__sizeof__MGMT_BUS_ADDRESS_U, sizeof (MGMT_BUS_ADDRESS_U) == 8);

   #else
      typedef union _MGMT_BUS_ADDRESS_U {
         MGMT_BUS_ADDRESS32 a32;
         MGMT_BUS_ADDRESS64 a64;
      } SG_PACK MGMT_BUS_ADDRESS_U, *PMGMT_BUS_ADDRESS_U;

      typedef union _MGMT_BUS_ADDRESS_U_UNION {
         MGMT_BUS_ADDRESS_U bits;
         u32 dw[2]; // dword union
      } SG_PACK MGMT_BUS_ADDRESS_U_UNION, *PMGMT_BUS_ADDRESS_U_UNION;

      SG_C_ASSERT(__sizeof__MGMT_BUS_ADDRESS_U_UNION, sizeof (MGMT_BUS_ADDRESS_U_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_BUS_ADDRESS {
      MGMT_BUS_ADDRESS_U u;
   } SG_PACK MGMT_BUS_ADDRESS, *PMGMT_BUS_ADDRESS;



#else
   
   typedef struct _MGMT_BUS_ADDRESS {
      MGMT_BUS_ADDRESS_U u;
   } SG_PACK MGMT_BUS_ADDRESS, *PMGMT_BUS_ADDRESS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_SG_ELEMENT {
      MGMT_BUS_ADDRESS address;
      UEXACT32 length;
      UEXACT32 offset;
   } SG_PACK MGMT_SG_ELEMENT, *PMGMT_SG_ELEMENT;



#else
   
   typedef struct _MGMT_SG_ELEMENT {
      MGMT_BUS_ADDRESS address;
      UEXACT32 length;
      UEXACT32 offset;
   } SG_PACK MGMT_SG_ELEMENT, *PMGMT_SG_ELEMENT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MGMT_SG_TABLE {
      UEXACT32 sg_count;
      UEXACT32 rsvd0;
      MGMT_SG_ELEMENT sg_list[1];
   } SG_PACK MGMT_SG_TABLE, *PMGMT_SG_TABLE;



#else
   
   typedef struct _MGMT_SG_TABLE {
      UEXACT32 sg_count;
      UEXACT32 rsvd0;
      MGMT_SG_ELEMENT sg_list[1];
   } SG_PACK MGMT_SG_TABLE, *PMGMT_SG_TABLE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Template header used in the offload IOCTLs.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_TEMPLATE_HEADER {
         union {
            union { 
               TEMPLATE_HEADER ethernetII;
               TEMPLATE_HEADER_TS ethernetII_ts;
               TEMPLATE_IPV6_HEADER ipv6_ethernetII;
               TEMPLATE_IPV6_HEADER_TS ipv6_ethernetII_ts;
               TEMPLATE_VLAN_IPV6_HEADER vlan_ipv6_ethernetII;
               TEMPLATE_VLAN_IPV6_HEADER_TS vlan_ipv6_ethernetII_ts;
               TEMPLATE_VLAN_HEADER vlan_ethernetII;
               TEMPLATE_VLAN_HEADER_TS vlan_ethernetII_ts;
               TEMPLATE_SNAP_HEADER snap;
               TEMPLATE_VLAN_SNAP_HEADER vlan_snap;
               UEXACT32 rsvd0[32];
               struct {
                  UEXACT8 rsvd0[92];
                  RXFILT_D filter_template[2];
                  UEXACT32 reset_sequence;
               } extra;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK MPU_TEMPLATE_HEADER, *PMPU_TEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__MPU_TEMPLATE_HEADER, sizeof (MPU_TEMPLATE_HEADER) == 128);

   #else
      typedef union _MPU_TEMPLATE_HEADER {
         TEMPLATE_HEADER ethernetII;
         TEMPLATE_HEADER_TS ethernetII_ts;
         TEMPLATE_IPV6_HEADER ipv6_ethernetII;
         TEMPLATE_IPV6_HEADER_TS ipv6_ethernetII_ts;
         TEMPLATE_VLAN_IPV6_HEADER vlan_ipv6_ethernetII;
         TEMPLATE_VLAN_IPV6_HEADER_TS vlan_ipv6_ethernetII_ts;
         TEMPLATE_VLAN_HEADER vlan_ethernetII;
         TEMPLATE_VLAN_HEADER_TS vlan_ethernetII_ts;
         TEMPLATE_SNAP_HEADER snap;
         TEMPLATE_VLAN_SNAP_HEADER vlan_snap;
         UEXACT32 rsvd0[32];
         struct {
            UEXACT8 rsvd0[92];
            RXFILT_D filter_template[2];
            UEXACT32 reset_sequence;
         } extra;
      } SG_PACK MPU_TEMPLATE_HEADER, *PMPU_TEMPLATE_HEADER;

      typedef union _MPU_TEMPLATE_HEADER_UNION {
         MPU_TEMPLATE_HEADER bits;
         u32 dw[32]; // dword union
      } SG_PACK MPU_TEMPLATE_HEADER_UNION, *PMPU_TEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__MPU_TEMPLATE_HEADER_UNION, sizeof (MPU_TEMPLATE_HEADER_UNION) == 128);
   #endif


#else
   // Template header used in the offload IOCTLs.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_TEMPLATE_HEADER {
         union {
            union { 
               TEMPLATE_HEADER ethernetII;
               TEMPLATE_HEADER_TS ethernetII_ts;
               TEMPLATE_IPV6_HEADER ipv6_ethernetII;
               TEMPLATE_IPV6_HEADER_TS ipv6_ethernetII_ts;
               TEMPLATE_VLAN_IPV6_HEADER vlan_ipv6_ethernetII;
               TEMPLATE_VLAN_IPV6_HEADER_TS vlan_ipv6_ethernetII_ts;
               TEMPLATE_VLAN_HEADER vlan_ethernetII;
               TEMPLATE_VLAN_HEADER_TS vlan_ethernetII_ts;
               TEMPLATE_SNAP_HEADER snap;
               TEMPLATE_VLAN_SNAP_HEADER vlan_snap;
               UEXACT32 rsvd0[32];
               struct {
                  UEXACT8 rsvd0[92];
                  RXFILT_D filter_template[2];
                  UEXACT32 reset_sequence;
               } extra;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK MPU_TEMPLATE_HEADER, *PMPU_TEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__MPU_TEMPLATE_HEADER, sizeof (MPU_TEMPLATE_HEADER) == 128);

   #else
      typedef union _MPU_TEMPLATE_HEADER {
         TEMPLATE_HEADER ethernetII;
         TEMPLATE_HEADER_TS ethernetII_ts;
         TEMPLATE_IPV6_HEADER ipv6_ethernetII;
         TEMPLATE_IPV6_HEADER_TS ipv6_ethernetII_ts;
         TEMPLATE_VLAN_IPV6_HEADER vlan_ipv6_ethernetII;
         TEMPLATE_VLAN_IPV6_HEADER_TS vlan_ipv6_ethernetII_ts;
         TEMPLATE_VLAN_HEADER vlan_ethernetII;
         TEMPLATE_VLAN_HEADER_TS vlan_ethernetII_ts;
         TEMPLATE_SNAP_HEADER snap;
         TEMPLATE_VLAN_SNAP_HEADER vlan_snap;
         UEXACT32 rsvd0[32];
         struct {
            UEXACT8 rsvd0[92];
            RXFILT_D filter_template[2];
            UEXACT32 reset_sequence;
         } extra;
      } SG_PACK MPU_TEMPLATE_HEADER, *PMPU_TEMPLATE_HEADER;

      typedef union _MPU_TEMPLATE_HEADER_UNION {
         MPU_TEMPLATE_HEADER bits;
         u32 dw[32]; // dword union
      } SG_PACK MPU_TEMPLATE_HEADER_UNION, *PMPU_TEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__MPU_TEMPLATE_HEADER_UNION, sizeof (MPU_TEMPLATE_HEADER_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IPV4_OFFLOAD_CXN_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 dst_port : 16;                 // DWORD 1
               u32 src_port : 16;                 // DWORD 1
               u32 src_addr;                      // DWORD 2
               u32 dst_addr;                      // DWORD 3
               u32 rsvd1[3];                      // DWORDS 4 to 6
               u32 valid : 1;                     // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct0 : 2;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK MPU_IPV4_OFFLOAD_CXN_ENTRY, *PMPU_IPV4_OFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__MPU_IPV4_OFFLOAD_CXN_ENTRY, sizeof (MPU_IPV4_OFFLOAD_CXN_ENTRY) == 32);

   #else
      typedef struct _MPU_IPV4_OFFLOAD_CXN_ENTRY {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 dst_port : 16;                       // DWORD 1
         u32 src_port : 16;                       // DWORD 1
         u32 src_addr;                            // DWORD 2
         u32 dst_addr;                            // DWORD 3
         u32 rsvd1[3];                            // DWORDS 4 to 6
         u32 valid : 1;                           // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct0 : 2;                             // DWORD 7
      } SG_PACK MPU_IPV4_OFFLOAD_CXN_ENTRY, *PMPU_IPV4_OFFLOAD_CXN_ENTRY;

      typedef union _MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION {
         MPU_IPV4_OFFLOAD_CXN_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION, *PMPU_IPV4_OFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION, sizeof (MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION) == 32);
   #endif


#else
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IPV4_OFFLOAD_CXN_ENTRY {
         union {
            struct { 
               u32 mac_id : 6;                    // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
               u32 src_port : 16;                 // DWORD 1
               u32 dst_port : 16;                 // DWORD 1
               u32 src_addr;                      // DWORD 2
               u32 dst_addr;                      // DWORD 3
               u32 rsvd1[3];                      // DWORDS 4 to 6
               u32 ct0 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 valid : 1;                     // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK MPU_IPV4_OFFLOAD_CXN_ENTRY, *PMPU_IPV4_OFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__MPU_IPV4_OFFLOAD_CXN_ENTRY, sizeof (MPU_IPV4_OFFLOAD_CXN_ENTRY) == 32);

   #else
      typedef struct _MPU_IPV4_OFFLOAD_CXN_ENTRY {
         u32 mac_id : 6;                          // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
         u32 src_port : 16;                       // DWORD 1
         u32 dst_port : 16;                       // DWORD 1
         u32 src_addr;                            // DWORD 2
         u32 dst_addr;                            // DWORD 3
         u32 rsvd1[3];                            // DWORDS 4 to 6
         u32 ct0 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 valid : 1;                           // DWORD 7
      } SG_PACK MPU_IPV4_OFFLOAD_CXN_ENTRY, *PMPU_IPV4_OFFLOAD_CXN_ENTRY;

      typedef union _MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION {
         MPU_IPV4_OFFLOAD_CXN_ENTRY bits;
         u32 dw[8]; // dword union
      } SG_PACK MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION, *PMPU_IPV4_OFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION, sizeof (MPU_IPV4_OFFLOAD_CXN_ENTRY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IPV6_OFFLOAD_CXN_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 mac_id : 6;                    // DWORD 0
               u32 dst_port : 16;                 // DWORD 1
               u32 src_port : 16;                 // DWORD 1
               u32 src_addr[4];                   // DWORDS 2 to 5
               u32 rsvd1 : 26;                    // DWORD 6
               u32 da_id : 6;                     // DWORD 6
               u32 valid : 1;                     // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct0 : 2;                       // DWORD 7
               u32 dst_addr[4];                   // DWORDS 8 to 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK MPU_IPV6_OFFLOAD_CXN_ENTRY, *PMPU_IPV6_OFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__MPU_IPV6_OFFLOAD_CXN_ENTRY, sizeof (MPU_IPV6_OFFLOAD_CXN_ENTRY) == 48);

   #else
      typedef struct _MPU_IPV6_OFFLOAD_CXN_ENTRY {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 mac_id : 6;                          // DWORD 0
         u32 dst_port : 16;                       // DWORD 1
         u32 src_port : 16;                       // DWORD 1
         u32 src_addr[4];                         // DWORDS 2 to 5
         u32 rsvd1 : 26;                          // DWORD 6
         u32 da_id : 6;                           // DWORD 6
         u32 valid : 1;                           // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct0 : 2;                             // DWORD 7
         u32 dst_addr[4];                         // DWORDS 8 to 11
      } SG_PACK MPU_IPV6_OFFLOAD_CXN_ENTRY, *PMPU_IPV6_OFFLOAD_CXN_ENTRY;

      typedef union _MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION {
         MPU_IPV6_OFFLOAD_CXN_ENTRY bits;
         u32 dw[12]; // dword union
      } SG_PACK MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION, *PMPU_IPV6_OFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION, sizeof (MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION) == 48);
   #endif


#else
   // This structure defines a single offloaded connection entry in the Offload Connection
   // Table. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IPV6_OFFLOAD_CXN_ENTRY {
         union {
            struct { 
               u32 mac_id : 6;                    // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
               u32 src_port : 16;                 // DWORD 1
               u32 dst_port : 16;                 // DWORD 1
               u32 src_addr[4];                   // DWORDS 2 to 5
               u32 da_id : 6;                     // DWORD 6
               u32 rsvd1 : 26;                    // DWORD 6
               u32 ct0 : 2;                       // DWORD 7
               u32 rsvd2 : 6;                     // DWORD 7
               u32 ct1 : 2;                       // DWORD 7
               u32 rsvd3 : 21;                    // DWORD 7
               u32 valid : 1;                     // DWORD 7
               u32 dst_addr[4];                   // DWORDS 8 to 11
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK MPU_IPV6_OFFLOAD_CXN_ENTRY, *PMPU_IPV6_OFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__MPU_IPV6_OFFLOAD_CXN_ENTRY, sizeof (MPU_IPV6_OFFLOAD_CXN_ENTRY) == 48);

   #else
      typedef struct _MPU_IPV6_OFFLOAD_CXN_ENTRY {
         u32 mac_id : 6;                          // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
         u32 src_port : 16;                       // DWORD 1
         u32 dst_port : 16;                       // DWORD 1
         u32 src_addr[4];                         // DWORDS 2 to 5
         u32 da_id : 6;                           // DWORD 6
         u32 rsvd1 : 26;                          // DWORD 6
         u32 ct0 : 2;                             // DWORD 7
         u32 rsvd2 : 6;                           // DWORD 7
         u32 ct1 : 2;                             // DWORD 7
         u32 rsvd3 : 21;                          // DWORD 7
         u32 valid : 1;                           // DWORD 7
         u32 dst_addr[4];                         // DWORDS 8 to 11
      } SG_PACK MPU_IPV6_OFFLOAD_CXN_ENTRY, *PMPU_IPV6_OFFLOAD_CXN_ENTRY;

      typedef union _MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION {
         MPU_IPV6_OFFLOAD_CXN_ENTRY bits;
         u32 dw[12]; // dword union
      } SG_PACK MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION, *PMPU_IPV6_OFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION, sizeof (MPU_IPV6_OFFLOAD_CXN_ENTRY_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_OFFLOAD_CXN_ENTRY {
         union {
            union { 
               MPU_IPV4_OFFLOAD_CXN_ENTRY ipv4;
               MPU_IPV6_OFFLOAD_CXN_ENTRY ipv6;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK MPU_OFFLOAD_CXN_ENTRY, *PMPU_OFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__MPU_OFFLOAD_CXN_ENTRY, sizeof (MPU_OFFLOAD_CXN_ENTRY) == 48);

   #else
      typedef union _MPU_OFFLOAD_CXN_ENTRY {
         MPU_IPV4_OFFLOAD_CXN_ENTRY ipv4;
         MPU_IPV6_OFFLOAD_CXN_ENTRY ipv6;
      } SG_PACK MPU_OFFLOAD_CXN_ENTRY, *PMPU_OFFLOAD_CXN_ENTRY;

      typedef union _MPU_OFFLOAD_CXN_ENTRY_UNION {
         MPU_OFFLOAD_CXN_ENTRY bits;
         u32 dw[12]; // dword union
      } SG_PACK MPU_OFFLOAD_CXN_ENTRY_UNION, *PMPU_OFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MPU_OFFLOAD_CXN_ENTRY_UNION, sizeof (MPU_OFFLOAD_CXN_ENTRY_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_OFFLOAD_CXN_ENTRY {
         union {
            union { 
               MPU_IPV4_OFFLOAD_CXN_ENTRY ipv4;
               MPU_IPV6_OFFLOAD_CXN_ENTRY ipv6;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK MPU_OFFLOAD_CXN_ENTRY, *PMPU_OFFLOAD_CXN_ENTRY;

      SG_C_ASSERT(__sizeof__MPU_OFFLOAD_CXN_ENTRY, sizeof (MPU_OFFLOAD_CXN_ENTRY) == 48);

   #else
      typedef union _MPU_OFFLOAD_CXN_ENTRY {
         MPU_IPV4_OFFLOAD_CXN_ENTRY ipv4;
         MPU_IPV6_OFFLOAD_CXN_ENTRY ipv6;
      } SG_PACK MPU_OFFLOAD_CXN_ENTRY, *PMPU_OFFLOAD_CXN_ENTRY;

      typedef union _MPU_OFFLOAD_CXN_ENTRY_UNION {
         MPU_OFFLOAD_CXN_ENTRY bits;
         u32 dw[12]; // dword union
      } SG_PACK MPU_OFFLOAD_CXN_ENTRY_UNION, *PMPU_OFFLOAD_CXN_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MPU_OFFLOAD_CXN_ENTRY_UNION, sizeof (MPU_OFFLOAD_CXN_ENTRY_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ARP_TABLE_ENTRY {
      IP_ADDRESS_FORMAT ip_address;
      MAC_ADDRESS_FORMAT mac_address;
      UEXACT32 arp_flags;
      UEXACT32 rsvd0;
   } SG_PACK ARP_TABLE_ENTRY, *PARP_TABLE_ENTRY;



#else
   
   typedef struct _ARP_TABLE_ENTRY {
      IP_ADDRESS_FORMAT ip_address;
      MAC_ADDRESS_FORMAT mac_address;
      UEXACT32 arp_flags;
      UEXACT32 rsvd0;
   } SG_PACK ARP_TABLE_ENTRY, *PARP_TABLE_ENTRY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ROUTE_TABLE_ENTRY {
      IP_ADDRESS_SUBNET_FORMAT ip_address_subnet;
      IP_ADDRESS_FORMAT next_hop;
   } SG_PACK ROUTE_TABLE_ENTRY, *PROUTE_TABLE_ENTRY;



#else
   
   typedef struct _ROUTE_TABLE_ENTRY {
      IP_ADDRESS_SUBNET_FORMAT ip_address_subnet;
      IP_ADDRESS_FORMAT next_hop;
   } SG_PACK ROUTE_TABLE_ENTRY, *PROUTE_TABLE_ENTRY;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_types_bmap_h__

