/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ipsec_sa_structs_bmap_h__
#define __ipsec_sa_structs_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // AES Key for ENCRYPT_256. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES256_KEY {
         union {
            struct { 
               u32 aes_key[8];                    // DWORDS 0 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK AES256_KEY, *PAES256_KEY;

      SG_C_ASSERT(__sizeof__AES256_KEY, sizeof (AES256_KEY) == 32);

   #else
      typedef struct _AES256_KEY {
         u32 aes_key[8];                          // DWORDS 0 to 7
      } SG_PACK AES256_KEY, *PAES256_KEY;

      typedef union _AES256_KEY_UNION {
         AES256_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK AES256_KEY_UNION, *PAES256_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES256_KEY_UNION, sizeof (AES256_KEY_UNION) == 32);
   #endif


#else
   // AES Key for ENCRYPT_256. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES256_KEY {
         union {
            struct { 
               u32 aes_key[8];                    // DWORDS 0 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK AES256_KEY, *PAES256_KEY;

      SG_C_ASSERT(__sizeof__AES256_KEY, sizeof (AES256_KEY) == 32);

   #else
      typedef struct _AES256_KEY {
         u32 aes_key[8];                          // DWORDS 0 to 7
      } SG_PACK AES256_KEY, *PAES256_KEY;

      typedef union _AES256_KEY_UNION {
         AES256_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK AES256_KEY_UNION, *PAES256_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES256_KEY_UNION, sizeof (AES256_KEY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // AES Key for ENCRYPT_192. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES192_KEY {
         union {
            struct { 
               u32 aes_key[8];                    // DWORDS 0 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK AES192_KEY, *PAES192_KEY;

      SG_C_ASSERT(__sizeof__AES192_KEY, sizeof (AES192_KEY) == 32);

   #else
      typedef struct _AES192_KEY {
         u32 aes_key[8];                          // DWORDS 0 to 7
      } SG_PACK AES192_KEY, *PAES192_KEY;

      typedef union _AES192_KEY_UNION {
         AES192_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK AES192_KEY_UNION, *PAES192_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES192_KEY_UNION, sizeof (AES192_KEY_UNION) == 32);
   #endif


#else
   // AES Key for ENCRYPT_192. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES192_KEY {
         union {
            struct { 
               u32 aes_key[8];                    // DWORDS 0 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK AES192_KEY, *PAES192_KEY;

      SG_C_ASSERT(__sizeof__AES192_KEY, sizeof (AES192_KEY) == 32);

   #else
      typedef struct _AES192_KEY {
         u32 aes_key[8];                          // DWORDS 0 to 7
      } SG_PACK AES192_KEY, *PAES192_KEY;

      typedef union _AES192_KEY_UNION {
         AES192_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK AES192_KEY_UNION, *PAES192_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES192_KEY_UNION, sizeof (AES192_KEY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // AES Key for ENCRYPT_AES128. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES128_KEY {
         union {
            struct { 
               u32 aes_key[4];                    // DWORDS 0 to 3
               u32 rsvd0[4];                      // DWORDS 4 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK AES128_KEY, *PAES128_KEY;

      SG_C_ASSERT(__sizeof__AES128_KEY, sizeof (AES128_KEY) == 32);

   #else
      typedef struct _AES128_KEY {
         u32 aes_key[4];                          // DWORDS 0 to 3
         u32 rsvd0[4];                            // DWORDS 4 to 7
      } SG_PACK AES128_KEY, *PAES128_KEY;

      typedef union _AES128_KEY_UNION {
         AES128_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK AES128_KEY_UNION, *PAES128_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES128_KEY_UNION, sizeof (AES128_KEY_UNION) == 32);
   #endif


#else
   // AES Key for ENCRYPT_AES128. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES128_KEY {
         union {
            struct { 
               u32 aes_key[4];                    // DWORDS 0 to 3
               u32 rsvd0[4];                      // DWORDS 4 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK AES128_KEY, *PAES128_KEY;

      SG_C_ASSERT(__sizeof__AES128_KEY, sizeof (AES128_KEY) == 32);

   #else
      typedef struct _AES128_KEY {
         u32 aes_key[4];                          // DWORDS 0 to 3
         u32 rsvd0[4];                            // DWORDS 4 to 7
      } SG_PACK AES128_KEY, *PAES128_KEY;

      typedef union _AES128_KEY_UNION {
         AES128_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK AES128_KEY_UNION, *PAES128_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES128_KEY_UNION, sizeof (AES128_KEY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Triple DES three Key for ENCRYPT_3DES. For Two key Triple DES, write key3=key1. This
   // structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TDES_KEY {
         union {
            struct { 
               u32 tdes_key1[2];                  // DWORDS 0 to 1
               u32 tdes_key2[2];                  // DWORDS 2 to 3
               u32 tdes_key3[2];                  // DWORDS 4 to 5
               u32 rsvd0[2];                      // DWORDS 6 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK TDES_KEY, *PTDES_KEY;

      SG_C_ASSERT(__sizeof__TDES_KEY, sizeof (TDES_KEY) == 32);

   #else
      typedef struct _TDES_KEY {
         u32 tdes_key1[2];                        // DWORDS 0 to 1
         u32 tdes_key2[2];                        // DWORDS 2 to 3
         u32 tdes_key3[2];                        // DWORDS 4 to 5
         u32 rsvd0[2];                            // DWORDS 6 to 7
      } SG_PACK TDES_KEY, *PTDES_KEY;

      typedef union _TDES_KEY_UNION {
         TDES_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK TDES_KEY_UNION, *PTDES_KEY_UNION;

      SG_C_ASSERT(__sizeof__TDES_KEY_UNION, sizeof (TDES_KEY_UNION) == 32);
   #endif


#else
   // Triple DES three Key for ENCRYPT_3DES. For Two key Triple DES, write key3=key1. This
   // structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TDES_KEY {
         union {
            struct { 
               u32 tdes_key1[2];                  // DWORDS 0 to 1
               u32 tdes_key2[2];                  // DWORDS 2 to 3
               u32 tdes_key3[2];                  // DWORDS 4 to 5
               u32 rsvd0[2];                      // DWORDS 6 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK TDES_KEY, *PTDES_KEY;

      SG_C_ASSERT(__sizeof__TDES_KEY, sizeof (TDES_KEY) == 32);

   #else
      typedef struct _TDES_KEY {
         u32 tdes_key1[2];                        // DWORDS 0 to 1
         u32 tdes_key2[2];                        // DWORDS 2 to 3
         u32 tdes_key3[2];                        // DWORDS 4 to 5
         u32 rsvd0[2];                            // DWORDS 6 to 7
      } SG_PACK TDES_KEY, *PTDES_KEY;

      typedef union _TDES_KEY_UNION {
         TDES_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK TDES_KEY_UNION, *PTDES_KEY_UNION;

      SG_C_ASSERT(__sizeof__TDES_KEY_UNION, sizeof (TDES_KEY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Single DES Key for ENCRYPT_DES.This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _DES_KEY {
         union {
            struct { 
               u32 tdes_key1[2];                  // DWORDS 0 to 1
               u32 rsvd0[6];                      // DWORDS 2 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DES_KEY, *PDES_KEY;

      SG_C_ASSERT(__sizeof__DES_KEY, sizeof (DES_KEY) == 32);

   #else
      typedef struct _DES_KEY {
         u32 tdes_key1[2];                        // DWORDS 0 to 1
         u32 rsvd0[6];                            // DWORDS 2 to 7
      } SG_PACK DES_KEY, *PDES_KEY;

      typedef union _DES_KEY_UNION {
         DES_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK DES_KEY_UNION, *PDES_KEY_UNION;

      SG_C_ASSERT(__sizeof__DES_KEY_UNION, sizeof (DES_KEY_UNION) == 32);
   #endif


#else
   // Single DES Key for ENCRYPT_DES.This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _DES_KEY {
         union {
            struct { 
               u32 tdes_key1[2];                  // DWORDS 0 to 1
               u32 rsvd0[6];                      // DWORDS 2 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK DES_KEY, *PDES_KEY;

      SG_C_ASSERT(__sizeof__DES_KEY, sizeof (DES_KEY) == 32);

   #else
      typedef struct _DES_KEY {
         u32 tdes_key1[2];                        // DWORDS 0 to 1
         u32 rsvd0[6];                            // DWORDS 2 to 7
      } SG_PACK DES_KEY, *PDES_KEY;

      typedef union _DES_KEY_UNION {
         DES_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK DES_KEY_UNION, *PDES_KEY_UNION;

      SG_C_ASSERT(__sizeof__DES_KEY_UNION, sizeof (DES_KEY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Cipher Key of type AES128/AES192/AES256/3DES/DES. If NULL this structure is not
   // used.
   #if defined(SG_BMAP_UNION)
      typedef struct _CIPHER_KEY {
         union {
            union { 
               DES_KEY des;
               TDES_KEY tdes;
               AES128_KEY aes128;
               AES192_KEY aes192;
               AES256_KEY aes256;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK CIPHER_KEY, *PCIPHER_KEY;

      SG_C_ASSERT(__sizeof__CIPHER_KEY, sizeof (CIPHER_KEY) == 32);

   #else
      typedef union _CIPHER_KEY {
         DES_KEY des;
         TDES_KEY tdes;
         AES128_KEY aes128;
         AES192_KEY aes192;
         AES256_KEY aes256;
      } SG_PACK CIPHER_KEY, *PCIPHER_KEY;

      typedef union _CIPHER_KEY_UNION {
         CIPHER_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK CIPHER_KEY_UNION, *PCIPHER_KEY_UNION;

      SG_C_ASSERT(__sizeof__CIPHER_KEY_UNION, sizeof (CIPHER_KEY_UNION) == 32);
   #endif


#else
   // Cipher Key of type AES128/AES192/AES256/3DES/DES. If NULL this structure is not
   // used.
   #if defined(SG_BMAP_UNION)
      typedef struct _CIPHER_KEY {
         union {
            union { 
               DES_KEY des;
               TDES_KEY tdes;
               AES128_KEY aes128;
               AES192_KEY aes192;
               AES256_KEY aes256;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK CIPHER_KEY, *PCIPHER_KEY;

      SG_C_ASSERT(__sizeof__CIPHER_KEY, sizeof (CIPHER_KEY) == 32);

   #else
      typedef union _CIPHER_KEY {
         DES_KEY des;
         TDES_KEY tdes;
         AES128_KEY aes128;
         AES192_KEY aes192;
         AES256_KEY aes256;
      } SG_PACK CIPHER_KEY, *PCIPHER_KEY;

      typedef union _CIPHER_KEY_UNION {
         CIPHER_KEY bits;
         u32 dw[8]; // dword union
      } SG_PACK CIPHER_KEY_UNION, *PCIPHER_KEY_UNION;

      SG_C_ASSERT(__sizeof__CIPHER_KEY_UNION, sizeof (CIPHER_KEY_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // SHA-1 Key. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _SHA1_KEY {
         union {
            struct { 
               u32 sha1_key[5];                   // DWORDS 0 to 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK SHA1_KEY, *PSHA1_KEY;

      SG_C_ASSERT(__sizeof__SHA1_KEY, sizeof (SHA1_KEY) == 20);

   #else
      typedef struct _SHA1_KEY {
         u32 sha1_key[5];                         // DWORDS 0 to 4
      } SG_PACK SHA1_KEY, *PSHA1_KEY;

      typedef union _SHA1_KEY_UNION {
         SHA1_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK SHA1_KEY_UNION, *PSHA1_KEY_UNION;

      SG_C_ASSERT(__sizeof__SHA1_KEY_UNION, sizeof (SHA1_KEY_UNION) == 20);
   #endif


#else
   // SHA-1 Key. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _SHA1_KEY {
         union {
            struct { 
               u32 sha1_key[5];                   // DWORDS 0 to 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK SHA1_KEY, *PSHA1_KEY;

      SG_C_ASSERT(__sizeof__SHA1_KEY, sizeof (SHA1_KEY) == 20);

   #else
      typedef struct _SHA1_KEY {
         u32 sha1_key[5];                         // DWORDS 0 to 4
      } SG_PACK SHA1_KEY, *PSHA1_KEY;

      typedef union _SHA1_KEY_UNION {
         SHA1_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK SHA1_KEY_UNION, *PSHA1_KEY_UNION;

      SG_C_ASSERT(__sizeof__SHA1_KEY_UNION, sizeof (SHA1_KEY_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MD5 Key. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _MD5_KEY {
         union {
            struct { 
               u32 md5_key[4];                    // DWORDS 0 to 3
               u32 rsvd0[1];                      // DWORDS 4 to 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK MD5_KEY, *PMD5_KEY;

      SG_C_ASSERT(__sizeof__MD5_KEY, sizeof (MD5_KEY) == 20);

   #else
      typedef struct _MD5_KEY {
         u32 md5_key[4];                          // DWORDS 0 to 3
         u32 rsvd0[1];                            // DWORDS 4 to 4
      } SG_PACK MD5_KEY, *PMD5_KEY;

      typedef union _MD5_KEY_UNION {
         MD5_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK MD5_KEY_UNION, *PMD5_KEY_UNION;

      SG_C_ASSERT(__sizeof__MD5_KEY_UNION, sizeof (MD5_KEY_UNION) == 20);
   #endif


#else
   // MD5 Key. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _MD5_KEY {
         union {
            struct { 
               u32 md5_key[4];                    // DWORDS 0 to 3
               u32 rsvd0[1];                      // DWORDS 4 to 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK MD5_KEY, *PMD5_KEY;

      SG_C_ASSERT(__sizeof__MD5_KEY, sizeof (MD5_KEY) == 20);

   #else
      typedef struct _MD5_KEY {
         u32 md5_key[4];                          // DWORDS 0 to 3
         u32 rsvd0[1];                            // DWORDS 4 to 4
      } SG_PACK MD5_KEY, *PMD5_KEY;

      typedef union _MD5_KEY_UNION {
         MD5_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK MD5_KEY_UNION, *PMD5_KEY_UNION;

      SG_C_ASSERT(__sizeof__MD5_KEY_UNION, sizeof (MD5_KEY_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // AES-XCBC-MAC Key. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES_XCBC_MAC_KEY {
         union {
            struct { 
               u32 aes_xcbc_key[4];               // DWORDS 0 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK AES_XCBC_MAC_KEY, *PAES_XCBC_MAC_KEY;

      SG_C_ASSERT(__sizeof__AES_XCBC_MAC_KEY, sizeof (AES_XCBC_MAC_KEY) == 16);

   #else
      typedef struct _AES_XCBC_MAC_KEY {
         u32 aes_xcbc_key[4];                     // DWORDS 0 to 3
      } SG_PACK AES_XCBC_MAC_KEY, *PAES_XCBC_MAC_KEY;

      typedef union _AES_XCBC_MAC_KEY_UNION {
         AES_XCBC_MAC_KEY bits;
         u32 dw[4]; // dword union
      } SG_PACK AES_XCBC_MAC_KEY_UNION, *PAES_XCBC_MAC_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES_XCBC_MAC_KEY_UNION, sizeof (AES_XCBC_MAC_KEY_UNION) == 16);
   #endif


#else
   // AES-XCBC-MAC Key. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AES_XCBC_MAC_KEY {
         union {
            struct { 
               u32 aes_xcbc_key[4];               // DWORDS 0 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK AES_XCBC_MAC_KEY, *PAES_XCBC_MAC_KEY;

      SG_C_ASSERT(__sizeof__AES_XCBC_MAC_KEY, sizeof (AES_XCBC_MAC_KEY) == 16);

   #else
      typedef struct _AES_XCBC_MAC_KEY {
         u32 aes_xcbc_key[4];                     // DWORDS 0 to 3
      } SG_PACK AES_XCBC_MAC_KEY, *PAES_XCBC_MAC_KEY;

      typedef union _AES_XCBC_MAC_KEY_UNION {
         AES_XCBC_MAC_KEY bits;
         u32 dw[4]; // dword union
      } SG_PACK AES_XCBC_MAC_KEY_UNION, *PAES_XCBC_MAC_KEY_UNION;

      SG_C_ASSERT(__sizeof__AES_XCBC_MAC_KEY_UNION, sizeof (AES_XCBC_MAC_KEY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Pre-Computed HMAC Inner Digest Key (two choices, unioned). This field has the hash
   // digest value after hashing the first 64 bytes of HMAC inner digest.
   #if defined(SG_BMAP_UNION)
      typedef struct _IDIGEST_KEY {
         union {
            union { 
               SHA1_KEY sha1;
               MD5_KEY md5;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IDIGEST_KEY, *PIDIGEST_KEY;

      SG_C_ASSERT(__sizeof__IDIGEST_KEY, sizeof (IDIGEST_KEY) == 20);

   #else
      typedef union _IDIGEST_KEY {
         SHA1_KEY sha1;
         MD5_KEY md5;
      } SG_PACK IDIGEST_KEY, *PIDIGEST_KEY;

      typedef union _IDIGEST_KEY_UNION {
         IDIGEST_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK IDIGEST_KEY_UNION, *PIDIGEST_KEY_UNION;

      SG_C_ASSERT(__sizeof__IDIGEST_KEY_UNION, sizeof (IDIGEST_KEY_UNION) == 20);
   #endif


#else
   // Pre-Computed HMAC Inner Digest Key (two choices, unioned). This field has the hash
   // digest value after hashing the first 64 bytes of HMAC inner digest.
   #if defined(SG_BMAP_UNION)
      typedef struct _IDIGEST_KEY {
         union {
            union { 
               SHA1_KEY sha1;
               MD5_KEY md5;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IDIGEST_KEY, *PIDIGEST_KEY;

      SG_C_ASSERT(__sizeof__IDIGEST_KEY, sizeof (IDIGEST_KEY) == 20);

   #else
      typedef union _IDIGEST_KEY {
         SHA1_KEY sha1;
         MD5_KEY md5;
      } SG_PACK IDIGEST_KEY, *PIDIGEST_KEY;

      typedef union _IDIGEST_KEY_UNION {
         IDIGEST_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK IDIGEST_KEY_UNION, *PIDIGEST_KEY_UNION;

      SG_C_ASSERT(__sizeof__IDIGEST_KEY_UNION, sizeof (IDIGEST_KEY_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Pre-Computed HMAC Outer Digest Key (two choices, unioned). This field has the hash
   // digest value after hashing the first 64 bytes of HMAC outer digest.
   #if defined(SG_BMAP_UNION)
      typedef struct _ODIGEST_KEY {
         union {
            union { 
               SHA1_KEY sha1;
               MD5_KEY md5;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK ODIGEST_KEY, *PODIGEST_KEY;

      SG_C_ASSERT(__sizeof__ODIGEST_KEY, sizeof (ODIGEST_KEY) == 20);

   #else
      typedef union _ODIGEST_KEY {
         SHA1_KEY sha1;
         MD5_KEY md5;
      } SG_PACK ODIGEST_KEY, *PODIGEST_KEY;

      typedef union _ODIGEST_KEY_UNION {
         ODIGEST_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK ODIGEST_KEY_UNION, *PODIGEST_KEY_UNION;

      SG_C_ASSERT(__sizeof__ODIGEST_KEY_UNION, sizeof (ODIGEST_KEY_UNION) == 20);
   #endif


#else
   // Pre-Computed HMAC Outer Digest Key (two choices, unioned). This field has the hash
   // digest value after hashing the first 64 bytes of HMAC outer digest.
   #if defined(SG_BMAP_UNION)
      typedef struct _ODIGEST_KEY {
         union {
            union { 
               SHA1_KEY sha1;
               MD5_KEY md5;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK ODIGEST_KEY, *PODIGEST_KEY;

      SG_C_ASSERT(__sizeof__ODIGEST_KEY, sizeof (ODIGEST_KEY) == 20);

   #else
      typedef union _ODIGEST_KEY {
         SHA1_KEY sha1;
         MD5_KEY md5;
      } SG_PACK ODIGEST_KEY, *PODIGEST_KEY;

      typedef union _ODIGEST_KEY_UNION {
         ODIGEST_KEY bits;
         u32 dw[5]; // dword union
      } SG_PACK ODIGEST_KEY_UNION, *PODIGEST_KEY_UNION;

      SG_C_ASSERT(__sizeof__ODIGEST_KEY_UNION, sizeof (ODIGEST_KEY_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Pre-Computed HMAC Keys. If Authenticaion type is AUTHENT_NONE, this structure is not
   // used. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _HMAC_IO_KEY {
         union {
            struct { 
               IDIGEST_KEY idigest;
               ODIGEST_KEY odigest;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK HMAC_IO_KEY, *PHMAC_IO_KEY;

      SG_C_ASSERT(__sizeof__HMAC_IO_KEY, sizeof (HMAC_IO_KEY) == 40);

   #else
      typedef struct _HMAC_IO_KEY {
         IDIGEST_KEY idigest;
         ODIGEST_KEY odigest;
      } SG_PACK HMAC_IO_KEY, *PHMAC_IO_KEY;

      typedef union _HMAC_IO_KEY_UNION {
         HMAC_IO_KEY bits;
         u32 dw[10]; // dword union
      } SG_PACK HMAC_IO_KEY_UNION, *PHMAC_IO_KEY_UNION;

      SG_C_ASSERT(__sizeof__HMAC_IO_KEY_UNION, sizeof (HMAC_IO_KEY_UNION) == 40);
   #endif


#else
   // Pre-Computed HMAC Keys. If Authenticaion type is AUTHENT_NONE, this structure is not
   // used. This structure is common to both RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _HMAC_IO_KEY {
         union {
            struct { 
               IDIGEST_KEY idigest;
               ODIGEST_KEY odigest;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK HMAC_IO_KEY, *PHMAC_IO_KEY;

      SG_C_ASSERT(__sizeof__HMAC_IO_KEY, sizeof (HMAC_IO_KEY) == 40);

   #else
      typedef struct _HMAC_IO_KEY {
         IDIGEST_KEY idigest;
         ODIGEST_KEY odigest;
      } SG_PACK HMAC_IO_KEY, *PHMAC_IO_KEY;

      typedef union _HMAC_IO_KEY_UNION {
         HMAC_IO_KEY bits;
         u32 dw[10]; // dword union
      } SG_PACK HMAC_IO_KEY_UNION, *PHMAC_IO_KEY_UNION;

      SG_C_ASSERT(__sizeof__HMAC_IO_KEY_UNION, sizeof (HMAC_IO_KEY_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Pre-Computed HMAC Keys or AES-XCBC-MAC key (two choices, unioned). If Authenticaion
   // type is AUTHENT_NONE, this structure is not used. This structure is common to both
   // RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AUTHENT_KEY {
         union {
            union { 
               HMAC_IO_KEY hmac_io;
               AES_XCBC_MAC_KEY aes_xcbc;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK AUTHENT_KEY, *PAUTHENT_KEY;

      SG_C_ASSERT(__sizeof__AUTHENT_KEY, sizeof (AUTHENT_KEY) == 40);

   #else
      typedef union _AUTHENT_KEY {
         HMAC_IO_KEY hmac_io;
         AES_XCBC_MAC_KEY aes_xcbc;
      } SG_PACK AUTHENT_KEY, *PAUTHENT_KEY;

      typedef union _AUTHENT_KEY_UNION {
         AUTHENT_KEY bits;
         u32 dw[10]; // dword union
      } SG_PACK AUTHENT_KEY_UNION, *PAUTHENT_KEY_UNION;

      SG_C_ASSERT(__sizeof__AUTHENT_KEY_UNION, sizeof (AUTHENT_KEY_UNION) == 40);
   #endif


#else
   // Pre-Computed HMAC Keys or AES-XCBC-MAC key (two choices, unioned). If Authenticaion
   // type is AUTHENT_NONE, this structure is not used. This structure is common to both
   // RxIPS and TxIPS SAs.
   #if defined(SG_BMAP_UNION)
      typedef struct _AUTHENT_KEY {
         union {
            union { 
               HMAC_IO_KEY hmac_io;
               AES_XCBC_MAC_KEY aes_xcbc;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK AUTHENT_KEY, *PAUTHENT_KEY;

      SG_C_ASSERT(__sizeof__AUTHENT_KEY, sizeof (AUTHENT_KEY) == 40);

   #else
      typedef union _AUTHENT_KEY {
         HMAC_IO_KEY hmac_io;
         AES_XCBC_MAC_KEY aes_xcbc;
      } SG_PACK AUTHENT_KEY, *PAUTHENT_KEY;

      typedef union _AUTHENT_KEY_UNION {
         AUTHENT_KEY bits;
         u32 dw[10]; // dword union
      } SG_PACK AUTHENT_KEY_UNION, *PAUTHENT_KEY_UNION;

      SG_C_ASSERT(__sizeof__AUTHENT_KEY_UNION, sizeof (AUTHENT_KEY_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RxIPS Security Association Context. This is located in the RxIPS SRAM. The SRAM
   // contains 64 SAs. Incoming IPSec datagrams index into the appropriate SA using index
   // bits from RxPP.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXIPS_SA {
         union {
            struct { 
               u32 Valid : 1;                     // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 HardByteOutSts : 1;            // DWORD 0
               u32 HardTimeOutSts : 1;            // DWORD 0
               u32 SoftByteOutSts : 1;            // DWORD 0
               u32 SoftTimeOutSts : 1;            // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 AntiReplaySz : 1;              // DWORD 0
               u32 AntiReplay : 1;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 HardByteOutEn : 1;             // DWORD 0
               u32 HardTimeOutEn : 1;             // DWORD 0
               u32 SoftByteOutEn : 1;             // DWORD 0
               u32 SoftTimeOutEn : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 Protocol : 1;                  // DWORD 0
               u32 Authentication : 4;            // DWORD 0
               u32 Encryption : 4;                // DWORD 0
               u32 SPI;                           // DWORD 1
               u32 ARHighSeqNum;                  // DWORD 2
               u32 AesCMNonce;                    // DWORD 3
               u32 SPIWin[2];                     // DWORDS 4 to 5
               u32 CurByteCnt[2];                 // DWORDS 6 to 7
               u32 SoftTimeOut;                   // DWORD 8
               u32 HardTimeOut;                   // DWORD 9
               u32 SoftByteOut[2];                // DWORDS 10 to 11
               u32 HardByteOut[2];                // DWORDS 12 to 13
               AUTHENT_KEY authent_key;
               CIPHER_KEY cipher_key;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RXIPS_SA, *PRXIPS_SA;

      SG_C_ASSERT(__sizeof__RXIPS_SA, sizeof (RXIPS_SA) == 128);

   #else
      typedef struct _RXIPS_SA {
         u32 Valid : 1;                           // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 HardByteOutSts : 1;                  // DWORD 0
         u32 HardTimeOutSts : 1;                  // DWORD 0
         u32 SoftByteOutSts : 1;                  // DWORD 0
         u32 SoftTimeOutSts : 1;                  // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 AntiReplaySz : 1;                    // DWORD 0
         u32 AntiReplay : 1;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 HardByteOutEn : 1;                   // DWORD 0
         u32 HardTimeOutEn : 1;                   // DWORD 0
         u32 SoftByteOutEn : 1;                   // DWORD 0
         u32 SoftTimeOutEn : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 Protocol : 1;                        // DWORD 0
         u32 Authentication : 4;                  // DWORD 0
         u32 Encryption : 4;                      // DWORD 0
         u32 SPI;                                 // DWORD 1
         u32 ARHighSeqNum;                        // DWORD 2
         u32 AesCMNonce;                          // DWORD 3
         u32 SPIWin[2];                           // DWORDS 4 to 5
         u32 CurByteCnt[2];                       // DWORDS 6 to 7
         u32 SoftTimeOut;                         // DWORD 8
         u32 HardTimeOut;                         // DWORD 9
         u32 SoftByteOut[2];                      // DWORDS 10 to 11
         u32 HardByteOut[2];                      // DWORDS 12 to 13
         AUTHENT_KEY authent_key;
         CIPHER_KEY cipher_key;
      } SG_PACK RXIPS_SA, *PRXIPS_SA;

      typedef union _RXIPS_SA_UNION {
         RXIPS_SA bits;
         u32 dw[32]; // dword union
      } SG_PACK RXIPS_SA_UNION, *PRXIPS_SA_UNION;

      SG_C_ASSERT(__sizeof__RXIPS_SA_UNION, sizeof (RXIPS_SA_UNION) == 128);
   #endif


#else
   // RxIPS Security Association Context. This is located in the RxIPS SRAM. The SRAM
   // contains 64 SAs. Incoming IPSec datagrams index into the appropriate SA using index
   // bits from RxPP.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXIPS_SA {
         union {
            struct { 
               u32 Encryption : 4;                // DWORD 0
               u32 Authentication : 4;            // DWORD 0
               u32 Protocol : 1;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 SoftTimeOutEn : 1;             // DWORD 0
               u32 SoftByteOutEn : 1;             // DWORD 0
               u32 HardTimeOutEn : 1;             // DWORD 0
               u32 HardByteOutEn : 1;             // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 AntiReplay : 1;                // DWORD 0
               u32 AntiReplaySz : 1;              // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 SoftTimeOutSts : 1;            // DWORD 0
               u32 SoftByteOutSts : 1;            // DWORD 0
               u32 HardTimeOutSts : 1;            // DWORD 0
               u32 HardByteOutSts : 1;            // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 Valid : 1;                     // DWORD 0
               u32 SPI;                           // DWORD 1
               u32 ARHighSeqNum;                  // DWORD 2
               u32 AesCMNonce;                    // DWORD 3
               u32 SPIWin[2];                     // DWORDS 4 to 5
               u32 CurByteCnt[2];                 // DWORDS 6 to 7
               u32 SoftTimeOut;                   // DWORD 8
               u32 HardTimeOut;                   // DWORD 9
               u32 SoftByteOut[2];                // DWORDS 10 to 11
               u32 HardByteOut[2];                // DWORDS 12 to 13
               AUTHENT_KEY authent_key;
               CIPHER_KEY cipher_key;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RXIPS_SA, *PRXIPS_SA;

      SG_C_ASSERT(__sizeof__RXIPS_SA, sizeof (RXIPS_SA) == 128);

   #else
      typedef struct _RXIPS_SA {
         u32 Encryption : 4;                      // DWORD 0
         u32 Authentication : 4;                  // DWORD 0
         u32 Protocol : 1;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 SoftTimeOutEn : 1;                   // DWORD 0
         u32 SoftByteOutEn : 1;                   // DWORD 0
         u32 HardTimeOutEn : 1;                   // DWORD 0
         u32 HardByteOutEn : 1;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 AntiReplay : 1;                      // DWORD 0
         u32 AntiReplaySz : 1;                    // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 SoftTimeOutSts : 1;                  // DWORD 0
         u32 SoftByteOutSts : 1;                  // DWORD 0
         u32 HardTimeOutSts : 1;                  // DWORD 0
         u32 HardByteOutSts : 1;                  // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 Valid : 1;                           // DWORD 0
         u32 SPI;                                 // DWORD 1
         u32 ARHighSeqNum;                        // DWORD 2
         u32 AesCMNonce;                          // DWORD 3
         u32 SPIWin[2];                           // DWORDS 4 to 5
         u32 CurByteCnt[2];                       // DWORDS 6 to 7
         u32 SoftTimeOut;                         // DWORD 8
         u32 HardTimeOut;                         // DWORD 9
         u32 SoftByteOut[2];                      // DWORDS 10 to 11
         u32 HardByteOut[2];                      // DWORDS 12 to 13
         AUTHENT_KEY authent_key;
         CIPHER_KEY cipher_key;
      } SG_PACK RXIPS_SA, *PRXIPS_SA;

      typedef union _RXIPS_SA_UNION {
         RXIPS_SA bits;
         u32 dw[32]; // dword union
      } SG_PACK RXIPS_SA_UNION, *PRXIPS_SA_UNION;

      SG_C_ASSERT(__sizeof__RXIPS_SA_UNION, sizeof (RXIPS_SA_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TxIPS Security Association Context. This is located in the TxIPS SRAM. The SRAM
   // contains 64 SAs. Incoming IPSec datagrams index into the appropriate SA using index
   // field from TXP block.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXIPS_SA {
         union {
            struct { 
               u32 Valid : 1;                     // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 SeqOverflowSts : 1;            // DWORD 0
               u32 HardByteOutSts : 1;            // DWORD 0
               u32 HardTimeOutSts : 1;            // DWORD 0
               u32 SoftByteOutSts : 1;            // DWORD 0
               u32 SoftTimeOutSts : 1;            // DWORD 0
               u32 rsvd3 : 6;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 AntiReplay : 1;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 HardByteOutEn : 1;             // DWORD 0
               u32 HardTimeOutEn : 1;             // DWORD 0
               u32 SoftByteOutEn : 1;             // DWORD 0
               u32 SoftTimeOutEn : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 Protocol : 1;                  // DWORD 0
               u32 Authentication : 4;            // DWORD 0
               u32 Encryption : 4;                // DWORD 0
               u32 SPI;                           // DWORD 1
               u32 SeqNum;                        // DWORD 2
               u32 AesCMNonce;                    // DWORD 3
               u32 rsvd5[2];                      // DWORDS 4 to 5
               u32 CurByteCnt[2];                 // DWORDS 6 to 7
               u32 SoftTimeOut;                   // DWORD 8
               u32 HardTimeOut;                   // DWORD 9
               u32 SoftByteOut[2];                // DWORDS 10 to 11
               u32 HardByteOut[2];                // DWORDS 12 to 13
               AUTHENT_KEY authent_key;
               CIPHER_KEY cipher_key;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK TXIPS_SA, *PTXIPS_SA;

      SG_C_ASSERT(__sizeof__TXIPS_SA, sizeof (TXIPS_SA) == 128);

   #else
      typedef struct _TXIPS_SA {
         u32 Valid : 1;                           // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 SeqOverflowSts : 1;                  // DWORD 0
         u32 HardByteOutSts : 1;                  // DWORD 0
         u32 HardTimeOutSts : 1;                  // DWORD 0
         u32 SoftByteOutSts : 1;                  // DWORD 0
         u32 SoftTimeOutSts : 1;                  // DWORD 0
         u32 rsvd3 : 6;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 AntiReplay : 1;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 HardByteOutEn : 1;                   // DWORD 0
         u32 HardTimeOutEn : 1;                   // DWORD 0
         u32 SoftByteOutEn : 1;                   // DWORD 0
         u32 SoftTimeOutEn : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 Protocol : 1;                        // DWORD 0
         u32 Authentication : 4;                  // DWORD 0
         u32 Encryption : 4;                      // DWORD 0
         u32 SPI;                                 // DWORD 1
         u32 SeqNum;                              // DWORD 2
         u32 AesCMNonce;                          // DWORD 3
         u32 rsvd5[2];                            // DWORDS 4 to 5
         u32 CurByteCnt[2];                       // DWORDS 6 to 7
         u32 SoftTimeOut;                         // DWORD 8
         u32 HardTimeOut;                         // DWORD 9
         u32 SoftByteOut[2];                      // DWORDS 10 to 11
         u32 HardByteOut[2];                      // DWORDS 12 to 13
         AUTHENT_KEY authent_key;
         CIPHER_KEY cipher_key;
      } SG_PACK TXIPS_SA, *PTXIPS_SA;

      typedef union _TXIPS_SA_UNION {
         TXIPS_SA bits;
         u32 dw[32]; // dword union
      } SG_PACK TXIPS_SA_UNION, *PTXIPS_SA_UNION;

      SG_C_ASSERT(__sizeof__TXIPS_SA_UNION, sizeof (TXIPS_SA_UNION) == 128);
   #endif


#else
   // TxIPS Security Association Context. This is located in the TxIPS SRAM. The SRAM
   // contains 64 SAs. Incoming IPSec datagrams index into the appropriate SA using index
   // field from TXP block.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXIPS_SA {
         union {
            struct { 
               u32 Encryption : 4;                // DWORD 0
               u32 Authentication : 4;            // DWORD 0
               u32 Protocol : 1;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 SoftTimeOutEn : 1;             // DWORD 0
               u32 SoftByteOutEn : 1;             // DWORD 0
               u32 HardTimeOutEn : 1;             // DWORD 0
               u32 HardByteOutEn : 1;             // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 AntiReplay : 1;                // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd3 : 6;                     // DWORD 0
               u32 SoftTimeOutSts : 1;            // DWORD 0
               u32 SoftByteOutSts : 1;            // DWORD 0
               u32 HardTimeOutSts : 1;            // DWORD 0
               u32 HardByteOutSts : 1;            // DWORD 0
               u32 SeqOverflowSts : 1;            // DWORD 0
               u32 rsvd4 : 2;                     // DWORD 0
               u32 Valid : 1;                     // DWORD 0
               u32 SPI;                           // DWORD 1
               u32 SeqNum;                        // DWORD 2
               u32 AesCMNonce;                    // DWORD 3
               u32 rsvd5[2];                      // DWORDS 4 to 5
               u32 CurByteCnt[2];                 // DWORDS 6 to 7
               u32 SoftTimeOut;                   // DWORD 8
               u32 HardTimeOut;                   // DWORD 9
               u32 SoftByteOut[2];                // DWORDS 10 to 11
               u32 HardByteOut[2];                // DWORDS 12 to 13
               AUTHENT_KEY authent_key;
               CIPHER_KEY cipher_key;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK TXIPS_SA, *PTXIPS_SA;

      SG_C_ASSERT(__sizeof__TXIPS_SA, sizeof (TXIPS_SA) == 128);

   #else
      typedef struct _TXIPS_SA {
         u32 Encryption : 4;                      // DWORD 0
         u32 Authentication : 4;                  // DWORD 0
         u32 Protocol : 1;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 SoftTimeOutEn : 1;                   // DWORD 0
         u32 SoftByteOutEn : 1;                   // DWORD 0
         u32 HardTimeOutEn : 1;                   // DWORD 0
         u32 HardByteOutEn : 1;                   // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 AntiReplay : 1;                      // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 6;                           // DWORD 0
         u32 SoftTimeOutSts : 1;                  // DWORD 0
         u32 SoftByteOutSts : 1;                  // DWORD 0
         u32 HardTimeOutSts : 1;                  // DWORD 0
         u32 HardByteOutSts : 1;                  // DWORD 0
         u32 SeqOverflowSts : 1;                  // DWORD 0
         u32 rsvd4 : 2;                           // DWORD 0
         u32 Valid : 1;                           // DWORD 0
         u32 SPI;                                 // DWORD 1
         u32 SeqNum;                              // DWORD 2
         u32 AesCMNonce;                          // DWORD 3
         u32 rsvd5[2];                            // DWORDS 4 to 5
         u32 CurByteCnt[2];                       // DWORDS 6 to 7
         u32 SoftTimeOut;                         // DWORD 8
         u32 HardTimeOut;                         // DWORD 9
         u32 SoftByteOut[2];                      // DWORDS 10 to 11
         u32 HardByteOut[2];                      // DWORDS 12 to 13
         AUTHENT_KEY authent_key;
         CIPHER_KEY cipher_key;
      } SG_PACK TXIPS_SA, *PTXIPS_SA;

      typedef union _TXIPS_SA_UNION {
         TXIPS_SA bits;
         u32 dw[32]; // dword union
      } SG_PACK TXIPS_SA_UNION, *PTXIPS_SA_UNION;

      SG_C_ASSERT(__sizeof__TXIPS_SA_UNION, sizeof (TXIPS_SA_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The following table defines the layout of RxIPS Security Association context SRAM. 
   // The total size of this dedicated SRAM in RxIPS is 16384 bytes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXIPS_MEMORY_MAP {
         union {
            struct { 
               RXIPS_SA rxips_sat[128];
            } SG_PACK ; // unnamed struct
            u32 dw[4096]; // dword union
         }; // unnamed union
      } SG_PACK RXIPS_MEMORY_MAP, *PRXIPS_MEMORY_MAP;

      SG_C_ASSERT(__sizeof__RXIPS_MEMORY_MAP, sizeof (RXIPS_MEMORY_MAP) == 16384);

   #else
      typedef struct _RXIPS_MEMORY_MAP {
         RXIPS_SA rxips_sat[128];
      } SG_PACK RXIPS_MEMORY_MAP, *PRXIPS_MEMORY_MAP;

      typedef union _RXIPS_MEMORY_MAP_UNION {
         RXIPS_MEMORY_MAP bits;
         u32 dw[4096]; // dword union
      } SG_PACK RXIPS_MEMORY_MAP_UNION, *PRXIPS_MEMORY_MAP_UNION;

      SG_C_ASSERT(__sizeof__RXIPS_MEMORY_MAP_UNION, sizeof (RXIPS_MEMORY_MAP_UNION) == 16384);
   #endif


#else
   // The following table defines the layout of RxIPS Security Association context SRAM. 
   // The total size of this dedicated SRAM in RxIPS is 16384 bytes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RXIPS_MEMORY_MAP {
         union {
            struct { 
               RXIPS_SA rxips_sat[128];
            } SG_PACK ; // unnamed struct
            u32 dw[4096]; // dword union
         }; // unnamed union
      } SG_PACK RXIPS_MEMORY_MAP, *PRXIPS_MEMORY_MAP;

      SG_C_ASSERT(__sizeof__RXIPS_MEMORY_MAP, sizeof (RXIPS_MEMORY_MAP) == 16384);

   #else
      typedef struct _RXIPS_MEMORY_MAP {
         RXIPS_SA rxips_sat[128];
      } SG_PACK RXIPS_MEMORY_MAP, *PRXIPS_MEMORY_MAP;

      typedef union _RXIPS_MEMORY_MAP_UNION {
         RXIPS_MEMORY_MAP bits;
         u32 dw[4096]; // dword union
      } SG_PACK RXIPS_MEMORY_MAP_UNION, *PRXIPS_MEMORY_MAP_UNION;

      SG_C_ASSERT(__sizeof__RXIPS_MEMORY_MAP_UNION, sizeof (RXIPS_MEMORY_MAP_UNION) == 16384);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The following table defines the layout of TxIPS Security Association context SRAM. 
   // The total size of this dedicated SRAM in TxIPS is 8192 bytes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXIPS_MEMORY_MAP {
         union {
            struct { 
               TXIPS_SA txips_sat[64];
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK TXIPS_MEMORY_MAP, *PTXIPS_MEMORY_MAP;

      SG_C_ASSERT(__sizeof__TXIPS_MEMORY_MAP, sizeof (TXIPS_MEMORY_MAP) == 8192);

   #else
      typedef struct _TXIPS_MEMORY_MAP {
         TXIPS_SA txips_sat[64];
      } SG_PACK TXIPS_MEMORY_MAP, *PTXIPS_MEMORY_MAP;

      typedef union _TXIPS_MEMORY_MAP_UNION {
         TXIPS_MEMORY_MAP bits;
         u32 dw[2048]; // dword union
      } SG_PACK TXIPS_MEMORY_MAP_UNION, *PTXIPS_MEMORY_MAP_UNION;

      SG_C_ASSERT(__sizeof__TXIPS_MEMORY_MAP_UNION, sizeof (TXIPS_MEMORY_MAP_UNION) == 8192);
   #endif


#else
   // The following table defines the layout of TxIPS Security Association context SRAM. 
   // The total size of this dedicated SRAM in TxIPS is 8192 bytes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXIPS_MEMORY_MAP {
         union {
            struct { 
               TXIPS_SA txips_sat[64];
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK TXIPS_MEMORY_MAP, *PTXIPS_MEMORY_MAP;

      SG_C_ASSERT(__sizeof__TXIPS_MEMORY_MAP, sizeof (TXIPS_MEMORY_MAP) == 8192);

   #else
      typedef struct _TXIPS_MEMORY_MAP {
         TXIPS_SA txips_sat[64];
      } SG_PACK TXIPS_MEMORY_MAP, *PTXIPS_MEMORY_MAP;

      typedef union _TXIPS_MEMORY_MAP_UNION {
         TXIPS_MEMORY_MAP bits;
         u32 dw[2048]; // dword union
      } SG_PACK TXIPS_MEMORY_MAP_UNION, *PTXIPS_MEMORY_MAP_UNION;

      SG_C_ASSERT(__sizeof__TXIPS_MEMORY_MAP_UNION, sizeof (TXIPS_MEMORY_MAP_UNION) == 8192);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ipsec_sa_structs_bmap_h__

