/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_common_host_struct_bmap_h__
#define __iscsi_common_host_struct_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "iscsi_enums_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Completion Queue Entry for iSCSI Initiator or Target mode of operation.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CQE {
         union {
            struct { 
               u32 mode_specific1[2];             // DWORDS 0 to 1
               u32 mode_specific2 : 16;           // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 mode_specific3 : 31;           // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CQE, *PISCSI_CQE;

      SG_C_ASSERT(__sizeof__ISCSI_CQE, sizeof (ISCSI_CQE) == 16);

   #else
      typedef struct _ISCSI_CQE {
         u32 mode_specific1[2];                   // DWORDS 0 to 1
         u32 mode_specific2 : 16;                 // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 mode_specific3 : 31;                 // DWORD 3
      } SG_PACK ISCSI_CQE, *PISCSI_CQE;

      typedef union _ISCSI_CQE_UNION {
         ISCSI_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_CQE_UNION, *PISCSI_CQE_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CQE_UNION, sizeof (ISCSI_CQE_UNION) == 16);
   #endif


#else
   // Completion Queue Entry for iSCSI Initiator or Target mode of operation.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CQE {
         union {
            struct { 
               u32 mode_specific1[2];             // DWORDS 0 to 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 mode_specific2 : 16;           // DWORD 2
               u32 mode_specific3 : 31;           // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CQE, *PISCSI_CQE;

      SG_C_ASSERT(__sizeof__ISCSI_CQE, sizeof (ISCSI_CQE) == 16);

   #else
      typedef struct _ISCSI_CQE {
         u32 mode_specific1[2];                   // DWORDS 0 to 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 mode_specific2 : 16;                 // DWORD 2
         u32 mode_specific3 : 31;                 // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ISCSI_CQE, *PISCSI_CQE;

      typedef union _ISCSI_CQE_UNION {
         ISCSI_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_CQE_UNION, *PISCSI_CQE_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CQE_UNION, sizeof (ISCSI_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI unsolicited PDU completions.
   #if defined(SG_BMAP_UNION)
      typedef struct _I_T_DPDU_CQE {
         union {
            struct { 
               u32 db_addr_hi;                    // DWORD 0
               u32 db_addr_lo;                    // DWORD 1
               u32 DataPlacementLength : 16;      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 final : 1;                     // DWORD 3
               u32 rsvd0 : 4;                     // DWORD 3
               u32 num_cons : 10;                 // DWORD 3
               u32 index : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK I_T_DPDU_CQE, *PI_T_DPDU_CQE;

      SG_C_ASSERT(__sizeof__I_T_DPDU_CQE, sizeof (I_T_DPDU_CQE) == 16);

   #else
      typedef struct _I_T_DPDU_CQE {
         u32 db_addr_hi;                          // DWORD 0
         u32 db_addr_lo;                          // DWORD 1
         u32 DataPlacementLength : 16;            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 final : 1;                           // DWORD 3
         u32 rsvd0 : 4;                           // DWORD 3
         u32 num_cons : 10;                       // DWORD 3
         u32 index : 16;                          // DWORD 3
      } SG_PACK I_T_DPDU_CQE, *PI_T_DPDU_CQE;

      typedef union _I_T_DPDU_CQE_UNION {
         I_T_DPDU_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK I_T_DPDU_CQE_UNION, *PI_T_DPDU_CQE_UNION;

      SG_C_ASSERT(__sizeof__I_T_DPDU_CQE_UNION, sizeof (I_T_DPDU_CQE_UNION) == 16);
   #endif


#else
   // iSCSI unsolicited PDU completions.
   #if defined(SG_BMAP_UNION)
      typedef struct _I_T_DPDU_CQE {
         union {
            struct { 
               u32 db_addr_hi;                    // DWORD 0
               u32 db_addr_lo;                    // DWORD 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 DataPlacementLength : 16;      // DWORD 2
               u32 index : 16;                    // DWORD 3
               u32 num_cons : 10;                 // DWORD 3
               u32 rsvd0 : 4;                     // DWORD 3
               u32 final : 1;                     // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK I_T_DPDU_CQE, *PI_T_DPDU_CQE;

      SG_C_ASSERT(__sizeof__I_T_DPDU_CQE, sizeof (I_T_DPDU_CQE) == 16);

   #else
      typedef struct _I_T_DPDU_CQE {
         u32 db_addr_hi;                          // DWORD 0
         u32 db_addr_lo;                          // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 DataPlacementLength : 16;            // DWORD 2
         u32 index : 16;                          // DWORD 3
         u32 num_cons : 10;                       // DWORD 3
         u32 rsvd0 : 4;                           // DWORD 3
         u32 final : 1;                           // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK I_T_DPDU_CQE, *PI_T_DPDU_CQE;

      typedef union _I_T_DPDU_CQE_UNION {
         I_T_DPDU_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK I_T_DPDU_CQE_UNION, *PI_T_DPDU_CQE_UNION;

      SG_C_ASSERT(__sizeof__I_T_DPDU_CQE_UNION, sizeof (I_T_DPDU_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI ack/driver message completions.
   #if defined(SG_BMAP_UNION)
      typedef struct _I_T_DMSG_CQE {
         union {
            struct { 
               u32 ack_num;                       // DWORD 0
               u32 pdu_bytes_rcvd;                // DWORD 1
               u32 rsvd0 : 8;                     // DWORD 2
               u32 wrb_index : 8;                 // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 rsvd1 : 31;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK I_T_DMSG_CQE, *PI_T_DMSG_CQE;

      SG_C_ASSERT(__sizeof__I_T_DMSG_CQE, sizeof (I_T_DMSG_CQE) == 16);

   #else
      typedef struct _I_T_DMSG_CQE {
         u32 ack_num;                             // DWORD 0
         u32 pdu_bytes_rcvd;                      // DWORD 1
         u32 rsvd0 : 8;                           // DWORD 2
         u32 wrb_index : 8;                       // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 rsvd1 : 31;                          // DWORD 3
      } SG_PACK I_T_DMSG_CQE, *PI_T_DMSG_CQE;

      typedef union _I_T_DMSG_CQE_UNION {
         I_T_DMSG_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK I_T_DMSG_CQE_UNION, *PI_T_DMSG_CQE_UNION;

      SG_C_ASSERT(__sizeof__I_T_DMSG_CQE_UNION, sizeof (I_T_DMSG_CQE_UNION) == 16);
   #endif


#else
   // iSCSI ack/driver message completions.
   #if defined(SG_BMAP_UNION)
      typedef struct _I_T_DMSG_CQE {
         union {
            struct { 
               u32 ack_num;                       // DWORD 0
               u32 pdu_bytes_rcvd;                // DWORD 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 wrb_index : 8;                 // DWORD 2
               u32 rsvd0 : 8;                     // DWORD 2
               u32 rsvd1 : 31;                    // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK I_T_DMSG_CQE, *PI_T_DMSG_CQE;

      SG_C_ASSERT(__sizeof__I_T_DMSG_CQE, sizeof (I_T_DMSG_CQE) == 16);

   #else
      typedef struct _I_T_DMSG_CQE {
         u32 ack_num;                             // DWORD 0
         u32 pdu_bytes_rcvd;                      // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 wrb_index : 8;                       // DWORD 2
         u32 rsvd0 : 8;                           // DWORD 2
         u32 rsvd1 : 31;                          // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK I_T_DMSG_CQE, *PI_T_DMSG_CQE;

      typedef union _I_T_DMSG_CQE_UNION {
         I_T_DMSG_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK I_T_DMSG_CQE_UNION, *PI_T_DMSG_CQE_UNION;

      SG_C_ASSERT(__sizeof__I_T_DMSG_CQE_UNION, sizeof (I_T_DMSG_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scatter gather element
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
               u32 last_sge : 1;                  // DWORD 2
               u32 rsvd0 : 9;                     // DWORD 2
               u32 sge_offset : 22;               // DWORD 2
               u32 rsvd1 : 15;                    // DWORD 3
               u32 len : 17;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_SGE, *PISCSI_SGE;

      SG_C_ASSERT(__sizeof__ISCSI_SGE, sizeof (ISCSI_SGE) == 16);

   #else
      typedef struct _ISCSI_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
         u32 last_sge : 1;                        // DWORD 2
         u32 rsvd0 : 9;                           // DWORD 2
         u32 sge_offset : 22;                     // DWORD 2
         u32 rsvd1 : 15;                          // DWORD 3
         u32 len : 17;                            // DWORD 3
      } SG_PACK ISCSI_SGE, *PISCSI_SGE;

      typedef union _ISCSI_SGE_UNION {
         ISCSI_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_SGE_UNION, *PISCSI_SGE_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_SGE_UNION, sizeof (ISCSI_SGE_UNION) == 16);
   #endif


#else
   // Scatter gather element
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
               u32 sge_offset : 22;               // DWORD 2
               u32 rsvd0 : 9;                     // DWORD 2
               u32 last_sge : 1;                  // DWORD 2
               u32 len : 17;                      // DWORD 3
               u32 rsvd1 : 15;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_SGE, *PISCSI_SGE;

      SG_C_ASSERT(__sizeof__ISCSI_SGE, sizeof (ISCSI_SGE) == 16);

   #else
      typedef struct _ISCSI_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
         u32 sge_offset : 22;                     // DWORD 2
         u32 rsvd0 : 9;                           // DWORD 2
         u32 last_sge : 1;                        // DWORD 2
         u32 len : 17;                            // DWORD 3
         u32 rsvd1 : 15;                          // DWORD 3
      } SG_PACK ISCSI_SGE, *PISCSI_SGE;

      typedef union _ISCSI_SGE_UNION {
         ISCSI_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_SGE_UNION, *PISCSI_SGE_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_SGE_UNION, sizeof (ISCSI_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scatter gather element to DMA OOO segments
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_SGE, *PISCSI_OOO_SGE;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_SGE, sizeof (ISCSI_OOO_SGE) == 8);

   #else
      typedef struct _ISCSI_OOO_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
      } SG_PACK ISCSI_OOO_SGE, *PISCSI_OOO_SGE;

      typedef union _ISCSI_OOO_SGE_UNION {
         ISCSI_OOO_SGE bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_OOO_SGE_UNION, *PISCSI_OOO_SGE_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_SGE_UNION, sizeof (ISCSI_OOO_SGE_UNION) == 8);
   #endif


#else
   // Scatter gather element to DMA OOO segments
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_SGE, *PISCSI_OOO_SGE;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_SGE, sizeof (ISCSI_OOO_SGE) == 8);

   #else
      typedef struct _ISCSI_OOO_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
      } SG_PACK ISCSI_OOO_SGE, *PISCSI_OOO_SGE;

      typedef union _ISCSI_OOO_SGE_UNION {
         ISCSI_OOO_SGE bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_OOO_SGE_UNION, *PISCSI_OOO_SGE_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_SGE_UNION, sizeof (ISCSI_OOO_SGE_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RRmsg sent from ARM to iSCSI TXULP and carried as body of IPC between EPs
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_RRMSG {
         union {
            struct { 
               u32 invalidate_ref_handle : 16;    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 chuteid : 1;                   // DWORD 0
               u32 defpdu_invld : 1;              // DWORD 0
               u32 req_id : 11;                   // DWORD 0
               u32 partialBytesSent : 24;         // DWORD 1
               u32 upload : 1;                    // DWORD 1
               u32 rstonneed : 1;                 // DWORD 1
               u32 invld_resp : 1;                // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 iscsicon_rst : 1;              // DWORD 1
               u32 icd_free : 1;                  // DWORD 1
               u32 icd_invld : 1;                 // DWORD 1
               u32 iscsicon_invld : 1;            // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_RRMSG, *PISCSI_RRMSG;

      SG_C_ASSERT(__sizeof__ISCSI_RRMSG, sizeof (ISCSI_RRMSG) == 8);

   #else
      typedef struct _ISCSI_RRMSG {
         u32 invalidate_ref_handle : 16;          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 chuteid : 1;                         // DWORD 0
         u32 defpdu_invld : 1;                    // DWORD 0
         u32 req_id : 11;                         // DWORD 0
         u32 partialBytesSent : 24;               // DWORD 1
         u32 upload : 1;                          // DWORD 1
         u32 rstonneed : 1;                       // DWORD 1
         u32 invld_resp : 1;                      // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 iscsicon_rst : 1;                    // DWORD 1
         u32 icd_free : 1;                        // DWORD 1
         u32 icd_invld : 1;                       // DWORD 1
         u32 iscsicon_invld : 1;                  // DWORD 1
      } SG_PACK ISCSI_RRMSG, *PISCSI_RRMSG;

      typedef union _ISCSI_RRMSG_UNION {
         ISCSI_RRMSG bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_RRMSG_UNION, *PISCSI_RRMSG_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_RRMSG_UNION, sizeof (ISCSI_RRMSG_UNION) == 8);
   #endif


#else
   // RRmsg sent from ARM to iSCSI TXULP and carried as body of IPC between EPs
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_RRMSG {
         union {
            struct { 
               u32 req_id : 11;                   // DWORD 0
               u32 defpdu_invld : 1;              // DWORD 0
               u32 chuteid : 1;                   // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 invalidate_ref_handle : 16;    // DWORD 0
               u32 iscsicon_invld : 1;            // DWORD 1
               u32 icd_invld : 1;                 // DWORD 1
               u32 icd_free : 1;                  // DWORD 1
               u32 iscsicon_rst : 1;              // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 invld_resp : 1;                // DWORD 1
               u32 rstonneed : 1;                 // DWORD 1
               u32 upload : 1;                    // DWORD 1
               u32 partialBytesSent : 24;         // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_RRMSG, *PISCSI_RRMSG;

      SG_C_ASSERT(__sizeof__ISCSI_RRMSG, sizeof (ISCSI_RRMSG) == 8);

   #else
      typedef struct _ISCSI_RRMSG {
         u32 req_id : 11;                         // DWORD 0
         u32 defpdu_invld : 1;                    // DWORD 0
         u32 chuteid : 1;                         // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 invalidate_ref_handle : 16;          // DWORD 0
         u32 iscsicon_invld : 1;                  // DWORD 1
         u32 icd_invld : 1;                       // DWORD 1
         u32 icd_free : 1;                        // DWORD 1
         u32 iscsicon_rst : 1;                    // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 invld_resp : 1;                      // DWORD 1
         u32 rstonneed : 1;                       // DWORD 1
         u32 upload : 1;                          // DWORD 1
         u32 partialBytesSent : 24;               // DWORD 1
      } SG_PACK ISCSI_RRMSG, *PISCSI_RRMSG;

      typedef union _ISCSI_RRMSG_UNION {
         ISCSI_RRMSG bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_RRMSG_UNION, *PISCSI_RRMSG_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_RRMSG_UNION, sizeof (ISCSI_RRMSG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Full 8 byte LUN.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_LUN {
         union {
            struct { 
               u8 bytes[8];
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_LUN, *PISCSI_LUN;

      SG_C_ASSERT(__sizeof__ISCSI_LUN, sizeof (ISCSI_LUN) == 8);

   #else
      typedef struct _ISCSI_LUN {
         u8 bytes[8];
      } SG_PACK ISCSI_LUN, *PISCSI_LUN;

      typedef union _ISCSI_LUN_UNION {
         ISCSI_LUN bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_LUN_UNION, *PISCSI_LUN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_LUN_UNION, sizeof (ISCSI_LUN_UNION) == 8);
   #endif


#else
   // Full 8 byte LUN.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_LUN {
         union {
            struct { 
               u8 bytes[8];
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_LUN, *PISCSI_LUN;

      SG_C_ASSERT(__sizeof__ISCSI_LUN, sizeof (ISCSI_LUN) == 8);

   #else
      typedef struct _ISCSI_LUN {
         u8 bytes[8];
      } SG_PACK ISCSI_LUN, *PISCSI_LUN;

      typedef union _ISCSI_LUN_UNION {
         ISCSI_LUN bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_LUN_UNION, *PISCSI_LUN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_LUN_UNION, sizeof (ISCSI_LUN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ISCSI Default PDU Context latest
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DEFAULT_PDU_CONTEXT {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 ring_state : 4;                // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 dbuf_cindex : 13;              // DWORD 0
               u32 rx_pdid_valid : 1;             // DWORD 1
               u32 rx_pdid : 9;                   // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 dbuf_pindex : 13;              // DWORD 1
               u32 rsvd3 : 5;                     // DWORD 2
               u32 rx_pdid_not_valid : 1;         // DWORD 2
               u32 cq_id_recv : 10;               // DWORD 2
               u32 default_buffer_size : 16;      // DWORD 2
               u32 rsvd4[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DEFAULT_PDU_CONTEXT, *PISCSI_DEFAULT_PDU_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_DEFAULT_PDU_CONTEXT, sizeof (ISCSI_DEFAULT_PDU_CONTEXT) == 16);

   #else
      typedef struct _ISCSI_DEFAULT_PDU_CONTEXT {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 ring_state : 4;                      // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 dbuf_cindex : 13;                    // DWORD 0
         u32 rx_pdid_valid : 1;                   // DWORD 1
         u32 rx_pdid : 9;                         // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 dbuf_pindex : 13;                    // DWORD 1
         u32 rsvd3 : 5;                           // DWORD 2
         u32 rx_pdid_not_valid : 1;               // DWORD 2
         u32 cq_id_recv : 10;                     // DWORD 2
         u32 default_buffer_size : 16;            // DWORD 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
      } SG_PACK ISCSI_DEFAULT_PDU_CONTEXT, *PISCSI_DEFAULT_PDU_CONTEXT;

      typedef union _ISCSI_DEFAULT_PDU_CONTEXT_UNION {
         ISCSI_DEFAULT_PDU_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_DEFAULT_PDU_CONTEXT_UNION, *PISCSI_DEFAULT_PDU_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DEFAULT_PDU_CONTEXT_UNION, sizeof (ISCSI_DEFAULT_PDU_CONTEXT_UNION) == 16);
   #endif


#else
   // ISCSI Default PDU Context latest
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DEFAULT_PDU_CONTEXT {
         union {
            struct { 
               u32 dbuf_cindex : 13;              // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 ring_state : 4;                // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
               u32 dbuf_pindex : 13;              // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 rx_pdid : 9;                   // DWORD 1
               u32 rx_pdid_valid : 1;             // DWORD 1
               u32 default_buffer_size : 16;      // DWORD 2
               u32 cq_id_recv : 10;               // DWORD 2
               u32 rx_pdid_not_valid : 1;         // DWORD 2
               u32 rsvd3 : 5;                     // DWORD 2
               u32 rsvd4[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DEFAULT_PDU_CONTEXT, *PISCSI_DEFAULT_PDU_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_DEFAULT_PDU_CONTEXT, sizeof (ISCSI_DEFAULT_PDU_CONTEXT) == 16);

   #else
      typedef struct _ISCSI_DEFAULT_PDU_CONTEXT {
         u32 dbuf_cindex : 13;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 ring_state : 4;                      // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
         u32 dbuf_pindex : 13;                    // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 rx_pdid : 9;                         // DWORD 1
         u32 rx_pdid_valid : 1;                   // DWORD 1
         u32 default_buffer_size : 16;            // DWORD 2
         u32 cq_id_recv : 10;                     // DWORD 2
         u32 rx_pdid_not_valid : 1;               // DWORD 2
         u32 rsvd3 : 5;                           // DWORD 2
         u32 rsvd4[1];                            // DWORDS 3 to 3
      } SG_PACK ISCSI_DEFAULT_PDU_CONTEXT, *PISCSI_DEFAULT_PDU_CONTEXT;

      typedef union _ISCSI_DEFAULT_PDU_CONTEXT_UNION {
         ISCSI_DEFAULT_PDU_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK ISCSI_DEFAULT_PDU_CONTEXT_UNION, *PISCSI_DEFAULT_PDU_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DEFAULT_PDU_CONTEXT_UNION, sizeof (ISCSI_DEFAULT_PDU_CONTEXT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_WRB {
         union {
            struct { 
               u32 type : 4;                      // DWORD 0
               u32 over_run : 1;                  // DWORD 0
               u32 undr_run : 1;                  // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 wrb_idx : 8;                   // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 lun : 14;                      // DWORD 0
               u32 r2t_exp_dtl : 24;              // DWORD 1
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 rsvd0 : 10;                    // DWORD 2
               u32 cq_id : 10;                    // DWORD 2
               u32 sgl_icd_idx : 12;              // DWORD 2
               u32 exp_data_sn;                   // DWORD 3
               u32 iscsi_bhs_addr_hi;             // DWORD 4
               u32 iscsi_bhs_addr_lo;             // DWORD 5
               u32 cmdsn_itt;                     // DWORD 6
               u32 dif_ref_tag;                   // DWORD 7
               u32 sge0_addr_hi;                  // DWORD 8
               u32 sge0_addr_lo;                  // DWORD 9
               u32 sge0_last : 1;                 // DWORD 10
               u32 rsvd1 : 6;                     // DWORD 10
               u32 dif_mode : 2;                  // DWORD 10
               u32 pbs : 1;                       // DWORD 10
               u32 sge0_offset : 22;              // DWORD 10
               u32 sge0_in_ddr : 1;               // DWORD 11
               u32 dif_meta_tag : 14;             // DWORD 11
               u32 sge0_len : 17;                 // DWORD 11
               u32 sge1_addr_hi;                  // DWORD 12
               u32 sge1_addr_lo;                  // DWORD 13
               u32 sge1_last : 1;                 // DWORD 14
               u32 rsvd2 : 9;                     // DWORD 14
               u32 sge1_r2t_offset : 22;          // DWORD 14
               u32 sge1_in_ddr : 1;               // DWORD 15
               u32 rsvd3 : 2;                     // DWORD 15
               u32 ref_sgl_icd_idx : 12;          // DWORD 15
               u32 sge1_len : 17;                 // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_WRB, *PISCSI_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_WRB, sizeof (ISCSI_WRB) == 64);

   #else
      typedef struct _ISCSI_WRB {
         u32 type : 4;                            // DWORD 0
         u32 over_run : 1;                        // DWORD 0
         u32 undr_run : 1;                        // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 wrb_idx : 8;                         // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 lun : 14;                            // DWORD 0
         u32 r2t_exp_dtl : 24;                    // DWORD 1
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 rsvd0 : 10;                          // DWORD 2
         u32 cq_id : 10;                          // DWORD 2
         u32 sgl_icd_idx : 12;                    // DWORD 2
         u32 exp_data_sn;                         // DWORD 3
         u32 iscsi_bhs_addr_hi;                   // DWORD 4
         u32 iscsi_bhs_addr_lo;                   // DWORD 5
         u32 cmdsn_itt;                           // DWORD 6
         u32 dif_ref_tag;                         // DWORD 7
         u32 sge0_addr_hi;                        // DWORD 8
         u32 sge0_addr_lo;                        // DWORD 9
         u32 sge0_last : 1;                       // DWORD 10
         u32 rsvd1 : 6;                           // DWORD 10
         u32 dif_mode : 2;                        // DWORD 10
         u32 pbs : 1;                             // DWORD 10
         u32 sge0_offset : 22;                    // DWORD 10
         u32 sge0_in_ddr : 1;                     // DWORD 11
         u32 dif_meta_tag : 14;                   // DWORD 11
         u32 sge0_len : 17;                       // DWORD 11
         u32 sge1_addr_hi;                        // DWORD 12
         u32 sge1_addr_lo;                        // DWORD 13
         u32 sge1_last : 1;                       // DWORD 14
         u32 rsvd2 : 9;                           // DWORD 14
         u32 sge1_r2t_offset : 22;                // DWORD 14
         u32 sge1_in_ddr : 1;                     // DWORD 15
         u32 rsvd3 : 2;                           // DWORD 15
         u32 ref_sgl_icd_idx : 12;                // DWORD 15
         u32 sge1_len : 17;                       // DWORD 15
      } SG_PACK ISCSI_WRB, *PISCSI_WRB;

      typedef union _ISCSI_WRB_UNION {
         ISCSI_WRB bits;
         u32 dw[16]; // dword union
      } SG_PACK ISCSI_WRB_UNION, *PISCSI_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_WRB_UNION, sizeof (ISCSI_WRB_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_WRB {
         union {
            struct { 
               u32 lun : 14;                      // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 wrb_idx : 8;                   // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 undr_run : 1;                  // DWORD 0
               u32 over_run : 1;                  // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 r2t_exp_dtl : 24;              // DWORD 1
               u32 sgl_icd_idx : 12;              // DWORD 2
               u32 cq_id : 10;                    // DWORD 2
               u32 rsvd0 : 10;                    // DWORD 2
               u32 exp_data_sn;                   // DWORD 3
               u32 iscsi_bhs_addr_hi;             // DWORD 4
               u32 iscsi_bhs_addr_lo;             // DWORD 5
               u32 cmdsn_itt;                     // DWORD 6
               u32 dif_ref_tag;                   // DWORD 7
               u32 sge0_addr_hi;                  // DWORD 8
               u32 sge0_addr_lo;                  // DWORD 9
               u32 sge0_offset : 22;              // DWORD 10
               u32 pbs : 1;                       // DWORD 10
               u32 dif_mode : 2;                  // DWORD 10
               u32 rsvd1 : 6;                     // DWORD 10
               u32 sge0_last : 1;                 // DWORD 10
               u32 sge0_len : 17;                 // DWORD 11
               u32 dif_meta_tag : 14;             // DWORD 11
               u32 sge0_in_ddr : 1;               // DWORD 11
               u32 sge1_addr_hi;                  // DWORD 12
               u32 sge1_addr_lo;                  // DWORD 13
               u32 sge1_r2t_offset : 22;          // DWORD 14
               u32 rsvd2 : 9;                     // DWORD 14
               u32 sge1_last : 1;                 // DWORD 14
               u32 sge1_len : 17;                 // DWORD 15
               u32 ref_sgl_icd_idx : 12;          // DWORD 15
               u32 rsvd3 : 2;                     // DWORD 15
               u32 sge1_in_ddr : 1;               // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_WRB, *PISCSI_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_WRB, sizeof (ISCSI_WRB) == 64);

   #else
      typedef struct _ISCSI_WRB {
         u32 lun : 14;                            // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 wrb_idx : 8;                         // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 undr_run : 1;                        // DWORD 0
         u32 over_run : 1;                        // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 r2t_exp_dtl : 24;                    // DWORD 1
         u32 sgl_icd_idx : 12;                    // DWORD 2
         u32 cq_id : 10;                          // DWORD 2
         u32 rsvd0 : 10;                          // DWORD 2
         u32 exp_data_sn;                         // DWORD 3
         u32 iscsi_bhs_addr_hi;                   // DWORD 4
         u32 iscsi_bhs_addr_lo;                   // DWORD 5
         u32 cmdsn_itt;                           // DWORD 6
         u32 dif_ref_tag;                         // DWORD 7
         u32 sge0_addr_hi;                        // DWORD 8
         u32 sge0_addr_lo;                        // DWORD 9
         u32 sge0_offset : 22;                    // DWORD 10
         u32 pbs : 1;                             // DWORD 10
         u32 dif_mode : 2;                        // DWORD 10
         u32 rsvd1 : 6;                           // DWORD 10
         u32 sge0_last : 1;                       // DWORD 10
         u32 sge0_len : 17;                       // DWORD 11
         u32 dif_meta_tag : 14;                   // DWORD 11
         u32 sge0_in_ddr : 1;                     // DWORD 11
         u32 sge1_addr_hi;                        // DWORD 12
         u32 sge1_addr_lo;                        // DWORD 13
         u32 sge1_r2t_offset : 22;                // DWORD 14
         u32 rsvd2 : 9;                           // DWORD 14
         u32 sge1_last : 1;                       // DWORD 14
         u32 sge1_len : 17;                       // DWORD 15
         u32 ref_sgl_icd_idx : 12;                // DWORD 15
         u32 rsvd3 : 2;                           // DWORD 15
         u32 sge1_in_ddr : 1;                     // DWORD 15
      } SG_PACK ISCSI_WRB, *PISCSI_WRB;

      typedef union _ISCSI_WRB_UNION {
         ISCSI_WRB bits;
         u32 dw[16]; // dword union
      } SG_PACK ISCSI_WRB_UNION, *PISCSI_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_WRB_UNION, sizeof (ISCSI_WRB_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DIF_WRB {
         union {
            struct { 
               u32 type : 4;                      // DWORD 0
               u32 over_run : 1;                  // DWORD 0
               u32 undr_run : 1;                  // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 wrb_idx : 8;                   // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 lun : 14;                      // DWORD 0
               u32 r2t_exp_dtl : 24;              // DWORD 1
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 dif_meta_tag : 16;             // DWORD 2
               u32 rsvd0 : 4;                     // DWORD 2
               u32 sgl_icd_idx : 12;              // DWORD 2
               u32 exp_data_sn;                   // DWORD 3
               u32 iscsi_bhs_addr_hi;             // DWORD 4
               u32 iscsi_bhs_addr_lo;             // DWORD 5
               u32 cmdsn_itt;                     // DWORD 6
               u32 dif_ref_tag;                   // DWORD 7
               u32 sge0_addr_hi;                  // DWORD 8
               u32 sge0_addr_lo;                  // DWORD 9
               u32 sge0_last : 1;                 // DWORD 10
               u32 rsvd1 : 6;                     // DWORD 10
               u32 dif_mode : 2;                  // DWORD 10
               u32 pbs : 1;                       // DWORD 10
               u32 sge0_offset : 22;              // DWORD 10
               u32 sge0_in_ddr : 1;               // DWORD 11
               u32 rsvd2 : 14;                    // DWORD 11
               u32 sge0_len : 17;                 // DWORD 11
               u32 newreftag;                     // DWORD 12
               u32 sge1_addr_lo;                  // DWORD 13
               u32 sge1_last : 1;                 // DWORD 14
               u32 m : 2;                         // DWORD 14
               u32 bs : 2;                        // DWORD 14
               u32 dsbl_ref : 1;                  // DWORD 14
               u32 dsbl_meta : 1;                 // DWORD 14
               u32 dsbl_crc : 1;                  // DWORD 14
               u32 sge1_valid : 1;                // DWORD 14
               u32 rsvd3 : 1;                     // DWORD 14
               u32 sge1_r2t_offset : 22;          // DWORD 14
               u32 sge1_in_ddr : 1;               // DWORD 15
               u32 rsvd4 : 2;                     // DWORD 15
               u32 ref_sgl_icd_idx : 12;          // DWORD 15
               u32 sge1_len : 17;                 // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DIF_WRB, *PISCSI_DIF_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_DIF_WRB, sizeof (ISCSI_DIF_WRB) == 64);

   #else
      typedef struct _ISCSI_DIF_WRB {
         u32 type : 4;                            // DWORD 0
         u32 over_run : 1;                        // DWORD 0
         u32 undr_run : 1;                        // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 wrb_idx : 8;                         // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 lun : 14;                            // DWORD 0
         u32 r2t_exp_dtl : 24;                    // DWORD 1
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 dif_meta_tag : 16;                   // DWORD 2
         u32 rsvd0 : 4;                           // DWORD 2
         u32 sgl_icd_idx : 12;                    // DWORD 2
         u32 exp_data_sn;                         // DWORD 3
         u32 iscsi_bhs_addr_hi;                   // DWORD 4
         u32 iscsi_bhs_addr_lo;                   // DWORD 5
         u32 cmdsn_itt;                           // DWORD 6
         u32 dif_ref_tag;                         // DWORD 7
         u32 sge0_addr_hi;                        // DWORD 8
         u32 sge0_addr_lo;                        // DWORD 9
         u32 sge0_last : 1;                       // DWORD 10
         u32 rsvd1 : 6;                           // DWORD 10
         u32 dif_mode : 2;                        // DWORD 10
         u32 pbs : 1;                             // DWORD 10
         u32 sge0_offset : 22;                    // DWORD 10
         u32 sge0_in_ddr : 1;                     // DWORD 11
         u32 rsvd2 : 14;                          // DWORD 11
         u32 sge0_len : 17;                       // DWORD 11
         u32 newreftag;                           // DWORD 12
         u32 sge1_addr_lo;                        // DWORD 13
         u32 sge1_last : 1;                       // DWORD 14
         u32 m : 2;                               // DWORD 14
         u32 bs : 2;                              // DWORD 14
         u32 dsbl_ref : 1;                        // DWORD 14
         u32 dsbl_meta : 1;                       // DWORD 14
         u32 dsbl_crc : 1;                        // DWORD 14
         u32 sge1_valid : 1;                      // DWORD 14
         u32 rsvd3 : 1;                           // DWORD 14
         u32 sge1_r2t_offset : 22;                // DWORD 14
         u32 sge1_in_ddr : 1;                     // DWORD 15
         u32 rsvd4 : 2;                           // DWORD 15
         u32 ref_sgl_icd_idx : 12;                // DWORD 15
         u32 sge1_len : 17;                       // DWORD 15
      } SG_PACK ISCSI_DIF_WRB, *PISCSI_DIF_WRB;

      typedef union _ISCSI_DIF_WRB_UNION {
         ISCSI_DIF_WRB bits;
         u32 dw[16]; // dword union
      } SG_PACK ISCSI_DIF_WRB_UNION, *PISCSI_DIF_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DIF_WRB_UNION, sizeof (ISCSI_DIF_WRB_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_DIF_WRB {
         union {
            struct { 
               u32 lun : 14;                      // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 wrb_idx : 8;                   // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 undr_run : 1;                  // DWORD 0
               u32 over_run : 1;                  // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 r2t_exp_dtl : 24;              // DWORD 1
               u32 sgl_icd_idx : 12;              // DWORD 2
               u32 rsvd0 : 4;                     // DWORD 2
               u32 dif_meta_tag : 16;             // DWORD 2
               u32 exp_data_sn;                   // DWORD 3
               u32 iscsi_bhs_addr_hi;             // DWORD 4
               u32 iscsi_bhs_addr_lo;             // DWORD 5
               u32 cmdsn_itt;                     // DWORD 6
               u32 dif_ref_tag;                   // DWORD 7
               u32 sge0_addr_hi;                  // DWORD 8
               u32 sge0_addr_lo;                  // DWORD 9
               u32 sge0_offset : 22;              // DWORD 10
               u32 pbs : 1;                       // DWORD 10
               u32 dif_mode : 2;                  // DWORD 10
               u32 rsvd1 : 6;                     // DWORD 10
               u32 sge0_last : 1;                 // DWORD 10
               u32 sge0_len : 17;                 // DWORD 11
               u32 rsvd2 : 14;                    // DWORD 11
               u32 sge0_in_ddr : 1;               // DWORD 11
               u32 newreftag;                     // DWORD 12
               u32 sge1_addr_lo;                  // DWORD 13
               u32 sge1_r2t_offset : 22;          // DWORD 14
               u32 rsvd3 : 1;                     // DWORD 14
               u32 sge1_valid : 1;                // DWORD 14
               u32 dsbl_crc : 1;                  // DWORD 14
               u32 dsbl_meta : 1;                 // DWORD 14
               u32 dsbl_ref : 1;                  // DWORD 14
               u32 bs : 2;                        // DWORD 14
               u32 m : 2;                         // DWORD 14
               u32 sge1_last : 1;                 // DWORD 14
               u32 sge1_len : 17;                 // DWORD 15
               u32 ref_sgl_icd_idx : 12;          // DWORD 15
               u32 rsvd4 : 2;                     // DWORD 15
               u32 sge1_in_ddr : 1;               // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_DIF_WRB, *PISCSI_DIF_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_DIF_WRB, sizeof (ISCSI_DIF_WRB) == 64);

   #else
      typedef struct _ISCSI_DIF_WRB {
         u32 lun : 14;                            // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 wrb_idx : 8;                         // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 undr_run : 1;                        // DWORD 0
         u32 over_run : 1;                        // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 r2t_exp_dtl : 24;                    // DWORD 1
         u32 sgl_icd_idx : 12;                    // DWORD 2
         u32 rsvd0 : 4;                           // DWORD 2
         u32 dif_meta_tag : 16;                   // DWORD 2
         u32 exp_data_sn;                         // DWORD 3
         u32 iscsi_bhs_addr_hi;                   // DWORD 4
         u32 iscsi_bhs_addr_lo;                   // DWORD 5
         u32 cmdsn_itt;                           // DWORD 6
         u32 dif_ref_tag;                         // DWORD 7
         u32 sge0_addr_hi;                        // DWORD 8
         u32 sge0_addr_lo;                        // DWORD 9
         u32 sge0_offset : 22;                    // DWORD 10
         u32 pbs : 1;                             // DWORD 10
         u32 dif_mode : 2;                        // DWORD 10
         u32 rsvd1 : 6;                           // DWORD 10
         u32 sge0_last : 1;                       // DWORD 10
         u32 sge0_len : 17;                       // DWORD 11
         u32 rsvd2 : 14;                          // DWORD 11
         u32 sge0_in_ddr : 1;                     // DWORD 11
         u32 newreftag;                           // DWORD 12
         u32 sge1_addr_lo;                        // DWORD 13
         u32 sge1_r2t_offset : 22;                // DWORD 14
         u32 rsvd3 : 1;                           // DWORD 14
         u32 sge1_valid : 1;                      // DWORD 14
         u32 dsbl_crc : 1;                        // DWORD 14
         u32 dsbl_meta : 1;                       // DWORD 14
         u32 dsbl_ref : 1;                        // DWORD 14
         u32 bs : 2;                              // DWORD 14
         u32 m : 2;                               // DWORD 14
         u32 sge1_last : 1;                       // DWORD 14
         u32 sge1_len : 17;                       // DWORD 15
         u32 ref_sgl_icd_idx : 12;                // DWORD 15
         u32 rsvd4 : 2;                           // DWORD 15
         u32 sge1_in_ddr : 1;                     // DWORD 15
      } SG_PACK ISCSI_DIF_WRB, *PISCSI_DIF_WRB;

      typedef union _ISCSI_DIF_WRB_UNION {
         ISCSI_DIF_WRB bits;
         u32 dw[16]; // dword union
      } SG_PACK ISCSI_DIF_WRB_UNION, *PISCSI_DIF_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_DIF_WRB_UNION, sizeof (ISCSI_DIF_WRB_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the ring context structure for iSCSI only, because of its special linked
   // list structure. The HLL and h are used only by btlr to track the list. When
   // receiving a driver request, that is, the driver request bit is set in the
   // TCPSCH_PROC_IQ_DATA descriptor from TCP Scheduler, iSCSI TXULP will double check the
   // wrb_pend to make sure it is greater than zero, and then use the wrb_addr as the
   // address of pending WRB and use it to generate CRA for UC request. After completing
   // the current WRB, the iSCSI RXULP will send the ptr2NxtWRB to the CEV. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_ISCSI {
         union {
            struct { 
               u32 rsvd0 : 3;                     // DWORD 0
               u32 r2t_cidx : 7;                  // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 hll : 8;                       // DWORD 0
               u32 wrb_addr : 8;                  // DWORD 0
               u32 ctx_valid : 1;                 // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 rsvd1 : 5;                     // DWORD 1
               u32 h : 1;                         // DWORD 1
               u32 wrb_pend : 8;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_ISCSI, *PRING_CONTEXT_ISCSI;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_ISCSI, sizeof (RING_CONTEXT_ISCSI) == 8);

   #else
      typedef struct _RING_CONTEXT_ISCSI {
         u32 rsvd0 : 3;                           // DWORD 0
         u32 r2t_cidx : 7;                        // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 hll : 8;                             // DWORD 0
         u32 wrb_addr : 8;                        // DWORD 0
         u32 ctx_valid : 1;                       // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 rsvd1 : 5;                           // DWORD 1
         u32 h : 1;                               // DWORD 1
         u32 wrb_pend : 8;                        // DWORD 1
      } SG_PACK RING_CONTEXT_ISCSI, *PRING_CONTEXT_ISCSI;

      typedef union _RING_CONTEXT_ISCSI_UNION {
         RING_CONTEXT_ISCSI bits;
         u32 dw[2]; // dword union
      } SG_PACK RING_CONTEXT_ISCSI_UNION, *PRING_CONTEXT_ISCSI_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_ISCSI_UNION, sizeof (RING_CONTEXT_ISCSI_UNION) == 8);
   #endif


#else
   // This is the ring context structure for iSCSI only, because of its special linked
   // list structure. The HLL and h are used only by btlr to track the list. When
   // receiving a driver request, that is, the driver request bit is set in the
   // TCPSCH_PROC_IQ_DATA descriptor from TCP Scheduler, iSCSI TXULP will double check the
   // wrb_pend to make sure it is greater than zero, and then use the wrb_addr as the
   // address of pending WRB and use it to generate CRA for UC request. After completing
   // the current WRB, the iSCSI RXULP will send the ptr2NxtWRB to the CEV. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_ISCSI {
         union {
            struct { 
               u32 wrb_addr : 8;                  // DWORD 0
               u32 hll : 8;                       // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 r2t_cidx : 7;                  // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 wrb_pend : 8;                  // DWORD 1
               u32 h : 1;                         // DWORD 1
               u32 rsvd1 : 5;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 ctx_valid : 1;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_ISCSI, *PRING_CONTEXT_ISCSI;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_ISCSI, sizeof (RING_CONTEXT_ISCSI) == 8);

   #else
      typedef struct _RING_CONTEXT_ISCSI {
         u32 wrb_addr : 8;                        // DWORD 0
         u32 hll : 8;                             // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 r2t_cidx : 7;                        // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 wrb_pend : 8;                        // DWORD 1
         u32 h : 1;                               // DWORD 1
         u32 rsvd1 : 5;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 ctx_valid : 1;                       // DWORD 1
      } SG_PACK RING_CONTEXT_ISCSI, *PRING_CONTEXT_ISCSI;

      typedef union _RING_CONTEXT_ISCSI_UNION {
         RING_CONTEXT_ISCSI bits;
         u32 dw[2]; // dword union
      } SG_PACK RING_CONTEXT_ISCSI_UNION, *PRING_CONTEXT_ISCSI_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_ISCSI_UNION, sizeof (RING_CONTEXT_ISCSI_UNION) == 8);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_common_host_struct_bmap_h__

