/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_initiator_host_struct_bmap_h__
#define __iscsi_initiator_host_struct_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "iscsi_enums_bmap.h"
#include "iscsi_common_host_struct_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Status CQE for solicited PDU sequence completions in iSCSI Initiator mode.
   #if defined(SG_BMAP_UNION)
      typedef struct _I_SOL_CQE {
         union {
            struct { 
               u32 s : 1;                         // DWORD 0
               u32 i_flags : 7;                   // DWORD 0
               u32 i_resp : 8;                    // DWORD 0
               u32 i_sts : 8;                     // DWORD 0
               u32 hw_sts : 8;                    // DWORD 0
               u32 i_exp_cmd_sn;                  // DWORD 1
               u32 i_cmd_wnd : 8;                 // DWORD 2
               u32 wrb_index : 8;                 // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 code : 6;                      // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 i_res_cnt : 31;                // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK I_SOL_CQE, *PI_SOL_CQE;

      SG_C_ASSERT(__sizeof__I_SOL_CQE, sizeof (I_SOL_CQE) == 16);

   #else
      typedef struct _I_SOL_CQE {
         u32 s : 1;                               // DWORD 0
         u32 i_flags : 7;                         // DWORD 0
         u32 i_resp : 8;                          // DWORD 0
         u32 i_sts : 8;                           // DWORD 0
         u32 hw_sts : 8;                          // DWORD 0
         u32 i_exp_cmd_sn;                        // DWORD 1
         u32 i_cmd_wnd : 8;                       // DWORD 2
         u32 wrb_index : 8;                       // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 code : 6;                            // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 i_res_cnt : 31;                      // DWORD 3
      } SG_PACK I_SOL_CQE, *PI_SOL_CQE;

      typedef union _I_SOL_CQE_UNION {
         I_SOL_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK I_SOL_CQE_UNION, *PI_SOL_CQE_UNION;

      SG_C_ASSERT(__sizeof__I_SOL_CQE_UNION, sizeof (I_SOL_CQE_UNION) == 16);
   #endif


#else
   // Status CQE for solicited PDU sequence completions in iSCSI Initiator mode.
   #if defined(SG_BMAP_UNION)
      typedef struct _I_SOL_CQE {
         union {
            struct { 
               u32 hw_sts : 8;                    // DWORD 0
               u32 i_sts : 8;                     // DWORD 0
               u32 i_resp : 8;                    // DWORD 0
               u32 i_flags : 7;                   // DWORD 0
               u32 s : 1;                         // DWORD 0
               u32 i_exp_cmd_sn;                  // DWORD 1
               u32 code : 6;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 wrb_index : 8;                 // DWORD 2
               u32 i_cmd_wnd : 8;                 // DWORD 2
               u32 i_res_cnt : 31;                // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK I_SOL_CQE, *PI_SOL_CQE;

      SG_C_ASSERT(__sizeof__I_SOL_CQE, sizeof (I_SOL_CQE) == 16);

   #else
      typedef struct _I_SOL_CQE {
         u32 hw_sts : 8;                          // DWORD 0
         u32 i_sts : 8;                           // DWORD 0
         u32 i_resp : 8;                          // DWORD 0
         u32 i_flags : 7;                         // DWORD 0
         u32 s : 1;                               // DWORD 0
         u32 i_exp_cmd_sn;                        // DWORD 1
         u32 code : 6;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 wrb_index : 8;                       // DWORD 2
         u32 i_cmd_wnd : 8;                       // DWORD 2
         u32 i_res_cnt : 31;                      // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK I_SOL_CQE, *PI_SOL_CQE;

      typedef union _I_SOL_CQE_UNION {
         I_SOL_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK I_SOL_CQE_UNION, *PI_SOL_CQE_UNION;

      SG_C_ASSERT(__sizeof__I_SOL_CQE_UNION, sizeof (I_SOL_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // [table name="iSCSIWRBInitiator" col="4" delimit=":" caption="iSCSI Initiator WRB
   // flag details."] iSCSI PDU type : WR : DSP : DMSG : iSCSI Write command with/without
   // Immediate/unsolicited data : 1 : 1 : 0 : iSCSI Read command: 0 : 0 : 0 : Text
   // request without data: 0 : 0 : 0 : Text request with data: 1 : 1 : 0 : Logout
   // request: 0 : 0 : 0 : NOP OUT with ping data with acknowledgement: 1 : 1 : 0 : NOP
   // OUT without ping data with acknowledgement: 0 : 0 : 0 : NOP OUT without
   // acknowledgement: 0 : 0 : 1 : NOP OUT in response to NOP IN from iSCSI target: 0 : 0
   // : 1 : Task Management function request: 0 : 0 : 0 : [/table] Note:  The logout and
   // task management response will be notified to host driver by Rx ULP as part of
   // default ring processing. It is host driver responsibility to wait for response or
   // time out for these commands to cleanup related data structures. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INITIATOR_WRB {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 abort : 1;                     // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 wrbindex : 8;                  // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 lun : 14;                      // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 1
               u32 sgl_icd_Index : 12;            // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 cmdsn;                         // DWORD 2
               u32 rsvd3 : 20;                    // DWORD 3
               u32 abort_sgl_icd_Index : 12;      // DWORD 3
               u32 addr_hi;                       // DWORD 4
               u32 addr_lo;                       // DWORD 5
               u32 rsvd4[1];                      // DWORDS 6 to 6
               u32 ExpDataXfrLen : 24;            // DWORD 7
               u32 len : 8;                       // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INITIATOR_WRB, *PISCSI_INITIATOR_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_INITIATOR_WRB, sizeof (ISCSI_INITIATOR_WRB) == 32);

   #else
      typedef struct _ISCSI_INITIATOR_WRB {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 abort : 1;                           // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 wrbindex : 8;                        // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 lun : 14;                            // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 1
         u32 sgl_icd_Index : 12;                  // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 cmdsn;                               // DWORD 2
         u32 rsvd3 : 20;                          // DWORD 3
         u32 abort_sgl_icd_Index : 12;            // DWORD 3
         u32 addr_hi;                             // DWORD 4
         u32 addr_lo;                             // DWORD 5
         u32 rsvd4[1];                            // DWORDS 6 to 6
         u32 ExpDataXfrLen : 24;                  // DWORD 7
         u32 len : 8;                             // DWORD 7
      } SG_PACK ISCSI_INITIATOR_WRB, *PISCSI_INITIATOR_WRB;

      typedef union _ISCSI_INITIATOR_WRB_UNION {
         ISCSI_INITIATOR_WRB bits;
         u32 dw[8]; // dword union
      } SG_PACK ISCSI_INITIATOR_WRB_UNION, *PISCSI_INITIATOR_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INITIATOR_WRB_UNION, sizeof (ISCSI_INITIATOR_WRB_UNION) == 32);
   #endif


#else
   // [table name="iSCSIWRBInitiator" col="4" delimit=":" caption="iSCSI Initiator WRB
   // flag details."] iSCSI PDU type : WR : DSP : DMSG : iSCSI Write command with/without
   // Immediate/unsolicited data : 1 : 1 : 0 : iSCSI Read command: 0 : 0 : 0 : Text
   // request without data: 0 : 0 : 0 : Text request with data: 1 : 1 : 0 : Logout
   // request: 0 : 0 : 0 : NOP OUT with ping data with acknowledgement: 1 : 1 : 0 : NOP
   // OUT without ping data with acknowledgement: 0 : 0 : 0 : NOP OUT without
   // acknowledgement: 0 : 0 : 1 : NOP OUT in response to NOP IN from iSCSI target: 0 : 0
   // : 1 : Task Management function request: 0 : 0 : 0 : [/table] Note:  The logout and
   // task management response will be notified to host driver by Rx ULP as part of
   // default ring processing. It is host driver responsibility to wait for response or
   // time out for these commands to cleanup related data structures. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INITIATOR_WRB {
         union {
            struct { 
               u32 lun : 14;                      // DWORD 0
               u32 lt : 1;                        // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 wrbindex : 8;                  // DWORD 0
               u32 dmsg : 1;                      // DWORD 0
               u32 abort : 1;                     // DWORD 0
               u32 dsp : 1;                       // DWORD 0
               u32 invld : 1;                     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 ptr2NextWrb : 8;               // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 sgl_icd_Index : 12;            // DWORD 1
               u32 rsvd2 : 4;                     // DWORD 1
               u32 cmdsn;                         // DWORD 2
               u32 abort_sgl_icd_Index : 12;      // DWORD 3
               u32 rsvd3 : 20;                    // DWORD 3
               u32 addr_hi;                       // DWORD 4
               u32 addr_lo;                       // DWORD 5
               u32 rsvd4[1];                      // DWORDS 6 to 6
               u32 len : 8;                       // DWORD 7
               u32 ExpDataXfrLen : 24;            // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INITIATOR_WRB, *PISCSI_INITIATOR_WRB;

      SG_C_ASSERT(__sizeof__ISCSI_INITIATOR_WRB, sizeof (ISCSI_INITIATOR_WRB) == 32);

   #else
      typedef struct _ISCSI_INITIATOR_WRB {
         u32 lun : 14;                            // DWORD 0
         u32 lt : 1;                              // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 wrbindex : 8;                        // DWORD 0
         u32 dmsg : 1;                            // DWORD 0
         u32 abort : 1;                           // DWORD 0
         u32 dsp : 1;                             // DWORD 0
         u32 invld : 1;                           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 ptr2NextWrb : 8;                     // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 sgl_icd_Index : 12;                  // DWORD 1
         u32 rsvd2 : 4;                           // DWORD 1
         u32 cmdsn;                               // DWORD 2
         u32 abort_sgl_icd_Index : 12;            // DWORD 3
         u32 rsvd3 : 20;                          // DWORD 3
         u32 addr_hi;                             // DWORD 4
         u32 addr_lo;                             // DWORD 5
         u32 rsvd4[1];                            // DWORDS 6 to 6
         u32 len : 8;                             // DWORD 7
         u32 ExpDataXfrLen : 24;                  // DWORD 7
      } SG_PACK ISCSI_INITIATOR_WRB, *PISCSI_INITIATOR_WRB;

      typedef union _ISCSI_INITIATOR_WRB_UNION {
         ISCSI_INITIATOR_WRB bits;
         u32 dw[8]; // dword union
      } SG_PACK ISCSI_INITIATOR_WRB_UNION, *PISCSI_INITIATOR_WRB_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INITIATOR_WRB_UNION, sizeof (ISCSI_INITIATOR_WRB_UNION) == 32);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_initiator_host_struct_bmap_h__

