/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __lpc_bmap_h__
#define __lpc_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Used to generate the address on LPC Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_ADDRESS_CSR {
         union {
            struct { 
               u32 address;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_ADDRESS_CSR, *PLPC_ADDRESS_CSR;

      SG_C_ASSERT(__sizeof__LPC_ADDRESS_CSR, sizeof (LPC_ADDRESS_CSR) == 4);

   #else
      typedef struct _LPC_ADDRESS_CSR {
         u32 address;                             // DWORD 0
      } SG_PACK LPC_ADDRESS_CSR, *PLPC_ADDRESS_CSR;

      typedef union _LPC_ADDRESS_CSR_UNION {
         LPC_ADDRESS_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_ADDRESS_CSR_UNION, *PLPC_ADDRESS_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_ADDRESS_CSR_UNION, sizeof (LPC_ADDRESS_CSR_UNION) == 4);
   #endif


#else
   // Used to generate the address on LPC Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_ADDRESS_CSR {
         union {
            struct { 
               u32 address;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_ADDRESS_CSR, *PLPC_ADDRESS_CSR;

      SG_C_ASSERT(__sizeof__LPC_ADDRESS_CSR, sizeof (LPC_ADDRESS_CSR) == 4);

   #else
      typedef struct _LPC_ADDRESS_CSR {
         u32 address;                             // DWORD 0
      } SG_PACK LPC_ADDRESS_CSR, *PLPC_ADDRESS_CSR;

      typedef union _LPC_ADDRESS_CSR_UNION {
         LPC_ADDRESS_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_ADDRESS_CSR_UNION, *PLPC_ADDRESS_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_ADDRESS_CSR_UNION, sizeof (LPC_ADDRESS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to generate the address on LPC Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_DATA_CSR, *PLPC_DATA_CSR;

      SG_C_ASSERT(__sizeof__LPC_DATA_CSR, sizeof (LPC_DATA_CSR) == 4);

   #else
      typedef struct _LPC_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK LPC_DATA_CSR, *PLPC_DATA_CSR;

      typedef union _LPC_DATA_CSR_UNION {
         LPC_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_DATA_CSR_UNION, *PLPC_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_DATA_CSR_UNION, sizeof (LPC_DATA_CSR_UNION) == 4);
   #endif


#else
   // Used to generate the address on LPC Interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_DATA_CSR, *PLPC_DATA_CSR;

      SG_C_ASSERT(__sizeof__LPC_DATA_CSR, sizeof (LPC_DATA_CSR) == 4);

   #else
      typedef struct _LPC_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK LPC_DATA_CSR, *PLPC_DATA_CSR;

      typedef union _LPC_DATA_CSR_UNION {
         LPC_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_DATA_CSR_UNION, *PLPC_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_DATA_CSR_UNION, sizeof (LPC_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // A write with the LPC start bit set will initiate a R/W cycle based on the Read/Write
   // Bit. Once this register is written, the host software should read the status
   // register to check for the LPC interface to be not busy to determine the completion
   // of the cycle. To R/W 32-bits of data the Byte Enable[3:0] should be programmed to
   // 0Fh.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_CMD_CSR {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 start : 1;                     // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 be : 4;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_CMD_CSR, *PLPC_CMD_CSR;

      SG_C_ASSERT(__sizeof__LPC_CMD_CSR, sizeof (LPC_CMD_CSR) == 4);

   #else
      typedef struct _LPC_CMD_CSR {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 start : 1;                           // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 be : 4;                              // DWORD 0
      } SG_PACK LPC_CMD_CSR, *PLPC_CMD_CSR;

      typedef union _LPC_CMD_CSR_UNION {
         LPC_CMD_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_CMD_CSR_UNION, *PLPC_CMD_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_CMD_CSR_UNION, sizeof (LPC_CMD_CSR_UNION) == 4);
   #endif


#else
   // A write with the LPC start bit set will initiate a R/W cycle based on the Read/Write
   // Bit. Once this register is written, the host software should read the status
   // register to check for the LPC interface to be not busy to determine the completion
   // of the cycle. To R/W 32-bits of data the Byte Enable[3:0] should be programmed to
   // 0Fh.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_CMD_CSR {
         union {
            struct { 
               u32 be : 4;                        // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 start : 1;                     // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_CMD_CSR, *PLPC_CMD_CSR;

      SG_C_ASSERT(__sizeof__LPC_CMD_CSR, sizeof (LPC_CMD_CSR) == 4);

   #else
      typedef struct _LPC_CMD_CSR {
         u32 be : 4;                              // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 start : 1;                           // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK LPC_CMD_CSR, *PLPC_CMD_CSR;

      typedef union _LPC_CMD_CSR_UNION {
         LPC_CMD_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_CMD_CSR_UNION, *PLPC_CMD_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_CMD_CSR_UNION, sizeof (LPC_CMD_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // A write with the LPC start bit set will initiate a R/W cycle based on the Read/Write
   // Bit. Once this register is written, the host software should read the status
   // register to check for the LPC interface to be not busy to determine the completion
   // of the cycle. To R/W 32-bits of data the Byte Enable[3:0] should be programmed to
   // 0Fh.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 30;                    // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 busy : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_STATUS_CSR, *PLPC_STATUS_CSR;

      SG_C_ASSERT(__sizeof__LPC_STATUS_CSR, sizeof (LPC_STATUS_CSR) == 4);

   #else
      typedef struct _LPC_STATUS_CSR {
         u32 rsvd0 : 30;                          // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 busy : 1;                            // DWORD 0
      } SG_PACK LPC_STATUS_CSR, *PLPC_STATUS_CSR;

      typedef union _LPC_STATUS_CSR_UNION {
         LPC_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_STATUS_CSR_UNION, *PLPC_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_STATUS_CSR_UNION, sizeof (LPC_STATUS_CSR_UNION) == 4);
   #endif


#else
   // A write with the LPC start bit set will initiate a R/W cycle based on the Read/Write
   // Bit. Once this register is written, the host software should read the status
   // register to check for the LPC interface to be not busy to determine the completion
   // of the cycle. To R/W 32-bits of data the Byte Enable[3:0] should be programmed to
   // 0Fh.
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_STATUS_CSR {
         union {
            struct { 
               u32 busy : 1;                      // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 rsvd0 : 30;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LPC_STATUS_CSR, *PLPC_STATUS_CSR;

      SG_C_ASSERT(__sizeof__LPC_STATUS_CSR, sizeof (LPC_STATUS_CSR) == 4);

   #else
      typedef struct _LPC_STATUS_CSR {
         u32 busy : 1;                            // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
      } SG_PACK LPC_STATUS_CSR, *PLPC_STATUS_CSR;

      typedef union _LPC_STATUS_CSR_UNION {
         LPC_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK LPC_STATUS_CSR_UNION, *PLPC_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__LPC_STATUS_CSR_UNION, sizeof (LPC_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This section defines the low pin count interface register map. 
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_CSRMAP {
         union {
            struct { 
               LPC_ADDRESS_CSR addr;
               LPC_DATA_CSR data;
               LPC_CMD_CSR cmd;
               LPC_STATUS_CSR status;
               u32 rsvd0[252];                    // DWORDS 4 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK LPC_CSRMAP, *PLPC_CSRMAP;

      SG_C_ASSERT(__sizeof__LPC_CSRMAP, sizeof (LPC_CSRMAP) == 1024);

   #else
      typedef struct _LPC_CSRMAP {
         LPC_ADDRESS_CSR addr;
         LPC_DATA_CSR data;
         LPC_CMD_CSR cmd;
         LPC_STATUS_CSR status;
         u32 rsvd0[252];                          // DWORDS 4 to 255
      } SG_PACK LPC_CSRMAP, *PLPC_CSRMAP;

      typedef union _LPC_CSRMAP_UNION {
         LPC_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK LPC_CSRMAP_UNION, *PLPC_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__LPC_CSRMAP_UNION, sizeof (LPC_CSRMAP_UNION) == 1024);
   #endif


#else
   // This section defines the low pin count interface register map. 
   #if defined(SG_BMAP_UNION)
      typedef struct _LPC_CSRMAP {
         union {
            struct { 
               LPC_ADDRESS_CSR addr;
               LPC_DATA_CSR data;
               LPC_CMD_CSR cmd;
               LPC_STATUS_CSR status;
               u32 rsvd0[252];                    // DWORDS 4 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK LPC_CSRMAP, *PLPC_CSRMAP;

      SG_C_ASSERT(__sizeof__LPC_CSRMAP, sizeof (LPC_CSRMAP) == 1024);

   #else
      typedef struct _LPC_CSRMAP {
         LPC_ADDRESS_CSR addr;
         LPC_DATA_CSR data;
         LPC_CMD_CSR cmd;
         LPC_STATUS_CSR status;
         u32 rsvd0[252];                          // DWORDS 4 to 255
      } SG_PACK LPC_CSRMAP, *PLPC_CSRMAP;

      typedef union _LPC_CSRMAP_UNION {
         LPC_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK LPC_CSRMAP_UNION, *PLPC_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__LPC_CSRMAP_UNION, sizeof (LPC_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __lpc_bmap_h__

