/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __lro_tcp_context_bmap_h__
#define __lro_tcp_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // LRO parameters, configurable per interface by host, interface can be tied to either
   // port. 
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_INTERFACE_PARAMS {
         union {
            struct { 
               u32 max_chainlen;                  // DWORD 0
               u32 full_chainlen;                 // DWORD 1
               u32 max_segcount;                  // DWORD 2
               u32 max_chaintime;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK LRO_INTERFACE_PARAMS, *PLRO_INTERFACE_PARAMS;

      SG_C_ASSERT(__sizeof__LRO_INTERFACE_PARAMS, sizeof (LRO_INTERFACE_PARAMS) == 16);

   #else
      typedef struct _LRO_INTERFACE_PARAMS {
         u32 max_chainlen;                        // DWORD 0
         u32 full_chainlen;                       // DWORD 1
         u32 max_segcount;                        // DWORD 2
         u32 max_chaintime;                       // DWORD 3
      } SG_PACK LRO_INTERFACE_PARAMS, *PLRO_INTERFACE_PARAMS;

      typedef union _LRO_INTERFACE_PARAMS_UNION {
         LRO_INTERFACE_PARAMS bits;
         u32 dw[4]; // dword union
      } SG_PACK LRO_INTERFACE_PARAMS_UNION, *PLRO_INTERFACE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__LRO_INTERFACE_PARAMS_UNION, sizeof (LRO_INTERFACE_PARAMS_UNION) == 16);
   #endif


#else
   // LRO parameters, configurable per interface by host, interface can be tied to either
   // port. 
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_INTERFACE_PARAMS {
         union {
            struct { 
               u32 max_chainlen;                  // DWORD 0
               u32 full_chainlen;                 // DWORD 1
               u32 max_segcount;                  // DWORD 2
               u32 max_chaintime;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK LRO_INTERFACE_PARAMS, *PLRO_INTERFACE_PARAMS;

      SG_C_ASSERT(__sizeof__LRO_INTERFACE_PARAMS, sizeof (LRO_INTERFACE_PARAMS) == 16);

   #else
      typedef struct _LRO_INTERFACE_PARAMS {
         u32 max_chainlen;                        // DWORD 0
         u32 full_chainlen;                       // DWORD 1
         u32 max_segcount;                        // DWORD 2
         u32 max_chaintime;                       // DWORD 3
      } SG_PACK LRO_INTERFACE_PARAMS, *PLRO_INTERFACE_PARAMS;

      typedef union _LRO_INTERFACE_PARAMS_UNION {
         LRO_INTERFACE_PARAMS bits;
         u32 dw[4]; // dword union
      } SG_PACK LRO_INTERFACE_PARAMS_UNION, *PLRO_INTERFACE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__LRO_INTERFACE_PARAMS_UNION, sizeof (LRO_INTERFACE_PARAMS_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // LRO TCP connection context structure
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_TCP_CONTEXT {
         union {
            struct { 
               LRO_INTERFACE_PARAMS lroparms[2];
               u32 lro_credits_added[2];          // DWORDS 8 to 9
               u32 rsvd0[1];                      // DWORDS 10 to 10
               union {
                  u32 all;                        // DWORD 11
                  struct {
                     u32 inchain : 8;             // DWORD 11
                     u32 ipv6 : 8;                // DWORD 11
                     u32 tsopt : 8;               // DWORD 11
                     u32 port : 8;                // DWORD 11
                  } field;
               } flags;
               u32 srcip[4];                      // DWORDS 12 to 15
               u32 dstip[4];                      // DWORDS 16 to 19
               union {
                  u32 all;                        // DWORD 20
                  struct {
                     u32 srcport : 16;            // DWORD 20
                     u32 dstport : 16;            // DWORD 20
                  } field;
               } ports;
               u32 rsvd1 : 8;                     // DWORD 21
               u32 cid : 8;                       // DWORD 21
               u32 lro_win : 16;                  // DWORD 21
               u32 lro_rcv_nxt;                   // DWORD 22
               u32 lro_ack;                       // DWORD 23
               u32 lro_len;                       // DWORD 24
               u32 lro_segcount : 16;             // DWORD 25
               u32 dupack_count : 16;             // DWORD 25
               u32 lro_tsval;                     // DWORD 26
               u32 rsvd2[4];                      // DWORDS 27 to 30
               u32 lro_ctx_addr;                  // DWORD 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK LRO_TCP_CONTEXT, *PLRO_TCP_CONTEXT;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT, sizeof (LRO_TCP_CONTEXT) == 128);

   #else
      typedef struct _LRO_TCP_CONTEXT {
         LRO_INTERFACE_PARAMS lroparms[2];
         u32 lro_credits_added[2];                // DWORDS 8 to 9
         u32 rsvd0[1];                            // DWORDS 10 to 10
         union {
            u32 all;                              // DWORD 11
            struct {
               u32 inchain : 8;                   // DWORD 11
               u32 ipv6 : 8;                      // DWORD 11
               u32 tsopt : 8;                     // DWORD 11
               u32 port : 8;                      // DWORD 11
            } field;
         } flags;
         u32 srcip[4];                            // DWORDS 12 to 15
         u32 dstip[4];                            // DWORDS 16 to 19
         union {
            u32 all;                              // DWORD 20
            struct {
               u32 srcport : 16;                  // DWORD 20
               u32 dstport : 16;                  // DWORD 20
            } field;
         } ports;
         u32 rsvd1 : 8;                           // DWORD 21
         u32 cid : 8;                             // DWORD 21
         u32 lro_win : 16;                        // DWORD 21
         u32 lro_rcv_nxt;                         // DWORD 22
         u32 lro_ack;                             // DWORD 23
         u32 lro_len;                             // DWORD 24
         u32 lro_segcount : 16;                   // DWORD 25
         u32 dupack_count : 16;                   // DWORD 25
         u32 lro_tsval;                           // DWORD 26
         u32 rsvd2[4];                            // DWORDS 27 to 30
         u32 lro_ctx_addr;                        // DWORD 31
      } SG_PACK LRO_TCP_CONTEXT, *PLRO_TCP_CONTEXT;

      typedef union _LRO_TCP_CONTEXT_UNION {
         LRO_TCP_CONTEXT bits;
         u32 dw[32]; // dword union
      } SG_PACK LRO_TCP_CONTEXT_UNION, *PLRO_TCP_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT_UNION, sizeof (LRO_TCP_CONTEXT_UNION) == 128);
   #endif


#else
   // LRO TCP connection context structure
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_TCP_CONTEXT {
         union {
            struct { 
               LRO_INTERFACE_PARAMS lroparms[2];
               u32 lro_credits_added[2];          // DWORDS 8 to 9
               u32 rsvd0[1];                      // DWORDS 10 to 10
               union {
                  u32 all;                        // DWORD 11
                  struct {
                     u32 port : 8;                // DWORD 11
                     u32 tsopt : 8;               // DWORD 11
                     u32 ipv6 : 8;                // DWORD 11
                     u32 inchain : 8;             // DWORD 11
                  } field;
               } flags;
               u32 srcip[4];                      // DWORDS 12 to 15
               u32 dstip[4];                      // DWORDS 16 to 19
               union {
                  u32 all;                        // DWORD 20
                  struct {
                     u32 dstport : 16;            // DWORD 20
                     u32 srcport : 16;            // DWORD 20
                  } field;
               } ports;
               u32 lro_win : 16;                  // DWORD 21
               u32 cid : 8;                       // DWORD 21
               u32 rsvd1 : 8;                     // DWORD 21
               u32 lro_rcv_nxt;                   // DWORD 22
               u32 lro_ack;                       // DWORD 23
               u32 lro_len;                       // DWORD 24
               u32 dupack_count : 16;             // DWORD 25
               u32 lro_segcount : 16;             // DWORD 25
               u32 lro_tsval;                     // DWORD 26
               u32 rsvd2[4];                      // DWORDS 27 to 30
               u32 lro_ctx_addr;                  // DWORD 31
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK LRO_TCP_CONTEXT, *PLRO_TCP_CONTEXT;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT, sizeof (LRO_TCP_CONTEXT) == 128);

   #else
      typedef struct _LRO_TCP_CONTEXT {
         LRO_INTERFACE_PARAMS lroparms[2];
         u32 lro_credits_added[2];                // DWORDS 8 to 9
         u32 rsvd0[1];                            // DWORDS 10 to 10
         union {
            u32 all;                              // DWORD 11
            struct {
               u32 port : 8;                      // DWORD 11
               u32 tsopt : 8;                     // DWORD 11
               u32 ipv6 : 8;                      // DWORD 11
               u32 inchain : 8;                   // DWORD 11
            } field;
         } flags;
         u32 srcip[4];                            // DWORDS 12 to 15
         u32 dstip[4];                            // DWORDS 16 to 19
         union {
            u32 all;                              // DWORD 20
            struct {
               u32 dstport : 16;                  // DWORD 20
               u32 srcport : 16;                  // DWORD 20
            } field;
         } ports;
         u32 lro_win : 16;                        // DWORD 21
         u32 cid : 8;                             // DWORD 21
         u32 rsvd1 : 8;                           // DWORD 21
         u32 lro_rcv_nxt;                         // DWORD 22
         u32 lro_ack;                             // DWORD 23
         u32 lro_len;                             // DWORD 24
         u32 dupack_count : 16;                   // DWORD 25
         u32 lro_segcount : 16;                   // DWORD 25
         u32 lro_tsval;                           // DWORD 26
         u32 rsvd2[4];                            // DWORDS 27 to 30
         u32 lro_ctx_addr;                        // DWORD 31
      } SG_PACK LRO_TCP_CONTEXT, *PLRO_TCP_CONTEXT;

      typedef union _LRO_TCP_CONTEXT_UNION {
         LRO_TCP_CONTEXT bits;
         u32 dw[32]; // dword union
      } SG_PACK LRO_TCP_CONTEXT_UNION, *PLRO_TCP_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT_UNION, sizeof (LRO_TCP_CONTEXT_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_QCR_FORMAT {
         union {
            struct { 
               u32 rsvd2 : 11;                    // DWORD 0
               u32 dbcred_check : 1;              // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
               u32 is_in_sequence : 1;            // DWORD 0
               u32 lro_context_match : 1;         // DWORD 0
               u32 is_singleton : 1;              // DWORD 0
               u32 rsvd0 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LRO_QCR_FORMAT, *PLRO_QCR_FORMAT;

      SG_C_ASSERT(__sizeof__LRO_QCR_FORMAT, sizeof (LRO_QCR_FORMAT) == 4);

   #else
      typedef struct _LRO_QCR_FORMAT {
         u32 rsvd2 : 11;                          // DWORD 0
         u32 dbcred_check : 1;                    // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 is_in_sequence : 1;                  // DWORD 0
         u32 lro_context_match : 1;               // DWORD 0
         u32 is_singleton : 1;                    // DWORD 0
         u32 rsvd0 : 11;                          // DWORD 0
      } SG_PACK LRO_QCR_FORMAT, *PLRO_QCR_FORMAT;

      typedef union _LRO_QCR_FORMAT_UNION {
         LRO_QCR_FORMAT bits;
         u32 dw; // dword union
      } SG_PACK LRO_QCR_FORMAT_UNION, *PLRO_QCR_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__LRO_QCR_FORMAT_UNION, sizeof (LRO_QCR_FORMAT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_QCR_FORMAT {
         union {
            struct { 
               u32 rsvd0 : 11;                    // DWORD 0
               u32 is_singleton : 1;              // DWORD 0
               u32 lro_context_match : 1;         // DWORD 0
               u32 is_in_sequence : 1;            // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
               u32 dbcred_check : 1;              // DWORD 0
               u32 rsvd2 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LRO_QCR_FORMAT, *PLRO_QCR_FORMAT;

      SG_C_ASSERT(__sizeof__LRO_QCR_FORMAT, sizeof (LRO_QCR_FORMAT) == 4);

   #else
      typedef struct _LRO_QCR_FORMAT {
         u32 rsvd0 : 11;                          // DWORD 0
         u32 is_singleton : 1;                    // DWORD 0
         u32 lro_context_match : 1;               // DWORD 0
         u32 is_in_sequence : 1;                  // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 dbcred_check : 1;                    // DWORD 0
         u32 rsvd2 : 11;                          // DWORD 0
      } SG_PACK LRO_QCR_FORMAT, *PLRO_QCR_FORMAT;

      typedef union _LRO_QCR_FORMAT_UNION {
         LRO_QCR_FORMAT bits;
         u32 dw; // dword union
      } SG_PACK LRO_QCR_FORMAT_UNION, *PLRO_QCR_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__LRO_QCR_FORMAT_UNION, sizeof (LRO_QCR_FORMAT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_TCP_CONTEXT_QCR {
         union {
            struct { 
               LRO_TCP_CONTEXT ctx;
               LRO_QCR_FORMAT qcr;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK LRO_TCP_CONTEXT_QCR, *PLRO_TCP_CONTEXT_QCR;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT_QCR, sizeof (LRO_TCP_CONTEXT_QCR) == 132);

   #else
      typedef struct _LRO_TCP_CONTEXT_QCR {
         LRO_TCP_CONTEXT ctx;
         LRO_QCR_FORMAT qcr;
      } SG_PACK LRO_TCP_CONTEXT_QCR, *PLRO_TCP_CONTEXT_QCR;

      typedef union _LRO_TCP_CONTEXT_QCR_UNION {
         LRO_TCP_CONTEXT_QCR bits;
         u32 dw[33]; // dword union
      } SG_PACK LRO_TCP_CONTEXT_QCR_UNION, *PLRO_TCP_CONTEXT_QCR_UNION;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT_QCR_UNION, sizeof (LRO_TCP_CONTEXT_QCR_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LRO_TCP_CONTEXT_QCR {
         union {
            struct { 
               LRO_TCP_CONTEXT ctx;
               LRO_QCR_FORMAT qcr;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK LRO_TCP_CONTEXT_QCR, *PLRO_TCP_CONTEXT_QCR;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT_QCR, sizeof (LRO_TCP_CONTEXT_QCR) == 132);

   #else
      typedef struct _LRO_TCP_CONTEXT_QCR {
         LRO_TCP_CONTEXT ctx;
         LRO_QCR_FORMAT qcr;
      } SG_PACK LRO_TCP_CONTEXT_QCR, *PLRO_TCP_CONTEXT_QCR;

      typedef union _LRO_TCP_CONTEXT_QCR_UNION {
         LRO_TCP_CONTEXT_QCR bits;
         u32 dw[33]; // dword union
      } SG_PACK LRO_TCP_CONTEXT_QCR_UNION, *PLRO_TCP_CONTEXT_QCR_UNION;

      SG_C_ASSERT(__sizeof__LRO_TCP_CONTEXT_QCR_UNION, sizeof (LRO_TCP_CONTEXT_QCR_UNION) == 132);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __lro_tcp_context_bmap_h__

