/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_context_bmap_h__
#define __mpu_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Management command and control ring context. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_RING_CONTEXT {
         union {
            struct { 
               u32 cq_id : 10;                    // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 con_index : 14;                // DWORD 0
               u32 valid : 1;                     // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 fid : 8;                       // DWORD 1
               u32 prod_index : 14;               // DWORD 1
               u32 rsvd1 : 21;                    // DWORD 2
               u32 async_cq_id : 10;              // DWORD 2
               u32 async_cq_valid : 1;            // DWORD 2
               u32 rsvd2[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MCC_RING_CONTEXT, *PMCC_RING_CONTEXT;

      SG_C_ASSERT(__sizeof__MCC_RING_CONTEXT, sizeof (MCC_RING_CONTEXT) == 16);

   #else
      typedef struct _MCC_RING_CONTEXT {
         u32 cq_id : 10;                          // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 con_index : 14;                      // DWORD 0
         u32 valid : 1;                           // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 fid : 8;                             // DWORD 1
         u32 prod_index : 14;                     // DWORD 1
         u32 rsvd1 : 21;                          // DWORD 2
         u32 async_cq_id : 10;                    // DWORD 2
         u32 async_cq_valid : 1;                  // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
      } SG_PACK MCC_RING_CONTEXT, *PMCC_RING_CONTEXT;

      typedef union _MCC_RING_CONTEXT_UNION {
         MCC_RING_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK MCC_RING_CONTEXT_UNION, *PMCC_RING_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__MCC_RING_CONTEXT_UNION, sizeof (MCC_RING_CONTEXT_UNION) == 16);
   #endif


#else
   // Management command and control ring context. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_RING_CONTEXT {
         union {
            struct { 
               u32 con_index : 14;                // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ring_size : 4;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 cq_id : 10;                    // DWORD 0
               u32 prod_index : 14;               // DWORD 1
               u32 fid : 8;                       // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 valid : 1;                     // DWORD 1
               u32 async_cq_valid : 1;            // DWORD 2
               u32 async_cq_id : 10;              // DWORD 2
               u32 rsvd1 : 21;                    // DWORD 2
               u32 rsvd2[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MCC_RING_CONTEXT, *PMCC_RING_CONTEXT;

      SG_C_ASSERT(__sizeof__MCC_RING_CONTEXT, sizeof (MCC_RING_CONTEXT) == 16);

   #else
      typedef struct _MCC_RING_CONTEXT {
         u32 con_index : 14;                      // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ring_size : 4;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 cq_id : 10;                          // DWORD 0
         u32 prod_index : 14;                     // DWORD 1
         u32 fid : 8;                             // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 valid : 1;                           // DWORD 1
         u32 async_cq_valid : 1;                  // DWORD 2
         u32 async_cq_id : 10;                    // DWORD 2
         u32 rsvd1 : 21;                          // DWORD 2
         u32 rsvd2[1];                            // DWORDS 3 to 3
      } SG_PACK MCC_RING_CONTEXT, *PMCC_RING_CONTEXT;

      typedef union _MCC_RING_CONTEXT_UNION {
         MCC_RING_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK MCC_RING_CONTEXT_UNION, *PMCC_RING_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__MCC_RING_CONTEXT_UNION, sizeof (MCC_RING_CONTEXT_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __mpu_context_bmap_h__

