/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_mailbox_bmap_h__
#define __mpu_mailbox_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // MPU Mailbox data for initialization.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAILBOX {
         union {
            struct { 
               u32 mpu_mailbox_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAILBOX, *PMAILBOX;

      SG_C_ASSERT(__sizeof__MAILBOX, sizeof (MAILBOX) == 4);

   #else
      typedef struct _MAILBOX {
         u32 mpu_mailbox_data;                    // DWORD 0
      } SG_PACK MAILBOX, *PMAILBOX;

      typedef union _MAILBOX_UNION {
         MAILBOX bits;
         u32 dw; // dword union
      } SG_PACK MAILBOX_UNION, *PMAILBOX_UNION;

      SG_C_ASSERT(__sizeof__MAILBOX_UNION, sizeof (MAILBOX_UNION) == 4);
   #endif


#else
   // MPU Mailbox data for initialization.
   #if defined(SG_BMAP_UNION)
      typedef struct _MAILBOX {
         union {
            struct { 
               u32 mpu_mailbox_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MAILBOX, *PMAILBOX;

      SG_C_ASSERT(__sizeof__MAILBOX, sizeof (MAILBOX) == 4);

   #else
      typedef struct _MAILBOX {
         u32 mpu_mailbox_data;                    // DWORD 0
      } SG_PACK MAILBOX, *PMAILBOX;

      typedef union _MAILBOX_UNION {
         MAILBOX bits;
         u32 dw; // dword union
      } SG_PACK MAILBOX_UNION, *PMAILBOX_UNION;

      SG_C_ASSERT(__sizeof__MAILBOX_UNION, sizeof (MAILBOX_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MCC Bootstrap registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MAILBOX_CSRMAP {
         union {
            struct { 
               MAILBOX mailbox[32];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK MPU_MAILBOX_CSRMAP, *PMPU_MAILBOX_CSRMAP;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_CSRMAP, sizeof (MPU_MAILBOX_CSRMAP) == 128);

   #else
      typedef struct _MPU_MAILBOX_CSRMAP {
         MAILBOX mailbox[32];
      } SG_PACK MPU_MAILBOX_CSRMAP, *PMPU_MAILBOX_CSRMAP;

      typedef union _MPU_MAILBOX_CSRMAP_UNION {
         MPU_MAILBOX_CSRMAP bits;
         u32 dw[32]; // dword union
      } SG_PACK MPU_MAILBOX_CSRMAP_UNION, *PMPU_MAILBOX_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_CSRMAP_UNION, sizeof (MPU_MAILBOX_CSRMAP_UNION) == 128);
   #endif


#else
   // MCC Bootstrap registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MAILBOX_CSRMAP {
         union {
            struct { 
               MAILBOX mailbox[32];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK MPU_MAILBOX_CSRMAP, *PMPU_MAILBOX_CSRMAP;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_CSRMAP, sizeof (MPU_MAILBOX_CSRMAP) == 128);

   #else
      typedef struct _MPU_MAILBOX_CSRMAP {
         MAILBOX mailbox[32];
      } SG_PACK MPU_MAILBOX_CSRMAP, *PMPU_MAILBOX_CSRMAP;

      typedef union _MPU_MAILBOX_CSRMAP_UNION {
         MPU_MAILBOX_CSRMAP bits;
         u32 dw[32]; // dword union
      } SG_PACK MPU_MAILBOX_CSRMAP_UNION, *PMPU_MAILBOX_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_CSRMAP_UNION, sizeof (MPU_MAILBOX_CSRMAP_UNION) == 128);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __mpu_mailbox_bmap_h__

