/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ndma_bmap_h__
#define __ndma_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pq_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Weighted Arbitration Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_WRR_ENTRY_CSR {
         union {
            struct { 
               u32 rsvd2 : 16;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 weight1 : 6;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 weight0 : 6;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_WRR_ENTRY_CSR, *PNDMA_WRR_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__NDMA_WRR_ENTRY_CSR, sizeof (NDMA_WRR_ENTRY_CSR) == 4);

   #else
      typedef struct _NDMA_WRR_ENTRY_CSR {
         u32 rsvd2 : 16;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 weight1 : 6;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 weight0 : 6;                         // DWORD 0
      } SG_PACK NDMA_WRR_ENTRY_CSR, *PNDMA_WRR_ENTRY_CSR;

      typedef union _NDMA_WRR_ENTRY_CSR_UNION {
         NDMA_WRR_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_WRR_ENTRY_CSR_UNION, *PNDMA_WRR_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_WRR_ENTRY_CSR_UNION, sizeof (NDMA_WRR_ENTRY_CSR_UNION) == 4);
   #endif


#else
   // Weighted Arbitration Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_WRR_ENTRY_CSR {
         union {
            struct { 
               u32 weight0 : 6;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 weight1 : 6;                   // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rsvd2 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_WRR_ENTRY_CSR, *PNDMA_WRR_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__NDMA_WRR_ENTRY_CSR, sizeof (NDMA_WRR_ENTRY_CSR) == 4);

   #else
      typedef struct _NDMA_WRR_ENTRY_CSR {
         u32 weight0 : 6;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 weight1 : 6;                         // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rsvd2 : 16;                          // DWORD 0
      } SG_PACK NDMA_WRR_ENTRY_CSR, *PNDMA_WRR_ENTRY_CSR;

      typedef union _NDMA_WRR_ENTRY_CSR_UNION {
         NDMA_WRR_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_WRR_ENTRY_CSR_UNION, *PNDMA_WRR_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_WRR_ENTRY_CSR_UNION, sizeof (NDMA_WRR_ENTRY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_CTRL_CSR {
         union {
            struct { 
               u32 rsvd0 : 25;                    // DWORD 0
               u32 stall_on_error : 1;            // DWORD 0
               u32 auto_inc : 1;                  // DWORD 0
               u32 dbug_sel : 5;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_CTRL_CSR, *PNDMA_CTRL_CSR;

      SG_C_ASSERT(__sizeof__NDMA_CTRL_CSR, sizeof (NDMA_CTRL_CSR) == 4);

   #else
      typedef struct _NDMA_CTRL_CSR {
         u32 rsvd0 : 25;                          // DWORD 0
         u32 stall_on_error : 1;                  // DWORD 0
         u32 auto_inc : 1;                        // DWORD 0
         u32 dbug_sel : 5;                        // DWORD 0
      } SG_PACK NDMA_CTRL_CSR, *PNDMA_CTRL_CSR;

      typedef union _NDMA_CTRL_CSR_UNION {
         NDMA_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_CTRL_CSR_UNION, *PNDMA_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_CTRL_CSR_UNION, sizeof (NDMA_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Debug Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_CTRL_CSR {
         union {
            struct { 
               u32 dbug_sel : 5;                  // DWORD 0
               u32 auto_inc : 1;                  // DWORD 0
               u32 stall_on_error : 1;            // DWORD 0
               u32 rsvd0 : 25;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_CTRL_CSR, *PNDMA_CTRL_CSR;

      SG_C_ASSERT(__sizeof__NDMA_CTRL_CSR, sizeof (NDMA_CTRL_CSR) == 4);

   #else
      typedef struct _NDMA_CTRL_CSR {
         u32 dbug_sel : 5;                        // DWORD 0
         u32 auto_inc : 1;                        // DWORD 0
         u32 stall_on_error : 1;                  // DWORD 0
         u32 rsvd0 : 25;                          // DWORD 0
      } SG_PACK NDMA_CTRL_CSR, *PNDMA_CTRL_CSR;

      typedef union _NDMA_CTRL_CSR_UNION {
         NDMA_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_CTRL_CSR_UNION, *PNDMA_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_CTRL_CSR_UNION, sizeof (NDMA_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // NDMA Status Register. This CSR is a read-only mux of multiple internal status
   // registers
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_STS_CSR {
         union {
            struct { 
               u32 status;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_STS_CSR, *PNDMA_STS_CSR;

      SG_C_ASSERT(__sizeof__NDMA_STS_CSR, sizeof (NDMA_STS_CSR) == 4);

   #else
      typedef struct _NDMA_STS_CSR {
         u32 status;                              // DWORD 0
      } SG_PACK NDMA_STS_CSR, *PNDMA_STS_CSR;

      typedef union _NDMA_STS_CSR_UNION {
         NDMA_STS_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_STS_CSR_UNION, *PNDMA_STS_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_STS_CSR_UNION, sizeof (NDMA_STS_CSR_UNION) == 4);
   #endif


#else
   // NDMA Status Register. This CSR is a read-only mux of multiple internal status
   // registers
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_STS_CSR {
         union {
            struct { 
               u32 status;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_STS_CSR, *PNDMA_STS_CSR;

      SG_C_ASSERT(__sizeof__NDMA_STS_CSR, sizeof (NDMA_STS_CSR) == 4);

   #else
      typedef struct _NDMA_STS_CSR {
         u32 status;                              // DWORD 0
      } SG_PACK NDMA_STS_CSR, *PNDMA_STS_CSR;

      typedef union _NDMA_STS_CSR_UNION {
         NDMA_STS_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_STS_CSR_UNION, *PNDMA_STS_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_STS_CSR_UNION, sizeof (NDMA_STS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // NDMA Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 ndma_host_ue_source : 1;       // DWORD 0
               u32 ndma_parity_ue_source : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_UE_SOURCE_CSR, *PNDMA_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__NDMA_UE_SOURCE_CSR, sizeof (NDMA_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _NDMA_UE_SOURCE_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 ndma_host_ue_source : 1;             // DWORD 0
         u32 ndma_parity_ue_source : 1;           // DWORD 0
      } SG_PACK NDMA_UE_SOURCE_CSR, *PNDMA_UE_SOURCE_CSR;

      typedef union _NDMA_UE_SOURCE_CSR_UNION {
         NDMA_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_UE_SOURCE_CSR_UNION, *PNDMA_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_UE_SOURCE_CSR_UNION, sizeof (NDMA_UE_SOURCE_CSR_UNION) == 4);
   #endif


#else
   // NDMA Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_UE_SOURCE_CSR {
         union {
            struct { 
               u32 ndma_parity_ue_source : 1;     // DWORD 0
               u32 ndma_host_ue_source : 1;       // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_UE_SOURCE_CSR, *PNDMA_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__NDMA_UE_SOURCE_CSR, sizeof (NDMA_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _NDMA_UE_SOURCE_CSR {
         u32 ndma_parity_ue_source : 1;           // DWORD 0
         u32 ndma_host_ue_source : 1;             // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK NDMA_UE_SOURCE_CSR, *PNDMA_UE_SOURCE_CSR;

      typedef union _NDMA_UE_SOURCE_CSR_UNION {
         NDMA_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_UE_SOURCE_CSR_UNION, *PNDMA_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_UE_SOURCE_CSR_UNION, sizeof (NDMA_UE_SOURCE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // NDMA Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 ndma_host_ue_enable : 1;       // DWORD 0
               u32 ndma_parity_ue_enable : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_UE_ENABLE_CSR, *PNDMA_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__NDMA_UE_ENABLE_CSR, sizeof (NDMA_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _NDMA_UE_ENABLE_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 ndma_host_ue_enable : 1;             // DWORD 0
         u32 ndma_parity_ue_enable : 1;           // DWORD 0
      } SG_PACK NDMA_UE_ENABLE_CSR, *PNDMA_UE_ENABLE_CSR;

      typedef union _NDMA_UE_ENABLE_CSR_UNION {
         NDMA_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_UE_ENABLE_CSR_UNION, *PNDMA_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_UE_ENABLE_CSR_UNION, sizeof (NDMA_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // NDMA Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_UE_ENABLE_CSR {
         union {
            struct { 
               u32 ndma_parity_ue_enable : 1;     // DWORD 0
               u32 ndma_host_ue_enable : 1;       // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_UE_ENABLE_CSR, *PNDMA_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__NDMA_UE_ENABLE_CSR, sizeof (NDMA_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _NDMA_UE_ENABLE_CSR {
         u32 ndma_parity_ue_enable : 1;           // DWORD 0
         u32 ndma_host_ue_enable : 1;             // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK NDMA_UE_ENABLE_CSR, *PNDMA_UE_ENABLE_CSR;

      typedef union _NDMA_UE_ENABLE_CSR_UNION {
         NDMA_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_UE_ENABLE_CSR_UNION, *PNDMA_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_UE_ENABLE_CSR_UNION, sizeof (NDMA_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Zero Length (Dummy Read) Host Memory Address (Lower 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_ZERODMA_HOST_ADDLSB_CSR {
         union {
            struct { 
               u32 host_lsb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_ZERODMA_HOST_ADDLSB_CSR, *PNDMA_ZERODMA_HOST_ADDLSB_CSR;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDLSB_CSR, sizeof (NDMA_ZERODMA_HOST_ADDLSB_CSR) == 4);

   #else
      typedef struct _NDMA_ZERODMA_HOST_ADDLSB_CSR {
         u32 host_lsb;                            // DWORD 0
      } SG_PACK NDMA_ZERODMA_HOST_ADDLSB_CSR, *PNDMA_ZERODMA_HOST_ADDLSB_CSR;

      typedef union _NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION {
         NDMA_ZERODMA_HOST_ADDLSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, *PNDMA_ZERODMA_HOST_ADDLSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, sizeof (NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION) == 4);
   #endif


#else
   // Zero Length (Dummy Read) Host Memory Address (Lower 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_ZERODMA_HOST_ADDLSB_CSR {
         union {
            struct { 
               u32 host_lsb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_ZERODMA_HOST_ADDLSB_CSR, *PNDMA_ZERODMA_HOST_ADDLSB_CSR;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDLSB_CSR, sizeof (NDMA_ZERODMA_HOST_ADDLSB_CSR) == 4);

   #else
      typedef struct _NDMA_ZERODMA_HOST_ADDLSB_CSR {
         u32 host_lsb;                            // DWORD 0
      } SG_PACK NDMA_ZERODMA_HOST_ADDLSB_CSR, *PNDMA_ZERODMA_HOST_ADDLSB_CSR;

      typedef union _NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION {
         NDMA_ZERODMA_HOST_ADDLSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, *PNDMA_ZERODMA_HOST_ADDLSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, sizeof (NDMA_ZERODMA_HOST_ADDLSB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Zero Length (Dummy Read) Host Memory Address (Upper 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_ZERODMA_HOST_ADDMSB_CSR {
         union {
            struct { 
               u32 host_msb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_ZERODMA_HOST_ADDMSB_CSR, *PNDMA_ZERODMA_HOST_ADDMSB_CSR;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDMSB_CSR, sizeof (NDMA_ZERODMA_HOST_ADDMSB_CSR) == 4);

   #else
      typedef struct _NDMA_ZERODMA_HOST_ADDMSB_CSR {
         u32 host_msb;                            // DWORD 0
      } SG_PACK NDMA_ZERODMA_HOST_ADDMSB_CSR, *PNDMA_ZERODMA_HOST_ADDMSB_CSR;

      typedef union _NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION {
         NDMA_ZERODMA_HOST_ADDMSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, *PNDMA_ZERODMA_HOST_ADDMSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, sizeof (NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION) == 4);
   #endif


#else
   // Zero Length (Dummy Read) Host Memory Address (Upper 32 Bits) Register
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_ZERODMA_HOST_ADDMSB_CSR {
         union {
            struct { 
               u32 host_msb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NDMA_ZERODMA_HOST_ADDMSB_CSR, *PNDMA_ZERODMA_HOST_ADDMSB_CSR;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDMSB_CSR, sizeof (NDMA_ZERODMA_HOST_ADDMSB_CSR) == 4);

   #else
      typedef struct _NDMA_ZERODMA_HOST_ADDMSB_CSR {
         u32 host_msb;                            // DWORD 0
      } SG_PACK NDMA_ZERODMA_HOST_ADDMSB_CSR, *PNDMA_ZERODMA_HOST_ADDMSB_CSR;

      typedef union _NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION {
         NDMA_ZERODMA_HOST_ADDMSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, *PNDMA_ZERODMA_HOST_ADDMSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, sizeof (NDMA_ZERODMA_HOST_ADDMSB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Bulk (Packet) Data Read DMA Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_CSRMAP {
         union {
            struct { 
               NDMA_CTRL_CSR ndma_ctrl;
               NDMA_STS_CSR ndma_sts;
               NDMA_WRR_ENTRY_CSR ndma_wrr;
               NDMA_UE_SOURCE_CSR ue_source;
               NDMA_UE_ENABLE_CSR ue_enable;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } txp_pq;
               HWDBG_CSRMAP hwdbg;
               NDMA_ZERODMA_HOST_ADDLSB_CSR ndma_zero_addr_lsb;
               NDMA_ZERODMA_HOST_ADDMSB_CSR ndma_zero_addr_msb;
               u32 rsvd0[241];                    // DWORDS 15 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK NDMA_CSRMAP, *PNDMA_CSRMAP;

      SG_C_ASSERT(__sizeof__NDMA_CSRMAP, sizeof (NDMA_CSRMAP) == 1024);

   #else
      typedef struct _NDMA_CSRMAP {
         NDMA_CTRL_CSR ndma_ctrl;
         NDMA_STS_CSR ndma_sts;
         NDMA_WRR_ENTRY_CSR ndma_wrr;
         NDMA_UE_SOURCE_CSR ue_source;
         NDMA_UE_ENABLE_CSR ue_enable;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } txp_pq;
         HWDBG_CSRMAP hwdbg;
         NDMA_ZERODMA_HOST_ADDLSB_CSR ndma_zero_addr_lsb;
         NDMA_ZERODMA_HOST_ADDMSB_CSR ndma_zero_addr_msb;
         u32 rsvd0[241];                          // DWORDS 15 to 255
      } SG_PACK NDMA_CSRMAP, *PNDMA_CSRMAP;

      typedef union _NDMA_CSRMAP_UNION {
         NDMA_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK NDMA_CSRMAP_UNION, *PNDMA_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__NDMA_CSRMAP_UNION, sizeof (NDMA_CSRMAP_UNION) == 1024);
   #endif


#else
   // Bulk (Packet) Data Read DMA Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _NDMA_CSRMAP {
         union {
            struct { 
               NDMA_CTRL_CSR ndma_ctrl;
               NDMA_STS_CSR ndma_sts;
               NDMA_WRR_ENTRY_CSR ndma_wrr;
               NDMA_UE_SOURCE_CSR ue_source;
               NDMA_UE_ENABLE_CSR ue_enable;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } txp_pq;
               HWDBG_CSRMAP hwdbg;
               NDMA_ZERODMA_HOST_ADDLSB_CSR ndma_zero_addr_lsb;
               NDMA_ZERODMA_HOST_ADDMSB_CSR ndma_zero_addr_msb;
               u32 rsvd0[241];                    // DWORDS 15 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK NDMA_CSRMAP, *PNDMA_CSRMAP;

      SG_C_ASSERT(__sizeof__NDMA_CSRMAP, sizeof (NDMA_CSRMAP) == 1024);

   #else
      typedef struct _NDMA_CSRMAP {
         NDMA_CTRL_CSR ndma_ctrl;
         NDMA_STS_CSR ndma_sts;
         NDMA_WRR_ENTRY_CSR ndma_wrr;
         NDMA_UE_SOURCE_CSR ue_source;
         NDMA_UE_ENABLE_CSR ue_enable;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } txp_pq;
         HWDBG_CSRMAP hwdbg;
         NDMA_ZERODMA_HOST_ADDLSB_CSR ndma_zero_addr_lsb;
         NDMA_ZERODMA_HOST_ADDMSB_CSR ndma_zero_addr_msb;
         u32 rsvd0[241];                          // DWORDS 15 to 255
      } SG_PACK NDMA_CSRMAP, *PNDMA_CSRMAP;

      typedef union _NDMA_CSRMAP_UNION {
         NDMA_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK NDMA_CSRMAP_UNION, *PNDMA_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__NDMA_CSRMAP_UNION, sizeof (NDMA_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ndma_bmap_h__

