/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __pmem_bmap_h__
#define __pmem_bmap_h__
#include "setypes.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The index for the read-only debug port.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_INDEX_CSR {
         union {
            struct { 
               u32 hdr : 1;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 offset : 12;                   // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 pbuf : 9;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_INDEX_CSR, *PPMEM_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PMEM_INDEX_CSR, sizeof (PMEM_INDEX_CSR) == 4);

   #else
      typedef struct _PMEM_INDEX_CSR {
         u32 hdr : 1;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 offset : 12;                         // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 pbuf : 9;                            // DWORD 0
      } SG_PACK PMEM_INDEX_CSR, *PPMEM_INDEX_CSR;

      typedef union _PMEM_INDEX_CSR_UNION {
         PMEM_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_INDEX_CSR_UNION, *PPMEM_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_INDEX_CSR_UNION, sizeof (PMEM_INDEX_CSR_UNION) == 4);
   #endif


#else
   // The index for the read-only debug port.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_INDEX_CSR {
         union {
            struct { 
               u32 pbuf : 9;                      // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 offset : 12;                   // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 hdr : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_INDEX_CSR, *PPMEM_INDEX_CSR;

      SG_C_ASSERT(__sizeof__PMEM_INDEX_CSR, sizeof (PMEM_INDEX_CSR) == 4);

   #else
      typedef struct _PMEM_INDEX_CSR {
         u32 pbuf : 9;                            // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 offset : 12;                         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 hdr : 1;                             // DWORD 0
      } SG_PACK PMEM_INDEX_CSR, *PPMEM_INDEX_CSR;

      typedef union _PMEM_INDEX_CSR_UNION {
         PMEM_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_INDEX_CSR_UNION, *PPMEM_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_INDEX_CSR_UNION, sizeof (PMEM_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The data from a pbuf from the read-only debug port.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_DATA_CSR, *PPMEM_DATA_CSR;

      SG_C_ASSERT(__sizeof__PMEM_DATA_CSR, sizeof (PMEM_DATA_CSR) == 4);

   #else
      typedef struct _PMEM_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PMEM_DATA_CSR, *PPMEM_DATA_CSR;

      typedef union _PMEM_DATA_CSR_UNION {
         PMEM_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_DATA_CSR_UNION, *PPMEM_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_DATA_CSR_UNION, sizeof (PMEM_DATA_CSR_UNION) == 4);
   #endif


#else
   // The data from a pbuf from the read-only debug port.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_DATA_CSR, *PPMEM_DATA_CSR;

      SG_C_ASSERT(__sizeof__PMEM_DATA_CSR, sizeof (PMEM_DATA_CSR) == 4);

   #else
      typedef struct _PMEM_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK PMEM_DATA_CSR, *PPMEM_DATA_CSR;

      typedef union _PMEM_DATA_CSR_UNION {
         PMEM_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_DATA_CSR_UNION, *PPMEM_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_DATA_CSR_UNION, sizeof (PMEM_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This partitions the 512 PBUFs into 3 partitions, one reserved for port 0 FCoE
   // packets, one reserved for port 1 FCoE packets, and a default partition, which gets
   // the remainder. The default is to have all the PBUFs partitioned to the default
   // partition. NOTE: it is illegal to program these such that the two FCoE parttions
   // total more than 512
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_PARTITION_CSR {
         union {
            struct { 
               u32 rsvd1 : 6;                     // DWORD 0
               u32 fcoe1_partition : 10;          // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 fcoe0_partition : 10;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_PARTITION_CSR, *PPMEM_PARTITION_CSR;

      SG_C_ASSERT(__sizeof__PMEM_PARTITION_CSR, sizeof (PMEM_PARTITION_CSR) == 4);

   #else
      typedef struct _PMEM_PARTITION_CSR {
         u32 rsvd1 : 6;                           // DWORD 0
         u32 fcoe1_partition : 10;                // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 fcoe0_partition : 10;                // DWORD 0
      } SG_PACK PMEM_PARTITION_CSR, *PPMEM_PARTITION_CSR;

      typedef union _PMEM_PARTITION_CSR_UNION {
         PMEM_PARTITION_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_PARTITION_CSR_UNION, *PPMEM_PARTITION_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_PARTITION_CSR_UNION, sizeof (PMEM_PARTITION_CSR_UNION) == 4);
   #endif


#else
   // This partitions the 512 PBUFs into 3 partitions, one reserved for port 0 FCoE
   // packets, one reserved for port 1 FCoE packets, and a default partition, which gets
   // the remainder. The default is to have all the PBUFs partitioned to the default
   // partition. NOTE: it is illegal to program these such that the two FCoE parttions
   // total more than 512
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_PARTITION_CSR {
         union {
            struct { 
               u32 fcoe0_partition : 10;          // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 fcoe1_partition : 10;          // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_PARTITION_CSR, *PPMEM_PARTITION_CSR;

      SG_C_ASSERT(__sizeof__PMEM_PARTITION_CSR, sizeof (PMEM_PARTITION_CSR) == 4);

   #else
      typedef struct _PMEM_PARTITION_CSR {
         u32 fcoe0_partition : 10;                // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 fcoe1_partition : 10;                // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
      } SG_PACK PMEM_PARTITION_CSR, *PPMEM_PARTITION_CSR;

      typedef union _PMEM_PARTITION_CSR_UNION {
         PMEM_PARTITION_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_PARTITION_CSR_UNION, *PPMEM_PARTITION_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_PARTITION_CSR_UNION, sizeof (PMEM_PARTITION_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The PMEM Count Control and status register gives the count of pbufs allocated.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_COUNT_CSR {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 cnt : 10;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_COUNT_CSR, *PPMEM_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PMEM_COUNT_CSR, sizeof (PMEM_COUNT_CSR) == 4);

   #else
      typedef struct _PMEM_COUNT_CSR {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 cnt : 10;                            // DWORD 0
      } SG_PACK PMEM_COUNT_CSR, *PPMEM_COUNT_CSR;

      typedef union _PMEM_COUNT_CSR_UNION {
         PMEM_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_COUNT_CSR_UNION, *PPMEM_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_COUNT_CSR_UNION, sizeof (PMEM_COUNT_CSR_UNION) == 4);
   #endif


#else
   // The PMEM Count Control and status register gives the count of pbufs allocated.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_COUNT_CSR {
         union {
            struct { 
               u32 cnt : 10;                      // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_COUNT_CSR, *PPMEM_COUNT_CSR;

      SG_C_ASSERT(__sizeof__PMEM_COUNT_CSR, sizeof (PMEM_COUNT_CSR) == 4);

   #else
      typedef struct _PMEM_COUNT_CSR {
         u32 cnt : 10;                            // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK PMEM_COUNT_CSR, *PPMEM_COUNT_CSR;

      typedef union _PMEM_COUNT_CSR_UNION {
         PMEM_COUNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_COUNT_CSR_UNION, *PPMEM_COUNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_COUNT_CSR_UNION, sizeof (PMEM_COUNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The PMEM deallocate register allows pbufs to be deallocated.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_PIO_DEALLOC {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 pbuf_head : 9;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_PIO_DEALLOC, *PPMEM_PIO_DEALLOC;

      SG_C_ASSERT(__sizeof__PMEM_PIO_DEALLOC, sizeof (PMEM_PIO_DEALLOC) == 4);

   #else
      typedef struct _PMEM_PIO_DEALLOC {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 pbuf_head : 9;                       // DWORD 0
      } SG_PACK PMEM_PIO_DEALLOC, *PPMEM_PIO_DEALLOC;

      typedef union _PMEM_PIO_DEALLOC_UNION {
         PMEM_PIO_DEALLOC bits;
         u32 dw; // dword union
      } SG_PACK PMEM_PIO_DEALLOC_UNION, *PPMEM_PIO_DEALLOC_UNION;

      SG_C_ASSERT(__sizeof__PMEM_PIO_DEALLOC_UNION, sizeof (PMEM_PIO_DEALLOC_UNION) == 4);
   #endif


#else
   // The PMEM deallocate register allows pbufs to be deallocated.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_PIO_DEALLOC {
         union {
            struct { 
               u32 pbuf_head : 9;                 // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_PIO_DEALLOC, *PPMEM_PIO_DEALLOC;

      SG_C_ASSERT(__sizeof__PMEM_PIO_DEALLOC, sizeof (PMEM_PIO_DEALLOC) == 4);

   #else
      typedef struct _PMEM_PIO_DEALLOC {
         u32 pbuf_head : 9;                       // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK PMEM_PIO_DEALLOC, *PPMEM_PIO_DEALLOC;

      typedef union _PMEM_PIO_DEALLOC_UNION {
         PMEM_PIO_DEALLOC bits;
         u32 dw; // dword union
      } SG_PACK PMEM_PIO_DEALLOC_UNION, *PPMEM_PIO_DEALLOC_UNION;

      SG_C_ASSERT(__sizeof__PMEM_PIO_DEALLOC_UNION, sizeof (PMEM_PIO_DEALLOC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits. Write 1 to clear the UE SOURCE 
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 rxpp_fcoe_write_bus : 1;       // DWORD 0
               u32 rxpp_write_bus : 1;            // DWORD 0
               u32 wdma_read_bus : 1;             // DWORD 0
               u32 tpre_read_bus : 1;             // DWORD 0
               u32 mpu_read_bus : 1;              // DWORD 0
               u32 rxulp1_read_bus : 1;           // DWORD 0
               u32 rxulp0_read_bus : 1;           // DWORD 0
               u32 sram_durning_init : 1;         // DWORD 0
               u32 perr3_ue : 1;                  // DWORD 0
               u32 perr2_ue : 1;                  // DWORD 0
               u32 perr1_ue : 1;                  // DWORD 0
               u32 perr0_ue : 1;                  // DWORD 0
               u32 head_b_perr_ue : 1;            // DWORD 0
               u32 head_a_perr_ue : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_UE_SOURCE, *PPMEM_UE_SOURCE;

      SG_C_ASSERT(__sizeof__PMEM_UE_SOURCE, sizeof (PMEM_UE_SOURCE) == 4);

   #else
      typedef struct _PMEM_UE_SOURCE {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 rxpp_fcoe_write_bus : 1;             // DWORD 0
         u32 rxpp_write_bus : 1;                  // DWORD 0
         u32 wdma_read_bus : 1;                   // DWORD 0
         u32 tpre_read_bus : 1;                   // DWORD 0
         u32 mpu_read_bus : 1;                    // DWORD 0
         u32 rxulp1_read_bus : 1;                 // DWORD 0
         u32 rxulp0_read_bus : 1;                 // DWORD 0
         u32 sram_durning_init : 1;               // DWORD 0
         u32 perr3_ue : 1;                        // DWORD 0
         u32 perr2_ue : 1;                        // DWORD 0
         u32 perr1_ue : 1;                        // DWORD 0
         u32 perr0_ue : 1;                        // DWORD 0
         u32 head_b_perr_ue : 1;                  // DWORD 0
         u32 head_a_perr_ue : 1;                  // DWORD 0
      } SG_PACK PMEM_UE_SOURCE, *PPMEM_UE_SOURCE;

      typedef union _PMEM_UE_SOURCE_UNION {
         PMEM_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK PMEM_UE_SOURCE_UNION, *PPMEM_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__PMEM_UE_SOURCE_UNION, sizeof (PMEM_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits. Write 1 to clear the UE SOURCE 
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_UE_SOURCE {
         union {
            struct { 
               u32 head_a_perr_ue : 1;            // DWORD 0
               u32 head_b_perr_ue : 1;            // DWORD 0
               u32 perr0_ue : 1;                  // DWORD 0
               u32 perr1_ue : 1;                  // DWORD 0
               u32 perr2_ue : 1;                  // DWORD 0
               u32 perr3_ue : 1;                  // DWORD 0
               u32 sram_durning_init : 1;         // DWORD 0
               u32 rxulp0_read_bus : 1;           // DWORD 0
               u32 rxulp1_read_bus : 1;           // DWORD 0
               u32 mpu_read_bus : 1;              // DWORD 0
               u32 tpre_read_bus : 1;             // DWORD 0
               u32 wdma_read_bus : 1;             // DWORD 0
               u32 rxpp_write_bus : 1;            // DWORD 0
               u32 rxpp_fcoe_write_bus : 1;       // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_UE_SOURCE, *PPMEM_UE_SOURCE;

      SG_C_ASSERT(__sizeof__PMEM_UE_SOURCE, sizeof (PMEM_UE_SOURCE) == 4);

   #else
      typedef struct _PMEM_UE_SOURCE {
         u32 head_a_perr_ue : 1;                  // DWORD 0
         u32 head_b_perr_ue : 1;                  // DWORD 0
         u32 perr0_ue : 1;                        // DWORD 0
         u32 perr1_ue : 1;                        // DWORD 0
         u32 perr2_ue : 1;                        // DWORD 0
         u32 perr3_ue : 1;                        // DWORD 0
         u32 sram_durning_init : 1;               // DWORD 0
         u32 rxulp0_read_bus : 1;                 // DWORD 0
         u32 rxulp1_read_bus : 1;                 // DWORD 0
         u32 mpu_read_bus : 1;                    // DWORD 0
         u32 tpre_read_bus : 1;                   // DWORD 0
         u32 wdma_read_bus : 1;                   // DWORD 0
         u32 rxpp_write_bus : 1;                  // DWORD 0
         u32 rxpp_fcoe_write_bus : 1;             // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK PMEM_UE_SOURCE, *PPMEM_UE_SOURCE;

      typedef union _PMEM_UE_SOURCE_UNION {
         PMEM_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK PMEM_UE_SOURCE_UNION, *PPMEM_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__PMEM_UE_SOURCE_UNION, sizeof (PMEM_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for enabling unrecoverable error. Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 rxpp_fcoe_write_bus_ue_en : 1; // DWORD 0
               u32 rxpp_write_bus_ue_en : 1;      // DWORD 0
               u32 wdma_read_bus_ue_en : 1;       // DWORD 0
               u32 tpre_read_bus_ue_en : 1;       // DWORD 0
               u32 mpu_read_bus_ue_en : 1;        // DWORD 0
               u32 rxulp1_read_bus_ue_en : 1;     // DWORD 0
               u32 rxulp0_read_bus_ue_en : 1;     // DWORD 0
               u32 sram_durning_init_ue_en : 1;   // DWORD 0
               u32 perr3_ue_en : 1;               // DWORD 0
               u32 perr2_ue_en : 1;               // DWORD 0
               u32 perr1_ue_en : 1;               // DWORD 0
               u32 perr0_ue_en : 1;               // DWORD 0
               u32 head_b_perr_ue_en : 1;         // DWORD 0
               u32 head_a_perr_ue_en : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_UE_ENABLE, *PPMEM_UE_ENABLE;

      SG_C_ASSERT(__sizeof__PMEM_UE_ENABLE, sizeof (PMEM_UE_ENABLE) == 4);

   #else
      typedef struct _PMEM_UE_ENABLE {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 rxpp_fcoe_write_bus_ue_en : 1;       // DWORD 0
         u32 rxpp_write_bus_ue_en : 1;            // DWORD 0
         u32 wdma_read_bus_ue_en : 1;             // DWORD 0
         u32 tpre_read_bus_ue_en : 1;             // DWORD 0
         u32 mpu_read_bus_ue_en : 1;              // DWORD 0
         u32 rxulp1_read_bus_ue_en : 1;           // DWORD 0
         u32 rxulp0_read_bus_ue_en : 1;           // DWORD 0
         u32 sram_durning_init_ue_en : 1;         // DWORD 0
         u32 perr3_ue_en : 1;                     // DWORD 0
         u32 perr2_ue_en : 1;                     // DWORD 0
         u32 perr1_ue_en : 1;                     // DWORD 0
         u32 perr0_ue_en : 1;                     // DWORD 0
         u32 head_b_perr_ue_en : 1;               // DWORD 0
         u32 head_a_perr_ue_en : 1;               // DWORD 0
      } SG_PACK PMEM_UE_ENABLE, *PPMEM_UE_ENABLE;

      typedef union _PMEM_UE_ENABLE_UNION {
         PMEM_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK PMEM_UE_ENABLE_UNION, *PPMEM_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__PMEM_UE_ENABLE_UNION, sizeof (PMEM_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Mask for enabling unrecoverable error. Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_UE_ENABLE {
         union {
            struct { 
               u32 head_a_perr_ue_en : 1;         // DWORD 0
               u32 head_b_perr_ue_en : 1;         // DWORD 0
               u32 perr0_ue_en : 1;               // DWORD 0
               u32 perr1_ue_en : 1;               // DWORD 0
               u32 perr2_ue_en : 1;               // DWORD 0
               u32 perr3_ue_en : 1;               // DWORD 0
               u32 sram_durning_init_ue_en : 1;   // DWORD 0
               u32 rxulp0_read_bus_ue_en : 1;     // DWORD 0
               u32 rxulp1_read_bus_ue_en : 1;     // DWORD 0
               u32 mpu_read_bus_ue_en : 1;        // DWORD 0
               u32 tpre_read_bus_ue_en : 1;       // DWORD 0
               u32 wdma_read_bus_ue_en : 1;       // DWORD 0
               u32 rxpp_write_bus_ue_en : 1;      // DWORD 0
               u32 rxpp_fcoe_write_bus_ue_en : 1; // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_UE_ENABLE, *PPMEM_UE_ENABLE;

      SG_C_ASSERT(__sizeof__PMEM_UE_ENABLE, sizeof (PMEM_UE_ENABLE) == 4);

   #else
      typedef struct _PMEM_UE_ENABLE {
         u32 head_a_perr_ue_en : 1;               // DWORD 0
         u32 head_b_perr_ue_en : 1;               // DWORD 0
         u32 perr0_ue_en : 1;                     // DWORD 0
         u32 perr1_ue_en : 1;                     // DWORD 0
         u32 perr2_ue_en : 1;                     // DWORD 0
         u32 perr3_ue_en : 1;                     // DWORD 0
         u32 sram_durning_init_ue_en : 1;         // DWORD 0
         u32 rxulp0_read_bus_ue_en : 1;           // DWORD 0
         u32 rxulp1_read_bus_ue_en : 1;           // DWORD 0
         u32 mpu_read_bus_ue_en : 1;              // DWORD 0
         u32 tpre_read_bus_ue_en : 1;             // DWORD 0
         u32 wdma_read_bus_ue_en : 1;             // DWORD 0
         u32 rxpp_write_bus_ue_en : 1;            // DWORD 0
         u32 rxpp_fcoe_write_bus_ue_en : 1;       // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK PMEM_UE_ENABLE, *PPMEM_UE_ENABLE;

      typedef union _PMEM_UE_ENABLE_UNION {
         PMEM_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK PMEM_UE_ENABLE_UNION, *PPMEM_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__PMEM_UE_ENABLE_UNION, sizeof (PMEM_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // gives memory initialization status
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 rsvd1 : 21;                    // DWORD 0
               u32 cr_red_dbg_sel : 3;            // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 init_status : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_CONTROL_STATUS_CSR, *PPMEM_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PMEM_CONTROL_STATUS_CSR, sizeof (PMEM_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _PMEM_CONTROL_STATUS_CSR {
         u32 rsvd1 : 21;                          // DWORD 0
         u32 cr_red_dbg_sel : 3;                  // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 init_status : 1;                     // DWORD 0
      } SG_PACK PMEM_CONTROL_STATUS_CSR, *PPMEM_CONTROL_STATUS_CSR;

      typedef union _PMEM_CONTROL_STATUS_CSR_UNION {
         PMEM_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_CONTROL_STATUS_CSR_UNION, *PPMEM_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_CONTROL_STATUS_CSR_UNION, sizeof (PMEM_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#else
   // gives memory initialization status
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_CONTROL_STATUS_CSR {
         union {
            struct { 
               u32 init_status : 1;               // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 cr_red_dbg_sel : 3;            // DWORD 0
               u32 rsvd1 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_CONTROL_STATUS_CSR, *PPMEM_CONTROL_STATUS_CSR;

      SG_C_ASSERT(__sizeof__PMEM_CONTROL_STATUS_CSR, sizeof (PMEM_CONTROL_STATUS_CSR) == 4);

   #else
      typedef struct _PMEM_CONTROL_STATUS_CSR {
         u32 init_status : 1;                     // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 cr_red_dbg_sel : 3;                  // DWORD 0
         u32 rsvd1 : 21;                          // DWORD 0
      } SG_PACK PMEM_CONTROL_STATUS_CSR, *PPMEM_CONTROL_STATUS_CSR;

      typedef union _PMEM_CONTROL_STATUS_CSR_UNION {
         PMEM_CONTROL_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_CONTROL_STATUS_CSR_UNION, *PPMEM_CONTROL_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_CONTROL_STATUS_CSR_UNION, sizeof (PMEM_CONTROL_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register determining the parameters for random early discard (RED) due to a
   // specific traffic type congestion.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_CTRL_1_CSR {
         union {
            struct { 
               u32 rsvd1 : 6;                     // DWORD 0
               u32 red_maxth : 10;                // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 red_minth : 10;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_CTRL_1_CSR, *PPMEM_RED_CTRL_1_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_1_CSR, sizeof (PMEM_RED_CTRL_1_CSR) == 4);

   #else
      typedef struct _PMEM_RED_CTRL_1_CSR {
         u32 rsvd1 : 6;                           // DWORD 0
         u32 red_maxth : 10;                      // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 red_minth : 10;                      // DWORD 0
      } SG_PACK PMEM_RED_CTRL_1_CSR, *PPMEM_RED_CTRL_1_CSR;

      typedef union _PMEM_RED_CTRL_1_CSR_UNION {
         PMEM_RED_CTRL_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_CTRL_1_CSR_UNION, *PPMEM_RED_CTRL_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_1_CSR_UNION, sizeof (PMEM_RED_CTRL_1_CSR_UNION) == 4);
   #endif


#else
   // Control register determining the parameters for random early discard (RED) due to a
   // specific traffic type congestion.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_CTRL_1_CSR {
         union {
            struct { 
               u32 red_minth : 10;                // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 red_maxth : 10;                // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_CTRL_1_CSR, *PPMEM_RED_CTRL_1_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_1_CSR, sizeof (PMEM_RED_CTRL_1_CSR) == 4);

   #else
      typedef struct _PMEM_RED_CTRL_1_CSR {
         u32 red_minth : 10;                      // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 red_maxth : 10;                      // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
      } SG_PACK PMEM_RED_CTRL_1_CSR, *PPMEM_RED_CTRL_1_CSR;

      typedef union _PMEM_RED_CTRL_1_CSR_UNION {
         PMEM_RED_CTRL_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_CTRL_1_CSR_UNION, *PPMEM_RED_CTRL_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_1_CSR_UNION, sizeof (PMEM_RED_CTRL_1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register determining the parameters for random early discard (RED) due to
   // specific traffic type congestion.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_CTRL_2_CSR {
         union {
            struct { 
               u32 rsvd1 : 11;                    // DWORD 0
               u32 red_en : 1;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 red_mtu_int : 2;               // DWORD 0
               u32 red_mtu_exp : 4;               // DWORD 0
               u32 red_slope : 4;                 // DWORD 0
               u32 red_w2 : 4;                    // DWORD 0
               u32 red_w1 : 4;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_CTRL_2_CSR, *PPMEM_RED_CTRL_2_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_2_CSR, sizeof (PMEM_RED_CTRL_2_CSR) == 4);

   #else
      typedef struct _PMEM_RED_CTRL_2_CSR {
         u32 rsvd1 : 11;                          // DWORD 0
         u32 red_en : 1;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 red_mtu_int : 2;                     // DWORD 0
         u32 red_mtu_exp : 4;                     // DWORD 0
         u32 red_slope : 4;                       // DWORD 0
         u32 red_w2 : 4;                          // DWORD 0
         u32 red_w1 : 4;                          // DWORD 0
      } SG_PACK PMEM_RED_CTRL_2_CSR, *PPMEM_RED_CTRL_2_CSR;

      typedef union _PMEM_RED_CTRL_2_CSR_UNION {
         PMEM_RED_CTRL_2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_CTRL_2_CSR_UNION, *PPMEM_RED_CTRL_2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_2_CSR_UNION, sizeof (PMEM_RED_CTRL_2_CSR_UNION) == 4);
   #endif


#else
   // Control register determining the parameters for random early discard (RED) due to
   // specific traffic type congestion.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_CTRL_2_CSR {
         union {
            struct { 
               u32 red_w1 : 4;                    // DWORD 0
               u32 red_w2 : 4;                    // DWORD 0
               u32 red_slope : 4;                 // DWORD 0
               u32 red_mtu_exp : 4;               // DWORD 0
               u32 red_mtu_int : 2;               // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 red_en : 1;                    // DWORD 0
               u32 rsvd1 : 11;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_CTRL_2_CSR, *PPMEM_RED_CTRL_2_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_2_CSR, sizeof (PMEM_RED_CTRL_2_CSR) == 4);

   #else
      typedef struct _PMEM_RED_CTRL_2_CSR {
         u32 red_w1 : 4;                          // DWORD 0
         u32 red_w2 : 4;                          // DWORD 0
         u32 red_slope : 4;                       // DWORD 0
         u32 red_mtu_exp : 4;                     // DWORD 0
         u32 red_mtu_int : 2;                     // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 red_en : 1;                          // DWORD 0
         u32 rsvd1 : 11;                          // DWORD 0
      } SG_PACK PMEM_RED_CTRL_2_CSR, *PPMEM_RED_CTRL_2_CSR;

      typedef union _PMEM_RED_CTRL_2_CSR_UNION {
         PMEM_RED_CTRL_2_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_CTRL_2_CSR_UNION, *PPMEM_RED_CTRL_2_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_CTRL_2_CSR_UNION, sizeof (PMEM_RED_CTRL_2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Configuration register for RED functionality
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_CONFIG_CSR {
         union {
            struct { 
               u32 rsvd0 : 30;                    // DWORD 0
               u32 disable_small_pkt_red : 1;     // DWORD 0
               u32 mark_tcp_offload_only : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_CONFIG_CSR, *PPMEM_RED_CONFIG_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_CONFIG_CSR, sizeof (PMEM_RED_CONFIG_CSR) == 4);

   #else
      typedef struct _PMEM_RED_CONFIG_CSR {
         u32 rsvd0 : 30;                          // DWORD 0
         u32 disable_small_pkt_red : 1;           // DWORD 0
         u32 mark_tcp_offload_only : 1;           // DWORD 0
      } SG_PACK PMEM_RED_CONFIG_CSR, *PPMEM_RED_CONFIG_CSR;

      typedef union _PMEM_RED_CONFIG_CSR_UNION {
         PMEM_RED_CONFIG_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_CONFIG_CSR_UNION, *PPMEM_RED_CONFIG_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_CONFIG_CSR_UNION, sizeof (PMEM_RED_CONFIG_CSR_UNION) == 4);
   #endif


#else
   // General Configuration register for RED functionality
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_CONFIG_CSR {
         union {
            struct { 
               u32 mark_tcp_offload_only : 1;     // DWORD 0
               u32 disable_small_pkt_red : 1;     // DWORD 0
               u32 rsvd0 : 30;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_CONFIG_CSR, *PPMEM_RED_CONFIG_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_CONFIG_CSR, sizeof (PMEM_RED_CONFIG_CSR) == 4);

   #else
      typedef struct _PMEM_RED_CONFIG_CSR {
         u32 mark_tcp_offload_only : 1;           // DWORD 0
         u32 disable_small_pkt_red : 1;           // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
      } SG_PACK PMEM_RED_CONFIG_CSR, *PPMEM_RED_CONFIG_CSR;

      typedef union _PMEM_RED_CONFIG_CSR_UNION {
         PMEM_RED_CONFIG_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_CONFIG_CSR_UNION, *PPMEM_RED_CONFIG_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_CONFIG_CSR_UNION, sizeof (PMEM_RED_CONFIG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Counter register for packets marked by RED functionality. This is a free-running
   // counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_COUNTER_CSR {
         union {
            struct { 
               u32 mark_count;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_COUNTER_CSR, *PPMEM_RED_COUNTER_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_COUNTER_CSR, sizeof (PMEM_RED_COUNTER_CSR) == 4);

   #else
      typedef struct _PMEM_RED_COUNTER_CSR {
         u32 mark_count;                          // DWORD 0
      } SG_PACK PMEM_RED_COUNTER_CSR, *PPMEM_RED_COUNTER_CSR;

      typedef union _PMEM_RED_COUNTER_CSR_UNION {
         PMEM_RED_COUNTER_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_COUNTER_CSR_UNION, *PPMEM_RED_COUNTER_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_COUNTER_CSR_UNION, sizeof (PMEM_RED_COUNTER_CSR_UNION) == 4);
   #endif


#else
   // Counter register for packets marked by RED functionality. This is a free-running
   // counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_RED_COUNTER_CSR {
         union {
            struct { 
               u32 mark_count;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PMEM_RED_COUNTER_CSR, *PPMEM_RED_COUNTER_CSR;

      SG_C_ASSERT(__sizeof__PMEM_RED_COUNTER_CSR, sizeof (PMEM_RED_COUNTER_CSR) == 4);

   #else
      typedef struct _PMEM_RED_COUNTER_CSR {
         u32 mark_count;                          // DWORD 0
      } SG_PACK PMEM_RED_COUNTER_CSR, *PPMEM_RED_COUNTER_CSR;

      typedef union _PMEM_RED_COUNTER_CSR_UNION {
         PMEM_RED_COUNTER_CSR bits;
         u32 dw; // dword union
      } SG_PACK PMEM_RED_COUNTER_CSR_UNION, *PPMEM_RED_COUNTER_CSR_UNION;

      SG_C_ASSERT(__sizeof__PMEM_RED_COUNTER_CSR_UNION, sizeof (PMEM_RED_COUNTER_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Provides basic statistical information for packet memory usage as well as debug
   // capabilities.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_CSRMAP {
         union {
            struct { 
               PMEM_INDEX_CSR index;
               PMEM_DATA_CSR data;
               PMEM_COUNT_CSR chute0_count;
               PMEM_COUNT_CSR chute1_count;
               PMEM_COUNT_CSR chute2_count;
               PMEM_COUNT_CSR chute3_count;
               PMEM_COUNT_CSR chute4_count;
               PMEM_COUNT_CSR total_count;
               PMEM_PARTITION_CSR partitions;
               PMEM_PIO_DEALLOC pio_dealloc;
               HWDBG_CSRMAP hwdbg;
               PMEM_UE_SOURCE ue_source;
               PMEM_UE_ENABLE ue_enable;
               PMEM_CONTROL_STATUS_CSR control_status;
               PMEM_COUNT_CSR fcoe0_count;
               PMEM_COUNT_CSR fcoe1_count;
               PMEM_RED_CTRL_1_CSR pmem_red_ulp0_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_ulp0_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_ulp1_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_ulp1_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_ulp2_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_ulp2_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_lro_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_lro_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_eth_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_eth_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_global_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_global_ctrl_2;
               PMEM_RED_CONFIG_CSR pmem_red_config;
               PMEM_RED_COUNTER_CSR pmem_red_eth_count;
               PMEM_RED_COUNTER_CSR pmem_red_lro_count;
               PMEM_RED_COUNTER_CSR pmem_red_ulp0_count;
               PMEM_RED_COUNTER_CSR pmem_red_ulp1_count;
               PMEM_RED_COUNTER_CSR pmem_red_ulp2_count;
               PMEM_RED_COUNTER_CSR pmem_red_global_count;
               u32 rsvd0[219];                    // DWORDS 37 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK PMEM_CSRMAP, *PPMEM_CSRMAP;

      SG_C_ASSERT(__sizeof__PMEM_CSRMAP, sizeof (PMEM_CSRMAP) == 1024);

   #else
      typedef struct _PMEM_CSRMAP {
         PMEM_INDEX_CSR index;
         PMEM_DATA_CSR data;
         PMEM_COUNT_CSR chute0_count;
         PMEM_COUNT_CSR chute1_count;
         PMEM_COUNT_CSR chute2_count;
         PMEM_COUNT_CSR chute3_count;
         PMEM_COUNT_CSR chute4_count;
         PMEM_COUNT_CSR total_count;
         PMEM_PARTITION_CSR partitions;
         PMEM_PIO_DEALLOC pio_dealloc;
         HWDBG_CSRMAP hwdbg;
         PMEM_UE_SOURCE ue_source;
         PMEM_UE_ENABLE ue_enable;
         PMEM_CONTROL_STATUS_CSR control_status;
         PMEM_COUNT_CSR fcoe0_count;
         PMEM_COUNT_CSR fcoe1_count;
         PMEM_RED_CTRL_1_CSR pmem_red_ulp0_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_ulp0_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_ulp1_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_ulp1_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_ulp2_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_ulp2_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_lro_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_lro_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_eth_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_eth_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_global_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_global_ctrl_2;
         PMEM_RED_CONFIG_CSR pmem_red_config;
         PMEM_RED_COUNTER_CSR pmem_red_eth_count;
         PMEM_RED_COUNTER_CSR pmem_red_lro_count;
         PMEM_RED_COUNTER_CSR pmem_red_ulp0_count;
         PMEM_RED_COUNTER_CSR pmem_red_ulp1_count;
         PMEM_RED_COUNTER_CSR pmem_red_ulp2_count;
         PMEM_RED_COUNTER_CSR pmem_red_global_count;
         u32 rsvd0[219];                          // DWORDS 37 to 255
      } SG_PACK PMEM_CSRMAP, *PPMEM_CSRMAP;

      typedef union _PMEM_CSRMAP_UNION {
         PMEM_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK PMEM_CSRMAP_UNION, *PPMEM_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PMEM_CSRMAP_UNION, sizeof (PMEM_CSRMAP_UNION) == 1024);
   #endif


#else
   // Provides basic statistical information for packet memory usage as well as debug
   // capabilities.
   #if defined(SG_BMAP_UNION)
      typedef struct _PMEM_CSRMAP {
         union {
            struct { 
               PMEM_INDEX_CSR index;
               PMEM_DATA_CSR data;
               PMEM_COUNT_CSR chute0_count;
               PMEM_COUNT_CSR chute1_count;
               PMEM_COUNT_CSR chute2_count;
               PMEM_COUNT_CSR chute3_count;
               PMEM_COUNT_CSR chute4_count;
               PMEM_COUNT_CSR total_count;
               PMEM_PARTITION_CSR partitions;
               PMEM_PIO_DEALLOC pio_dealloc;
               HWDBG_CSRMAP hwdbg;
               PMEM_UE_SOURCE ue_source;
               PMEM_UE_ENABLE ue_enable;
               PMEM_CONTROL_STATUS_CSR control_status;
               PMEM_COUNT_CSR fcoe0_count;
               PMEM_COUNT_CSR fcoe1_count;
               PMEM_RED_CTRL_1_CSR pmem_red_ulp0_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_ulp0_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_ulp1_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_ulp1_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_ulp2_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_ulp2_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_lro_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_lro_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_eth_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_eth_ctrl_2;
               PMEM_RED_CTRL_1_CSR pmem_red_global_ctrl_1;
               PMEM_RED_CTRL_2_CSR pmem_red_global_ctrl_2;
               PMEM_RED_CONFIG_CSR pmem_red_config;
               PMEM_RED_COUNTER_CSR pmem_red_eth_count;
               PMEM_RED_COUNTER_CSR pmem_red_lro_count;
               PMEM_RED_COUNTER_CSR pmem_red_ulp0_count;
               PMEM_RED_COUNTER_CSR pmem_red_ulp1_count;
               PMEM_RED_COUNTER_CSR pmem_red_ulp2_count;
               PMEM_RED_COUNTER_CSR pmem_red_global_count;
               u32 rsvd0[219];                    // DWORDS 37 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK PMEM_CSRMAP, *PPMEM_CSRMAP;

      SG_C_ASSERT(__sizeof__PMEM_CSRMAP, sizeof (PMEM_CSRMAP) == 1024);

   #else
      typedef struct _PMEM_CSRMAP {
         PMEM_INDEX_CSR index;
         PMEM_DATA_CSR data;
         PMEM_COUNT_CSR chute0_count;
         PMEM_COUNT_CSR chute1_count;
         PMEM_COUNT_CSR chute2_count;
         PMEM_COUNT_CSR chute3_count;
         PMEM_COUNT_CSR chute4_count;
         PMEM_COUNT_CSR total_count;
         PMEM_PARTITION_CSR partitions;
         PMEM_PIO_DEALLOC pio_dealloc;
         HWDBG_CSRMAP hwdbg;
         PMEM_UE_SOURCE ue_source;
         PMEM_UE_ENABLE ue_enable;
         PMEM_CONTROL_STATUS_CSR control_status;
         PMEM_COUNT_CSR fcoe0_count;
         PMEM_COUNT_CSR fcoe1_count;
         PMEM_RED_CTRL_1_CSR pmem_red_ulp0_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_ulp0_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_ulp1_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_ulp1_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_ulp2_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_ulp2_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_lro_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_lro_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_eth_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_eth_ctrl_2;
         PMEM_RED_CTRL_1_CSR pmem_red_global_ctrl_1;
         PMEM_RED_CTRL_2_CSR pmem_red_global_ctrl_2;
         PMEM_RED_CONFIG_CSR pmem_red_config;
         PMEM_RED_COUNTER_CSR pmem_red_eth_count;
         PMEM_RED_COUNTER_CSR pmem_red_lro_count;
         PMEM_RED_COUNTER_CSR pmem_red_ulp0_count;
         PMEM_RED_COUNTER_CSR pmem_red_ulp1_count;
         PMEM_RED_COUNTER_CSR pmem_red_ulp2_count;
         PMEM_RED_COUNTER_CSR pmem_red_global_count;
         u32 rsvd0[219];                          // DWORDS 37 to 255
      } SG_PACK PMEM_CSRMAP, *PPMEM_CSRMAP;

      typedef union _PMEM_CSRMAP_UNION {
         PMEM_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK PMEM_CSRMAP_UNION, *PPMEM_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__PMEM_CSRMAP_UNION, sizeof (PMEM_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __pmem_bmap_h__

