/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __toerx_exp_bmap_h__
#define __toerx_exp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TOERX_STATS {
         union {
            struct { 
               u32 tx_chip_requests;              // DWORD 0
               u32 piggyback_acks;                // DWORD 1
               u32 def_buff_db;                   // DWORD 2
               u32 pre_post_db;                   // DWORD 3
               u32 win_up_wr;                     // DWORD 4
               u32 pre_post_uc_fetch;             // DWORD 5
               u32 sm_refetch_sgl;                // DWORD 6
               u32 sm_offset_sgl;                 // DWORD 7
               u32 sm_skip_sgl;                   // DWORD 8
               u32 sm_push_sgl;                   // DWORD 9
               u32 max_uc_reqs;                   // DWORD 10
               u32 defq_flush_ipc;                // DWORD 11
               u32 tpre_state_change_ipc;         // DWORD 12
               u32 tpre_upload_ipc;               // DWORD 13
               u32 tpre_tx_flush_ipc;             // DWORD 14
               u32 tpre_push_timer;               // DWORD 15
               u32 tpre_purge_ooo;                // DWORD 16
               u32 siq;                           // DWORD 17
               u32 siq0;                          // DWORD 18
               u32 pre_post_db_after_flush;       // DWORD 19
               u32 uc_resp_after_flush;           // DWORD 20
               u32 dbg1;                          // DWORD 21
               u32 dbg2;                          // DWORD 22
               u32 dbg3;                          // DWORD 23
               u32 dbg4;                          // DWORD 24
               u32 tpred_count;                   // DWORD 25
               u32 pure_acks;                     // DWORD 26
               u32 default_packets;               // DWORD 27
               u32 preposted_packets;             // DWORD 28
               u32 ooo_packets;                   // DWORD 29
               u32 tpre_pure_fin;                 // DWORD 30
               u32 poke_tpred;                    // DWORD 31
               u32 vqueue_disarm;                 // DWORD 32
               u32 vqueue_rearm;                  // DWORD 33
               u32 default_buffer_ringwrap;       // DWORD 34
               u32 ooo_default_ringwrap;          // DWORD 35
               u32 ooo_plugs;                     // DWORD 36
               u32 pure_data_ooo;                 // DWORD 37
               u32 new_ooo_fin;                   // DWORD 38
               u32 lro_driver_credits;            // DWORD 39
               u32 lro_data_credits;              // DWORD 40
               u32 start_chain_requests;          // DWORD 41
               u32 singleton_requests;            // DWORD 42
               u32 precompl_requests;             // DWORD 43
               u32 precompl_start;                // DWORD 44
               u32 precompl_singleton;            // DWORD 45
               u32 append_requests;               // DWORD 46
               u32 append_compl;                  // DWORD 47
               u32 collision_requests;            // DWORD 48
               u32 collision_drops;               // DWORD 49
               u32 flush_requests;                // DWORD 50
               u32 rsvd0[205];                    // DWORDS 51 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TOERX_STATS, *PBE_TOERX_STATS;

      SG_C_ASSERT(__sizeof__BE_TOERX_STATS, sizeof (BE_TOERX_STATS) == 1024);

   #else
      typedef struct _BE_TOERX_STATS {
         u32 tx_chip_requests;                    // DWORD 0
         u32 piggyback_acks;                      // DWORD 1
         u32 def_buff_db;                         // DWORD 2
         u32 pre_post_db;                         // DWORD 3
         u32 win_up_wr;                           // DWORD 4
         u32 pre_post_uc_fetch;                   // DWORD 5
         u32 sm_refetch_sgl;                      // DWORD 6
         u32 sm_offset_sgl;                       // DWORD 7
         u32 sm_skip_sgl;                         // DWORD 8
         u32 sm_push_sgl;                         // DWORD 9
         u32 max_uc_reqs;                         // DWORD 10
         u32 defq_flush_ipc;                      // DWORD 11
         u32 tpre_state_change_ipc;               // DWORD 12
         u32 tpre_upload_ipc;                     // DWORD 13
         u32 tpre_tx_flush_ipc;                   // DWORD 14
         u32 tpre_push_timer;                     // DWORD 15
         u32 tpre_purge_ooo;                      // DWORD 16
         u32 siq;                                 // DWORD 17
         u32 siq0;                                // DWORD 18
         u32 pre_post_db_after_flush;             // DWORD 19
         u32 uc_resp_after_flush;                 // DWORD 20
         u32 dbg1;                                // DWORD 21
         u32 dbg2;                                // DWORD 22
         u32 dbg3;                                // DWORD 23
         u32 dbg4;                                // DWORD 24
         u32 tpred_count;                         // DWORD 25
         u32 pure_acks;                           // DWORD 26
         u32 default_packets;                     // DWORD 27
         u32 preposted_packets;                   // DWORD 28
         u32 ooo_packets;                         // DWORD 29
         u32 tpre_pure_fin;                       // DWORD 30
         u32 poke_tpred;                          // DWORD 31
         u32 vqueue_disarm;                       // DWORD 32
         u32 vqueue_rearm;                        // DWORD 33
         u32 default_buffer_ringwrap;             // DWORD 34
         u32 ooo_default_ringwrap;                // DWORD 35
         u32 ooo_plugs;                           // DWORD 36
         u32 pure_data_ooo;                       // DWORD 37
         u32 new_ooo_fin;                         // DWORD 38
         u32 lro_driver_credits;                  // DWORD 39
         u32 lro_data_credits;                    // DWORD 40
         u32 start_chain_requests;                // DWORD 41
         u32 singleton_requests;                  // DWORD 42
         u32 precompl_requests;                   // DWORD 43
         u32 precompl_start;                      // DWORD 44
         u32 precompl_singleton;                  // DWORD 45
         u32 append_requests;                     // DWORD 46
         u32 append_compl;                        // DWORD 47
         u32 collision_requests;                  // DWORD 48
         u32 collision_drops;                     // DWORD 49
         u32 flush_requests;                      // DWORD 50
         u32 rsvd0[205];                          // DWORDS 51 to 255
      } SG_PACK BE_TOERX_STATS, *PBE_TOERX_STATS;

      typedef union _BE_TOERX_STATS_UNION {
         BE_TOERX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TOERX_STATS_UNION, *PBE_TOERX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TOERX_STATS_UNION, sizeof (BE_TOERX_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TOERX_STATS {
         union {
            struct { 
               u32 tx_chip_requests;              // DWORD 0
               u32 piggyback_acks;                // DWORD 1
               u32 def_buff_db;                   // DWORD 2
               u32 pre_post_db;                   // DWORD 3
               u32 win_up_wr;                     // DWORD 4
               u32 pre_post_uc_fetch;             // DWORD 5
               u32 sm_refetch_sgl;                // DWORD 6
               u32 sm_offset_sgl;                 // DWORD 7
               u32 sm_skip_sgl;                   // DWORD 8
               u32 sm_push_sgl;                   // DWORD 9
               u32 max_uc_reqs;                   // DWORD 10
               u32 defq_flush_ipc;                // DWORD 11
               u32 tpre_state_change_ipc;         // DWORD 12
               u32 tpre_upload_ipc;               // DWORD 13
               u32 tpre_tx_flush_ipc;             // DWORD 14
               u32 tpre_push_timer;               // DWORD 15
               u32 tpre_purge_ooo;                // DWORD 16
               u32 siq;                           // DWORD 17
               u32 siq0;                          // DWORD 18
               u32 pre_post_db_after_flush;       // DWORD 19
               u32 uc_resp_after_flush;           // DWORD 20
               u32 dbg1;                          // DWORD 21
               u32 dbg2;                          // DWORD 22
               u32 dbg3;                          // DWORD 23
               u32 dbg4;                          // DWORD 24
               u32 tpred_count;                   // DWORD 25
               u32 pure_acks;                     // DWORD 26
               u32 default_packets;               // DWORD 27
               u32 preposted_packets;             // DWORD 28
               u32 ooo_packets;                   // DWORD 29
               u32 tpre_pure_fin;                 // DWORD 30
               u32 poke_tpred;                    // DWORD 31
               u32 vqueue_disarm;                 // DWORD 32
               u32 vqueue_rearm;                  // DWORD 33
               u32 default_buffer_ringwrap;       // DWORD 34
               u32 ooo_default_ringwrap;          // DWORD 35
               u32 ooo_plugs;                     // DWORD 36
               u32 pure_data_ooo;                 // DWORD 37
               u32 new_ooo_fin;                   // DWORD 38
               u32 lro_driver_credits;            // DWORD 39
               u32 lro_data_credits;              // DWORD 40
               u32 start_chain_requests;          // DWORD 41
               u32 singleton_requests;            // DWORD 42
               u32 precompl_requests;             // DWORD 43
               u32 precompl_start;                // DWORD 44
               u32 precompl_singleton;            // DWORD 45
               u32 append_requests;               // DWORD 46
               u32 append_compl;                  // DWORD 47
               u32 collision_requests;            // DWORD 48
               u32 collision_drops;               // DWORD 49
               u32 flush_requests;                // DWORD 50
               u32 rsvd0[205];                    // DWORDS 51 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TOERX_STATS, *PBE_TOERX_STATS;

      SG_C_ASSERT(__sizeof__BE_TOERX_STATS, sizeof (BE_TOERX_STATS) == 1024);

   #else
      typedef struct _BE_TOERX_STATS {
         u32 tx_chip_requests;                    // DWORD 0
         u32 piggyback_acks;                      // DWORD 1
         u32 def_buff_db;                         // DWORD 2
         u32 pre_post_db;                         // DWORD 3
         u32 win_up_wr;                           // DWORD 4
         u32 pre_post_uc_fetch;                   // DWORD 5
         u32 sm_refetch_sgl;                      // DWORD 6
         u32 sm_offset_sgl;                       // DWORD 7
         u32 sm_skip_sgl;                         // DWORD 8
         u32 sm_push_sgl;                         // DWORD 9
         u32 max_uc_reqs;                         // DWORD 10
         u32 defq_flush_ipc;                      // DWORD 11
         u32 tpre_state_change_ipc;               // DWORD 12
         u32 tpre_upload_ipc;                     // DWORD 13
         u32 tpre_tx_flush_ipc;                   // DWORD 14
         u32 tpre_push_timer;                     // DWORD 15
         u32 tpre_purge_ooo;                      // DWORD 16
         u32 siq;                                 // DWORD 17
         u32 siq0;                                // DWORD 18
         u32 pre_post_db_after_flush;             // DWORD 19
         u32 uc_resp_after_flush;                 // DWORD 20
         u32 dbg1;                                // DWORD 21
         u32 dbg2;                                // DWORD 22
         u32 dbg3;                                // DWORD 23
         u32 dbg4;                                // DWORD 24
         u32 tpred_count;                         // DWORD 25
         u32 pure_acks;                           // DWORD 26
         u32 default_packets;                     // DWORD 27
         u32 preposted_packets;                   // DWORD 28
         u32 ooo_packets;                         // DWORD 29
         u32 tpre_pure_fin;                       // DWORD 30
         u32 poke_tpred;                          // DWORD 31
         u32 vqueue_disarm;                       // DWORD 32
         u32 vqueue_rearm;                        // DWORD 33
         u32 default_buffer_ringwrap;             // DWORD 34
         u32 ooo_default_ringwrap;                // DWORD 35
         u32 ooo_plugs;                           // DWORD 36
         u32 pure_data_ooo;                       // DWORD 37
         u32 new_ooo_fin;                         // DWORD 38
         u32 lro_driver_credits;                  // DWORD 39
         u32 lro_data_credits;                    // DWORD 40
         u32 start_chain_requests;                // DWORD 41
         u32 singleton_requests;                  // DWORD 42
         u32 precompl_requests;                   // DWORD 43
         u32 precompl_start;                      // DWORD 44
         u32 precompl_singleton;                  // DWORD 45
         u32 append_requests;                     // DWORD 46
         u32 append_compl;                        // DWORD 47
         u32 collision_requests;                  // DWORD 48
         u32 collision_drops;                     // DWORD 49
         u32 flush_requests;                      // DWORD 50
         u32 rsvd0[205];                          // DWORDS 51 to 255
      } SG_PACK BE_TOERX_STATS, *PBE_TOERX_STATS;

      typedef union _BE_TOERX_STATS_UNION {
         BE_TOERX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TOERX_STATS_UNION, *PBE_TOERX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TOERX_STATS_UNION, sizeof (BE_TOERX_STATS_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __toerx_exp_bmap_h__

