/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __toetx_exp_bmap_h__
#define __toetx_exp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TOETX_STATS {
         union {
            struct { 
               u32 num_disabled_conns;            // DWORD 0
               u32 num_txpballoc_failures;        // DWORD 1
               u32 toe_driver_requests;           // DWORD 2
               u32 supercid_driver_requests;      // DWORD 3
               u32 supercid_nowork_requests;      // DWORD 4
               u32 eth_driver_requests;           // DWORD 5
               u32 toe_rxmt_requests;             // DWORD 6
               u32 num_supercid_wrb_fetches;      // DWORD 7
               u32 num_supercid_extra_wrb_fetches; // DWORD 8
               u32 toe_flush;                     // DWORD 9
               u32 eth_flush;                     // DWORD 10
               u32 num_uc_requests;               // DWORD 11
               u32 num_invalid_connection_requests; // DWORD 12
               u32 jellm_throttle_cnt;            // DWORD 13
               u32 crd_iq_enable;                 // DWORD 14
               u32 crd_iq_disable;                // DWORD 15
               u32 num_siq4;                      // DWORD 16
               u32 window_reneg_detected;         // DWORD 17
               u32 num_ack_txds;                  // DWORD 18
               u32 num_ack1_txds;                 // DWORD 19
               u32 num_access_plus_rexmt_requests; // DWORD 20
               u32 num_access_minus_normal_requests; // DWORD 21
               u32 num_access_minus_rexmt_requests; // DWORD 22
               u32 num_invalidate_normal_requests; // DWORD 23
               u32 num_invalidate_rexmt_requests; // DWORD 24
               u32 num_range_flush_requests;      // DWORD 25
               u32 num_rexmt_reschedules;         // DWORD 26
               u32 flush_txds;                    // DWORD 27
               u32 num_sws_avoid_requests;        // DWORD 28
               u32 num_sws_avoid_requests2;       // DWORD 29
               u32 num_toe_fast_requests;         // DWORD 30
               u32 num_toe_slow_requests;         // DWORD 31
               u32 txd_6mss;                      // DWORD 32
               u32 txd_4mss;                      // DWORD 33
               u32 txd_1mss;                      // DWORD 34
               u32 txd_1024;                      // DWORD 35
               u32 txd_512;                       // DWORD 36
               u32 txd_256;                       // DWORD 37
               u32 txd_128;                       // DWORD 38
               u32 win_too_small;                 // DWORD 39
               u32 toe_zerowin_posts;             // DWORD 40
               u32 bug9461_avoid_count;           // DWORD 41
               u32 tcp_update_ipc_cnt;            // DWORD 42
               u32 newreno_defer;                 // DWORD 43
               u32 pfc_enable_cnt;                // DWORD 44
               u32 pfc_disable_cnt;               // DWORD 45
               u32 pfc_timer_cnt;                 // DWORD 46
               u32 skip_backpoked_fin;            // DWORD 47
               u32 num_extra_wrb_fetches;         // DWORD 48
               u32 multiple_jrnl_rexmit;          // DWORD 49
               u32 walk_jelist_again;             // DWORD 50
               u32 use_repeated_wrb;              // DWORD 51
               u32 excess_enable_cnt;             // DWORD 52
               u32 excess_disable_pt0_cnt;        // DWORD 53
               u32 excess_disable_pt1_cnt;        // DWORD 54
               u32 toe_excess;                    // DWORD 55
               u32 using_excess_wait;             // DWORD 56
               u32 excess_spacing_ipc;            // DWORD 57
               u32 etx_no_excess;                 // DWORD 58
               u32 etx_excess;                    // DWORD 59
               u32 excess_qos_ctx_set;            // DWORD 60
               u32 excess_qos_ctx_clear;          // DWORD 61
               u32 debug0;                        // DWORD 62
               u32 debug1;                        // DWORD 63
               u32 debug2;                        // DWORD 64
               u32 debug3;                        // DWORD 65
               u32 rsvd0[190];                    // DWORDS 66 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TOETX_STATS, *PBE_TOETX_STATS;

      SG_C_ASSERT(__sizeof__BE_TOETX_STATS, sizeof (BE_TOETX_STATS) == 1024);

   #else
      typedef struct _BE_TOETX_STATS {
         u32 num_disabled_conns;                  // DWORD 0
         u32 num_txpballoc_failures;              // DWORD 1
         u32 toe_driver_requests;                 // DWORD 2
         u32 supercid_driver_requests;            // DWORD 3
         u32 supercid_nowork_requests;            // DWORD 4
         u32 eth_driver_requests;                 // DWORD 5
         u32 toe_rxmt_requests;                   // DWORD 6
         u32 num_supercid_wrb_fetches;            // DWORD 7
         u32 num_supercid_extra_wrb_fetches;      // DWORD 8
         u32 toe_flush;                           // DWORD 9
         u32 eth_flush;                           // DWORD 10
         u32 num_uc_requests;                     // DWORD 11
         u32 num_invalid_connection_requests;     // DWORD 12
         u32 jellm_throttle_cnt;                  // DWORD 13
         u32 crd_iq_enable;                       // DWORD 14
         u32 crd_iq_disable;                      // DWORD 15
         u32 num_siq4;                            // DWORD 16
         u32 window_reneg_detected;               // DWORD 17
         u32 num_ack_txds;                        // DWORD 18
         u32 num_ack1_txds;                       // DWORD 19
         u32 num_access_plus_rexmt_requests;      // DWORD 20
         u32 num_access_minus_normal_requests;    // DWORD 21
         u32 num_access_minus_rexmt_requests;     // DWORD 22
         u32 num_invalidate_normal_requests;      // DWORD 23
         u32 num_invalidate_rexmt_requests;       // DWORD 24
         u32 num_range_flush_requests;            // DWORD 25
         u32 num_rexmt_reschedules;               // DWORD 26
         u32 flush_txds;                          // DWORD 27
         u32 num_sws_avoid_requests;              // DWORD 28
         u32 num_sws_avoid_requests2;             // DWORD 29
         u32 num_toe_fast_requests;               // DWORD 30
         u32 num_toe_slow_requests;               // DWORD 31
         u32 txd_6mss;                            // DWORD 32
         u32 txd_4mss;                            // DWORD 33
         u32 txd_1mss;                            // DWORD 34
         u32 txd_1024;                            // DWORD 35
         u32 txd_512;                             // DWORD 36
         u32 txd_256;                             // DWORD 37
         u32 txd_128;                             // DWORD 38
         u32 win_too_small;                       // DWORD 39
         u32 toe_zerowin_posts;                   // DWORD 40
         u32 bug9461_avoid_count;                 // DWORD 41
         u32 tcp_update_ipc_cnt;                  // DWORD 42
         u32 newreno_defer;                       // DWORD 43
         u32 pfc_enable_cnt;                      // DWORD 44
         u32 pfc_disable_cnt;                     // DWORD 45
         u32 pfc_timer_cnt;                       // DWORD 46
         u32 skip_backpoked_fin;                  // DWORD 47
         u32 num_extra_wrb_fetches;               // DWORD 48
         u32 multiple_jrnl_rexmit;                // DWORD 49
         u32 walk_jelist_again;                   // DWORD 50
         u32 use_repeated_wrb;                    // DWORD 51
         u32 excess_enable_cnt;                   // DWORD 52
         u32 excess_disable_pt0_cnt;              // DWORD 53
         u32 excess_disable_pt1_cnt;              // DWORD 54
         u32 toe_excess;                          // DWORD 55
         u32 using_excess_wait;                   // DWORD 56
         u32 excess_spacing_ipc;                  // DWORD 57
         u32 etx_no_excess;                       // DWORD 58
         u32 etx_excess;                          // DWORD 59
         u32 excess_qos_ctx_set;                  // DWORD 60
         u32 excess_qos_ctx_clear;                // DWORD 61
         u32 debug0;                              // DWORD 62
         u32 debug1;                              // DWORD 63
         u32 debug2;                              // DWORD 64
         u32 debug3;                              // DWORD 65
         u32 rsvd0[190];                          // DWORDS 66 to 255
      } SG_PACK BE_TOETX_STATS, *PBE_TOETX_STATS;

      typedef union _BE_TOETX_STATS_UNION {
         BE_TOETX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TOETX_STATS_UNION, *PBE_TOETX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TOETX_STATS_UNION, sizeof (BE_TOETX_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TOETX_STATS {
         union {
            struct { 
               u32 num_disabled_conns;            // DWORD 0
               u32 num_txpballoc_failures;        // DWORD 1
               u32 toe_driver_requests;           // DWORD 2
               u32 supercid_driver_requests;      // DWORD 3
               u32 supercid_nowork_requests;      // DWORD 4
               u32 eth_driver_requests;           // DWORD 5
               u32 toe_rxmt_requests;             // DWORD 6
               u32 num_supercid_wrb_fetches;      // DWORD 7
               u32 num_supercid_extra_wrb_fetches; // DWORD 8
               u32 toe_flush;                     // DWORD 9
               u32 eth_flush;                     // DWORD 10
               u32 num_uc_requests;               // DWORD 11
               u32 num_invalid_connection_requests; // DWORD 12
               u32 jellm_throttle_cnt;            // DWORD 13
               u32 crd_iq_enable;                 // DWORD 14
               u32 crd_iq_disable;                // DWORD 15
               u32 num_siq4;                      // DWORD 16
               u32 window_reneg_detected;         // DWORD 17
               u32 num_ack_txds;                  // DWORD 18
               u32 num_ack1_txds;                 // DWORD 19
               u32 num_access_plus_rexmt_requests; // DWORD 20
               u32 num_access_minus_normal_requests; // DWORD 21
               u32 num_access_minus_rexmt_requests; // DWORD 22
               u32 num_invalidate_normal_requests; // DWORD 23
               u32 num_invalidate_rexmt_requests; // DWORD 24
               u32 num_range_flush_requests;      // DWORD 25
               u32 num_rexmt_reschedules;         // DWORD 26
               u32 flush_txds;                    // DWORD 27
               u32 num_sws_avoid_requests;        // DWORD 28
               u32 num_sws_avoid_requests2;       // DWORD 29
               u32 num_toe_fast_requests;         // DWORD 30
               u32 num_toe_slow_requests;         // DWORD 31
               u32 txd_6mss;                      // DWORD 32
               u32 txd_4mss;                      // DWORD 33
               u32 txd_1mss;                      // DWORD 34
               u32 txd_1024;                      // DWORD 35
               u32 txd_512;                       // DWORD 36
               u32 txd_256;                       // DWORD 37
               u32 txd_128;                       // DWORD 38
               u32 win_too_small;                 // DWORD 39
               u32 toe_zerowin_posts;             // DWORD 40
               u32 bug9461_avoid_count;           // DWORD 41
               u32 tcp_update_ipc_cnt;            // DWORD 42
               u32 newreno_defer;                 // DWORD 43
               u32 pfc_enable_cnt;                // DWORD 44
               u32 pfc_disable_cnt;               // DWORD 45
               u32 pfc_timer_cnt;                 // DWORD 46
               u32 skip_backpoked_fin;            // DWORD 47
               u32 num_extra_wrb_fetches;         // DWORD 48
               u32 multiple_jrnl_rexmit;          // DWORD 49
               u32 walk_jelist_again;             // DWORD 50
               u32 use_repeated_wrb;              // DWORD 51
               u32 excess_enable_cnt;             // DWORD 52
               u32 excess_disable_pt0_cnt;        // DWORD 53
               u32 excess_disable_pt1_cnt;        // DWORD 54
               u32 toe_excess;                    // DWORD 55
               u32 using_excess_wait;             // DWORD 56
               u32 excess_spacing_ipc;            // DWORD 57
               u32 etx_no_excess;                 // DWORD 58
               u32 etx_excess;                    // DWORD 59
               u32 excess_qos_ctx_set;            // DWORD 60
               u32 excess_qos_ctx_clear;          // DWORD 61
               u32 debug0;                        // DWORD 62
               u32 debug1;                        // DWORD 63
               u32 debug2;                        // DWORD 64
               u32 debug3;                        // DWORD 65
               u32 rsvd0[190];                    // DWORDS 66 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TOETX_STATS, *PBE_TOETX_STATS;

      SG_C_ASSERT(__sizeof__BE_TOETX_STATS, sizeof (BE_TOETX_STATS) == 1024);

   #else
      typedef struct _BE_TOETX_STATS {
         u32 num_disabled_conns;                  // DWORD 0
         u32 num_txpballoc_failures;              // DWORD 1
         u32 toe_driver_requests;                 // DWORD 2
         u32 supercid_driver_requests;            // DWORD 3
         u32 supercid_nowork_requests;            // DWORD 4
         u32 eth_driver_requests;                 // DWORD 5
         u32 toe_rxmt_requests;                   // DWORD 6
         u32 num_supercid_wrb_fetches;            // DWORD 7
         u32 num_supercid_extra_wrb_fetches;      // DWORD 8
         u32 toe_flush;                           // DWORD 9
         u32 eth_flush;                           // DWORD 10
         u32 num_uc_requests;                     // DWORD 11
         u32 num_invalid_connection_requests;     // DWORD 12
         u32 jellm_throttle_cnt;                  // DWORD 13
         u32 crd_iq_enable;                       // DWORD 14
         u32 crd_iq_disable;                      // DWORD 15
         u32 num_siq4;                            // DWORD 16
         u32 window_reneg_detected;               // DWORD 17
         u32 num_ack_txds;                        // DWORD 18
         u32 num_ack1_txds;                       // DWORD 19
         u32 num_access_plus_rexmt_requests;      // DWORD 20
         u32 num_access_minus_normal_requests;    // DWORD 21
         u32 num_access_minus_rexmt_requests;     // DWORD 22
         u32 num_invalidate_normal_requests;      // DWORD 23
         u32 num_invalidate_rexmt_requests;       // DWORD 24
         u32 num_range_flush_requests;            // DWORD 25
         u32 num_rexmt_reschedules;               // DWORD 26
         u32 flush_txds;                          // DWORD 27
         u32 num_sws_avoid_requests;              // DWORD 28
         u32 num_sws_avoid_requests2;             // DWORD 29
         u32 num_toe_fast_requests;               // DWORD 30
         u32 num_toe_slow_requests;               // DWORD 31
         u32 txd_6mss;                            // DWORD 32
         u32 txd_4mss;                            // DWORD 33
         u32 txd_1mss;                            // DWORD 34
         u32 txd_1024;                            // DWORD 35
         u32 txd_512;                             // DWORD 36
         u32 txd_256;                             // DWORD 37
         u32 txd_128;                             // DWORD 38
         u32 win_too_small;                       // DWORD 39
         u32 toe_zerowin_posts;                   // DWORD 40
         u32 bug9461_avoid_count;                 // DWORD 41
         u32 tcp_update_ipc_cnt;                  // DWORD 42
         u32 newreno_defer;                       // DWORD 43
         u32 pfc_enable_cnt;                      // DWORD 44
         u32 pfc_disable_cnt;                     // DWORD 45
         u32 pfc_timer_cnt;                       // DWORD 46
         u32 skip_backpoked_fin;                  // DWORD 47
         u32 num_extra_wrb_fetches;               // DWORD 48
         u32 multiple_jrnl_rexmit;                // DWORD 49
         u32 walk_jelist_again;                   // DWORD 50
         u32 use_repeated_wrb;                    // DWORD 51
         u32 excess_enable_cnt;                   // DWORD 52
         u32 excess_disable_pt0_cnt;              // DWORD 53
         u32 excess_disable_pt1_cnt;              // DWORD 54
         u32 toe_excess;                          // DWORD 55
         u32 using_excess_wait;                   // DWORD 56
         u32 excess_spacing_ipc;                  // DWORD 57
         u32 etx_no_excess;                       // DWORD 58
         u32 etx_excess;                          // DWORD 59
         u32 excess_qos_ctx_set;                  // DWORD 60
         u32 excess_qos_ctx_clear;                // DWORD 61
         u32 debug0;                              // DWORD 62
         u32 debug1;                              // DWORD 63
         u32 debug2;                              // DWORD 64
         u32 debug3;                              // DWORD 65
         u32 rsvd0[190];                          // DWORDS 66 to 255
      } SG_PACK BE_TOETX_STATS, *PBE_TOETX_STATS;

      typedef union _BE_TOETX_STATS_UNION {
         BE_TOETX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TOETX_STATS_UNION, *PBE_TOETX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TOETX_STATS_UNION, sizeof (BE_TOETX_STATS_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __toetx_exp_bmap_h__

