/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tpost_exp_bmap_h__
#define __tpost_exp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPOST_CHUTE_STATS {
         union {
            struct { 
               u32 segments_timed;                // DWORD 0
               u32 delayed_acks;                  // DWORD 1
               u32 persist_timeouts;              // DWORD 2
               u32 keepalive_timeouts;            // DWORD 3
               u32 keepalive_probes;              // DWORD 4
               u32 keepalive_drops;               // DWORD 5
               u32 window_updates;                // DWORD 6
               u32 delegated_packets;             // DWORD 7
               u32 delegated_bytes;               // DWORD 8
               u32 drop_imm_acks;                 // DWORD 9
               u32 drop_templated_acks;           // DWORD 10
               u32 ack_ipcs;                      // DWORD 11
               u32 dummyloads;                    // DWORD 12
               u32 ack_txd_drops;                 // DWORD 13
               u32 ack_txd_sent;                  // DWORD 14
               u32 winup_txd_sent;                // DWORD 15
               u32 ipc_rxmt_complete;             // DWORD 16
               u32 ipc_rxmt_complete1;            // DWORD 17
               u32 flush_txds;                    // DWORD 18
               u32 p0_sackbytes;                  // DWORD 19
               u32 p1_sackbytes;                  // DWORD 20
               u32 ipc_tcp_upload;                // DWORD 21
               u32 tcp_update_ipc_cnt;            // DWORD 22
               u32 debug0;                        // DWORD 23
               u32 debug1;                        // DWORD 24
               u32 debug2;                        // DWORD 25
               u32 debug3;                        // DWORD 26
               u32 rsvd0[37];                     // DWORDS 27 to 63
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPOST_CHUTE_STATS, *PBE_TPOST_CHUTE_STATS;

      SG_C_ASSERT(__sizeof__BE_TPOST_CHUTE_STATS, sizeof (BE_TPOST_CHUTE_STATS) == 256);

   #else
      typedef struct _BE_TPOST_CHUTE_STATS {
         u32 segments_timed;                      // DWORD 0
         u32 delayed_acks;                        // DWORD 1
         u32 persist_timeouts;                    // DWORD 2
         u32 keepalive_timeouts;                  // DWORD 3
         u32 keepalive_probes;                    // DWORD 4
         u32 keepalive_drops;                     // DWORD 5
         u32 window_updates;                      // DWORD 6
         u32 delegated_packets;                   // DWORD 7
         u32 delegated_bytes;                     // DWORD 8
         u32 drop_imm_acks;                       // DWORD 9
         u32 drop_templated_acks;                 // DWORD 10
         u32 ack_ipcs;                            // DWORD 11
         u32 dummyloads;                          // DWORD 12
         u32 ack_txd_drops;                       // DWORD 13
         u32 ack_txd_sent;                        // DWORD 14
         u32 winup_txd_sent;                      // DWORD 15
         u32 ipc_rxmt_complete;                   // DWORD 16
         u32 ipc_rxmt_complete1;                  // DWORD 17
         u32 flush_txds;                          // DWORD 18
         u32 p0_sackbytes;                        // DWORD 19
         u32 p1_sackbytes;                        // DWORD 20
         u32 ipc_tcp_upload;                      // DWORD 21
         u32 tcp_update_ipc_cnt;                  // DWORD 22
         u32 debug0;                              // DWORD 23
         u32 debug1;                              // DWORD 24
         u32 debug2;                              // DWORD 25
         u32 debug3;                              // DWORD 26
         u32 rsvd0[37];                           // DWORDS 27 to 63
      } SG_PACK BE_TPOST_CHUTE_STATS, *PBE_TPOST_CHUTE_STATS;

      typedef union _BE_TPOST_CHUTE_STATS_UNION {
         BE_TPOST_CHUTE_STATS bits;
         u32 dw[64]; // dword union
      } SG_PACK BE_TPOST_CHUTE_STATS_UNION, *PBE_TPOST_CHUTE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPOST_CHUTE_STATS_UNION, sizeof (BE_TPOST_CHUTE_STATS_UNION) == 256);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPOST_CHUTE_STATS {
         union {
            struct { 
               u32 segments_timed;                // DWORD 0
               u32 delayed_acks;                  // DWORD 1
               u32 persist_timeouts;              // DWORD 2
               u32 keepalive_timeouts;            // DWORD 3
               u32 keepalive_probes;              // DWORD 4
               u32 keepalive_drops;               // DWORD 5
               u32 window_updates;                // DWORD 6
               u32 delegated_packets;             // DWORD 7
               u32 delegated_bytes;               // DWORD 8
               u32 drop_imm_acks;                 // DWORD 9
               u32 drop_templated_acks;           // DWORD 10
               u32 ack_ipcs;                      // DWORD 11
               u32 dummyloads;                    // DWORD 12
               u32 ack_txd_drops;                 // DWORD 13
               u32 ack_txd_sent;                  // DWORD 14
               u32 winup_txd_sent;                // DWORD 15
               u32 ipc_rxmt_complete;             // DWORD 16
               u32 ipc_rxmt_complete1;            // DWORD 17
               u32 flush_txds;                    // DWORD 18
               u32 p0_sackbytes;                  // DWORD 19
               u32 p1_sackbytes;                  // DWORD 20
               u32 ipc_tcp_upload;                // DWORD 21
               u32 tcp_update_ipc_cnt;            // DWORD 22
               u32 debug0;                        // DWORD 23
               u32 debug1;                        // DWORD 24
               u32 debug2;                        // DWORD 25
               u32 debug3;                        // DWORD 26
               u32 rsvd0[37];                     // DWORDS 27 to 63
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPOST_CHUTE_STATS, *PBE_TPOST_CHUTE_STATS;

      SG_C_ASSERT(__sizeof__BE_TPOST_CHUTE_STATS, sizeof (BE_TPOST_CHUTE_STATS) == 256);

   #else
      typedef struct _BE_TPOST_CHUTE_STATS {
         u32 segments_timed;                      // DWORD 0
         u32 delayed_acks;                        // DWORD 1
         u32 persist_timeouts;                    // DWORD 2
         u32 keepalive_timeouts;                  // DWORD 3
         u32 keepalive_probes;                    // DWORD 4
         u32 keepalive_drops;                     // DWORD 5
         u32 window_updates;                      // DWORD 6
         u32 delegated_packets;                   // DWORD 7
         u32 delegated_bytes;                     // DWORD 8
         u32 drop_imm_acks;                       // DWORD 9
         u32 drop_templated_acks;                 // DWORD 10
         u32 ack_ipcs;                            // DWORD 11
         u32 dummyloads;                          // DWORD 12
         u32 ack_txd_drops;                       // DWORD 13
         u32 ack_txd_sent;                        // DWORD 14
         u32 winup_txd_sent;                      // DWORD 15
         u32 ipc_rxmt_complete;                   // DWORD 16
         u32 ipc_rxmt_complete1;                  // DWORD 17
         u32 flush_txds;                          // DWORD 18
         u32 p0_sackbytes;                        // DWORD 19
         u32 p1_sackbytes;                        // DWORD 20
         u32 ipc_tcp_upload;                      // DWORD 21
         u32 tcp_update_ipc_cnt;                  // DWORD 22
         u32 debug0;                              // DWORD 23
         u32 debug1;                              // DWORD 24
         u32 debug2;                              // DWORD 25
         u32 debug3;                              // DWORD 26
         u32 rsvd0[37];                           // DWORDS 27 to 63
      } SG_PACK BE_TPOST_CHUTE_STATS, *PBE_TPOST_CHUTE_STATS;

      typedef union _BE_TPOST_CHUTE_STATS_UNION {
         BE_TPOST_CHUTE_STATS bits;
         u32 dw[64]; // dword union
      } SG_PACK BE_TPOST_CHUTE_STATS_UNION, *PBE_TPOST_CHUTE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPOST_CHUTE_STATS_UNION, sizeof (BE_TPOST_CHUTE_STATS_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPOST_STATS {
         union {
            struct { 
               BE_TPOST_CHUTE_STATS ct1_stats;
               BE_TPOST_CHUTE_STATS ct2_stats;
               BE_TPOST_CHUTE_STATS ct3_stats;
               u32 jellm_throttle_cnt;            // DWORD 192
               u32 wdma_req_resp_cnt;             // DWORD 193
               u32 wdma_req_noresp_cnt;           // DWORD 194
               u32 wdma_resp;                     // DWORD 195
               u32 txp_iq_disable;                // DWORD 196
               u32 num_txds;                      // DWORD 197
               u32 num_ack_descs;                 // DWORD 198
               u32 num_timer_pops;                // DWORD 199
               u32 low_lat_descs;                 // DWORD 200
               u32 num_txds_cmpl;                 // DWORD 201
               u32 num_ack_descs_cmpl;            // DWORD 202
               u32 num_timer_pops_cmpl;           // DWORD 203
               u32 low_lat_descs_cmpl;            // DWORD 204
               u32 num_cred_ret;                  // DWORD 205
               u32 jrnl_alloc_cnt;                // DWORD 206
               u32 jrnl_alloc_cmpl_cnt;           // DWORD 207
               u32 idle_timer_pops_cleared;       // DWORD 208
               u32 num_txulp_acks;                // DWORD 209
               u32 num_txulp_acks_dropped;        // DWORD 210
               u32 p0_xon;                        // DWORD 211
               u32 p0_xoff;                       // DWORD 212
               u32 p1_xon;                        // DWORD 213
               u32 p1_xoff;                       // DWORD 214
               u32 qos_interrupt;                 // DWORD 215
               u32 qos_enable_ipc;                // DWORD 216
               u32 qos_disable_pt0_ipc;           // DWORD 217
               u32 qos_disable_pt1_ipc;           // DWORD 218
               u32 acks[8];                       // DWORDS 219 to 226
               u32 wnd_probes[8];                 // DWORDS 227 to 234
               u32 rsvd0[21];                     // DWORDS 235 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPOST_STATS, *PBE_TPOST_STATS;

      SG_C_ASSERT(__sizeof__BE_TPOST_STATS, sizeof (BE_TPOST_STATS) == 1024);

   #else
      typedef struct _BE_TPOST_STATS {
         BE_TPOST_CHUTE_STATS ct1_stats;
         BE_TPOST_CHUTE_STATS ct2_stats;
         BE_TPOST_CHUTE_STATS ct3_stats;
         u32 jellm_throttle_cnt;                  // DWORD 192
         u32 wdma_req_resp_cnt;                   // DWORD 193
         u32 wdma_req_noresp_cnt;                 // DWORD 194
         u32 wdma_resp;                           // DWORD 195
         u32 txp_iq_disable;                      // DWORD 196
         u32 num_txds;                            // DWORD 197
         u32 num_ack_descs;                       // DWORD 198
         u32 num_timer_pops;                      // DWORD 199
         u32 low_lat_descs;                       // DWORD 200
         u32 num_txds_cmpl;                       // DWORD 201
         u32 num_ack_descs_cmpl;                  // DWORD 202
         u32 num_timer_pops_cmpl;                 // DWORD 203
         u32 low_lat_descs_cmpl;                  // DWORD 204
         u32 num_cred_ret;                        // DWORD 205
         u32 jrnl_alloc_cnt;                      // DWORD 206
         u32 jrnl_alloc_cmpl_cnt;                 // DWORD 207
         u32 idle_timer_pops_cleared;             // DWORD 208
         u32 num_txulp_acks;                      // DWORD 209
         u32 num_txulp_acks_dropped;              // DWORD 210
         u32 p0_xon;                              // DWORD 211
         u32 p0_xoff;                             // DWORD 212
         u32 p1_xon;                              // DWORD 213
         u32 p1_xoff;                             // DWORD 214
         u32 qos_interrupt;                       // DWORD 215
         u32 qos_enable_ipc;                      // DWORD 216
         u32 qos_disable_pt0_ipc;                 // DWORD 217
         u32 qos_disable_pt1_ipc;                 // DWORD 218
         u32 acks[8];                             // DWORDS 219 to 226
         u32 wnd_probes[8];                       // DWORDS 227 to 234
         u32 rsvd0[21];                           // DWORDS 235 to 255
      } SG_PACK BE_TPOST_STATS, *PBE_TPOST_STATS;

      typedef union _BE_TPOST_STATS_UNION {
         BE_TPOST_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TPOST_STATS_UNION, *PBE_TPOST_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPOST_STATS_UNION, sizeof (BE_TPOST_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TPOST_STATS {
         union {
            struct { 
               BE_TPOST_CHUTE_STATS ct1_stats;
               BE_TPOST_CHUTE_STATS ct2_stats;
               BE_TPOST_CHUTE_STATS ct3_stats;
               u32 jellm_throttle_cnt;            // DWORD 192
               u32 wdma_req_resp_cnt;             // DWORD 193
               u32 wdma_req_noresp_cnt;           // DWORD 194
               u32 wdma_resp;                     // DWORD 195
               u32 txp_iq_disable;                // DWORD 196
               u32 num_txds;                      // DWORD 197
               u32 num_ack_descs;                 // DWORD 198
               u32 num_timer_pops;                // DWORD 199
               u32 low_lat_descs;                 // DWORD 200
               u32 num_txds_cmpl;                 // DWORD 201
               u32 num_ack_descs_cmpl;            // DWORD 202
               u32 num_timer_pops_cmpl;           // DWORD 203
               u32 low_lat_descs_cmpl;            // DWORD 204
               u32 num_cred_ret;                  // DWORD 205
               u32 jrnl_alloc_cnt;                // DWORD 206
               u32 jrnl_alloc_cmpl_cnt;           // DWORD 207
               u32 idle_timer_pops_cleared;       // DWORD 208
               u32 num_txulp_acks;                // DWORD 209
               u32 num_txulp_acks_dropped;        // DWORD 210
               u32 p0_xon;                        // DWORD 211
               u32 p0_xoff;                       // DWORD 212
               u32 p1_xon;                        // DWORD 213
               u32 p1_xoff;                       // DWORD 214
               u32 qos_interrupt;                 // DWORD 215
               u32 qos_enable_ipc;                // DWORD 216
               u32 qos_disable_pt0_ipc;           // DWORD 217
               u32 qos_disable_pt1_ipc;           // DWORD 218
               u32 acks[8];                       // DWORDS 219 to 226
               u32 wnd_probes[8];                 // DWORDS 227 to 234
               u32 rsvd0[21];                     // DWORDS 235 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_TPOST_STATS, *PBE_TPOST_STATS;

      SG_C_ASSERT(__sizeof__BE_TPOST_STATS, sizeof (BE_TPOST_STATS) == 1024);

   #else
      typedef struct _BE_TPOST_STATS {
         BE_TPOST_CHUTE_STATS ct1_stats;
         BE_TPOST_CHUTE_STATS ct2_stats;
         BE_TPOST_CHUTE_STATS ct3_stats;
         u32 jellm_throttle_cnt;                  // DWORD 192
         u32 wdma_req_resp_cnt;                   // DWORD 193
         u32 wdma_req_noresp_cnt;                 // DWORD 194
         u32 wdma_resp;                           // DWORD 195
         u32 txp_iq_disable;                      // DWORD 196
         u32 num_txds;                            // DWORD 197
         u32 num_ack_descs;                       // DWORD 198
         u32 num_timer_pops;                      // DWORD 199
         u32 low_lat_descs;                       // DWORD 200
         u32 num_txds_cmpl;                       // DWORD 201
         u32 num_ack_descs_cmpl;                  // DWORD 202
         u32 num_timer_pops_cmpl;                 // DWORD 203
         u32 low_lat_descs_cmpl;                  // DWORD 204
         u32 num_cred_ret;                        // DWORD 205
         u32 jrnl_alloc_cnt;                      // DWORD 206
         u32 jrnl_alloc_cmpl_cnt;                 // DWORD 207
         u32 idle_timer_pops_cleared;             // DWORD 208
         u32 num_txulp_acks;                      // DWORD 209
         u32 num_txulp_acks_dropped;              // DWORD 210
         u32 p0_xon;                              // DWORD 211
         u32 p0_xoff;                             // DWORD 212
         u32 p1_xon;                              // DWORD 213
         u32 p1_xoff;                             // DWORD 214
         u32 qos_interrupt;                       // DWORD 215
         u32 qos_enable_ipc;                      // DWORD 216
         u32 qos_disable_pt0_ipc;                 // DWORD 217
         u32 qos_disable_pt1_ipc;                 // DWORD 218
         u32 acks[8];                             // DWORDS 219 to 226
         u32 wnd_probes[8];                       // DWORDS 227 to 234
         u32 rsvd0[21];                           // DWORDS 235 to 255
      } SG_PACK BE_TPOST_STATS, *PBE_TPOST_STATS;

      typedef union _BE_TPOST_STATS_UNION {
         BE_TPOST_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_TPOST_STATS_UNION, *PBE_TPOST_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TPOST_STATS_UNION, sizeof (BE_TPOST_STATS_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tpost_exp_bmap_h__

