/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __txpb_bmap_h__
#define __txpb_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This register provides control of the txpb operation. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_CONTROL_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 swap_ndma : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_CONTROL_CSR, *PTXPB_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__TXPB_CONTROL_CSR, sizeof (TXPB_CONTROL_CSR) == 4);

   #else
      typedef struct _TXPB_CONTROL_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 swap_ndma : 1;                       // DWORD 0
      } SG_PACK TXPB_CONTROL_CSR, *PTXPB_CONTROL_CSR;

      typedef union _TXPB_CONTROL_CSR_UNION {
         TXPB_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXPB_CONTROL_CSR_UNION, *PTXPB_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXPB_CONTROL_CSR_UNION, sizeof (TXPB_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // This register provides control of the txpb operation. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_CONTROL_CSR {
         union {
            struct { 
               u32 swap_ndma : 1;                 // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_CONTROL_CSR, *PTXPB_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__TXPB_CONTROL_CSR, sizeof (TXPB_CONTROL_CSR) == 4);

   #else
      typedef struct _TXPB_CONTROL_CSR {
         u32 swap_ndma : 1;                       // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK TXPB_CONTROL_CSR, *PTXPB_CONTROL_CSR;

      typedef union _TXPB_CONTROL_CSR_UNION {
         TXPB_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXPB_CONTROL_CSR_UNION, *PTXPB_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXPB_CONTROL_CSR_UNION, sizeof (TXPB_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides windowed access for reading/writing the tx pbuf memories.
   // There are two logical memories: a 48KB buffer memory and a 576B link memory. These
   // memories can be read at any time, including during normal operation, but must
   // written carefully or hardware operation will be corrupted. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_OFFSET_CSR {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 link_memory : 1;               // DWORD 0
               u32 addr : 14;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_OFFSET_CSR, *PTXPB_OFFSET_CSR;

      SG_C_ASSERT(__sizeof__TXPB_OFFSET_CSR, sizeof (TXPB_OFFSET_CSR) == 4);

   #else
      typedef struct _TXPB_OFFSET_CSR {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 link_memory : 1;                     // DWORD 0
         u32 addr : 14;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK TXPB_OFFSET_CSR, *PTXPB_OFFSET_CSR;

      typedef union _TXPB_OFFSET_CSR_UNION {
         TXPB_OFFSET_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXPB_OFFSET_CSR_UNION, *PTXPB_OFFSET_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXPB_OFFSET_CSR_UNION, sizeof (TXPB_OFFSET_CSR_UNION) == 4);
   #endif


#else
   // This register provides windowed access for reading/writing the tx pbuf memories.
   // There are two logical memories: a 48KB buffer memory and a 576B link memory. These
   // memories can be read at any time, including during normal operation, but must
   // written carefully or hardware operation will be corrupted. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_OFFSET_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 addr : 14;                     // DWORD 0
               u32 link_memory : 1;               // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_OFFSET_CSR, *PTXPB_OFFSET_CSR;

      SG_C_ASSERT(__sizeof__TXPB_OFFSET_CSR, sizeof (TXPB_OFFSET_CSR) == 4);

   #else
      typedef struct _TXPB_OFFSET_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 addr : 14;                           // DWORD 0
         u32 link_memory : 1;                     // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK TXPB_OFFSET_CSR, *PTXPB_OFFSET_CSR;

      typedef union _TXPB_OFFSET_CSR_UNION {
         TXPB_OFFSET_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXPB_OFFSET_CSR_UNION, *PTXPB_OFFSET_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXPB_OFFSET_CSR_UNION, sizeof (TXPB_OFFSET_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Buffer memory access: The 32-bit value written to this register is written to the
   // DWORD offset specified in the TXPB_OFFSET_CSR. The 32-bit value read from this
   // register is read from the DWORD offset specified in theTXPB_OFFSET_CSR. Link memory
   // access: The 24-bit value written to the lower bits of this register is written to
   // the entry specified in the TXPB_OFFSET_CSR. The 24-bit value read from the lower
   // bits of this register is read from the entry specified in the TXPB_OFFSET_CSR. The
   // read value of this register is undefined until the appropriate memory location is
   // initialized. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_VALUE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_VALUE_CSR, *PTXPB_VALUE_CSR;

      SG_C_ASSERT(__sizeof__TXPB_VALUE_CSR, sizeof (TXPB_VALUE_CSR) == 4);

   #else
      typedef struct _TXPB_VALUE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXPB_VALUE_CSR, *PTXPB_VALUE_CSR;

      typedef union _TXPB_VALUE_CSR_UNION {
         TXPB_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXPB_VALUE_CSR_UNION, *PTXPB_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXPB_VALUE_CSR_UNION, sizeof (TXPB_VALUE_CSR_UNION) == 4);
   #endif


#else
   // Buffer memory access: The 32-bit value written to this register is written to the
   // DWORD offset specified in the TXPB_OFFSET_CSR. The 32-bit value read from this
   // register is read from the DWORD offset specified in theTXPB_OFFSET_CSR. Link memory
   // access: The 24-bit value written to the lower bits of this register is written to
   // the entry specified in the TXPB_OFFSET_CSR. The 24-bit value read from the lower
   // bits of this register is read from the entry specified in the TXPB_OFFSET_CSR. The
   // read value of this register is undefined until the appropriate memory location is
   // initialized. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_VALUE_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_VALUE_CSR, *PTXPB_VALUE_CSR;

      SG_C_ASSERT(__sizeof__TXPB_VALUE_CSR, sizeof (TXPB_VALUE_CSR) == 4);

   #else
      typedef struct _TXPB_VALUE_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXPB_VALUE_CSR, *PTXPB_VALUE_CSR;

      typedef union _TXPB_VALUE_CSR_UNION {
         TXPB_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXPB_VALUE_CSR_UNION, *PTXPB_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXPB_VALUE_CSR_UNION, sizeof (TXPB_VALUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB Payload Buffers register. Used to allocate a number of TXPB buffers for packet
   // payloads."; 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_PAYLOAD_BUFS {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 payload_bufs : 8;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_PAYLOAD_BUFS, *PTXPB_PAYLOAD_BUFS;

      SG_C_ASSERT(__sizeof__TXPB_PAYLOAD_BUFS, sizeof (TXPB_PAYLOAD_BUFS) == 4);

   #else
      typedef struct _TXPB_PAYLOAD_BUFS {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 payload_bufs : 8;                    // DWORD 0
      } SG_PACK TXPB_PAYLOAD_BUFS, *PTXPB_PAYLOAD_BUFS;

      typedef union _TXPB_PAYLOAD_BUFS_UNION {
         TXPB_PAYLOAD_BUFS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_PAYLOAD_BUFS_UNION, *PTXPB_PAYLOAD_BUFS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_PAYLOAD_BUFS_UNION, sizeof (TXPB_PAYLOAD_BUFS_UNION) == 4);
   #endif


#else
   // TXPB Payload Buffers register. Used to allocate a number of TXPB buffers for packet
   // payloads."; 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_PAYLOAD_BUFS {
         union {
            struct { 
               u32 payload_bufs : 8;              // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_PAYLOAD_BUFS, *PTXPB_PAYLOAD_BUFS;

      SG_C_ASSERT(__sizeof__TXPB_PAYLOAD_BUFS, sizeof (TXPB_PAYLOAD_BUFS) == 4);

   #else
      typedef struct _TXPB_PAYLOAD_BUFS {
         u32 payload_bufs : 8;                    // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK TXPB_PAYLOAD_BUFS, *PTXPB_PAYLOAD_BUFS;

      typedef union _TXPB_PAYLOAD_BUFS_UNION {
         TXPB_PAYLOAD_BUFS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_PAYLOAD_BUFS_UNION, *PTXPB_PAYLOAD_BUFS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_PAYLOAD_BUFS_UNION, sizeof (TXPB_PAYLOAD_BUFS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB Buffers In-Use register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_BUFS_IN_USE {
         union {
            struct { 
               u32 rsvd0 : 14;                    // DWORD 0
               u32 pyld_bufs_in_use : 9;          // DWORD 0
               u32 total_bufs_in_use : 9;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_BUFS_IN_USE, *PTXPB_BUFS_IN_USE;

      SG_C_ASSERT(__sizeof__TXPB_BUFS_IN_USE, sizeof (TXPB_BUFS_IN_USE) == 4);

   #else
      typedef struct _TXPB_BUFS_IN_USE {
         u32 rsvd0 : 14;                          // DWORD 0
         u32 pyld_bufs_in_use : 9;                // DWORD 0
         u32 total_bufs_in_use : 9;               // DWORD 0
      } SG_PACK TXPB_BUFS_IN_USE, *PTXPB_BUFS_IN_USE;

      typedef union _TXPB_BUFS_IN_USE_UNION {
         TXPB_BUFS_IN_USE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_BUFS_IN_USE_UNION, *PTXPB_BUFS_IN_USE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_BUFS_IN_USE_UNION, sizeof (TXPB_BUFS_IN_USE_UNION) == 4);
   #endif


#else
   // TXPB Buffers In-Use register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_BUFS_IN_USE {
         union {
            struct { 
               u32 total_bufs_in_use : 9;         // DWORD 0
               u32 pyld_bufs_in_use : 9;          // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_BUFS_IN_USE, *PTXPB_BUFS_IN_USE;

      SG_C_ASSERT(__sizeof__TXPB_BUFS_IN_USE, sizeof (TXPB_BUFS_IN_USE) == 4);

   #else
      typedef struct _TXPB_BUFS_IN_USE {
         u32 total_bufs_in_use : 9;               // DWORD 0
         u32 pyld_bufs_in_use : 9;                // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
      } SG_PACK TXPB_BUFS_IN_USE, *PTXPB_BUFS_IN_USE;

      typedef union _TXPB_BUFS_IN_USE_UNION {
         TXPB_BUFS_IN_USE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_BUFS_IN_USE_UNION, *PTXPB_BUFS_IN_USE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_BUFS_IN_USE_UNION, sizeof (TXPB_BUFS_IN_USE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB Free buffer count. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_FREE_BUF_STATS {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 freelist_tail : 8;             // DWORD 0
               u32 freelist_head : 8;             // DWORD 0
               u32 freecount : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_FREE_BUF_STATS, *PTXPB_FREE_BUF_STATS;

      SG_C_ASSERT(__sizeof__TXPB_FREE_BUF_STATS, sizeof (TXPB_FREE_BUF_STATS) == 4);

   #else
      typedef struct _TXPB_FREE_BUF_STATS {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 freelist_tail : 8;                   // DWORD 0
         u32 freelist_head : 8;                   // DWORD 0
         u32 freecount : 8;                       // DWORD 0
      } SG_PACK TXPB_FREE_BUF_STATS, *PTXPB_FREE_BUF_STATS;

      typedef union _TXPB_FREE_BUF_STATS_UNION {
         TXPB_FREE_BUF_STATS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_FREE_BUF_STATS_UNION, *PTXPB_FREE_BUF_STATS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_FREE_BUF_STATS_UNION, sizeof (TXPB_FREE_BUF_STATS_UNION) == 4);
   #endif


#else
   // TXPB Free buffer count. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_FREE_BUF_STATS {
         union {
            struct { 
               u32 freecount : 8;                 // DWORD 0
               u32 freelist_head : 8;             // DWORD 0
               u32 freelist_tail : 8;             // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_FREE_BUF_STATS, *PTXPB_FREE_BUF_STATS;

      SG_C_ASSERT(__sizeof__TXPB_FREE_BUF_STATS, sizeof (TXPB_FREE_BUF_STATS) == 4);

   #else
      typedef struct _TXPB_FREE_BUF_STATS {
         u32 freecount : 8;                       // DWORD 0
         u32 freelist_head : 8;                   // DWORD 0
         u32 freelist_tail : 8;                   // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXPB_FREE_BUF_STATS, *PTXPB_FREE_BUF_STATS;

      typedef union _TXPB_FREE_BUF_STATS_UNION {
         TXPB_FREE_BUF_STATS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_FREE_BUF_STATS_UNION, *PTXPB_FREE_BUF_STATS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_FREE_BUF_STATS_UNION, sizeof (TXPB_FREE_BUF_STATS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB Hardware Debug Port client select. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_HWDBG_CLIENT_SELECT {
         union {
            struct { 
               u32 rsvd3 : 20;                    // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 ctrl_client : 3;               // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 dealloc_client : 2;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 alloc_client : 3;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_HWDBG_CLIENT_SELECT, *PTXPB_HWDBG_CLIENT_SELECT;

      SG_C_ASSERT(__sizeof__TXPB_HWDBG_CLIENT_SELECT, sizeof (TXPB_HWDBG_CLIENT_SELECT) == 4);

   #else
      typedef struct _TXPB_HWDBG_CLIENT_SELECT {
         u32 rsvd3 : 20;                          // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 ctrl_client : 3;                     // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 dealloc_client : 2;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 alloc_client : 3;                    // DWORD 0
      } SG_PACK TXPB_HWDBG_CLIENT_SELECT, *PTXPB_HWDBG_CLIENT_SELECT;

      typedef union _TXPB_HWDBG_CLIENT_SELECT_UNION {
         TXPB_HWDBG_CLIENT_SELECT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_HWDBG_CLIENT_SELECT_UNION, *PTXPB_HWDBG_CLIENT_SELECT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_HWDBG_CLIENT_SELECT_UNION, sizeof (TXPB_HWDBG_CLIENT_SELECT_UNION) == 4);
   #endif


#else
   // TXPB Hardware Debug Port client select. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_HWDBG_CLIENT_SELECT {
         union {
            struct { 
               u32 alloc_client : 3;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dealloc_client : 2;            // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 ctrl_client : 3;               // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd3 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_HWDBG_CLIENT_SELECT, *PTXPB_HWDBG_CLIENT_SELECT;

      SG_C_ASSERT(__sizeof__TXPB_HWDBG_CLIENT_SELECT, sizeof (TXPB_HWDBG_CLIENT_SELECT) == 4);

   #else
      typedef struct _TXPB_HWDBG_CLIENT_SELECT {
         u32 alloc_client : 3;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dealloc_client : 2;                  // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 ctrl_client : 3;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 20;                          // DWORD 0
      } SG_PACK TXPB_HWDBG_CLIENT_SELECT, *PTXPB_HWDBG_CLIENT_SELECT;

      typedef union _TXPB_HWDBG_CLIENT_SELECT_UNION {
         TXPB_HWDBG_CLIENT_SELECT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_HWDBG_CLIENT_SELECT_UNION, *PTXPB_HWDBG_CLIENT_SELECT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_HWDBG_CLIENT_SELECT_UNION, sizeof (TXPB_HWDBG_CLIENT_SELECT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_WR_CLIENT {
         union {
            struct { 
               u32 cmd_rd_addr : 18;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 write_client : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_WR_CLIENT, *PTXPB_UE_CTRL_WR_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CLIENT, sizeof (TXPB_UE_CTRL_WR_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_WR_CLIENT {
         u32 cmd_rd_addr : 18;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 write_client : 4;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_WR_CLIENT, *PTXPB_UE_CTRL_WR_CLIENT;

      typedef union _TXPB_UE_CTRL_WR_CLIENT_UNION {
         TXPB_UE_CTRL_WR_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_WR_CLIENT_UNION, *PTXPB_UE_CTRL_WR_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CLIENT_UNION, sizeof (TXPB_UE_CTRL_WR_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_WR_CLIENT {
         union {
            struct { 
               u32 write_client : 4;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 cmd_rd_addr : 18;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_WR_CLIENT, *PTXPB_UE_CTRL_WR_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CLIENT, sizeof (TXPB_UE_CTRL_WR_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_WR_CLIENT {
         u32 write_client : 4;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 cmd_rd_addr : 18;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_WR_CLIENT, *PTXPB_UE_CTRL_WR_CLIENT;

      typedef union _TXPB_UE_CTRL_WR_CLIENT_UNION {
         TXPB_UE_CTRL_WR_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_WR_CLIENT_UNION, *PTXPB_UE_CTRL_WR_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CLIENT_UNION, sizeof (TXPB_UE_CTRL_WR_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD0_CLIENT {
         union {
            struct { 
               u32 cmd_rd_addr : 18;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 read0_client : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD0_CLIENT, *PTXPB_UE_CTRL_RD0_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CLIENT, sizeof (TXPB_UE_CTRL_RD0_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD0_CLIENT {
         u32 cmd_rd_addr : 18;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 read0_client : 4;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD0_CLIENT, *PTXPB_UE_CTRL_RD0_CLIENT;

      typedef union _TXPB_UE_CTRL_RD0_CLIENT_UNION {
         TXPB_UE_CTRL_RD0_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD0_CLIENT_UNION, *PTXPB_UE_CTRL_RD0_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD0_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD0_CLIENT {
         union {
            struct { 
               u32 read0_client : 4;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 cmd_rd_addr : 18;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD0_CLIENT, *PTXPB_UE_CTRL_RD0_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CLIENT, sizeof (TXPB_UE_CTRL_RD0_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD0_CLIENT {
         u32 read0_client : 4;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 cmd_rd_addr : 18;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD0_CLIENT, *PTXPB_UE_CTRL_RD0_CLIENT;

      typedef union _TXPB_UE_CTRL_RD0_CLIENT_UNION {
         TXPB_UE_CTRL_RD0_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD0_CLIENT_UNION, *PTXPB_UE_CTRL_RD0_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD0_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD1_CLIENT {
         union {
            struct { 
               u32 cmd_rd_addr : 18;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 read1_client : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD1_CLIENT, *PTXPB_UE_CTRL_RD1_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CLIENT, sizeof (TXPB_UE_CTRL_RD1_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD1_CLIENT {
         u32 cmd_rd_addr : 18;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 read1_client : 4;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD1_CLIENT, *PTXPB_UE_CTRL_RD1_CLIENT;

      typedef union _TXPB_UE_CTRL_RD1_CLIENT_UNION {
         TXPB_UE_CTRL_RD1_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD1_CLIENT_UNION, *PTXPB_UE_CTRL_RD1_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD1_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD1_CLIENT {
         union {
            struct { 
               u32 read1_client : 4;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 cmd_rd_addr : 18;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD1_CLIENT, *PTXPB_UE_CTRL_RD1_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CLIENT, sizeof (TXPB_UE_CTRL_RD1_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD1_CLIENT {
         u32 read1_client : 4;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 cmd_rd_addr : 18;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD1_CLIENT, *PTXPB_UE_CTRL_RD1_CLIENT;

      typedef union _TXPB_UE_CTRL_RD1_CLIENT_UNION {
         TXPB_UE_CTRL_RD1_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD1_CLIENT_UNION, *PTXPB_UE_CTRL_RD1_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD1_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_WR_CMD_CLIENT {
         union {
            struct { 
               u32 cmd_rd_addr : 18;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 write_cmd_client : 4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_WR_CMD_CLIENT, *PTXPB_UE_CTRL_WR_CMD_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CMD_CLIENT, sizeof (TXPB_UE_CTRL_WR_CMD_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_WR_CMD_CLIENT {
         u32 cmd_rd_addr : 18;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 write_cmd_client : 4;                // DWORD 0
      } SG_PACK TXPB_UE_CTRL_WR_CMD_CLIENT, *PTXPB_UE_CTRL_WR_CMD_CLIENT;

      typedef union _TXPB_UE_CTRL_WR_CMD_CLIENT_UNION {
         TXPB_UE_CTRL_WR_CMD_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_WR_CMD_CLIENT_UNION, *PTXPB_UE_CTRL_WR_CMD_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CMD_CLIENT_UNION, sizeof (TXPB_UE_CTRL_WR_CMD_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_WR_CMD_CLIENT {
         union {
            struct { 
               u32 write_cmd_client : 4;          // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 cmd_rd_addr : 18;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_WR_CMD_CLIENT, *PTXPB_UE_CTRL_WR_CMD_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CMD_CLIENT, sizeof (TXPB_UE_CTRL_WR_CMD_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_WR_CMD_CLIENT {
         u32 write_cmd_client : 4;                // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 cmd_rd_addr : 18;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_WR_CMD_CLIENT, *PTXPB_UE_CTRL_WR_CMD_CLIENT;

      typedef union _TXPB_UE_CTRL_WR_CMD_CLIENT_UNION {
         TXPB_UE_CTRL_WR_CMD_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_WR_CMD_CLIENT_UNION, *PTXPB_UE_CTRL_WR_CMD_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_WR_CMD_CLIENT_UNION, sizeof (TXPB_UE_CTRL_WR_CMD_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD0_CMD_CLIENT {
         union {
            struct { 
               u32 cmd_rd_addr : 18;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 read0_cmd_client : 4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD0_CMD_CLIENT, *PTXPB_UE_CTRL_RD0_CMD_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CMD_CLIENT, sizeof (TXPB_UE_CTRL_RD0_CMD_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD0_CMD_CLIENT {
         u32 cmd_rd_addr : 18;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 read0_cmd_client : 4;                // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD0_CMD_CLIENT, *PTXPB_UE_CTRL_RD0_CMD_CLIENT;

      typedef union _TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION {
         TXPB_UE_CTRL_RD0_CMD_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION, *PTXPB_UE_CTRL_RD0_CMD_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD0_CMD_CLIENT {
         union {
            struct { 
               u32 read0_cmd_client : 4;          // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 cmd_rd_addr : 18;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD0_CMD_CLIENT, *PTXPB_UE_CTRL_RD0_CMD_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CMD_CLIENT, sizeof (TXPB_UE_CTRL_RD0_CMD_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD0_CMD_CLIENT {
         u32 read0_cmd_client : 4;                // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 cmd_rd_addr : 18;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD0_CMD_CLIENT, *PTXPB_UE_CTRL_RD0_CMD_CLIENT;

      typedef union _TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION {
         TXPB_UE_CTRL_RD0_CMD_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION, *PTXPB_UE_CTRL_RD0_CMD_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD0_CMD_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD1_CMD_CLIENT {
         union {
            struct { 
               u32 cmd_rd_addr : 18;              // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 read1_cmd_client : 4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD1_CMD_CLIENT, *PTXPB_UE_CTRL_RD1_CMD_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CMD_CLIENT, sizeof (TXPB_UE_CTRL_RD1_CMD_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD1_CMD_CLIENT {
         u32 cmd_rd_addr : 18;                    // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 read1_cmd_client : 4;                // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD1_CMD_CLIENT, *PTXPB_UE_CTRL_RD1_CMD_CLIENT;

      typedef union _TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION {
         TXPB_UE_CTRL_RD1_CMD_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION, *PTXPB_UE_CTRL_RD1_CMD_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE Ctrl Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CTRL_RD1_CMD_CLIENT {
         union {
            struct { 
               u32 read1_cmd_client : 4;          // DWORD 0
               u32 cmd_rd_len : 10;               // DWORD 0
               u32 cmd_rd_addr : 18;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CTRL_RD1_CMD_CLIENT, *PTXPB_UE_CTRL_RD1_CMD_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CMD_CLIENT, sizeof (TXPB_UE_CTRL_RD1_CMD_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_CTRL_RD1_CMD_CLIENT {
         u32 read1_cmd_client : 4;                // DWORD 0
         u32 cmd_rd_len : 10;                     // DWORD 0
         u32 cmd_rd_addr : 18;                    // DWORD 0
      } SG_PACK TXPB_UE_CTRL_RD1_CMD_CLIENT, *PTXPB_UE_CTRL_RD1_CMD_CLIENT;

      typedef union _TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION {
         TXPB_UE_CTRL_RD1_CMD_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION, *PTXPB_UE_CTRL_RD1_CMD_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION, sizeof (TXPB_UE_CTRL_RD1_CMD_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE BMEM simultaneous access. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_BMEM_SIMUL_ACCESS {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 wr_addr : 12;                  // DWORD 0
               u32 rd_addr : 12;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_BMEM_SIMUL_ACCESS, *PTXPB_UE_BMEM_SIMUL_ACCESS;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_SIMUL_ACCESS, sizeof (TXPB_UE_BMEM_SIMUL_ACCESS) == 4);

   #else
      typedef struct _TXPB_UE_BMEM_SIMUL_ACCESS {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 wr_addr : 12;                        // DWORD 0
         u32 rd_addr : 12;                        // DWORD 0
      } SG_PACK TXPB_UE_BMEM_SIMUL_ACCESS, *PTXPB_UE_BMEM_SIMUL_ACCESS;

      typedef union _TXPB_UE_BMEM_SIMUL_ACCESS_UNION {
         TXPB_UE_BMEM_SIMUL_ACCESS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_BMEM_SIMUL_ACCESS_UNION, *PTXPB_UE_BMEM_SIMUL_ACCESS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_SIMUL_ACCESS_UNION, sizeof (TXPB_UE_BMEM_SIMUL_ACCESS_UNION) == 4);
   #endif


#else
   // TXPB UE BMEM simultaneous access. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_BMEM_SIMUL_ACCESS {
         union {
            struct { 
               u32 rd_addr : 12;                  // DWORD 0
               u32 wr_addr : 12;                  // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_BMEM_SIMUL_ACCESS, *PTXPB_UE_BMEM_SIMUL_ACCESS;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_SIMUL_ACCESS, sizeof (TXPB_UE_BMEM_SIMUL_ACCESS) == 4);

   #else
      typedef struct _TXPB_UE_BMEM_SIMUL_ACCESS {
         u32 rd_addr : 12;                        // DWORD 0
         u32 wr_addr : 12;                        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXPB_UE_BMEM_SIMUL_ACCESS, *PTXPB_UE_BMEM_SIMUL_ACCESS;

      typedef union _TXPB_UE_BMEM_SIMUL_ACCESS_UNION {
         TXPB_UE_BMEM_SIMUL_ACCESS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_BMEM_SIMUL_ACCESS_UNION, *PTXPB_UE_BMEM_SIMUL_ACCESS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_SIMUL_ACCESS_UNION, sizeof (TXPB_UE_BMEM_SIMUL_ACCESS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE BMEM simultaneous access. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_LMEM_SIMUL_ACCESS {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 wr_addr : 8;                   // DWORD 0
               u32 rd_addr : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_LMEM_SIMUL_ACCESS, *PTXPB_UE_LMEM_SIMUL_ACCESS;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_SIMUL_ACCESS, sizeof (TXPB_UE_LMEM_SIMUL_ACCESS) == 4);

   #else
      typedef struct _TXPB_UE_LMEM_SIMUL_ACCESS {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 wr_addr : 8;                         // DWORD 0
         u32 rd_addr : 8;                         // DWORD 0
      } SG_PACK TXPB_UE_LMEM_SIMUL_ACCESS, *PTXPB_UE_LMEM_SIMUL_ACCESS;

      typedef union _TXPB_UE_LMEM_SIMUL_ACCESS_UNION {
         TXPB_UE_LMEM_SIMUL_ACCESS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_LMEM_SIMUL_ACCESS_UNION, *PTXPB_UE_LMEM_SIMUL_ACCESS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_SIMUL_ACCESS_UNION, sizeof (TXPB_UE_LMEM_SIMUL_ACCESS_UNION) == 4);
   #endif


#else
   // TXPB UE BMEM simultaneous access. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_LMEM_SIMUL_ACCESS {
         union {
            struct { 
               u32 rd_addr : 8;                   // DWORD 0
               u32 wr_addr : 8;                   // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_LMEM_SIMUL_ACCESS, *PTXPB_UE_LMEM_SIMUL_ACCESS;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_SIMUL_ACCESS, sizeof (TXPB_UE_LMEM_SIMUL_ACCESS) == 4);

   #else
      typedef struct _TXPB_UE_LMEM_SIMUL_ACCESS {
         u32 rd_addr : 8;                         // DWORD 0
         u32 wr_addr : 8;                         // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK TXPB_UE_LMEM_SIMUL_ACCESS, *PTXPB_UE_LMEM_SIMUL_ACCESS;

      typedef union _TXPB_UE_LMEM_SIMUL_ACCESS_UNION {
         TXPB_UE_LMEM_SIMUL_ACCESS bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_LMEM_SIMUL_ACCESS_UNION, *PTXPB_UE_LMEM_SIMUL_ACCESS_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_SIMUL_ACCESS_UNION, sizeof (TXPB_UE_LMEM_SIMUL_ACCESS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE MMU Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_MMU_CLIENT {
         union {
            struct { 
               u32 rsvd0 : 25;                    // DWORD 0
               u32 dealloc : 1;                   // DWORD 0
               u32 alloc : 1;                     // DWORD 0
               u32 dealloc_client : 2;            // DWORD 0
               u32 alloc_client : 3;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_MMU_CLIENT, *PTXPB_UE_MMU_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_MMU_CLIENT, sizeof (TXPB_UE_MMU_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_MMU_CLIENT {
         u32 rsvd0 : 25;                          // DWORD 0
         u32 dealloc : 1;                         // DWORD 0
         u32 alloc : 1;                           // DWORD 0
         u32 dealloc_client : 2;                  // DWORD 0
         u32 alloc_client : 3;                    // DWORD 0
      } SG_PACK TXPB_UE_MMU_CLIENT, *PTXPB_UE_MMU_CLIENT;

      typedef union _TXPB_UE_MMU_CLIENT_UNION {
         TXPB_UE_MMU_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_MMU_CLIENT_UNION, *PTXPB_UE_MMU_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_MMU_CLIENT_UNION, sizeof (TXPB_UE_MMU_CLIENT_UNION) == 4);
   #endif


#else
   // TXPB UE MMU Client. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_MMU_CLIENT {
         union {
            struct { 
               u32 alloc_client : 3;              // DWORD 0
               u32 dealloc_client : 2;            // DWORD 0
               u32 alloc : 1;                     // DWORD 0
               u32 dealloc : 1;                   // DWORD 0
               u32 rsvd0 : 25;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_MMU_CLIENT, *PTXPB_UE_MMU_CLIENT;

      SG_C_ASSERT(__sizeof__TXPB_UE_MMU_CLIENT, sizeof (TXPB_UE_MMU_CLIENT) == 4);

   #else
      typedef struct _TXPB_UE_MMU_CLIENT {
         u32 alloc_client : 3;                    // DWORD 0
         u32 dealloc_client : 2;                  // DWORD 0
         u32 alloc : 1;                           // DWORD 0
         u32 dealloc : 1;                         // DWORD 0
         u32 rsvd0 : 25;                          // DWORD 0
      } SG_PACK TXPB_UE_MMU_CLIENT, *PTXPB_UE_MMU_CLIENT;

      typedef union _TXPB_UE_MMU_CLIENT_UNION {
         TXPB_UE_MMU_CLIENT bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_MMU_CLIENT_UNION, *PTXPB_UE_MMU_CLIENT_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_MMU_CLIENT_UNION, sizeof (TXPB_UE_MMU_CLIENT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Cause. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_BMEM_CAUSE {
         union {
            struct { 
               u32 bmem_parity_error : 1;         // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 ctl_wr : 1;                    // DWORD 0
               u32 ctl_waddr : 12;                // DWORD 0
               u32 ctl_raddr : 12;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_BMEM_CAUSE, *PTXPB_UE_BMEM_CAUSE;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_CAUSE, sizeof (TXPB_UE_BMEM_CAUSE) == 4);

   #else
      typedef struct _TXPB_UE_BMEM_CAUSE {
         u32 bmem_parity_error : 1;               // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 ctl_wr : 1;                          // DWORD 0
         u32 ctl_waddr : 12;                      // DWORD 0
         u32 ctl_raddr : 12;                      // DWORD 0
      } SG_PACK TXPB_UE_BMEM_CAUSE, *PTXPB_UE_BMEM_CAUSE;

      typedef union _TXPB_UE_BMEM_CAUSE_UNION {
         TXPB_UE_BMEM_CAUSE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_BMEM_CAUSE_UNION, *PTXPB_UE_BMEM_CAUSE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_CAUSE_UNION, sizeof (TXPB_UE_BMEM_CAUSE_UNION) == 4);
   #endif


#else
   // TXPB UE Cause. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_BMEM_CAUSE {
         union {
            struct { 
               u32 ctl_raddr : 12;                // DWORD 0
               u32 ctl_waddr : 12;                // DWORD 0
               u32 ctl_wr : 1;                    // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 bmem_parity_error : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_BMEM_CAUSE, *PTXPB_UE_BMEM_CAUSE;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_CAUSE, sizeof (TXPB_UE_BMEM_CAUSE) == 4);

   #else
      typedef struct _TXPB_UE_BMEM_CAUSE {
         u32 ctl_raddr : 12;                      // DWORD 0
         u32 ctl_waddr : 12;                      // DWORD 0
         u32 ctl_wr : 1;                          // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 bmem_parity_error : 1;               // DWORD 0
      } SG_PACK TXPB_UE_BMEM_CAUSE, *PTXPB_UE_BMEM_CAUSE;

      typedef union _TXPB_UE_BMEM_CAUSE_UNION {
         TXPB_UE_BMEM_CAUSE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_BMEM_CAUSE_UNION, *PTXPB_UE_BMEM_CAUSE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_BMEM_CAUSE_UNION, sizeof (TXPB_UE_BMEM_CAUSE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Cause. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_LMEM_CAUSE {
         union {
            struct { 
               u32 lmem_parity_error : 1;         // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 error_write_addr : 8;          // DWORD 0
               u32 error_aport : 1;               // DWORD 0
               u32 error_addr : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_LMEM_CAUSE, *PTXPB_UE_LMEM_CAUSE;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_CAUSE, sizeof (TXPB_UE_LMEM_CAUSE) == 4);

   #else
      typedef struct _TXPB_UE_LMEM_CAUSE {
         u32 lmem_parity_error : 1;               // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 error_write_addr : 8;                // DWORD 0
         u32 error_aport : 1;                     // DWORD 0
         u32 error_addr : 8;                      // DWORD 0
      } SG_PACK TXPB_UE_LMEM_CAUSE, *PTXPB_UE_LMEM_CAUSE;

      typedef union _TXPB_UE_LMEM_CAUSE_UNION {
         TXPB_UE_LMEM_CAUSE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_LMEM_CAUSE_UNION, *PTXPB_UE_LMEM_CAUSE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_CAUSE_UNION, sizeof (TXPB_UE_LMEM_CAUSE_UNION) == 4);
   #endif


#else
   // TXPB UE Cause. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_LMEM_CAUSE {
         union {
            struct { 
               u32 error_addr : 8;                // DWORD 0
               u32 error_aport : 1;               // DWORD 0
               u32 error_write_addr : 8;          // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 rsvd0 : 13;                    // DWORD 0
               u32 lmem_parity_error : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_LMEM_CAUSE, *PTXPB_UE_LMEM_CAUSE;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_CAUSE, sizeof (TXPB_UE_LMEM_CAUSE) == 4);

   #else
      typedef struct _TXPB_UE_LMEM_CAUSE {
         u32 error_addr : 8;                      // DWORD 0
         u32 error_aport : 1;                     // DWORD 0
         u32 error_write_addr : 8;                // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 rsvd0 : 13;                          // DWORD 0
         u32 lmem_parity_error : 1;               // DWORD 0
      } SG_PACK TXPB_UE_LMEM_CAUSE, *PTXPB_UE_LMEM_CAUSE;

      typedef union _TXPB_UE_LMEM_CAUSE_UNION {
         TXPB_UE_LMEM_CAUSE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_LMEM_CAUSE_UNION, *PTXPB_UE_LMEM_CAUSE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_LMEM_CAUSE_UNION, sizeof (TXPB_UE_LMEM_CAUSE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE overflow status register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_OFLOW {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 rd1_fifo_oflow : 1;            // DWORD 0
               u32 rd0_fifo_oflow : 1;            // DWORD 0
               u32 wr_fifo_oflow : 1;             // DWORD 0
               u32 csr_req_fifo_oflow : 1;        // DWORD 0
               u32 wdma_req_fifo_oflow : 1;       // DWORD 0
               u32 mpu_req_fifo_oflow : 1;        // DWORD 0
               u32 ndma_req_fifo_oflow : 1;       // DWORD 0
               u32 tpre_req_fifo_oflow : 1;       // DWORD 0
               u32 txp2_req_fifo_oflow : 1;       // DWORD 0
               u32 txp_req_fifo_oflow : 1;        // DWORD 0
               u32 tpost_req_fifo_oflow : 1;      // DWORD 0
               u32 txulp1_req_fifo_oflow : 1;     // DWORD 0
               u32 txulp0_req_fifo_oflow : 1;     // DWORD 0
               u32 etx_req_fifo_oflow : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_OFLOW, *PTXPB_UE_OFLOW;

      SG_C_ASSERT(__sizeof__TXPB_UE_OFLOW, sizeof (TXPB_UE_OFLOW) == 4);

   #else
      typedef struct _TXPB_UE_OFLOW {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 rd1_fifo_oflow : 1;                  // DWORD 0
         u32 rd0_fifo_oflow : 1;                  // DWORD 0
         u32 wr_fifo_oflow : 1;                   // DWORD 0
         u32 csr_req_fifo_oflow : 1;              // DWORD 0
         u32 wdma_req_fifo_oflow : 1;             // DWORD 0
         u32 mpu_req_fifo_oflow : 1;              // DWORD 0
         u32 ndma_req_fifo_oflow : 1;             // DWORD 0
         u32 tpre_req_fifo_oflow : 1;             // DWORD 0
         u32 txp2_req_fifo_oflow : 1;             // DWORD 0
         u32 txp_req_fifo_oflow : 1;              // DWORD 0
         u32 tpost_req_fifo_oflow : 1;            // DWORD 0
         u32 txulp1_req_fifo_oflow : 1;           // DWORD 0
         u32 txulp0_req_fifo_oflow : 1;           // DWORD 0
         u32 etx_req_fifo_oflow : 1;              // DWORD 0
      } SG_PACK TXPB_UE_OFLOW, *PTXPB_UE_OFLOW;

      typedef union _TXPB_UE_OFLOW_UNION {
         TXPB_UE_OFLOW bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_OFLOW_UNION, *PTXPB_UE_OFLOW_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_OFLOW_UNION, sizeof (TXPB_UE_OFLOW_UNION) == 4);
   #endif


#else
   // TXPB UE overflow status register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_OFLOW {
         union {
            struct { 
               u32 etx_req_fifo_oflow : 1;        // DWORD 0
               u32 txulp0_req_fifo_oflow : 1;     // DWORD 0
               u32 txulp1_req_fifo_oflow : 1;     // DWORD 0
               u32 tpost_req_fifo_oflow : 1;      // DWORD 0
               u32 txp_req_fifo_oflow : 1;        // DWORD 0
               u32 txp2_req_fifo_oflow : 1;       // DWORD 0
               u32 tpre_req_fifo_oflow : 1;       // DWORD 0
               u32 ndma_req_fifo_oflow : 1;       // DWORD 0
               u32 mpu_req_fifo_oflow : 1;        // DWORD 0
               u32 wdma_req_fifo_oflow : 1;       // DWORD 0
               u32 csr_req_fifo_oflow : 1;        // DWORD 0
               u32 wr_fifo_oflow : 1;             // DWORD 0
               u32 rd0_fifo_oflow : 1;            // DWORD 0
               u32 rd1_fifo_oflow : 1;            // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_OFLOW, *PTXPB_UE_OFLOW;

      SG_C_ASSERT(__sizeof__TXPB_UE_OFLOW, sizeof (TXPB_UE_OFLOW) == 4);

   #else
      typedef struct _TXPB_UE_OFLOW {
         u32 etx_req_fifo_oflow : 1;              // DWORD 0
         u32 txulp0_req_fifo_oflow : 1;           // DWORD 0
         u32 txulp1_req_fifo_oflow : 1;           // DWORD 0
         u32 tpost_req_fifo_oflow : 1;            // DWORD 0
         u32 txp_req_fifo_oflow : 1;              // DWORD 0
         u32 txp2_req_fifo_oflow : 1;             // DWORD 0
         u32 tpre_req_fifo_oflow : 1;             // DWORD 0
         u32 ndma_req_fifo_oflow : 1;             // DWORD 0
         u32 mpu_req_fifo_oflow : 1;              // DWORD 0
         u32 wdma_req_fifo_oflow : 1;             // DWORD 0
         u32 csr_req_fifo_oflow : 1;              // DWORD 0
         u32 wr_fifo_oflow : 1;                   // DWORD 0
         u32 rd0_fifo_oflow : 1;                  // DWORD 0
         u32 rd1_fifo_oflow : 1;                  // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK TXPB_UE_OFLOW, *PTXPB_UE_OFLOW;

      typedef union _TXPB_UE_OFLOW_UNION {
         TXPB_UE_OFLOW bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_OFLOW_UNION, *PTXPB_UE_OFLOW_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_OFLOW_UNION, sizeof (TXPB_UE_OFLOW_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE overflow status register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_UFLOW {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 rd1_fifo_uflow : 1;            // DWORD 0
               u32 rd0_fifo_uflow : 1;            // DWORD 0
               u32 wr_fifo_uflow : 1;             // DWORD 0
               u32 csr_req_fifo_uflow : 1;        // DWORD 0
               u32 wdma_req_fifo_uflow : 1;       // DWORD 0
               u32 mpu_req_fifo_uflow : 1;        // DWORD 0
               u32 ndma_req_fifo_uflow : 1;       // DWORD 0
               u32 tpre_req_fifo_uflow : 1;       // DWORD 0
               u32 txp2_req_fifo_uflow : 1;       // DWORD 0
               u32 txp_req_fifo_uflow : 1;        // DWORD 0
               u32 tpost_req_fifo_uflow : 1;      // DWORD 0
               u32 txulp1_req_fifo_uflow : 1;     // DWORD 0
               u32 txulp0_req_fifo_uflow : 1;     // DWORD 0
               u32 etx_req_fifo_uflow : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_UFLOW, *PTXPB_UE_UFLOW;

      SG_C_ASSERT(__sizeof__TXPB_UE_UFLOW, sizeof (TXPB_UE_UFLOW) == 4);

   #else
      typedef struct _TXPB_UE_UFLOW {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 rd1_fifo_uflow : 1;                  // DWORD 0
         u32 rd0_fifo_uflow : 1;                  // DWORD 0
         u32 wr_fifo_uflow : 1;                   // DWORD 0
         u32 csr_req_fifo_uflow : 1;              // DWORD 0
         u32 wdma_req_fifo_uflow : 1;             // DWORD 0
         u32 mpu_req_fifo_uflow : 1;              // DWORD 0
         u32 ndma_req_fifo_uflow : 1;             // DWORD 0
         u32 tpre_req_fifo_uflow : 1;             // DWORD 0
         u32 txp2_req_fifo_uflow : 1;             // DWORD 0
         u32 txp_req_fifo_uflow : 1;              // DWORD 0
         u32 tpost_req_fifo_uflow : 1;            // DWORD 0
         u32 txulp1_req_fifo_uflow : 1;           // DWORD 0
         u32 txulp0_req_fifo_uflow : 1;           // DWORD 0
         u32 etx_req_fifo_uflow : 1;              // DWORD 0
      } SG_PACK TXPB_UE_UFLOW, *PTXPB_UE_UFLOW;

      typedef union _TXPB_UE_UFLOW_UNION {
         TXPB_UE_UFLOW bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_UFLOW_UNION, *PTXPB_UE_UFLOW_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_UFLOW_UNION, sizeof (TXPB_UE_UFLOW_UNION) == 4);
   #endif


#else
   // TXPB UE overflow status register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_UFLOW {
         union {
            struct { 
               u32 etx_req_fifo_uflow : 1;        // DWORD 0
               u32 txulp0_req_fifo_uflow : 1;     // DWORD 0
               u32 txulp1_req_fifo_uflow : 1;     // DWORD 0
               u32 tpost_req_fifo_uflow : 1;      // DWORD 0
               u32 txp_req_fifo_uflow : 1;        // DWORD 0
               u32 txp2_req_fifo_uflow : 1;       // DWORD 0
               u32 tpre_req_fifo_uflow : 1;       // DWORD 0
               u32 ndma_req_fifo_uflow : 1;       // DWORD 0
               u32 mpu_req_fifo_uflow : 1;        // DWORD 0
               u32 wdma_req_fifo_uflow : 1;       // DWORD 0
               u32 csr_req_fifo_uflow : 1;        // DWORD 0
               u32 wr_fifo_uflow : 1;             // DWORD 0
               u32 rd0_fifo_uflow : 1;            // DWORD 0
               u32 rd1_fifo_uflow : 1;            // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_UFLOW, *PTXPB_UE_UFLOW;

      SG_C_ASSERT(__sizeof__TXPB_UE_UFLOW, sizeof (TXPB_UE_UFLOW) == 4);

   #else
      typedef struct _TXPB_UE_UFLOW {
         u32 etx_req_fifo_uflow : 1;              // DWORD 0
         u32 txulp0_req_fifo_uflow : 1;           // DWORD 0
         u32 txulp1_req_fifo_uflow : 1;           // DWORD 0
         u32 tpost_req_fifo_uflow : 1;            // DWORD 0
         u32 txp_req_fifo_uflow : 1;              // DWORD 0
         u32 txp2_req_fifo_uflow : 1;             // DWORD 0
         u32 tpre_req_fifo_uflow : 1;             // DWORD 0
         u32 ndma_req_fifo_uflow : 1;             // DWORD 0
         u32 mpu_req_fifo_uflow : 1;              // DWORD 0
         u32 wdma_req_fifo_uflow : 1;             // DWORD 0
         u32 csr_req_fifo_uflow : 1;              // DWORD 0
         u32 wr_fifo_uflow : 1;                   // DWORD 0
         u32 rd0_fifo_uflow : 1;                  // DWORD 0
         u32 rd1_fifo_uflow : 1;                  // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK TXPB_UE_UFLOW, *PTXPB_UE_UFLOW;

      typedef union _TXPB_UE_UFLOW_UNION {
         TXPB_UE_UFLOW bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_UFLOW_UNION, *PTXPB_UE_UFLOW_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_UFLOW_UNION, sizeof (TXPB_UE_UFLOW_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Cause register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CAUSE {
         union {
            struct { 
               u32 read1_unalloc_buf_ue : 1;      // DWORD 0
               u32 read0_unalloc_buf_ue : 1;      // DWORD 0
               u32 write_unalloc_buf_ue : 1;      // DWORD 0
               u32 zero_byte_allocation_ue : 1;   // DWORD 0
               u32 parityerr_wdma_ue : 1;         // DWORD 0
               u32 parityerr_txulp1_ue : 1;       // DWORD 0
               u32 parityerr_txulp0_ue : 1;       // DWORD 0
               u32 parityerr_txp_ue : 1;          // DWORD 0
               u32 parityerr_txp2_ue : 1;         // DWORD 0
               u32 parityerr_tpost_ue : 1;        // DWORD 0
               u32 parityerr_ndma_ue : 1;         // DWORD 0
               u32 parityerr_mpu_ue : 1;          // DWORD 0
               u32 mmu_dealloc_FF : 1;            // DWORD 0
               u32 rd1_buf_id_FF : 1;             // DWORD 0
               u32 rd0_buf_id_FF : 1;             // DWORD 0
               u32 wr_buf_id_FF : 1;              // DWORD 0
               u32 rd1_cmd_buf_id_FF : 1;         // DWORD 0
               u32 rd0_cmd_buf_id_FF : 1;         // DWORD 0
               u32 wr_cmd_buf_id_FF : 1;          // DWORD 0
               u32 mmu_pyld_limit_exceeded : 1;   // DWORD 0
               u32 mmu_descr_limit_exceeded : 1;  // DWORD 0
               u32 fifo_overflows : 1;            // DWORD 0
               u32 fifo_underflows : 1;           // DWORD 0
               u32 lmem_simultaneous_access : 1;  // DWORD 0
               u32 bmem_simultaneous_access : 1;  // DWORD 0
               u32 mmu_alloc_FF : 1;              // DWORD 0
               u32 mmu_counts_mismatch : 1;       // DWORD 0
               u32 lmem_perr : 1;                 // DWORD 0
               u32 bmem_perr : 1;                 // DWORD 0
               u32 over_write : 1;                // DWORD 0
               u32 over_read0 : 1;                // DWORD 0
               u32 over_read1 : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CAUSE, *PTXPB_UE_CAUSE;

      SG_C_ASSERT(__sizeof__TXPB_UE_CAUSE, sizeof (TXPB_UE_CAUSE) == 4);

   #else
      typedef struct _TXPB_UE_CAUSE {
         u32 read1_unalloc_buf_ue : 1;            // DWORD 0
         u32 read0_unalloc_buf_ue : 1;            // DWORD 0
         u32 write_unalloc_buf_ue : 1;            // DWORD 0
         u32 zero_byte_allocation_ue : 1;         // DWORD 0
         u32 parityerr_wdma_ue : 1;               // DWORD 0
         u32 parityerr_txulp1_ue : 1;             // DWORD 0
         u32 parityerr_txulp0_ue : 1;             // DWORD 0
         u32 parityerr_txp_ue : 1;                // DWORD 0
         u32 parityerr_txp2_ue : 1;               // DWORD 0
         u32 parityerr_tpost_ue : 1;              // DWORD 0
         u32 parityerr_ndma_ue : 1;               // DWORD 0
         u32 parityerr_mpu_ue : 1;                // DWORD 0
         u32 mmu_dealloc_FF : 1;                  // DWORD 0
         u32 rd1_buf_id_FF : 1;                   // DWORD 0
         u32 rd0_buf_id_FF : 1;                   // DWORD 0
         u32 wr_buf_id_FF : 1;                    // DWORD 0
         u32 rd1_cmd_buf_id_FF : 1;               // DWORD 0
         u32 rd0_cmd_buf_id_FF : 1;               // DWORD 0
         u32 wr_cmd_buf_id_FF : 1;                // DWORD 0
         u32 mmu_pyld_limit_exceeded : 1;         // DWORD 0
         u32 mmu_descr_limit_exceeded : 1;        // DWORD 0
         u32 fifo_overflows : 1;                  // DWORD 0
         u32 fifo_underflows : 1;                 // DWORD 0
         u32 lmem_simultaneous_access : 1;        // DWORD 0
         u32 bmem_simultaneous_access : 1;        // DWORD 0
         u32 mmu_alloc_FF : 1;                    // DWORD 0
         u32 mmu_counts_mismatch : 1;             // DWORD 0
         u32 lmem_perr : 1;                       // DWORD 0
         u32 bmem_perr : 1;                       // DWORD 0
         u32 over_write : 1;                      // DWORD 0
         u32 over_read0 : 1;                      // DWORD 0
         u32 over_read1 : 1;                      // DWORD 0
      } SG_PACK TXPB_UE_CAUSE, *PTXPB_UE_CAUSE;

      typedef union _TXPB_UE_CAUSE_UNION {
         TXPB_UE_CAUSE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CAUSE_UNION, *PTXPB_UE_CAUSE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CAUSE_UNION, sizeof (TXPB_UE_CAUSE_UNION) == 4);
   #endif


#else
   // TXPB UE Cause register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_CAUSE {
         union {
            struct { 
               u32 over_read1 : 1;                // DWORD 0
               u32 over_read0 : 1;                // DWORD 0
               u32 over_write : 1;                // DWORD 0
               u32 bmem_perr : 1;                 // DWORD 0
               u32 lmem_perr : 1;                 // DWORD 0
               u32 mmu_counts_mismatch : 1;       // DWORD 0
               u32 mmu_alloc_FF : 1;              // DWORD 0
               u32 bmem_simultaneous_access : 1;  // DWORD 0
               u32 lmem_simultaneous_access : 1;  // DWORD 0
               u32 fifo_underflows : 1;           // DWORD 0
               u32 fifo_overflows : 1;            // DWORD 0
               u32 mmu_descr_limit_exceeded : 1;  // DWORD 0
               u32 mmu_pyld_limit_exceeded : 1;   // DWORD 0
               u32 wr_cmd_buf_id_FF : 1;          // DWORD 0
               u32 rd0_cmd_buf_id_FF : 1;         // DWORD 0
               u32 rd1_cmd_buf_id_FF : 1;         // DWORD 0
               u32 wr_buf_id_FF : 1;              // DWORD 0
               u32 rd0_buf_id_FF : 1;             // DWORD 0
               u32 rd1_buf_id_FF : 1;             // DWORD 0
               u32 mmu_dealloc_FF : 1;            // DWORD 0
               u32 parityerr_mpu_ue : 1;          // DWORD 0
               u32 parityerr_ndma_ue : 1;         // DWORD 0
               u32 parityerr_tpost_ue : 1;        // DWORD 0
               u32 parityerr_txp2_ue : 1;         // DWORD 0
               u32 parityerr_txp_ue : 1;          // DWORD 0
               u32 parityerr_txulp0_ue : 1;       // DWORD 0
               u32 parityerr_txulp1_ue : 1;       // DWORD 0
               u32 parityerr_wdma_ue : 1;         // DWORD 0
               u32 zero_byte_allocation_ue : 1;   // DWORD 0
               u32 write_unalloc_buf_ue : 1;      // DWORD 0
               u32 read0_unalloc_buf_ue : 1;      // DWORD 0
               u32 read1_unalloc_buf_ue : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_CAUSE, *PTXPB_UE_CAUSE;

      SG_C_ASSERT(__sizeof__TXPB_UE_CAUSE, sizeof (TXPB_UE_CAUSE) == 4);

   #else
      typedef struct _TXPB_UE_CAUSE {
         u32 over_read1 : 1;                      // DWORD 0
         u32 over_read0 : 1;                      // DWORD 0
         u32 over_write : 1;                      // DWORD 0
         u32 bmem_perr : 1;                       // DWORD 0
         u32 lmem_perr : 1;                       // DWORD 0
         u32 mmu_counts_mismatch : 1;             // DWORD 0
         u32 mmu_alloc_FF : 1;                    // DWORD 0
         u32 bmem_simultaneous_access : 1;        // DWORD 0
         u32 lmem_simultaneous_access : 1;        // DWORD 0
         u32 fifo_underflows : 1;                 // DWORD 0
         u32 fifo_overflows : 1;                  // DWORD 0
         u32 mmu_descr_limit_exceeded : 1;        // DWORD 0
         u32 mmu_pyld_limit_exceeded : 1;         // DWORD 0
         u32 wr_cmd_buf_id_FF : 1;                // DWORD 0
         u32 rd0_cmd_buf_id_FF : 1;               // DWORD 0
         u32 rd1_cmd_buf_id_FF : 1;               // DWORD 0
         u32 wr_buf_id_FF : 1;                    // DWORD 0
         u32 rd0_buf_id_FF : 1;                   // DWORD 0
         u32 rd1_buf_id_FF : 1;                   // DWORD 0
         u32 mmu_dealloc_FF : 1;                  // DWORD 0
         u32 parityerr_mpu_ue : 1;                // DWORD 0
         u32 parityerr_ndma_ue : 1;               // DWORD 0
         u32 parityerr_tpost_ue : 1;              // DWORD 0
         u32 parityerr_txp2_ue : 1;               // DWORD 0
         u32 parityerr_txp_ue : 1;                // DWORD 0
         u32 parityerr_txulp0_ue : 1;             // DWORD 0
         u32 parityerr_txulp1_ue : 1;             // DWORD 0
         u32 parityerr_wdma_ue : 1;               // DWORD 0
         u32 zero_byte_allocation_ue : 1;         // DWORD 0
         u32 write_unalloc_buf_ue : 1;            // DWORD 0
         u32 read0_unalloc_buf_ue : 1;            // DWORD 0
         u32 read1_unalloc_buf_ue : 1;            // DWORD 0
      } SG_PACK TXPB_UE_CAUSE, *PTXPB_UE_CAUSE;

      typedef union _TXPB_UE_CAUSE_UNION {
         TXPB_UE_CAUSE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_CAUSE_UNION, *PTXPB_UE_CAUSE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_CAUSE_UNION, sizeof (TXPB_UE_CAUSE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXPB UE Cause register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_ENABLE {
         union {
            struct { 
               u32 read1_unalloc_buf_ue_enable : 1; // DWORD 0
               u32 read0_unalloc_buf_ue_enable : 1; // DWORD 0
               u32 write_unalloc_buf_ue_enable : 1; // DWORD 0
               u32 zero_byte_allocation_ue_enable : 1; // DWORD 0
               u32 parityerr_wdma_ue_enable : 1;  // DWORD 0
               u32 parityerr_txulp1_ue_enable : 1; // DWORD 0
               u32 parityerr_txulp0_ue_enable : 1; // DWORD 0
               u32 parityerr_txp_ue_enable : 1;   // DWORD 0
               u32 parityerr_txp2_ue_enable : 1;  // DWORD 0
               u32 parityerr_tpost_ue_enable : 1; // DWORD 0
               u32 parityerr_ndma_ue_enable : 1;  // DWORD 0
               u32 parityerr_mpu_ue_enable : 1;   // DWORD 0
               u32 mmu_dealloc_FF_ue_enable : 1;  // DWORD 0
               u32 rd1_buf_id_FF_ue_enable : 1;   // DWORD 0
               u32 rd0_buf_id_FF_ue_enable : 1;   // DWORD 0
               u32 wr_buf_id_FF_ue_enable : 1;    // DWORD 0
               u32 rd1_cmd_buf_id_FF_ue_enable : 1; // DWORD 0
               u32 rd0_cmd_buf_id_FF_ue_enable : 1; // DWORD 0
               u32 wr_cmd_buf_id_FF_ue_enable : 1; // DWORD 0
               u32 mmu_pyld_limit_exceeded_ue_enable : 1; // DWORD 0
               u32 mmu_descr_limit_exceeded_ue_enable : 1; // DWORD 0
               u32 fifo_uflow_ue_enable : 1;      // DWORD 0
               u32 fifo_oflow_ue_enable : 1;      // DWORD 0
               u32 lmem_simultaneous_access_enable : 1; // DWORD 0
               u32 bmem_simultaneous_access_enable : 1; // DWORD 0
               u32 mmu_alloc_FF_enable : 1;       // DWORD 0
               u32 mmu_counts_mismatch_enable : 1; // DWORD 0
               u32 lmem_perr_enable : 1;          // DWORD 0
               u32 bmem_perr_enable : 1;          // DWORD 0
               u32 over_write_enable : 1;         // DWORD 0
               u32 over_read0_enable : 1;         // DWORD 0
               u32 over_read1_enable : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_ENABLE, *PTXPB_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXPB_UE_ENABLE, sizeof (TXPB_UE_ENABLE) == 4);

   #else
      typedef struct _TXPB_UE_ENABLE {
         u32 read1_unalloc_buf_ue_enable : 1;     // DWORD 0
         u32 read0_unalloc_buf_ue_enable : 1;     // DWORD 0
         u32 write_unalloc_buf_ue_enable : 1;     // DWORD 0
         u32 zero_byte_allocation_ue_enable : 1;  // DWORD 0
         u32 parityerr_wdma_ue_enable : 1;        // DWORD 0
         u32 parityerr_txulp1_ue_enable : 1;      // DWORD 0
         u32 parityerr_txulp0_ue_enable : 1;      // DWORD 0
         u32 parityerr_txp_ue_enable : 1;         // DWORD 0
         u32 parityerr_txp2_ue_enable : 1;        // DWORD 0
         u32 parityerr_tpost_ue_enable : 1;       // DWORD 0
         u32 parityerr_ndma_ue_enable : 1;        // DWORD 0
         u32 parityerr_mpu_ue_enable : 1;         // DWORD 0
         u32 mmu_dealloc_FF_ue_enable : 1;        // DWORD 0
         u32 rd1_buf_id_FF_ue_enable : 1;         // DWORD 0
         u32 rd0_buf_id_FF_ue_enable : 1;         // DWORD 0
         u32 wr_buf_id_FF_ue_enable : 1;          // DWORD 0
         u32 rd1_cmd_buf_id_FF_ue_enable : 1;     // DWORD 0
         u32 rd0_cmd_buf_id_FF_ue_enable : 1;     // DWORD 0
         u32 wr_cmd_buf_id_FF_ue_enable : 1;      // DWORD 0
         u32 mmu_pyld_limit_exceeded_ue_enable : 1; // DWORD 0
         u32 mmu_descr_limit_exceeded_ue_enable : 1; // DWORD 0
         u32 fifo_uflow_ue_enable : 1;            // DWORD 0
         u32 fifo_oflow_ue_enable : 1;            // DWORD 0
         u32 lmem_simultaneous_access_enable : 1; // DWORD 0
         u32 bmem_simultaneous_access_enable : 1; // DWORD 0
         u32 mmu_alloc_FF_enable : 1;             // DWORD 0
         u32 mmu_counts_mismatch_enable : 1;      // DWORD 0
         u32 lmem_perr_enable : 1;                // DWORD 0
         u32 bmem_perr_enable : 1;                // DWORD 0
         u32 over_write_enable : 1;               // DWORD 0
         u32 over_read0_enable : 1;               // DWORD 0
         u32 over_read1_enable : 1;               // DWORD 0
      } SG_PACK TXPB_UE_ENABLE, *PTXPB_UE_ENABLE;

      typedef union _TXPB_UE_ENABLE_UNION {
         TXPB_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_ENABLE_UNION, *PTXPB_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_ENABLE_UNION, sizeof (TXPB_UE_ENABLE_UNION) == 4);
   #endif


#else
   // TXPB UE Cause register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_UE_ENABLE {
         union {
            struct { 
               u32 over_read1_enable : 1;         // DWORD 0
               u32 over_read0_enable : 1;         // DWORD 0
               u32 over_write_enable : 1;         // DWORD 0
               u32 bmem_perr_enable : 1;          // DWORD 0
               u32 lmem_perr_enable : 1;          // DWORD 0
               u32 mmu_counts_mismatch_enable : 1; // DWORD 0
               u32 mmu_alloc_FF_enable : 1;       // DWORD 0
               u32 bmem_simultaneous_access_enable : 1; // DWORD 0
               u32 lmem_simultaneous_access_enable : 1; // DWORD 0
               u32 fifo_oflow_ue_enable : 1;      // DWORD 0
               u32 fifo_uflow_ue_enable : 1;      // DWORD 0
               u32 mmu_descr_limit_exceeded_ue_enable : 1; // DWORD 0
               u32 mmu_pyld_limit_exceeded_ue_enable : 1; // DWORD 0
               u32 wr_cmd_buf_id_FF_ue_enable : 1; // DWORD 0
               u32 rd0_cmd_buf_id_FF_ue_enable : 1; // DWORD 0
               u32 rd1_cmd_buf_id_FF_ue_enable : 1; // DWORD 0
               u32 wr_buf_id_FF_ue_enable : 1;    // DWORD 0
               u32 rd0_buf_id_FF_ue_enable : 1;   // DWORD 0
               u32 rd1_buf_id_FF_ue_enable : 1;   // DWORD 0
               u32 mmu_dealloc_FF_ue_enable : 1;  // DWORD 0
               u32 parityerr_mpu_ue_enable : 1;   // DWORD 0
               u32 parityerr_ndma_ue_enable : 1;  // DWORD 0
               u32 parityerr_tpost_ue_enable : 1; // DWORD 0
               u32 parityerr_txp2_ue_enable : 1;  // DWORD 0
               u32 parityerr_txp_ue_enable : 1;   // DWORD 0
               u32 parityerr_txulp0_ue_enable : 1; // DWORD 0
               u32 parityerr_txulp1_ue_enable : 1; // DWORD 0
               u32 parityerr_wdma_ue_enable : 1;  // DWORD 0
               u32 zero_byte_allocation_ue_enable : 1; // DWORD 0
               u32 write_unalloc_buf_ue_enable : 1; // DWORD 0
               u32 read0_unalloc_buf_ue_enable : 1; // DWORD 0
               u32 read1_unalloc_buf_ue_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXPB_UE_ENABLE, *PTXPB_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXPB_UE_ENABLE, sizeof (TXPB_UE_ENABLE) == 4);

   #else
      typedef struct _TXPB_UE_ENABLE {
         u32 over_read1_enable : 1;               // DWORD 0
         u32 over_read0_enable : 1;               // DWORD 0
         u32 over_write_enable : 1;               // DWORD 0
         u32 bmem_perr_enable : 1;                // DWORD 0
         u32 lmem_perr_enable : 1;                // DWORD 0
         u32 mmu_counts_mismatch_enable : 1;      // DWORD 0
         u32 mmu_alloc_FF_enable : 1;             // DWORD 0
         u32 bmem_simultaneous_access_enable : 1; // DWORD 0
         u32 lmem_simultaneous_access_enable : 1; // DWORD 0
         u32 fifo_oflow_ue_enable : 1;            // DWORD 0
         u32 fifo_uflow_ue_enable : 1;            // DWORD 0
         u32 mmu_descr_limit_exceeded_ue_enable : 1; // DWORD 0
         u32 mmu_pyld_limit_exceeded_ue_enable : 1; // DWORD 0
         u32 wr_cmd_buf_id_FF_ue_enable : 1;      // DWORD 0
         u32 rd0_cmd_buf_id_FF_ue_enable : 1;     // DWORD 0
         u32 rd1_cmd_buf_id_FF_ue_enable : 1;     // DWORD 0
         u32 wr_buf_id_FF_ue_enable : 1;          // DWORD 0
         u32 rd0_buf_id_FF_ue_enable : 1;         // DWORD 0
         u32 rd1_buf_id_FF_ue_enable : 1;         // DWORD 0
         u32 mmu_dealloc_FF_ue_enable : 1;        // DWORD 0
         u32 parityerr_mpu_ue_enable : 1;         // DWORD 0
         u32 parityerr_ndma_ue_enable : 1;        // DWORD 0
         u32 parityerr_tpost_ue_enable : 1;       // DWORD 0
         u32 parityerr_txp2_ue_enable : 1;        // DWORD 0
         u32 parityerr_txp_ue_enable : 1;         // DWORD 0
         u32 parityerr_txulp0_ue_enable : 1;      // DWORD 0
         u32 parityerr_txulp1_ue_enable : 1;      // DWORD 0
         u32 parityerr_wdma_ue_enable : 1;        // DWORD 0
         u32 zero_byte_allocation_ue_enable : 1;  // DWORD 0
         u32 write_unalloc_buf_ue_enable : 1;     // DWORD 0
         u32 read0_unalloc_buf_ue_enable : 1;     // DWORD 0
         u32 read1_unalloc_buf_ue_enable : 1;     // DWORD 0
      } SG_PACK TXPB_UE_ENABLE, *PTXPB_UE_ENABLE;

      typedef union _TXPB_UE_ENABLE_UNION {
         TXPB_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXPB_UE_ENABLE_UNION, *PTXPB_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXPB_UE_ENABLE_UNION, sizeof (TXPB_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These registers provide access to TX Packet Buffers, as well as basic statistical
   // information. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_CSRMAP {
         union {
            struct { 
               TXPB_CONTROL_CSR control;
               TXPB_OFFSET_CSR offset;
               TXPB_VALUE_CSR value;
               TXPB_PAYLOAD_BUFS payload_bufs;
               TXPB_BUFS_IN_USE bufs_in_use;
               TXPB_FREE_BUF_STATS free_bufs_stats;
               TXPB_HWDBG_CLIENT_SELECT hwdbg_client_select;
               TXPB_UE_CTRL_WR_CLIENT ue_ctl_wr_client;
               TXPB_UE_CTRL_RD0_CLIENT ue_ctl_rd0_client;
               TXPB_UE_CTRL_RD1_CLIENT ue_ctl_rd1_client;
               TXPB_UE_CTRL_WR_CMD_CLIENT ue_ctl_wr_cmd_client;
               TXPB_UE_CTRL_RD0_CMD_CLIENT ue_ctl_rd0_cmd_client;
               TXPB_UE_CTRL_RD1_CMD_CLIENT ue_ctl_rd1_cmd_client;
               TXPB_UE_BMEM_SIMUL_ACCESS ue_bmem_simul_access;
               TXPB_UE_LMEM_SIMUL_ACCESS ue_lmem_simul_access;
               TXPB_UE_MMU_CLIENT ue_mmu_client;
               TXPB_UE_BMEM_CAUSE ue_bmem_cause;
               TXPB_UE_LMEM_CAUSE ue_lmem_cause;
               TXPB_UE_OFLOW ue_oflow;
               TXPB_UE_UFLOW ue_uflow;
               TXPB_UE_CAUSE ue_cause;
               TXPB_UE_ENABLE ue_enable;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[231];                    // DWORDS 25 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TXPB_CSRMAP, *PTXPB_CSRMAP;

      SG_C_ASSERT(__sizeof__TXPB_CSRMAP, sizeof (TXPB_CSRMAP) == 1024);

   #else
      typedef struct _TXPB_CSRMAP {
         TXPB_CONTROL_CSR control;
         TXPB_OFFSET_CSR offset;
         TXPB_VALUE_CSR value;
         TXPB_PAYLOAD_BUFS payload_bufs;
         TXPB_BUFS_IN_USE bufs_in_use;
         TXPB_FREE_BUF_STATS free_bufs_stats;
         TXPB_HWDBG_CLIENT_SELECT hwdbg_client_select;
         TXPB_UE_CTRL_WR_CLIENT ue_ctl_wr_client;
         TXPB_UE_CTRL_RD0_CLIENT ue_ctl_rd0_client;
         TXPB_UE_CTRL_RD1_CLIENT ue_ctl_rd1_client;
         TXPB_UE_CTRL_WR_CMD_CLIENT ue_ctl_wr_cmd_client;
         TXPB_UE_CTRL_RD0_CMD_CLIENT ue_ctl_rd0_cmd_client;
         TXPB_UE_CTRL_RD1_CMD_CLIENT ue_ctl_rd1_cmd_client;
         TXPB_UE_BMEM_SIMUL_ACCESS ue_bmem_simul_access;
         TXPB_UE_LMEM_SIMUL_ACCESS ue_lmem_simul_access;
         TXPB_UE_MMU_CLIENT ue_mmu_client;
         TXPB_UE_BMEM_CAUSE ue_bmem_cause;
         TXPB_UE_LMEM_CAUSE ue_lmem_cause;
         TXPB_UE_OFLOW ue_oflow;
         TXPB_UE_UFLOW ue_uflow;
         TXPB_UE_CAUSE ue_cause;
         TXPB_UE_ENABLE ue_enable;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[231];                          // DWORDS 25 to 255
      } SG_PACK TXPB_CSRMAP, *PTXPB_CSRMAP;

      typedef union _TXPB_CSRMAP_UNION {
         TXPB_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TXPB_CSRMAP_UNION, *PTXPB_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TXPB_CSRMAP_UNION, sizeof (TXPB_CSRMAP_UNION) == 1024);
   #endif


#else
   // These registers provide access to TX Packet Buffers, as well as basic statistical
   // information. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXPB_CSRMAP {
         union {
            struct { 
               TXPB_CONTROL_CSR control;
               TXPB_OFFSET_CSR offset;
               TXPB_VALUE_CSR value;
               TXPB_PAYLOAD_BUFS payload_bufs;
               TXPB_BUFS_IN_USE bufs_in_use;
               TXPB_FREE_BUF_STATS free_bufs_stats;
               TXPB_HWDBG_CLIENT_SELECT hwdbg_client_select;
               TXPB_UE_CTRL_WR_CLIENT ue_ctl_wr_client;
               TXPB_UE_CTRL_RD0_CLIENT ue_ctl_rd0_client;
               TXPB_UE_CTRL_RD1_CLIENT ue_ctl_rd1_client;
               TXPB_UE_CTRL_WR_CMD_CLIENT ue_ctl_wr_cmd_client;
               TXPB_UE_CTRL_RD0_CMD_CLIENT ue_ctl_rd0_cmd_client;
               TXPB_UE_CTRL_RD1_CMD_CLIENT ue_ctl_rd1_cmd_client;
               TXPB_UE_BMEM_SIMUL_ACCESS ue_bmem_simul_access;
               TXPB_UE_LMEM_SIMUL_ACCESS ue_lmem_simul_access;
               TXPB_UE_MMU_CLIENT ue_mmu_client;
               TXPB_UE_BMEM_CAUSE ue_bmem_cause;
               TXPB_UE_LMEM_CAUSE ue_lmem_cause;
               TXPB_UE_OFLOW ue_oflow;
               TXPB_UE_UFLOW ue_uflow;
               TXPB_UE_CAUSE ue_cause;
               TXPB_UE_ENABLE ue_enable;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[231];                    // DWORDS 25 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TXPB_CSRMAP, *PTXPB_CSRMAP;

      SG_C_ASSERT(__sizeof__TXPB_CSRMAP, sizeof (TXPB_CSRMAP) == 1024);

   #else
      typedef struct _TXPB_CSRMAP {
         TXPB_CONTROL_CSR control;
         TXPB_OFFSET_CSR offset;
         TXPB_VALUE_CSR value;
         TXPB_PAYLOAD_BUFS payload_bufs;
         TXPB_BUFS_IN_USE bufs_in_use;
         TXPB_FREE_BUF_STATS free_bufs_stats;
         TXPB_HWDBG_CLIENT_SELECT hwdbg_client_select;
         TXPB_UE_CTRL_WR_CLIENT ue_ctl_wr_client;
         TXPB_UE_CTRL_RD0_CLIENT ue_ctl_rd0_client;
         TXPB_UE_CTRL_RD1_CLIENT ue_ctl_rd1_client;
         TXPB_UE_CTRL_WR_CMD_CLIENT ue_ctl_wr_cmd_client;
         TXPB_UE_CTRL_RD0_CMD_CLIENT ue_ctl_rd0_cmd_client;
         TXPB_UE_CTRL_RD1_CMD_CLIENT ue_ctl_rd1_cmd_client;
         TXPB_UE_BMEM_SIMUL_ACCESS ue_bmem_simul_access;
         TXPB_UE_LMEM_SIMUL_ACCESS ue_lmem_simul_access;
         TXPB_UE_MMU_CLIENT ue_mmu_client;
         TXPB_UE_BMEM_CAUSE ue_bmem_cause;
         TXPB_UE_LMEM_CAUSE ue_lmem_cause;
         TXPB_UE_OFLOW ue_oflow;
         TXPB_UE_UFLOW ue_uflow;
         TXPB_UE_CAUSE ue_cause;
         TXPB_UE_ENABLE ue_enable;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[231];                          // DWORDS 25 to 255
      } SG_PACK TXPB_CSRMAP, *PTXPB_CSRMAP;

      typedef union _TXPB_CSRMAP_UNION {
         TXPB_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TXPB_CSRMAP_UNION, *PTXPB_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TXPB_CSRMAP_UNION, sizeof (TXPB_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __txpb_bmap_h__

