/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __wdma_bmap_h__
#define __wdma_bmap_h__
#include "setypes.h"
#include "pq_bmap.h"
#include "hwdbg_reg_bmap.h"
#include "reg_enums_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Client Weighted Arbitration Control 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_WRR0_ENTRY_CSR {
         union {
            struct { 
               u32 rsvd3 : 2;                     // DWORD 0
               u32 uc_wt : 6;                     // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 rxulp2_wt : 6;                 // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rxulp1_wt : 6;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 rxulp0_wt : 6;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_WRR0_ENTRY_CSR, *PWDMA_WRR0_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__WDMA_WRR0_ENTRY_CSR, sizeof (WDMA_WRR0_ENTRY_CSR) == 4);

   #else
      typedef struct _WDMA_WRR0_ENTRY_CSR {
         u32 rsvd3 : 2;                           // DWORD 0
         u32 uc_wt : 6;                           // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 rxulp2_wt : 6;                       // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rxulp1_wt : 6;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 rxulp0_wt : 6;                       // DWORD 0
      } SG_PACK WDMA_WRR0_ENTRY_CSR, *PWDMA_WRR0_ENTRY_CSR;

      typedef union _WDMA_WRR0_ENTRY_CSR_UNION {
         WDMA_WRR0_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_WRR0_ENTRY_CSR_UNION, *PWDMA_WRR0_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_WRR0_ENTRY_CSR_UNION, sizeof (WDMA_WRR0_ENTRY_CSR_UNION) == 4);
   #endif


#else
   // Client Weighted Arbitration Control 0 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_WRR0_ENTRY_CSR {
         union {
            struct { 
               u32 rxulp0_wt : 6;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 rxulp1_wt : 6;                 // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rxulp2_wt : 6;                 // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 uc_wt : 6;                     // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_WRR0_ENTRY_CSR, *PWDMA_WRR0_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__WDMA_WRR0_ENTRY_CSR, sizeof (WDMA_WRR0_ENTRY_CSR) == 4);

   #else
      typedef struct _WDMA_WRR0_ENTRY_CSR {
         u32 rxulp0_wt : 6;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 rxulp1_wt : 6;                       // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rxulp2_wt : 6;                       // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 uc_wt : 6;                           // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
      } SG_PACK WDMA_WRR0_ENTRY_CSR, *PWDMA_WRR0_ENTRY_CSR;

      typedef union _WDMA_WRR0_ENTRY_CSR_UNION {
         WDMA_WRR0_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_WRR0_ENTRY_CSR_UNION, *PWDMA_WRR0_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_WRR0_ENTRY_CSR_UNION, sizeof (WDMA_WRR0_ENTRY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Client Weighted Arbitration Control 1 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_WRR1_ENTRY_CSR {
         union {
            struct { 
               u32 rsvd3 : 2;                     // DWORD 0
               u32 cev_wt : 6;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 mpu_wt : 6;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 tpost_wt : 6;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 erx_wt : 6;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_WRR1_ENTRY_CSR, *PWDMA_WRR1_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__WDMA_WRR1_ENTRY_CSR, sizeof (WDMA_WRR1_ENTRY_CSR) == 4);

   #else
      typedef struct _WDMA_WRR1_ENTRY_CSR {
         u32 rsvd3 : 2;                           // DWORD 0
         u32 cev_wt : 6;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 mpu_wt : 6;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 tpost_wt : 6;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 erx_wt : 6;                          // DWORD 0
      } SG_PACK WDMA_WRR1_ENTRY_CSR, *PWDMA_WRR1_ENTRY_CSR;

      typedef union _WDMA_WRR1_ENTRY_CSR_UNION {
         WDMA_WRR1_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_WRR1_ENTRY_CSR_UNION, *PWDMA_WRR1_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_WRR1_ENTRY_CSR_UNION, sizeof (WDMA_WRR1_ENTRY_CSR_UNION) == 4);
   #endif


#else
   // Client Weighted Arbitration Control 1 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_WRR1_ENTRY_CSR {
         union {
            struct { 
               u32 erx_wt : 6;                    // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tpost_wt : 6;                  // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 mpu_wt : 6;                    // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 cev_wt : 6;                    // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_WRR1_ENTRY_CSR, *PWDMA_WRR1_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__WDMA_WRR1_ENTRY_CSR, sizeof (WDMA_WRR1_ENTRY_CSR) == 4);

   #else
      typedef struct _WDMA_WRR1_ENTRY_CSR {
         u32 erx_wt : 6;                          // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tpost_wt : 6;                        // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 mpu_wt : 6;                          // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 cev_wt : 6;                          // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
      } SG_PACK WDMA_WRR1_ENTRY_CSR, *PWDMA_WRR1_ENTRY_CSR;

      typedef union _WDMA_WRR1_ENTRY_CSR_UNION {
         WDMA_WRR1_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_WRR1_ENTRY_CSR_UNION, *PWDMA_WRR1_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_WRR1_ENTRY_CSR_UNION, sizeof (WDMA_WRR1_ENTRY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Stall Arc Identifier Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_MODE_ENTRY_CSR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 stallarc : 4;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_MODE_ENTRY_CSR, *PWDMA_MODE_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__WDMA_MODE_ENTRY_CSR, sizeof (WDMA_MODE_ENTRY_CSR) == 4);

   #else
      typedef struct _WDMA_MODE_ENTRY_CSR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 stallarc : 4;                        // DWORD 0
      } SG_PACK WDMA_MODE_ENTRY_CSR, *PWDMA_MODE_ENTRY_CSR;

      typedef union _WDMA_MODE_ENTRY_CSR_UNION {
         WDMA_MODE_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_MODE_ENTRY_CSR_UNION, *PWDMA_MODE_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_MODE_ENTRY_CSR_UNION, sizeof (WDMA_MODE_ENTRY_CSR_UNION) == 4);
   #endif


#else
   // Stall Arc Identifier Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_MODE_ENTRY_CSR {
         union {
            struct { 
               u32 stallarc : 4;                  // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_MODE_ENTRY_CSR, *PWDMA_MODE_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__WDMA_MODE_ENTRY_CSR, sizeof (WDMA_MODE_ENTRY_CSR) == 4);

   #else
      typedef struct _WDMA_MODE_ENTRY_CSR {
         u32 stallarc : 4;                        // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK WDMA_MODE_ENTRY_CSR, *PWDMA_MODE_ENTRY_CSR;

      typedef union _WDMA_MODE_ENTRY_CSR_UNION {
         WDMA_MODE_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_MODE_ENTRY_CSR_UNION, *PWDMA_MODE_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_MODE_ENTRY_CSR_UNION, sizeof (WDMA_MODE_ENTRY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CTRL_CSR {
         union {
            struct { 
               u32 rsvd0 : 25;                    // DWORD 0
               u32 stall_on_error : 1;            // DWORD 0
               u32 auto_inc : 1;                  // DWORD 0
               u32 dbug_sel : 5;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CTRL_CSR, *PWDMA_CTRL_CSR;

      SG_C_ASSERT(__sizeof__WDMA_CTRL_CSR, sizeof (WDMA_CTRL_CSR) == 4);

   #else
      typedef struct _WDMA_CTRL_CSR {
         u32 rsvd0 : 25;                          // DWORD 0
         u32 stall_on_error : 1;                  // DWORD 0
         u32 auto_inc : 1;                        // DWORD 0
         u32 dbug_sel : 5;                        // DWORD 0
      } SG_PACK WDMA_CTRL_CSR, *PWDMA_CTRL_CSR;

      typedef union _WDMA_CTRL_CSR_UNION {
         WDMA_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_CTRL_CSR_UNION, *PWDMA_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CTRL_CSR_UNION, sizeof (WDMA_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CTRL_CSR {
         union {
            struct { 
               u32 dbug_sel : 5;                  // DWORD 0
               u32 auto_inc : 1;                  // DWORD 0
               u32 stall_on_error : 1;            // DWORD 0
               u32 rsvd0 : 25;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CTRL_CSR, *PWDMA_CTRL_CSR;

      SG_C_ASSERT(__sizeof__WDMA_CTRL_CSR, sizeof (WDMA_CTRL_CSR) == 4);

   #else
      typedef struct _WDMA_CTRL_CSR {
         u32 dbug_sel : 5;                        // DWORD 0
         u32 auto_inc : 1;                        // DWORD 0
         u32 stall_on_error : 1;                  // DWORD 0
         u32 rsvd0 : 25;                          // DWORD 0
      } SG_PACK WDMA_CTRL_CSR, *PWDMA_CTRL_CSR;

      typedef union _WDMA_CTRL_CSR_UNION {
         WDMA_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_CTRL_CSR_UNION, *PWDMA_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CTRL_CSR_UNION, sizeof (WDMA_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Status Register
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_STS_CSR {
         union {
            struct { 
               u32 status;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_STS_CSR, *PWDMA_STS_CSR;

      SG_C_ASSERT(__sizeof__WDMA_STS_CSR, sizeof (WDMA_STS_CSR) == 4);

   #else
      typedef struct _WDMA_STS_CSR {
         u32 status;                              // DWORD 0
      } SG_PACK WDMA_STS_CSR, *PWDMA_STS_CSR;

      typedef union _WDMA_STS_CSR_UNION {
         WDMA_STS_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_STS_CSR_UNION, *PWDMA_STS_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_STS_CSR_UNION, sizeof (WDMA_STS_CSR_UNION) == 4);
   #endif


#else
   // Status Register
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_STS_CSR {
         union {
            struct { 
               u32 status;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_STS_CSR, *PWDMA_STS_CSR;

      SG_C_ASSERT(__sizeof__WDMA_STS_CSR, sizeof (WDMA_STS_CSR) == 4);

   #else
      typedef struct _WDMA_STS_CSR {
         u32 status;                              // DWORD 0
      } SG_PACK WDMA_STS_CSR, *PWDMA_STS_CSR;

      typedef union _WDMA_STS_CSR_UNION {
         WDMA_STS_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_STS_CSR_UNION, *PWDMA_STS_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_STS_CSR_UNION, sizeof (WDMA_STS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // UC Release Request Vector Register. When a client has WDMA issue a Release request
   // to UC at the end of a data transfer, the control DWORD portion of the UC_REQ_D
   // descriptor sent to UC is given by the content of this CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_UC_RELEASE_CSR {
         union {
            struct { 
               u32 rsvd0 : 17;                    // DWORD 0
               u32 pci_func : 1;                  // DWORD 0
               u32 cqe : 1;                       // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 req_opcode : 3;                // DWORD 0
               u32 drop : 1;                      // DWORD 0
               u32 req_type : 1;                  // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 p : 1;                         // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 stall : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_UC_RELEASE_CSR, *PWDMA_UC_RELEASE_CSR;

      SG_C_ASSERT(__sizeof__WDMA_UC_RELEASE_CSR, sizeof (WDMA_UC_RELEASE_CSR) == 4);

   #else
      typedef struct _WDMA_UC_RELEASE_CSR {
         u32 rsvd0 : 17;                          // DWORD 0
         u32 pci_func : 1;                        // DWORD 0
         u32 cqe : 1;                             // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 req_opcode : 3;                      // DWORD 0
         u32 drop : 1;                            // DWORD 0
         u32 req_type : 1;                        // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 p : 1;                               // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 stall : 1;                           // DWORD 0
      } SG_PACK WDMA_UC_RELEASE_CSR, *PWDMA_UC_RELEASE_CSR;

      typedef union _WDMA_UC_RELEASE_CSR_UNION {
         WDMA_UC_RELEASE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_UC_RELEASE_CSR_UNION, *PWDMA_UC_RELEASE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_UC_RELEASE_CSR_UNION, sizeof (WDMA_UC_RELEASE_CSR_UNION) == 4);
   #endif


#else
   // UC Release Request Vector Register. When a client has WDMA issue a Release request
   // to UC at the end of a data transfer, the control DWORD portion of the UC_REQ_D
   // descriptor sent to UC is given by the content of this CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_UC_RELEASE_CSR {
         union {
            struct { 
               u32 stall : 1;                     // DWORD 0
               u32 discard : 1;                   // DWORD 0
               u32 empty : 1;                     // DWORD 0
               u32 i : 1;                         // DWORD 0
               u32 p : 1;                         // DWORD 0
               u32 vl : 2;                        // DWORD 0
               u32 req_type : 1;                  // DWORD 0
               u32 drop : 1;                      // DWORD 0
               u32 req_opcode : 3;                // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 cqe : 1;                       // DWORD 0
               u32 pci_func : 1;                  // DWORD 0
               u32 rsvd0 : 17;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_UC_RELEASE_CSR, *PWDMA_UC_RELEASE_CSR;

      SG_C_ASSERT(__sizeof__WDMA_UC_RELEASE_CSR, sizeof (WDMA_UC_RELEASE_CSR) == 4);

   #else
      typedef struct _WDMA_UC_RELEASE_CSR {
         u32 stall : 1;                           // DWORD 0
         u32 discard : 1;                         // DWORD 0
         u32 empty : 1;                           // DWORD 0
         u32 i : 1;                               // DWORD 0
         u32 p : 1;                               // DWORD 0
         u32 vl : 2;                              // DWORD 0
         u32 req_type : 1;                        // DWORD 0
         u32 drop : 1;                            // DWORD 0
         u32 req_opcode : 3;                      // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 cqe : 1;                             // DWORD 0
         u32 pci_func : 1;                        // DWORD 0
         u32 rsvd0 : 17;                          // DWORD 0
      } SG_PACK WDMA_UC_RELEASE_CSR, *PWDMA_UC_RELEASE_CSR;

      typedef union _WDMA_UC_RELEASE_CSR_UNION {
         WDMA_UC_RELEASE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_UC_RELEASE_CSR_UNION, *PWDMA_UC_RELEASE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_UC_RELEASE_CSR_UNION, sizeof (WDMA_UC_RELEASE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 wdma_txpb_ue_source : 1;       // DWORD 0
               u32 wdma_pmem_ue_source : 1;       // DWORD 0
               u32 wdma_ctx_ue_source : 1;        // DWORD 0
               u32 wdma_parity_ue_source : 1;     // DWORD 0
               u32 wdma_parser_ue_source : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_UE_SOURCE_CSR, *PWDMA_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__WDMA_UE_SOURCE_CSR, sizeof (WDMA_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _WDMA_UE_SOURCE_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 wdma_txpb_ue_source : 1;             // DWORD 0
         u32 wdma_pmem_ue_source : 1;             // DWORD 0
         u32 wdma_ctx_ue_source : 1;              // DWORD 0
         u32 wdma_parity_ue_source : 1;           // DWORD 0
         u32 wdma_parser_ue_source : 1;           // DWORD 0
      } SG_PACK WDMA_UE_SOURCE_CSR, *PWDMA_UE_SOURCE_CSR;

      typedef union _WDMA_UE_SOURCE_CSR_UNION {
         WDMA_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_UE_SOURCE_CSR_UNION, *PWDMA_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_UE_SOURCE_CSR_UNION, sizeof (WDMA_UE_SOURCE_CSR_UNION) == 4);
   #endif


#else
   // WDMA Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_UE_SOURCE_CSR {
         union {
            struct { 
               u32 wdma_parser_ue_source : 1;     // DWORD 0
               u32 wdma_parity_ue_source : 1;     // DWORD 0
               u32 wdma_ctx_ue_source : 1;        // DWORD 0
               u32 wdma_pmem_ue_source : 1;       // DWORD 0
               u32 wdma_txpb_ue_source : 1;       // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_UE_SOURCE_CSR, *PWDMA_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__WDMA_UE_SOURCE_CSR, sizeof (WDMA_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _WDMA_UE_SOURCE_CSR {
         u32 wdma_parser_ue_source : 1;           // DWORD 0
         u32 wdma_parity_ue_source : 1;           // DWORD 0
         u32 wdma_ctx_ue_source : 1;              // DWORD 0
         u32 wdma_pmem_ue_source : 1;             // DWORD 0
         u32 wdma_txpb_ue_source : 1;             // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK WDMA_UE_SOURCE_CSR, *PWDMA_UE_SOURCE_CSR;

      typedef union _WDMA_UE_SOURCE_CSR_UNION {
         WDMA_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_UE_SOURCE_CSR_UNION, *PWDMA_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_UE_SOURCE_CSR_UNION, sizeof (WDMA_UE_SOURCE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 wdma_txpb_bus_ue_enable : 1;   // DWORD 0
               u32 wdma_pmem_bus_ue_enable : 1;   // DWORD 0
               u32 wdma_ctx_bus_ue_enable : 1;    // DWORD 0
               u32 wdma_parity_ue_enable : 1;     // DWORD 0
               u32 wdma_parser_ue_enable : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_UE_ENABLE_CSR, *PWDMA_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__WDMA_UE_ENABLE_CSR, sizeof (WDMA_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _WDMA_UE_ENABLE_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 wdma_txpb_bus_ue_enable : 1;         // DWORD 0
         u32 wdma_pmem_bus_ue_enable : 1;         // DWORD 0
         u32 wdma_ctx_bus_ue_enable : 1;          // DWORD 0
         u32 wdma_parity_ue_enable : 1;           // DWORD 0
         u32 wdma_parser_ue_enable : 1;           // DWORD 0
      } SG_PACK WDMA_UE_ENABLE_CSR, *PWDMA_UE_ENABLE_CSR;

      typedef union _WDMA_UE_ENABLE_CSR_UNION {
         WDMA_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_UE_ENABLE_CSR_UNION, *PWDMA_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_UE_ENABLE_CSR_UNION, sizeof (WDMA_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // WDMA Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_UE_ENABLE_CSR {
         union {
            struct { 
               u32 wdma_parser_ue_enable : 1;     // DWORD 0
               u32 wdma_parity_ue_enable : 1;     // DWORD 0
               u32 wdma_ctx_bus_ue_enable : 1;    // DWORD 0
               u32 wdma_pmem_bus_ue_enable : 1;   // DWORD 0
               u32 wdma_txpb_bus_ue_enable : 1;   // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_UE_ENABLE_CSR, *PWDMA_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__WDMA_UE_ENABLE_CSR, sizeof (WDMA_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _WDMA_UE_ENABLE_CSR {
         u32 wdma_parser_ue_enable : 1;           // DWORD 0
         u32 wdma_parity_ue_enable : 1;           // DWORD 0
         u32 wdma_ctx_bus_ue_enable : 1;          // DWORD 0
         u32 wdma_pmem_bus_ue_enable : 1;         // DWORD 0
         u32 wdma_txpb_bus_ue_enable : 1;         // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK WDMA_UE_ENABLE_CSR, *PWDMA_UE_ENABLE_CSR;

      typedef union _WDMA_UE_ENABLE_CSR_UNION {
         WDMA_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_UE_ENABLE_CSR_UNION, *PWDMA_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_UE_ENABLE_CSR_UNION, sizeof (WDMA_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CRC (iSCSI) Start Address Register. This register programs the starting address in
   // CTX RAM where iSCSI partial CRCs (per connection) are maintained.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CRC_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CRC_START_ADDR_CSR, *PWDMA_CRC_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__WDMA_CRC_START_ADDR_CSR, sizeof (WDMA_CRC_START_ADDR_CSR) == 4);

   #else
      typedef struct _WDMA_CRC_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK WDMA_CRC_START_ADDR_CSR, *PWDMA_CRC_START_ADDR_CSR;

      typedef union _WDMA_CRC_START_ADDR_CSR_UNION {
         WDMA_CRC_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_CRC_START_ADDR_CSR_UNION, *PWDMA_CRC_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CRC_START_ADDR_CSR_UNION, sizeof (WDMA_CRC_START_ADDR_CSR_UNION) == 4);
   #endif


#else
   // CRC (iSCSI) Start Address Register. This register programs the starting address in
   // CTX RAM where iSCSI partial CRCs (per connection) are maintained.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CRC_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CRC_START_ADDR_CSR, *PWDMA_CRC_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__WDMA_CRC_START_ADDR_CSR, sizeof (WDMA_CRC_START_ADDR_CSR) == 4);

   #else
      typedef struct _WDMA_CRC_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK WDMA_CRC_START_ADDR_CSR, *PWDMA_CRC_START_ADDR_CSR;

      typedef union _WDMA_CRC_START_ADDR_CSR_UNION {
         WDMA_CRC_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_CRC_START_ADDR_CSR_UNION, *PWDMA_CRC_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CRC_START_ADDR_CSR_UNION, sizeof (WDMA_CRC_START_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DIF (iSCSI) Start Address Register. This register programs the starting address in
   // CTX RAM where iSCSI ICD command are maintained.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_DIF_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_DIF_START_ADDR_CSR, *PWDMA_DIF_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__WDMA_DIF_START_ADDR_CSR, sizeof (WDMA_DIF_START_ADDR_CSR) == 4);

   #else
      typedef struct _WDMA_DIF_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK WDMA_DIF_START_ADDR_CSR, *PWDMA_DIF_START_ADDR_CSR;

      typedef union _WDMA_DIF_START_ADDR_CSR_UNION {
         WDMA_DIF_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_DIF_START_ADDR_CSR_UNION, *PWDMA_DIF_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_DIF_START_ADDR_CSR_UNION, sizeof (WDMA_DIF_START_ADDR_CSR_UNION) == 4);
   #endif


#else
   // DIF (iSCSI) Start Address Register. This register programs the starting address in
   // CTX RAM where iSCSI ICD command are maintained.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_DIF_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_DIF_START_ADDR_CSR, *PWDMA_DIF_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__WDMA_DIF_START_ADDR_CSR, sizeof (WDMA_DIF_START_ADDR_CSR) == 4);

   #else
      typedef struct _WDMA_DIF_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK WDMA_DIF_START_ADDR_CSR, *PWDMA_DIF_START_ADDR_CSR;

      typedef union _WDMA_DIF_START_ADDR_CSR_UNION {
         WDMA_DIF_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_DIF_START_ADDR_CSR_UNION, *PWDMA_DIF_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_DIF_START_ADDR_CSR_UNION, sizeof (WDMA_DIF_START_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Zero Length (Dummy Write) Host Memory Address (Lower 32 Bits) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_ZERODMA_HOST_ADDLSB_CSR {
         union {
            struct { 
               u32 host_lsb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_ZERODMA_HOST_ADDLSB_CSR, *PWDMA_ZERODMA_HOST_ADDLSB_CSR;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDLSB_CSR, sizeof (WDMA_ZERODMA_HOST_ADDLSB_CSR) == 4);

   #else
      typedef struct _WDMA_ZERODMA_HOST_ADDLSB_CSR {
         u32 host_lsb;                            // DWORD 0
      } SG_PACK WDMA_ZERODMA_HOST_ADDLSB_CSR, *PWDMA_ZERODMA_HOST_ADDLSB_CSR;

      typedef union _WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION {
         WDMA_ZERODMA_HOST_ADDLSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, *PWDMA_ZERODMA_HOST_ADDLSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, sizeof (WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION) == 4);
   #endif


#else
   // Zero Length (Dummy Write) Host Memory Address (Lower 32 Bits) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_ZERODMA_HOST_ADDLSB_CSR {
         union {
            struct { 
               u32 host_lsb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_ZERODMA_HOST_ADDLSB_CSR, *PWDMA_ZERODMA_HOST_ADDLSB_CSR;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDLSB_CSR, sizeof (WDMA_ZERODMA_HOST_ADDLSB_CSR) == 4);

   #else
      typedef struct _WDMA_ZERODMA_HOST_ADDLSB_CSR {
         u32 host_lsb;                            // DWORD 0
      } SG_PACK WDMA_ZERODMA_HOST_ADDLSB_CSR, *PWDMA_ZERODMA_HOST_ADDLSB_CSR;

      typedef union _WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION {
         WDMA_ZERODMA_HOST_ADDLSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, *PWDMA_ZERODMA_HOST_ADDLSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION, sizeof (WDMA_ZERODMA_HOST_ADDLSB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Zero Length (Dummy Write) Host Memory Address (Upper 32 Bits) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_ZERODMA_HOST_ADDMSB_CSR {
         union {
            struct { 
               u32 host_msb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_ZERODMA_HOST_ADDMSB_CSR, *PWDMA_ZERODMA_HOST_ADDMSB_CSR;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDMSB_CSR, sizeof (WDMA_ZERODMA_HOST_ADDMSB_CSR) == 4);

   #else
      typedef struct _WDMA_ZERODMA_HOST_ADDMSB_CSR {
         u32 host_msb;                            // DWORD 0
      } SG_PACK WDMA_ZERODMA_HOST_ADDMSB_CSR, *PWDMA_ZERODMA_HOST_ADDMSB_CSR;

      typedef union _WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION {
         WDMA_ZERODMA_HOST_ADDMSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, *PWDMA_ZERODMA_HOST_ADDMSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, sizeof (WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION) == 4);
   #endif


#else
   // Zero Length (Dummy Write) Host Memory Address (Upper 32 Bits) Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_ZERODMA_HOST_ADDMSB_CSR {
         union {
            struct { 
               u32 host_msb;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WDMA_ZERODMA_HOST_ADDMSB_CSR, *PWDMA_ZERODMA_HOST_ADDMSB_CSR;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDMSB_CSR, sizeof (WDMA_ZERODMA_HOST_ADDMSB_CSR) == 4);

   #else
      typedef struct _WDMA_ZERODMA_HOST_ADDMSB_CSR {
         u32 host_msb;                            // DWORD 0
      } SG_PACK WDMA_ZERODMA_HOST_ADDMSB_CSR, *PWDMA_ZERODMA_HOST_ADDMSB_CSR;

      typedef union _WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION {
         WDMA_ZERODMA_HOST_ADDMSB_CSR bits;
         u32 dw; // dword union
      } SG_PACK WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, *PWDMA_ZERODMA_HOST_ADDMSB_CSR_UNION;

      SG_C_ASSERT(__sizeof__WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION, sizeof (WDMA_ZERODMA_HOST_ADDMSB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Write DMA Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CSRMAP {
         union {
            struct { 
               WDMA_CTRL_CSR wdma_ctrl;
               WDMA_STS_CSR wdma_sts;
               WDMA_WRR0_ENTRY_CSR wdma_wrr0;
               WDMA_WRR1_ENTRY_CSR wdma_wrr1;
               WDMA_CRC_START_ADDR_CSR wdma_crc_start_addr;
               WDMA_DIF_START_ADDR_CSR wdma_dif_start_addr;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } uc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } tpost_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rxulp2_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } cev_pq;
               HWDBG_CSRMAP hwdbg;
               WDMA_UC_RELEASE_CSR wdma_uc_release_status;
               WDMA_UE_SOURCE_CSR ue_source;
               WDMA_UE_ENABLE_CSR ue_enable;
               WDMA_ZERODMA_HOST_ADDLSB_CSR wdma_zero_addr_lsb;
               WDMA_ZERODMA_HOST_ADDMSB_CSR wdma_zero_addr_msb;
               u32 rsvd0[217];                    // DWORDS 39 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CSRMAP, *PWDMA_CSRMAP;

      SG_C_ASSERT(__sizeof__WDMA_CSRMAP, sizeof (WDMA_CSRMAP) == 1024);

   #else
      typedef struct _WDMA_CSRMAP {
         WDMA_CTRL_CSR wdma_ctrl;
         WDMA_STS_CSR wdma_sts;
         WDMA_WRR0_ENTRY_CSR wdma_wrr0;
         WDMA_WRR1_ENTRY_CSR wdma_wrr1;
         WDMA_CRC_START_ADDR_CSR wdma_crc_start_addr;
         WDMA_DIF_START_ADDR_CSR wdma_dif_start_addr;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } uc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } tpost_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rxulp2_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } cev_pq;
         HWDBG_CSRMAP hwdbg;
         WDMA_UC_RELEASE_CSR wdma_uc_release_status;
         WDMA_UE_SOURCE_CSR ue_source;
         WDMA_UE_ENABLE_CSR ue_enable;
         WDMA_ZERODMA_HOST_ADDLSB_CSR wdma_zero_addr_lsb;
         WDMA_ZERODMA_HOST_ADDMSB_CSR wdma_zero_addr_msb;
         u32 rsvd0[217];                          // DWORDS 39 to 255
      } SG_PACK WDMA_CSRMAP, *PWDMA_CSRMAP;

      typedef union _WDMA_CSRMAP_UNION {
         WDMA_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK WDMA_CSRMAP_UNION, *PWDMA_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CSRMAP_UNION, sizeof (WDMA_CSRMAP_UNION) == 1024);
   #endif


#else
   // Write DMA Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _WDMA_CSRMAP {
         union {
            struct { 
               WDMA_CTRL_CSR wdma_ctrl;
               WDMA_STS_CSR wdma_sts;
               WDMA_WRR0_ENTRY_CSR wdma_wrr0;
               WDMA_WRR1_ENTRY_CSR wdma_wrr1;
               WDMA_CRC_START_ADDR_CSR wdma_crc_start_addr;
               WDMA_DIF_START_ADDR_CSR wdma_dif_start_addr;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } uc_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } tpost_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rxulp2_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } cev_pq;
               HWDBG_CSRMAP hwdbg;
               WDMA_UC_RELEASE_CSR wdma_uc_release_status;
               WDMA_UE_SOURCE_CSR ue_source;
               WDMA_UE_ENABLE_CSR ue_enable;
               WDMA_ZERODMA_HOST_ADDLSB_CSR wdma_zero_addr_lsb;
               WDMA_ZERODMA_HOST_ADDMSB_CSR wdma_zero_addr_msb;
               u32 rsvd0[217];                    // DWORDS 39 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK WDMA_CSRMAP, *PWDMA_CSRMAP;

      SG_C_ASSERT(__sizeof__WDMA_CSRMAP, sizeof (WDMA_CSRMAP) == 1024);

   #else
      typedef struct _WDMA_CSRMAP {
         WDMA_CTRL_CSR wdma_ctrl;
         WDMA_STS_CSR wdma_sts;
         WDMA_WRR0_ENTRY_CSR wdma_wrr0;
         WDMA_WRR1_ENTRY_CSR wdma_wrr1;
         WDMA_CRC_START_ADDR_CSR wdma_crc_start_addr;
         WDMA_DIF_START_ADDR_CSR wdma_dif_start_addr;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } uc_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } tpost_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rxulp2_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } cev_pq;
         HWDBG_CSRMAP hwdbg;
         WDMA_UC_RELEASE_CSR wdma_uc_release_status;
         WDMA_UE_SOURCE_CSR ue_source;
         WDMA_UE_ENABLE_CSR ue_enable;
         WDMA_ZERODMA_HOST_ADDLSB_CSR wdma_zero_addr_lsb;
         WDMA_ZERODMA_HOST_ADDMSB_CSR wdma_zero_addr_msb;
         u32 rsvd0[217];                          // DWORDS 39 to 255
      } SG_PACK WDMA_CSRMAP, *PWDMA_CSRMAP;

      typedef union _WDMA_CSRMAP_UNION {
         WDMA_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK WDMA_CSRMAP_UNION, *PWDMA_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__WDMA_CSRMAP_UNION, sizeof (WDMA_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __wdma_bmap_h__

