/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __armsys_amap_h__
#define __armsys_amap_h__
#include "setypes.h"
#include "defines.h"
#include "gencommon.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// Current status chip strap pins. 
typedef struct {
   BE_BIT pad_flashboot;                          // DWORD 0
   BE_BIT pad_lpc_bank_sz;                        // DWORD 0
   BE_BIT pads_disable_spi;                       // DWORD 0
   BE_BIT debug_bram_loading;                     // DWORD 0
   BE_BIT rsvd0[28];                              // DWORD 0
} SG_PACK BE_ARMSYS_STRAPSTAT_AMAP;
typedef struct { u32 dw[1]; } ARMSYS_STRAPSTAT_AMAP, *PARMSYS_STRAPSTAT_AMAP;


//           The ARMSYS_CSRMAP defines the layout of the ARM System Control        
// Registers. To access any of these registers, program the relative          offset into
// the [link]MPUARM_SYSREG_CTRL[/link] <I>addr</I> field         and set the appropriate
// control bits in that register.         
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT rsvd2[32];                              // DWORD 2
   BE_BIT rsvd3[32];                              // DWORD 3
   BE_BIT rsvd4[32];                              // DWORD 4
   BE_ARMSYS_STRAPSTAT_AMAP strapstat;
   BE_BIT rsvd5[32];                              // DWORD 6
   BE_BIT rsvd6[32];                              // DWORD 7
   BE_BIT rsvd7[32];                              // DWORD 8
   BE_BIT rsvd8[32];                              // DWORD 9
   BE_BIT rsvd9[32];                              // DWORD 10
   BE_BIT rsvd10[32];                             // DWORD 11
   BE_BIT rsvd11[32];                             // DWORD 12
   BE_BIT rsvd12[32];                             // DWORD 13
   BE_BIT rsvd13[32];                             // DWORD 14
   BE_BIT rsvd14[32];                             // DWORD 15
   BE_BIT rsvd15[32];                             // DWORD 16
   BE_BIT rsvd16[32];                             // DWORD 17
   BE_BIT rsvd17[32];                             // DWORD 18
   BE_BIT rsvd18[32];                             // DWORD 19
   BE_BIT rsvd19[32];                             // DWORD 20
   BE_BIT rsvd20[32];                             // DWORD 21
   BE_BIT rsvd21[32];                             // DWORD 22
   BE_BIT rsvd22[32];                             // DWORD 23
   BE_BIT rsvd23[32];                             // DWORD 24
   BE_BIT rsvd24[32];                             // DWORD 25
   BE_BIT rsvd25[32];                             // DWORD 26
   BE_BIT rsvd26[32];                             // DWORD 27
   BE_BIT rsvd27[32];                             // DWORD 28
   BE_BIT rsvd28[32];                             // DWORD 29
   BE_BIT rsvd29[32];                             // DWORD 30
   BE_BIT rsvd30[32];                             // DWORD 31
   BE_BIT rsvd31[32];                             // DWORD 32
   BE_BIT rsvd32[32];                             // DWORD 33
   BE_BIT rsvd33[32];                             // DWORD 34
   BE_BIT rsvd34[32];                             // DWORD 35
   BE_BIT rsvd35[220][32];                        // DWORD 36
} SG_PACK BE_ARMSYS_CSRMAP_AMAP;
typedef struct { u32 dw[256]; } ARMSYS_CSRMAP_AMAP, *PARMSYS_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __armsys_amap_h__

