/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __asyncmesg_amap_h__
#define __asyncmesg_amap_h__
#include "setypes.h"
#include "defines.h"
#include "nativedefs.h"
#include "ioctl_common.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- ASYNC_EVENT_CODES ---
#define ASYNC_EVENT_CODE_LINK_STATE     (1)       
#define ASYNC_EVENT_CODE_FCOE_FIP       (2)       
#define ASYNC_EVENT_CODE_DCBX           (3)       
#define ASYNC_EVENT_CODE_ISCSI          (4)       
#define ASYNC_EVENT_CODE_GRP_5          (5)       
#define ASYNC_EVENT_CODE_DEBUG          (6)       

typedef enum {
   ENUM_ASYNC_EVENT_CODE_LINK_STATE = 0x1UL,
   ENUM_ASYNC_EVENT_CODE_FCOE_FIP = 0x2UL,
   ENUM_ASYNC_EVENT_CODE_DCBX = 0x3UL,
   ENUM_ASYNC_EVENT_CODE_ISCSI = 0x4UL,
   ENUM_ASYNC_EVENT_CODE_GRP_5 = 0x5UL,
   ENUM_ASYNC_EVENT_CODE_DEBUG = 0x6UL
} ASYNC_EVENT_CODES;

// --- ASYNC_LINK_STATES ---
#define ASYNC_EVENT_LINK_DOWN           (0)       // Link Down on a port 
#define ASYNC_EVENT_LINK_UP             (1)       // Link Up on a port 
#define ASYNC_EVENT_LOGICAL             (2)       // This Link up/down event is being
                                                  // reported for a logical port, based on
                                                  // DBCX TLV received from a (DCBX
                                                  // enabled) switch connected to the
                                                  // physical port associated with this
                                                  // PCI function

typedef enum {
   ENUM_ASYNC_EVENT_LINK_DOWN = 0x0UL,
   ENUM_ASYNC_EVENT_LINK_UP = 0x1UL,
   ENUM_ASYNC_EVENT_LOGICAL = 0x2UL
} ASYNC_LINK_STATES;

// --- LINK_EVENT_REASON ---
#define ASYNC_EVENT_REASON_NONE         (0)       
#define ASYNC_EVENT_REASON_DCC          (1)       
#define ASYNC_EVENT_REASON_FIP          (2)       
#define ASYNC_EVENT_REASON_VNIC         (3)       
#define ASYNC_EVENT_REASON_PAUSE_FLOOD  (4)       

typedef enum {
   ENUM_ASYNC_EVENT_REASON_NONE = 0x0UL,
   ENUM_ASYNC_EVENT_REASON_DCC = 0x1UL,
   ENUM_ASYNC_EVENT_REASON_FIP = 0x2UL,
   ENUM_ASYNC_EVENT_REASON_VNIC = 0x3UL,
   ENUM_ASYNC_EVENT_REASON_PAUSE_FLOOD = 0x4UL
} LINK_EVENT_REASON;

//              The last 4 bytes of the async events have this common format.  It allows
// the             driver to distinguish [link]MCC_CQ_ENTRY[/link] structs from
// asynchronous             events.  Both arrive on the same completion queue.  This
// structure also             contains the common fields used to decode the async event.  
//       
typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT event_code[8];                          // DWORD 0
   BE_BIT event_type[8];                          // DWORD 0
   BE_BIT rsvd1[6];                               // DWORD 0
   BE_BIT async_event;                            // DWORD 0
   BE_BIT valid;                                  // DWORD 0
} SG_PACK BE_ASYNC_EVENT_TRAILER_AMAP;
typedef struct { u32 dw[1]; } ASYNC_EVENT_TRAILER_AMAP, *PASYNC_EVENT_TRAILER_AMAP;


//              <p> <b>Note</b> Applicable in Initiator, Target and TOE modes.            
// <br>             A link state async event is seen by all device drivers as soon they
// create              an MCC ring. Thereafter, anytime the link status changes the
// drivers will              receive a link state async event. Notifications continue to
// be sent until a              driver destroys its MCC ring.                          A
// link down event is reported when a client's port loses link. A link up event is
// reported              when that port regains link.         
typedef struct {
   BE_UEXACT8_AMAP physical_port;
   BE_UEXACT8_AMAP port_link_status;
   BE_UEXACT8_AMAP port_duplex;
   BE_UEXACT8_AMAP port_speed;
   BE_UEXACT8_AMAP port_fault;
   BE_UEXACT8_AMAP event_reason;
   BE_UEXACT16_AMAP qos_link_speed;
   BE_UEXACT32_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_LINK_STATE_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_LINK_STATE_AMAP, *PASYNC_EVENT_LINK_STATE_AMAP;


// --- ASYNC_GRP_5_EVENTS ---
#define ASYNC_GRP_5_EVENT_QOS_SPEED     (1)       // Event to set the QoS speed 
#define ASYNC_GRP_5_EVENT_COS_PRIORITY  (2)       // Event to set the CoS priority 
#define ASYNC_GRP_5_EVENT_PVID_STATE    (3)       // Event to disable/enable PVID tag 
#define ASYNC_GRP_5_EVENT_PRIORITY_CLASS_QUEUE_MAP (4) // Event to inform driver of
                                                       // class_queue to priority map 

typedef enum {
   ENUM_ASYNC_GRP_5_EVENT_QOS_SPEED = 0x1UL,
   ENUM_ASYNC_GRP_5_EVENT_COS_PRIORITY = 0x2UL,
   ENUM_ASYNC_GRP_5_EVENT_PVID_STATE = 0x3UL,
   ENUM_ASYNC_GRP_5_EVENT_PRIORITY_CLASS_QUEUE_MAP = 0x4UL
} ASYNC_GRP_5_EVENTS;


typedef struct {
   BE_UEXACT8_AMAP physical_port;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_BIT rsvd2[8];                               // DWORD 0
   BE_BIT rsvd3[8];                               // DWORD 1
   BE_BIT rsvd4[8];                               // DWORD 1
   BE_UEXACT16_AMAP qos_link_speed;
   BE_UEXACT32_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_GRP_5_QOS_SPEED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_GRP_5_QOS_SPEED_AMAP, *PASYNC_EVENT_GRP_5_QOS_SPEED_AMAP;



typedef struct {
   BE_UEXACT8_AMAP enabled;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_AMAP tag;
   BE_UEXACT32_AMAP event_tag;
   BE_BIT rsvd1[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_GRP_5_PVID_STATE_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_GRP_5_PVID_STATE_AMAP, *PASYNC_EVENT_GRP_5_PVID_STATE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP physical_port;
   BE_UEXACT8_AMAP available_priority_bmap;
   BE_UEXACT8_AMAP reco_default_priority;
   BE_UEXACT8_AMAP valid;
   BE_BIT pg_v;                                   // DWORD 1
   BE_BIT pg;                                     // DWORD 1
   BE_BIT pfc_v;                                  // DWORD 1
   BE_BIT pfc;                                    // DWORD 1
   BE_BIT app_v;                                  // DWORD 1
   BE_BIT app;                                    // DWORD 1
   BE_BIT rsvd0[26];                              // DWORD 1
   BE_UEXACT32_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_GRP_5_COS_PRIORITY_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_GRP_5_COS_PRIORITY_AMAP, *PASYNC_EVENT_GRP_5_COS_PRIORITY_AMAP;


// --- ASYNC_DEBUG_EVENTTYPE ---
// Enum for event_type when event_code=ASYNC_EVENT_CODE_DEBUG.
#define ASYNC_DEBUG_EVENT_TYPE_QNQ      (1)       // Event to send the driver the outter
                                                  // VLAN tag. 

typedef enum {
   ENUM_ASYNC_DEBUG_EVENT_TYPE_QNQ = 0x1UL
} ASYNC_DEBUG_EVENTTYPE;

//              Drivers must subscribe to async event group MCC_ASYNC_GROUP_DEBUG to
// receive             this message. If subscribed, the driver will immediately receive
// this message             after the async CQ is activated, and additional messages will
// arrive when the             outer VLAN tag value changes.              <p>            
// Both virtual and physical function drivers will receive this message.  Only networking 
//            drivers will receive this message.                          <p>            
// This message is a debug feature allowing the driver knowledge of the configured outer
// VLAN             tag.  It is not required for drivers.         
typedef struct {
   BE_UEXACT8_AMAP enabled;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_AMAP vlan_tag;
   BE_UEXACT32_AMAP event_tag;
   BE_BIT rsvd1[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_QNQ_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_QNQ_AMAP, *PASYNC_EVENT_QNQ_AMAP;



typedef struct {
   BE_UEXACT8_AMAP priority0_classq;
   BE_UEXACT8_AMAP priority1_classq;
   BE_UEXACT8_AMAP priority2_classq;
   BE_UEXACT8_AMAP priority3_classq;
   BE_UEXACT8_AMAP priority4_classq;
   BE_UEXACT8_AMAP priority5_classq;
   BE_UEXACT8_AMAP priority6_classq;
   BE_UEXACT8_AMAP priority7_classq;
   BE_UEXACT32_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP_AMAP, *PASYNC_EVENT_GRP_5_PRIORITY_CLASS_QUEUE_MAP_AMAP;


// --- ASYNC_ISCSI_EVENTS ---
#define ASYNC_ISCSI_EVENT_NEW_TARGET_DISCOVERED (4) // iSCSI discovery services found a
                                                    // new Target for this Initiator
#define ASYNC_ISCSI_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED (5) // The firmware's
                                                               // background task (re)
                                                               // established a session
                                                               // for this initiator. In
                                                               // VM mode, this is the
                                                               // only mode in which new
                                                               // targets/LUNs can be
                                                               // added to a guest domain
#define ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ESTABLISHED (7) 
#define ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ACCEPTED (16) // Target mode ONLY - an
                                                           // initiator has opened a
                                                           // connection on the listen
                                                           // port 
#define ASYNC_ISCSI_EVENT_IPV4_STATELESS_OPERATION_COMPLETE (32) // Stateless operation on
                                                                 // one of the IPv4 iSCSI
                                                                 // Interfaces has
                                                                 // completed 
#define ASYNC_ISCSI_EVENT_IPV6_STATELESS_OPERATION_COMPLETE (64) // Stateless operation on
                                                                 // one of the IPv6 iSCSI
                                                                 // Interfaces has
                                                                 // completed 
#define ASYNC_ISCSI_EVENT_ISNS_SERVER_DHCP_OPERATION_COMPLETE (128) // DHCP to get iSNS
                                                                    // servers operation
                                                                    // completed. 
#define ASYNC_ISCSI_EVENT_DHCP_LEASE_FAILED_RENEW (129) // DHCP Client failed to renew the
                                                        // lease
#define ASYNC_ISCSI_EVENT_IPV6_DEFAULT_ROUTER_CHANGED (130) // IPv6 default router changed
                                                            // event
#define ASYNC_ISCSI_EVENT_IPV6_ICMP_ERROR_PACKET_RECVD (131) // IPv6 ICMP error packet is
                                                             // recieved
#define ASYNC_ISCSI_EVENT_IPV6_AUTONOMOUS_PREFIX_IGNORED (132) // IPv6 Autonomous prefix
                                                               // ignored
#define ASYNC_ISCSI_EVENT_IPV6_ND_LOCAL_PREFIX_IGNORED (133) // IPv6 ND Local Prefix
                                                             // ignored
#define ASYNC_ISCSI_EVENT_IPV6_LINK_MTU_CHANGED (134) // IPv6 Link MTU Change detected
#define ASYNC_ISCSI_EVENT_IPV6_IP_ADDRESS_EXPIRY (135) // An IPv6 IP Address lease time
                                                       // has expired
#define ASYNC_ISCSI_EVENT_INITIATOR_START_RECOVERY (136) // Driver to start session level
                                                         // recovery on this function 

typedef enum {
   ENUM_ASYNC_ISCSI_EVENT_NEW_TARGET_DISCOVERED = 0x4UL,
   ENUM_ASYNC_ISCSI_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED = 0x5UL,
   ENUM_ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ESTABLISHED = 0x7UL,
   ENUM_ASYNC_ISCSI_EVENT_NEW_TCP_CONNECTION_ACCEPTED = 0x10UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV4_STATELESS_OPERATION_COMPLETE = 0x20UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_STATELESS_OPERATION_COMPLETE = 0x40UL,
   ENUM_ASYNC_ISCSI_EVENT_ISNS_SERVER_DHCP_OPERATION_COMPLETE = 0x80UL,
   ENUM_ASYNC_ISCSI_EVENT_DHCP_LEASE_FAILED_RENEW = 0x81UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_DEFAULT_ROUTER_CHANGED = 0x82UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_ICMP_ERROR_PACKET_RECVD = 0x83UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_AUTONOMOUS_PREFIX_IGNORED = 0x84UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_ND_LOCAL_PREFIX_IGNORED = 0x85UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_LINK_MTU_CHANGED = 0x86UL,
   ENUM_ASYNC_ISCSI_EVENT_IPV6_IP_ADDRESS_EXPIRY = 0x87UL,
   ENUM_ASYNC_ISCSI_EVENT_INITIATOR_START_RECOVERY = 0x88UL
} ASYNC_ISCSI_EVENTS;

//  The (Initiator) firmware has discovered new Targets through the iSCSI disovery        
//      services.              <p> <b>Note</b> Applicable in Initiator mode only.         
typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_BIT rsvd0[64];                              // DWORD 1
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED_AMAP, *PASYNC_EVENT_NEW_ISCSI_TARGET_DISCOVERED_AMAP;


//  The (Initiator) firmware has established a new iSCSI connection with a target.        
// The driver can use the session and connection handles to offload this connection.      
//       <p> <b>Note</b> Applicable in Initiator mode only.         
typedef struct {
   BE_UEXACT16_AMAP connection_handle;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP session_handle;
   BE_BIT rsvd1[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED_AMAP, *PASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED_AMAP;


//  The (Initiator) firmware has established a new TCP connection for a Target        
// which was configured to use multiple connections-per-session.          The driver can
// use the session and connection IDs to issue a call to
// [link]IOCTL_ISCSI_INI_DRIVER_REOPEN_A_SESSION[/link].             <p> <b>Note</b>
// Applicable in Initiator mode only.         
typedef struct {
   BE_UEXACT16_AMAP connection_handle;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP session_handle;
   BE_BIT rsvd1[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED_AMAP, *PASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED_AMAP;


//  A new TCP connection has been accepted on the listen port. The Target                
// driver is expected to issue [link]IOCTL_ISCSI_TGT_GET_CONNECTION_INFO[/link]           
//       to get the source/destination IP Address and port numbers for this connection.   
//          <p> <b>Note</b> Applicable in Target mode only.         
typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_BIT rsvd0[64];                              // DWORD 1
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED_AMAP, *PASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED_AMAP;


//  A DHCP or a Stateless IP operation was requested in non blocking mode, and it is
// completed now.                the ioctl was completed earlier when the call was made,
// this message carries.                the status, addnl status and interface handle.    
//     
typedef struct {
   BE_UEXACT8_AMAP status;
   BE_UEXACT8_AMAP additional_status;
   BE_UEXACT16_AMAP padd;
   BE_UEXACT32_AMAP interface_handle;
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_STATELESS_OPERATION_COMPLETE_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_STATELESS_OPERATION_COMPLETE_AMAP, *PASYNC_EVENT_STATELESS_OPERATION_COMPLETE_AMAP;


//  An IPv6 router can advertise the link MTU with router advertisement messages, if the
// router                 advertises a lesser MTU than what is set on this port, firmware
// will raise this event with                advertised mtu for host to take action..     
//    
typedef struct {
   BE_UEXACT32_AMAP new_link_mtu;
   BE_UEXACT32_AMAP padd;
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED_AMAP, *PASYNC_EVENT_DEFAULT_PORT_MTU_CHANGED_AMAP;


//  An IPv6 router can advertise the link MTU with router advertisement messages, if the
// router                  advertises a lesser MTU than what is set on this port, firmware
// will raise this event with                 advertised mtu for host to take action..    
//         
typedef struct {
   BE_UEXACT32_AMAP interface_handle;
   BE_UEXACT8_AMAP err_code;
   BE_UEXACT8_AMAP padd1;
   BE_UEXACT16_AMAP padd2;
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD_AMAP, *PASYNC_EVENT_ICMPV6_ERROR_PKT_RECVD_AMAP;


//   			Firmware indicates to iSCSI Driver that a session level recovery is required on
// this function.         
typedef struct {
   BE_UEXACT32_AMAP padd1;
   BE_UEXACT32_AMAP padd2;
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_INITIATOR_START_RECOVERY_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_INITIATOR_START_RECOVERY_AMAP, *PASYNC_EVENT_INITIATOR_START_RECOVERY_AMAP;


// --- ASYNC_DCBX_EVENTS ---
#define ASYNC_DCBX_EVENT_RX_TTL_EXPIRED (1)       // The TTL in DCBX LLDP TLV expired

typedef enum {
   ENUM_ASYNC_DCBX_EVENT_RX_TTL_EXPIRED = 0x1UL
} ASYNC_DCBX_EVENTS;

//             DCBX TLV TTL expired in the Control State machine.            DCBX is
// determined to be disabled on the peer.         
typedef struct {
   BE_UEXACT32_AMAP TLV_TTL;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_UEXACT32_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_DCBX_TTL_EXPIRED_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_DCBX_TTL_EXPIRED_AMAP, *PASYNC_EVENT_DCBX_TTL_EXPIRED_AMAP;


// --- ASYNC_FCOE_EVENTS ---
#define ASYNC_FCOE_EVENT_NEW_FCF_DISCOVERED (1)   // An advertisement was received from an
                                                  // FCF which is not present in the table
                                                  // maintained by the ARM f/w 
#define ASYNC_FCOE_EVENT_FCF_TABLE_FULL (2)       // The FCF table has MAX_FCF_ENTRIES and
                                                  // a new FCF has been discovered. Issue
                                                  // one or more IOCTL_FCOE_DELETE_FCF
                                                  // IOCTL to make way for the new FCF
#define ASYNC_FCOE_EVENT_FCF_DEAD       (3)       // An FCF heart beat stopped 
#define ASYNC_FCOE_EVENT_CLEAR_VLINKS_RECVD (4)   // FCF has sent us Clear Virtual Links
                                                  // for a Particular VPI 
#define ASYNC_FCOE_EVENT_FCF_PARAM_MODIFIED (5)   // One or more of FCF Parameters were
                                                  // modified in an FCF Adv. 

typedef enum {
   ENUM_ASYNC_FCOE_EVENT_NEW_FCF_DISCOVERED = 0x1UL,
   ENUM_ASYNC_FCOE_EVENT_FCF_TABLE_FULL = 0x2UL,
   ENUM_ASYNC_FCOE_EVENT_FCF_DEAD = 0x3UL,
   ENUM_ASYNC_FCOE_EVENT_CLEAR_VLINKS_RECVD = 0x4UL,
   ENUM_ASYNC_FCOE_EVENT_FCF_PARAM_MODIFIED = 0x5UL
} ASYNC_FCOE_EVENTS;

//                 An asynchronous event is sent by the ARM firmware in the following
// cases                <ul>                   <li> A new FCF is discovered (using FIP)   
//                <li> An FCF currently logged-into, has stopped responding to heartbeat  
//                 <li> A newly discoved FCF could not be added to the FCF table since it
// is full.                       Use the [link]IOCTL_FCOE_DELETE_FCF[/link] to delete
// stale/unwanted entries. 				  <li> One or more FCF parameters were modified by the FCF
// (via FCF Advertisement).               </ul>             
typedef struct {
   BE_UEXACT32_AMAP ref_index;
   BE_UEXACT16_AMAP fcf_count;
   BE_UEXACT16_AMAP event_type;
   BE_UEXACT32_AMAP event_tag;
   BE_ASYNC_EVENT_TRAILER_AMAP trailer;
} SG_PACK BE_ASYNC_EVENT_FCOE_AMAP;
typedef struct { u32 dw[4]; } ASYNC_EVENT_FCOE_AMAP, *PASYNC_EVENT_FCOE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __asyncmesg_amap_h__

