/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __doorbells_amap_h__
#define __doorbells_amap_h__
#include "setypes.h"
#include "defines.h"
#include "pcicfg.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// The TX/RDMA send queue doorbell.
typedef struct {
   BE_BIT cid[11];                                // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT numPosted[14];                          // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_SQ_DB_AMAP;
typedef struct { u32 dw[1]; } SQ_DB_AMAP, *PSQ_DB_AMAP;


// --- FRAG_RING_ENUM ---
#define FRAG_RING_HOST_NET              (0)       // Host Networking
#define FRAG_RING_HOST_STORAGE          (1)       // Host Storage

typedef enum {
   ENUM_FRAG_RING_HOST_NET = 0x0UL,
   ENUM_FRAG_RING_HOST_STORAGE = 0x1UL,
} FRAG_RING_ENUM;

// The receive queue doorbell.
typedef struct {
   BE_BIT rq[10];                                 // DWORD 0
   BE_BIT rsvd0[13];                              // DWORD 0
   BE_BIT Invalidate;                             // DWORD 0
   BE_BIT numPosted[8];                           // DWORD 0
} SG_PACK BE_RQ_DB_AMAP;
typedef struct { u32 dw[1]; } RQ_DB_AMAP, *PRQ_DB_AMAP;


// The CQ doorbell. Software MUST set reserved fields in this descriptor to zero,
// otherwise (CEV) hardware will not execute the doorbell (flagging a bad_db_qid error
// instead). To ring an EQ doorbell use the address same as CQ_DB but with the format as :
// [link] EQ_DB [/link]
typedef struct {
   BE_BIT qid[10];                                // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT num_popped[13];                         // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_CQ_DB_AMAP;
typedef struct { u32 dw[1]; } CQ_DB_AMAP, *PCQ_DB_AMAP;


// The EQ doorbell. Software MUST set reserved fields in this descriptor to zero,
// otherwise (CEV) hardware will not execute the doorbell (flagging a bad_db_qid error
// instead). Ring the Doorbell with the address same as CQ_DB.
typedef struct {
   BE_BIT qid[9];                                 // DWORD 0
   BE_BIT ClearInt;                               // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT num_popped[13];                         // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_EQ_DB_AMAP;
typedef struct { u32 dw[1]; } EQ_DB_AMAP, *PEQ_DB_AMAP;


// Doorbell format used for a window update doorbell for TOE
typedef struct {
   BE_BIT qid[11];                                // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT window_update;                          // DWORD 0
   BE_BIT byte_count[16];                         // DWORD 0
} SG_PACK BE_TOE_WINUPD_DB_AMAP;
typedef struct { u32 dw[1]; } TOE_WINUPD_DB_AMAP, *PTOE_WINUPD_DB_AMAP;


// Preposted and default fragment doorbell for TOE.
typedef struct {
   BE_BIT qid[11];                                // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT numPosted[11];                          // DWORD 0
   BE_BIT rsvd1[5];                               // DWORD 0
} SG_PACK BE_TOE_RQ_DB_AMAP;
typedef struct { u32 dw[1]; } TOE_RQ_DB_AMAP, *PTOE_RQ_DB_AMAP;


// Post WRB Queue Doorbell Register used by the host Storage stack to notify the
// controller of a posted Work Request Block
typedef struct {
   BE_BIT wrb_cid[11];                            // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT wrb_index[8];                           // DWORD 0
   BE_BIT numberPosted[8];                        // DWORD 0
} SG_PACK BE_SQ_LIST_DB_AMAP;
typedef struct { u32 dw[1]; } SQ_LIST_DB_AMAP, *PSQ_LIST_DB_AMAP;


// Post WRB Queue Doorbell Register used by the host Storage stack to notify the
// controller of a posted Work Request Block
typedef struct {
   BE_BIT wrb_cid[10];                            // DWORD 0
   BE_BIT rsvd0[6];                               // DWORD 0
   BE_BIT wrb_index[8];                           // DWORD 0
   BE_BIT numberPosted[8];                        // DWORD 0
} SG_PACK BE_WRB_POST_DB_AMAP;
typedef struct { u32 dw[1]; } WRB_POST_DB_AMAP, *PWRB_POST_DB_AMAP;


// Update Default PDU Queue Doorbell Register used to communicate to the controller that
// the driver has stopped processing the queue and where in the queue it stopped, this is
// a CQ Entry Type. Used by storage driver.
typedef struct {
   BE_BIT qid[10];                                // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT rearm;                                  // DWORD 0
   BE_BIT event;                                  // DWORD 0
   BE_BIT cqproc[14];                             // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_DEFAULT_PDU_DB_AMAP;
typedef struct { u32 dw[1]; } DEFAULT_PDU_DB_AMAP, *PDEFAULT_PDU_DB_AMAP;


// Management Command and Controller default fragment ring
typedef struct {
   BE_BIT rid[11];                                // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT numPosted[14];                          // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_MCC_DB_AMAP;
typedef struct { u32 dw[1]; } MCC_DB_AMAP, *PMCC_DB_AMAP;



typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_GENERIC_DB_AMAP;
typedef struct { u32 dw[1]; } GENERIC_DB_AMAP, *PGENERIC_DB_AMAP;


//                Used for bootstrapping the Host interface. This register is             
//  used for driver communication with the MPU when no MCC Rings exist.                   
//           <p>               The software must write this register twice to post any MCC
// command.               First, it writes the register with hi=1 and the upper bits of
// the               physical address for the MCC_MAILBOX structure.  Software must poll  
//             the ready bit until this is acknowledged.  Then, sotware writes the        
//       register with hi=0 with the lower bits in the address.  It must              
// poll the ready bit until the MCC command is complete.  Upon               completion,
// the MCC_MAILBOX will contain a valid completion queue               entry.         
typedef struct {
   BE_BIT ready;                                  // DWORD 0
   BE_BIT hi;                                     // DWORD 0
   BE_BIT address[30];                            // DWORD 0
} SG_PACK BE_MPU_MAILBOX_DB_AMAP;
typedef struct { u32 dw[1]; } MPU_MAILBOX_DB_AMAP, *PMPU_MAILBOX_DB_AMAP;


//  <p> This is the protection domain doorbell register map. Note that  while this map
// shows doorbells for all Blade Engine supported  protocols, not all of these may be
// valid in a given function or  protection domain. It is the responsibility of the
// application  accessing the doorbells to know which are valid.  Each doorbell  occupies
// 32 bytes of space, but unless otherwise specified, only  the first 4 bytes should be
// written. </p>  <p> [cloak cat="vm"] There are 32 instances of these doorbells for the
// host and  31 virtual machines respectively. The host and VMs will only  map the
// doorbell pages belonging to its protection domain.  It will not be able to touch the
// doorbells for another VM.  The doorbells are the only registers directly accessible by 
// a virtual machine.  Similarly, there are 511 additional  doorbells for RDMA protection
// domains. PD 0 for RDMA shares  the same physical protection domain doorbell page as 
// ETH/TOE/iSCSI. [/cloak] </p> 
typedef struct {
   BE_BIT rsvd0[16][32];                          // DWORD 0
   BE_GENERIC_DB_AMAP txulp0_db;
   BE_BIT rsvd1[7][32];                           // DWORD 17
   BE_GENERIC_DB_AMAP txulp1_db;
   BE_BIT rsvd2[7][32];                           // DWORD 25
   BE_GENERIC_DB_AMAP txulp2_db;
   BE_BIT rsvd3[7][32];                           // DWORD 33
   BE_GENERIC_DB_AMAP rxulp0_db;
   BE_BIT rsvd4[7][32];                           // DWORD 41
   BE_GENERIC_DB_AMAP rxulp1_db;
   BE_BIT rsvd5[7][32];                           // DWORD 49
   BE_GENERIC_DB_AMAP rxulp2_db;
   BE_BIT rsvd6[7][32];                           // DWORD 57
   BE_GENERIC_DB_AMAP erx_db;
   BE_BIT rsvd7[7][32];                           // DWORD 65
   BE_GENERIC_DB_AMAP cq_db;
   BE_BIT rsvd8[7][32];                           // DWORD 73
   BE_GENERIC_DB_AMAP mpu_mcc_db;
   BE_BIT rsvd9[7][32];                           // DWORD 81
   BE_GENERIC_DB_AMAP mpu_mailbox_db;
   BE_BIT rsvd10[935][32];                        // DWORD 89
} SG_PACK BE_PROTECTION_DOMAIN_DBMAP_AMAP;
typedef struct { u32 dw[1024]; } PROTECTION_DOMAIN_DBMAP_AMAP, *PPROTECTION_DOMAIN_DBMAP_AMAP;


//               The Blade Engine storage function (PCI function 0)              requires 
//             [cloak cat="vm" alt="1"]32[/cloak]              doorbell pages (up to      
//        [cloak cat="vm" alt="1"]32[/cloak]             protection domains).         
typedef struct {
   BE_PROTECTION_DOMAIN_DBMAP_AMAP pci_func0_protection_domain_dbmap;
   BE_BIT rsvd0[31][32768];                       // DWORD 1024
} SG_PACK BE_BLADE_ENGINE_PCI0_DBMAP_AMAP;
typedef struct { u32 dw[32768]; } BLADE_ENGINE_PCI0_DBMAP_AMAP, *PBLADE_ENGINE_PCI0_DBMAP_AMAP;


#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK BE_BLADE_ENGINE_PCI1_DBMAP_AMAP;
   typedef struct { u32 dw[1]; } BLADE_ENGINE_PCI1_DBMAP_AMAP, *PBLADE_ENGINE_PCI1_DBMAP_AMAP;
#else
   //              The Blade Engine network function (PCI function 1) requires            
   //  [cloak cat="vm" alt="512"]543[/cloak] doorbell pages (up to              [cloak
   // cat="vm" alt="1"]32[/cloak] for protection domain pages and              an
   // additional 511 specific to RDMA).            
   typedef struct {
      BE_PROTECTION_DOMAIN_DBMAP_AMAP pci_func1_protection_domain_dbmap;
      BE_BIT rsvd0[31][32768];                    // DWORD 1024
      BE_PROTECTION_DOMAIN_DBMAP_AMAP pci_func1_protection_domain_dbmap_rdma[511];
   } SG_PACK BE_BLADE_ENGINE_PCI1_DBMAP_AMAP;
   typedef struct { u32 dw[556032]; } BLADE_ENGINE_PCI1_DBMAP_AMAP, *PBLADE_ENGINE_PCI1_DBMAP_AMAP;
#endif // SG_OMIT_64KB_STRUCTS



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __doorbells_amap_h__

