/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fw_exp_amap_h__
#define __fw_exp_amap_h__
#include "setypes.h"
#include "tpost_exp.h"
#include "tpre_exp.h"
#include "fcoetx_exp.h"
#include "fcoerx_exp.h"
#include "toetx_exp.h"
#include "toerx_exp.h"
#include "daltx_exp.h"
#include "dalrx_exp.h"
#include "be2_config_sg.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- TEMP_FW_EXPORT_ENUM ---
#define TOERX_MAX_TPREDS                (15)      

typedef enum {
   ENUM_TOERX_MAX_TPREDS = 0xfUL
} TEMP_FW_EXPORT_ENUM;

// --- TCP_ACK_FREQUENCY_VALUES ---
#define TCP_ACK_FREQUENCY_DISABLE       (0)       // Indicates that sending an ack
                                                  // immediately on response to a segment
                                                  // is disabled. Has no effect on delayed
                                                  // acks 
#define TCP_ACK_FREQUENCY_MIN           (1)       // Minimum value of the ack frequency,
                                                  // send one ack per segment. 
#define TCP_ACK_FREQUENCY_DEFAULT       (2)       // Default value of the ack frequency.
                                                  // Sends one ack per two segments 
#define TCP_ACK_FREQUENCY_MAX           (15)      // Maximum value of the ack frequency 

typedef enum {
   ENUM_TCP_ACK_FREQUENCY_DISABLE = 0x0UL,
   ENUM_TCP_ACK_FREQUENCY_MIN = 0x1UL,
   ENUM_TCP_ACK_FREQUENCY_DEFAULT = 0x2UL,
   ENUM_TCP_ACK_FREQUENCY_MAX = 0xfUL
} TCP_ACK_FREQUENCY_VALUES;

// --- TCP_OOO_SUPPORTED_VALUES ---
#define TCP_OOO_DISABLE                 (0)       // Indicates that OOO is disabled. 
#define TCP_OOO_MIN                     (1)       // Minimum value of number of holes
                                                  // supported. 
#define TCP_OOO_MAX                     (3)       // Maximum value of number of holes
                                                  // supported. 
#define TCP_OOO_DEFAULT                 (3)       // Default value of holes supported. 

typedef enum {
   ENUM_TCP_OOO_DISABLE = 0x0UL,
   ENUM_TCP_OOO_MIN = 0x1UL,
   ENUM_TCP_OOO_MAX = 0x3UL,
   ENUM_TCP_OOO_DEFAULT = 0x3UL
} TCP_OOO_SUPPORTED_VALUES;

// --- TCP_DELAYED_ACK_TICKS_VALUES ---
#define TCP_DELAYED_ACK_TICKS_DISABLE   (0)       // Indicates that the delayed ack timer
                                                  // is disabled. 
#define TCP_DELAYED_ACK_TIMER_MS_STEP   (8)       // The number of milliseconds
                                                  // represented by each increment of the
                                                  // delayed ack timer 
#define TCP_DELAYED_ACK_TICKS_DEFAULT   (25)      // The default value of the delayed ack
                                                  // timer 

typedef enum {
   ENUM_TCP_DELAYED_ACK_TICKS_DISABLE = 0x0UL,
   ENUM_TCP_DELAYED_ACK_TIMER_MS_STEP = 0x8UL,
   ENUM_TCP_DELAYED_ACK_TICKS_DEFAULT = 0x19UL
} TCP_DELAYED_ACK_TICKS_VALUES;

// --- TCP_MAX_RXMT_COUNT_VALUES ---
#define TCP_MAX_RXMT_COUNT_DEFAULT      (12)      // Default max retransmit counter 

typedef enum {
   ENUM_TCP_MAX_RXMT_COUNT_DEFAULT = 0xcUL
} TCP_MAX_RXMT_COUNT_VALUES;

// --- TCP_MAX_RXMT_COUNT_ISCSI_VALUES ---
#define TCP_MAX_RXMT_COUNT_ISCSI_DEFAULT (7)      // Default max retransmit counter 

typedef enum {
   ENUM_TCP_MAX_RXMT_COUNT_ISCSI_DEFAULT = 0x7UL
} TCP_MAX_RXMT_COUNT_ISCSI_VALUES;

// --- TCP_MAX_WARNING_COUNT_VALUES ---
#define TCP_MAX_WARNING_COUNT_DEFAULT   (4)       // Default max warning count 

typedef enum {
   ENUM_TCP_MAX_WARNING_COUNT_DEFAULT = 0x4UL
} TCP_MAX_WARNING_COUNT_VALUES;

// --- TCP_DUP_ACK_THRESHOLD_VALUES ---
#define TCP_DUP_ACK_THRESHOLD_DEFAULT   (3)       // Defautl value for dup_ack_threshold 

typedef enum {
   ENUM_TCP_DUP_ACK_THRESHOLD_DEFAULT = 0x3UL
} TCP_DUP_ACK_THRESHOLD_VALUES;

// --- TCP_IDLE_TICKS_VALUES ---
#define TCP_IDLE_TICKS_DEFAULT          (1)       

typedef enum {
   ENUM_TCP_IDLE_TICKS_DEFAULT = 0x1UL
} TCP_IDLE_TICKS_VALUES;

// --- TCP_SWS_PREVENTION_TICKS_VALUES ---
#define TCP_SWS_PREVENTION_TICKS_DEFAULT (1)      

typedef enum {
   ENUM_TCP_SWS_PREVENTION_TICKS_DEFAULT = 0x1UL
} TCP_SWS_PREVENTION_TICKS_VALUES;

// --- TCP_PUSH_TIMER_TICKS_VALUES ---
#define TCP_PUSH_TIMER_TICKS_DEFAULT    (0)       

typedef enum {
   ENUM_TCP_PUSH_TIMER_TICKS_DEFAULT = 0x0UL
} TCP_PUSH_TIMER_TICKS_VALUES;

// --- TCP_FIN_WAIT2_TICKS_VALUES ---
#define TCP_FIN_WAIT2_TICKS_DEFAULT     (1)       

typedef enum {
   ENUM_TCP_FIN_WAIT2_TICKS_DEFAULT = 0x1UL
} TCP_FIN_WAIT2_TICKS_VALUES;

// --- TCP_DBCRED_COST ---
#define TCP_DBCRED_COST_DEFAULT         (4)       // Default dbcred cost 

typedef enum {
   ENUM_TCP_DBCRED_COST_DEFAULT = 0x4UL
} TCP_DBCRED_COST;

//  		 These parameters are used in the tcp receive offload engine. 		 
typedef struct {
   BE_BIT delayed_ack_ticks[8];                   // DWORD 0
   BE_BIT push_timer_ticks[8];                    // DWORD 0
   BE_BIT fin_wait2_ticks[8];                     // DWORD 0
   BE_BIT persist_thresh[6];                      // DWORD 0
   BE_BIT num_holes_supported[2];                 // DWORD 0
   BE_BIT ack_frequency[4];                       // DWORD 1
   BE_BIT max_rxmt_count[4];                      // DWORD 1
   BE_BIT max_warning_count[4];                   // DWORD 1
   BE_BIT dup_ack_threshold[4];                   // DWORD 1
   BE_BIT sws_prevention_ticks[8];                // DWORD 1
   BE_BIT idle_ticks[8];                          // DWORD 1
} SG_PACK BE_TCP_PARAMETERS_AMAP;
typedef struct { u32 dw[2]; } TCP_PARAMETERS_AMAP, *PTCP_PARAMETERS_AMAP;



typedef struct {
   BE_BIT t_maxseg[14];                           // DWORD 0
   BE_BIT reset_cwnd;                             // DWORD 0
   BE_BIT reset_rt;                               // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT restart_ka;                             // DWORD 1
   BE_BIT ka_interval[8];                         // DWORD 1
   BE_BIT ka_timeout[13];                         // DWORD 1
   BE_BIT ka_probe_max[4];                        // DWORD 1
   BE_BIT max_rt[6];                              // DWORD 1
} SG_PACK BE_TCP_UPDATE_DATA_AMAP;
typedef struct { u32 dw[2]; } TCP_UPDATE_DATA_AMAP, *PTCP_UPDATE_DATA_AMAP;



typedef struct {
   BE_BIT window_shrink_start_seq[32];            // DWORD 0
   BE_BIT window_shrink_bytes[32];                // DWORD 1
} SG_PACK BE_TCP_WINDOW_SHRINK_DATA_AMAP;
typedef struct { u32 dw[2]; } TCP_WINDOW_SHRINK_DATA_AMAP, *PTCP_WINDOW_SHRINK_DATA_AMAP;



typedef struct {
   BE_BIT outer_vlan_tag1[16];                    // DWORD 0
   BE_BIT outer_vlan_tag0[16];                    // DWORD 0
   BE_BIT outer_vlan_tag3[16];                    // DWORD 1
   BE_BIT outer_vlan_tag2[16];                    // DWORD 1
   BE_BIT outer_vlan_tag5[16];                    // DWORD 2
   BE_BIT outer_vlan_tag4[16];                    // DWORD 2
   BE_BIT outer_vlan_tag7[16];                    // DWORD 3
   BE_BIT outer_vlan_tag6[16];                    // DWORD 3
} SG_PACK BE_OUTER_VLAN_INFO_AMAP;
typedef struct { u32 dw[4]; } OUTER_VLAN_INFO_AMAP, *POUTER_VLAN_INFO_AMAP;


//                 Each TXP stat contains a 32 bit frame counter and a 64 bit packet
// counter             
typedef struct {
   BE_BIT packets[32];                            // DWORD 0
   BE_BIT lsd[32];                                // DWORD 1
   BE_BIT msd[32];                                // DWORD 2
} SG_PACK BE_BE2_TXP_SW_STAT_AMAP;
typedef struct { u32 dw[3]; } BE2_TXP_SW_STAT_AMAP, *PBE2_TXP_SW_STAT_AMAP;



typedef struct {
   BE_BE2_TXP_SW_STAT_AMAP ct1pt0_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt0_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt0_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt0_rexmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt1_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt1_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt1_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct1pt1_rexmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt0_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt0_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt0_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt0_rexmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt1_xmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt1_xmt_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt1_rexmt_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP ct2pt1_rexmt_ipv6_ctrs;
} SG_PACK BE_BE2_TXP_SW_COUNTERS_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP_SW_COUNTERS_AMAP, *PBE2_TXP_SW_COUNTERS_AMAP;


//                TXP counter map for 8 function config             
typedef struct {
   BE_BE2_TXP_SW_STAT_AMAP func0_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func0_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func1_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func1_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func2_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func2_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func3_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func3_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func4_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func4_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func5_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func5_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func6_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func6_rexmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func7_xmt_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func7_rexmt_ctrs;
} SG_PACK BE_BE2_TXP2_SW_COUNTERS_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP2_SW_COUNTERS_AMAP, *PBE2_TXP2_SW_COUNTERS_AMAP;


//                TXP counter map for 8 function QPGE config             
typedef struct {
   BE_BE2_TXP_SW_STAT_AMAP func0_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func0_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func1_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func1_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func2_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func2_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func3_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func3_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func4_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func4_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func5_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func5_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func6_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func6_ipv6_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func7_ipv4_ctrs;
   BE_BE2_TXP_SW_STAT_AMAP func7_ipv6_ctrs;
} SG_PACK BE_BE2_TXP3_SW_COUNTERS_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP3_SW_COUNTERS_AMAP, *PBE2_TXP3_SW_COUNTERS_AMAP;


//                    Same as BE2_TXP_SW_COUNTERS but uses arrays.             
typedef struct {
   struct {
      struct {
         BE_BE2_TXP_SW_STAT_AMAP xmt_ipv4_ctrs;
         BE_BE2_TXP_SW_STAT_AMAP xmt_ipv6_ctrs;
         BE_BE2_TXP_SW_STAT_AMAP rexmt_ipv4_ctrs;
         BE_BE2_TXP_SW_STAT_AMAP rexmt_ipv6_ctrs;
      } port[2];
   } chute[2];
} SG_PACK BE_BE2_TXP_PORT_SW_COUNTERS_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP_PORT_SW_COUNTERS_AMAP, *PBE2_TXP_PORT_SW_COUNTERS_AMAP;


//                    Same as BE2_TXP2_SW_COUNTERS but uses an array.             
typedef struct {
   struct {
      BE_BE2_TXP_SW_STAT_AMAP xmt_ctrs;
      BE_BE2_TXP_SW_STAT_AMAP rexmt_ctrs;
   } func[8];
} SG_PACK BE_BE2_TXP_FUNC_SW_COUNTERS_AMAP;
typedef struct { u32 dw[48]; } BE2_TXP_FUNC_SW_COUNTERS_AMAP, *PBE2_TXP_FUNC_SW_COUNTERS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fw_exp_amap_h__

