/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __headers_amap_h__
#define __headers_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- ETH_TYPE_ENUM ---
// Ethernet type field. 
#define ETH_TYPE_MAX_LENGTH             (1500)    // Maximum length for IEEE802.3 Field.
#define ETH_TYPE_IP                     (2048)    // DOD Internet Protocol (IP)
#define ETH_TYPE_ARP                    (2054)    // Address Resolution Protocol (ARP)
#define ETH_TYPE_RARP                   (32821)   // Reverse Address Resolution Protocol
                                                  // (RARP)
#define ETH_TYPE_VLAN                   (33024)   
#define ETH_TYPE_IPX                    (33079)   // Novell (old) NetWare IPX (ECONFIG E
                                                  // option)
#define ETH_TYPE_LLDP                   (35020)   // Link Layer Discovery Protocol
#define ETH_TYPE_FCoE                   (35078)   // Fibre Channel Over Ethernet
#define ETH_TYPE_FIP                    (35092)   // FCoE Initialization Protocol

typedef enum {
   ENUM_ETH_TYPE_MAX_LENGTH = 0x5dcUL,
   ENUM_ETH_TYPE_IP = 0x800UL,
   ENUM_ETH_TYPE_ARP = 0x806UL,
   ENUM_ETH_TYPE_RARP = 0x8035UL,
   ENUM_ETH_TYPE_VLAN = 0x8100UL,
   ENUM_ETH_TYPE_IPX = 0x8137UL,
   ENUM_ETH_TYPE_LLDP = 0x88ccUL,
   ENUM_ETH_TYPE_FCoE = 0x8906UL,
   ENUM_ETH_TYPE_FIP = 0x8914UL
} ETH_TYPE_ENUM;

// Ethernet header format.
typedef struct {
   BE_BIT dst_hi16[16];                           // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT dst_lo32[32];                           // DWORD 1
   BE_BIT src_hi32[32];                           // DWORD 2
   BE_BIT type[16];                               // DWORD 3
   BE_BIT src_lo16[16];                           // DWORD 3
} SG_PACK BE_ETH_HEADER_AMAP;
typedef struct { u32 dw[4]; } ETH_HEADER_AMAP, *PETH_HEADER_AMAP;


// Ethernet header with an 802 VLAN tag.
typedef struct {
   BE_BIT dst_hi16[16];                           // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT dst_lo32[32];                           // DWORD 1
   BE_BIT src_hi32[32];                           // DWORD 2
   BE_BIT vlan_type[16];                          // DWORD 3
   BE_BIT src_lo16[16];                           // DWORD 3
   BE_BIT ethertype[16];                          // DWORD 4
   BE_BIT tag[12];                                // DWORD 4
   BE_BIT canonical;                              // DWORD 4
   BE_BIT priority[3];                            // DWORD 4
} SG_PACK BE_ETH_VLAN_HEADER_AMAP;
typedef struct { u32 dw[5]; } ETH_VLAN_HEADER_AMAP, *PETH_VLAN_HEADER_AMAP;


//            This is the Priority-based Flow Control (PFC) frame format. Destination
// address            is the globally assigned 48-bit multicast address 01-80-C2-00-00-01.
// The Source            Address field of a MAC Control frame contains the 48-bit
// individual address of            the station sending the frame. The Length/Type field
// of a MAC Control frame is            a 2-octet field that shall contain the hexadecimal
// value: 88-08.         
typedef struct {
   BE_BIT dst_hi32[32];                           // DWORD 0
   BE_BIT src_hi16[16];                           // DWORD 1
   BE_BIT dst_lo16[16];                           // DWORD 1
   BE_BIT src_lo32[32];                           // DWORD 2
   BE_BIT ctl_opcode[16];                         // DWORD 3
   BE_BIT type[16];                               // DWORD 3
   BE_BIT time_vector0[16];                       // DWORD 4
   BE_BIT pr_en0;                                 // DWORD 4
   BE_BIT pr_en1;                                 // DWORD 4
   BE_BIT pr_en2;                                 // DWORD 4
   BE_BIT pr_en3;                                 // DWORD 4
   BE_BIT pr_en4;                                 // DWORD 4
   BE_BIT pr_en5;                                 // DWORD 4
   BE_BIT pr_en6;                                 // DWORD 4
   BE_BIT pr_en7;                                 // DWORD 4
   BE_BIT rsvd0[8];                               // DWORD 4
   BE_BIT time_vector2[16];                       // DWORD 5
   BE_BIT time_vector1[16];                       // DWORD 5
   BE_BIT time_vector4[16];                       // DWORD 6
   BE_BIT time_vector3[16];                       // DWORD 6
   BE_BIT time_vector6[16];                       // DWORD 7
   BE_BIT time_vector5[16];                       // DWORD 7
   BE_BIT rsvd1[16];                              // DWORD 8
   BE_BIT time_vector7[16];                       // DWORD 8
   BE_BIT rsvd2[192];                             // DWORD 9
} SG_PACK BE_PFC_FRAME_AMAP;
typedef struct { u32 dw[15]; } PFC_FRAME_AMAP, *PPFC_FRAME_AMAP;



typedef struct {
   BE_BIT orgcode_hi[8];                          // DWORD 0
   BE_BIT cntl[8];                                // DWORD 0
   BE_BIT ssap[8];                                // DWORD 0
   BE_BIT dsap[8];                                // DWORD 0
   BE_BIT type[16];                               // DWORD 1
   BE_BIT orgcode_lo[16];                         // DWORD 1
} SG_PACK BE_SNAP_HEADER_AMAP;
typedef struct { u32 dw[2]; } SNAP_HEADER_AMAP, *PSNAP_HEADER_AMAP;


// --- IP_VERSION_ENUM ---
#define IPV4                            (4)       
#define IPV6                            (6)       

typedef enum {
   ENUM_IPV4 = 0x4UL,
   ENUM_IPV6 = 0x6UL
} IP_VERSION_ENUM;

// --- IP_PROTOCOL_ENUM ---
#define IP_PROTOCOL_TCP                 (6)       
#define IP_PROTOCOL_UDP                 (17)      

typedef enum {
   ENUM_IP_PROTOCOL_TCP = 0x6UL,
   ENUM_IP_PROTOCOL_UDP = 0x11UL
} IP_PROTOCOL_ENUM;

//  IPV4 header.
typedef struct {
   BE_BIT length[16];                             // DWORD 0
   BE_BIT tos[8];                                 // DWORD 0
   BE_BIT headerLength[4];                        // DWORD 0
   BE_BIT version[4];                             // DWORD 0
   BE_BIT fragOffset[13];                         // DWORD 1
   BE_BIT flags[3];                               // DWORD 1
   BE_BIT id[16];                                 // DWORD 1
   BE_BIT checksum[16];                           // DWORD 2
   BE_BIT protocol[8];                            // DWORD 2
   BE_BIT ttl[8];                                 // DWORD 2
   BE_BIT src[32];                                // DWORD 3
   BE_BIT dst[32];                                // DWORD 4
} SG_PACK BE_IP_HEADER_AMAP;
typedef struct { u32 dw[5]; } IP_HEADER_AMAP, *PIP_HEADER_AMAP;


//  IPV6 header.
typedef struct {
   BE_BIT flowLabel[20];                          // DWORD 0
   BE_BIT trafficClass[8];                        // DWORD 0
   BE_BIT version[4];                             // DWORD 0
   BE_BIT hopLimit[8];                            // DWORD 1
   BE_BIT nextHeader[8];                          // DWORD 1
   BE_BIT payloadLength[16];                      // DWORD 1
   BE_BIT src[128];                               // DWORD 2
   BE_BIT dst[128];                               // DWORD 6
} SG_PACK BE_IPV6_HEADER_AMAP;
typedef struct { u32 dw[10]; } IPV6_HEADER_AMAP, *PIPV6_HEADER_AMAP;



typedef struct {
   BE_BIT dstPort[16];                            // DWORD 0
   BE_BIT srcPort[16];                            // DWORD 0
   BE_BIT checksum[16];                           // DWORD 1
   BE_BIT length[16];                             // DWORD 1
} SG_PACK BE_UDP_HEADER_AMAP;
typedef struct { u32 dw[2]; } UDP_HEADER_AMAP, *PUDP_HEADER_AMAP;


// --- TCP_STATE ---
#define TCPS_CLOSED                     (0)       // Closed
#define TCPS_LISTEN                     (1)       // listening for connection
#define TCPS_SYN_SENT                   (2)       // have sent SYN
#define TCPS_SYN_RECEIVED               (3)       // have sent and received SYN, waiting
                                                  // for ACK
#define TCPS_ESTABLISHED                (4)       // established
#define TCPS_CLOSE_WAIT                 (5)       // received FIN, waiting for application
                                                  // close
#define TCPS_FIN_WAIT_1                 (6)       // have closed, sent FIN, waiting for
                                                  // ACK and FIN
#define TCPS_CLOSING                    (7)       // simultaneous close, waiting for ACK
#define TCPS_LAST_ACK                   (8)       // received FIN have closed, waiting for
                                                  // ACK
#define TCPS_FIN_WAIT_2                 (9)       // have closed, awaiting FIN
#define TCPS_TIME_WAIT                  (10)      // 2MSL, wait state after active close
#define TCP_NSTATES                     (11)      // Number of TCP states

typedef enum {
   ENUM_TCPS_CLOSED = 0x0UL,
   ENUM_TCPS_LISTEN = 0x1UL,
   ENUM_TCPS_SYN_SENT = 0x2UL,
   ENUM_TCPS_SYN_RECEIVED = 0x3UL,
   ENUM_TCPS_ESTABLISHED = 0x4UL,
   ENUM_TCPS_CLOSE_WAIT = 0x5UL,
   ENUM_TCPS_FIN_WAIT_1 = 0x6UL,
   ENUM_TCPS_CLOSING = 0x7UL,
   ENUM_TCPS_LAST_ACK = 0x8UL,
   ENUM_TCPS_FIN_WAIT_2 = 0x9UL,
   ENUM_TCPS_TIME_WAIT = 0xaUL,
   ENUM_TCP_NSTATES = 0xbUL
} TCP_STATE;

// --- TH_FLAGS ---
#define TH_FIN                          (1)       
#define TH_SYN                          (2)       
#define TH_RST                          (4)       
#define TH_PUSH                         (8)       
#define TH_ACK                          (16)      
#define TH_URG                          (32)      

typedef enum {
   ENUM_TH_FIN = 0x1UL,
   ENUM_TH_SYN = 0x2UL,
   ENUM_TH_RST = 0x4UL,
   ENUM_TH_PUSH = 0x8UL,
   ENUM_TH_ACK = 0x10UL,
   ENUM_TH_URG = 0x20UL
} TH_FLAGS;

// --- TCP_FLAGS ---
#define TF_SENTFIN                      (1)       // Have sent FIN
#define TF_USE_TSTMP                    (2)       // Use timestamp option
#define TF_FLUSH_PENDING                (4)       // TxULP needs to schedule a flush
#define TF_RXMT_PENDING                 (8)       // Retransmit bits needs to be set for
                                                  // TCP scheduler
#define TF_IN_RXMT                      (16)      // We are in retransmit
#define TF_DELEGATED_DATA               (32)      // Firmware needs to handle delegated
                                                  // data
#define TF_SACK_ENABLE                  (64)      // Set when SACK is negotiated on a
                                                  // connection
#define TF_TPOST_UPLOAD_DONE            (128)     // Upon reception of flush completions,
                                                  // if TF_TPRE_UPLOAD_DONE is not set in
                                                  // rx_flags, the driver should poll
                                                  // t_flags for TF_TPOST_UPLOAD_DONE
                                                  // before it can consider the upload
                                                  // complete 
#define TF_SEND_PROBE                   (256)     // Indicates that txulp should initiate
                                                  // a window probe 
#define TF_SENT_PROBE                   (512)     // Indicates that a window probe has
                                                  // been sent 
#define TF_TPOST_FLUSH_RCVD             (1024)    // Indicates that tpost received the
                                                  // upload flush from txulp 
#define TF_TPOST_FLUSH_DONE             (2048)    // Indicates that tpost is done with a
                                                  // flush 
#define TF_TX_LAST                      (2048)    // No space in t_flags for any more
                                                  // flags

typedef enum {
   ENUM_TF_SENTFIN = 0x1UL,
   ENUM_TF_USE_TSTMP = 0x2UL,
   ENUM_TF_FLUSH_PENDING = 0x4UL,
   ENUM_TF_RXMT_PENDING = 0x8UL,
   ENUM_TF_IN_RXMT = 0x10UL,
   ENUM_TF_DELEGATED_DATA = 0x20UL,
   ENUM_TF_SACK_ENABLE = 0x40UL,
   ENUM_TF_TPOST_UPLOAD_DONE = 0x80UL,
   ENUM_TF_SEND_PROBE = 0x100UL,
   ENUM_TF_SENT_PROBE = 0x200UL,
   ENUM_TF_TPOST_FLUSH_RCVD = 0x400UL,
   ENUM_TF_TPOST_FLUSH_DONE = 0x800UL,
   ENUM_TF_TX_LAST = 0x800UL
} TCP_FLAGS;

// --- TCP_RX_FLAGS ---
#define TF_RXMT                         (1)       // Received retransmit IPC from TPRE
#define TF_FASTRXMT                     (2)       // Received fast retransmit IPC from
                                                  // TPRE
#define TF_OOO_PENDING                  (4)       // Receive out of order pending
#define TF_OOO_FIN                      (8)       // Receive out of order finish
#define TF_DROP_OOR_ACK                 (16)      // Firmware does not ack an unacceptable
                                                  // ack
#define TF_TT_REPLAY                    (32)      // Indicates that the TT replay is
                                                  // ongoing
#define TF_SACK_SEEN                    (64)      // SACK blocks are seen on this
                                                  // connection. Process the packet in
                                                  // slow path.
#define TF_TPRE_UPLOAD_DONE             (128)     // Upon reception of flush completions,
                                                  // if TF_TPRE_UPLOAD_DONE is not set in
                                                  // rx_flags, the driver should poll
                                                  // t_flags for TF_TPOST_UPLOAD_DONE
                                                  // before it can consider the upload
                                                  // complete 
#define TF_RX_LAST                      (128)     // No space in rx_flags for any more
                                                  // flags

typedef enum {
   ENUM_TF_RXMT = 0x1UL,
   ENUM_TF_FASTRXMT = 0x2UL,
   ENUM_TF_OOO_PENDING = 0x4UL,
   ENUM_TF_OOO_FIN = 0x8UL,
   ENUM_TF_DROP_OOR_ACK = 0x10UL,
   ENUM_TF_TT_REPLAY = 0x20UL,
   ENUM_TF_SACK_SEEN = 0x40UL,
   ENUM_TF_TPRE_UPLOAD_DONE = 0x80UL,
   ENUM_TF_RX_LAST = 0x80UL
} TCP_RX_FLAGS;

// --- TCP_TIMER_IDS ---
#define TCPT_REXMT                      (1)       // Retransmit
#define TCPT_PERSIST                    (2)       // Persist
#define TCPT_KEEP                       (3)       // Keep Alive
#define TCPT_DELACK                     (4)       // Delayed ACK

typedef enum {
   ENUM_TCPT_REXMT = 0x1UL,
   ENUM_TCPT_PERSIST = 0x2UL,
   ENUM_TCPT_KEEP = 0x3UL,
   ENUM_TCPT_DELACK = 0x4UL
} TCP_TIMER_IDS;

//              TCP header format.         
typedef struct {
   BE_BIT dstPort[16];                            // DWORD 0
   BE_BIT srcPort[16];                            // DWORD 0
   BE_BIT th_seq[32];                             // DWORD 1
   BE_BIT th_ack[32];                             // DWORD 2
   BE_BIT th_win[16];                             // DWORD 3
   BE_BIT th_flags[6];                            // DWORD 3
   BE_BIT rsvd0[6];                               // DWORD 3
   BE_BIT th_off[4];                              // DWORD 3
   BE_BIT urgentPtr[16];                          // DWORD 4
   BE_BIT th_sum[16];                             // DWORD 4
} SG_PACK BE_TCP_HEADER_AMAP;
typedef struct { u32 dw[5]; } TCP_HEADER_AMAP, *PTCP_HEADER_AMAP;


//              TCP timestamp option format suitable for endian toggling each 32-bit
// dword.         
typedef struct {
   BE_BIT len[8];                                 // DWORD 0
   BE_BIT kind[8];                                // DWORD 0
   BE_BIT nop1[8];                                // DWORD 0
   BE_BIT nop2[8];                                // DWORD 0
   BE_BIT ts_value[32];                           // DWORD 1
   BE_BIT ts_echo_reply[32];                      // DWORD 2
} SG_PACK BE_TCP_TIMESTAMP_AMAP;
typedef struct { u32 dw[3]; } TCP_TIMESTAMP_AMAP, *PTCP_TIMESTAMP_AMAP;


// --- BE_TCPOPT ---
// TCP Option Values 
#define BE_TCPOPT_EOL                   (0)       
#define BE_TCPOPT_NOP                   (1)       
#define BE_TCPOPT_MAXSEG                (2)       
#define BE_TCPOPT_WINDOW                (3)       
#define BE_TCPOPT_SACKPERMITTED         (4)       
#define BE_TCPOPT_SACK                  (5)       
#define BE_TCPOPT_TIMESTAMP             (8)       

typedef enum {
   ENUM_BE_TCPOPT_EOL = 0x0UL,
   ENUM_BE_TCPOPT_NOP = 0x1UL,
   ENUM_BE_TCPOPT_MAXSEG = 0x2UL,
   ENUM_BE_TCPOPT_WINDOW = 0x3UL,
   ENUM_BE_TCPOPT_SACKPERMITTED = 0x4UL,
   ENUM_BE_TCPOPT_SACK = 0x5UL,
   ENUM_BE_TCPOPT_TIMESTAMP = 0x8UL
} BE_TCPOPT;

// --- BE_TCPOLEN ---
// TCP Option lengths 
#define BE_TCPOLEN_SACKPERMITTED        (2)       
#define BE_TCPOLEN_WINDOW               (3)       
#define BE_TCPOLEN_MAXSEG               (4)       
#define BE_TCPOLEN_SACK_SINGLE          (10)      
#define BE_TCPOLEN_TIMESTAMP            (10)      

typedef enum {
   ENUM_BE_TCPOLEN_SACKPERMITTED = 0x2UL,
   ENUM_BE_TCPOLEN_WINDOW = 0x3UL,
   ENUM_BE_TCPOLEN_MAXSEG = 0x4UL,
   ENUM_BE_TCPOLEN_SACK_SINGLE = 0xaUL,
   ENUM_BE_TCPOLEN_TIMESTAMP = 0xaUL
} BE_TCPOLEN;

// --- ISCSI_OPCODE ---
// ISCSI Message Opcode Definitions Vendor Specific Initiator 0x1c-0x1e Vendor Specific
// Target 0x3c-0x3e 
#define ISCSI_OPCODE_NOP_OUT            (0)       
#define ISCSI_OPCODE_SCSI_CMD           (1)       
#define ISCSI_OPCODE_SCSI_TASK_MGMT     (2)       
#define ISCSI_OPCODE_LOGIN              (3)       
#define ISCSI_OPCODE_TEXT               (4)       
#define ISCSI_OPCODE_SCSI_DATA_OUT      (5)       
#define ISCSI_OPCODE_LOGOUT             (6)       
#define ISCSI_OPCODE_SNACK              (16)      
#define ISCSI_OPCODE_NOP_IN             (32)      
#define ISCSI_OPCODE_NOPIN              (32)      
#define ISCSI_OPCODE_SCSI_RESPONSE      (33)      
#define ISCSI_OPCODE_RESPONSE           (33)      
#define ISCSI_OPCODE_SCSI_TASK_MGMT_RESPONSE (34) 
#define ISCSI_OPCODE_LOGIN_RESPONSE     (35)      
#define ISCSI_OPCODE_TEXT_RESPONSE      (36)      
#define ISCSI_OPCODE_SCSI_DATA_IN       (37)      
#define ISCSI_OPCODE_DATAIN             (37)      
#define ISCSI_OPCODE_LOGOUT_RESPONSE    (38)      
#define ISCSI_OPCODE_R2T                (49)      
#define ISCSI_OPCODE_RTT                (49)      
#define ISCSI_OPCODE_ASYNC_MSG          (50)      
#define ISCSI_OPCODE_REJECT             (63)      

typedef enum {
   ENUM_ISCSI_OPCODE_NOP_OUT = 0x0UL,
   ENUM_ISCSI_OPCODE_SCSI_CMD = 0x1UL,
   ENUM_ISCSI_OPCODE_SCSI_TASK_MGMT = 0x2UL,
   ENUM_ISCSI_OPCODE_LOGIN = 0x3UL,
   ENUM_ISCSI_OPCODE_TEXT = 0x4UL,
   ENUM_ISCSI_OPCODE_SCSI_DATA_OUT = 0x5UL,
   ENUM_ISCSI_OPCODE_LOGOUT = 0x6UL,
   ENUM_ISCSI_OPCODE_SNACK = 0x10UL,
   ENUM_ISCSI_OPCODE_NOP_IN = 0x20UL,
   ENUM_ISCSI_OPCODE_NOPIN = 0x20UL,
   ENUM_ISCSI_OPCODE_SCSI_RESPONSE = 0x21UL,
   ENUM_ISCSI_OPCODE_RESPONSE = 0x21UL,
   ENUM_ISCSI_OPCODE_SCSI_TASK_MGMT_RESPONSE = 0x22UL,
   ENUM_ISCSI_OPCODE_LOGIN_RESPONSE = 0x23UL,
   ENUM_ISCSI_OPCODE_TEXT_RESPONSE = 0x24UL,
   ENUM_ISCSI_OPCODE_SCSI_DATA_IN = 0x25UL,
   ENUM_ISCSI_OPCODE_DATAIN = 0x25UL,
   ENUM_ISCSI_OPCODE_LOGOUT_RESPONSE = 0x26UL,
   ENUM_ISCSI_OPCODE_R2T = 0x31UL,
   ENUM_ISCSI_OPCODE_RTT = 0x31UL,
   ENUM_ISCSI_OPCODE_ASYNC_MSG = 0x32UL,
   ENUM_ISCSI_OPCODE_REJECT = 0x3fUL
} ISCSI_OPCODE;

// Basic ISCSI header format
typedef struct {
   BE_BIT opcodeSpecificFields[23];               // DWORD 0
   BE_BIT F;                                      // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT dataSegmentLength[24];                  // DWORD 1
   BE_BIT totalAHSLength[8];                      // DWORD 1
   BE_BIT lunOrOpcodeSpecificFields[2][32];       // DWORD 2
   BE_BIT itt[32];                                // DWORD 4
   BE_BIT opcodeSpecificFields1[7][32];           // DWORD 5
} SG_PACK BE_ISCSI_BHS_AMAP;
typedef struct { u32 dw[12]; } ISCSI_BHS_AMAP, *PISCSI_BHS_AMAP;


// The iSCSI data in header format.
typedef struct {
   BE_BIT status[8];                              // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT S;                                      // DWORD 0
   BE_BIT U;                                      // DWORD 0
   BE_BIT O;                                      // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT A;                                      // DWORD 0
   BE_BIT F;                                      // DWORD 0
   BE_BIT opcode[6];                              // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT dataSegmentLength[24];                  // DWORD 1
   BE_BIT totalAHSLength[8];                      // DWORD 1
   BE_BIT lun[2][32];                             // DWORD 2
   BE_BIT itt[32];                                // DWORD 4
   BE_BIT ttt[32];                                // DWORD 5
   BE_BIT statSN[32];                             // DWORD 6
   BE_BIT expCmdSN[32];                           // DWORD 7
   BE_BIT maxCmdSN[32];                           // DWORD 8
   BE_BIT dataSN[32];                             // DWORD 9
   BE_BIT bufferOffset[32];                       // DWORD 10
   BE_BIT residualCount[32];                      // DWORD 11
} SG_PACK BE_ISCSI_DATA_IN_HDR_AMAP;
typedef struct { u32 dw[12]; } ISCSI_DATA_IN_HDR_AMAP, *PISCSI_DATA_IN_HDR_AMAP;


// The iSCSI data out header format.
typedef struct {
   BE_BIT rsvd0[23];                              // DWORD 0
   BE_BIT final;                                  // DWORD 0
   BE_BIT opcode[6];                              // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT dataSegmentLength[24];                  // DWORD 1
   BE_BIT totalAHSLength[8];                      // DWORD 1
   BE_BIT rsvd2[32];                              // DWORD 2
   BE_BIT rsvd3[32];                              // DWORD 3
   BE_BIT itt[32];                                // DWORD 4
   BE_BIT ttt[32];                                // DWORD 5
   BE_BIT rsvd4[32];                              // DWORD 6
   BE_BIT ExpStatSN[32];                          // DWORD 7
   BE_BIT rsvd5[32];                              // DWORD 8
   BE_BIT dataSN[32];                             // DWORD 9
   BE_BIT bufferOffset[32];                       // DWORD 10
   BE_BIT rsvd6[32];                              // DWORD 11
} SG_PACK BE_ISCSI_DATA_OUT_HDR_AMAP;
typedef struct { u32 dw[12]; } ISCSI_DATA_OUT_HDR_AMAP, *PISCSI_DATA_OUT_HDR_AMAP;


// The iSCSI R2T header format.
typedef struct {
   BE_BIT rsvd0[23];                              // DWORD 0
   BE_BIT final;                                  // DWORD 0
   BE_BIT opcode[6];                              // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT dataSegmentLength[24];                  // DWORD 1
   BE_BIT totalAHSLength[8];                      // DWORD 1
   BE_BIT lunHi[32];                              // DWORD 2
   BE_BIT lunLo[32];                              // DWORD 3
   BE_BIT itt[32];                                // DWORD 4
   BE_BIT ttt[32];                                // DWORD 5
   BE_BIT StatSN[32];                             // DWORD 6
   BE_BIT ExpCmdSN[32];                           // DWORD 7
   BE_BIT MaxCmdSN[32];                           // DWORD 8
   BE_BIT R2TSN[32];                              // DWORD 9
   BE_BIT bufferOffset[32];                       // DWORD 10
   BE_BIT desiredDataTransferLength[32];          // DWORD 11
} SG_PACK BE_ISCSI_R2T_HDR_AMAP;
typedef struct { u32 dw[12]; } ISCSI_R2T_HDR_AMAP, *PISCSI_R2T_HDR_AMAP;


// The iSCSI command header format.
typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT immediate;                              // DWORD 0
   BE_BIT opcode[6];                              // DWORD 0
   BE_BIT final;                                  // DWORD 0
   BE_BIT rd;                                     // DWORD 0
   BE_BIT wr;                                     // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT attributes[3];                          // DWORD 0
   BE_BIT rsvd2[16];                              // DWORD 0
   BE_BIT totalAHSLength[8];                      // DWORD 1
   BE_BIT dataSegmentLength[24];                  // DWORD 1
   BE_BIT lunHi[32];                              // DWORD 2
   BE_BIT lunLo[32];                              // DWORD 3
   BE_BIT itt[32];                                // DWORD 4
   BE_BIT ExpectedDataTransferLength[32];         // DWORD 5
   BE_BIT CmdSN[32];                              // DWORD 6
   BE_BIT ExpStatSN[32];                          // DWORD 7
   BE_BIT cdb3[32];                               // DWORD 8
   BE_BIT cdb2[32];                               // DWORD 9
   BE_BIT cdb1[32];                               // DWORD 10
   BE_BIT cdb0[32];                               // DWORD 11
} SG_PACK BE_ISCSI_CMD_HDR_AMAP;
typedef struct { u32 dw[12]; } ISCSI_CMD_HDR_AMAP, *PISCSI_CMD_HDR_AMAP;


// The iSCSI response header format.
typedef struct {
   BE_BIT status[8];                              // DWORD 0
   BE_BIT response[8];                            // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT underflow;                              // DWORD 0
   BE_BIT overflow;                               // DWORD 0
   BE_BIT bdUnderflow;                            // DWORD 0
   BE_BIT bdOverflow;                             // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
   BE_BIT final;                                  // DWORD 0
   BE_BIT opcode[6];                              // DWORD 0
   BE_BIT rsvd2[2];                               // DWORD 0
   BE_BIT dataSegmentLength[24];                  // DWORD 1
   BE_BIT totalAHSLength[8];                      // DWORD 1
   BE_BIT rsvd3[32];                              // DWORD 2
   BE_BIT rsvd4[32];                              // DWORD 3
   BE_BIT itt[32];                                // DWORD 4
   BE_BIT snackTag[32];                           // DWORD 5
   BE_BIT StatSN[32];                             // DWORD 6
   BE_BIT ExpCmdSN[32];                           // DWORD 7
   BE_BIT MaxCmdSN[32];                           // DWORD 8
   BE_BIT ExpDataSN[32];                          // DWORD 9
   BE_BIT BidirReadResdiualCnt[32];               // DWORD 10
   BE_BIT ResidualCnt[32];                        // DWORD 11
} SG_PACK BE_ISCSI_RESPONSE_HDR_AMAP;
typedef struct { u32 dw[12]; } ISCSI_RESPONSE_HDR_AMAP, *PISCSI_RESPONSE_HDR_AMAP;



typedef struct {
   BE_BIT ulp_length[16];                         // DWORD 0
   BE_BIT ddp_control[8];                         // DWORD 0
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT dword1[32];                             // DWORD 1
   BE_BIT dword2[32];                             // DWORD 2
   BE_BIT dword3[32];                             // DWORD 3
   BE_BIT dword4[32];                             // DWORD 4
   BE_BIT dword5[32];                             // DWORD 5
   BE_BIT dword6[32];                             // DWORD 6
   BE_BIT dword7[32];                             // DWORD 7
   BE_BIT dword8[32];                             // DWORD 8
   BE_BIT dword9[32];                             // DWORD 9
   BE_BIT dword10[32];                            // DWORD 10
   BE_BIT dword11[32];                            // DWORD 11
   BE_BIT dword12[32];                            // DWORD 12
   BE_BIT dword13[32];                            // DWORD 13
   BE_BIT dword14[32];                            // DWORD 14
} SG_PACK BE_RDMA_HEADER_D_AMAP;
typedef struct { u32 dw[15]; } RDMA_HEADER_D_AMAP, *PRDMA_HEADER_D_AMAP;



typedef struct {
   BE_BIT ulp_length[16];                         // DWORD 0
   BE_BIT ddp_control[8];                         // DWORD 0
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT invalidate_stag[32];                    // DWORD 1
   BE_BIT queue_number[32];                       // DWORD 2
   BE_BIT msg_sequence_number[32];                // DWORD 3
   BE_BIT msg_offset[32];                         // DWORD 4
} SG_PACK BE_RDMA_HEADER_SEND_AMAP;
typedef struct { u32 dw[5]; } RDMA_HEADER_SEND_AMAP, *PRDMA_HEADER_SEND_AMAP;



typedef struct {
   BE_BIT ulp_length[16];                         // DWORD 0
   BE_BIT ddp_control[8];                         // DWORD 0
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT data_sink_stag[32];                     // DWORD 1
   BE_BIT data_sink_tagged_offset_hi[32];         // DWORD 2
   BE_BIT data_sink_tagged_offset_lo[32];         // DWORD 3
} SG_PACK BE_RDMA_HEADER_WRITE_AMAP;
typedef struct { u32 dw[4]; } RDMA_HEADER_WRITE_AMAP, *PRDMA_HEADER_WRITE_AMAP;



typedef struct {
   BE_BIT ulp_length[16];                         // DWORD 0
   BE_BIT ddp_control[8];                         // DWORD 0
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT data_sink_stag[32];                     // DWORD 1
   BE_BIT data_sink_tagged_offset_hi[32];         // DWORD 2
   BE_BIT data_sink_tagged_offset_lo[32];         // DWORD 3
} SG_PACK BE_RDMA_HEADER_RESPONSE_AMAP;
typedef struct { u32 dw[4]; } RDMA_HEADER_RESPONSE_AMAP, *PRDMA_HEADER_RESPONSE_AMAP;



typedef struct {
   BE_BIT ulp_length[16];                         // DWORD 0
   BE_BIT ddp_control[8];                         // DWORD 0
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_BIT queue_number[32];                       // DWORD 2
   BE_BIT msg_sequence_number[32];                // DWORD 3
   BE_BIT msg_offset[32];                         // DWORD 4
   BE_BIT data_sink_stag[32];                     // DWORD 5
   BE_BIT data_sink_tagged_offset_hi[32];         // DWORD 6
   BE_BIT data_sink_tagged_offset_lo[32];         // DWORD 7
   BE_BIT read_msg_size[32];                      // DWORD 8
   BE_BIT data_source_stag[32];                   // DWORD 9
   BE_BIT data_source_tagged_offset_hi[32];       // DWORD 10
   BE_BIT data_source_tagged_offset_lo[32];       // DWORD 11
} SG_PACK BE_RDMA_HEADER_READ_REQUEST_AMAP;
typedef struct { u32 dw[12]; } RDMA_HEADER_READ_REQUEST_AMAP, *PRDMA_HEADER_READ_REQUEST_AMAP;



typedef struct {
   BE_BIT ulp_length[16];                         // DWORD 0
   BE_BIT ddp_control[8];                         // DWORD 0
   BE_BIT opcode[8];                              // DWORD 0
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_BIT queue_number[32];                       // DWORD 2
   BE_BIT msg_sequence_number[32];                // DWORD 3
   BE_BIT msg_offset[32];                         // DWORD 4
   BE_BIT terminate_control[16];                  // DWORD 5
   BE_BIT rsvd1[16];                              // DWORD 5
} SG_PACK BE_RDMA_HEADER_TERMINATE_AMAP;
typedef struct { u32 dw[6]; } RDMA_HEADER_TERMINATE_AMAP, *PRDMA_HEADER_TERMINATE_AMAP;


// --- FCOE_SOF ---
// FCoE encodings for SOF
#define FCOE_SOFf                       (40)      
#define FCOE_SOFi2                      (45)      
#define FCOE_SOFi3                      (46)      
#define FCOE_SOFn2                      (53)      
#define FCOE_SOFn3                      (54)      

typedef enum {
   ENUM_FCOE_SOFf = 0x28UL,
   ENUM_FCOE_SOFi2 = 0x2dUL,
   ENUM_FCOE_SOFi3 = 0x2eUL,
   ENUM_FCOE_SOFn2 = 0x35UL,
   ENUM_FCOE_SOFn3 = 0x36UL
} FCOE_SOF;

// --- FCOE_EOF ---
// FCoE encodings for EOF
#define FCOE_EOFn                       (65)      
#define FCOE_EOFt                       (66)      
#define FCOE_EOFni                      (73)      
#define FCOE_EOFa                       (80)      

typedef enum {
   ENUM_FCOE_EOFn = 0x41UL,
   ENUM_FCOE_EOFt = 0x42UL,
   ENUM_FCOE_EOFni = 0x49UL,
   ENUM_FCOE_EOFa = 0x50UL
} FCOE_EOF;


typedef struct {
   BE_BIT information[4];                         // DWORD 0
   BE_BIT routing[4];                             // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_FC_R_CTL_AMAP;
typedef struct { u32 dw[1]; } FC_R_CTL_AMAP, *PFC_R_CTL_AMAP;



typedef struct {
   BE_BIT d_id[24];                               // DWORD 0
   BE_BIT r_ctl[8];                               // DWORD 0
   BE_BIT s_id[24];                               // DWORD 1
   BE_BIT cs_ctl_prio[8];                         // DWORD 1
   BE_BIT f_ctl[24];                              // DWORD 2
   BE_BIT type[8];                                // DWORD 2
   BE_BIT seq_cnt[16];                            // DWORD 3
   BE_BIT df_ctl[8];                              // DWORD 3
   BE_BIT seq_id[8];                              // DWORD 3
   BE_BIT rx_id[16];                              // DWORD 4
   BE_BIT ox_id[16];                              // DWORD 4
   BE_BIT param[32];                              // DWORD 5
} SG_PACK BE_FC_HEADER_AMAP;
typedef struct { u32 dw[6]; } FC_HEADER_AMAP, *PFC_HEADER_AMAP;



typedef struct {
   BE_BIT fill_bytes[2];                          // DWORD 0
   BE_BIT exchange_reassembly;                    // DWORD 0
   BE_BIT relative_offset_present;                // DWORD 0
   BE_BIT abort_sequence_condition[2];            // DWORD 0
   BE_BIT continue_sequence_condition[2];         // DWORD 0
   BE_BIT unidirectional_transmit;                // DWORD 0
   BE_BIT retransmitted_sequence;                 // DWORD 0
   BE_BIT data_encryption_obsolete;               // DWORD 0
   BE_BIT data_compression_obsolete;              // DWORD 0
   BE_BIT ack_form[2];                            // DWORD 0
   BE_BIT invalidate_xid_obsolete;                // DWORD 0
   BE_BIT xid_reassigned_obsolete;                // DWORD 0
   BE_BIT sequence_initiative;                    // DWORD 0
   BE_BIT cs_ctl_priority_enable;                 // DWORD 0
   BE_BIT end_connection;                         // DWORD 0
   BE_BIT end_sequence;                           // DWORD 0
   BE_BIT last_sequence;                          // DWORD 0
   BE_BIT first_sequence;                         // DWORD 0
   BE_BIT sequence_context;                       // DWORD 0
   BE_BIT exchange_context;                       // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_FC_F_CTL_AMAP;
typedef struct { u32 dw[1]; } FC_F_CTL_AMAP, *PFC_F_CTL_AMAP;



typedef struct {
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT vf_id[12];                              // DWORD 0
   BE_BIT priority[3];                            // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT rsvd2;                                  // DWORD 0
   BE_BIT type[4];                                // DWORD 0
   BE_BIT ver[2];                                 // DWORD 0
   BE_BIT r_ctl[8];                               // DWORD 0
   BE_BIT rsvd3[24];                              // DWORD 1
   BE_BIT hopcnt[8];                              // DWORD 1
} SG_PACK BE_FC_VFT_HEADER_AMAP;
typedef struct { u32 dw[2]; } FC_VFT_HEADER_AMAP, *PFC_VFT_HEADER_AMAP;



typedef struct {
   BE_BIT dmac_hi_32[32];                         // DWORD 0
   BE_BIT smac_hi_16[16];                         // DWORD 1
   BE_BIT dmac_lo_16[16];                         // DWORD 1
   BE_BIT smac_lo_32[32];                         // DWORD 2
   BE_BIT rsvd0[12];                              // DWORD 3
   BE_BIT ver[4];                                 // DWORD 3
   BE_BIT type[16];                               // DWORD 3
   BE_BIT rsvd1[32];                              // DWORD 4
   BE_BIT rsvd2[32];                              // DWORD 5
   BE_BIT sof[8];                                 // DWORD 6
   BE_BIT rsvd3[24];                              // DWORD 6
} SG_PACK BE_FCOE_HEADER_AMAP;
typedef struct { u32 dw[7]; } FCOE_HEADER_AMAP, *PFCOE_HEADER_AMAP;



typedef struct {
   BE_BIT dmac_hi_32[32];                         // DWORD 0
   BE_BIT smac_hi_16[16];                         // DWORD 1
   BE_BIT dmac_lo_16[16];                         // DWORD 1
   BE_BIT smac_lo_32[32];                         // DWORD 2
   BE_BIT vlan_id[12];                            // DWORD 3
   BE_BIT cannonical;                             // DWORD 3
   BE_BIT pri[3];                                 // DWORD 3
   BE_BIT ether_type[16];                         // DWORD 3
   BE_BIT rsvd0[12];                              // DWORD 4
   BE_BIT ver[4];                                 // DWORD 4
   BE_BIT type[16];                               // DWORD 4
   BE_BIT rsvd1[32];                              // DWORD 5
   BE_BIT rsvd2[32];                              // DWORD 6
   BE_BIT sof[8];                                 // DWORD 7
   BE_BIT rsvd3[24];                              // DWORD 7
} SG_PACK BE_FCOE_HEADER_VLAN_AMAP;
typedef struct { u32 dw[8]; } FCOE_HEADER_VLAN_AMAP, *PFCOE_HEADER_VLAN_AMAP;



typedef struct {
   BE_BIT lun_hi[32];                             // DWORD 0
   BE_BIT lun_lo[32];                             // DWORD 1
   BE_BIT wrdata;                                 // DWORD 2
   BE_BIT rddata;                                 // DWORD 2
   BE_BIT additional_cdb_len[6];                  // DWORD 2
   BE_BIT task_management_flags[8];               // DWORD 2
   BE_BIT task_attribute[3];                      // DWORD 2
   BE_BIT priority[4];                            // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT command_reference_number[8];            // DWORD 2
   BE_BIT fcp_cdb_dw0[32];                        // DWORD 3
   BE_BIT fcp_cdb_dw1[32];                        // DWORD 4
   BE_BIT fcp_cdb_dw2[32];                        // DWORD 5
   BE_BIT fcp_cdb_dw3[32];                        // DWORD 6
   BE_BIT fcp_dl[32];                             // DWORD 7
   BE_BIT fcp_bi_directional_read_len[32];        // DWORD 8
} SG_PACK BE_FCP_CMD_AMAP;
typedef struct { u32 dw[9]; } FCP_CMD_AMAP, *PFCP_CMD_AMAP;



typedef struct {
   BE_BIT fcp_data_ro[32];                        // DWORD 0
   BE_BIT fcp_burst_len[32];                      // DWORD 1
   BE_BIT rsvd0[32];                              // DWORD 2
} SG_PACK BE_FCP_XFER_RDY_AMAP;
typedef struct { u32 dw[3]; } FCP_XFER_RDY_AMAP, *PFCP_XFER_RDY_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT scsi_status_code[8];                    // DWORD 2
   BE_BIT fcp_rsp_len_valid;                      // DWORD 2
   BE_BIT fcp_sns_len_valid;                      // DWORD 2
   BE_BIT fcp_resid_over;                         // DWORD 2
   BE_BIT fcp_resid_under;                        // DWORD 2
   BE_BIT fcp_conf_req;                           // DWORD 2
   BE_BIT fcp_bidi_read_resid_over;               // DWORD 2
   BE_BIT fcp_bidi_read_resid_under;              // DWORD 2
   BE_BIT fcp_bidi_rsp;                           // DWORD 2
   BE_BIT retry_delay_timer[16];                  // DWORD 2
   BE_BIT fcp_resid[32];                          // DWORD 3
   BE_BIT fcp_sns_len[32];                        // DWORD 4
   BE_BIT fcp_rsp_len[32];                        // DWORD 5
   BE_BIT fcp_rsp_info[32];                       // DWORD 6
} SG_PACK BE_FCP_RSP_AMAP;
typedef struct { u32 dw[7]; } FCP_RSP_AMAP, *PFCP_RSP_AMAP;


// --- FC_RESP_CODE_ENUM ---
// FCP response codes
#define TASK_MGMT_FUN_COMPLETE          (0)       // Task Management function complete
#define FCP_BURST_LEN_MISMATCH          (1)       // FCP_DATA length different than
                                                  // FCP_BURST_LEN
#define FCP_CMND_INVALID                (2)       // FCP_CMND fields invalid
#define FCP_PARAM_MISMATCH              (3)       // FCP_DATA parameter mismatch with
                                                  // FCP_DATA_RO
#define TASK_MGMT_REJECTED              (4)       // Task Management function rejected
#define TASK_MGMT_FAILED                (5)       // Task Management function failed
#define TASK_MGMT_BAD_LUN               (9)       // Task Management function incorrect
                                                  // logical unit number

typedef enum {
   ENUM_TASK_MGMT_FUN_COMPLETE = 0x0UL,
   ENUM_FCP_BURST_LEN_MISMATCH = 0x1UL,
   ENUM_FCP_CMND_INVALID = 0x2UL,
   ENUM_FCP_PARAM_MISMATCH = 0x3UL,
   ENUM_TASK_MGMT_REJECTED = 0x4UL,
   ENUM_TASK_MGMT_FAILED = 0x5UL,
   ENUM_TASK_MGMT_BAD_LUN = 0x9UL
} FC_RESP_CODE_ENUM;

// FCP response information
typedef struct {
   BE_BIT rsp_code[8];                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
} SG_PACK BE_FCP_RSP_INFO_AMAP;
typedef struct { u32 dw[2]; } FCP_RSP_INFO_AMAP, *PFCP_RSP_INFO_AMAP;


// FC-FS-3 BA_ACC payload (reply to ABTS BLS)
typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT last_seq_id[8];                         // DWORD 0
   BE_BIT seq_id_valid[8];                        // DWORD 0
   BE_BIT rx_id[16];                              // DWORD 1
   BE_BIT ox_id[16];                              // DWORD 1
   BE_BIT hi_seq_cnt[16];                         // DWORD 2
   BE_BIT lo_seq_cnt[16];                         // DWORD 2
} SG_PACK BE_FC_BA_ACC_PAYLOAD_AMAP;
typedef struct { u32 dw[3]; } FC_BA_ACC_PAYLOAD_AMAP, *PFC_BA_ACC_PAYLOAD_AMAP;


// --- FC_ELS_COMMAND_CODE ---
// FC-LS-2 ELS command codes
#define FC_ELS_CMD_LS_RJT               (1)       // Link Service Reject
#define FC_ELS_CMD_LS_ACC               (2)       // Link Service Accept
#define FC_ELS_CMD_RRQ                  (18)      // Reinstate Recovery Qualifier Request
                                                  // Sequence
#define FC_ELS_CMD_REC                  (19)      // Read Exchange Concise Request
                                                  // Sequence

typedef enum {
   ENUM_FC_ELS_CMD_LS_RJT = 0x1UL,
   ENUM_FC_ELS_CMD_LS_ACC = 0x2UL,
   ENUM_FC_ELS_CMD_RRQ = 0x12UL,
   ENUM_FC_ELS_CMD_REC = 0x13UL
} FC_ELS_COMMAND_CODE;

// --- FC_FC4_COMMAND_CODE ---
// FCP-4 Link Services command codes
#define FC_FCP_LS_RJT                   (1)       // Link Service Reject
#define FC_FCP_LS_ACC                   (2)       // Link Service Accept
#define FC_FCP_LS_SRR                   (20)      // Sequence Retransmission Request

typedef enum {
   ENUM_FC_FCP_LS_RJT = 0x1UL,
   ENUM_FC_FCP_LS_ACC = 0x2UL,
   ENUM_FC_FCP_LS_SRR = 0x14UL
} FC_FC4_COMMAND_CODE;

// Generic FC-LS-2 ELS payload
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
   BE_BIT els_payload[32];                        // DWORD 1
} SG_PACK BE_FC_ELS_PAYLOAD_AMAP;
typedef struct { u32 dw[2]; } FC_ELS_PAYLOAD_AMAP, *PFC_ELS_PAYLOAD_AMAP;


// --- FC_RJT_REASON_CODE ---
// FC-FS-3/FC-LS-2/FCP-3 link services reject reason codes.
#define FC_RJT_INVALID_COMMAND_CODE     (1)       // The Command code in the Sequence
                                                  // being rejected is invalid.
#define FC_RJT_LOGICAL_ERROR            (3)       // The request identified by the Command
                                                  // code is invalid or logically
                                                  // inconsistent for the conditions
                                                  // present.
#define FC_RJT_LOGICAL_BUSY             (5)       // The Basic Link Service is logically
                                                  // busy and unable to process the
                                                  // request at this time.
#define FC_RJT_PROTOCOL_ERROR           (7)       // This indicates that an error has been
                                                  // detected that violates the rules of
                                                  // FC-2 protocol that are not specified
                                                  // by other error codes.
#define FC_RJT_UNABLE_TO_PERFORM_COMMAND_REQUEST (9) // The Recipient of a Link Service
                                                     // command is unable to perform the
                                                     // request at this time.
#define FC_RJT_COMMAND_NOT_SUPPORTED    (11)      // The Recipient of a Link Service
                                                  // command does not support the command
                                                  // requested.
#define FC_RJT_COMMAND_ALREADY_IN_PROGRESS (14)   // Command is already in progress.
#define FC_RJT_VENDOR_SPECIFIC_ERROR    (255)     // The Vendor specific error bits may be
                                                  // used to specify vendor unique reason
                                                  // codes.

typedef enum {
   ENUM_FC_RJT_INVALID_COMMAND_CODE = 0x1UL,
   ENUM_FC_RJT_LOGICAL_ERROR = 0x3UL,
   ENUM_FC_RJT_LOGICAL_BUSY = 0x5UL,
   ENUM_FC_RJT_PROTOCOL_ERROR = 0x7UL,
   ENUM_FC_RJT_UNABLE_TO_PERFORM_COMMAND_REQUEST = 0x9UL,
   ENUM_FC_RJT_COMMAND_NOT_SUPPORTED = 0xbUL,
   ENUM_FC_RJT_COMMAND_ALREADY_IN_PROGRESS = 0xeUL,
   ENUM_FC_RJT_VENDOR_SPECIFIC_ERROR = 0xffUL
} FC_RJT_REASON_CODE;

// --- FC_BA_RJT_REASON_CODE_EXPLANATION ---
// FC-FS-3 BA_RJT basic link services reason code explanations
#define FC_BA_RJT_NO_ADDL_EXPL          (0)       // No additional explanation
#define FC_BA_RJT_INV_ID_COMBO          (3)       // Invalid OX_ID-RX_ID combination
#define FC_BA_RJT_SEQ_ABORTED           (5)       // Sequence aborted, no sequence
                                                  // information provided

typedef enum {
   ENUM_FC_BA_RJT_NO_ADDL_EXPL = 0x0UL,
   ENUM_FC_BA_RJT_INV_ID_COMBO = 0x3UL,
   ENUM_FC_BA_RJT_SEQ_ABORTED = 0x5UL
} FC_BA_RJT_REASON_CODE_EXPLANATION;

// --- FC_LS_RJT_REASON_CODE_EXPLANATION ---
// FC-LS-2/FCP-3 extended link services reject reason code explanations
#define FC_RJT_NO_ADDL_EXPL             (0)       // No additional explanation
#define FC_RJT_SVC_PARM_ERR_OPTIONS     (1)       // Service Parm error - Options
#define FC_RJT_SVC_PARM_ERR_INIT_CTL    (3)       // Service Parm error - Initiator Ctl
#define FC_RJT_SVC_PARM_ERR_RCPNT_CTL   (5)       // Service Parm error - Recipient Ctl
#define FC_RJT_SVC_PARM_ERR_FLD_SIZE    (7)       // Service Parm error - Receive
                                                  // Data_Field Size
#define FC_RJT_SVC_PARM_ERR_CONC_SEQ    (9)       // Service Parm error - Concurrent Seq
#define FC_RJT_SVC_PARM_ERR_CREDIT      (11)      // Service Parm error - Credit
#define FC_RJT_INV_N_F_PORT_NAME        (13)      // Invalid N_Port/F_Port_Name
#define FC_RJT_INV_NODE_FABRIC_NAME     (14)      // Invalid node/Fabric Name
#define FC_RJT_INV_SRV_PARMS            (15)      // Invalid Common Service Parameters
#define FC_RJT_INV_ASSOC_HDR            (17)      // Invalid Association_Header
#define FC_RJT_ASSOC_HDR_REQ            (19)      // Association_Header required
#define FC_RJT_INV_ORIG_S_ID            (21)      // Invalid Originator S_ID
#define FC_RJT_INV_ID_COMBO             (23)      // Invalid OX_ID-RX_ID combination
#define FC_RJT_CMD_IN_PROGRESS          (25)      // Command (request) already in progress
#define FC_RJT_N_PORT_LOGIN_REQ         (30)      // N_Port Login required
#define FC_RJT_INV_N_PORT_ID            (31)      // Invalid N_Port_ID
#define FC_RJT_INSUFF_RESOURCES         (41)      // Insufficient resources to support
                                                  // Login
#define FC_RJT_CANT_SUPPLY_DATA         (42)      // Unable to supply requested data
#define FC_RJT_RQST_UNSUPPORTED         (44)      // Request not supported
#define FC_RJT_INV_PYLD_LEN             (45)      // Invalid Payload length
#define FC_RJT_NO_ALIAS_IDS_AVAIL       (48)      // No Alias_IDs available for this
                                                  // Alias_ID Type
#define FC_RJT_ALIAS_NOT_ACT_NO_RES     (49)      // Alias_ID not activated (no resources
                                                  // available)
#define FC_RJT_ALIAS_NOT_ACT_INV        (50)      // Alias_ID not activated (invalid
                                                  // Alias_ID)
#define FC_RJT_ALIAS_NOT_DEACT_INV      (51)      // Alias_ID not deactivated (doesn't
                                                  // exist)
#define FC_RJT_ALIAS_NOT_DEACT_RES      (52)      // Alias_ID not deactivated (resource
                                                  // problem)
#define FC_RJT_SVC_PARM_CONFLICT        (53)      // Service Parameter conflict
#define FC_RJT_INV_ALIAS_TOKEN          (54)      // Invalid Alias_Token
#define FC_RJT_UNSUPP_ALIAS_TOKEN       (55)      // Unsupported Alias_Token
#define FC_RJT_CANT_FORM_ALIAS_GRP      (56)      // Alias Group cannot be formed
#define FC_RJT_INV_PORT_NODE_NAME       (68)      // Invalid Port/Node_Name
#define FC_RJT_LOGIN_EXT_UNSUPP         (70)      // Login Extension not supported
#define FC_RJT_AUTH_REQ                 (72)      // Authentication required (see FC-SP)
#define FC_RJT_SCAN_VAL_NOT_ALLOWED     (80)      // Periodic Scan Value not allowed
#define FC_RJT_SANNING_UNSUPP           (81)      // Periodic Scanning not supported

typedef enum {
   ENUM_FC_RJT_NO_ADDL_EXPL = 0x0UL,
   ENUM_FC_RJT_SVC_PARM_ERR_OPTIONS = 0x1UL,
   ENUM_FC_RJT_SVC_PARM_ERR_INIT_CTL = 0x3UL,
   ENUM_FC_RJT_SVC_PARM_ERR_RCPNT_CTL = 0x5UL,
   ENUM_FC_RJT_SVC_PARM_ERR_FLD_SIZE = 0x7UL,
   ENUM_FC_RJT_SVC_PARM_ERR_CONC_SEQ = 0x9UL,
   ENUM_FC_RJT_SVC_PARM_ERR_CREDIT = 0xbUL,
   ENUM_FC_RJT_INV_N_F_PORT_NAME = 0xdUL,
   ENUM_FC_RJT_INV_NODE_FABRIC_NAME = 0xeUL,
   ENUM_FC_RJT_INV_SRV_PARMS = 0xfUL,
   ENUM_FC_RJT_INV_ASSOC_HDR = 0x11UL,
   ENUM_FC_RJT_ASSOC_HDR_REQ = 0x13UL,
   ENUM_FC_RJT_INV_ORIG_S_ID = 0x15UL,
   ENUM_FC_RJT_INV_ID_COMBO = 0x17UL,
   ENUM_FC_RJT_CMD_IN_PROGRESS = 0x19UL,
   ENUM_FC_RJT_N_PORT_LOGIN_REQ = 0x1eUL,
   ENUM_FC_RJT_INV_N_PORT_ID = 0x1fUL,
   ENUM_FC_RJT_INSUFF_RESOURCES = 0x29UL,
   ENUM_FC_RJT_CANT_SUPPLY_DATA = 0x2aUL,
   ENUM_FC_RJT_RQST_UNSUPPORTED = 0x2cUL,
   ENUM_FC_RJT_INV_PYLD_LEN = 0x2dUL,
   ENUM_FC_RJT_NO_ALIAS_IDS_AVAIL = 0x30UL,
   ENUM_FC_RJT_ALIAS_NOT_ACT_NO_RES = 0x31UL,
   ENUM_FC_RJT_ALIAS_NOT_ACT_INV = 0x32UL,
   ENUM_FC_RJT_ALIAS_NOT_DEACT_INV = 0x33UL,
   ENUM_FC_RJT_ALIAS_NOT_DEACT_RES = 0x34UL,
   ENUM_FC_RJT_SVC_PARM_CONFLICT = 0x35UL,
   ENUM_FC_RJT_INV_ALIAS_TOKEN = 0x36UL,
   ENUM_FC_RJT_UNSUPP_ALIAS_TOKEN = 0x37UL,
   ENUM_FC_RJT_CANT_FORM_ALIAS_GRP = 0x38UL,
   ENUM_FC_RJT_INV_PORT_NODE_NAME = 0x44UL,
   ENUM_FC_RJT_LOGIN_EXT_UNSUPP = 0x46UL,
   ENUM_FC_RJT_AUTH_REQ = 0x48UL,
   ENUM_FC_RJT_SCAN_VAL_NOT_ALLOWED = 0x50UL,
   ENUM_FC_RJT_SANNING_UNSUPP = 0x51UL
} FC_LS_RJT_REASON_CODE_EXPLANATION;

// FC-FS-3 BA_RJT basic link services payload.
typedef struct {
   BE_BIT vendor_unique_code[8];                  // DWORD 0
   BE_BIT reason_explanation[8];                  // DWORD 0
   BE_BIT reason_code[8];                         // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_FC_BA_RJT_PAYLOAD_AMAP;
typedef struct { u32 dw[1]; } FC_BA_RJT_PAYLOAD_AMAP, *PFC_BA_RJT_PAYLOAD_AMAP;


// FC-LS-2 LS_RJT basic link services payload. The FCP-3 FCP_RJT payload is identical.
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
   BE_BIT vendor_unique_code[8];                  // DWORD 1
   BE_BIT reason_explanation[8];                  // DWORD 1
   BE_BIT reason_code[8];                         // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
} SG_PACK BE_FC_LS_RJT_PAYLOAD_AMAP;
typedef struct { u32 dw[2]; } FC_LS_RJT_PAYLOAD_AMAP, *PFC_LS_RJT_PAYLOAD_AMAP;


// FC-LS-2 REC extended link services payload
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
   BE_BIT exchange_originator_s_id[24];           // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT rx_id[16];                              // DWORD 2
   BE_BIT ox_id[16];                              // DWORD 2
} SG_PACK BE_FC_REC_PAYLOAD_AMAP;
typedef struct { u32 dw[3]; } FC_REC_PAYLOAD_AMAP, *PFC_REC_PAYLOAD_AMAP;


// --- FC_E_STAT ---
// FC E_STAT field
#define FC_E_STAT_EXCHANGE_COMPLETE     (536870912) // Exchange is complete
#define FC_E_STAT_HOLD_SEQ_INITIATIVE   (1073741824) // Responder holds sequence
                                                     // initiative

typedef enum {
   ENUM_FC_E_STAT_EXCHANGE_COMPLETE = 0x20000000UL,
   ENUM_FC_E_STAT_HOLD_SEQ_INITIATIVE = 0x40000000UL
} FC_E_STAT;

// FC-LS-2 REC extended link services LS_ACC reply payload
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
   BE_BIT rx_id[16];                              // DWORD 1
   BE_BIT ox_id[16];                              // DWORD 1
   BE_BIT originator_address_identifier[24];      // DWORD 2
   BE_BIT rsvd1[8];                               // DWORD 2
   BE_BIT responder_address_identifier[24];       // DWORD 3
   BE_BIT rsvd2[8];                               // DWORD 3
   BE_BIT fc4value[32];                           // DWORD 4
   BE_BIT e_stat[32];                             // DWORD 5
} SG_PACK BE_FC_REC_ACC_PAYLOAD_AMAP;
typedef struct { u32 dw[6]; } FC_REC_ACC_PAYLOAD_AMAP, *PFC_REC_ACC_PAYLOAD_AMAP;


// FCP-3 SRR extended link services payload
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
   BE_BIT rx_id[16];                              // DWORD 1
   BE_BIT ox_id[16];                              // DWORD 1
   BE_BIT relative_offset[32];                    // DWORD 2
   BE_BIT rsvd1[24];                              // DWORD 3
   BE_BIT r_ctl_for_iu[8];                        // DWORD 3
} SG_PACK BE_FC_SRR_PAYLOAD_AMAP;
typedef struct { u32 dw[4]; } FC_SRR_PAYLOAD_AMAP, *PFC_SRR_PAYLOAD_AMAP;


// FC-LS-2 SRR extended link services LS_ACC reply payload
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
} SG_PACK BE_FC_SRR_ACC_PAYLOAD_AMAP;
typedef struct { u32 dw[1]; } FC_SRR_ACC_PAYLOAD_AMAP, *PFC_SRR_ACC_PAYLOAD_AMAP;


// Association Header
typedef struct {
   BE_BIT Originator_Process_Associator_Valid;    // DWORD 0
   BE_BIT Responder_Process_Associator_Valid;     // DWORD 0
   BE_BIT rsvd0[5];                               // DWORD 0
   BE_BIT Multicast_Process_Associator;           // DWORD 0
   BE_BIT Originator_Process_Associator_Hi[24];   // DWORD 0
   BE_BIT Originator_Process_Associator_Lo[32];   // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 2
   BE_BIT Responder_Process_Associator_Hi[24];    // DWORD 2
   BE_BIT Responder_Process_Associator_Lo[32];    // DWORD 3
   BE_BIT rsvd2[32];                              // DWORD 4
   BE_BIT rsvd3[32];                              // DWORD 5
   BE_BIT rsvd4[32];                              // DWORD 6
   BE_BIT rsvd5[32];                              // DWORD 7
} SG_PACK BE_FC_ASSOCIATION_HEADER_AMAP;
typedef struct { u32 dw[8]; } FC_ASSOCIATION_HEADER_AMAP, *PFC_ASSOCIATION_HEADER_AMAP;


// FC-LS-2 RRQ extended link services payload
typedef struct {
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT els_command_code[8];                    // DWORD 0
   BE_BIT exchange_originator_s_id[24];           // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT rx_id[16];                              // DWORD 2
   BE_BIT ox_id[16];                              // DWORD 2
   BE_FC_ASSOCIATION_HEADER_AMAP association_header;
} SG_PACK BE_FC_RRQ_PAYLOAD_AMAP;
typedef struct { u32 dw[11]; } FC_RRQ_PAYLOAD_AMAP, *PFC_RRQ_PAYLOAD_AMAP;


// --- FIP_OPERATION_CODE ---
// FIP operation codes
#define FIP_OP_CODE_DISC                (1)       // Discovery
#define FIP_OP_CODE_VLI                 (2)       // Virtual Link Instantiation
#define FIP_OP_CODE_MISC                (3)       // Miscellaneous

typedef enum {
   ENUM_FIP_OP_CODE_DISC = 0x1UL,
   ENUM_FIP_OP_CODE_VLI = 0x2UL,
   ENUM_FIP_OP_CODE_MISC = 0x3UL
} FIP_OPERATION_CODE;

// --- FIP_SUBCODE ---
// FIP subcodes
#define FIP_SUBCODE_DISC_SOLICITATION   (1)       // Discovery Solicitation
#define FIP_SUBCODE_VLI_REQUEST         (1)       // Virtual Link Instantiation Request
#define FIP_SUBCODE_KEEP_ALIVE          (1)       // FIP Keep Alive
#define FIP_SUBCODE_DISC_ADVERTISEMENT  (2)       // Discovery Advertisement
#define FIP_SUBCODE_VLI_REPLY           (2)       // Virtual Link Instantiation Reply
#define FIP_SUBCODE_CLR_VIRT_LINKS      (2)       // FIP Clear Virtual Links

typedef enum {
   ENUM_FIP_SUBCODE_DISC_SOLICITATION = 0x1UL,
   ENUM_FIP_SUBCODE_VLI_REQUEST = 0x1UL,
   ENUM_FIP_SUBCODE_KEEP_ALIVE = 0x1UL,
   ENUM_FIP_SUBCODE_DISC_ADVERTISEMENT = 0x2UL,
   ENUM_FIP_SUBCODE_VLI_REPLY = 0x2UL,
   ENUM_FIP_SUBCODE_CLR_VIRT_LINKS = 0x2UL
} FIP_SUBCODE;

// --- FIP_DESCRIPTOR_TYPE ---
// FIP descriptor types
#define FIP_DESC_PRIORITY               (1)       // Priority
#define FIP_DESC_MAC_ADDRESS            (2)       // MAC address
#define FIP_DESC_FC_MAP                 (3)       // FC-MAP
#define FIP_DESC_NAME_IDENTIFIER        (4)       // Name_Identifier
#define FIP_DESC_FABRIC                 (5)       // Fabric
#define FIP_DESC_MAX_FCOE_SIZE          (6)       // Max FCoE Size
#define FIP_DESC_FLOGI                  (7)       // FLOGI
#define FIP_DESC_FDISC_NPIV             (8)       // FDISC_NPIV
#define FIP_DESC_LOGO                   (9)       // LOGO
#define FIP_DESC_ELP                    (10)      // ELP
#define FIP_DESC_VN_PORT_ID             (11)      // VN_Port Identification
#define FIP_DESC_FKA_ADV_PERIOD         (12)      // FKA_ADV_Period
#define FIP_DESC_VENDOR_ID              (13)      // Vendor_ID
#define FIP_DESC_MAX_CRITICAL           (127)     // Maximum critical descriptor

typedef enum {
   ENUM_FIP_DESC_PRIORITY = 0x1UL,
   ENUM_FIP_DESC_MAC_ADDRESS = 0x2UL,
   ENUM_FIP_DESC_FC_MAP = 0x3UL,
   ENUM_FIP_DESC_NAME_IDENTIFIER = 0x4UL,
   ENUM_FIP_DESC_FABRIC = 0x5UL,
   ENUM_FIP_DESC_MAX_FCOE_SIZE = 0x6UL,
   ENUM_FIP_DESC_FLOGI = 0x7UL,
   ENUM_FIP_DESC_FDISC_NPIV = 0x8UL,
   ENUM_FIP_DESC_LOGO = 0x9UL,
   ENUM_FIP_DESC_ELP = 0xaUL,
   ENUM_FIP_DESC_VN_PORT_ID = 0xbUL,
   ENUM_FIP_DESC_FKA_ADV_PERIOD = 0xcUL,
   ENUM_FIP_DESC_VENDOR_ID = 0xdUL,
   ENUM_FIP_DESC_MAX_CRITICAL = 0x7fUL
} FIP_DESCRIPTOR_TYPE;

// Format of FIP frame and Encapsulated FIP operation
typedef struct {
   BE_BIT dmac_hi_32[32];                         // DWORD 0
   BE_BIT smac_hi_16[16];                         // DWORD 1
   BE_BIT dmac_lo_16[16];                         // DWORD 1
   BE_BIT smac_lo_32[32];                         // DWORD 2
   BE_BIT rsvd0[12];                              // DWORD 3
   BE_BIT ver[4];                                 // DWORD 3
   BE_BIT type[16];                               // DWORD 3
   BE_BIT fip_subcode[8];                         // DWORD 4
   BE_BIT rsvd1[8];                               // DWORD 4
   BE_BIT fip_operation_code[16];                 // DWORD 4
   BE_BIT f;                                      // DWORD 5
   BE_BIT s;                                      // DWORD 5
   BE_BIT a;                                      // DWORD 5
   BE_BIT rsvd2[11];                              // DWORD 5
   BE_BIT sp;                                     // DWORD 5
   BE_BIT fp;                                     // DWORD 5
   BE_BIT fip_descriptor_list_length[16];         // DWORD 5
} SG_PACK BE_FIP_FRAME_AMAP;
typedef struct { u32 dw[6]; } FIP_FRAME_AMAP, *PFIP_FRAME_AMAP;


// Format of FIP frame and Encapsulated FIP operation
typedef struct {
   BE_BIT dmac_hi_32[32];                         // DWORD 0
   BE_BIT smac_hi_16[16];                         // DWORD 1
   BE_BIT dmac_lo_16[16];                         // DWORD 1
   BE_BIT smac_lo_32[32];                         // DWORD 2
   BE_BIT vlan_id[12];                            // DWORD 3
   BE_BIT cannonical;                             // DWORD 3
   BE_BIT pri[3];                                 // DWORD 3
   BE_BIT ether_type[16];                         // DWORD 3
   BE_BIT rsvd0[12];                              // DWORD 4
   BE_BIT ver[4];                                 // DWORD 4
   BE_BIT type[16];                               // DWORD 4
   BE_BIT fip_subcode[8];                         // DWORD 5
   BE_BIT rsvd1[8];                               // DWORD 5
   BE_BIT fip_operation_code[16];                 // DWORD 5
   BE_BIT f;                                      // DWORD 6
   BE_BIT s;                                      // DWORD 6
   BE_BIT a;                                      // DWORD 6
   BE_BIT rsvd2[11];                              // DWORD 6
   BE_BIT sp;                                     // DWORD 6
   BE_BIT fp;                                     // DWORD 6
   BE_BIT fip_descriptor_list_length[16];         // DWORD 6
} SG_PACK BE_FIP_FRAME_VLAN_AMAP;
typedef struct { u32 dw[7]; } FIP_FRAME_VLAN_AMAP, *PFIP_FRAME_VLAN_AMAP;


// Format of FIP MAC AddressDescriptor
typedef struct {
   BE_BIT mac_hi_16[16];                          // DWORD 0
   BE_BIT length[8];                              // DWORD 0
   BE_BIT type[8];                                // DWORD 0
   BE_BIT mac_lo_32[32];                          // DWORD 1
} SG_PACK BE_FIP_MAC_ADDR_DESCRIPTOR_AMAP;
typedef struct { u32 dw[2]; } FIP_MAC_ADDR_DESCRIPTOR_AMAP, *PFIP_MAC_ADDR_DESCRIPTOR_AMAP;


// Format of FIP FLOGI or NPIV FDISC descriptor
typedef struct {
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_BIT length[8];                              // DWORD 0
   BE_BIT type[8];                                // DWORD 0
   BE_FC_HEADER_AMAP fc_header;
} SG_PACK BE_FIP_FLOGI_DESCRIPTOR_AMAP;
typedef struct { u32 dw[7]; } FIP_FLOGI_DESCRIPTOR_AMAP, *PFIP_FLOGI_DESCRIPTOR_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __headers_amap_h__

