/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_iscsi_amap_h__
#define __ioctl_common_iscsi_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_common_iscsi_ntwk.h"
#include "ioctl_common_iscsi_discovery.h"
#include "ioctl_common_iscsi_ipsec.h"
#include "ioctl_iscsi_tgt.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP pdu_transmitted;
   BE_UEXACT32_AMAP pdu_received;
   BE_UEXACT32_AMAP byte_transmitted;
   BE_UEXACT32_AMAP byte_received;
} SG_PACK BE_MIB_NIC_STATISTICS_AMAP;
typedef struct { u32 dw[4]; } MIB_NIC_STATISTICS_AMAP, *PMIB_NIC_STATISTICS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MIB_NIC_STATISTICS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_AMAP, *PIOCTL_COMMON_ISCSI_STATS_GET_NIC_STATISTICS_AMAP;


// --- MIB_PORTAL_ADDRESS_TYPE ---
// Definition of node_portal_address_type 
#define MIB_PORTAL_ADDR_TYPE_UKNOWN     (0)       
#define MIB_PORTAL_ADDR_TYPE_IPV4       (1)       
#define MIB_PORTAL_ADDR_TYPE_IPV6       (2)       
#define MIB_PORTAL_ADDR_TYPE_DNS        (3)       

typedef enum {
   ENUM_MIB_PORTAL_ADDR_TYPE_UKNOWN = 0x0UL,
   ENUM_MIB_PORTAL_ADDR_TYPE_IPV4 = 0x1UL,
   ENUM_MIB_PORTAL_ADDR_TYPE_IPV6 = 0x2UL,
   ENUM_MIB_PORTAL_ADDR_TYPE_DNS = 0x3UL
} MIB_PORTAL_ADDRESS_TYPE;

// --- MIB_ISCSI_ROLE ---
// Definition of iscsi_node_roles and node_portal_roles 
#define MIB_TARGET_ROLE                 (1)       
#define MIB_INITIATOR_ROLE              (2)       
#define MIB_INI_TGT_ROLE                (3)       

typedef enum {
   ENUM_MIB_TARGET_ROLE = 0x1UL,
   ENUM_MIB_INITIATOR_ROLE = 0x2UL,
   ENUM_MIB_INI_TGT_ROLE = 0x3UL
} MIB_ISCSI_ROLE;

// --- MIB_ISCSI_PORTAL_PROTOCOL ---
// Definition of node_portal_protocol 
#define MIB_NODE_PORTAL_PROTOCOL        (6)       

typedef enum {
   ENUM_MIB_NODE_PORTAL_PROTOCOL = 0x6UL
} MIB_ISCSI_PORTAL_PROTOCOL;

// --- MIB_PORTAL_STATUS ---
// Definition of node_portal_status 
#define MIB_PORTAL_STATUS_ACTIVE        (1)       
#define MIB_PORTAL_STATUS_NOT_READY     (2)       

typedef enum {
   ENUM_MIB_PORTAL_STATUS_ACTIVE = 0x1UL,
   ENUM_MIB_PORTAL_STATUS_NOT_READY = 0x2UL
} MIB_PORTAL_STATUS;


typedef struct {
   BE_UEXACT32_AMAP node_portal_id;
   BE_UEXACT32_AMAP node_portal_status;
   BE_UEXACT8_AMAP node_portal_role;
   BE_UEXACT8_AMAP node_portal_protocol;
   BE_EXACT8_AMAP node_portal_address_type;
   BE_UEXACT8_AMAP node_port;
   BE_UEXACT16_AMAP node_portal_tag;
   BE_BIT rsvd0[16];                              // DWORD 3
   BE_IP_ADDRESS_FORMAT_AMAP node_portal_address;
} SG_PACK BE_MIB_NODE_PORTAL_ATTRIB_AMAP;
typedef struct { u32 dw[10]; } MIB_NODE_PORTAL_ATTRIB_AMAP, *PMIB_NODE_PORTAL_ATTRIB_AMAP;



typedef struct {
   BE_UEXACT32_AMAP node_id;
   BE_EXACT16_AMAP node_roles;
   BE_EXACT16_AMAP node_portal_count;
   BE_EXACT8_AMAP node_name[224];
   BE_EXACT8_AMAP node_alias[224];
   BE_EXACT8_AMAP node_transport_type[256];
   BE_MIB_NODE_PORTAL_ATTRIB_AMAP node_portal[1];
} SG_PACK BE_MIB_NODE_ATTRIB_AMAP;
typedef struct { u32 dw[188]; } MIB_NODE_ATTRIB_AMAP, *PMIB_NODE_ATTRIB_AMAP;



typedef struct {
   BE_UEXACT32_AMAP node_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MIB_NODE_ATTRIB_AMAP node_attrib[1];
} SG_PACK BE_GET_ISCSI_NODE_ATTRIB_PARAMS_AMAP;
typedef struct { u32 dw[190]; } GET_ISCSI_NODE_ATTRIB_PARAMS_AMAP, *PGET_ISCSI_NODE_ATTRIB_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ISCSI_NODE_ATTRIB_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_AMAP;
typedef struct { u32 dw[194]; } IOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_AMAP, *PIOCTL_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES_AMAP;


//              Maps pages of physical memory to be used for SGLs for each command.  The  
//           num_pages may be larger the the pages array shown below, if a non-embedded   
//          command is used.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT16_AMAP page_offset;
         BE_BIT rsvd0[32];                        // DWORD 5
         BE_PHYS_ADDR_AMAP pages[26];
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
   BE_BIT rsvd0[32];                              // DWORD 58
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_AMAP, *PIOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGES_AMAP;


//              Unmaps all pages of physical memory used for SGLs.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_AMAP, *PIOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES_AMAP;


//           Posts out-of-order (OOO) buffers.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT16_AMAP final;
         BE_PHYS_ADDR_AMAP pages[27];
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_AMAP, *PIOCTL_COMMON_ISCSI_CFG_POST_OOO_BUFFERS_AMAP;


//               Removes all the posted out-of-order buffers.  This should be done after
// all             iSCSI connections are destroyed.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_AMAP, *PIOCTL_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS_AMAP;



typedef struct {
   BE_UEXACT16_AMAP index;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT8_AMAP LUN[8];
} SG_PACK BE_ADD_8BYTE_LUN_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } ADD_8BYTE_LUN_PARAMS_IN_AMAP, *PADD_8BYTE_LUN_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_ADD_8BYTE_LUN_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } ADD_8BYTE_LUN_PARAMS_OUT_AMAP, *PADD_8BYTE_LUN_PARAMS_OUT_AMAP;



typedef union {
   BE_ADD_8BYTE_LUN_PARAMS_IN_AMAP request;
   BE_ADD_8BYTE_LUN_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_AMAP;
typedef struct { u32 dw[3]; } IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_AMAP, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_AMAP;


//              By default, the iSCSI microcode (EP firmware) only supports single level
// LUNs. The EP's context memory 			allows for upto 1024 multilevel LUN numbers to be
// programmed. If a target LUN 			has an heirarchical (multi-level) LUN number, iSCSI
// drivers (Initiator or Target) should request the 			ARM to populate one of the 1024
// slots in context memory with this 8 byte LUN number. All iSCSI WRBs for 			that LUN
// should reference the slot/index number used in this IOCTL. It is the responsibility of 
// host 			drivers to manage the array of 1024 entries. The ARM and EP firmware make no
// attempt to verify  			their allocation or usage. There is no need to 'delete' an entry.
// The host driver should simply stop 			referencing an index if it is no longer used.
// Similarly, to reuse an entry, it should overwrite any 			exisiting LUN information with
// newer data.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_AMAP, *PIOCTL_COMMON_ISCSI_ADD_8BYTE_LUN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_bits;
} SG_PACK BE_SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_AMAP;
typedef struct { u32 dw[1]; } SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_AMAP, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_AMAP, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_AMAP;



typedef union {
   BE_SET_FRAGNUM_BITS_FOR_SGL_CRA_IN_AMAP request;
   BE_SET_FRAGNUM_BITS_FOR_SGL_CRA_OUT_AMAP response;
} SG_PACK BE_SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_AMAP;
typedef struct { u32 dw[1]; } SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_AMAP, *PSET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_AMAP;


//              Overrides the number of bits used for frag_num in ISCSI_SGL_CRA structure.
// By default EP firmware              uses 5 bits for frag_num. If host drivers need to
// support more than 32 scatter gather elements              per I/O, it can allocate
// memory for more ISCSI_SGEs and set num_bits accordingly to notify the EP             
// firmware of the increased size for the SGL. Other than the default value, EP firmware
// currently              supports 8 bits for frag_num to get a total of 256 scatter
// gather elements for every SGL.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_FRAGNUM_BITS_FOR_SGL_CRA_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_AMAP, *PIOCTL_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA_AMAP;


// --- ISCSI_COMMAND_CLEANUP_TYPE ---
#define IOCTL_ISCSI_COMMAND_INVALIDATE  (1)       // Invalidate this command, a TMF abort
                                                  // will follow
#define IOCTL_ISCSI_COMMAND_FREE        (2)       // Free this command, the TCP conn has
                                                  // be closed with commands pending

typedef enum {
   ENUM_IOCTL_ISCSI_COMMAND_INVALIDATE = 0x1UL,
   ENUM_IOCTL_ISCSI_COMMAND_FREE = 0x2UL
} ISCSI_COMMAND_CLEANUP_TYPE;

// --- SGL_ICD_CLEANUP_STATUS ---
#define SGL_ICD_CLEANUP_SUCCESS         (1)       // The invalidation/freeing was
                                                  // successful
#define SGL_ICD_NOT_FOUND               (2)       // This sgl_icd was not found
#define SGL_ICD_INVALIDATION_ERROR      (4)       // Unkown error while invalidating this
                                                  // sgl_icd

typedef enum {
   ENUM_SGL_ICD_CLEANUP_SUCCESS = 0x1UL,
   ENUM_SGL_ICD_NOT_FOUND = 0x2UL,
   ENUM_SGL_ICD_INVALIDATION_ERROR = 0x4UL
} SGL_ICD_CLEANUP_STATUS;

// --- IOCTL_ISCSI_DEFINED_ENUM ---
#define MGMT_MAX_SGL_ICD_INVALIDATE     (128)     

typedef enum {
   ENUM_MGMT_MAX_SGL_ICD_INVALIDATE = 0x80UL
} IOCTL_ISCSI_DEFINED_ENUM;


typedef struct {
   BE_UEXACT16_AMAP icd;
   BE_UEXACT16_AMAP cid;
} SG_PACK BE_INVALIDATE_COMMAND_TABLE_AMAP;
typedef struct { u32 dw[1]; } INVALIDATE_COMMAND_TABLE_AMAP, *PINVALIDATE_COMMAND_TABLE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ref_handle;
   BE_UEXACT32_AMAP icd_count;
   BE_INVALIDATE_COMMAND_TABLE_AMAP table[128];
   BE_UEXACT16_AMAP cleanup_type;
   BE_UEXACT16_AMAP unused;
} SG_PACK BE_INVALIDATE_COMMANDS_PARAMS_IN_AMAP;
typedef struct { u32 dw[131]; } INVALIDATE_COMMANDS_PARAMS_IN_AMAP, *PINVALIDATE_COMMANDS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP ref_handle;
   BE_UEXACT32_AMAP icd_count;
   BE_UEXACT32_AMAP icd_status[128];
} SG_PACK BE_INVALIDATE_COMMANDS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[130]; } INVALIDATE_COMMANDS_PARAMS_OUT_AMAP, *PINVALIDATE_COMMANDS_PARAMS_OUT_AMAP;



typedef union {
   BE_INVALIDATE_COMMANDS_PARAMS_IN_AMAP request;
   BE_INVALIDATE_COMMANDS_PARAMS_OUT_AMAP response;
} SG_PACK BE_INVALIDATE_COMMANDS_PARAMS_AMAP;
typedef struct { u32 dw[131]; } INVALIDATE_COMMANDS_PARAMS_AMAP, *PINVALIDATE_COMMANDS_PARAMS_AMAP;


//              This Ioctl can be used to <br>                 <ol>                    
// <li> Invalidate one or more iSCSI commands.                     <li> Request the EP
// firmware to force a command 'free' and release an SGL-ICD. Refer to the                
//           Initiator or .Target I/O flow documents for usage.                 </ol>     
//        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_INVALIDATE_COMMANDS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_AMAP;
typedef struct { u32 dw[135]; } IOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_AMAP, *PIOCTL_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS_AMAP;



typedef struct {
   BE_UEXACT16_AMAP chute;
   BE_UEXACT8_AMAP hdr_ring_id;
   BE_UEXACT8_AMAP data_ring_id;
} SG_PACK BE_ISCSI_CLEANUP_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ISCSI_CLEANUP_PARAMS_IN_AMAP, *PISCSI_CLEANUP_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_ISCSI_CLEANUP_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } ISCSI_CLEANUP_PARAMS_OUT_AMAP, *PISCSI_CLEANUP_PARAMS_OUT_AMAP;



typedef union {
   BE_ISCSI_CLEANUP_PARAMS_IN_AMAP request;
   BE_ISCSI_CLEANUP_PARAMS_OUT_AMAP response;
} SG_PACK BE_ISCSI_CLEANUP_PARAMS_AMAP;
typedef struct { u32 dw[1]; } ISCSI_CLEANUP_PARAMS_AMAP, *PISCSI_CLEANUP_PARAMS_AMAP;


//              This Ioctl should be issued by iSCSI drivers (Initiator or Target) before
// an unload/disable to 			allow the embedded processors to cleanup their data structures.
// This process is required only when 			the driver is expected to be reloaded without a
// power-cycle or reset.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_CLEANUP_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CLEANUP_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_CLEANUP_AMAP, *PIOCTL_COMMON_ISCSI_CLEANUP_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_AMAP;
typedef struct { u32 dw[4]; } IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_AMAP, *PIOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG_AMAP;


// --- EVENT_LOG_TABLE_TYPE ---
// Definition of table_type in IOCTL_ISCSI_INI_CFG_READ_EVENT_LOG 
#define MGMT_EVENT_LOG_ALL              (0)       
#define MGMT_EVENT_LOG_FATAL            (1)       

typedef enum {
   ENUM_MGMT_EVENT_LOG_ALL = 0x0UL,
   ENUM_MGMT_EVENT_LOG_FATAL = 0x1UL
} EVENT_LOG_TABLE_TYPE;


typedef struct {
   BE_UEXACT32_AMAP seq_number;
   BE_UEXACT32_AMAP table_type;
} SG_PACK BE_READ_EVENT_LOG_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } READ_EVENT_LOG_PARAMS_IN_AMAP, *PREAD_EVENT_LOG_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP seq_number;
   BE_UEXACT32_AMAP event_entry_count;
   BE_EVENT_LOG_AMAP event_entries[1];
} SG_PACK BE_READ_EVENT_LOG_PARAMS_OUT_AMAP;
typedef struct { u32 dw[18]; } READ_EVENT_LOG_PARAMS_OUT_AMAP, *PREAD_EVENT_LOG_PARAMS_OUT_AMAP;



typedef union {
   BE_READ_EVENT_LOG_PARAMS_IN_AMAP request;
   BE_READ_EVENT_LOG_PARAMS_OUT_AMAP response;
} SG_PACK BE_READ_EVENT_LOG_PARAMS_AMAP;
typedef struct { u32 dw[18]; } READ_EVENT_LOG_PARAMS_AMAP, *PREAD_EVENT_LOG_PARAMS_AMAP;


//          Each entry will be returned with a sequence number generated by the firmware. 
//        The utility  should supply the next sequence number from where it wants to read 
//        the next log entry. If the requested sequence number is not available         
// (may have been overwritten),the firmware searches for the next sequence number         
// available in it's log buffer.The firmware then returns all entries starting from       
//   this number upto it's own write index pointer.                  The number of events
// (NumEvents) can be set by the utility. If it is set to zero,         the firmware will
// return all entries that fits into 64k (scatter/gather limitation).         If NumEvents
// is non-zero, then the firmware will return entries equal to NumEvents.                 
// SeqNumber starts from 1.                  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_READ_EVENT_LOG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG_AMAP;
typedef struct { u32 dw[22]; } IOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG_AMAP, *PIOCTL_COMMON_ISCSI_CFG_READ_EVENT_LOG_AMAP;


//          IOCTL for creating iSCSI WRB ring.                  <P>An iSCSI WRB (transmit)
// ring must be at least 128 entries deep (corresponding to 1 page) and          at most
// 2k entries deep (corresponding to 4 pages). When the connection is offloaded,         
// the encoded ring size in the context must result in a ring fitting within the number of
//          pages posted with this IOCTL.                  <P>The IOCTL may fail with the
// following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to create this ring type.         </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- this ring type is
// either unavailable or all rings are already created.         </LI>         </UL>       
//  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT8_AMAP ulp_num;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_WRBQ_CREATE_AMAP;
typedef struct { u32 dw[21]; } IOCTL_COMMON_ISCSI_WRBQ_CREATE_AMAP, *PIOCTL_COMMON_ISCSI_WRBQ_CREATE_AMAP;


//           IOCTL for destroying an iSCSI WRB (transmit) ring. Use opcode
// [link]OPCODE_COMMON_ISCSI_WRBQ_DESTROY[/link].                  <P>The IOCTL may fail
// with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to destroy this ring.         </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP id;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_WRBQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_WRBQ_DESTROY_AMAP, *PIOCTL_COMMON_ISCSI_WRBQ_DESTROY_AMAP;


//          IOCTL for creating iSCSI default PDU ring. Use opcode
// [link]OPCODE_COMMON_ISCSI_DEFQ_CREATE[/link].                  <P>         An iSCSI
// default PDU ring must be at least 512 entries deep (corresponding to 1 page) and       
//   at most 4k entries deep (corresponding to 8 pages).                  <P>The IOCTL may
// fail with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to create this ring type.         </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- this ring type is
// either unavailable or all rings are already created.         </LI>         </UL>       
//  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT8_AMAP ulp_num;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_ISCSI_DEFAULT_PDU_CONTEXT_AMAP context;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_DEFQ_CREATE_AMAP;
typedef struct { u32 dw[25]; } IOCTL_COMMON_ISCSI_DEFQ_CREATE_AMAP, *PIOCTL_COMMON_ISCSI_DEFQ_CREATE_AMAP;


//           IOCTL for destroying an iSCSI default PDU ring. Use opcode
// [link]OPCODE_COMMON_ISCSI_DEFQ_DESTROY[/link].                  <P>The IOCTL may fail
// with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the client is not
// authorized to destroy this ring.         </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP id;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_DEFQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_DEFQ_DESTROY_AMAP, *PIOCTL_COMMON_ISCSI_DEFQ_DESTROY_AMAP;


// --- CONN_OFFLOAD ---

#define TCP_CONNECT_NO_OFFLOAD          (0)       
#define TCP_CONNECT_AND_OFFLOAD         (1)       

typedef enum {
   ENUM_TCP_CONNECT_NO_OFFLOAD = 0x0UL,
   ENUM_TCP_CONNECT_AND_OFFLOAD = 0x1UL
} CONN_OFFLOAD;


typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP ip_address;
   BE_UEXACT16_AMAP tcp_port;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP cq_id;
   BE_UEXACT16_AMAP defq_id;
   BE_PHYS_ADDR_AMAP dataout_template_pa;
   BE_UEXACT16_AMAP hdr_ring_id;
   BE_UEXACT16_AMAP data_ring_id;
   BE_UEXACT8_AMAP do_offload;
   BE_BIT rsvd0[3][8];                            // DWORD 11
} SG_PACK BE_TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_AMAP;
typedef struct { u32 dw[12]; } TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_AMAP, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_IN_AMAP;


//  Returned values after a iSCSI connection and offload completes
typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT16_AMAP cid;
   BE_BIT rsvd0[16];                              // DWORD 1
} SG_PACK BE_TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_AMAP, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_AMAP;



typedef union {
   BE_TCP_CONNECT_AND_OFFLOAD_PARAMS_IN_AMAP request;
   BE_TCP_CONNECT_AND_OFFLOAD_PARAMS_OUT_AMAP response;
} SG_PACK BE_TCP_CONNECT_AND_OFFLOAD_PARAMS_AMAP;
typedef struct { u32 dw[12]; } TCP_CONNECT_AND_OFFLOAD_PARAMS_AMAP, *PTCP_CONNECT_AND_OFFLOAD_PARAMS_AMAP;


//                  This Ioctl is used by drivers  to request the ARM firmware            
//     to open a TCP connection to the specified IP and tcp port number.                 
// Once the TCP connection	is established, it can be optionally offloaded.                
//                  <br>                 <b>Originator(s)</b> : Driver                
// <br>                 <b>Implemented in</b>: Firmware                 <br>              
//   <b>Return Values</b> :  <ul>                                        
// <li>MGMT_STATUS_SUCCESS                                         <li>MGMT_STATUS_FAILED 
//                                         <li>MGMT_STATUS_INVALID_CONNECTION             
//                            </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TCP_CONNECT_AND_OFFLOAD_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_AMAP;
typedef struct { u32 dw[16]; } IOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_AMAP, *PIOCTL_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD_AMAP;



typedef struct {
   BE_UEXACT32_AMAP connection_handle;
} SG_PACK BE_TCP_DISCONNECT_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } TCP_DISCONNECT_PARAMS_IN_AMAP, *PTCP_DISCONNECT_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_TCP_DISCONNECT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } TCP_DISCONNECT_PARAMS_OUT_AMAP, *PTCP_DISCONNECT_PARAMS_OUT_AMAP;



typedef union {
   BE_TCP_DISCONNECT_PARAMS_IN_AMAP request;
   BE_TCP_DISCONNECT_PARAMS_OUT_AMAP response;
} SG_PACK BE_TCP_DISCONNECT_AMAP;
typedef struct { u32 dw[1]; } TCP_DISCONNECT_AMAP, *PTCP_DISCONNECT_AMAP;


//                  This Ioctl is used by Drivers to request the ARM firmware             
//    to close an opened TCP connection.                 <br>                
// <b>Originator(s)</b> : Driver                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> :  <ul>     
//                                    <li>MGMT_STATUS_SUCCESS                             
//            <li>MGMT_STATUS_FAILED                                         
// <li>MGMT_STATUS_INVALID_CONNECTION                                         </ul>       
//      
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TCP_DISCONNECT_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ISCSI_TCP_DISCONNECT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ISCSI_TCP_DISCONNECT_AMAP, *PIOCTL_COMMON_ISCSI_TCP_DISCONNECT_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_iscsi_amap_h__

