/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_dcbx_amap_h__
#define __ioctl_dcbx_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- DCBX_PROTO_OUI ---
#define DCBX_PROTOCOL_OUI               (6945)    // DCBX protocol OUI defined by Intel 

typedef enum {
   ENUM_DCBX_PROTOCOL_OUI = 0x1b21UL
} DCBX_PROTO_OUI;

// --- DCBX_GLOBAL_STATE ---
#define DCBX_STATE_DISABLED             (0)       // DCBX is disabled. LLDP Tx state m.c
                                                  // is disabled. Rx may be disabled based
                                                  // on ICDS availability 
#define DCBX_STATE_ENABLED              (1)       // DCBX support is enabled in the ARM
                                                  // fw. Both Tx and Rx state are enabled
                                                  // in the LLDP state m/c 

typedef enum {
   ENUM_DCBX_STATE_DISABLED = 0x0UL,
   ENUM_DCBX_STATE_ENABLED = 0x1UL
} DCBX_GLOBAL_STATE;

// --- IOCTL_DCBX_FEATURE_STATE ---
#define IOCTL_DCBX_FEATURE_DISABLED     (0)       // This indicates DCBX feature is
                                                  // disabled 
#define IOCTL_DCBX_FEATURE_ENABLED      (1)       // This indicates DCBX feature is
                                                  // Enabled 
#define IOCTL_DCBX_FEATURE_ADVERTISED   (2)       // This indicates DCBX feature need to
                                                  // be Advertized 
#define IOCTL_DCBX_FEATURE_WILLING      (4)       // This indicates DCBX feature is
                                                  // willing to accept params from peer 
#define IOCTL_DCBX_FEATURE_SYNCED       (8)       // This indicates DCBX feature is Synced
#define IOCTL_DCBX_FEATURE_ERROR        (2147483648) // This indicates DCBX feature is
                                                     // ERROR in negotiation 

typedef enum {
   ENUM_IOCTL_DCBX_FEATURE_DISABLED = 0x0UL,
   ENUM_IOCTL_DCBX_FEATURE_ENABLED = 0x1UL,
   ENUM_IOCTL_DCBX_FEATURE_ADVERTISED = 0x2UL,
   ENUM_IOCTL_DCBX_FEATURE_WILLING = 0x4UL,
   ENUM_IOCTL_DCBX_FEATURE_SYNCED = 0x8UL,
   ENUM_IOCTL_DCBX_FEATURE_ERROR = 0x80000000UL
} IOCTL_DCBX_FEATURE_STATE;

// --- DCBX_MAX_SUPPORTED_TRAFFIC_CLASSES ---
#define DCBX_MAX_TRAFFIC_CLASSES        (8)       // Max Traffic Classes supported 

typedef enum {
   ENUM_DCBX_MAX_TRAFFIC_CLASSES = 0x8UL
} DCBX_MAX_SUPPORTED_TRAFFIC_CLASSES;

// --- DCBX_MAX_SUPPORTED_USER_PRIORITIES ---
#define DCBX_MAX_USER_PRIORITIES        (8)       // Max User Priority supported this
                                                  // limitation came from 3 bit VLAN
                                                  // priority 

typedef enum {
   ENUM_DCBX_MAX_USER_PRIORITIES = 0x8UL
} DCBX_MAX_SUPPORTED_USER_PRIORITIES;

// --- DCBX_MAX_SUPPORTED_BW_GROUPS ---
#define DCBX_MAX_BW_GROUPS              (8)       // Max Bandwidth Groups supported 

typedef enum {
   ENUM_DCBX_MAX_BW_GROUPS = 0x8UL
} DCBX_MAX_SUPPORTED_BW_GROUPS;

// --- DCBX_MAX_SUPPORTED_APP_PROTOCOLS ---
#define DCBX_MAX_APP_PROTOCOLS          (15)      // MAX number of Application protocols
                                                  // supported 

typedef enum {
   ENUM_DCBX_MAX_APP_PROTOCOLS = 0xfUL
} DCBX_MAX_SUPPORTED_APP_PROTOCOLS;

// --- DCBX_APP_PROTOCOL_SELECTORS ---
#define DCBX_APP_PROTOCOL_SELECTOR_ETHER_TYPE (0) // Layer 2 Ether Type 
#define DCBX_APP_PROTOCOL_SELECTOR_TCPUDP_PORT (1) // Layer 4 TCP/UDP Port 

typedef enum {
   ENUM_DCBX_APP_PROTOCOL_SELECTOR_ETHER_TYPE = 0x0UL,
   ENUM_DCBX_APP_PROTOCOL_SELECTOR_TCPUDP_PORT = 0x1UL
} DCBX_APP_PROTOCOL_SELECTORS;

// --- DCBX_APP_PROTOCOL_STATE ---
#define DCBX_APP_PROTOCOL_DISABLED      (0)       
#define DCBX_APP_PROTOCOL_ENABLED       (1)       

typedef enum {
   ENUM_DCBX_APP_PROTOCOL_DISABLED = 0x0UL,
   ENUM_DCBX_APP_PROTOCOL_ENABLED = 0x1UL
} DCBX_APP_PROTOCOL_STATE;

// --- DCBX_PRIORITY_SETTINGS ---
#define DCBX_PRIORITY_SETTINGS_NO_STRICT (0)      // No strict priority 
#define DCBX_PRIORITY_SETTINGS_GROUP_STRICT (1)   // Group Strict Priority (GSP) 
#define DCBX_PRIORITY_SETTINGS_LINK_STRICT (2)    // Link Strict Priority (LSP) 

typedef enum {
   ENUM_DCBX_PRIORITY_SETTINGS_NO_STRICT = 0x0UL,
   ENUM_DCBX_PRIORITY_SETTINGS_GROUP_STRICT = 0x1UL,
   ENUM_DCBX_PRIORITY_SETTINGS_LINK_STRICT = 0x2UL
} DCBX_PRIORITY_SETTINGS;

// --- DCBX_PARAM_TYPE ---
#define DCBX_PARAM_TYPE_ADMIN           (0)       // Parameters set by Admin 
#define DCBX_PARAM_TYPE_OPERATIONAL     (1)       // Operational parameters. 
#define DCBX_PARAM_TYPE_PEER            (2)       // Peer Parameters 

typedef enum {
   ENUM_DCBX_PARAM_TYPE_ADMIN = 0x0UL,
   ENUM_DCBX_PARAM_TYPE_OPERATIONAL = 0x1UL,
   ENUM_DCBX_PARAM_TYPE_PEER = 0x2UL
} DCBX_PARAM_TYPE;

// --- DCBX_OPERATIONAL_PARAMS ---
#define DCBX_OPERATIONAL_PARAMS_INVALID (0)       // A remote dcbx-enabled switch hasn't
                                                  // responde to DCBX TLVs within the
                                                  // timeout period All opertional
                                                  // parameters retrieved with
                                                  // parameter_type =
                                                  // DCBX_PARAM_TYPE_OPERATIONAL are
                                                  // invalid 
#define DCBX_OPERATIONAL_PARAMS_VALID   (1)       // All opertional parameters retrieved
                                                  // with parameter_type =
                                                  // DCBX_PARAM_TYPE_OPERATIONAL are valid

typedef enum {
   ENUM_DCBX_OPERATIONAL_PARAMS_INVALID = 0x0UL,
   ENUM_DCBX_OPERATIONAL_PARAMS_VALID = 0x1UL
} DCBX_OPERATIONAL_PARAMS;

//              
typedef struct {
   BE_UEXACT8_AMAP bwg_id;
   BE_UEXACT8_AMAP bw_percentage;
   BE_UEXACT8_AMAP strict_priority;
   BE_UEXACT8_AMAP not_used;
} SG_PACK BE_DCBX_PG_SETTINGS_AMAP;
typedef struct { u32 dw[1]; } DCBX_PG_SETTINGS_AMAP, *PDCBX_PG_SETTINGS_AMAP;



typedef struct {
   BE_UEXACT8_AMAP bwg_percentage[8];
   BE_DCBX_PG_SETTINGS_AMAP pg_up_settings[8];
} SG_PACK BE_DCBX_PRIORITY_IN_BWG_AMAP;
typedef struct { u32 dw[10]; } DCBX_PRIORITY_IN_BWG_AMAP, *PDCBX_PRIORITY_IN_BWG_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pfc_settings[8];
} SG_PACK BE_DCBX_PFC_SETTINGS_AMAP;
typedef struct { u32 dw[2]; } DCBX_PFC_SETTINGS_AMAP, *PDCBX_PFC_SETTINGS_AMAP;



typedef struct {
   BE_UEXACT16_AMAP app_protocol_id;
   BE_UEXACT8_AMAP protocol_selector;
   BE_UEXACT8_AMAP valid;
   BE_UEXACT32_AMAP oui;
   BE_UEXACT8_AMAP user_priority[8];
} SG_PACK BE_DCBX_APP_SETTINGS_AMAP;
typedef struct { u32 dw[4]; } DCBX_APP_SETTINGS_AMAP, *PDCBX_APP_SETTINGS_AMAP;



typedef struct {
   BE_UEXACT8_AMAP parameter_type;
} SG_PACK BE_DCBX_GET_DCBX_CFG_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } DCBX_GET_DCBX_CFG_PARAMS_IN_AMAP, *PDCBX_GET_DCBX_CFG_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP dcbx_state;
   BE_UEXACT8_AMAP dcbx_operational_params_valid;
   BE_UEXACT8_AMAP num_app_entries_valid;
   BE_UEXACT8_AMAP num_pgs_supported;
   BE_UEXACT32_AMAP pg_state;
   BE_UEXACT32_AMAP pfc_state;
   BE_UEXACT32_AMAP bcn_state;
   BE_UEXACT32_AMAP appl_state;
   BE_UEXACT32_AMAP logical_link_state;
   BE_DCBX_PRIORITY_IN_BWG_AMAP priority_in_bwg;
   BE_DCBX_PFC_SETTINGS_AMAP pfc;
   BE_DCBX_APP_SETTINGS_AMAP app_settings[15];
} SG_PACK BE_DCBX_GET_DCBX_CFG_PARAMS_OUT_AMAP;
typedef struct { u32 dw[78]; } DCBX_GET_DCBX_CFG_PARAMS_OUT_AMAP, *PDCBX_GET_DCBX_CFG_PARAMS_OUT_AMAP;



typedef union {
   BE_DCBX_GET_DCBX_CFG_PARAMS_IN_AMAP request;
   BE_DCBX_GET_DCBX_CFG_PARAMS_OUT_AMAP response;
} SG_PACK BE_DCBX_GET_DCBX_CFG_PARAMS_AMAP;
typedef struct { u32 dw[78]; } DCBX_GET_DCBX_CFG_PARAMS_AMAP, *PDCBX_GET_DCBX_CFG_PARAMS_AMAP;


//            This Ioctl should be issued by drivers to get the current DCBX settings in
// the BE firmware.           Two types of parameters can retrieved            <ul>       
//      <li> Parameter set by the administrator of this node using the                   
// [link]IOCTL_DCBX_SET_DCBX_CFG[/link]           </ul> Operational parameters after
// 'negotiation' with remote switch           The ioctl STATUS is always
// [link]MGMT_STATUS_SUCCESS[/link].        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DCBX_GET_DCBX_CFG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_DCBX_GET_DCBX_CFG_AMAP;
typedef struct { u32 dw[82]; } IOCTL_DCBX_GET_DCBX_CFG_AMAP, *PIOCTL_DCBX_GET_DCBX_CFG_AMAP;



typedef struct {
   BE_UEXACT8_AMAP dcbx_state;
   BE_UEXACT8_AMAP num_app_entries_valid;
   BE_UEXACT8_AMAP unused[2];
   BE_UEXACT32_AMAP pg_state;
   BE_UEXACT32_AMAP pfc_state;
   BE_UEXACT32_AMAP bcn_state;
   BE_UEXACT32_AMAP appl_state;
   BE_UEXACT32_AMAP logical_link_state;
   BE_DCBX_PRIORITY_IN_BWG_AMAP priority_in_bwg;
   BE_DCBX_PFC_SETTINGS_AMAP pfc;
   BE_DCBX_APP_SETTINGS_AMAP app_settings[15];
} SG_PACK BE_DCBX_SET_DCBX_CFG_PARAMS_IN_AMAP;
typedef struct { u32 dw[78]; } DCBX_SET_DCBX_CFG_PARAMS_IN_AMAP, *PDCBX_SET_DCBX_CFG_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_DCBX_SET_DCBX_CFG_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } DCBX_SET_DCBX_CFG_PARAMS_OUT_AMAP, *PDCBX_SET_DCBX_CFG_PARAMS_OUT_AMAP;



typedef union {
   BE_DCBX_SET_DCBX_CFG_PARAMS_IN_AMAP request;
   BE_DCBX_SET_DCBX_CFG_PARAMS_OUT_AMAP response;
} SG_PACK BE_DCBX_SET_DCBX_CFG_PARAMS_AMAP;
typedef struct { u32 dw[78]; } DCBX_SET_DCBX_CFG_PARAMS_AMAP, *PDCBX_SET_DCBX_CFG_PARAMS_AMAP;


//          This Ioctl should be issued by drivers to enable/disable DCBX support in the
// ARM f/w         Management software is expected to do a read-modify-write of the
// parameters         by changing the required fields in the response from a call to      
//    [link]IOCTL_DCBX_GET_DCBX_CFG[/link].          The ioctl STATUS is always
// [link]MGMT_STATUS_SUCCESS[/link].      
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DCBX_SET_DCBX_CFG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_DCBX_SET_DCBX_CFG_AMAP;
typedef struct { u32 dw[82]; } IOCTL_DCBX_SET_DCBX_CFG_AMAP, *PIOCTL_DCBX_SET_DCBX_CFG_AMAP;



typedef struct {
   BE_UEXACT8_AMAP port_number;
   BE_UEXACT8_AMAP port_enable;
   BE_UEXACT8_AMAP port_operating_version;
   BE_UEXACT8_AMAP port_max_version;
   BE_UEXACT32_AMAP sequence_number;
   BE_UEXACT32_AMAP ack_number;
   BE_UEXACT32_AMAP Peer_sequence_number;
   BE_UEXACT32_AMAP peer_ack_number;
   BE_BIT rsvd0[4][32];                           // DWORD 5
} SG_PACK BE_DCBX_PORT_VARS_AMAP;
typedef struct { u32 dw[9]; } DCBX_PORT_VARS_AMAP, *PDCBX_PORT_VARS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP app_feature_sequence_number;
   BE_UEXACT32_AMAP pg_feature_sequence_number;
   BE_UEXACT32_AMAP pfc_feature_sequence_number;
   BE_BIT rsvd0[4][32];                           // DWORD 3
} SG_PACK BE_DCBX_FEATURE_VARS_AMAP;
typedef struct { u32 dw[7]; } DCBX_FEATURE_VARS_AMAP, *PDCBX_FEATURE_VARS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_tx_packets;
   BE_UEXACT32_AMAP num_rx_packets;
   BE_UEXACT32_AMAP num_error_packets;
   BE_UEXACT32_AMAP num_packets_dropped;
   BE_UEXACT32_AMAP num_packets_pocessed;
   BE_UEXACT32_AMAP num_local_params_changed;
   BE_UEXACT32_AMAP num_remote_params_changed;
   BE_BIT rsvd0[4][32];                           // DWORD 7
} SG_PACK BE_DCBX_STATISTICS_AMAP;
typedef struct { u32 dw[11]; } DCBX_STATISTICS_AMAP, *PDCBX_STATISTICS_AMAP;


// --- IOCTL_DCBX_LOCAL_OPCODES ---
#define IOCTL_DCBX_PG_FEATURE           (0)       // Priority Group 
#define IOCTL_DCBX_PFC_FEATURE          (1)       // Priority Flow Control 
#define IOCTL_DCBX_BCN_FEATURE          (2)       // Backword Congetion 
#define IOCTL_DCBX_APP_FEATURE          (3)       // Application Feature 
#define IOCTL_DCBX_LLD_FEATURE          (4)       // Logical Link down 
#define IOCTL_DCBX_NV_FEATURE           (5)       // Network virtualization 

typedef enum {
   ENUM_IOCTL_DCBX_PG_FEATURE = 0x0UL,
   ENUM_IOCTL_DCBX_PFC_FEATURE = 0x1UL,
   ENUM_IOCTL_DCBX_BCN_FEATURE = 0x2UL,
   ENUM_IOCTL_DCBX_APP_FEATURE = 0x3UL,
   ENUM_IOCTL_DCBX_LLD_FEATURE = 0x4UL,
   ENUM_IOCTL_DCBX_NV_FEATURE = 0x5UL
} IOCTL_DCBX_LOCAL_OPCODES;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_DCBX_MIB_INFO_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_DCBX_MIB_INFO_PARAMS_IN_AMAP, *PGET_DCBX_MIB_INFO_PARAMS_IN_AMAP;



typedef struct {
   BE_DCBX_PORT_VARS_AMAP port_vars;
   BE_DCBX_FEATURE_VARS_AMAP feature_vars;
   BE_DCBX_STATISTICS_AMAP dcbx_stats;
} SG_PACK BE_GET_DCBX_MIB_INFO_PARAMS_OUT_AMAP;
typedef struct { u32 dw[27]; } GET_DCBX_MIB_INFO_PARAMS_OUT_AMAP, *PGET_DCBX_MIB_INFO_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_DCBX_MIB_INFO_PARAMS_IN_AMAP request;
   BE_GET_DCBX_MIB_INFO_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_DCBX_MIB_INFO_PARAMS_AMAP;
typedef struct { u32 dw[27]; } GET_DCBX_MIB_INFO_PARAMS_AMAP, *PGET_DCBX_MIB_INFO_PARAMS_AMAP;


//           This Ioctl should be issued by drivers to get all the parameters required to
// build         the DCBX MIB.        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_DCBX_MIB_INFO_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_DCBX_GET_DCBX_MIB_INFO_AMAP;
typedef struct { u32 dw[31]; } IOCTL_DCBX_GET_DCBX_MIB_INFO_AMAP, *PIOCTL_DCBX_GET_DCBX_MIB_INFO_AMAP;


// --- DCBX_MODE ---
#define DCBX_MODE_CEE                   (0)       // This implementation of DCBX follows
                                                  // the (new) CEE author's spec
#define DCBX_MODE_CIN                   (1)       // This implementation of DCBX follows
                                                  // the (old) Cisco/Intel/Nouvo spec 

typedef enum {
   ENUM_DCBX_MODE_CEE = 0x0UL,
   ENUM_DCBX_MODE_CIN = 0x1UL
} DCBX_MODE;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_DCBX_GET_DCBX_MODE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } DCBX_GET_DCBX_MODE_PARAMS_IN_AMAP, *PDCBX_GET_DCBX_MODE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP dcbx_mode;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_DCBX_GET_DCBX_MODE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } DCBX_GET_DCBX_MODE_PARAMS_OUT_AMAP, *PDCBX_GET_DCBX_MODE_PARAMS_OUT_AMAP;



typedef union {
   BE_DCBX_GET_DCBX_MODE_PARAMS_IN_AMAP request;
   BE_DCBX_GET_DCBX_MODE_PARAMS_OUT_AMAP response;
} SG_PACK BE_DCBX_GET_DCBX_MODE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } DCBX_GET_DCBX_MODE_PARAMS_AMAP, *PDCBX_GET_DCBX_MODE_PARAMS_AMAP;


//              The DCBX protocol can be used in one of two modes - 'CIN'
// (Cisco/Intel/Nuovo) or in the 'CEE authors'              (the newer spec). By default,
// the ARM firmware assumes the CEE mode of operation. However, it can             be
// forced to use the CIN mode as default. Use this IOCTL to determine the current mode for
// a given port.         
typedef struct {
   BE_DCBX_GET_DCBX_MODE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_DCBX_GET_DCBX_MODE_AMAP;
typedef struct { u32 dw[1]; } IOCTL_DCBX_GET_DCBX_MODE_AMAP, *PIOCTL_DCBX_GET_DCBX_MODE_AMAP;



typedef struct {
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_AMAP dcbx_mode;
   BE_BIT rsvd1[2][8];                            // DWORD 0
} SG_PACK BE_DCBX_SET_DCBX_MODE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } DCBX_SET_DCBX_MODE_PARAMS_IN_AMAP, *PDCBX_SET_DCBX_MODE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_DCBX_SET_DCBX_MODE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } DCBX_SET_DCBX_MODE_PARAMS_OUT_AMAP, *PDCBX_SET_DCBX_MODE_PARAMS_OUT_AMAP;



typedef union {
   BE_DCBX_SET_DCBX_MODE_PARAMS_IN_AMAP request;
   BE_DCBX_SET_DCBX_MODE_PARAMS_OUT_AMAP response;
} SG_PACK BE_DCBX_SET_DCBX_MODE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } DCBX_SET_DCBX_MODE_PARAMS_AMAP, *PDCBX_SET_DCBX_MODE_PARAMS_AMAP;


//              The DCBX protocol can be used in one of two modes - 'CIN'
// (Cisco/Intel/Nuovo) or in the 'CEE authors'              (the newer spec). By default,
// the ARM firmware assumes the CEE mode of operation. However, it can             be
// forced to either of these modes using this IOCTL.         
typedef struct {
   BE_DCBX_SET_DCBX_MODE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_DCBX_SET_DCBX_MODE_AMAP;
typedef struct { u32 dw[1]; } IOCTL_DCBX_SET_DCBX_MODE_AMAP, *PIOCTL_DCBX_SET_DCBX_MODE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_dcbx_amap_h__

