/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_dmtf_amap_h__
#define __ioctl_dmtf_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- IOCTL_DMTF_CLP_STATUS_CODES ---
#define DMTF_CLP_CMD_COMPLETED_SUCCESS  (0)       
#define DMTF_CLP_CMD_SPAWNED            (1)       
#define DMTF_CLP_CMD_PROCESSING_FAILED  (2)       
#define DMTF_CLP_CMD_EXECUTION_FAILED   (3)       

typedef enum {
   ENUM_DMTF_CLP_CMD_COMPLETED_SUCCESS = 0x0UL,
   ENUM_DMTF_CLP_CMD_SPAWNED = 0x1UL,
   ENUM_DMTF_CLP_CMD_PROCESSING_FAILED = 0x2UL,
   ENUM_DMTF_CLP_CMD_EXECUTION_FAILED = 0x3UL
} IOCTL_DMTF_CLP_STATUS_CODES;

// --- IOCTL_DMTF_CLP_DETAILED_STATUS_CODES ---
#define DMTF_CLP_CMD_QUEUE_FULL         (244)     
#define DMTF_CLP_CMD_REQUIRED_OPTION_MISSING (245) 
#define DMTF_CLP_CMD_INVALID_TARGET     (246)     
#define DMTF_CLP_CMD_OPTION_NOT_SUPPORTED (247)   
#define DMTF_CLP_CMD_MISSING_ARGUMENT   (248)     
#define DMTF_CLP_CMD_OUTPUT_FORMAT_NOT_SUPPORTED (249) 
#define DMTF_CLP_CMD_INVALID_ARGUMENT   (250)     
#define DMTF_CLP_CMD_INVALID_OPTION     (251)     
#define DMTF_CLP_CMD_SYNTAX_ERROR       (252)     
#define DMTF_CLP_CMD_NOT_RECOGNIZED     (253)     
#define DMTF_CLP_CMD_NOT_SUPPORTED      (254)     
#define DMTF_CLP_CMD_ERROR_NOT_SPECIFIED (255)    

typedef enum {
   ENUM_DMTF_CLP_CMD_QUEUE_FULL = 0xf4UL,
   ENUM_DMTF_CLP_CMD_REQUIRED_OPTION_MISSING = 0xf5UL,
   ENUM_DMTF_CLP_CMD_INVALID_TARGET = 0xf6UL,
   ENUM_DMTF_CLP_CMD_OPTION_NOT_SUPPORTED = 0xf7UL,
   ENUM_DMTF_CLP_CMD_MISSING_ARGUMENT = 0xf8UL,
   ENUM_DMTF_CLP_CMD_OUTPUT_FORMAT_NOT_SUPPORTED = 0xf9UL,
   ENUM_DMTF_CLP_CMD_INVALID_ARGUMENT = 0xfaUL,
   ENUM_DMTF_CLP_CMD_INVALID_OPTION = 0xfbUL,
   ENUM_DMTF_CLP_CMD_SYNTAX_ERROR = 0xfcUL,
   ENUM_DMTF_CLP_CMD_NOT_RECOGNIZED = 0xfdUL,
   ENUM_DMTF_CLP_CMD_NOT_SUPPORTED = 0xfeUL,
   ENUM_DMTF_CLP_CMD_ERROR_NOT_SPECIFIED = 0xffUL
} IOCTL_DMTF_CLP_DETAILED_STATUS_CODES;

// --- IOCTL_DMTF_CLP_EXECUTION_TYPE_CODE ---
#define DMTF_CLP_SPECIFIC_EXECUTION_CODE (0)      
#define DMTF_CLP_OEM_SPECIFIC_EXECUTION_CODE (1)  

typedef enum {
   ENUM_DMTF_CLP_SPECIFIC_EXECUTION_CODE = 0x0UL,
   ENUM_DMTF_CLP_OEM_SPECIFIC_EXECUTION_CODE = 0x1UL
} IOCTL_DMTF_CLP_EXECUTION_TYPE_CODE;

// --- IOCTL_DMTF_CLP_EXECUTION_ERROR_CODES ---
#define DMTF_CLP_EXEC_UNKNOWN_ERROR     (0)       
#define DMTF_CLP_EXEC_OTHER_ERROR       (1)       
#define DMTF_CLP_EXEC_COMMUNICATION_ERROR (2)     
#define DMTF_CLP_EXEC_QOS_ERROR         (3)       
#define DMTF_CLP_EXEC_SOFTWARE_ERROR    (4)       
#define DMTF_CLP_EXEC_HARDWARE_ERROR    (5)       
#define DMTF_CLP_EXEC_ENVIRONMENT_ERROR (6)       
#define DMTF_CLP_EXEC_SECURITY_ERROR    (7)       
#define DMTF_CLP_EXEC_OVER_SUBSCRIPTION_ERROR (8) 
#define DMTF_CLP_EXEC_UNAVAILABLE_RESOURCE_ERROR (9) 
#define DMTF_CLP_EXEC_UNSUPPORTED_OPERATION_ERROR (10) 

typedef enum {
   ENUM_DMTF_CLP_EXEC_UNKNOWN_ERROR = 0x0UL,
   ENUM_DMTF_CLP_EXEC_OTHER_ERROR = 0x1UL,
   ENUM_DMTF_CLP_EXEC_COMMUNICATION_ERROR = 0x2UL,
   ENUM_DMTF_CLP_EXEC_QOS_ERROR = 0x3UL,
   ENUM_DMTF_CLP_EXEC_SOFTWARE_ERROR = 0x4UL,
   ENUM_DMTF_CLP_EXEC_HARDWARE_ERROR = 0x5UL,
   ENUM_DMTF_CLP_EXEC_ENVIRONMENT_ERROR = 0x6UL,
   ENUM_DMTF_CLP_EXEC_SECURITY_ERROR = 0x7UL,
   ENUM_DMTF_CLP_EXEC_OVER_SUBSCRIPTION_ERROR = 0x8UL,
   ENUM_DMTF_CLP_EXEC_UNAVAILABLE_RESOURCE_ERROR = 0x9UL,
   ENUM_DMTF_CLP_EXEC_UNSUPPORTED_OPERATION_ERROR = 0xaUL
} IOCTL_DMTF_CLP_EXECUTION_ERROR_CODES;


typedef struct {
   BE_UEXACT32_AMAP cmd_buf_len;
   BE_UEXACT32_AMAP resp_buf_len;
   BE_UEXACT64_AMAP command_buffer;
   BE_UEXACT64_AMAP response_buffer;
} SG_PACK BE_DMTF_CLP_CMD_PARAMS_IN_AMAP;
typedef struct { u32 dw[6]; } DMTF_CLP_CMD_PARAMS_IN_AMAP, *PDMTF_CLP_CMD_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_UEXACT32_AMAP actual_resp_buf_len;
   BE_BIT rsvd1[64];                              // DWORD 2
   BE_UEXACT64_AMAP response_buffer;
   BE_UEXACT32_AMAP clp_status;
   BE_UEXACT32_AMAP clp_detailed_status;
} SG_PACK BE_DMTF_CLP_CMD_PARAMS_OUT_AMAP;
typedef struct { u32 dw[8]; } DMTF_CLP_CMD_PARAMS_OUT_AMAP, *PDMTF_CLP_CMD_PARAMS_OUT_AMAP;



typedef union {
   BE_DMTF_CLP_CMD_PARAMS_IN_AMAP request;
   BE_DMTF_CLP_CMD_PARAMS_OUT_AMAP response;
} SG_PACK BE_DMTF_CLP_CMD_PARAMS_AMAP;
typedef struct { u32 dw[8]; } DMTF_CLP_CMD_PARAMS_AMAP, *PDMTF_CLP_CMD_PARAMS_AMAP;


//            This Ioctl should be issued by Option ROM BIOS to execute the DMTF specifc  
//         Command Line Protocol (CLP) command by the ARMFW. ARMFW will execute this      
//     command and DMAs the response back in the response buffer and updates the          
//  response length, clp_status and clp_detailed_status accordingly.                  
// [link]IOCTL_DMTF_CLP_CMD_PARAMS[/link].                 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DMTF_CLP_CMD_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_DMTF_CLP_CMD_PARAMS_AMAP;
typedef struct { u32 dw[12]; } IOCTL_DMTF_CLP_CMD_PARAMS_AMAP, *PIOCTL_DMTF_CLP_CMD_PARAMS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_dmtf_amap_h__

