/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_hdr_amap_h__
#define __ioctl_hdr_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_defs.h"
#include "ioctl_opcodes.h"
#include "fat_header.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT8_AMAP opcode;
   BE_UEXACT8_AMAP subsystem;
   BE_UEXACT8_AMAP port_number;
   BE_UEXACT8_AMAP domain;
   BE_UEXACT32_AMAP timeout;
   BE_UEXACT32_AMAP request_length;
   BE_UEXACT8_AMAP version;
   BE_BIT rsvd0[3][8];                            // DWORD 3
} SG_PACK BE_IOCTL_REQUEST_HEADER_AMAP;
typedef struct { u32 dw[4]; } IOCTL_REQUEST_HEADER_AMAP, *PIOCTL_REQUEST_HEADER_AMAP;



typedef struct {
   BE_UEXACT8_AMAP opcode;
   BE_UEXACT8_AMAP subsystem;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_AMAP domain;
   BE_UEXACT8_AMAP status;
   BE_UEXACT8_AMAP additional_status;
   BE_BIT rsvd1[16];                              // DWORD 1
   BE_UEXACT32_AMAP response_length;
   BE_UEXACT32_AMAP actual_response_length;
} SG_PACK BE_IOCTL_RESPONSE_HEADER_AMAP;
typedef struct { u32 dw[4]; } IOCTL_RESPONSE_HEADER_AMAP, *PIOCTL_RESPONSE_HEADER_AMAP;


//              The firmware/driver overwrites the input IOCTL_REQUEST_HEADER with the
// output              IOCTL_RESPONSE_HEADER.         
typedef union {
   BE_IOCTL_REQUEST_HEADER_AMAP request;
   BE_IOCTL_RESPONSE_HEADER_AMAP response;
} SG_PACK BE_IOCTL_HEADER_AMAP;
typedef struct { u32 dw[4]; } IOCTL_HEADER_AMAP, *PIOCTL_HEADER_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_hdr_amap_h__

