/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_ibft_amap_h__
#define __ioctl_ibft_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- IBFT_STRUCTURE_TYPE_ID ---
#define IBFT_STRUCTURE_TYPE_RESERVED    (0)       // opcode for reserved iBFT structure 
#define IBFT_STRUCTURE_TYPE_CONTROL     (1)       // opcode for control iBFT structure 
#define IBFT_STRUCTURE_TYPE_INITIATOR   (2)       // opcode for initiator iBFT structure 
#define IBFT_STRUCTURE_TYPE_NIC         (3)       // opcode for NIC iBFT structure 
#define IBFT_STRUCTURE_TYPE_TARGET      (4)       // opcode for Target iBFT structure 
#define IBFT_STRUCTURE_TYPE_EXTENSIONS  (5)       // opcode for Extensions iBFT structure 

typedef enum {
   ENUM_IBFT_STRUCTURE_TYPE_RESERVED = 0x0UL,
   ENUM_IBFT_STRUCTURE_TYPE_CONTROL = 0x1UL,
   ENUM_IBFT_STRUCTURE_TYPE_INITIATOR = 0x2UL,
   ENUM_IBFT_STRUCTURE_TYPE_NIC = 0x3UL,
   ENUM_IBFT_STRUCTURE_TYPE_TARGET = 0x4UL,
   ENUM_IBFT_STRUCTURE_TYPE_EXTENSIONS = 0x5UL
} IBFT_STRUCTURE_TYPE_ID;

// --- IBFT_SUPPORTED_STRUCTURE_VERSION ---
#define IBFT_STRUCTURE_VERSION          (1)       // Current structure version supported 

typedef enum {
   ENUM_IBFT_STRUCTURE_VERSION = 0x1UL
} IBFT_SUPPORTED_STRUCTURE_VERSION;

// --- IBFT_SUPPORTED_TABLE_REVISION ---
#define IBFT_TABLE_REVISION             (1)       // Current structure version supported 

typedef enum {
   ENUM_IBFT_TABLE_REVISION = 0x1UL
} IBFT_SUPPORTED_TABLE_REVISION;

// --- IBFT_CONTROL_STRUCTURE_FLAGS ---
#define IBFT_MULTI_LOGIN_MODE           (0)       // all the targets will be logged in
#define IBFT_SINGLE_LOGIN_MODE          (1)       // only one target is logged in 

typedef enum {
   ENUM_IBFT_MULTI_LOGIN_MODE = 0x0UL,
   ENUM_IBFT_SINGLE_LOGIN_MODE = 0x1UL
} IBFT_CONTROL_STRUCTURE_FLAGS;

// --- IBFT_INITIATOR_FLAGS ---
#define IBFT_INITIATOR_BLOCK_VALID_FLAG (1)       // Block valid flag 
#define IBFT_INITIATOR_FW_BOOT_SELECTED_FLAG (2)  // This initiator is selected for Boot 

typedef enum {
   ENUM_IBFT_INITIATOR_BLOCK_VALID_FLAG = 0x1UL,
   ENUM_IBFT_INITIATOR_FW_BOOT_SELECTED_FLAG = 0x2UL
} IBFT_INITIATOR_FLAGS;

// --- IBFT_TARGET_FLAGS ---
#define IBFT_TARGET_BLOCK_VALID_FLAG    (1)       // Block valid flag 
#define IBFT_TARGET_FW_BOOT_SELECTED_FLAG (2)     // This target is selected for Boot 
#define IBFT_TARGET_USE_RADIUS_CHAP     (4)       // Use Radius CHAP 
#define IBFT_TARGET_USE_RADIUS_REVERSE_CHAP (8)   // Use Radius Reverse CHAP 

typedef enum {
   ENUM_IBFT_TARGET_BLOCK_VALID_FLAG = 0x1UL,
   ENUM_IBFT_TARGET_FW_BOOT_SELECTED_FLAG = 0x2UL,
   ENUM_IBFT_TARGET_USE_RADIUS_CHAP = 0x4UL,
   ENUM_IBFT_TARGET_USE_RADIUS_REVERSE_CHAP = 0x8UL
} IBFT_TARGET_FLAGS;

// --- IBFT_NIC_FLAGS ---
#define IBFT_NIC_BLOCK_VALID_FLAG       (1)       // Block valid flag 
#define IBFT_NIC_FW_BOOT_SELECTED_FLAG  (2)       // This NIC is selected for Boot 
#define IBFT_NIC_LINK_GLOBAL_FLAG       (4)       // Link Local Flag or Global Link Flag 

typedef enum {
   ENUM_IBFT_NIC_BLOCK_VALID_FLAG = 0x1UL,
   ENUM_IBFT_NIC_FW_BOOT_SELECTED_FLAG = 0x2UL,
   ENUM_IBFT_NIC_LINK_GLOBAL_FLAG = 0x4UL
} IBFT_NIC_FLAGS;

// --- IBFT_CHAP_METHODS ---
#define IBFT_NO_CHAP                    (0)       // no chap 
#define IBFT_NORMAL_CHAP                (1)       // enable chap 
#define IBFT_MUTUAL_CHAP                (2)       // enable mutual chap 

typedef enum {
   ENUM_IBFT_NO_CHAP = 0x0UL,
   ENUM_IBFT_NORMAL_CHAP = 0x1UL,
   ENUM_IBFT_MUTUAL_CHAP = 0x2UL
} IBFT_CHAP_METHODS;

// --- IBFT_MAX_SUPPORTED_NICS ---
#define IBFT_MAX_NICS                   (1)       // Max number of NICS on which iBFT is
                                                  // supported 

typedef enum {
   ENUM_IBFT_MAX_NICS = 0x1UL
} IBFT_MAX_SUPPORTED_NICS;

// --- IBFT_MAX_SUPPORTED_TARGETS ---
#define IBFT_MAX_TARGETS                (2)       // Max number of TARGETS supported 

typedef enum {
   ENUM_IBFT_MAX_TARGETS = 0x2UL
} IBFT_MAX_SUPPORTED_TARGETS;

// --- IBFT_MAX_INITIATOR_STRING_NAME ---
#define IBFT_MAX_INITIATOR_NAME         (256)     // Max initiator string name length 

typedef enum {
   ENUM_IBFT_MAX_INITIATOR_NAME = 0x100UL
} IBFT_MAX_INITIATOR_STRING_NAME;

// --- IBFT_MAX_TARGET_STRING_NAME ---
#define IBFT_MAX_TARGET_NAME            (256)     // Max target string name length 

typedef enum {
   ENUM_IBFT_MAX_TARGET_NAME = 0x100UL
} IBFT_MAX_TARGET_STRING_NAME;


typedef struct {
   BE_UEXACT8_AMAP structure_id;
   BE_UEXACT8_AMAP version;
   BE_UEXACT16_AMAP length;
   BE_UEXACT8_AMAP index;
   BE_UEXACT8_AMAP flags;
} SG_PACK BE_IBFT_STANDARD_STRUCTURE_HEADER_AMAP;
typedef struct { u32 dw[2]; } IBFT_STANDARD_STRUCTURE_HEADER_AMAP, *PIBFT_STANDARD_STRUCTURE_HEADER_AMAP;



typedef struct {
   BE_EXACT8_AMAP signature[4];
   BE_UEXACT32_AMAP length;
   BE_UEXACT8_AMAP revision;
   BE_UEXACT8_AMAP checksum;
   BE_EXACT8_AMAP oem_id[6];
   BE_EXACT8_AMAP oem_table_id[8];
   BE_BIT rsvd0[24][8];                           // DWORD 6
} SG_PACK BE_IBFT_TABLE_HEADER_AMAP;
typedef struct { u32 dw[12]; } IBFT_TABLE_HEADER_AMAP, *PIBFT_TABLE_HEADER_AMAP;



typedef struct {
   BE_IBFT_STANDARD_STRUCTURE_HEADER_AMAP header;
   BE_UEXACT16_AMAP extensions;
   BE_UEXACT16_AMAP initiator_offset;
   BE_UEXACT16_AMAP nic0_offset;
   BE_UEXACT16_AMAP target0_offset;
   BE_UEXACT16_AMAP nic1_offset;
   BE_UEXACT16_AMAP target1_offset;
} SG_PACK BE_IBFT_CONTROL_STRUCTURE_AMAP;
typedef struct { u32 dw[5]; } IBFT_CONTROL_STRUCTURE_AMAP, *PIBFT_CONTROL_STRUCTURE_AMAP;



typedef struct {
   BE_IBFT_STANDARD_STRUCTURE_HEADER_AMAP header;
   BE_UEXACT8_AMAP isns_server[16];
   BE_UEXACT8_AMAP slp_server[16];
   BE_UEXACT8_AMAP pri_radius_server[16];
   BE_UEXACT8_AMAP sec_radius_server[16];
   BE_UEXACT16_AMAP initiator_name_length;
   BE_UEXACT16_AMAP initiator_name_offset;
} SG_PACK BE_IBFT_INITIATOR_STRUCTURE_AMAP;
typedef struct { u32 dw[19]; } IBFT_INITIATOR_STRUCTURE_AMAP, *PIBFT_INITIATOR_STRUCTURE_AMAP;



typedef struct {
   BE_IBFT_STANDARD_STRUCTURE_HEADER_AMAP header;
   BE_UEXACT8_AMAP ip_address[16];
   BE_UEXACT8_AMAP subnet_mask_prefix;
   BE_UEXACT8_AMAP origin;
   BE_UEXACT8_AMAP gateway_addreess[16];
   BE_UEXACT8_AMAP pri_dns_address[16];
   BE_UEXACT8_AMAP sec_dns_address[16];
   BE_UEXACT8_AMAP dhcp_ip_address[16];
   BE_UEXACT16_AMAP vlan_id;
   BE_UEXACT8_AMAP mac_address[6];
   BE_UEXACT16_AMAP pci_bdf;
   BE_UEXACT16_AMAP host_name_length;
   BE_UEXACT16_AMAP host_name_offset;
} SG_PACK BE_IBFT_NIC_STRUCTURE_AMAP;
typedef struct { u32 dw[26]; } IBFT_NIC_STRUCTURE_AMAP, *PIBFT_NIC_STRUCTURE_AMAP;



typedef struct {
   BE_IBFT_STANDARD_STRUCTURE_HEADER_AMAP header;
   BE_UEXACT8_AMAP ip_address[16];
   BE_UEXACT16_AMAP portnum;
   BE_UEXACT8_AMAP boot_lun[8];
   BE_UEXACT8_AMAP chap_method;
   BE_UEXACT8_AMAP nic_assosiation;
   BE_UEXACT16_AMAP target_name_length;
   BE_UEXACT16_AMAP target_name_offset;
   BE_UEXACT16_AMAP chap_name_length;
   BE_UEXACT16_AMAP chap_name_offset;
   BE_UEXACT16_AMAP chap_secret_length;
   BE_UEXACT16_AMAP chap_secret_offset;
   BE_UEXACT16_AMAP rchap_name_length;
   BE_UEXACT16_AMAP rchap_name_offset;
   BE_UEXACT16_AMAP rchap_secret_length;
   BE_UEXACT16_AMAP rchap_secret_offset;
} SG_PACK BE_IBFT_TARGET_STRUCTURE_AMAP;
typedef struct { u32 dw[14]; } IBFT_TARGET_STRUCTURE_AMAP, *PIBFT_TARGET_STRUCTURE_AMAP;



typedef struct {
   BE_EXACT8_AMAP initiator_name[256];
   BE_EXACT8_AMAP target_name[256];
   BE_EXACT8_AMAP chap_name[256];
   BE_EXACT8_AMAP chap_secret[256];
   BE_EXACT8_AMAP rchap_name[256];
   BE_EXACT8_AMAP rchap_secret[256];
   BE_EXACT8_AMAP host_name[256];
} SG_PACK BE_IBFT_HEAP_AMAP;
typedef struct { u32 dw[448]; } IBFT_HEAP_AMAP, *PIBFT_HEAP_AMAP;



typedef struct {
   BE_IBFT_TABLE_HEADER_AMAP header;
   BE_IBFT_CONTROL_STRUCTURE_AMAP control;
   BE_IBFT_INITIATOR_STRUCTURE_AMAP initiator;
   BE_IBFT_NIC_STRUCTURE_AMAP nic;
   BE_IBFT_TARGET_STRUCTURE_AMAP target;
   BE_IBFT_HEAP_AMAP heap;
} SG_PACK BE_IBFT_TABLE_AMAP;
typedef struct { u32 dw[522]; } IBFT_TABLE_AMAP, *PIBFT_TABLE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_ibft_amap_h__

