/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_target_discovery_amap_h__
#define __ioctl_iscsi_target_discovery_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_MGMT_ISNS_SERVER_AMAP isns_server;
   BE_UEXACT32_AMAP send_xmit_len;
   BE_UEXACT8_AMAP payload[1];
} SG_PACK BE_ISNS_SEND_PACKET_IN_AMAP;
typedef struct { u32 dw[9]; } ISNS_SEND_PACKET_IN_AMAP, *PISNS_SEND_PACKET_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP payload[1];
} SG_PACK BE_ISNS_SEND_PACKET_OUT_AMAP;
typedef struct { u32 dw[1]; } ISNS_SEND_PACKET_OUT_AMAP, *PISNS_SEND_PACKET_OUT_AMAP;



typedef union {
   BE_ISNS_SEND_PACKET_IN_AMAP request;
   BE_ISNS_SEND_PACKET_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS_AMAP;
typedef struct { u32 dw[9]; } IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS_AMAP, *PIOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS_AMAP;


//              This IOCTL will be used to send a isns packet to the iSNS server.         
//    this packet is expected to be fully prepared according RFC 3271. 			no protocol
// related checks will be done in ARM Firmware.             <br>            
// <b>Originator(s)</b> : Management application             <br>            
// <b>Implemented in</b>: Firmware             <br>             <b>Return Values</b> :
// <ul>                                 <li>MGMT_STATUS_SUCCESS                           
//      <li>MGMT_STATUS_INVALID_ISNS_ADDRESS                                
// <li>MGMT_STATUS_INVALID_TCPPORT                             </ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_AMAP;
typedef struct { u32 dw[13]; } IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_AMAP, *PIOCTL_ISCSI_TGT_ISNS_SEND_PACKET_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MGMT_PORTAL_AMAP esi_format;
} SG_PACK BE_IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP;
typedef struct { u32 dw[11]; } IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP, *PIOCTL_ISCSI_TGT_ESI_LISTEN_AMAP;



typedef IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP IOCTL_ISCSI_TGT_START_ESI_LISTEN_AMAP;
typedef BE_IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP BE_IOCTL_ISCSI_TGT_START_ESI_LISTEN_AMAP;


typedef IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP* PIOCTL_ISCSI_TGT_START_ESI_LISTEN_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_TGT_START_ESI_LISTEN_AMAP;


typedef IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP IOCTL_ISCSI_TGT_STOP_ESI_LISTEN_AMAP;
typedef BE_IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP BE_IOCTL_ISCSI_TGT_STOP_ESI_LISTEN_AMAP;


typedef IOCTL_ISCSI_TGT_ESI_LISTEN_AMAP* PIOCTL_ISCSI_TGT_STOP_ESI_LISTEN_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_TGT_STOP_ESI_LISTEN_AMAP;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_target_discovery_amap_h__

