/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_tgt_amap_h__
#define __ioctl_iscsi_tgt_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_iscsi_target_discovery.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_IP_ADDRESS_VLAN_FORMAT_AMAP ip_addr_vlan;
} SG_PACK BE_TGT_ADD_IP_ADDR_PARAMS_IN_AMAP;
typedef struct { u32 dw[11]; } TGT_ADD_IP_ADDR_PARAMS_IN_AMAP, *PTGT_ADD_IP_ADDR_PARAMS_IN_AMAP;


//              Use this IOCTL to set the IP address, subnet mask and any VLAN tags       
//      <break>                 This IOCTL may return one of the following status values
// in the response                  <ul>                     <li>
// [link]MGMT_STATUS_SUCCESS[/link]                     <li>
// [link]MGMT_STATUS_INVALID_IPADDR[/link] - IP address format is invalid                
// </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TGT_ADD_IP_ADDR_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_ADD_IP_ADDR_AMAP;
typedef struct { u32 dw[15]; } IOCTL_ISCSI_TGT_ADD_IP_ADDR_AMAP, *PIOCTL_ISCSI_TGT_ADD_IP_ADDR_AMAP;



typedef struct {
   BE_IP_ADDRESS_VLAN_FORMAT_AMAP ip_addr_vlan;
} SG_PACK BE_TGT_DELETE_IP_ADDR_PARAMS_IN_AMAP;
typedef struct { u32 dw[11]; } TGT_DELETE_IP_ADDR_PARAMS_IN_AMAP, *PTGT_DELETE_IP_ADDR_PARAMS_IN_AMAP;


//              Use this IOCTL to delete a previously set IP address             <break>  
//               This IOCTL may return one of the following status values in the response 
//                 <ul>                     <li> [link]MGMT_STATUS_SUCCESS[/link]         
//            <li> [link]MGMT_STATUS_INVALID_IPADDR[/link] - No such IP address was added 
//                </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TGT_DELETE_IP_ADDR_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_DELETE_IP_ADDR_AMAP;
typedef struct { u32 dw[15]; } IOCTL_ISCSI_TGT_DELETE_IP_ADDR_AMAP, *PIOCTL_ISCSI_TGT_DELETE_IP_ADDR_AMAP;



typedef struct {
   BE_UEXACT16_AMAP addr_count;
   BE_UEXACT16_AMAP pad1;
   BE_IP_ADDRESS_VLAN_FORMAT_AMAP ip_addr_vlan[1];
} SG_PACK BE_TGT_LIST_IP_ADDR_PARAMS_OUT_AMAP;
typedef struct { u32 dw[12]; } TGT_LIST_IP_ADDR_PARAMS_OUT_AMAP, *PTGT_LIST_IP_ADDR_PARAMS_OUT_AMAP;



typedef union {
   BE_TGT_LIST_IP_ADDR_PARAMS_OUT_AMAP response;
} SG_PACK BE_TGT_LIST_IP_ADDR_PARAMS_AMAP;
typedef struct { u32 dw[12]; } TGT_LIST_IP_ADDR_PARAMS_AMAP, *PTGT_LIST_IP_ADDR_PARAMS_AMAP;


//              Use this IOCTL to retrieve a list of all IP addresses configured          
//   <break>                 This IOCTL may return one of the following status values in
// the response                  <ul>                     <li>
// [link]MGMT_STATUS_SUCCESS[/link]                 </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TGT_LIST_IP_ADDR_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_TGT_LIST_IP_ADDR_AMAP;
typedef struct { u32 dw[16]; } IOCTL_ISCSI_TGT_LIST_IP_ADDR_AMAP, *PIOCTL_ISCSI_TGT_LIST_IP_ADDR_AMAP;



typedef struct {
   BE_UEXACT32_AMAP connection_handle;
} SG_PACK BE_GET_CONNECTION_INFO_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_CONNECTION_INFO_PARAMS_IN_AMAP, *PGET_CONNECTION_INFO_PARAMS_IN_AMAP;



typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP src_ip_addr;
   BE_IP_ADDRESS_FORMAT_AMAP dst_ip_addr;
   BE_UEXACT16_AMAP src_port;
   BE_UEXACT16_AMAP dst_port;
   BE_UEXACT32_AMAP tcp_mss;
} SG_PACK BE_GET_CONNECTION_INFO_PARAMS_OUT_AMAP;
typedef struct { u32 dw[14]; } GET_CONNECTION_INFO_PARAMS_OUT_AMAP, *PGET_CONNECTION_INFO_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_CONNECTION_INFO_PARAMS_IN_AMAP request;
   BE_GET_CONNECTION_INFO_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_CONNECTION_INFO_PARAMS_AMAP;
typedef struct { u32 dw[14]; } GET_CONNECTION_INFO_PARAMS_AMAP, *PGET_CONNECTION_INFO_PARAMS_AMAP;


//              The Target driver is expected to issue this IOCTL on             
// receiving an [link]ASYNC_EVENT_NEW_TCP_CONNECTION_ACCEPTED[/link]            
// asynchronous message.             <break>                 This IOCTL may return one of
// the following status values in the response                  <ul>                    
// <li> [link]MGMT_STATUS_SUCCESS[/link]                     <li>
// [link]MGMT_STATUS_FAILED[/link] with additional status                          <ul>   
//                          <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE[/link]    
//                         <li> [link]MGMT_ADDL_STATUS_CONN_RST[/link] - The ARM firmware
// has received a TCP RST on this connection.                                             
//    The host driver must issue [link]IOCTL_ISCSI_TGT_CONNECTION_REJECT[/link]           
//                                      to release the socket before cleaning up the
// related host structures.                         </ul>                 </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_CONNECTION_INFO_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_TGT_GET_CONNECTION_INFO_AMAP;
typedef struct { u32 dw[18]; } IOCTL_ISCSI_TGT_GET_CONNECTION_INFO_AMAP, *PIOCTL_ISCSI_TGT_GET_CONNECTION_INFO_AMAP;



typedef struct {
   BE_UEXACT32_AMAP connection_handle;
} SG_PACK BE_CONNECTION_REJECT_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } CONNECTION_REJECT_PARAMS_IN_AMAP, *PCONNECTION_REJECT_PARAMS_IN_AMAP;



typedef union {
   BE_CONNECTION_REJECT_PARAMS_IN_AMAP request;
} SG_PACK BE_CONNECTION_REJECT_PARAMS_AMAP;
typedef struct { u32 dw[1]; } CONNECTION_REJECT_PARAMS_AMAP, *PCONNECTION_REJECT_PARAMS_AMAP;


//               Taget host drivers must use this IOCTL to inform the ARM firmware to
// close and free the connection             handle associated with this TCP connection
// whenever              <break>             <ul>                 <li> The host is unable
// to accept a cnxn (possibly because there are too many iSCSI connections).              
//   <li> A TCP RST was received on a connection before a the host driver could
// accept/offload the connection             </ul>             In general, once a
// connection_handle is notified to host driver, the ARM firmware will not free it        
//      (even after receiving a TCP RST) till this IOCTL or
// [link]IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION[/link] is              received.              
//     <break>                 This IOCTL may return one of the following status values in
// the response                  <ul>                     <li>
// [link]MGMT_STATUS_SUCCESS[/link]                     <li>
// [link]MGMT_STATUS_FAILED[/link] with additional status
// [link]MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE[/link]                  </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_CONNECTION_REJECT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_TGT_CONNECTION_REJECT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_TGT_CONNECTION_REJECT_AMAP, *PIOCTL_ISCSI_TGT_CONNECTION_REJECT_AMAP;



typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP cq_id;
   BE_UEXACT8_AMAP hdr_ring_id;
   BE_UEXACT8_AMAP data_ring_id;
   BE_UEXACT16_AMAP chute;
   BE_UEXACT32_AMAP tcp_window;
   BE_PHYS_ADDR_AMAP padd_buffer_pa;
   BE_MGMT_TARGET_LOGIN_OPTIONS_AMAP def_login_options;
} SG_PACK BE_OFFLOAD_CONNECTION_PARAMS_IN_AMAP;
typedef struct { u32 dw[13]; } OFFLOAD_CONNECTION_PARAMS_IN_AMAP, *POFFLOAD_CONNECTION_PARAMS_IN_AMAP;



typedef union {
   BE_OFFLOAD_CONNECTION_PARAMS_IN_AMAP request;
} SG_PACK BE_OFFLOAD_CONNECTION_PARAMS_AMAP;
typedef struct { u32 dw[13]; } OFFLOAD_CONNECTION_PARAMS_AMAP, *POFFLOAD_CONNECTION_PARAMS_AMAP;


//              The Target driver issues this IOCTL after             retrieving
// connection-specific information using             
// [link]IOCTL_ISCSI_TGT_GET_CONNECTION_INFO[/link]             This call forces the ARM
// firmware to -             <ul                 <li> Offloads the TCP connection context 
//                <li> Programs default iSCSI parameters                 <li> Sets the CAM
// valid bit                  <li> Sends a TCP window update (from NIC path)            
// </ul>              After the TCP windows update is sent, the host driver should expect 
//            an iSCSI login PDU to be notified possibly before the completion of this
// IOCTL.              <break>                 This IOCTL may return one of the following
// status values in the response                  <ul>                     <li>
// [link]MGMT_STATUS_SUCCESS[/link]                     <li>
// [link]MGMT_STATUS_FAILED[/link] with additional status                          <ul>   
//                          <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE[/link]    
//                         <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CQID[/link]            
//                 <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CID[/link]                     
//        <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CHUTE[/link]                        
// </ul>                 </ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_OFFLOAD_CONNECTION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION_AMAP;
typedef struct { u32 dw[17]; } IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION_AMAP, *PIOCTL_ISCSI_TGT_OFFLOAD_CONNECTION_AMAP;



typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP server_ip;
   BE_UEXACT32_AMAP tcp_port;
   BE_UEXACT32_AMAP portal_key;
} SG_PACK BE_START_LISTEN_SERVER_IN_AMAP;
typedef struct { u32 dw[8]; } START_LISTEN_SERVER_IN_AMAP, *PSTART_LISTEN_SERVER_IN_AMAP;


//              Request the ARM firmware to start a listen server at the specific IP
// address and TCP port. iSCSI Initiators             are expected to open a TCP
// connection to this port. An asynchronous notification will be issued to the host       
//      target driver whenever a new connection is accepted.             <break>          
//       This IOCTL may return one of the following status values in the response         
//         <ul>                     <li> [link]MGMT_STATUS_SUCCESS[/link]                 
//    <li> [link]MGMT_STATUS_INVALID_TARGET_IPADDR[/link] - This IP address is not
// configured.                 </ul>            This IOCTL returns one of the following
// additional status values in the response<br>         <ul>           
// <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link>           
// <li><link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>         </ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_START_LISTEN_SERVER_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_START_LISTEN_SERVER_AMAP;
typedef struct { u32 dw[12]; } IOCTL_ISCSI_TGT_START_LISTEN_SERVER_AMAP, *PIOCTL_ISCSI_TGT_START_LISTEN_SERVER_AMAP;



typedef struct {
   BE_IP_ADDRESS_FORMAT_AMAP server_ip;
   BE_UEXACT32_AMAP tcp_port;
   BE_UEXACT32_AMAP portal_key;
} SG_PACK BE_STOP_LISTEN_SERVER_IN_AMAP;
typedef struct { u32 dw[8]; } STOP_LISTEN_SERVER_IN_AMAP, *PSTOP_LISTEN_SERVER_IN_AMAP;


//              Stops a listen server started on the specified IP address and port number
// using              [link]IOCTL_ISCSI_TGT_START_LISTEN_SERVER[/link].             
// <break>                 This IOCTL may return one of the following status values in the
// response                  <ul>                     <li>
// [link]MGMT_STATUS_SUCCESS[/link]                     <li>
// [link]MGMT_STATUS_INVALID_TARGET_IPADDR[/link] - No listen server was started on this
// IP address/port                     <li> [link]MGMT_STATUS_INVALID_TCPPORT[/link] - No
// listen server was started on this port                 </ul>            This IOCTL
// returns one of the following additional status values in the response<br>         <ul> 
//           <li><link>MGMT_ADDI_STATUS_INVALID_KEY</link>           
// <li><link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>         </ul>           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_STOP_LISTEN_SERVER_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER_AMAP;
typedef struct { u32 dw[12]; } IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER_AMAP, *PIOCTL_ISCSI_TGT_STOP_LISTEN_SERVER_AMAP;



typedef struct {
   BE_UEXACT8_AMAP target_name[224];
   BE_IP_ADDRESS_FORMAT_AMAP target_ip;
   BE_UEXACT32_AMAP target_port;
} SG_PACK BE_REGISTER_SLP_TARGET_IN_AMAP;
typedef struct { u32 dw[63]; } REGISTER_SLP_TARGET_IN_AMAP, *PREGISTER_SLP_TARGET_IN_AMAP;


//  			Request the ARM firmware to register the target with the SLP(Service Location
// Protocol) SA (Service Agent)  			running inside the ARM. Initiators can query for this
// target using Findsrvs option in SLP UA (User Agent). 			<break> 				This IOCTL may
// return one of the following status values in the response  				<ul> 					<li>
// [link]MGMT_STATUS_SUCCESS[/link] 				</ul> 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_REGISTER_SLP_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_SLP_REGISTER_AMAP;
typedef struct { u32 dw[67]; } IOCTL_ISCSI_TGT_SLP_REGISTER_AMAP, *PIOCTL_ISCSI_TGT_SLP_REGISTER_AMAP;



typedef struct {
   BE_UEXACT8_AMAP target_name[224];
   BE_IP_ADDRESS_FORMAT_AMAP target_ip;
   BE_UEXACT32_AMAP target_port;
} SG_PACK BE_DEREGISTER_SLP_TARGET_IN_AMAP;
typedef struct { u32 dw[63]; } DEREGISTER_SLP_TARGET_IN_AMAP, *PDEREGISTER_SLP_TARGET_IN_AMAP;


//  			Request the ARM firmware to de-register the target with the SLP(Service Location
// Protocol) SA(Service Agent)  			running inside the ARM.  			<break> 				This IOCTL may
// return one of the following status values in the response  				<ul> 					<li>
// [link]MGMT_STATUS_SUCCESS[/link] 				</ul> 		
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DEREGISTER_SLP_TARGET_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_SLP_DEREGISTER_AMAP;
typedef struct { u32 dw[67]; } IOCTL_ISCSI_TGT_SLP_DEREGISTER_AMAP, *PIOCTL_ISCSI_TGT_SLP_DEREGISTER_AMAP;


// --- IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_ENUM ---
#define IOCTL_ISCSI_TGT_CONNECTION_INVALIDATE (1) // Request the EP firmware to
                                                  // 'invalidate' this connection.
#define IOCTL_ISCSI_TGT_CONNECTION_ISSUE_TCP_RST (2) // Issue a TCP RST on this connection

typedef enum {
   ENUM_IOCTL_ISCSI_TGT_CONNECTION_INVALIDATE = 0x1UL,
   ENUM_IOCTL_ISCSI_TGT_CONNECTION_ISSUE_TCP_RST = 0x2UL
} IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_ENUM;


typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP cleanup_type;
} SG_PACK BE_INVALIDATE_TGT_CONNECTION_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } INVALIDATE_TGT_CONNECTION_PARAMS_IN_AMAP, *PINVALIDATE_TGT_CONNECTION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP unused;
} SG_PACK BE_INVALIDATE_TGT_CONNECTION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } INVALIDATE_TGT_CONNECTION_PARAMS_OUT_AMAP, *PINVALIDATE_TGT_CONNECTION_PARAMS_OUT_AMAP;



typedef union {
   BE_INVALIDATE_TGT_CONNECTION_PARAMS_IN_AMAP request;
   BE_INVALIDATE_TGT_CONNECTION_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_AMAP;
typedef struct { u32 dw[2]; } IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_AMAP, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_AMAP;


//               The target driver should use this command to invalidate a connection and
// optionally send a TCP RST              before terminating the connection and releasing
// all I/O requests and other resources. The ARM firmware forwards             this
// request to the EP firmware. The EP firmware will clean up its internal data structures
// and issue             a TCP reset if IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST is set.      
//       <break>                 This IOCTL may return one of the following status values
// in the response                  <ul>                     <li>
// [link]MGMT_STATUS_SUCCESS[/link]                     <li>
// [link]MGMT_STATUS_FAILED[/link] with additional status                          <ul>   
//                          <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CONN_HANDLE[/link]    
//                         <li> [link]MGMT_ADDL_STATUS_TGT_INVALID_CID[/link]             
//            </ul>                 </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_AMAP, *PIOCTL_ISCSI_TGT_INVALIDATE_CONNECTION_AMAP;



typedef struct {
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP QoS_category;
} SG_PACK BE_SET_CONN_QOS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } SET_CONN_QOS_PARAMS_IN_AMAP, *PSET_CONN_QOS_PARAMS_IN_AMAP;


//              Use this IOCTL to set the QoS category for an offloaded iSCSI connection. 
//            <break>             This IOCTL will return [link]MGMT_STATUS_SUCCESS[/link] 
//        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_CONN_QOS_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_TGT_SET_CONN_QOS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_TGT_SET_CONN_QOS_AMAP, *PIOCTL_ISCSI_TGT_SET_CONN_QOS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_tgt_amap_h__

