/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_lowlevel_amap_h__
#define __ioctl_lowlevel_amap_h__
#include "setypes.h"
#include "ioctl_hdr.h"
#include "ioctl_common.h"
#include "host_struct.h"
#include "ioctl_toe.h"
#include "ep_queue.h"
#include "fc_device_context.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//               Reads or writes a range of directory table entries.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP dt_index;
         BE_UEXACT8_AMAP write;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_PHYS_ADDR_AMAP pa;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
         BE_PHYS_ADDR_AMAP pa;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_CONFIG_DT_ENTRY_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_CONFIG_DT_ENTRY_AMAP, *PIOCTL_LOWLEVEL_CONFIG_DT_ENTRY_AMAP;


//               Invalidates a page table entry.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP cra;
      } request;
      struct {
         BE_UEXACT32_AMAP cra;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY_AMAP, *PIOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY_AMAP;


// --- MEMORY_ENUM ---
#define MEMORY_CONTEXT                  (0)       
#define MEMORY_CEV                      (1)       
#define MEMORY_PMEM                     (2)       
#define MEMORY_DBUF                     (3)       
#define MEMORY_DDR                      (4)       
#define MEMORY_CLASSIFICATION_RAM       (6)       
#define MEMORY_TXIPS_RAM                (8)       
#define MEMORY_RXIPS_RAM                (9)       
#define MEMORY_DIRECTORY_TABLE          (10)      

typedef enum {
   ENUM_MEMORY_CONTEXT = 0x0UL,
   ENUM_MEMORY_CEV = 0x1UL,
   ENUM_MEMORY_PMEM = 0x2UL,
   ENUM_MEMORY_DBUF = 0x3UL,
   ENUM_MEMORY_DDR = 0x4UL,
   ENUM_MEMORY_CLASSIFICATION_RAM = 0x6UL,
   ENUM_MEMORY_TXIPS_RAM = 0x8UL,
   ENUM_MEMORY_RXIPS_RAM = 0x9UL,
   ENUM_MEMORY_DIRECTORY_TABLE = 0xaUL
} MEMORY_ENUM;


typedef struct {
   BE_UEXACT32_AMAP address;
   BE_UEXACT16_AMAP length;
   BE_UEXACT8_AMAP memory;
   BE_UEXACT8_AMAP write;
   BE_UEXACT32_AMAP data;
} SG_PACK BE_ACCESS_MEMORY_REQUEST_AMAP;
typedef struct { u32 dw[3]; } ACCESS_MEMORY_REQUEST_AMAP, *PACCESS_MEMORY_REQUEST_AMAP;


//               Reads or writes on-chip memories. This is a debug-only feature.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_ACCESS_MEMORY_REQUEST_AMAP request;
      struct {
         BE_UEXACT32_AMAP data;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_ACCESS_MEMORY_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_ACCESS_MEMORY_AMAP, *PIOCTL_LOWLEVEL_ACCESS_MEMORY_AMAP;


//  Describes a single register transaction via IOCTL_LOWLEVEL_ACCESS_REGISTERS 
typedef struct {
   BE_UEXACT16_AMAP offset;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_AMAP write;
   BE_UEXACT32_AMAP data;
} SG_PACK BE_ACCESS_REGISTERS_TRANSACTION_AMAP;
typedef struct { u32 dw[2]; } ACCESS_REGISTERS_TRANSACTION_AMAP, *PACCESS_REGISTERS_TRANSACTION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_requests;
   BE_ACCESS_REGISTERS_TRANSACTION_AMAP registers[27];
} SG_PACK BE_ACCESS_REGISTERS_PAYLOAD_AMAP;
typedef struct { u32 dw[55]; } ACCESS_REGISTERS_PAYLOAD_AMAP, *PACCESS_REGISTERS_PAYLOAD_AMAP;


//               Reads or writes on-chip registers. This is a debug-only feature. While
// this IOCTL              structure is shown in a format such that it can be an embedded
// IOCTL              (limited to 27 register transactions), the registers array may
// contain more              than 27 entries in a non-embedded format. In either format,
// the num_requests              field determines the number of transactions.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_ACCESS_REGISTERS_PAYLOAD_AMAP request;
      BE_ACCESS_REGISTERS_PAYLOAD_AMAP response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_ACCESS_REGISTERS_AMAP;
typedef struct { u32 dw[59]; } IOCTL_LOWLEVEL_ACCESS_REGISTERS_AMAP, *PIOCTL_LOWLEVEL_ACCESS_REGISTERS_AMAP;


//               Temporarily disables/reenables an offloaded connection.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_MPU_OFFLOAD_CXN_ENTRY_AMAP filter;
      } request;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_OFFLOAD_ENABLE_AMAP;
typedef struct { u32 dw[17]; } IOCTL_LOWLEVEL_OFFLOAD_ENABLE_AMAP, *PIOCTL_LOWLEVEL_OFFLOAD_ENABLE_AMAP;


//               Queries or updates the TCP connection state.               The offload
// should be disabled before updating the state.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP write;
         BE_TCP_CONTEXT_AMAP tcp;
      } request;
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_TCP_CONTEXT_AMAP tcp;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_CONFIG_TCP_STATE_AMAP;
typedef struct { u32 dw[37]; } IOCTL_LOWLEVEL_CONFIG_TCP_STATE_AMAP, *PIOCTL_LOWLEVEL_CONFIG_TCP_STATE_AMAP;


//               Queries or updates the TCP connection state.               The offload
// should be disabled before updating the state.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP write;
         BE_MPU_TEMPLATE_HEADER_AMAP header;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
         BE_MPU_TEMPLATE_HEADER_AMAP header;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER_AMAP;
typedef struct { u32 dw[37]; } IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER_AMAP, *PIOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADER_AMAP;


//               Queries or updates the iSCSI connection state.               The offload
// should be disabled before updating the state.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP write;
         BE_ISCSI_CONTEXT_AMAP context;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
         BE_ISCSI_CONTEXT_AMAP context;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_CONFIG_ISCSI_AMAP;
typedef struct { u32 dw[37]; } IOCTL_LOWLEVEL_CONFIG_ISCSI_AMAP, *PIOCTL_LOWLEVEL_CONFIG_ISCSI_AMAP;


//               Queries or updates the TOE connection state.               The offload
// should be disabled before updating the state.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP write;
         BE_TOE_CONTEXT_AMAP context;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
         BE_TOE_CONTEXT_AMAP context;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_CONFIG_TOE_AMAP;
typedef struct { u32 dw[21]; } IOCTL_LOWLEVEL_CONFIG_TOE_AMAP, *PIOCTL_LOWLEVEL_CONFIG_TOE_AMAP;


//               Offloads a connection.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_MPU_TEMPLATE_HEADER_AMAP header;
         BE_TCP_CONTEXT_AMAP tcp;
         BE_MPU_OFFLOAD_CXN_ENTRY_AMAP filter;
         BE_ISCSI_CONTEXT_AMAP context;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_ISCSI_OFFLOAD_AMAP;
typedef struct { u32 dw[113]; } IOCTL_LOWLEVEL_ISCSI_OFFLOAD_AMAP, *PIOCTL_LOWLEVEL_ISCSI_OFFLOAD_AMAP;


//              Offloads a fcoe interface.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cid;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_MPU_TEMPLATE_HEADER_AMAP header;
         BE_TCP_CONTEXT_AMAP tcp;
         BE_BIT rsvd1[128];                       // DWORD 69
         BE_FC_CONTEXT_AMAP context;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_FCOE_OFFLOAD_AMAP;
typedef struct { u32 dw[89]; } IOCTL_LOWLEVEL_FCOE_OFFLOAD_AMAP, *PIOCTL_LOWLEVEL_FCOE_OFFLOAD_AMAP;


//               Maps pages into the UT.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_UEXACT32_AMAP cra;
         BE_PHYS_ADDR_AMAP pages[16];
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_MAP_UT_PAGES_AMAP;
typedef struct { u32 dw[38]; } IOCTL_LOWLEVEL_MAP_UT_PAGES_AMAP, *PIOCTL_LOWLEVEL_MAP_UT_PAGES_AMAP;


//               Unmaps pages from the UT.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_UEXACT32_AMAP cra;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_UNMAP_UT_PAGES_AMAP;
typedef struct { u32 dw[6]; } IOCTL_LOWLEVEL_UNMAP_UT_PAGES_AMAP, *PIOCTL_LOWLEVEL_UNMAP_UT_PAGES_AMAP;


//           This IOCTL can be used by drivers to control debug levels in the BladeEngine 
//         management firmware. This is provided as a debugging tool only.          The
// IOCTL returns the previous settings in the response buffer.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u32_AMAP print_level;
         BE_BIT rsvd0[32];                        // DWORD 5
         BE_u32_AMAP store_level;
         BE_u32_AMAP enable_disable_print;
         BE_u32_AMAP enable_disable_store;
      } request;
      struct {
         BE_u32_AMAP old_print_level;
         BE_BIT rsvd0[32];                        // DWORD 5
         BE_u32_AMAP old_store_level;
         BE_u32_AMAP old_enable_disable_print;
         BE_u32_AMAP old_enable_disable_store;
      } response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL_AMAP;
typedef struct { u32 dw[9]; } IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL_AMAP, *PIOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL_AMAP;



typedef struct {
   BE_u32_AMAP transfer_size;
   BE_u32_AMAP num_rmda_transfered;
   BE_u32_AMAP num_wdma_transfered;
   BE_u32_AMAP rdma_ticks;
   BE_u32_AMAP wdma_ticks;
   BE_u32_AMAP ioctl_ticks;
   BE_u32_AMAP clock_speed;
} SG_PACK BE_IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_AMAP, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_AMAP;


//          This IOCTL allows running a DMA bandwidth test in the ARM firmware.           
//      It should only be used for diagnostic system checks.           This IOCTL will
// lock out all other processing in the ARM and should only          be used when the
// system is idle. The system should         be rebooted after using this IOCTL.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_u8_AMAP transaction_type;
         BE_u8_AMAP rdma_target;
         BE_u8_AMAP rdma_source;
         BE_u8_AMAP wdma_source;
         BE_u8_AMAP wdma_target;
         BE_u8_AMAP enable_bidi;
         BE_BIT rsvd0[16];                        // DWORD 5
         BE_u32_AMAP transfer_size;
         BE_u32_AMAP number_transfers;
         BE_u32_AMAP ioctl_measure;
         BE_u32_AMAP ioctl_start;
         BE_u32_AMAP ioctl_stop;
         BE_PHYS_ADDR_AMAP pa_read;
         BE_PHYS_ADDR_AMAP pa_write;
      } request;
      BE_IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_AMAP;
typedef struct { u32 dw[15]; } IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_AMAP, *PIOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH_AMAP;


// --- BE_LOOPBACK_MODE ---
#define MAC_LOOPBACK                    (0)       // MAC loopback mode, transmitted packet
                                                  // is looped back at the MAC.
#define PHY_LOOPBACK                    (1)       // PHY loopback mode, transmitted packet
                                                  // is looped back at the PHY.
#define ONE_PORT_EXT_LOOPBACK           (2)       // External loopback mode, transmitted
                                                  // packet is looped back externally on
                                                  // the same port.
#define TWO_PORT_EXT_LOOPBACK           (3)       // External loopback mode, transmitted
                                                  // packet is looped back externally on
                                                  // different port.
#define NO_LOOPBACK                     (255)     // No loopback mode applied.

typedef enum {
   ENUM_MAC_LOOPBACK = 0x0UL,
   ENUM_PHY_LOOPBACK = 0x1UL,
   ENUM_ONE_PORT_EXT_LOOPBACK = 0x2UL,
   ENUM_TWO_PORT_EXT_LOOPBACK = 0x3UL,
   ENUM_NO_LOOPBACK = 0xffUL
} BE_LOOPBACK_MODE;

// --- BE_LOOPBACK_STATUS ---
#define LOOPBACK_SUCCESS                (0)       // Loopback mode passed successfully.
#define LOOPBACK_TRANSMIT_FAILURE       (1)       // An error occurred in the transmit
                                                  // path of the loopback test.
#define LOOPBACK_RECEIVE_FAILURE        (2)       // An error occurred in the receive path
                                                  // of the loopback test.
#define LOOPBACK_DATA_MISMATCH          (3)       // Data integrity failure in the
                                                  // transmitted vs. received packet.
#define LOOPBACK_TIMEOUT                (4)       // Timed out on loopback IOCTL.
#define LOOPBACK_LINK_DOWN_FAILURE      (5)       // An error occured due to link down on
                                                  // the port.

typedef enum {
   ENUM_LOOPBACK_SUCCESS = 0x0UL,
   ENUM_LOOPBACK_TRANSMIT_FAILURE = 0x1UL,
   ENUM_LOOPBACK_RECEIVE_FAILURE = 0x2UL,
   ENUM_LOOPBACK_DATA_MISMATCH = 0x3UL,
   ENUM_LOOPBACK_TIMEOUT = 0x4UL,
   ENUM_LOOPBACK_LINK_DOWN_FAILURE = 0x5UL
} BE_LOOPBACK_STATUS;


typedef struct {
   BE_u32_AMAP loopback_type;
   BE_u32_AMAP number_packets;
   BE_u64_AMAP pattern;
   BE_u32_AMAP src_port;
   BE_u32_AMAP dest_port;
   BE_u32_AMAP packet_size;
} SG_PACK BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_AMAP;



typedef struct {
   BE_u32_AMAP status;
   BE_u32_AMAP number_transfered;
   BE_u32_AMAP number_received;
   BE_u32_AMAP miscompare_offset;
   BE_u32_AMAP num_ticks_completion;
} SG_PACK BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_AMAP, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_AMAP;


//          This IOCTL enables loopback tests at various levels.         The loopback test
// provides diagnostic capability to transmit and receive packets for a given loop back
// mode.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_LOOPBACK_TEST_AMAP;
typedef struct { u32 dw[11]; } IOCTL_LOWLEVEL_LOOPBACK_TEST_AMAP, *PIOCTL_LOWLEVEL_LOOPBACK_TEST_AMAP;



typedef struct {
   BE_UEXACT64_AMAP pattern;
   BE_UEXACT32_AMAP byte_count;
   BE_BIT rsvd0[32];                              // DWORD 3
   BE_UEXACT8_AMAP send_buffer[4096];
   BE_BIT rsvd1[4096][8];                         // DWORD 1028
} SG_PACK BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_AMAP;
typedef struct { u32 dw[2052]; } IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT64_AMAP pattern;
   BE_UEXACT32_AMAP byte_count;
   BE_UEXACT32_AMAP send_error;
   BE_BIT rsvd0[4096][8];                         // DWORD 4
   BE_UEXACT8_AMAP recv_buffer[4096];
} SG_PACK BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2052]; } IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_AMAP;
typedef struct { u32 dw[2052]; } IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_AMAP, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_AMAP;


//          This IOCTL verifies the DMA path from host memory to DDR memory (forward path
// DMA) and from DDR         to host memory (reverse path DMA). The application fills the
// send_buffer space with the a 64B pattern          and posts the IOCTL. On IOCTL
// completion, the application would pattern match the received pattern in         
// response field with the data in recv_buffer. Forward path DMA error is tracked by AMRfw
// and noted in the          send_error field. Reverse path DMA is tracked by the
// application as a result of above mentioned pattern          matching.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_HOST_DDR_DMA_AMAP;
typedef struct { u32 dw[2056]; } IOCTL_LOWLEVEL_HOST_DDR_DMA_AMAP, *PIOCTL_LOWLEVEL_HOST_DDR_DMA_AMAP;


// --- LOOPBACK_STATE_ENUM ---
#define LOOPBACK_STATE_DISABLE          (0)       
#define LOOPBACK_STATE_ENABLE           (1)       // Enable Loopback mode

typedef enum {
   ENUM_LOOPBACK_STATE_DISABLE = 0x0UL,
   ENUM_LOOPBACK_STATE_ENABLE = 0x1UL
} LOOPBACK_STATE_ENUM;


typedef struct {
   BE_u8_AMAP src_port;
   BE_u8_AMAP dest_port;
   BE_u8_AMAP loopback_mode;
   BE_u8_AMAP loopback_state;
} SG_PACK BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_AMAP;



typedef struct {
   BE_u32_AMAP status;
} SG_PACK BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_AMAP, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_AMAP;


//          This IOCTL is for entering and exiting loopback mode .         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LOWLEVEL_SET_LOOPBACK_MODE_AMAP, *PIOCTL_LOWLEVEL_SET_LOOPBACK_MODE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP port_num;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP loopback_mode;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_AMAP, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_AMAP;


//  This IOCTL will report the current state of loopback mode on the selected port.       
//   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LOWLEVEL_GET_LOOPBACK_MODE_AMAP, *PIOCTL_LOWLEVEL_GET_LOOPBACK_MODE_AMAP;


// --- CHIP_STATE_ENUM ---
#define CHIP_STATE_ALIVE                (0)       
#define CHIP_STATE_DEAD                 (1)       

typedef enum {
   ENUM_CHIP_STATE_ALIVE = 0x0UL,
   ENUM_CHIP_STATE_DEAD = 0x1UL
} CHIP_STATE_ENUM;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP low_version;
   BE_UEXACT8_AMAP high_version;
   BE_UEXACT8_AMAP chip_state;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT32_AMAP sli_intf;
   BE_BIT rsvd1[2][32];                           // DWORD 2
   BE_UEXACT32_AMAP max_components;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_AMAP;


//  This IOCTL reports the properties of a Core Dump that will be captured.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_AMAP;
typedef struct { u32 dw[9]; } IOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_PROPERTIES_AMAP;


// --- CORE_DUMP_COMPONENT ---
#define COREDUMP_COMPONENT_BYTECODE     (1)       
#define COREDUMP_COMPONENT_FW           (2)       
#define COREDUMP_COMPONENT_FW_CLI       (3)       
#define COREDUMP_COMPONENT_DRIVER       (4)       
#define COREDUMP_COMPONENT_MGMT         (5)       
#define COREDUMP_COMPONENT_OEM          (6)       
#define COREDUMP_COMPONENT_MAX          (6)       

typedef enum {
   ENUM_COREDUMP_COMPONENT_BYTECODE = 0x1UL,
   ENUM_COREDUMP_COMPONENT_FW = 0x2UL,
   ENUM_COREDUMP_COMPONENT_FW_CLI = 0x3UL,
   ENUM_COREDUMP_COMPONENT_DRIVER = 0x4UL,
   ENUM_COREDUMP_COMPONENT_MGMT = 0x5UL,
   ENUM_COREDUMP_COMPONENT_OEM = 0x6UL,
   ENUM_COREDUMP_COMPONENT_MAX = 0x6UL
} CORE_DUMP_COMPONENT;


typedef struct {
   BE_UEXACT32_AMAP component_id;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_segments;
   BE_UEXACT32_AMAP component_status;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_AMAP;
typedef struct { u32 dw[2]; } IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_AMAP;


//  This IOCTL reports the properties of a Core Dump component.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_AMAP;
typedef struct { u32 dw[6]; } IOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP component_id;
   BE_UEXACT32_AMAP segment_id;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP low_version;
   BE_UEXACT8_AMAP high_version;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP segment_status;
   BE_UEXACT32_AMAP max_instance;
   BE_UEXACT32_AMAP max_length;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[4]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_AMAP;
typedef struct { u32 dw[4]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_AMAP;


//  This IOCTL reports the properties of a Core Dump segment.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_AMAP;
typedef struct { u32 dw[8]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP component_id;
   BE_UEXACT32_AMAP segment_id;
   BE_UEXACT32_AMAP instance;
   BE_UEXACT32_AMAP offset;
   BE_UEXACT32_AMAP length;
   BE_UEXACT32_AMAP bytecode_length;
   BE_UEXACT32_AMAP bytecode[1];
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_IN_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_IN_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP segment_status;
   BE_UEXACT32_AMAP length;
   BE_UEXACT8_AMAP data[1];
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_OUT_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_IN_AMAP request;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_AMAP;
typedef struct { u32 dw[7]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_AMAP;


//  This IOCTL reads data from a specified segment (or instance of a segment). If bytecode
// is needed,                it will be attached after the input payload.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_AMAP;
typedef struct { u32 dw[11]; } IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_AMAP, *PIOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_lowlevel_amap_h__

