/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_common_host_struct_amap_h__
#define __iscsi_common_host_struct_amap_h__
#include "setypes.h"
#include "defines.h"
#include "iscsi_enums.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- ISCSI_EVENT_MINOR_CODE ---
// Minor event codes for iSCSI offload. The major event will be set to
// EQ_MAJOR_CODE_ISCSI. The ResourceID in the EQ_ENTRY is set to CID to indicate which
// connection failed.
#define ISCSI_MINOR_CODE_UNDEFINED      (0)       // This minor code should never be
                                                  // issued.
#define ISCSI_MINOR_CODE_CRC_ERROR      (1)       // A bad CRC was received on this
                                                  // connection. 
#define ISCSI_MINOR_CODE_BAD_OPCODE     (2)       // A bad opcode was received on this
                                                  // connection.
#define ISCSI_MINOR_CODE_BAD_DATA_SN    (3)       // A bad data sequence number was
                                                  // received on this connection.
#define ISCSI_MINOR_CODE_BAD_ITT        (4)       // A bad itt was received on this
                                                  // connection.
#define ISCSI_MINOR_CODE_BAD_HEADER     (5)       // Indicates a header parse error.
#define ISCSI_MINOR_CODE_PROTOCOL_ERROR (6)       // Indicates a protocol error.

typedef enum {
   ENUM_ISCSI_MINOR_CODE_UNDEFINED = 0x0UL,
   ENUM_ISCSI_MINOR_CODE_CRC_ERROR = 0x1UL,
   ENUM_ISCSI_MINOR_CODE_BAD_OPCODE = 0x2UL,
   ENUM_ISCSI_MINOR_CODE_BAD_DATA_SN = 0x3UL,
   ENUM_ISCSI_MINOR_CODE_BAD_ITT = 0x4UL,
   ENUM_ISCSI_MINOR_CODE_BAD_HEADER = 0x5UL,
   ENUM_ISCSI_MINOR_CODE_PROTOCOL_ERROR = 0x6UL
} ISCSI_EVENT_MINOR_CODE;

// --- CMD_FLAG ---
// Read/Write command flag.
#define READ_FLAG                       (0)       // iSCSI Read command PDU
#define WRITE_FLAG                      (1)       // iSCSI Write command PDU

typedef enum {
   ENUM_READ_FLAG = 0x0UL,
   ENUM_WRITE_FLAG = 0x1UL
} CMD_FLAG;

// Completion Queue Entry for iSCSI Initiator or Target mode of operation.
typedef struct {
   BE_BIT mode_specific1[64];                     // DWORD 0
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT mode_specific2[16];                     // DWORD 2
   BE_BIT mode_specific3[31];                     // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_ISCSI_CQE_AMAP;
typedef struct { u32 dw[4]; } ISCSI_CQE_AMAP, *PISCSI_CQE_AMAP;


// iSCSI unsolicited PDU completions.
typedef struct {
   BE_BIT db_addr_hi[32];                         // DWORD 0
   BE_BIT db_addr_lo[32];                         // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT DataPlacementLength[16];                // DWORD 2
   BE_BIT index[16];                              // DWORD 3
   BE_BIT num_cons[10];                           // DWORD 3
   BE_BIT rsvd0[4];                               // DWORD 3
   BE_BIT final;                                  // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_I_T_DPDU_CQE_AMAP;
typedef struct { u32 dw[4]; } I_T_DPDU_CQE_AMAP, *PI_T_DPDU_CQE_AMAP;


// iSCSI ack/driver message completions.
typedef struct {
   BE_BIT ack_num[32];                            // DWORD 0
   BE_BIT pdu_bytes_rcvd[32];                     // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT wrb_index[8];                           // DWORD 2
   BE_BIT rsvd0[8];                               // DWORD 2
   BE_BIT rsvd1[31];                              // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_I_T_DMSG_CQE_AMAP;
typedef struct { u32 dw[4]; } I_T_DMSG_CQE_AMAP, *PI_T_DMSG_CQE_AMAP;


// Scatter gather element
typedef struct {
   BE_BIT addr_hi[32];                            // DWORD 0
   BE_BIT addr_lo[32];                            // DWORD 1
   BE_BIT sge_offset[22];                         // DWORD 2
   BE_BIT rsvd0[9];                               // DWORD 2
   BE_BIT last_sge;                               // DWORD 2
   BE_BIT len[17];                                // DWORD 3
   BE_BIT rsvd1[15];                              // DWORD 3
} SG_PACK BE_ISCSI_SGE_AMAP;
typedef struct { u32 dw[4]; } ISCSI_SGE_AMAP, *PISCSI_SGE_AMAP;


// Scatter gather element to DMA OOO segments
typedef struct {
   BE_BIT addr_hi[32];                            // DWORD 0
   BE_BIT addr_lo[32];                            // DWORD 1
} SG_PACK BE_ISCSI_OOO_SGE_AMAP;
typedef struct { u32 dw[2]; } ISCSI_OOO_SGE_AMAP, *PISCSI_OOO_SGE_AMAP;


// RRmsg sent from ARM to iSCSI TXULP and carried as body of IPC between EPs
typedef struct {
   BE_BIT req_id[11];                             // DWORD 0
   BE_BIT defpdu_invld;                           // DWORD 0
   BE_BIT chuteid;                                // DWORD 0
   BE_BIT port;                                   // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT invalidate_ref_handle[16];              // DWORD 0
   BE_BIT iscsicon_invld;                         // DWORD 1
   BE_BIT icd_invld;                              // DWORD 1
   BE_BIT icd_free;                               // DWORD 1
   BE_BIT iscsicon_rst;                           // DWORD 1
   BE_BIT wr;                                     // DWORD 1
   BE_BIT invld_resp;                             // DWORD 1
   BE_BIT rstonneed;                              // DWORD 1
   BE_BIT upload;                                 // DWORD 1
   BE_BIT partialBytesSent[24];                   // DWORD 1
} SG_PACK BE_ISCSI_RRMSG_AMAP;
typedef struct { u32 dw[2]; } ISCSI_RRMSG_AMAP, *PISCSI_RRMSG_AMAP;


// Full 8 byte LUN.
typedef struct {
   BE_BIT bytes[8][8];                            // DWORD 0
} SG_PACK BE_ISCSI_LUN_AMAP;
typedef struct { u32 dw[2]; } ISCSI_LUN_AMAP, *PISCSI_LUN_AMAP;


// ISCSI Default PDU Context latest
typedef struct {
   BE_BIT dbuf_cindex[13];                        // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT ring_size[4];                           // DWORD 0
   BE_BIT ring_state[4];                          // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_BIT dbuf_pindex[13];                        // DWORD 1
   BE_BIT rsvd2;                                  // DWORD 1
   BE_BIT pci_func_id[8];                         // DWORD 1
   BE_BIT rx_pdid[9];                             // DWORD 1
   BE_BIT rx_pdid_valid;                          // DWORD 1
   BE_BIT default_buffer_size[16];                // DWORD 2
   BE_BIT cq_id_recv[10];                         // DWORD 2
   BE_BIT rx_pdid_not_valid;                      // DWORD 2
   BE_BIT rsvd3[5];                               // DWORD 2
   BE_BIT rsvd4[32];                              // DWORD 3
} SG_PACK BE_ISCSI_DEFAULT_PDU_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } ISCSI_DEFAULT_PDU_CONTEXT_AMAP, *PISCSI_DEFAULT_PDU_CONTEXT_AMAP;



typedef struct {
   BE_BIT lun[14];                                // DWORD 0
   BE_BIT lt;                                     // DWORD 0
   BE_BIT invld;                                  // DWORD 0
   BE_BIT wrb_idx[8];                             // DWORD 0
   BE_BIT dsp;                                    // DWORD 0
   BE_BIT dmsg;                                   // DWORD 0
   BE_BIT undr_run;                               // DWORD 0
   BE_BIT over_run;                               // DWORD 0
   BE_BIT type[4];                                // DWORD 0
   BE_BIT ptr2NextWrb[8];                         // DWORD 1
   BE_BIT r2t_exp_dtl[24];                        // DWORD 1
   BE_BIT sgl_icd_idx[12];                        // DWORD 2
   BE_BIT cq_id[10];                              // DWORD 2
   BE_BIT rsvd0[10];                              // DWORD 2
   BE_BIT exp_data_sn[32];                        // DWORD 3
   BE_BIT iscsi_bhs_addr_hi[32];                  // DWORD 4
   BE_BIT iscsi_bhs_addr_lo[32];                  // DWORD 5
   BE_BIT cmdsn_itt[32];                          // DWORD 6
   BE_BIT dif_ref_tag[32];                        // DWORD 7
   BE_BIT sge0_addr_hi[32];                       // DWORD 8
   BE_BIT sge0_addr_lo[32];                       // DWORD 9
   BE_BIT sge0_offset[22];                        // DWORD 10
   BE_BIT pbs;                                    // DWORD 10
   BE_BIT dif_mode[2];                            // DWORD 10
   BE_BIT rsvd1[6];                               // DWORD 10
   BE_BIT sge0_last;                              // DWORD 10
   BE_BIT sge0_len[17];                           // DWORD 11
   BE_BIT dif_meta_tag[14];                       // DWORD 11
   BE_BIT sge0_in_ddr;                            // DWORD 11
   BE_BIT sge1_addr_hi[32];                       // DWORD 12
   BE_BIT sge1_addr_lo[32];                       // DWORD 13
   BE_BIT sge1_r2t_offset[22];                    // DWORD 14
   BE_BIT rsvd2[9];                               // DWORD 14
   BE_BIT sge1_last;                              // DWORD 14
   BE_BIT sge1_len[17];                           // DWORD 15
   BE_BIT ref_sgl_icd_idx[12];                    // DWORD 15
   BE_BIT rsvd3[2];                               // DWORD 15
   BE_BIT sge1_in_ddr;                            // DWORD 15
} SG_PACK BE_ISCSI_WRB_AMAP;
typedef struct { u32 dw[16]; } ISCSI_WRB_AMAP, *PISCSI_WRB_AMAP;



typedef struct {
   BE_BIT lun[14];                                // DWORD 0
   BE_BIT lt;                                     // DWORD 0
   BE_BIT invld;                                  // DWORD 0
   BE_BIT wrb_idx[8];                             // DWORD 0
   BE_BIT dsp;                                    // DWORD 0
   BE_BIT dmsg;                                   // DWORD 0
   BE_BIT undr_run;                               // DWORD 0
   BE_BIT over_run;                               // DWORD 0
   BE_BIT type[4];                                // DWORD 0
   BE_BIT ptr2NextWrb[8];                         // DWORD 1
   BE_BIT r2t_exp_dtl[24];                        // DWORD 1
   BE_BIT sgl_icd_idx[12];                        // DWORD 2
   BE_BIT rsvd0[4];                               // DWORD 2
   BE_BIT dif_meta_tag[16];                       // DWORD 2
   BE_BIT exp_data_sn[32];                        // DWORD 3
   BE_BIT iscsi_bhs_addr_hi[32];                  // DWORD 4
   BE_BIT iscsi_bhs_addr_lo[32];                  // DWORD 5
   BE_BIT cmdsn_itt[32];                          // DWORD 6
   BE_BIT dif_ref_tag[32];                        // DWORD 7
   BE_BIT sge0_addr_hi[32];                       // DWORD 8
   BE_BIT sge0_addr_lo[32];                       // DWORD 9
   BE_BIT sge0_offset[22];                        // DWORD 10
   BE_BIT pbs;                                    // DWORD 10
   BE_BIT dif_mode[2];                            // DWORD 10
   BE_BIT rsvd1[6];                               // DWORD 10
   BE_BIT sge0_last;                              // DWORD 10
   BE_BIT sge0_len[17];                           // DWORD 11
   BE_BIT rsvd2[14];                              // DWORD 11
   BE_BIT sge0_in_ddr;                            // DWORD 11
   BE_BIT newreftag[32];                          // DWORD 12
   BE_BIT sge1_addr_lo[32];                       // DWORD 13
   BE_BIT sge1_r2t_offset[22];                    // DWORD 14
   BE_BIT rsvd3;                                  // DWORD 14
   BE_BIT sge1_valid;                             // DWORD 14
   BE_BIT dsbl_crc;                               // DWORD 14
   BE_BIT dsbl_meta;                              // DWORD 14
   BE_BIT dsbl_ref;                               // DWORD 14
   BE_BIT bs[2];                                  // DWORD 14
   BE_BIT m[2];                                   // DWORD 14
   BE_BIT sge1_last;                              // DWORD 14
   BE_BIT sge1_len[17];                           // DWORD 15
   BE_BIT ref_sgl_icd_idx[12];                    // DWORD 15
   BE_BIT rsvd4[2];                               // DWORD 15
   BE_BIT sge1_in_ddr;                            // DWORD 15
} SG_PACK BE_ISCSI_DIF_WRB_AMAP;
typedef struct { u32 dw[16]; } ISCSI_DIF_WRB_AMAP, *PISCSI_DIF_WRB_AMAP;


// --- ISCSI_ENTRY_SIZE_ENUM ---
#define ENTRY_SIZE_64                   (0)       // 64 bytes
#define ENTRY_SIZE_128                  (1)       // 128 bytes
#define ENTRY_SIZE_256                  (2)       // 256 bytes
#define ENTRY_SIZE_512                  (3)       // 512 bytes

typedef enum {
   ENUM_ENTRY_SIZE_64 = 0x0UL,
   ENUM_ENTRY_SIZE_128 = 0x1UL,
   ENUM_ENTRY_SIZE_256 = 0x2UL,
   ENUM_ENTRY_SIZE_512 = 0x3UL
} ISCSI_ENTRY_SIZE_ENUM;

//          This is the ring context structure for iSCSI only, because         of its
// special linked list structure. The HLL and h are                              used only
// by btlr to track the list. When receiving a                              driver
// request, that is, the driver request bit is set                             in the
// TCPSCH_PROC_IQ_DATA descriptor from TCP Scheduler,                             iSCSI
// TXULP will double check the wrb_pend to make sure                             it is
// greater than zero, and then use the wrb_addr as                             the address
// of pending WRB and use it to generate CRA                             for UC request.
// After completing the current WRB, the                              iSCSI RXULP will
// send the ptr2NxtWRB to the CEV.     
typedef struct {
   BE_BIT wrb_addr[8];                            // DWORD 0
   BE_BIT hll[8];                                 // DWORD 0
   BE_BIT tx_ring_size[4];                        // DWORD 0
   BE_BIT fetch_wrb;                              // DWORD 0
   BE_BIT fetch_r2t;                              // DWORD 0
   BE_BIT r2t_cidx[7];                            // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT wrb_pend[8];                            // DWORD 1
   BE_BIT h;                                      // DWORD 1
   BE_BIT rsvd1[5];                               // DWORD 1
   BE_BIT pci_func_id[8];                         // DWORD 1
   BE_BIT pdid[9];                                // DWORD 1
   BE_BIT ctx_valid;                              // DWORD 1
} SG_PACK BE_RING_CONTEXT_ISCSI_AMAP;
typedef struct { u32 dw[2]; } RING_CONTEXT_ISCSI_AMAP, *PRING_CONTEXT_ISCSI_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_common_host_struct_amap_h__

