/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_context_amap_h__
#define __iscsi_context_amap_h__
#include "setypes.h"
#include "defines.h"
#include "descriptors.h"
#include "iscsi_enums.h"
#include "common_context.h"
#include "iscsi_common_host_struct.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//       The on-chip R2T context memory structure for iSCSI write commands.<p>      Note
// that for each offloaded connection, an array of 32 R2T elements      exists in that
// iSCSI connection's context memory.     
typedef struct {
   BE_BIT rsvd0[27];                              // DWORD 0
   BE_BIT valid2;                                 // DWORD 0
   BE_BIT opcode[4];                              // DWORD 0
   BE_BIT ttt[32];                                // DWORD 1
   BE_BIT sgl_icd_index[11];                      // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT dataTransferLength[20];                 // DWORD 2
   BE_BIT bufferOffset[32];                       // DWORD 3
} SG_PACK BE_ISCSI_R2T_AMAP;
typedef struct { u32 dw[4]; } ISCSI_R2T_AMAP, *PISCSI_R2T_AMAP;


//        The on-chip iSCSI context structure keeps track of per connection details for
// processing an        iSCSI commnad. Also, it keeps track of negotiated iSCSI parameters
// and iSCSI mode specific       fields. This structure is basically divided into Tx, Rx
// and common fields. The contents of       this structure differs for different mode of
// operation.<p>        Color Code:<br>       <li>orange : Hardware modified fields. Also,
// read only access for EPs.       <li>green : iSCSI TX ULP read only accessed fields.    
//   <li>brown : These fields are copied from WRB structure and written into ICD structre.
//        These fields are maintained in iSCSI context sturcture for ICD context write
// optimization.        These fields will be written to ICD structure only once at the end
// of generating TX_D descriptor.        In case of crunch situation for iSCSI context
// memory space, these fields can be utilised losing the optimization.       <li>blue :
// iSCSI TX ULP owned fields. Both read/write access for iSCSI TX ULP.       <li>dark blue
// : Common read only fields for both iSCSI TX ULP and RX ULP. Also, iSCSI TX ULP has
// write permission.       <li>yellow : Common read only access fields.       <li>white :
// iSCSI RX ULP owned fields. Both read/write access for iSCSI RX ULP.       <li>teal :
// Common read only fields for both iSCSI TX ULP and RX ULP. Also, iSCSI RX ULP has write
// permission.<p>       iSCSI TX ULP has both read/write permissions to common fields of
// iSCSI context, whereas       iSCSI RX ULP has only read permissions.        <p>      
// The following fields in iSCSI context structure should be initialized by host driver   
//    while offloading the connection. Rest of the fields should be initialized to zero.
// <br>       <li>ring_context : With ring specific information.      
// <li>maxSendDataSegmentLength : Negotiated value.       <li>firstburstLength :
// Negotiated value.       <li>r2tConsumerIndex, r2tProducerIndex : 0      
// <li>tx_wrbindex_drv_msg, rx_wrbindex_drv_msg  : 0xFF       <li>ir2t, imd, ERL, DDE, HDE
// : Negotiated value.       <li>exp_stat_sn : Expected status sequence number after login
// negotiation.       <li>maxBurstLength : Negotiated value.       <li>complQueueID,
// defaultQueueID : Queue ID of completion queue and default ring queue.              
typedef struct {
   BE_RING_CONTEXT_ISCSI_AMAP ring_context;
   BE_BIT addr_hi_bhs[32];                        // DWORD 2
   BE_BIT max_snd_dsl[17];                        // DWORD 3
   BE_BIT fbl[14];                                // DWORD 3
   BE_BIT hde;                                    // DWORD 3
   BE_BIT lun[14];                                // DWORD 4
   BE_BIT lt;                                     // DWORD 4
   BE_BIT rsvd0;                                  // DWORD 4
   BE_BIT wrb_idx[8];                             // DWORD 4
   BE_BIT dsp;                                    // DWORD 4
   BE_BIT dmsg;                                   // DWORD 4
   BE_BIT undr_run;                               // DWORD 4
   BE_BIT over_run;                               // DWORD 4
   BE_BIT type[4];                                // DWORD 4
   BE_BIT addr_lo_bhs[32];                        // DWORD 5
   BE_BIT data_sn[12];                            // DWORD 6
   BE_BIT dde;                                    // DWORD 6
   BE_BIT ooo_tx_hole_id;                         // DWORD 6
   BE_BIT dcrp_tgl[2];                            // DWORD 6
   BE_BIT dpdu_rid[4];                            // DWORD 6
   BE_BIT pbs;                                    // DWORD 6
   BE_BIT domain_id[2];                           // DWORD 6
   BE_BIT rsvd1[6];                               // DWORD 6
   BE_BIT ipc_ooo_last;                           // DWORD 6
   BE_BIT cic;                                    // DWORD 6
   BE_BIT ndr;                                    // DWORD 6
   BE_BIT r2t_sn[12];                             // DWORD 7
   BE_BIT tx_state[3];                            // DWORD 7
   BE_BIT iscsi_ctxt_update;                      // DWORD 7
   BE_BIT frag_offset[16];                        // DWORD 7
   BE_BIT bytes_left[19];                         // DWORD 8
   BE_BIT tx_r2t_vld;                             // DWORD 8
   BE_BIT tx_curr_icd[12];                        // DWORD 8
   BE_BIT r2t_ttt_pri_icd_resdCnt[32];            // DWORD 9
   BE_BIT curr_frag_ptr[9];                       // DWORD 10
   BE_BIT ooo_last[10];                           // DWORD 10
   BE_BIT ooo_last_ext;                           // DWORD 10
   BE_BIT mops;                                   // DWORD 10
   BE_BIT invld;                                  // DWORD 10
   BE_BIT new_cnx;                                // DWORD 10
   BE_BIT icd_invld;                              // DWORD 10
   BE_BIT tx_wrb_idx_dmsg[8];                     // DWORD 10
   BE_BIT tx_seq_num_dmsg[32];                    // DWORD 11
   BE_BIT stat_sn[32];                            // DWORD 12
   BE_BIT ooo_tail[10];                           // DWORD 13
   BE_BIT ooo_tail_ext;                           // DWORD 13
   BE_BIT ooo_replay;                             // DWORD 13
   BE_BIT ooo_hole_id;                            // DWORD 13
   BE_BIT mbl[19];                                // DWORD 13
   BE_BIT rx_wrb_idx_dmsg[8];                     // DWORD 14
   BE_BIT mode;                                   // DWORD 14
   BE_BIT erl[2];                                 // DWORD 14
   BE_BIT imm;                                    // DWORD 14
   BE_BIT ir2t;                                   // DWORD 14
   BE_BIT cq_id[10];                              // DWORD 14
   BE_BIT rsvd2;                                  // DWORD 14
   BE_BIT compltonack;                            // DWORD 14
   BE_BIT r2t_pidx[7];                            // DWORD 14
   BE_BIT rx_seq_num_dmsg[32];                    // DWORD 15
   BE_BIT partial_hdr[13][32];                    // DWORD 16
   BE_BIT crc_bytes[3];                           // DWORD 29
   BE_BIT pad_bytes[2];                           // DWORD 29
   BE_BIT pdu_type;                               // DWORD 29
   BE_BIT spl_pdu;                                // DWORD 29
   BE_BIT sop;                                    // DWORD 29
   BE_BIT rx_r2t_vld;                             // DWORD 29
   BE_BIT rx_state[3];                            // DWORD 29
   BE_BIT partial_dif[4];                         // DWORD 29
   BE_BIT partial_data[10];                       // DWORD 29
   BE_BIT icd_state[2];                           // DWORD 29
   BE_BIT dif_mode[2];                            // DWORD 29
   BE_BIT icd_inv;                                // DWORD 29
   BE_BIT last_sol_pdu;                           // DWORD 29
   BE_BIT dpdu_ref_hndl[16];                      // DWORD 30
   BE_BIT dpdu_data_offset[14];                   // DWORD 30
   BE_BIT partial_seg;                            // DWORD 30
   BE_BIT rsvd3;                                  // DWORD 30
   BE_BIT pdu_bytes_rcvd[24];                     // DWORD 31
   BE_BIT hdr_bytes_left[6];                      // DWORD 31
   BE_BIT rsvd4[2];                               // DWORD 31
} SG_PACK BE_ISCSI_CONTEXT_AMAP;
typedef struct { u32 dw[32]; } ISCSI_CONTEXT_AMAP, *PISCSI_CONTEXT_AMAP;


//        The on-chip ICD context structure maintains command plus data placement specific
//        details. The BE iSCSI Initiator/target architecture supports 2K commands, with
// 256        commands outstanding per connection at any point of time.        The ICD
// index are maintained in host driver and one of the ICD gets statically        allocated
// per request. The iSCSI TX ULP populates the ICD structure upon receiving       WRB
// request [link]ISCSI_TARGET_DATAIN_WRB[/link] from host driver.        The ICD context
// struture will be valid for life time of the command/request.      
typedef struct {
   BE_BIT LUN[14];                                // DWORD 0
   BE_BIT lt;                                     // DWORD 0
   BE_BIT invld;                                  // DWORD 0
   BE_BIT wrbindex[8];                            // DWORD 0
   BE_BIT dsp;                                    // DWORD 0
   BE_BIT dmsg;                                   // DWORD 0
   BE_BIT U;                                      // DWORD 0
   BE_BIT O;                                      // DWORD 0
   BE_BIT opcode[4];                              // DWORD 0
   BE_BIT run_len[22];                            // DWORD 1
   BE_BIT cid[10];                                // DWORD 1
   BE_BIT data_sn[12];                            // DWORD 2
   BE_BIT p_sgl_idx;                              // DWORD 2
   BE_BIT r2tbit;                                 // DWORD 2
   BE_BIT lfbit;                                  // DWORD 2
   BE_BIT r2t_sn_xfr_length[17];                  // DWORD 2
   BE_BIT rsvd0[12];                              // DWORD 3
   BE_BIT partial_dif[4];                         // DWORD 3
   BE_BIT partial_data[10];                       // DWORD 3
   BE_BIT icd_state[2];                           // DWORD 3
   BE_BIT dif_mode[2];                            // DWORD 3
   BE_BIT icd_inv;                                // DWORD 3
   BE_BIT last_sol_pdu;                           // DWORD 3
} SG_PACK BE_ICD_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } ICD_CONTEXT_AMAP, *PICD_CONTEXT_AMAP;


//        The on-chip ICD context structure maintains command plus data placement specific
//        details. The BE iSCSI Initiator/target architecture supports 2K commands, with
// 256        commands outstanding per connection at any point of time.        The ICD
// index are maintained in host driver and one of the ICD gets statically        allocated
// per request. The iSCSI TX ULP populates the ICD structure upon receiving       WRB
// request [link]ISCSI_TARGET_DATAIN_WRB[/link] from host driver.        The ICD context
// struture will be valid for life time of the command/request.      
typedef struct {
   BE_BIT LUN[14];                                // DWORD 0
   BE_BIT lt;                                     // DWORD 0
   BE_BIT invld;                                  // DWORD 0
   BE_BIT wrbindex[8];                            // DWORD 0
   BE_BIT dsp;                                    // DWORD 0
   BE_BIT dmsg;                                   // DWORD 0
   BE_BIT U;                                      // DWORD 0
   BE_BIT O;                                      // DWORD 0
   BE_BIT opcode[4];                              // DWORD 0
   BE_BIT run_len[22];                            // DWORD 1
   BE_BIT cid[10];                                // DWORD 1
   BE_BIT data_sn[12];                            // DWORD 2
   BE_BIT p_sgl_idx;                              // DWORD 2
   BE_BIT r2tbit;                                 // DWORD 2
   BE_BIT lfbit;                                  // DWORD 2
   BE_BIT r2t_sn_xfr_length[17];                  // DWORD 2
   BE_BIT rsvd0[12];                              // DWORD 3
   BE_BIT partial_dif[4];                         // DWORD 3
   BE_BIT partial_data[10];                       // DWORD 3
   BE_BIT icd_state[2];                           // DWORD 3
   BE_BIT dif_mode[2];                            // DWORD 3
   BE_BIT icd_inv;                                // DWORD 3
   BE_BIT last_sol_pdu;                           // DWORD 3
   BE_BIT metadata[16];                           // DWORD 4
   BE_BIT partialcrc[16];                         // DWORD 4
   BE_BIT expreftag[32];                          // DWORD 5
   BE_BIT runlen[16];                             // DWORD 6
   BE_BIT err;                                    // DWORD 6
   BE_BIT dsbl_crc;                               // DWORD 6
   BE_BIT dsbl_meta;                              // DWORD 6
   BE_BIT dsbl_ref;                               // DWORD 6
   BE_BIT rsvd1[6];                               // DWORD 6
   BE_BIT bs[2];                                  // DWORD 6
   BE_BIT m[2];                                   // DWORD 6
   BE_BIT rsvd2;                                  // DWORD 6
   BE_BIT ErrValid;                               // DWORD 6
   BE_BIT newreftag[32];                          // DWORD 7
} SG_PACK BE_ICD_DIF_CONTEXT_AMAP;
typedef struct { u32 dw[8]; } ICD_DIF_CONTEXT_AMAP, *PICD_DIF_CONTEXT_AMAP;


//          The ITT information stored per R2T request for validation.     
typedef struct {
   BE_BIT itt[32];                                // DWORD 0
} SG_PACK BE_ISCSI_ITT_AMAP;
typedef struct { u32 dw[1]; } ISCSI_ITT_AMAP, *PISCSI_ITT_AMAP;


//  Format of default buffer SG frag in default PDU default ring.
typedef struct {
   BE_BIT addr_hi[32];                            // DWORD 0
   BE_BIT addr_lo[32];                            // DWORD 1
} SG_PACK BE_CTX_DB_SGE_AMAP;
typedef struct { u32 dw[2]; } CTX_DB_SGE_AMAP, *PCTX_DB_SGE_AMAP;


//          Context memory bank used to get/store default PDU buffers from host default
// PDU ring.      
typedef struct {
   BE_CTX_DB_SGE_AMAP db_pool[4];
} SG_PACK BE_CTX_DB_POOL_AMAP;
typedef struct { u32 dw[8]; } CTX_DB_POOL_AMAP, *PCTX_DB_POOL_AMAP;


//          Per-domain IOPS/bytes counters maintained by iSCSI TXULP for enforcing quality
// of service.     
typedef struct {
   BE_BIT iops_count[13];                         // DWORD 0
   BE_BIT byte_count[19];                         // DWORD 0
} SG_PACK BE_ISCSI_QOS_COUNTERS_AMAP;
typedef struct { u32 dw[1]; } ISCSI_QOS_COUNTERS_AMAP, *PISCSI_QOS_COUNTERS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_context_amap_h__

