/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __lro_tcp_context_amap_h__
#define __lro_tcp_context_amap_h__
#include "setypes.h"
#include "defines.h"
#include "headers.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//          LRO parameters, configurable per interface by host, interface can be tied to
// either port.             
typedef struct {
   BE_BIT max_chainlen[32];                       // DWORD 0
   BE_BIT full_chainlen[32];                      // DWORD 1
   BE_BIT max_segcount[32];                       // DWORD 2
   BE_BIT max_chaintime[32];                      // DWORD 3
} SG_PACK BE_LRO_INTERFACE_PARAMS_AMAP;
typedef struct { u32 dw[4]; } LRO_INTERFACE_PARAMS_AMAP, *PLRO_INTERFACE_PARAMS_AMAP;


// LRO TCP connection context structure
typedef struct {
   BE_LRO_INTERFACE_PARAMS_AMAP lroparms[2];
   BE_BIT lro_credits_added[2][32];               // DWORD 8
   BE_BIT rsvd0[32];                              // DWORD 10
   union {
      BE_BIT all[32];                             // DWORD 11
      struct {
         BE_BIT port[8];                          // DWORD 11
         BE_BIT tsopt[8];                         // DWORD 11
         BE_BIT ipv6[8];                          // DWORD 11
         BE_BIT inchain[8];                       // DWORD 11
      } field;
   } flags;
   BE_BIT srcip[4][32];                           // DWORD 12
   BE_BIT dstip[4][32];                           // DWORD 16
   union {
      BE_BIT all[32];                             // DWORD 20
      struct {
         BE_BIT dstport[16];                      // DWORD 20
         BE_BIT srcport[16];                      // DWORD 20
      } field;
   } ports;
   BE_BIT lro_win[16];                            // DWORD 21
   BE_BIT cid[8];                                 // DWORD 21
   BE_BIT rsvd1[8];                               // DWORD 21
   BE_BIT lro_rcv_nxt[32];                        // DWORD 22
   BE_BIT lro_ack[32];                            // DWORD 23
   BE_BIT lro_len[32];                            // DWORD 24
   BE_BIT dupack_count[16];                       // DWORD 25
   BE_BIT lro_segcount[16];                       // DWORD 25
   BE_BIT lro_tsval[32];                          // DWORD 26
   BE_BIT rsvd2[4][32];                           // DWORD 27
   BE_BIT lro_ctx_addr[32];                       // DWORD 31
} SG_PACK BE_LRO_TCP_CONTEXT_AMAP;
typedef struct { u32 dw[32]; } LRO_TCP_CONTEXT_AMAP, *PLRO_TCP_CONTEXT_AMAP;



typedef struct {
   BE_BIT rsvd0[11];                              // DWORD 0
   BE_BIT is_singleton;                           // DWORD 0
   BE_BIT lro_context_match;                      // DWORD 0
   BE_BIT is_in_sequence;                         // DWORD 0
   BE_BIT rsvd1[6];                               // DWORD 0
   BE_BIT dbcred_check;                           // DWORD 0
   BE_BIT rsvd2[11];                              // DWORD 0
} SG_PACK BE_LRO_QCR_FORMAT_AMAP;
typedef struct { u32 dw[1]; } LRO_QCR_FORMAT_AMAP, *PLRO_QCR_FORMAT_AMAP;



typedef struct {
   BE_LRO_TCP_CONTEXT_AMAP ctx;
   BE_LRO_QCR_FORMAT_AMAP qcr;
} SG_PACK BE_LRO_TCP_CONTEXT_QCR_AMAP;
typedef struct { u32 dw[33]; } LRO_TCP_CONTEXT_QCR_AMAP, *PLRO_TCP_CONTEXT_QCR_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __lro_tcp_context_amap_h__

