/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __post_codes_amap_h__
#define __post_codes_amap_h__
#include "setypes.h"
#include "nativedefs.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- MGMT_HBA_POST_STAGE_ENUM ---
#define POST_STAGE_POWER_ON_RESET       (0)       // State after a cold or warm boot. 
#define POST_STAGE_AWAITING_HOST_RDY    (1)       // ARM boot code awaiting a go-ahed from
                                                  // the host.
#define POST_STAGE_HOST_RDY             (2)       // Host has given go-ahed to ARM. 
#define POST_STAGE_BE_RESET             (3)       // Host wants to reset chip, this is a
                                                  // chip workaround 
#define POST_STAGE_SEEPROM_CS_START     (256)     // SEEPROM checksum test start. 
#define POST_STAGE_SEEPROM_CS_DONE      (257)     // SEEPROM checksum test done. 
#define POST_STAGE_DDR_CONFIG_START     (512)     // DDR configuration start. 
#define POST_STAGE_DDR_CONFIG_DONE      (513)     // DDR configuration done. 
#define POST_STAGE_DDR_CALIBRATE_START  (768)     // DDR calibration start. 
#define POST_STAGE_DDR_CALIBRATE_DONE   (769)     // DDR calibration done. 
#define POST_STAGE_DDR_TEST_START       (1024)    // DDR memory test start. 
#define POST_STAGE_DDR_TEST_DONE        (1025)    // DDR memory test done. 
#define POST_STAGE_NCSI_INIT_START      (1104)    // NCSI Handshake start. 
#define POST_STAGE_NCSI_INIT_DONE       (1105)    // NCSI Handshake done. 
#define POST_STAGE_REDBOOT_INIT_START   (1536)    // Redboot starts execution. 
#define POST_STAGE_REDBOOT_INIT_DONE    (1537)    // Redboot done execution. 
#define POST_STAGE_FW_IMAGE_LOAD_START  (1792)    // Firmware image load to DDR start. 
#define POST_STAGE_FW_IMAGE_LOAD_DONE   (1793)    // Firmware image load to DDR done. 
#define POST_STAGE_FW_HW_MISMATCH       (1824)    // Firmware unsupported on this
                                                  // hardware. 
#define POST_STAGE_FW_DOWNLOAD_START    (1872)    // Firmware image download from host to
                                                  // DDR start. 
#define POST_STAGE_FW_DOWNLOAD_DONE     (1873)    // Firmware image donwload from host to
                                                  // DDR done. 
#define POST_STAGE_ARMFW_START          (2048)    // ARMfw runtime code starts execution. 
#define POST_STAGE_CHIP_INIT_START      (2064)    // ARMfw runtime chip initalization in
                                                  // progress. 
#define POST_STAGE_CHIP_INIT_DONE       (2065)    // ARMfw runtime chip initialization
                                                  // copmlete. 
#define POST_STAGE_QPGE_INIT_START      (2080)    // Qpge specific initalization in
                                                  // progress. 
#define POST_STAGE_QPGE_INIT_DONE       (2081)    // Qpge specific initialization
                                                  // copmlete. 
#define POST_STAGE_DHCP_QUERY_START     (2304)    // DHCP server query start. 
#define POST_STAGE_DHCP_QUERY_DONE      (2305)    // DHCP server query done. 
#define POST_STAGE_BOOT_TARGET_DISCOVERY_START (2560) // Boot Target Discovery Start. 
#define POST_STAGE_BOOT_TARGET_DISCOVERY_DONE (2561) // Boot Target Discovery Done. 
#define POST_STAGE_HANG_CONDITION       (2816)    // Hang condition before ARMfw is ready.
#define POST_STAGE_SWITCH_LINK          (2817)    // Wait for link up on switch 
#define POST_STAGE_SEND_ICDS_MESSAGE    (2818)    // Send the ICDS message to switch 
#define POST_STAGE_PERFROM_TFTP         (2819)    // Download xml using TFTP 
#define POST_STAGE_PARSE_XML            (2820)    // Parse XML file 
#define POST_STAGE_DOWNLOAD_IMAGE       (2821)    // Download IMAGE from TFTP server
#define POST_STAGE_FLASH_IMAGE          (2822)    // Flash the IMAGE 
#define POST_STAGE_RC_DONE              (2823)    // Remote configuration complete 
#define POST_STAGE_REBOOT_SYSTEM        (2824)    // Upgrade IMAGE done, reboot required 
#define POST_STAGE_MAC_ADDRESS          (3072)    // MAC Address Check 
#define POST_STAGE_FAT_LOG_START        (3328)    // ARMfw has detected a UE and is
                                                  // dumping FAT log data. 
#define POST_STAGE_FAT_LOG_END          (3329)    // ARMfw has completed dumping FAT log
                                                  // data. 
#define POST_STAGE_ARMFW_READY          (49152)   // ARMfw is done with POST and ready. 
#define POST_STAGE_ARMFW_UE             (61440)   // ARMfw has asserted an unrecoverable
                                                  // error. The lower 3 hex digits of the
                                                  // stage code identify the unique error
                                                  // code. 

typedef enum {
   ENUM_POST_STAGE_POWER_ON_RESET = 0x0UL,
   ENUM_POST_STAGE_AWAITING_HOST_RDY = 0x1UL,
   ENUM_POST_STAGE_HOST_RDY = 0x2UL,
   ENUM_POST_STAGE_BE_RESET = 0x3UL,
   ENUM_POST_STAGE_SEEPROM_CS_START = 0x100UL,
   ENUM_POST_STAGE_SEEPROM_CS_DONE = 0x101UL,
   ENUM_POST_STAGE_DDR_CONFIG_START = 0x200UL,
   ENUM_POST_STAGE_DDR_CONFIG_DONE = 0x201UL,
   ENUM_POST_STAGE_DDR_CALIBRATE_START = 0x300UL,
   ENUM_POST_STAGE_DDR_CALIBRATE_DONE = 0x301UL,
   ENUM_POST_STAGE_DDR_TEST_START = 0x400UL,
   ENUM_POST_STAGE_DDR_TEST_DONE = 0x401UL,
   ENUM_POST_STAGE_NCSI_INIT_START = 0x450UL,
   ENUM_POST_STAGE_NCSI_INIT_DONE = 0x451UL,
   ENUM_POST_STAGE_REDBOOT_INIT_START = 0x600UL,
   ENUM_POST_STAGE_REDBOOT_INIT_DONE = 0x601UL,
   ENUM_POST_STAGE_FW_IMAGE_LOAD_START = 0x700UL,
   ENUM_POST_STAGE_FW_IMAGE_LOAD_DONE = 0x701UL,
   ENUM_POST_STAGE_FW_HW_MISMATCH = 0x720UL,
   ENUM_POST_STAGE_FW_DOWNLOAD_START = 0x750UL,
   ENUM_POST_STAGE_FW_DOWNLOAD_DONE = 0x751UL,
   ENUM_POST_STAGE_ARMFW_START = 0x800UL,
   ENUM_POST_STAGE_CHIP_INIT_START = 0x810UL,
   ENUM_POST_STAGE_CHIP_INIT_DONE = 0x811UL,
   ENUM_POST_STAGE_QPGE_INIT_START = 0x820UL,
   ENUM_POST_STAGE_QPGE_INIT_DONE = 0x821UL,
   ENUM_POST_STAGE_DHCP_QUERY_START = 0x900UL,
   ENUM_POST_STAGE_DHCP_QUERY_DONE = 0x901UL,
   ENUM_POST_STAGE_BOOT_TARGET_DISCOVERY_START = 0xa00UL,
   ENUM_POST_STAGE_BOOT_TARGET_DISCOVERY_DONE = 0xa01UL,
   ENUM_POST_STAGE_HANG_CONDITION = 0xb00UL,
   ENUM_POST_STAGE_SWITCH_LINK = 0xb01UL,
   ENUM_POST_STAGE_SEND_ICDS_MESSAGE = 0xb02UL,
   ENUM_POST_STAGE_PERFROM_TFTP = 0xb03UL,
   ENUM_POST_STAGE_PARSE_XML = 0xb04UL,
   ENUM_POST_STAGE_DOWNLOAD_IMAGE = 0xb05UL,
   ENUM_POST_STAGE_FLASH_IMAGE = 0xb06UL,
   ENUM_POST_STAGE_RC_DONE = 0xb07UL,
   ENUM_POST_STAGE_REBOOT_SYSTEM = 0xb08UL,
   ENUM_POST_STAGE_MAC_ADDRESS = 0xc00UL,
   ENUM_POST_STAGE_FAT_LOG_START = 0xd00UL,
   ENUM_POST_STAGE_FAT_LOG_END = 0xd01UL,
   ENUM_POST_STAGE_ARMFW_READY = 0xc000UL,
   ENUM_POST_STAGE_ARMFW_UE = 0xf000UL
} MGMT_HBA_POST_STAGE_ENUM;

//  This structure defines the format of the MPU semaphore          register when used for
// POST.         
typedef struct {
   BE_BIT stage[16];                              // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT p0_linkup;                              // DWORD 0
   BE_BIT p1_linkup;                              // DWORD 0
   BE_BIT flash_semaphore_request;                // DWORD 0
   BE_BIT flash_semaphore_status;                 // DWORD 0
   BE_BIT pxe_option_rom_flags[2];                // DWORD 0
   BE_BIT nic_driver_loaded;                      // DWORD 0
   BE_BIT iscsi_driver_loaded;                    // DWORD 0
   BE_BIT option_rom_installed;                   // DWORD 0
   BE_BIT iscsi_ip_conflict;                      // DWORD 0
   BE_BIT iscsi_no_ip;                            // DWORD 0
   BE_BIT backup_fw;                              // DWORD 0
   BE_BIT error;                                  // DWORD 0
} SG_PACK BE_MGMT_HBA_POST_STATUS_STRUCT_AMAP;
typedef struct { u32 dw[1]; } MGMT_HBA_POST_STATUS_STRUCT_AMAP, *PMGMT_HBA_POST_STATUS_STRUCT_AMAP;


// --- MGMT_HBA_POST_DUMMY_BITS_ENUM ---
#define POST_BIT_PORT0_LINKUP           (19)      
#define POST_BIT_PORT1_LINKUP           (20)      
#define POST_BIT_ISCSI_LOADED           (26)      
#define POST_BIT_OPTROM_INST            (27)      
#define POST_BIT_BAD_IP_ADDR            (28)      
#define POST_BIT_NO_IP_ADDR             (29)      
#define POST_BIT_BACKUP_FW              (30)      
#define POST_BIT_ERROR                  (31)      

typedef enum {
   ENUM_POST_BIT_PORT0_LINKUP = 0x13UL,
   ENUM_POST_BIT_PORT1_LINKUP = 0x14UL,
   ENUM_POST_BIT_ISCSI_LOADED = 0x1aUL,
   ENUM_POST_BIT_OPTROM_INST = 0x1bUL,
   ENUM_POST_BIT_BAD_IP_ADDR = 0x1cUL,
   ENUM_POST_BIT_NO_IP_ADDR = 0x1dUL,
   ENUM_POST_BIT_BACKUP_FW = 0x1eUL,
   ENUM_POST_BIT_ERROR = 0x1fUL
} MGMT_HBA_POST_DUMMY_BITS_ENUM;

// --- MGMT_HBA_POST_DUMMY_VALUES_ENUM ---
#define POST_PORT0_LINKUP               (524288)  
#define POST_PORT1_LINKUP               (1048576) 
#define POST_ISCSI_DRIVER_LOADED        (67108864) 
#define POST_OPTROM_INSTALLED           (134217728) 
#define POST_ISCSI_IP_ADDRESS_CONFLICT  (268435456) 
#define POST_ISCSI_NO_IP_ADDRESS        (536870912) 
#define POST_BACKUP_FW_LOADED           (1073741824) 
#define POST_FATAL_ERROR                (2147483648) 

typedef enum {
   ENUM_POST_PORT0_LINKUP = 0x80000UL,
   ENUM_POST_PORT1_LINKUP = 0x100000UL,
   ENUM_POST_ISCSI_DRIVER_LOADED = 0x4000000UL,
   ENUM_POST_OPTROM_INSTALLED = 0x8000000UL,
   ENUM_POST_ISCSI_IP_ADDRESS_CONFLICT = 0x10000000UL,
   ENUM_POST_ISCSI_NO_IP_ADDRESS = 0x20000000UL,
   ENUM_POST_BACKUP_FW_LOADED = 0x40000000UL,
   ENUM_POST_FATAL_ERROR = 0x80000000UL
} MGMT_HBA_POST_DUMMY_VALUES_ENUM;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __post_codes_amap_h__

