/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rdma_context_amap_h__
#define __rdma_context_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- RDMA_CTXT_FLAGS_ENUM ---
// QP Configuration flags
#define QPCF_RX_MPA_EN                  (1)       // Receive MPA encapsulation enabled
#define QPCF_TX_MPA_EN                  (2)       // Transmit MPA encapsulation enabled
#define QPCF_IRD_RESP_EN                (4)       // Allow inbound rdma read responses on
                                                  // this QP
#define QPCF_IRD_REQ_EN                 (8)       // Allow inbound rdma read requests on
                                                  // this QP
#define QPCF_ORD_EN                     (16)      // Allow outbound rdma read requests on
                                                  // this QP
#define QPCF_IRW_EN                     (32)      // Allow inbound rdma writes on this QP
#define QPCF_ORW_EN                     (64)      // Allow outbound rdma writes on this QP
#define QPCF_MW_BIND_EN                 (128)     // Memory window binding enabled

typedef enum {
   ENUM_QPCF_RX_MPA_EN = 0x1UL,
   ENUM_QPCF_TX_MPA_EN = 0x2UL,
   ENUM_QPCF_IRD_RESP_EN = 0x4UL,
   ENUM_QPCF_IRD_REQ_EN = 0x8UL,
   ENUM_QPCF_ORD_EN = 0x10UL,
   ENUM_QPCF_IRW_EN = 0x20UL,
   ENUM_QPCF_ORW_EN = 0x40UL,
   ENUM_QPCF_MW_BIND_EN = 0x80UL
} RDMA_CTXT_FLAGS_ENUM;

// --- RDMA_STATE_ENUM ---
// RDMA State
#define RDMA_STATE_NONE                 (0)       
#define RDMA_STATE_IDLE                 (1)       
#define RDMA_STATE_RTS                  (2)       
#define RDMA_STATE_CLOSING              (4)       
#define RDMA_STATE_TERMINATE            (5)       
#define RDMA_STATE_RSVD                 (6)       
#define RDMA_STATE_ERROR                (7)       

typedef enum {
   ENUM_RDMA_STATE_NONE = 0x0UL,
   ENUM_RDMA_STATE_IDLE = 0x1UL,
   ENUM_RDMA_STATE_RTS = 0x2UL,
   ENUM_RDMA_STATE_CLOSING = 0x4UL,
   ENUM_RDMA_STATE_TERMINATE = 0x5UL,
   ENUM_RDMA_STATE_RSVD = 0x6UL,
   ENUM_RDMA_STATE_ERROR = 0x7UL
} RDMA_STATE_ENUM;

// --- RUNTIME_FLAGS_ENUM ---
#define ORRJ_MODIFIED                   (128)     // orrj modified

typedef enum {
   ENUM_ORRJ_MODIFIED = 0x80UL
} RUNTIME_FLAGS_ENUM;

// --- QP_SIZE_ENUM ---
#define SQ_SIZE_2                       (0)       // 2 entries
#define SQ_SIZE_4                       (1)       // 4 entries
#define SQ_SIZE_8                       (2)       // 8 entries
#define SQ_SIZE_16                      (3)       // 16 entries
#define SQ_SIZE_32                      (4)       // 32 entries
#define SQ_SIZE_64                      (5)       // 64 entries
#define SQ_SIZE_128                     (6)       // 128 entries
#define SQ_SIZE_256                     (7)       // 256 entries
#define SQ_SIZE_512                     (8)       // 512 entries - only valid for RQ.

typedef enum {
   ENUM_SQ_SIZE_2 = 0x0UL,
   ENUM_SQ_SIZE_4 = 0x1UL,
   ENUM_SQ_SIZE_8 = 0x2UL,
   ENUM_SQ_SIZE_16 = 0x3UL,
   ENUM_SQ_SIZE_32 = 0x4UL,
   ENUM_SQ_SIZE_64 = 0x5UL,
   ENUM_SQ_SIZE_128 = 0x6UL,
   ENUM_SQ_SIZE_256 = 0x7UL,
   ENUM_SQ_SIZE_512 = 0x8UL
} QP_SIZE_ENUM;

// Context control structure for an RDMA Queue Pair
typedef struct {
   BE_BIT snd_prd[9];                             // DWORD 0
   BE_BIT cqid_sq[10];                            // DWORD 0
   BE_BIT pdid1[9];                               // DWORD 0
   BE_BIT valid1;                                 // DWORD 0
   BE_BIT sq_size[3];                             // DWORD 0
   BE_BIT tx_marker_off[9];                       // DWORD 1
   BE_BIT curr_sge[2];                            // DWORD 1
   BE_BIT max_sge[2];                             // DWORD 1
   BE_BIT d2p_pending;                            // DWORD 1
   BE_BIT opcode[4];                              // DWORD 1
   BE_BIT prev_te;                                // DWORD 1
   BE_BIT currdriverrequest;                      // DWORD 1
   BE_BIT currchiprequest;                        // DWORD 1
   BE_BIT rxmt;                                   // DWORD 1
   BE_BIT jrnl_match;                             // DWORD 1
   BE_BIT je_cur[8];                              // DWORD 1
   BE_BIT func;                                   // DWORD 1
   BE_BIT tx_send_msn[32];                        // DWORD 2
   BE_BIT tx_resp_bytes[32];                      // DWORD 3
   BE_BIT tx_send_bytes[32];                      // DWORD 4
   BE_BIT tx_rreq_msn[32];                        // DWORD 5
   BE_BIT chip_seq_no[32];                        // DWORD 6
   BE_BIT windows_bound[14];                      // DWORD 7
   BE_BIT snd_csmr[2];                            // DWORD 7
   BE_BIT chip_wqe_idx[14];                       // DWORD 7
   BE_BIT rsvd0[2];                               // DWORD 7
   BE_BIT cqid_rq[11];                            // DWORD 8
   BE_BIT rflags[2];                              // DWORD 8
   BE_BIT valid2;                                 // DWORD 8
   BE_BIT rcv_prd[9];                             // DWORD 8
   BE_BIT pdid2[9];                               // DWORD 8
   BE_BIT stake_seq_no[32];                       // DWORD 9
   BE_BIT irrj_read[2];                           // DWORD 10
   BE_BIT irrj_size[2];                           // DWORD 10
   BE_BIT irrj_io_write[2];                       // DWORD 10
   BE_BIT irrj_oo_write[2];                       // DWORD 10
   BE_BIT stake_wqe_idx[14];                      // DWORD 10
   BE_BIT orrj_write[2];                          // DWORD 10
   BE_BIT orrj_read[2];                           // DWORD 10
   BE_BIT rrsq_cnt[2];                            // DWORD 10
   BE_BIT rsvd1[4];                               // DWORD 10
   BE_BIT rx_send_msn[32];                        // DWORD 11
   BE_BIT rx_rreq_msn[32];                        // DWORD 12
   BE_BIT rx_marker_off[9];                       // DWORD 13
   BE_BIT flags[8];                               // DWORD 13
   BE_BIT fence;                                  // DWORD 13
   BE_BIT terminate;                              // DWORD 13
   BE_BIT error;                                  // DWORD 13
   BE_BIT rdma_state[3];                          // DWORD 13
   BE_BIT rcv_csmr[9];                            // DWORD 13
   BE_BIT exp_io_tcp_seq_no[32];                  // DWORD 14
   BE_BIT rq_size[4];                             // DWORD 15
   BE_BIT irrj_ddr_base_cra[28];                  // DWORD 15
} SG_PACK BE_QP_CONTEXT_AMAP;
typedef struct { u32 dw[16]; } QP_CONTEXT_AMAP, *PQP_CONTEXT_AMAP;


// Rdma Scatter/Gather Entry. This structure represents a single STag fragment. Multiple
// SGEs are typically combined into an RDMA Scatter Gather List. Many RDMA WQEs contain 1
// or more SGEs.
typedef struct {
   BE_BIT stag[32];                               // DWORD 0
   BE_BIT length[32];                             // DWORD 1
   BE_BIT to[64];                                 // DWORD 2
} SG_PACK BE_RDMA_SGE_AMAP;
typedef struct { u32 dw[4]; } RDMA_SGE_AMAP, *PRDMA_SGE_AMAP;


//  The RDMA Inbound Read Request Journal stores context for RDMA inbound read operations.
//     
typedef struct {
   BE_BIT sink_stag[32];                          // DWORD 0
   BE_BIT sink_TO[64];                            // DWORD 1
   BE_BIT source_stag[16];                        // DWORD 3
   BE_BIT rsvd0[16];                              // DWORD 3
   BE_BIT source_TO[64];                          // DWORD 4
   BE_BIT length[30];                             // DWORD 6
   BE_BIT valid;                                  // DWORD 6
   BE_BIT rsvd1;                                  // DWORD 6
   BE_BIT rsvd2[32];                              // DWORD 7
} SG_PACK BE_RDMA_IRRJ_AMAP;
typedef struct { u32 dw[8]; } RDMA_IRRJ_AMAP, *PRDMA_IRRJ_AMAP;


//  The RDMA WQE that is commonly used for SEND and WRITE .     
typedef struct {
   BE_BIT curr_offset[32];                        // DWORD 0
   BE_BIT remote_stag[32];                        // DWORD 1
   BE_BIT to_0[32];                               // DWORD 2
   BE_BIT to_1[32];                               // DWORD 3
   BE_BIT stag[32];                               // DWORD 4
   BE_BIT len[32];                                // DWORD 5
   BE_BIT addr_lo[32];                            // DWORD 6
   BE_BIT addr_hi[32];                            // DWORD 7
} SG_PACK BE_RDMA_WQE_AMAP;
typedef struct { u32 dw[8]; } RDMA_WQE_AMAP, *PRDMA_WQE_AMAP;


//  The RDMA WQE that is commonly used for SEND and WRITE .     
typedef struct {
   BE_BIT curr_offset[32];                        // DWORD 0
   BE_BIT remote_stag[32];                        // DWORD 1
   BE_BIT opcode[8];                              // DWORD 2
   BE_BIT flags[16];                              // DWORD 2
   BE_BIT sge_count[8];                           // DWORD 2
   BE_BIT rsvd0[32];                              // DWORD 3
   BE_BIT stag[32];                               // DWORD 4
   BE_BIT len[32];                                // DWORD 5
   BE_BIT addr_lo[32];                            // DWORD 6
   BE_BIT addr_hi[32];                            // DWORD 7
} SG_PACK BE_RDMA_HDR_WQE_AMAP;
typedef struct { u32 dw[8]; } RDMA_HDR_WQE_AMAP, *PRDMA_HDR_WQE_AMAP;



typedef struct {
   BE_BIT orrj_start_seq_num[32];                 // DWORD 0
   BE_BIT orrj_wqe_index[14];                     // DWORD 1
   BE_BIT event;                                  // DWORD 1
   BE_BIT read_req_only;                          // DWORD 1
   BE_BIT rsvd0[16];                              // DWORD 1
} SG_PACK BE_RDMA_ORRJ_AMAP;
typedef struct { u32 dw[2]; } RDMA_ORRJ_AMAP, *PRDMA_ORRJ_AMAP;



typedef struct {
   BE_BIT read_resp_seq_no[32];                   // DWORD 0
} SG_PACK BE_RDMA_RRSQ_ENTRY_AMAP;
typedef struct { u32 dw[1]; } RDMA_RRSQ_ENTRY_AMAP, *PRDMA_RRSQ_ENTRY_AMAP;


// Context control structures for RDMA ORRJ (4 Entries of 8 bytes) + RDMA RRSQ (4 Entries
// of 4 bytes each)
typedef struct {
   BE_RDMA_ORRJ_AMAP orrj[4];
   BE_RDMA_RRSQ_ENTRY_AMAP rrsq[4];
} SG_PACK BE_RDMA_RD_JRNLS_AMAP;
typedef struct { u32 dw[12]; } RDMA_RD_JRNLS_AMAP, *PRDMA_RD_JRNLS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __rdma_context_amap_h__

