/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __regmap_amap_h__
#define __regmap_amap_h__
#include "setypes.h"
#include "pcicfg.h"
#include "pq.h"
#include "jellm.h"
#include "ep.h"
#include "btlr.h"
#include "hwdbg_reg.h"
#include "d2p.h"
#include "ep_minirom.h"
#include "gencommon.h"
#include "ctx.h"
#include "cev.h"
#include "ptc.h"
#include "uc.h"
#include "rxf.h"
#include "erx.h"
#include "lpc.h"
#include "mpu.h"
#include "tpost.h"
#include "rxulp.h"
#include "txulp.h"
#include "tpre.h"
#include "txpb.h"
#include "txp.h"
#include "wdma.h"
#include "rdma.h"
#include "ndma.h"
#include "dbuf.h"
#include "pmem.h"
#include "wcon.h"
#include "doorbells.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// This is the control and status register map for BladeEngine, showing the relative size
// and offset of each sub-module. The CSR registers are identical for the network and
// storage PCI functions. The CSR map is shown below, followed by details of each block,
// in sub-sections.  The sub-sections begin with a description of CSRs that are
// instantiated in multiple blocks.
typedef struct {
   BE_MPU_CSRMAP_AMAP mpu;
   BE_TPOST_CSRMAP_AMAP tpost;
   BE_BIT rsvd0[8192];                            // DWORD 512
   BE_CEV_CSRMAP_AMAP cev;
   BE_BIT rsvd1[8192];                            // DWORD 1024
   BE_BIT rsvd2[8192];                            // DWORD 1280
   BE_BIT rsvd3[8192];                            // DWORD 1536
   BE_BIT rsvd4[8192];                            // DWORD 1792
   BE_BIT rsvd5[8192];                            // DWORD 2048
   BE_BIT rsvd6[8192];                            // DWORD 2304
   BE_BIT rsvd7[8192];                            // DWORD 2560
   BE_BIT rsvd8[8192];                            // DWORD 2816
   BE_BIT rsvd9[8192];                            // DWORD 3072
   BE_BIT rsvd10[8192];                           // DWORD 3328
   BE_BIT rsvd11[8192];                           // DWORD 3584
   BE_BIT rsvd12[8192];                           // DWORD 3840
   BE_BIT rsvd13[8192];                           // DWORD 4096
   BE_BIT rsvd14[8192];                           // DWORD 4352
   BE_BIT rsvd15[8192];                           // DWORD 4608
   BE_BIT rsvd16[8192];                           // DWORD 4864
   BE_BIT rsvd17[8192];                           // DWORD 5120
   BE_BIT rsvd18[8192];                           // DWORD 5376
   BE_BIT rsvd19[17920][32];                      // DWORD 5632
} SG_PACK BE_BLADE_ENGINE_CSRMAP_AMAP;
typedef struct { u32 dw[23552]; } BLADE_ENGINE_CSRMAP_AMAP, *PBLADE_ENGINE_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __regmap_amap_h__

