/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tpre_exp_amap_h__
#define __tpre_exp_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_BIT ipv4_rx_bytes[8][32];                   // DWORD 0
   BE_BIT ipv6_rx_bytes[8][32];                   // DWORD 8
   BE_BIT ipv4_rx_frames[8][32];                  // DWORD 16
   BE_BIT ipv6_rx_frames[8][32];                  // DWORD 24
   BE_BIT rx_window_probes[8][32];                // DWORD 32
   BE_BIT rx_window_updates[8][32];               // DWORD 40
   BE_BIT rxmit_timeouts[8][32];                  // DWORD 48
   BE_BIT ooo_packets[8][32];                     // DWORD 56
   BE_BIT delayed_acks_sent[8][32];               // DWORD 64
   BE_BIT rx_acks[8][32];                         // DWORD 72
   BE_BIT rx_duplicate_acks[8][32];               // DWORD 80
   BE_BIT ipv4_drops[8][32];                      // DWORD 88
   BE_BIT ipv6_drops[8][32];                      // DWORD 96
   BE_BIT duplicate_rx_bytes[32];                 // DWORD 104
   BE_BIT partial_duplicate_rx_bytes[32];         // DWORD 105
   BE_BIT bytes_after_window[32];                 // DWORD 106
   BE_BIT rx_prediction_segments[32];             // DWORD 107
   BE_BIT cam_bug_drops[32];                      // DWORD 108
   BE_BIT rx_dup_frames[32];                      // DWORD 109
   BE_BIT paws_drops[32];                         // DWORD 110
   BE_BIT rx_partial_duplicate_frames[32];        // DWORD 111
   BE_BIT packets_after_window[32];               // DWORD 112
   BE_BIT buffer_credit_drops[32];                // DWORD 113
   BE_BIT rx_ack_too_much[32];                    // DWORD 114
   BE_BIT timeout_drops[32];                      // DWORD 115
   BE_BIT ooo_disable_drops[32];                  // DWORD 116
   BE_BIT ooo_prepend_drops[32];                  // DWORD 117
   BE_BIT ooo_tt_replay_drops[32];                // DWORD 118
   BE_BIT fast_retransmits[32];                   // DWORD 119
   BE_BIT syn_in_window[32];                      // DWORD 120
   BE_BIT state_changes[32];                      // DWORD 121
   BE_BIT tt_data_pack[32];                       // DWORD 122
   BE_BIT tt_data_bytes[32];                      // DWORD 123
   BE_BIT p0_immack_queue_full[32];               // DWORD 124
   BE_BIT p1_immack_queue_full[32];               // DWORD 125
   BE_BIT immacks[32];                            // DWORD 126
   BE_BIT dbcred_return[32];                      // DWORD 127
   BE_BIT rx_ack_too_old[32];                     // DWORD 128
   BE_BIT rxmt_complete[32];                      // DWORD 129
   BE_BIT tcp_flush[32];                          // DWORD 130
   BE_BIT tcp_update_ipc_cnt[32];                 // DWORD 131
   BE_BIT lro_red_discard_count[32];              // DWORD 132
   BE_BIT lro_credit_discard_count[32];           // DWORD 133
   BE_BIT lro_packet_count[32];                   // DWORD 134
   BE_BIT lro_singleton_count[32];                // DWORD 135
   BE_BIT lro_chain_count[32];                    // DWORD 136
   BE_BIT lro_chainbreak_timeout[32];             // DWORD 137
   BE_BIT lro_chainbreak_maxlen[32];              // DWORD 138
   BE_BIT lro_chainbreak_maxpkts[32];             // DWORD 139
   BE_BIT lro_chainbreak_singleton[32];           // DWORD 140
   BE_BIT lro_chainbreak_collision[32];           // DWORD 141
   BE_BIT lro_chainbreak_ooo[32];                 // DWORD 142
   BE_BIT lro_flush_count[32];                    // DWORD 143
   BE_BIT tpre_int_debug_stat_1[32];              // DWORD 144
   BE_BIT tpre_int_debug_stat_2[32];              // DWORD 145
   BE_BIT tpre_int_debug_stat_3[32];              // DWORD 146
   BE_BIT tpre_int_debug_stat_4[32];              // DWORD 147
   BE_BIT p0_rx_bytes[32];                        // DWORD 148
   BE_BIT p1_rx_bytes[32];                        // DWORD 149
   BE_BIT p0_rx_frames[32];                       // DWORD 150
   BE_BIT p1_rx_frames[32];                       // DWORD 151
   BE_BIT p0_rx_sequences[32];                    // DWORD 152
   BE_BIT p1_rx_sequences[32];                    // DWORD 153
   BE_BIT p0_XON_xmit_count[32];                  // DWORD 154
   BE_BIT p1_XON_xmit_count[32];                  // DWORD 155
   BE_BIT p0_XOFF_xmit_count[32];                 // DWORD 156
   BE_BIT p1_XOFF_xmit_count[32];                 // DWORD 157
   BE_BIT p0_XON_timer_pops[32];                  // DWORD 158
   BE_BIT p1_XON_timer_pops[32];                  // DWORD 159
   BE_BIT p0_EOFni_count[32];                     // DWORD 160
   BE_BIT p1_EOFni_count[32];                     // DWORD 161
   BE_BIT p0_EOFa_count[32];                      // DWORD 162
   BE_BIT p1_EOFa_count[32];                      // DWORD 163
   BE_BIT frame_type_count[13][32];               // DWORD 164
   BE_BIT frame_discard_count[8][32];             // DWORD 177
   BE_BIT rsvd0[224];                             // DWORD 185
} SG_PACK BE_BE_TPRE_FUNC_STATS_AMAP;
typedef struct { u32 dw[192]; } BE_TPRE_FUNC_STATS_AMAP, *PBE_TPRE_FUNC_STATS_AMAP;



typedef struct {
   BE_BIT rsvd2[1568];                            // DWORD 0
   BE_BIT rsvd0[16];                              // DWORD 49
   BE_BIT win_probes[16];                         // DWORD 49
   BE_BIT partial_dup_acks[32];                   // DWORD 50
   BE_BIT dup_packets[32];                        // DWORD 51
   BE_BIT ooo_packets_desc[32];                   // DWORD 52
   BE_BIT non_zero_packets[32];                   // DWORD 53
   BE_BIT rcv_ack_packets[32];                    // DWORD 54
   BE_BIT rx_total[32];                           // DWORD 55
   BE_BIT rx_ulp2[32];                            // DWORD 56
   BE_BIT rx_ulp1[32];                            // DWORD 57
   BE_BIT rx_ulp0[32];                            // DWORD 58
   BE_BIT rsvd1[32];                              // DWORD 59
   BE_BIT dup_acks[16];                           // DWORD 60
   BE_BIT timer_drop[16];                         // DWORD 60
   BE_BIT red_global[16];                         // DWORD 61
   BE_BIT red_ulp2[16];                           // DWORD 61
   BE_BIT red_ulp1[16];                           // DWORD 62
   BE_BIT red_ulp0[16];                           // DWORD 62
   BE_BIT rsvd3[32];                              // DWORD 63
} SG_PACK BE_BE_TPRE_HW_STATS_AMAP;
typedef struct { u32 dw[64]; } BE_TPRE_HW_STATS_AMAP, *PBE_TPRE_HW_STATS_AMAP;



typedef struct {
   BE_BE_TPRE_FUNC_STATS_AMAP func_stats;
   BE_BE_TPRE_HW_STATS_AMAP hw_stats;
} SG_PACK BE_BE_TPRE_STATS_AMAP;
typedef struct { u32 dw[256]; } BE_TPRE_STATS_AMAP, *PBE_TPRE_STATS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tpre_exp_amap_h__

