/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __vf_pcicfg_amap_h__
#define __vf_pcicfg_amap_h__
#include "setypes.h"
#include "defines.h"
#include "mpu_local_mmr.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// VF Vendor and Device ID Register.
typedef struct {
   BE_BIT vendorid[16];                           // DWORD 0
   BE_BIT deviceid[16];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_ID_CSR_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_ID_CSR_AMAP, *PVF_PCICFG_ID_CSR_AMAP;


// Class Code and Revision ID Register. This register identifies the type of Device.
typedef struct {
   BE_BIT rev[8];                                 // DWORD 0
   BE_BIT prgintf[8];                             // DWORD 0
   BE_BIT subclass[8];                            // DWORD 0
   BE_BIT baseclass[8];                           // DWORD 0
} SG_PACK BE_VF_PCICFG_CLASS_REV_CSR_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_CLASS_REV_CSR_AMAP, *PVF_PCICFG_CLASS_REV_CSR_AMAP;


// Subsystem Vendor and ID (Function 0) Register.
typedef struct {
   BE_BIT subsys_vendor_id[16];                   // DWORD 0
   BE_BIT subsys_id[16];                          // DWORD 0
} SG_PACK BE_VF_PCICFG_SUBSYSTEM_ID_CSR_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_SUBSYSTEM_ID_CSR_AMAP, *PVF_PCICFG_SUBSYSTEM_ID_CSR_AMAP;


// PF's VF Function Numeber
typedef struct {
   BE_BIT vf_function_num[8];                     // DWORD 0
   BE_BIT pf_function_num[3];                     // DWORD 0
   BE_BIT rsvd0[18];                              // DWORD 0
   BE_BIT hostintr;                               // DWORD 0
   BE_BIT rsvd1[2];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_INT_CTRL_FUNCTION_NUM_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_INT_CTRL_FUNCTION_NUM_AMAP, *PVF_PCICFG_INT_CTRL_FUNCTION_NUM_AMAP;


// PCI Express Link Status Register.
typedef struct {
   BE_BIT ASPMCtl[2];                             // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT ReadCmplBndry;                          // DWORD 0
   BE_BIT LinkDisable;                            // DWORD 0
   BE_BIT RetrainLink;                            // DWORD 0
   BE_BIT CommonClkConfig;                        // DWORD 0
   BE_BIT ExtendSync;                             // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT hw_autonomous_width_dis;                // DWORD 0
   BE_BIT rsvd2[6];                               // DWORD 0
   BE_BIT LinkSpeed[4];                           // DWORD 0
   BE_BIT NegLinkWidth[6];                        // DWORD 0
   BE_BIT LinkTrainErr;                           // DWORD 0
   BE_BIT LinkTrain;                              // DWORD 0
   BE_BIT SlotClkConfig;                          // DWORD 0
   BE_BIT rsvd3[3];                               // DWORD 0
} SG_PACK BE_VF_PCICFG_PCIE_LINK_STATUS_CSR_AMAP;
typedef struct { u32 dw[1]; } VF_PCICFG_PCIE_LINK_STATUS_CSR_AMAP, *PVF_PCICFG_PCIE_LINK_STATUS_CSR_AMAP;


//  This PCI configuration space register map is for the          Virtual Function.       
//   
typedef struct {
   BE_VF_PCICFG_ID_CSR_AMAP id;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_VF_PCICFG_CLASS_REV_CSR_AMAP class_rev;
   BE_BIT rsvd1[32];                              // DWORD 3
   BE_BIT rsvd2[192];                             // DWORD 4
   BE_BIT rsvd3[32];                              // DWORD 10
   BE_VF_PCICFG_SUBSYSTEM_ID_CSR_AMAP subsystem_id;
   BE_BIT rsvd4[32];                              // DWORD 12
   BE_BIT rsvd5[32];                              // DWORD 13
   BE_BIT rsvd6[64];                              // DWORD 14
   BE_BIT rsvd7[64];                              // DWORD 16
   BE_BIT rsvd8[32];                              // DWORD 18
   BE_BIT rsvd9[32];                              // DWORD 19
   BE_BIT rsvd10[32];                             // DWORD 20
   BE_BIT rsvd11[352];                            // DWORD 21
   BE_BIT rsvd12[512];                            // DWORD 32
   BE_BIT rsvd13[32];                             // DWORD 48
   BE_BIT rsvd14[32];                             // DWORD 49
   BE_BIT rsvd15[32];                             // DWORD 50
   BE_BIT rsvd16[32];                             // DWORD 51
   BE_VF_PCICFG_PCIE_LINK_STATUS_CSR_AMAP pcie_link_status;
   BE_BIT rsvd17[4][32];                          // DWORD 53
   BE_BIT rsvd18[32];                             // DWORD 57
   BE_BIT rsvd19[32];                             // DWORD 58
   BE_BIT rsvd20[32];                             // DWORD 59
   BE_BIT rsvd21[32];                             // DWORD 60
   BE_BIT rsvd22[2][32];                          // DWORD 61
   BE_VF_PCICFG_INT_CTRL_FUNCTION_NUM_AMAP host_int_ctrl_vf_fnum;
   BE_BIT rsvd23[32];                             // DWORD 64
   BE_BIT rsvd24[32];                             // DWORD 65
   BE_BIT rsvd25[768];                            // DWORD 66
   BE_BIT rsvd26[32];                             // DWORD 90
   BE_BIT rsvd27[32];                             // DWORD 91
   BE_BIT rsvd28[32];                             // DWORD 92
   BE_BIT rsvd29[32];                             // DWORD 93
   BE_BIT rsvd30[32];                             // DWORD 94
   BE_BIT rsvd31[32];                             // DWORD 95
   BE_BIT rsvd32[32];                             // DWORD 96
   BE_BIT rsvd33[32];                             // DWORD 97
   BE_BIT rsvd34[32];                             // DWORD 98
   BE_BIT rsvd35[32];                             // DWORD 99
   BE_BIT rsvd36[32];                             // DWORD 100
   BE_BIT rsvd37[32];                             // DWORD 101
   BE_BIT rsvd38[576];                            // DWORD 102
   BE_BIT rsvd39[28928];                          // DWORD 120
} SG_PACK BE_VF_PCICFG_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } VF_PCICFG_CSRMAP_AMAP, *PVF_PCICFG_CSRMAP_AMAP;


//  This PCI configuration space register map is for the         Virtual Function.        
typedef struct {
   BE_VF_PCICFG_CSRMAP_AMAP pf_8vfs[8];
} SG_PACK BE_VF_PCICFG_CSRMAP_PF_8VF_AMAP;
typedef struct { u32 dw[8192]; } VF_PCICFG_CSRMAP_PF_8VF_AMAP, *PVF_PCICFG_CSRMAP_PF_8VF_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __vf_pcicfg_amap_h__

