/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __be_cm_enum_h__
#define __be_cm_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "be_common_enum.h"
#include "cev_enum.h"
#include "common_context_enum.h"
#include "iscsi_context_enum.h"
#include "rdma_context_enum.h"
#include "fc_device_context_enum.h"
#include "toe_context_enum.h"
#include "tcp_context_enum.h"
#include "lro_tcp_context_enum.h"
#include "tcp_sack_enum.h"
#include "mpu_context_enum.h"
#include "ipsec_sa_structs_enum.h"
#include "dal_context_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- DAL_RINGS ---
#define MAX_DAL_RINGS                   (32)      

typedef enum {
   ENUM_MAX_DAL_RINGS = 0x20UL
} DAL_RINGS;

// --- DAL_RX_IDX_CACHED ---
#define MAX_DAL_RX_IDX_CACHED           (32)      

typedef enum {
   ENUM_MAX_DAL_RX_IDX_CACHED = 0x20UL
} DAL_RX_IDX_CACHED;

// --- LRO_RINGS ---
#define MAX_LRO_RINGS                   (64)      

typedef enum {
   ENUM_MAX_LRO_RINGS = 0x40UL
} LRO_RINGS;

// --- DEFAULT_BUFFER_QUEUES ---
#define MAX_DEFAULT_BUFFER_QUEUES       (8)       

typedef enum {
   ENUM_MAX_DEFAULT_BUFFER_QUEUES = 0x8UL
} DEFAULT_BUFFER_QUEUES;

// --- TOE_CIDS ---
#define MAX_TOE_CIDS                    (448)     

typedef enum {
   ENUM_MAX_TOE_CIDS = 0x1c0UL
} TOE_CIDS;

// --- ISCSI_ICDS ---
#define CFG0_ISCSI_ICDS                 (2048)    

typedef enum {
   ENUM_CFG0_ISCSI_ICDS = 0x800UL
} ISCSI_ICDS;

// --- ISCSI_CXNS ---
#define CFG0_ISCSI_CXNS                 (512)     

typedef enum {
   ENUM_CFG0_ISCSI_CXNS = 0x200UL
} ISCSI_CXNS;

// --- TGT_ISCSI_ICDS ---
#define CFG3_ISCSI_ICDS                 (2048)    

typedef enum {
   ENUM_CFG3_ISCSI_ICDS = 0x800UL
} TGT_ISCSI_ICDS;

// --- TGT_ISCSI_CXNS ---
#define CFG3_ISCSI_CXNS                 (1000)    

typedef enum {
   ENUM_CFG3_ISCSI_CXNS = 0x3e8UL
} TGT_ISCSI_CXNS;

// --- INITGT_ISCSI_ICDS ---
#define CFG9_ISCSI_ICDS                 (2048)    

typedef enum {
   ENUM_CFG9_ISCSI_ICDS = 0x800UL
} INITGT_ISCSI_ICDS;

// --- INITGT_ISCSI_CXNS ---
#define CFG9_ISCSI_CXNS                 (1000)    

typedef enum {
   ENUM_CFG9_ISCSI_CXNS = 0x3e8UL
} INITGT_ISCSI_CXNS;

// --- CFG7_CTX_MEM_PARAMS ---
#define CFG7_NUM_FC_R2T_RING_CTX        (0)       
#define CFG7_NUM_FC_INTERFACE_CTX       (64)      
#define CFG7_NUM_FC_WRB_RING_CTX        (256)     
#define CFG7_NUM_FC_RBQ                 (256)     
#define CFG7_NUM_TOE_CTX                (384)     
#define CFG7_NUM_FC_ICD_CTX             (2048)    
#define CFG7_NUM_FC_RPI_CTX             (2048)    
#define CFG7_INVALID_RBQ_ID             (65535)   

typedef enum {
   ENUM_CFG7_NUM_FC_R2T_RING_CTX = 0x0UL,
   ENUM_CFG7_NUM_FC_INTERFACE_CTX = 0x40UL,
   ENUM_CFG7_NUM_FC_WRB_RING_CTX = 0x100UL,
   ENUM_CFG7_NUM_FC_RBQ = 0x100UL,
   ENUM_CFG7_NUM_TOE_CTX = 0x180UL,
   ENUM_CFG7_NUM_FC_ICD_CTX = 0x800UL,
   ENUM_CFG7_NUM_FC_RPI_CTX = 0x800UL,
   ENUM_CFG7_INVALID_RBQ_ID = 0xffffUL
} CFG7_CTX_MEM_PARAMS;

#endif // __be_cm_enum_h__

