/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fat_header_enum_h__
#define __fat_header_enum_h__
#include "setypes.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- BE_FAT_SIGNATURES ---
#define BE_FAT_HDR_SIGNATURE            (215793329) 
#define BE_FAT_DATA_SIGNATURE           (447528638) 
#define BE_FAT_SUBSECTION_SIGNATURE     (664568609) 
#define BE_FAT_DMA_SIGNATURE            (900876316) 
#define BE_FAT_RXF_SUBSECTION_SIGNATURE (1252283750) 
#define BE_FAT_TXD_SIGNATURE            (1301990257) 
#define BE_FAT_CONTEXT_SIGNATURE        (1539074194) 
#define BE_FAT_EP_SUBSECTION_SIGNATURE  (1835477488) 
#define BE_FAT_DATA_FOOTER_SIGNATURE    (2058346157) 

typedef enum {
   ENUM_BE_FAT_HDR_SIGNATURE = 0xcdcbeb1UL,
   ENUM_BE_FAT_DATA_SIGNATURE = 0x1aacbebeUL,
   ENUM_BE_FAT_SUBSECTION_SIGNATURE = 0x279c8321UL,
   ENUM_BE_FAT_DMA_SIGNATURE = 0x35b2481cUL,
   ENUM_BE_FAT_RXF_SUBSECTION_SIGNATURE = 0x4aa45566UL,
   ENUM_BE_FAT_TXD_SIGNATURE = 0x4d9acb71UL,
   ENUM_BE_FAT_CONTEXT_SIGNATURE = 0x5bbc6892UL,
   ENUM_BE_FAT_EP_SUBSECTION_SIGNATURE = 0x6d6729f0UL,
   ENUM_BE_FAT_DATA_FOOTER_SIGNATURE = 0x7aafdeadUL
} BE_FAT_SIGNATURES;

// --- FAT_CHIP_REV ---
#define FAT_CHIPREV_B2                  (1792)    
#define FAT_CHIPREV_B3                  (1808)    
#define FAT_CHIPREV_SKYHAWK             (4319)    

typedef enum {
   ENUM_FAT_CHIPREV_B2 = 0x700UL,
   ENUM_FAT_CHIPREV_B3 = 0x710UL,
   ENUM_FAT_CHIPREV_SKYHAWK = 0x10dfUL
} FAT_CHIP_REV;

// --- FAT_HDR_VERSION ---
#define FAT_HDR_VERSION1                (1)       
#define FAT_HDR_VERSION_CURRENT         (1)       

typedef enum {
   ENUM_FAT_HDR_VERSION1 = 0x1UL,
   ENUM_FAT_HDR_VERSION_CURRENT = 0x1UL
} FAT_HDR_VERSION;

// --- FAT_DATA_ID ---
#define FAT_DATA_ID_EP_CSR              (0)       
#define FAT_DATA_ID_MPU_CSR             (1)       
#define FAT_DATA_ID_EP_DUMP             (2)       
#define FAT_DATA_ID_SEEPROM             (3)       
#define FAT_DATA_ID_AUX_REG             (4)       
#define FAT_DATA_ID_RXF_STATS           (5)       
#define FAT_DATA_ID_TXP_STATS           (6)       
#define FAT_DATA_ID_TXD_DATA            (7)       
#define FAT_DATA_ID_PTC_STATS           (8)       
#define FAT_DATA_ID_UC_STATS            (9)       
#define FAT_DATA_ID_NDMA                (10)      
#define FAT_DATA_ID_RXF_DATA            (11)      
#define FAT_DATA_ID_RDMA                (12)      
#define FAT_DATA_ID_WDMA                (13)      
#define FAT_DATA_ID_CONTEXT             (14)      
#define FAT_DATA_ID_PMEM                (15)      
#define FAT_DATA_ID_PMEM_DATA           (16)      
#define FAT_DATA_ID_TXPB                (17)      
#define FAT_DATA_ID_TPRE_VQ             (18)      
#define FAT_DATA_ID_TPOST_VQ            (19)      
#define FAT_DATA_ID_TXP_VQ              (20)      
#define FAT_DATA_ID_RXULP_VQ            (21)      
#define FAT_DATA_ID_EXTFAT              (22)      
#define FAT_DATA_ID_MPU_SYSREG          (23)      
#define FAT_DATA_ID_MPU_DDRREG          (24)      

typedef enum {
   ENUM_FAT_DATA_ID_EP_CSR = 0x0UL,
   ENUM_FAT_DATA_ID_MPU_CSR = 0x1UL,
   ENUM_FAT_DATA_ID_EP_DUMP = 0x2UL,
   ENUM_FAT_DATA_ID_SEEPROM = 0x3UL,
   ENUM_FAT_DATA_ID_AUX_REG = 0x4UL,
   ENUM_FAT_DATA_ID_RXF_STATS = 0x5UL,
   ENUM_FAT_DATA_ID_TXP_STATS = 0x6UL,
   ENUM_FAT_DATA_ID_TXD_DATA = 0x7UL,
   ENUM_FAT_DATA_ID_PTC_STATS = 0x8UL,
   ENUM_FAT_DATA_ID_UC_STATS = 0x9UL,
   ENUM_FAT_DATA_ID_NDMA = 0xaUL,
   ENUM_FAT_DATA_ID_RXF_DATA = 0xbUL,
   ENUM_FAT_DATA_ID_RDMA = 0xcUL,
   ENUM_FAT_DATA_ID_WDMA = 0xdUL,
   ENUM_FAT_DATA_ID_CONTEXT = 0xeUL,
   ENUM_FAT_DATA_ID_PMEM = 0xfUL,
   ENUM_FAT_DATA_ID_PMEM_DATA = 0x10UL,
   ENUM_FAT_DATA_ID_TXPB = 0x11UL,
   ENUM_FAT_DATA_ID_TPRE_VQ = 0x12UL,
   ENUM_FAT_DATA_ID_TPOST_VQ = 0x13UL,
   ENUM_FAT_DATA_ID_TXP_VQ = 0x14UL,
   ENUM_FAT_DATA_ID_RXULP_VQ = 0x15UL,
   ENUM_FAT_DATA_ID_EXTFAT = 0x16UL,
   ENUM_FAT_DATA_ID_MPU_SYSREG = 0x17UL,
   ENUM_FAT_DATA_ID_MPU_DDRREG = 0x18UL
} FAT_DATA_ID;

// --- FAT_EP_ID ---
#define FAT_EP_ID_TPOST                 (0)       
#define FAT_EP_ID_TPRE                  (1)       
#define FAT_EP_TXULP0                   (2)       
#define FAT_EP_TXULP1                   (3)       
#define FAT_EP_RXULP0                   (5)       
#define FAT_EP_RXULP1                   (6)       
#define FAT_ARM_MPU                     (15)      
#define FAT_NON_SPECIFIC                (65280)   
#define FAT_EP_END_MARKER               (65535)   
#define FAT_EP_ID_ALL_CSR               (2147483647) 

typedef enum {
   ENUM_FAT_EP_ID_TPOST = 0x0UL,
   ENUM_FAT_EP_ID_TPRE = 0x1UL,
   ENUM_FAT_EP_TXULP0 = 0x2UL,
   ENUM_FAT_EP_TXULP1 = 0x3UL,
   ENUM_FAT_EP_RXULP0 = 0x5UL,
   ENUM_FAT_EP_RXULP1 = 0x6UL,
   ENUM_FAT_ARM_MPU = 0xfUL,
   ENUM_FAT_NON_SPECIFIC = 0xff00UL,
   ENUM_FAT_EP_END_MARKER = 0xffffUL,
   ENUM_FAT_EP_ID_ALL_CSR = 0x7fffffffUL
} FAT_EP_ID;

// --- FAT_EP_SUBSECTION_ID ---
#define FAT_EP_PROC_ID                  (1)       
#define FAT_EP_FIXED_ID                 (2)       
#define FAT_EP_BANKED_ID                (4)       
#define FAT_EP_SHARED_FIXED_ID          (8)       
#define FAT_EP_IRAM_ID                  (16)      
#define FAT_EP_MMR_ID                   (32)      
#define FAT_EP_STATISTICS_ID            (64)      

typedef enum {
   ENUM_FAT_EP_PROC_ID = 0x1UL,
   ENUM_FAT_EP_FIXED_ID = 0x2UL,
   ENUM_FAT_EP_BANKED_ID = 0x4UL,
   ENUM_FAT_EP_SHARED_FIXED_ID = 0x8UL,
   ENUM_FAT_EP_IRAM_ID = 0x10UL,
   ENUM_FAT_EP_MMR_ID = 0x20UL,
   ENUM_FAT_EP_STATISTICS_ID = 0x40UL
} FAT_EP_SUBSECTION_ID;

// --- FAT_EP_SUBSECTION_VERSION ---
#define FAT_EP_SUBSECTION_VERSION1      (1)       
#define FAT_EP_SUBSECTION_VERSION_CURRENT (1)     

typedef enum {
   ENUM_FAT_EP_SUBSECTION_VERSION1 = 0x1UL,
   ENUM_FAT_EP_SUBSECTION_VERSION_CURRENT = 0x1UL
} FAT_EP_SUBSECTION_VERSION;

// --- FAT_SEEPROM_VERSION ---
#define FAT_SEEPROM_ALLDATA             (1)       
#define FAT_SEEPROM_VERSION1            (2)       
#define FAT_SEEPROM_VERSION2            (3)       
#define FAT_SEEPROM_VERSION_CURRENT     (3)       

typedef enum {
   ENUM_FAT_SEEPROM_ALLDATA = 0x1UL,
   ENUM_FAT_SEEPROM_VERSION1 = 0x2UL,
   ENUM_FAT_SEEPROM_VERSION2 = 0x3UL,
   ENUM_FAT_SEEPROM_VERSION_CURRENT = 0x3UL
} FAT_SEEPROM_VERSION;

// --- FAT_EP_DUMP_VERSION ---
#define FAT_EP_DUMP_VERSION1            (1)       
#define FAT_EP_DUMP_VERSION2            (2)       
#define FAT_EP_DUMP_VERSION3            (3)       
#define FAT_EP_DUMP_VERSION_CURRENT     (3)       

typedef enum {
   ENUM_FAT_EP_DUMP_VERSION1 = 0x1UL,
   ENUM_FAT_EP_DUMP_VERSION2 = 0x2UL,
   ENUM_FAT_EP_DUMP_VERSION3 = 0x3UL,
   ENUM_FAT_EP_DUMP_VERSION_CURRENT = 0x3UL
} FAT_EP_DUMP_VERSION;

// --- FAT_EP_PROCESSOR_COLLECTION_VERSION ---
#define FAT_EP_PROCESSOR_COLLECTION_VERSION1 (1)  
#define FAT_EP_PROCESSOR_COLLECTION_VERSION2 (2)  
#define FAT_EP_PROCESSOR_COLLECTION_VERSION_CURRENT (2) 

typedef enum {
   ENUM_FAT_EP_PROCESSOR_COLLECTION_VERSION1 = 0x1UL,
   ENUM_FAT_EP_PROCESSOR_COLLECTION_VERSION2 = 0x2UL,
   ENUM_FAT_EP_PROCESSOR_COLLECTION_VERSION_CURRENT = 0x2UL
} FAT_EP_PROCESSOR_COLLECTION_VERSION;

// --- FAT_EP_OP_CODES ---
#define FAT_EP_RSR                      (48)      
#define FAT_EP_WSR                      (49)      
#define FAT_EP_RUR                      (62)      

typedef enum {
   ENUM_FAT_EP_RSR = 0x30UL,
   ENUM_FAT_EP_WSR = 0x31UL,
   ENUM_FAT_EP_RUR = 0x3eUL
} FAT_EP_OP_CODES;

// --- FAT_EP_REG_VALUES ---
#define FAT_EP_A0                       (0)       
#define FAT_EP_LBEG                     (0)       
#define FAT_EP_LEND                     (1)       
#define FAT_EP_LCOUNT                   (2)       
#define FAT_EP_A3                       (3)       
#define FAT_EP_SAR                      (3)       
#define FAT_EP_A4                       (4)       
#define FAT_EP_A5                       (5)       
#define FAT_EP_WINDOWBASE               (72)      
#define FAT_EP_WINDOWSTART              (73)      
#define FAT_EP_DDR                      (104)     
#define FAT_EP_IBREAKA0                 (128)     
#define FAT_EP_IBREAKA1                 (129)     
#define FAT_EP_DBREAKA0                 (144)     
#define FAT_EP_DBREAKA1                 (145)     
#define FAT_EP_EPC1                     (177)     
#define FAT_EP_EPC2                     (178)     
#define FAT_EP_EPC3                     (179)     
#define FAT_EP_EPC4                     (180)     
#define FAT_EP_DEPC                     (192)     
#define FAT_EP_EPS2                     (194)     
#define FAT_EP_EPS3                     (195)     
#define FAT_EP_EPS4                     (196)     
#define FAT_EP_EXCSAVE1                 (209)     
#define FAT_EP_EXCSAVE2                 (210)     
#define FAT_EP_EXCSAVE3                 (211)     
#define FAT_EP_EXCSAVE4                 (212)     
#define FAT_EP_INTENABLE                (228)     
#define FAT_EP_PS                       (230)     
#define FAT_EP_EXCCAUSE                 (232)     
#define FAT_EP_DEBUGCAUSE               (233)     
#define FAT_EP_CCOUNT                   (234)     
#define FAT_EP_PRID                     (235)     
#define FAT_EP_ICOUNT                   (236)     
#define FAT_EP_ICOUNTLEVEL              (237)     
#define FAT_EP_CCOMPARE0                (240)     

typedef enum {
   ENUM_FAT_EP_A0 = 0x0UL,
   ENUM_FAT_EP_LBEG = 0x0UL,
   ENUM_FAT_EP_LEND = 0x1UL,
   ENUM_FAT_EP_LCOUNT = 0x2UL,
   ENUM_FAT_EP_A3 = 0x3UL,
   ENUM_FAT_EP_SAR = 0x3UL,
   ENUM_FAT_EP_A4 = 0x4UL,
   ENUM_FAT_EP_A5 = 0x5UL,
   ENUM_FAT_EP_WINDOWBASE = 0x48UL,
   ENUM_FAT_EP_WINDOWSTART = 0x49UL,
   ENUM_FAT_EP_DDR = 0x68UL,
   ENUM_FAT_EP_IBREAKA0 = 0x80UL,
   ENUM_FAT_EP_IBREAKA1 = 0x81UL,
   ENUM_FAT_EP_DBREAKA0 = 0x90UL,
   ENUM_FAT_EP_DBREAKA1 = 0x91UL,
   ENUM_FAT_EP_EPC1 = 0xb1UL,
   ENUM_FAT_EP_EPC2 = 0xb2UL,
   ENUM_FAT_EP_EPC3 = 0xb3UL,
   ENUM_FAT_EP_EPC4 = 0xb4UL,
   ENUM_FAT_EP_DEPC = 0xc0UL,
   ENUM_FAT_EP_EPS2 = 0xc2UL,
   ENUM_FAT_EP_EPS3 = 0xc3UL,
   ENUM_FAT_EP_EPS4 = 0xc4UL,
   ENUM_FAT_EP_EXCSAVE1 = 0xd1UL,
   ENUM_FAT_EP_EXCSAVE2 = 0xd2UL,
   ENUM_FAT_EP_EXCSAVE3 = 0xd3UL,
   ENUM_FAT_EP_EXCSAVE4 = 0xd4UL,
   ENUM_FAT_EP_INTENABLE = 0xe4UL,
   ENUM_FAT_EP_PS = 0xe6UL,
   ENUM_FAT_EP_EXCCAUSE = 0xe8UL,
   ENUM_FAT_EP_DEBUGCAUSE = 0xe9UL,
   ENUM_FAT_EP_CCOUNT = 0xeaUL,
   ENUM_FAT_EP_PRID = 0xebUL,
   ENUM_FAT_EP_ICOUNT = 0xecUL,
   ENUM_FAT_EP_ICOUNTLEVEL = 0xedUL,
   ENUM_FAT_EP_CCOMPARE0 = 0xf0UL
} FAT_EP_REG_VALUES;

// --- FAT_TXD_DATA_VERSION ---
#define FAT_TXD_DATA_VERSION0           (0)       
#define FAT_TXD_DATA_VERSION1           (1)       
#define FAT_TXD_DATA_VERSION2           (2)       
#define FAT_TXD_DATA_VERSION_CURRENT    (2)       

typedef enum {
   ENUM_FAT_TXD_DATA_VERSION0 = 0x0UL,
   ENUM_FAT_TXD_DATA_VERSION1 = 0x1UL,
   ENUM_FAT_TXD_DATA_VERSION2 = 0x2UL,
   ENUM_FAT_TXD_DATA_VERSION_CURRENT = 0x2UL
} FAT_TXD_DATA_VERSION;

// --- FAT_DMA_SECTION_VERSION ---
#define FAT_DMA_SECTION_VERSION1        (1)       
#define FAT_DMA_SECTION_VERSION_CURRENT (1)       

typedef enum {
   ENUM_FAT_DMA_SECTION_VERSION1 = 0x1UL,
   ENUM_FAT_DMA_SECTION_VERSION_CURRENT = 0x1UL
} FAT_DMA_SECTION_VERSION;

// --- FAT_DMA_ID ---
#define FAT_DMA_ID_NDMA                 (1)       
#define FAT_DMA_ID_RDMA                 (2)       
#define FAT_DMA_ID_WDMA                 (4)       

typedef enum {
   ENUM_FAT_DMA_ID_NDMA = 0x1UL,
   ENUM_FAT_DMA_ID_RDMA = 0x2UL,
   ENUM_FAT_DMA_ID_WDMA = 0x4UL
} FAT_DMA_ID;

// --- FAT_RXF_DATA_VERSION ---
#define FAT_RXF_DATA_VERSION1           (1)       
#define FAT_RXF_DATA_VERSION_CURRENT    (1)       

typedef enum {
   ENUM_FAT_RXF_DATA_VERSION1 = 0x1UL,
   ENUM_FAT_RXF_DATA_VERSION_CURRENT = 0x1UL
} FAT_RXF_DATA_VERSION;

// --- FAT_RXF_SUBSECTION_ID ---
#define FAT_RXF_SUBSECTION_MAC_PORT0    (0)       
#define FAT_RXF_SUBSECTION_MULTICAST_PORT0 (1)    
#define FAT_RXF_SUBSECTION_VLAN         (2)       
#define FAT_RXF_SUBSECTION_DA           (3)       
#define FAT_RXF_SUBSECTION_ACPI         (4)       
#define FAT_RXF_SUBSECTION_OFFLOADED    (5)       
#define FAT_RXF_SUBSECTION_RSS_KEY      (9)       
#define FAT_RXF_SUBSECTION_RSS_TABLE    (10)      
#define FAT_RXF_SUBSECTION_FCOE         (11)      
#define FAT_RXF_SUBSECTION_MAC_PORT1    (12)      
#define FAT_RXF_SUBSECTION_MULTICAST_PORT1 (13)   

typedef enum {
   ENUM_FAT_RXF_SUBSECTION_MAC_PORT0 = 0x0UL,
   ENUM_FAT_RXF_SUBSECTION_MULTICAST_PORT0 = 0x1UL,
   ENUM_FAT_RXF_SUBSECTION_VLAN = 0x2UL,
   ENUM_FAT_RXF_SUBSECTION_DA = 0x3UL,
   ENUM_FAT_RXF_SUBSECTION_ACPI = 0x4UL,
   ENUM_FAT_RXF_SUBSECTION_OFFLOADED = 0x5UL,
   ENUM_FAT_RXF_SUBSECTION_RSS_KEY = 0x9UL,
   ENUM_FAT_RXF_SUBSECTION_RSS_TABLE = 0xaUL,
   ENUM_FAT_RXF_SUBSECTION_FCOE = 0xbUL,
   ENUM_FAT_RXF_SUBSECTION_MAC_PORT1 = 0xcUL,
   ENUM_FAT_RXF_SUBSECTION_MULTICAST_PORT1 = 0xdUL
} FAT_RXF_SUBSECTION_ID;

// --- FAT_GEN_SUBSECTION_ID ---
#define FAT_GEN_SUBSECTION_TXPB_LINK    (1)       
#define FAT_GEN_SUBSECTION_TXPB_BUFFER  (2)       
#define FAT_GEN_SUBSECTION_VQ_LL        (3)       
#define FAT_GEN_SUBSECTION_VQ_DATA      (4)       
#define FAT_GEN_SUBSECTION_VQ_REGS      (5)       
#define FAT_GEN_SUBSECTION_VQ_PTRS      (6)       

typedef enum {
   ENUM_FAT_GEN_SUBSECTION_TXPB_LINK = 0x1UL,
   ENUM_FAT_GEN_SUBSECTION_TXPB_BUFFER = 0x2UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_LL = 0x3UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_DATA = 0x4UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_REGS = 0x5UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_PTRS = 0x6UL
} FAT_GEN_SUBSECTION_ID;

// --- FAT_DATA_FOOTER_VERSION ---
#define FAT_DATA_FOOTER_VERSION1        (1)       
#define FAT_DATA_FOOTER_VERSION_CURRENT (1)       

typedef enum {
   ENUM_FAT_DATA_FOOTER_VERSION1 = 0x1UL,
   ENUM_FAT_DATA_FOOTER_VERSION_CURRENT = 0x1UL
} FAT_DATA_FOOTER_VERSION;

// --- FAT_DATA_SECTION_VERSION ---
#define FAT_DATA_SECTION_VERSION0       (0)       
#define FAT_DATA_SECTION_VERSION1       (1)       
#define FAT_DATA_SECTION_VERSION_CURRENT (1)      

typedef enum {
   ENUM_FAT_DATA_SECTION_VERSION0 = 0x0UL,
   ENUM_FAT_DATA_SECTION_VERSION1 = 0x1UL,
   ENUM_FAT_DATA_SECTION_VERSION_CURRENT = 0x1UL
} FAT_DATA_SECTION_VERSION;

// --- FAT_CSR_DATA_VERSION ---
#define FAT_CSR_DATA_VERSION_INITIAL    (0)       
#define FAT_CSR_DATA_VERSION_ENHANCED   (1)       
#define FAT_CSR_DATA_VERSION_ENHANCED_PLUS_WCON (2) 
#define FAT_CSR_DATA_VERSION_CURRENT    (2)       

typedef enum {
   ENUM_FAT_CSR_DATA_VERSION_INITIAL = 0x0UL,
   ENUM_FAT_CSR_DATA_VERSION_ENHANCED = 0x1UL,
   ENUM_FAT_CSR_DATA_VERSION_ENHANCED_PLUS_WCON = 0x2UL,
   ENUM_FAT_CSR_DATA_VERSION_CURRENT = 0x2UL
} FAT_CSR_DATA_VERSION;

#endif // __fat_header_enum_h__

