/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fc_common_host_struct_enum_h__
#define __fc_common_host_struct_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "fc_enums_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- FC_CMD_FLAG ---
// Read/Write command flag.
#define FC_READ_FLAG                    (0)       // FC Read command Frame
#define FC_WRITE_FLAG                   (1)       // FC Write command Frame

typedef enum {
   ENUM_FC_READ_FLAG = 0x0UL,
   ENUM_FC_WRITE_FLAG = 0x1UL
} FC_CMD_FLAG;

// --- FC_MAX_BUF_SIZE_ENUM ---
// Encoding of maximum buffer size for transmitted FCoE frames
#define FC_MAX_BUF_SIZE_1024            (0)       // 1024 bytes FC Payload, 1088 bytes
                                                  // Ethernet Frames (+4 if VLAN and +8 if
                                                  // VFT)
#define FC_MAX_BUF_SIZE_1452_1444       (1)       // 1452(no VSAN) or 1444(with VSAN)
                                                  // bytes FC Payload, 1516 bytes Ethernet
                                                  // Frames (+4 if VLAN, no change for
                                                  // VFT)
#define FC_MAX_BUF_SIZE_2048            (2)       // 2048 bytes FC Payload, 2112 bytes
                                                  // Ethernet Frames (+4 if VLAN and +8 if
                                                  // VFT)
#define FC_MAX_BUF_SIZE_2112            (3)       // 2112 bytes FC Payload, 2176 bytes
                                                  // Ethernet Frames (+4 if VLAN and +8 if
                                                  // VFT)

typedef enum {
   ENUM_FC_MAX_BUF_SIZE_1024 = 0x0UL,
   ENUM_FC_MAX_BUF_SIZE_1452_1444 = 0x1UL,
   ENUM_FC_MAX_BUF_SIZE_2048 = 0x2UL,
   ENUM_FC_MAX_BUF_SIZE_2112 = 0x3UL
} FC_MAX_BUF_SIZE_ENUM;

// --- FC_R2T_ARRAY_PARAMS ---
// Describe global R2T array parameters
#define FC_R2T_PER_FCF                  (1024)    // Number of R2T array entries per FCF

typedef enum {
   ENUM_FC_R2T_PER_FCF = 0x400UL
} FC_R2T_ARRAY_PARAMS;

// --- FC_CQE_STATUS_ENUM ---
// Completion status for solicited I/Os.
#define FC_STATUS_SUCCESS               (0)       // Success
#define FC_STATUS_FCP_RSP_FAILURE       (1)       // Link layer success, but FCP_RSP
                                                  // payload has one or more error
                                                  // indications, or residual transfer
                                                  // length is not 0
#define FC_STATUS_REMOTE_STOP           (2)       // Stopped by remote N_Port (ABTS)
#define FC_STATUS_LOCAL_REJECT          (3)       // Local reject (error detected by SLI
                                                  // Port)
#define FC_STATUS_NPORT_RJT             (4)       // Remote N_Port sent a reject (P_RJT)
#define FC_STATUS_FABRIC_RJT            (5)       // Fabric sent a reject (F_RJT)
#define FC_STATUS_NPORT_BSY             (6)       // Remote N_Port sent a P_BSY
#define FC_STATUS_FABRIC_BSY            (7)       // Fabric sent an F_BSY
#define FC_STATUS_INTERMED_RSP          (8)       // Intermediate response IOCB entry
#define FC_STATUS_LS_RJT                (9)       // Received an LS_RJT response entry
#define FC_STATUS_CMD_REJECT            (11)      // Local reject; exchange still open
#define FC_STATUS_FCP_TGT_LENCHECK      (12)      // Length overrun or underrun for an
                                                  // FCP_TRECEIVE64_CX
#define FC_STATUS_NEED_BUFF_ENTRY       (15)      // Need buffer entry for host buffer
                                                  // queue or exchange

typedef enum {
   ENUM_FC_STATUS_SUCCESS = 0x0UL,
   ENUM_FC_STATUS_FCP_RSP_FAILURE = 0x1UL,
   ENUM_FC_STATUS_REMOTE_STOP = 0x2UL,
   ENUM_FC_STATUS_LOCAL_REJECT = 0x3UL,
   ENUM_FC_STATUS_NPORT_RJT = 0x4UL,
   ENUM_FC_STATUS_FABRIC_RJT = 0x5UL,
   ENUM_FC_STATUS_NPORT_BSY = 0x6UL,
   ENUM_FC_STATUS_FABRIC_BSY = 0x7UL,
   ENUM_FC_STATUS_INTERMED_RSP = 0x8UL,
   ENUM_FC_STATUS_LS_RJT = 0x9UL,
   ENUM_FC_STATUS_CMD_REJECT = 0xbUL,
   ENUM_FC_STATUS_FCP_TGT_LENCHECK = 0xcUL,
   ENUM_FC_STATUS_NEED_BUFF_ENTRY = 0xfUL
} FC_CQE_STATUS_ENUM;

// --- FC_WQ_COMPL_CQE_CODE_ENUM ---
// Designates the type of CQE.
#define FC_STATUS_COMPL_WQ              (1)       // WQ Completion

typedef enum {
   ENUM_FC_STATUS_COMPL_WQ = 0x1UL
} FC_WQ_COMPL_CQE_CODE_ENUM;

// --- FC_RELEASE_WQES_CQE_CODE_ENUM ---
// Designates the type of CQE.
#define FC_STATUS_RELEASE_WQECS         (2)       // Release WQEs

typedef enum {
   ENUM_FC_STATUS_RELEASE_WQECS = 0x2UL
} FC_RELEASE_WQES_CQE_CODE_ENUM;

// --- FC_RQ_CQE_STATUS_ENUM ---
// Completion status for Async_Receive_CQE.
#define FC_STATUS_RQ_SUCCESS            (16)      // Asynchronous receive successful.
#define FC_STATUS_RQ_BUF_LEN_EXCEEDED   (17)      // Asynchronous receive, buffer length
                                                  // exceeded, payload truncated.
#define FC_STATUS_INSUFF_BUF_NEED_BUF   (18)      // Insufficient buffers for async
                                                  // receive - indication.
#define FC_STATUS_INSUFF_BUF_FRM_DISC   (19)      // Insufficient buffers for async
                                                  // receive - frame discarded.

typedef enum {
   ENUM_FC_STATUS_RQ_SUCCESS = 0x10UL,
   ENUM_FC_STATUS_RQ_BUF_LEN_EXCEEDED = 0x11UL,
   ENUM_FC_STATUS_INSUFF_BUF_NEED_BUF = 0x12UL,
   ENUM_FC_STATUS_INSUFF_BUF_FRM_DISC = 0x13UL
} FC_RQ_CQE_STATUS_ENUM;

// --- FC_RQ_CQE_CODE_ENUM ---
// Designates the type of CQE.
#define FC_STATUS_ASYNC_RECEIVE_CQE     (4)       // Asynchronous receive.

typedef enum {
   ENUM_FC_STATUS_ASYNC_RECEIVE_CQE = 0x4UL
} FC_RQ_CQE_CODE_ENUM;

// --- FC_XRI_ABORTED_CQE_CODE_ENUM ---
// Designates the type of CQE.
#define FC_STATUS_XRI_ABORTED           (5)       // XRI aborted.

typedef enum {
   ENUM_FC_STATUS_XRI_ABORTED = 0x5UL
} FC_XRI_ABORTED_CQE_CODE_ENUM;

// --- FC_ARM_IPC_REPLY_CQE_CODE_ENUM ---
// Designates the type of CQE.
#define FC_STATUS_DEFQ_CREATE_REPLY     (240)     // Reply to IPC_DEFQ_CREATE
#define FC_STATUS_DEFQ_FLUSH_REPLY      (241)     // Reply to IPC_DEFQ_FLUSH

typedef enum {
   ENUM_FC_STATUS_DEFQ_CREATE_REPLY = 0xf0UL,
   ENUM_FC_STATUS_DEFQ_FLUSH_REPLY = 0xf1UL
} FC_ARM_IPC_REPLY_CQE_CODE_ENUM;

// --- FC_ARM_IPC_REPLY_CQE_STATUS_ENUM ---
// Completion status for DEFQ IPCs
#define FC_STATUS_DEFQ_CREATE_ACCEPT    (2)       // IPC_SUB_DEFQ_CREATE_ACCEPT
#define FC_STATUS_DEFQ_FLUSH_ACCEPT     (2)       // IPC_SUB_DEFQ_FLUSH_ACCEPT
#define FC_STATUS_DEFQ_CREATE_REJECT    (3)       // IPC_SUB_DEFQ_CREATE_REJECT
#define FC_STATUS_DEFQ_FLUSH_REJECT     (3)       // IPC_SUB_DEFQ_FLUSH_REJECT

typedef enum {
   ENUM_FC_STATUS_DEFQ_CREATE_ACCEPT = 0x2UL,
   ENUM_FC_STATUS_DEFQ_FLUSH_ACCEPT = 0x2UL,
   ENUM_FC_STATUS_DEFQ_CREATE_REJECT = 0x3UL,
   ENUM_FC_STATUS_DEFQ_FLUSH_REJECT = 0x3UL
} FC_ARM_IPC_REPLY_CQE_STATUS_ENUM;

// --- FC_LOCAL_REJECT_STATUS_CODE ---
// Local Reject Status Code.
#define IOERR_MISSING_CONTINUE          (1)       // Defined aggregate buffer length too
                                                  // small for requested data transfer
                                                  // operation
#define IOERR_SEQUENCE_TIMEOUT          (2)       // E_D_TOV time-out occurred
#define IOERR_INTERNAL_ERROR            (3)       // Internal inconsistency discovered
                                                  // (check Status register for hard
                                                  // errors)
#define IOERR_INVALID_RPI               (4)       // Invalid RPI
#define IOERR_NO_XRI                    (5)       // Specified XRI is not used
#define IOERR_ILLEGAL_COMMAND           (6)       // Illegal command code in IOCB
#define IOERR_XCHG_DROPPED              (7)       // Data frame not completed when
                                                  // exchange goes away
#define IOERR_ILLEGAL_FIELD             (8)       // Bad descriptor entry count or LE
                                                  // field
#define IOERR_RCV_BUFFER_WAITING        (11)      // Incoming sequence or partial sequence
                                                  // received without enough host receive
                                                  // buffers queued to ring
#define IOERR_NO_ABORT_MATCH            (12)      // Abort multiple issued but no matches
                                                  // to abort criteria were found
#define IOERR_TX_DMA_FAILED             (13)      // Error in transmit DMA path
#define IOERR_RX_DMA_FAILED             (14)      // Error in receive DMA path
#define IOERR_ILLEGAL_FRAME             (15)      // Many meanings: for example, bad ACK_0
                                                  // (not at end of sequence), data or ACK
                                                  // too far out of order, duplicate
                                                  // frames, ACK when not expecting one,
                                                  // BA_ACC or BA_RJT received when not
                                                  // expecting it, non-XFR_RDY when
                                                  // expecting one
#define IOERR_NO_RESOURCES              (17)      // Required internal context (RPI, XRI,
                                                  // IOCB) is already in use
#define IOERR_ILLEGAL_LENGTH            (19)      // SCSI_CMND payload does not fit in a
                                                  // single frame
#define IOERR_UNSUPPORTED_FEATURE       (20)      // SLI feature is not yet implemented
#define IOERR_ABORT_IN_PROGRESS         (21)      // Exchange referenced is in the process
                                                  // of aborting
#define IOERR_ABORT_REQUESTED           (22)      // Exchange referenced is being aborted
                                                  // due to local request
#define IOERR_RCV_BUFFER_TIMEOUT        (23)      // Frames of a sequence received into
                                                  // buffer SRAM have been discarded
                                                  // because enough host buffers or buffer
                                                  // lists were not available within the
                                                  // E_D_TOV time-out
#define IOERR_LOOP_OPEN_FAILURE         (24)      // The port sent an FC-AL OPN that was
                                                  // not responded to because the device
                                                  // addressed is no longer on the loop;
                                                  // for example, it was removed or
                                                  // powered down
#define IOERR_RING_RESET                (25)      // Command was aborted because of
                                                  // RESET_RING mailbox command
#define IOERR_LINK_DOWN                 (26)      // Command queued when LINK_DOWN
                                                  // occurred and before CLEAR_LA mailbox
                                                  // command executed
#define IOERR_CORRUPTED_DATA            (27)      // Internal FIFO overrun during frame
                                                  // reception
#define IOERR_CORRUPTED_RPI             (28)      // Internal RPI cache error
#define IOERR_OUT_OF_ORDER_DATA         (29)      // Frames in sequence received out of
                                                  // order outside reordering window
#define IOERR_OUT_OF_ORDER_ACK          (30)      // ACK frames for sequence received out
                                                  // of order outside reordering window
#define IOERR_DUP_FRAME                 (31)      // Duplicate frame detected
#define IOERR_LINK_CONTROL_FRAME        (32)      // ACK_N or invalid ACK_0 received
#define IOERR_MSEQ_CHAIN_CORRUPTED      (36)      // Corrupted chain of related operations
#define IOERR_ABORTMULT_REQUESTED       (37)      // Command aborted by IO_TAG match
#define IOERR_BUFFER_SHORTAGE           (40)      // Freed buffers for point-to-point link
                                                  // reset
#define IOERR_RCV_XRIBUF_WAITING        (41)      // Incoming sequence, or partial
                                                  // sequence, received without enough
                                                  // host receive buffers queued to XRI
#define IOERR_MISSING_HBQ_ENTRY         (43)      // Frames of a sequence received into
                                                  // buffer SRAM have been discarded
                                                  // because enough host buffers or buffer
                                                  // lists queued to HBQ were not
                                                  // available within the E_D_TOV time-out
#define IOERR_ABORT_EXTENDED_REQUESTED  (44)      // IOCB command aborted by Abort
                                                  // Extended request
#define IOERR_CLOSE_EXTENDED_REQUESTED  (45)      // IOCB command closed by Close Extended
                                                  // request
#define IOERR_MISSING_XRIBUF            (48)      // Frames of a sequence received into
                                                  // buffer SRAM have been discarded
                                                  // because enough host buffers or buffer
                                                  // lists queued to an XRI were not
                                                  // available within the E_D_TOV time-out
#define IOERR_INVALID_RELOFFSET         (64)      // Received frame with bad relative
                                                  // offset from initiator
#define IOERR_MISSING_RELOFFSET         (65)      // Received frame without relative
                                                  // offset in frame header
#define IOERR_INSUFF_BUFFERSPACE        (66)      // Insufficient buffer space to transfer
                                                  // all data
#define IOERR_MISSING_SI                (67)      // Received ES frame without SI in frame
                                                  // header
#define IOERR_MISSING_ES                (68)      // Exhausted burst length without
                                                  // receiving ES
#define IOERR_INCOMPLETE_XFER           (69)      // Exhausted burst length with data
                                                  // still pending in frame
#define IOERR_SLER_FAILURE              (70)      // Error detected during Sequence Level
                                                  // Error Recovery. This is a generic
                                                  // catchall for any error during SLER
                                                  // that was not classified further.
#define IOERR_SLER_CMD_RCV_FAILURE      (71)      // Sequence Level Error Recovery Error:
                                                  // Tgt did not receive CMD. Recommended
                                                  // that the SLI-Host resend the command
#define IOERR_SLER_REC_RJT_ERR          (72)      // Sequence Level Error Recovery Error:
                                                  // Target rejected REC. Command context
                                                  // could not be established.
#define IOERR_SLER_REC_SRR_RETRY_ERR    (73)      // Sequence Level Error Recovery Error:
                                                  // REC or SRR retries failed.
#define IOERR_SLER_SRR_RJT_ERR          (74)      // Sequence Level Error Recovery Error:
                                                  // Target rejected SRR. Unable to resume
                                                  // command transmission.
#define IOERR_SLER_RRQ_RJT_ERR          (76)      // Sequence Level Error Recovery Error:
                                                  // Target rejected RRQ. Unable to
                                                  // recover SLER resources.
#define IOERR_SLER_RRQ_RETRY_ERR        (77)      // Sequence Level Error Recovery Error:
                                                  // RRQ retries failed. Unable to recover
                                                  // SLER resources.
#define IOERR_SLER_ABTS_ERR             (78)      // Sequence Level Error Recovery Error:
                                                  // ABTS of SLER REC/SRR/RRQ failed.
#define IOERR_SAS_IOCB_TIMEOUT          (112)     // SAS IOCB command timed out
#define IOERR_SAS_DEV_STARTED           (113)     // SAS device already started
#define IOERR_SAS_DEV_STOPPED           (114)     // SAS device already stopped
#define IOERR_SAS_PORT_STARTED          (115)     // SAS port already started
#define IOERR_SAS_PORT_STOPPED          (116)     // SAS port already stopped
#define IOERR_SAS_PHY_STOPPED           (117)     // SAS phy already stopped
#define IOERR_PHY_NOT_IN_SAS_PORT       (118)     // Phy not assigned to the SAS port
#define IOERR_NO_ACTV_SAS_PORT          (119)     // No active/connected SAS ports
#define IOERR_INV_SAS_CONFIG            (120)     // Invalid configuration - different
                                                  // remote SAS addresses on wide SAS port
#define IOERR_INV_SAS_PORT_INDEX        (121)     // Invalid SAS port index
#define IOERR_INV_SAS_PHY_INDEX         (122)     // Invalid SAS phy index
#define IOERR_SAS_PAIR_REGISTERED       (123)     // SAS port pair already registered
#define IOERR_INV_STAT_TYPE             (124)     // Invalid status type specified
#define IOERR_STAT_BUFF_TOO_SMALL       (125)     // More statistics available than can be
                                                  // returned in the supplied buffer
#define IOERR_INV_STAT_BDE              (126)     // Statistics descriptor entry invalid
#define IOERR_SAS_CMD_REJECT            (127)     // SAS command rejected
#define IOERR_DISCOVERY_ABORTED         (128)     // SAS discovery aborted - a Broadcast
                                                  // Change was received while the SLI
                                                  // Port was trying to get an updated
                                                  // discovery map
#define IOERR_INV_NTWK_TOPOLOGY         (129)     // Discovered invalid network topology -
                                                  // such as loop detected
#define IOERR_TOO_MANY_ENTRIES          (130)     // Actual number of entries discovered
                                                  // greater than the allocated number of
                                                  // entries
#define IOERR_INV_SAS_ADDRESS           (131)     // Invalid SAS address
#define IOERR_SAS_CMD_ALREADY_INPROG    (132)     // SAS command already in progress
                                                  // (typically START/STOP SAS commands)
#define IOERR_UNREG_REQUESTED           (139)     // Abort for UNREG_SAS_PORT_PAIR
#define IOERR_LOG_ACCESS_DENIED         (144)     // Invalid logging parameter type - read
                                                  // only
#define IOERR_LOG_NO_RESOURCES          (145)     // Insufficient resources to create
                                                  // logging channel
#define IOERR_LOG_INV_PARM_TYPE         (146)     // Supplied logging parameter type is
                                                  // not supported
#define IOERR_LOG_INV_PARM_VALUE        (147)     // Supplied logging parameter value is
                                                  // invalid
#define IOERR_LOG_INV_CONTROL           (148)     // Supplied logging control is not
                                                  // supported
#define IOERR_LOG_INV_CHANNEL           (149)     // Supplied logging channel identifier
                                                  // is already in use, is reserved, or
                                                  // does not exist

typedef enum {
   ENUM_IOERR_MISSING_CONTINUE = 0x1UL,
   ENUM_IOERR_SEQUENCE_TIMEOUT = 0x2UL,
   ENUM_IOERR_INTERNAL_ERROR = 0x3UL,
   ENUM_IOERR_INVALID_RPI = 0x4UL,
   ENUM_IOERR_NO_XRI = 0x5UL,
   ENUM_IOERR_ILLEGAL_COMMAND = 0x6UL,
   ENUM_IOERR_XCHG_DROPPED = 0x7UL,
   ENUM_IOERR_ILLEGAL_FIELD = 0x8UL,
   ENUM_IOERR_RCV_BUFFER_WAITING = 0xbUL,
   ENUM_IOERR_NO_ABORT_MATCH = 0xcUL,
   ENUM_IOERR_TX_DMA_FAILED = 0xdUL,
   ENUM_IOERR_RX_DMA_FAILED = 0xeUL,
   ENUM_IOERR_ILLEGAL_FRAME = 0xfUL,
   ENUM_IOERR_NO_RESOURCES = 0x11UL,
   ENUM_IOERR_ILLEGAL_LENGTH = 0x13UL,
   ENUM_IOERR_UNSUPPORTED_FEATURE = 0x14UL,
   ENUM_IOERR_ABORT_IN_PROGRESS = 0x15UL,
   ENUM_IOERR_ABORT_REQUESTED = 0x16UL,
   ENUM_IOERR_RCV_BUFFER_TIMEOUT = 0x17UL,
   ENUM_IOERR_LOOP_OPEN_FAILURE = 0x18UL,
   ENUM_IOERR_RING_RESET = 0x19UL,
   ENUM_IOERR_LINK_DOWN = 0x1aUL,
   ENUM_IOERR_CORRUPTED_DATA = 0x1bUL,
   ENUM_IOERR_CORRUPTED_RPI = 0x1cUL,
   ENUM_IOERR_OUT_OF_ORDER_DATA = 0x1dUL,
   ENUM_IOERR_OUT_OF_ORDER_ACK = 0x1eUL,
   ENUM_IOERR_DUP_FRAME = 0x1fUL,
   ENUM_IOERR_LINK_CONTROL_FRAME = 0x20UL,
   ENUM_IOERR_MSEQ_CHAIN_CORRUPTED = 0x24UL,
   ENUM_IOERR_ABORTMULT_REQUESTED = 0x25UL,
   ENUM_IOERR_BUFFER_SHORTAGE = 0x28UL,
   ENUM_IOERR_RCV_XRIBUF_WAITING = 0x29UL,
   ENUM_IOERR_MISSING_HBQ_ENTRY = 0x2bUL,
   ENUM_IOERR_ABORT_EXTENDED_REQUESTED = 0x2cUL,
   ENUM_IOERR_CLOSE_EXTENDED_REQUESTED = 0x2dUL,
   ENUM_IOERR_MISSING_XRIBUF = 0x30UL,
   ENUM_IOERR_INVALID_RELOFFSET = 0x40UL,
   ENUM_IOERR_MISSING_RELOFFSET = 0x41UL,
   ENUM_IOERR_INSUFF_BUFFERSPACE = 0x42UL,
   ENUM_IOERR_MISSING_SI = 0x43UL,
   ENUM_IOERR_MISSING_ES = 0x44UL,
   ENUM_IOERR_INCOMPLETE_XFER = 0x45UL,
   ENUM_IOERR_SLER_FAILURE = 0x46UL,
   ENUM_IOERR_SLER_CMD_RCV_FAILURE = 0x47UL,
   ENUM_IOERR_SLER_REC_RJT_ERR = 0x48UL,
   ENUM_IOERR_SLER_REC_SRR_RETRY_ERR = 0x49UL,
   ENUM_IOERR_SLER_SRR_RJT_ERR = 0x4aUL,
   ENUM_IOERR_SLER_RRQ_RJT_ERR = 0x4cUL,
   ENUM_IOERR_SLER_RRQ_RETRY_ERR = 0x4dUL,
   ENUM_IOERR_SLER_ABTS_ERR = 0x4eUL,
   ENUM_IOERR_SAS_IOCB_TIMEOUT = 0x70UL,
   ENUM_IOERR_SAS_DEV_STARTED = 0x71UL,
   ENUM_IOERR_SAS_DEV_STOPPED = 0x72UL,
   ENUM_IOERR_SAS_PORT_STARTED = 0x73UL,
   ENUM_IOERR_SAS_PORT_STOPPED = 0x74UL,
   ENUM_IOERR_SAS_PHY_STOPPED = 0x75UL,
   ENUM_IOERR_PHY_NOT_IN_SAS_PORT = 0x76UL,
   ENUM_IOERR_NO_ACTV_SAS_PORT = 0x77UL,
   ENUM_IOERR_INV_SAS_CONFIG = 0x78UL,
   ENUM_IOERR_INV_SAS_PORT_INDEX = 0x79UL,
   ENUM_IOERR_INV_SAS_PHY_INDEX = 0x7aUL,
   ENUM_IOERR_SAS_PAIR_REGISTERED = 0x7bUL,
   ENUM_IOERR_INV_STAT_TYPE = 0x7cUL,
   ENUM_IOERR_STAT_BUFF_TOO_SMALL = 0x7dUL,
   ENUM_IOERR_INV_STAT_BDE = 0x7eUL,
   ENUM_IOERR_SAS_CMD_REJECT = 0x7fUL,
   ENUM_IOERR_DISCOVERY_ABORTED = 0x80UL,
   ENUM_IOERR_INV_NTWK_TOPOLOGY = 0x81UL,
   ENUM_IOERR_TOO_MANY_ENTRIES = 0x82UL,
   ENUM_IOERR_INV_SAS_ADDRESS = 0x83UL,
   ENUM_IOERR_SAS_CMD_ALREADY_INPROG = 0x84UL,
   ENUM_IOERR_UNREG_REQUESTED = 0x8bUL,
   ENUM_IOERR_LOG_ACCESS_DENIED = 0x90UL,
   ENUM_IOERR_LOG_NO_RESOURCES = 0x91UL,
   ENUM_IOERR_LOG_INV_PARM_TYPE = 0x92UL,
   ENUM_IOERR_LOG_INV_PARM_VALUE = 0x93UL,
   ENUM_IOERR_LOG_INV_CONTROL = 0x94UL,
   ENUM_IOERR_LOG_INV_CHANNEL = 0x95UL
} FC_LOCAL_REJECT_STATUS_CODE;

// --- FC_HDR_R_CTL_ENUM ---
// Different types of route control information in FC header.
#define FC_UNCATEGORIZED                (0)       // Uncategorized information.
#define FC_SOLICITED_DATA               (1)       // Solicited data.
#define FC_UNSOLICITED_CONTROL          (2)       // Unsolicited control or request.
#define FC_SOLICITED_CONTROL            (3)       // Solicited control or reply.
#define FC_UNSOLICITED_DATA             (4)       // Unsolicited data.
#define FC_DATA_DESCRIPTOR              (5)       // Data descriptor or FCP_XFER_RDY
                                                  // request.
#define FC_UNSOLICITED_COMMAND          (6)       // Unsolicited command.
#define FC_COMMAND_STATUS               (7)       // Command status.
#define FC_ELS_SOLICITED_DATA           (33)      // ELS: Solicited Data
#define FC_ELS_REQUEST                  (34)      // ELS: Request
#define FC_ELS_REPLY                    (35)      // ELS: Reply
#define FC_FCP_LS_REQUEST               (50)      // FCP (FC-4): Request
#define FC_FCP_LS_RESPONSE              (51)      // FCP (FC-4): Response
#define FC_EXTN_HDR_PRSNT               (80)      // FCoE extension header present.
#define FC_NOP                          (128)     // BLS: No Operation
#define FC_ABTS                         (129)     // BLS: Abort Sequence
#define FC_BA_ACC                       (132)     // BLS: Basic_Accept
#define FC_BA_RJT                       (133)     // BLS: Basic_Reject
#define FC_ACK_1                        (192)     // Link Ctl: Acknowledge_1
#define FC_ACK_0                        (193)     // Link Ctl: Acknowledge_0
#define FC_P_RJT                        (194)     // Link Ctl: Nx_Port Reject
#define FC_F_RJT                        (195)     // Link Ctl: Fabric Reject
#define FC_P_BSY                        (196)     // Link Ctl: Nx_Port Busy
#define FC_F_BSY_DATA_FRM               (197)     // Link Ctl: Fabric Busy to Data frame
#define FC_F_BSY_LC_FRM                 (198)     // Link Ctl: Fabric Busy to Link_Control
                                                  // frame
#define FC_LCR                          (199)     // Link Ctl: Link Credit Reset

typedef enum {
   ENUM_FC_UNCATEGORIZED = 0x0UL,
   ENUM_FC_SOLICITED_DATA = 0x1UL,
   ENUM_FC_UNSOLICITED_CONTROL = 0x2UL,
   ENUM_FC_SOLICITED_CONTROL = 0x3UL,
   ENUM_FC_UNSOLICITED_DATA = 0x4UL,
   ENUM_FC_DATA_DESCRIPTOR = 0x5UL,
   ENUM_FC_UNSOLICITED_COMMAND = 0x6UL,
   ENUM_FC_COMMAND_STATUS = 0x7UL,
   ENUM_FC_ELS_SOLICITED_DATA = 0x21UL,
   ENUM_FC_ELS_REQUEST = 0x22UL,
   ENUM_FC_ELS_REPLY = 0x23UL,
   ENUM_FC_FCP_LS_REQUEST = 0x32UL,
   ENUM_FC_FCP_LS_RESPONSE = 0x33UL,
   ENUM_FC_EXTN_HDR_PRSNT = 0x50UL,
   ENUM_FC_NOP = 0x80UL,
   ENUM_FC_ABTS = 0x81UL,
   ENUM_FC_BA_ACC = 0x84UL,
   ENUM_FC_BA_RJT = 0x85UL,
   ENUM_FC_ACK_1 = 0xc0UL,
   ENUM_FC_ACK_0 = 0xc1UL,
   ENUM_FC_P_RJT = 0xc2UL,
   ENUM_FC_F_RJT = 0xc3UL,
   ENUM_FC_P_BSY = 0xc4UL,
   ENUM_FC_F_BSY_DATA_FRM = 0xc5UL,
   ENUM_FC_F_BSY_LC_FRM = 0xc6UL,
   ENUM_FC_LCR = 0xc7UL
} FC_HDR_R_CTL_ENUM;

// --- FC_HDR_R_CTL_ROUTING_ENUM ---
// Different types of routing control in FC header (bits 7:4 of R_CTL field).
#define FC_ROUTING_DEVICE_DATA          (0)       // Device_Data frames
#define FC_ROUTING_ELS                  (2)       // Extended Link Services
#define FC_ROUTING_FC4_LINK_DATA        (3)       // FC-4 Link_Data
#define FC_ROUTING_VIDEO_DATA           (4)       // Video_Data
#define FC_ROUTING_EXT_HDR              (5)       // Extended_Headers
#define FC_ROUTING_BLS                  (8)       // Basic Link Services
#define FC_ROUTING_LINK_CTL             (12)      // Link_Control Frame
#define FC_ROUTING_EXT_ROUTING          (15)      // Extended Routing

typedef enum {
   ENUM_FC_ROUTING_DEVICE_DATA = 0x0UL,
   ENUM_FC_ROUTING_ELS = 0x2UL,
   ENUM_FC_ROUTING_FC4_LINK_DATA = 0x3UL,
   ENUM_FC_ROUTING_VIDEO_DATA = 0x4UL,
   ENUM_FC_ROUTING_EXT_HDR = 0x5UL,
   ENUM_FC_ROUTING_BLS = 0x8UL,
   ENUM_FC_ROUTING_LINK_CTL = 0xcUL,
   ENUM_FC_ROUTING_EXT_ROUTING = 0xfUL
} FC_HDR_R_CTL_ROUTING_ENUM;

// --- FC_HDR_TYPE_ENUM ---
// FC header TYPE field
#define FC_FTYPE_BLS                    (0)       // Basic Link Service
#define FC_FTYPE_ELS                    (1)       // Extended Link Service
#define FC_FTYPE_FCP                    (8)       // FCP
#define FC_FTYPE_CT                     (32)      // Fibre Channel Common Transport

typedef enum {
   ENUM_FC_FTYPE_BLS = 0x0UL,
   ENUM_FC_FTYPE_ELS = 0x1UL,
   ENUM_FC_FTYPE_FCP = 0x8UL,
   ENUM_FC_FTYPE_CT = 0x20UL
} FC_HDR_TYPE_ENUM;

// --- FC_RESP_FLAG_ENUM ---
// FC response flag information.
#define FCP_RSP_LEN_VALID               (1)       // FCP response length is valid.
#define FCP_SNS_LEN_VALID               (2)       // FCP sense length valid.
#define FCP_RESID_OVER                  (4)       // FCP residual length overrun.
#define FCP_RESID_UNDER                 (8)       // FCP residual length underrun.
#define FCP_CONF_REQ                    (16)      // FCP status confirmation required.
#define FCP_BIDI_READ_RESID_OVER        (32)      // FCP bi-directional residual length
                                                  // overrun.
#define FCP_BIDI_READ_RESID_UNDER       (64)      // FCP bi-directional residual length
                                                  // underrun.
#define fcp_BIDI_RSP                    (128)     // FCP bi-directional response bit.

typedef enum {
   ENUM_FCP_RSP_LEN_VALID = 0x1UL,
   ENUM_FCP_SNS_LEN_VALID = 0x2UL,
   ENUM_FCP_RESID_OVER = 0x4UL,
   ENUM_FCP_RESID_UNDER = 0x8UL,
   ENUM_FCP_CONF_REQ = 0x10UL,
   ENUM_FCP_BIDI_READ_RESID_OVER = 0x20UL,
   ENUM_FCP_BIDI_READ_RESID_UNDER = 0x40UL,
   ENUM_fcp_BIDI_RSP = 0x80UL
} FC_RESP_FLAG_ENUM;

// --- FC_SCSI_STATUS_CODE_ENUM ---
// SCSI status codes (from SAM-4).
#define FC_SCSI_STATUS_GOOD             (0)       
#define FC_SCSI_STATUS_CHECK_CONDITION  (2)       
#define FC_SCSI_STATUS_CONDITION_MET    (4)       
#define FC_SCSI_STATUS_BUSY             (8)       
#define FC_SCSI_STATUS_INTERMEDIATE     (16)      
#define FC_SCSI_STATUS_INTERMEDIATE_CONDITION_MET (20) 
#define FC_SCSI_STATUS_RESERVATION_CONFLICT (24)  
#define FC_SCSI_STATUS_OBSOLETE         (34)      
#define FC_SCSI_STATUS_TASK_SET_FULL    (40)      
#define FC_SCSI_STATUS_ACA_ACTIVE       (48)      
#define FC_SCSI_STATUS_TASK_ABORTED     (64)      

typedef enum {
   ENUM_FC_SCSI_STATUS_GOOD = 0x0UL,
   ENUM_FC_SCSI_STATUS_CHECK_CONDITION = 0x2UL,
   ENUM_FC_SCSI_STATUS_CONDITION_MET = 0x4UL,
   ENUM_FC_SCSI_STATUS_BUSY = 0x8UL,
   ENUM_FC_SCSI_STATUS_INTERMEDIATE = 0x10UL,
   ENUM_FC_SCSI_STATUS_INTERMEDIATE_CONDITION_MET = 0x14UL,
   ENUM_FC_SCSI_STATUS_RESERVATION_CONFLICT = 0x18UL,
   ENUM_FC_SCSI_STATUS_OBSOLETE = 0x22UL,
   ENUM_FC_SCSI_STATUS_TASK_SET_FULL = 0x28UL,
   ENUM_FC_SCSI_STATUS_ACA_ACTIVE = 0x30UL,
   ENUM_FC_SCSI_STATUS_TASK_ABORTED = 0x40UL
} FC_SCSI_STATUS_CODE_ENUM;

// --- FC_ENTRY_SIZE_ENUM ---
#define FC_ENTRY_SIZE_64                (0)       // 64 bytes
#define FC_ENTRY_SIZE_128               (1)       // 128 bytes
#define FC_ENTRY_SIZE_256               (2)       // 256 bytes
#define FC_ENTRY_SIZE_512               (3)       // 512 bytes

typedef enum {
   ENUM_FC_ENTRY_SIZE_64 = 0x0UL,
   ENUM_FC_ENTRY_SIZE_128 = 0x1UL,
   ENUM_FC_ENTRY_SIZE_256 = 0x2UL,
   ENUM_FC_ENTRY_SIZE_512 = 0x3UL
} FC_ENTRY_SIZE_ENUM;

// --- FC_RXULP_UNRECOVERABLE_ERROR_CODES ---
// FCoE RxULP unrecoverable error codes
#define UNRECOVERABLE_ERROR_UNKNOWN_IPC (1)       
#define UNRECOVERABLE_ERROR_UNKNOWN_SIQ0_TASK (2) 
#define UNRECOVERABLE_ERROR_UNKNOWN_ERROR_RECOVERY_TIMEOUT (3) 
#define UNRECOVERABLE_ERROR_UNKNOWN_FCP_LS_RESPONSE (4) 
#define UNRECOVERABLE_ERROR_UNKNOWN_ELS_REPLY (5) 
#define UNRECOVERABLE_ERROR_UNKNOWN_WDMA_RESP_CODE (6) 
#define UNRECOVERABLE_ERROR_INVALID_HANDLER (7)   
#define UNRECOVERABLE_ERROR_SIQ0_OVERFLOW (8)     
#define UNRECOVERABLE_ERROR_SB_STK_OVERFLOW (9)   
#define UNRECOVERABLE_ERROR_BAD_ICD_CHECKSUM (10) 
#define UNRECOVERABLE_ERROR_NO_AVAIL_PER_RQ_STRUCT (11) 

typedef enum {
   ENUM_UNRECOVERABLE_ERROR_UNKNOWN_IPC = 0x1UL,
   ENUM_UNRECOVERABLE_ERROR_UNKNOWN_SIQ0_TASK = 0x2UL,
   ENUM_UNRECOVERABLE_ERROR_UNKNOWN_ERROR_RECOVERY_TIMEOUT = 0x3UL,
   ENUM_UNRECOVERABLE_ERROR_UNKNOWN_FCP_LS_RESPONSE = 0x4UL,
   ENUM_UNRECOVERABLE_ERROR_UNKNOWN_ELS_REPLY = 0x5UL,
   ENUM_UNRECOVERABLE_ERROR_UNKNOWN_WDMA_RESP_CODE = 0x6UL,
   ENUM_UNRECOVERABLE_ERROR_INVALID_HANDLER = 0x7UL,
   ENUM_UNRECOVERABLE_ERROR_SIQ0_OVERFLOW = 0x8UL,
   ENUM_UNRECOVERABLE_ERROR_SB_STK_OVERFLOW = 0x9UL,
   ENUM_UNRECOVERABLE_ERROR_BAD_ICD_CHECKSUM = 0xaUL,
   ENUM_UNRECOVERABLE_ERROR_NO_AVAIL_PER_RQ_STRUCT = 0xbUL
} FC_RXULP_UNRECOVERABLE_ERROR_CODES;

// --- FC_DEFPDU_STATE ---
// iSCSI default PDU state 
#define FC_DEF_PDU_VALID                (0)       // Default PDU valid.
#define FC_DEF_PDU_INVALID              (1)       // Default pDU invalid.

typedef enum {
   ENUM_FC_DEF_PDU_VALID = 0x0UL,
   ENUM_FC_DEF_PDU_INVALID = 0x1UL
} FC_DEFPDU_STATE;

// --- FC_CONNECTION_INVALIDATION_STATUS_ENUM ---
// Different types of status completion for FC connecton invalidate request.
#define FC_CXN_INVALIDATION_SUCESSFUL   (0)       // FC connecton invalidation sucessfull.
#define FC_CXN_INVALIDATED_PRIOR        (1)       // FC connecton invalidated prior to
                                                  // this.
#define FC_CXN_NOT_IN_RANGE             (2)       // FC connecton index not in range.

typedef enum {
   ENUM_FC_CXN_INVALIDATION_SUCESSFUL = 0x0UL,
   ENUM_FC_CXN_INVALIDATED_PRIOR = 0x1UL,
   ENUM_FC_CXN_NOT_IN_RANGE = 0x2UL
} FC_CONNECTION_INVALIDATION_STATUS_ENUM;

// --- FC_COMMAND_INVALIDATION_STATUS_ENUM ---
// Different types of status completion for command invalidate request.
#define FC_ICD_INVALIDATION_SUCESSFUL   (0)       // ICD invalidation sucessfull.
#define FC_ICD_INVALIDATED_PRIOR        (1)       // ICD invalidated prior to this.
#define FC_ICD_NOT_IN_RANGE             (2)       // ICD index not in range.

typedef enum {
   ENUM_FC_ICD_INVALIDATION_SUCESSFUL = 0x0UL,
   ENUM_FC_ICD_INVALIDATED_PRIOR = 0x1UL,
   ENUM_FC_ICD_NOT_IN_RANGE = 0x2UL
} FC_COMMAND_INVALIDATION_STATUS_ENUM;

// --- FC_SOL_HW_STS ---
// Solicited mode status values generated by hardware.
#define FC_SOL_HW_NO_ERR                (0)       // No error detected by hardware
#define FC_SOL_HW_UNDERRUN              (1)       // Number of bytes received is less than
                                                  // SGL
#define FC_SOL_HW_OVERRUN               (2)       // Number of bytes received is greater
                                                  // than SGL

typedef enum {
   ENUM_FC_SOL_HW_NO_ERR = 0x0UL,
   ENUM_FC_SOL_HW_UNDERRUN = 0x1UL,
   ENUM_FC_SOL_HW_OVERRUN = 0x2UL
} FC_SOL_HW_STS;

#endif // __fc_common_host_struct_enum_h__

