/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_defs_enum_h__
#define __ioctl_defs_enum_h__
#include "setypes.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- IOCTLDEF_DEFINED_ENUMS ---
#define MGMT_MAX_CONNECTIONS_PER_SESSION (1)      
#define MGMT_MAX_INITIATOR_PORTALS      (1)       
#define MGMT_MAX_NIC_PORTS              (2)       
#define MGMT_MAX_ISCSI_PORTS            (2)       
#define MGMT_MAX_PORTALS_PER_PG         (4)       
#define MGMT_IPV4_ADDRESS_LEN           (4)       
#define MGMT_IPV4_SUBNET_MASK_LEN       (4)       
#define MGMT_MAX_MPIO_BOOT_SESSIONS_SUPPORTED (4) 
#define MGMT_MAX_DNS_SERVER             (5)       
#define MGMT_MAX_MULTICAST_TIMEOUT_ENTRIES (5)    
#define MGMT_ISID_LENGTH                (6)       
#define MGMT_MAX_SCSI_CHANNELS          (8)       
#define MGMT_MAX_BOOTABLE_LUN           (8)       
#define MGMT_LUN_SIZE                   (8)       
#define MGMT_FCOE_WWPN_NAME_LEN         (8)       
#define MGMT_IOCTL_MIN_SRB_TIMEOUT_VALUE (10)     
#define MGMT_DIGEST_KEY_LEN             (12)      
#define MGMT_CHAP_SECRET_MIN_LEN        (12)      
#define MGMT_MAX_ROUTE_ENTRIES          (16)      
#define MGMT_CHAP_SECRET_LEN            (16)      
#define MGMT_IPV6_ADDRESS_LEN           (16)      
#define MGMT_IPV6_SUBNET_MASK_LEN       (16)      
#define MGMT_MAX_CDB_LEN                (16)      
#define MGMT_MAX_IP_SUPPORTED_PER_PORT  (16)      
#define MGMT_SENSE_BUFFER_LEN           (18)      
#define MGMT_MAX_SG_COUNT               (19)      
#define MGMT_SECURITY_KEY_LEN           (30)      
#define MGMT_ISCSI_ALIAS_LEN            (32)      
#define MGMT_MAX_MANUFACTURER_STRING    (32)      
#define MGMT_MAX_MODEL_NUMBER_STRING    (32)      
#define MGMT_MAX_CTLR_SERIALNO_STRING   (32)      
#define MGMT_MAX_FLASHROM_VERSION_STRING (32)     
#define MGMT_MAX_FW_VERSION_STRING      (32)      
#define MGMT_MAX_IP_VERSION_STRING      (32)      
#define MGMT_MAX_ISCSI_VERSION_STRING   (32)      
#define MGMT_MAX_BIOS_VERSION_STRING    (32)      
#define MGMT_MAX_REDBOOT_VERSION_STRING (32)      
#define MGMT_MAX_DRV_VERSION_STRING     (32)      
#define MGMT_MAX_INITIATOR_ALLOWED      (32)      
#define MGMT_MAX_ARP_ENTRIES            (64)      
#define MGMT_DNS_NAME_LEN               (64)      
#define MGMT_MAX_CTLR_DESCRIPTION_STRING (64)     
#define MGMT_MAX_TARGETS_ALLOWED_USING_SENDTARGETS (64) 
#define MGMT_MAX_TARGETS_ALLOWED_USING_DISCOVERY (128) 
#define MGMT_MAX_PORTAL_GROUPS          (128)     
#define MGMT_ISCSI_NAME_LEN             (224)     
#define MGMT_ISNS_PORTAL_SYM_NAME_LEN   (256)     
#define MGMT_CHAP_NAME_LEN              (256)     
#define MGMT_SEND_TARGET_TEXTKEY        (256)     
#define MGMT_MAX_SCOPE_LIST_LENGTH      (256)     
#define MGMT_MAX_QUERY_LIST_LENGTH      (256)     
#define MGMT_PRESHARED_KEYSIZE          (256)     
#define MGMT_IPSEC_ID_SIZE              (256)     
#define MGMT_MAX_TARGETS_ALLOWED        (512)     
#define MGMT_MAX_LUNS                   (512)     
#define MGMT_MAX_HOST_TABLE             (512)     
#define MGMT_MAX_ISCSI_SESSIONS_ALLOWED (512)     
#define MGMT_MAX_CONNECTIONS            (512)     
#define MGMT_MAX_ISCSI_SESSIONS_ALLOWED_USING_DISCOVERY (520) 
#define MGMT_MAX_CONNECTIONS_USING_DISCOVERY (520) 
#define MGMT_MAX_PORTALS                (1024)    
#define MAX_SEEPROM_SIZE                (1024)    
#define MGMT_MAX_IOCTL_PAYLOAD_SIZE     (73728)   

typedef enum {
   ENUM_MGMT_MAX_CONNECTIONS_PER_SESSION = 0x1UL,
   ENUM_MGMT_MAX_INITIATOR_PORTALS = 0x1UL,
   ENUM_MGMT_MAX_NIC_PORTS = 0x2UL,
   ENUM_MGMT_MAX_ISCSI_PORTS = 0x2UL,
   ENUM_MGMT_MAX_PORTALS_PER_PG = 0x4UL,
   ENUM_MGMT_IPV4_ADDRESS_LEN = 0x4UL,
   ENUM_MGMT_IPV4_SUBNET_MASK_LEN = 0x4UL,
   ENUM_MGMT_MAX_MPIO_BOOT_SESSIONS_SUPPORTED = 0x4UL,
   ENUM_MGMT_MAX_DNS_SERVER = 0x5UL,
   ENUM_MGMT_MAX_MULTICAST_TIMEOUT_ENTRIES = 0x5UL,
   ENUM_MGMT_ISID_LENGTH = 0x6UL,
   ENUM_MGMT_MAX_SCSI_CHANNELS = 0x8UL,
   ENUM_MGMT_MAX_BOOTABLE_LUN = 0x8UL,
   ENUM_MGMT_LUN_SIZE = 0x8UL,
   ENUM_MGMT_FCOE_WWPN_NAME_LEN = 0x8UL,
   ENUM_MGMT_IOCTL_MIN_SRB_TIMEOUT_VALUE = 0xaUL,
   ENUM_MGMT_DIGEST_KEY_LEN = 0xcUL,
   ENUM_MGMT_CHAP_SECRET_MIN_LEN = 0xcUL,
   ENUM_MGMT_MAX_ROUTE_ENTRIES = 0x10UL,
   ENUM_MGMT_CHAP_SECRET_LEN = 0x10UL,
   ENUM_MGMT_IPV6_ADDRESS_LEN = 0x10UL,
   ENUM_MGMT_IPV6_SUBNET_MASK_LEN = 0x10UL,
   ENUM_MGMT_MAX_CDB_LEN = 0x10UL,
   ENUM_MGMT_MAX_IP_SUPPORTED_PER_PORT = 0x10UL,
   ENUM_MGMT_SENSE_BUFFER_LEN = 0x12UL,
   ENUM_MGMT_MAX_SG_COUNT = 0x13UL,
   ENUM_MGMT_SECURITY_KEY_LEN = 0x1eUL,
   ENUM_MGMT_ISCSI_ALIAS_LEN = 0x20UL,
   ENUM_MGMT_MAX_MANUFACTURER_STRING = 0x20UL,
   ENUM_MGMT_MAX_MODEL_NUMBER_STRING = 0x20UL,
   ENUM_MGMT_MAX_CTLR_SERIALNO_STRING = 0x20UL,
   ENUM_MGMT_MAX_FLASHROM_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_FW_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_IP_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_ISCSI_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_BIOS_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_REDBOOT_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_DRV_VERSION_STRING = 0x20UL,
   ENUM_MGMT_MAX_INITIATOR_ALLOWED = 0x20UL,
   ENUM_MGMT_MAX_ARP_ENTRIES = 0x40UL,
   ENUM_MGMT_DNS_NAME_LEN = 0x40UL,
   ENUM_MGMT_MAX_CTLR_DESCRIPTION_STRING = 0x40UL,
   ENUM_MGMT_MAX_TARGETS_ALLOWED_USING_SENDTARGETS = 0x40UL,
   ENUM_MGMT_MAX_TARGETS_ALLOWED_USING_DISCOVERY = 0x80UL,
   ENUM_MGMT_MAX_PORTAL_GROUPS = 0x80UL,
   ENUM_MGMT_ISCSI_NAME_LEN = 0xe0UL,
   ENUM_MGMT_ISNS_PORTAL_SYM_NAME_LEN = 0x100UL,
   ENUM_MGMT_CHAP_NAME_LEN = 0x100UL,
   ENUM_MGMT_SEND_TARGET_TEXTKEY = 0x100UL,
   ENUM_MGMT_MAX_SCOPE_LIST_LENGTH = 0x100UL,
   ENUM_MGMT_MAX_QUERY_LIST_LENGTH = 0x100UL,
   ENUM_MGMT_PRESHARED_KEYSIZE = 0x100UL,
   ENUM_MGMT_IPSEC_ID_SIZE = 0x100UL,
   ENUM_MGMT_MAX_TARGETS_ALLOWED = 0x200UL,
   ENUM_MGMT_MAX_LUNS = 0x200UL,
   ENUM_MGMT_MAX_HOST_TABLE = 0x200UL,
   ENUM_MGMT_MAX_ISCSI_SESSIONS_ALLOWED = 0x200UL,
   ENUM_MGMT_MAX_CONNECTIONS = 0x200UL,
   ENUM_MGMT_MAX_ISCSI_SESSIONS_ALLOWED_USING_DISCOVERY = 0x208UL,
   ENUM_MGMT_MAX_CONNECTIONS_USING_DISCOVERY = 0x208UL,
   ENUM_MGMT_MAX_PORTALS = 0x400UL,
   ENUM_MAX_SEEPROM_SIZE = 0x400UL,
   ENUM_MGMT_MAX_IOCTL_PAYLOAD_SIZE = 0x12000UL
} IOCTLDEF_DEFINED_ENUMS;

#endif // __ioctl_defs_enum_h__

