/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_boot_enum_h__
#define __ioctl_iscsi_ini_boot_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- BOOT_TARGET_CONFIGURATION ---
#define BOOT_TARGET_MANUALLY_CONFIGURED (1)       // Boot target is manually configured 
#define BOOT_TARGET_AUTO_DISCOVERED     (2)       // The firmware needs to discover the
                                                  // boot device itself 

typedef enum {
   ENUM_BOOT_TARGET_MANUALLY_CONFIGURED = 0x1UL,
   ENUM_BOOT_TARGET_AUTO_DISCOVERED = 0x2UL
} BOOT_TARGET_CONFIGURATION;

// --- AUTO_DISCOVER_CONFIGURATION ---
#define DISCOVER_BOOT_TARGET_USING_DHCP_PORT0 (1) // Discover Boot Target using DHCP on
                                                  // Port0 
#define DISCOVER_BOOT_TARGET_USING_DHCP_PORT1 (2) // Discover Boot Target using DHCP on
                                                  // Port1 

typedef enum {
   ENUM_DISCOVER_BOOT_TARGET_USING_DHCP_PORT0 = 0x1UL,
   ENUM_DISCOVER_BOOT_TARGET_USING_DHCP_PORT1 = 0x2UL
} AUTO_DISCOVER_CONFIGURATION;

// --- MGMT_BIOS_INT13_STATE ---
#define MGMT_HBA_INT13_DISABLED         (0)       
#define MGMT_HBA_INT13_ENABLED          (1)       

typedef enum {
   ENUM_MGMT_HBA_INT13_DISABLED = 0x0UL,
   ENUM_MGMT_HBA_INT13_ENABLED = 0x1UL
} MGMT_BIOS_INT13_STATE;

// --- MGMT_INT13_PER_FUNC ---
#define MGMT_HBA_INT13_FUN0             (1)       
#define MGMT_HBA_INT13_FUN1             (2)       
#define MGMT_HBA_INT13_FUN2             (4)       
#define MGMT_HBA_INT13_FUN3             (8)       
#define MGMT_HBA_INT13_FUN4             (16)      
#define MGMT_HBA_INT13_FUN5             (32)      
#define MGMT_HBA_INT13_FUN6             (64)      
#define MGMT_HBA_INT13_FUN7             (128)     

typedef enum {
   ENUM_MGMT_HBA_INT13_FUN0 = 0x1UL,
   ENUM_MGMT_HBA_INT13_FUN1 = 0x2UL,
   ENUM_MGMT_HBA_INT13_FUN2 = 0x4UL,
   ENUM_MGMT_HBA_INT13_FUN3 = 0x8UL,
   ENUM_MGMT_HBA_INT13_FUN4 = 0x10UL,
   ENUM_MGMT_HBA_INT13_FUN5 = 0x20UL,
   ENUM_MGMT_HBA_INT13_FUN6 = 0x40UL,
   ENUM_MGMT_HBA_INT13_FUN7 = 0x80UL
} MGMT_INT13_PER_FUNC;

// --- BOOT_SECURITY_FLAG ---
#define BOOT_SECURITY_ENABLED           (1)       // Enabled 
#define BOOT_SECURITY_DISABLED          (2)       // Disabled 

typedef enum {
   ENUM_BOOT_SECURITY_ENABLED = 0x1UL,
   ENUM_BOOT_SECURITY_DISABLED = 0x2UL
} BOOT_SECURITY_FLAG;

// --- BIOS_DEFINED_ENUMS ---
#define MGMT_MAX_BIOS_SG_COUNT          (10)      // (240 - 16 (for ioctl_header) - 40)/16
                                                  // = 11.5 
#define MGMT_MAX_BIOS_IOCTL_SIZE        (240)     

typedef enum {
   ENUM_MGMT_MAX_BIOS_SG_COUNT = 0xaUL,
   ENUM_MGMT_MAX_BIOS_IOCTL_SIZE = 0xf0UL
} BIOS_DEFINED_ENUMS;

// --- IOCTL_DATA_DIRECTION ---
#define SCB_FLAG_XFER_FROM_DEVICE       (1)       // Read 
#define SCB_FLAG_XFER_TO_DEVICE         (2)       // Write 

typedef enum {
   ENUM_SCB_FLAG_XFER_FROM_DEVICE = 0x1UL,
   ENUM_SCB_FLAG_XFER_TO_DEVICE = 0x2UL
} IOCTL_DATA_DIRECTION;

// --- MGMT_REMOTE_CFG ---
#define DISABLE_REMOTE_CFG              (0)       
#define ENABLE_REMOTE_CFG               (1)       // ARM Firmware will perform ICDS
                                                  // protocol with switch to query its IP,
                                                  // TFTP Server IP and SLOT ID. And will
                                                  // TFTP the XML file from server, to
                                                  // configure BladeEngine.

typedef enum {
   ENUM_DISABLE_REMOTE_CFG = 0x0UL,
   ENUM_ENABLE_REMOTE_CFG = 0x1UL
} MGMT_REMOTE_CFG;

// --- MGMT_IBFT_CONFIGURATION ---
#define IBFT_ADDRESS_INVALID            (0)       
#define IBFT_ADDRESS_VALID              (1)       // IBFT address is present in
                                                  // ibft_pci_address 

typedef enum {
   ENUM_IBFT_ADDRESS_INVALID = 0x0UL,
   ENUM_IBFT_ADDRESS_VALID = 0x1UL
} MGMT_IBFT_CONFIGURATION;

#endif // __ioctl_iscsi_ini_boot_enum_h__

