/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_discovery_enum_h__
#define __ioctl_iscsi_ini_discovery_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- MGMT_TGT_FLAG ---
#define MGMT_TGT_FLAG_MANUAL_CONFIGURED (1)       
#define MGMT_TGT_FLAG_SENDTARGETS_DISCOVERED (2)  
#define MGMT_TGT_FLAG_ISNS_DISCOVERED   (4)       
#define MGMT_TGT_FLAG_SLP_DISCOVERED    (8)       

typedef enum {
   ENUM_MGMT_TGT_FLAG_MANUAL_CONFIGURED = 0x1UL,
   ENUM_MGMT_TGT_FLAG_SENDTARGETS_DISCOVERED = 0x2UL,
   ENUM_MGMT_TGT_FLAG_ISNS_DISCOVERED = 0x4UL,
   ENUM_MGMT_TGT_FLAG_SLP_DISCOVERED = 0x8UL
} MGMT_TGT_FLAG;

// --- MGMT_TGT_DISCOVERY ---
#define MGMT_TGT_DISCOVERY_SKIP         (0)       // "The firmware return all targets that
                                                  // has been already discovered. The
                                                  // firmware doesn't need to perform
                                                  // discovery 
#define MGMT_TGT_DISCOVERY_ISNS_SLP     (1)       // "The firmware should perform iSNSLP
                                                  // discovery before returing the targets
                                                  // to the application 

typedef enum {
   ENUM_MGMT_TGT_DISCOVERY_SKIP = 0x0UL,
   ENUM_MGMT_TGT_DISCOVERY_ISNS_SLP = 0x1UL
} MGMT_TGT_DISCOVERY;

// --- PARSE_DATA_OPTIONS ---
#define DO_NOT_PARSE_DATA               (0)       // Return the raw data returned by the
                                                  // SendTargets command 
#define RETURN_PARSED_DATA              (1)       // Firmware will return the parsed Send
                                                  // Targets Data. 
#define RETURN_TGT_COUNT                (2)       // Firmware parses the SendTarget Data,
                                                  // logs-in to all the discovered targets
                                                  // and returns the number of targets 

typedef enum {
   ENUM_DO_NOT_PARSE_DATA = 0x0UL,
   ENUM_RETURN_PARSED_DATA = 0x1UL,
   ENUM_RETURN_TGT_COUNT = 0x2UL
} PARSE_DATA_OPTIONS;

// --- RETRIEVE_TARGET_INFO_OPTIONS ---
#define RETURN_PORTAL_COUNT             (0)       // Return portal count for the given
                                                  // range of targets (target_index ->
                                                  // target_index + num_of_targets). 
#define RETURN_PORTAL_INFO_SINGLE_TARGET (1)      // Return portal information for a given
                                                  // target. num_of_targets MUST be set to
                                                  // 1. Set portal_index and
                                                  // num_of_portals appropriately 
#define RETURN_PORTAL_INFO_MULTIPLE_TARGETS (2)   // Return portal information for a given
                                                  // range of targets (num_of_targets)
                                                  // starting with target_index.
                                                  // portal_index and num_of_portals are
                                                  // ignored. 

typedef enum {
   ENUM_RETURN_PORTAL_COUNT = 0x0UL,
   ENUM_RETURN_PORTAL_INFO_SINGLE_TARGET = 0x1UL,
   ENUM_RETURN_PORTAL_INFO_MULTIPLE_TARGETS = 0x2UL
} RETRIEVE_TARGET_INFO_OPTIONS;

#endif // __ioctl_iscsi_ini_discovery_enum_h__

