/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_driver_enum_h__
#define __ioctl_iscsi_ini_driver_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"
#include "ioctl_iscsi_ini_stats_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ISCSI_DRIVER_REOPEN_ALL_SESSIONS_TYPE ---
#define IOCTL_ISCSI_REOPEN_ALL_SESSIONS (0)       // Reopen all the previously closed
                                                  // session. If any session is offloaded
                                                  // then that session will be invalidated
                                                  // and reopened again
#define IOCTL_ISCSI_REOPEN_BOOT_SESSION (1)       // Reopen only boot session. Mainly used
                                                  // in mailbox mode by hiber and crash
                                                  // dump driver. Bios will also use it
                                                  // for session recovery
#define IOCTL_ISCSI_REOPEN_A_SESSION    (2)       // Reopen specified session. The
                                                  // session_handle is also passed by
                                                  // IOCTL when this type is used

typedef enum {
   ENUM_IOCTL_ISCSI_REOPEN_ALL_SESSIONS = 0x0UL,
   ENUM_IOCTL_ISCSI_REOPEN_BOOT_SESSION = 0x1UL,
   ENUM_IOCTL_ISCSI_REOPEN_A_SESSION = 0x2UL
} ISCSI_DRIVER_REOPEN_ALL_SESSIONS_TYPE;

// --- IOCTL_ISCSI_INVALIDATE_CONNECTION_TYPE ---
#define IOCTL_ISCSI_CONNECTION_INVALIDATE (1)     // Request the EP firmware to
                                                  // 'invalidate' this connection.
#define IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST (2)  // Issue a TCP RST on this connection 
#define IOCTL_ISCSI_CONNECTION_IGNORE_HANDLE (32768) // With this bit set the session
                                                     // handle field in invalid and will
                                                     // not be used in ARM FW. This is
                                                     // used/set by Open iSCSI drivers. 

typedef enum {
   ENUM_IOCTL_ISCSI_CONNECTION_INVALIDATE = 0x1UL,
   ENUM_IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST = 0x2UL,
   ENUM_IOCTL_ISCSI_CONNECTION_IGNORE_HANDLE = 0x8000UL
} IOCTL_ISCSI_INVALIDATE_CONNECTION_TYPE;

// --- IOCTL_ISCSI_SESSION_SAVE_CFG ---
// This flag will not be used be driver since non persistent target will not be saved
// after successful login. It will only be saved when IOCTL to save these target is
// called. 
#define IOCTL_ISCSI_SESSION_DEL_CFG_FROM_FLASH (0) // If this is the last conn of a
                                                   // session, remove all session cfg data
                                                   // from Flash. This flag is ONLY
                                                   // applicable to non persistent
                                                   // targets. To delete a persistent
                                                   // target from Flash, an explicit
                                                   // command to delete the target
                                                   // IOCTL_ISCSI_INI_SESSION_DELETE_PERSI
                                                   // STENT_LOGIN must be received from
                                                   // the management layer. 
#define IOCTL_ISCSI_SESSION_SAVE_CFG_ON_FLASH (1) // Leave iSCSI session/conn info on
                                                  // Flash ROM

typedef enum {
   ENUM_IOCTL_ISCSI_SESSION_DEL_CFG_FROM_FLASH = 0x0UL,
   ENUM_IOCTL_ISCSI_SESSION_SAVE_CFG_ON_FLASH = 0x1UL
} IOCTL_ISCSI_SESSION_SAVE_CFG;

#endif // __ioctl_iscsi_ini_driver_enum_h__

