/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_enums_enum_h__
#define __iscsi_enums_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ICD_TR_BIT ---
// Type of WRB processing.
#define ISCSI_RECEIVE                   (0)       // Receive data on wire
#define ISCSI_TRANSMIT                  (1)       // Transmit data on wire

typedef enum {
   ENUM_ISCSI_RECEIVE = 0x0UL,
   ENUM_ISCSI_TRANSMIT = 0x1UL
} ICD_TR_BIT;

// --- I_T_CQE_CODE_ENUM ---
// Different types of iSCSI completions to host driver for both initiator and taget mode
// of operation.
#define SOL_CMD_COMPLETE                (1)       // Solicited command completed normally
#define SOL_CMD_KILLED_DATA_DIGEST_ERR  (2)       // Solicited command got invalidated
                                                  // internally due to Data Digest error
#define CXN_KILLED_PDU_SIZE_EXCEEDS_DSL (3)       // Connection got invalidated internally
                                                  // due to a recieved PDU size > DSL
#define CXN_KILLED_BURST_LEN_MISMATCH   (4)       // Connection got invalidated internally
                                                  // due ti received PDU sequence size >
                                                  // FBL/MBL.
#define CXN_KILLED_AHS_RCVD             (5)       // Connection got invalidated internally
                                                  // due to a recieved PDU Hdr that has
                                                  // AHS
#define CXN_KILLED_HDR_DIGEST_ERR       (6)       // Connection got invalidated internally
                                                  // due to Hdr Digest error
#define CXN_KILLED_UNKNOWN_HDR          (7)       // Connection got invalidated internally
                                                  // due to a bad opcode in the pdu hdr
#define CXN_KILLED_STALE_ITT_TTT_RCVD   (8)       // Connection got invalidated internally
                                                  // due to a recieved ITT/TTT that does
                                                  // not belong to this Connection
#define CXN_KILLED_INVALID_ITT_TTT_RCVD (9)       // Connection got invalidated internally
                                                  // due to recieved ITT/TTT value > Max
                                                  // Supported ITTs/TTTs
#define CXN_KILLED_RST_RCVD             (10)      // Connection got invalidated internally
                                                  // due to an incoming TCP RST
#define CXN_KILLED_TCP_PROT_ERR         (11)      // Connection got invalidated internally
                                                  // due to tcp protocol error (like syn
                                                  // rcvd, max retransmits exceeded,
                                                  // urgent rcvd, etc.)
#define CXN_KILLED_RST_SENT             (12)      // Connection got invalidated internally
                                                  // due to TCP RST sent by the Tx side
#define CXN_KILLED_FIN_RCVD             (13)      // Connection got invalidated internally
                                                  // due to an incoming TCP FIN.
#define CXN_KILLED_BAD_UNSOL_PDU_RCVD   (14)      // Connection got invalidated internally
                                                  // due to bad unsolicited PDU
                                                  // (Unsolicited PDUs are PDUs with
                                                  // ITT=0xffffffff) 
#define CXN_KILLED_BAD_WRB_INDEX_ERROR  (15)      // Connection got invalidated internally
                                                  // due to bad WRB index.
#define CXN_KILLED_OVER_RUN_RESIDUAL    (16)      // Command got invalidated internally
                                                  // due to recived command has residual
                                                  // over run bytes.
#define CXN_KILLED_UNDER_RUN_RESIDUAL   (17)      // Command got invalidated internally
                                                  // due to recived command has residual
                                                  // under run bytes.
#define CMD_KILLED_INVALID_STATSN_RCVD  (18)      // Command got invalidated internally
                                                  // due to a recieved PDU has an invalid
                                                  // StatusSN
#define CMD_KILLED_INVALID_R2T_RCVD     (19)      // Command got invalidated internally
                                                  // due to a recieved an R2T with some
                                                  // invalid field(s) in it
#define CMD_CXN_KILLED_LUN_INVALID      (20)      // Command got invalidated internally
                                                  // due to received PDU has an invalid
                                                  // LUN.
#define CMD_CXN_KILLED_ICD_INVALID      (21)      // Command got invalidated internally
                                                  // due to the corresponding ICD not in a
                                                  // valid state
#define CMD_CXN_KILLED_ITT_INVALID      (22)      // Command got invalidated due to
                                                  // received PDU has an invalid ITT.
#define CMD_CXN_KILLED_SEQ_OUTOFORDER   (23)      // Command got invalidated due to
                                                  // received sequence buffer offset is
                                                  // out of order.
#define CMD_CXN_KILLED_INVALID_DATASN_RCVD (24)   // Command got invalidated internally
                                                  // due to a recieved PDU has an invalid
                                                  // DataSN
#define CXN_INVALIDATE_NOTIFY           (25)      // Connection invalidation completion
                                                  // notify.
#define CXN_INVALIDATE_INDEX_NOTIFY     (26)      // Connection invalidation completion
                                                  // with data PDU index.
#define CMD_INVALIDATED_NOTIFY          (27)      // Command invalidation completion
                                                  // notifify.
#define UNSOL_HDR_NOTIFY                (28)      // Unsolicited header notify.
#define UNSOL_DATA_NOTIFY               (29)      // Unsolicited data notify.
#define UNSOL_DATA_DIGEST_ERROR_NOTIFY  (30)      // Unsolicited data digest error notify.
#define DRIVERMSG_NOTIFY                (31)      // TCP acknowledge based notification.
#define CXN_KILLED_CMND_DATA_NOT_ON_SAME_CONN (32) // Connection got invalidated
                                                   // internally due to command and data
                                                   // are not on same connection.
#define SOL_CMD_KILLED_DIF_ERR          (33)      // Solicited command got invalidated
                                                  // internally due to DIF error
#define CXN_KILLED_IMM_DATA_RCVD        (34)      // Connection got invalidated internally
                                                  // due to an incoming Unsolicited PDU
                                                  // that has immediate data on the cxn
                                                  // that does not support it.

typedef enum {
   ENUM_SOL_CMD_COMPLETE = 0x1UL,
   ENUM_SOL_CMD_KILLED_DATA_DIGEST_ERR = 0x2UL,
   ENUM_CXN_KILLED_PDU_SIZE_EXCEEDS_DSL = 0x3UL,
   ENUM_CXN_KILLED_BURST_LEN_MISMATCH = 0x4UL,
   ENUM_CXN_KILLED_AHS_RCVD = 0x5UL,
   ENUM_CXN_KILLED_HDR_DIGEST_ERR = 0x6UL,
   ENUM_CXN_KILLED_UNKNOWN_HDR = 0x7UL,
   ENUM_CXN_KILLED_STALE_ITT_TTT_RCVD = 0x8UL,
   ENUM_CXN_KILLED_INVALID_ITT_TTT_RCVD = 0x9UL,
   ENUM_CXN_KILLED_RST_RCVD = 0xaUL,
   ENUM_CXN_KILLED_TCP_PROT_ERR = 0xbUL,
   ENUM_CXN_KILLED_RST_SENT = 0xcUL,
   ENUM_CXN_KILLED_FIN_RCVD = 0xdUL,
   ENUM_CXN_KILLED_BAD_UNSOL_PDU_RCVD = 0xeUL,
   ENUM_CXN_KILLED_BAD_WRB_INDEX_ERROR = 0xfUL,
   ENUM_CXN_KILLED_OVER_RUN_RESIDUAL = 0x10UL,
   ENUM_CXN_KILLED_UNDER_RUN_RESIDUAL = 0x11UL,
   ENUM_CMD_KILLED_INVALID_STATSN_RCVD = 0x12UL,
   ENUM_CMD_KILLED_INVALID_R2T_RCVD = 0x13UL,
   ENUM_CMD_CXN_KILLED_LUN_INVALID = 0x14UL,
   ENUM_CMD_CXN_KILLED_ICD_INVALID = 0x15UL,
   ENUM_CMD_CXN_KILLED_ITT_INVALID = 0x16UL,
   ENUM_CMD_CXN_KILLED_SEQ_OUTOFORDER = 0x17UL,
   ENUM_CMD_CXN_KILLED_INVALID_DATASN_RCVD = 0x18UL,
   ENUM_CXN_INVALIDATE_NOTIFY = 0x19UL,
   ENUM_CXN_INVALIDATE_INDEX_NOTIFY = 0x1aUL,
   ENUM_CMD_INVALIDATED_NOTIFY = 0x1bUL,
   ENUM_UNSOL_HDR_NOTIFY = 0x1cUL,
   ENUM_UNSOL_DATA_NOTIFY = 0x1dUL,
   ENUM_UNSOL_DATA_DIGEST_ERROR_NOTIFY = 0x1eUL,
   ENUM_DRIVERMSG_NOTIFY = 0x1fUL,
   ENUM_CXN_KILLED_CMND_DATA_NOT_ON_SAME_CONN = 0x20UL,
   ENUM_SOL_CMD_KILLED_DIF_ERR = 0x21UL,
   ENUM_CXN_KILLED_IMM_DATA_RCVD = 0x22UL
} I_T_CQE_CODE_ENUM;

// --- SOL_HW_STS ---
// Solicited mode status values generated by hardware.
#define SOL_HW_UNDERRUN                 (1)       // Number of bytes received is less than
                                                  // SGL
#define SOL_HW_OVERRUN                  (2)       // Number of bytes received is greater
                                                  // than SGL

typedef enum {
   ENUM_SOL_HW_UNDERRUN = 0x1UL,
   ENUM_SOL_HW_OVERRUN = 0x2UL
} SOL_HW_STS;

// --- ICD_WR_BIT ---
// Type of iSCSI command PDU.
#define ISCSI_WRB_READ                  (0)       // iSCSI Read command PDU
#define ISCSI_WRB_WRITE                 (1)       // iSCSI Write command PDU

typedef enum {
   ENUM_ISCSI_WRB_READ = 0x0UL,
   ENUM_ISCSI_WRB_WRITE = 0x1UL
} ICD_WR_BIT;

// --- ICD_STATE ---
// Enumeration of states for an iSCSI command.
#define CMD_FREE                        (0)       // Command completed
#define CMD_SENT                        (1)       // Command BHS (plus all the immediate
                                                  // data) has been sent to the target;
                                                  // Awaiting Response/R2T/DataIn BHS.
#define CMD_MIDDLE                      (2)       // Iscsi rx is in the middle of DMAing
                                                  // data for this cmd.

typedef enum {
   ENUM_CMD_FREE = 0x0UL,
   ENUM_CMD_SENT = 0x1UL,
   ENUM_CMD_MIDDLE = 0x2UL
} ICD_STATE;

// --- CXN_STATE ---
// Enumeration of states for an iSCSI connection.
#define SOL_SPDU                        (0)       // Cxn is in solicited start-of-pdu
                                                  // processing state
#define SOL_MPDU                        (1)       // Cxn is in solicited mid-of-pdu
                                                  // processing state.
#define SLOW_PATH                       (2)       // Cxn is in slow-path processing state.
#define CXN_INVALID                     (3)       // Cxn is in invalidated state.
#define CXN_INVALID_FIN_RCVD            (4)       // Cxn is in FIN rcvd state.
#define CXN_INVALID_RST_RCVD            (5)       // Cxn is in RST rcvd state.
#define CXN_INVALID_RST_SENT            (6)       // Cxn is in RST sent state.
#define CXN_INVALID_TCP_PROT_ERR        (7)       // Cxn is in SYN rcvd state.

typedef enum {
   ENUM_SOL_SPDU = 0x0UL,
   ENUM_SOL_MPDU = 0x1UL,
   ENUM_SLOW_PATH = 0x2UL,
   ENUM_CXN_INVALID = 0x3UL,
   ENUM_CXN_INVALID_FIN_RCVD = 0x4UL,
   ENUM_CXN_INVALID_RST_RCVD = 0x5UL,
   ENUM_CXN_INVALID_RST_SENT = 0x6UL,
   ENUM_CXN_INVALID_TCP_PROT_ERR = 0x7UL
} CXN_STATE;

// --- JE_HDR_NO ---
// Enumeration of header number in SG frag 0
#define ISCSI_CMND_HEADER               (0)       
#define ISCSI_DATA_OUT_IN_HEADER        (1)       

typedef enum {
   ENUM_ISCSI_CMND_HEADER = 0x0UL,
   ENUM_ISCSI_DATA_OUT_IN_HEADER = 0x1UL
} JE_HDR_NO;

// --- LUN_TYPE ---
// Enumeration of LUN type in WRB
#define SINGLE_LEVEL_LUN                (0)       // Single level LUN
#define MULTI_LEVEL_LUN                 (1)       // Multi level LUN

typedef enum {
   ENUM_SINGLE_LEVEL_LUN = 0x0UL,
   ENUM_MULTI_LEVEL_LUN = 0x1UL
} LUN_TYPE;

// --- ISCSI_PDU_TYPE ---
// Solicited or Unsolicited iSCSI PDU
#define SOL                             (0)       // Solicited PDU
#define UNSOL                           (1)       // Unsolicited PDU

typedef enum {
   ENUM_SOL = 0x0UL,
   ENUM_UNSOL = 0x1UL
} ISCSI_PDU_TYPE;

// --- DATA_SEG_CHECK ---
// iSCSI data segment present or absent
#define DATASEG_ABSENT                  (0)       // iSCSI data segment absent with this
                                                  // iSCSI PDU
#define DATASEG_PRESENT                 (1)       // iSCSI data segment present with this
                                                  // iSCSI PDU

typedef enum {
   ENUM_DATASEG_ABSENT = 0x0UL,
   ENUM_DATASEG_PRESENT = 0x1UL
} DATA_SEG_CHECK;

// --- WRB_INVLAID_BIT ---
// WRB invalid bit
#define WRB_VALID                       (0)       // WRB request is valid
#define WRB_INVALID                     (1)       // WRB request is invalid

typedef enum {
   ENUM_WRB_VALID = 0x0UL,
   ENUM_WRB_INVALID = 0x1UL
} WRB_INVLAID_BIT;

// --- ISCSI_MODE_OP ---
// iSCSI mode of operation
#define ISCSI_INITIATOR                 (0)       // iSCSI initiator
#define ISCSI_TARGET                    (1)       // iSCSI target

typedef enum {
   ENUM_ISCSI_INITIATOR = 0x0UL,
   ENUM_ISCSI_TARGET = 0x1UL
} ISCSI_MODE_OP;

// --- ISCSI_DEFPDU_STATE ---
// iSCSI default PDU state 
#define DEF_PDU_VALID                   (0)       // Default PDU valid.
#define DEF_PDU_INVALID                 (1)       // Default pDU invalid.

typedef enum {
   ENUM_DEF_PDU_VALID = 0x0UL,
   ENUM_DEF_PDU_INVALID = 0x1UL
} ISCSI_DEFPDU_STATE;

// --- ISCSI_WRB_OPCODE ---
// ISCSI_WRB opcode/type. Initiator request types are prepended by INI, and target types
// by TGT. The enums here are subset of ISCSI_REQ_TYPE. Update ISCSI_REQ_TYPE when adding
// new types here 
#define INI_WR_CMD                      (1)       // Initiator write command
#define INI_TMF_CMD                     (2)       // Initiator TMF command
#define INI_NOPOUT_CMD                  (3)       // Initiator; Send a NOP-OUT
#define INI_RD_CMD                      (5)       // Initiator requesting to send a read
                                                  // command
#define TGT_CTX_UPDT_CMD                (7)       // Target context update
#define TGT_STS_CMD                     (8)       // Target R2T and other BHS where only
                                                  // the status number need to be updated
#define TGT_DATAIN_CMD                  (9)       // Target Data-Ins in response to read
                                                  // command
#define TGT_SOS_PDU                     (10)      // Target: stand alone status response
#define TGT_DM_CMD                      (11)      // Indicates that the bhs prepared by
                                                  // driver should not be touched

typedef enum {
   ENUM_INI_WR_CMD = 0x1UL,
   ENUM_INI_TMF_CMD = 0x2UL,
   ENUM_INI_NOPOUT_CMD = 0x3UL,
   ENUM_INI_RD_CMD = 0x5UL,
   ENUM_TGT_CTX_UPDT_CMD = 0x7UL,
   ENUM_TGT_STS_CMD = 0x8UL,
   ENUM_TGT_DATAIN_CMD = 0x9UL,
   ENUM_TGT_SOS_PDU = 0xaUL,
   ENUM_TGT_DM_CMD = 0xbUL
} ISCSI_WRB_OPCODE;

// --- ISCSI_REQ_TYPE ---
// ISCSI_REQ_TYPE opcode/type. These enums are used for the type field in the iSCSI
// context for the EP to determine the kind of processing that has to be done. This is a
// superset of ISCSI_WRB_OPCODE enums 
#define R2T_SIG                         (0)       // signature for R2T to identify type of
                                                  // data structure auto-fetched by
                                                  // scheduler
#define WR_CMD                          (1)       // Initiator write command
#define TMF_CMD                         (2)       // Initiator TMF command
#define NOPOUT_CMD                      (3)       // Initiator; Send a NOP-OUT
#define R2T_DATA                        (4)       // Initiator requesting to send data in
                                                  // response to R2T received from target
#define RD_CMD                          (5)       // Initiator requesting to send a read
                                                  // command
#define UNSOL_DATA                      (6)       // Initiator: Used internally by fw to
                                                  // indicate unsoliceted data
#define CTX_UPDT_CMD                    (7)       // Target context update
#define STS_CMD                         (8)       // Target R2T and other BHS where only
                                                  // the status number need to be updated
#define DATAIN_CMD                      (9)       // Target Data-Ins in response to read
                                                  // command
#define SOS_PDU                         (10)      // Target: stand alone status response
#define DM_CMD                          (11)      // Indicates that the bhs prepared by
                                                  // driver should not be touched
#define LDM_CMD                         (12)      // Indicates login resp, no digest
                                                  // should be inserted, statsn should not
                                                  // be modified.

typedef enum {
   ENUM_R2T_SIG = 0x0UL,
   ENUM_WR_CMD = 0x1UL,
   ENUM_TMF_CMD = 0x2UL,
   ENUM_NOPOUT_CMD = 0x3UL,
   ENUM_R2T_DATA = 0x4UL,
   ENUM_RD_CMD = 0x5UL,
   ENUM_UNSOL_DATA = 0x6UL,
   ENUM_CTX_UPDT_CMD = 0x7UL,
   ENUM_STS_CMD = 0x8UL,
   ENUM_DATAIN_CMD = 0x9UL,
   ENUM_SOS_PDU = 0xaUL,
   ENUM_DM_CMD = 0xbUL,
   ENUM_LDM_CMD = 0xcUL
} ISCSI_REQ_TYPE;

// --- ISCSI_DIF_BLK_SIZE ---
// All the supported DIF block sizes.
#define BS_512_BYTES                    (0)       // Block size of 512 bytes
#define BS_1024_BYTES                   (1)       // Block size of 1024 bytes
#define BS_4096_BYTES                   (2)       // Block size of 4096 bytes

typedef enum {
   ENUM_BS_512_BYTES = 0x0UL,
   ENUM_BS_1024_BYTES = 0x1UL,
   ENUM_BS_4096_BYTES = 0x2UL
} ISCSI_DIF_BLK_SIZE;

// --- ISCSI_DIF_MODES ---
// All the supported DIF modes.
#define ISCSI_DIF_NONE                  (0)       // DIF disabled
#define ISCSI_DIF_COMPARE               (1)       // Verify and pass through the 8-byte
                                                  // DIF
#define ISCSI_DIF_DELETE                (2)       // Verify and remove the 8-byte DIF from
                                                  // the data stream
#define ISCSI_DIF_INSERT                (3)       // Insert the 8-byte DIF in the data
                                                  // stream

typedef enum {
   ENUM_ISCSI_DIF_NONE = 0x0UL,
   ENUM_ISCSI_DIF_COMPARE = 0x1UL,
   ENUM_ISCSI_DIF_DELETE = 0x2UL,
   ENUM_ISCSI_DIF_INSERT = 0x3UL
} ISCSI_DIF_MODES;

// --- ICD_OPCODE ---
// Deprecate
#define ICD_OPCODE_READ                 (0)       // Read command, expect to receive data
#define ICD_OPCODE_WRITE                (1)       // Write command, expect to transfer
                                                  // data

typedef enum {
   ENUM_ICD_OPCODE_READ = 0x0UL,
   ENUM_ICD_OPCODE_WRITE = 0x1UL
} ICD_OPCODE;

#endif // __iscsi_enums_enum_h__

