/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __jellm_enum_h__
#define __jellm_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- JELLM_ALLOC_ENUM ---
// Encodings for Allocate state machine within JELLM.
#define JELLM_ST_ALLOC_IDLE             (0)       // Idle state
#define JELLM_ST_ALLOC_LATCH_REQ        (1)       // Latch Allocate Request state
#define JELLM_ST_ALLOC_HT_REQ           (2)       // Issue request to CTX for head/tail
                                                  // pointers
#define JELLM_ST_ALLOC_HT_FETCH         (3)       // Retrieve JE_head/JE_tail pointers
                                                  // from CTX
#define JELLM_ST_ALLOC_HT_EXTRACT       (4)       // Extract JE_head/JE_tail from returned
                                                  // CTX data
#define JELLM_ST_ALLOC_OLD_TJW_REQ      (5)       // Issue request to CTX to write old
                                                  // tail JELLE
#define JELLM_ST_ALLOC_OLD_TJW_DATA0    (6)       // Write old tail JELLE to CTX
#define JELLM_ST_ALLOC_OLD_TJW_DATA1    (7)       // Write old tail JELLE to CTX
#define JELLM_ST_ALLOC_NEW_TJ_REQ       (8)       // Read new tail JELLE from CTX
#define JELLM_ST_ALLOC_NEW_TJ_FETCH     (9)       // Retrieve new tail JELLE from CTX
#define JELLM_ST_ALLOC_NEW_TJ_EXTRACT   (10)      // Extract new tail JELLE from CTX
#define JELLM_ST_ALLOC_NEW_TJW_REQ      (11)      // Issue request to CTX to write new
                                                  // tail JELLE
#define JELLM_ST_ALLOC_NEW_TJW_DATA0    (12)      // Write new tail JELLE to CTX
#define JELLM_ST_ALLOC_NEW_TJW_DATA1    (13)      // Write new tail JELLE to CTX
#define JELLM_ST_ALLOC_HTW_REQ          (14)      // Issue request to CTX to write new
                                                  // head/tail pointers
#define JELLM_ST_ALLOC_HTW_DATA0        (15)      // Write new head/tail pointers to CTX
#define JELLM_ST_ALLOC_HTW_DATA1        (16)      // Write new head/tail pointers to CTX
#define JELLM_ST_ALLOC_DELIVER1         (17)      // Deliver Allocate result to client
                                                  // RISC - request phase
#define JELLM_ST_ALLOC_DELIVER2         (18)      // Deliver Allocate result to client
                                                  // RISC - data phase

typedef enum {
   ENUM_JELLM_ST_ALLOC_IDLE = 0x0UL,
   ENUM_JELLM_ST_ALLOC_LATCH_REQ = 0x1UL,
   ENUM_JELLM_ST_ALLOC_HT_REQ = 0x2UL,
   ENUM_JELLM_ST_ALLOC_HT_FETCH = 0x3UL,
   ENUM_JELLM_ST_ALLOC_HT_EXTRACT = 0x4UL,
   ENUM_JELLM_ST_ALLOC_OLD_TJW_REQ = 0x5UL,
   ENUM_JELLM_ST_ALLOC_OLD_TJW_DATA0 = 0x6UL,
   ENUM_JELLM_ST_ALLOC_OLD_TJW_DATA1 = 0x7UL,
   ENUM_JELLM_ST_ALLOC_NEW_TJ_REQ = 0x8UL,
   ENUM_JELLM_ST_ALLOC_NEW_TJ_FETCH = 0x9UL,
   ENUM_JELLM_ST_ALLOC_NEW_TJ_EXTRACT = 0xaUL,
   ENUM_JELLM_ST_ALLOC_NEW_TJW_REQ = 0xbUL,
   ENUM_JELLM_ST_ALLOC_NEW_TJW_DATA0 = 0xcUL,
   ENUM_JELLM_ST_ALLOC_NEW_TJW_DATA1 = 0xdUL,
   ENUM_JELLM_ST_ALLOC_HTW_REQ = 0xeUL,
   ENUM_JELLM_ST_ALLOC_HTW_DATA0 = 0xfUL,
   ENUM_JELLM_ST_ALLOC_HTW_DATA1 = 0x10UL,
   ENUM_JELLM_ST_ALLOC_DELIVER1 = 0x11UL,
   ENUM_JELLM_ST_ALLOC_DELIVER2 = 0x12UL
} JELLM_ALLOC_ENUM;

// --- JELLM_DEALLOC_ENUM ---
// Encodings for De-allocate state machine within JELLM.
#define JELLM_ST_DEALLOC_IDLE           (0)       // Quiescent state
#define JELLM_ST_DEALLOC_CID_RD_REQ     (1)       // Request CTX to fetch De-allocate CID
                                                  // context
#define JELLM_ST_DEALLOC_CID_FETCH      (2)       // Fetch De-allocate CID context from
                                                  // CTX.
#define JELLM_ST_DEALLOC_EXTRACT        (3)       // Extract JE_head, Deallocate_bytecnt
                                                  // from CID context
#define JELLM_ST_DEALLOC_JELLE_RD_REQ   (4)       // Request CTX to fetch JELLE
#define JELLM_ST_DEALLOC_JELLE_FETCH    (5)       // Fetch JELLE from CTX
#define JELLM_ST_DEALLOC_JELLE_COMPARE  (6)       // Examine JELLE content
#define JELLM_ST_DEALLOC_JELLE_WR_REQ   (7)       // Request CTX to write JELLE
#define JELLM_ST_DEALLOC_JELLE_WR_DATA0 (8)       // Deliver JELLE to CTX
#define JELLM_ST_DEALLOC_JELLE_WR_DATA1 (9)       // Deliver JELLE to CTX
#define JELLM_ST_DEALLOC_CID_WR_REQ     (10)      // Request CTX to write De-allocate CID
                                                  // context
#define JELLM_ST_DEALLOC_CID_WR_DATA0   (11)      // Update CID De-allocate context
#define JELLM_ST_DEALLOC_CID_WR_DATA1   (12)      // Update CID De-allocate context

typedef enum {
   ENUM_JELLM_ST_DEALLOC_IDLE = 0x0UL,
   ENUM_JELLM_ST_DEALLOC_CID_RD_REQ = 0x1UL,
   ENUM_JELLM_ST_DEALLOC_CID_FETCH = 0x2UL,
   ENUM_JELLM_ST_DEALLOC_EXTRACT = 0x3UL,
   ENUM_JELLM_ST_DEALLOC_JELLE_RD_REQ = 0x4UL,
   ENUM_JELLM_ST_DEALLOC_JELLE_FETCH = 0x5UL,
   ENUM_JELLM_ST_DEALLOC_JELLE_COMPARE = 0x6UL,
   ENUM_JELLM_ST_DEALLOC_JELLE_WR_REQ = 0x7UL,
   ENUM_JELLM_ST_DEALLOC_JELLE_WR_DATA0 = 0x8UL,
   ENUM_JELLM_ST_DEALLOC_JELLE_WR_DATA1 = 0x9UL,
   ENUM_JELLM_ST_DEALLOC_CID_WR_REQ = 0xaUL,
   ENUM_JELLM_ST_DEALLOC_CID_WR_DATA0 = 0xbUL,
   ENUM_JELLM_ST_DEALLOC_CID_WR_DATA1 = 0xcUL
} JELLM_DEALLOC_ENUM;

#endif // __jellm_enum_h__

