/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __pq_enum_h__
#define __pq_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- PQ_ID_ENUM ---
// Defines all the PQs on the chip. The naming convention is [from module]'_'[to module].
#define PQ_NULL                         (0)       // Null PQ
#define PQ_CONTEXT_READ                 (1)       // No Description
#define PQ_RXPP_ETHRX                   (2)       // From RXPP to Ethernet RX
#define PQ_ETHRX_RDDMA                  (3)       // From Ethernet rx to read dma
#define PQ_ETHRX_WRDMA                  (4)       // From Ethernet rx to write dma
#define PQ_TXAS_RDDMA                   (5)       // from tx assembler to read dma
#define PQ_ETHTX_TXAS_C                 (6)       // from Ethernet tx to tx assembler,
                                                  // commands
#define PQ_ETHTX_TXAS_D                 (7)       // from Ethernet tx to tx assembler,
                                                  // data
#define PQ_SCH_ETHTX                    (8)       // from transport scheduler to Ethernet
                                                  // tx
#define PQ_COP_SCH                      (9)       // from command processor to transport
                                                  // scheduler
#define PQ_RXPP_TCPRX                   (10)      // from rxpp to tcp rx
#define PQ_RXPP_ISCSIRX                 (11)      // from rxpp to iscsi rx
#define PQ_RXPP_RDMARX                  (12)      // from rxpp to rdma rx
#define PQ_ETHTX_RDDMA                  (13)      // from Ethernet tx to read dma
#define PQ_RDDMA_ETHTX                  (14)      // from read dma to Ethernet tx
#define PQ_RDDMA_TXAS                   (15)      // from read dma to tx assembler
#define PQ_PTC_RDDMA                    (16)      // From PTC to Read DMA
#define PQ_RDDMA_PTC                    (17)      // From Read DMA to PTC
#define PQ_TXPP_RDDMA                   (18)      // From tx packet processor to read DMA.
#define PQ_RDDMA_TXPP                   (19)      // From read DMA to TX packet processor
                                                  // -- DMA completion.
#define PQ_UC_PTC                       (20)      // From UC module to the PTC module
#define PQ_PTC_UC                       (21)      // From PTC module to the UC module
#define PQ_RXULP0_UC                    (22)      // From RX ULP 0 to the UC module
#define PQ_RXULP1_UC                    (23)      // From RX ULP 1 to the UC module
#define PQ_RXULP2_UC                    (24)      // From RX ULP 2 to the UC module
#define PQ_TXULP0_UC                    (25)      // From TX ULP 0 to the UC module
#define PQ_TXULP1_UC                    (26)      // From TX ULP 1 to the UC module
#define PQ_ETX_UC                       (27)      // From Ethernet TX to the UC module
#define PQ_ERX_UC                       (28)      // From Ethernet RX to the UC module
#define PQ_CAE_UC                       (29)      // From the completion and event
                                                  // processor to the UC
#define PQ_RDDMA_UC                     (30)      // From the Read DMA to UC
#define PQ_WRDMA_UC                     (31)      // From Write DMA to UC
#define PQ_UC_RXULP0                    (32)      // From UC To RXULP0
#define PQ_UC_RXULP1                    (33)      // From UC to RXULP1
#define PQ_UC_RXULP2                    (34)      // From UC to RXULP2
#define PQ_UC_TXULP0                    (35)      // From UC to TXULP0
#define PQ_UC_TXULP1                    (36)      // From UC to TXULP1
#define PQ_UC_ETX                       (37)      // From UC to ETX
#define PQ_UC_ERX                       (38)      // From UC To ERX
#define PQ_UC_CAE                       (39)      // From UC to Completion event processor
#define PQ_UC_RDDMA                     (40)      // From UC to RDDMA
#define PQ_UC_WRDMA                     (41)      // From UC to WRDMA
#define PQ_CAE_WRDMA                    (42)      // From completion and event processor
                                                  // to WRDMA
#define PQ_WRDMA_CAE                    (43)      // From WRDMA to completion and event
                                                  // processor
#define PQ_TXPP_CAE                     (44)      // From TXPP to completion and event
                                                  // processor
#define PQ_JM_WRDMA                     (45)      // From Journal Module to write DMA.
#define PQ_WRDMA_JM                     (46)      // From write DMA to journal module.
#define PQ_DMA_UC_FRAG                  (47)      // From DMA to UC module for reading
                                                  // frags out of UC.
#define PQ_UC_DMA_FRAG                  (48)      // From UC to DMA module for responses
                                                  // for frag requests out of UC.
#define PQ_RDDMA_ETHRX                  (49)      // From read dma to ethrx
#define PQ_WRDMA_ETHRX                  (50)      // From write dma to eth rx
#define PQ_ETHRX_CAE                    (51)      // From ethrx to completion and event
                                                  // processor
#define PQ_ID_COUNT                     (52)      // No Description 

typedef enum {
   ENUM_PQ_NULL = 0x0UL,
   ENUM_PQ_CONTEXT_READ = 0x1UL,
   ENUM_PQ_RXPP_ETHRX = 0x2UL,
   ENUM_PQ_ETHRX_RDDMA = 0x3UL,
   ENUM_PQ_ETHRX_WRDMA = 0x4UL,
   ENUM_PQ_TXAS_RDDMA = 0x5UL,
   ENUM_PQ_ETHTX_TXAS_C = 0x6UL,
   ENUM_PQ_ETHTX_TXAS_D = 0x7UL,
   ENUM_PQ_SCH_ETHTX = 0x8UL,
   ENUM_PQ_COP_SCH = 0x9UL,
   ENUM_PQ_RXPP_TCPRX = 0xaUL,
   ENUM_PQ_RXPP_ISCSIRX = 0xbUL,
   ENUM_PQ_RXPP_RDMARX = 0xcUL,
   ENUM_PQ_ETHTX_RDDMA = 0xdUL,
   ENUM_PQ_RDDMA_ETHTX = 0xeUL,
   ENUM_PQ_RDDMA_TXAS = 0xfUL,
   ENUM_PQ_PTC_RDDMA = 0x10UL,
   ENUM_PQ_RDDMA_PTC = 0x11UL,
   ENUM_PQ_TXPP_RDDMA = 0x12UL,
   ENUM_PQ_RDDMA_TXPP = 0x13UL,
   ENUM_PQ_UC_PTC = 0x14UL,
   ENUM_PQ_PTC_UC = 0x15UL,
   ENUM_PQ_RXULP0_UC = 0x16UL,
   ENUM_PQ_RXULP1_UC = 0x17UL,
   ENUM_PQ_RXULP2_UC = 0x18UL,
   ENUM_PQ_TXULP0_UC = 0x19UL,
   ENUM_PQ_TXULP1_UC = 0x1aUL,
   ENUM_PQ_ETX_UC = 0x1bUL,
   ENUM_PQ_ERX_UC = 0x1cUL,
   ENUM_PQ_CAE_UC = 0x1dUL,
   ENUM_PQ_RDDMA_UC = 0x1eUL,
   ENUM_PQ_WRDMA_UC = 0x1fUL,
   ENUM_PQ_UC_RXULP0 = 0x20UL,
   ENUM_PQ_UC_RXULP1 = 0x21UL,
   ENUM_PQ_UC_RXULP2 = 0x22UL,
   ENUM_PQ_UC_TXULP0 = 0x23UL,
   ENUM_PQ_UC_TXULP1 = 0x24UL,
   ENUM_PQ_UC_ETX = 0x25UL,
   ENUM_PQ_UC_ERX = 0x26UL,
   ENUM_PQ_UC_CAE = 0x27UL,
   ENUM_PQ_UC_RDDMA = 0x28UL,
   ENUM_PQ_UC_WRDMA = 0x29UL,
   ENUM_PQ_CAE_WRDMA = 0x2aUL,
   ENUM_PQ_WRDMA_CAE = 0x2bUL,
   ENUM_PQ_TXPP_CAE = 0x2cUL,
   ENUM_PQ_JM_WRDMA = 0x2dUL,
   ENUM_PQ_WRDMA_JM = 0x2eUL,
   ENUM_PQ_DMA_UC_FRAG = 0x2fUL,
   ENUM_PQ_UC_DMA_FRAG = 0x30UL,
   ENUM_PQ_RDDMA_ETHRX = 0x31UL,
   ENUM_PQ_WRDMA_ETHRX = 0x32UL,
   ENUM_PQ_ETHRX_CAE = 0x33UL,
   ENUM_PQ_ID_COUNT = 0x34UL
} PQ_ID_ENUM;

#endif // __pq_enum_h__

