/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __reg_enums_enum_h__
#define __reg_enums_enum_h__
#include "setypes.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- STALLARC_ENUM ---
// Encodings for StallArc field, placed in UC_REQ_D Descriptor by UC clients. Used to
// stall requests at a specific PQ in the UC,PTC,RDMA,WDMA sub-chip (a debug feature)
#define STALLARC_NO_STALL               (0)       // No stall
#define STALLARC_UC_WDMA                (1)       // Stall request at UC-WDMA request PQ
#define STALLARC_WDMA_UC                (2)       // Stall request at WDMA-UC response PQ
#define STALLARC_UC_PTC                 (3)       // Stall request at UC-PTC request PQ
#define STALLARC_PTC_RDMA               (4)       // Stall request at PTC-RDMA request PQ
#define STALLARC_RDMA_PTC               (5)       // Stall request at RDMA-PTC response PQ
#define STALLARC_PTC_UC                 (6)       // Stall request at PTC-UC response PQ
#define STALLARC_UC_RDMA                (7)       // Stall request at UC-RDMA request PQ
#define STALLARC_RDMA_UC                (8)       // Stall request at RDMA-UC response PQ

typedef enum {
   ENUM_STALLARC_NO_STALL = 0x0UL,
   ENUM_STALLARC_UC_WDMA = 0x1UL,
   ENUM_STALLARC_WDMA_UC = 0x2UL,
   ENUM_STALLARC_UC_PTC = 0x3UL,
   ENUM_STALLARC_PTC_RDMA = 0x4UL,
   ENUM_STALLARC_RDMA_PTC = 0x5UL,
   ENUM_STALLARC_PTC_UC = 0x6UL,
   ENUM_STALLARC_UC_RDMA = 0x7UL,
   ENUM_STALLARC_RDMA_UC = 0x8UL
} STALLARC_ENUM;

#endif // __reg_enums_enum_h__

