/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   sa_status.h

@brief
   
CVS Header Information:
   $Header: /opt/be_cvsrepo/dsn.sw.host.drivers/dsn/sw/host/sa/system/sa_status.h,v 1.4 2005/08/11 19:21:21 menz Exp $
*/
#ifndef __sa_status_h__
#define __sa_status_h__

#include "sa_types.h"

SA_CPP_HEADER

// Status code datatype
typedef i32 SA_STATUS, *PSA_STATUS;

// Error codes
#define SA_STATUS_SUCCESS             (0x00000000L)
#define SA_SUCCESS                    SA_STATUS_SUCCESS // abbreviation

#define SA_STATUS_PENDING             (0x20070001L)
#define SA_STATUS_NOT_OK              (0xE0070002L)
#define SA_NOT_OK                     SA_STATUS_NOT_OK  // abbreviation
#define SA_STATUS_NO_SYSTEM_RESOURCES (0xE0070003L)
#define SA_STATUS_NO_CHIP_RESOURCES   (0xE0070004L)
#define SA_STATUS_BUSY                (0xE0070006L)

#define SA_STATUS_INVALID_PARAMETER   (0xE0000007L)
#define SA_STATUS_INVALID_ADDRESS     (0xE000000CL)
#define SA_STATUS_NOT_SUPPORTED       (0xE000000DL)

#define SA_STATUS_ACCESS_DENIED       (0xE000000EL)

#define SA_STATUS_TIMEOUT             (0xE000100FL)
#define SA_STATUS_ALERTED             (0xE0001010L)



SA_CPP_TRAILER
#endif // __sa_status_h__

