/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __cev_bmap_h__
#define __cev_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pq_bmap.h"
#include "ep_bmap.h"
#include "txulp_bmap.h"
#include "reg_enums_bmap.h"
#include "gencommon_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Completion Queue Context Table Entry. Contains the state of a CQ. Located in RAM
   // within the CEV block.
   #if defined(SG_BMAP_UNION)
      typedef struct _CQ_CONTEXT {
         union {
            struct { 
               u32 Eventable : 1;                 // DWORD 0
               u32 SolEvent : 1;                  // DWORD 0
               u32 valid : 1;                     // DWORD 0
               u32 Count : 2;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 EPIdx : 11;                    // DWORD 0
               u32 NoDelay : 1;                   // DWORD 0
               u32 CoalescWM : 2;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 Cidx : 11;                     // DWORD 0
               u32 Armed : 1;                     // DWORD 1
               u32 Stalled : 1;                   // DWORD 1
               u32 EQID : 8;                      // DWORD 1
               u32 PD : 10;                       // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 Pidx : 11;                     // DWORD 1
               u32 rsvd4 : 20;                    // DWORD 2
               u32 Func : 8;                      // DWORD 2
               u32 rsvd3 : 4;                     // DWORD 2
               u32 rsvd5[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK CQ_CONTEXT, *PCQ_CONTEXT;

      SG_C_ASSERT(__sizeof__CQ_CONTEXT, sizeof (CQ_CONTEXT) == 16);

   #else
      typedef struct _CQ_CONTEXT {
         u32 Eventable : 1;                       // DWORD 0
         u32 SolEvent : 1;                        // DWORD 0
         u32 valid : 1;                           // DWORD 0
         u32 Count : 2;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 EPIdx : 11;                          // DWORD 0
         u32 NoDelay : 1;                         // DWORD 0
         u32 CoalescWM : 2;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 Cidx : 11;                           // DWORD 0
         u32 Armed : 1;                           // DWORD 1
         u32 Stalled : 1;                         // DWORD 1
         u32 EQID : 8;                            // DWORD 1
         u32 PD : 10;                             // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 Pidx : 11;                           // DWORD 1
         u32 rsvd4 : 20;                          // DWORD 2
         u32 Func : 8;                            // DWORD 2
         u32 rsvd3 : 4;                           // DWORD 2
         u32 rsvd5[1];                            // DWORDS 3 to 3
      } SG_PACK CQ_CONTEXT, *PCQ_CONTEXT;

      typedef union _CQ_CONTEXT_UNION {
         CQ_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK CQ_CONTEXT_UNION, *PCQ_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__CQ_CONTEXT_UNION, sizeof (CQ_CONTEXT_UNION) == 16);
   #endif


#else
   // Completion Queue Context Table Entry. Contains the state of a CQ. Located in RAM
   // within the CEV block.
   #if defined(SG_BMAP_UNION)
      typedef struct _CQ_CONTEXT {
         union {
            struct { 
               u32 Cidx : 11;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 CoalescWM : 2;                 // DWORD 0
               u32 NoDelay : 1;                   // DWORD 0
               u32 EPIdx : 11;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 Count : 2;                     // DWORD 0
               u32 valid : 1;                     // DWORD 0
               u32 SolEvent : 1;                  // DWORD 0
               u32 Eventable : 1;                 // DWORD 0
               u32 Pidx : 11;                     // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 PD : 10;                       // DWORD 1
               u32 EQID : 8;                      // DWORD 1
               u32 Stalled : 1;                   // DWORD 1
               u32 Armed : 1;                     // DWORD 1
               u32 rsvd3 : 4;                     // DWORD 2
               u32 Func : 8;                      // DWORD 2
               u32 rsvd4 : 20;                    // DWORD 2
               u32 rsvd5[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK CQ_CONTEXT, *PCQ_CONTEXT;

      SG_C_ASSERT(__sizeof__CQ_CONTEXT, sizeof (CQ_CONTEXT) == 16);

   #else
      typedef struct _CQ_CONTEXT {
         u32 Cidx : 11;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 CoalescWM : 2;                       // DWORD 0
         u32 NoDelay : 1;                         // DWORD 0
         u32 EPIdx : 11;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 Count : 2;                           // DWORD 0
         u32 valid : 1;                           // DWORD 0
         u32 SolEvent : 1;                        // DWORD 0
         u32 Eventable : 1;                       // DWORD 0
         u32 Pidx : 11;                           // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 PD : 10;                             // DWORD 1
         u32 EQID : 8;                            // DWORD 1
         u32 Stalled : 1;                         // DWORD 1
         u32 Armed : 1;                           // DWORD 1
         u32 rsvd3 : 4;                           // DWORD 2
         u32 Func : 8;                            // DWORD 2
         u32 rsvd4 : 20;                          // DWORD 2
         u32 rsvd5[1];                            // DWORDS 3 to 3
      } SG_PACK CQ_CONTEXT, *PCQ_CONTEXT;

      typedef union _CQ_CONTEXT_UNION {
         CQ_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK CQ_CONTEXT_UNION, *PCQ_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__CQ_CONTEXT_UNION, sizeof (CQ_CONTEXT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Event Queue Context Table Entry. Contains the state of an EQ. Located in RAM in the
   // CEV block.
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_CONTEXT {
         union {
            struct { 
               u32 Size : 1;                      // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 valid : 1;                     // DWORD 0
               u32 EPIdx : 13;                    // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 Cidx : 13;                     // DWORD 0
               u32 Armed : 1;                     // DWORD 1
               u32 Stalled : 1;                   // DWORD 1
               u32 SolEvent : 1;                  // DWORD 1
               u32 Count : 3;                     // DWORD 1
               u32 PD : 10;                       // DWORD 1
               u32 rsvd2 : 3;                     // DWORD 1
               u32 Pidx : 13;                     // DWORD 1
               u32 rsvd6 : 4;                     // DWORD 2
               u32 NoDelay : 1;                   // DWORD 2
               u32 PHASE : 2;                     // DWORD 2
               u32 rsvd5 : 2;                     // DWORD 2
               u32 DelayMult : 10;                // DWORD 2
               u32 rsvd4 : 1;                     // DWORD 2
               u32 Func : 8;                      // DWORD 2
               u32 rsvd3 : 4;                     // DWORD 2
               u32 rsvd7[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK EQ_CONTEXT, *PEQ_CONTEXT;

      SG_C_ASSERT(__sizeof__EQ_CONTEXT, sizeof (EQ_CONTEXT) == 16);

   #else
      typedef struct _EQ_CONTEXT {
         u32 Size : 1;                            // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 valid : 1;                           // DWORD 0
         u32 EPIdx : 13;                          // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 Cidx : 13;                           // DWORD 0
         u32 Armed : 1;                           // DWORD 1
         u32 Stalled : 1;                         // DWORD 1
         u32 SolEvent : 1;                        // DWORD 1
         u32 Count : 3;                           // DWORD 1
         u32 PD : 10;                             // DWORD 1
         u32 rsvd2 : 3;                           // DWORD 1
         u32 Pidx : 13;                           // DWORD 1
         u32 rsvd6 : 4;                           // DWORD 2
         u32 NoDelay : 1;                         // DWORD 2
         u32 PHASE : 2;                           // DWORD 2
         u32 rsvd5 : 2;                           // DWORD 2
         u32 DelayMult : 10;                      // DWORD 2
         u32 rsvd4 : 1;                           // DWORD 2
         u32 Func : 8;                            // DWORD 2
         u32 rsvd3 : 4;                           // DWORD 2
         u32 rsvd7[1];                            // DWORDS 3 to 3
      } SG_PACK EQ_CONTEXT, *PEQ_CONTEXT;

      typedef union _EQ_CONTEXT_UNION {
         EQ_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK EQ_CONTEXT_UNION, *PEQ_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__EQ_CONTEXT_UNION, sizeof (EQ_CONTEXT_UNION) == 16);
   #endif


#else
   // Event Queue Context Table Entry. Contains the state of an EQ. Located in RAM in the
   // CEV block.
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_CONTEXT {
         union {
            struct { 
               u32 Cidx : 13;                     // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 EPIdx : 13;                    // DWORD 0
               u32 valid : 1;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 Size : 1;                      // DWORD 0
               u32 Pidx : 13;                     // DWORD 1
               u32 rsvd2 : 3;                     // DWORD 1
               u32 PD : 10;                       // DWORD 1
               u32 Count : 3;                     // DWORD 1
               u32 SolEvent : 1;                  // DWORD 1
               u32 Stalled : 1;                   // DWORD 1
               u32 Armed : 1;                     // DWORD 1
               u32 rsvd3 : 4;                     // DWORD 2
               u32 Func : 8;                      // DWORD 2
               u32 rsvd4 : 1;                     // DWORD 2
               u32 DelayMult : 10;                // DWORD 2
               u32 rsvd5 : 2;                     // DWORD 2
               u32 PHASE : 2;                     // DWORD 2
               u32 NoDelay : 1;                   // DWORD 2
               u32 rsvd6 : 4;                     // DWORD 2
               u32 rsvd7[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK EQ_CONTEXT, *PEQ_CONTEXT;

      SG_C_ASSERT(__sizeof__EQ_CONTEXT, sizeof (EQ_CONTEXT) == 16);

   #else
      typedef struct _EQ_CONTEXT {
         u32 Cidx : 13;                           // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 EPIdx : 13;                          // DWORD 0
         u32 valid : 1;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 Size : 1;                            // DWORD 0
         u32 Pidx : 13;                           // DWORD 1
         u32 rsvd2 : 3;                           // DWORD 1
         u32 PD : 10;                             // DWORD 1
         u32 Count : 3;                           // DWORD 1
         u32 SolEvent : 1;                        // DWORD 1
         u32 Stalled : 1;                         // DWORD 1
         u32 Armed : 1;                           // DWORD 1
         u32 rsvd3 : 4;                           // DWORD 2
         u32 Func : 8;                            // DWORD 2
         u32 rsvd4 : 1;                           // DWORD 2
         u32 DelayMult : 10;                      // DWORD 2
         u32 rsvd5 : 2;                           // DWORD 2
         u32 PHASE : 2;                           // DWORD 2
         u32 NoDelay : 1;                         // DWORD 2
         u32 rsvd6 : 4;                           // DWORD 2
         u32 rsvd7[1];                            // DWORDS 3 to 3
      } SG_PACK EQ_CONTEXT, *PEQ_CONTEXT;

      typedef union _EQ_CONTEXT_UNION {
         EQ_CONTEXT bits;
         u32 dw[4]; // dword union
      } SG_PACK EQ_CONTEXT_UNION, *PEQ_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__EQ_CONTEXT_UNION, sizeof (EQ_CONTEXT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Control Register. Used for misc. control functions.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CTL_CSR {
         union {
            struct { 
               u32 rsvd2 : 2;                     // DWORD 0
               u32 Swap : 2;                      // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 PTCReqLimit : 3;               // DWORD 0
               u32 WDMAReqLimit : 4;              // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 QueueOvEn : 1;                 // DWORD 0
               u32 StallArc : 4;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CTL_CSR, *PCEV_CTL_CSR;

      SG_C_ASSERT(__sizeof__CEV_CTL_CSR, sizeof (CEV_CTL_CSR) == 4);

   #else
      typedef struct _CEV_CTL_CSR {
         u32 rsvd2 : 2;                           // DWORD 0
         u32 Swap : 2;                            // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 PTCReqLimit : 3;                     // DWORD 0
         u32 WDMAReqLimit : 4;                    // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 QueueOvEn : 1;                       // DWORD 0
         u32 StallArc : 4;                        // DWORD 0
      } SG_PACK CEV_CTL_CSR, *PCEV_CTL_CSR;

      typedef union _CEV_CTL_CSR_UNION {
         CEV_CTL_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_CTL_CSR_UNION, *PCEV_CTL_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_CTL_CSR_UNION, sizeof (CEV_CTL_CSR_UNION) == 4);
   #endif


#else
   // CEV Control Register. Used for misc. control functions.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CTL_CSR {
         union {
            struct { 
               u32 StallArc : 4;                  // DWORD 0
               u32 QueueOvEn : 1;                 // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 WDMAReqLimit : 4;              // DWORD 0
               u32 PTCReqLimit : 3;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 Swap : 2;                      // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CTL_CSR, *PCEV_CTL_CSR;

      SG_C_ASSERT(__sizeof__CEV_CTL_CSR, sizeof (CEV_CTL_CSR) == 4);

   #else
      typedef struct _CEV_CTL_CSR {
         u32 StallArc : 4;                        // DWORD 0
         u32 QueueOvEn : 1;                       // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 WDMAReqLimit : 4;                    // DWORD 0
         u32 PTCReqLimit : 3;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 Swap : 2;                            // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
      } SG_PACK CEV_CTL_CSR, *PCEV_CTL_CSR;

      typedef union _CEV_CTL_CSR_UNION {
         CEV_CTL_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_CTL_CSR_UNION, *PCEV_CTL_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_CTL_CSR_UNION, sizeof (CEV_CTL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV function 0 interrupt vectors timer delay register. This register defines the
   // timer delay for function 0 MSI-X/INTa vectors in units of 6.56us.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_MAX_SUST_INT_DLY_CNT_CSR {
         union {
            struct { 
               u32 MAX_CSR_STROLL : 7;            // DWORD 0
               u32 ENABLE_LKY_BUCKET : 1;         // DWORD 0
               u32 BUCKET_CREDIT : 8;             // DWORD 0
               u32 PHASE_RESET : 1;               // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_MAX_SUST_INT_DLY_CNT_CSR, *PCEV_MAX_SUST_INT_DLY_CNT_CSR;

      SG_C_ASSERT(__sizeof__CEV_MAX_SUST_INT_DLY_CNT_CSR, sizeof (CEV_MAX_SUST_INT_DLY_CNT_CSR) == 4);

   #else
      typedef struct _CEV_MAX_SUST_INT_DLY_CNT_CSR {
         u32 MAX_CSR_STROLL : 7;                  // DWORD 0
         u32 ENABLE_LKY_BUCKET : 1;               // DWORD 0
         u32 BUCKET_CREDIT : 8;                   // DWORD 0
         u32 PHASE_RESET : 1;                     // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
      } SG_PACK CEV_MAX_SUST_INT_DLY_CNT_CSR, *PCEV_MAX_SUST_INT_DLY_CNT_CSR;

      typedef union _CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION {
         CEV_MAX_SUST_INT_DLY_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION, *PCEV_MAX_SUST_INT_DLY_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION, sizeof (CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION) == 4);
   #endif


#else
   // CEV function 0 interrupt vectors timer delay register. This register defines the
   // timer delay for function 0 MSI-X/INTa vectors in units of 6.56us.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_MAX_SUST_INT_DLY_CNT_CSR {
         union {
            struct { 
               u32 rsvd0 : 15;                    // DWORD 0
               u32 PHASE_RESET : 1;               // DWORD 0
               u32 BUCKET_CREDIT : 8;             // DWORD 0
               u32 ENABLE_LKY_BUCKET : 1;         // DWORD 0
               u32 MAX_CSR_STROLL : 7;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_MAX_SUST_INT_DLY_CNT_CSR, *PCEV_MAX_SUST_INT_DLY_CNT_CSR;

      SG_C_ASSERT(__sizeof__CEV_MAX_SUST_INT_DLY_CNT_CSR, sizeof (CEV_MAX_SUST_INT_DLY_CNT_CSR) == 4);

   #else
      typedef struct _CEV_MAX_SUST_INT_DLY_CNT_CSR {
         u32 rsvd0 : 15;                          // DWORD 0
         u32 PHASE_RESET : 1;                     // DWORD 0
         u32 BUCKET_CREDIT : 8;                   // DWORD 0
         u32 ENABLE_LKY_BUCKET : 1;               // DWORD 0
         u32 MAX_CSR_STROLL : 7;                  // DWORD 0
      } SG_PACK CEV_MAX_SUST_INT_DLY_CNT_CSR, *PCEV_MAX_SUST_INT_DLY_CNT_CSR;

      typedef union _CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION {
         CEV_MAX_SUST_INT_DLY_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION, *PCEV_MAX_SUST_INT_DLY_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION, sizeof (CEV_MAX_SUST_INT_DLY_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV internal CQ/EQ context memory address register. This register is used to access
   // CQ or EQ memory within CEV. Software programs the CEV internal context memory
   // address into this register when it wishes to read or write the context. The
   // accompanying context data value is in the CEV_CTX_DATA_CSR register. Note that this
   // register auto-increments by four (bytes). every time the accompanying
   // CEV_CTX_DATA_CSR register is read or written by software, to make burst-mode access
   // more efficient.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CTX_ADDR_CSR {
         union {
            struct { 
               u32 rsvd0 : 17;                    // DWORD 0
               u32 ctx_addr : 15;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CTX_ADDR_CSR, *PCEV_CTX_ADDR_CSR;

      SG_C_ASSERT(__sizeof__CEV_CTX_ADDR_CSR, sizeof (CEV_CTX_ADDR_CSR) == 4);

   #else
      typedef struct _CEV_CTX_ADDR_CSR {
         u32 rsvd0 : 17;                          // DWORD 0
         u32 ctx_addr : 15;                       // DWORD 0
      } SG_PACK CEV_CTX_ADDR_CSR, *PCEV_CTX_ADDR_CSR;

      typedef union _CEV_CTX_ADDR_CSR_UNION {
         CEV_CTX_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_CTX_ADDR_CSR_UNION, *PCEV_CTX_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_CTX_ADDR_CSR_UNION, sizeof (CEV_CTX_ADDR_CSR_UNION) == 4);
   #endif


#else
   // CEV internal CQ/EQ context memory address register. This register is used to access
   // CQ or EQ memory within CEV. Software programs the CEV internal context memory
   // address into this register when it wishes to read or write the context. The
   // accompanying context data value is in the CEV_CTX_DATA_CSR register. Note that this
   // register auto-increments by four (bytes). every time the accompanying
   // CEV_CTX_DATA_CSR register is read or written by software, to make burst-mode access
   // more efficient.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CTX_ADDR_CSR {
         union {
            struct { 
               u32 ctx_addr : 15;                 // DWORD 0
               u32 rsvd0 : 17;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CTX_ADDR_CSR, *PCEV_CTX_ADDR_CSR;

      SG_C_ASSERT(__sizeof__CEV_CTX_ADDR_CSR, sizeof (CEV_CTX_ADDR_CSR) == 4);

   #else
      typedef struct _CEV_CTX_ADDR_CSR {
         u32 ctx_addr : 15;                       // DWORD 0
         u32 rsvd0 : 17;                          // DWORD 0
      } SG_PACK CEV_CTX_ADDR_CSR, *PCEV_CTX_ADDR_CSR;

      typedef union _CEV_CTX_ADDR_CSR_UNION {
         CEV_CTX_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_CTX_ADDR_CSR_UNION, *PCEV_CTX_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_CTX_ADDR_CSR_UNION, sizeof (CEV_CTX_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV internal CQ/EQ context memory indirect access data register. This register is
   // used to access CEV internal CQ or EQ memory. Software programs the CEV internal
   // context memory data value into this register when it wishes to write the context. It
   // reads this register when it wishes to read the CEV internal context memory data
   // value. The accompanying context address is in the CEV_CTX_ADDR_CSR. Note that writes
   // or reads of this data register auto-increments the ctx_addr field of accompanying
   // register CEV_CTX_ADDR_CSR. Note also that even though this hardware register is
   // cleared at reset, a read of it will return ambiguous data if the associated SRAM
   // location is not initialized.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CTX_DATA_CSR {
         union {
            struct { 
               u32 ctx_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CTX_DATA_CSR, *PCEV_CTX_DATA_CSR;

      SG_C_ASSERT(__sizeof__CEV_CTX_DATA_CSR, sizeof (CEV_CTX_DATA_CSR) == 4);

   #else
      typedef struct _CEV_CTX_DATA_CSR {
         u32 ctx_data;                            // DWORD 0
      } SG_PACK CEV_CTX_DATA_CSR, *PCEV_CTX_DATA_CSR;

      typedef union _CEV_CTX_DATA_CSR_UNION {
         CEV_CTX_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_CTX_DATA_CSR_UNION, *PCEV_CTX_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_CTX_DATA_CSR_UNION, sizeof (CEV_CTX_DATA_CSR_UNION) == 4);
   #endif


#else
   // CEV internal CQ/EQ context memory indirect access data register. This register is
   // used to access CEV internal CQ or EQ memory. Software programs the CEV internal
   // context memory data value into this register when it wishes to write the context. It
   // reads this register when it wishes to read the CEV internal context memory data
   // value. The accompanying context address is in the CEV_CTX_ADDR_CSR. Note that writes
   // or reads of this data register auto-increments the ctx_addr field of accompanying
   // register CEV_CTX_ADDR_CSR. Note also that even though this hardware register is
   // cleared at reset, a read of it will return ambiguous data if the associated SRAM
   // location is not initialized.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CTX_DATA_CSR {
         union {
            struct { 
               u32 ctx_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CTX_DATA_CSR, *PCEV_CTX_DATA_CSR;

      SG_C_ASSERT(__sizeof__CEV_CTX_DATA_CSR, sizeof (CEV_CTX_DATA_CSR) == 4);

   #else
      typedef struct _CEV_CTX_DATA_CSR {
         u32 ctx_data;                            // DWORD 0
      } SG_PACK CEV_CTX_DATA_CSR, *PCEV_CTX_DATA_CSR;

      typedef union _CEV_CTX_DATA_CSR_UNION {
         CEV_CTX_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_CTX_DATA_CSR_UNION, *PCEV_CTX_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_CTX_DATA_CSR_UNION, sizeof (CEV_CTX_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV CQE Coalescing threshold/watermark configuration register. This register is used
   // to configure three different values for cqe coalescing threshold. The threshold
   // specify the number of CQEs pending at host before coalescing starts. CQE coalescing
   // threshold can be set ranging from 1 to 256.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CSR_COALESCWM_CFG {
         union {
            struct { 
               u32 coalesc_wm3 : 8;               // DWORD 0
               u32 coalesc_wm2 : 8;               // DWORD 0
               u32 coalesc_wm1 : 8;               // DWORD 0
               u32 coalesc_wm0 : 8;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CSR_COALESCWM_CFG, *PCEV_CSR_COALESCWM_CFG;

      SG_C_ASSERT(__sizeof__CEV_CSR_COALESCWM_CFG, sizeof (CEV_CSR_COALESCWM_CFG) == 4);

   #else
      typedef struct _CEV_CSR_COALESCWM_CFG {
         u32 coalesc_wm3 : 8;                     // DWORD 0
         u32 coalesc_wm2 : 8;                     // DWORD 0
         u32 coalesc_wm1 : 8;                     // DWORD 0
         u32 coalesc_wm0 : 8;                     // DWORD 0
      } SG_PACK CEV_CSR_COALESCWM_CFG, *PCEV_CSR_COALESCWM_CFG;

      typedef union _CEV_CSR_COALESCWM_CFG_UNION {
         CEV_CSR_COALESCWM_CFG bits;
         u32 dw; // dword union
      } SG_PACK CEV_CSR_COALESCWM_CFG_UNION, *PCEV_CSR_COALESCWM_CFG_UNION;

      SG_C_ASSERT(__sizeof__CEV_CSR_COALESCWM_CFG_UNION, sizeof (CEV_CSR_COALESCWM_CFG_UNION) == 4);
   #endif


#else
   // CEV CQE Coalescing threshold/watermark configuration register. This register is used
   // to configure three different values for cqe coalescing threshold. The threshold
   // specify the number of CQEs pending at host before coalescing starts. CQE coalescing
   // threshold can be set ranging from 1 to 256.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CSR_COALESCWM_CFG {
         union {
            struct { 
               u32 coalesc_wm0 : 8;               // DWORD 0
               u32 coalesc_wm1 : 8;               // DWORD 0
               u32 coalesc_wm2 : 8;               // DWORD 0
               u32 coalesc_wm3 : 8;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_CSR_COALESCWM_CFG, *PCEV_CSR_COALESCWM_CFG;

      SG_C_ASSERT(__sizeof__CEV_CSR_COALESCWM_CFG, sizeof (CEV_CSR_COALESCWM_CFG) == 4);

   #else
      typedef struct _CEV_CSR_COALESCWM_CFG {
         u32 coalesc_wm0 : 8;                     // DWORD 0
         u32 coalesc_wm1 : 8;                     // DWORD 0
         u32 coalesc_wm2 : 8;                     // DWORD 0
         u32 coalesc_wm3 : 8;                     // DWORD 0
      } SG_PACK CEV_CSR_COALESCWM_CFG, *PCEV_CSR_COALESCWM_CFG;

      typedef union _CEV_CSR_COALESCWM_CFG_UNION {
         CEV_CSR_COALESCWM_CFG bits;
         u32 dw; // dword union
      } SG_PACK CEV_CSR_COALESCWM_CFG_UNION, *PCEV_CSR_COALESCWM_CFG_UNION;

      SG_C_ASSERT(__sizeof__CEV_CSR_COALESCWM_CFG_UNION, sizeof (CEV_CSR_COALESCWM_CFG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 0. The first of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ0 through EQ7.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR0_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt7 : 1;                // DWORD 0
               u32 interrupt6 : 1;                // DWORD 0
               u32 interrupt5 : 1;                // DWORD 0
               u32 interrupt4 : 1;                // DWORD 0
               u32 interrupt3 : 1;                // DWORD 0
               u32 interrupt2 : 1;                // DWORD 0
               u32 interrupt1 : 1;                // DWORD 0
               u32 interrupt0 : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR0_CSR, *PCEV_ISR0_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR0_CSR, sizeof (CEV_ISR0_CSR) == 4);

   #else
      typedef struct _CEV_ISR0_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt7 : 1;                      // DWORD 0
         u32 interrupt6 : 1;                      // DWORD 0
         u32 interrupt5 : 1;                      // DWORD 0
         u32 interrupt4 : 1;                      // DWORD 0
         u32 interrupt3 : 1;                      // DWORD 0
         u32 interrupt2 : 1;                      // DWORD 0
         u32 interrupt1 : 1;                      // DWORD 0
         u32 interrupt0 : 1;                      // DWORD 0
      } SG_PACK CEV_ISR0_CSR, *PCEV_ISR0_CSR;

      typedef union _CEV_ISR0_CSR_UNION {
         CEV_ISR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR0_CSR_UNION, *PCEV_ISR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR0_CSR_UNION, sizeof (CEV_ISR0_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 0. The first of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ0 through EQ7.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR0_CSR {
         union {
            struct { 
               u32 interrupt0 : 1;                // DWORD 0
               u32 interrupt1 : 1;                // DWORD 0
               u32 interrupt2 : 1;                // DWORD 0
               u32 interrupt3 : 1;                // DWORD 0
               u32 interrupt4 : 1;                // DWORD 0
               u32 interrupt5 : 1;                // DWORD 0
               u32 interrupt6 : 1;                // DWORD 0
               u32 interrupt7 : 1;                // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR0_CSR, *PCEV_ISR0_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR0_CSR, sizeof (CEV_ISR0_CSR) == 4);

   #else
      typedef struct _CEV_ISR0_CSR {
         u32 interrupt0 : 1;                      // DWORD 0
         u32 interrupt1 : 1;                      // DWORD 0
         u32 interrupt2 : 1;                      // DWORD 0
         u32 interrupt3 : 1;                      // DWORD 0
         u32 interrupt4 : 1;                      // DWORD 0
         u32 interrupt5 : 1;                      // DWORD 0
         u32 interrupt6 : 1;                      // DWORD 0
         u32 interrupt7 : 1;                      // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR0_CSR, *PCEV_ISR0_CSR;

      typedef union _CEV_ISR0_CSR_UNION {
         CEV_ISR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR0_CSR_UNION, *PCEV_ISR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR0_CSR_UNION, sizeof (CEV_ISR0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 1. The second of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ8 through EQ15.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR1_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt15 : 1;               // DWORD 0
               u32 interrupt14 : 1;               // DWORD 0
               u32 interrupt13 : 1;               // DWORD 0
               u32 interrupt12 : 1;               // DWORD 0
               u32 interrupt11 : 1;               // DWORD 0
               u32 interrupt10 : 1;               // DWORD 0
               u32 interrupt9 : 1;                // DWORD 0
               u32 interrupt8 : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR1_CSR, *PCEV_ISR1_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR1_CSR, sizeof (CEV_ISR1_CSR) == 4);

   #else
      typedef struct _CEV_ISR1_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt15 : 1;                     // DWORD 0
         u32 interrupt14 : 1;                     // DWORD 0
         u32 interrupt13 : 1;                     // DWORD 0
         u32 interrupt12 : 1;                     // DWORD 0
         u32 interrupt11 : 1;                     // DWORD 0
         u32 interrupt10 : 1;                     // DWORD 0
         u32 interrupt9 : 1;                      // DWORD 0
         u32 interrupt8 : 1;                      // DWORD 0
      } SG_PACK CEV_ISR1_CSR, *PCEV_ISR1_CSR;

      typedef union _CEV_ISR1_CSR_UNION {
         CEV_ISR1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR1_CSR_UNION, *PCEV_ISR1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR1_CSR_UNION, sizeof (CEV_ISR1_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 1. The second of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ8 through EQ15.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR1_CSR {
         union {
            struct { 
               u32 interrupt8 : 1;                // DWORD 0
               u32 interrupt9 : 1;                // DWORD 0
               u32 interrupt10 : 1;               // DWORD 0
               u32 interrupt11 : 1;               // DWORD 0
               u32 interrupt12 : 1;               // DWORD 0
               u32 interrupt13 : 1;               // DWORD 0
               u32 interrupt14 : 1;               // DWORD 0
               u32 interrupt15 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR1_CSR, *PCEV_ISR1_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR1_CSR, sizeof (CEV_ISR1_CSR) == 4);

   #else
      typedef struct _CEV_ISR1_CSR {
         u32 interrupt8 : 1;                      // DWORD 0
         u32 interrupt9 : 1;                      // DWORD 0
         u32 interrupt10 : 1;                     // DWORD 0
         u32 interrupt11 : 1;                     // DWORD 0
         u32 interrupt12 : 1;                     // DWORD 0
         u32 interrupt13 : 1;                     // DWORD 0
         u32 interrupt14 : 1;                     // DWORD 0
         u32 interrupt15 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR1_CSR, *PCEV_ISR1_CSR;

      typedef union _CEV_ISR1_CSR_UNION {
         CEV_ISR1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR1_CSR_UNION, *PCEV_ISR1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR1_CSR_UNION, sizeof (CEV_ISR1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 2. The third of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ16 through EQ23.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR2_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt23 : 1;               // DWORD 0
               u32 interrupt22 : 1;               // DWORD 0
               u32 interrupt21 : 1;               // DWORD 0
               u32 interrupt20 : 1;               // DWORD 0
               u32 interrupt19 : 1;               // DWORD 0
               u32 interrupt18 : 1;               // DWORD 0
               u32 interrupt17 : 1;               // DWORD 0
               u32 interrupt16 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR2_CSR, *PCEV_ISR2_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR2_CSR, sizeof (CEV_ISR2_CSR) == 4);

   #else
      typedef struct _CEV_ISR2_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt23 : 1;                     // DWORD 0
         u32 interrupt22 : 1;                     // DWORD 0
         u32 interrupt21 : 1;                     // DWORD 0
         u32 interrupt20 : 1;                     // DWORD 0
         u32 interrupt19 : 1;                     // DWORD 0
         u32 interrupt18 : 1;                     // DWORD 0
         u32 interrupt17 : 1;                     // DWORD 0
         u32 interrupt16 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR2_CSR, *PCEV_ISR2_CSR;

      typedef union _CEV_ISR2_CSR_UNION {
         CEV_ISR2_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR2_CSR_UNION, *PCEV_ISR2_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR2_CSR_UNION, sizeof (CEV_ISR2_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 2. The third of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ16 through EQ23.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR2_CSR {
         union {
            struct { 
               u32 interrupt16 : 1;               // DWORD 0
               u32 interrupt17 : 1;               // DWORD 0
               u32 interrupt18 : 1;               // DWORD 0
               u32 interrupt19 : 1;               // DWORD 0
               u32 interrupt20 : 1;               // DWORD 0
               u32 interrupt21 : 1;               // DWORD 0
               u32 interrupt22 : 1;               // DWORD 0
               u32 interrupt23 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR2_CSR, *PCEV_ISR2_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR2_CSR, sizeof (CEV_ISR2_CSR) == 4);

   #else
      typedef struct _CEV_ISR2_CSR {
         u32 interrupt16 : 1;                     // DWORD 0
         u32 interrupt17 : 1;                     // DWORD 0
         u32 interrupt18 : 1;                     // DWORD 0
         u32 interrupt19 : 1;                     // DWORD 0
         u32 interrupt20 : 1;                     // DWORD 0
         u32 interrupt21 : 1;                     // DWORD 0
         u32 interrupt22 : 1;                     // DWORD 0
         u32 interrupt23 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR2_CSR, *PCEV_ISR2_CSR;

      typedef union _CEV_ISR2_CSR_UNION {
         CEV_ISR2_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR2_CSR_UNION, *PCEV_ISR2_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR2_CSR_UNION, sizeof (CEV_ISR2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 3. The fourth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ24 through EQ31.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR3_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt31 : 1;               // DWORD 0
               u32 interrupt30 : 1;               // DWORD 0
               u32 interrupt29 : 1;               // DWORD 0
               u32 interrupt28 : 1;               // DWORD 0
               u32 interrupt27 : 1;               // DWORD 0
               u32 interrupt26 : 1;               // DWORD 0
               u32 interrupt25 : 1;               // DWORD 0
               u32 interrupt24 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR3_CSR, *PCEV_ISR3_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR3_CSR, sizeof (CEV_ISR3_CSR) == 4);

   #else
      typedef struct _CEV_ISR3_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt31 : 1;                     // DWORD 0
         u32 interrupt30 : 1;                     // DWORD 0
         u32 interrupt29 : 1;                     // DWORD 0
         u32 interrupt28 : 1;                     // DWORD 0
         u32 interrupt27 : 1;                     // DWORD 0
         u32 interrupt26 : 1;                     // DWORD 0
         u32 interrupt25 : 1;                     // DWORD 0
         u32 interrupt24 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR3_CSR, *PCEV_ISR3_CSR;

      typedef union _CEV_ISR3_CSR_UNION {
         CEV_ISR3_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR3_CSR_UNION, *PCEV_ISR3_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR3_CSR_UNION, sizeof (CEV_ISR3_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 3. The fourth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ24 through EQ31.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR3_CSR {
         union {
            struct { 
               u32 interrupt24 : 1;               // DWORD 0
               u32 interrupt25 : 1;               // DWORD 0
               u32 interrupt26 : 1;               // DWORD 0
               u32 interrupt27 : 1;               // DWORD 0
               u32 interrupt28 : 1;               // DWORD 0
               u32 interrupt29 : 1;               // DWORD 0
               u32 interrupt30 : 1;               // DWORD 0
               u32 interrupt31 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR3_CSR, *PCEV_ISR3_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR3_CSR, sizeof (CEV_ISR3_CSR) == 4);

   #else
      typedef struct _CEV_ISR3_CSR {
         u32 interrupt24 : 1;                     // DWORD 0
         u32 interrupt25 : 1;                     // DWORD 0
         u32 interrupt26 : 1;                     // DWORD 0
         u32 interrupt27 : 1;                     // DWORD 0
         u32 interrupt28 : 1;                     // DWORD 0
         u32 interrupt29 : 1;                     // DWORD 0
         u32 interrupt30 : 1;                     // DWORD 0
         u32 interrupt31 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR3_CSR, *PCEV_ISR3_CSR;

      typedef union _CEV_ISR3_CSR_UNION {
         CEV_ISR3_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR3_CSR_UNION, *PCEV_ISR3_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR3_CSR_UNION, sizeof (CEV_ISR3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 4. The fifth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ32 through EQ39.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR4_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt39 : 1;               // DWORD 0
               u32 interrupt38 : 1;               // DWORD 0
               u32 interrupt37 : 1;               // DWORD 0
               u32 interrupt36 : 1;               // DWORD 0
               u32 interrupt35 : 1;               // DWORD 0
               u32 interrupt34 : 1;               // DWORD 0
               u32 interrupt33 : 1;               // DWORD 0
               u32 interrupt32 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR4_CSR, *PCEV_ISR4_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR4_CSR, sizeof (CEV_ISR4_CSR) == 4);

   #else
      typedef struct _CEV_ISR4_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt39 : 1;                     // DWORD 0
         u32 interrupt38 : 1;                     // DWORD 0
         u32 interrupt37 : 1;                     // DWORD 0
         u32 interrupt36 : 1;                     // DWORD 0
         u32 interrupt35 : 1;                     // DWORD 0
         u32 interrupt34 : 1;                     // DWORD 0
         u32 interrupt33 : 1;                     // DWORD 0
         u32 interrupt32 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR4_CSR, *PCEV_ISR4_CSR;

      typedef union _CEV_ISR4_CSR_UNION {
         CEV_ISR4_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR4_CSR_UNION, *PCEV_ISR4_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR4_CSR_UNION, sizeof (CEV_ISR4_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 4. The fifth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ32 through EQ39.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR4_CSR {
         union {
            struct { 
               u32 interrupt32 : 1;               // DWORD 0
               u32 interrupt33 : 1;               // DWORD 0
               u32 interrupt34 : 1;               // DWORD 0
               u32 interrupt35 : 1;               // DWORD 0
               u32 interrupt36 : 1;               // DWORD 0
               u32 interrupt37 : 1;               // DWORD 0
               u32 interrupt38 : 1;               // DWORD 0
               u32 interrupt39 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR4_CSR, *PCEV_ISR4_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR4_CSR, sizeof (CEV_ISR4_CSR) == 4);

   #else
      typedef struct _CEV_ISR4_CSR {
         u32 interrupt32 : 1;                     // DWORD 0
         u32 interrupt33 : 1;                     // DWORD 0
         u32 interrupt34 : 1;                     // DWORD 0
         u32 interrupt35 : 1;                     // DWORD 0
         u32 interrupt36 : 1;                     // DWORD 0
         u32 interrupt37 : 1;                     // DWORD 0
         u32 interrupt38 : 1;                     // DWORD 0
         u32 interrupt39 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR4_CSR, *PCEV_ISR4_CSR;

      typedef union _CEV_ISR4_CSR_UNION {
         CEV_ISR4_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR4_CSR_UNION, *PCEV_ISR4_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR4_CSR_UNION, sizeof (CEV_ISR4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 5. The sixth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ40 through EQ47.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR5_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt47 : 1;               // DWORD 0
               u32 interrupt46 : 1;               // DWORD 0
               u32 interrupt45 : 1;               // DWORD 0
               u32 interrupt44 : 1;               // DWORD 0
               u32 interrupt43 : 1;               // DWORD 0
               u32 interrupt42 : 1;               // DWORD 0
               u32 interrupt41 : 1;               // DWORD 0
               u32 interrupt40 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR5_CSR, *PCEV_ISR5_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR5_CSR, sizeof (CEV_ISR5_CSR) == 4);

   #else
      typedef struct _CEV_ISR5_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt47 : 1;                     // DWORD 0
         u32 interrupt46 : 1;                     // DWORD 0
         u32 interrupt45 : 1;                     // DWORD 0
         u32 interrupt44 : 1;                     // DWORD 0
         u32 interrupt43 : 1;                     // DWORD 0
         u32 interrupt42 : 1;                     // DWORD 0
         u32 interrupt41 : 1;                     // DWORD 0
         u32 interrupt40 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR5_CSR, *PCEV_ISR5_CSR;

      typedef union _CEV_ISR5_CSR_UNION {
         CEV_ISR5_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR5_CSR_UNION, *PCEV_ISR5_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR5_CSR_UNION, sizeof (CEV_ISR5_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 5. The sixth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ40 through EQ47.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR5_CSR {
         union {
            struct { 
               u32 interrupt40 : 1;               // DWORD 0
               u32 interrupt41 : 1;               // DWORD 0
               u32 interrupt42 : 1;               // DWORD 0
               u32 interrupt43 : 1;               // DWORD 0
               u32 interrupt44 : 1;               // DWORD 0
               u32 interrupt45 : 1;               // DWORD 0
               u32 interrupt46 : 1;               // DWORD 0
               u32 interrupt47 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR5_CSR, *PCEV_ISR5_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR5_CSR, sizeof (CEV_ISR5_CSR) == 4);

   #else
      typedef struct _CEV_ISR5_CSR {
         u32 interrupt40 : 1;                     // DWORD 0
         u32 interrupt41 : 1;                     // DWORD 0
         u32 interrupt42 : 1;                     // DWORD 0
         u32 interrupt43 : 1;                     // DWORD 0
         u32 interrupt44 : 1;                     // DWORD 0
         u32 interrupt45 : 1;                     // DWORD 0
         u32 interrupt46 : 1;                     // DWORD 0
         u32 interrupt47 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR5_CSR, *PCEV_ISR5_CSR;

      typedef union _CEV_ISR5_CSR_UNION {
         CEV_ISR5_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR5_CSR_UNION, *PCEV_ISR5_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR5_CSR_UNION, sizeof (CEV_ISR5_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 6. The seventh of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ48 through EQ55.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR6_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt55 : 1;               // DWORD 0
               u32 interrupt54 : 1;               // DWORD 0
               u32 interrupt53 : 1;               // DWORD 0
               u32 interrupt52 : 1;               // DWORD 0
               u32 interrupt51 : 1;               // DWORD 0
               u32 interrupt50 : 1;               // DWORD 0
               u32 interrupt49 : 1;               // DWORD 0
               u32 interrupt48 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR6_CSR, *PCEV_ISR6_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR6_CSR, sizeof (CEV_ISR6_CSR) == 4);

   #else
      typedef struct _CEV_ISR6_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt55 : 1;                     // DWORD 0
         u32 interrupt54 : 1;                     // DWORD 0
         u32 interrupt53 : 1;                     // DWORD 0
         u32 interrupt52 : 1;                     // DWORD 0
         u32 interrupt51 : 1;                     // DWORD 0
         u32 interrupt50 : 1;                     // DWORD 0
         u32 interrupt49 : 1;                     // DWORD 0
         u32 interrupt48 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR6_CSR, *PCEV_ISR6_CSR;

      typedef union _CEV_ISR6_CSR_UNION {
         CEV_ISR6_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR6_CSR_UNION, *PCEV_ISR6_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR6_CSR_UNION, sizeof (CEV_ISR6_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 6. The seventh of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ48 through EQ55.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR6_CSR {
         union {
            struct { 
               u32 interrupt48 : 1;               // DWORD 0
               u32 interrupt49 : 1;               // DWORD 0
               u32 interrupt50 : 1;               // DWORD 0
               u32 interrupt51 : 1;               // DWORD 0
               u32 interrupt52 : 1;               // DWORD 0
               u32 interrupt53 : 1;               // DWORD 0
               u32 interrupt54 : 1;               // DWORD 0
               u32 interrupt55 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR6_CSR, *PCEV_ISR6_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR6_CSR, sizeof (CEV_ISR6_CSR) == 4);

   #else
      typedef struct _CEV_ISR6_CSR {
         u32 interrupt48 : 1;                     // DWORD 0
         u32 interrupt49 : 1;                     // DWORD 0
         u32 interrupt50 : 1;                     // DWORD 0
         u32 interrupt51 : 1;                     // DWORD 0
         u32 interrupt52 : 1;                     // DWORD 0
         u32 interrupt53 : 1;                     // DWORD 0
         u32 interrupt54 : 1;                     // DWORD 0
         u32 interrupt55 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR6_CSR, *PCEV_ISR6_CSR;

      typedef union _CEV_ISR6_CSR_UNION {
         CEV_ISR6_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR6_CSR_UNION, *PCEV_ISR6_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR6_CSR_UNION, sizeof (CEV_ISR6_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 7. The eigth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ56 through EQ63.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR7_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 interrupt63 : 1;               // DWORD 0
               u32 interrupt62 : 1;               // DWORD 0
               u32 interrupt61 : 1;               // DWORD 0
               u32 interrupt60 : 1;               // DWORD 0
               u32 interrupt59 : 1;               // DWORD 0
               u32 interrupt58 : 1;               // DWORD 0
               u32 interrupt57 : 1;               // DWORD 0
               u32 interrupt56 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR7_CSR, *PCEV_ISR7_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR7_CSR, sizeof (CEV_ISR7_CSR) == 4);

   #else
      typedef struct _CEV_ISR7_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 interrupt63 : 1;                     // DWORD 0
         u32 interrupt62 : 1;                     // DWORD 0
         u32 interrupt61 : 1;                     // DWORD 0
         u32 interrupt60 : 1;                     // DWORD 0
         u32 interrupt59 : 1;                     // DWORD 0
         u32 interrupt58 : 1;                     // DWORD 0
         u32 interrupt57 : 1;                     // DWORD 0
         u32 interrupt56 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR7_CSR, *PCEV_ISR7_CSR;

      typedef union _CEV_ISR7_CSR_UNION {
         CEV_ISR7_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR7_CSR_UNION, *PCEV_ISR7_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR7_CSR_UNION, sizeof (CEV_ISR7_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 7. The eigth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ56 through EQ63.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR7_CSR {
         union {
            struct { 
               u32 interrupt56 : 1;               // DWORD 0
               u32 interrupt57 : 1;               // DWORD 0
               u32 interrupt58 : 1;               // DWORD 0
               u32 interrupt59 : 1;               // DWORD 0
               u32 interrupt60 : 1;               // DWORD 0
               u32 interrupt61 : 1;               // DWORD 0
               u32 interrupt62 : 1;               // DWORD 0
               u32 interrupt63 : 1;               // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR7_CSR, *PCEV_ISR7_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR7_CSR, sizeof (CEV_ISR7_CSR) == 4);

   #else
      typedef struct _CEV_ISR7_CSR {
         u32 interrupt56 : 1;                     // DWORD 0
         u32 interrupt57 : 1;                     // DWORD 0
         u32 interrupt58 : 1;                     // DWORD 0
         u32 interrupt59 : 1;                     // DWORD 0
         u32 interrupt60 : 1;                     // DWORD 0
         u32 interrupt61 : 1;                     // DWORD 0
         u32 interrupt62 : 1;                     // DWORD 0
         u32 interrupt63 : 1;                     // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISR7_CSR, *PCEV_ISR7_CSR;

      typedef union _CEV_ISR7_CSR_UNION {
         CEV_ISR7_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR7_CSR_UNION, *PCEV_ISR7_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR7_CSR_UNION, sizeof (CEV_ISR7_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 8. The ninth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ64 through EQ95.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR8_CSR {
         union {
            struct { 
               u32 interrupt95 : 1;               // DWORD 0
               u32 interrupt94 : 1;               // DWORD 0
               u32 interrupt93 : 1;               // DWORD 0
               u32 interrupt92 : 1;               // DWORD 0
               u32 interrupt91 : 1;               // DWORD 0
               u32 interrupt90 : 1;               // DWORD 0
               u32 interrupt89 : 1;               // DWORD 0
               u32 interrupt88 : 1;               // DWORD 0
               u32 interrupt87 : 1;               // DWORD 0
               u32 interrupt86 : 1;               // DWORD 0
               u32 interrupt85 : 1;               // DWORD 0
               u32 interrupt84 : 1;               // DWORD 0
               u32 interrupt83 : 1;               // DWORD 0
               u32 interrupt82 : 1;               // DWORD 0
               u32 interrupt81 : 1;               // DWORD 0
               u32 interrupt80 : 1;               // DWORD 0
               u32 interrupt79 : 1;               // DWORD 0
               u32 interrupt78 : 1;               // DWORD 0
               u32 interrupt77 : 1;               // DWORD 0
               u32 interrupt76 : 1;               // DWORD 0
               u32 interrupt75 : 1;               // DWORD 0
               u32 interrupt74 : 1;               // DWORD 0
               u32 interrupt73 : 1;               // DWORD 0
               u32 interrupt72 : 1;               // DWORD 0
               u32 interrupt71 : 1;               // DWORD 0
               u32 interrupt70 : 1;               // DWORD 0
               u32 interrupt69 : 1;               // DWORD 0
               u32 interrupt68 : 1;               // DWORD 0
               u32 interrupt67 : 1;               // DWORD 0
               u32 interrupt66 : 1;               // DWORD 0
               u32 interrupt65 : 1;               // DWORD 0
               u32 interrupt64 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR8_CSR, *PCEV_ISR8_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR8_CSR, sizeof (CEV_ISR8_CSR) == 4);

   #else
      typedef struct _CEV_ISR8_CSR {
         u32 interrupt95 : 1;                     // DWORD 0
         u32 interrupt94 : 1;                     // DWORD 0
         u32 interrupt93 : 1;                     // DWORD 0
         u32 interrupt92 : 1;                     // DWORD 0
         u32 interrupt91 : 1;                     // DWORD 0
         u32 interrupt90 : 1;                     // DWORD 0
         u32 interrupt89 : 1;                     // DWORD 0
         u32 interrupt88 : 1;                     // DWORD 0
         u32 interrupt87 : 1;                     // DWORD 0
         u32 interrupt86 : 1;                     // DWORD 0
         u32 interrupt85 : 1;                     // DWORD 0
         u32 interrupt84 : 1;                     // DWORD 0
         u32 interrupt83 : 1;                     // DWORD 0
         u32 interrupt82 : 1;                     // DWORD 0
         u32 interrupt81 : 1;                     // DWORD 0
         u32 interrupt80 : 1;                     // DWORD 0
         u32 interrupt79 : 1;                     // DWORD 0
         u32 interrupt78 : 1;                     // DWORD 0
         u32 interrupt77 : 1;                     // DWORD 0
         u32 interrupt76 : 1;                     // DWORD 0
         u32 interrupt75 : 1;                     // DWORD 0
         u32 interrupt74 : 1;                     // DWORD 0
         u32 interrupt73 : 1;                     // DWORD 0
         u32 interrupt72 : 1;                     // DWORD 0
         u32 interrupt71 : 1;                     // DWORD 0
         u32 interrupt70 : 1;                     // DWORD 0
         u32 interrupt69 : 1;                     // DWORD 0
         u32 interrupt68 : 1;                     // DWORD 0
         u32 interrupt67 : 1;                     // DWORD 0
         u32 interrupt66 : 1;                     // DWORD 0
         u32 interrupt65 : 1;                     // DWORD 0
         u32 interrupt64 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR8_CSR, *PCEV_ISR8_CSR;

      typedef union _CEV_ISR8_CSR_UNION {
         CEV_ISR8_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR8_CSR_UNION, *PCEV_ISR8_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR8_CSR_UNION, sizeof (CEV_ISR8_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 8. The ninth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ64 through EQ95.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR8_CSR {
         union {
            struct { 
               u32 interrupt64 : 1;               // DWORD 0
               u32 interrupt65 : 1;               // DWORD 0
               u32 interrupt66 : 1;               // DWORD 0
               u32 interrupt67 : 1;               // DWORD 0
               u32 interrupt68 : 1;               // DWORD 0
               u32 interrupt69 : 1;               // DWORD 0
               u32 interrupt70 : 1;               // DWORD 0
               u32 interrupt71 : 1;               // DWORD 0
               u32 interrupt72 : 1;               // DWORD 0
               u32 interrupt73 : 1;               // DWORD 0
               u32 interrupt74 : 1;               // DWORD 0
               u32 interrupt75 : 1;               // DWORD 0
               u32 interrupt76 : 1;               // DWORD 0
               u32 interrupt77 : 1;               // DWORD 0
               u32 interrupt78 : 1;               // DWORD 0
               u32 interrupt79 : 1;               // DWORD 0
               u32 interrupt80 : 1;               // DWORD 0
               u32 interrupt81 : 1;               // DWORD 0
               u32 interrupt82 : 1;               // DWORD 0
               u32 interrupt83 : 1;               // DWORD 0
               u32 interrupt84 : 1;               // DWORD 0
               u32 interrupt85 : 1;               // DWORD 0
               u32 interrupt86 : 1;               // DWORD 0
               u32 interrupt87 : 1;               // DWORD 0
               u32 interrupt88 : 1;               // DWORD 0
               u32 interrupt89 : 1;               // DWORD 0
               u32 interrupt90 : 1;               // DWORD 0
               u32 interrupt91 : 1;               // DWORD 0
               u32 interrupt92 : 1;               // DWORD 0
               u32 interrupt93 : 1;               // DWORD 0
               u32 interrupt94 : 1;               // DWORD 0
               u32 interrupt95 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR8_CSR, *PCEV_ISR8_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR8_CSR, sizeof (CEV_ISR8_CSR) == 4);

   #else
      typedef struct _CEV_ISR8_CSR {
         u32 interrupt64 : 1;                     // DWORD 0
         u32 interrupt65 : 1;                     // DWORD 0
         u32 interrupt66 : 1;                     // DWORD 0
         u32 interrupt67 : 1;                     // DWORD 0
         u32 interrupt68 : 1;                     // DWORD 0
         u32 interrupt69 : 1;                     // DWORD 0
         u32 interrupt70 : 1;                     // DWORD 0
         u32 interrupt71 : 1;                     // DWORD 0
         u32 interrupt72 : 1;                     // DWORD 0
         u32 interrupt73 : 1;                     // DWORD 0
         u32 interrupt74 : 1;                     // DWORD 0
         u32 interrupt75 : 1;                     // DWORD 0
         u32 interrupt76 : 1;                     // DWORD 0
         u32 interrupt77 : 1;                     // DWORD 0
         u32 interrupt78 : 1;                     // DWORD 0
         u32 interrupt79 : 1;                     // DWORD 0
         u32 interrupt80 : 1;                     // DWORD 0
         u32 interrupt81 : 1;                     // DWORD 0
         u32 interrupt82 : 1;                     // DWORD 0
         u32 interrupt83 : 1;                     // DWORD 0
         u32 interrupt84 : 1;                     // DWORD 0
         u32 interrupt85 : 1;                     // DWORD 0
         u32 interrupt86 : 1;                     // DWORD 0
         u32 interrupt87 : 1;                     // DWORD 0
         u32 interrupt88 : 1;                     // DWORD 0
         u32 interrupt89 : 1;                     // DWORD 0
         u32 interrupt90 : 1;                     // DWORD 0
         u32 interrupt91 : 1;                     // DWORD 0
         u32 interrupt92 : 1;                     // DWORD 0
         u32 interrupt93 : 1;                     // DWORD 0
         u32 interrupt94 : 1;                     // DWORD 0
         u32 interrupt95 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR8_CSR, *PCEV_ISR8_CSR;

      typedef union _CEV_ISR8_CSR_UNION {
         CEV_ISR8_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR8_CSR_UNION, *PCEV_ISR8_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR8_CSR_UNION, sizeof (CEV_ISR8_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 9. The tenth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ96 through
   // EQ127.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR9_CSR {
         union {
            struct { 
               u32 interrupt127 : 1;              // DWORD 0
               u32 interrupt126 : 1;              // DWORD 0
               u32 interrupt125 : 1;              // DWORD 0
               u32 interrupt124 : 1;              // DWORD 0
               u32 interrupt123 : 1;              // DWORD 0
               u32 interrupt122 : 1;              // DWORD 0
               u32 interrupt121 : 1;              // DWORD 0
               u32 interrupt120 : 1;              // DWORD 0
               u32 interrupt119 : 1;              // DWORD 0
               u32 interrupt118 : 1;              // DWORD 0
               u32 interrupt117 : 1;              // DWORD 0
               u32 interrupt116 : 1;              // DWORD 0
               u32 interrupt115 : 1;              // DWORD 0
               u32 interrupt114 : 1;              // DWORD 0
               u32 interrupt113 : 1;              // DWORD 0
               u32 interrupt112 : 1;              // DWORD 0
               u32 interrupt111 : 1;              // DWORD 0
               u32 interrupt110 : 1;              // DWORD 0
               u32 interrupt109 : 1;              // DWORD 0
               u32 interrupt108 : 1;              // DWORD 0
               u32 interrupt107 : 1;              // DWORD 0
               u32 interrupt106 : 1;              // DWORD 0
               u32 interrupt105 : 1;              // DWORD 0
               u32 interrupt104 : 1;              // DWORD 0
               u32 interrupt103 : 1;              // DWORD 0
               u32 interrupt102 : 1;              // DWORD 0
               u32 interrupt101 : 1;              // DWORD 0
               u32 interrupt100 : 1;              // DWORD 0
               u32 interrupt99 : 1;               // DWORD 0
               u32 interrupt98 : 1;               // DWORD 0
               u32 interrupt97 : 1;               // DWORD 0
               u32 interrupt96 : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR9_CSR, *PCEV_ISR9_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR9_CSR, sizeof (CEV_ISR9_CSR) == 4);

   #else
      typedef struct _CEV_ISR9_CSR {
         u32 interrupt127 : 1;                    // DWORD 0
         u32 interrupt126 : 1;                    // DWORD 0
         u32 interrupt125 : 1;                    // DWORD 0
         u32 interrupt124 : 1;                    // DWORD 0
         u32 interrupt123 : 1;                    // DWORD 0
         u32 interrupt122 : 1;                    // DWORD 0
         u32 interrupt121 : 1;                    // DWORD 0
         u32 interrupt120 : 1;                    // DWORD 0
         u32 interrupt119 : 1;                    // DWORD 0
         u32 interrupt118 : 1;                    // DWORD 0
         u32 interrupt117 : 1;                    // DWORD 0
         u32 interrupt116 : 1;                    // DWORD 0
         u32 interrupt115 : 1;                    // DWORD 0
         u32 interrupt114 : 1;                    // DWORD 0
         u32 interrupt113 : 1;                    // DWORD 0
         u32 interrupt112 : 1;                    // DWORD 0
         u32 interrupt111 : 1;                    // DWORD 0
         u32 interrupt110 : 1;                    // DWORD 0
         u32 interrupt109 : 1;                    // DWORD 0
         u32 interrupt108 : 1;                    // DWORD 0
         u32 interrupt107 : 1;                    // DWORD 0
         u32 interrupt106 : 1;                    // DWORD 0
         u32 interrupt105 : 1;                    // DWORD 0
         u32 interrupt104 : 1;                    // DWORD 0
         u32 interrupt103 : 1;                    // DWORD 0
         u32 interrupt102 : 1;                    // DWORD 0
         u32 interrupt101 : 1;                    // DWORD 0
         u32 interrupt100 : 1;                    // DWORD 0
         u32 interrupt99 : 1;                     // DWORD 0
         u32 interrupt98 : 1;                     // DWORD 0
         u32 interrupt97 : 1;                     // DWORD 0
         u32 interrupt96 : 1;                     // DWORD 0
      } SG_PACK CEV_ISR9_CSR, *PCEV_ISR9_CSR;

      typedef union _CEV_ISR9_CSR_UNION {
         CEV_ISR9_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR9_CSR_UNION, *PCEV_ISR9_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR9_CSR_UNION, sizeof (CEV_ISR9_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 9. The tenth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ96 through
   // EQ127.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR9_CSR {
         union {
            struct { 
               u32 interrupt96 : 1;               // DWORD 0
               u32 interrupt97 : 1;               // DWORD 0
               u32 interrupt98 : 1;               // DWORD 0
               u32 interrupt99 : 1;               // DWORD 0
               u32 interrupt100 : 1;              // DWORD 0
               u32 interrupt101 : 1;              // DWORD 0
               u32 interrupt102 : 1;              // DWORD 0
               u32 interrupt103 : 1;              // DWORD 0
               u32 interrupt104 : 1;              // DWORD 0
               u32 interrupt105 : 1;              // DWORD 0
               u32 interrupt106 : 1;              // DWORD 0
               u32 interrupt107 : 1;              // DWORD 0
               u32 interrupt108 : 1;              // DWORD 0
               u32 interrupt109 : 1;              // DWORD 0
               u32 interrupt110 : 1;              // DWORD 0
               u32 interrupt111 : 1;              // DWORD 0
               u32 interrupt112 : 1;              // DWORD 0
               u32 interrupt113 : 1;              // DWORD 0
               u32 interrupt114 : 1;              // DWORD 0
               u32 interrupt115 : 1;              // DWORD 0
               u32 interrupt116 : 1;              // DWORD 0
               u32 interrupt117 : 1;              // DWORD 0
               u32 interrupt118 : 1;              // DWORD 0
               u32 interrupt119 : 1;              // DWORD 0
               u32 interrupt120 : 1;              // DWORD 0
               u32 interrupt121 : 1;              // DWORD 0
               u32 interrupt122 : 1;              // DWORD 0
               u32 interrupt123 : 1;              // DWORD 0
               u32 interrupt124 : 1;              // DWORD 0
               u32 interrupt125 : 1;              // DWORD 0
               u32 interrupt126 : 1;              // DWORD 0
               u32 interrupt127 : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR9_CSR, *PCEV_ISR9_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR9_CSR, sizeof (CEV_ISR9_CSR) == 4);

   #else
      typedef struct _CEV_ISR9_CSR {
         u32 interrupt96 : 1;                     // DWORD 0
         u32 interrupt97 : 1;                     // DWORD 0
         u32 interrupt98 : 1;                     // DWORD 0
         u32 interrupt99 : 1;                     // DWORD 0
         u32 interrupt100 : 1;                    // DWORD 0
         u32 interrupt101 : 1;                    // DWORD 0
         u32 interrupt102 : 1;                    // DWORD 0
         u32 interrupt103 : 1;                    // DWORD 0
         u32 interrupt104 : 1;                    // DWORD 0
         u32 interrupt105 : 1;                    // DWORD 0
         u32 interrupt106 : 1;                    // DWORD 0
         u32 interrupt107 : 1;                    // DWORD 0
         u32 interrupt108 : 1;                    // DWORD 0
         u32 interrupt109 : 1;                    // DWORD 0
         u32 interrupt110 : 1;                    // DWORD 0
         u32 interrupt111 : 1;                    // DWORD 0
         u32 interrupt112 : 1;                    // DWORD 0
         u32 interrupt113 : 1;                    // DWORD 0
         u32 interrupt114 : 1;                    // DWORD 0
         u32 interrupt115 : 1;                    // DWORD 0
         u32 interrupt116 : 1;                    // DWORD 0
         u32 interrupt117 : 1;                    // DWORD 0
         u32 interrupt118 : 1;                    // DWORD 0
         u32 interrupt119 : 1;                    // DWORD 0
         u32 interrupt120 : 1;                    // DWORD 0
         u32 interrupt121 : 1;                    // DWORD 0
         u32 interrupt122 : 1;                    // DWORD 0
         u32 interrupt123 : 1;                    // DWORD 0
         u32 interrupt124 : 1;                    // DWORD 0
         u32 interrupt125 : 1;                    // DWORD 0
         u32 interrupt126 : 1;                    // DWORD 0
         u32 interrupt127 : 1;                    // DWORD 0
      } SG_PACK CEV_ISR9_CSR, *PCEV_ISR9_CSR;

      typedef union _CEV_ISR9_CSR_UNION {
         CEV_ISR9_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR9_CSR_UNION, *PCEV_ISR9_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR9_CSR_UNION, sizeof (CEV_ISR9_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 10. The eleventh of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ128 through
   // EQ159.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR10_CSR {
         union {
            struct { 
               u32 interrupt159 : 1;              // DWORD 0
               u32 interrupt158 : 1;              // DWORD 0
               u32 interrupt157 : 1;              // DWORD 0
               u32 interrupt156 : 1;              // DWORD 0
               u32 interrupt155 : 1;              // DWORD 0
               u32 interrupt154 : 1;              // DWORD 0
               u32 interrupt153 : 1;              // DWORD 0
               u32 interrupt152 : 1;              // DWORD 0
               u32 interrupt151 : 1;              // DWORD 0
               u32 interrupt150 : 1;              // DWORD 0
               u32 interrupt149 : 1;              // DWORD 0
               u32 interrupt148 : 1;              // DWORD 0
               u32 interrupt147 : 1;              // DWORD 0
               u32 interrupt146 : 1;              // DWORD 0
               u32 interrupt145 : 1;              // DWORD 0
               u32 interrupt144 : 1;              // DWORD 0
               u32 interrupt143 : 1;              // DWORD 0
               u32 interrupt142 : 1;              // DWORD 0
               u32 interrupt141 : 1;              // DWORD 0
               u32 interrupt140 : 1;              // DWORD 0
               u32 interrupt139 : 1;              // DWORD 0
               u32 interrupt138 : 1;              // DWORD 0
               u32 interrupt137 : 1;              // DWORD 0
               u32 interrupt136 : 1;              // DWORD 0
               u32 interrupt135 : 1;              // DWORD 0
               u32 interrupt134 : 1;              // DWORD 0
               u32 interrupt133 : 1;              // DWORD 0
               u32 interrupt132 : 1;              // DWORD 0
               u32 interrupt131 : 1;              // DWORD 0
               u32 interrupt130 : 1;              // DWORD 0
               u32 interrupt129 : 1;              // DWORD 0
               u32 interrupt128 : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR10_CSR, *PCEV_ISR10_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR10_CSR, sizeof (CEV_ISR10_CSR) == 4);

   #else
      typedef struct _CEV_ISR10_CSR {
         u32 interrupt159 : 1;                    // DWORD 0
         u32 interrupt158 : 1;                    // DWORD 0
         u32 interrupt157 : 1;                    // DWORD 0
         u32 interrupt156 : 1;                    // DWORD 0
         u32 interrupt155 : 1;                    // DWORD 0
         u32 interrupt154 : 1;                    // DWORD 0
         u32 interrupt153 : 1;                    // DWORD 0
         u32 interrupt152 : 1;                    // DWORD 0
         u32 interrupt151 : 1;                    // DWORD 0
         u32 interrupt150 : 1;                    // DWORD 0
         u32 interrupt149 : 1;                    // DWORD 0
         u32 interrupt148 : 1;                    // DWORD 0
         u32 interrupt147 : 1;                    // DWORD 0
         u32 interrupt146 : 1;                    // DWORD 0
         u32 interrupt145 : 1;                    // DWORD 0
         u32 interrupt144 : 1;                    // DWORD 0
         u32 interrupt143 : 1;                    // DWORD 0
         u32 interrupt142 : 1;                    // DWORD 0
         u32 interrupt141 : 1;                    // DWORD 0
         u32 interrupt140 : 1;                    // DWORD 0
         u32 interrupt139 : 1;                    // DWORD 0
         u32 interrupt138 : 1;                    // DWORD 0
         u32 interrupt137 : 1;                    // DWORD 0
         u32 interrupt136 : 1;                    // DWORD 0
         u32 interrupt135 : 1;                    // DWORD 0
         u32 interrupt134 : 1;                    // DWORD 0
         u32 interrupt133 : 1;                    // DWORD 0
         u32 interrupt132 : 1;                    // DWORD 0
         u32 interrupt131 : 1;                    // DWORD 0
         u32 interrupt130 : 1;                    // DWORD 0
         u32 interrupt129 : 1;                    // DWORD 0
         u32 interrupt128 : 1;                    // DWORD 0
      } SG_PACK CEV_ISR10_CSR, *PCEV_ISR10_CSR;

      typedef union _CEV_ISR10_CSR_UNION {
         CEV_ISR10_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR10_CSR_UNION, *PCEV_ISR10_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR10_CSR_UNION, sizeof (CEV_ISR10_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 10. The eleventh of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ128 through
   // EQ159.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR10_CSR {
         union {
            struct { 
               u32 interrupt128 : 1;              // DWORD 0
               u32 interrupt129 : 1;              // DWORD 0
               u32 interrupt130 : 1;              // DWORD 0
               u32 interrupt131 : 1;              // DWORD 0
               u32 interrupt132 : 1;              // DWORD 0
               u32 interrupt133 : 1;              // DWORD 0
               u32 interrupt134 : 1;              // DWORD 0
               u32 interrupt135 : 1;              // DWORD 0
               u32 interrupt136 : 1;              // DWORD 0
               u32 interrupt137 : 1;              // DWORD 0
               u32 interrupt138 : 1;              // DWORD 0
               u32 interrupt139 : 1;              // DWORD 0
               u32 interrupt140 : 1;              // DWORD 0
               u32 interrupt141 : 1;              // DWORD 0
               u32 interrupt142 : 1;              // DWORD 0
               u32 interrupt143 : 1;              // DWORD 0
               u32 interrupt144 : 1;              // DWORD 0
               u32 interrupt145 : 1;              // DWORD 0
               u32 interrupt146 : 1;              // DWORD 0
               u32 interrupt147 : 1;              // DWORD 0
               u32 interrupt148 : 1;              // DWORD 0
               u32 interrupt149 : 1;              // DWORD 0
               u32 interrupt150 : 1;              // DWORD 0
               u32 interrupt151 : 1;              // DWORD 0
               u32 interrupt152 : 1;              // DWORD 0
               u32 interrupt153 : 1;              // DWORD 0
               u32 interrupt154 : 1;              // DWORD 0
               u32 interrupt155 : 1;              // DWORD 0
               u32 interrupt156 : 1;              // DWORD 0
               u32 interrupt157 : 1;              // DWORD 0
               u32 interrupt158 : 1;              // DWORD 0
               u32 interrupt159 : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR10_CSR, *PCEV_ISR10_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR10_CSR, sizeof (CEV_ISR10_CSR) == 4);

   #else
      typedef struct _CEV_ISR10_CSR {
         u32 interrupt128 : 1;                    // DWORD 0
         u32 interrupt129 : 1;                    // DWORD 0
         u32 interrupt130 : 1;                    // DWORD 0
         u32 interrupt131 : 1;                    // DWORD 0
         u32 interrupt132 : 1;                    // DWORD 0
         u32 interrupt133 : 1;                    // DWORD 0
         u32 interrupt134 : 1;                    // DWORD 0
         u32 interrupt135 : 1;                    // DWORD 0
         u32 interrupt136 : 1;                    // DWORD 0
         u32 interrupt137 : 1;                    // DWORD 0
         u32 interrupt138 : 1;                    // DWORD 0
         u32 interrupt139 : 1;                    // DWORD 0
         u32 interrupt140 : 1;                    // DWORD 0
         u32 interrupt141 : 1;                    // DWORD 0
         u32 interrupt142 : 1;                    // DWORD 0
         u32 interrupt143 : 1;                    // DWORD 0
         u32 interrupt144 : 1;                    // DWORD 0
         u32 interrupt145 : 1;                    // DWORD 0
         u32 interrupt146 : 1;                    // DWORD 0
         u32 interrupt147 : 1;                    // DWORD 0
         u32 interrupt148 : 1;                    // DWORD 0
         u32 interrupt149 : 1;                    // DWORD 0
         u32 interrupt150 : 1;                    // DWORD 0
         u32 interrupt151 : 1;                    // DWORD 0
         u32 interrupt152 : 1;                    // DWORD 0
         u32 interrupt153 : 1;                    // DWORD 0
         u32 interrupt154 : 1;                    // DWORD 0
         u32 interrupt155 : 1;                    // DWORD 0
         u32 interrupt156 : 1;                    // DWORD 0
         u32 interrupt157 : 1;                    // DWORD 0
         u32 interrupt158 : 1;                    // DWORD 0
         u32 interrupt159 : 1;                    // DWORD 0
      } SG_PACK CEV_ISR10_CSR, *PCEV_ISR10_CSR;

      typedef union _CEV_ISR10_CSR_UNION {
         CEV_ISR10_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR10_CSR_UNION, *PCEV_ISR10_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR10_CSR_UNION, sizeof (CEV_ISR10_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Register 11. The twelfth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ160 through
   // EQ191.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR11_CSR {
         union {
            struct { 
               u32 interrupt191 : 1;              // DWORD 0
               u32 interrupt190 : 1;              // DWORD 0
               u32 interrupt189 : 1;              // DWORD 0
               u32 interrupt188 : 1;              // DWORD 0
               u32 interrupt187 : 1;              // DWORD 0
               u32 interrupt186 : 1;              // DWORD 0
               u32 interrupt185 : 1;              // DWORD 0
               u32 interrupt184 : 1;              // DWORD 0
               u32 interrupt183 : 1;              // DWORD 0
               u32 interrupt182 : 1;              // DWORD 0
               u32 interrupt181 : 1;              // DWORD 0
               u32 interrupt180 : 1;              // DWORD 0
               u32 interrupt179 : 1;              // DWORD 0
               u32 interrupt178 : 1;              // DWORD 0
               u32 interrupt177 : 1;              // DWORD 0
               u32 interrupt176 : 1;              // DWORD 0
               u32 interrupt175 : 1;              // DWORD 0
               u32 interrupt174 : 1;              // DWORD 0
               u32 interrupt173 : 1;              // DWORD 0
               u32 interrupt172 : 1;              // DWORD 0
               u32 interrupt171 : 1;              // DWORD 0
               u32 interrupt170 : 1;              // DWORD 0
               u32 interrupt169 : 1;              // DWORD 0
               u32 interrupt168 : 1;              // DWORD 0
               u32 interrupt167 : 1;              // DWORD 0
               u32 interrupt166 : 1;              // DWORD 0
               u32 interrupt165 : 1;              // DWORD 0
               u32 interrupt164 : 1;              // DWORD 0
               u32 interrupt163 : 1;              // DWORD 0
               u32 interrupt162 : 1;              // DWORD 0
               u32 interrupt161 : 1;              // DWORD 0
               u32 interrupt160 : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR11_CSR, *PCEV_ISR11_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR11_CSR, sizeof (CEV_ISR11_CSR) == 4);

   #else
      typedef struct _CEV_ISR11_CSR {
         u32 interrupt191 : 1;                    // DWORD 0
         u32 interrupt190 : 1;                    // DWORD 0
         u32 interrupt189 : 1;                    // DWORD 0
         u32 interrupt188 : 1;                    // DWORD 0
         u32 interrupt187 : 1;                    // DWORD 0
         u32 interrupt186 : 1;                    // DWORD 0
         u32 interrupt185 : 1;                    // DWORD 0
         u32 interrupt184 : 1;                    // DWORD 0
         u32 interrupt183 : 1;                    // DWORD 0
         u32 interrupt182 : 1;                    // DWORD 0
         u32 interrupt181 : 1;                    // DWORD 0
         u32 interrupt180 : 1;                    // DWORD 0
         u32 interrupt179 : 1;                    // DWORD 0
         u32 interrupt178 : 1;                    // DWORD 0
         u32 interrupt177 : 1;                    // DWORD 0
         u32 interrupt176 : 1;                    // DWORD 0
         u32 interrupt175 : 1;                    // DWORD 0
         u32 interrupt174 : 1;                    // DWORD 0
         u32 interrupt173 : 1;                    // DWORD 0
         u32 interrupt172 : 1;                    // DWORD 0
         u32 interrupt171 : 1;                    // DWORD 0
         u32 interrupt170 : 1;                    // DWORD 0
         u32 interrupt169 : 1;                    // DWORD 0
         u32 interrupt168 : 1;                    // DWORD 0
         u32 interrupt167 : 1;                    // DWORD 0
         u32 interrupt166 : 1;                    // DWORD 0
         u32 interrupt165 : 1;                    // DWORD 0
         u32 interrupt164 : 1;                    // DWORD 0
         u32 interrupt163 : 1;                    // DWORD 0
         u32 interrupt162 : 1;                    // DWORD 0
         u32 interrupt161 : 1;                    // DWORD 0
         u32 interrupt160 : 1;                    // DWORD 0
      } SG_PACK CEV_ISR11_CSR, *PCEV_ISR11_CSR;

      typedef union _CEV_ISR11_CSR_UNION {
         CEV_ISR11_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR11_CSR_UNION, *PCEV_ISR11_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR11_CSR_UNION, sizeof (CEV_ISR11_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Register 11. The twelfth of twelve application interrupt status
   // registers. This register contains the interrupts for Event Queues EQ160 through
   // EQ191.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISR11_CSR {
         union {
            struct { 
               u32 interrupt160 : 1;              // DWORD 0
               u32 interrupt161 : 1;              // DWORD 0
               u32 interrupt162 : 1;              // DWORD 0
               u32 interrupt163 : 1;              // DWORD 0
               u32 interrupt164 : 1;              // DWORD 0
               u32 interrupt165 : 1;              // DWORD 0
               u32 interrupt166 : 1;              // DWORD 0
               u32 interrupt167 : 1;              // DWORD 0
               u32 interrupt168 : 1;              // DWORD 0
               u32 interrupt169 : 1;              // DWORD 0
               u32 interrupt170 : 1;              // DWORD 0
               u32 interrupt171 : 1;              // DWORD 0
               u32 interrupt172 : 1;              // DWORD 0
               u32 interrupt173 : 1;              // DWORD 0
               u32 interrupt174 : 1;              // DWORD 0
               u32 interrupt175 : 1;              // DWORD 0
               u32 interrupt176 : 1;              // DWORD 0
               u32 interrupt177 : 1;              // DWORD 0
               u32 interrupt178 : 1;              // DWORD 0
               u32 interrupt179 : 1;              // DWORD 0
               u32 interrupt180 : 1;              // DWORD 0
               u32 interrupt181 : 1;              // DWORD 0
               u32 interrupt182 : 1;              // DWORD 0
               u32 interrupt183 : 1;              // DWORD 0
               u32 interrupt184 : 1;              // DWORD 0
               u32 interrupt185 : 1;              // DWORD 0
               u32 interrupt186 : 1;              // DWORD 0
               u32 interrupt187 : 1;              // DWORD 0
               u32 interrupt188 : 1;              // DWORD 0
               u32 interrupt189 : 1;              // DWORD 0
               u32 interrupt190 : 1;              // DWORD 0
               u32 interrupt191 : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISR11_CSR, *PCEV_ISR11_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISR11_CSR, sizeof (CEV_ISR11_CSR) == 4);

   #else
      typedef struct _CEV_ISR11_CSR {
         u32 interrupt160 : 1;                    // DWORD 0
         u32 interrupt161 : 1;                    // DWORD 0
         u32 interrupt162 : 1;                    // DWORD 0
         u32 interrupt163 : 1;                    // DWORD 0
         u32 interrupt164 : 1;                    // DWORD 0
         u32 interrupt165 : 1;                    // DWORD 0
         u32 interrupt166 : 1;                    // DWORD 0
         u32 interrupt167 : 1;                    // DWORD 0
         u32 interrupt168 : 1;                    // DWORD 0
         u32 interrupt169 : 1;                    // DWORD 0
         u32 interrupt170 : 1;                    // DWORD 0
         u32 interrupt171 : 1;                    // DWORD 0
         u32 interrupt172 : 1;                    // DWORD 0
         u32 interrupt173 : 1;                    // DWORD 0
         u32 interrupt174 : 1;                    // DWORD 0
         u32 interrupt175 : 1;                    // DWORD 0
         u32 interrupt176 : 1;                    // DWORD 0
         u32 interrupt177 : 1;                    // DWORD 0
         u32 interrupt178 : 1;                    // DWORD 0
         u32 interrupt179 : 1;                    // DWORD 0
         u32 interrupt180 : 1;                    // DWORD 0
         u32 interrupt181 : 1;                    // DWORD 0
         u32 interrupt182 : 1;                    // DWORD 0
         u32 interrupt183 : 1;                    // DWORD 0
         u32 interrupt184 : 1;                    // DWORD 0
         u32 interrupt185 : 1;                    // DWORD 0
         u32 interrupt186 : 1;                    // DWORD 0
         u32 interrupt187 : 1;                    // DWORD 0
         u32 interrupt188 : 1;                    // DWORD 0
         u32 interrupt189 : 1;                    // DWORD 0
         u32 interrupt190 : 1;                    // DWORD 0
         u32 interrupt191 : 1;                    // DWORD 0
      } SG_PACK CEV_ISR11_CSR, *PCEV_ISR11_CSR;

      typedef union _CEV_ISR11_CSR_UNION {
         CEV_ISR11_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISR11_CSR_UNION, *PCEV_ISR11_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISR11_CSR_UNION, sizeof (CEV_ISR11_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 0. The first of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ0 through EQ7. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR0_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR0_CSR, *PCEV_IMR0_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR0_CSR, sizeof (CEV_IMR0_CSR) == 4);

   #else
      typedef struct _CEV_IMR0_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR0_CSR, *PCEV_IMR0_CSR;

      typedef union _CEV_IMR0_CSR_UNION {
         CEV_IMR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR0_CSR_UNION, *PCEV_IMR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR0_CSR_UNION, sizeof (CEV_IMR0_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 0. The first of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ0 through EQ7. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR0_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR0_CSR, *PCEV_IMR0_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR0_CSR, sizeof (CEV_IMR0_CSR) == 4);

   #else
      typedef struct _CEV_IMR0_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR0_CSR, *PCEV_IMR0_CSR;

      typedef union _CEV_IMR0_CSR_UNION {
         CEV_IMR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR0_CSR_UNION, *PCEV_IMR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR0_CSR_UNION, sizeof (CEV_IMR0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 1. The second of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ8 through
   // EQ15. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR1_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR1_CSR, *PCEV_IMR1_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR1_CSR, sizeof (CEV_IMR1_CSR) == 4);

   #else
      typedef struct _CEV_IMR1_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR1_CSR, *PCEV_IMR1_CSR;

      typedef union _CEV_IMR1_CSR_UNION {
         CEV_IMR1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR1_CSR_UNION, *PCEV_IMR1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR1_CSR_UNION, sizeof (CEV_IMR1_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 1. The second of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ8 through
   // EQ15. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR1_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR1_CSR, *PCEV_IMR1_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR1_CSR, sizeof (CEV_IMR1_CSR) == 4);

   #else
      typedef struct _CEV_IMR1_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR1_CSR, *PCEV_IMR1_CSR;

      typedef union _CEV_IMR1_CSR_UNION {
         CEV_IMR1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR1_CSR_UNION, *PCEV_IMR1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR1_CSR_UNION, sizeof (CEV_IMR1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 2. The third of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ16 through EQ23. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR2_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR2_CSR, *PCEV_IMR2_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR2_CSR, sizeof (CEV_IMR2_CSR) == 4);

   #else
      typedef struct _CEV_IMR2_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR2_CSR, *PCEV_IMR2_CSR;

      typedef union _CEV_IMR2_CSR_UNION {
         CEV_IMR2_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR2_CSR_UNION, *PCEV_IMR2_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR2_CSR_UNION, sizeof (CEV_IMR2_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 2. The third of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ16 through EQ23. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR2_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR2_CSR, *PCEV_IMR2_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR2_CSR, sizeof (CEV_IMR2_CSR) == 4);

   #else
      typedef struct _CEV_IMR2_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR2_CSR, *PCEV_IMR2_CSR;

      typedef union _CEV_IMR2_CSR_UNION {
         CEV_IMR2_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR2_CSR_UNION, *PCEV_IMR2_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR2_CSR_UNION, sizeof (CEV_IMR2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 3. The fourth of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ24 through
   // EQ31. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR3_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR3_CSR, *PCEV_IMR3_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR3_CSR, sizeof (CEV_IMR3_CSR) == 4);

   #else
      typedef struct _CEV_IMR3_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR3_CSR, *PCEV_IMR3_CSR;

      typedef union _CEV_IMR3_CSR_UNION {
         CEV_IMR3_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR3_CSR_UNION, *PCEV_IMR3_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR3_CSR_UNION, sizeof (CEV_IMR3_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 3. The fourth of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ24 through
   // EQ31. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR3_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR3_CSR, *PCEV_IMR3_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR3_CSR, sizeof (CEV_IMR3_CSR) == 4);

   #else
      typedef struct _CEV_IMR3_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR3_CSR, *PCEV_IMR3_CSR;

      typedef union _CEV_IMR3_CSR_UNION {
         CEV_IMR3_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR3_CSR_UNION, *PCEV_IMR3_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR3_CSR_UNION, sizeof (CEV_IMR3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 4. The fifth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ32 through EQ39. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR4_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR4_CSR, *PCEV_IMR4_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR4_CSR, sizeof (CEV_IMR4_CSR) == 4);

   #else
      typedef struct _CEV_IMR4_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR4_CSR, *PCEV_IMR4_CSR;

      typedef union _CEV_IMR4_CSR_UNION {
         CEV_IMR4_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR4_CSR_UNION, *PCEV_IMR4_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR4_CSR_UNION, sizeof (CEV_IMR4_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 4. The fifth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ32 through EQ39. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR4_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR4_CSR, *PCEV_IMR4_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR4_CSR, sizeof (CEV_IMR4_CSR) == 4);

   #else
      typedef struct _CEV_IMR4_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR4_CSR, *PCEV_IMR4_CSR;

      typedef union _CEV_IMR4_CSR_UNION {
         CEV_IMR4_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR4_CSR_UNION, *PCEV_IMR4_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR4_CSR_UNION, sizeof (CEV_IMR4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 5. The sixth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ40 through EQ47. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR5_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR5_CSR, *PCEV_IMR5_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR5_CSR, sizeof (CEV_IMR5_CSR) == 4);

   #else
      typedef struct _CEV_IMR5_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR5_CSR, *PCEV_IMR5_CSR;

      typedef union _CEV_IMR5_CSR_UNION {
         CEV_IMR5_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR5_CSR_UNION, *PCEV_IMR5_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR5_CSR_UNION, sizeof (CEV_IMR5_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 5. The sixth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ40 through EQ47. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR5_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR5_CSR, *PCEV_IMR5_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR5_CSR, sizeof (CEV_IMR5_CSR) == 4);

   #else
      typedef struct _CEV_IMR5_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR5_CSR, *PCEV_IMR5_CSR;

      typedef union _CEV_IMR5_CSR_UNION {
         CEV_IMR5_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR5_CSR_UNION, *PCEV_IMR5_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR5_CSR_UNION, sizeof (CEV_IMR5_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 6. The seventh of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ48 through
   // EQ55. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR6_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR6_CSR, *PCEV_IMR6_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR6_CSR, sizeof (CEV_IMR6_CSR) == 4);

   #else
      typedef struct _CEV_IMR6_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR6_CSR, *PCEV_IMR6_CSR;

      typedef union _CEV_IMR6_CSR_UNION {
         CEV_IMR6_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR6_CSR_UNION, *PCEV_IMR6_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR6_CSR_UNION, sizeof (CEV_IMR6_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 6. The seventh of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ48 through
   // EQ55. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR6_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR6_CSR, *PCEV_IMR6_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR6_CSR, sizeof (CEV_IMR6_CSR) == 4);

   #else
      typedef struct _CEV_IMR6_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR6_CSR, *PCEV_IMR6_CSR;

      typedef union _CEV_IMR6_CSR_UNION {
         CEV_IMR6_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR6_CSR_UNION, *PCEV_IMR6_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR6_CSR_UNION, sizeof (CEV_IMR6_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 7. The eigth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ56 through EQ63. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR7_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 mask : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR7_CSR, *PCEV_IMR7_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR7_CSR, sizeof (CEV_IMR7_CSR) == 4);

   #else
      typedef struct _CEV_IMR7_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 mask : 8;                            // DWORD 0
      } SG_PACK CEV_IMR7_CSR, *PCEV_IMR7_CSR;

      typedef union _CEV_IMR7_CSR_UNION {
         CEV_IMR7_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR7_CSR_UNION, *PCEV_IMR7_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR7_CSR_UNION, sizeof (CEV_IMR7_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 7. The eigth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ56 through EQ63. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR7_CSR {
         union {
            struct { 
               u32 mask : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR7_CSR, *PCEV_IMR7_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR7_CSR, sizeof (CEV_IMR7_CSR) == 4);

   #else
      typedef struct _CEV_IMR7_CSR {
         u32 mask : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_IMR7_CSR, *PCEV_IMR7_CSR;

      typedef union _CEV_IMR7_CSR_UNION {
         CEV_IMR7_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR7_CSR_UNION, *PCEV_IMR7_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR7_CSR_UNION, sizeof (CEV_IMR7_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 8. The ninth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ64 through EQ95. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR8_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR8_CSR, *PCEV_IMR8_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR8_CSR, sizeof (CEV_IMR8_CSR) == 4);

   #else
      typedef struct _CEV_IMR8_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR8_CSR, *PCEV_IMR8_CSR;

      typedef union _CEV_IMR8_CSR_UNION {
         CEV_IMR8_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR8_CSR_UNION, *PCEV_IMR8_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR8_CSR_UNION, sizeof (CEV_IMR8_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 8. The ninth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ64 through EQ95. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR8_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR8_CSR, *PCEV_IMR8_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR8_CSR, sizeof (CEV_IMR8_CSR) == 4);

   #else
      typedef struct _CEV_IMR8_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR8_CSR, *PCEV_IMR8_CSR;

      typedef union _CEV_IMR8_CSR_UNION {
         CEV_IMR8_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR8_CSR_UNION, *PCEV_IMR8_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR8_CSR_UNION, sizeof (CEV_IMR8_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 9. The tenth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ96 through EQ127. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR9_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR9_CSR, *PCEV_IMR9_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR9_CSR, sizeof (CEV_IMR9_CSR) == 4);

   #else
      typedef struct _CEV_IMR9_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR9_CSR, *PCEV_IMR9_CSR;

      typedef union _CEV_IMR9_CSR_UNION {
         CEV_IMR9_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR9_CSR_UNION, *PCEV_IMR9_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR9_CSR_UNION, sizeof (CEV_IMR9_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 9. The tenth of twelve application interrupt mask registers.
   // This register contains the interrupt mask for Event Queues EQ96 through EQ127. Note
   // that this is a conventional read/write register, whose bits are only modified by
   // software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR9_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR9_CSR, *PCEV_IMR9_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR9_CSR, sizeof (CEV_IMR9_CSR) == 4);

   #else
      typedef struct _CEV_IMR9_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR9_CSR, *PCEV_IMR9_CSR;

      typedef union _CEV_IMR9_CSR_UNION {
         CEV_IMR9_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR9_CSR_UNION, *PCEV_IMR9_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR9_CSR_UNION, sizeof (CEV_IMR9_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 10. The eleventh of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ128 through
   // EQ159. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR10_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR10_CSR, *PCEV_IMR10_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR10_CSR, sizeof (CEV_IMR10_CSR) == 4);

   #else
      typedef struct _CEV_IMR10_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR10_CSR, *PCEV_IMR10_CSR;

      typedef union _CEV_IMR10_CSR_UNION {
         CEV_IMR10_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR10_CSR_UNION, *PCEV_IMR10_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR10_CSR_UNION, sizeof (CEV_IMR10_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 10. The eleventh of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ128 through
   // EQ159. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR10_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR10_CSR, *PCEV_IMR10_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR10_CSR, sizeof (CEV_IMR10_CSR) == 4);

   #else
      typedef struct _CEV_IMR10_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR10_CSR, *PCEV_IMR10_CSR;

      typedef union _CEV_IMR10_CSR_UNION {
         CEV_IMR10_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR10_CSR_UNION, *PCEV_IMR10_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR10_CSR_UNION, sizeof (CEV_IMR10_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Mask Register 11. The twelfth of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ160 through
   // EQ191. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR11_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR11_CSR, *PCEV_IMR11_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR11_CSR, sizeof (CEV_IMR11_CSR) == 4);

   #else
      typedef struct _CEV_IMR11_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR11_CSR, *PCEV_IMR11_CSR;

      typedef union _CEV_IMR11_CSR_UNION {
         CEV_IMR11_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR11_CSR_UNION, *PCEV_IMR11_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR11_CSR_UNION, sizeof (CEV_IMR11_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Mask Register 11. The twelfth of twelve application interrupt mask
   // registers. This register contains the interrupt mask for Event Queues EQ160 through
   // EQ191. Note that this is a conventional read/write register, whose bits are only
   // modified by software or by reset.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_IMR11_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_IMR11_CSR, *PCEV_IMR11_CSR;

      SG_C_ASSERT(__sizeof__CEV_IMR11_CSR, sizeof (CEV_IMR11_CSR) == 4);

   #else
      typedef struct _CEV_IMR11_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK CEV_IMR11_CSR, *PCEV_IMR11_CSR;

      typedef union _CEV_IMR11_CSR_UNION {
         CEV_IMR11_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_IMR11_CSR_UNION, *PCEV_IMR11_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_IMR11_CSR_UNION, sizeof (CEV_IMR11_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 0. The first of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ0 through EQ7. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR0_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR0_CSR, *PCEV_ISCR0_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR0_CSR, sizeof (CEV_ISCR0_CSR) == 4);

   #else
      typedef struct _CEV_ISCR0_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR0_CSR, *PCEV_ISCR0_CSR;

      typedef union _CEV_ISCR0_CSR_UNION {
         CEV_ISCR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR0_CSR_UNION, *PCEV_ISCR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR0_CSR_UNION, sizeof (CEV_ISCR0_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 0. The first of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ0 through EQ7. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR0_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR0_CSR, *PCEV_ISCR0_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR0_CSR, sizeof (CEV_ISCR0_CSR) == 4);

   #else
      typedef struct _CEV_ISCR0_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR0_CSR, *PCEV_ISCR0_CSR;

      typedef union _CEV_ISCR0_CSR_UNION {
         CEV_ISCR0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR0_CSR_UNION, *PCEV_ISCR0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR0_CSR_UNION, sizeof (CEV_ISCR0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 1. The second of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ8 through EQ15. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR1_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR1_CSR, *PCEV_ISCR1_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR1_CSR, sizeof (CEV_ISCR1_CSR) == 4);

   #else
      typedef struct _CEV_ISCR1_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR1_CSR, *PCEV_ISCR1_CSR;

      typedef union _CEV_ISCR1_CSR_UNION {
         CEV_ISCR1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR1_CSR_UNION, *PCEV_ISCR1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR1_CSR_UNION, sizeof (CEV_ISCR1_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 1. The second of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ8 through EQ15. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR1_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR1_CSR, *PCEV_ISCR1_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR1_CSR, sizeof (CEV_ISCR1_CSR) == 4);

   #else
      typedef struct _CEV_ISCR1_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR1_CSR, *PCEV_ISCR1_CSR;

      typedef union _CEV_ISCR1_CSR_UNION {
         CEV_ISCR1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR1_CSR_UNION, *PCEV_ISCR1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR1_CSR_UNION, sizeof (CEV_ISCR1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 2. The third of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ16 through EQ23. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR2_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR2_CSR, *PCEV_ISCR2_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR2_CSR, sizeof (CEV_ISCR2_CSR) == 4);

   #else
      typedef struct _CEV_ISCR2_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR2_CSR, *PCEV_ISCR2_CSR;

      typedef union _CEV_ISCR2_CSR_UNION {
         CEV_ISCR2_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR2_CSR_UNION, *PCEV_ISCR2_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR2_CSR_UNION, sizeof (CEV_ISCR2_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 2. The third of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ16 through EQ23. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR2_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR2_CSR, *PCEV_ISCR2_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR2_CSR, sizeof (CEV_ISCR2_CSR) == 4);

   #else
      typedef struct _CEV_ISCR2_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR2_CSR, *PCEV_ISCR2_CSR;

      typedef union _CEV_ISCR2_CSR_UNION {
         CEV_ISCR2_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR2_CSR_UNION, *PCEV_ISCR2_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR2_CSR_UNION, sizeof (CEV_ISCR2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 3. The fourth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ24 through EQ31. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR3_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR3_CSR, *PCEV_ISCR3_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR3_CSR, sizeof (CEV_ISCR3_CSR) == 4);

   #else
      typedef struct _CEV_ISCR3_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR3_CSR, *PCEV_ISCR3_CSR;

      typedef union _CEV_ISCR3_CSR_UNION {
         CEV_ISCR3_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR3_CSR_UNION, *PCEV_ISCR3_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR3_CSR_UNION, sizeof (CEV_ISCR3_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 3. The fourth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ24 through EQ31. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR3_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR3_CSR, *PCEV_ISCR3_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR3_CSR, sizeof (CEV_ISCR3_CSR) == 4);

   #else
      typedef struct _CEV_ISCR3_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR3_CSR, *PCEV_ISCR3_CSR;

      typedef union _CEV_ISCR3_CSR_UNION {
         CEV_ISCR3_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR3_CSR_UNION, *PCEV_ISCR3_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR3_CSR_UNION, sizeof (CEV_ISCR3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 4. The fifth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ32 through EQ39. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR4_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR4_CSR, *PCEV_ISCR4_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR4_CSR, sizeof (CEV_ISCR4_CSR) == 4);

   #else
      typedef struct _CEV_ISCR4_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR4_CSR, *PCEV_ISCR4_CSR;

      typedef union _CEV_ISCR4_CSR_UNION {
         CEV_ISCR4_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR4_CSR_UNION, *PCEV_ISCR4_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR4_CSR_UNION, sizeof (CEV_ISCR4_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 4. The fifth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ32 through EQ39. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR4_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR4_CSR, *PCEV_ISCR4_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR4_CSR, sizeof (CEV_ISCR4_CSR) == 4);

   #else
      typedef struct _CEV_ISCR4_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR4_CSR, *PCEV_ISCR4_CSR;

      typedef union _CEV_ISCR4_CSR_UNION {
         CEV_ISCR4_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR4_CSR_UNION, *PCEV_ISCR4_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR4_CSR_UNION, sizeof (CEV_ISCR4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 5. The sixth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ40 through EQ47. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR5_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR5_CSR, *PCEV_ISCR5_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR5_CSR, sizeof (CEV_ISCR5_CSR) == 4);

   #else
      typedef struct _CEV_ISCR5_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR5_CSR, *PCEV_ISCR5_CSR;

      typedef union _CEV_ISCR5_CSR_UNION {
         CEV_ISCR5_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR5_CSR_UNION, *PCEV_ISCR5_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR5_CSR_UNION, sizeof (CEV_ISCR5_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 5. The sixth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ40 through EQ47. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR5_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR5_CSR, *PCEV_ISCR5_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR5_CSR, sizeof (CEV_ISCR5_CSR) == 4);

   #else
      typedef struct _CEV_ISCR5_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR5_CSR, *PCEV_ISCR5_CSR;

      typedef union _CEV_ISCR5_CSR_UNION {
         CEV_ISCR5_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR5_CSR_UNION, *PCEV_ISCR5_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR5_CSR_UNION, sizeof (CEV_ISCR5_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 6. The seventh of twelve application interrupt
   // status clear registers. This register contains the interrupt status clear bits for
   // Event Queues EQ48 through EQ55. Note that this is a conventional read/write
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR6_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR6_CSR, *PCEV_ISCR6_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR6_CSR, sizeof (CEV_ISCR6_CSR) == 4);

   #else
      typedef struct _CEV_ISCR6_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR6_CSR, *PCEV_ISCR6_CSR;

      typedef union _CEV_ISCR6_CSR_UNION {
         CEV_ISCR6_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR6_CSR_UNION, *PCEV_ISCR6_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR6_CSR_UNION, sizeof (CEV_ISCR6_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 6. The seventh of twelve application interrupt
   // status clear registers. This register contains the interrupt status clear bits for
   // Event Queues EQ48 through EQ55. Note that this is a conventional read/write
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR6_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR6_CSR, *PCEV_ISCR6_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR6_CSR, sizeof (CEV_ISCR6_CSR) == 4);

   #else
      typedef struct _CEV_ISCR6_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR6_CSR, *PCEV_ISCR6_CSR;

      typedef union _CEV_ISCR6_CSR_UNION {
         CEV_ISCR6_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR6_CSR_UNION, *PCEV_ISCR6_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR6_CSR_UNION, sizeof (CEV_ISCR6_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 7. The eigth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ56 through EQ64. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR7_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 clear : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR7_CSR, *PCEV_ISCR7_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR7_CSR, sizeof (CEV_ISCR7_CSR) == 4);

   #else
      typedef struct _CEV_ISCR7_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 clear : 8;                           // DWORD 0
      } SG_PACK CEV_ISCR7_CSR, *PCEV_ISCR7_CSR;

      typedef union _CEV_ISCR7_CSR_UNION {
         CEV_ISCR7_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR7_CSR_UNION, *PCEV_ISCR7_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR7_CSR_UNION, sizeof (CEV_ISCR7_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 7. The eigth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ56 through EQ64. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR7_CSR {
         union {
            struct { 
               u32 clear : 8;                     // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR7_CSR, *PCEV_ISCR7_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR7_CSR, sizeof (CEV_ISCR7_CSR) == 4);

   #else
      typedef struct _CEV_ISCR7_CSR {
         u32 clear : 8;                           // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK CEV_ISCR7_CSR, *PCEV_ISCR7_CSR;

      typedef union _CEV_ISCR7_CSR_UNION {
         CEV_ISCR7_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR7_CSR_UNION, *PCEV_ISCR7_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR7_CSR_UNION, sizeof (CEV_ISCR7_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 8. The ninth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ64 through EQ95. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR8_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR8_CSR, *PCEV_ISCR8_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR8_CSR, sizeof (CEV_ISCR8_CSR) == 4);

   #else
      typedef struct _CEV_ISCR8_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR8_CSR, *PCEV_ISCR8_CSR;

      typedef union _CEV_ISCR8_CSR_UNION {
         CEV_ISCR8_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR8_CSR_UNION, *PCEV_ISCR8_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR8_CSR_UNION, sizeof (CEV_ISCR8_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 8. The ninth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ64 through EQ95. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR8_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR8_CSR, *PCEV_ISCR8_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR8_CSR, sizeof (CEV_ISCR8_CSR) == 4);

   #else
      typedef struct _CEV_ISCR8_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR8_CSR, *PCEV_ISCR8_CSR;

      typedef union _CEV_ISCR8_CSR_UNION {
         CEV_ISCR8_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR8_CSR_UNION, *PCEV_ISCR8_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR8_CSR_UNION, sizeof (CEV_ISCR8_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 9. The tenth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ96 through EQ127. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR9_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR9_CSR, *PCEV_ISCR9_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR9_CSR, sizeof (CEV_ISCR9_CSR) == 4);

   #else
      typedef struct _CEV_ISCR9_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR9_CSR, *PCEV_ISCR9_CSR;

      typedef union _CEV_ISCR9_CSR_UNION {
         CEV_ISCR9_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR9_CSR_UNION, *PCEV_ISCR9_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR9_CSR_UNION, sizeof (CEV_ISCR9_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 9. The tenth of twelve application interrupt status
   // clear registers. This register contains the interrupt status clear bits for Event
   // Queues EQ96 through EQ127. Note that this is a conventional read/write register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR9_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR9_CSR, *PCEV_ISCR9_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR9_CSR, sizeof (CEV_ISCR9_CSR) == 4);

   #else
      typedef struct _CEV_ISCR9_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR9_CSR, *PCEV_ISCR9_CSR;

      typedef union _CEV_ISCR9_CSR_UNION {
         CEV_ISCR9_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR9_CSR_UNION, *PCEV_ISCR9_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR9_CSR_UNION, sizeof (CEV_ISCR9_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 10. The eleventh of twelve application interrupt
   // status clear registers. This register contains the interrupt status clear bits for
   // Event Queues EQ128 through EQ159. Note that this is a conventional read/write
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR10_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR10_CSR, *PCEV_ISCR10_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR10_CSR, sizeof (CEV_ISCR10_CSR) == 4);

   #else
      typedef struct _CEV_ISCR10_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR10_CSR, *PCEV_ISCR10_CSR;

      typedef union _CEV_ISCR10_CSR_UNION {
         CEV_ISCR10_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR10_CSR_UNION, *PCEV_ISCR10_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR10_CSR_UNION, sizeof (CEV_ISCR10_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 10. The eleventh of twelve application interrupt
   // status clear registers. This register contains the interrupt status clear bits for
   // Event Queues EQ128 through EQ159. Note that this is a conventional read/write
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR10_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR10_CSR, *PCEV_ISCR10_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR10_CSR, sizeof (CEV_ISCR10_CSR) == 4);

   #else
      typedef struct _CEV_ISCR10_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR10_CSR, *PCEV_ISCR10_CSR;

      typedef union _CEV_ISCR10_CSR_UNION {
         CEV_ISCR10_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR10_CSR_UNION, *PCEV_ISCR10_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR10_CSR_UNION, sizeof (CEV_ISCR10_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Status Clear Register 11. The twelfth of twelve application interrupt
   // status clear registers. This register contains the interrupt status clear bits for
   // Event Queues EQ160 through EQ191. Note that this is a conventional read/write
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR11_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR11_CSR, *PCEV_ISCR11_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR11_CSR, sizeof (CEV_ISCR11_CSR) == 4);

   #else
      typedef struct _CEV_ISCR11_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR11_CSR, *PCEV_ISCR11_CSR;

      typedef union _CEV_ISCR11_CSR_UNION {
         CEV_ISCR11_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR11_CSR_UNION, *PCEV_ISCR11_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR11_CSR_UNION, sizeof (CEV_ISCR11_CSR_UNION) == 4);
   #endif


#else
   // Interrupt Status Clear Register 11. The twelfth of twelve application interrupt
   // status clear registers. This register contains the interrupt status clear bits for
   // Event Queues EQ160 through EQ191. Note that this is a conventional read/write
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_ISCR11_CSR {
         union {
            struct { 
               u32 clear;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_ISCR11_CSR, *PCEV_ISCR11_CSR;

      SG_C_ASSERT(__sizeof__CEV_ISCR11_CSR, sizeof (CEV_ISCR11_CSR) == 4);

   #else
      typedef struct _CEV_ISCR11_CSR {
         u32 clear;                               // DWORD 0
      } SG_PACK CEV_ISCR11_CSR, *PCEV_ISCR11_CSR;

      typedef union _CEV_ISCR11_CSR_UNION {
         CEV_ISCR11_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_ISCR11_CSR_UNION, *PCEV_ISCR11_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_ISCR11_CSR_UNION, sizeof (CEV_ISCR11_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This CSR is used as a selector for the multiplexor on bus used for interrupts. By
   // programming a 0 in f0_sel field all the interrupts bits (7 to 0) used for Physical
   // Function 0 would get mapped to 0 th bit of the Vector. Programming a 1 in f0_sel
   // would make 0 th and 1 st bit active and interrupt bits from 3 to 0 would get mapped
   // to 0 the bit and interrupt bits from 7:4 would get mapped to bit 1 for the Vector.
   // Similarly programming a 2 would make 4 interrupt bits active and bits from 7:6 ,
   // 5:4, 3:2, 1:0 would get mapped onto 4 , 3, 2, 1 bits of the interrupt vector.
   // Default value of 3 would make the mapping one to one. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_FUNC_INTX_MUX_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 f7_intx_sel : 2;               // DWORD 0
               u32 f6_intx_sel : 2;               // DWORD 0
               u32 f5_intx_sel : 2;               // DWORD 0
               u32 f4_intx_sel : 2;               // DWORD 0
               u32 f3_intx_sel : 2;               // DWORD 0
               u32 f2_intx_sel : 2;               // DWORD 0
               u32 f1_intx_sel : 2;               // DWORD 0
               u32 f0_intx_sel : 2;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_FUNC_INTX_MUX_CSR, *PCEV_FUNC_INTX_MUX_CSR;

      SG_C_ASSERT(__sizeof__CEV_FUNC_INTX_MUX_CSR, sizeof (CEV_FUNC_INTX_MUX_CSR) == 4);

   #else
      typedef struct _CEV_FUNC_INTX_MUX_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 f7_intx_sel : 2;                     // DWORD 0
         u32 f6_intx_sel : 2;                     // DWORD 0
         u32 f5_intx_sel : 2;                     // DWORD 0
         u32 f4_intx_sel : 2;                     // DWORD 0
         u32 f3_intx_sel : 2;                     // DWORD 0
         u32 f2_intx_sel : 2;                     // DWORD 0
         u32 f1_intx_sel : 2;                     // DWORD 0
         u32 f0_intx_sel : 2;                     // DWORD 0
      } SG_PACK CEV_FUNC_INTX_MUX_CSR, *PCEV_FUNC_INTX_MUX_CSR;

      typedef union _CEV_FUNC_INTX_MUX_CSR_UNION {
         CEV_FUNC_INTX_MUX_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_FUNC_INTX_MUX_CSR_UNION, *PCEV_FUNC_INTX_MUX_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_FUNC_INTX_MUX_CSR_UNION, sizeof (CEV_FUNC_INTX_MUX_CSR_UNION) == 4);
   #endif


#else
   // This CSR is used as a selector for the multiplexor on bus used for interrupts. By
   // programming a 0 in f0_sel field all the interrupts bits (7 to 0) used for Physical
   // Function 0 would get mapped to 0 th bit of the Vector. Programming a 1 in f0_sel
   // would make 0 th and 1 st bit active and interrupt bits from 3 to 0 would get mapped
   // to 0 the bit and interrupt bits from 7:4 would get mapped to bit 1 for the Vector.
   // Similarly programming a 2 would make 4 interrupt bits active and bits from 7:6 ,
   // 5:4, 3:2, 1:0 would get mapped onto 4 , 3, 2, 1 bits of the interrupt vector.
   // Default value of 3 would make the mapping one to one. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_FUNC_INTX_MUX_CSR {
         union {
            struct { 
               u32 f0_intx_sel : 2;               // DWORD 0
               u32 f1_intx_sel : 2;               // DWORD 0
               u32 f2_intx_sel : 2;               // DWORD 0
               u32 f3_intx_sel : 2;               // DWORD 0
               u32 f4_intx_sel : 2;               // DWORD 0
               u32 f5_intx_sel : 2;               // DWORD 0
               u32 f6_intx_sel : 2;               // DWORD 0
               u32 f7_intx_sel : 2;               // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_FUNC_INTX_MUX_CSR, *PCEV_FUNC_INTX_MUX_CSR;

      SG_C_ASSERT(__sizeof__CEV_FUNC_INTX_MUX_CSR, sizeof (CEV_FUNC_INTX_MUX_CSR) == 4);

   #else
      typedef struct _CEV_FUNC_INTX_MUX_CSR {
         u32 f0_intx_sel : 2;                     // DWORD 0
         u32 f1_intx_sel : 2;                     // DWORD 0
         u32 f2_intx_sel : 2;                     // DWORD 0
         u32 f3_intx_sel : 2;                     // DWORD 0
         u32 f4_intx_sel : 2;                     // DWORD 0
         u32 f5_intx_sel : 2;                     // DWORD 0
         u32 f6_intx_sel : 2;                     // DWORD 0
         u32 f7_intx_sel : 2;                     // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK CEV_FUNC_INTX_MUX_CSR, *PCEV_FUNC_INTX_MUX_CSR;

      typedef union _CEV_FUNC_INTX_MUX_CSR_UNION {
         CEV_FUNC_INTX_MUX_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_FUNC_INTX_MUX_CSR_UNION, *PCEV_FUNC_INTX_MUX_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_FUNC_INTX_MUX_CSR_UNION, sizeof (CEV_FUNC_INTX_MUX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Internal Interrupt Status Register. This register indicates the source/cause of CEV
   // internally generated interrupts. This register records exceptions incurred by CEV in
   // the course of its normal processing. Note that these interrupts are sent to the
   // on-chip MPU. When a CEV_INTERNAL_ISR_CSR bit gets set and its equivalent Mask bit in
   // CEV_INTERNAL_IMR_CSR is cleared (enabled), MPU is interrupted. This register has a
   // clear-on-read functionality. If the CEV_INTERNAL_ISR_CSR is set, the register bit is
   // cleared when software reads it AND the equivalent CEV_INTERNAL_IMR_CSR bit is also
   // automatically set, disabling further MPU interrupts from that source. Software
   // re-arms the interrupt by writing ones to the CEV_INTERNAL_ISR_CSR. When a one is
   // written to this register, the equivalent CEV_INTERNAL_IMR_CSR bit is cleared,
   // (re-)enabling the interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_INTERNAL_ISR_CSR {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 bad_wdma_resp : 1;             // DWORD 0
               u32 client_overflow : 1;           // DWORD 0
               u32 bad_db_qid : 1;                // DWORD 0
               u32 bad_ptc_acc : 1;               // DWORD 0
               u32 cq_rearm_eq_inv : 1;           // DWORD 0
               u32 cq_rearm_oflow : 1;            // DWORD 0
               u32 BTLR1_bad : 1;                 // DWORD 0
               u32 BTLR0_bad : 1;                 // DWORD 0
               u32 MPU_bad_push : 1;              // DWORD 0
               u32 TXP_bad_push : 1;              // DWORD 0
               u32 ERX_bad_push : 1;              // DWORD 0
               u32 RxULP2_bad_push : 1;           // DWORD 0
               u32 RxULP1_bad_push : 1;           // DWORD 0
               u32 RxULP0_bad_push : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_INTERNAL_ISR_CSR, *PCEV_INTERNAL_ISR_CSR;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_ISR_CSR, sizeof (CEV_INTERNAL_ISR_CSR) == 4);

   #else
      typedef struct _CEV_INTERNAL_ISR_CSR {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 bad_wdma_resp : 1;                   // DWORD 0
         u32 client_overflow : 1;                 // DWORD 0
         u32 bad_db_qid : 1;                      // DWORD 0
         u32 bad_ptc_acc : 1;                     // DWORD 0
         u32 cq_rearm_eq_inv : 1;                 // DWORD 0
         u32 cq_rearm_oflow : 1;                  // DWORD 0
         u32 BTLR1_bad : 1;                       // DWORD 0
         u32 BTLR0_bad : 1;                       // DWORD 0
         u32 MPU_bad_push : 1;                    // DWORD 0
         u32 TXP_bad_push : 1;                    // DWORD 0
         u32 ERX_bad_push : 1;                    // DWORD 0
         u32 RxULP2_bad_push : 1;                 // DWORD 0
         u32 RxULP1_bad_push : 1;                 // DWORD 0
         u32 RxULP0_bad_push : 1;                 // DWORD 0
      } SG_PACK CEV_INTERNAL_ISR_CSR, *PCEV_INTERNAL_ISR_CSR;

      typedef union _CEV_INTERNAL_ISR_CSR_UNION {
         CEV_INTERNAL_ISR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_INTERNAL_ISR_CSR_UNION, *PCEV_INTERNAL_ISR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_ISR_CSR_UNION, sizeof (CEV_INTERNAL_ISR_CSR_UNION) == 4);
   #endif


#else
   // Internal Interrupt Status Register. This register indicates the source/cause of CEV
   // internally generated interrupts. This register records exceptions incurred by CEV in
   // the course of its normal processing. Note that these interrupts are sent to the
   // on-chip MPU. When a CEV_INTERNAL_ISR_CSR bit gets set and its equivalent Mask bit in
   // CEV_INTERNAL_IMR_CSR is cleared (enabled), MPU is interrupted. This register has a
   // clear-on-read functionality. If the CEV_INTERNAL_ISR_CSR is set, the register bit is
   // cleared when software reads it AND the equivalent CEV_INTERNAL_IMR_CSR bit is also
   // automatically set, disabling further MPU interrupts from that source. Software
   // re-arms the interrupt by writing ones to the CEV_INTERNAL_ISR_CSR. When a one is
   // written to this register, the equivalent CEV_INTERNAL_IMR_CSR bit is cleared,
   // (re-)enabling the interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_INTERNAL_ISR_CSR {
         union {
            struct { 
               u32 RxULP0_bad_push : 1;           // DWORD 0
               u32 RxULP1_bad_push : 1;           // DWORD 0
               u32 RxULP2_bad_push : 1;           // DWORD 0
               u32 ERX_bad_push : 1;              // DWORD 0
               u32 TXP_bad_push : 1;              // DWORD 0
               u32 MPU_bad_push : 1;              // DWORD 0
               u32 BTLR0_bad : 1;                 // DWORD 0
               u32 BTLR1_bad : 1;                 // DWORD 0
               u32 cq_rearm_oflow : 1;            // DWORD 0
               u32 cq_rearm_eq_inv : 1;           // DWORD 0
               u32 bad_ptc_acc : 1;               // DWORD 0
               u32 bad_db_qid : 1;                // DWORD 0
               u32 client_overflow : 1;           // DWORD 0
               u32 bad_wdma_resp : 1;             // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_INTERNAL_ISR_CSR, *PCEV_INTERNAL_ISR_CSR;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_ISR_CSR, sizeof (CEV_INTERNAL_ISR_CSR) == 4);

   #else
      typedef struct _CEV_INTERNAL_ISR_CSR {
         u32 RxULP0_bad_push : 1;                 // DWORD 0
         u32 RxULP1_bad_push : 1;                 // DWORD 0
         u32 RxULP2_bad_push : 1;                 // DWORD 0
         u32 ERX_bad_push : 1;                    // DWORD 0
         u32 TXP_bad_push : 1;                    // DWORD 0
         u32 MPU_bad_push : 1;                    // DWORD 0
         u32 BTLR0_bad : 1;                       // DWORD 0
         u32 BTLR1_bad : 1;                       // DWORD 0
         u32 cq_rearm_oflow : 1;                  // DWORD 0
         u32 cq_rearm_eq_inv : 1;                 // DWORD 0
         u32 bad_ptc_acc : 1;                     // DWORD 0
         u32 bad_db_qid : 1;                      // DWORD 0
         u32 client_overflow : 1;                 // DWORD 0
         u32 bad_wdma_resp : 1;                   // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK CEV_INTERNAL_ISR_CSR, *PCEV_INTERNAL_ISR_CSR;

      typedef union _CEV_INTERNAL_ISR_CSR_UNION {
         CEV_INTERNAL_ISR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_INTERNAL_ISR_CSR_UNION, *PCEV_INTERNAL_ISR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_ISR_CSR_UNION, sizeof (CEV_INTERNAL_ISR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Internal Interrupt Mask Register. Mask register for CEV internal interrupts to MPU
   // defined in CEV_INTERNAL_ISR_CSR. Software access to this register is through the
   // CEV_INTERNAL_ISR_CSR. Software may enable or disable the CEV internal interrupts by
   // writing a one or disable respectively to the relevant bits in CEV_INTERNAL_ISR_CSR
   // register. Software writes of zero have no effect. Hardware automatically sets each
   // CEV_INTERNAL_IMR_CSR bit when software reads a one (an interrupt) from the
   // equivalent bit in the CEV_INTERNAL_ISR_CSR interrupt status register. Hardware
   // automatically clears each CEV_INTERNAL_IMR_CSR bit when software writes a one to the
   // equivalent bit in CEV_INTERNAL_ISR_CSR register. Note that software writes of zero
   // to this register have no effect; only writes of one update the relevant bit.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_INTERNAL_IMR_CSR {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 bad_wdma_resp : 1;             // DWORD 0
               u32 client_overflow : 1;           // DWORD 0
               u32 bad_db_qid : 1;                // DWORD 0
               u32 bad_ptc_acc : 1;               // DWORD 0
               u32 cq_rearm_eq_inv : 1;           // DWORD 0
               u32 cq_rearm_oflow : 1;            // DWORD 0
               u32 BTLR1_bad : 1;                 // DWORD 0
               u32 BTLR0_bad : 1;                 // DWORD 0
               u32 MPU_bad_push : 1;              // DWORD 0
               u32 TXP_bad_push : 1;              // DWORD 0
               u32 ERX_bad_push : 1;              // DWORD 0
               u32 RxULP2_bad_push : 1;           // DWORD 0
               u32 RxULP1_bad_push : 1;           // DWORD 0
               u32 RxULP0_bad_push : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_INTERNAL_IMR_CSR, *PCEV_INTERNAL_IMR_CSR;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_IMR_CSR, sizeof (CEV_INTERNAL_IMR_CSR) == 4);

   #else
      typedef struct _CEV_INTERNAL_IMR_CSR {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 bad_wdma_resp : 1;                   // DWORD 0
         u32 client_overflow : 1;                 // DWORD 0
         u32 bad_db_qid : 1;                      // DWORD 0
         u32 bad_ptc_acc : 1;                     // DWORD 0
         u32 cq_rearm_eq_inv : 1;                 // DWORD 0
         u32 cq_rearm_oflow : 1;                  // DWORD 0
         u32 BTLR1_bad : 1;                       // DWORD 0
         u32 BTLR0_bad : 1;                       // DWORD 0
         u32 MPU_bad_push : 1;                    // DWORD 0
         u32 TXP_bad_push : 1;                    // DWORD 0
         u32 ERX_bad_push : 1;                    // DWORD 0
         u32 RxULP2_bad_push : 1;                 // DWORD 0
         u32 RxULP1_bad_push : 1;                 // DWORD 0
         u32 RxULP0_bad_push : 1;                 // DWORD 0
      } SG_PACK CEV_INTERNAL_IMR_CSR, *PCEV_INTERNAL_IMR_CSR;

      typedef union _CEV_INTERNAL_IMR_CSR_UNION {
         CEV_INTERNAL_IMR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_INTERNAL_IMR_CSR_UNION, *PCEV_INTERNAL_IMR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_IMR_CSR_UNION, sizeof (CEV_INTERNAL_IMR_CSR_UNION) == 4);
   #endif


#else
   // Internal Interrupt Mask Register. Mask register for CEV internal interrupts to MPU
   // defined in CEV_INTERNAL_ISR_CSR. Software access to this register is through the
   // CEV_INTERNAL_ISR_CSR. Software may enable or disable the CEV internal interrupts by
   // writing a one or disable respectively to the relevant bits in CEV_INTERNAL_ISR_CSR
   // register. Software writes of zero have no effect. Hardware automatically sets each
   // CEV_INTERNAL_IMR_CSR bit when software reads a one (an interrupt) from the
   // equivalent bit in the CEV_INTERNAL_ISR_CSR interrupt status register. Hardware
   // automatically clears each CEV_INTERNAL_IMR_CSR bit when software writes a one to the
   // equivalent bit in CEV_INTERNAL_ISR_CSR register. Note that software writes of zero
   // to this register have no effect; only writes of one update the relevant bit.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_INTERNAL_IMR_CSR {
         union {
            struct { 
               u32 RxULP0_bad_push : 1;           // DWORD 0
               u32 RxULP1_bad_push : 1;           // DWORD 0
               u32 RxULP2_bad_push : 1;           // DWORD 0
               u32 ERX_bad_push : 1;              // DWORD 0
               u32 TXP_bad_push : 1;              // DWORD 0
               u32 MPU_bad_push : 1;              // DWORD 0
               u32 BTLR0_bad : 1;                 // DWORD 0
               u32 BTLR1_bad : 1;                 // DWORD 0
               u32 cq_rearm_oflow : 1;            // DWORD 0
               u32 cq_rearm_eq_inv : 1;           // DWORD 0
               u32 bad_ptc_acc : 1;               // DWORD 0
               u32 bad_db_qid : 1;                // DWORD 0
               u32 client_overflow : 1;           // DWORD 0
               u32 bad_wdma_resp : 1;             // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_INTERNAL_IMR_CSR, *PCEV_INTERNAL_IMR_CSR;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_IMR_CSR, sizeof (CEV_INTERNAL_IMR_CSR) == 4);

   #else
      typedef struct _CEV_INTERNAL_IMR_CSR {
         u32 RxULP0_bad_push : 1;                 // DWORD 0
         u32 RxULP1_bad_push : 1;                 // DWORD 0
         u32 RxULP2_bad_push : 1;                 // DWORD 0
         u32 ERX_bad_push : 1;                    // DWORD 0
         u32 TXP_bad_push : 1;                    // DWORD 0
         u32 MPU_bad_push : 1;                    // DWORD 0
         u32 BTLR0_bad : 1;                       // DWORD 0
         u32 BTLR1_bad : 1;                       // DWORD 0
         u32 cq_rearm_oflow : 1;                  // DWORD 0
         u32 cq_rearm_eq_inv : 1;                 // DWORD 0
         u32 bad_ptc_acc : 1;                     // DWORD 0
         u32 bad_db_qid : 1;                      // DWORD 0
         u32 client_overflow : 1;                 // DWORD 0
         u32 bad_wdma_resp : 1;                   // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK CEV_INTERNAL_IMR_CSR, *PCEV_INTERNAL_IMR_CSR;

      typedef union _CEV_INTERNAL_IMR_CSR_UNION {
         CEV_INTERNAL_IMR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_INTERNAL_IMR_CSR_UNION, *PCEV_INTERNAL_IMR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_INTERNAL_IMR_CSR_UNION, sizeof (CEV_INTERNAL_IMR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV State Machine Debug register. This read-only debug-mode register provides
   // read-only access to the current state of CEV internal state machines.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_SM_DEBUG0_CSR {
         union {
            struct { 
               u32 ptc_full : 1;                  // DWORD 0
               u32 eq_full : 1;                   // DWORD 0
               u32 cq_full : 1;                   // DWORD 0
               u32 ptc_ev_pending : 1;            // DWORD 0
               u32 desc_wr_req_pending : 3;       // DWORD 0
               u32 desc_alloc_req_pending : 2;    // DWORD 0
               u32 any_client_pending : 1;        // DWORD 0
               u32 btlr_acc_sm : 3;               // DWORD 0
               u32 csr_acc_sm : 3;                // DWORD 0
               u32 eqew_sm : 3;                   // DWORD 0
               u32 db_sm : 4;                     // DWORD 0
               u32 cl_req_sm : 4;                 // DWORD 0
               u32 eqe_desc_write_sm : 3;         // DWORD 0
               u32 desc_alloc_sm : 2;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_SM_DEBUG0_CSR, *PCEV_SM_DEBUG0_CSR;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG0_CSR, sizeof (CEV_SM_DEBUG0_CSR) == 4);

   #else
      typedef struct _CEV_SM_DEBUG0_CSR {
         u32 ptc_full : 1;                        // DWORD 0
         u32 eq_full : 1;                         // DWORD 0
         u32 cq_full : 1;                         // DWORD 0
         u32 ptc_ev_pending : 1;                  // DWORD 0
         u32 desc_wr_req_pending : 3;             // DWORD 0
         u32 desc_alloc_req_pending : 2;          // DWORD 0
         u32 any_client_pending : 1;              // DWORD 0
         u32 btlr_acc_sm : 3;                     // DWORD 0
         u32 csr_acc_sm : 3;                      // DWORD 0
         u32 eqew_sm : 3;                         // DWORD 0
         u32 db_sm : 4;                           // DWORD 0
         u32 cl_req_sm : 4;                       // DWORD 0
         u32 eqe_desc_write_sm : 3;               // DWORD 0
         u32 desc_alloc_sm : 2;                   // DWORD 0
      } SG_PACK CEV_SM_DEBUG0_CSR, *PCEV_SM_DEBUG0_CSR;

      typedef union _CEV_SM_DEBUG0_CSR_UNION {
         CEV_SM_DEBUG0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_SM_DEBUG0_CSR_UNION, *PCEV_SM_DEBUG0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG0_CSR_UNION, sizeof (CEV_SM_DEBUG0_CSR_UNION) == 4);
   #endif


#else
   // CEV State Machine Debug register. This read-only debug-mode register provides
   // read-only access to the current state of CEV internal state machines.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_SM_DEBUG0_CSR {
         union {
            struct { 
               u32 desc_alloc_sm : 2;             // DWORD 0
               u32 eqe_desc_write_sm : 3;         // DWORD 0
               u32 cl_req_sm : 4;                 // DWORD 0
               u32 db_sm : 4;                     // DWORD 0
               u32 eqew_sm : 3;                   // DWORD 0
               u32 csr_acc_sm : 3;                // DWORD 0
               u32 btlr_acc_sm : 3;               // DWORD 0
               u32 any_client_pending : 1;        // DWORD 0
               u32 desc_alloc_req_pending : 2;    // DWORD 0
               u32 desc_wr_req_pending : 3;       // DWORD 0
               u32 ptc_ev_pending : 1;            // DWORD 0
               u32 cq_full : 1;                   // DWORD 0
               u32 eq_full : 1;                   // DWORD 0
               u32 ptc_full : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_SM_DEBUG0_CSR, *PCEV_SM_DEBUG0_CSR;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG0_CSR, sizeof (CEV_SM_DEBUG0_CSR) == 4);

   #else
      typedef struct _CEV_SM_DEBUG0_CSR {
         u32 desc_alloc_sm : 2;                   // DWORD 0
         u32 eqe_desc_write_sm : 3;               // DWORD 0
         u32 cl_req_sm : 4;                       // DWORD 0
         u32 db_sm : 4;                           // DWORD 0
         u32 eqew_sm : 3;                         // DWORD 0
         u32 csr_acc_sm : 3;                      // DWORD 0
         u32 btlr_acc_sm : 3;                     // DWORD 0
         u32 any_client_pending : 1;              // DWORD 0
         u32 desc_alloc_req_pending : 2;          // DWORD 0
         u32 desc_wr_req_pending : 3;             // DWORD 0
         u32 ptc_ev_pending : 1;                  // DWORD 0
         u32 cq_full : 1;                         // DWORD 0
         u32 eq_full : 1;                         // DWORD 0
         u32 ptc_full : 1;                        // DWORD 0
      } SG_PACK CEV_SM_DEBUG0_CSR, *PCEV_SM_DEBUG0_CSR;

      typedef union _CEV_SM_DEBUG0_CSR_UNION {
         CEV_SM_DEBUG0_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_SM_DEBUG0_CSR_UNION, *PCEV_SM_DEBUG0_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG0_CSR_UNION, sizeof (CEV_SM_DEBUG0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Debug pending register. This read-only debug-mode register provides read-only
   // access to the current state of CEV internal state machines.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_SM_DEBUG1_CSR {
         union {
            struct { 
               u32 rsvd0 : 21;                    // DWORD 0
               u32 online : 1;                    // DWORD 0
               u32 wdma_full : 1;                 // DWORD 0
               u32 desc_write_sm : 3;             // DWORD 0
               u32 no_coalesc_sm : 3;             // DWORD 0
               u32 coalescing_sm : 3;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_SM_DEBUG1_CSR, *PCEV_SM_DEBUG1_CSR;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG1_CSR, sizeof (CEV_SM_DEBUG1_CSR) == 4);

   #else
      typedef struct _CEV_SM_DEBUG1_CSR {
         u32 rsvd0 : 21;                          // DWORD 0
         u32 online : 1;                          // DWORD 0
         u32 wdma_full : 1;                       // DWORD 0
         u32 desc_write_sm : 3;                   // DWORD 0
         u32 no_coalesc_sm : 3;                   // DWORD 0
         u32 coalescing_sm : 3;                   // DWORD 0
      } SG_PACK CEV_SM_DEBUG1_CSR, *PCEV_SM_DEBUG1_CSR;

      typedef union _CEV_SM_DEBUG1_CSR_UNION {
         CEV_SM_DEBUG1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_SM_DEBUG1_CSR_UNION, *PCEV_SM_DEBUG1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG1_CSR_UNION, sizeof (CEV_SM_DEBUG1_CSR_UNION) == 4);
   #endif


#else
   // CEV Debug pending register. This read-only debug-mode register provides read-only
   // access to the current state of CEV internal state machines.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_SM_DEBUG1_CSR {
         union {
            struct { 
               u32 coalescing_sm : 3;             // DWORD 0
               u32 no_coalesc_sm : 3;             // DWORD 0
               u32 desc_write_sm : 3;             // DWORD 0
               u32 wdma_full : 1;                 // DWORD 0
               u32 online : 1;                    // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_SM_DEBUG1_CSR, *PCEV_SM_DEBUG1_CSR;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG1_CSR, sizeof (CEV_SM_DEBUG1_CSR) == 4);

   #else
      typedef struct _CEV_SM_DEBUG1_CSR {
         u32 coalescing_sm : 3;                   // DWORD 0
         u32 no_coalesc_sm : 3;                   // DWORD 0
         u32 desc_write_sm : 3;                   // DWORD 0
         u32 wdma_full : 1;                       // DWORD 0
         u32 online : 1;                          // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK CEV_SM_DEBUG1_CSR, *PCEV_SM_DEBUG1_CSR;

      typedef union _CEV_SM_DEBUG1_CSR_UNION {
         CEV_SM_DEBUG1_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_SM_DEBUG1_CSR_UNION, *PCEV_SM_DEBUG1_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_SM_DEBUG1_CSR_UNION, sizeof (CEV_SM_DEBUG1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Error Information. In the Event of an Error within CEV, this register contains
   // further information on the offending transaction. Note that this register is updated
   // every time an Error occurs, (watch out for information loss).
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_RE_INFO_CSR {
         union {
            struct { 
               u32 rsvd1 : 14;                    // DWORD 0
               u32 cev_intx_contx_sram_init_over_dbg : 1; // DWORD 0
               u32 cev_sram_init_over_dbg : 1;    // DWORD 0
               u32 ptc_status : 4;                // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 cqid : 10;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_RE_INFO_CSR, *PCEV_RE_INFO_CSR;

      SG_C_ASSERT(__sizeof__CEV_RE_INFO_CSR, sizeof (CEV_RE_INFO_CSR) == 4);

   #else
      typedef struct _CEV_RE_INFO_CSR {
         u32 rsvd1 : 14;                          // DWORD 0
         u32 cev_intx_contx_sram_init_over_dbg : 1; // DWORD 0
         u32 cev_sram_init_over_dbg : 1;          // DWORD 0
         u32 ptc_status : 4;                      // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 cqid : 10;                           // DWORD 0
      } SG_PACK CEV_RE_INFO_CSR, *PCEV_RE_INFO_CSR;

      typedef union _CEV_RE_INFO_CSR_UNION {
         CEV_RE_INFO_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_RE_INFO_CSR_UNION, *PCEV_RE_INFO_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_RE_INFO_CSR_UNION, sizeof (CEV_RE_INFO_CSR_UNION) == 4);
   #endif


#else
   // CEV Error Information. In the Event of an Error within CEV, this register contains
   // further information on the offending transaction. Note that this register is updated
   // every time an Error occurs, (watch out for information loss).
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_RE_INFO_CSR {
         union {
            struct { 
               u32 cqid : 10;                     // DWORD 0
               u32 event : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ptc_status : 4;                // DWORD 0
               u32 cev_sram_init_over_dbg : 1;    // DWORD 0
               u32 cev_intx_contx_sram_init_over_dbg : 1; // DWORD 0
               u32 rsvd1 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_RE_INFO_CSR, *PCEV_RE_INFO_CSR;

      SG_C_ASSERT(__sizeof__CEV_RE_INFO_CSR, sizeof (CEV_RE_INFO_CSR) == 4);

   #else
      typedef struct _CEV_RE_INFO_CSR {
         u32 cqid : 10;                           // DWORD 0
         u32 event : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ptc_status : 4;                      // DWORD 0
         u32 cev_sram_init_over_dbg : 1;          // DWORD 0
         u32 cev_intx_contx_sram_init_over_dbg : 1; // DWORD 0
         u32 rsvd1 : 14;                          // DWORD 0
      } SG_PACK CEV_RE_INFO_CSR, *PCEV_RE_INFO_CSR;

      typedef union _CEV_RE_INFO_CSR_UNION {
         CEV_RE_INFO_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_RE_INFO_CSR_UNION, *PCEV_RE_INFO_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_RE_INFO_CSR_UNION, sizeof (CEV_RE_INFO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Unrecoverable Error Cause register. This a debug-only register, providing
   // details of Unrecoverable Error(s) that have occurred within CEV. The errors are
   // enabled (to be propagated to shut down the chip) via the adjacent CEV_UE_ENABLE_CSR
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_UNRECOVERABLE_ERROR_CSR {
         union {
            struct { 
               u32 bad_wdma_resp_status : 1;      // DWORD 0
               u32 sram_intx_contx_access_during_init : 1; // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 EQNumP_oflow : 1;              // DWORD 0
               u32 CQNumP_oflow : 1;              // DWORD 0
               u32 TooManyPops : 1;               // DWORD 0
               u32 wdma_fifo_oflow : 1;           // DWORD 0
               u32 wdma_fifo_uflow : 1;           // DWORD 0
               u32 erx_fifo_oflow : 1;            // DWORD 0
               u32 erx_fifo_uflow : 1;            // DWORD 0
               u32 ptc_resp_oflow : 1;            // DWORD 0
               u32 ptc_resp_uflow : 1;            // DWORD 0
               u32 txp_fifo_oflow : 1;            // DWORD 0
               u32 txp_fifo_uflow : 1;            // DWORD 0
               u32 mpu_fifo_oflow : 1;            // DWORD 0
               u32 mpu_fifo_uflow : 1;            // DWORD 0
               u32 rxulp2_fifo_oflow : 1;         // DWORD 0
               u32 rxulp2_fifo_uflow : 1;         // DWORD 0
               u32 rxulp1_fifo_oflow : 1;         // DWORD 0
               u32 rxulp1_fifo_uflow : 1;         // DWORD 0
               u32 rxulp0_fifo_oflow : 1;         // DWORD 0
               u32 rxulp0_fifo_uflow : 1;         // DWORD 0
               u32 eqe_write_fifo_oflow : 1;      // DWORD 0
               u32 eqe_write_fifo_uflow : 1;      // DWORD 0
               u32 eqe_alloc_fifo_oflow : 1;      // DWORD 0
               u32 eqe_alloc_fifo_uflow : 1;      // DWORD 0
               u32 eqid_fifo_oflow : 1;           // DWORD 0
               u32 eqid_fifo_uflow : 1;           // DWORD 0
               u32 db_fifo_oflow1 : 1;            // DWORD 0
               u32 bad_ptc_resp_status : 1;       // DWORD 0
               u32 tim_perr : 1;                  // DWORD 0
               u32 ctx_perr : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_UNRECOVERABLE_ERROR_CSR, *PCEV_UNRECOVERABLE_ERROR_CSR;

      SG_C_ASSERT(__sizeof__CEV_UNRECOVERABLE_ERROR_CSR, sizeof (CEV_UNRECOVERABLE_ERROR_CSR) == 4);

   #else
      typedef struct _CEV_UNRECOVERABLE_ERROR_CSR {
         u32 bad_wdma_resp_status : 1;            // DWORD 0
         u32 sram_intx_contx_access_during_init : 1; // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 EQNumP_oflow : 1;                    // DWORD 0
         u32 CQNumP_oflow : 1;                    // DWORD 0
         u32 TooManyPops : 1;                     // DWORD 0
         u32 wdma_fifo_oflow : 1;                 // DWORD 0
         u32 wdma_fifo_uflow : 1;                 // DWORD 0
         u32 erx_fifo_oflow : 1;                  // DWORD 0
         u32 erx_fifo_uflow : 1;                  // DWORD 0
         u32 ptc_resp_oflow : 1;                  // DWORD 0
         u32 ptc_resp_uflow : 1;                  // DWORD 0
         u32 txp_fifo_oflow : 1;                  // DWORD 0
         u32 txp_fifo_uflow : 1;                  // DWORD 0
         u32 mpu_fifo_oflow : 1;                  // DWORD 0
         u32 mpu_fifo_uflow : 1;                  // DWORD 0
         u32 rxulp2_fifo_oflow : 1;               // DWORD 0
         u32 rxulp2_fifo_uflow : 1;               // DWORD 0
         u32 rxulp1_fifo_oflow : 1;               // DWORD 0
         u32 rxulp1_fifo_uflow : 1;               // DWORD 0
         u32 rxulp0_fifo_oflow : 1;               // DWORD 0
         u32 rxulp0_fifo_uflow : 1;               // DWORD 0
         u32 eqe_write_fifo_oflow : 1;            // DWORD 0
         u32 eqe_write_fifo_uflow : 1;            // DWORD 0
         u32 eqe_alloc_fifo_oflow : 1;            // DWORD 0
         u32 eqe_alloc_fifo_uflow : 1;            // DWORD 0
         u32 eqid_fifo_oflow : 1;                 // DWORD 0
         u32 eqid_fifo_uflow : 1;                 // DWORD 0
         u32 db_fifo_oflow1 : 1;                  // DWORD 0
         u32 bad_ptc_resp_status : 1;             // DWORD 0
         u32 tim_perr : 1;                        // DWORD 0
         u32 ctx_perr : 1;                        // DWORD 0
      } SG_PACK CEV_UNRECOVERABLE_ERROR_CSR, *PCEV_UNRECOVERABLE_ERROR_CSR;

      typedef union _CEV_UNRECOVERABLE_ERROR_CSR_UNION {
         CEV_UNRECOVERABLE_ERROR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_UNRECOVERABLE_ERROR_CSR_UNION, *PCEV_UNRECOVERABLE_ERROR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_UNRECOVERABLE_ERROR_CSR_UNION, sizeof (CEV_UNRECOVERABLE_ERROR_CSR_UNION) == 4);
   #endif


#else
   // CEV Unrecoverable Error Cause register. This a debug-only register, providing
   // details of Unrecoverable Error(s) that have occurred within CEV. The errors are
   // enabled (to be propagated to shut down the chip) via the adjacent CEV_UE_ENABLE_CSR
   // register.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_UNRECOVERABLE_ERROR_CSR {
         union {
            struct { 
               u32 ctx_perr : 1;                  // DWORD 0
               u32 tim_perr : 1;                  // DWORD 0
               u32 bad_ptc_resp_status : 1;       // DWORD 0
               u32 db_fifo_oflow1 : 1;            // DWORD 0
               u32 eqid_fifo_uflow : 1;           // DWORD 0
               u32 eqid_fifo_oflow : 1;           // DWORD 0
               u32 eqe_alloc_fifo_uflow : 1;      // DWORD 0
               u32 eqe_alloc_fifo_oflow : 1;      // DWORD 0
               u32 eqe_write_fifo_uflow : 1;      // DWORD 0
               u32 eqe_write_fifo_oflow : 1;      // DWORD 0
               u32 rxulp0_fifo_uflow : 1;         // DWORD 0
               u32 rxulp0_fifo_oflow : 1;         // DWORD 0
               u32 rxulp1_fifo_uflow : 1;         // DWORD 0
               u32 rxulp1_fifo_oflow : 1;         // DWORD 0
               u32 rxulp2_fifo_uflow : 1;         // DWORD 0
               u32 rxulp2_fifo_oflow : 1;         // DWORD 0
               u32 mpu_fifo_uflow : 1;            // DWORD 0
               u32 mpu_fifo_oflow : 1;            // DWORD 0
               u32 txp_fifo_uflow : 1;            // DWORD 0
               u32 txp_fifo_oflow : 1;            // DWORD 0
               u32 ptc_resp_uflow : 1;            // DWORD 0
               u32 ptc_resp_oflow : 1;            // DWORD 0
               u32 erx_fifo_uflow : 1;            // DWORD 0
               u32 erx_fifo_oflow : 1;            // DWORD 0
               u32 wdma_fifo_uflow : 1;           // DWORD 0
               u32 wdma_fifo_oflow : 1;           // DWORD 0
               u32 TooManyPops : 1;               // DWORD 0
               u32 CQNumP_oflow : 1;              // DWORD 0
               u32 EQNumP_oflow : 1;              // DWORD 0
               u32 sram_access_during_init : 1;   // DWORD 0
               u32 sram_intx_contx_access_during_init : 1; // DWORD 0
               u32 bad_wdma_resp_status : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_UNRECOVERABLE_ERROR_CSR, *PCEV_UNRECOVERABLE_ERROR_CSR;

      SG_C_ASSERT(__sizeof__CEV_UNRECOVERABLE_ERROR_CSR, sizeof (CEV_UNRECOVERABLE_ERROR_CSR) == 4);

   #else
      typedef struct _CEV_UNRECOVERABLE_ERROR_CSR {
         u32 ctx_perr : 1;                        // DWORD 0
         u32 tim_perr : 1;                        // DWORD 0
         u32 bad_ptc_resp_status : 1;             // DWORD 0
         u32 db_fifo_oflow1 : 1;                  // DWORD 0
         u32 eqid_fifo_uflow : 1;                 // DWORD 0
         u32 eqid_fifo_oflow : 1;                 // DWORD 0
         u32 eqe_alloc_fifo_uflow : 1;            // DWORD 0
         u32 eqe_alloc_fifo_oflow : 1;            // DWORD 0
         u32 eqe_write_fifo_uflow : 1;            // DWORD 0
         u32 eqe_write_fifo_oflow : 1;            // DWORD 0
         u32 rxulp0_fifo_uflow : 1;               // DWORD 0
         u32 rxulp0_fifo_oflow : 1;               // DWORD 0
         u32 rxulp1_fifo_uflow : 1;               // DWORD 0
         u32 rxulp1_fifo_oflow : 1;               // DWORD 0
         u32 rxulp2_fifo_uflow : 1;               // DWORD 0
         u32 rxulp2_fifo_oflow : 1;               // DWORD 0
         u32 mpu_fifo_uflow : 1;                  // DWORD 0
         u32 mpu_fifo_oflow : 1;                  // DWORD 0
         u32 txp_fifo_uflow : 1;                  // DWORD 0
         u32 txp_fifo_oflow : 1;                  // DWORD 0
         u32 ptc_resp_uflow : 1;                  // DWORD 0
         u32 ptc_resp_oflow : 1;                  // DWORD 0
         u32 erx_fifo_uflow : 1;                  // DWORD 0
         u32 erx_fifo_oflow : 1;                  // DWORD 0
         u32 wdma_fifo_uflow : 1;                 // DWORD 0
         u32 wdma_fifo_oflow : 1;                 // DWORD 0
         u32 TooManyPops : 1;                     // DWORD 0
         u32 CQNumP_oflow : 1;                    // DWORD 0
         u32 EQNumP_oflow : 1;                    // DWORD 0
         u32 sram_access_during_init : 1;         // DWORD 0
         u32 sram_intx_contx_access_during_init : 1; // DWORD 0
         u32 bad_wdma_resp_status : 1;            // DWORD 0
      } SG_PACK CEV_UNRECOVERABLE_ERROR_CSR, *PCEV_UNRECOVERABLE_ERROR_CSR;

      typedef union _CEV_UNRECOVERABLE_ERROR_CSR_UNION {
         CEV_UNRECOVERABLE_ERROR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_UNRECOVERABLE_ERROR_CSR_UNION, *PCEV_UNRECOVERABLE_ERROR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_UNRECOVERABLE_ERROR_CSR_UNION, sizeof (CEV_UNRECOVERABLE_ERROR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CEV Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of CEV. The errors are reported in
   // the adjacent CEV_UNRECOVERABLE_ERROR_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_UE_ENABLE_CSR {
         union {
            struct { 
               u32 bad_wdma_resp_status : 1;      // DWORD 0
               u32 sram_intx_contx_access_during_init_en : 1; // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 EQNumP_oflow : 1;              // DWORD 0
               u32 CQNumP_oflow : 1;              // DWORD 0
               u32 TooManyPops : 1;               // DWORD 0
               u32 wdma_fifo_oflow : 1;           // DWORD 0
               u32 wdma_fifo_uflow : 1;           // DWORD 0
               u32 erx_fifo_oflow : 1;            // DWORD 0
               u32 erx_fifo_uflow : 1;            // DWORD 0
               u32 ptc_fifo_oflow : 1;            // DWORD 0
               u32 ptc_fifo_uflow : 1;            // DWORD 0
               u32 txp_fifo_oflow : 1;            // DWORD 0
               u32 txp_fifo_uflow : 1;            // DWORD 0
               u32 mpu_fifo_oflow : 1;            // DWORD 0
               u32 mpu_fifo_uflow : 1;            // DWORD 0
               u32 rxulp2_fifo_oflow : 1;         // DWORD 0
               u32 rxulp2_fifo_uflow : 1;         // DWORD 0
               u32 rxulp1_fifo_oflow : 1;         // DWORD 0
               u32 rxulp1_fifo_uflow : 1;         // DWORD 0
               u32 rxulp0_fifo_oflow : 1;         // DWORD 0
               u32 rxulp0_fifo_uflow : 1;         // DWORD 0
               u32 eqe_write_fifo_oflow : 1;      // DWORD 0
               u32 eqe_write_fifo_uflow : 1;      // DWORD 0
               u32 eqe_alloc_fifo_oflow : 1;      // DWORD 0
               u32 eqe_alloc_fifo_uflow : 1;      // DWORD 0
               u32 eqid_fifo_oflow : 1;           // DWORD 0
               u32 eqid_fifo_uflow : 1;           // DWORD 0
               u32 db_fifo_oflow1 : 1;            // DWORD 0
               u32 bad_ptc_resp_status : 1;       // DWORD 0
               u32 tim_perr : 1;                  // DWORD 0
               u32 ctx_perr : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_UE_ENABLE_CSR, *PCEV_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__CEV_UE_ENABLE_CSR, sizeof (CEV_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _CEV_UE_ENABLE_CSR {
         u32 bad_wdma_resp_status : 1;            // DWORD 0
         u32 sram_intx_contx_access_during_init_en : 1; // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 EQNumP_oflow : 1;                    // DWORD 0
         u32 CQNumP_oflow : 1;                    // DWORD 0
         u32 TooManyPops : 1;                     // DWORD 0
         u32 wdma_fifo_oflow : 1;                 // DWORD 0
         u32 wdma_fifo_uflow : 1;                 // DWORD 0
         u32 erx_fifo_oflow : 1;                  // DWORD 0
         u32 erx_fifo_uflow : 1;                  // DWORD 0
         u32 ptc_fifo_oflow : 1;                  // DWORD 0
         u32 ptc_fifo_uflow : 1;                  // DWORD 0
         u32 txp_fifo_oflow : 1;                  // DWORD 0
         u32 txp_fifo_uflow : 1;                  // DWORD 0
         u32 mpu_fifo_oflow : 1;                  // DWORD 0
         u32 mpu_fifo_uflow : 1;                  // DWORD 0
         u32 rxulp2_fifo_oflow : 1;               // DWORD 0
         u32 rxulp2_fifo_uflow : 1;               // DWORD 0
         u32 rxulp1_fifo_oflow : 1;               // DWORD 0
         u32 rxulp1_fifo_uflow : 1;               // DWORD 0
         u32 rxulp0_fifo_oflow : 1;               // DWORD 0
         u32 rxulp0_fifo_uflow : 1;               // DWORD 0
         u32 eqe_write_fifo_oflow : 1;            // DWORD 0
         u32 eqe_write_fifo_uflow : 1;            // DWORD 0
         u32 eqe_alloc_fifo_oflow : 1;            // DWORD 0
         u32 eqe_alloc_fifo_uflow : 1;            // DWORD 0
         u32 eqid_fifo_oflow : 1;                 // DWORD 0
         u32 eqid_fifo_uflow : 1;                 // DWORD 0
         u32 db_fifo_oflow1 : 1;                  // DWORD 0
         u32 bad_ptc_resp_status : 1;             // DWORD 0
         u32 tim_perr : 1;                        // DWORD 0
         u32 ctx_perr : 1;                        // DWORD 0
      } SG_PACK CEV_UE_ENABLE_CSR, *PCEV_UE_ENABLE_CSR;

      typedef union _CEV_UE_ENABLE_CSR_UNION {
         CEV_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_UE_ENABLE_CSR_UNION, *PCEV_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_UE_ENABLE_CSR_UNION, sizeof (CEV_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // CEV Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of CEV. The errors are reported in
   // the adjacent CEV_UNRECOVERABLE_ERROR_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_UE_ENABLE_CSR {
         union {
            struct { 
               u32 ctx_perr : 1;                  // DWORD 0
               u32 tim_perr : 1;                  // DWORD 0
               u32 bad_ptc_resp_status : 1;       // DWORD 0
               u32 db_fifo_oflow1 : 1;            // DWORD 0
               u32 eqid_fifo_uflow : 1;           // DWORD 0
               u32 eqid_fifo_oflow : 1;           // DWORD 0
               u32 eqe_alloc_fifo_uflow : 1;      // DWORD 0
               u32 eqe_alloc_fifo_oflow : 1;      // DWORD 0
               u32 eqe_write_fifo_uflow : 1;      // DWORD 0
               u32 eqe_write_fifo_oflow : 1;      // DWORD 0
               u32 rxulp0_fifo_uflow : 1;         // DWORD 0
               u32 rxulp0_fifo_oflow : 1;         // DWORD 0
               u32 rxulp1_fifo_uflow : 1;         // DWORD 0
               u32 rxulp1_fifo_oflow : 1;         // DWORD 0
               u32 rxulp2_fifo_uflow : 1;         // DWORD 0
               u32 rxulp2_fifo_oflow : 1;         // DWORD 0
               u32 mpu_fifo_uflow : 1;            // DWORD 0
               u32 mpu_fifo_oflow : 1;            // DWORD 0
               u32 txp_fifo_uflow : 1;            // DWORD 0
               u32 txp_fifo_oflow : 1;            // DWORD 0
               u32 ptc_fifo_uflow : 1;            // DWORD 0
               u32 ptc_fifo_oflow : 1;            // DWORD 0
               u32 erx_fifo_uflow : 1;            // DWORD 0
               u32 erx_fifo_oflow : 1;            // DWORD 0
               u32 wdma_fifo_uflow : 1;           // DWORD 0
               u32 wdma_fifo_oflow : 1;           // DWORD 0
               u32 TooManyPops : 1;               // DWORD 0
               u32 CQNumP_oflow : 1;              // DWORD 0
               u32 EQNumP_oflow : 1;              // DWORD 0
               u32 sram_access_during_init_en : 1; // DWORD 0
               u32 sram_intx_contx_access_during_init_en : 1; // DWORD 0
               u32 bad_wdma_resp_status : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_UE_ENABLE_CSR, *PCEV_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__CEV_UE_ENABLE_CSR, sizeof (CEV_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _CEV_UE_ENABLE_CSR {
         u32 ctx_perr : 1;                        // DWORD 0
         u32 tim_perr : 1;                        // DWORD 0
         u32 bad_ptc_resp_status : 1;             // DWORD 0
         u32 db_fifo_oflow1 : 1;                  // DWORD 0
         u32 eqid_fifo_uflow : 1;                 // DWORD 0
         u32 eqid_fifo_oflow : 1;                 // DWORD 0
         u32 eqe_alloc_fifo_uflow : 1;            // DWORD 0
         u32 eqe_alloc_fifo_oflow : 1;            // DWORD 0
         u32 eqe_write_fifo_uflow : 1;            // DWORD 0
         u32 eqe_write_fifo_oflow : 1;            // DWORD 0
         u32 rxulp0_fifo_uflow : 1;               // DWORD 0
         u32 rxulp0_fifo_oflow : 1;               // DWORD 0
         u32 rxulp1_fifo_uflow : 1;               // DWORD 0
         u32 rxulp1_fifo_oflow : 1;               // DWORD 0
         u32 rxulp2_fifo_uflow : 1;               // DWORD 0
         u32 rxulp2_fifo_oflow : 1;               // DWORD 0
         u32 mpu_fifo_uflow : 1;                  // DWORD 0
         u32 mpu_fifo_oflow : 1;                  // DWORD 0
         u32 txp_fifo_uflow : 1;                  // DWORD 0
         u32 txp_fifo_oflow : 1;                  // DWORD 0
         u32 ptc_fifo_uflow : 1;                  // DWORD 0
         u32 ptc_fifo_oflow : 1;                  // DWORD 0
         u32 erx_fifo_uflow : 1;                  // DWORD 0
         u32 erx_fifo_oflow : 1;                  // DWORD 0
         u32 wdma_fifo_uflow : 1;                 // DWORD 0
         u32 wdma_fifo_oflow : 1;                 // DWORD 0
         u32 TooManyPops : 1;                     // DWORD 0
         u32 CQNumP_oflow : 1;                    // DWORD 0
         u32 EQNumP_oflow : 1;                    // DWORD 0
         u32 sram_access_during_init_en : 1;      // DWORD 0
         u32 sram_intx_contx_access_during_init_en : 1; // DWORD 0
         u32 bad_wdma_resp_status : 1;            // DWORD 0
      } SG_PACK CEV_UE_ENABLE_CSR, *PCEV_UE_ENABLE_CSR;

      typedef union _CEV_UE_ENABLE_CSR_UNION {
         CEV_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_UE_ENABLE_CSR_UNION, *PCEV_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_UE_ENABLE_CSR_UNION, sizeof (CEV_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of all CQEs and EQEs pushed by CEV to
   // host memory. The count is a combined value for all CQs and EQs. It includes CQEs and
   // EQEs pushed as a result of explicit CEV clients requests, plus those EQEs created by
   // CEV as a result of Eventable Completions. The counter is incremented when the CEV
   // Client Access State Machine pops a request off any of its input request PQs (which
   // only happens if the relevant Queue is not full, the CEV client request is error-free
   // and PTC has space available for the push request from CEV), or when CEV itself
   // creates an Event (EQE) as a result of an Eventable Completion push request (from a
   // CEV client) or a doorbell re-arm. Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PUSH_CSR {
         union {
            struct { 
               u32 qe_push_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PUSH_CSR, *PCEV_DBG_PUSH_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PUSH_CSR, sizeof (CEV_DBG_PUSH_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PUSH_CSR {
         u32 qe_push_cnt;                         // DWORD 0
      } SG_PACK CEV_DBG_PUSH_CSR, *PCEV_DBG_PUSH_CSR;

      typedef union _CEV_DBG_PUSH_CSR_UNION {
         CEV_DBG_PUSH_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PUSH_CSR_UNION, *PCEV_DBG_PUSH_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PUSH_CSR_UNION, sizeof (CEV_DBG_PUSH_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of all CQEs and EQEs pushed by CEV to
   // host memory. The count is a combined value for all CQs and EQs. It includes CQEs and
   // EQEs pushed as a result of explicit CEV clients requests, plus those EQEs created by
   // CEV as a result of Eventable Completions. The counter is incremented when the CEV
   // Client Access State Machine pops a request off any of its input request PQs (which
   // only happens if the relevant Queue is not full, the CEV client request is error-free
   // and PTC has space available for the push request from CEV), or when CEV itself
   // creates an Event (EQE) as a result of an Eventable Completion push request (from a
   // CEV client) or a doorbell re-arm. Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PUSH_CSR {
         union {
            struct { 
               u32 qe_push_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PUSH_CSR, *PCEV_DBG_PUSH_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PUSH_CSR, sizeof (CEV_DBG_PUSH_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PUSH_CSR {
         u32 qe_push_cnt;                         // DWORD 0
      } SG_PACK CEV_DBG_PUSH_CSR, *PCEV_DBG_PUSH_CSR;

      typedef union _CEV_DBG_PUSH_CSR_UNION {
         CEV_DBG_PUSH_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PUSH_CSR_UNION, *PCEV_DBG_PUSH_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PUSH_CSR_UNION, sizeof (CEV_DBG_PUSH_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of all CQEs and EQEs successfully
   // popped by CEV to host memory. The count is a combined value for all CQs and EQs.
   // Only pop counts from legitimate doorbells are counted. Software can initialize this
   // counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_POP_CSR {
         union {
            struct { 
               u32 qe_pop_cnt;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_POP_CSR, *PCEV_DBG_POP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_POP_CSR, sizeof (CEV_DBG_POP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_POP_CSR {
         u32 qe_pop_cnt;                          // DWORD 0
      } SG_PACK CEV_DBG_POP_CSR, *PCEV_DBG_POP_CSR;

      typedef union _CEV_DBG_POP_CSR_UNION {
         CEV_DBG_POP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_POP_CSR_UNION, *PCEV_DBG_POP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_POP_CSR_UNION, sizeof (CEV_DBG_POP_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of all CQEs and EQEs successfully
   // popped by CEV to host memory. The count is a combined value for all CQs and EQs.
   // Only pop counts from legitimate doorbells are counted. Software can initialize this
   // counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_POP_CSR {
         union {
            struct { 
               u32 qe_pop_cnt;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_POP_CSR, *PCEV_DBG_POP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_POP_CSR, sizeof (CEV_DBG_POP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_POP_CSR {
         u32 qe_pop_cnt;                          // DWORD 0
      } SG_PACK CEV_DBG_POP_CSR, *PCEV_DBG_POP_CSR;

      typedef union _CEV_DBG_POP_CSR_UNION {
         CEV_DBG_POP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_POP_CSR_UNION, *PCEV_DBG_POP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_POP_CSR_UNION, sizeof (CEV_DBG_POP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of all CQE and EQE push requests
   // issued by CEV to PTC. The count is a combined value for all CQEs and EQEs. Software
   // can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCREQ_CSR {
         union {
            struct { 
               u32 ptc_req_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCREQ_CSR, *PCEV_DBG_PTCREQ_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_CSR, sizeof (CEV_DBG_PTCREQ_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCREQ_CSR {
         u32 ptc_req_cnt;                         // DWORD 0
      } SG_PACK CEV_DBG_PTCREQ_CSR, *PCEV_DBG_PTCREQ_CSR;

      typedef union _CEV_DBG_PTCREQ_CSR_UNION {
         CEV_DBG_PTCREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCREQ_CSR_UNION, *PCEV_DBG_PTCREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_CSR_UNION, sizeof (CEV_DBG_PTCREQ_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of all CQE and EQE push requests
   // issued by CEV to PTC. The count is a combined value for all CQEs and EQEs. Software
   // can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCREQ_CSR {
         union {
            struct { 
               u32 ptc_req_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCREQ_CSR, *PCEV_DBG_PTCREQ_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_CSR, sizeof (CEV_DBG_PTCREQ_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCREQ_CSR {
         u32 ptc_req_cnt;                         // DWORD 0
      } SG_PACK CEV_DBG_PTCREQ_CSR, *PCEV_DBG_PTCREQ_CSR;

      typedef union _CEV_DBG_PTCREQ_CSR_UNION {
         CEV_DBG_PTCREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCREQ_CSR_UNION, *PCEV_DBG_PTCREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_CSR_UNION, sizeof (CEV_DBG_PTCREQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of the number of responses expected
   // back to CEV from PTC. Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_EXPPTCRESP_CSR {
         union {
            struct { 
               u32 ptc_exp_resp_cnt;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_EXPPTCRESP_CSR, *PCEV_DBG_EXPPTCRESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPPTCRESP_CSR, sizeof (CEV_DBG_EXPPTCRESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_EXPPTCRESP_CSR {
         u32 ptc_exp_resp_cnt;                    // DWORD 0
      } SG_PACK CEV_DBG_EXPPTCRESP_CSR, *PCEV_DBG_EXPPTCRESP_CSR;

      typedef union _CEV_DBG_EXPPTCRESP_CSR_UNION {
         CEV_DBG_EXPPTCRESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_EXPPTCRESP_CSR_UNION, *PCEV_DBG_EXPPTCRESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPPTCRESP_CSR_UNION, sizeof (CEV_DBG_EXPPTCRESP_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of the number of responses expected
   // back to CEV from PTC. Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_EXPPTCRESP_CSR {
         union {
            struct { 
               u32 ptc_exp_resp_cnt;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_EXPPTCRESP_CSR, *PCEV_DBG_EXPPTCRESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPPTCRESP_CSR, sizeof (CEV_DBG_EXPPTCRESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_EXPPTCRESP_CSR {
         u32 ptc_exp_resp_cnt;                    // DWORD 0
      } SG_PACK CEV_DBG_EXPPTCRESP_CSR, *PCEV_DBG_EXPPTCRESP_CSR;

      typedef union _CEV_DBG_EXPPTCRESP_CSR_UNION {
         CEV_DBG_EXPPTCRESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_EXPPTCRESP_CSR_UNION, *PCEV_DBG_EXPPTCRESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPPTCRESP_CSR_UNION, sizeof (CEV_DBG_EXPPTCRESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of the number of responses returned
   // back to CEV from PTC. Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_ACTPTCRESP_CSR {
         union {
            struct { 
               u32 ptc_act_resp_cnt;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_ACTPTCRESP_CSR, *PCEV_DBG_ACTPTCRESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTPTCRESP_CSR, sizeof (CEV_DBG_ACTPTCRESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_ACTPTCRESP_CSR {
         u32 ptc_act_resp_cnt;                    // DWORD 0
      } SG_PACK CEV_DBG_ACTPTCRESP_CSR, *PCEV_DBG_ACTPTCRESP_CSR;

      typedef union _CEV_DBG_ACTPTCRESP_CSR_UNION {
         CEV_DBG_ACTPTCRESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_ACTPTCRESP_CSR_UNION, *PCEV_DBG_ACTPTCRESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTPTCRESP_CSR_UNION, sizeof (CEV_DBG_ACTPTCRESP_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of the number of responses returned
   // back to CEV from PTC. Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_ACTPTCRESP_CSR {
         union {
            struct { 
               u32 ptc_act_resp_cnt;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_ACTPTCRESP_CSR, *PCEV_DBG_ACTPTCRESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTPTCRESP_CSR, sizeof (CEV_DBG_ACTPTCRESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_ACTPTCRESP_CSR {
         u32 ptc_act_resp_cnt;                    // DWORD 0
      } SG_PACK CEV_DBG_ACTPTCRESP_CSR, *PCEV_DBG_ACTPTCRESP_CSR;

      typedef union _CEV_DBG_ACTPTCRESP_CSR_UNION {
         CEV_DBG_ACTPTCRESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_ACTPTCRESP_CSR_UNION, *PCEV_DBG_ACTPTCRESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTPTCRESP_CSR_UNION, sizeof (CEV_DBG_ACTPTCRESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of all Type2 and Type3 DMA_D issued
   // by CEV to WDMA. . Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_WDMAREQ_CSR {
         union {
            struct { 
               u32 wdma_req_cnt;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_WDMAREQ_CSR, *PCEV_DBG_WDMAREQ_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_WDMAREQ_CSR, sizeof (CEV_DBG_WDMAREQ_CSR) == 4);

   #else
      typedef struct _CEV_DBG_WDMAREQ_CSR {
         u32 wdma_req_cnt;                        // DWORD 0
      } SG_PACK CEV_DBG_WDMAREQ_CSR, *PCEV_DBG_WDMAREQ_CSR;

      typedef union _CEV_DBG_WDMAREQ_CSR_UNION {
         CEV_DBG_WDMAREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_WDMAREQ_CSR_UNION, *PCEV_DBG_WDMAREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_WDMAREQ_CSR_UNION, sizeof (CEV_DBG_WDMAREQ_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of all Type2 and Type3 DMA_D issued
   // by CEV to WDMA. . Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_WDMAREQ_CSR {
         union {
            struct { 
               u32 wdma_req_cnt;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_WDMAREQ_CSR, *PCEV_DBG_WDMAREQ_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_WDMAREQ_CSR, sizeof (CEV_DBG_WDMAREQ_CSR) == 4);

   #else
      typedef struct _CEV_DBG_WDMAREQ_CSR {
         u32 wdma_req_cnt;                        // DWORD 0
      } SG_PACK CEV_DBG_WDMAREQ_CSR, *PCEV_DBG_WDMAREQ_CSR;

      typedef union _CEV_DBG_WDMAREQ_CSR_UNION {
         CEV_DBG_WDMAREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_WDMAREQ_CSR_UNION, *PCEV_DBG_WDMAREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_WDMAREQ_CSR_UNION, sizeof (CEV_DBG_WDMAREQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of TYPE2 and TYPE3 DMA Descriptor
   // write confirmation responses expected back to CEV from WDMA. Software can initialize
   // this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_EXPWDMARESP_CSR {
         union {
            struct { 
               u32 wdma_exp_resp_cnt;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_EXPWDMARESP_CSR, *PCEV_DBG_EXPWDMARESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPWDMARESP_CSR, sizeof (CEV_DBG_EXPWDMARESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_EXPWDMARESP_CSR {
         u32 wdma_exp_resp_cnt;                   // DWORD 0
      } SG_PACK CEV_DBG_EXPWDMARESP_CSR, *PCEV_DBG_EXPWDMARESP_CSR;

      typedef union _CEV_DBG_EXPWDMARESP_CSR_UNION {
         CEV_DBG_EXPWDMARESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_EXPWDMARESP_CSR_UNION, *PCEV_DBG_EXPWDMARESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPWDMARESP_CSR_UNION, sizeof (CEV_DBG_EXPWDMARESP_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of TYPE2 and TYPE3 DMA Descriptor
   // write confirmation responses expected back to CEV from WDMA. Software can initialize
   // this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_EXPWDMARESP_CSR {
         union {
            struct { 
               u32 wdma_exp_resp_cnt;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_EXPWDMARESP_CSR, *PCEV_DBG_EXPWDMARESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPWDMARESP_CSR, sizeof (CEV_DBG_EXPWDMARESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_EXPWDMARESP_CSR {
         u32 wdma_exp_resp_cnt;                   // DWORD 0
      } SG_PACK CEV_DBG_EXPWDMARESP_CSR, *PCEV_DBG_EXPWDMARESP_CSR;

      typedef union _CEV_DBG_EXPWDMARESP_CSR_UNION {
         CEV_DBG_EXPWDMARESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_EXPWDMARESP_CSR_UNION, *PCEV_DBG_EXPWDMARESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_EXPWDMARESP_CSR_UNION, sizeof (CEV_DBG_EXPWDMARESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of the number of TYPE2 and TYPE3
   // DMA_D write confirmation responses returned back to CEV from WDMA. Software can
   // initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_ACTWDMARESP_CSR {
         union {
            struct { 
               u32 wdma_act_resp_cnt;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_ACTWDMARESP_CSR, *PCEV_DBG_ACTWDMARESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTWDMARESP_CSR, sizeof (CEV_DBG_ACTWDMARESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_ACTWDMARESP_CSR {
         u32 wdma_act_resp_cnt;                   // DWORD 0
      } SG_PACK CEV_DBG_ACTWDMARESP_CSR, *PCEV_DBG_ACTWDMARESP_CSR;

      typedef union _CEV_DBG_ACTWDMARESP_CSR_UNION {
         CEV_DBG_ACTWDMARESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_ACTWDMARESP_CSR_UNION, *PCEV_DBG_ACTWDMARESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTWDMARESP_CSR_UNION, sizeof (CEV_DBG_ACTWDMARESP_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of the number of TYPE2 and TYPE3
   // DMA_D write confirmation responses returned back to CEV from WDMA. Software can
   // initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_ACTWDMARESP_CSR {
         union {
            struct { 
               u32 wdma_act_resp_cnt;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_ACTWDMARESP_CSR, *PCEV_DBG_ACTWDMARESP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTWDMARESP_CSR, sizeof (CEV_DBG_ACTWDMARESP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_ACTWDMARESP_CSR {
         u32 wdma_act_resp_cnt;                   // DWORD 0
      } SG_PACK CEV_DBG_ACTWDMARESP_CSR, *PCEV_DBG_ACTWDMARESP_CSR;

      typedef union _CEV_DBG_ACTWDMARESP_CSR_UNION {
         CEV_DBG_ACTWDMARESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_ACTWDMARESP_CSR_UNION, *PCEV_DBG_ACTWDMARESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_ACTWDMARESP_CSR_UNION, sizeof (CEV_DBG_ACTWDMARESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent request (in
   // descriptor format CEV_PQ_D) from any CEV client that has been serviced by the CEV
   // Client Access state machine. This register is initialized to all zeroes. It is
   // updated when the Client Access state machine returns to its idle state.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CL_REQ_CSR {
         union {
            struct { 
               u32 cl_req;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CL_REQ_CSR, *PCEV_DBG_CL_REQ_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CL_REQ_CSR, sizeof (CEV_DBG_CL_REQ_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CL_REQ_CSR {
         u32 cl_req;                              // DWORD 0
      } SG_PACK CEV_DBG_CL_REQ_CSR, *PCEV_DBG_CL_REQ_CSR;

      typedef union _CEV_DBG_CL_REQ_CSR_UNION {
         CEV_DBG_CL_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CL_REQ_CSR_UNION, *PCEV_DBG_CL_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CL_REQ_CSR_UNION, sizeof (CEV_DBG_CL_REQ_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent request (in
   // descriptor format CEV_PQ_D) from any CEV client that has been serviced by the CEV
   // Client Access state machine. This register is initialized to all zeroes. It is
   // updated when the Client Access state machine returns to its idle state.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CL_REQ_CSR {
         union {
            struct { 
               u32 cl_req;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CL_REQ_CSR, *PCEV_DBG_CL_REQ_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CL_REQ_CSR, sizeof (CEV_DBG_CL_REQ_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CL_REQ_CSR {
         u32 cl_req;                              // DWORD 0
      } SG_PACK CEV_DBG_CL_REQ_CSR, *PCEV_DBG_CL_REQ_CSR;

      typedef union _CEV_DBG_CL_REQ_CSR_UNION {
         CEV_DBG_CL_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CL_REQ_CSR_UNION, *PCEV_DBG_CL_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CL_REQ_CSR_UNION, sizeof (CEV_DBG_CL_REQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the lower DWORD of the most recent request
   // (format: PTC_REQ_D) issued by CEV to PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCREQ_L_CSR {
         union {
            struct { 
               u32 ptc_req_l;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCREQ_L_CSR, *PCEV_DBG_PTCREQ_L_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_L_CSR, sizeof (CEV_DBG_PTCREQ_L_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCREQ_L_CSR {
         u32 ptc_req_l;                           // DWORD 0
      } SG_PACK CEV_DBG_PTCREQ_L_CSR, *PCEV_DBG_PTCREQ_L_CSR;

      typedef union _CEV_DBG_PTCREQ_L_CSR_UNION {
         CEV_DBG_PTCREQ_L_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCREQ_L_CSR_UNION, *PCEV_DBG_PTCREQ_L_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_L_CSR_UNION, sizeof (CEV_DBG_PTCREQ_L_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the lower DWORD of the most recent request
   // (format: PTC_REQ_D) issued by CEV to PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCREQ_L_CSR {
         union {
            struct { 
               u32 ptc_req_l;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCREQ_L_CSR, *PCEV_DBG_PTCREQ_L_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_L_CSR, sizeof (CEV_DBG_PTCREQ_L_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCREQ_L_CSR {
         u32 ptc_req_l;                           // DWORD 0
      } SG_PACK CEV_DBG_PTCREQ_L_CSR, *PCEV_DBG_PTCREQ_L_CSR;

      typedef union _CEV_DBG_PTCREQ_L_CSR_UNION {
         CEV_DBG_PTCREQ_L_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCREQ_L_CSR_UNION, *PCEV_DBG_PTCREQ_L_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_L_CSR_UNION, sizeof (CEV_DBG_PTCREQ_L_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the upper DWORD of the most recent request
   // (format: PTC_REQ_D) issued by CEV to PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCREQ_U_CSR {
         union {
            struct { 
               u32 ptc_req_u;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCREQ_U_CSR, *PCEV_DBG_PTCREQ_U_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_U_CSR, sizeof (CEV_DBG_PTCREQ_U_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCREQ_U_CSR {
         u32 ptc_req_u;                           // DWORD 0
      } SG_PACK CEV_DBG_PTCREQ_U_CSR, *PCEV_DBG_PTCREQ_U_CSR;

      typedef union _CEV_DBG_PTCREQ_U_CSR_UNION {
         CEV_DBG_PTCREQ_U_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCREQ_U_CSR_UNION, *PCEV_DBG_PTCREQ_U_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_U_CSR_UNION, sizeof (CEV_DBG_PTCREQ_U_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the upper DWORD of the most recent request
   // (format: PTC_REQ_D) issued by CEV to PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCREQ_U_CSR {
         union {
            struct { 
               u32 ptc_req_u;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCREQ_U_CSR, *PCEV_DBG_PTCREQ_U_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_U_CSR, sizeof (CEV_DBG_PTCREQ_U_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCREQ_U_CSR {
         u32 ptc_req_u;                           // DWORD 0
      } SG_PACK CEV_DBG_PTCREQ_U_CSR, *PCEV_DBG_PTCREQ_U_CSR;

      typedef union _CEV_DBG_PTCREQ_U_CSR_UNION {
         CEV_DBG_PTCREQ_U_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCREQ_U_CSR_UNION, *PCEV_DBG_PTCREQ_U_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCREQ_U_CSR_UNION, sizeof (CEV_DBG_PTCREQ_U_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_PA_LO_CSR {
         union {
            struct { 
               u32 ptc_resp_pa_lo;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_PA_LO_CSR, *PCEV_DBG_PTCRESP_PA_LO_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_LO_CSR, sizeof (CEV_DBG_PTCRESP_PA_LO_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_PA_LO_CSR {
         u32 ptc_resp_pa_lo;                      // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_PA_LO_CSR, *PCEV_DBG_PTCRESP_PA_LO_CSR;

      typedef union _CEV_DBG_PTCRESP_PA_LO_CSR_UNION {
         CEV_DBG_PTCRESP_PA_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_PA_LO_CSR_UNION, *PCEV_DBG_PTCRESP_PA_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_LO_CSR_UNION, sizeof (CEV_DBG_PTCRESP_PA_LO_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_PA_LO_CSR {
         union {
            struct { 
               u32 ptc_resp_pa_lo;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_PA_LO_CSR, *PCEV_DBG_PTCRESP_PA_LO_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_LO_CSR, sizeof (CEV_DBG_PTCRESP_PA_LO_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_PA_LO_CSR {
         u32 ptc_resp_pa_lo;                      // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_PA_LO_CSR, *PCEV_DBG_PTCRESP_PA_LO_CSR;

      typedef union _CEV_DBG_PTCRESP_PA_LO_CSR_UNION {
         CEV_DBG_PTCRESP_PA_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_PA_LO_CSR_UNION, *PCEV_DBG_PTCRESP_PA_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_LO_CSR_UNION, sizeof (CEV_DBG_PTCRESP_PA_LO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_PA_HI_CSR {
         union {
            struct { 
               u32 ptc_resp_pa_hi;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_PA_HI_CSR, *PCEV_DBG_PTCRESP_PA_HI_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_HI_CSR, sizeof (CEV_DBG_PTCRESP_PA_HI_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_PA_HI_CSR {
         u32 ptc_resp_pa_hi;                      // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_PA_HI_CSR, *PCEV_DBG_PTCRESP_PA_HI_CSR;

      typedef union _CEV_DBG_PTCRESP_PA_HI_CSR_UNION {
         CEV_DBG_PTCRESP_PA_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_PA_HI_CSR_UNION, *PCEV_DBG_PTCRESP_PA_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_HI_CSR_UNION, sizeof (CEV_DBG_PTCRESP_PA_HI_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_PA_HI_CSR {
         union {
            struct { 
               u32 ptc_resp_pa_hi;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_PA_HI_CSR, *PCEV_DBG_PTCRESP_PA_HI_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_HI_CSR, sizeof (CEV_DBG_PTCRESP_PA_HI_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_PA_HI_CSR {
         u32 ptc_resp_pa_hi;                      // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_PA_HI_CSR, *PCEV_DBG_PTCRESP_PA_HI_CSR;

      typedef union _CEV_DBG_PTCRESP_PA_HI_CSR_UNION {
         CEV_DBG_PTCRESP_PA_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_PA_HI_CSR_UNION, *PCEV_DBG_PTCRESP_PA_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_PA_HI_CSR_UNION, sizeof (CEV_DBG_PTCRESP_PA_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_CTRL_CSR {
         union {
            struct { 
               u32 ptc_resp_ctrl;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_CTRL_CSR, *PCEV_DBG_PTCRESP_CTRL_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CTRL_CSR, sizeof (CEV_DBG_PTCRESP_CTRL_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_CTRL_CSR {
         u32 ptc_resp_ctrl;                       // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_CTRL_CSR, *PCEV_DBG_PTCRESP_CTRL_CSR;

      typedef union _CEV_DBG_PTCRESP_CTRL_CSR_UNION {
         CEV_DBG_PTCRESP_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_CTRL_CSR_UNION, *PCEV_DBG_PTCRESP_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CTRL_CSR_UNION, sizeof (CEV_DBG_PTCRESP_CTRL_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_CTRL_CSR {
         union {
            struct { 
               u32 ptc_resp_ctrl;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_CTRL_CSR, *PCEV_DBG_PTCRESP_CTRL_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CTRL_CSR, sizeof (CEV_DBG_PTCRESP_CTRL_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_CTRL_CSR {
         u32 ptc_resp_ctrl;                       // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_CTRL_CSR, *PCEV_DBG_PTCRESP_CTRL_CSR;

      typedef union _CEV_DBG_PTCRESP_CTRL_CSR_UNION {
         CEV_DBG_PTCRESP_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_CTRL_CSR_UNION, *PCEV_DBG_PTCRESP_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CTRL_CSR_UNION, sizeof (CEV_DBG_PTCRESP_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) 2nd DWORD returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_CRA_CSR {
         union {
            struct { 
               u32 ptc_resp_cra;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_CRA_CSR, *PCEV_DBG_PTCRESP_CRA_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CRA_CSR, sizeof (CEV_DBG_PTCRESP_CRA_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_CRA_CSR {
         u32 ptc_resp_cra;                        // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_CRA_CSR, *PCEV_DBG_PTCRESP_CRA_CSR;

      typedef union _CEV_DBG_PTCRESP_CRA_CSR_UNION {
         CEV_DBG_PTCRESP_CRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_CRA_CSR_UNION, *PCEV_DBG_PTCRESP_CRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CRA_CSR_UNION, sizeof (CEV_DBG_PTCRESP_CRA_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent response (format:
   // PTC_NEWRESP_D) 2nd DWORD returned to CEV by PTC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESP_CRA_CSR {
         union {
            struct { 
               u32 ptc_resp_cra;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESP_CRA_CSR, *PCEV_DBG_PTCRESP_CRA_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CRA_CSR, sizeof (CEV_DBG_PTCRESP_CRA_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESP_CRA_CSR {
         u32 ptc_resp_cra;                        // DWORD 0
      } SG_PACK CEV_DBG_PTCRESP_CRA_CSR, *PCEV_DBG_PTCRESP_CRA_CSR;

      typedef union _CEV_DBG_PTCRESP_CRA_CSR_UNION {
         CEV_DBG_PTCRESP_CRA_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESP_CRA_CSR_UNION, *PCEV_DBG_PTCRESP_CRA_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESP_CRA_CSR_UNION, sizeof (CEV_DBG_PTCRESP_CRA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent VALID doorbell
   // (format: CQ_DB) processed by CEV. This register is NOT updated for doorbells that
   // are rejected by CEV BTLR instances (see BTLR Violation registers for reason why).
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_DB_CSR {
         union {
            struct { 
               u32 db_content;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_DB_CSR, *PCEV_DBG_DB_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_DB_CSR, sizeof (CEV_DBG_DB_CSR) == 4);

   #else
      typedef struct _CEV_DBG_DB_CSR {
         u32 db_content;                          // DWORD 0
      } SG_PACK CEV_DBG_DB_CSR, *PCEV_DBG_DB_CSR;

      typedef union _CEV_DBG_DB_CSR_UNION {
         CEV_DBG_DB_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_DB_CSR_UNION, *PCEV_DBG_DB_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_DB_CSR_UNION, sizeof (CEV_DBG_DB_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent VALID doorbell
   // (format: CQ_DB) processed by CEV. This register is NOT updated for doorbells that
   // are rejected by CEV BTLR instances (see BTLR Violation registers for reason why).
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_DB_CSR {
         union {
            struct { 
               u32 db_content;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_DB_CSR, *PCEV_DBG_DB_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_DB_CSR, sizeof (CEV_DBG_DB_CSR) == 4);

   #else
      typedef struct _CEV_DBG_DB_CSR {
         u32 db_content;                          // DWORD 0
      } SG_PACK CEV_DBG_DB_CSR, *PCEV_DBG_DB_CSR;

      typedef union _CEV_DBG_DB_CSR_UNION {
         CEV_DBG_DB_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_DB_CSR_UNION, *PCEV_DBG_DB_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_DB_CSR_UNION, sizeof (CEV_DBG_DB_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent CTX access by CEV
   // (to write EQE content), specifically the CTX address. CEV always performs a 16-byte
   // write to the Immediate data field of the EQEs Type 2 DMA descriptor. The EQE it
   // writes is just one DWORD, which it replicates four times in the 16B Type 2 Immediate
   // data location. The associated EQE data is located in the adjacent CEV_DBG_CTX_D_CSR.
   // Note that CEV only writes EQE content in the case of Eventable Completions. The EQE
   // content of EQEs for Event-only Queues is written by CEV client(s), not CEV itself.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CTX_A_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 address : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CTX_A_CSR, *PCEV_DBG_CTX_A_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_A_CSR, sizeof (CEV_DBG_CTX_A_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CTX_A_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 address : 16;                        // DWORD 0
      } SG_PACK CEV_DBG_CTX_A_CSR, *PCEV_DBG_CTX_A_CSR;

      typedef union _CEV_DBG_CTX_A_CSR_UNION {
         CEV_DBG_CTX_A_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CTX_A_CSR_UNION, *PCEV_DBG_CTX_A_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_A_CSR_UNION, sizeof (CEV_DBG_CTX_A_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent CTX access by CEV
   // (to write EQE content), specifically the CTX address. CEV always performs a 16-byte
   // write to the Immediate data field of the EQEs Type 2 DMA descriptor. The EQE it
   // writes is just one DWORD, which it replicates four times in the 16B Type 2 Immediate
   // data location. The associated EQE data is located in the adjacent CEV_DBG_CTX_D_CSR.
   // Note that CEV only writes EQE content in the case of Eventable Completions. The EQE
   // content of EQEs for Event-only Queues is written by CEV client(s), not CEV itself.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CTX_A_CSR {
         union {
            struct { 
               u32 address : 16;                  // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CTX_A_CSR, *PCEV_DBG_CTX_A_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_A_CSR, sizeof (CEV_DBG_CTX_A_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CTX_A_CSR {
         u32 address : 16;                        // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK CEV_DBG_CTX_A_CSR, *PCEV_DBG_CTX_A_CSR;

      typedef union _CEV_DBG_CTX_A_CSR_UNION {
         CEV_DBG_CTX_A_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CTX_A_CSR_UNION, *PCEV_DBG_CTX_A_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_A_CSR_UNION, sizeof (CEV_DBG_CTX_A_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the content of the most recent CTX access by CEV
   // (to write EQE content), specifically the CTX address and sideband signals. CEV
   // always performs a 16-byte write to the Immediate data field of the EQEs Type 2 DMA
   // descriptor. The EQE it writes is just one DWORD, which it replicates four times in
   // the 16B Type 2 Immediate data location. The associated EQE data is located in the
   // adjacent CEV_DBG_CTX_D_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CTX_D_CSR {
         union {
            struct { 
               u32 eqe_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CTX_D_CSR, *PCEV_DBG_CTX_D_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_D_CSR, sizeof (CEV_DBG_CTX_D_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CTX_D_CSR {
         u32 eqe_data;                            // DWORD 0
      } SG_PACK CEV_DBG_CTX_D_CSR, *PCEV_DBG_CTX_D_CSR;

      typedef union _CEV_DBG_CTX_D_CSR_UNION {
         CEV_DBG_CTX_D_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CTX_D_CSR_UNION, *PCEV_DBG_CTX_D_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_D_CSR_UNION, sizeof (CEV_DBG_CTX_D_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the content of the most recent CTX access by CEV
   // (to write EQE content), specifically the CTX address and sideband signals. CEV
   // always performs a 16-byte write to the Immediate data field of the EQEs Type 2 DMA
   // descriptor. The EQE it writes is just one DWORD, which it replicates four times in
   // the 16B Type 2 Immediate data location. The associated EQE data is located in the
   // adjacent CEV_DBG_CTX_D_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CTX_D_CSR {
         union {
            struct { 
               u32 eqe_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CTX_D_CSR, *PCEV_DBG_CTX_D_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_D_CSR, sizeof (CEV_DBG_CTX_D_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CTX_D_CSR {
         u32 eqe_data;                            // DWORD 0
      } SG_PACK CEV_DBG_CTX_D_CSR, *PCEV_DBG_CTX_D_CSR;

      typedef union _CEV_DBG_CTX_D_CSR_UNION {
         CEV_DBG_CTX_D_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CTX_D_CSR_UNION, *PCEV_DBG_CTX_D_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CTX_D_CSR_UNION, sizeof (CEV_DBG_CTX_D_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a count of the number of responses returned
   // back to CEV from PTC which are popped from the parking buffer . Software can
   // initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESPPOP_CSR {
         union {
            struct { 
               u32 ptc_resp_pop_cnt;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESPPOP_CSR, *PCEV_DBG_PTCRESPPOP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESPPOP_CSR, sizeof (CEV_DBG_PTCRESPPOP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESPPOP_CSR {
         u32 ptc_resp_pop_cnt;                    // DWORD 0
      } SG_PACK CEV_DBG_PTCRESPPOP_CSR, *PCEV_DBG_PTCRESPPOP_CSR;

      typedef union _CEV_DBG_PTCRESPPOP_CSR_UNION {
         CEV_DBG_PTCRESPPOP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESPPOP_CSR_UNION, *PCEV_DBG_PTCRESPPOP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESPPOP_CSR_UNION, sizeof (CEV_DBG_PTCRESPPOP_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a count of the number of responses returned
   // back to CEV from PTC which are popped from the parking buffer . Software can
   // initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTCRESPPOP_CSR {
         union {
            struct { 
               u32 ptc_resp_pop_cnt;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTCRESPPOP_CSR, *PCEV_DBG_PTCRESPPOP_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESPPOP_CSR, sizeof (CEV_DBG_PTCRESPPOP_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTCRESPPOP_CSR {
         u32 ptc_resp_pop_cnt;                    // DWORD 0
      } SG_PACK CEV_DBG_PTCRESPPOP_CSR, *PCEV_DBG_PTCRESPPOP_CSR;

      typedef union _CEV_DBG_PTCRESPPOP_CSR_UNION {
         CEV_DBG_PTCRESPPOP_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTCRESPPOP_CSR_UNION, *PCEV_DBG_PTCRESPPOP_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTCRESPPOP_CSR_UNION, sizeof (CEV_DBG_PTCRESPPOP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It maintains a current count of the number of outstanding
   // request cnt from CEV to PTC . Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTC_OUTST_REQ_CNT_CSR {
         union {
            struct { 
               u32 ptc_outstanding_req_cnt;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTC_OUTST_REQ_CNT_CSR, *PCEV_DBG_PTC_OUTST_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTC_OUTST_REQ_CNT_CSR, sizeof (CEV_DBG_PTC_OUTST_REQ_CNT_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTC_OUTST_REQ_CNT_CSR {
         u32 ptc_outstanding_req_cnt;             // DWORD 0
      } SG_PACK CEV_DBG_PTC_OUTST_REQ_CNT_CSR, *PCEV_DBG_PTC_OUTST_REQ_CNT_CSR;

      typedef union _CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION {
         CEV_DBG_PTC_OUTST_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION, *PCEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION, sizeof (CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It maintains a current count of the number of outstanding
   // request cnt from CEV to PTC . Software can initialize this counter.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_PTC_OUTST_REQ_CNT_CSR {
         union {
            struct { 
               u32 ptc_outstanding_req_cnt;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_PTC_OUTST_REQ_CNT_CSR, *PCEV_DBG_PTC_OUTST_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTC_OUTST_REQ_CNT_CSR, sizeof (CEV_DBG_PTC_OUTST_REQ_CNT_CSR) == 4);

   #else
      typedef struct _CEV_DBG_PTC_OUTST_REQ_CNT_CSR {
         u32 ptc_outstanding_req_cnt;             // DWORD 0
      } SG_PACK CEV_DBG_PTC_OUTST_REQ_CNT_CSR, *PCEV_DBG_PTC_OUTST_REQ_CNT_CSR;

      typedef union _CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION {
         CEV_DBG_PTC_OUTST_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION, *PCEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION, sizeof (CEV_DBG_PTC_OUTST_REQ_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a debug register. It holds the Claim,Valid and Evacuation bits of all the
   // CQE coalescing buffers This CSR value must get to back to all zero in quiescent
   // condition This CSR value must remain to all zero for CQE coalescing disabled.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CQE_COALESC_BUF_CSR {
         union {
            struct { 
               u32 wdma_cev_full_r : 1;           // DWORD 0
               u32 cqe_coalescing_state_r : 3;    // DWORD 0
               u32 cqe_cb7_evac : 1;              // DWORD 0
               u32 cqe_cb7_valid : 1;             // DWORD 0
               u32 cqe_cb7_claim : 1;             // DWORD 0
               u32 cqe_cb6_evac : 1;              // DWORD 0
               u32 cqe_cb6_valid : 1;             // DWORD 0
               u32 cqe_cb6_claim : 1;             // DWORD 0
               u32 cqe_cb5_evac : 1;              // DWORD 0
               u32 cqe_cb5_valid : 1;             // DWORD 0
               u32 cqe_cb5_claim : 1;             // DWORD 0
               u32 cqe_cb4_evac : 1;              // DWORD 0
               u32 cqe_cb4_valid : 1;             // DWORD 0
               u32 cqe_cb4_claim : 1;             // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 cqe_cb3_evac : 1;              // DWORD 0
               u32 cqe_cb3_valid : 1;             // DWORD 0
               u32 cqe_cb3_claim : 1;             // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 cqe_cb2_evac : 1;              // DWORD 0
               u32 cqe_cb2_valid : 1;             // DWORD 0
               u32 cqe_cb2_claim : 1;             // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 cqe_cb1_evac : 1;              // DWORD 0
               u32 cqe_cb1_valid : 1;             // DWORD 0
               u32 cqe_cb1_claim : 1;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 cqe_cb0_evac : 1;              // DWORD 0
               u32 cqe_cb0_valid : 1;             // DWORD 0
               u32 cqe_cb0_claim : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CQE_COALESC_BUF_CSR, *PCEV_DBG_CQE_COALESC_BUF_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CQE_COALESC_BUF_CSR, sizeof (CEV_DBG_CQE_COALESC_BUF_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CQE_COALESC_BUF_CSR {
         u32 wdma_cev_full_r : 1;                 // DWORD 0
         u32 cqe_coalescing_state_r : 3;          // DWORD 0
         u32 cqe_cb7_evac : 1;                    // DWORD 0
         u32 cqe_cb7_valid : 1;                   // DWORD 0
         u32 cqe_cb7_claim : 1;                   // DWORD 0
         u32 cqe_cb6_evac : 1;                    // DWORD 0
         u32 cqe_cb6_valid : 1;                   // DWORD 0
         u32 cqe_cb6_claim : 1;                   // DWORD 0
         u32 cqe_cb5_evac : 1;                    // DWORD 0
         u32 cqe_cb5_valid : 1;                   // DWORD 0
         u32 cqe_cb5_claim : 1;                   // DWORD 0
         u32 cqe_cb4_evac : 1;                    // DWORD 0
         u32 cqe_cb4_valid : 1;                   // DWORD 0
         u32 cqe_cb4_claim : 1;                   // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 cqe_cb3_evac : 1;                    // DWORD 0
         u32 cqe_cb3_valid : 1;                   // DWORD 0
         u32 cqe_cb3_claim : 1;                   // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 cqe_cb2_evac : 1;                    // DWORD 0
         u32 cqe_cb2_valid : 1;                   // DWORD 0
         u32 cqe_cb2_claim : 1;                   // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 cqe_cb1_evac : 1;                    // DWORD 0
         u32 cqe_cb1_valid : 1;                   // DWORD 0
         u32 cqe_cb1_claim : 1;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 cqe_cb0_evac : 1;                    // DWORD 0
         u32 cqe_cb0_valid : 1;                   // DWORD 0
         u32 cqe_cb0_claim : 1;                   // DWORD 0
      } SG_PACK CEV_DBG_CQE_COALESC_BUF_CSR, *PCEV_DBG_CQE_COALESC_BUF_CSR;

      typedef union _CEV_DBG_CQE_COALESC_BUF_CSR_UNION {
         CEV_DBG_CQE_COALESC_BUF_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CQE_COALESC_BUF_CSR_UNION, *PCEV_DBG_CQE_COALESC_BUF_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CQE_COALESC_BUF_CSR_UNION, sizeof (CEV_DBG_CQE_COALESC_BUF_CSR_UNION) == 4);
   #endif


#else
   // This is a debug register. It holds the Claim,Valid and Evacuation bits of all the
   // CQE coalescing buffers This CSR value must get to back to all zero in quiescent
   // condition This CSR value must remain to all zero for CQE coalescing disabled.
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_DBG_CQE_COALESC_BUF_CSR {
         union {
            struct { 
               u32 cqe_cb0_claim : 1;             // DWORD 0
               u32 cqe_cb0_valid : 1;             // DWORD 0
               u32 cqe_cb0_evac : 1;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 cqe_cb1_claim : 1;             // DWORD 0
               u32 cqe_cb1_valid : 1;             // DWORD 0
               u32 cqe_cb1_evac : 1;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 cqe_cb2_claim : 1;             // DWORD 0
               u32 cqe_cb2_valid : 1;             // DWORD 0
               u32 cqe_cb2_evac : 1;              // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 cqe_cb3_claim : 1;             // DWORD 0
               u32 cqe_cb3_valid : 1;             // DWORD 0
               u32 cqe_cb3_evac : 1;              // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 cqe_cb4_claim : 1;             // DWORD 0
               u32 cqe_cb4_valid : 1;             // DWORD 0
               u32 cqe_cb4_evac : 1;              // DWORD 0
               u32 cqe_cb5_claim : 1;             // DWORD 0
               u32 cqe_cb5_valid : 1;             // DWORD 0
               u32 cqe_cb5_evac : 1;              // DWORD 0
               u32 cqe_cb6_claim : 1;             // DWORD 0
               u32 cqe_cb6_valid : 1;             // DWORD 0
               u32 cqe_cb6_evac : 1;              // DWORD 0
               u32 cqe_cb7_claim : 1;             // DWORD 0
               u32 cqe_cb7_valid : 1;             // DWORD 0
               u32 cqe_cb7_evac : 1;              // DWORD 0
               u32 cqe_coalescing_state_r : 3;    // DWORD 0
               u32 wdma_cev_full_r : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_DBG_CQE_COALESC_BUF_CSR, *PCEV_DBG_CQE_COALESC_BUF_CSR;

      SG_C_ASSERT(__sizeof__CEV_DBG_CQE_COALESC_BUF_CSR, sizeof (CEV_DBG_CQE_COALESC_BUF_CSR) == 4);

   #else
      typedef struct _CEV_DBG_CQE_COALESC_BUF_CSR {
         u32 cqe_cb0_claim : 1;                   // DWORD 0
         u32 cqe_cb0_valid : 1;                   // DWORD 0
         u32 cqe_cb0_evac : 1;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 cqe_cb1_claim : 1;                   // DWORD 0
         u32 cqe_cb1_valid : 1;                   // DWORD 0
         u32 cqe_cb1_evac : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 cqe_cb2_claim : 1;                   // DWORD 0
         u32 cqe_cb2_valid : 1;                   // DWORD 0
         u32 cqe_cb2_evac : 1;                    // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 cqe_cb3_claim : 1;                   // DWORD 0
         u32 cqe_cb3_valid : 1;                   // DWORD 0
         u32 cqe_cb3_evac : 1;                    // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 cqe_cb4_claim : 1;                   // DWORD 0
         u32 cqe_cb4_valid : 1;                   // DWORD 0
         u32 cqe_cb4_evac : 1;                    // DWORD 0
         u32 cqe_cb5_claim : 1;                   // DWORD 0
         u32 cqe_cb5_valid : 1;                   // DWORD 0
         u32 cqe_cb5_evac : 1;                    // DWORD 0
         u32 cqe_cb6_claim : 1;                   // DWORD 0
         u32 cqe_cb6_valid : 1;                   // DWORD 0
         u32 cqe_cb6_evac : 1;                    // DWORD 0
         u32 cqe_cb7_claim : 1;                   // DWORD 0
         u32 cqe_cb7_valid : 1;                   // DWORD 0
         u32 cqe_cb7_evac : 1;                    // DWORD 0
         u32 cqe_coalescing_state_r : 3;          // DWORD 0
         u32 wdma_cev_full_r : 1;                 // DWORD 0
      } SG_PACK CEV_DBG_CQE_COALESC_BUF_CSR, *PCEV_DBG_CQE_COALESC_BUF_CSR;

      typedef union _CEV_DBG_CQE_COALESC_BUF_CSR_UNION {
         CEV_DBG_CQE_COALESC_BUF_CSR bits;
         u32 dw; // dword union
      } SG_PACK CEV_DBG_CQE_COALESC_BUF_CSR_UNION, *PCEV_DBG_CQE_COALESC_BUF_CSR_UNION;

      SG_C_ASSERT(__sizeof__CEV_DBG_CQE_COALESC_BUF_CSR_UNION, sizeof (CEV_DBG_CQE_COALESC_BUF_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control registers for how and what completions and events are generated. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CSRMAP {
         union {
            struct { 
               CEV_CTL_CSR ctl;
               REV_ID rev_id;
               CEV_MAX_SUST_INT_DLY_CNT_CSR cev_max_sust_int_dly_cnt_csr;
               CEV_CTX_ADDR_CSR ctx_address;
               CEV_CTX_DATA_CSR ctx_data;
               CEV_CSR_COALESCWM_CFG coalesc_wm;
               CEV_ISR0_CSR isr0;
               CEV_ISR1_CSR isr1;
               CEV_ISR2_CSR isr2;
               CEV_ISR3_CSR isr3;
               CEV_ISR4_CSR isr4;
               CEV_ISR5_CSR isr5;
               CEV_ISR6_CSR isr6;
               CEV_ISR7_CSR isr7;
               CEV_ISR8_CSR isr8;
               CEV_ISR9_CSR isr9;
               CEV_ISR10_CSR isr10;
               CEV_ISR11_CSR isr11;
               CEV_IMR0_CSR imr0;
               CEV_IMR1_CSR imr1;
               CEV_IMR2_CSR imr2;
               CEV_IMR3_CSR imr3;
               CEV_IMR4_CSR imr4;
               CEV_IMR5_CSR imr5;
               CEV_IMR6_CSR imr6;
               CEV_IMR7_CSR imr7;
               CEV_IMR8_CSR imr8;
               CEV_IMR9_CSR imr9;
               CEV_IMR10_CSR imr10;
               CEV_IMR11_CSR imr11;
               CEV_ISCR0_CSR iscr0;
               CEV_ISCR1_CSR iscr1;
               CEV_ISCR2_CSR iscr2;
               CEV_ISCR3_CSR iscr3;
               CEV_ISCR4_CSR iscr4;
               CEV_ISCR5_CSR iscr5;
               CEV_ISCR6_CSR iscr6;
               CEV_ISCR7_CSR iscr7;
               CEV_ISCR8_CSR iscr8;
               CEV_ISCR9_CSR iscr9;
               CEV_ISCR10_CSR iscr10;
               CEV_ISCR11_CSR iscr11;
               CEV_INTERNAL_ISR_CSR int_isr;
               CEV_INTERNAL_IMR_CSR int_imr;
               CEV_RE_INFO_CSR re_info;
               CEV_UE_ENABLE_CSR ue_enable;
               CEV_UNRECOVERABLE_ERROR_CSR ue_cause;
               CEV_SM_DEBUG0_CSR sm_debug0;
               CEV_SM_DEBUG1_CSR sm_debug1;
               CEV_DBG_PUSH_CSR dbg_push;
               CEV_DBG_POP_CSR dbg_pop;
               CEV_DBG_PTCREQ_CSR dbg_ptcreq;
               CEV_DBG_EXPPTCRESP_CSR dbg_expptcresp;
               CEV_DBG_ACTPTCRESP_CSR dbg_actptcresp;
               CEV_DBG_WDMAREQ_CSR dbg_wdmareq;
               CEV_DBG_EXPWDMARESP_CSR dbg_expwdmaresp;
               CEV_DBG_ACTWDMARESP_CSR dbg_actwdmaresp;
               CEV_DBG_CL_REQ_CSR dbg_cl_req;
               CEV_DBG_PTCREQ_L_CSR dbg_ptcreq_l;
               CEV_DBG_PTCREQ_U_CSR dbg_ptcreq_u;
               CEV_DBG_PTCRESP_PA_LO_CSR dbg_ptcresp_palo;
               CEV_DBG_PTCRESP_PA_HI_CSR dbg_ptcresp_pahi;
               CEV_DBG_PTCRESP_CTRL_CSR dbg_ptcresp_ctrl;
               CEV_DBG_PTCRESPPOP_CSR dbg_ptcresppop;
               CEV_DBG_PTC_OUTST_REQ_CNT_CSR dbg_ptc_outst_req_cnt;
               CEV_DBG_DB_CSR dbg_db;
               CEV_DBG_CTX_A_CSR dbg_ctx_a;
               CEV_DBG_CTX_D_CSR dbg_ctx_d;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr1;
               CEV_FUNC_INTX_MUX_CSR cev_func_intx_mux_csr;
               CEV_DBG_PTCRESP_CRA_CSR dbg_ptcresp_cra;
               CEV_DBG_CQE_COALESC_BUF_CSR dbg_cqe_coalesc_buf_stat;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rxulp2_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } txp_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } ptc_pq;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[145];                    // DWORDS 111 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK CEV_CSRMAP, *PCEV_CSRMAP;

      SG_C_ASSERT(__sizeof__CEV_CSRMAP, sizeof (CEV_CSRMAP) == 1024);

   #else
      typedef struct _CEV_CSRMAP {
         CEV_CTL_CSR ctl;
         REV_ID rev_id;
         CEV_MAX_SUST_INT_DLY_CNT_CSR cev_max_sust_int_dly_cnt_csr;
         CEV_CTX_ADDR_CSR ctx_address;
         CEV_CTX_DATA_CSR ctx_data;
         CEV_CSR_COALESCWM_CFG coalesc_wm;
         CEV_ISR0_CSR isr0;
         CEV_ISR1_CSR isr1;
         CEV_ISR2_CSR isr2;
         CEV_ISR3_CSR isr3;
         CEV_ISR4_CSR isr4;
         CEV_ISR5_CSR isr5;
         CEV_ISR6_CSR isr6;
         CEV_ISR7_CSR isr7;
         CEV_ISR8_CSR isr8;
         CEV_ISR9_CSR isr9;
         CEV_ISR10_CSR isr10;
         CEV_ISR11_CSR isr11;
         CEV_IMR0_CSR imr0;
         CEV_IMR1_CSR imr1;
         CEV_IMR2_CSR imr2;
         CEV_IMR3_CSR imr3;
         CEV_IMR4_CSR imr4;
         CEV_IMR5_CSR imr5;
         CEV_IMR6_CSR imr6;
         CEV_IMR7_CSR imr7;
         CEV_IMR8_CSR imr8;
         CEV_IMR9_CSR imr9;
         CEV_IMR10_CSR imr10;
         CEV_IMR11_CSR imr11;
         CEV_ISCR0_CSR iscr0;
         CEV_ISCR1_CSR iscr1;
         CEV_ISCR2_CSR iscr2;
         CEV_ISCR3_CSR iscr3;
         CEV_ISCR4_CSR iscr4;
         CEV_ISCR5_CSR iscr5;
         CEV_ISCR6_CSR iscr6;
         CEV_ISCR7_CSR iscr7;
         CEV_ISCR8_CSR iscr8;
         CEV_ISCR9_CSR iscr9;
         CEV_ISCR10_CSR iscr10;
         CEV_ISCR11_CSR iscr11;
         CEV_INTERNAL_ISR_CSR int_isr;
         CEV_INTERNAL_IMR_CSR int_imr;
         CEV_RE_INFO_CSR re_info;
         CEV_UE_ENABLE_CSR ue_enable;
         CEV_UNRECOVERABLE_ERROR_CSR ue_cause;
         CEV_SM_DEBUG0_CSR sm_debug0;
         CEV_SM_DEBUG1_CSR sm_debug1;
         CEV_DBG_PUSH_CSR dbg_push;
         CEV_DBG_POP_CSR dbg_pop;
         CEV_DBG_PTCREQ_CSR dbg_ptcreq;
         CEV_DBG_EXPPTCRESP_CSR dbg_expptcresp;
         CEV_DBG_ACTPTCRESP_CSR dbg_actptcresp;
         CEV_DBG_WDMAREQ_CSR dbg_wdmareq;
         CEV_DBG_EXPWDMARESP_CSR dbg_expwdmaresp;
         CEV_DBG_ACTWDMARESP_CSR dbg_actwdmaresp;
         CEV_DBG_CL_REQ_CSR dbg_cl_req;
         CEV_DBG_PTCREQ_L_CSR dbg_ptcreq_l;
         CEV_DBG_PTCREQ_U_CSR dbg_ptcreq_u;
         CEV_DBG_PTCRESP_PA_LO_CSR dbg_ptcresp_palo;
         CEV_DBG_PTCRESP_PA_HI_CSR dbg_ptcresp_pahi;
         CEV_DBG_PTCRESP_CTRL_CSR dbg_ptcresp_ctrl;
         CEV_DBG_PTCRESPPOP_CSR dbg_ptcresppop;
         CEV_DBG_PTC_OUTST_REQ_CNT_CSR dbg_ptc_outst_req_cnt;
         CEV_DBG_DB_CSR dbg_db;
         CEV_DBG_CTX_A_CSR dbg_ctx_a;
         CEV_DBG_CTX_D_CSR dbg_ctx_d;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr1;
         CEV_FUNC_INTX_MUX_CSR cev_func_intx_mux_csr;
         CEV_DBG_PTCRESP_CRA_CSR dbg_ptcresp_cra;
         CEV_DBG_CQE_COALESC_BUF_CSR dbg_cqe_coalesc_buf_stat;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rxulp2_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } txp_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } ptc_pq;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[145];                          // DWORDS 111 to 255
      } SG_PACK CEV_CSRMAP, *PCEV_CSRMAP;

      typedef union _CEV_CSRMAP_UNION {
         CEV_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK CEV_CSRMAP_UNION, *PCEV_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__CEV_CSRMAP_UNION, sizeof (CEV_CSRMAP_UNION) == 1024);
   #endif


#else
   // Control registers for how and what completions and events are generated. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_CSRMAP {
         union {
            struct { 
               CEV_CTL_CSR ctl;
               REV_ID rev_id;
               CEV_MAX_SUST_INT_DLY_CNT_CSR cev_max_sust_int_dly_cnt_csr;
               CEV_CTX_ADDR_CSR ctx_address;
               CEV_CTX_DATA_CSR ctx_data;
               CEV_CSR_COALESCWM_CFG coalesc_wm;
               CEV_ISR0_CSR isr0;
               CEV_ISR1_CSR isr1;
               CEV_ISR2_CSR isr2;
               CEV_ISR3_CSR isr3;
               CEV_ISR4_CSR isr4;
               CEV_ISR5_CSR isr5;
               CEV_ISR6_CSR isr6;
               CEV_ISR7_CSR isr7;
               CEV_ISR8_CSR isr8;
               CEV_ISR9_CSR isr9;
               CEV_ISR10_CSR isr10;
               CEV_ISR11_CSR isr11;
               CEV_IMR0_CSR imr0;
               CEV_IMR1_CSR imr1;
               CEV_IMR2_CSR imr2;
               CEV_IMR3_CSR imr3;
               CEV_IMR4_CSR imr4;
               CEV_IMR5_CSR imr5;
               CEV_IMR6_CSR imr6;
               CEV_IMR7_CSR imr7;
               CEV_IMR8_CSR imr8;
               CEV_IMR9_CSR imr9;
               CEV_IMR10_CSR imr10;
               CEV_IMR11_CSR imr11;
               CEV_ISCR0_CSR iscr0;
               CEV_ISCR1_CSR iscr1;
               CEV_ISCR2_CSR iscr2;
               CEV_ISCR3_CSR iscr3;
               CEV_ISCR4_CSR iscr4;
               CEV_ISCR5_CSR iscr5;
               CEV_ISCR6_CSR iscr6;
               CEV_ISCR7_CSR iscr7;
               CEV_ISCR8_CSR iscr8;
               CEV_ISCR9_CSR iscr9;
               CEV_ISCR10_CSR iscr10;
               CEV_ISCR11_CSR iscr11;
               CEV_INTERNAL_ISR_CSR int_isr;
               CEV_INTERNAL_IMR_CSR int_imr;
               CEV_RE_INFO_CSR re_info;
               CEV_UE_ENABLE_CSR ue_enable;
               CEV_UNRECOVERABLE_ERROR_CSR ue_cause;
               CEV_SM_DEBUG0_CSR sm_debug0;
               CEV_SM_DEBUG1_CSR sm_debug1;
               CEV_DBG_PUSH_CSR dbg_push;
               CEV_DBG_POP_CSR dbg_pop;
               CEV_DBG_PTCREQ_CSR dbg_ptcreq;
               CEV_DBG_EXPPTCRESP_CSR dbg_expptcresp;
               CEV_DBG_ACTPTCRESP_CSR dbg_actptcresp;
               CEV_DBG_WDMAREQ_CSR dbg_wdmareq;
               CEV_DBG_EXPWDMARESP_CSR dbg_expwdmaresp;
               CEV_DBG_ACTWDMARESP_CSR dbg_actwdmaresp;
               CEV_DBG_CL_REQ_CSR dbg_cl_req;
               CEV_DBG_PTCREQ_L_CSR dbg_ptcreq_l;
               CEV_DBG_PTCREQ_U_CSR dbg_ptcreq_u;
               CEV_DBG_PTCRESP_PA_LO_CSR dbg_ptcresp_palo;
               CEV_DBG_PTCRESP_PA_HI_CSR dbg_ptcresp_pahi;
               CEV_DBG_PTCRESP_CTRL_CSR dbg_ptcresp_ctrl;
               CEV_DBG_PTCRESPPOP_CSR dbg_ptcresppop;
               CEV_DBG_PTC_OUTST_REQ_CNT_CSR dbg_ptc_outst_req_cnt;
               CEV_DBG_DB_CSR dbg_db;
               CEV_DBG_CTX_A_CSR dbg_ctx_a;
               CEV_DBG_CTX_D_CSR dbg_ctx_d;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr1;
               CEV_FUNC_INTX_MUX_CSR cev_func_intx_mux_csr;
               CEV_DBG_PTCRESP_CRA_CSR dbg_ptcresp_cra;
               CEV_DBG_CQE_COALESC_BUF_CSR dbg_cqe_coalesc_buf_stat;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } rxulp2_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } erx_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } txp_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
                  PQ_DATA2_WRITE_CSR wrdata2;
                  PQ_DATA2_READ_CSR rddata2;
                  PQ_DATA3_WRITE_CSR wrdata3;
                  PQ_DATA3_READ_CSR rddata3;
               } ptc_pq;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[145];                    // DWORDS 111 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK CEV_CSRMAP, *PCEV_CSRMAP;

      SG_C_ASSERT(__sizeof__CEV_CSRMAP, sizeof (CEV_CSRMAP) == 1024);

   #else
      typedef struct _CEV_CSRMAP {
         CEV_CTL_CSR ctl;
         REV_ID rev_id;
         CEV_MAX_SUST_INT_DLY_CNT_CSR cev_max_sust_int_dly_cnt_csr;
         CEV_CTX_ADDR_CSR ctx_address;
         CEV_CTX_DATA_CSR ctx_data;
         CEV_CSR_COALESCWM_CFG coalesc_wm;
         CEV_ISR0_CSR isr0;
         CEV_ISR1_CSR isr1;
         CEV_ISR2_CSR isr2;
         CEV_ISR3_CSR isr3;
         CEV_ISR4_CSR isr4;
         CEV_ISR5_CSR isr5;
         CEV_ISR6_CSR isr6;
         CEV_ISR7_CSR isr7;
         CEV_ISR8_CSR isr8;
         CEV_ISR9_CSR isr9;
         CEV_ISR10_CSR isr10;
         CEV_ISR11_CSR isr11;
         CEV_IMR0_CSR imr0;
         CEV_IMR1_CSR imr1;
         CEV_IMR2_CSR imr2;
         CEV_IMR3_CSR imr3;
         CEV_IMR4_CSR imr4;
         CEV_IMR5_CSR imr5;
         CEV_IMR6_CSR imr6;
         CEV_IMR7_CSR imr7;
         CEV_IMR8_CSR imr8;
         CEV_IMR9_CSR imr9;
         CEV_IMR10_CSR imr10;
         CEV_IMR11_CSR imr11;
         CEV_ISCR0_CSR iscr0;
         CEV_ISCR1_CSR iscr1;
         CEV_ISCR2_CSR iscr2;
         CEV_ISCR3_CSR iscr3;
         CEV_ISCR4_CSR iscr4;
         CEV_ISCR5_CSR iscr5;
         CEV_ISCR6_CSR iscr6;
         CEV_ISCR7_CSR iscr7;
         CEV_ISCR8_CSR iscr8;
         CEV_ISCR9_CSR iscr9;
         CEV_ISCR10_CSR iscr10;
         CEV_ISCR11_CSR iscr11;
         CEV_INTERNAL_ISR_CSR int_isr;
         CEV_INTERNAL_IMR_CSR int_imr;
         CEV_RE_INFO_CSR re_info;
         CEV_UE_ENABLE_CSR ue_enable;
         CEV_UNRECOVERABLE_ERROR_CSR ue_cause;
         CEV_SM_DEBUG0_CSR sm_debug0;
         CEV_SM_DEBUG1_CSR sm_debug1;
         CEV_DBG_PUSH_CSR dbg_push;
         CEV_DBG_POP_CSR dbg_pop;
         CEV_DBG_PTCREQ_CSR dbg_ptcreq;
         CEV_DBG_EXPPTCRESP_CSR dbg_expptcresp;
         CEV_DBG_ACTPTCRESP_CSR dbg_actptcresp;
         CEV_DBG_WDMAREQ_CSR dbg_wdmareq;
         CEV_DBG_EXPWDMARESP_CSR dbg_expwdmaresp;
         CEV_DBG_ACTWDMARESP_CSR dbg_actwdmaresp;
         CEV_DBG_CL_REQ_CSR dbg_cl_req;
         CEV_DBG_PTCREQ_L_CSR dbg_ptcreq_l;
         CEV_DBG_PTCREQ_U_CSR dbg_ptcreq_u;
         CEV_DBG_PTCRESP_PA_LO_CSR dbg_ptcresp_palo;
         CEV_DBG_PTCRESP_PA_HI_CSR dbg_ptcresp_pahi;
         CEV_DBG_PTCRESP_CTRL_CSR dbg_ptcresp_ctrl;
         CEV_DBG_PTCRESPPOP_CSR dbg_ptcresppop;
         CEV_DBG_PTC_OUTST_REQ_CNT_CSR dbg_ptc_outst_req_cnt;
         CEV_DBG_DB_CSR dbg_db;
         CEV_DBG_CTX_A_CSR dbg_ctx_a;
         CEV_DBG_CTX_D_CSR dbg_ctx_d;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr1;
         CEV_FUNC_INTX_MUX_CSR cev_func_intx_mux_csr;
         CEV_DBG_PTCRESP_CRA_CSR dbg_ptcresp_cra;
         CEV_DBG_CQE_COALESC_BUF_CSR dbg_cqe_coalesc_buf_stat;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } rxulp2_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } erx_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } txp_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
            PQ_DATA2_WRITE_CSR wrdata2;
            PQ_DATA2_READ_CSR rddata2;
            PQ_DATA3_WRITE_CSR wrdata3;
            PQ_DATA3_READ_CSR rddata3;
         } ptc_pq;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[145];                          // DWORDS 111 to 255
      } SG_PACK CEV_CSRMAP, *PCEV_CSRMAP;

      typedef union _CEV_CSRMAP_UNION {
         CEV_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK CEV_CSRMAP_UNION, *PCEV_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__CEV_CSRMAP_UNION, sizeof (CEV_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __cev_bmap_h__

