/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __host_struct_bmap_h__
#define __host_struct_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "headers_bmap.h"
#include "be_cm_bmap.h"
#include "rxf_bmap.h"
#include "descriptors_bmap.h"
#include "iscsi_initiator_host_struct_bmap.h"
#include "iscsi_target_host_struct_bmap.h"
#include "fc_enums_bmap.h"
#include "fc_common_host_struct_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Default tag and index mapping for UC
   typedef struct _UC_CRA {
      u32 tag : 16;                               // DWORD 0
      u32 index : 8;                              // DWORD 0
      u32 offset : 6;                             // DWORD 0
   } SG_PACK UC_CRA, *PUC_CRA;



#else
   // Default tag and index mapping for UC
   typedef struct _UC_CRA {
      u32 offset : 6;                             // DWORD 0
      u32 index : 8;                              // DWORD 0
      u32 tag : 16;                               // DWORD 0
   } SG_PACK UC_CRA, *PUC_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Default tag and index mapping for PTC
   typedef struct _PTC_CRA {
      u32 tag : 10;                               // DWORD 0
      u32 index : 7;                              // DWORD 0
      u32 offset : 1;                             // DWORD 0
      u32 pagesize : 12;                          // DWORD 0
   } SG_PACK PTC_CRA, *PPTC_CRA;



#else
   // Default tag and index mapping for PTC
   typedef struct _PTC_CRA {
      u32 pagesize : 12;                          // DWORD 0
      u32 offset : 1;                             // DWORD 0
      u32 index : 7;                              // DWORD 0
      u32 tag : 10;                               // DWORD 0
   } SG_PACK PTC_CRA, *PPTC_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The Cache Request Address (CRA) is the virtual address used to access items in the
   // Unified Table. This structure shows how the Unified Cache and Page Table cache use
   // the bits in the CRA to locate an element in the Unified Table. The 30-bit address is
   // divided into three levels of indirection. The upper bits are used to locate a
   // directory table entry, which points to a physical page in the page table. The page
   // table index selects one entry from that page, which points to a physical page in the
   // Unified Table. The offset field selects a byte within that page.  The CRA format
   // shown here represents how the caches access data in the Unified Table. Other
   // hardware and firmware modules form CRA's to access individual items in the Unified
   // Table. These items are placed in the Unified Table using the PE_CRA, JE_CRA,
   // JE_OOO_CRA, R2T_CRA, TE_CRA, ISCSI_SGL_CRA, FC_SGL_CRA, RING_CRA formats. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CRA {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dt_index : 9;                  // DWORD 0
               u32 pt_index : 9;                  // DWORD 0
               u32 offset : 12;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CRA, *PCRA;

      SG_C_ASSERT(__sizeof__CRA, sizeof (CRA) == 4);

   #else
      typedef struct _CRA {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dt_index : 9;                        // DWORD 0
         u32 pt_index : 9;                        // DWORD 0
         u32 offset : 12;                         // DWORD 0
      } SG_PACK CRA, *PCRA;

      typedef union _CRA_UNION {
         CRA bits;
         u32 dw; // dword union
      } SG_PACK CRA_UNION, *PCRA_UNION;

      SG_C_ASSERT(__sizeof__CRA_UNION, sizeof (CRA_UNION) == 4);
   #endif


#else
   // The Cache Request Address (CRA) is the virtual address used to access items in the
   // Unified Table. This structure shows how the Unified Cache and Page Table cache use
   // the bits in the CRA to locate an element in the Unified Table. The 30-bit address is
   // divided into three levels of indirection. The upper bits are used to locate a
   // directory table entry, which points to a physical page in the page table. The page
   // table index selects one entry from that page, which points to a physical page in the
   // Unified Table. The offset field selects a byte within that page.  The CRA format
   // shown here represents how the caches access data in the Unified Table. Other
   // hardware and firmware modules form CRA's to access individual items in the Unified
   // Table. These items are placed in the Unified Table using the PE_CRA, JE_CRA,
   // JE_OOO_CRA, R2T_CRA, TE_CRA, ISCSI_SGL_CRA, FC_SGL_CRA, RING_CRA formats. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CRA {
         union {
            struct { 
               u32 offset : 12;                   // DWORD 0
               u32 pt_index : 9;                  // DWORD 0
               u32 dt_index : 9;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CRA, *PCRA;

      SG_C_ASSERT(__sizeof__CRA, sizeof (CRA) == 4);

   #else
      typedef struct _CRA {
         u32 offset : 12;                         // DWORD 0
         u32 pt_index : 9;                        // DWORD 0
         u32 dt_index : 9;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK CRA, *PCRA;

      typedef union _CRA_UNION {
         CRA bits;
         u32 dw; // dword union
      } SG_PACK CRA_UNION, *PCRA_UNION;

      SG_C_ASSERT(__sizeof__CRA_UNION, sizeof (CRA_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The driver must put Protection Entries in the Unified Table at the CRA given by this
   // format. At each PE_CRA address there lives a PE structure. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PE_CRA {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 constant : 3;                  // DWORD 0
               u32 stag : 21;                     // DWORD 0
               u32 offset : 6;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PE_CRA, *PPE_CRA;

      SG_C_ASSERT(__sizeof__PE_CRA, sizeof (PE_CRA) == 4);

   #else
      typedef struct _PE_CRA {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 constant : 3;                        // DWORD 0
         u32 stag : 21;                           // DWORD 0
         u32 offset : 6;                          // DWORD 0
      } SG_PACK PE_CRA, *PPE_CRA;

      typedef union _PE_CRA_UNION {
         PE_CRA bits;
         u32 dw; // dword union
      } SG_PACK PE_CRA_UNION, *PPE_CRA_UNION;

      SG_C_ASSERT(__sizeof__PE_CRA_UNION, sizeof (PE_CRA_UNION) == 4);
   #endif


#else
   // The driver must put Protection Entries in the Unified Table at the CRA given by this
   // format. At each PE_CRA address there lives a PE structure. 
   #if defined(SG_BMAP_UNION)
      typedef struct _PE_CRA {
         union {
            struct { 
               u32 offset : 6;                    // DWORD 0
               u32 stag : 21;                     // DWORD 0
               u32 constant : 3;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK PE_CRA, *PPE_CRA;

      SG_C_ASSERT(__sizeof__PE_CRA, sizeof (PE_CRA) == 4);

   #else
      typedef struct _PE_CRA {
         u32 offset : 6;                          // DWORD 0
         u32 stag : 21;                           // DWORD 0
         u32 constant : 3;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK PE_CRA, *PPE_CRA;

      typedef union _PE_CRA_UNION {
         PE_CRA bits;
         u32 dw; // dword union
      } SG_PACK PE_CRA_UNION, *PPE_CRA_UNION;

      SG_C_ASSERT(__sizeof__PE_CRA_UNION, sizeof (PE_CRA_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The driver must allocate 2MB of space in the Unified Table for retransmit Journal
   // Entries (JE). This memory is mapped into the Unified Table using the following CRA
   // formula. 
   typedef struct _JE_CRA {
      u32 constant : 9;                           // DWORD 0
      u32 je : 13;                                // DWORD 0
      u32 jelloff : 3;                            // DWORD 0
      u32 offset : 5;                             // DWORD 0
   } SG_PACK JE_CRA, *PJE_CRA;



#else
   // The driver must allocate 2MB of space in the Unified Table for retransmit Journal
   // Entries (JE). This memory is mapped into the Unified Table using the following CRA
   // formula. 
   typedef struct _JE_CRA {
      u32 offset : 5;                             // DWORD 0
      u32 jelloff : 3;                            // DWORD 0
      u32 je : 13;                                // DWORD 0
      u32 constant : 9;                           // DWORD 0
   } SG_PACK JE_CRA, *PJE_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The driver must allocate 2MB of space in the Unified Table for retransmit Journal
   // Entries (JE). This memory is mapped into the Unified Table using the following CRA
   // formula. 
   typedef struct _JE_OOO_CRA {
      u32 constant : 13;                          // DWORD 0
      u32 je : 12;                                // DWORD 0
      u32 offset : 5;                             // DWORD 0
   } SG_PACK JE_OOO_CRA, *PJE_OOO_CRA;



#else
   // The driver must allocate 2MB of space in the Unified Table for retransmit Journal
   // Entries (JE). This memory is mapped into the Unified Table using the following CRA
   // formula. 
   typedef struct _JE_OOO_CRA {
      u32 offset : 5;                             // DWORD 0
      u32 je : 12;                                // DWORD 0
      u32 constant : 13;                          // DWORD 0
   } SG_PACK JE_OOO_CRA, *PJE_OOO_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The driver must allocate 256K bytes of space in the Unified Table for storing R2T
   // Entries. This memory is mapped into the Unified Table using the following CRA
   // formula. 
   typedef struct _R2T_CRA {
      u32 constant : 12;                          // DWORD 0
      u32 cid : 9;                                // DWORD 0
      u32 index : 5;                              // DWORD 0
      u32 offset : 4;                             // DWORD 0
   } SG_PACK R2T_CRA, *PR2T_CRA;



#else
   // The driver must allocate 256K bytes of space in the Unified Table for storing R2T
   // Entries. This memory is mapped into the Unified Table using the following CRA
   // formula. 
   typedef struct _R2T_CRA {
      u32 offset : 4;                             // DWORD 0
      u32 index : 5;                              // DWORD 0
      u32 cid : 9;                                // DWORD 0
      u32 constant : 12;                          // DWORD 0
   } SG_PACK R2T_CRA, *PR2T_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The driver must allocate 256K bytes of space in the Unified Table for storing R2T
   // Entries. This memory is mapped into the Unified Table using the following CRA
   // formula. NOTE: we have temporarily restricted the number of R2T entries in the table
   // (per FCF) to 256 when we really want to have 1024. Further research will determine
   // if we can expand the table. 
   typedef struct _FC_R2T_CRA {
      u32 constant : 12;                          // DWORD 0
      u32 cid : 6;                                // DWORD 0
      u32 index : 8;                              // DWORD 0
      u32 offset : 4;                             // DWORD 0
   } SG_PACK FC_R2T_CRA, *PFC_R2T_CRA;



#else
   // The driver must allocate 256K bytes of space in the Unified Table for storing R2T
   // Entries. This memory is mapped into the Unified Table using the following CRA
   // formula. NOTE: we have temporarily restricted the number of R2T entries in the table
   // (per FCF) to 256 when we really want to have 1024. Further research will determine
   // if we can expand the table. 
   typedef struct _FC_R2T_CRA {
      u32 offset : 4;                             // DWORD 0
      u32 index : 8;                              // DWORD 0
      u32 cid : 6;                                // DWORD 0
      u32 constant : 12;                          // DWORD 0
   } SG_PACK FC_R2T_CRA, *PFC_R2T_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Translation Entries are mapped into the Unified Table using the following CRA
   // formula. At each TE_CRA address there lives a collection of four TE structures.
   // These structures are grouped in fours because each TE is 8 bytes (64-bit physical
   // address), and the cache line size for the UC is 64 bytes. 64 Bytes / 8 Bytes/TE = 8
   // TEs. 
   typedef struct _TE_CRA {
      u32 constant : 2;                           // DWORD 0
      u32 te : 23;                                // DWORD 0
      u32 offset : 5;                             // DWORD 0
   } SG_PACK TE_CRA, *PTE_CRA;



#else
   // Translation Entries are mapped into the Unified Table using the following CRA
   // formula. At each TE_CRA address there lives a collection of four TE structures.
   // These structures are grouped in fours because each TE is 8 bytes (64-bit physical
   // address), and the cache line size for the UC is 64 bytes. 64 Bytes / 8 Bytes/TE = 8
   // TEs. 
   typedef struct _TE_CRA {
      u32 offset : 5;                             // DWORD 0
      u32 te : 23;                                // DWORD 0
      u32 constant : 2;                           // DWORD 0
   } SG_PACK TE_CRA, *PTE_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // DEPRECATE. 
   typedef struct _ISCSI_FRAG_CRA {
      u32 constant : 2;                           // DWORD 0
      u32 cid : 8;                                // DWORD 0
      u32 cmd : 8;                                // DWORD 0
      u32 frag_num : 8;                           // DWORD 0
      u32 offset : 4;                             // DWORD 0
   } SG_PACK ISCSI_FRAG_CRA, *PISCSI_FRAG_CRA;



#else
   // DEPRECATE. 
   typedef struct _ISCSI_FRAG_CRA {
      u32 offset : 4;                             // DWORD 0
      u32 frag_num : 8;                           // DWORD 0
      u32 cmd : 8;                                // DWORD 0
      u32 cid : 8;                                // DWORD 0
      u32 constant : 2;                           // DWORD 0
   } SG_PACK ISCSI_FRAG_CRA, *PISCSI_FRAG_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The CRA format for iSCSI scatter gather lists (SGLs). This is the typical format,
   // where each list contains 32 scatter gather elements (ISCSI_SGE). 
   typedef struct _ISCSI_SGL_CRA {
      u32 constant : 2;                           // DWORD 0
      u32 rsvd0 : 8;                              // DWORD 0
      u32 sgl_index : 11;                         // DWORD 0
      u32 frag_num : 5;                           // DWORD 0
      u32 offset : 4;                             // DWORD 0
   } SG_PACK ISCSI_SGL_CRA, *PISCSI_SGL_CRA;



#else
   // The CRA format for iSCSI scatter gather lists (SGLs). This is the typical format,
   // where each list contains 32 scatter gather elements (ISCSI_SGE). 
   typedef struct _ISCSI_SGL_CRA {
      u32 offset : 4;                             // DWORD 0
      u32 frag_num : 5;                           // DWORD 0
      u32 sgl_index : 11;                         // DWORD 0
      u32 rsvd0 : 8;                              // DWORD 0
      u32 constant : 2;                           // DWORD 0
   } SG_PACK ISCSI_SGL_CRA, *PISCSI_SGL_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISCSI_SGL_CRA_256 {
      u32 constant : 2;                           // DWORD 0
      u32 rsvd0 : 5;                              // DWORD 0
      u32 sgl_index : 11;                         // DWORD 0
      u32 frag_num : 8;                           // DWORD 0
      u32 offset : 4;                             // DWORD 0
   } SG_PACK ISCSI_SGL_CRA_256, *PISCSI_SGL_CRA_256;



#else
   
   typedef struct _ISCSI_SGL_CRA_256 {
      u32 offset : 4;                             // DWORD 0
      u32 frag_num : 8;                           // DWORD 0
      u32 sgl_index : 11;                         // DWORD 0
      u32 rsvd0 : 5;                              // DWORD 0
      u32 constant : 2;                           // DWORD 0
   } SG_PACK ISCSI_SGL_CRA_256, *PISCSI_SGL_CRA_256;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // The CRA format for Config7 FCoE scatter gather lists (SGLs). This is the typical
   // format, where each list contains 512 scatter gather elements (ISCSI_SGE). 
   typedef struct _FC_SGL_CRA {
      u32 constant : 2;                           // DWORD 0
      u32 rsvd0 : 3;                              // DWORD 0
      u32 sgl_index : 12;                         // DWORD 0
      u32 frag_num : 9;                           // DWORD 0
      u32 offset : 4;                             // DWORD 0
   } SG_PACK FC_SGL_CRA, *PFC_SGL_CRA;



#else
   // The CRA format for Config7 FCoE scatter gather lists (SGLs). This is the typical
   // format, where each list contains 512 scatter gather elements (ISCSI_SGE). 
   typedef struct _FC_SGL_CRA {
      u32 offset : 4;                             // DWORD 0
      u32 frag_num : 9;                           // DWORD 0
      u32 sgl_index : 12;                         // DWORD 0
      u32 rsvd0 : 3;                              // DWORD 0
      u32 constant : 2;                           // DWORD 0
   } SG_PACK FC_SGL_CRA, *PFC_SGL_CRA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Send, receive, completion, and event rings are mapped into the Unified Table using
   // the following CRA format. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CRA {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 constant : 2;                  // DWORD 0
               u32 queueid : 10;                  // DWORD 0
               u32 type : 3;                      // DWORD 0
               u32 offset : 15;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RING_CRA, *PRING_CRA;

      SG_C_ASSERT(__sizeof__RING_CRA, sizeof (RING_CRA) == 4);

   #else
      typedef struct _RING_CRA {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 constant : 2;                        // DWORD 0
         u32 queueid : 10;                        // DWORD 0
         u32 type : 3;                            // DWORD 0
         u32 offset : 15;                         // DWORD 0
      } SG_PACK RING_CRA, *PRING_CRA;

      typedef union _RING_CRA_UNION {
         RING_CRA bits;
         u32 dw; // dword union
      } SG_PACK RING_CRA_UNION, *PRING_CRA_UNION;

      SG_C_ASSERT(__sizeof__RING_CRA_UNION, sizeof (RING_CRA_UNION) == 4);
   #endif


#else
   // Send, receive, completion, and event rings are mapped into the Unified Table using
   // the following CRA format. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CRA {
         union {
            struct { 
               u32 offset : 15;                   // DWORD 0
               u32 type : 3;                      // DWORD 0
               u32 queueid : 10;                  // DWORD 0
               u32 constant : 2;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RING_CRA, *PRING_CRA;

      SG_C_ASSERT(__sizeof__RING_CRA, sizeof (RING_CRA) == 4);

   #else
      typedef struct _RING_CRA {
         u32 offset : 15;                         // DWORD 0
         u32 type : 3;                            // DWORD 0
         u32 queueid : 10;                        // DWORD 0
         u32 constant : 2;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK RING_CRA, *PRING_CRA;

      typedef union _RING_CRA_UNION {
         RING_CRA bits;
         u32 dw; // dword union
      } SG_PACK RING_CRA_UNION, *PRING_CRA_UNION;

      SG_C_ASSERT(__sizeof__RING_CRA_UNION, sizeof (RING_CRA_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Receive rings are mapped into the Unified Table using the following CRA format. In
   // order to work around the UC isssue 19891, we are moving the TOE RQ rings to
   // different quadrant. The new CRA format makes sure that the Tx and RX donot access
   // same index in the UC cache. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CRA_RX {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 constant : 2;                  // DWORD 0
               u32 queueid : 14;                  // DWORD 0
               u32 type : 1;                      // DWORD 0
               u32 offset : 13;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RING_CRA_RX, *PRING_CRA_RX;

      SG_C_ASSERT(__sizeof__RING_CRA_RX, sizeof (RING_CRA_RX) == 4);

   #else
      typedef struct _RING_CRA_RX {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 constant : 2;                        // DWORD 0
         u32 queueid : 14;                        // DWORD 0
         u32 type : 1;                            // DWORD 0
         u32 offset : 13;                         // DWORD 0
      } SG_PACK RING_CRA_RX, *PRING_CRA_RX;

      typedef union _RING_CRA_RX_UNION {
         RING_CRA_RX bits;
         u32 dw; // dword union
      } SG_PACK RING_CRA_RX_UNION, *PRING_CRA_RX_UNION;

      SG_C_ASSERT(__sizeof__RING_CRA_RX_UNION, sizeof (RING_CRA_RX_UNION) == 4);
   #endif


#else
   // Receive rings are mapped into the Unified Table using the following CRA format. In
   // order to work around the UC isssue 19891, we are moving the TOE RQ rings to
   // different quadrant. The new CRA format makes sure that the Tx and RX donot access
   // same index in the UC cache. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CRA_RX {
         union {
            struct { 
               u32 offset : 13;                   // DWORD 0
               u32 type : 1;                      // DWORD 0
               u32 queueid : 14;                  // DWORD 0
               u32 constant : 2;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RING_CRA_RX, *PRING_CRA_RX;

      SG_C_ASSERT(__sizeof__RING_CRA_RX, sizeof (RING_CRA_RX) == 4);

   #else
      typedef struct _RING_CRA_RX {
         u32 offset : 13;                         // DWORD 0
         u32 type : 1;                            // DWORD 0
         u32 queueid : 14;                        // DWORD 0
         u32 constant : 2;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK RING_CRA_RX, *PRING_CRA_RX;

      typedef union _RING_CRA_RX_UNION {
         RING_CRA_RX bits;
         u32 dw; // dword union
      } SG_PACK RING_CRA_RX_UNION, *PRING_CRA_RX_UNION;

      SG_C_ASSERT(__sizeof__RING_CRA_RX_UNION, sizeof (RING_CRA_RX_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This union shows various interpretations of the UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CRA_FORMAT_UNION {
         union {
            union { 
               u32 dword : 30;                    // DWORD 0
               CRA ut;
               UC_CRA uc;
               PTC_CRA ptc;
               ISCSI_SGL_CRA sgl;
               FC_SGL_CRA fcsgl;
               RING_CRA ring;
               RING_CRA_RX ring_rx;
               PE_CRA pe;
               JE_CRA je;
               JE_OOO_CRA jeooo;
               R2T_CRA r2t;
               FC_R2T_CRA fc_r2t;
               TE_CRA te;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CRA_FORMAT_UNION, *PCRA_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__CRA_FORMAT_UNION, sizeof (CRA_FORMAT_UNION) == 4);

   #else
      typedef union _CRA_FORMAT_UNION {
         u32 dword : 30;                          // DWORD 0
         CRA ut;
         UC_CRA uc;
         PTC_CRA ptc;
         ISCSI_SGL_CRA sgl;
         FC_SGL_CRA fcsgl;
         RING_CRA ring;
         RING_CRA_RX ring_rx;
         PE_CRA pe;
         JE_CRA je;
         JE_OOO_CRA jeooo;
         R2T_CRA r2t;
         FC_R2T_CRA fc_r2t;
         TE_CRA te;
      } SG_PACK CRA_FORMAT_UNION, *PCRA_FORMAT_UNION;

      typedef union _CRA_FORMAT_UNION_UNION {
         CRA_FORMAT_UNION bits;
         u32 dw; // dword union
      } SG_PACK CRA_FORMAT_UNION_UNION, *PCRA_FORMAT_UNION_UNION;

      SG_C_ASSERT(__sizeof__CRA_FORMAT_UNION_UNION, sizeof (CRA_FORMAT_UNION_UNION) == 4);
   #endif


#else
   // This union shows various interpretations of the UC.
   #if defined(SG_BMAP_UNION)
      typedef struct _CRA_FORMAT_UNION {
         union {
            union { 
               u32 dword : 30;                    // DWORD 0
               CRA ut;
               UC_CRA uc;
               PTC_CRA ptc;
               ISCSI_SGL_CRA sgl;
               FC_SGL_CRA fcsgl;
               RING_CRA ring;
               RING_CRA_RX ring_rx;
               PE_CRA pe;
               JE_CRA je;
               JE_OOO_CRA jeooo;
               R2T_CRA r2t;
               FC_R2T_CRA fc_r2t;
               TE_CRA te;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CRA_FORMAT_UNION, *PCRA_FORMAT_UNION;

      SG_C_ASSERT(__sizeof__CRA_FORMAT_UNION, sizeof (CRA_FORMAT_UNION) == 4);

   #else
      typedef union _CRA_FORMAT_UNION {
         u32 dword : 30;                          // DWORD 0
         CRA ut;
         UC_CRA uc;
         PTC_CRA ptc;
         ISCSI_SGL_CRA sgl;
         FC_SGL_CRA fcsgl;
         RING_CRA ring;
         RING_CRA_RX ring_rx;
         PE_CRA pe;
         JE_CRA je;
         JE_OOO_CRA jeooo;
         R2T_CRA r2t;
         FC_R2T_CRA fc_r2t;
         TE_CRA te;
      } SG_PACK CRA_FORMAT_UNION, *PCRA_FORMAT_UNION;

      typedef union _CRA_FORMAT_UNION_UNION {
         CRA_FORMAT_UNION bits;
         u32 dw; // dword union
      } SG_PACK CRA_FORMAT_UNION_UNION, *PCRA_FORMAT_UNION_UNION;

      SG_C_ASSERT(__sizeof__CRA_FORMAT_UNION_UNION, sizeof (CRA_FORMAT_UNION_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is an LRO Completion Descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _HW_LRO_COMPL {
         union {
            struct { 
               u32 tcp_ack_number;                // DWORD 0
               u32 tcp_timestamp_ecr;             // DWORD 1
               u32 vlan_tag : 16;                 // DWORD 2
               u32 tcp_window : 16;               // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 cid : 5;                       // DWORD 3
               u32 lro_timer_pop : 1;             // DWORD 3
               u32 lro_flush : 1;                 // DWORD 3
               u32 vtp : 1;                       // DWORD 3
               u32 tcp_push : 1;                  // DWORD 3
               u32 snap : 1;                      // DWORD 3
               u32 ip_version : 1;                // DWORD 3
               u32 tsopt : 1;                     // DWORD 3
               u32 qinq : 1;                      // DWORD 3
               u32 dupack_count : 2;              // DWORD 3
               u32 pktsize : 16;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK HW_LRO_COMPL, *PHW_LRO_COMPL;

      SG_C_ASSERT(__sizeof__HW_LRO_COMPL, sizeof (HW_LRO_COMPL) == 16);

   #else
      typedef struct _HW_LRO_COMPL {
         u32 tcp_ack_number;                      // DWORD 0
         u32 tcp_timestamp_ecr;                   // DWORD 1
         u32 vlan_tag : 16;                       // DWORD 2
         u32 tcp_window : 16;                     // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 cid : 5;                             // DWORD 3
         u32 lro_timer_pop : 1;                   // DWORD 3
         u32 lro_flush : 1;                       // DWORD 3
         u32 vtp : 1;                             // DWORD 3
         u32 tcp_push : 1;                        // DWORD 3
         u32 snap : 1;                            // DWORD 3
         u32 ip_version : 1;                      // DWORD 3
         u32 tsopt : 1;                           // DWORD 3
         u32 qinq : 1;                            // DWORD 3
         u32 dupack_count : 2;                    // DWORD 3
         u32 pktsize : 16;                        // DWORD 3
      } SG_PACK HW_LRO_COMPL, *PHW_LRO_COMPL;

      typedef union _HW_LRO_COMPL_UNION {
         HW_LRO_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK HW_LRO_COMPL_UNION, *PHW_LRO_COMPL_UNION;

      SG_C_ASSERT(__sizeof__HW_LRO_COMPL_UNION, sizeof (HW_LRO_COMPL_UNION) == 16);
   #endif


#else
   // This is an LRO Completion Descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _HW_LRO_COMPL {
         union {
            struct { 
               u32 tcp_ack_number;                // DWORD 0
               u32 tcp_timestamp_ecr;             // DWORD 1
               u32 tcp_window : 16;               // DWORD 2
               u32 vlan_tag : 16;                 // DWORD 2
               u32 pktsize : 16;                  // DWORD 3
               u32 dupack_count : 2;              // DWORD 3
               u32 qinq : 1;                      // DWORD 3
               u32 tsopt : 1;                     // DWORD 3
               u32 ip_version : 1;                // DWORD 3
               u32 snap : 1;                      // DWORD 3
               u32 tcp_push : 1;                  // DWORD 3
               u32 vtp : 1;                       // DWORD 3
               u32 lro_flush : 1;                 // DWORD 3
               u32 lro_timer_pop : 1;             // DWORD 3
               u32 cid : 5;                       // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK HW_LRO_COMPL, *PHW_LRO_COMPL;

      SG_C_ASSERT(__sizeof__HW_LRO_COMPL, sizeof (HW_LRO_COMPL) == 16);

   #else
      typedef struct _HW_LRO_COMPL {
         u32 tcp_ack_number;                      // DWORD 0
         u32 tcp_timestamp_ecr;                   // DWORD 1
         u32 tcp_window : 16;                     // DWORD 2
         u32 vlan_tag : 16;                       // DWORD 2
         u32 pktsize : 16;                        // DWORD 3
         u32 dupack_count : 2;                    // DWORD 3
         u32 qinq : 1;                            // DWORD 3
         u32 tsopt : 1;                           // DWORD 3
         u32 ip_version : 1;                      // DWORD 3
         u32 snap : 1;                            // DWORD 3
         u32 tcp_push : 1;                        // DWORD 3
         u32 vtp : 1;                             // DWORD 3
         u32 lro_flush : 1;                       // DWORD 3
         u32 lro_timer_pop : 1;                   // DWORD 3
         u32 cid : 5;                             // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK HW_LRO_COMPL, *PHW_LRO_COMPL;

      typedef union _HW_LRO_COMPL_UNION {
         HW_LRO_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK HW_LRO_COMPL_UNION, *PHW_LRO_COMPL_UNION;

      SG_C_ASSERT(__sizeof__HW_LRO_COMPL_UNION, sizeof (HW_LRO_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TOE Default Buffer Work Request Entry
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_DEFBUFFER {
         union {
            struct { 
               u32 frag_addr_hi;                  // DWORD 0
               u32 frag_addr_lo;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TOE_DEFBUFFER, *PTOE_DEFBUFFER;

      SG_C_ASSERT(__sizeof__TOE_DEFBUFFER, sizeof (TOE_DEFBUFFER) == 8);

   #else
      typedef struct _TOE_DEFBUFFER {
         u32 frag_addr_hi;                        // DWORD 0
         u32 frag_addr_lo;                        // DWORD 1
      } SG_PACK TOE_DEFBUFFER, *PTOE_DEFBUFFER;

      typedef union _TOE_DEFBUFFER_UNION {
         TOE_DEFBUFFER bits;
         u32 dw[2]; // dword union
      } SG_PACK TOE_DEFBUFFER_UNION, *PTOE_DEFBUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOE_DEFBUFFER_UNION, sizeof (TOE_DEFBUFFER_UNION) == 8);
   #endif


#else
   // TOE Default Buffer Work Request Entry
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_DEFBUFFER {
         union {
            struct { 
               u32 frag_addr_hi;                  // DWORD 0
               u32 frag_addr_lo;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK TOE_DEFBUFFER, *PTOE_DEFBUFFER;

      SG_C_ASSERT(__sizeof__TOE_DEFBUFFER, sizeof (TOE_DEFBUFFER) == 8);

   #else
      typedef struct _TOE_DEFBUFFER {
         u32 frag_addr_hi;                        // DWORD 0
         u32 frag_addr_lo;                        // DWORD 1
      } SG_PACK TOE_DEFBUFFER, *PTOE_DEFBUFFER;

      typedef union _TOE_DEFBUFFER_UNION {
         TOE_DEFBUFFER bits;
         u32 dw[2]; // dword union
      } SG_PACK TOE_DEFBUFFER_UNION, *PTOE_DEFBUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOE_DEFBUFFER_UNION, sizeof (TOE_DEFBUFFER_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TOE Preposted Buffer WRB.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_PREBUFFER {
         union {
            struct { 
               u32 frag_addr_hi;                  // DWORD 0
               u32 frag_addr_lo;                  // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 2
               u32 sgl_bytes : 31;                // DWORD 2
               u32 rsvd2 : 1;                     // DWORD 3
               u32 push_mode : 1;                 // DWORD 3
               u32 rsvd1 : 1;                     // DWORD 3
               u32 sgl_group_last : 1;            // DWORD 3
               u32 frag_cnt : 8;                  // DWORD 3
               u32 frag_len : 20;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_PREBUFFER, *PTOE_PREBUFFER;

      SG_C_ASSERT(__sizeof__TOE_PREBUFFER, sizeof (TOE_PREBUFFER) == 16);

   #else
      typedef struct _TOE_PREBUFFER {
         u32 frag_addr_hi;                        // DWORD 0
         u32 frag_addr_lo;                        // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 2
         u32 sgl_bytes : 31;                      // DWORD 2
         u32 rsvd2 : 1;                           // DWORD 3
         u32 push_mode : 1;                       // DWORD 3
         u32 rsvd1 : 1;                           // DWORD 3
         u32 sgl_group_last : 1;                  // DWORD 3
         u32 frag_cnt : 8;                        // DWORD 3
         u32 frag_len : 20;                       // DWORD 3
      } SG_PACK TOE_PREBUFFER, *PTOE_PREBUFFER;

      typedef union _TOE_PREBUFFER_UNION {
         TOE_PREBUFFER bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_PREBUFFER_UNION, *PTOE_PREBUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOE_PREBUFFER_UNION, sizeof (TOE_PREBUFFER_UNION) == 16);
   #endif


#else
   // TOE Preposted Buffer WRB.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_PREBUFFER {
         union {
            struct { 
               u32 frag_addr_hi;                  // DWORD 0
               u32 frag_addr_lo;                  // DWORD 1
               u32 sgl_bytes : 31;                // DWORD 2
               u32 rsvd0 : 1;                     // DWORD 2
               u32 frag_len : 20;                 // DWORD 3
               u32 frag_cnt : 8;                  // DWORD 3
               u32 sgl_group_last : 1;            // DWORD 3
               u32 rsvd1 : 1;                     // DWORD 3
               u32 push_mode : 1;                 // DWORD 3
               u32 rsvd2 : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_PREBUFFER, *PTOE_PREBUFFER;

      SG_C_ASSERT(__sizeof__TOE_PREBUFFER, sizeof (TOE_PREBUFFER) == 16);

   #else
      typedef struct _TOE_PREBUFFER {
         u32 frag_addr_hi;                        // DWORD 0
         u32 frag_addr_lo;                        // DWORD 1
         u32 sgl_bytes : 31;                      // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 frag_len : 20;                       // DWORD 3
         u32 frag_cnt : 8;                        // DWORD 3
         u32 sgl_group_last : 1;                  // DWORD 3
         u32 rsvd1 : 1;                           // DWORD 3
         u32 push_mode : 1;                       // DWORD 3
         u32 rsvd2 : 1;                           // DWORD 3
      } SG_PACK TOE_PREBUFFER, *PTOE_PREBUFFER;

      typedef union _TOE_PREBUFFER_UNION {
         TOE_PREBUFFER bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_PREBUFFER_UNION, *PTOE_PREBUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOE_PREBUFFER_UNION, sizeof (TOE_PREBUFFER_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is TOE transmit completion descriptor follows the general TOE completion
   // structure. TOE completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_TX_COMPL {
         union {
            struct { 
               u32 wrb_index : 12;                // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 valid : 1;                     // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 rsvd3 : 13;                    // DWORD 2
               u32 rsvd2 : 3;                     // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_TX_COMPL, *PTOE_TX_COMPL;

      SG_C_ASSERT(__sizeof__TOE_TX_COMPL, sizeof (TOE_TX_COMPL) == 16);

   #else
      typedef struct _TOE_TX_COMPL {
         u32 wrb_index : 12;                      // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 valid : 1;                           // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 rsvd3 : 13;                          // DWORD 2
         u32 rsvd2 : 3;                           // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_TX_COMPL, *PTOE_TX_COMPL;

      typedef union _TOE_TX_COMPL_UNION {
         TOE_TX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_TX_COMPL_UNION, *PTOE_TX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_TX_COMPL_UNION, sizeof (TOE_TX_COMPL_UNION) == 16);
   #endif


#else
   // This is TOE transmit completion descriptor follows the general TOE completion
   // structure. TOE completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_TX_COMPL {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 wrb_index : 12;                // DWORD 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 cid : 10;                      // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 rsvd2 : 3;                     // DWORD 2
               u32 rsvd3 : 13;                    // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_TX_COMPL, *PTOE_TX_COMPL;

      SG_C_ASSERT(__sizeof__TOE_TX_COMPL, sizeof (TOE_TX_COMPL) == 16);

   #else
      typedef struct _TOE_TX_COMPL {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 wrb_index : 12;                      // DWORD 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 cid : 10;                            // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 rsvd2 : 3;                           // DWORD 2
         u32 rsvd3 : 13;                          // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_TX_COMPL, *PTOE_TX_COMPL;

      typedef union _TOE_TX_COMPL_UNION {
         TOE_TX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_TX_COMPL_UNION, *PTOE_TX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_TX_COMPL_UNION, sizeof (TOE_TX_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is TOE receive completion descriptor follows the general TOE_COMPL structure.
   // Toe completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_RX_COMPL {
         union {
            struct { 
               u32 wrb_index : 12;                // DWORD 0
               u32 prepostoffs : 20;              // DWORD 0
               u32 ooo_hi : 9;                    // DWORD 1
               u32 order : 3;                     // DWORD 1
               u32 bytesrx : 20;                  // DWORD 1
               u32 valid : 1;                     // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 ooo_lo : 13;                   // DWORD 2
               u32 push_flag : 1;                 // DWORD 2
               u32 fin : 1;                       // DWORD 2
               u32 push_timer : 1;                // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_RX_COMPL, *PTOE_RX_COMPL;

      SG_C_ASSERT(__sizeof__TOE_RX_COMPL, sizeof (TOE_RX_COMPL) == 16);

   #else
      typedef struct _TOE_RX_COMPL {
         u32 wrb_index : 12;                      // DWORD 0
         u32 prepostoffs : 20;                    // DWORD 0
         u32 ooo_hi : 9;                          // DWORD 1
         u32 order : 3;                           // DWORD 1
         u32 bytesrx : 20;                        // DWORD 1
         u32 valid : 1;                           // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 ooo_lo : 13;                         // DWORD 2
         u32 push_flag : 1;                       // DWORD 2
         u32 fin : 1;                             // DWORD 2
         u32 push_timer : 1;                      // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_RX_COMPL, *PTOE_RX_COMPL;

      typedef union _TOE_RX_COMPL_UNION {
         TOE_RX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_RX_COMPL_UNION, *PTOE_RX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_RX_COMPL_UNION, sizeof (TOE_RX_COMPL_UNION) == 16);
   #endif


#else
   // This is TOE receive completion descriptor follows the general TOE_COMPL structure.
   // Toe completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_RX_COMPL {
         union {
            struct { 
               u32 prepostoffs : 20;              // DWORD 0
               u32 wrb_index : 12;                // DWORD 0
               u32 bytesrx : 20;                  // DWORD 1
               u32 order : 3;                     // DWORD 1
               u32 ooo_hi : 9;                    // DWORD 1
               u32 cid : 10;                      // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 push_timer : 1;                // DWORD 2
               u32 fin : 1;                       // DWORD 2
               u32 push_flag : 1;                 // DWORD 2
               u32 ooo_lo : 13;                   // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_RX_COMPL, *PTOE_RX_COMPL;

      SG_C_ASSERT(__sizeof__TOE_RX_COMPL, sizeof (TOE_RX_COMPL) == 16);

   #else
      typedef struct _TOE_RX_COMPL {
         u32 prepostoffs : 20;                    // DWORD 0
         u32 wrb_index : 12;                      // DWORD 0
         u32 bytesrx : 20;                        // DWORD 1
         u32 order : 3;                           // DWORD 1
         u32 ooo_hi : 9;                          // DWORD 1
         u32 cid : 10;                            // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 push_timer : 1;                      // DWORD 2
         u32 fin : 1;                             // DWORD 2
         u32 push_flag : 1;                       // DWORD 2
         u32 ooo_lo : 13;                         // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_RX_COMPL, *PTOE_RX_COMPL;

      typedef union _TOE_RX_COMPL_UNION {
         TOE_RX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_RX_COMPL_UNION, *PTOE_RX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_RX_COMPL_UNION, sizeof (TOE_RX_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is TOE receive completion descriptor follows the general TOE_COMPL structure.
   // Toe completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_PA_COMPL {
         union {
            struct { 
               u32 hi;                            // DWORD 0
               u32 lo;                            // DWORD 1
               u32 valid : 1;                     // DWORD 2
               u32 bytesrx : 15;                  // DWORD 2
               u32 push_flag : 1;                 // DWORD 2
               u32 fin : 1;                       // DWORD 2
               u32 push_timer : 1;                // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_PA_COMPL, *PTOE_PA_COMPL;

      SG_C_ASSERT(__sizeof__TOE_PA_COMPL, sizeof (TOE_PA_COMPL) == 16);

   #else
      typedef struct _TOE_PA_COMPL {
         u32 hi;                                  // DWORD 0
         u32 lo;                                  // DWORD 1
         u32 valid : 1;                           // DWORD 2
         u32 bytesrx : 15;                        // DWORD 2
         u32 push_flag : 1;                       // DWORD 2
         u32 fin : 1;                             // DWORD 2
         u32 push_timer : 1;                      // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_PA_COMPL, *PTOE_PA_COMPL;

      typedef union _TOE_PA_COMPL_UNION {
         TOE_PA_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_PA_COMPL_UNION, *PTOE_PA_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_PA_COMPL_UNION, sizeof (TOE_PA_COMPL_UNION) == 16);
   #endif


#else
   // This is TOE receive completion descriptor follows the general TOE_COMPL structure.
   // Toe completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_PA_COMPL {
         union {
            struct { 
               u32 hi;                            // DWORD 0
               u32 lo;                            // DWORD 1
               u32 cid : 10;                      // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 push_timer : 1;                // DWORD 2
               u32 fin : 1;                       // DWORD 2
               u32 push_flag : 1;                 // DWORD 2
               u32 bytesrx : 15;                  // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_PA_COMPL, *PTOE_PA_COMPL;

      SG_C_ASSERT(__sizeof__TOE_PA_COMPL, sizeof (TOE_PA_COMPL) == 16);

   #else
      typedef struct _TOE_PA_COMPL {
         u32 hi;                                  // DWORD 0
         u32 lo;                                  // DWORD 1
         u32 cid : 10;                            // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 push_timer : 1;                      // DWORD 2
         u32 fin : 1;                             // DWORD 2
         u32 push_flag : 1;                       // DWORD 2
         u32 bytesrx : 15;                        // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_PA_COMPL, *PTOE_PA_COMPL;

      typedef union _TOE_PA_COMPL_UNION {
         TOE_PA_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_PA_COMPL_UNION, *PTOE_PA_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_PA_COMPL_UNION, sizeof (TOE_PA_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is TOE transmit completion descriptor follows the general TOE completion
   // structure. TOE completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_TX_FLUSH_COMPL {
         union {
            struct { 
               u32 wrb_index : 12;                // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 valid : 1;                     // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 rsvd3 : 13;                    // DWORD 2
               u32 rsvd2 : 3;                     // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_TX_FLUSH_COMPL, *PTOE_TX_FLUSH_COMPL;

      SG_C_ASSERT(__sizeof__TOE_TX_FLUSH_COMPL, sizeof (TOE_TX_FLUSH_COMPL) == 16);

   #else
      typedef struct _TOE_TX_FLUSH_COMPL {
         u32 wrb_index : 12;                      // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 valid : 1;                           // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 rsvd3 : 13;                          // DWORD 2
         u32 rsvd2 : 3;                           // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_TX_FLUSH_COMPL, *PTOE_TX_FLUSH_COMPL;

      typedef union _TOE_TX_FLUSH_COMPL_UNION {
         TOE_TX_FLUSH_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_TX_FLUSH_COMPL_UNION, *PTOE_TX_FLUSH_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_TX_FLUSH_COMPL_UNION, sizeof (TOE_TX_FLUSH_COMPL_UNION) == 16);
   #endif


#else
   // This is TOE transmit completion descriptor follows the general TOE completion
   // structure. TOE completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_TX_FLUSH_COMPL {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 wrb_index : 12;                // DWORD 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 cid : 10;                      // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 rsvd2 : 3;                     // DWORD 2
               u32 rsvd3 : 13;                    // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_TX_FLUSH_COMPL, *PTOE_TX_FLUSH_COMPL;

      SG_C_ASSERT(__sizeof__TOE_TX_FLUSH_COMPL, sizeof (TOE_TX_FLUSH_COMPL) == 16);

   #else
      typedef struct _TOE_TX_FLUSH_COMPL {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 wrb_index : 12;                      // DWORD 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 cid : 10;                            // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 rsvd2 : 3;                           // DWORD 2
         u32 rsvd3 : 13;                          // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_TX_FLUSH_COMPL, *PTOE_TX_FLUSH_COMPL;

      typedef union _TOE_TX_FLUSH_COMPL_UNION {
         TOE_TX_FLUSH_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_TX_FLUSH_COMPL_UNION, *PTOE_TX_FLUSH_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_TX_FLUSH_COMPL_UNION, sizeof (TOE_TX_FLUSH_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is TOE receive completion descriptor follows the general TOE completion
   // structure. TOE completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_RX_FLUSH_COMPL {
         union {
            struct { 
               u32 wrb_index : 12;                // DWORD 0
               u32 prepostoffs : 20;              // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 1
               u32 order : 3;                     // DWORD 1
               u32 bytesrx : 20;                  // DWORD 1
               u32 valid : 1;                     // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 rsvd2 : 13;                    // DWORD 2
               u32 rsvd1 : 3;                     // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_RX_FLUSH_COMPL, *PTOE_RX_FLUSH_COMPL;

      SG_C_ASSERT(__sizeof__TOE_RX_FLUSH_COMPL, sizeof (TOE_RX_FLUSH_COMPL) == 16);

   #else
      typedef struct _TOE_RX_FLUSH_COMPL {
         u32 wrb_index : 12;                      // DWORD 0
         u32 prepostoffs : 20;                    // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 1
         u32 order : 3;                           // DWORD 1
         u32 bytesrx : 20;                        // DWORD 1
         u32 valid : 1;                           // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 rsvd2 : 13;                          // DWORD 2
         u32 rsvd1 : 3;                           // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_RX_FLUSH_COMPL, *PTOE_RX_FLUSH_COMPL;

      typedef union _TOE_RX_FLUSH_COMPL_UNION {
         TOE_RX_FLUSH_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_RX_FLUSH_COMPL_UNION, *PTOE_RX_FLUSH_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_RX_FLUSH_COMPL_UNION, sizeof (TOE_RX_FLUSH_COMPL_UNION) == 16);
   #endif


#else
   // This is TOE receive completion descriptor follows the general TOE completion
   // structure. TOE completions of transmit and receive can occupy the same ring.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_RX_FLUSH_COMPL {
         union {
            struct { 
               u32 prepostoffs : 20;              // DWORD 0
               u32 wrb_index : 12;                // DWORD 0
               u32 bytesrx : 20;                  // DWORD 1
               u32 order : 3;                     // DWORD 1
               u32 rsvd0 : 9;                     // DWORD 1
               u32 cid : 10;                      // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 rsvd1 : 3;                     // DWORD 2
               u32 rsvd2 : 13;                    // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_RX_FLUSH_COMPL, *PTOE_RX_FLUSH_COMPL;

      SG_C_ASSERT(__sizeof__TOE_RX_FLUSH_COMPL, sizeof (TOE_RX_FLUSH_COMPL) == 16);

   #else
      typedef struct _TOE_RX_FLUSH_COMPL {
         u32 prepostoffs : 20;                    // DWORD 0
         u32 wrb_index : 12;                      // DWORD 0
         u32 bytesrx : 20;                        // DWORD 1
         u32 order : 3;                           // DWORD 1
         u32 rsvd0 : 9;                           // DWORD 1
         u32 cid : 10;                            // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 rsvd1 : 3;                           // DWORD 2
         u32 rsvd2 : 13;                          // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_RX_FLUSH_COMPL, *PTOE_RX_FLUSH_COMPL;

      typedef union _TOE_RX_FLUSH_COMPL_UNION {
         TOE_RX_FLUSH_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_RX_FLUSH_COMPL_UNION, *PTOE_RX_FLUSH_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_RX_FLUSH_COMPL_UNION, sizeof (TOE_RX_FLUSH_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_STATE_COMPL {
         union {
            struct { 
               u32 wrb_index : 12;                // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 state : 16;                    // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 1
               u32 error_code : 16;               // DWORD 1
               u32 valid : 1;                     // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 rsvd3 : 13;                    // DWORD 2
               u32 rsvd2 : 3;                     // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 cid : 10;                      // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_STATE_COMPL, *PTOE_STATE_COMPL;

      SG_C_ASSERT(__sizeof__TOE_STATE_COMPL, sizeof (TOE_STATE_COMPL) == 16);

   #else
      typedef struct _TOE_STATE_COMPL {
         u32 wrb_index : 12;                      // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 state : 16;                          // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 1
         u32 error_code : 16;                     // DWORD 1
         u32 valid : 1;                           // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 rsvd3 : 13;                          // DWORD 2
         u32 rsvd2 : 3;                           // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 cid : 10;                            // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_STATE_COMPL, *PTOE_STATE_COMPL;

      typedef union _TOE_STATE_COMPL_UNION {
         TOE_STATE_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_STATE_COMPL_UNION, *PTOE_STATE_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_STATE_COMPL_UNION, sizeof (TOE_STATE_COMPL_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_STATE_COMPL {
         union {
            struct { 
               u32 state : 16;                    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 wrb_index : 12;                // DWORD 0
               u32 error_code : 16;               // DWORD 1
               u32 rsvd1 : 16;                    // DWORD 1
               u32 cid : 10;                      // DWORD 2
               u32 type : 3;                      // DWORD 2
               u32 rsvd2 : 3;                     // DWORD 2
               u32 rsvd3 : 13;                    // DWORD 2
               u32 ct : 2;                        // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 seqno;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK TOE_STATE_COMPL, *PTOE_STATE_COMPL;

      SG_C_ASSERT(__sizeof__TOE_STATE_COMPL, sizeof (TOE_STATE_COMPL) == 16);

   #else
      typedef struct _TOE_STATE_COMPL {
         u32 state : 16;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 wrb_index : 12;                      // DWORD 0
         u32 error_code : 16;                     // DWORD 1
         u32 rsvd1 : 16;                          // DWORD 1
         u32 cid : 10;                            // DWORD 2
         u32 type : 3;                            // DWORD 2
         u32 rsvd2 : 3;                           // DWORD 2
         u32 rsvd3 : 13;                          // DWORD 2
         u32 ct : 2;                              // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 seqno;                               // DWORD 3
      } SG_PACK TOE_STATE_COMPL, *PTOE_STATE_COMPL;

      typedef union _TOE_STATE_COMPL_UNION {
         TOE_STATE_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK TOE_STATE_COMPL_UNION, *PTOE_STATE_COMPL_UNION;

      SG_C_ASSERT(__sizeof__TOE_STATE_COMPL_UNION, sizeof (TOE_STATE_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Solicited I/O request Completion Queue Entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_CQ_ENTRY {
         union {
            struct { 
               u32 REQUEST_TAG : 16;              // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 HW_Status : 8;                 // DWORD 0
               u32 TotalDataPlaced;               // DWORD 1
               u32 Parameter;                     // DWORD 2
               u32 Valid : 1;                     // DWORD 3
               u32 rsvd1 : 2;                     // DWORD 3
               u32 XB : 1;                        // DWORD 3
               u32 PV : 1;                        // DWORD 3
               u32 Pri : 3;                       // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd0 : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_CQ_ENTRY, *PFC_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_CQ_ENTRY, sizeof (FC_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_CQ_ENTRY {
         u32 REQUEST_TAG : 16;                    // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 HW_Status : 8;                       // DWORD 0
         u32 TotalDataPlaced;                     // DWORD 1
         u32 Parameter;                           // DWORD 2
         u32 Valid : 1;                           // DWORD 3
         u32 rsvd1 : 2;                           // DWORD 3
         u32 XB : 1;                              // DWORD 3
         u32 PV : 1;                              // DWORD 3
         u32 Pri : 3;                             // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd0 : 16;                          // DWORD 3
      } SG_PACK FC_CQ_ENTRY, *PFC_CQ_ENTRY;

      typedef union _FC_CQ_ENTRY_UNION {
         FC_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_CQ_ENTRY_UNION, *PFC_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_CQ_ENTRY_UNION, sizeof (FC_CQ_ENTRY_UNION) == 16);
   #endif


#else
   // Solicited I/O request Completion Queue Entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_CQ_ENTRY {
         union {
            struct { 
               u32 HW_Status : 8;                 // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 REQUEST_TAG : 16;              // DWORD 0
               u32 TotalDataPlaced;               // DWORD 1
               u32 Parameter;                     // DWORD 2
               u32 rsvd0 : 16;                    // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 Pri : 3;                       // DWORD 3
               u32 PV : 1;                        // DWORD 3
               u32 XB : 1;                        // DWORD 3
               u32 rsvd1 : 2;                     // DWORD 3
               u32 Valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_CQ_ENTRY, *PFC_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_CQ_ENTRY, sizeof (FC_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_CQ_ENTRY {
         u32 HW_Status : 8;                       // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 REQUEST_TAG : 16;                    // DWORD 0
         u32 TotalDataPlaced;                     // DWORD 1
         u32 Parameter;                           // DWORD 2
         u32 rsvd0 : 16;                          // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 Pri : 3;                             // DWORD 3
         u32 PV : 1;                              // DWORD 3
         u32 XB : 1;                              // DWORD 3
         u32 rsvd1 : 2;                           // DWORD 3
         u32 Valid : 1;                           // DWORD 3
      } SG_PACK FC_CQ_ENTRY, *PFC_CQ_ENTRY;

      typedef union _FC_CQ_ENTRY_UNION {
         FC_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_CQ_ENTRY_UNION, *PFC_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_CQ_ENTRY_UNION, sizeof (FC_CQ_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Aborted I/O Completion Queue Entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_XRI_ABORTED_CQE {
         union {
            struct { 
               u32 rsvd1 : 16;                    // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 RJT_status;                    // DWORD 1
               u32 Remote_XID : 16;               // DWORD 2
               u32 XRI : 16;                      // DWORD 2
               u32 Valid : 1;                     // DWORD 3
               u32 IA : 1;                        // DWORD 3
               u32 BR : 1;                        // DWORD 3
               u32 EO : 1;                        // DWORD 3
               u32 rsvd3 : 4;                     // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd2 : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_XRI_ABORTED_CQE, *PFC_XRI_ABORTED_CQE;

      SG_C_ASSERT(__sizeof__FC_XRI_ABORTED_CQE, sizeof (FC_XRI_ABORTED_CQE) == 16);

   #else
      typedef struct _FC_XRI_ABORTED_CQE {
         u32 rsvd1 : 16;                          // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 RJT_status;                          // DWORD 1
         u32 Remote_XID : 16;                     // DWORD 2
         u32 XRI : 16;                            // DWORD 2
         u32 Valid : 1;                           // DWORD 3
         u32 IA : 1;                              // DWORD 3
         u32 BR : 1;                              // DWORD 3
         u32 EO : 1;                              // DWORD 3
         u32 rsvd3 : 4;                           // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd2 : 16;                          // DWORD 3
      } SG_PACK FC_XRI_ABORTED_CQE, *PFC_XRI_ABORTED_CQE;

      typedef union _FC_XRI_ABORTED_CQE_UNION {
         FC_XRI_ABORTED_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_XRI_ABORTED_CQE_UNION, *PFC_XRI_ABORTED_CQE_UNION;

      SG_C_ASSERT(__sizeof__FC_XRI_ABORTED_CQE_UNION, sizeof (FC_XRI_ABORTED_CQE_UNION) == 16);
   #endif


#else
   // Aborted I/O Completion Queue Entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_XRI_ABORTED_CQE {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
               u32 RJT_status;                    // DWORD 1
               u32 XRI : 16;                      // DWORD 2
               u32 Remote_XID : 16;               // DWORD 2
               u32 rsvd2 : 16;                    // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd3 : 4;                     // DWORD 3
               u32 EO : 1;                        // DWORD 3
               u32 BR : 1;                        // DWORD 3
               u32 IA : 1;                        // DWORD 3
               u32 Valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_XRI_ABORTED_CQE, *PFC_XRI_ABORTED_CQE;

      SG_C_ASSERT(__sizeof__FC_XRI_ABORTED_CQE, sizeof (FC_XRI_ABORTED_CQE) == 16);

   #else
      typedef struct _FC_XRI_ABORTED_CQE {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
         u32 RJT_status;                          // DWORD 1
         u32 XRI : 16;                            // DWORD 2
         u32 Remote_XID : 16;                     // DWORD 2
         u32 rsvd2 : 16;                          // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd3 : 4;                           // DWORD 3
         u32 EO : 1;                              // DWORD 3
         u32 BR : 1;                              // DWORD 3
         u32 IA : 1;                              // DWORD 3
         u32 Valid : 1;                           // DWORD 3
      } SG_PACK FC_XRI_ABORTED_CQE, *PFC_XRI_ABORTED_CQE;

      typedef union _FC_XRI_ABORTED_CQE_UNION {
         FC_XRI_ABORTED_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_XRI_ABORTED_CQE_UNION, *PFC_XRI_ABORTED_CQE_UNION;

      SG_C_ASSERT(__sizeof__FC_XRI_ABORTED_CQE_UNION, sizeof (FC_XRI_ABORTED_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Release WRBs Completion Queue Entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_RELEASE_WRBS_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 WRBQ_ID : 16;                  // DWORD 2
               u32 wrb_index : 16;                // DWORD 2
               u32 Valid : 1;                     // DWORD 3
               u32 rsvd3 : 7;                     // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd2 : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_RELEASE_WRBS_CQ_ENTRY, *PFC_RELEASE_WRBS_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_RELEASE_WRBS_CQ_ENTRY, sizeof (FC_RELEASE_WRBS_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_RELEASE_WRBS_CQ_ENTRY {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 WRBQ_ID : 16;                        // DWORD 2
         u32 wrb_index : 16;                      // DWORD 2
         u32 Valid : 1;                           // DWORD 3
         u32 rsvd3 : 7;                           // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd2 : 16;                          // DWORD 3
      } SG_PACK FC_RELEASE_WRBS_CQ_ENTRY, *PFC_RELEASE_WRBS_CQ_ENTRY;

      typedef union _FC_RELEASE_WRBS_CQ_ENTRY_UNION {
         FC_RELEASE_WRBS_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_RELEASE_WRBS_CQ_ENTRY_UNION, *PFC_RELEASE_WRBS_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_RELEASE_WRBS_CQ_ENTRY_UNION, sizeof (FC_RELEASE_WRBS_CQ_ENTRY_UNION) == 16);
   #endif


#else
   // Release WRBs Completion Queue Entry.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_RELEASE_WRBS_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 wrb_index : 16;                // DWORD 2
               u32 WRBQ_ID : 16;                  // DWORD 2
               u32 rsvd2 : 16;                    // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd3 : 7;                     // DWORD 3
               u32 Valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_RELEASE_WRBS_CQ_ENTRY, *PFC_RELEASE_WRBS_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_RELEASE_WRBS_CQ_ENTRY, sizeof (FC_RELEASE_WRBS_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_RELEASE_WRBS_CQ_ENTRY {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 wrb_index : 16;                      // DWORD 2
         u32 WRBQ_ID : 16;                        // DWORD 2
         u32 rsvd2 : 16;                          // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd3 : 7;                           // DWORD 3
         u32 Valid : 1;                           // DWORD 3
      } SG_PACK FC_RELEASE_WRBS_CQ_ENTRY, *PFC_RELEASE_WRBS_CQ_ENTRY;

      typedef union _FC_RELEASE_WRBS_CQ_ENTRY_UNION {
         FC_RELEASE_WRBS_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_RELEASE_WRBS_CQ_ENTRY_UNION, *PFC_RELEASE_WRBS_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_RELEASE_WRBS_CQ_ENTRY_UNION, sizeof (FC_RELEASE_WRBS_CQ_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unsolicited frame Completion Queue Entry for host.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_DEFAULT_FRAME_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd1 : 4;                     // DWORD 0
               u32 RBIndex : 12;                  // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 rsvd2[1];                      // DWORDS 1 to 1
               u32 DataPlacementLength : 16;      // DWORD 2
               u32 RBQ_ID : 10;                   // DWORD 2
               u32 FCF_ID : 6;                    // DWORD 2
               u32 Valid : 1;                     // DWORD 3
               u32 Port : 1;                      // DWORD 3
               u32 HdrPlacementLength : 6;        // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 EOFByte : 8;                   // DWORD 3
               u32 SOFByte : 8;                   // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_DEFAULT_FRAME_CQ_ENTRY, *PFC_DEFAULT_FRAME_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_DEFAULT_FRAME_CQ_ENTRY, sizeof (FC_DEFAULT_FRAME_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_DEFAULT_FRAME_CQ_ENTRY {
         u32 rsvd1 : 4;                           // DWORD 0
         u32 RBIndex : 12;                        // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rsvd2[1];                            // DWORDS 1 to 1
         u32 DataPlacementLength : 16;            // DWORD 2
         u32 RBQ_ID : 10;                         // DWORD 2
         u32 FCF_ID : 6;                          // DWORD 2
         u32 Valid : 1;                           // DWORD 3
         u32 Port : 1;                            // DWORD 3
         u32 HdrPlacementLength : 6;              // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 EOFByte : 8;                         // DWORD 3
         u32 SOFByte : 8;                         // DWORD 3
      } SG_PACK FC_DEFAULT_FRAME_CQ_ENTRY, *PFC_DEFAULT_FRAME_CQ_ENTRY;

      typedef union _FC_DEFAULT_FRAME_CQ_ENTRY_UNION {
         FC_DEFAULT_FRAME_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_DEFAULT_FRAME_CQ_ENTRY_UNION, *PFC_DEFAULT_FRAME_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_DEFAULT_FRAME_CQ_ENTRY_UNION, sizeof (FC_DEFAULT_FRAME_CQ_ENTRY_UNION) == 16);
   #endif


#else
   // Unsolicited frame Completion Queue Entry for host.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_DEFAULT_FRAME_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 RBIndex : 12;                  // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 rsvd2[1];                      // DWORDS 1 to 1
               u32 FCF_ID : 6;                    // DWORD 2
               u32 RBQ_ID : 10;                   // DWORD 2
               u32 DataPlacementLength : 16;      // DWORD 2
               u32 SOFByte : 8;                   // DWORD 3
               u32 EOFByte : 8;                   // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 HdrPlacementLength : 6;        // DWORD 3
               u32 Port : 1;                      // DWORD 3
               u32 Valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_DEFAULT_FRAME_CQ_ENTRY, *PFC_DEFAULT_FRAME_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_DEFAULT_FRAME_CQ_ENTRY, sizeof (FC_DEFAULT_FRAME_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_DEFAULT_FRAME_CQ_ENTRY {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 RBIndex : 12;                        // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 rsvd2[1];                            // DWORDS 1 to 1
         u32 FCF_ID : 6;                          // DWORD 2
         u32 RBQ_ID : 10;                         // DWORD 2
         u32 DataPlacementLength : 16;            // DWORD 2
         u32 SOFByte : 8;                         // DWORD 3
         u32 EOFByte : 8;                         // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 HdrPlacementLength : 6;              // DWORD 3
         u32 Port : 1;                            // DWORD 3
         u32 Valid : 1;                           // DWORD 3
      } SG_PACK FC_DEFAULT_FRAME_CQ_ENTRY, *PFC_DEFAULT_FRAME_CQ_ENTRY;

      typedef union _FC_DEFAULT_FRAME_CQ_ENTRY_UNION {
         FC_DEFAULT_FRAME_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_DEFAULT_FRAME_CQ_ENTRY_UNION, *PFC_DEFAULT_FRAME_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_DEFAULT_FRAME_CQ_ENTRY_UNION, sizeof (FC_DEFAULT_FRAME_CQ_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unsolicited frame Completion Queue Entry for ARM.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ARM_DEFAULT_FRAME_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd1 : 4;                     // DWORD 0
               u32 RBIndex : 12;                  // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 rsvd2[1];                      // DWORDS 1 to 1
               u32 DataPlacementLength : 16;      // DWORD 2
               u32 RBQ_ID : 10;                   // DWORD 2
               u32 FCF_ID : 6;                    // DWORD 2
               u32 Valid : 1;                     // DWORD 3
               u32 Port : 1;                      // DWORD 3
               u32 VTP : 1;                       // DWORD 3
               u32 rsvd3 : 5;                     // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 VTag : 16;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_ARM_DEFAULT_FRAME_CQ_ENTRY, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_ARM_DEFAULT_FRAME_CQ_ENTRY, sizeof (FC_ARM_DEFAULT_FRAME_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_ARM_DEFAULT_FRAME_CQ_ENTRY {
         u32 rsvd1 : 4;                           // DWORD 0
         u32 RBIndex : 12;                        // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rsvd2[1];                            // DWORDS 1 to 1
         u32 DataPlacementLength : 16;            // DWORD 2
         u32 RBQ_ID : 10;                         // DWORD 2
         u32 FCF_ID : 6;                          // DWORD 2
         u32 Valid : 1;                           // DWORD 3
         u32 Port : 1;                            // DWORD 3
         u32 VTP : 1;                             // DWORD 3
         u32 rsvd3 : 5;                           // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 VTag : 16;                           // DWORD 3
      } SG_PACK FC_ARM_DEFAULT_FRAME_CQ_ENTRY, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY;

      typedef union _FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION {
         FC_ARM_DEFAULT_FRAME_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION, sizeof (FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION) == 16);
   #endif


#else
   // Unsolicited frame Completion Queue Entry for ARM.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ARM_DEFAULT_FRAME_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 RBIndex : 12;                  // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 rsvd2[1];                      // DWORDS 1 to 1
               u32 FCF_ID : 6;                    // DWORD 2
               u32 RBQ_ID : 10;                   // DWORD 2
               u32 DataPlacementLength : 16;      // DWORD 2
               u32 VTag : 16;                     // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd3 : 5;                     // DWORD 3
               u32 VTP : 1;                       // DWORD 3
               u32 Port : 1;                      // DWORD 3
               u32 Valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_ARM_DEFAULT_FRAME_CQ_ENTRY, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_ARM_DEFAULT_FRAME_CQ_ENTRY, sizeof (FC_ARM_DEFAULT_FRAME_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_ARM_DEFAULT_FRAME_CQ_ENTRY {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 RBIndex : 12;                        // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 rsvd2[1];                            // DWORDS 1 to 1
         u32 FCF_ID : 6;                          // DWORD 2
         u32 RBQ_ID : 10;                         // DWORD 2
         u32 DataPlacementLength : 16;            // DWORD 2
         u32 VTag : 16;                           // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd3 : 5;                           // DWORD 3
         u32 VTP : 1;                             // DWORD 3
         u32 Port : 1;                            // DWORD 3
         u32 Valid : 1;                           // DWORD 3
      } SG_PACK FC_ARM_DEFAULT_FRAME_CQ_ENTRY, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY;

      typedef union _FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION {
         FC_ARM_DEFAULT_FRAME_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION, *PFC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION, sizeof (FC_ARM_DEFAULT_FRAME_CQ_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Reply to IPC Completion Queue Entry for ARM.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ARM_IPC_REPLY_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd1 : 16;                    // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 rsvd2[1];                      // DWORDS 1 to 1
               u32 rsvd4 : 16;                    // DWORD 2
               u32 RBQ_ID : 10;                   // DWORD 2
               u32 rsvd3 : 6;                     // DWORD 2
               u32 Valid : 1;                     // DWORD 3
               u32 rsvd6 : 7;                     // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd5 : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_ARM_IPC_REPLY_CQ_ENTRY, *PFC_ARM_IPC_REPLY_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_ARM_IPC_REPLY_CQ_ENTRY, sizeof (FC_ARM_IPC_REPLY_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_ARM_IPC_REPLY_CQ_ENTRY {
         u32 rsvd1 : 16;                          // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rsvd2[1];                            // DWORDS 1 to 1
         u32 rsvd4 : 16;                          // DWORD 2
         u32 RBQ_ID : 10;                         // DWORD 2
         u32 rsvd3 : 6;                           // DWORD 2
         u32 Valid : 1;                           // DWORD 3
         u32 rsvd6 : 7;                           // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd5 : 16;                          // DWORD 3
      } SG_PACK FC_ARM_IPC_REPLY_CQ_ENTRY, *PFC_ARM_IPC_REPLY_CQ_ENTRY;

      typedef union _FC_ARM_IPC_REPLY_CQ_ENTRY_UNION {
         FC_ARM_IPC_REPLY_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_ARM_IPC_REPLY_CQ_ENTRY_UNION, *PFC_ARM_IPC_REPLY_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_ARM_IPC_REPLY_CQ_ENTRY_UNION, sizeof (FC_ARM_IPC_REPLY_CQ_ENTRY_UNION) == 16);
   #endif


#else
   // Reply to IPC Completion Queue Entry for ARM.
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ARM_IPC_REPLY_CQ_ENTRY {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 Status : 8;                    // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
               u32 rsvd2[1];                      // DWORDS 1 to 1
               u32 rsvd3 : 6;                     // DWORD 2
               u32 RBQ_ID : 10;                   // DWORD 2
               u32 rsvd4 : 16;                    // DWORD 2
               u32 rsvd5 : 16;                    // DWORD 3
               u32 Code : 8;                      // DWORD 3
               u32 rsvd6 : 7;                     // DWORD 3
               u32 Valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_ARM_IPC_REPLY_CQ_ENTRY, *PFC_ARM_IPC_REPLY_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__FC_ARM_IPC_REPLY_CQ_ENTRY, sizeof (FC_ARM_IPC_REPLY_CQ_ENTRY) == 16);

   #else
      typedef struct _FC_ARM_IPC_REPLY_CQ_ENTRY {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 Status : 8;                          // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
         u32 rsvd2[1];                            // DWORDS 1 to 1
         u32 rsvd3 : 6;                           // DWORD 2
         u32 RBQ_ID : 10;                         // DWORD 2
         u32 rsvd4 : 16;                          // DWORD 2
         u32 rsvd5 : 16;                          // DWORD 3
         u32 Code : 8;                            // DWORD 3
         u32 rsvd6 : 7;                           // DWORD 3
         u32 Valid : 1;                           // DWORD 3
      } SG_PACK FC_ARM_IPC_REPLY_CQ_ENTRY, *PFC_ARM_IPC_REPLY_CQ_ENTRY;

      typedef union _FC_ARM_IPC_REPLY_CQ_ENTRY_UNION {
         FC_ARM_IPC_REPLY_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_ARM_IPC_REPLY_CQ_ENTRY_UNION, *PFC_ARM_IPC_REPLY_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__FC_ARM_IPC_REPLY_CQ_ENTRY_UNION, sizeof (FC_ARM_IPC_REPLY_CQ_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_WRB_CONTEXT_SLI3 {
         union {
            struct { 
               u32 BufferType : 8;                // DWORD 0
               u32 BufferSize : 24;               // DWORD 0
               u32 AddressLow;                    // DWORD 1
               u32 AddressHigh;                   // DWORD 2
               u32 IO_TAG32;                      // DWORD 3
               union {
                  u32 TransferLength;             // DWORD 4
                  struct {
                     u32 rsvd0 : 8;               // DWORD 4
                     u32 expected_xfer_count_hi : 8; // DWORD 4
                     u32 expected_xfer_count_lo : 16; // DWORD 4
                  } iwr_xfer_length;
                  struct {
                     u32 rsvd0 : 8;               // DWORD 4
                     u32 D_ID : 24;               // DWORD 4
                  } xmit_els_rsp;
                  struct {
                     u32 CRITERIA : 8;            // DWORD 4
                     u32 rsvd0 : 23;              // DWORD 4
                     u32 MM : 1;                  // DWORD 4
                  } abort_close_extended;
                  struct {
                     u32 Parameter;               // DWORD 4
                  } gen_request;
                  struct {
                     u32 rsvd0 : 7;               // DWORD 4
                     u32 SP : 1;                  // DWORD 4
                     u32 S_ID : 24;               // DWORD 4
                  } els_request;
               } word4;
               union {
                  u32 InitialTransferLength;      // DWORD 5
                  struct {
                     u32 err_RPI : 16;            // DWORD 5
                     u32 err_sgl_icd_index : 16;  // DWORD 5
                  } abort_xri;
                  struct {
                     u32 R_CTL : 8;               // DWORD 5
                     u32 TYPE : 8;                // DWORD 5
                     u32 DF_CTL : 8;              // DWORD 5
                     u32 rsvd0 : 8;               // DWORD 5
                  } gen_request;
                  struct {
                     u32 rsvd0 : 8;               // DWORD 5
                     u32 D_ID : 24;               // DWORD 5
                  } els_request;
               } word5;
               u32 CONTEXT_TAG : 16;              // DWORD 6
               u32 sgl_icd_index : 16;            // DWORD 6
               u32 Timer : 8;                     // DWORD 7
               u32 XS : 1;                        // DWORD 7
               u32 ERP : 1;                       // DWORD 7
               u32 PU : 2;                        // DWORD 7
               u32 rsvd0 : 1;                     // DWORD 7
               u32 ClassService : 3;              // DWORD 7
               u32 Command : 8;                   // DWORD 7
               u32 Status : 4;                    // DWORD 7
               u32 BDE : 2;                       // DWORD 7
               u32 LE : 1;                        // DWORD 7
               u32 AC : 1;                        // DWORD 7
               u32 IO_TAG64_LOW;                  // DWORD 8
               u32 IO_TAG64_HIGH;                 // DWORD 9
               u32 CCP : 8;                       // DWORD 10
               u32 CCPE : 1;                      // DWORD 10
               u32 rsvd2 : 3;                     // DWORD 10
               u32 PV : 1;                        // DWORD 10
               u32 PRI : 3;                       // DWORD 10
               u32 rsvd1 : 16;                    // DWORD 10
               u32 rsvd5 : 6;                     // DWORD 11
               u32 cq_id : 10;                    // DWORD 11
               u32 rsvd4 : 8;                     // DWORD 11
               u32 flush_wrb : 1;                 // DWORD 11
               u32 rsvd3 : 3;                     // DWORD 11
               u32 cmd_type : 4;                  // DWORD 11
               u32 rsvd6[4];                      // DWORDS 12 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_WRB_CONTEXT_SLI3, *PFC_WRB_CONTEXT_SLI3;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT_SLI3, sizeof (FC_WRB_CONTEXT_SLI3) == 64);

   #else
      typedef struct _FC_WRB_CONTEXT_SLI3 {
         u32 BufferType : 8;                      // DWORD 0
         u32 BufferSize : 24;                     // DWORD 0
         u32 AddressLow;                          // DWORD 1
         u32 AddressHigh;                         // DWORD 2
         u32 IO_TAG32;                            // DWORD 3
         union {
            u32 TransferLength;                   // DWORD 4
            struct {
               u32 rsvd0 : 8;                     // DWORD 4
               u32 expected_xfer_count_hi : 8;    // DWORD 4
               u32 expected_xfer_count_lo : 16;   // DWORD 4
            } iwr_xfer_length;
            struct {
               u32 rsvd0 : 8;                     // DWORD 4
               u32 D_ID : 24;                     // DWORD 4
            } xmit_els_rsp;
            struct {
               u32 CRITERIA : 8;                  // DWORD 4
               u32 rsvd0 : 23;                    // DWORD 4
               u32 MM : 1;                        // DWORD 4
            } abort_close_extended;
            struct {
               u32 Parameter;                     // DWORD 4
            } gen_request;
            struct {
               u32 rsvd0 : 7;                     // DWORD 4
               u32 SP : 1;                        // DWORD 4
               u32 S_ID : 24;                     // DWORD 4
            } els_request;
         } word4;
         union {
            u32 InitialTransferLength;            // DWORD 5
            struct {
               u32 err_RPI : 16;                  // DWORD 5
               u32 err_sgl_icd_index : 16;        // DWORD 5
            } abort_xri;
            struct {
               u32 R_CTL : 8;                     // DWORD 5
               u32 TYPE : 8;                      // DWORD 5
               u32 DF_CTL : 8;                    // DWORD 5
               u32 rsvd0 : 8;                     // DWORD 5
            } gen_request;
            struct {
               u32 rsvd0 : 8;                     // DWORD 5
               u32 D_ID : 24;                     // DWORD 5
            } els_request;
         } word5;
         u32 CONTEXT_TAG : 16;                    // DWORD 6
         u32 sgl_icd_index : 16;                  // DWORD 6
         u32 Timer : 8;                           // DWORD 7
         u32 XS : 1;                              // DWORD 7
         u32 ERP : 1;                             // DWORD 7
         u32 PU : 2;                              // DWORD 7
         u32 rsvd0 : 1;                           // DWORD 7
         u32 ClassService : 3;                    // DWORD 7
         u32 Command : 8;                         // DWORD 7
         u32 Status : 4;                          // DWORD 7
         u32 BDE : 2;                             // DWORD 7
         u32 LE : 1;                              // DWORD 7
         u32 AC : 1;                              // DWORD 7
         u32 IO_TAG64_LOW;                        // DWORD 8
         u32 IO_TAG64_HIGH;                       // DWORD 9
         u32 CCP : 8;                             // DWORD 10
         u32 CCPE : 1;                            // DWORD 10
         u32 rsvd2 : 3;                           // DWORD 10
         u32 PV : 1;                              // DWORD 10
         u32 PRI : 3;                             // DWORD 10
         u32 rsvd1 : 16;                          // DWORD 10
         u32 rsvd5 : 6;                           // DWORD 11
         u32 cq_id : 10;                          // DWORD 11
         u32 rsvd4 : 8;                           // DWORD 11
         u32 flush_wrb : 1;                       // DWORD 11
         u32 rsvd3 : 3;                           // DWORD 11
         u32 cmd_type : 4;                        // DWORD 11
         u32 rsvd6[4];                            // DWORDS 12 to 15
      } SG_PACK FC_WRB_CONTEXT_SLI3, *PFC_WRB_CONTEXT_SLI3;

      typedef union _FC_WRB_CONTEXT_SLI3_UNION {
         FC_WRB_CONTEXT_SLI3 bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_WRB_CONTEXT_SLI3_UNION, *PFC_WRB_CONTEXT_SLI3_UNION;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT_SLI3_UNION, sizeof (FC_WRB_CONTEXT_SLI3_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_WRB_CONTEXT_SLI3 {
         union {
            struct { 
               u32 BufferSize : 24;               // DWORD 0
               u32 BufferType : 8;                // DWORD 0
               u32 AddressLow;                    // DWORD 1
               u32 AddressHigh;                   // DWORD 2
               u32 IO_TAG32;                      // DWORD 3
               union {
                  u32 TransferLength;             // DWORD 4
                  struct {
                     u32 expected_xfer_count_lo : 16; // DWORD 4
                     u32 expected_xfer_count_hi : 8; // DWORD 4
                     u32 rsvd0 : 8;               // DWORD 4
                  } iwr_xfer_length;
                  struct {
                     u32 D_ID : 24;               // DWORD 4
                     u32 rsvd0 : 8;               // DWORD 4
                  } xmit_els_rsp;
                  struct {
                     u32 MM : 1;                  // DWORD 4
                     u32 rsvd0 : 23;              // DWORD 4
                     u32 CRITERIA : 8;            // DWORD 4
                  } abort_close_extended;
                  struct {
                     u32 Parameter;               // DWORD 4
                  } gen_request;
                  struct {
                     u32 S_ID : 24;               // DWORD 4
                     u32 SP : 1;                  // DWORD 4
                     u32 rsvd0 : 7;               // DWORD 4
                  } els_request;
               } word4;
               union {
                  u32 InitialTransferLength;      // DWORD 5
                  struct {
                     u32 err_sgl_icd_index : 16;  // DWORD 5
                     u32 err_RPI : 16;            // DWORD 5
                  } abort_xri;
                  struct {
                     u32 rsvd0 : 8;               // DWORD 5
                     u32 DF_CTL : 8;              // DWORD 5
                     u32 TYPE : 8;                // DWORD 5
                     u32 R_CTL : 8;               // DWORD 5
                  } gen_request;
                  struct {
                     u32 D_ID : 24;               // DWORD 5
                     u32 rsvd0 : 8;               // DWORD 5
                  } els_request;
               } word5;
               u32 sgl_icd_index : 16;            // DWORD 6
               u32 CONTEXT_TAG : 16;              // DWORD 6
               u32 AC : 1;                        // DWORD 7
               u32 LE : 1;                        // DWORD 7
               u32 BDE : 2;                       // DWORD 7
               u32 Status : 4;                    // DWORD 7
               u32 Command : 8;                   // DWORD 7
               u32 ClassService : 3;              // DWORD 7
               u32 rsvd0 : 1;                     // DWORD 7
               u32 PU : 2;                        // DWORD 7
               u32 ERP : 1;                       // DWORD 7
               u32 XS : 1;                        // DWORD 7
               u32 Timer : 8;                     // DWORD 7
               u32 IO_TAG64_LOW;                  // DWORD 8
               u32 IO_TAG64_HIGH;                 // DWORD 9
               u32 rsvd1 : 16;                    // DWORD 10
               u32 PRI : 3;                       // DWORD 10
               u32 PV : 1;                        // DWORD 10
               u32 rsvd2 : 3;                     // DWORD 10
               u32 CCPE : 1;                      // DWORD 10
               u32 CCP : 8;                       // DWORD 10
               u32 cmd_type : 4;                  // DWORD 11
               u32 rsvd3 : 3;                     // DWORD 11
               u32 flush_wrb : 1;                 // DWORD 11
               u32 rsvd4 : 8;                     // DWORD 11
               u32 cq_id : 10;                    // DWORD 11
               u32 rsvd5 : 6;                     // DWORD 11
               u32 rsvd6[4];                      // DWORDS 12 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_WRB_CONTEXT_SLI3, *PFC_WRB_CONTEXT_SLI3;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT_SLI3, sizeof (FC_WRB_CONTEXT_SLI3) == 64);

   #else
      typedef struct _FC_WRB_CONTEXT_SLI3 {
         u32 BufferSize : 24;                     // DWORD 0
         u32 BufferType : 8;                      // DWORD 0
         u32 AddressLow;                          // DWORD 1
         u32 AddressHigh;                         // DWORD 2
         u32 IO_TAG32;                            // DWORD 3
         union {
            u32 TransferLength;                   // DWORD 4
            struct {
               u32 expected_xfer_count_lo : 16;   // DWORD 4
               u32 expected_xfer_count_hi : 8;    // DWORD 4
               u32 rsvd0 : 8;                     // DWORD 4
            } iwr_xfer_length;
            struct {
               u32 D_ID : 24;                     // DWORD 4
               u32 rsvd0 : 8;                     // DWORD 4
            } xmit_els_rsp;
            struct {
               u32 MM : 1;                        // DWORD 4
               u32 rsvd0 : 23;                    // DWORD 4
               u32 CRITERIA : 8;                  // DWORD 4
            } abort_close_extended;
            struct {
               u32 Parameter;                     // DWORD 4
            } gen_request;
            struct {
               u32 S_ID : 24;                     // DWORD 4
               u32 SP : 1;                        // DWORD 4
               u32 rsvd0 : 7;                     // DWORD 4
            } els_request;
         } word4;
         union {
            u32 InitialTransferLength;            // DWORD 5
            struct {
               u32 err_sgl_icd_index : 16;        // DWORD 5
               u32 err_RPI : 16;                  // DWORD 5
            } abort_xri;
            struct {
               u32 rsvd0 : 8;                     // DWORD 5
               u32 DF_CTL : 8;                    // DWORD 5
               u32 TYPE : 8;                      // DWORD 5
               u32 R_CTL : 8;                     // DWORD 5
            } gen_request;
            struct {
               u32 D_ID : 24;                     // DWORD 5
               u32 rsvd0 : 8;                     // DWORD 5
            } els_request;
         } word5;
         u32 sgl_icd_index : 16;                  // DWORD 6
         u32 CONTEXT_TAG : 16;                    // DWORD 6
         u32 AC : 1;                              // DWORD 7
         u32 LE : 1;                              // DWORD 7
         u32 BDE : 2;                             // DWORD 7
         u32 Status : 4;                          // DWORD 7
         u32 Command : 8;                         // DWORD 7
         u32 ClassService : 3;                    // DWORD 7
         u32 rsvd0 : 1;                           // DWORD 7
         u32 PU : 2;                              // DWORD 7
         u32 ERP : 1;                             // DWORD 7
         u32 XS : 1;                              // DWORD 7
         u32 Timer : 8;                           // DWORD 7
         u32 IO_TAG64_LOW;                        // DWORD 8
         u32 IO_TAG64_HIGH;                       // DWORD 9
         u32 rsvd1 : 16;                          // DWORD 10
         u32 PRI : 3;                             // DWORD 10
         u32 PV : 1;                              // DWORD 10
         u32 rsvd2 : 3;                           // DWORD 10
         u32 CCPE : 1;                            // DWORD 10
         u32 CCP : 8;                             // DWORD 10
         u32 cmd_type : 4;                        // DWORD 11
         u32 rsvd3 : 3;                           // DWORD 11
         u32 flush_wrb : 1;                       // DWORD 11
         u32 rsvd4 : 8;                           // DWORD 11
         u32 cq_id : 10;                          // DWORD 11
         u32 rsvd5 : 6;                           // DWORD 11
         u32 rsvd6[4];                            // DWORDS 12 to 15
      } SG_PACK FC_WRB_CONTEXT_SLI3, *PFC_WRB_CONTEXT_SLI3;

      typedef union _FC_WRB_CONTEXT_SLI3_UNION {
         FC_WRB_CONTEXT_SLI3 bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_WRB_CONTEXT_SLI3_UNION, *PFC_WRB_CONTEXT_SLI3_UNION;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT_SLI3_UNION, sizeof (FC_WRB_CONTEXT_SLI3_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_WRB_CONTEXT {
         union {
            struct { 
               u32 BufferType : 8;                // DWORD 0
               u32 BufferSize : 24;               // DWORD 0
               u32 AddressLow;                    // DWORD 1
               u32 AddressHigh;                   // DWORD 2
               union {
                  u32 PayloadLength;              // DWORD 3
                  struct {
                     u32 PayloadOffset;           // DWORD 3
                  } tsend_trcv_xmitseq;
                  struct {
                     u32 rsvd1 : 16;              // DWORD 3
                     u32 Criteria : 8;            // DWORD 3
                     u32 rsvd0 : 7;               // DWORD 3
                     u32 IA : 1;                  // DWORD 3
                  } abort;
               } word3;
               union {
                  u32 TransferLength;             // DWORD 4
                  struct {
                     u32 DR : 1;                  // DWORD 4
                     u32 rsvd0 : 31;              // DWORD 4
                  } create_xri;
                  struct {
                     u32 rsvd0 : 6;               // DWORD 4
                     u32 VF : 1;                  // DWORD 4
                     u32 SP : 1;                  // DWORD 4
                     u32 S_ID : 24;               // DWORD 4
                  } els_request;
                  struct {
                     u32 relative_offset;         // DWORD 4
                  } fcp_tsr;
                  struct {
                     u32 rsvd0 : 8;               // DWORD 4
                     u32 expected_xfer_count_hi : 8; // DWORD 4
                     u32 expected_xfer_count_lo : 16; // DWORD 4
                  } iwr_xfer_length;
                  struct {
                     u32 relative_offset;         // DWORD 4
                  } genreq_xmitseq;
               } word4;
               union {
                  u32 InitialTransferLength;      // DWORD 5
                  struct {
                     u32 rsvd0 : 8;               // DWORD 5
                     u32 Remote_ID : 24;          // DWORD 5
                  } abort_elsreq_elsrsp_blsrsp;
                  struct {
                     u32 burst_length;            // DWORD 5
                  } fcp_tsr;
                  struct {
                     u32 R_CTL : 8;               // DWORD 5
                     u32 TYPE : 8;                // DWORD 5
                     u32 DF_CTL : 8;              // DWORD 5
                     u32 rsvd1 : 4;               // DWORD 5
                     u32 LA : 1;                  // DWORD 5
                     u32 rsvd0 : 3;               // DWORD 5
                  } gen_request;
                  struct {
                     u32 XO : 1;                  // DWORD 5
                     u32 AR : 1;                  // DWORD 5
                     u32 PT : 2;                  // DWORD 5
                     u32 rsvd0 : 28;              // DWORD 5
                  } xmit_bls_rsp;
                  struct {
                     u32 R_CTL : 8;               // DWORD 5
                     u32 TYPE : 8;                // DWORD 5
                     u32 DF_CTL : 8;              // DWORD 5
                     u32 LS : 1;                  // DWORD 5
                     u32 rsvd1 : 3;               // DWORD 5
                     u32 LA : 1;                  // DWORD 5
                     u32 SI : 1;                  // DWORD 5
                     u32 rsvd0 : 2;               // DWORD 5
                  } xmit_sequence;
               } word5;
               u32 CONTEXT_TAG : 16;              // DWORD 6
               u32 XRI_TAG : 16;                  // DWORD 6
               u32 Timer : 8;                     // DWORD 7
               u32 LINK : 1;                      // DWORD 7
               u32 ERP : 1;                       // DWORD 7
               u32 PU : 2;                        // DWORD 7
               u32 IR : 1;                        // DWORD 7
               u32 ClassService : 3;              // DWORD 7
               u32 Command : 8;                   // DWORD 7
               u32 Status : 4;                    // DWORD 7
               u32 CT : 2;                        // DWORD 7
               u32 rsvd0 : 2;                     // DWORD 7
               union {
                  u32 ABORT_TAG;                  // DWORD 8
                  struct {
                     u32 T_TAG;                   // DWORD 8
                  } abort;
               } word8;
               u32 OX_ID : 16;                    // DWORD 9
               u32 REQUEST_TAG : 16;              // DWORD 9
               u32 CCP : 8;                       // DWORD 10
               u32 CCPE : 1;                      // DWORD 10
               u32 SR : 1;                        // DWORD 10
               u32 XC : 1;                        // DWORD 10
               u32 rsvd2 : 1;                     // DWORD 10
               u32 PV : 1;                        // DWORD 10
               u32 PRI : 3;                       // DWORD 10
               u32 rsvd1 : 16;                    // DWORD 10
               u32 rsvd5 : 6;                     // DWORD 11
               u32 cq_id : 10;                    // DWORD 11
               u32 rsvd4 : 8;                     // DWORD 11
               u32 WQEC : 1;                      // DWORD 11
               u32 rsvd3 : 1;                     // DWORD 11
               u32 ELS_ID : 2;                    // DWORD 11
               u32 cmd_type : 4;                  // DWORD 11
               union {
                  struct {
                     u32 rsvd1 : 16;              // DWORD 12
                     u32 Priority : 3;            // DWORD 12
                     u32 VF_ID : 12;              // DWORD 12
                     u32 rsvd0 : 1;               // DWORD 12
                  } els_request;
                  struct {
                     u32 Xmit_Length;             // DWORD 12
                  } xmit_sequence;
               } word12;
               u32 Hop_Count : 8;                 // DWORD 13
               u32 rsvd6 : 24;                    // DWORD 13
               u32 rsvd7[2];                      // DWORDS 14 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_WRB_CONTEXT, *PFC_WRB_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT, sizeof (FC_WRB_CONTEXT) == 64);

   #else
      typedef struct _FC_WRB_CONTEXT {
         u32 BufferType : 8;                      // DWORD 0
         u32 BufferSize : 24;                     // DWORD 0
         u32 AddressLow;                          // DWORD 1
         u32 AddressHigh;                         // DWORD 2
         union {
            u32 PayloadLength;                    // DWORD 3
            struct {
               u32 PayloadOffset;                 // DWORD 3
            } tsend_trcv_xmitseq;
            struct {
               u32 rsvd1 : 16;                    // DWORD 3
               u32 Criteria : 8;                  // DWORD 3
               u32 rsvd0 : 7;                     // DWORD 3
               u32 IA : 1;                        // DWORD 3
            } abort;
         } word3;
         union {
            u32 TransferLength;                   // DWORD 4
            struct {
               u32 DR : 1;                        // DWORD 4
               u32 rsvd0 : 31;                    // DWORD 4
            } create_xri;
            struct {
               u32 rsvd0 : 6;                     // DWORD 4
               u32 VF : 1;                        // DWORD 4
               u32 SP : 1;                        // DWORD 4
               u32 S_ID : 24;                     // DWORD 4
            } els_request;
            struct {
               u32 relative_offset;               // DWORD 4
            } fcp_tsr;
            struct {
               u32 rsvd0 : 8;                     // DWORD 4
               u32 expected_xfer_count_hi : 8;    // DWORD 4
               u32 expected_xfer_count_lo : 16;   // DWORD 4
            } iwr_xfer_length;
            struct {
               u32 relative_offset;               // DWORD 4
            } genreq_xmitseq;
         } word4;
         union {
            u32 InitialTransferLength;            // DWORD 5
            struct {
               u32 rsvd0 : 8;                     // DWORD 5
               u32 Remote_ID : 24;                // DWORD 5
            } abort_elsreq_elsrsp_blsrsp;
            struct {
               u32 burst_length;                  // DWORD 5
            } fcp_tsr;
            struct {
               u32 R_CTL : 8;                     // DWORD 5
               u32 TYPE : 8;                      // DWORD 5
               u32 DF_CTL : 8;                    // DWORD 5
               u32 rsvd1 : 4;                     // DWORD 5
               u32 LA : 1;                        // DWORD 5
               u32 rsvd0 : 3;                     // DWORD 5
            } gen_request;
            struct {
               u32 XO : 1;                        // DWORD 5
               u32 AR : 1;                        // DWORD 5
               u32 PT : 2;                        // DWORD 5
               u32 rsvd0 : 28;                    // DWORD 5
            } xmit_bls_rsp;
            struct {
               u32 R_CTL : 8;                     // DWORD 5
               u32 TYPE : 8;                      // DWORD 5
               u32 DF_CTL : 8;                    // DWORD 5
               u32 LS : 1;                        // DWORD 5
               u32 rsvd1 : 3;                     // DWORD 5
               u32 LA : 1;                        // DWORD 5
               u32 SI : 1;                        // DWORD 5
               u32 rsvd0 : 2;                     // DWORD 5
            } xmit_sequence;
         } word5;
         u32 CONTEXT_TAG : 16;                    // DWORD 6
         u32 XRI_TAG : 16;                        // DWORD 6
         u32 Timer : 8;                           // DWORD 7
         u32 LINK : 1;                            // DWORD 7
         u32 ERP : 1;                             // DWORD 7
         u32 PU : 2;                              // DWORD 7
         u32 IR : 1;                              // DWORD 7
         u32 ClassService : 3;                    // DWORD 7
         u32 Command : 8;                         // DWORD 7
         u32 Status : 4;                          // DWORD 7
         u32 CT : 2;                              // DWORD 7
         u32 rsvd0 : 2;                           // DWORD 7
         union {
            u32 ABORT_TAG;                        // DWORD 8
            struct {
               u32 T_TAG;                         // DWORD 8
            } abort;
         } word8;
         u32 OX_ID : 16;                          // DWORD 9
         u32 REQUEST_TAG : 16;                    // DWORD 9
         u32 CCP : 8;                             // DWORD 10
         u32 CCPE : 1;                            // DWORD 10
         u32 SR : 1;                              // DWORD 10
         u32 XC : 1;                              // DWORD 10
         u32 rsvd2 : 1;                           // DWORD 10
         u32 PV : 1;                              // DWORD 10
         u32 PRI : 3;                             // DWORD 10
         u32 rsvd1 : 16;                          // DWORD 10
         u32 rsvd5 : 6;                           // DWORD 11
         u32 cq_id : 10;                          // DWORD 11
         u32 rsvd4 : 8;                           // DWORD 11
         u32 WQEC : 1;                            // DWORD 11
         u32 rsvd3 : 1;                           // DWORD 11
         u32 ELS_ID : 2;                          // DWORD 11
         u32 cmd_type : 4;                        // DWORD 11
         union {
            struct {
               u32 rsvd1 : 16;                    // DWORD 12
               u32 Priority : 3;                  // DWORD 12
               u32 VF_ID : 12;                    // DWORD 12
               u32 rsvd0 : 1;                     // DWORD 12
            } els_request;
            struct {
               u32 Xmit_Length;                   // DWORD 12
            } xmit_sequence;
         } word12;
         u32 Hop_Count : 8;                       // DWORD 13
         u32 rsvd6 : 24;                          // DWORD 13
         u32 rsvd7[2];                            // DWORDS 14 to 15
      } SG_PACK FC_WRB_CONTEXT, *PFC_WRB_CONTEXT;

      typedef union _FC_WRB_CONTEXT_UNION {
         FC_WRB_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_WRB_CONTEXT_UNION, *PFC_WRB_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT_UNION, sizeof (FC_WRB_CONTEXT_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_WRB_CONTEXT {
         union {
            struct { 
               u32 BufferSize : 24;               // DWORD 0
               u32 BufferType : 8;                // DWORD 0
               u32 AddressLow;                    // DWORD 1
               u32 AddressHigh;                   // DWORD 2
               union {
                  u32 PayloadLength;              // DWORD 3
                  struct {
                     u32 PayloadOffset;           // DWORD 3
                  } tsend_trcv_xmitseq;
                  struct {
                     u32 IA : 1;                  // DWORD 3
                     u32 rsvd0 : 7;               // DWORD 3
                     u32 Criteria : 8;            // DWORD 3
                     u32 rsvd1 : 16;              // DWORD 3
                  } abort;
               } word3;
               union {
                  u32 TransferLength;             // DWORD 4
                  struct {
                     u32 rsvd0 : 31;              // DWORD 4
                     u32 DR : 1;                  // DWORD 4
                  } create_xri;
                  struct {
                     u32 S_ID : 24;               // DWORD 4
                     u32 SP : 1;                  // DWORD 4
                     u32 VF : 1;                  // DWORD 4
                     u32 rsvd0 : 6;               // DWORD 4
                  } els_request;
                  struct {
                     u32 relative_offset;         // DWORD 4
                  } fcp_tsr;
                  struct {
                     u32 expected_xfer_count_lo : 16; // DWORD 4
                     u32 expected_xfer_count_hi : 8; // DWORD 4
                     u32 rsvd0 : 8;               // DWORD 4
                  } iwr_xfer_length;
                  struct {
                     u32 relative_offset;         // DWORD 4
                  } genreq_xmitseq;
               } word4;
               union {
                  u32 InitialTransferLength;      // DWORD 5
                  struct {
                     u32 Remote_ID : 24;          // DWORD 5
                     u32 rsvd0 : 8;               // DWORD 5
                  } abort_elsreq_elsrsp_blsrsp;
                  struct {
                     u32 burst_length;            // DWORD 5
                  } fcp_tsr;
                  struct {
                     u32 rsvd0 : 3;               // DWORD 5
                     u32 LA : 1;                  // DWORD 5
                     u32 rsvd1 : 4;               // DWORD 5
                     u32 DF_CTL : 8;              // DWORD 5
                     u32 TYPE : 8;                // DWORD 5
                     u32 R_CTL : 8;               // DWORD 5
                  } gen_request;
                  struct {
                     u32 rsvd0 : 28;              // DWORD 5
                     u32 PT : 2;                  // DWORD 5
                     u32 AR : 1;                  // DWORD 5
                     u32 XO : 1;                  // DWORD 5
                  } xmit_bls_rsp;
                  struct {
                     u32 rsvd0 : 2;               // DWORD 5
                     u32 SI : 1;                  // DWORD 5
                     u32 LA : 1;                  // DWORD 5
                     u32 rsvd1 : 3;               // DWORD 5
                     u32 LS : 1;                  // DWORD 5
                     u32 DF_CTL : 8;              // DWORD 5
                     u32 TYPE : 8;                // DWORD 5
                     u32 R_CTL : 8;               // DWORD 5
                  } xmit_sequence;
               } word5;
               u32 XRI_TAG : 16;                  // DWORD 6
               u32 CONTEXT_TAG : 16;              // DWORD 6
               u32 rsvd0 : 2;                     // DWORD 7
               u32 CT : 2;                        // DWORD 7
               u32 Status : 4;                    // DWORD 7
               u32 Command : 8;                   // DWORD 7
               u32 ClassService : 3;              // DWORD 7
               u32 IR : 1;                        // DWORD 7
               u32 PU : 2;                        // DWORD 7
               u32 ERP : 1;                       // DWORD 7
               u32 LINK : 1;                      // DWORD 7
               u32 Timer : 8;                     // DWORD 7
               union {
                  u32 ABORT_TAG;                  // DWORD 8
                  struct {
                     u32 T_TAG;                   // DWORD 8
                  } abort;
               } word8;
               u32 REQUEST_TAG : 16;              // DWORD 9
               u32 OX_ID : 16;                    // DWORD 9
               u32 rsvd1 : 16;                    // DWORD 10
               u32 PRI : 3;                       // DWORD 10
               u32 PV : 1;                        // DWORD 10
               u32 rsvd2 : 1;                     // DWORD 10
               u32 XC : 1;                        // DWORD 10
               u32 SR : 1;                        // DWORD 10
               u32 CCPE : 1;                      // DWORD 10
               u32 CCP : 8;                       // DWORD 10
               u32 cmd_type : 4;                  // DWORD 11
               u32 ELS_ID : 2;                    // DWORD 11
               u32 rsvd3 : 1;                     // DWORD 11
               u32 WQEC : 1;                      // DWORD 11
               u32 rsvd4 : 8;                     // DWORD 11
               u32 cq_id : 10;                    // DWORD 11
               u32 rsvd5 : 6;                     // DWORD 11
               union {
                  struct {
                     u32 rsvd0 : 1;               // DWORD 12
                     u32 VF_ID : 12;              // DWORD 12
                     u32 Priority : 3;            // DWORD 12
                     u32 rsvd1 : 16;              // DWORD 12
                  } els_request;
                  struct {
                     u32 Xmit_Length;             // DWORD 12
                  } xmit_sequence;
               } word12;
               u32 rsvd6 : 24;                    // DWORD 13
               u32 Hop_Count : 8;                 // DWORD 13
               u32 rsvd7[2];                      // DWORDS 14 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_WRB_CONTEXT, *PFC_WRB_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT, sizeof (FC_WRB_CONTEXT) == 64);

   #else
      typedef struct _FC_WRB_CONTEXT {
         u32 BufferSize : 24;                     // DWORD 0
         u32 BufferType : 8;                      // DWORD 0
         u32 AddressLow;                          // DWORD 1
         u32 AddressHigh;                         // DWORD 2
         union {
            u32 PayloadLength;                    // DWORD 3
            struct {
               u32 PayloadOffset;                 // DWORD 3
            } tsend_trcv_xmitseq;
            struct {
               u32 IA : 1;                        // DWORD 3
               u32 rsvd0 : 7;                     // DWORD 3
               u32 Criteria : 8;                  // DWORD 3
               u32 rsvd1 : 16;                    // DWORD 3
            } abort;
         } word3;
         union {
            u32 TransferLength;                   // DWORD 4
            struct {
               u32 rsvd0 : 31;                    // DWORD 4
               u32 DR : 1;                        // DWORD 4
            } create_xri;
            struct {
               u32 S_ID : 24;                     // DWORD 4
               u32 SP : 1;                        // DWORD 4
               u32 VF : 1;                        // DWORD 4
               u32 rsvd0 : 6;                     // DWORD 4
            } els_request;
            struct {
               u32 relative_offset;               // DWORD 4
            } fcp_tsr;
            struct {
               u32 expected_xfer_count_lo : 16;   // DWORD 4
               u32 expected_xfer_count_hi : 8;    // DWORD 4
               u32 rsvd0 : 8;                     // DWORD 4
            } iwr_xfer_length;
            struct {
               u32 relative_offset;               // DWORD 4
            } genreq_xmitseq;
         } word4;
         union {
            u32 InitialTransferLength;            // DWORD 5
            struct {
               u32 Remote_ID : 24;                // DWORD 5
               u32 rsvd0 : 8;                     // DWORD 5
            } abort_elsreq_elsrsp_blsrsp;
            struct {
               u32 burst_length;                  // DWORD 5
            } fcp_tsr;
            struct {
               u32 rsvd0 : 3;                     // DWORD 5
               u32 LA : 1;                        // DWORD 5
               u32 rsvd1 : 4;                     // DWORD 5
               u32 DF_CTL : 8;                    // DWORD 5
               u32 TYPE : 8;                      // DWORD 5
               u32 R_CTL : 8;                     // DWORD 5
            } gen_request;
            struct {
               u32 rsvd0 : 28;                    // DWORD 5
               u32 PT : 2;                        // DWORD 5
               u32 AR : 1;                        // DWORD 5
               u32 XO : 1;                        // DWORD 5
            } xmit_bls_rsp;
            struct {
               u32 rsvd0 : 2;                     // DWORD 5
               u32 SI : 1;                        // DWORD 5
               u32 LA : 1;                        // DWORD 5
               u32 rsvd1 : 3;                     // DWORD 5
               u32 LS : 1;                        // DWORD 5
               u32 DF_CTL : 8;                    // DWORD 5
               u32 TYPE : 8;                      // DWORD 5
               u32 R_CTL : 8;                     // DWORD 5
            } xmit_sequence;
         } word5;
         u32 XRI_TAG : 16;                        // DWORD 6
         u32 CONTEXT_TAG : 16;                    // DWORD 6
         u32 rsvd0 : 2;                           // DWORD 7
         u32 CT : 2;                              // DWORD 7
         u32 Status : 4;                          // DWORD 7
         u32 Command : 8;                         // DWORD 7
         u32 ClassService : 3;                    // DWORD 7
         u32 IR : 1;                              // DWORD 7
         u32 PU : 2;                              // DWORD 7
         u32 ERP : 1;                             // DWORD 7
         u32 LINK : 1;                            // DWORD 7
         u32 Timer : 8;                           // DWORD 7
         union {
            u32 ABORT_TAG;                        // DWORD 8
            struct {
               u32 T_TAG;                         // DWORD 8
            } abort;
         } word8;
         u32 REQUEST_TAG : 16;                    // DWORD 9
         u32 OX_ID : 16;                          // DWORD 9
         u32 rsvd1 : 16;                          // DWORD 10
         u32 PRI : 3;                             // DWORD 10
         u32 PV : 1;                              // DWORD 10
         u32 rsvd2 : 1;                           // DWORD 10
         u32 XC : 1;                              // DWORD 10
         u32 SR : 1;                              // DWORD 10
         u32 CCPE : 1;                            // DWORD 10
         u32 CCP : 8;                             // DWORD 10
         u32 cmd_type : 4;                        // DWORD 11
         u32 ELS_ID : 2;                          // DWORD 11
         u32 rsvd3 : 1;                           // DWORD 11
         u32 WQEC : 1;                            // DWORD 11
         u32 rsvd4 : 8;                           // DWORD 11
         u32 cq_id : 10;                          // DWORD 11
         u32 rsvd5 : 6;                           // DWORD 11
         union {
            struct {
               u32 rsvd0 : 1;                     // DWORD 12
               u32 VF_ID : 12;                    // DWORD 12
               u32 Priority : 3;                  // DWORD 12
               u32 rsvd1 : 16;                    // DWORD 12
            } els_request;
            struct {
               u32 Xmit_Length;                   // DWORD 12
            } xmit_sequence;
         } word12;
         u32 rsvd6 : 24;                          // DWORD 13
         u32 Hop_Count : 8;                       // DWORD 13
         u32 rsvd7[2];                            // DWORDS 14 to 15
      } SG_PACK FC_WRB_CONTEXT, *PFC_WRB_CONTEXT;

      typedef union _FC_WRB_CONTEXT_UNION {
         FC_WRB_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_WRB_CONTEXT_UNION, *PFC_WRB_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_WRB_CONTEXT_UNION, sizeof (FC_WRB_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_DIF_WRB_CONTEXT {
         union {
            struct { 
               u32 BufferType : 8;                // DWORD 0
               u32 BufferSize : 24;               // DWORD 0
               u32 AddressLow;                    // DWORD 1
               u32 AddressHigh;                   // DWORD 2
               u32 IO_TAG32;                      // DWORD 3
               u32 TransferLength;                // DWORD 4
               u32 InitialTransferLength;         // DWORD 5
               u32 CONTEXT_TAG : 16;              // DWORD 6
               u32 sgl_icd_index : 16;            // DWORD 6
               u32 Timer : 8;                     // DWORD 7
               u32 XS : 1;                        // DWORD 7
               u32 ERP : 1;                       // DWORD 7
               u32 PU : 2;                        // DWORD 7
               u32 rsvd0 : 1;                     // DWORD 7
               u32 ClassService : 3;              // DWORD 7
               u32 Command : 8;                   // DWORD 7
               u32 Status : 4;                    // DWORD 7
               u32 BDE : 2;                       // DWORD 7
               u32 LE : 1;                        // DWORD 7
               u32 AC : 1;                        // DWORD 7
               u32 IO_TAG64_LOW;                  // DWORD 8
               u32 IO_TAG64_HIGH;                 // DWORD 9
               u32 CCP : 8;                       // DWORD 10
               u32 CCPE : 1;                      // DWORD 10
               u32 rsvd2 : 3;                     // DWORD 10
               u32 PV : 1;                        // DWORD 10
               u32 PRI : 3;                       // DWORD 10
               u32 rsvd1 : 8;                     // DWORD 10
               u32 EBDE_COUNT : 8;                // DWORD 10
               u32 cmd_type : 2;                  // DWORD 11
               u32 dif_en : 1;                    // DWORD 11
               u32 cont_inc_seq_cnt : 1;          // DWORD 11
               u32 max_buf_size : 12;             // DWORD 11
               u32 WRBC : 1;                      // DWORD 11
               u32 hdr_template_index : 15;       // DWORD 11
               u32 rsvd3 : 16;                    // DWORD 12
               u32 metadata : 16;                 // DWORD 12
               u32 expreftag;                     // DWORD 13
               u32 rsvd4[1];                      // DWORDS 14 to 14
               u32 newreftag;                     // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_DIF_WRB_CONTEXT, *PFC_DIF_WRB_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_DIF_WRB_CONTEXT, sizeof (FC_DIF_WRB_CONTEXT) == 64);

   #else
      typedef struct _FC_DIF_WRB_CONTEXT {
         u32 BufferType : 8;                      // DWORD 0
         u32 BufferSize : 24;                     // DWORD 0
         u32 AddressLow;                          // DWORD 1
         u32 AddressHigh;                         // DWORD 2
         u32 IO_TAG32;                            // DWORD 3
         u32 TransferLength;                      // DWORD 4
         u32 InitialTransferLength;               // DWORD 5
         u32 CONTEXT_TAG : 16;                    // DWORD 6
         u32 sgl_icd_index : 16;                  // DWORD 6
         u32 Timer : 8;                           // DWORD 7
         u32 XS : 1;                              // DWORD 7
         u32 ERP : 1;                             // DWORD 7
         u32 PU : 2;                              // DWORD 7
         u32 rsvd0 : 1;                           // DWORD 7
         u32 ClassService : 3;                    // DWORD 7
         u32 Command : 8;                         // DWORD 7
         u32 Status : 4;                          // DWORD 7
         u32 BDE : 2;                             // DWORD 7
         u32 LE : 1;                              // DWORD 7
         u32 AC : 1;                              // DWORD 7
         u32 IO_TAG64_LOW;                        // DWORD 8
         u32 IO_TAG64_HIGH;                       // DWORD 9
         u32 CCP : 8;                             // DWORD 10
         u32 CCPE : 1;                            // DWORD 10
         u32 rsvd2 : 3;                           // DWORD 10
         u32 PV : 1;                              // DWORD 10
         u32 PRI : 3;                             // DWORD 10
         u32 rsvd1 : 8;                           // DWORD 10
         u32 EBDE_COUNT : 8;                      // DWORD 10
         u32 cmd_type : 2;                        // DWORD 11
         u32 dif_en : 1;                          // DWORD 11
         u32 cont_inc_seq_cnt : 1;                // DWORD 11
         u32 max_buf_size : 12;                   // DWORD 11
         u32 WRBC : 1;                            // DWORD 11
         u32 hdr_template_index : 15;             // DWORD 11
         u32 rsvd3 : 16;                          // DWORD 12
         u32 metadata : 16;                       // DWORD 12
         u32 expreftag;                           // DWORD 13
         u32 rsvd4[1];                            // DWORDS 14 to 14
         u32 newreftag;                           // DWORD 15
      } SG_PACK FC_DIF_WRB_CONTEXT, *PFC_DIF_WRB_CONTEXT;

      typedef union _FC_DIF_WRB_CONTEXT_UNION {
         FC_DIF_WRB_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_DIF_WRB_CONTEXT_UNION, *PFC_DIF_WRB_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_DIF_WRB_CONTEXT_UNION, sizeof (FC_DIF_WRB_CONTEXT_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_DIF_WRB_CONTEXT {
         union {
            struct { 
               u32 BufferSize : 24;               // DWORD 0
               u32 BufferType : 8;                // DWORD 0
               u32 AddressLow;                    // DWORD 1
               u32 AddressHigh;                   // DWORD 2
               u32 IO_TAG32;                      // DWORD 3
               u32 TransferLength;                // DWORD 4
               u32 InitialTransferLength;         // DWORD 5
               u32 sgl_icd_index : 16;            // DWORD 6
               u32 CONTEXT_TAG : 16;              // DWORD 6
               u32 AC : 1;                        // DWORD 7
               u32 LE : 1;                        // DWORD 7
               u32 BDE : 2;                       // DWORD 7
               u32 Status : 4;                    // DWORD 7
               u32 Command : 8;                   // DWORD 7
               u32 ClassService : 3;              // DWORD 7
               u32 rsvd0 : 1;                     // DWORD 7
               u32 PU : 2;                        // DWORD 7
               u32 ERP : 1;                       // DWORD 7
               u32 XS : 1;                        // DWORD 7
               u32 Timer : 8;                     // DWORD 7
               u32 IO_TAG64_LOW;                  // DWORD 8
               u32 IO_TAG64_HIGH;                 // DWORD 9
               u32 EBDE_COUNT : 8;                // DWORD 10
               u32 rsvd1 : 8;                     // DWORD 10
               u32 PRI : 3;                       // DWORD 10
               u32 PV : 1;                        // DWORD 10
               u32 rsvd2 : 3;                     // DWORD 10
               u32 CCPE : 1;                      // DWORD 10
               u32 CCP : 8;                       // DWORD 10
               u32 hdr_template_index : 15;       // DWORD 11
               u32 WRBC : 1;                      // DWORD 11
               u32 max_buf_size : 12;             // DWORD 11
               u32 cont_inc_seq_cnt : 1;          // DWORD 11
               u32 dif_en : 1;                    // DWORD 11
               u32 cmd_type : 2;                  // DWORD 11
               u32 metadata : 16;                 // DWORD 12
               u32 rsvd3 : 16;                    // DWORD 12
               u32 expreftag;                     // DWORD 13
               u32 rsvd4[1];                      // DWORDS 14 to 14
               u32 newreftag;                     // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FC_DIF_WRB_CONTEXT, *PFC_DIF_WRB_CONTEXT;

      SG_C_ASSERT(__sizeof__FC_DIF_WRB_CONTEXT, sizeof (FC_DIF_WRB_CONTEXT) == 64);

   #else
      typedef struct _FC_DIF_WRB_CONTEXT {
         u32 BufferSize : 24;                     // DWORD 0
         u32 BufferType : 8;                      // DWORD 0
         u32 AddressLow;                          // DWORD 1
         u32 AddressHigh;                         // DWORD 2
         u32 IO_TAG32;                            // DWORD 3
         u32 TransferLength;                      // DWORD 4
         u32 InitialTransferLength;               // DWORD 5
         u32 sgl_icd_index : 16;                  // DWORD 6
         u32 CONTEXT_TAG : 16;                    // DWORD 6
         u32 AC : 1;                              // DWORD 7
         u32 LE : 1;                              // DWORD 7
         u32 BDE : 2;                             // DWORD 7
         u32 Status : 4;                          // DWORD 7
         u32 Command : 8;                         // DWORD 7
         u32 ClassService : 3;                    // DWORD 7
         u32 rsvd0 : 1;                           // DWORD 7
         u32 PU : 2;                              // DWORD 7
         u32 ERP : 1;                             // DWORD 7
         u32 XS : 1;                              // DWORD 7
         u32 Timer : 8;                           // DWORD 7
         u32 IO_TAG64_LOW;                        // DWORD 8
         u32 IO_TAG64_HIGH;                       // DWORD 9
         u32 EBDE_COUNT : 8;                      // DWORD 10
         u32 rsvd1 : 8;                           // DWORD 10
         u32 PRI : 3;                             // DWORD 10
         u32 PV : 1;                              // DWORD 10
         u32 rsvd2 : 3;                           // DWORD 10
         u32 CCPE : 1;                            // DWORD 10
         u32 CCP : 8;                             // DWORD 10
         u32 hdr_template_index : 15;             // DWORD 11
         u32 WRBC : 1;                            // DWORD 11
         u32 max_buf_size : 12;                   // DWORD 11
         u32 cont_inc_seq_cnt : 1;                // DWORD 11
         u32 dif_en : 1;                          // DWORD 11
         u32 cmd_type : 2;                        // DWORD 11
         u32 metadata : 16;                       // DWORD 12
         u32 rsvd3 : 16;                          // DWORD 12
         u32 expreftag;                           // DWORD 13
         u32 rsvd4[1];                            // DWORDS 14 to 14
         u32 newreftag;                           // DWORD 15
      } SG_PACK FC_DIF_WRB_CONTEXT, *PFC_DIF_WRB_CONTEXT;

      typedef union _FC_DIF_WRB_CONTEXT_UNION {
         FC_DIF_WRB_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK FC_DIF_WRB_CONTEXT_UNION, *PFC_DIF_WRB_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__FC_DIF_WRB_CONTEXT_UNION, sizeof (FC_DIF_WRB_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scatter gather element
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
               u32 last_sge : 1;                  // DWORD 2
               u32 rsvd0 : 9;                     // DWORD 2
               u32 sge_offset : 22;               // DWORD 2
               u32 rsvd1 : 15;                    // DWORD 3
               u32 len : 17;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_SGE, *PFC_SGE;

      SG_C_ASSERT(__sizeof__FC_SGE, sizeof (FC_SGE) == 16);

   #else
      typedef struct _FC_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
         u32 last_sge : 1;                        // DWORD 2
         u32 rsvd0 : 9;                           // DWORD 2
         u32 sge_offset : 22;                     // DWORD 2
         u32 rsvd1 : 15;                          // DWORD 3
         u32 len : 17;                            // DWORD 3
      } SG_PACK FC_SGE, *PFC_SGE;

      typedef union _FC_SGE_UNION {
         FC_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_SGE_UNION, *PFC_SGE_UNION;

      SG_C_ASSERT(__sizeof__FC_SGE_UNION, sizeof (FC_SGE_UNION) == 16);
   #endif


#else
   // Scatter gather element
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_SGE {
         union {
            struct { 
               u32 addr_hi;                       // DWORD 0
               u32 addr_lo;                       // DWORD 1
               u32 sge_offset : 22;               // DWORD 2
               u32 rsvd0 : 9;                     // DWORD 2
               u32 last_sge : 1;                  // DWORD 2
               u32 len : 17;                      // DWORD 3
               u32 rsvd1 : 15;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK FC_SGE, *PFC_SGE;

      SG_C_ASSERT(__sizeof__FC_SGE, sizeof (FC_SGE) == 16);

   #else
      typedef struct _FC_SGE {
         u32 addr_hi;                             // DWORD 0
         u32 addr_lo;                             // DWORD 1
         u32 sge_offset : 22;                     // DWORD 2
         u32 rsvd0 : 9;                           // DWORD 2
         u32 last_sge : 1;                        // DWORD 2
         u32 len : 17;                            // DWORD 3
         u32 rsvd1 : 15;                          // DWORD 3
      } SG_PACK FC_SGE, *PFC_SGE;

      typedef union _FC_SGE_UNION {
         FC_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK FC_SGE_UNION, *PFC_SGE_UNION;

      SG_C_ASSERT(__sizeof__FC_SGE_UNION, sizeof (FC_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // RRmsg sent from ARM to FC TXULP and carried as body of IPC between EPs
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_RRMSG {
         union {
            struct { 
               u32 invalidate_ref_handle : 16;    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 defpdu_invld : 1;              // DWORD 0
               u32 sgl_icd_index : 11;            // DWORD 0
               u32 rsvd3 : 23;                    // DWORD 1
               u32 upload : 1;                    // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 invld_resp : 1;                // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 icd_free : 1;                  // DWORD 1
               u32 icd_invld : 1;                 // DWORD 1
               u32 fc_ctx_invld : 1;              // DWORD 1
               u32 rsvd4 : 8;                     // DWORD 2
               u32 partialBytesSent : 24;         // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FC_RRMSG, *PFC_RRMSG;

      SG_C_ASSERT(__sizeof__FC_RRMSG, sizeof (FC_RRMSG) == 12);

   #else
      typedef struct _FC_RRMSG {
         u32 invalidate_ref_handle : 16;          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 defpdu_invld : 1;                    // DWORD 0
         u32 sgl_icd_index : 11;                  // DWORD 0
         u32 rsvd3 : 23;                          // DWORD 1
         u32 upload : 1;                          // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 invld_resp : 1;                      // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 icd_free : 1;                        // DWORD 1
         u32 icd_invld : 1;                       // DWORD 1
         u32 fc_ctx_invld : 1;                    // DWORD 1
         u32 rsvd4 : 8;                           // DWORD 2
         u32 partialBytesSent : 24;               // DWORD 2
      } SG_PACK FC_RRMSG, *PFC_RRMSG;

      typedef union _FC_RRMSG_UNION {
         FC_RRMSG bits;
         u32 dw[3]; // dword union
      } SG_PACK FC_RRMSG_UNION, *PFC_RRMSG_UNION;

      SG_C_ASSERT(__sizeof__FC_RRMSG_UNION, sizeof (FC_RRMSG_UNION) == 12);
   #endif


#else
   // RRmsg sent from ARM to FC TXULP and carried as body of IPC between EPs
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_RRMSG {
         union {
            struct { 
               u32 sgl_icd_index : 11;            // DWORD 0
               u32 defpdu_invld : 1;              // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 invalidate_ref_handle : 16;    // DWORD 0
               u32 fc_ctx_invld : 1;              // DWORD 1
               u32 icd_invld : 1;                 // DWORD 1
               u32 icd_free : 1;                  // DWORD 1
               u32 rsvd1 : 2;                     // DWORD 1
               u32 wr : 1;                        // DWORD 1
               u32 invld_resp : 1;                // DWORD 1
               u32 rsvd2 : 1;                     // DWORD 1
               u32 upload : 1;                    // DWORD 1
               u32 rsvd3 : 23;                    // DWORD 1
               u32 partialBytesSent : 24;         // DWORD 2
               u32 rsvd4 : 8;                     // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK FC_RRMSG, *PFC_RRMSG;

      SG_C_ASSERT(__sizeof__FC_RRMSG, sizeof (FC_RRMSG) == 12);

   #else
      typedef struct _FC_RRMSG {
         u32 sgl_icd_index : 11;                  // DWORD 0
         u32 defpdu_invld : 1;                    // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 invalidate_ref_handle : 16;          // DWORD 0
         u32 fc_ctx_invld : 1;                    // DWORD 1
         u32 icd_invld : 1;                       // DWORD 1
         u32 icd_free : 1;                        // DWORD 1
         u32 rsvd1 : 2;                           // DWORD 1
         u32 wr : 1;                              // DWORD 1
         u32 invld_resp : 1;                      // DWORD 1
         u32 rsvd2 : 1;                           // DWORD 1
         u32 upload : 1;                          // DWORD 1
         u32 rsvd3 : 23;                          // DWORD 1
         u32 partialBytesSent : 24;               // DWORD 2
         u32 rsvd4 : 8;                           // DWORD 2
      } SG_PACK FC_RRMSG, *PFC_RRMSG;

      typedef union _FC_RRMSG_UNION {
         FC_RRMSG bits;
         u32 dw[3]; // dword union
      } SG_PACK FC_RRMSG_UNION, *PFC_RRMSG_UNION;

      SG_C_ASSERT(__sizeof__FC_RRMSG_UNION, sizeof (FC_RRMSG_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_HEADER {
         union {
            struct { 
               ETH_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_HEADER, *PTEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER, sizeof (TEMPLATE_HEADER) == 56);

   #else
      typedef struct _TEMPLATE_HEADER {
         ETH_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_HEADER, *PTEMPLATE_HEADER;

      typedef union _TEMPLATE_HEADER_UNION {
         TEMPLATE_HEADER bits;
         u32 dw[14]; // dword union
      } SG_PACK TEMPLATE_HEADER_UNION, *PTEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER_UNION, sizeof (TEMPLATE_HEADER_UNION) == 56);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_HEADER {
         union {
            struct { 
               ETH_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_HEADER, *PTEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER, sizeof (TEMPLATE_HEADER) == 56);

   #else
      typedef struct _TEMPLATE_HEADER {
         ETH_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_HEADER, *PTEMPLATE_HEADER;

      typedef union _TEMPLATE_HEADER_UNION {
         TEMPLATE_HEADER bits;
         u32 dw[14]; // dword union
      } SG_PACK TEMPLATE_HEADER_UNION, *PTEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER_UNION, sizeof (TEMPLATE_HEADER_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_IPV6_HEADER {
         union {
            struct { 
               ETH_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_IPV6_HEADER, *PTEMPLATE_IPV6_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER, sizeof (TEMPLATE_IPV6_HEADER) == 76);

   #else
      typedef struct _TEMPLATE_IPV6_HEADER {
         ETH_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_IPV6_HEADER, *PTEMPLATE_IPV6_HEADER;

      typedef union _TEMPLATE_IPV6_HEADER_UNION {
         TEMPLATE_IPV6_HEADER bits;
         u32 dw[19]; // dword union
      } SG_PACK TEMPLATE_IPV6_HEADER_UNION, *PTEMPLATE_IPV6_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER_UNION, sizeof (TEMPLATE_IPV6_HEADER_UNION) == 76);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_IPV6_HEADER {
         union {
            struct { 
               ETH_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[19]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_IPV6_HEADER, *PTEMPLATE_IPV6_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER, sizeof (TEMPLATE_IPV6_HEADER) == 76);

   #else
      typedef struct _TEMPLATE_IPV6_HEADER {
         ETH_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_IPV6_HEADER, *PTEMPLATE_IPV6_HEADER;

      typedef union _TEMPLATE_IPV6_HEADER_UNION {
         TEMPLATE_IPV6_HEADER bits;
         u32 dw[19]; // dword union
      } SG_PACK TEMPLATE_IPV6_HEADER_UNION, *PTEMPLATE_IPV6_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER_UNION, sizeof (TEMPLATE_IPV6_HEADER_UNION) == 76);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_HEADER {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[15]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_HEADER, *PTEMPLATE_VLAN_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER, sizeof (TEMPLATE_VLAN_HEADER) == 60);

   #else
      typedef struct _TEMPLATE_VLAN_HEADER {
         ETH_VLAN_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_VLAN_HEADER, *PTEMPLATE_VLAN_HEADER;

      typedef union _TEMPLATE_VLAN_HEADER_UNION {
         TEMPLATE_VLAN_HEADER bits;
         u32 dw[15]; // dword union
      } SG_PACK TEMPLATE_VLAN_HEADER_UNION, *PTEMPLATE_VLAN_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER_UNION, sizeof (TEMPLATE_VLAN_HEADER_UNION) == 60);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_HEADER {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[15]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_HEADER, *PTEMPLATE_VLAN_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER, sizeof (TEMPLATE_VLAN_HEADER) == 60);

   #else
      typedef struct _TEMPLATE_VLAN_HEADER {
         ETH_VLAN_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_VLAN_HEADER, *PTEMPLATE_VLAN_HEADER;

      typedef union _TEMPLATE_VLAN_HEADER_UNION {
         TEMPLATE_VLAN_HEADER bits;
         u32 dw[15]; // dword union
      } SG_PACK TEMPLATE_VLAN_HEADER_UNION, *PTEMPLATE_VLAN_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER_UNION, sizeof (TEMPLATE_VLAN_HEADER_UNION) == 60);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[20]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER, *PTEMPLATE_VLAN_IPV6_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER, sizeof (TEMPLATE_VLAN_IPV6_HEADER) == 80);

   #else
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER {
         ETH_VLAN_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER, *PTEMPLATE_VLAN_IPV6_HEADER;

      typedef union _TEMPLATE_VLAN_IPV6_HEADER_UNION {
         TEMPLATE_VLAN_IPV6_HEADER bits;
         u32 dw[20]; // dword union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_UNION, *PTEMPLATE_VLAN_IPV6_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER_UNION, sizeof (TEMPLATE_VLAN_IPV6_HEADER_UNION) == 80);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[20]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER, *PTEMPLATE_VLAN_IPV6_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER, sizeof (TEMPLATE_VLAN_IPV6_HEADER) == 80);

   #else
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER {
         ETH_VLAN_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER, *PTEMPLATE_VLAN_IPV6_HEADER;

      typedef union _TEMPLATE_VLAN_IPV6_HEADER_UNION {
         TEMPLATE_VLAN_IPV6_HEADER bits;
         u32 dw[20]; // dword union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_UNION, *PTEMPLATE_VLAN_IPV6_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER_UNION, sizeof (TEMPLATE_VLAN_IPV6_HEADER_UNION) == 80);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_SNAP_HEADER {
         union {
            struct { 
               ETH_HEADER Eth;
               SNAP_HEADER Snap;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_SNAP_HEADER, *PTEMPLATE_SNAP_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_SNAP_HEADER, sizeof (TEMPLATE_SNAP_HEADER) == 64);

   #else
      typedef struct _TEMPLATE_SNAP_HEADER {
         ETH_HEADER Eth;
         SNAP_HEADER Snap;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_SNAP_HEADER, *PTEMPLATE_SNAP_HEADER;

      typedef union _TEMPLATE_SNAP_HEADER_UNION {
         TEMPLATE_SNAP_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK TEMPLATE_SNAP_HEADER_UNION, *PTEMPLATE_SNAP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_SNAP_HEADER_UNION, sizeof (TEMPLATE_SNAP_HEADER_UNION) == 64);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_SNAP_HEADER {
         union {
            struct { 
               ETH_HEADER Eth;
               SNAP_HEADER Snap;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_SNAP_HEADER, *PTEMPLATE_SNAP_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_SNAP_HEADER, sizeof (TEMPLATE_SNAP_HEADER) == 64);

   #else
      typedef struct _TEMPLATE_SNAP_HEADER {
         ETH_HEADER Eth;
         SNAP_HEADER Snap;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_SNAP_HEADER, *PTEMPLATE_SNAP_HEADER;

      typedef union _TEMPLATE_SNAP_HEADER_UNION {
         TEMPLATE_SNAP_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK TEMPLATE_SNAP_HEADER_UNION, *PTEMPLATE_SNAP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_SNAP_HEADER_UNION, sizeof (TEMPLATE_SNAP_HEADER_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_SNAP_HEADER {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               SNAP_HEADER Snap;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_SNAP_HEADER, *PTEMPLATE_VLAN_SNAP_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_SNAP_HEADER, sizeof (TEMPLATE_VLAN_SNAP_HEADER) == 68);

   #else
      typedef struct _TEMPLATE_VLAN_SNAP_HEADER {
         ETH_VLAN_HEADER Eth;
         SNAP_HEADER Snap;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_VLAN_SNAP_HEADER, *PTEMPLATE_VLAN_SNAP_HEADER;

      typedef union _TEMPLATE_VLAN_SNAP_HEADER_UNION {
         TEMPLATE_VLAN_SNAP_HEADER bits;
         u32 dw[17]; // dword union
      } SG_PACK TEMPLATE_VLAN_SNAP_HEADER_UNION, *PTEMPLATE_VLAN_SNAP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_SNAP_HEADER_UNION, sizeof (TEMPLATE_VLAN_SNAP_HEADER_UNION) == 68);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_SNAP_HEADER {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               SNAP_HEADER Snap;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_SNAP_HEADER, *PTEMPLATE_VLAN_SNAP_HEADER;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_SNAP_HEADER, sizeof (TEMPLATE_VLAN_SNAP_HEADER) == 68);

   #else
      typedef struct _TEMPLATE_VLAN_SNAP_HEADER {
         ETH_VLAN_HEADER Eth;
         SNAP_HEADER Snap;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
      } SG_PACK TEMPLATE_VLAN_SNAP_HEADER, *PTEMPLATE_VLAN_SNAP_HEADER;

      typedef union _TEMPLATE_VLAN_SNAP_HEADER_UNION {
         TEMPLATE_VLAN_SNAP_HEADER bits;
         u32 dw[17]; // dword union
      } SG_PACK TEMPLATE_VLAN_SNAP_HEADER_UNION, *PTEMPLATE_VLAN_SNAP_HEADER_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_SNAP_HEADER_UNION, sizeof (TEMPLATE_VLAN_SNAP_HEADER_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_HEADER_TS {
         union {
            struct { 
               ETH_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_HEADER_TS, *PTEMPLATE_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER_TS, sizeof (TEMPLATE_HEADER_TS) == 68);

   #else
      typedef struct _TEMPLATE_HEADER_TS {
         ETH_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_HEADER_TS, *PTEMPLATE_HEADER_TS;

      typedef union _TEMPLATE_HEADER_TS_UNION {
         TEMPLATE_HEADER_TS bits;
         u32 dw[17]; // dword union
      } SG_PACK TEMPLATE_HEADER_TS_UNION, *PTEMPLATE_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER_TS_UNION, sizeof (TEMPLATE_HEADER_TS_UNION) == 68);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_HEADER_TS {
         union {
            struct { 
               ETH_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_HEADER_TS, *PTEMPLATE_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER_TS, sizeof (TEMPLATE_HEADER_TS) == 68);

   #else
      typedef struct _TEMPLATE_HEADER_TS {
         ETH_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_HEADER_TS, *PTEMPLATE_HEADER_TS;

      typedef union _TEMPLATE_HEADER_TS_UNION {
         TEMPLATE_HEADER_TS bits;
         u32 dw[17]; // dword union
      } SG_PACK TEMPLATE_HEADER_TS_UNION, *PTEMPLATE_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_HEADER_TS_UNION, sizeof (TEMPLATE_HEADER_TS_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_IPV6_HEADER_TS {
         union {
            struct { 
               ETH_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[22]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_IPV6_HEADER_TS, *PTEMPLATE_IPV6_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER_TS, sizeof (TEMPLATE_IPV6_HEADER_TS) == 88);

   #else
      typedef struct _TEMPLATE_IPV6_HEADER_TS {
         ETH_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_IPV6_HEADER_TS, *PTEMPLATE_IPV6_HEADER_TS;

      typedef union _TEMPLATE_IPV6_HEADER_TS_UNION {
         TEMPLATE_IPV6_HEADER_TS bits;
         u32 dw[22]; // dword union
      } SG_PACK TEMPLATE_IPV6_HEADER_TS_UNION, *PTEMPLATE_IPV6_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER_TS_UNION, sizeof (TEMPLATE_IPV6_HEADER_TS_UNION) == 88);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_IPV6_HEADER_TS {
         union {
            struct { 
               ETH_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[22]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_IPV6_HEADER_TS, *PTEMPLATE_IPV6_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER_TS, sizeof (TEMPLATE_IPV6_HEADER_TS) == 88);

   #else
      typedef struct _TEMPLATE_IPV6_HEADER_TS {
         ETH_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_IPV6_HEADER_TS, *PTEMPLATE_IPV6_HEADER_TS;

      typedef union _TEMPLATE_IPV6_HEADER_TS_UNION {
         TEMPLATE_IPV6_HEADER_TS bits;
         u32 dw[22]; // dword union
      } SG_PACK TEMPLATE_IPV6_HEADER_TS_UNION, *PTEMPLATE_IPV6_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_IPV6_HEADER_TS_UNION, sizeof (TEMPLATE_IPV6_HEADER_TS_UNION) == 88);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_HEADER_TS {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_HEADER_TS, *PTEMPLATE_VLAN_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER_TS, sizeof (TEMPLATE_VLAN_HEADER_TS) == 72);

   #else
      typedef struct _TEMPLATE_VLAN_HEADER_TS {
         ETH_VLAN_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_VLAN_HEADER_TS, *PTEMPLATE_VLAN_HEADER_TS;

      typedef union _TEMPLATE_VLAN_HEADER_TS_UNION {
         TEMPLATE_VLAN_HEADER_TS bits;
         u32 dw[18]; // dword union
      } SG_PACK TEMPLATE_VLAN_HEADER_TS_UNION, *PTEMPLATE_VLAN_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER_TS_UNION, sizeof (TEMPLATE_VLAN_HEADER_TS_UNION) == 72);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_HEADER_TS {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IP_HEADER Ip;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_HEADER_TS, *PTEMPLATE_VLAN_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER_TS, sizeof (TEMPLATE_VLAN_HEADER_TS) == 72);

   #else
      typedef struct _TEMPLATE_VLAN_HEADER_TS {
         ETH_VLAN_HEADER Eth;
         IP_HEADER Ip;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_VLAN_HEADER_TS, *PTEMPLATE_VLAN_HEADER_TS;

      typedef union _TEMPLATE_VLAN_HEADER_TS_UNION {
         TEMPLATE_VLAN_HEADER_TS bits;
         u32 dw[18]; // dword union
      } SG_PACK TEMPLATE_VLAN_HEADER_TS_UNION, *PTEMPLATE_VLAN_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_HEADER_TS_UNION, sizeof (TEMPLATE_VLAN_HEADER_TS_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER_TS {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[23]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_TS, *PTEMPLATE_VLAN_IPV6_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER_TS, sizeof (TEMPLATE_VLAN_IPV6_HEADER_TS) == 92);

   #else
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER_TS {
         ETH_VLAN_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_TS, *PTEMPLATE_VLAN_IPV6_HEADER_TS;

      typedef union _TEMPLATE_VLAN_IPV6_HEADER_TS_UNION {
         TEMPLATE_VLAN_IPV6_HEADER_TS bits;
         u32 dw[23]; // dword union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_TS_UNION, *PTEMPLATE_VLAN_IPV6_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER_TS_UNION, sizeof (TEMPLATE_VLAN_IPV6_HEADER_TS_UNION) == 92);
   #endif


#else
   // This describes the layout for template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER_TS {
         union {
            struct { 
               ETH_VLAN_HEADER Eth;
               IPV6_HEADER Ipv6;
               TCP_HEADER Tcp;
               TCP_TIMESTAMP Timestamp;
            } SG_PACK ; // unnamed struct
            u32 dw[23]; // dword union
         }; // unnamed union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_TS, *PTEMPLATE_VLAN_IPV6_HEADER_TS;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER_TS, sizeof (TEMPLATE_VLAN_IPV6_HEADER_TS) == 92);

   #else
      typedef struct _TEMPLATE_VLAN_IPV6_HEADER_TS {
         ETH_VLAN_HEADER Eth;
         IPV6_HEADER Ipv6;
         TCP_HEADER Tcp;
         TCP_TIMESTAMP Timestamp;
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_TS, *PTEMPLATE_VLAN_IPV6_HEADER_TS;

      typedef union _TEMPLATE_VLAN_IPV6_HEADER_TS_UNION {
         TEMPLATE_VLAN_IPV6_HEADER_TS bits;
         u32 dw[23]; // dword union
      } SG_PACK TEMPLATE_VLAN_IPV6_HEADER_TS_UNION, *PTEMPLATE_VLAN_IPV6_HEADER_TS_UNION;

      SG_C_ASSERT(__sizeof__TEMPLATE_VLAN_IPV6_HEADER_TS_UNION, sizeof (TEMPLATE_VLAN_IPV6_HEADER_TS_UNION) == 92);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for fip template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_TEMPLATE_HEADER {
         union {
            struct { 
               FIP_FRAME_VLAN fip_header;
               FIP_FLOGI_DESCRIPTOR fip_descriptor;
               u32 rsvd0[2];                      // DWORDS 14 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FIP_TEMPLATE_HEADER, *PFIP_TEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__FIP_TEMPLATE_HEADER, sizeof (FIP_TEMPLATE_HEADER) == 64);

   #else
      typedef struct _FIP_TEMPLATE_HEADER {
         FIP_FRAME_VLAN fip_header;
         FIP_FLOGI_DESCRIPTOR fip_descriptor;
         u32 rsvd0[2];                            // DWORDS 14 to 15
      } SG_PACK FIP_TEMPLATE_HEADER, *PFIP_TEMPLATE_HEADER;

      typedef union _FIP_TEMPLATE_HEADER_UNION {
         FIP_TEMPLATE_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK FIP_TEMPLATE_HEADER_UNION, *PFIP_TEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FIP_TEMPLATE_HEADER_UNION, sizeof (FIP_TEMPLATE_HEADER_UNION) == 64);
   #endif


#else
   // This describes the layout for fip template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_TEMPLATE_HEADER {
         union {
            struct { 
               FIP_FRAME_VLAN fip_header;
               FIP_FLOGI_DESCRIPTOR fip_descriptor;
               u32 rsvd0[2];                      // DWORDS 14 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FIP_TEMPLATE_HEADER, *PFIP_TEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__FIP_TEMPLATE_HEADER, sizeof (FIP_TEMPLATE_HEADER) == 64);

   #else
      typedef struct _FIP_TEMPLATE_HEADER {
         FIP_FRAME_VLAN fip_header;
         FIP_FLOGI_DESCRIPTOR fip_descriptor;
         u32 rsvd0[2];                            // DWORDS 14 to 15
      } SG_PACK FIP_TEMPLATE_HEADER, *PFIP_TEMPLATE_HEADER;

      typedef union _FIP_TEMPLATE_HEADER_UNION {
         FIP_TEMPLATE_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK FIP_TEMPLATE_HEADER_UNION, *PFIP_TEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FIP_TEMPLATE_HEADER_UNION, sizeof (FIP_TEMPLATE_HEADER_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for mac address fip descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_MAC_DESCRIPTOR_TEMPLATE {
         union {
            struct { 
               FIP_MAC_ADDR_DESCRIPTOR fip_tail;
               FIP_MAC_ADDR_DESCRIPTOR fip_logo;
               u32 rsvd0[12];                     // DWORDS 4 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FIP_MAC_DESCRIPTOR_TEMPLATE, *PFIP_MAC_DESCRIPTOR_TEMPLATE;

      SG_C_ASSERT(__sizeof__FIP_MAC_DESCRIPTOR_TEMPLATE, sizeof (FIP_MAC_DESCRIPTOR_TEMPLATE) == 64);

   #else
      typedef struct _FIP_MAC_DESCRIPTOR_TEMPLATE {
         FIP_MAC_ADDR_DESCRIPTOR fip_tail;
         FIP_MAC_ADDR_DESCRIPTOR fip_logo;
         u32 rsvd0[12];                           // DWORDS 4 to 15
      } SG_PACK FIP_MAC_DESCRIPTOR_TEMPLATE, *PFIP_MAC_DESCRIPTOR_TEMPLATE;

      typedef union _FIP_MAC_DESCRIPTOR_TEMPLATE_UNION {
         FIP_MAC_DESCRIPTOR_TEMPLATE bits;
         u32 dw[16]; // dword union
      } SG_PACK FIP_MAC_DESCRIPTOR_TEMPLATE_UNION, *PFIP_MAC_DESCRIPTOR_TEMPLATE_UNION;

      SG_C_ASSERT(__sizeof__FIP_MAC_DESCRIPTOR_TEMPLATE_UNION, sizeof (FIP_MAC_DESCRIPTOR_TEMPLATE_UNION) == 64);
   #endif


#else
   // This describes the layout for mac address fip descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _FIP_MAC_DESCRIPTOR_TEMPLATE {
         union {
            struct { 
               FIP_MAC_ADDR_DESCRIPTOR fip_tail;
               FIP_MAC_ADDR_DESCRIPTOR fip_logo;
               u32 rsvd0[12];                     // DWORDS 4 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FIP_MAC_DESCRIPTOR_TEMPLATE, *PFIP_MAC_DESCRIPTOR_TEMPLATE;

      SG_C_ASSERT(__sizeof__FIP_MAC_DESCRIPTOR_TEMPLATE, sizeof (FIP_MAC_DESCRIPTOR_TEMPLATE) == 64);

   #else
      typedef struct _FIP_MAC_DESCRIPTOR_TEMPLATE {
         FIP_MAC_ADDR_DESCRIPTOR fip_tail;
         FIP_MAC_ADDR_DESCRIPTOR fip_logo;
         u32 rsvd0[12];                           // DWORDS 4 to 15
      } SG_PACK FIP_MAC_DESCRIPTOR_TEMPLATE, *PFIP_MAC_DESCRIPTOR_TEMPLATE;

      typedef union _FIP_MAC_DESCRIPTOR_TEMPLATE_UNION {
         FIP_MAC_DESCRIPTOR_TEMPLATE bits;
         u32 dw[16]; // dword union
      } SG_PACK FIP_MAC_DESCRIPTOR_TEMPLATE_UNION, *PFIP_MAC_DESCRIPTOR_TEMPLATE_UNION;

      SG_C_ASSERT(__sizeof__FIP_MAC_DESCRIPTOR_TEMPLATE_UNION, sizeof (FIP_MAC_DESCRIPTOR_TEMPLATE_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This describes the layout for fcoe template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_TEMPLATE_HEADER {
         union {
            struct { 
               FCOE_HEADER_VLAN fcoe_header;
               FC_HEADER fc_header;
               u32 rsvd0[2];                      // DWORDS 14 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_TEMPLATE_HEADER, *PFCOE_TEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__FCOE_TEMPLATE_HEADER, sizeof (FCOE_TEMPLATE_HEADER) == 64);

   #else
      typedef struct _FCOE_TEMPLATE_HEADER {
         FCOE_HEADER_VLAN fcoe_header;
         FC_HEADER fc_header;
         u32 rsvd0[2];                            // DWORDS 14 to 15
      } SG_PACK FCOE_TEMPLATE_HEADER, *PFCOE_TEMPLATE_HEADER;

      typedef union _FCOE_TEMPLATE_HEADER_UNION {
         FCOE_TEMPLATE_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK FCOE_TEMPLATE_HEADER_UNION, *PFCOE_TEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FCOE_TEMPLATE_HEADER_UNION, sizeof (FCOE_TEMPLATE_HEADER_UNION) == 64);
   #endif


#else
   // This describes the layout for fcoe template headers
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOE_TEMPLATE_HEADER {
         union {
            struct { 
               FCOE_HEADER_VLAN fcoe_header;
               FC_HEADER fc_header;
               u32 rsvd0[2];                      // DWORDS 14 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK FCOE_TEMPLATE_HEADER, *PFCOE_TEMPLATE_HEADER;

      SG_C_ASSERT(__sizeof__FCOE_TEMPLATE_HEADER, sizeof (FCOE_TEMPLATE_HEADER) == 64);

   #else
      typedef struct _FCOE_TEMPLATE_HEADER {
         FCOE_HEADER_VLAN fcoe_header;
         FC_HEADER fc_header;
         u32 rsvd0[2];                            // DWORDS 14 to 15
      } SG_PACK FCOE_TEMPLATE_HEADER, *PFCOE_TEMPLATE_HEADER;

      typedef union _FCOE_TEMPLATE_HEADER_UNION {
         FCOE_TEMPLATE_HEADER bits;
         u32 dw[16]; // dword union
      } SG_PACK FCOE_TEMPLATE_HEADER_UNION, *PFCOE_TEMPLATE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__FCOE_TEMPLATE_HEADER_UNION, sizeof (FCOE_TEMPLATE_HEADER_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the master template structure for fip operations used per FCF/VFI/VPI 
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ELS_MASTER_TEMPLATE {
         union {
            struct { 
               FIP_TEMPLATE_HEADER fip_template_flogi;
               FIP_MAC_DESCRIPTOR_TEMPLATE fip_mac_desc_template;
               FCOE_TEMPLATE_HEADER fcoe_template_1;
               FIP_TEMPLATE_HEADER fip_template_flogo;
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK FC_ELS_MASTER_TEMPLATE, *PFC_ELS_MASTER_TEMPLATE;

      SG_C_ASSERT(__sizeof__FC_ELS_MASTER_TEMPLATE, sizeof (FC_ELS_MASTER_TEMPLATE) == 256);

   #else
      typedef struct _FC_ELS_MASTER_TEMPLATE {
         FIP_TEMPLATE_HEADER fip_template_flogi;
         FIP_MAC_DESCRIPTOR_TEMPLATE fip_mac_desc_template;
         FCOE_TEMPLATE_HEADER fcoe_template_1;
         FIP_TEMPLATE_HEADER fip_template_flogo;
      } SG_PACK FC_ELS_MASTER_TEMPLATE, *PFC_ELS_MASTER_TEMPLATE;

      typedef union _FC_ELS_MASTER_TEMPLATE_UNION {
         FC_ELS_MASTER_TEMPLATE bits;
         u32 dw[64]; // dword union
      } SG_PACK FC_ELS_MASTER_TEMPLATE_UNION, *PFC_ELS_MASTER_TEMPLATE_UNION;

      SG_C_ASSERT(__sizeof__FC_ELS_MASTER_TEMPLATE_UNION, sizeof (FC_ELS_MASTER_TEMPLATE_UNION) == 256);
   #endif


#else
   // This is the master template structure for fip operations used per FCF/VFI/VPI 
   #if defined(SG_BMAP_UNION)
      typedef struct _FC_ELS_MASTER_TEMPLATE {
         union {
            struct { 
               FIP_TEMPLATE_HEADER fip_template_flogi;
               FIP_MAC_DESCRIPTOR_TEMPLATE fip_mac_desc_template;
               FCOE_TEMPLATE_HEADER fcoe_template_1;
               FIP_TEMPLATE_HEADER fip_template_flogo;
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK FC_ELS_MASTER_TEMPLATE, *PFC_ELS_MASTER_TEMPLATE;

      SG_C_ASSERT(__sizeof__FC_ELS_MASTER_TEMPLATE, sizeof (FC_ELS_MASTER_TEMPLATE) == 256);

   #else
      typedef struct _FC_ELS_MASTER_TEMPLATE {
         FIP_TEMPLATE_HEADER fip_template_flogi;
         FIP_MAC_DESCRIPTOR_TEMPLATE fip_mac_desc_template;
         FCOE_TEMPLATE_HEADER fcoe_template_1;
         FIP_TEMPLATE_HEADER fip_template_flogo;
      } SG_PACK FC_ELS_MASTER_TEMPLATE, *PFC_ELS_MASTER_TEMPLATE;

      typedef union _FC_ELS_MASTER_TEMPLATE_UNION {
         FC_ELS_MASTER_TEMPLATE bits;
         u32 dw[64]; // dword union
      } SG_PACK FC_ELS_MASTER_TEMPLATE_UNION, *PFC_ELS_MASTER_TEMPLATE_UNION;

      SG_C_ASSERT(__sizeof__FC_ELS_MASTER_TEMPLATE_UNION, sizeof (FC_ELS_MASTER_TEMPLATE_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // cqe flags map the same as wqe flags, not all are used, an additional SQ flag
   // indicates which WQ relates to CQE
   typedef struct _CQE_FLAGS {
      u32 rsvd0 : 4;                              // DWORD 0
      u32 sq : 1;                                 // DWORD 0
      u32 pbl_struct : 1;                         // DWORD 0
      u32 bindable : 1;                           // DWORD 0
      u32 remote_write : 1;                       // DWORD 0
      u32 local_write : 1;                        // DWORD 0
      u32 remote_read : 1;                        // DWORD 0
      u32 local_read : 1;                         // DWORD 0
      u32 va_addr : 1;                            // DWORD 0
      u32 invalidate : 1;                         // DWORD 0
      u32 fence : 1;                              // DWORD 0
      u32 solicited : 1;                          // DWORD 0
      u32 signal : 1;                             // DWORD 0
   } SG_PACK CQE_FLAGS, *PCQE_FLAGS;



#else
   // cqe flags map the same as wqe flags, not all are used, an additional SQ flag
   // indicates which WQ relates to CQE
   typedef struct _CQE_FLAGS {
      u32 signal : 1;                             // DWORD 0
      u32 solicited : 1;                          // DWORD 0
      u32 fence : 1;                              // DWORD 0
      u32 invalidate : 1;                         // DWORD 0
      u32 va_addr : 1;                            // DWORD 0
      u32 local_read : 1;                         // DWORD 0
      u32 remote_read : 1;                        // DWORD 0
      u32 local_write : 1;                        // DWORD 0
      u32 remote_write : 1;                       // DWORD 0
      u32 bindable : 1;                           // DWORD 0
      u32 pbl_struct : 1;                         // DWORD 0
      u32 sq : 1;                                 // DWORD 0
      u32 rsvd0 : 4;                              // DWORD 0
   } SG_PACK CQE_FLAGS, *PCQE_FLAGS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // RDMA Tx scatter/gather entry. This structure represents a single STag fragment.
   // Multiple SGEs are typically combined into a single SendQ WQE.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_TX_SGE {
         union {
            struct { 
               u32 length;                        // DWORD 0
               u32 stag;                          // DWORD 1
               u32 to_hi;                         // DWORD 2
               u32 to_lo;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_TX_SGE, *PRDMA_TX_SGE;

      SG_C_ASSERT(__sizeof__RDMA_TX_SGE, sizeof (RDMA_TX_SGE) == 16);

   #else
      typedef struct _RDMA_TX_SGE {
         u32 length;                              // DWORD 0
         u32 stag;                                // DWORD 1
         u32 to_hi;                               // DWORD 2
         u32 to_lo;                               // DWORD 3
      } SG_PACK RDMA_TX_SGE, *PRDMA_TX_SGE;

      typedef union _RDMA_TX_SGE_UNION {
         RDMA_TX_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_TX_SGE_UNION, *PRDMA_TX_SGE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_TX_SGE_UNION, sizeof (RDMA_TX_SGE_UNION) == 16);
   #endif


#else
   // RDMA Tx scatter/gather entry. This structure represents a single STag fragment.
   // Multiple SGEs are typically combined into a single SendQ WQE.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_TX_SGE {
         union {
            struct { 
               u32 length;                        // DWORD 0
               u32 stag;                          // DWORD 1
               u32 to_hi;                         // DWORD 2
               u32 to_lo;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_TX_SGE, *PRDMA_TX_SGE;

      SG_C_ASSERT(__sizeof__RDMA_TX_SGE, sizeof (RDMA_TX_SGE) == 16);

   #else
      typedef struct _RDMA_TX_SGE {
         u32 length;                              // DWORD 0
         u32 stag;                                // DWORD 1
         u32 to_hi;                               // DWORD 2
         u32 to_lo;                               // DWORD 3
      } SG_PACK RDMA_TX_SGE, *PRDMA_TX_SGE;

      typedef union _RDMA_TX_SGE_UNION {
         RDMA_TX_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_TX_SGE_UNION, *PRDMA_TX_SGE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_TX_SGE_UNION, sizeof (RDMA_TX_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a single self-contained unit of the WQE that can be fetched by BE in a
   // single UC fetch cache-line. A complete WQE can contain upto 4 of these WQE Units.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WQE_UNIT {
         union {
            struct { 
               u32 remote_stag;                   // DWORD 0
               u32 flags : 16;                    // DWORD 1
               u32 wqe_unit_count : 8;            // DWORD 1
               u32 op_code : 8;                   // DWORD 1
               u32 remote_to_hi;                  // DWORD 2
               u32 remote_to_lo;                  // DWORD 3
               RDMA_TX_SGE sge;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WQE_UNIT, *PRDMA_WQE_UNIT;

      SG_C_ASSERT(__sizeof__RDMA_WQE_UNIT, sizeof (RDMA_WQE_UNIT) == 32);

   #else
      typedef struct _RDMA_WQE_UNIT {
         u32 remote_stag;                         // DWORD 0
         u32 flags : 16;                          // DWORD 1
         u32 wqe_unit_count : 8;                  // DWORD 1
         u32 op_code : 8;                         // DWORD 1
         u32 remote_to_hi;                        // DWORD 2
         u32 remote_to_lo;                        // DWORD 3
         RDMA_TX_SGE sge;
      } SG_PACK RDMA_WQE_UNIT, *PRDMA_WQE_UNIT;

      typedef union _RDMA_WQE_UNIT_UNION {
         RDMA_WQE_UNIT bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_WQE_UNIT_UNION, *PRDMA_WQE_UNIT_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WQE_UNIT_UNION, sizeof (RDMA_WQE_UNIT_UNION) == 32);
   #endif


#else
   // This is a single self-contained unit of the WQE that can be fetched by BE in a
   // single UC fetch cache-line. A complete WQE can contain upto 4 of these WQE Units.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WQE_UNIT {
         union {
            struct { 
               u32 remote_stag;                   // DWORD 0
               u32 op_code : 8;                   // DWORD 1
               u32 wqe_unit_count : 8;            // DWORD 1
               u32 flags : 16;                    // DWORD 1
               u32 remote_to_hi;                  // DWORD 2
               u32 remote_to_lo;                  // DWORD 3
               RDMA_TX_SGE sge;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WQE_UNIT, *PRDMA_WQE_UNIT;

      SG_C_ASSERT(__sizeof__RDMA_WQE_UNIT, sizeof (RDMA_WQE_UNIT) == 32);

   #else
      typedef struct _RDMA_WQE_UNIT {
         u32 remote_stag;                         // DWORD 0
         u32 op_code : 8;                         // DWORD 1
         u32 wqe_unit_count : 8;                  // DWORD 1
         u32 flags : 16;                          // DWORD 1
         u32 remote_to_hi;                        // DWORD 2
         u32 remote_to_lo;                        // DWORD 3
         RDMA_TX_SGE sge;
      } SG_PACK RDMA_WQE_UNIT, *PRDMA_WQE_UNIT;

      typedef union _RDMA_WQE_UNIT_UNION {
         RDMA_WQE_UNIT bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_WQE_UNIT_UNION, *PRDMA_WQE_UNIT_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WQE_UNIT_UNION, sizeof (RDMA_WQE_UNIT_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post a Send, Send with SE, Send with Invalidate, and Send with
   // SE and Invalidate operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_SEND_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit[4];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_SEND_WQE, *PRDMA_SEND_WQE;

      SG_C_ASSERT(__sizeof__RDMA_SEND_WQE, sizeof (RDMA_SEND_WQE) == 128);

   #else
      typedef struct _RDMA_SEND_WQE {
         RDMA_WQE_UNIT wqe_unit[4];
      } SG_PACK RDMA_SEND_WQE, *PRDMA_SEND_WQE;

      typedef union _RDMA_SEND_WQE_UNION {
         RDMA_SEND_WQE bits;
         u32 dw[32]; // dword union
      } SG_PACK RDMA_SEND_WQE_UNION, *PRDMA_SEND_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_SEND_WQE_UNION, sizeof (RDMA_SEND_WQE_UNION) == 128);
   #endif


#else
   // This WQE is used to post a Send, Send with SE, Send with Invalidate, and Send with
   // SE and Invalidate operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_SEND_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit[4];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_SEND_WQE, *PRDMA_SEND_WQE;

      SG_C_ASSERT(__sizeof__RDMA_SEND_WQE, sizeof (RDMA_SEND_WQE) == 128);

   #else
      typedef struct _RDMA_SEND_WQE {
         RDMA_WQE_UNIT wqe_unit[4];
      } SG_PACK RDMA_SEND_WQE, *PRDMA_SEND_WQE;

      typedef union _RDMA_SEND_WQE_UNION {
         RDMA_SEND_WQE bits;
         u32 dw[32]; // dword union
      } SG_PACK RDMA_SEND_WQE_UNION, *PRDMA_SEND_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_SEND_WQE_UNION, sizeof (RDMA_SEND_WQE_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post an RDMA Write operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WRITE_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit[4];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WRITE_WQE, *PRDMA_WRITE_WQE;

      SG_C_ASSERT(__sizeof__RDMA_WRITE_WQE, sizeof (RDMA_WRITE_WQE) == 128);

   #else
      typedef struct _RDMA_WRITE_WQE {
         RDMA_WQE_UNIT wqe_unit[4];
      } SG_PACK RDMA_WRITE_WQE, *PRDMA_WRITE_WQE;

      typedef union _RDMA_WRITE_WQE_UNION {
         RDMA_WRITE_WQE bits;
         u32 dw[32]; // dword union
      } SG_PACK RDMA_WRITE_WQE_UNION, *PRDMA_WRITE_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WRITE_WQE_UNION, sizeof (RDMA_WRITE_WQE_UNION) == 128);
   #endif


#else
   // This WQE is used to post an RDMA Write operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_WRITE_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit[4];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_WRITE_WQE, *PRDMA_WRITE_WQE;

      SG_C_ASSERT(__sizeof__RDMA_WRITE_WQE, sizeof (RDMA_WRITE_WQE) == 128);

   #else
      typedef struct _RDMA_WRITE_WQE {
         RDMA_WQE_UNIT wqe_unit[4];
      } SG_PACK RDMA_WRITE_WQE, *PRDMA_WRITE_WQE;

      typedef union _RDMA_WRITE_WQE_UNION {
         RDMA_WRITE_WQE bits;
         u32 dw[32]; // dword union
      } SG_PACK RDMA_WRITE_WQE_UNION, *PRDMA_WRITE_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_WRITE_WQE_UNION, sizeof (RDMA_WRITE_WQE_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post an RDMA Read operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_READ_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_READ_WQE, *PRDMA_READ_WQE;

      SG_C_ASSERT(__sizeof__RDMA_READ_WQE, sizeof (RDMA_READ_WQE) == 32);

   #else
      typedef struct _RDMA_READ_WQE {
         RDMA_WQE_UNIT wqe_unit;
      } SG_PACK RDMA_READ_WQE, *PRDMA_READ_WQE;

      typedef union _RDMA_READ_WQE_UNION {
         RDMA_READ_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_READ_WQE_UNION, *PRDMA_READ_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_READ_WQE_UNION, sizeof (RDMA_READ_WQE_UNION) == 32);
   #endif


#else
   // This WQE is used to post an RDMA Read operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_READ_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_READ_WQE, *PRDMA_READ_WQE;

      SG_C_ASSERT(__sizeof__RDMA_READ_WQE, sizeof (RDMA_READ_WQE) == 32);

   #else
      typedef struct _RDMA_READ_WQE {
         RDMA_WQE_UNIT wqe_unit;
      } SG_PACK RDMA_READ_WQE, *PRDMA_READ_WQE;

      typedef union _RDMA_READ_WQE_UNION {
         RDMA_READ_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_READ_WQE_UNION, *PRDMA_READ_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_READ_WQE_UNION, sizeof (RDMA_READ_WQE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post TERMINATE requests.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_TERMINATE_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_TERMINATE_WQE, *PRDMA_TERMINATE_WQE;

      SG_C_ASSERT(__sizeof__RDMA_TERMINATE_WQE, sizeof (RDMA_TERMINATE_WQE) == 32);

   #else
      typedef struct _RDMA_TERMINATE_WQE {
         RDMA_WQE_UNIT wqe_unit;
      } SG_PACK RDMA_TERMINATE_WQE, *PRDMA_TERMINATE_WQE;

      typedef union _RDMA_TERMINATE_WQE_UNION {
         RDMA_TERMINATE_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_TERMINATE_WQE_UNION, *PRDMA_TERMINATE_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_TERMINATE_WQE_UNION, sizeof (RDMA_TERMINATE_WQE_UNION) == 32);
   #endif


#else
   // This WQE is used to post TERMINATE requests.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_TERMINATE_WQE {
         union {
            struct { 
               RDMA_WQE_UNIT wqe_unit;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_TERMINATE_WQE, *PRDMA_TERMINATE_WQE;

      SG_C_ASSERT(__sizeof__RDMA_TERMINATE_WQE, sizeof (RDMA_TERMINATE_WQE) == 32);

   #else
      typedef struct _RDMA_TERMINATE_WQE {
         RDMA_WQE_UNIT wqe_unit;
      } SG_PACK RDMA_TERMINATE_WQE, *PRDMA_TERMINATE_WQE;

      typedef union _RDMA_TERMINATE_WQE_UNION {
         RDMA_TERMINATE_WQE bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_TERMINATE_WQE_UNION, *PRDMA_TERMINATE_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_TERMINATE_WQE_UNION, sizeof (RDMA_TERMINATE_WQE_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post memory window bind operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_BIND_WQE {
         union {
            struct { 
               u32 memory_region_stag;            // DWORD 0
               u32 flags : 16;                    // DWORD 1
               u32 wqe_unit_count : 8;            // DWORD 1
               u32 op_code : 8;                   // DWORD 1
               u32 memory_window_stag;            // DWORD 2
               u32 memory_window_length;          // DWORD 3
               u32 memory_region_virtual_address_hi; // DWORD 4
               u32 memory_region_virtual_address_lo; // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_BIND_WQE, *PRDMA_BIND_WQE;

      SG_C_ASSERT(__sizeof__RDMA_BIND_WQE, sizeof (RDMA_BIND_WQE) == 24);

   #else
      typedef struct _RDMA_BIND_WQE {
         u32 memory_region_stag;                  // DWORD 0
         u32 flags : 16;                          // DWORD 1
         u32 wqe_unit_count : 8;                  // DWORD 1
         u32 op_code : 8;                         // DWORD 1
         u32 memory_window_stag;                  // DWORD 2
         u32 memory_window_length;                // DWORD 3
         u32 memory_region_virtual_address_hi;    // DWORD 4
         u32 memory_region_virtual_address_lo;    // DWORD 5
      } SG_PACK RDMA_BIND_WQE, *PRDMA_BIND_WQE;

      typedef union _RDMA_BIND_WQE_UNION {
         RDMA_BIND_WQE bits;
         u32 dw[6]; // dword union
      } SG_PACK RDMA_BIND_WQE_UNION, *PRDMA_BIND_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_BIND_WQE_UNION, sizeof (RDMA_BIND_WQE_UNION) == 24);
   #endif


#else
   // This WQE is used to post memory window bind operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_BIND_WQE {
         union {
            struct { 
               u32 memory_region_stag;            // DWORD 0
               u32 op_code : 8;                   // DWORD 1
               u32 wqe_unit_count : 8;            // DWORD 1
               u32 flags : 16;                    // DWORD 1
               u32 memory_window_stag;            // DWORD 2
               u32 memory_window_length;          // DWORD 3
               u32 memory_region_virtual_address_hi; // DWORD 4
               u32 memory_region_virtual_address_lo; // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_BIND_WQE, *PRDMA_BIND_WQE;

      SG_C_ASSERT(__sizeof__RDMA_BIND_WQE, sizeof (RDMA_BIND_WQE) == 24);

   #else
      typedef struct _RDMA_BIND_WQE {
         u32 memory_region_stag;                  // DWORD 0
         u32 op_code : 8;                         // DWORD 1
         u32 wqe_unit_count : 8;                  // DWORD 1
         u32 flags : 16;                          // DWORD 1
         u32 memory_window_stag;                  // DWORD 2
         u32 memory_window_length;                // DWORD 3
         u32 memory_region_virtual_address_hi;    // DWORD 4
         u32 memory_region_virtual_address_lo;    // DWORD 5
      } SG_PACK RDMA_BIND_WQE, *PRDMA_BIND_WQE;

      typedef union _RDMA_BIND_WQE_UNION {
         RDMA_BIND_WQE bits;
         u32 dw[6]; // dword union
      } SG_PACK RDMA_BIND_WQE_UNION, *PRDMA_BIND_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_BIND_WQE_UNION, sizeof (RDMA_BIND_WQE_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post a non-shared memory fast register operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_FAST_REGISTER_WQE {
         union {
            struct { 
               u32 memory_region_stag;            // DWORD 0
               u32 flags : 16;                    // DWORD 1
               u32 wqe_unit_count : 8;            // DWORD 1
               u32 op_code : 8;                   // DWORD 1
               u32 memory_region_virtual_address_hi; // DWORD 2
               u32 memory_region_virtual_address_lo; // DWORD 3
               u32 length;                        // DWORD 4
               u32 cra;                           // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_FAST_REGISTER_WQE, *PRDMA_FAST_REGISTER_WQE;

      SG_C_ASSERT(__sizeof__RDMA_FAST_REGISTER_WQE, sizeof (RDMA_FAST_REGISTER_WQE) == 24);

   #else
      typedef struct _RDMA_FAST_REGISTER_WQE {
         u32 memory_region_stag;                  // DWORD 0
         u32 flags : 16;                          // DWORD 1
         u32 wqe_unit_count : 8;                  // DWORD 1
         u32 op_code : 8;                         // DWORD 1
         u32 memory_region_virtual_address_hi;    // DWORD 2
         u32 memory_region_virtual_address_lo;    // DWORD 3
         u32 length;                              // DWORD 4
         u32 cra;                                 // DWORD 5
      } SG_PACK RDMA_FAST_REGISTER_WQE, *PRDMA_FAST_REGISTER_WQE;

      typedef union _RDMA_FAST_REGISTER_WQE_UNION {
         RDMA_FAST_REGISTER_WQE bits;
         u32 dw[6]; // dword union
      } SG_PACK RDMA_FAST_REGISTER_WQE_UNION, *PRDMA_FAST_REGISTER_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_FAST_REGISTER_WQE_UNION, sizeof (RDMA_FAST_REGISTER_WQE_UNION) == 24);
   #endif


#else
   // This WQE is used to post a non-shared memory fast register operations.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_FAST_REGISTER_WQE {
         union {
            struct { 
               u32 memory_region_stag;            // DWORD 0
               u32 op_code : 8;                   // DWORD 1
               u32 wqe_unit_count : 8;            // DWORD 1
               u32 flags : 16;                    // DWORD 1
               u32 memory_region_virtual_address_hi; // DWORD 2
               u32 memory_region_virtual_address_lo; // DWORD 3
               u32 length;                        // DWORD 4
               u32 cra;                           // DWORD 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_FAST_REGISTER_WQE, *PRDMA_FAST_REGISTER_WQE;

      SG_C_ASSERT(__sizeof__RDMA_FAST_REGISTER_WQE, sizeof (RDMA_FAST_REGISTER_WQE) == 24);

   #else
      typedef struct _RDMA_FAST_REGISTER_WQE {
         u32 memory_region_stag;                  // DWORD 0
         u32 op_code : 8;                         // DWORD 1
         u32 wqe_unit_count : 8;                  // DWORD 1
         u32 flags : 16;                          // DWORD 1
         u32 memory_region_virtual_address_hi;    // DWORD 2
         u32 memory_region_virtual_address_lo;    // DWORD 3
         u32 length;                              // DWORD 4
         u32 cra;                                 // DWORD 5
      } SG_PACK RDMA_FAST_REGISTER_WQE, *PRDMA_FAST_REGISTER_WQE;

      typedef union _RDMA_FAST_REGISTER_WQE_UNION {
         RDMA_FAST_REGISTER_WQE bits;
         u32 dw[6]; // dword union
      } SG_PACK RDMA_FAST_REGISTER_WQE_UNION, *PRDMA_FAST_REGISTER_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_FAST_REGISTER_WQE_UNION, sizeof (RDMA_FAST_REGISTER_WQE_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Rdma Rx Scatter/Gather Entry. This structure represents a single STag fragment.
   // Multiple SGEs are typically combined into an RDMA Scatter Gather List. Many RDMA
   // WQEs contain 1 or more SGEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RX_SGE {
         union {
            struct { 
               u32 stag;                          // DWORD 0
               u32 length;                        // DWORD 1
               u32 to_hi;                         // DWORD 2
               u32 to_lo;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RX_SGE, *PRDMA_RX_SGE;

      SG_C_ASSERT(__sizeof__RDMA_RX_SGE, sizeof (RDMA_RX_SGE) == 16);

   #else
      typedef struct _RDMA_RX_SGE {
         u32 stag;                                // DWORD 0
         u32 length;                              // DWORD 1
         u32 to_hi;                               // DWORD 2
         u32 to_lo;                               // DWORD 3
      } SG_PACK RDMA_RX_SGE, *PRDMA_RX_SGE;

      typedef union _RDMA_RX_SGE_UNION {
         RDMA_RX_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_RX_SGE_UNION, *PRDMA_RX_SGE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RX_SGE_UNION, sizeof (RDMA_RX_SGE_UNION) == 16);
   #endif


#else
   // Rdma Rx Scatter/Gather Entry. This structure represents a single STag fragment.
   // Multiple SGEs are typically combined into an RDMA Scatter Gather List. Many RDMA
   // WQEs contain 1 or more SGEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RX_SGE {
         union {
            struct { 
               u32 stag;                          // DWORD 0
               u32 length;                        // DWORD 1
               u32 to_hi;                         // DWORD 2
               u32 to_lo;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RX_SGE, *PRDMA_RX_SGE;

      SG_C_ASSERT(__sizeof__RDMA_RX_SGE, sizeof (RDMA_RX_SGE) == 16);

   #else
      typedef struct _RDMA_RX_SGE {
         u32 stag;                                // DWORD 0
         u32 length;                              // DWORD 1
         u32 to_hi;                               // DWORD 2
         u32 to_lo;                               // DWORD 3
      } SG_PACK RDMA_RX_SGE, *PRDMA_RX_SGE;

      typedef union _RDMA_RX_SGE_UNION {
         RDMA_RX_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_RX_SGE_UNION, *PRDMA_RX_SGE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RX_SGE_UNION, sizeof (RDMA_RX_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Rdma Rx wqe unit. This structure represents a single STag fragment. Multiple WQE
   // Units are typically combined into an RDMA_RX_WQE (one unit in RDMA RCV Q . Four RDMA
   // RX WQE UNITs are contained in one RDMA_RX_WQE
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RX_WQE_UNIT {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 RxBufLength;                   // DWORD 2
               u32 rsvd2 : 28;                    // DWORD 3
               u32 SgeIndx : 2;                   // DWORD 3
               u32 SgeCnt : 2;                    // DWORD 3
               RDMA_RX_SGE RxSge;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RX_WQE_UNIT, *PRDMA_RX_WQE_UNIT;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE_UNIT, sizeof (RDMA_RX_WQE_UNIT) == 32);

   #else
      typedef struct _RDMA_RX_WQE_UNIT {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 RxBufLength;                         // DWORD 2
         u32 rsvd2 : 28;                          // DWORD 3
         u32 SgeIndx : 2;                         // DWORD 3
         u32 SgeCnt : 2;                          // DWORD 3
         RDMA_RX_SGE RxSge;
      } SG_PACK RDMA_RX_WQE_UNIT, *PRDMA_RX_WQE_UNIT;

      typedef union _RDMA_RX_WQE_UNIT_UNION {
         RDMA_RX_WQE_UNIT bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_RX_WQE_UNIT_UNION, *PRDMA_RX_WQE_UNIT_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE_UNIT_UNION, sizeof (RDMA_RX_WQE_UNIT_UNION) == 32);
   #endif


#else
   // Rdma Rx wqe unit. This structure represents a single STag fragment. Multiple WQE
   // Units are typically combined into an RDMA_RX_WQE (one unit in RDMA RCV Q . Four RDMA
   // RX WQE UNITs are contained in one RDMA_RX_WQE
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RX_WQE_UNIT {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 RxBufLength;                   // DWORD 2
               u32 SgeCnt : 2;                    // DWORD 3
               u32 SgeIndx : 2;                   // DWORD 3
               u32 rsvd2 : 28;                    // DWORD 3
               RDMA_RX_SGE RxSge;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RX_WQE_UNIT, *PRDMA_RX_WQE_UNIT;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE_UNIT, sizeof (RDMA_RX_WQE_UNIT) == 32);

   #else
      typedef struct _RDMA_RX_WQE_UNIT {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 RxBufLength;                         // DWORD 2
         u32 SgeCnt : 2;                          // DWORD 3
         u32 SgeIndx : 2;                         // DWORD 3
         u32 rsvd2 : 28;                          // DWORD 3
         RDMA_RX_SGE RxSge;
      } SG_PACK RDMA_RX_WQE_UNIT, *PRDMA_RX_WQE_UNIT;

      typedef union _RDMA_RX_WQE_UNIT_UNION {
         RDMA_RX_WQE_UNIT bits;
         u32 dw[8]; // dword union
      } SG_PACK RDMA_RX_WQE_UNIT_UNION, *PRDMA_RX_WQE_UNIT_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE_UNIT_UNION, sizeof (RDMA_RX_WQE_UNIT_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ONe entry in RDMA Queue Pair's Receive Queue
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RX_WQE {
         union {
            struct { 
               RDMA_RX_WQE_UNIT RxWqeUnit[4];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RX_WQE, *PRDMA_RX_WQE;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE, sizeof (RDMA_RX_WQE) == 128);

   #else
      typedef struct _RDMA_RX_WQE {
         RDMA_RX_WQE_UNIT RxWqeUnit[4];
      } SG_PACK RDMA_RX_WQE, *PRDMA_RX_WQE;

      typedef union _RDMA_RX_WQE_UNION {
         RDMA_RX_WQE bits;
         u32 dw[32]; // dword union
      } SG_PACK RDMA_RX_WQE_UNION, *PRDMA_RX_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE_UNION, sizeof (RDMA_RX_WQE_UNION) == 128);
   #endif


#else
   // ONe entry in RDMA Queue Pair's Receive Queue
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RX_WQE {
         union {
            struct { 
               RDMA_RX_WQE_UNIT RxWqeUnit[4];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RX_WQE, *PRDMA_RX_WQE;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE, sizeof (RDMA_RX_WQE) == 128);

   #else
      typedef struct _RDMA_RX_WQE {
         RDMA_RX_WQE_UNIT RxWqeUnit[4];
      } SG_PACK RDMA_RX_WQE, *PRDMA_RX_WQE;

      typedef union _RDMA_RX_WQE_UNION {
         RDMA_RX_WQE bits;
         u32 dw[32]; // dword union
      } SG_PACK RDMA_RX_WQE_UNION, *PRDMA_RX_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RX_WQE_UNION, sizeof (RDMA_RX_WQE_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This WQE is used to post an Receive request to the RQ
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RECEIVE_WQE {
         union {
            struct { 
               RDMA_RX_SGE receive_sgl[4];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RECEIVE_WQE, *PRDMA_RECEIVE_WQE;

      SG_C_ASSERT(__sizeof__RDMA_RECEIVE_WQE, sizeof (RDMA_RECEIVE_WQE) == 64);

   #else
      typedef struct _RDMA_RECEIVE_WQE {
         RDMA_RX_SGE receive_sgl[4];
      } SG_PACK RDMA_RECEIVE_WQE, *PRDMA_RECEIVE_WQE;

      typedef union _RDMA_RECEIVE_WQE_UNION {
         RDMA_RECEIVE_WQE bits;
         u32 dw[16]; // dword union
      } SG_PACK RDMA_RECEIVE_WQE_UNION, *PRDMA_RECEIVE_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RECEIVE_WQE_UNION, sizeof (RDMA_RECEIVE_WQE_UNION) == 64);
   #endif


#else
   // This WQE is used to post an Receive request to the RQ
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_RECEIVE_WQE {
         union {
            struct { 
               RDMA_RX_SGE receive_sgl[4];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_RECEIVE_WQE, *PRDMA_RECEIVE_WQE;

      SG_C_ASSERT(__sizeof__RDMA_RECEIVE_WQE, sizeof (RDMA_RECEIVE_WQE) == 64);

   #else
      typedef struct _RDMA_RECEIVE_WQE {
         RDMA_RX_SGE receive_sgl[4];
      } SG_PACK RDMA_RECEIVE_WQE, *PRDMA_RECEIVE_WQE;

      typedef union _RDMA_RECEIVE_WQE_UNION {
         RDMA_RECEIVE_WQE bits;
         u32 dw[16]; // dword union
      } SG_PACK RDMA_RECEIVE_WQE_UNION, *PRDMA_RECEIVE_WQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_RECEIVE_WQE_UNION, sizeof (RDMA_RECEIVE_WQE_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Completion Queue Entry. This format is used by both SQ and RQ CQEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_CQE {
         union {
            struct { 
               u32 order : 3;                     // DWORD 0
               u32 qp_id : 13;                    // DWORD 0
               u32 flags_rsvd0 : 4;               // DWORD 0
               u32 flags_sq : 1;                  // DWORD 0
               u32 flags_pbl_struct : 1;          // DWORD 0
               u32 flags_bindable : 1;            // DWORD 0
               u32 flags_remote_write : 1;        // DWORD 0
               u32 flags_local_write : 1;         // DWORD 0
               u32 flags_remote_read : 1;         // DWORD 0
               u32 flags_local_read : 1;          // DWORD 0
               u32 flags_va_addr : 1;             // DWORD 0
               u32 flags_invalidate : 1;          // DWORD 0
               u32 flags_fence : 1;               // DWORD 0
               u32 flags_solicited : 1;           // DWORD 0
               u32 flags_signal : 1;              // DWORD 0
               u32 invalidated_stag;              // DWORD 1
               u32 valid : 1;                     // DWORD 2
               u32 bytes_received : 31;           // DWORD 2
               u32 status : 8;                    // DWORD 3
               u32 op : 8;                        // DWORD 3
               u32 wqe_index : 16;                // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_CQE, *PRDMA_CQE;

      SG_C_ASSERT(__sizeof__RDMA_CQE, sizeof (RDMA_CQE) == 16);

   #else
      typedef struct _RDMA_CQE {
         u32 order : 3;                           // DWORD 0
         u32 qp_id : 13;                          // DWORD 0
         u32 flags_rsvd0 : 4;                     // DWORD 0
         u32 flags_sq : 1;                        // DWORD 0
         u32 flags_pbl_struct : 1;                // DWORD 0
         u32 flags_bindable : 1;                  // DWORD 0
         u32 flags_remote_write : 1;              // DWORD 0
         u32 flags_local_write : 1;               // DWORD 0
         u32 flags_remote_read : 1;               // DWORD 0
         u32 flags_local_read : 1;                // DWORD 0
         u32 flags_va_addr : 1;                   // DWORD 0
         u32 flags_invalidate : 1;                // DWORD 0
         u32 flags_fence : 1;                     // DWORD 0
         u32 flags_solicited : 1;                 // DWORD 0
         u32 flags_signal : 1;                    // DWORD 0
         u32 invalidated_stag;                    // DWORD 1
         u32 valid : 1;                           // DWORD 2
         u32 bytes_received : 31;                 // DWORD 2
         u32 status : 8;                          // DWORD 3
         u32 op : 8;                              // DWORD 3
         u32 wqe_index : 16;                      // DWORD 3
      } SG_PACK RDMA_CQE, *PRDMA_CQE;

      typedef union _RDMA_CQE_UNION {
         RDMA_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_CQE_UNION, *PRDMA_CQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_CQE_UNION, sizeof (RDMA_CQE_UNION) == 16);
   #endif


#else
   // Completion Queue Entry. This format is used by both SQ and RQ CQEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RDMA_CQE {
         union {
            struct { 
               u32 flags_signal : 1;              // DWORD 0
               u32 flags_solicited : 1;           // DWORD 0
               u32 flags_fence : 1;               // DWORD 0
               u32 flags_invalidate : 1;          // DWORD 0
               u32 flags_va_addr : 1;             // DWORD 0
               u32 flags_local_read : 1;          // DWORD 0
               u32 flags_remote_read : 1;         // DWORD 0
               u32 flags_local_write : 1;         // DWORD 0
               u32 flags_remote_write : 1;        // DWORD 0
               u32 flags_bindable : 1;            // DWORD 0
               u32 flags_pbl_struct : 1;          // DWORD 0
               u32 flags_sq : 1;                  // DWORD 0
               u32 flags_rsvd0 : 4;               // DWORD 0
               u32 qp_id : 13;                    // DWORD 0
               u32 order : 3;                     // DWORD 0
               u32 invalidated_stag;              // DWORD 1
               u32 bytes_received : 31;           // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 wqe_index : 16;                // DWORD 3
               u32 op : 8;                        // DWORD 3
               u32 status : 8;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK RDMA_CQE, *PRDMA_CQE;

      SG_C_ASSERT(__sizeof__RDMA_CQE, sizeof (RDMA_CQE) == 16);

   #else
      typedef struct _RDMA_CQE {
         u32 flags_signal : 1;                    // DWORD 0
         u32 flags_solicited : 1;                 // DWORD 0
         u32 flags_fence : 1;                     // DWORD 0
         u32 flags_invalidate : 1;                // DWORD 0
         u32 flags_va_addr : 1;                   // DWORD 0
         u32 flags_local_read : 1;                // DWORD 0
         u32 flags_remote_read : 1;               // DWORD 0
         u32 flags_local_write : 1;               // DWORD 0
         u32 flags_remote_write : 1;              // DWORD 0
         u32 flags_bindable : 1;                  // DWORD 0
         u32 flags_pbl_struct : 1;                // DWORD 0
         u32 flags_sq : 1;                        // DWORD 0
         u32 flags_rsvd0 : 4;                     // DWORD 0
         u32 qp_id : 13;                          // DWORD 0
         u32 order : 3;                           // DWORD 0
         u32 invalidated_stag;                    // DWORD 1
         u32 bytes_received : 31;                 // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 wqe_index : 16;                      // DWORD 3
         u32 op : 8;                              // DWORD 3
         u32 status : 8;                          // DWORD 3
      } SG_PACK RDMA_CQE, *PRDMA_CQE;

      typedef union _RDMA_CQE_UNION {
         RDMA_CQE bits;
         u32 dw[4]; // dword union
      } SG_PACK RDMA_CQE_UNION, *PRDMA_CQE_UNION;

      SG_C_ASSERT(__sizeof__RDMA_CQE_UNION, sizeof (RDMA_CQE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Translation Entry. This structure defines an entry in a list of physical addresses.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TE {
         union {
            struct { 
               WCON_PM_CC dal_te;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TE, *PDAL_TE;

      SG_C_ASSERT(__sizeof__DAL_TE, sizeof (DAL_TE) == 8);

   #else
      typedef struct _DAL_TE {
         WCON_PM_CC dal_te;
      } SG_PACK DAL_TE, *PDAL_TE;

      typedef union _DAL_TE_UNION {
         DAL_TE bits;
         u32 dw[2]; // dword union
      } SG_PACK DAL_TE_UNION, *PDAL_TE_UNION;

      SG_C_ASSERT(__sizeof__DAL_TE_UNION, sizeof (DAL_TE_UNION) == 8);
   #endif


#else
   // Translation Entry. This structure defines an entry in a list of physical addresses.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TE {
         union {
            struct { 
               WCON_PM_CC dal_te;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TE, *PDAL_TE;

      SG_C_ASSERT(__sizeof__DAL_TE, sizeof (DAL_TE) == 8);

   #else
      typedef struct _DAL_TE {
         WCON_PM_CC dal_te;
      } SG_PACK DAL_TE, *PDAL_TE;

      typedef union _DAL_TE_UNION {
         DAL_TE bits;
         u32 dw[2]; // dword union
      } SG_PACK DAL_TE_UNION, *PDAL_TE_UNION;

      SG_C_ASSERT(__sizeof__DAL_TE_UNION, sizeof (DAL_TE_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Protection Entry. This structure defines access rights to a memory region
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_PE {
         union {
            struct { 
               u32 pdid : 16;                     // DWORD 0
               u32 reference_count : 16;          // DWORD 0
               u32 page_size : 16;                // DWORD 1
               u32 rsvd0 : 14;                    // DWORD 1
               u32 cached_in_ctx : 1;             // DWORD 1
               u32 valid : 1;                     // DWORD 1
               u32 rsvd1[1];                      // DWORDS 2 to 2
               STAG_D stag;
               u32 length;                        // DWORD 4
               u32 rsvd2[1];                      // DWORDS 5 to 5
               u32 te_ctx;                        // DWORD 6
               u32 te_cra;                        // DWORD 7
               u32 rsvd3[1];                      // DWORDS 8 to 8
               u32 rsvd4[1];                      // DWORDS 9 to 9
               u32 rsvd5[1];                      // DWORDS 10 to 10
               u32 rsvd6[1];                      // DWORDS 11 to 11
               u32 rsvd7[1];                      // DWORDS 12 to 12
               u32 rsvd8[1];                      // DWORDS 13 to 13
               u32 rsvd9[1];                      // DWORDS 14 to 14
               u32 rsvd10[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_PE, *PDAL_PE;

      SG_C_ASSERT(__sizeof__DAL_PE, sizeof (DAL_PE) == 64);

   #else
      typedef struct _DAL_PE {
         u32 pdid : 16;                           // DWORD 0
         u32 reference_count : 16;                // DWORD 0
         u32 page_size : 16;                      // DWORD 1
         u32 rsvd0 : 14;                          // DWORD 1
         u32 cached_in_ctx : 1;                   // DWORD 1
         u32 valid : 1;                           // DWORD 1
         u32 rsvd1[1];                            // DWORDS 2 to 2
         STAG_D stag;
         u32 length;                              // DWORD 4
         u32 rsvd2[1];                            // DWORDS 5 to 5
         u32 te_ctx;                              // DWORD 6
         u32 te_cra;                              // DWORD 7
         u32 rsvd3[1];                            // DWORDS 8 to 8
         u32 rsvd4[1];                            // DWORDS 9 to 9
         u32 rsvd5[1];                            // DWORDS 10 to 10
         u32 rsvd6[1];                            // DWORDS 11 to 11
         u32 rsvd7[1];                            // DWORDS 12 to 12
         u32 rsvd8[1];                            // DWORDS 13 to 13
         u32 rsvd9[1];                            // DWORDS 14 to 14
         u32 rsvd10[1];                           // DWORDS 15 to 15
      } SG_PACK DAL_PE, *PDAL_PE;

      typedef union _DAL_PE_UNION {
         DAL_PE bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_PE_UNION, *PDAL_PE_UNION;

      SG_C_ASSERT(__sizeof__DAL_PE_UNION, sizeof (DAL_PE_UNION) == 64);
   #endif


#else
   // Protection Entry. This structure defines access rights to a memory region
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_PE {
         union {
            struct { 
               u32 reference_count : 16;          // DWORD 0
               u32 pdid : 16;                     // DWORD 0
               u32 valid : 1;                     // DWORD 1
               u32 cached_in_ctx : 1;             // DWORD 1
               u32 rsvd0 : 14;                    // DWORD 1
               u32 page_size : 16;                // DWORD 1
               u32 rsvd1[1];                      // DWORDS 2 to 2
               STAG_D stag;
               u32 length;                        // DWORD 4
               u32 rsvd2[1];                      // DWORDS 5 to 5
               u32 te_ctx;                        // DWORD 6
               u32 te_cra;                        // DWORD 7
               u32 rsvd3[1];                      // DWORDS 8 to 8
               u32 rsvd4[1];                      // DWORDS 9 to 9
               u32 rsvd5[1];                      // DWORDS 10 to 10
               u32 rsvd6[1];                      // DWORDS 11 to 11
               u32 rsvd7[1];                      // DWORDS 12 to 12
               u32 rsvd8[1];                      // DWORDS 13 to 13
               u32 rsvd9[1];                      // DWORDS 14 to 14
               u32 rsvd10[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_PE, *PDAL_PE;

      SG_C_ASSERT(__sizeof__DAL_PE, sizeof (DAL_PE) == 64);

   #else
      typedef struct _DAL_PE {
         u32 reference_count : 16;                // DWORD 0
         u32 pdid : 16;                           // DWORD 0
         u32 valid : 1;                           // DWORD 1
         u32 cached_in_ctx : 1;                   // DWORD 1
         u32 rsvd0 : 14;                          // DWORD 1
         u32 page_size : 16;                      // DWORD 1
         u32 rsvd1[1];                            // DWORDS 2 to 2
         STAG_D stag;
         u32 length;                              // DWORD 4
         u32 rsvd2[1];                            // DWORDS 5 to 5
         u32 te_ctx;                              // DWORD 6
         u32 te_cra;                              // DWORD 7
         u32 rsvd3[1];                            // DWORDS 8 to 8
         u32 rsvd4[1];                            // DWORDS 9 to 9
         u32 rsvd5[1];                            // DWORDS 10 to 10
         u32 rsvd6[1];                            // DWORDS 11 to 11
         u32 rsvd7[1];                            // DWORDS 12 to 12
         u32 rsvd8[1];                            // DWORDS 13 to 13
         u32 rsvd9[1];                            // DWORDS 14 to 14
         u32 rsvd10[1];                           // DWORDS 15 to 15
      } SG_PACK DAL_PE, *PDAL_PE;

      typedef union _DAL_PE_UNION {
         DAL_PE bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_PE_UNION, *PDAL_PE_UNION;

      SG_C_ASSERT(__sizeof__DAL_PE_UNION, sizeof (DAL_PE_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DAL Scatter/Gather Entry. This structure represents a single STag fragment. Multiple
   // SGEs are typically combined into an DAL Scatter Gather List.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_SGE {
         union {
            struct { 
               u32 stag;                          // DWORD 0
               u32 length;                        // DWORD 1
               u32 to_hi;                         // DWORD 2
               u32 to_lo;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK DAL_SGE, *PDAL_SGE;

      SG_C_ASSERT(__sizeof__DAL_SGE, sizeof (DAL_SGE) == 16);

   #else
      typedef struct _DAL_SGE {
         u32 stag;                                // DWORD 0
         u32 length;                              // DWORD 1
         u32 to_hi;                               // DWORD 2
         u32 to_lo;                               // DWORD 3
      } SG_PACK DAL_SGE, *PDAL_SGE;

      typedef union _DAL_SGE_UNION {
         DAL_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK DAL_SGE_UNION, *PDAL_SGE_UNION;

      SG_C_ASSERT(__sizeof__DAL_SGE_UNION, sizeof (DAL_SGE_UNION) == 16);
   #endif


#else
   // DAL Scatter/Gather Entry. This structure represents a single STag fragment. Multiple
   // SGEs are typically combined into an DAL Scatter Gather List.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_SGE {
         union {
            struct { 
               u32 stag;                          // DWORD 0
               u32 length;                        // DWORD 1
               u32 to_hi;                         // DWORD 2
               u32 to_lo;                         // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK DAL_SGE, *PDAL_SGE;

      SG_C_ASSERT(__sizeof__DAL_SGE, sizeof (DAL_SGE) == 16);

   #else
      typedef struct _DAL_SGE {
         u32 stag;                                // DWORD 0
         u32 length;                              // DWORD 1
         u32 to_hi;                               // DWORD 2
         u32 to_lo;                               // DWORD 3
      } SG_PACK DAL_SGE, *PDAL_SGE;

      typedef union _DAL_SGE_UNION {
         DAL_SGE bits;
         u32 dw[4]; // dword union
      } SG_PACK DAL_SGE_UNION, *PDAL_SGE_UNION;

      SG_C_ASSERT(__sizeof__DAL_SGE_UNION, sizeof (DAL_SGE_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the DAL TX work queue element. It contains a header portion and upto three
   // scatter-gather elements
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TX_WQE {
         union {
            struct { 
               ETH_HEADER eth_hdr;
               DAL_SGE tx_sge[3];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TX_WQE, *PDAL_TX_WQE;

      SG_C_ASSERT(__sizeof__DAL_TX_WQE, sizeof (DAL_TX_WQE) == 64);

   #else
      typedef struct _DAL_TX_WQE {
         ETH_HEADER eth_hdr;
         DAL_SGE tx_sge[3];
      } SG_PACK DAL_TX_WQE, *PDAL_TX_WQE;

      typedef union _DAL_TX_WQE_UNION {
         DAL_TX_WQE bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_TX_WQE_UNION, *PDAL_TX_WQE_UNION;

      SG_C_ASSERT(__sizeof__DAL_TX_WQE_UNION, sizeof (DAL_TX_WQE_UNION) == 64);
   #endif


#else
   // This is the DAL TX work queue element. It contains a header portion and upto three
   // scatter-gather elements
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_TX_WQE {
         union {
            struct { 
               ETH_HEADER eth_hdr;
               DAL_SGE tx_sge[3];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK DAL_TX_WQE, *PDAL_TX_WQE;

      SG_C_ASSERT(__sizeof__DAL_TX_WQE, sizeof (DAL_TX_WQE) == 64);

   #else
      typedef struct _DAL_TX_WQE {
         ETH_HEADER eth_hdr;
         DAL_SGE tx_sge[3];
      } SG_PACK DAL_TX_WQE, *PDAL_TX_WQE;

      typedef union _DAL_TX_WQE_UNION {
         DAL_TX_WQE bits;
         u32 dw[16]; // dword union
      } SG_PACK DAL_TX_WQE_UNION, *PDAL_TX_WQE_UNION;

      SG_C_ASSERT(__sizeof__DAL_TX_WQE_UNION, sizeof (DAL_TX_WQE_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Completion Queue Entry. This format is used by both SQ and RQ CQEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_COMPL {
         union {
            struct { 
               u32 status : 4;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 port : 2;                      // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 wrb_index : 12;                // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 1
               u32 nwh_bytes : 8;                 // DWORD 1
               u32 user_bytes : 16;               // DWORD 1
               u32 stag;                          // DWORD 2
               u32 valid : 1;                     // DWORD 3
               u32 qp_id : 15;                    // DWORD 3
               u32 packets : 16;                  // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK DAL_COMPL, *PDAL_COMPL;

      SG_C_ASSERT(__sizeof__DAL_COMPL, sizeof (DAL_COMPL) == 16);

   #else
      typedef struct _DAL_COMPL {
         u32 status : 4;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 port : 2;                            // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 wrb_index : 12;                      // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 1
         u32 nwh_bytes : 8;                       // DWORD 1
         u32 user_bytes : 16;                     // DWORD 1
         u32 stag;                                // DWORD 2
         u32 valid : 1;                           // DWORD 3
         u32 qp_id : 15;                          // DWORD 3
         u32 packets : 16;                        // DWORD 3
      } SG_PACK DAL_COMPL, *PDAL_COMPL;

      typedef union _DAL_COMPL_UNION {
         DAL_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK DAL_COMPL_UNION, *PDAL_COMPL_UNION;

      SG_C_ASSERT(__sizeof__DAL_COMPL_UNION, sizeof (DAL_COMPL_UNION) == 16);
   #endif


#else
   // Completion Queue Entry. This format is used by both SQ and RQ CQEs.
   #if defined(SG_BMAP_UNION)
      typedef struct _DAL_COMPL {
         union {
            struct { 
               u32 wrb_index : 12;                // DWORD 0
               u32 type : 4;                      // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 port : 2;                      // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 user_bytes : 16;               // DWORD 1
               u32 nwh_bytes : 8;                 // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 1
               u32 stag;                          // DWORD 2
               u32 packets : 16;                  // DWORD 3
               u32 qp_id : 15;                    // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK DAL_COMPL, *PDAL_COMPL;

      SG_C_ASSERT(__sizeof__DAL_COMPL, sizeof (DAL_COMPL) == 16);

   #else
      typedef struct _DAL_COMPL {
         u32 wrb_index : 12;                      // DWORD 0
         u32 type : 4;                            // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 port : 2;                            // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 user_bytes : 16;                     // DWORD 1
         u32 nwh_bytes : 8;                       // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 1
         u32 stag;                                // DWORD 2
         u32 packets : 16;                        // DWORD 3
         u32 qp_id : 15;                          // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK DAL_COMPL, *PDAL_COMPL;

      typedef union _DAL_COMPL_UNION {
         DAL_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK DAL_COMPL_UNION, *PDAL_COMPL_UNION;

      SG_C_ASSERT(__sizeof__DAL_COMPL_UNION, sizeof (DAL_COMPL_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __host_struct_bmap_h__

