/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __txp_bmap_h__
#define __txp_bmap_h__
#include "setypes.h"
#include "pq_bmap.h"
#include "gencommon_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Each TXP stat is 64-bits, with the least significant DWORD first. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_STAT {
         union {
            struct { 
               u32 lsd;                           // DWORD 0
               u32 msd;                           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_STAT, *PBE2_TXP_STAT;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT, sizeof (BE2_TXP_STAT) == 8);

   #else
      typedef struct _BE2_TXP_STAT {
         u32 lsd;                                 // DWORD 0
         u32 msd;                                 // DWORD 1
      } SG_PACK BE2_TXP_STAT, *PBE2_TXP_STAT;

      typedef union _BE2_TXP_STAT_UNION {
         BE2_TXP_STAT bits;
         u32 dw[2]; // dword union
      } SG_PACK BE2_TXP_STAT_UNION, *PBE2_TXP_STAT_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT_UNION, sizeof (BE2_TXP_STAT_UNION) == 8);
   #endif


#else
   // Each TXP stat is 64-bits, with the least significant DWORD first. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_STAT {
         union {
            struct { 
               u32 lsd;                           // DWORD 0
               u32 msd;                           // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_STAT, *PBE2_TXP_STAT;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT, sizeof (BE2_TXP_STAT) == 8);

   #else
      typedef struct _BE2_TXP_STAT {
         u32 lsd;                                 // DWORD 0
         u32 msd;                                 // DWORD 1
      } SG_PACK BE2_TXP_STAT, *PBE2_TXP_STAT;

      typedef union _BE2_TXP_STAT_UNION {
         BE2_TXP_STAT bits;
         u32 dw[2]; // dword union
      } SG_PACK BE2_TXP_STAT_UNION, *PBE2_TXP_STAT_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT_UNION, sizeof (BE2_TXP_STAT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each chute contains port 0 and 1 stats. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_CHUTE_STAT {
         union {
            struct { 
               BE2_TXP_STAT port[2];
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_CHUTE_STAT, *PBE2_TXP_CHUTE_STAT;

      SG_C_ASSERT(__sizeof__BE2_TXP_CHUTE_STAT, sizeof (BE2_TXP_CHUTE_STAT) == 16);

   #else
      typedef struct _BE2_TXP_CHUTE_STAT {
         BE2_TXP_STAT port[2];
      } SG_PACK BE2_TXP_CHUTE_STAT, *PBE2_TXP_CHUTE_STAT;

      typedef union _BE2_TXP_CHUTE_STAT_UNION {
         BE2_TXP_CHUTE_STAT bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_TXP_CHUTE_STAT_UNION, *PBE2_TXP_CHUTE_STAT_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_CHUTE_STAT_UNION, sizeof (BE2_TXP_CHUTE_STAT_UNION) == 16);
   #endif


#else
   // Each chute contains port 0 and 1 stats. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_CHUTE_STAT {
         union {
            struct { 
               BE2_TXP_STAT port[2];
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_CHUTE_STAT, *PBE2_TXP_CHUTE_STAT;

      SG_C_ASSERT(__sizeof__BE2_TXP_CHUTE_STAT, sizeof (BE2_TXP_CHUTE_STAT) == 16);

   #else
      typedef struct _BE2_TXP_CHUTE_STAT {
         BE2_TXP_STAT port[2];
      } SG_PACK BE2_TXP_CHUTE_STAT, *PBE2_TXP_CHUTE_STAT;

      typedef union _BE2_TXP_CHUTE_STAT_UNION {
         BE2_TXP_CHUTE_STAT bits;
         u32 dw[4]; // dword union
      } SG_PACK BE2_TXP_CHUTE_STAT_UNION, *PBE2_TXP_CHUTE_STAT_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_CHUTE_STAT_UNION, sizeof (BE2_TXP_CHUTE_STAT_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each stat is recorded for all transmit chutes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_STAT_SET {
         union {
            struct { 
               BE2_TXP_CHUTE_STAT chute[3];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_STAT_SET, *PBE2_TXP_STAT_SET;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT_SET, sizeof (BE2_TXP_STAT_SET) == 48);

   #else
      typedef struct _BE2_TXP_STAT_SET {
         BE2_TXP_CHUTE_STAT chute[3];
      } SG_PACK BE2_TXP_STAT_SET, *PBE2_TXP_STAT_SET;

      typedef union _BE2_TXP_STAT_SET_UNION {
         BE2_TXP_STAT_SET bits;
         u32 dw[12]; // dword union
      } SG_PACK BE2_TXP_STAT_SET_UNION, *PBE2_TXP_STAT_SET_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT_SET_UNION, sizeof (BE2_TXP_STAT_SET_UNION) == 48);
   #endif


#else
   // Each stat is recorded for all transmit chutes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_STAT_SET {
         union {
            struct { 
               BE2_TXP_CHUTE_STAT chute[3];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_STAT_SET, *PBE2_TXP_STAT_SET;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT_SET, sizeof (BE2_TXP_STAT_SET) == 48);

   #else
      typedef struct _BE2_TXP_STAT_SET {
         BE2_TXP_CHUTE_STAT chute[3];
      } SG_PACK BE2_TXP_STAT_SET, *PBE2_TXP_STAT_SET;

      typedef union _BE2_TXP_STAT_SET_UNION {
         BE2_TXP_STAT_SET bits;
         u32 dw[12]; // dword union
      } SG_PACK BE2_TXP_STAT_SET_UNION, *PBE2_TXP_STAT_SET_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_STAT_SET_UNION, sizeof (BE2_TXP_STAT_SET_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The stats read using the TXP_STAT_INDEX_CSR and TXP_STAT_VALUE_CSR. The 32-bit
   // offset in the struct matches the index in the TX_STAT_INDICES_ENUM enum. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_STATS {
         union {
            struct { 
               BE2_TXP_STAT_SET tx_bytes;
               BE2_TXP_STAT_SET tx_packets;
               BE2_TXP_STAT_SET tx_rexmit_bytes;
               BE2_TXP_STAT_SET tx_rexmit_packets;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_STATS, *PBE2_TXP_STATS;

      SG_C_ASSERT(__sizeof__BE2_TXP_STATS, sizeof (BE2_TXP_STATS) == 192);

   #else
      typedef struct _BE2_TXP_STATS {
         BE2_TXP_STAT_SET tx_bytes;
         BE2_TXP_STAT_SET tx_packets;
         BE2_TXP_STAT_SET tx_rexmit_bytes;
         BE2_TXP_STAT_SET tx_rexmit_packets;
      } SG_PACK BE2_TXP_STATS, *PBE2_TXP_STATS;

      typedef union _BE2_TXP_STATS_UNION {
         BE2_TXP_STATS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_STATS_UNION, *PBE2_TXP_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_STATS_UNION, sizeof (BE2_TXP_STATS_UNION) == 192);
   #endif


#else
   // The stats read using the TXP_STAT_INDEX_CSR and TXP_STAT_VALUE_CSR. The 32-bit
   // offset in the struct matches the index in the TX_STAT_INDICES_ENUM enum. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_TXP_STATS {
         union {
            struct { 
               BE2_TXP_STAT_SET tx_bytes;
               BE2_TXP_STAT_SET tx_packets;
               BE2_TXP_STAT_SET tx_rexmit_bytes;
               BE2_TXP_STAT_SET tx_rexmit_packets;
            } SG_PACK ; // unnamed struct
            u32 dw[48]; // dword union
         }; // unnamed union
      } SG_PACK BE2_TXP_STATS, *PBE2_TXP_STATS;

      SG_C_ASSERT(__sizeof__BE2_TXP_STATS, sizeof (BE2_TXP_STATS) == 192);

   #else
      typedef struct _BE2_TXP_STATS {
         BE2_TXP_STAT_SET tx_bytes;
         BE2_TXP_STAT_SET tx_packets;
         BE2_TXP_STAT_SET tx_rexmit_bytes;
         BE2_TXP_STAT_SET tx_rexmit_packets;
      } SG_PACK BE2_TXP_STATS, *PBE2_TXP_STATS;

      typedef union _BE2_TXP_STATS_UNION {
         BE2_TXP_STATS bits;
         u32 dw[48]; // dword union
      } SG_PACK BE2_TXP_STATS_UNION, *PBE2_TXP_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE2_TXP_STATS_UNION, sizeof (BE2_TXP_STATS_UNION) == 192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Controls the TXP operation. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CONTROL_CSR {
         union {
            struct { 
               u32 ndma_limit : 4;                // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 enable_switch : 1;             // DWORD 0
               u32 txpb_eth_fraglist : 1;         // DWORD 0
               u32 per_priority_pause_ignore_txpb_limit : 1; // DWORD 0
               u32 per_priority_pause_ignore_txd_limit : 1; // DWORD 0
               u32 per_priority_pause_stop_dma : 1; // DWORD 0
               u32 per_priority_pause : 1;        // DWORD 0
               u32 cev_swap_cntl : 2;             // DWORD 0
               u32 ndma_swap_cntl : 2;            // DWORD 0
               u32 mgmt_forward_1 : 1;            // DWORD 0
               u32 mgmt_forward_0 : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CONTROL_CSR, *PTXP_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CONTROL_CSR, sizeof (TXP_CONTROL_CSR) == 4);

   #else
      typedef struct _TXP_CONTROL_CSR {
         u32 ndma_limit : 4;                      // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 enable_switch : 1;                   // DWORD 0
         u32 txpb_eth_fraglist : 1;               // DWORD 0
         u32 per_priority_pause_ignore_txpb_limit : 1; // DWORD 0
         u32 per_priority_pause_ignore_txd_limit : 1; // DWORD 0
         u32 per_priority_pause_stop_dma : 1;     // DWORD 0
         u32 per_priority_pause : 1;              // DWORD 0
         u32 cev_swap_cntl : 2;                   // DWORD 0
         u32 ndma_swap_cntl : 2;                  // DWORD 0
         u32 mgmt_forward_1 : 1;                  // DWORD 0
         u32 mgmt_forward_0 : 1;                  // DWORD 0
      } SG_PACK TXP_CONTROL_CSR, *PTXP_CONTROL_CSR;

      typedef union _TXP_CONTROL_CSR_UNION {
         TXP_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CONTROL_CSR_UNION, *PTXP_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CONTROL_CSR_UNION, sizeof (TXP_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // Controls the TXP operation. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CONTROL_CSR {
         union {
            struct { 
               u32 mgmt_forward_0 : 1;            // DWORD 0
               u32 mgmt_forward_1 : 1;            // DWORD 0
               u32 ndma_swap_cntl : 2;            // DWORD 0
               u32 cev_swap_cntl : 2;             // DWORD 0
               u32 per_priority_pause : 1;        // DWORD 0
               u32 per_priority_pause_stop_dma : 1; // DWORD 0
               u32 per_priority_pause_ignore_txd_limit : 1; // DWORD 0
               u32 per_priority_pause_ignore_txpb_limit : 1; // DWORD 0
               u32 txpb_eth_fraglist : 1;         // DWORD 0
               u32 enable_switch : 1;             // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 ndma_limit : 4;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CONTROL_CSR, *PTXP_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CONTROL_CSR, sizeof (TXP_CONTROL_CSR) == 4);

   #else
      typedef struct _TXP_CONTROL_CSR {
         u32 mgmt_forward_0 : 1;                  // DWORD 0
         u32 mgmt_forward_1 : 1;                  // DWORD 0
         u32 ndma_swap_cntl : 2;                  // DWORD 0
         u32 cev_swap_cntl : 2;                   // DWORD 0
         u32 per_priority_pause : 1;              // DWORD 0
         u32 per_priority_pause_stop_dma : 1;     // DWORD 0
         u32 per_priority_pause_ignore_txd_limit : 1; // DWORD 0
         u32 per_priority_pause_ignore_txpb_limit : 1; // DWORD 0
         u32 txpb_eth_fraglist : 1;               // DWORD 0
         u32 enable_switch : 1;                   // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 ndma_limit : 4;                      // DWORD 0
      } SG_PACK TXP_CONTROL_CSR, *PTXP_CONTROL_CSR;

      typedef union _TXP_CONTROL_CSR_UNION {
         TXP_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CONTROL_CSR_UNION, *PTXP_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CONTROL_CSR_UNION, sizeof (TXP_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The TXP PIO Command register is used to transmit packets in PIO mode. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PIO_COMMAND_CSR {
         union {
            struct { 
               u32 rsvd0 : 30;                    // DWORD 0
               u32 transmit : 1;                  // DWORD 0
               u32 mode : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PIO_COMMAND_CSR, *PTXP_PIO_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__TXP_PIO_COMMAND_CSR, sizeof (TXP_PIO_COMMAND_CSR) == 4);

   #else
      typedef struct _TXP_PIO_COMMAND_CSR {
         u32 rsvd0 : 30;                          // DWORD 0
         u32 transmit : 1;                        // DWORD 0
         u32 mode : 1;                            // DWORD 0
      } SG_PACK TXP_PIO_COMMAND_CSR, *PTXP_PIO_COMMAND_CSR;

      typedef union _TXP_PIO_COMMAND_CSR_UNION {
         TXP_PIO_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PIO_COMMAND_CSR_UNION, *PTXP_PIO_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PIO_COMMAND_CSR_UNION, sizeof (TXP_PIO_COMMAND_CSR_UNION) == 4);
   #endif


#else
   // The TXP PIO Command register is used to transmit packets in PIO mode. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PIO_COMMAND_CSR {
         union {
            struct { 
               u32 mode : 1;                      // DWORD 0
               u32 transmit : 1;                  // DWORD 0
               u32 rsvd0 : 30;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PIO_COMMAND_CSR, *PTXP_PIO_COMMAND_CSR;

      SG_C_ASSERT(__sizeof__TXP_PIO_COMMAND_CSR, sizeof (TXP_PIO_COMMAND_CSR) == 4);

   #else
      typedef struct _TXP_PIO_COMMAND_CSR {
         u32 mode : 1;                            // DWORD 0
         u32 transmit : 1;                        // DWORD 0
         u32 rsvd0 : 30;                          // DWORD 0
      } SG_PACK TXP_PIO_COMMAND_CSR, *PTXP_PIO_COMMAND_CSR;

      typedef union _TXP_PIO_COMMAND_CSR_UNION {
         TXP_PIO_COMMAND_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PIO_COMMAND_CSR_UNION, *PTXP_PIO_COMMAND_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PIO_COMMAND_CSR_UNION, sizeof (TXP_PIO_COMMAND_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The TXP PIO Data register is used to write transmit packet data. For each packet,
   // the number of writes to this register must be a multiple of 2. Packet data must be 8
   // byte aligned. Byte order: The first 2 writes to this register must be the 8 bytes of
   // the packet's TX_FIFO_HDR_D, with the dst field in byte 3, bits 2 to 0, of the first
   // write. The packet data writes follow with the first byte on the wire in byte 3, bits
   // 7 to 0. The second byte on the wire is byte 2, bits 15 to 8, etc. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PIO_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PIO_DATA_CSR, *PTXP_PIO_DATA_CSR;

      SG_C_ASSERT(__sizeof__TXP_PIO_DATA_CSR, sizeof (TXP_PIO_DATA_CSR) == 4);

   #else
      typedef struct _TXP_PIO_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK TXP_PIO_DATA_CSR, *PTXP_PIO_DATA_CSR;

      typedef union _TXP_PIO_DATA_CSR_UNION {
         TXP_PIO_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PIO_DATA_CSR_UNION, *PTXP_PIO_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PIO_DATA_CSR_UNION, sizeof (TXP_PIO_DATA_CSR_UNION) == 4);
   #endif


#else
   // The TXP PIO Data register is used to write transmit packet data. For each packet,
   // the number of writes to this register must be a multiple of 2. Packet data must be 8
   // byte aligned. Byte order: The first 2 writes to this register must be the 8 bytes of
   // the packet's TX_FIFO_HDR_D, with the dst field in byte 3, bits 2 to 0, of the first
   // write. The packet data writes follow with the first byte on the wire in byte 3, bits
   // 7 to 0. The second byte on the wire is byte 2, bits 15 to 8, etc. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PIO_DATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PIO_DATA_CSR, *PTXP_PIO_DATA_CSR;

      SG_C_ASSERT(__sizeof__TXP_PIO_DATA_CSR, sizeof (TXP_PIO_DATA_CSR) == 4);

   #else
      typedef struct _TXP_PIO_DATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK TXP_PIO_DATA_CSR, *PTXP_PIO_DATA_CSR;

      typedef union _TXP_PIO_DATA_CSR_UNION {
         TXP_PIO_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PIO_DATA_CSR_UNION, *PTXP_PIO_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PIO_DATA_CSR_UNION, sizeof (TXP_PIO_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The number of free 64-bit entries in the 10G Port 0 TX FIFO. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_FIFO_FREE_0_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_FIFO_FREE_0_CSR, *PTXP_FIFO_FREE_0_CSR;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_0_CSR, sizeof (TXP_FIFO_FREE_0_CSR) == 4);

   #else
      typedef struct _TXP_FIFO_FREE_0_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK TXP_FIFO_FREE_0_CSR, *PTXP_FIFO_FREE_0_CSR;

      typedef union _TXP_FIFO_FREE_0_CSR_UNION {
         TXP_FIFO_FREE_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_FIFO_FREE_0_CSR_UNION, *PTXP_FIFO_FREE_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_0_CSR_UNION, sizeof (TXP_FIFO_FREE_0_CSR_UNION) == 4);
   #endif


#else
   // The number of free 64-bit entries in the 10G Port 0 TX FIFO. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_FIFO_FREE_0_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_FIFO_FREE_0_CSR, *PTXP_FIFO_FREE_0_CSR;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_0_CSR, sizeof (TXP_FIFO_FREE_0_CSR) == 4);

   #else
      typedef struct _TXP_FIFO_FREE_0_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK TXP_FIFO_FREE_0_CSR, *PTXP_FIFO_FREE_0_CSR;

      typedef union _TXP_FIFO_FREE_0_CSR_UNION {
         TXP_FIFO_FREE_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_FIFO_FREE_0_CSR_UNION, *PTXP_FIFO_FREE_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_0_CSR_UNION, sizeof (TXP_FIFO_FREE_0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The number of free 64-bit entries in the 10G Port 1 TX FIFO. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_FIFO_FREE_1_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_FIFO_FREE_1_CSR, *PTXP_FIFO_FREE_1_CSR;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_1_CSR, sizeof (TXP_FIFO_FREE_1_CSR) == 4);

   #else
      typedef struct _TXP_FIFO_FREE_1_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK TXP_FIFO_FREE_1_CSR, *PTXP_FIFO_FREE_1_CSR;

      typedef union _TXP_FIFO_FREE_1_CSR_UNION {
         TXP_FIFO_FREE_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_FIFO_FREE_1_CSR_UNION, *PTXP_FIFO_FREE_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_1_CSR_UNION, sizeof (TXP_FIFO_FREE_1_CSR_UNION) == 4);
   #endif


#else
   // The number of free 64-bit entries in the 10G Port 1 TX FIFO. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_FIFO_FREE_1_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_FIFO_FREE_1_CSR, *PTXP_FIFO_FREE_1_CSR;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_1_CSR, sizeof (TXP_FIFO_FREE_1_CSR) == 4);

   #else
      typedef struct _TXP_FIFO_FREE_1_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK TXP_FIFO_FREE_1_CSR, *PTXP_FIFO_FREE_1_CSR;

      typedef union _TXP_FIFO_FREE_1_CSR_UNION {
         TXP_FIFO_FREE_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_FIFO_FREE_1_CSR_UNION, *PTXP_FIFO_FREE_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_FIFO_FREE_1_CSR_UNION, sizeof (TXP_FIFO_FREE_1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The TXP TPOST WRR registers define the round-robin weights used to service requests
   // from TPOST. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_TPOST_WRR_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 chute2_port1_weight : 4;       // DWORD 0
               u32 chute2_port0_weight : 4;       // DWORD 0
               u32 chute1_port1_weight : 4;       // DWORD 0
               u32 chute1_port0_weight : 4;       // DWORD 0
               u32 chute0_port1_weight : 4;       // DWORD 0
               u32 chute0_port0_weight : 4;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_TPOST_WRR_CSR, *PTXP_TPOST_WRR_CSR;

      SG_C_ASSERT(__sizeof__TXP_TPOST_WRR_CSR, sizeof (TXP_TPOST_WRR_CSR) == 4);

   #else
      typedef struct _TXP_TPOST_WRR_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 chute2_port1_weight : 4;             // DWORD 0
         u32 chute2_port0_weight : 4;             // DWORD 0
         u32 chute1_port1_weight : 4;             // DWORD 0
         u32 chute1_port0_weight : 4;             // DWORD 0
         u32 chute0_port1_weight : 4;             // DWORD 0
         u32 chute0_port0_weight : 4;             // DWORD 0
      } SG_PACK TXP_TPOST_WRR_CSR, *PTXP_TPOST_WRR_CSR;

      typedef union _TXP_TPOST_WRR_CSR_UNION {
         TXP_TPOST_WRR_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_TPOST_WRR_CSR_UNION, *PTXP_TPOST_WRR_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_TPOST_WRR_CSR_UNION, sizeof (TXP_TPOST_WRR_CSR_UNION) == 4);
   #endif


#else
   // The TXP TPOST WRR registers define the round-robin weights used to service requests
   // from TPOST. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_TPOST_WRR_CSR {
         union {
            struct { 
               u32 chute0_port0_weight : 4;       // DWORD 0
               u32 chute0_port1_weight : 4;       // DWORD 0
               u32 chute1_port0_weight : 4;       // DWORD 0
               u32 chute1_port1_weight : 4;       // DWORD 0
               u32 chute2_port0_weight : 4;       // DWORD 0
               u32 chute2_port1_weight : 4;       // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_TPOST_WRR_CSR, *PTXP_TPOST_WRR_CSR;

      SG_C_ASSERT(__sizeof__TXP_TPOST_WRR_CSR, sizeof (TXP_TPOST_WRR_CSR) == 4);

   #else
      typedef struct _TXP_TPOST_WRR_CSR {
         u32 chute0_port0_weight : 4;             // DWORD 0
         u32 chute0_port1_weight : 4;             // DWORD 0
         u32 chute1_port0_weight : 4;             // DWORD 0
         u32 chute1_port1_weight : 4;             // DWORD 0
         u32 chute2_port0_weight : 4;             // DWORD 0
         u32 chute2_port1_weight : 4;             // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXP_TPOST_WRR_CSR, *PTXP_TPOST_WRR_CSR;

      typedef union _TXP_TPOST_WRR_CSR_UNION {
         TXP_TPOST_WRR_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_TPOST_WRR_CSR_UNION, *PTXP_TPOST_WRR_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_TPOST_WRR_CSR_UNION, sizeof (TXP_TPOST_WRR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register programs the start address in CTX RAM where the iSCSI partial CRCs
   // (per connection) reside. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CRC_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CRC_START_ADDR_CSR, *PTXP_CRC_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__TXP_CRC_START_ADDR_CSR, sizeof (TXP_CRC_START_ADDR_CSR) == 4);

   #else
      typedef struct _TXP_CRC_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK TXP_CRC_START_ADDR_CSR, *PTXP_CRC_START_ADDR_CSR;

      typedef union _TXP_CRC_START_ADDR_CSR_UNION {
         TXP_CRC_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CRC_START_ADDR_CSR_UNION, *PTXP_CRC_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CRC_START_ADDR_CSR_UNION, sizeof (TXP_CRC_START_ADDR_CSR_UNION) == 4);
   #endif


#else
   // This register programs the start address in CTX RAM where the iSCSI partial CRCs
   // (per connection) reside. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CRC_START_ADDR_CSR {
         union {
            struct { 
               u32 addr;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CRC_START_ADDR_CSR, *PTXP_CRC_START_ADDR_CSR;

      SG_C_ASSERT(__sizeof__TXP_CRC_START_ADDR_CSR, sizeof (TXP_CRC_START_ADDR_CSR) == 4);

   #else
      typedef struct _TXP_CRC_START_ADDR_CSR {
         u32 addr;                                // DWORD 0
      } SG_PACK TXP_CRC_START_ADDR_CSR, *PTXP_CRC_START_ADDR_CSR;

      typedef union _TXP_CRC_START_ADDR_CSR_UNION {
         TXP_CRC_START_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CRC_START_ADDR_CSR_UNION, *PTXP_CRC_START_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CRC_START_ADDR_CSR_UNION, sizeof (TXP_CRC_START_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE0_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE0_CSR {
         union {
            struct { 
               u32 pup0_cksm_stage_underflow : 1; // DWORD 0
               u32 pup0_cksm_stage_overflow : 1;  // DWORD 0
               u32 txfifo1_underflow : 1;         // DWORD 0
               u32 txfifo1_overflow : 1;          // DWORD 0
               u32 txfifo0_underflow : 1;         // DWORD 0
               u32 txfifo0_overflow : 1;          // DWORD 0
               u32 rxpp_fifo_underflow : 1;       // DWORD 0
               u32 rxpp_fifo_overflow : 1;        // DWORD 0
               u32 mgmt_txfifo_underflow : 1;     // DWORD 0
               u32 mgmt_txfifo_overflow : 1;      // DWORD 0
               u32 descr_underflow_2_1 : 1;       // DWORD 0
               u32 descr_overflow_2_1 : 1;        // DWORD 0
               u32 descr_underflow_2_0 : 1;       // DWORD 0
               u32 descr_overflow_2_0 : 1;        // DWORD 0
               u32 descr_underflow_1_1 : 1;       // DWORD 0
               u32 descr_overflow_1_1 : 1;        // DWORD 0
               u32 descr_underflow_1_0 : 1;       // DWORD 0
               u32 descr_overflow_1_0 : 1;        // DWORD 0
               u32 descr_underflow_0_1 : 1;       // DWORD 0
               u32 descr_overflow_0_1 : 1;        // DWORD 0
               u32 descr_underflow_0_0 : 1;       // DWORD 0
               u32 descr_overflow_0_0 : 1;        // DWORD 0
               u32 pup1_hdr1_mem_perr : 1;        // DWORD 0
               u32 pup1_hdr0_mem_perr : 1;        // DWORD 0
               u32 pup0_hdr1_mem_perr : 1;        // DWORD 0
               u32 pup0_hdr0_mem_perr : 1;        // DWORD 0
               u32 rxpp_fifo_perr : 1;            // DWORD 0
               u32 mgmt_txfifo_perr : 1;          // DWORD 0
               u32 txfifo1_perr1 : 1;             // DWORD 0
               u32 txfifo1_perr0 : 1;             // DWORD 0
               u32 txfifo0_perr1 : 1;             // DWORD 0
               u32 txfifo0_perr0 : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE0_CSR, *PTXP_UE_CAUSE0_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE0_CSR, sizeof (TXP_UE_CAUSE0_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE0_CSR {
         u32 pup0_cksm_stage_underflow : 1;       // DWORD 0
         u32 pup0_cksm_stage_overflow : 1;        // DWORD 0
         u32 txfifo1_underflow : 1;               // DWORD 0
         u32 txfifo1_overflow : 1;                // DWORD 0
         u32 txfifo0_underflow : 1;               // DWORD 0
         u32 txfifo0_overflow : 1;                // DWORD 0
         u32 rxpp_fifo_underflow : 1;             // DWORD 0
         u32 rxpp_fifo_overflow : 1;              // DWORD 0
         u32 mgmt_txfifo_underflow : 1;           // DWORD 0
         u32 mgmt_txfifo_overflow : 1;            // DWORD 0
         u32 descr_underflow_2_1 : 1;             // DWORD 0
         u32 descr_overflow_2_1 : 1;              // DWORD 0
         u32 descr_underflow_2_0 : 1;             // DWORD 0
         u32 descr_overflow_2_0 : 1;              // DWORD 0
         u32 descr_underflow_1_1 : 1;             // DWORD 0
         u32 descr_overflow_1_1 : 1;              // DWORD 0
         u32 descr_underflow_1_0 : 1;             // DWORD 0
         u32 descr_overflow_1_0 : 1;              // DWORD 0
         u32 descr_underflow_0_1 : 1;             // DWORD 0
         u32 descr_overflow_0_1 : 1;              // DWORD 0
         u32 descr_underflow_0_0 : 1;             // DWORD 0
         u32 descr_overflow_0_0 : 1;              // DWORD 0
         u32 pup1_hdr1_mem_perr : 1;              // DWORD 0
         u32 pup1_hdr0_mem_perr : 1;              // DWORD 0
         u32 pup0_hdr1_mem_perr : 1;              // DWORD 0
         u32 pup0_hdr0_mem_perr : 1;              // DWORD 0
         u32 rxpp_fifo_perr : 1;                  // DWORD 0
         u32 mgmt_txfifo_perr : 1;                // DWORD 0
         u32 txfifo1_perr1 : 1;                   // DWORD 0
         u32 txfifo1_perr0 : 1;                   // DWORD 0
         u32 txfifo0_perr1 : 1;                   // DWORD 0
         u32 txfifo0_perr0 : 1;                   // DWORD 0
      } SG_PACK TXP_UE_CAUSE0_CSR, *PTXP_UE_CAUSE0_CSR;

      typedef union _TXP_UE_CAUSE0_CSR_UNION {
         TXP_UE_CAUSE0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE0_CSR_UNION, *PTXP_UE_CAUSE0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE0_CSR_UNION, sizeof (TXP_UE_CAUSE0_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE0_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE0_CSR {
         union {
            struct { 
               u32 txfifo0_perr0 : 1;             // DWORD 0
               u32 txfifo0_perr1 : 1;             // DWORD 0
               u32 txfifo1_perr0 : 1;             // DWORD 0
               u32 txfifo1_perr1 : 1;             // DWORD 0
               u32 mgmt_txfifo_perr : 1;          // DWORD 0
               u32 rxpp_fifo_perr : 1;            // DWORD 0
               u32 pup0_hdr0_mem_perr : 1;        // DWORD 0
               u32 pup0_hdr1_mem_perr : 1;        // DWORD 0
               u32 pup1_hdr0_mem_perr : 1;        // DWORD 0
               u32 pup1_hdr1_mem_perr : 1;        // DWORD 0
               u32 descr_overflow_0_0 : 1;        // DWORD 0
               u32 descr_underflow_0_0 : 1;       // DWORD 0
               u32 descr_overflow_0_1 : 1;        // DWORD 0
               u32 descr_underflow_0_1 : 1;       // DWORD 0
               u32 descr_overflow_1_0 : 1;        // DWORD 0
               u32 descr_underflow_1_0 : 1;       // DWORD 0
               u32 descr_overflow_1_1 : 1;        // DWORD 0
               u32 descr_underflow_1_1 : 1;       // DWORD 0
               u32 descr_overflow_2_0 : 1;        // DWORD 0
               u32 descr_underflow_2_0 : 1;       // DWORD 0
               u32 descr_overflow_2_1 : 1;        // DWORD 0
               u32 descr_underflow_2_1 : 1;       // DWORD 0
               u32 mgmt_txfifo_overflow : 1;      // DWORD 0
               u32 mgmt_txfifo_underflow : 1;     // DWORD 0
               u32 rxpp_fifo_overflow : 1;        // DWORD 0
               u32 rxpp_fifo_underflow : 1;       // DWORD 0
               u32 txfifo0_overflow : 1;          // DWORD 0
               u32 txfifo0_underflow : 1;         // DWORD 0
               u32 txfifo1_overflow : 1;          // DWORD 0
               u32 txfifo1_underflow : 1;         // DWORD 0
               u32 pup0_cksm_stage_overflow : 1;  // DWORD 0
               u32 pup0_cksm_stage_underflow : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE0_CSR, *PTXP_UE_CAUSE0_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE0_CSR, sizeof (TXP_UE_CAUSE0_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE0_CSR {
         u32 txfifo0_perr0 : 1;                   // DWORD 0
         u32 txfifo0_perr1 : 1;                   // DWORD 0
         u32 txfifo1_perr0 : 1;                   // DWORD 0
         u32 txfifo1_perr1 : 1;                   // DWORD 0
         u32 mgmt_txfifo_perr : 1;                // DWORD 0
         u32 rxpp_fifo_perr : 1;                  // DWORD 0
         u32 pup0_hdr0_mem_perr : 1;              // DWORD 0
         u32 pup0_hdr1_mem_perr : 1;              // DWORD 0
         u32 pup1_hdr0_mem_perr : 1;              // DWORD 0
         u32 pup1_hdr1_mem_perr : 1;              // DWORD 0
         u32 descr_overflow_0_0 : 1;              // DWORD 0
         u32 descr_underflow_0_0 : 1;             // DWORD 0
         u32 descr_overflow_0_1 : 1;              // DWORD 0
         u32 descr_underflow_0_1 : 1;             // DWORD 0
         u32 descr_overflow_1_0 : 1;              // DWORD 0
         u32 descr_underflow_1_0 : 1;             // DWORD 0
         u32 descr_overflow_1_1 : 1;              // DWORD 0
         u32 descr_underflow_1_1 : 1;             // DWORD 0
         u32 descr_overflow_2_0 : 1;              // DWORD 0
         u32 descr_underflow_2_0 : 1;             // DWORD 0
         u32 descr_overflow_2_1 : 1;              // DWORD 0
         u32 descr_underflow_2_1 : 1;             // DWORD 0
         u32 mgmt_txfifo_overflow : 1;            // DWORD 0
         u32 mgmt_txfifo_underflow : 1;           // DWORD 0
         u32 rxpp_fifo_overflow : 1;              // DWORD 0
         u32 rxpp_fifo_underflow : 1;             // DWORD 0
         u32 txfifo0_overflow : 1;                // DWORD 0
         u32 txfifo0_underflow : 1;               // DWORD 0
         u32 txfifo1_overflow : 1;                // DWORD 0
         u32 txfifo1_underflow : 1;               // DWORD 0
         u32 pup0_cksm_stage_overflow : 1;        // DWORD 0
         u32 pup0_cksm_stage_underflow : 1;       // DWORD 0
      } SG_PACK TXP_UE_CAUSE0_CSR, *PTXP_UE_CAUSE0_CSR;

      typedef union _TXP_UE_CAUSE0_CSR_UNION {
         TXP_UE_CAUSE0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE0_CSR_UNION, *PTXP_UE_CAUSE0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE0_CSR_UNION, sizeof (TXP_UE_CAUSE0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE1_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE1_CSR {
         union {
            struct { 
               u32 pup0_hdr1_stage_underflow : 1; // DWORD 0
               u32 pup0_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup0_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup0_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr0_rd_overflow : 1;     // DWORD 0
               u32 cev_req_underflow : 1;         // DWORD 0
               u32 cev_req_overflow : 1;          // DWORD 0
               u32 pup1_pyld_buf_underflow : 1;   // DWORD 0
               u32 pup1_pyld_buf_overflow : 1;    // DWORD 0
               u32 pup0_pyld_buf_underflow : 1;   // DWORD 0
               u32 pup0_pyld_buf_overflow : 1;    // DWORD 0
               u32 prep_req_underflow : 1;        // DWORD 0
               u32 prep_req_overflow : 1;         // DWORD 0
               u32 pup1_ret_req_underflow : 1;    // DWORD 0
               u32 pup1_ret_req_overflow : 1;     // DWORD 0
               u32 pup0_ret_req_underflow : 1;    // DWORD 0
               u32 pup0_ret_req_overflow : 1;     // DWORD 0
               u32 txp_desc_buf_free_underflow : 1; // DWORD 0
               u32 txp_desc_buf_free_overflow : 1; // DWORD 0
               u32 pup1_txpb_stage_underflow : 1; // DWORD 0
               u32 pup1_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup0_txpb_stage_underflow : 1; // DWORD 0
               u32 pup0_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup1_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup1_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup0_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup0_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup1_cksm_stage_underflow : 1; // DWORD 0
               u32 pup1_cksm_stage_overflow : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE1_CSR, *PTXP_UE_CAUSE1_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE1_CSR, sizeof (TXP_UE_CAUSE1_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE1_CSR {
         u32 pup0_hdr1_stage_underflow : 1;       // DWORD 0
         u32 pup0_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup0_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup0_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr0_rd_overflow : 1;           // DWORD 0
         u32 cev_req_underflow : 1;               // DWORD 0
         u32 cev_req_overflow : 1;                // DWORD 0
         u32 pup1_pyld_buf_underflow : 1;         // DWORD 0
         u32 pup1_pyld_buf_overflow : 1;          // DWORD 0
         u32 pup0_pyld_buf_underflow : 1;         // DWORD 0
         u32 pup0_pyld_buf_overflow : 1;          // DWORD 0
         u32 prep_req_underflow : 1;              // DWORD 0
         u32 prep_req_overflow : 1;               // DWORD 0
         u32 pup1_ret_req_underflow : 1;          // DWORD 0
         u32 pup1_ret_req_overflow : 1;           // DWORD 0
         u32 pup0_ret_req_underflow : 1;          // DWORD 0
         u32 pup0_ret_req_overflow : 1;           // DWORD 0
         u32 txp_desc_buf_free_underflow : 1;     // DWORD 0
         u32 txp_desc_buf_free_overflow : 1;      // DWORD 0
         u32 pup1_txpb_stage_underflow : 1;       // DWORD 0
         u32 pup1_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup0_txpb_stage_underflow : 1;       // DWORD 0
         u32 pup0_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup1_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup1_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup0_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup0_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup1_cksm_stage_underflow : 1;       // DWORD 0
         u32 pup1_cksm_stage_overflow : 1;        // DWORD 0
      } SG_PACK TXP_UE_CAUSE1_CSR, *PTXP_UE_CAUSE1_CSR;

      typedef union _TXP_UE_CAUSE1_CSR_UNION {
         TXP_UE_CAUSE1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE1_CSR_UNION, *PTXP_UE_CAUSE1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE1_CSR_UNION, sizeof (TXP_UE_CAUSE1_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE1_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE1_CSR {
         union {
            struct { 
               u32 pup1_cksm_stage_overflow : 1;  // DWORD 0
               u32 pup1_cksm_stage_underflow : 1; // DWORD 0
               u32 pup0_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup0_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup1_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup1_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup0_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup0_txpb_stage_underflow : 1; // DWORD 0
               u32 pup1_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup1_txpb_stage_underflow : 1; // DWORD 0
               u32 txp_desc_buf_free_overflow : 1; // DWORD 0
               u32 txp_desc_buf_free_underflow : 1; // DWORD 0
               u32 pup0_ret_req_overflow : 1;     // DWORD 0
               u32 pup0_ret_req_underflow : 1;    // DWORD 0
               u32 pup1_ret_req_overflow : 1;     // DWORD 0
               u32 pup1_ret_req_underflow : 1;    // DWORD 0
               u32 prep_req_overflow : 1;         // DWORD 0
               u32 prep_req_underflow : 1;        // DWORD 0
               u32 pup0_pyld_buf_overflow : 1;    // DWORD 0
               u32 pup0_pyld_buf_underflow : 1;   // DWORD 0
               u32 pup1_pyld_buf_overflow : 1;    // DWORD 0
               u32 pup1_pyld_buf_underflow : 1;   // DWORD 0
               u32 cev_req_overflow : 1;          // DWORD 0
               u32 cev_req_underflow : 1;         // DWORD 0
               u32 pup0_hdr0_rd_overflow : 1;     // DWORD 0
               u32 pup0_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup0_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup0_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr1_stage_underflow : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE1_CSR, *PTXP_UE_CAUSE1_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE1_CSR, sizeof (TXP_UE_CAUSE1_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE1_CSR {
         u32 pup1_cksm_stage_overflow : 1;        // DWORD 0
         u32 pup1_cksm_stage_underflow : 1;       // DWORD 0
         u32 pup0_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup0_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup1_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup1_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup0_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup0_txpb_stage_underflow : 1;       // DWORD 0
         u32 pup1_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup1_txpb_stage_underflow : 1;       // DWORD 0
         u32 txp_desc_buf_free_overflow : 1;      // DWORD 0
         u32 txp_desc_buf_free_underflow : 1;     // DWORD 0
         u32 pup0_ret_req_overflow : 1;           // DWORD 0
         u32 pup0_ret_req_underflow : 1;          // DWORD 0
         u32 pup1_ret_req_overflow : 1;           // DWORD 0
         u32 pup1_ret_req_underflow : 1;          // DWORD 0
         u32 prep_req_overflow : 1;               // DWORD 0
         u32 prep_req_underflow : 1;              // DWORD 0
         u32 pup0_pyld_buf_overflow : 1;          // DWORD 0
         u32 pup0_pyld_buf_underflow : 1;         // DWORD 0
         u32 pup1_pyld_buf_overflow : 1;          // DWORD 0
         u32 pup1_pyld_buf_underflow : 1;         // DWORD 0
         u32 cev_req_overflow : 1;                // DWORD 0
         u32 cev_req_underflow : 1;               // DWORD 0
         u32 pup0_hdr0_rd_overflow : 1;           // DWORD 0
         u32 pup0_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup0_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup0_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr1_stage_underflow : 1;       // DWORD 0
      } SG_PACK TXP_UE_CAUSE1_CSR, *PTXP_UE_CAUSE1_CSR;

      typedef union _TXP_UE_CAUSE1_CSR_UNION {
         TXP_UE_CAUSE1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE1_CSR_UNION, *PTXP_UE_CAUSE1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE1_CSR_UNION, sizeof (TXP_UE_CAUSE1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE2_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE2_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 port0_class4_underflow : 1;    // DWORD 0
               u32 port0_class4_overflow : 1;     // DWORD 0
               u32 port0_class3_underflow : 1;    // DWORD 0
               u32 port0_class3_overflow : 1;     // DWORD 0
               u32 port0_class2_underflow : 1;    // DWORD 0
               u32 port0_class2_overflow : 1;     // DWORD 0
               u32 port0_class1_underflow : 1;    // DWORD 0
               u32 port0_class1_overflow : 1;     // DWORD 0
               u32 port0_class0_underflow : 1;    // DWORD 0
               u32 port0_class0_overflow : 1;     // DWORD 0
               u32 dma_ret_underflow : 1;         // DWORD 0
               u32 dma_ret_overflow : 1;          // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 txpb_parity_ue1 : 1;           // DWORD 0
               u32 txpb_parity_ue0 : 1;           // DWORD 0
               u32 pup1_txpb_req_underflow : 1;   // DWORD 0
               u32 pup1_txpb_req_overflow : 1;    // DWORD 0
               u32 pup0_txpb_req_underflow : 1;   // DWORD 0
               u32 pup0_txpb_req_overflow : 1;    // DWORD 0
               u32 rxf_cam_underflow : 1;         // DWORD 0
               u32 rxf_cam_overflow : 1;          // DWORD 0
               u32 txips_hold_underflow : 1;      // DWORD 0
               u32 txips_hold_overflow : 1;       // DWORD 0
               u32 pup1_hdr1_stage_underflow : 1; // DWORD 0
               u32 pup1_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup1_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup1_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr0_rd_overflow : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE2_CSR, *PTXP_UE_CAUSE2_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE2_CSR, sizeof (TXP_UE_CAUSE2_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE2_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 port0_class4_underflow : 1;          // DWORD 0
         u32 port0_class4_overflow : 1;           // DWORD 0
         u32 port0_class3_underflow : 1;          // DWORD 0
         u32 port0_class3_overflow : 1;           // DWORD 0
         u32 port0_class2_underflow : 1;          // DWORD 0
         u32 port0_class2_overflow : 1;           // DWORD 0
         u32 port0_class1_underflow : 1;          // DWORD 0
         u32 port0_class1_overflow : 1;           // DWORD 0
         u32 port0_class0_underflow : 1;          // DWORD 0
         u32 port0_class0_overflow : 1;           // DWORD 0
         u32 dma_ret_underflow : 1;               // DWORD 0
         u32 dma_ret_overflow : 1;                // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 txpb_parity_ue1 : 1;                 // DWORD 0
         u32 txpb_parity_ue0 : 1;                 // DWORD 0
         u32 pup1_txpb_req_underflow : 1;         // DWORD 0
         u32 pup1_txpb_req_overflow : 1;          // DWORD 0
         u32 pup0_txpb_req_underflow : 1;         // DWORD 0
         u32 pup0_txpb_req_overflow : 1;          // DWORD 0
         u32 rxf_cam_underflow : 1;               // DWORD 0
         u32 rxf_cam_overflow : 1;                // DWORD 0
         u32 txips_hold_underflow : 1;            // DWORD 0
         u32 txips_hold_overflow : 1;             // DWORD 0
         u32 pup1_hdr1_stage_underflow : 1;       // DWORD 0
         u32 pup1_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup1_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup1_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr0_rd_overflow : 1;           // DWORD 0
      } SG_PACK TXP_UE_CAUSE2_CSR, *PTXP_UE_CAUSE2_CSR;

      typedef union _TXP_UE_CAUSE2_CSR_UNION {
         TXP_UE_CAUSE2_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE2_CSR_UNION, *PTXP_UE_CAUSE2_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE2_CSR_UNION, sizeof (TXP_UE_CAUSE2_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE2_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE2_CSR {
         union {
            struct { 
               u32 pup1_hdr0_rd_overflow : 1;     // DWORD 0
               u32 pup1_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup1_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup1_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr1_stage_underflow : 1; // DWORD 0
               u32 txips_hold_overflow : 1;       // DWORD 0
               u32 txips_hold_underflow : 1;      // DWORD 0
               u32 rxf_cam_overflow : 1;          // DWORD 0
               u32 rxf_cam_underflow : 1;         // DWORD 0
               u32 pup0_txpb_req_overflow : 1;    // DWORD 0
               u32 pup0_txpb_req_underflow : 1;   // DWORD 0
               u32 pup1_txpb_req_overflow : 1;    // DWORD 0
               u32 pup1_txpb_req_underflow : 1;   // DWORD 0
               u32 txpb_parity_ue0 : 1;           // DWORD 0
               u32 txpb_parity_ue1 : 1;           // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 dma_ret_overflow : 1;          // DWORD 0
               u32 dma_ret_underflow : 1;         // DWORD 0
               u32 port0_class0_overflow : 1;     // DWORD 0
               u32 port0_class0_underflow : 1;    // DWORD 0
               u32 port0_class1_overflow : 1;     // DWORD 0
               u32 port0_class1_underflow : 1;    // DWORD 0
               u32 port0_class2_overflow : 1;     // DWORD 0
               u32 port0_class2_underflow : 1;    // DWORD 0
               u32 port0_class3_overflow : 1;     // DWORD 0
               u32 port0_class3_underflow : 1;    // DWORD 0
               u32 port0_class4_overflow : 1;     // DWORD 0
               u32 port0_class4_underflow : 1;    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE2_CSR, *PTXP_UE_CAUSE2_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE2_CSR, sizeof (TXP_UE_CAUSE2_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE2_CSR {
         u32 pup1_hdr0_rd_overflow : 1;           // DWORD 0
         u32 pup1_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup1_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup1_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr1_stage_underflow : 1;       // DWORD 0
         u32 txips_hold_overflow : 1;             // DWORD 0
         u32 txips_hold_underflow : 1;            // DWORD 0
         u32 rxf_cam_overflow : 1;                // DWORD 0
         u32 rxf_cam_underflow : 1;               // DWORD 0
         u32 pup0_txpb_req_overflow : 1;          // DWORD 0
         u32 pup0_txpb_req_underflow : 1;         // DWORD 0
         u32 pup1_txpb_req_overflow : 1;          // DWORD 0
         u32 pup1_txpb_req_underflow : 1;         // DWORD 0
         u32 txpb_parity_ue0 : 1;                 // DWORD 0
         u32 txpb_parity_ue1 : 1;                 // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 dma_ret_overflow : 1;                // DWORD 0
         u32 dma_ret_underflow : 1;               // DWORD 0
         u32 port0_class0_overflow : 1;           // DWORD 0
         u32 port0_class0_underflow : 1;          // DWORD 0
         u32 port0_class1_overflow : 1;           // DWORD 0
         u32 port0_class1_underflow : 1;          // DWORD 0
         u32 port0_class2_overflow : 1;           // DWORD 0
         u32 port0_class2_underflow : 1;          // DWORD 0
         u32 port0_class3_overflow : 1;           // DWORD 0
         u32 port0_class3_underflow : 1;          // DWORD 0
         u32 port0_class4_overflow : 1;           // DWORD 0
         u32 port0_class4_underflow : 1;          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK TXP_UE_CAUSE2_CSR, *PTXP_UE_CAUSE2_CSR;

      typedef union _TXP_UE_CAUSE2_CSR_UNION {
         TXP_UE_CAUSE2_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE2_CSR_UNION, *PTXP_UE_CAUSE2_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE2_CSR_UNION, sizeof (TXP_UE_CAUSE2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE3_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE3_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 port1_class7_underflow : 1;    // DWORD 0
               u32 port1_class7_overflow : 1;     // DWORD 0
               u32 port1_class6_underflow : 1;    // DWORD 0
               u32 port1_class6_overflow : 1;     // DWORD 0
               u32 port1_class5_underflow : 1;    // DWORD 0
               u32 port1_class5_overflow : 1;     // DWORD 0
               u32 port1_class4_underflow : 1;    // DWORD 0
               u32 port1_class4_overflow : 1;     // DWORD 0
               u32 port1_class3_underflow : 1;    // DWORD 0
               u32 port1_class3_overflow : 1;     // DWORD 0
               u32 port1_class2_underflow : 1;    // DWORD 0
               u32 port1_class2_overflow : 1;     // DWORD 0
               u32 port1_class1_underflow : 1;    // DWORD 0
               u32 port1_class1_overflow : 1;     // DWORD 0
               u32 port1_class0_underflow : 1;    // DWORD 0
               u32 port1_class0_overflow : 1;     // DWORD 0
               u32 port0_class7_underflow : 1;    // DWORD 0
               u32 port0_class7_overflow : 1;     // DWORD 0
               u32 port0_class6_underflow : 1;    // DWORD 0
               u32 port0_class6_overflow : 1;     // DWORD 0
               u32 port0_class5_underflow : 1;    // DWORD 0
               u32 port0_class5_overflow : 1;     // DWORD 0
               u32 tx_mgmt_async_underflow : 1;   // DWORD 0
               u32 tx_mgmt_async_overflow : 1;    // DWORD 0
               u32 tx_10g_async_underflow1 : 1;   // DWORD 0
               u32 tx_10g_async_overflow1 : 1;    // DWORD 0
               u32 tx_10g_async_underflow0 : 1;   // DWORD 0
               u32 tx_10g_async_overflow0 : 1;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE3_CSR, *PTXP_UE_CAUSE3_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE3_CSR, sizeof (TXP_UE_CAUSE3_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE3_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 port1_class7_underflow : 1;          // DWORD 0
         u32 port1_class7_overflow : 1;           // DWORD 0
         u32 port1_class6_underflow : 1;          // DWORD 0
         u32 port1_class6_overflow : 1;           // DWORD 0
         u32 port1_class5_underflow : 1;          // DWORD 0
         u32 port1_class5_overflow : 1;           // DWORD 0
         u32 port1_class4_underflow : 1;          // DWORD 0
         u32 port1_class4_overflow : 1;           // DWORD 0
         u32 port1_class3_underflow : 1;          // DWORD 0
         u32 port1_class3_overflow : 1;           // DWORD 0
         u32 port1_class2_underflow : 1;          // DWORD 0
         u32 port1_class2_overflow : 1;           // DWORD 0
         u32 port1_class1_underflow : 1;          // DWORD 0
         u32 port1_class1_overflow : 1;           // DWORD 0
         u32 port1_class0_underflow : 1;          // DWORD 0
         u32 port1_class0_overflow : 1;           // DWORD 0
         u32 port0_class7_underflow : 1;          // DWORD 0
         u32 port0_class7_overflow : 1;           // DWORD 0
         u32 port0_class6_underflow : 1;          // DWORD 0
         u32 port0_class6_overflow : 1;           // DWORD 0
         u32 port0_class5_underflow : 1;          // DWORD 0
         u32 port0_class5_overflow : 1;           // DWORD 0
         u32 tx_mgmt_async_underflow : 1;         // DWORD 0
         u32 tx_mgmt_async_overflow : 1;          // DWORD 0
         u32 tx_10g_async_underflow1 : 1;         // DWORD 0
         u32 tx_10g_async_overflow1 : 1;          // DWORD 0
         u32 tx_10g_async_underflow0 : 1;         // DWORD 0
         u32 tx_10g_async_overflow0 : 1;          // DWORD 0
      } SG_PACK TXP_UE_CAUSE3_CSR, *PTXP_UE_CAUSE3_CSR;

      typedef union _TXP_UE_CAUSE3_CSR_UNION {
         TXP_UE_CAUSE3_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE3_CSR_UNION, *PTXP_UE_CAUSE3_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE3_CSR_UNION, sizeof (TXP_UE_CAUSE3_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE3_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE3_CSR {
         union {
            struct { 
               u32 tx_10g_async_overflow0 : 1;    // DWORD 0
               u32 tx_10g_async_underflow0 : 1;   // DWORD 0
               u32 tx_10g_async_overflow1 : 1;    // DWORD 0
               u32 tx_10g_async_underflow1 : 1;   // DWORD 0
               u32 tx_mgmt_async_overflow : 1;    // DWORD 0
               u32 tx_mgmt_async_underflow : 1;   // DWORD 0
               u32 port0_class5_overflow : 1;     // DWORD 0
               u32 port0_class5_underflow : 1;    // DWORD 0
               u32 port0_class6_overflow : 1;     // DWORD 0
               u32 port0_class6_underflow : 1;    // DWORD 0
               u32 port0_class7_overflow : 1;     // DWORD 0
               u32 port0_class7_underflow : 1;    // DWORD 0
               u32 port1_class0_overflow : 1;     // DWORD 0
               u32 port1_class0_underflow : 1;    // DWORD 0
               u32 port1_class1_overflow : 1;     // DWORD 0
               u32 port1_class1_underflow : 1;    // DWORD 0
               u32 port1_class2_overflow : 1;     // DWORD 0
               u32 port1_class2_underflow : 1;    // DWORD 0
               u32 port1_class3_overflow : 1;     // DWORD 0
               u32 port1_class3_underflow : 1;    // DWORD 0
               u32 port1_class4_overflow : 1;     // DWORD 0
               u32 port1_class4_underflow : 1;    // DWORD 0
               u32 port1_class5_overflow : 1;     // DWORD 0
               u32 port1_class5_underflow : 1;    // DWORD 0
               u32 port1_class6_overflow : 1;     // DWORD 0
               u32 port1_class6_underflow : 1;    // DWORD 0
               u32 port1_class7_overflow : 1;     // DWORD 0
               u32 port1_class7_underflow : 1;    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE3_CSR, *PTXP_UE_CAUSE3_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE3_CSR, sizeof (TXP_UE_CAUSE3_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE3_CSR {
         u32 tx_10g_async_overflow0 : 1;          // DWORD 0
         u32 tx_10g_async_underflow0 : 1;         // DWORD 0
         u32 tx_10g_async_overflow1 : 1;          // DWORD 0
         u32 tx_10g_async_underflow1 : 1;         // DWORD 0
         u32 tx_mgmt_async_overflow : 1;          // DWORD 0
         u32 tx_mgmt_async_underflow : 1;         // DWORD 0
         u32 port0_class5_overflow : 1;           // DWORD 0
         u32 port0_class5_underflow : 1;          // DWORD 0
         u32 port0_class6_overflow : 1;           // DWORD 0
         u32 port0_class6_underflow : 1;          // DWORD 0
         u32 port0_class7_overflow : 1;           // DWORD 0
         u32 port0_class7_underflow : 1;          // DWORD 0
         u32 port1_class0_overflow : 1;           // DWORD 0
         u32 port1_class0_underflow : 1;          // DWORD 0
         u32 port1_class1_overflow : 1;           // DWORD 0
         u32 port1_class1_underflow : 1;          // DWORD 0
         u32 port1_class2_overflow : 1;           // DWORD 0
         u32 port1_class2_underflow : 1;          // DWORD 0
         u32 port1_class3_overflow : 1;           // DWORD 0
         u32 port1_class3_underflow : 1;          // DWORD 0
         u32 port1_class4_overflow : 1;           // DWORD 0
         u32 port1_class4_underflow : 1;          // DWORD 0
         u32 port1_class5_overflow : 1;           // DWORD 0
         u32 port1_class5_underflow : 1;          // DWORD 0
         u32 port1_class6_overflow : 1;           // DWORD 0
         u32 port1_class6_underflow : 1;          // DWORD 0
         u32 port1_class7_overflow : 1;           // DWORD 0
         u32 port1_class7_underflow : 1;          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK TXP_UE_CAUSE3_CSR, *PTXP_UE_CAUSE3_CSR;

      typedef union _TXP_UE_CAUSE3_CSR_UNION {
         TXP_UE_CAUSE3_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE3_CSR_UNION, *PTXP_UE_CAUSE3_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE3_CSR_UNION, sizeof (TXP_UE_CAUSE3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE4_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE4_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 pup1_pup1_stage_underflow : 1; // DWORD 0
               u32 pup1_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup1_pup0_stage_underflow : 1; // DWORD 0
               u32 pup1_pup0_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup1_stage_underflow : 1; // DWORD 0
               u32 pup0_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup0_stage_underflow : 1; // DWORD 0
               u32 pup0_pup0_stage_overflow : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE4_CSR, *PTXP_UE_CAUSE4_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE4_CSR, sizeof (TXP_UE_CAUSE4_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE4_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 pup1_pup1_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup1_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup0_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup1_stage_underflow : 1;       // DWORD 0
         u32 pup0_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup0_pup0_stage_overflow : 1;        // DWORD 0
      } SG_PACK TXP_UE_CAUSE4_CSR, *PTXP_UE_CAUSE4_CSR;

      typedef union _TXP_UE_CAUSE4_CSR_UNION {
         TXP_UE_CAUSE4_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE4_CSR_UNION, *PTXP_UE_CAUSE4_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE4_CSR_UNION, sizeof (TXP_UE_CAUSE4_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Cause register. This a debug-only register, recording the
   // cause of Unrecoverable Error(s) that have occurred within TXP. The errors are
   // enabled (to be propagated to shut down the chip) via the TXP_UE_ENABLE4_CSR
   // register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_CAUSE4_CSR {
         union {
            struct { 
               u32 pup0_pup0_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup0_stage_underflow : 1; // DWORD 0
               u32 pup0_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup1_stage_underflow : 1; // DWORD 0
               u32 pup1_pup0_stage_overflow : 1;  // DWORD 0
               u32 pup1_pup0_stage_underflow : 1; // DWORD 0
               u32 pup1_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup1_pup1_stage_underflow : 1; // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_CAUSE4_CSR, *PTXP_UE_CAUSE4_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE4_CSR, sizeof (TXP_UE_CAUSE4_CSR) == 4);

   #else
      typedef struct _TXP_UE_CAUSE4_CSR {
         u32 pup0_pup0_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup0_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup1_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup0_stage_overflow : 1;        // DWORD 0
         u32 pup1_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup1_pup1_stage_underflow : 1;       // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK TXP_UE_CAUSE4_CSR, *PTXP_UE_CAUSE4_CSR;

      typedef union _TXP_UE_CAUSE4_CSR_UNION {
         TXP_UE_CAUSE4_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_CAUSE4_CSR_UNION, *PTXP_UE_CAUSE4_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_CAUSE4_CSR_UNION, sizeof (TXP_UE_CAUSE4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE0_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE0_CSR {
         union {
            struct { 
               u32 pup1_cksm_stage_underflow : 1; // DWORD 0
               u32 pup1_cksm_stage_overflow : 1;  // DWORD 0
               u32 pup0_cksm_stage_underflow : 1; // DWORD 0
               u32 pup0_cksm_stage_overflow : 1;  // DWORD 0
               u32 txfifo1_underflow : 1;         // DWORD 0
               u32 txfifo1_overflow : 1;          // DWORD 0
               u32 txfifo0_underflow : 1;         // DWORD 0
               u32 txfifo0_overflow : 1;          // DWORD 0
               u32 rxpp_fifo_underflow : 1;       // DWORD 0
               u32 rxpp_fifo_overflow : 1;        // DWORD 0
               u32 mgmt_txfifo_underflow : 1;     // DWORD 0
               u32 mgmt_txfifo_overflow : 1;      // DWORD 0
               u32 descr_underflow_2_1 : 1;       // DWORD 0
               u32 descr_overflow_2_1 : 1;        // DWORD 0
               u32 descr_underflow_2_0 : 1;       // DWORD 0
               u32 descr_overflow_2_0 : 1;        // DWORD 0
               u32 descr_underflow_1_1 : 1;       // DWORD 0
               u32 descr_overflow_1_1 : 1;        // DWORD 0
               u32 descr_underflow_1_0 : 1;       // DWORD 0
               u32 descr_overflow_1_0 : 1;        // DWORD 0
               u32 descr_underflow_0_1 : 1;       // DWORD 0
               u32 descr_overflow_0_1 : 1;        // DWORD 0
               u32 descr_underflow_0_0 : 1;       // DWORD 0
               u32 descr_overflow_0_0 : 1;        // DWORD 0
               u32 hdr1_mem_perr : 1;             // DWORD 0
               u32 hdr0_mem_perr : 1;             // DWORD 0
               u32 rxpp_fifo_perr : 1;            // DWORD 0
               u32 mgmt_txfifo_perr : 1;          // DWORD 0
               u32 txfifo1_perr1 : 1;             // DWORD 0
               u32 txfifo1_perr0 : 1;             // DWORD 0
               u32 txfifo0_perr1 : 1;             // DWORD 0
               u32 txfifo0_perr0 : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE0_CSR, *PTXP_UE_ENABLE0_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE0_CSR, sizeof (TXP_UE_ENABLE0_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE0_CSR {
         u32 pup1_cksm_stage_underflow : 1;       // DWORD 0
         u32 pup1_cksm_stage_overflow : 1;        // DWORD 0
         u32 pup0_cksm_stage_underflow : 1;       // DWORD 0
         u32 pup0_cksm_stage_overflow : 1;        // DWORD 0
         u32 txfifo1_underflow : 1;               // DWORD 0
         u32 txfifo1_overflow : 1;                // DWORD 0
         u32 txfifo0_underflow : 1;               // DWORD 0
         u32 txfifo0_overflow : 1;                // DWORD 0
         u32 rxpp_fifo_underflow : 1;             // DWORD 0
         u32 rxpp_fifo_overflow : 1;              // DWORD 0
         u32 mgmt_txfifo_underflow : 1;           // DWORD 0
         u32 mgmt_txfifo_overflow : 1;            // DWORD 0
         u32 descr_underflow_2_1 : 1;             // DWORD 0
         u32 descr_overflow_2_1 : 1;              // DWORD 0
         u32 descr_underflow_2_0 : 1;             // DWORD 0
         u32 descr_overflow_2_0 : 1;              // DWORD 0
         u32 descr_underflow_1_1 : 1;             // DWORD 0
         u32 descr_overflow_1_1 : 1;              // DWORD 0
         u32 descr_underflow_1_0 : 1;             // DWORD 0
         u32 descr_overflow_1_0 : 1;              // DWORD 0
         u32 descr_underflow_0_1 : 1;             // DWORD 0
         u32 descr_overflow_0_1 : 1;              // DWORD 0
         u32 descr_underflow_0_0 : 1;             // DWORD 0
         u32 descr_overflow_0_0 : 1;              // DWORD 0
         u32 hdr1_mem_perr : 1;                   // DWORD 0
         u32 hdr0_mem_perr : 1;                   // DWORD 0
         u32 rxpp_fifo_perr : 1;                  // DWORD 0
         u32 mgmt_txfifo_perr : 1;                // DWORD 0
         u32 txfifo1_perr1 : 1;                   // DWORD 0
         u32 txfifo1_perr0 : 1;                   // DWORD 0
         u32 txfifo0_perr1 : 1;                   // DWORD 0
         u32 txfifo0_perr0 : 1;                   // DWORD 0
      } SG_PACK TXP_UE_ENABLE0_CSR, *PTXP_UE_ENABLE0_CSR;

      typedef union _TXP_UE_ENABLE0_CSR_UNION {
         TXP_UE_ENABLE0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE0_CSR_UNION, *PTXP_UE_ENABLE0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE0_CSR_UNION, sizeof (TXP_UE_ENABLE0_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE0_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE0_CSR {
         union {
            struct { 
               u32 txfifo0_perr0 : 1;             // DWORD 0
               u32 txfifo0_perr1 : 1;             // DWORD 0
               u32 txfifo1_perr0 : 1;             // DWORD 0
               u32 txfifo1_perr1 : 1;             // DWORD 0
               u32 mgmt_txfifo_perr : 1;          // DWORD 0
               u32 rxpp_fifo_perr : 1;            // DWORD 0
               u32 hdr0_mem_perr : 1;             // DWORD 0
               u32 hdr1_mem_perr : 1;             // DWORD 0
               u32 descr_overflow_0_0 : 1;        // DWORD 0
               u32 descr_underflow_0_0 : 1;       // DWORD 0
               u32 descr_overflow_0_1 : 1;        // DWORD 0
               u32 descr_underflow_0_1 : 1;       // DWORD 0
               u32 descr_overflow_1_0 : 1;        // DWORD 0
               u32 descr_underflow_1_0 : 1;       // DWORD 0
               u32 descr_overflow_1_1 : 1;        // DWORD 0
               u32 descr_underflow_1_1 : 1;       // DWORD 0
               u32 descr_overflow_2_0 : 1;        // DWORD 0
               u32 descr_underflow_2_0 : 1;       // DWORD 0
               u32 descr_overflow_2_1 : 1;        // DWORD 0
               u32 descr_underflow_2_1 : 1;       // DWORD 0
               u32 mgmt_txfifo_overflow : 1;      // DWORD 0
               u32 mgmt_txfifo_underflow : 1;     // DWORD 0
               u32 rxpp_fifo_overflow : 1;        // DWORD 0
               u32 rxpp_fifo_underflow : 1;       // DWORD 0
               u32 txfifo0_overflow : 1;          // DWORD 0
               u32 txfifo0_underflow : 1;         // DWORD 0
               u32 txfifo1_overflow : 1;          // DWORD 0
               u32 txfifo1_underflow : 1;         // DWORD 0
               u32 pup0_cksm_stage_overflow : 1;  // DWORD 0
               u32 pup0_cksm_stage_underflow : 1; // DWORD 0
               u32 pup1_cksm_stage_overflow : 1;  // DWORD 0
               u32 pup1_cksm_stage_underflow : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE0_CSR, *PTXP_UE_ENABLE0_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE0_CSR, sizeof (TXP_UE_ENABLE0_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE0_CSR {
         u32 txfifo0_perr0 : 1;                   // DWORD 0
         u32 txfifo0_perr1 : 1;                   // DWORD 0
         u32 txfifo1_perr0 : 1;                   // DWORD 0
         u32 txfifo1_perr1 : 1;                   // DWORD 0
         u32 mgmt_txfifo_perr : 1;                // DWORD 0
         u32 rxpp_fifo_perr : 1;                  // DWORD 0
         u32 hdr0_mem_perr : 1;                   // DWORD 0
         u32 hdr1_mem_perr : 1;                   // DWORD 0
         u32 descr_overflow_0_0 : 1;              // DWORD 0
         u32 descr_underflow_0_0 : 1;             // DWORD 0
         u32 descr_overflow_0_1 : 1;              // DWORD 0
         u32 descr_underflow_0_1 : 1;             // DWORD 0
         u32 descr_overflow_1_0 : 1;              // DWORD 0
         u32 descr_underflow_1_0 : 1;             // DWORD 0
         u32 descr_overflow_1_1 : 1;              // DWORD 0
         u32 descr_underflow_1_1 : 1;             // DWORD 0
         u32 descr_overflow_2_0 : 1;              // DWORD 0
         u32 descr_underflow_2_0 : 1;             // DWORD 0
         u32 descr_overflow_2_1 : 1;              // DWORD 0
         u32 descr_underflow_2_1 : 1;             // DWORD 0
         u32 mgmt_txfifo_overflow : 1;            // DWORD 0
         u32 mgmt_txfifo_underflow : 1;           // DWORD 0
         u32 rxpp_fifo_overflow : 1;              // DWORD 0
         u32 rxpp_fifo_underflow : 1;             // DWORD 0
         u32 txfifo0_overflow : 1;                // DWORD 0
         u32 txfifo0_underflow : 1;               // DWORD 0
         u32 txfifo1_overflow : 1;                // DWORD 0
         u32 txfifo1_underflow : 1;               // DWORD 0
         u32 pup0_cksm_stage_overflow : 1;        // DWORD 0
         u32 pup0_cksm_stage_underflow : 1;       // DWORD 0
         u32 pup1_cksm_stage_overflow : 1;        // DWORD 0
         u32 pup1_cksm_stage_underflow : 1;       // DWORD 0
      } SG_PACK TXP_UE_ENABLE0_CSR, *PTXP_UE_ENABLE0_CSR;

      typedef union _TXP_UE_ENABLE0_CSR_UNION {
         TXP_UE_ENABLE0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE0_CSR_UNION, *PTXP_UE_ENABLE0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE0_CSR_UNION, sizeof (TXP_UE_ENABLE0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE1_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE1_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 pup0_hdr1_stage_underflow : 1; // DWORD 0
               u32 pup0_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup0_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup0_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr0_rd_overflow : 1;     // DWORD 0
               u32 cev_req_underflow : 1;         // DWORD 0
               u32 cev_req_overflow : 1;          // DWORD 0
               u32 pup1_pyld_buf_underflow : 1;   // DWORD 0
               u32 pup1_pyld_buf_overflow : 1;    // DWORD 0
               u32 pup0_pyld_buf_underflow : 1;   // DWORD 0
               u32 pup0_pyld_buf_overflow : 1;    // DWORD 0
               u32 prep_req_underflow : 1;        // DWORD 0
               u32 prep_req_overflow : 1;         // DWORD 0
               u32 pup1_ret_req_underflow : 1;    // DWORD 0
               u32 pup1_ret_req_overflow : 1;     // DWORD 0
               u32 pup0_ret_req_underflow : 1;    // DWORD 0
               u32 pup0_ret_req_overflow : 1;     // DWORD 0
               u32 txp_desc_buf_free_underflow : 1; // DWORD 0
               u32 txp_desc_buf_free_overflow : 1; // DWORD 0
               u32 pup1_txpb_stage_underflow : 1; // DWORD 0
               u32 pup1_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup0_txpb_stage_underflow : 1; // DWORD 0
               u32 pup0_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup1_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup1_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup0_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup0_txpb_hold_overflow : 1;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE1_CSR, *PTXP_UE_ENABLE1_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE1_CSR, sizeof (TXP_UE_ENABLE1_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE1_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 pup0_hdr1_stage_underflow : 1;       // DWORD 0
         u32 pup0_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup0_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup0_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr0_rd_overflow : 1;           // DWORD 0
         u32 cev_req_underflow : 1;               // DWORD 0
         u32 cev_req_overflow : 1;                // DWORD 0
         u32 pup1_pyld_buf_underflow : 1;         // DWORD 0
         u32 pup1_pyld_buf_overflow : 1;          // DWORD 0
         u32 pup0_pyld_buf_underflow : 1;         // DWORD 0
         u32 pup0_pyld_buf_overflow : 1;          // DWORD 0
         u32 prep_req_underflow : 1;              // DWORD 0
         u32 prep_req_overflow : 1;               // DWORD 0
         u32 pup1_ret_req_underflow : 1;          // DWORD 0
         u32 pup1_ret_req_overflow : 1;           // DWORD 0
         u32 pup0_ret_req_underflow : 1;          // DWORD 0
         u32 pup0_ret_req_overflow : 1;           // DWORD 0
         u32 txp_desc_buf_free_underflow : 1;     // DWORD 0
         u32 txp_desc_buf_free_overflow : 1;      // DWORD 0
         u32 pup1_txpb_stage_underflow : 1;       // DWORD 0
         u32 pup1_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup0_txpb_stage_underflow : 1;       // DWORD 0
         u32 pup0_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup1_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup1_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup0_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup0_txpb_hold_overflow : 1;         // DWORD 0
      } SG_PACK TXP_UE_ENABLE1_CSR, *PTXP_UE_ENABLE1_CSR;

      typedef union _TXP_UE_ENABLE1_CSR_UNION {
         TXP_UE_ENABLE1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE1_CSR_UNION, *PTXP_UE_ENABLE1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE1_CSR_UNION, sizeof (TXP_UE_ENABLE1_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE1_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE1_CSR {
         union {
            struct { 
               u32 pup0_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup0_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup1_txpb_hold_overflow : 1;   // DWORD 0
               u32 pup1_txpb_hold_underflow : 1;  // DWORD 0
               u32 pup0_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup0_txpb_stage_underflow : 1; // DWORD 0
               u32 pup1_txpb_stage_overflow : 1;  // DWORD 0
               u32 pup1_txpb_stage_underflow : 1; // DWORD 0
               u32 txp_desc_buf_free_overflow : 1; // DWORD 0
               u32 txp_desc_buf_free_underflow : 1; // DWORD 0
               u32 pup0_ret_req_overflow : 1;     // DWORD 0
               u32 pup0_ret_req_underflow : 1;    // DWORD 0
               u32 pup1_ret_req_overflow : 1;     // DWORD 0
               u32 pup1_ret_req_underflow : 1;    // DWORD 0
               u32 prep_req_overflow : 1;         // DWORD 0
               u32 prep_req_underflow : 1;        // DWORD 0
               u32 pup0_pyld_buf_overflow : 1;    // DWORD 0
               u32 pup0_pyld_buf_underflow : 1;   // DWORD 0
               u32 pup1_pyld_buf_overflow : 1;    // DWORD 0
               u32 pup1_pyld_buf_underflow : 1;   // DWORD 0
               u32 cev_req_overflow : 1;          // DWORD 0
               u32 cev_req_underflow : 1;         // DWORD 0
               u32 pup0_hdr0_rd_overflow : 1;     // DWORD 0
               u32 pup0_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup0_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup0_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup0_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup0_hdr1_stage_underflow : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE1_CSR, *PTXP_UE_ENABLE1_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE1_CSR, sizeof (TXP_UE_ENABLE1_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE1_CSR {
         u32 pup0_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup0_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup1_txpb_hold_overflow : 1;         // DWORD 0
         u32 pup1_txpb_hold_underflow : 1;        // DWORD 0
         u32 pup0_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup0_txpb_stage_underflow : 1;       // DWORD 0
         u32 pup1_txpb_stage_overflow : 1;        // DWORD 0
         u32 pup1_txpb_stage_underflow : 1;       // DWORD 0
         u32 txp_desc_buf_free_overflow : 1;      // DWORD 0
         u32 txp_desc_buf_free_underflow : 1;     // DWORD 0
         u32 pup0_ret_req_overflow : 1;           // DWORD 0
         u32 pup0_ret_req_underflow : 1;          // DWORD 0
         u32 pup1_ret_req_overflow : 1;           // DWORD 0
         u32 pup1_ret_req_underflow : 1;          // DWORD 0
         u32 prep_req_overflow : 1;               // DWORD 0
         u32 prep_req_underflow : 1;              // DWORD 0
         u32 pup0_pyld_buf_overflow : 1;          // DWORD 0
         u32 pup0_pyld_buf_underflow : 1;         // DWORD 0
         u32 pup1_pyld_buf_overflow : 1;          // DWORD 0
         u32 pup1_pyld_buf_underflow : 1;         // DWORD 0
         u32 cev_req_overflow : 1;                // DWORD 0
         u32 cev_req_underflow : 1;               // DWORD 0
         u32 pup0_hdr0_rd_overflow : 1;           // DWORD 0
         u32 pup0_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup0_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup0_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup0_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup0_hdr1_stage_underflow : 1;       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK TXP_UE_ENABLE1_CSR, *PTXP_UE_ENABLE1_CSR;

      typedef union _TXP_UE_ENABLE1_CSR_UNION {
         TXP_UE_ENABLE1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE1_CSR_UNION, *PTXP_UE_ENABLE1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE1_CSR_UNION, sizeof (TXP_UE_ENABLE1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE2_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE2_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 port0_class4_underflow : 1;    // DWORD 0
               u32 port0_class4_overflow : 1;     // DWORD 0
               u32 port0_class3_underflow : 1;    // DWORD 0
               u32 port0_class3_overflow : 1;     // DWORD 0
               u32 port0_class2_underflow : 1;    // DWORD 0
               u32 port0_class2_overflow : 1;     // DWORD 0
               u32 port0_class1_underflow : 1;    // DWORD 0
               u32 port0_class1_overflow : 1;     // DWORD 0
               u32 port0_class0_underflow : 1;    // DWORD 0
               u32 port0_class0_overflow : 1;     // DWORD 0
               u32 dma_ret_underflow : 1;         // DWORD 0
               u32 dma_ret_overflow : 1;          // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 txpb_parity_ue1 : 1;           // DWORD 0
               u32 txpb_parity_ue0 : 1;           // DWORD 0
               u32 pup1_txpb_req_underflow : 1;   // DWORD 0
               u32 pup1_txpb_req_overflow : 1;    // DWORD 0
               u32 pup0_txpb_req_underflow : 1;   // DWORD 0
               u32 pup0_txpb_req_overflow : 1;    // DWORD 0
               u32 rxf_valid_underflow : 1;       // DWORD 0
               u32 rxf_valid_overflow : 1;        // DWORD 0
               u32 txips_hold_underflow : 1;      // DWORD 0
               u32 txips_hold_overflow : 1;       // DWORD 0
               u32 pup1_hdr1_stage_underflow : 1; // DWORD 0
               u32 pup1_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup1_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup1_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr0_rd_overflow : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE2_CSR, *PTXP_UE_ENABLE2_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE2_CSR, sizeof (TXP_UE_ENABLE2_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE2_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 port0_class4_underflow : 1;          // DWORD 0
         u32 port0_class4_overflow : 1;           // DWORD 0
         u32 port0_class3_underflow : 1;          // DWORD 0
         u32 port0_class3_overflow : 1;           // DWORD 0
         u32 port0_class2_underflow : 1;          // DWORD 0
         u32 port0_class2_overflow : 1;           // DWORD 0
         u32 port0_class1_underflow : 1;          // DWORD 0
         u32 port0_class1_overflow : 1;           // DWORD 0
         u32 port0_class0_underflow : 1;          // DWORD 0
         u32 port0_class0_overflow : 1;           // DWORD 0
         u32 dma_ret_underflow : 1;               // DWORD 0
         u32 dma_ret_overflow : 1;                // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 txpb_parity_ue1 : 1;                 // DWORD 0
         u32 txpb_parity_ue0 : 1;                 // DWORD 0
         u32 pup1_txpb_req_underflow : 1;         // DWORD 0
         u32 pup1_txpb_req_overflow : 1;          // DWORD 0
         u32 pup0_txpb_req_underflow : 1;         // DWORD 0
         u32 pup0_txpb_req_overflow : 1;          // DWORD 0
         u32 rxf_valid_underflow : 1;             // DWORD 0
         u32 rxf_valid_overflow : 1;              // DWORD 0
         u32 txips_hold_underflow : 1;            // DWORD 0
         u32 txips_hold_overflow : 1;             // DWORD 0
         u32 pup1_hdr1_stage_underflow : 1;       // DWORD 0
         u32 pup1_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup1_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup1_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr0_rd_overflow : 1;           // DWORD 0
      } SG_PACK TXP_UE_ENABLE2_CSR, *PTXP_UE_ENABLE2_CSR;

      typedef union _TXP_UE_ENABLE2_CSR_UNION {
         TXP_UE_ENABLE2_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE2_CSR_UNION, *PTXP_UE_ENABLE2_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE2_CSR_UNION, sizeof (TXP_UE_ENABLE2_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE2_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE2_CSR {
         union {
            struct { 
               u32 pup1_hdr0_rd_overflow : 1;     // DWORD 0
               u32 pup1_hdr0_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr1_rd_overflow : 1;     // DWORD 0
               u32 pup1_hdr1_rd_underflow : 1;    // DWORD 0
               u32 pup1_hdr0_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr0_stage_underflow : 1; // DWORD 0
               u32 pup1_hdr1_stage_overflow : 1;  // DWORD 0
               u32 pup1_hdr1_stage_underflow : 1; // DWORD 0
               u32 txips_hold_overflow : 1;       // DWORD 0
               u32 txips_hold_underflow : 1;      // DWORD 0
               u32 rxf_valid_overflow : 1;        // DWORD 0
               u32 rxf_valid_underflow : 1;       // DWORD 0
               u32 pup0_txpb_req_overflow : 1;    // DWORD 0
               u32 pup0_txpb_req_underflow : 1;   // DWORD 0
               u32 pup1_txpb_req_overflow : 1;    // DWORD 0
               u32 pup1_txpb_req_underflow : 1;   // DWORD 0
               u32 txpb_parity_ue0 : 1;           // DWORD 0
               u32 txpb_parity_ue1 : 1;           // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 dma_ret_overflow : 1;          // DWORD 0
               u32 dma_ret_underflow : 1;         // DWORD 0
               u32 port0_class0_overflow : 1;     // DWORD 0
               u32 port0_class0_underflow : 1;    // DWORD 0
               u32 port0_class1_overflow : 1;     // DWORD 0
               u32 port0_class1_underflow : 1;    // DWORD 0
               u32 port0_class2_overflow : 1;     // DWORD 0
               u32 port0_class2_underflow : 1;    // DWORD 0
               u32 port0_class3_overflow : 1;     // DWORD 0
               u32 port0_class3_underflow : 1;    // DWORD 0
               u32 port0_class4_overflow : 1;     // DWORD 0
               u32 port0_class4_underflow : 1;    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE2_CSR, *PTXP_UE_ENABLE2_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE2_CSR, sizeof (TXP_UE_ENABLE2_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE2_CSR {
         u32 pup1_hdr0_rd_overflow : 1;           // DWORD 0
         u32 pup1_hdr0_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr1_rd_overflow : 1;           // DWORD 0
         u32 pup1_hdr1_rd_underflow : 1;          // DWORD 0
         u32 pup1_hdr0_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr0_stage_underflow : 1;       // DWORD 0
         u32 pup1_hdr1_stage_overflow : 1;        // DWORD 0
         u32 pup1_hdr1_stage_underflow : 1;       // DWORD 0
         u32 txips_hold_overflow : 1;             // DWORD 0
         u32 txips_hold_underflow : 1;            // DWORD 0
         u32 rxf_valid_overflow : 1;              // DWORD 0
         u32 rxf_valid_underflow : 1;             // DWORD 0
         u32 pup0_txpb_req_overflow : 1;          // DWORD 0
         u32 pup0_txpb_req_underflow : 1;         // DWORD 0
         u32 pup1_txpb_req_overflow : 1;          // DWORD 0
         u32 pup1_txpb_req_underflow : 1;         // DWORD 0
         u32 txpb_parity_ue0 : 1;                 // DWORD 0
         u32 txpb_parity_ue1 : 1;                 // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 dma_ret_overflow : 1;                // DWORD 0
         u32 dma_ret_underflow : 1;               // DWORD 0
         u32 port0_class0_overflow : 1;           // DWORD 0
         u32 port0_class0_underflow : 1;          // DWORD 0
         u32 port0_class1_overflow : 1;           // DWORD 0
         u32 port0_class1_underflow : 1;          // DWORD 0
         u32 port0_class2_overflow : 1;           // DWORD 0
         u32 port0_class2_underflow : 1;          // DWORD 0
         u32 port0_class3_overflow : 1;           // DWORD 0
         u32 port0_class3_underflow : 1;          // DWORD 0
         u32 port0_class4_overflow : 1;           // DWORD 0
         u32 port0_class4_underflow : 1;          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK TXP_UE_ENABLE2_CSR, *PTXP_UE_ENABLE2_CSR;

      typedef union _TXP_UE_ENABLE2_CSR_UNION {
         TXP_UE_ENABLE2_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE2_CSR_UNION, *PTXP_UE_ENABLE2_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE2_CSR_UNION, sizeof (TXP_UE_ENABLE2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE3_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE3_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 port1_class7_underflow : 1;    // DWORD 0
               u32 port1_class7_overflow : 1;     // DWORD 0
               u32 port1_class6_underflow : 1;    // DWORD 0
               u32 port1_class6_overflow : 1;     // DWORD 0
               u32 port1_class5_underflow : 1;    // DWORD 0
               u32 port1_class5_overflow : 1;     // DWORD 0
               u32 port1_class4_underflow : 1;    // DWORD 0
               u32 port1_class4_overflow : 1;     // DWORD 0
               u32 port1_class3_underflow : 1;    // DWORD 0
               u32 port1_class3_overflow : 1;     // DWORD 0
               u32 port1_class2_underflow : 1;    // DWORD 0
               u32 port1_class2_overflow : 1;     // DWORD 0
               u32 port1_class1_underflow : 1;    // DWORD 0
               u32 port1_class1_overflow : 1;     // DWORD 0
               u32 port1_class0_underflow : 1;    // DWORD 0
               u32 port1_class0_overflow : 1;     // DWORD 0
               u32 port0_class7_underflow : 1;    // DWORD 0
               u32 port0_class7_overflow : 1;     // DWORD 0
               u32 port0_class6_underflow : 1;    // DWORD 0
               u32 port0_class6_overflow : 1;     // DWORD 0
               u32 port0_class5_underflow : 1;    // DWORD 0
               u32 port0_class5_overflow : 1;     // DWORD 0
               u32 tx_mgmt_async_underflow : 1;   // DWORD 0
               u32 tx_mgmt_async_overflow : 1;    // DWORD 0
               u32 tx_10g_async_underflow1 : 1;   // DWORD 0
               u32 tx_10g_async_overflow1 : 1;    // DWORD 0
               u32 tx_10g_async_underflow0 : 1;   // DWORD 0
               u32 tx_10g_async_overflow0 : 1;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE3_CSR, *PTXP_UE_ENABLE3_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE3_CSR, sizeof (TXP_UE_ENABLE3_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE3_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 port1_class7_underflow : 1;          // DWORD 0
         u32 port1_class7_overflow : 1;           // DWORD 0
         u32 port1_class6_underflow : 1;          // DWORD 0
         u32 port1_class6_overflow : 1;           // DWORD 0
         u32 port1_class5_underflow : 1;          // DWORD 0
         u32 port1_class5_overflow : 1;           // DWORD 0
         u32 port1_class4_underflow : 1;          // DWORD 0
         u32 port1_class4_overflow : 1;           // DWORD 0
         u32 port1_class3_underflow : 1;          // DWORD 0
         u32 port1_class3_overflow : 1;           // DWORD 0
         u32 port1_class2_underflow : 1;          // DWORD 0
         u32 port1_class2_overflow : 1;           // DWORD 0
         u32 port1_class1_underflow : 1;          // DWORD 0
         u32 port1_class1_overflow : 1;           // DWORD 0
         u32 port1_class0_underflow : 1;          // DWORD 0
         u32 port1_class0_overflow : 1;           // DWORD 0
         u32 port0_class7_underflow : 1;          // DWORD 0
         u32 port0_class7_overflow : 1;           // DWORD 0
         u32 port0_class6_underflow : 1;          // DWORD 0
         u32 port0_class6_overflow : 1;           // DWORD 0
         u32 port0_class5_underflow : 1;          // DWORD 0
         u32 port0_class5_overflow : 1;           // DWORD 0
         u32 tx_mgmt_async_underflow : 1;         // DWORD 0
         u32 tx_mgmt_async_overflow : 1;          // DWORD 0
         u32 tx_10g_async_underflow1 : 1;         // DWORD 0
         u32 tx_10g_async_overflow1 : 1;          // DWORD 0
         u32 tx_10g_async_underflow0 : 1;         // DWORD 0
         u32 tx_10g_async_overflow0 : 1;          // DWORD 0
      } SG_PACK TXP_UE_ENABLE3_CSR, *PTXP_UE_ENABLE3_CSR;

      typedef union _TXP_UE_ENABLE3_CSR_UNION {
         TXP_UE_ENABLE3_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE3_CSR_UNION, *PTXP_UE_ENABLE3_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE3_CSR_UNION, sizeof (TXP_UE_ENABLE3_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE3_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE3_CSR {
         union {
            struct { 
               u32 tx_10g_async_overflow0 : 1;    // DWORD 0
               u32 tx_10g_async_underflow0 : 1;   // DWORD 0
               u32 tx_10g_async_overflow1 : 1;    // DWORD 0
               u32 tx_10g_async_underflow1 : 1;   // DWORD 0
               u32 tx_mgmt_async_overflow : 1;    // DWORD 0
               u32 tx_mgmt_async_underflow : 1;   // DWORD 0
               u32 port0_class5_overflow : 1;     // DWORD 0
               u32 port0_class5_underflow : 1;    // DWORD 0
               u32 port0_class6_overflow : 1;     // DWORD 0
               u32 port0_class6_underflow : 1;    // DWORD 0
               u32 port0_class7_overflow : 1;     // DWORD 0
               u32 port0_class7_underflow : 1;    // DWORD 0
               u32 port1_class0_overflow : 1;     // DWORD 0
               u32 port1_class0_underflow : 1;    // DWORD 0
               u32 port1_class1_overflow : 1;     // DWORD 0
               u32 port1_class1_underflow : 1;    // DWORD 0
               u32 port1_class2_overflow : 1;     // DWORD 0
               u32 port1_class2_underflow : 1;    // DWORD 0
               u32 port1_class3_overflow : 1;     // DWORD 0
               u32 port1_class3_underflow : 1;    // DWORD 0
               u32 port1_class4_overflow : 1;     // DWORD 0
               u32 port1_class4_underflow : 1;    // DWORD 0
               u32 port1_class5_overflow : 1;     // DWORD 0
               u32 port1_class5_underflow : 1;    // DWORD 0
               u32 port1_class6_overflow : 1;     // DWORD 0
               u32 port1_class6_underflow : 1;    // DWORD 0
               u32 port1_class7_overflow : 1;     // DWORD 0
               u32 port1_class7_underflow : 1;    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE3_CSR, *PTXP_UE_ENABLE3_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE3_CSR, sizeof (TXP_UE_ENABLE3_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE3_CSR {
         u32 tx_10g_async_overflow0 : 1;          // DWORD 0
         u32 tx_10g_async_underflow0 : 1;         // DWORD 0
         u32 tx_10g_async_overflow1 : 1;          // DWORD 0
         u32 tx_10g_async_underflow1 : 1;         // DWORD 0
         u32 tx_mgmt_async_overflow : 1;          // DWORD 0
         u32 tx_mgmt_async_underflow : 1;         // DWORD 0
         u32 port0_class5_overflow : 1;           // DWORD 0
         u32 port0_class5_underflow : 1;          // DWORD 0
         u32 port0_class6_overflow : 1;           // DWORD 0
         u32 port0_class6_underflow : 1;          // DWORD 0
         u32 port0_class7_overflow : 1;           // DWORD 0
         u32 port0_class7_underflow : 1;          // DWORD 0
         u32 port1_class0_overflow : 1;           // DWORD 0
         u32 port1_class0_underflow : 1;          // DWORD 0
         u32 port1_class1_overflow : 1;           // DWORD 0
         u32 port1_class1_underflow : 1;          // DWORD 0
         u32 port1_class2_overflow : 1;           // DWORD 0
         u32 port1_class2_underflow : 1;          // DWORD 0
         u32 port1_class3_overflow : 1;           // DWORD 0
         u32 port1_class3_underflow : 1;          // DWORD 0
         u32 port1_class4_overflow : 1;           // DWORD 0
         u32 port1_class4_underflow : 1;          // DWORD 0
         u32 port1_class5_overflow : 1;           // DWORD 0
         u32 port1_class5_underflow : 1;          // DWORD 0
         u32 port1_class6_overflow : 1;           // DWORD 0
         u32 port1_class6_underflow : 1;          // DWORD 0
         u32 port1_class7_overflow : 1;           // DWORD 0
         u32 port1_class7_underflow : 1;          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK TXP_UE_ENABLE3_CSR, *PTXP_UE_ENABLE3_CSR;

      typedef union _TXP_UE_ENABLE3_CSR_UNION {
         TXP_UE_ENABLE3_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE3_CSR_UNION, *PTXP_UE_ENABLE3_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE3_CSR_UNION, sizeof (TXP_UE_ENABLE3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE4_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE4_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 pup1_pup1_stage_underflow : 1; // DWORD 0
               u32 pup1_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup1_pup0_stage_underflow : 1; // DWORD 0
               u32 pup1_pup0_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup1_stage_underflow : 1; // DWORD 0
               u32 pup0_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup0_stage_underflow : 1; // DWORD 0
               u32 pup0_pup0_stage_overflow : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE4_CSR, *PTXP_UE_ENABLE4_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE4_CSR, sizeof (TXP_UE_ENABLE4_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE4_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 pup1_pup1_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup1_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup0_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup1_stage_underflow : 1;       // DWORD 0
         u32 pup0_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup0_pup0_stage_overflow : 1;        // DWORD 0
      } SG_PACK TXP_UE_ENABLE4_CSR, *PTXP_UE_ENABLE4_CSR;

      typedef union _TXP_UE_ENABLE4_CSR_UNION {
         TXP_UE_ENABLE4_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE4_CSR_UNION, *PTXP_UE_ENABLE4_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE4_CSR_UNION, sizeof (TXP_UE_ENABLE4_CSR_UNION) == 4);
   #endif


#else
   // TXP Unrecoverable Error Enable register. This a debug-only register, enabling
   // reporting of individual Unrecoverable Errors out of TXP. The errors are reported in
   // the TXP_UE_CAUSE4_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_UE_ENABLE4_CSR {
         union {
            struct { 
               u32 pup0_pup0_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup0_stage_underflow : 1; // DWORD 0
               u32 pup0_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup0_pup1_stage_underflow : 1; // DWORD 0
               u32 pup1_pup0_stage_overflow : 1;  // DWORD 0
               u32 pup1_pup0_stage_underflow : 1; // DWORD 0
               u32 pup1_pup1_stage_overflow : 1;  // DWORD 0
               u32 pup1_pup1_stage_underflow : 1; // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_UE_ENABLE4_CSR, *PTXP_UE_ENABLE4_CSR;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE4_CSR, sizeof (TXP_UE_ENABLE4_CSR) == 4);

   #else
      typedef struct _TXP_UE_ENABLE4_CSR {
         u32 pup0_pup0_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup0_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup0_pup1_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup0_stage_overflow : 1;        // DWORD 0
         u32 pup1_pup0_stage_underflow : 1;       // DWORD 0
         u32 pup1_pup1_stage_overflow : 1;        // DWORD 0
         u32 pup1_pup1_stage_underflow : 1;       // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK TXP_UE_ENABLE4_CSR, *PTXP_UE_ENABLE4_CSR;

      typedef union _TXP_UE_ENABLE4_CSR_UNION {
         TXP_UE_ENABLE4_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_UE_ENABLE4_CSR_UNION, *PTXP_UE_ENABLE4_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_UE_ENABLE4_CSR_UNION, sizeof (TXP_UE_ENABLE4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 0, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT0_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT0_DEQUEUE_CSR, *PTXP_CHUTE0_PORT0_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_DEQUEUE_CSR, sizeof (TXP_CHUTE0_PORT0_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT0_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT0_DEQUEUE_CSR, *PTXP_CHUTE0_PORT0_DEQUEUE_CSR;

      typedef union _TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION {
         TXP_CHUTE0_PORT0_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION, *PTXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 0, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT0_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT0_DEQUEUE_CSR, *PTXP_CHUTE0_PORT0_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_DEQUEUE_CSR, sizeof (TXP_CHUTE0_PORT0_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT0_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT0_DEQUEUE_CSR, *PTXP_CHUTE0_PORT0_DEQUEUE_CSR;

      typedef union _TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION {
         TXP_CHUTE0_PORT0_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION, *PTXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE0_PORT0_DEQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 0, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT1_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT1_DEQUEUE_CSR, *PTXP_CHUTE0_PORT1_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_DEQUEUE_CSR, sizeof (TXP_CHUTE0_PORT1_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT1_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT1_DEQUEUE_CSR, *PTXP_CHUTE0_PORT1_DEQUEUE_CSR;

      typedef union _TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION {
         TXP_CHUTE0_PORT1_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION, *PTXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 0, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT1_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT1_DEQUEUE_CSR, *PTXP_CHUTE0_PORT1_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_DEQUEUE_CSR, sizeof (TXP_CHUTE0_PORT1_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT1_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT1_DEQUEUE_CSR, *PTXP_CHUTE0_PORT1_DEQUEUE_CSR;

      typedef union _TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION {
         TXP_CHUTE0_PORT1_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION, *PTXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE0_PORT1_DEQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 1, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT0_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT0_DEQUEUE_CSR, *PTXP_CHUTE1_PORT0_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_DEQUEUE_CSR, sizeof (TXP_CHUTE1_PORT0_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT0_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT0_DEQUEUE_CSR, *PTXP_CHUTE1_PORT0_DEQUEUE_CSR;

      typedef union _TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION {
         TXP_CHUTE1_PORT0_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION, *PTXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 1, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT0_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT0_DEQUEUE_CSR, *PTXP_CHUTE1_PORT0_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_DEQUEUE_CSR, sizeof (TXP_CHUTE1_PORT0_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT0_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT0_DEQUEUE_CSR, *PTXP_CHUTE1_PORT0_DEQUEUE_CSR;

      typedef union _TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION {
         TXP_CHUTE1_PORT0_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION, *PTXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE1_PORT0_DEQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 1, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT1_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT1_DEQUEUE_CSR, *PTXP_CHUTE1_PORT1_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_DEQUEUE_CSR, sizeof (TXP_CHUTE1_PORT1_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT1_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT1_DEQUEUE_CSR, *PTXP_CHUTE1_PORT1_DEQUEUE_CSR;

      typedef union _TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION {
         TXP_CHUTE1_PORT1_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION, *PTXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 1, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT1_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT1_DEQUEUE_CSR, *PTXP_CHUTE1_PORT1_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_DEQUEUE_CSR, sizeof (TXP_CHUTE1_PORT1_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT1_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT1_DEQUEUE_CSR, *PTXP_CHUTE1_PORT1_DEQUEUE_CSR;

      typedef union _TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION {
         TXP_CHUTE1_PORT1_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION, *PTXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE1_PORT1_DEQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 2, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT0_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT0_DEQUEUE_CSR, *PTXP_CHUTE2_PORT0_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_DEQUEUE_CSR, sizeof (TXP_CHUTE2_PORT0_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT0_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT0_DEQUEUE_CSR, *PTXP_CHUTE2_PORT0_DEQUEUE_CSR;

      typedef union _TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION {
         TXP_CHUTE2_PORT0_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION, *PTXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 2, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT0_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT0_DEQUEUE_CSR, *PTXP_CHUTE2_PORT0_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_DEQUEUE_CSR, sizeof (TXP_CHUTE2_PORT0_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT0_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT0_DEQUEUE_CSR, *PTXP_CHUTE2_PORT0_DEQUEUE_CSR;

      typedef union _TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION {
         TXP_CHUTE2_PORT0_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION, *PTXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE2_PORT0_DEQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 2, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT1_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT1_DEQUEUE_CSR, *PTXP_CHUTE2_PORT1_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_DEQUEUE_CSR, sizeof (TXP_CHUTE2_PORT1_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT1_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT1_DEQUEUE_CSR, *PTXP_CHUTE2_PORT1_DEQUEUE_CSR;

      typedef union _TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION {
         TXP_CHUTE2_PORT1_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION, *PTXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds dequeued from TPOST on CHUTE 2, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT1_DEQUEUE_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT1_DEQUEUE_CSR, *PTXP_CHUTE2_PORT1_DEQUEUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_DEQUEUE_CSR, sizeof (TXP_CHUTE2_PORT1_DEQUEUE_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT1_DEQUEUE_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT1_DEQUEUE_CSR, *PTXP_CHUTE2_PORT1_DEQUEUE_CSR;

      typedef union _TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION {
         TXP_CHUTE2_PORT1_DEQUEUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION, *PTXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION, sizeof (TXP_CHUTE2_PORT1_DEQUEUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 0, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT0_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT0_CMPL_CSR, *PTXP_CHUTE0_PORT0_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_CMPL_CSR, sizeof (TXP_CHUTE0_PORT0_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT0_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT0_CMPL_CSR, *PTXP_CHUTE0_PORT0_CMPL_CSR;

      typedef union _TXP_CHUTE0_PORT0_CMPL_CSR_UNION {
         TXP_CHUTE0_PORT0_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT0_CMPL_CSR_UNION, *PTXP_CHUTE0_PORT0_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_CMPL_CSR_UNION, sizeof (TXP_CHUTE0_PORT0_CMPL_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 0, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT0_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT0_CMPL_CSR, *PTXP_CHUTE0_PORT0_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_CMPL_CSR, sizeof (TXP_CHUTE0_PORT0_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT0_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT0_CMPL_CSR, *PTXP_CHUTE0_PORT0_CMPL_CSR;

      typedef union _TXP_CHUTE0_PORT0_CMPL_CSR_UNION {
         TXP_CHUTE0_PORT0_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT0_CMPL_CSR_UNION, *PTXP_CHUTE0_PORT0_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT0_CMPL_CSR_UNION, sizeof (TXP_CHUTE0_PORT0_CMPL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 0, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT1_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT1_CMPL_CSR, *PTXP_CHUTE0_PORT1_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_CMPL_CSR, sizeof (TXP_CHUTE0_PORT1_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT1_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT1_CMPL_CSR, *PTXP_CHUTE0_PORT1_CMPL_CSR;

      typedef union _TXP_CHUTE0_PORT1_CMPL_CSR_UNION {
         TXP_CHUTE0_PORT1_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT1_CMPL_CSR_UNION, *PTXP_CHUTE0_PORT1_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_CMPL_CSR_UNION, sizeof (TXP_CHUTE0_PORT1_CMPL_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 0, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE0_PORT1_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE0_PORT1_CMPL_CSR, *PTXP_CHUTE0_PORT1_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_CMPL_CSR, sizeof (TXP_CHUTE0_PORT1_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE0_PORT1_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE0_PORT1_CMPL_CSR, *PTXP_CHUTE0_PORT1_CMPL_CSR;

      typedef union _TXP_CHUTE0_PORT1_CMPL_CSR_UNION {
         TXP_CHUTE0_PORT1_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE0_PORT1_CMPL_CSR_UNION, *PTXP_CHUTE0_PORT1_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE0_PORT1_CMPL_CSR_UNION, sizeof (TXP_CHUTE0_PORT1_CMPL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 1, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT0_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT0_CMPL_CSR, *PTXP_CHUTE1_PORT0_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_CMPL_CSR, sizeof (TXP_CHUTE1_PORT0_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT0_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT0_CMPL_CSR, *PTXP_CHUTE1_PORT0_CMPL_CSR;

      typedef union _TXP_CHUTE1_PORT0_CMPL_CSR_UNION {
         TXP_CHUTE1_PORT0_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT0_CMPL_CSR_UNION, *PTXP_CHUTE1_PORT0_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_CMPL_CSR_UNION, sizeof (TXP_CHUTE1_PORT0_CMPL_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 1, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT0_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT0_CMPL_CSR, *PTXP_CHUTE1_PORT0_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_CMPL_CSR, sizeof (TXP_CHUTE1_PORT0_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT0_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT0_CMPL_CSR, *PTXP_CHUTE1_PORT0_CMPL_CSR;

      typedef union _TXP_CHUTE1_PORT0_CMPL_CSR_UNION {
         TXP_CHUTE1_PORT0_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT0_CMPL_CSR_UNION, *PTXP_CHUTE1_PORT0_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT0_CMPL_CSR_UNION, sizeof (TXP_CHUTE1_PORT0_CMPL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 1, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT1_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT1_CMPL_CSR, *PTXP_CHUTE1_PORT1_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_CMPL_CSR, sizeof (TXP_CHUTE1_PORT1_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT1_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT1_CMPL_CSR, *PTXP_CHUTE1_PORT1_CMPL_CSR;

      typedef union _TXP_CHUTE1_PORT1_CMPL_CSR_UNION {
         TXP_CHUTE1_PORT1_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT1_CMPL_CSR_UNION, *PTXP_CHUTE1_PORT1_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_CMPL_CSR_UNION, sizeof (TXP_CHUTE1_PORT1_CMPL_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 1, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE1_PORT1_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE1_PORT1_CMPL_CSR, *PTXP_CHUTE1_PORT1_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_CMPL_CSR, sizeof (TXP_CHUTE1_PORT1_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE1_PORT1_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE1_PORT1_CMPL_CSR, *PTXP_CHUTE1_PORT1_CMPL_CSR;

      typedef union _TXP_CHUTE1_PORT1_CMPL_CSR_UNION {
         TXP_CHUTE1_PORT1_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE1_PORT1_CMPL_CSR_UNION, *PTXP_CHUTE1_PORT1_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE1_PORT1_CMPL_CSR_UNION, sizeof (TXP_CHUTE1_PORT1_CMPL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 2, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT0_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT0_CMPL_CSR, *PTXP_CHUTE2_PORT0_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_CMPL_CSR, sizeof (TXP_CHUTE2_PORT0_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT0_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT0_CMPL_CSR, *PTXP_CHUTE2_PORT0_CMPL_CSR;

      typedef union _TXP_CHUTE2_PORT0_CMPL_CSR_UNION {
         TXP_CHUTE2_PORT0_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT0_CMPL_CSR_UNION, *PTXP_CHUTE2_PORT0_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_CMPL_CSR_UNION, sizeof (TXP_CHUTE2_PORT0_CMPL_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 2, PORT0
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT0_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT0_CMPL_CSR, *PTXP_CHUTE2_PORT0_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_CMPL_CSR, sizeof (TXP_CHUTE2_PORT0_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT0_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT0_CMPL_CSR, *PTXP_CHUTE2_PORT0_CMPL_CSR;

      typedef union _TXP_CHUTE2_PORT0_CMPL_CSR_UNION {
         TXP_CHUTE2_PORT0_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT0_CMPL_CSR_UNION, *PTXP_CHUTE2_PORT0_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT0_CMPL_CSR_UNION, sizeof (TXP_CHUTE2_PORT0_CMPL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 2, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT1_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT1_CMPL_CSR, *PTXP_CHUTE2_PORT1_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_CMPL_CSR, sizeof (TXP_CHUTE2_PORT1_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT1_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT1_CMPL_CSR, *PTXP_CHUTE2_PORT1_CMPL_CSR;

      typedef union _TXP_CHUTE2_PORT1_CMPL_CSR_UNION {
         TXP_CHUTE2_PORT1_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT1_CMPL_CSR_UNION, *PTXP_CHUTE2_PORT1_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_CMPL_CSR_UNION, sizeof (TXP_CHUTE2_PORT1_CMPL_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of TX_Ds completed from TPOST on CHUTE 2, PORT1
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CHUTE2_PORT1_CMPL_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_CHUTE2_PORT1_CMPL_CSR, *PTXP_CHUTE2_PORT1_CMPL_CSR;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_CMPL_CSR, sizeof (TXP_CHUTE2_PORT1_CMPL_CSR) == 4);

   #else
      typedef struct _TXP_CHUTE2_PORT1_CMPL_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_CHUTE2_PORT1_CMPL_CSR, *PTXP_CHUTE2_PORT1_CMPL_CSR;

      typedef union _TXP_CHUTE2_PORT1_CMPL_CSR_UNION {
         TXP_CHUTE2_PORT1_CMPL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_CHUTE2_PORT1_CMPL_CSR_UNION, *PTXP_CHUTE2_PORT1_CMPL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_CHUTE2_PORT1_CMPL_CSR_UNION, sizeof (TXP_CHUTE2_PORT1_CMPL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the number of NDMA completion errors
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_NDMA_ERRS_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_NDMA_ERRS_CSR, *PTXP_NDMA_ERRS_CSR;

      SG_C_ASSERT(__sizeof__TXP_NDMA_ERRS_CSR, sizeof (TXP_NDMA_ERRS_CSR) == 4);

   #else
      typedef struct _TXP_NDMA_ERRS_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_NDMA_ERRS_CSR, *PTXP_NDMA_ERRS_CSR;

      typedef union _TXP_NDMA_ERRS_CSR_UNION {
         TXP_NDMA_ERRS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_NDMA_ERRS_CSR_UNION, *PTXP_NDMA_ERRS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_NDMA_ERRS_CSR_UNION, sizeof (TXP_NDMA_ERRS_CSR_UNION) == 4);
   #endif


#else
   // This register contains the number of NDMA completion errors
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_NDMA_ERRS_CSR {
         union {
            struct { 
               u32 num;                           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_NDMA_ERRS_CSR, *PTXP_NDMA_ERRS_CSR;

      SG_C_ASSERT(__sizeof__TXP_NDMA_ERRS_CSR, sizeof (TXP_NDMA_ERRS_CSR) == 4);

   #else
      typedef struct _TXP_NDMA_ERRS_CSR {
         u32 num;                                 // DWORD 0
      } SG_PACK TXP_NDMA_ERRS_CSR, *PTXP_NDMA_ERRS_CSR;

      typedef union _TXP_NDMA_ERRS_CSR_UNION {
         TXP_NDMA_ERRS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_NDMA_ERRS_CSR_UNION, *PTXP_NDMA_ERRS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_NDMA_ERRS_CSR_UNION, sizeof (TXP_NDMA_ERRS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Per Priority Class Limit Index. Provides indexed access to the Per Priority Class
   // limits registers. There are 8 classes per port and each has a number of TX_Ds and a
   // number of TXPBs limit. Write this register and then read or write the
   // TXP_PRIORITY_CLASS_LIMIT_DATA_CSR register to get or set the limit. The
   // priority_class field auto-increments with each access to
   // TXP_PRIORITY_CLASS_LIMIT_DATA_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 limit_type : 1;                // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 priority_class : 3;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR, *PTXP_PRIORITY_CLASS_LIMIT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR, sizeof (TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 limit_type : 1;                      // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 priority_class : 3;                  // DWORD 0
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR, *PTXP_PRIORITY_CLASS_LIMIT_INDEX_CSR;

      typedef union _TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION {
         TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION, *PTXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION, sizeof (TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Per Priority Class Limit Index. Provides indexed access to the Per Priority Class
   // limits registers. There are 8 classes per port and each has a number of TX_Ds and a
   // number of TXPBs limit. Write this register and then read or write the
   // TXP_PRIORITY_CLASS_LIMIT_DATA_CSR register to get or set the limit. The
   // priority_class field auto-increments with each access to
   // TXP_PRIORITY_CLASS_LIMIT_DATA_CSR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR {
         union {
            struct { 
               u32 priority_class : 3;            // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 limit_type : 1;                // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR, *PTXP_PRIORITY_CLASS_LIMIT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR, sizeof (TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR {
         u32 priority_class : 3;                  // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 limit_type : 1;                      // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR, *PTXP_PRIORITY_CLASS_LIMIT_INDEX_CSR;

      typedef union _TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION {
         TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION, *PTXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION, sizeof (TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Per Priority Class Limit Data. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_DATA_CSR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 data : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_DATA_CSR, *PTXP_PRIORITY_CLASS_LIMIT_DATA_CSR;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_DATA_CSR, sizeof (TXP_PRIORITY_CLASS_LIMIT_DATA_CSR) == 4);

   #else
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_DATA_CSR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 data : 8;                            // DWORD 0
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_DATA_CSR, *PTXP_PRIORITY_CLASS_LIMIT_DATA_CSR;

      typedef union _TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION {
         TXP_PRIORITY_CLASS_LIMIT_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION, *PTXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION, sizeof (TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION) == 4);
   #endif


#else
   // Per Priority Class Limit Data. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_DATA_CSR {
         union {
            struct { 
               u32 data : 8;                      // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_DATA_CSR, *PTXP_PRIORITY_CLASS_LIMIT_DATA_CSR;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_DATA_CSR, sizeof (TXP_PRIORITY_CLASS_LIMIT_DATA_CSR) == 4);

   #else
      typedef struct _TXP_PRIORITY_CLASS_LIMIT_DATA_CSR {
         u32 data : 8;                            // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_DATA_CSR, *PTXP_PRIORITY_CLASS_LIMIT_DATA_CSR;

      typedef union _TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION {
         TXP_PRIORITY_CLASS_LIMIT_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION, *PTXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION, sizeof (TXP_PRIORITY_CLASS_LIMIT_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Index for read/write interface to cached pup programs. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PUP_PROG_CACHE_INDEX_CSR {
         union {
            struct { 
               u32 rsvd2 : 19;                    // DWORD 0
               u32 unit : 1;                      // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 instr_num : 5;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 program : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PUP_PROG_CACHE_INDEX_CSR, *PTXP_PUP_PROG_CACHE_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INDEX_CSR, sizeof (TXP_PUP_PROG_CACHE_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_PUP_PROG_CACHE_INDEX_CSR {
         u32 rsvd2 : 19;                          // DWORD 0
         u32 unit : 1;                            // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 instr_num : 5;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 program : 3;                         // DWORD 0
      } SG_PACK TXP_PUP_PROG_CACHE_INDEX_CSR, *PTXP_PUP_PROG_CACHE_INDEX_CSR;

      typedef union _TXP_PUP_PROG_CACHE_INDEX_CSR_UNION {
         TXP_PUP_PROG_CACHE_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PUP_PROG_CACHE_INDEX_CSR_UNION, *PTXP_PUP_PROG_CACHE_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INDEX_CSR_UNION, sizeof (TXP_PUP_PROG_CACHE_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Index for read/write interface to cached pup programs. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PUP_PROG_CACHE_INDEX_CSR {
         union {
            struct { 
               u32 program : 3;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 instr_num : 5;                 // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 unit : 1;                      // DWORD 0
               u32 rsvd2 : 19;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PUP_PROG_CACHE_INDEX_CSR, *PTXP_PUP_PROG_CACHE_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INDEX_CSR, sizeof (TXP_PUP_PROG_CACHE_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_PUP_PROG_CACHE_INDEX_CSR {
         u32 program : 3;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 instr_num : 5;                       // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 unit : 1;                            // DWORD 0
         u32 rsvd2 : 19;                          // DWORD 0
      } SG_PACK TXP_PUP_PROG_CACHE_INDEX_CSR, *PTXP_PUP_PROG_CACHE_INDEX_CSR;

      typedef union _TXP_PUP_PROG_CACHE_INDEX_CSR_UNION {
         TXP_PUP_PROG_CACHE_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PUP_PROG_CACHE_INDEX_CSR_UNION, *PTXP_PUP_PROG_CACHE_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INDEX_CSR_UNION, sizeof (TXP_PUP_PROG_CACHE_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction value for read/write interface to cached pup programs. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PUP_PROG_CACHE_INSTR_CSR {
         union {
            struct { 
               u32 instr;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PUP_PROG_CACHE_INSTR_CSR, *PTXP_PUP_PROG_CACHE_INSTR_CSR;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INSTR_CSR, sizeof (TXP_PUP_PROG_CACHE_INSTR_CSR) == 4);

   #else
      typedef struct _TXP_PUP_PROG_CACHE_INSTR_CSR {
         u32 instr;                               // DWORD 0
      } SG_PACK TXP_PUP_PROG_CACHE_INSTR_CSR, *PTXP_PUP_PROG_CACHE_INSTR_CSR;

      typedef union _TXP_PUP_PROG_CACHE_INSTR_CSR_UNION {
         TXP_PUP_PROG_CACHE_INSTR_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PUP_PROG_CACHE_INSTR_CSR_UNION, *PTXP_PUP_PROG_CACHE_INSTR_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INSTR_CSR_UNION, sizeof (TXP_PUP_PROG_CACHE_INSTR_CSR_UNION) == 4);
   #endif


#else
   // Instruction value for read/write interface to cached pup programs. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_PUP_PROG_CACHE_INSTR_CSR {
         union {
            struct { 
               u32 instr;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_PUP_PROG_CACHE_INSTR_CSR, *PTXP_PUP_PROG_CACHE_INSTR_CSR;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INSTR_CSR, sizeof (TXP_PUP_PROG_CACHE_INSTR_CSR) == 4);

   #else
      typedef struct _TXP_PUP_PROG_CACHE_INSTR_CSR {
         u32 instr;                               // DWORD 0
      } SG_PACK TXP_PUP_PROG_CACHE_INSTR_CSR, *PTXP_PUP_PROG_CACHE_INSTR_CSR;

      typedef union _TXP_PUP_PROG_CACHE_INSTR_CSR_UNION {
         TXP_PUP_PROG_CACHE_INSTR_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_PUP_PROG_CACHE_INSTR_CSR_UNION, *PTXP_PUP_PROG_CACHE_INSTR_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_PUP_PROG_CACHE_INSTR_CSR_UNION, sizeof (TXP_PUP_PROG_CACHE_INSTR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // FCoE ethertype and FIP ethertype
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_FCOE_TYPE_CSR {
         union {
            struct { 
               u32 fip_type : 16;                 // DWORD 0
               u32 fcoe_type : 16;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_FCOE_TYPE_CSR, *PTXP_FCOE_TYPE_CSR;

      SG_C_ASSERT(__sizeof__TXP_FCOE_TYPE_CSR, sizeof (TXP_FCOE_TYPE_CSR) == 4);

   #else
      typedef struct _TXP_FCOE_TYPE_CSR {
         u32 fip_type : 16;                       // DWORD 0
         u32 fcoe_type : 16;                      // DWORD 0
      } SG_PACK TXP_FCOE_TYPE_CSR, *PTXP_FCOE_TYPE_CSR;

      typedef union _TXP_FCOE_TYPE_CSR_UNION {
         TXP_FCOE_TYPE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_FCOE_TYPE_CSR_UNION, *PTXP_FCOE_TYPE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_FCOE_TYPE_CSR_UNION, sizeof (TXP_FCOE_TYPE_CSR_UNION) == 4);
   #endif


#else
   // FCoE ethertype and FIP ethertype
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_FCOE_TYPE_CSR {
         union {
            struct { 
               u32 fcoe_type : 16;                // DWORD 0
               u32 fip_type : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_FCOE_TYPE_CSR, *PTXP_FCOE_TYPE_CSR;

      SG_C_ASSERT(__sizeof__TXP_FCOE_TYPE_CSR, sizeof (TXP_FCOE_TYPE_CSR) == 4);

   #else
      typedef struct _TXP_FCOE_TYPE_CSR {
         u32 fcoe_type : 16;                      // DWORD 0
         u32 fip_type : 16;                       // DWORD 0
      } SG_PACK TXP_FCOE_TYPE_CSR, *PTXP_FCOE_TYPE_CSR;

      typedef union _TXP_FCOE_TYPE_CSR_UNION {
         TXP_FCOE_TYPE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_FCOE_TYPE_CSR_UNION, *PTXP_FCOE_TYPE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_FCOE_TYPE_CSR_UNION, sizeof (TXP_FCOE_TYPE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The TXD currently accessed by each machine that accesses TXDs. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_SM_TXDS_CSR {
         union {
            struct { 
               u32 rsvd7 : 4;                     // DWORD 0
               u32 rsvd6 : 1;                     // DWORD 0
               u32 ret_txd : 3;                   // DWORD 0
               u32 rsvd5 : 1;                     // DWORD 0
               u32 pup1_txd : 3;                  // DWORD 0
               u32 rsvd4 : 1;                     // DWORD 0
               u32 pup0_txd : 3;                  // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 segp_cmpl_txd : 3;             // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 prep_txd : 3;                  // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 segp_txd : 3;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dscp_txd : 3;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_SM_TXDS_CSR, *PTXP_SM_TXDS_CSR;

      SG_C_ASSERT(__sizeof__TXP_SM_TXDS_CSR, sizeof (TXP_SM_TXDS_CSR) == 4);

   #else
      typedef struct _TXP_SM_TXDS_CSR {
         u32 rsvd7 : 4;                           // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 ret_txd : 3;                         // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 pup1_txd : 3;                        // DWORD 0
         u32 rsvd4 : 1;                           // DWORD 0
         u32 pup0_txd : 3;                        // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 segp_cmpl_txd : 3;                   // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 prep_txd : 3;                        // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 segp_txd : 3;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dscp_txd : 3;                        // DWORD 0
      } SG_PACK TXP_SM_TXDS_CSR, *PTXP_SM_TXDS_CSR;

      typedef union _TXP_SM_TXDS_CSR_UNION {
         TXP_SM_TXDS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_SM_TXDS_CSR_UNION, *PTXP_SM_TXDS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_SM_TXDS_CSR_UNION, sizeof (TXP_SM_TXDS_CSR_UNION) == 4);
   #endif


#else
   // The TXD currently accessed by each machine that accesses TXDs. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_SM_TXDS_CSR {
         union {
            struct { 
               u32 dscp_txd : 3;                  // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 segp_txd : 3;                  // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 prep_txd : 3;                  // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 segp_cmpl_txd : 3;             // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 pup0_txd : 3;                  // DWORD 0
               u32 rsvd4 : 1;                     // DWORD 0
               u32 pup1_txd : 3;                  // DWORD 0
               u32 rsvd5 : 1;                     // DWORD 0
               u32 ret_txd : 3;                   // DWORD 0
               u32 rsvd6 : 1;                     // DWORD 0
               u32 rsvd7 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_SM_TXDS_CSR, *PTXP_SM_TXDS_CSR;

      SG_C_ASSERT(__sizeof__TXP_SM_TXDS_CSR, sizeof (TXP_SM_TXDS_CSR) == 4);

   #else
      typedef struct _TXP_SM_TXDS_CSR {
         u32 dscp_txd : 3;                        // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 segp_txd : 3;                        // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 prep_txd : 3;                        // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 segp_cmpl_txd : 3;                   // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 pup0_txd : 3;                        // DWORD 0
         u32 rsvd4 : 1;                           // DWORD 0
         u32 pup1_txd : 3;                        // DWORD 0
         u32 rsvd5 : 1;                           // DWORD 0
         u32 ret_txd : 3;                         // DWORD 0
         u32 rsvd6 : 1;                           // DWORD 0
         u32 rsvd7 : 4;                           // DWORD 0
      } SG_PACK TXP_SM_TXDS_CSR, *PTXP_SM_TXDS_CSR;

      typedef union _TXP_SM_TXDS_CSR_UNION {
         TXP_SM_TXDS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_SM_TXDS_CSR_UNION, *PTXP_SM_TXDS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_SM_TXDS_CSR_UNION, sizeof (TXP_SM_TXDS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXD index for accessing TXD values. A write to this register will start the dump of
   // the specified TXD. The TXD value is read from the TXP_TXD_VALUE_CSR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_TXD_INDEX_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 txd_index : 3;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_TXD_INDEX_CSR, *PTXP_TXD_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_TXD_INDEX_CSR, sizeof (TXP_TXD_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_TXD_INDEX_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 txd_index : 3;                       // DWORD 0
      } SG_PACK TXP_TXD_INDEX_CSR, *PTXP_TXD_INDEX_CSR;

      typedef union _TXP_TXD_INDEX_CSR_UNION {
         TXP_TXD_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_TXD_INDEX_CSR_UNION, *PTXP_TXD_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_TXD_INDEX_CSR_UNION, sizeof (TXP_TXD_INDEX_CSR_UNION) == 4);
   #endif


#else
   // TXD index for accessing TXD values. A write to this register will start the dump of
   // the specified TXD. The TXD value is read from the TXP_TXD_VALUE_CSR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_TXD_INDEX_CSR {
         union {
            struct { 
               u32 txd_index : 3;                 // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_TXD_INDEX_CSR, *PTXP_TXD_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_TXD_INDEX_CSR, sizeof (TXP_TXD_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_TXD_INDEX_CSR {
         u32 txd_index : 3;                       // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK TXP_TXD_INDEX_CSR, *PTXP_TXD_INDEX_CSR;

      typedef union _TXP_TXD_INDEX_CSR_UNION {
         TXP_TXD_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_TXD_INDEX_CSR_UNION, *PTXP_TXD_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_TXD_INDEX_CSR_UNION, sizeof (TXP_TXD_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXD value indexed by TXP_TXD_INDEX_CSR register. The TXD values are accessed with 8
   // consecutive reads. Each read of this register will return the next 32 bits of the
   // TXD. The 9th read returns the TXD state, in bits 3:0, and port, in bit 4. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_TXD_VALUE_CSR {
         union {
            struct { 
               u32 txd_value;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_TXD_VALUE_CSR, *PTXP_TXD_VALUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_TXD_VALUE_CSR, sizeof (TXP_TXD_VALUE_CSR) == 4);

   #else
      typedef struct _TXP_TXD_VALUE_CSR {
         u32 txd_value;                           // DWORD 0
      } SG_PACK TXP_TXD_VALUE_CSR, *PTXP_TXD_VALUE_CSR;

      typedef union _TXP_TXD_VALUE_CSR_UNION {
         TXP_TXD_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_TXD_VALUE_CSR_UNION, *PTXP_TXD_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_TXD_VALUE_CSR_UNION, sizeof (TXP_TXD_VALUE_CSR_UNION) == 4);
   #endif


#else
   // TXD value indexed by TXP_TXD_INDEX_CSR register. The TXD values are accessed with 8
   // consecutive reads. Each read of this register will return the next 32 bits of the
   // TXD. The 9th read returns the TXD state, in bits 3:0, and port, in bit 4. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_TXD_VALUE_CSR {
         union {
            struct { 
               u32 txd_value;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_TXD_VALUE_CSR, *PTXP_TXD_VALUE_CSR;

      SG_C_ASSERT(__sizeof__TXP_TXD_VALUE_CSR, sizeof (TXP_TXD_VALUE_CSR) == 4);

   #else
      typedef struct _TXP_TXD_VALUE_CSR {
         u32 txd_value;                           // DWORD 0
      } SG_PACK TXP_TXD_VALUE_CSR, *PTXP_TXD_VALUE_CSR;

      typedef union _TXP_TXD_VALUE_CSR_UNION {
         TXP_TXD_VALUE_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_TXD_VALUE_CSR_UNION, *PTXP_TXD_VALUE_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_TXD_VALUE_CSR_UNION, sizeof (TXP_TXD_VALUE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Statistic counters index. A write to this register selects a set of statistics to be
   // read from the TXP_STAT_PKTS_CSR, TXP_STAT_BYTES_L_CSR, and TXP_STAT_BYTES_U_CSR
   // registers. TXP maintains 16 sets of counters. The stat_counter field in each TX_D
   // controls which sets of counters, if any, are updated. Each set of statistics
   // consists of two counters. The first is a 32-bit packet counter and the second is a
   // 64-bit byte counter. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_INDEX_CSR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 stat_index : 4;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_INDEX_CSR, *PTXP_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_INDEX_CSR, sizeof (TXP_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_STAT_INDEX_CSR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 stat_index : 4;                      // DWORD 0
      } SG_PACK TXP_STAT_INDEX_CSR, *PTXP_STAT_INDEX_CSR;

      typedef union _TXP_STAT_INDEX_CSR_UNION {
         TXP_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_INDEX_CSR_UNION, *PTXP_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_INDEX_CSR_UNION, sizeof (TXP_STAT_INDEX_CSR_UNION) == 4);
   #endif


#else
   // Statistic counters index. A write to this register selects a set of statistics to be
   // read from the TXP_STAT_PKTS_CSR, TXP_STAT_BYTES_L_CSR, and TXP_STAT_BYTES_U_CSR
   // registers. TXP maintains 16 sets of counters. The stat_counter field in each TX_D
   // controls which sets of counters, if any, are updated. Each set of statistics
   // consists of two counters. The first is a 32-bit packet counter and the second is a
   // 64-bit byte counter. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_INDEX_CSR {
         union {
            struct { 
               u32 stat_index : 4;                // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_INDEX_CSR, *PTXP_STAT_INDEX_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_INDEX_CSR, sizeof (TXP_STAT_INDEX_CSR) == 4);

   #else
      typedef struct _TXP_STAT_INDEX_CSR {
         u32 stat_index : 4;                      // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK TXP_STAT_INDEX_CSR, *PTXP_STAT_INDEX_CSR;

      typedef union _TXP_STAT_INDEX_CSR_UNION {
         TXP_STAT_INDEX_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_INDEX_CSR_UNION, *PTXP_STAT_INDEX_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_INDEX_CSR_UNION, sizeof (TXP_STAT_INDEX_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Packets transmitted, indexed by TXP_STAT_INDEX_CSR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_PKTS_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_PKTS_CSR, *PTXP_STAT_PKTS_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_PKTS_CSR, sizeof (TXP_STAT_PKTS_CSR) == 4);

   #else
      typedef struct _TXP_STAT_PKTS_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXP_STAT_PKTS_CSR, *PTXP_STAT_PKTS_CSR;

      typedef union _TXP_STAT_PKTS_CSR_UNION {
         TXP_STAT_PKTS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_PKTS_CSR_UNION, *PTXP_STAT_PKTS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_PKTS_CSR_UNION, sizeof (TXP_STAT_PKTS_CSR_UNION) == 4);
   #endif


#else
   // Packets transmitted, indexed by TXP_STAT_INDEX_CSR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_PKTS_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_PKTS_CSR, *PTXP_STAT_PKTS_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_PKTS_CSR, sizeof (TXP_STAT_PKTS_CSR) == 4);

   #else
      typedef struct _TXP_STAT_PKTS_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXP_STAT_PKTS_CSR, *PTXP_STAT_PKTS_CSR;

      typedef union _TXP_STAT_PKTS_CSR_UNION {
         TXP_STAT_PKTS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_PKTS_CSR_UNION, *PTXP_STAT_PKTS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_PKTS_CSR_UNION, sizeof (TXP_STAT_PKTS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // User bytes transmitted, LS DWORD, indexed by TXP_STAT_INDEX_CSR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_BYTES_L_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_BYTES_L_CSR, *PTXP_STAT_BYTES_L_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_L_CSR, sizeof (TXP_STAT_BYTES_L_CSR) == 4);

   #else
      typedef struct _TXP_STAT_BYTES_L_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXP_STAT_BYTES_L_CSR, *PTXP_STAT_BYTES_L_CSR;

      typedef union _TXP_STAT_BYTES_L_CSR_UNION {
         TXP_STAT_BYTES_L_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_BYTES_L_CSR_UNION, *PTXP_STAT_BYTES_L_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_L_CSR_UNION, sizeof (TXP_STAT_BYTES_L_CSR_UNION) == 4);
   #endif


#else
   // User bytes transmitted, LS DWORD, indexed by TXP_STAT_INDEX_CSR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_BYTES_L_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_BYTES_L_CSR, *PTXP_STAT_BYTES_L_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_L_CSR, sizeof (TXP_STAT_BYTES_L_CSR) == 4);

   #else
      typedef struct _TXP_STAT_BYTES_L_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXP_STAT_BYTES_L_CSR, *PTXP_STAT_BYTES_L_CSR;

      typedef union _TXP_STAT_BYTES_L_CSR_UNION {
         TXP_STAT_BYTES_L_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_BYTES_L_CSR_UNION, *PTXP_STAT_BYTES_L_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_L_CSR_UNION, sizeof (TXP_STAT_BYTES_L_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // User bytes transmitted, MS DWORD, indexed by TXP_STAT_INDEX_CSR register. Reading
   // this register auto-increments the index register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_BYTES_U_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_BYTES_U_CSR, *PTXP_STAT_BYTES_U_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_U_CSR, sizeof (TXP_STAT_BYTES_U_CSR) == 4);

   #else
      typedef struct _TXP_STAT_BYTES_U_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXP_STAT_BYTES_U_CSR, *PTXP_STAT_BYTES_U_CSR;

      typedef union _TXP_STAT_BYTES_U_CSR_UNION {
         TXP_STAT_BYTES_U_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_BYTES_U_CSR_UNION, *PTXP_STAT_BYTES_U_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_U_CSR_UNION, sizeof (TXP_STAT_BYTES_U_CSR_UNION) == 4);
   #endif


#else
   // User bytes transmitted, MS DWORD, indexed by TXP_STAT_INDEX_CSR register. Reading
   // this register auto-increments the index register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_STAT_BYTES_U_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXP_STAT_BYTES_U_CSR, *PTXP_STAT_BYTES_U_CSR;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_U_CSR, sizeof (TXP_STAT_BYTES_U_CSR) == 4);

   #else
      typedef struct _TXP_STAT_BYTES_U_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK TXP_STAT_BYTES_U_CSR, *PTXP_STAT_BYTES_U_CSR;

      typedef union _TXP_STAT_BYTES_U_CSR_UNION {
         TXP_STAT_BYTES_U_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXP_STAT_BYTES_U_CSR_UNION, *PTXP_STAT_BYTES_U_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXP_STAT_BYTES_U_CSR_UNION, sizeof (TXP_STAT_BYTES_U_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Registers for the TX Packet Processor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CSRMAP {
         union {
            struct { 
               TXP_CONTROL_CSR txp_control;
               TXP_PIO_COMMAND_CSR txp_pio_command;
               TXP_PIO_DATA_CSR txp_pio_data;
               TXP_FIFO_FREE_0_CSR txp_fifo_0_free;
               TXP_FIFO_FREE_1_CSR txp_fifo_1_free;
               TXP_TPOST_WRR_CSR txp_tpost_wrr;
               TXP_CRC_START_ADDR_CSR txp_crc_start_addr;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } ndma_pq;
               TXP_UE_CAUSE0_CSR txp_ue_cause0;
               TXP_UE_CAUSE1_CSR txp_ue_cause1;
               TXP_UE_CAUSE2_CSR txp_ue_cause2;
               TXP_UE_CAUSE3_CSR txp_ue_cause3;
               TXP_UE_CAUSE4_CSR txp_ue_cause4;
               TXP_UE_ENABLE0_CSR txp_ue_enable0;
               TXP_UE_ENABLE1_CSR txp_ue_enable1;
               TXP_UE_ENABLE2_CSR txp_ue_enable2;
               TXP_UE_ENABLE3_CSR txp_ue_enable3;
               TXP_UE_ENABLE4_CSR txp_ue_enable4;
               TXP_CHUTE0_PORT0_DEQUEUE_CSR txp_chute0_port0_dequeue;
               TXP_CHUTE0_PORT1_DEQUEUE_CSR txp_chute0_port1_dequeue;
               TXP_CHUTE1_PORT0_DEQUEUE_CSR txp_chute1_port0_dequeue;
               TXP_CHUTE1_PORT1_DEQUEUE_CSR txp_chute1_port1_dequeue;
               TXP_CHUTE2_PORT0_DEQUEUE_CSR txp_chute2_port0_dequeue;
               TXP_CHUTE2_PORT1_DEQUEUE_CSR txp_chute2_port1_dequeue;
               TXP_CHUTE0_PORT0_CMPL_CSR txp_chute0_port0_cmpl;
               TXP_CHUTE0_PORT1_CMPL_CSR txp_chute0_port1_cmpl;
               TXP_CHUTE1_PORT0_CMPL_CSR txp_chute1_port0_cmpl;
               TXP_CHUTE1_PORT1_CMPL_CSR txp_chute1_port1_cmpl;
               TXP_CHUTE2_PORT0_CMPL_CSR txp_chute2_port0_cmpl;
               TXP_CHUTE2_PORT1_CMPL_CSR txp_chute2_port1_cmpl;
               TXP_NDMA_ERRS_CSR txp_ndma_errs;
               TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR txp_priority_class_limit_index;
               TXP_PRIORITY_CLASS_LIMIT_DATA_CSR txp_priority_class_limit_data;
               TXP_PUP_PROG_CACHE_INDEX_CSR txp_pup_prog_cache_index;
               TXP_PUP_PROG_CACHE_INSTR_CSR txp_pup_prog_instr;
               TXP_FCOE_TYPE_CSR txp_fcoe_type;
               TXP_SM_TXDS_CSR txp_sm_txds;
               TXP_TXD_INDEX_CSR txp_txd_index;
               TXP_TXD_VALUE_CSR txp_txd_value;
               TXP_STAT_INDEX_CSR txp_stat_index;
               TXP_STAT_PKTS_CSR txp_stat_pkts;
               TXP_STAT_BYTES_L_CSR txp_stat_bytes_l;
               TXP_STAT_BYTES_U_CSR txp_stat_bytes_u;
               GEN_CTXIF_DEBUG ctxif_debug;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[205];                    // DWORDS 51 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TXP_CSRMAP, *PTXP_CSRMAP;

      SG_C_ASSERT(__sizeof__TXP_CSRMAP, sizeof (TXP_CSRMAP) == 1024);

   #else
      typedef struct _TXP_CSRMAP {
         TXP_CONTROL_CSR txp_control;
         TXP_PIO_COMMAND_CSR txp_pio_command;
         TXP_PIO_DATA_CSR txp_pio_data;
         TXP_FIFO_FREE_0_CSR txp_fifo_0_free;
         TXP_FIFO_FREE_1_CSR txp_fifo_1_free;
         TXP_TPOST_WRR_CSR txp_tpost_wrr;
         TXP_CRC_START_ADDR_CSR txp_crc_start_addr;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } ndma_pq;
         TXP_UE_CAUSE0_CSR txp_ue_cause0;
         TXP_UE_CAUSE1_CSR txp_ue_cause1;
         TXP_UE_CAUSE2_CSR txp_ue_cause2;
         TXP_UE_CAUSE3_CSR txp_ue_cause3;
         TXP_UE_CAUSE4_CSR txp_ue_cause4;
         TXP_UE_ENABLE0_CSR txp_ue_enable0;
         TXP_UE_ENABLE1_CSR txp_ue_enable1;
         TXP_UE_ENABLE2_CSR txp_ue_enable2;
         TXP_UE_ENABLE3_CSR txp_ue_enable3;
         TXP_UE_ENABLE4_CSR txp_ue_enable4;
         TXP_CHUTE0_PORT0_DEQUEUE_CSR txp_chute0_port0_dequeue;
         TXP_CHUTE0_PORT1_DEQUEUE_CSR txp_chute0_port1_dequeue;
         TXP_CHUTE1_PORT0_DEQUEUE_CSR txp_chute1_port0_dequeue;
         TXP_CHUTE1_PORT1_DEQUEUE_CSR txp_chute1_port1_dequeue;
         TXP_CHUTE2_PORT0_DEQUEUE_CSR txp_chute2_port0_dequeue;
         TXP_CHUTE2_PORT1_DEQUEUE_CSR txp_chute2_port1_dequeue;
         TXP_CHUTE0_PORT0_CMPL_CSR txp_chute0_port0_cmpl;
         TXP_CHUTE0_PORT1_CMPL_CSR txp_chute0_port1_cmpl;
         TXP_CHUTE1_PORT0_CMPL_CSR txp_chute1_port0_cmpl;
         TXP_CHUTE1_PORT1_CMPL_CSR txp_chute1_port1_cmpl;
         TXP_CHUTE2_PORT0_CMPL_CSR txp_chute2_port0_cmpl;
         TXP_CHUTE2_PORT1_CMPL_CSR txp_chute2_port1_cmpl;
         TXP_NDMA_ERRS_CSR txp_ndma_errs;
         TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR txp_priority_class_limit_index;
         TXP_PRIORITY_CLASS_LIMIT_DATA_CSR txp_priority_class_limit_data;
         TXP_PUP_PROG_CACHE_INDEX_CSR txp_pup_prog_cache_index;
         TXP_PUP_PROG_CACHE_INSTR_CSR txp_pup_prog_instr;
         TXP_FCOE_TYPE_CSR txp_fcoe_type;
         TXP_SM_TXDS_CSR txp_sm_txds;
         TXP_TXD_INDEX_CSR txp_txd_index;
         TXP_TXD_VALUE_CSR txp_txd_value;
         TXP_STAT_INDEX_CSR txp_stat_index;
         TXP_STAT_PKTS_CSR txp_stat_pkts;
         TXP_STAT_BYTES_L_CSR txp_stat_bytes_l;
         TXP_STAT_BYTES_U_CSR txp_stat_bytes_u;
         GEN_CTXIF_DEBUG ctxif_debug;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[205];                          // DWORDS 51 to 255
      } SG_PACK TXP_CSRMAP, *PTXP_CSRMAP;

      typedef union _TXP_CSRMAP_UNION {
         TXP_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TXP_CSRMAP_UNION, *PTXP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TXP_CSRMAP_UNION, sizeof (TXP_CSRMAP_UNION) == 1024);
   #endif


#else
   // Registers for the TX Packet Processor. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXP_CSRMAP {
         union {
            struct { 
               TXP_CONTROL_CSR txp_control;
               TXP_PIO_COMMAND_CSR txp_pio_command;
               TXP_PIO_DATA_CSR txp_pio_data;
               TXP_FIFO_FREE_0_CSR txp_fifo_0_free;
               TXP_FIFO_FREE_1_CSR txp_fifo_1_free;
               TXP_TPOST_WRR_CSR txp_tpost_wrr;
               TXP_CRC_START_ADDR_CSR txp_crc_start_addr;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } ndma_pq;
               TXP_UE_CAUSE0_CSR txp_ue_cause0;
               TXP_UE_CAUSE1_CSR txp_ue_cause1;
               TXP_UE_CAUSE2_CSR txp_ue_cause2;
               TXP_UE_CAUSE3_CSR txp_ue_cause3;
               TXP_UE_CAUSE4_CSR txp_ue_cause4;
               TXP_UE_ENABLE0_CSR txp_ue_enable0;
               TXP_UE_ENABLE1_CSR txp_ue_enable1;
               TXP_UE_ENABLE2_CSR txp_ue_enable2;
               TXP_UE_ENABLE3_CSR txp_ue_enable3;
               TXP_UE_ENABLE4_CSR txp_ue_enable4;
               TXP_CHUTE0_PORT0_DEQUEUE_CSR txp_chute0_port0_dequeue;
               TXP_CHUTE0_PORT1_DEQUEUE_CSR txp_chute0_port1_dequeue;
               TXP_CHUTE1_PORT0_DEQUEUE_CSR txp_chute1_port0_dequeue;
               TXP_CHUTE1_PORT1_DEQUEUE_CSR txp_chute1_port1_dequeue;
               TXP_CHUTE2_PORT0_DEQUEUE_CSR txp_chute2_port0_dequeue;
               TXP_CHUTE2_PORT1_DEQUEUE_CSR txp_chute2_port1_dequeue;
               TXP_CHUTE0_PORT0_CMPL_CSR txp_chute0_port0_cmpl;
               TXP_CHUTE0_PORT1_CMPL_CSR txp_chute0_port1_cmpl;
               TXP_CHUTE1_PORT0_CMPL_CSR txp_chute1_port0_cmpl;
               TXP_CHUTE1_PORT1_CMPL_CSR txp_chute1_port1_cmpl;
               TXP_CHUTE2_PORT0_CMPL_CSR txp_chute2_port0_cmpl;
               TXP_CHUTE2_PORT1_CMPL_CSR txp_chute2_port1_cmpl;
               TXP_NDMA_ERRS_CSR txp_ndma_errs;
               TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR txp_priority_class_limit_index;
               TXP_PRIORITY_CLASS_LIMIT_DATA_CSR txp_priority_class_limit_data;
               TXP_PUP_PROG_CACHE_INDEX_CSR txp_pup_prog_cache_index;
               TXP_PUP_PROG_CACHE_INSTR_CSR txp_pup_prog_instr;
               TXP_FCOE_TYPE_CSR txp_fcoe_type;
               TXP_SM_TXDS_CSR txp_sm_txds;
               TXP_TXD_INDEX_CSR txp_txd_index;
               TXP_TXD_VALUE_CSR txp_txd_value;
               TXP_STAT_INDEX_CSR txp_stat_index;
               TXP_STAT_PKTS_CSR txp_stat_pkts;
               TXP_STAT_BYTES_L_CSR txp_stat_bytes_l;
               TXP_STAT_BYTES_U_CSR txp_stat_bytes_u;
               GEN_CTXIF_DEBUG ctxif_debug;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[205];                    // DWORDS 51 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TXP_CSRMAP, *PTXP_CSRMAP;

      SG_C_ASSERT(__sizeof__TXP_CSRMAP, sizeof (TXP_CSRMAP) == 1024);

   #else
      typedef struct _TXP_CSRMAP {
         TXP_CONTROL_CSR txp_control;
         TXP_PIO_COMMAND_CSR txp_pio_command;
         TXP_PIO_DATA_CSR txp_pio_data;
         TXP_FIFO_FREE_0_CSR txp_fifo_0_free;
         TXP_FIFO_FREE_1_CSR txp_fifo_1_free;
         TXP_TPOST_WRR_CSR txp_tpost_wrr;
         TXP_CRC_START_ADDR_CSR txp_crc_start_addr;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } ndma_pq;
         TXP_UE_CAUSE0_CSR txp_ue_cause0;
         TXP_UE_CAUSE1_CSR txp_ue_cause1;
         TXP_UE_CAUSE2_CSR txp_ue_cause2;
         TXP_UE_CAUSE3_CSR txp_ue_cause3;
         TXP_UE_CAUSE4_CSR txp_ue_cause4;
         TXP_UE_ENABLE0_CSR txp_ue_enable0;
         TXP_UE_ENABLE1_CSR txp_ue_enable1;
         TXP_UE_ENABLE2_CSR txp_ue_enable2;
         TXP_UE_ENABLE3_CSR txp_ue_enable3;
         TXP_UE_ENABLE4_CSR txp_ue_enable4;
         TXP_CHUTE0_PORT0_DEQUEUE_CSR txp_chute0_port0_dequeue;
         TXP_CHUTE0_PORT1_DEQUEUE_CSR txp_chute0_port1_dequeue;
         TXP_CHUTE1_PORT0_DEQUEUE_CSR txp_chute1_port0_dequeue;
         TXP_CHUTE1_PORT1_DEQUEUE_CSR txp_chute1_port1_dequeue;
         TXP_CHUTE2_PORT0_DEQUEUE_CSR txp_chute2_port0_dequeue;
         TXP_CHUTE2_PORT1_DEQUEUE_CSR txp_chute2_port1_dequeue;
         TXP_CHUTE0_PORT0_CMPL_CSR txp_chute0_port0_cmpl;
         TXP_CHUTE0_PORT1_CMPL_CSR txp_chute0_port1_cmpl;
         TXP_CHUTE1_PORT0_CMPL_CSR txp_chute1_port0_cmpl;
         TXP_CHUTE1_PORT1_CMPL_CSR txp_chute1_port1_cmpl;
         TXP_CHUTE2_PORT0_CMPL_CSR txp_chute2_port0_cmpl;
         TXP_CHUTE2_PORT1_CMPL_CSR txp_chute2_port1_cmpl;
         TXP_NDMA_ERRS_CSR txp_ndma_errs;
         TXP_PRIORITY_CLASS_LIMIT_INDEX_CSR txp_priority_class_limit_index;
         TXP_PRIORITY_CLASS_LIMIT_DATA_CSR txp_priority_class_limit_data;
         TXP_PUP_PROG_CACHE_INDEX_CSR txp_pup_prog_cache_index;
         TXP_PUP_PROG_CACHE_INSTR_CSR txp_pup_prog_instr;
         TXP_FCOE_TYPE_CSR txp_fcoe_type;
         TXP_SM_TXDS_CSR txp_sm_txds;
         TXP_TXD_INDEX_CSR txp_txd_index;
         TXP_TXD_VALUE_CSR txp_txd_value;
         TXP_STAT_INDEX_CSR txp_stat_index;
         TXP_STAT_PKTS_CSR txp_stat_pkts;
         TXP_STAT_BYTES_L_CSR txp_stat_bytes_l;
         TXP_STAT_BYTES_U_CSR txp_stat_bytes_u;
         GEN_CTXIF_DEBUG ctxif_debug;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[205];                          // DWORDS 51 to 255
      } SG_PACK TXP_CSRMAP, *PTXP_CSRMAP;

      typedef union _TXP_CSRMAP_UNION {
         TXP_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TXP_CSRMAP_UNION, *PTXP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TXP_CSRMAP_UNION, sizeof (TXP_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __txp_bmap_h__

