/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_opcodes_amap_h__
#define __ioctl_opcodes_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- IOCTL_SUBSYSTEMS ---
// The IOCTLs are grouped into the following subsystems. The subsystem code along with the
// opcode uniquely identify a particular IOCTL. 
#define IOCTL_SUBSYSTEM_RSVD            (0)       // This subsystem is reserved. It is
                                                  // never used.
#define IOCTL_SUBSYSTEM_COMMON          (1)       // IOCTLs in this group are common to
                                                  // all subsystems. See
                                                  // COMMON_SUBSYSTEM_OPCODES for opcodes
                                                  // and Common Host Configuration IOCTLs
                                                  // for the IOCTL descriptions. 
#define IOCTL_SUBSYSTEM_COMMON_ISCSI    (2)       // IOCTLs in this group are common to
                                                  // iSCSI Initiator and Target. See
                                                  // COMMON_ISCSI_SUBSYSTEM_OPCODES and
                                                  // Common iSCSI Initiator and Target
                                                  // IOCTLs for the IOCTL descriptions. 
#define IOCTL_SUBSYSTEM_ETH             (3)       // This subsystem is used to execute
                                                  // Ethernet commands. See
                                                  // ETH_SUBSYSTEM_OPCODES and Ethernet
                                                  // IOCTLs for the IOCTL descriptions. 
#define IOCTL_SUBSYSTEM_TOE             (4)       // This subsystem is used to execute TOE
                                                  // commands. See TOE_SUBSYSTEM_OPCODES
                                                  // and TOE IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_PXE_UNDI        (5)       // This subsystem is used to execute PXE
                                                  // and UNDI specific commands. See
                                                  // PXE_UNDI_SUBSYSTEM_OPCODES and
                                                  // PXE/UNDI IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_ISCSI_INI       (6)       // This subsystem is used to execute
                                                  // ISCSI Initiator specific commands.
                                                  // See ISCSI_INI_SUBSYSTEM_OPCODES and
                                                  // iSCSI Initiator IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_ISCSI_TGT       (7)       // This subsystem is used to execute
                                                  // iSCSI Target specific
                                                  // commands.between PTL and ARM
                                                  // firmware. See
                                                  // ISCSI_TGT_SUBSYSTEM_OPCODES and iSCSI
                                                  // Target IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_MILI_PTL        (8)       // This subsystem is used to execute
                                                  // iSCSI Target specific
                                                  // commands.between MILI and PTL. See
                                                  // MILI_PTL_SUBSYSTEM_OPCODES and
                                                  // MILI-PTL IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_MILI_TMD        (9)       // This subsystem is used to execute
                                                  // iSCSI Target specific commands
                                                  // between MILI and TMD. See
                                                  // MILI_TMD_SUBSYSTEM_OPCODES and
                                                  // MILI-TMD IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_RDMA            (10)      // This subsystem is used to execute
                                                  // RDMA specific commands. See
                                                  // RDMA_SUBSSTEM_OPCODES. 
#define IOCTL_SUBSYSTEM_LOWLEVEL        (11)      // Low level commands used for
                                                  // diagnostic tests or non-standard
                                                  // driver operations. See
                                                  // LOWLEVEL_SUBSYSTEM_OPCODES and Low
                                                  // Level IOCTLs for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_COMMON_FCOE     (12)      // This subsystem is used for FCoE
                                                  // commands. See
                                                  // COMMON_FCOE_SUBSYSTEM_OPCODES. 
#define IOCTL_SUBSYSTEM_LRO             (13)      // This subsystem is used for Large
                                                  // Receive Offload (LRO). See
                                                  // LRO_SUBSYSTEM_OPCODES for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_DAL             (14)      // This subsystem is used for Datagram
                                                  // Access Layer (DAL). See
                                                  // DAL_SUBSYSTEM_OPCODES for the IOCTL
                                                  // descriptions. 
#define IOCTL_SUBSYSTEM_LLDP            (15)      // This subsystem is used for
                                                  // configuring the LLDP settigs used by
                                                  // DCBX and/or the ServerEngines' ICDS
                                                  // protocols. See
                                                  // LLDP_SUBSYSTEM_OPCODES. 
#define IOCTL_SUBSYSTEM_DCBX            (16)      // This subsystem is used for
                                                  // configuring the Data Center Bridging
                                                  // Capability exchange protocol. See
                                                  // DCBX_SUBSYSTEM_OPCODES. 
#define IOCTL_SUBSYSTEM_DMTF            (17)      // This subsystem is used for
                                                  // configuring the Distributed
                                                  // Management Task Force (DMTF) Command
                                                  // Line Protocol. See
                                                  // DMTF_SUBSYSTEM_OPCODES. 
#define IOCTL_SUBSYSTEM_DIAG            (18)      // Diag commands used for diagnostic
                                                  // tests or non-standard driver
                                                  // operations. See
                                                  // DIAG_SUBSYSTEM_OPCODES and Diag
                                                  // IOCTLs for the IOCTL descriptions. 
#define IOCTL_SUBSYSTEM_VENDOR          (19)      // Vendor specific ioctls are used for
                                                  // non standard ioctls defined in vendor
                                                  // specific documents. See
                                                  // VENDOR_SUBSYSTEM_OPCODES for the
                                                  // IOCTL descriptions. 

typedef enum {
   ENUM_IOCTL_SUBSYSTEM_RSVD = 0x0UL,
   ENUM_IOCTL_SUBSYSTEM_COMMON = 0x1UL,
   ENUM_IOCTL_SUBSYSTEM_COMMON_ISCSI = 0x2UL,
   ENUM_IOCTL_SUBSYSTEM_ETH = 0x3UL,
   ENUM_IOCTL_SUBSYSTEM_TOE = 0x4UL,
   ENUM_IOCTL_SUBSYSTEM_PXE_UNDI = 0x5UL,
   ENUM_IOCTL_SUBSYSTEM_ISCSI_INI = 0x6UL,
   ENUM_IOCTL_SUBSYSTEM_ISCSI_TGT = 0x7UL,
   ENUM_IOCTL_SUBSYSTEM_MILI_PTL = 0x8UL,
   ENUM_IOCTL_SUBSYSTEM_MILI_TMD = 0x9UL,
   ENUM_IOCTL_SUBSYSTEM_RDMA = 0xaUL,
   ENUM_IOCTL_SUBSYSTEM_LOWLEVEL = 0xbUL,
   ENUM_IOCTL_SUBSYSTEM_COMMON_FCOE = 0xcUL,
   ENUM_IOCTL_SUBSYSTEM_LRO = 0xdUL,
   ENUM_IOCTL_SUBSYSTEM_DAL = 0xeUL,
   ENUM_IOCTL_SUBSYSTEM_LLDP = 0xfUL,
   ENUM_IOCTL_SUBSYSTEM_DCBX = 0x10UL,
   ENUM_IOCTL_SUBSYSTEM_DMTF = 0x11UL,
   ENUM_IOCTL_SUBSYSTEM_DIAG = 0x12UL,
   ENUM_IOCTL_SUBSYSTEM_VENDOR = 0x13UL
} IOCTL_SUBSYSTEMS;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* ioctl_subsystems_get_name (u32 enum_value) {
      switch (enum_value) {
         case IOCTL_SUBSYSTEM_RSVD:
            return "IOCTL_SUBSYSTEM_RSVD";
         case IOCTL_SUBSYSTEM_COMMON:
            return "IOCTL_SUBSYSTEM_COMMON";
         case IOCTL_SUBSYSTEM_COMMON_ISCSI:
            return "IOCTL_SUBSYSTEM_COMMON_ISCSI";
         case IOCTL_SUBSYSTEM_ETH:
            return "IOCTL_SUBSYSTEM_ETH";
         case IOCTL_SUBSYSTEM_TOE:
            return "IOCTL_SUBSYSTEM_TOE";
         case IOCTL_SUBSYSTEM_PXE_UNDI:
            return "IOCTL_SUBSYSTEM_PXE_UNDI";
         case IOCTL_SUBSYSTEM_ISCSI_INI:
            return "IOCTL_SUBSYSTEM_ISCSI_INI";
         case IOCTL_SUBSYSTEM_ISCSI_TGT:
            return "IOCTL_SUBSYSTEM_ISCSI_TGT";
         case IOCTL_SUBSYSTEM_MILI_PTL:
            return "IOCTL_SUBSYSTEM_MILI_PTL";
         case IOCTL_SUBSYSTEM_MILI_TMD:
            return "IOCTL_SUBSYSTEM_MILI_TMD";
         case IOCTL_SUBSYSTEM_RDMA:
            return "IOCTL_SUBSYSTEM_RDMA";
         case IOCTL_SUBSYSTEM_LOWLEVEL:
            return "IOCTL_SUBSYSTEM_LOWLEVEL";
         case IOCTL_SUBSYSTEM_COMMON_FCOE:
            return "IOCTL_SUBSYSTEM_COMMON_FCOE";
         case IOCTL_SUBSYSTEM_LRO:
            return "IOCTL_SUBSYSTEM_LRO";
         case IOCTL_SUBSYSTEM_DAL:
            return "IOCTL_SUBSYSTEM_DAL";
         case IOCTL_SUBSYSTEM_LLDP:
            return "IOCTL_SUBSYSTEM_LLDP";
         case IOCTL_SUBSYSTEM_DCBX:
            return "IOCTL_SUBSYSTEM_DCBX";
         case IOCTL_SUBSYSTEM_DMTF:
            return "IOCTL_SUBSYSTEM_DMTF";
         case IOCTL_SUBSYSTEM_DIAG:
            return "IOCTL_SUBSYSTEM_DIAG";
         case IOCTL_SUBSYSTEM_VENDOR:
            return "IOCTL_SUBSYSTEM_VENDOR";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_SUBSYSTEM_OPCODES ---
// These opcodes are common to both networking and storage PCI functions. They are used to
// reserve resources and configure BladeEngine. These opcodes all use the
// IOCTL_SUBSYSTEM_COMMON subsystem code. 
#define OPCODE_COMMON_NTWK_MAC_QUERY    (1)       // Refer to IOCTL_COMMON_NTWK_MAC_QUERY
#define SUBSYSTEM_COMMON_NTWK_MAC_QUERY (1)       
#define SUBSYSTEM_COMMON_NTWK_MAC_SET   (1)       
#define SUBSYSTEM_COMMON_NTWK_MULTICAST_SET (1)   
#define SUBSYSTEM_COMMON_NTWK_VLAN_CONFIG (1)     
#define SUBSYSTEM_COMMON_NTWK_LINK_STATUS_QUERY (1) 
#define SUBSYSTEM_COMMON_READ_FLASHROM  (1)       
#define SUBSYSTEM_COMMON_WRITE_FLASHROM (1)       
#define SUBSYSTEM_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE (1) 
#define SUBSYSTEM_COMMON_ADD_PAGE_TABLES (1)      
#define SUBSYSTEM_COMMON_REMOVE_PAGE_TABLES (1)   
#define SUBSYSTEM_COMMON_CQ_CREATE      (1)       
#define SUBSYSTEM_COMMON_EQ_CREATE      (1)       
#define SUBSYSTEM_COMMON_MCC_CREATE     (1)       
#define SUBSYSTEM_COMMON_JELL_CONFIG    (1)       
#define SUBSYSTEM_COMMON_ADD_TEMPLATE_HEADER_BUFFERS (1) 
#define SUBSYSTEM_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS (1) 
#define SUBSYSTEM_COMMON_POST_ZERO_BUFFER (1)     
#define SUBSYSTEM_COMMON_GET_QOS        (1)       
#define SUBSYSTEM_COMMON_SET_QOS        (1)       
#define SUBSYSTEM_COMMON_TCP_GET_STATISTICS (1)   
#define SUBSYSTEM_COMMON_SEEPROM_READ   (1)       
#define SUBSYSTEM_COMMON_TCP_STATE_QUERY (1)      
#define SUBSYSTEM_COMMON_GET_CNTL_ATTRIBUTES (1)  
#define SUBSYSTEM_COMMON_NOP            (1)       
#define SUBSYSTEM_COMMON_NTWK_RX_FILTER (1)       
#define SUBSYSTEM_COMMON_GET_FW_VERSION (1)       
#define SUBSYSTEM_COMMON_SET_FLOW_CONTROL (1)     
#define SUBSYSTEM_COMMON_GET_FLOW_CONTROL (1)     
#define SUBSYSTEM_COMMON_SET_TCP_PARAMETERS (1)   
#define SUBSYSTEM_COMMON_SET_FRAME_SIZE (1)       
#define SUBSYSTEM_COMMON_GET_FAT        (1)       
#define SUBSYSTEM_COMMON_MODIFY_EQ_DELAY (1)      
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_DOMAINS (1) 
#define SUBSYSTEM_COMMON_GET_DOMAIN_CONFIG (1)    
#define SUBSYSTEM_COMMON_GET_PORT_EQUALIZATION (1) 
#define SUBSYSTEM_COMMON_SET_PORT_EQUALIZATION (1) 
#define SUBSYSTEM_COMMON_RED_CONFIG     (1)       
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_CREATE (1) 
#define SUBSYSTEM_COMMON_NTWK_INTERFACE_DESTROY (1) 
#define SUBSYSTEM_COMMON_CEV_MODIFY_MSI_MESSAGES (1) 
#define SUBSYSTEM_COMMON_MCC_DESTROY    (1)       
#define SUBSYSTEM_COMMON_CQ_DESTROY     (1)       
#define SUBSYSTEM_COMMON_EQ_DESTROY     (1)       
#define SUBSYSTEM_COMMON_TCP_UPLOAD     (1)       
#define SUBSYSTEM_COMMON_NTWK_SET_LINK_SPEED (1)  
#define SUBSYSTEM_COMMON_QUERY_FIRMWARE_CONFIG (1) 
#define SUBSYSTEM_COMMON_NTWK_PMAC_ADD  (1)       
#define SUBSYSTEM_COMMON_NTWK_PMAC_DEL  (1)       
#define SUBSYSTEM_COMMON_FUNCTION_RESET (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_PORT (1)  
#define SUBSYSTEM_COMMON_GET_PORT_CAPABILITY (1)  
#define SUBSYSTEM_COMMON_GET_PHYSICAL_FUNCTION_CONFIG (1) 
#define SUBSYSTEM_COMMON_SET_PHYSICAL_FUNCTION_CONFIG (1) 
#define SUBSYSTEM_COMMON_GET_BOOT_CONFIG (1)      
#define SUBSYSTEM_COMMON_SET_BOOT_CONFIG (1)      
#define SUBSYSTEM_COMMON_MANAGE_FAT     (1)       
#define SUBSYSTEM_COMMON_ENABLE_DISABLE_BEACON (1) 
#define SUBSYSTEM_COMMON_GET_BEACON_STATE (1)     
#define SUBSYSTEM_COMMON_GET_PORT_STATUS (1)      
#define SUBSYSTEM_COMMON_READ_PCI_CONFIG_SPACE (1) 
#define SUBSYSTEM_COMMON_READ_TRANSRECEIVER_DATA (1) 
#define SUBSYSTEM_COMMON_GET_OEM_ATTRIBUTES (1)   
#define SUBSYSTEM_COMMON_GET_PORT_NAME  (1)       
#define SUBSYSTEM_COMMON_GET_CONFIG_SIGNATURE (1) 
#define SUBSYSTEM_COMMON_SET_CONFIG_SIGNATURE (1) 
#define SUBSYSTEM_COMMON_FUNCTION_LINK_CONFIG (1) 
#define SUBSYSTEM_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES (1) 
#define SUBSYSTEM_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES (1) 
#define SUBSYSTEM_COMMON_GET_PCI_FUNCTION_MAPPING (1) 
#define SUBSYSTEM_COMMON_QUERY_PERSONALITY_CHANGE (1) 
#define SUBSYSTEM_COMMON_QUERY_CHIP_SERIAL_NUMBER (1) 
#define SUBSYSTEM_COMMON_GET_NCSI_CONFIGURATION (1) 
#define SUBSYSTEM_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION (1) 
#define SUBSYSTEM_COMMON_START_MANAGEMENT_SERVICE (1) 
#define SUBSYSTEM_COMMON_MCC_CREATE_EXT (1)       
#define SUBSYSTEM_COMMON_GET_VPD_DATA   (1)       
#define SUBSYSTEM_COMMON_SET_VPD_DATA   (1)       
#define SUBSYSTEM_COMMON_SET_VF_PRIVILEGE_LEVEL (1) 
#define SUBSYSTEM_COMMON_SET_VF_PORT_TYPE (1)     
#define SUBSYSTEM_COMMON_GET_PHY_DETAILS (1)      
#define SUBSYSTEM_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES (1) 
#define SUBSYSTEM_COMMON_GET_ADAPTER_ID (1)       
#define SUBSYSTEM_COMMON_GET_UPGRADE_FEATURES (1) 
#define SUBSYSTEM_COMMON_GET_INSTALLED_FEATURES (1) 
#define SUBSYSTEM_COMMON_GET_AVAILABLE_PERSONALITIES (1) 
#define SUBSYSTEM_COMMON_GET_CONFIGURED_PERSONALITY (1) 
#define SUBSYSTEM_COMMON_SEND_ACTIVATION (1)      
#define SUBSYSTEM_COMMON_RESET_LICENSES (1)       
#define SUBSYSTEM_COMMON_GET_FUNCTION_NAME_INFO (1) 
#define SUBSYSTEM_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES (1) 
#define SUBSYSTEM_COMMON_WRITE_PHY_FLASHROM (1)   
#define SUBSYSTEM_COMMON_GET_CAPABILITY (1)       
#define SUBSYSTEM_COMMON_SET_SWITCH_TYPE (1)      
#define SUBSYSTEM_COMMON_GET_EXT_FAT_CAPABILITES (1) 
#define SUBSYSTEM_COMMON_SET_EXT_FAT_CAPABILITES (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT (1) 
#define SUBSYSTEM_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT (1) 
#define SUBSYSTEM_COMMON_DMA_HOST_BUFFERS (1)     
#define SUBSYSTEM_COMMON_EXT_FAT_READ_STRING_TABLE (1) 
#define SUBSYSTEM_COMMON_POPULATE_SENSOR_CFG_INFO (1) 
#define SUBSYSTEM_COMMON_SET_TX_THROTTLE (1)      
#define SUBSYSTEM_COMMON_GET_TX_THROTTLE (1)      
#define OPCODE_COMMON_NTWK_MAC_SET      (2)       // Refer to IOCTL_COMMON_NTWK_MAC_SET
#define OPCODE_COMMON_NTWK_MULTICAST_SET (3)      // Refer to
                                                  // IOCTL_COMMON_NTWK_MULTICAST_SET
#define OPCODE_COMMON_NTWK_VLAN_CONFIG  (4)       // Refer to
                                                  // IOCTL_COMMON_NTWK_VLAN_CONFIG
#define OPCODE_COMMON_NTWK_LINK_STATUS_QUERY (5)  // Refer to
                                                  // IOCTL_COMMON_NTWK_LINK_STATUS_QUERY
#define OPCODE_COMMON_READ_FLASHROM     (6)       // Refer to IOCTL_COMMON_READ_FLASHROM
#define OPCODE_COMMON_WRITE_FLASHROM    (7)       // Refer to IOCTL_COMMON_WRITE_FLASHROM
#define OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE (8) // Refer to
                                                      // IOCTL_COMMON_QUERY_MAX_IOCTL_BUFF
                                                      // ER_SIZE
#define OPCODE_COMMON_ADD_PAGE_TABLES   (9)       // Refer to IOCTL_COMMON_ADD_PAGE_TABLES
#define OPCODE_COMMON_REMOVE_PAGE_TABLES (10)     // Refer to
                                                  // IOCTL_COMMON_REMOVE_PAGE_TABLES
#define OPCODE_COMMON_CQ_CREATE         (12)      // Refer to IOCTL_COMMON_CQ_CREATE
#define OPCODE_COMMON_EQ_CREATE         (13)      // Refer to IOCTL_COMMON_EQ_CREATE
#define OPCODE_COMMON_MCC_CREATE        (21)      // Refer to IOCTL_COMMON_MCC_CREATE
#define OPCODE_COMMON_JELL_CONFIG       (22)      // Refer to IOCTL_COMMON_JELL_CONFIG
#define OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS (24) // Refer to
                                                       // IOCTL_COMMON_ADD_TEMPLATE_HEADER
                                                       // _BUFFERS
#define OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS (25) // Refer to
                                                          // IOCTL_COMMON_REMOVE_TEMPLATE_
                                                          // HEADER_BUFFERS
#define OPCODE_COMMON_POST_ZERO_BUFFER  (26)      // Refer to
                                                  // IOCTL_COMMON_POST_ZERO_BUFFER
#define OPCODE_COMMON_GET_QOS           (27)      // Refer to IOCTL_COMMON_GET_QOS
#define OPCODE_COMMON_SET_QOS           (28)      // Refer to IOCTL_COMMON_SET_QOS
#define OPCODE_COMMON_TCP_GET_STATISTICS (29)     // Refer to
                                                  // IOCTL_COMMON_TCP_GET_STATISTICS
#define OPCODE_COMMON_SEEPROM_READ      (30)      // Refer to IOCTL_COMMON_SEEPROM_READ
#define OPCODE_COMMON_TCP_STATE_QUERY   (31)      // Refer to IOCTL_COMMON_TCP_STATE_QUERY
#define OPCODE_COMMON_GET_CNTL_ATTRIBUTES (32)    // Refer to
                                                  // IOCTL_COMMON_GET_CNTL_ATTRIBUTES
#define OPCODE_COMMON_NOP               (33)      // Refer to IOCTL_COMMON_NOP
#define OPCODE_COMMON_NTWK_RX_FILTER    (34)      // Refer to IOCTL_COMMON_NTWK_RX_FILTER
#define OPCODE_COMMON_GET_FW_VERSION    (35)      // Refer to IOCTL_COMMON_GET_FW_VERSION
#define OPCODE_COMMON_SET_FLOW_CONTROL  (36)      // Refer to
                                                  // IOCTL_COMMON_SET_FLOW_CONTROL
#define OPCODE_COMMON_GET_FLOW_CONTROL  (37)      // Refer to
                                                  // IOCTL_COMMON_GET_FLOW_CONTROL
#define OPCODE_COMMON_SET_TCP_PARAMETERS (38)     // Refer to
                                                  // IOCTL_COMMON_SET_TCP_PARAMETERS
#define OPCODE_COMMON_SET_FRAME_SIZE    (39)      // Refer to IOCTL_COMMON_SET_FRAME_SIZE
#define OPCODE_COMMON_GET_FAT           (40)      // Refer to IOCTL_COMMON_GET_FAT
#define OPCODE_COMMON_MODIFY_EQ_DELAY   (41)      // Refer to IOCTL_COMMON_MODIFY_EQ_DELAY
#define OPCODE_COMMON_ENABLE_DISABLE_DOMAINS (43) // Refer to
                                                  // IOCTL_COMMON_ENABLE_DISABLE_DOMAINS
#define OPCODE_COMMON_GET_DOMAIN_CONFIG (44)      // Refer to
                                                  // IOCTL_COMMON_GET_DOMAIN_CONFIG
#define OPCODE_COMMON_GET_PORT_EQUALIZATION (47)  // Refer to
                                                  // IOCTL_COMMON_GET_PORT_EQUALIZATION
#define OPCODE_COMMON_SET_PORT_EQUALIZATION (48)  // Refer to
                                                  // IOCTL_COMMON_SET_PORT_EQUALIZATION
#define OPCODE_COMMON_RED_CONFIG        (49)      // Refer to IOCTL_COMMON_RED_CONFIG
#define OPCODE_COMMON_NTWK_INTERFACE_CREATE (50)  // Refer to
                                                  // IOCTL_COMMON_NTWK_INTERFACE_CREATE
#define OPCODE_COMMON_NTWK_INTERFACE_DESTROY (51) // Refer to
                                                  // IOCTL_COMMON_NTWK_INTERFACE_DESTROY
#define OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES (52) // Refer to
                                                   // IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES
#define OPCODE_COMMON_MCC_DESTROY       (53)      // Refer to IOCTL_COMMON_MCC_DESTROY
#define OPCODE_COMMON_CQ_DESTROY        (54)      // Refer to IOCTL_COMMON_CQ_DESTROY
#define OPCODE_COMMON_EQ_DESTROY        (55)      // Refer to IOCTL_COMMON_EQ_DESTROY
#define OPCODE_COMMON_TCP_UPLOAD        (56)      // Refer to IOCTL_COMMON_TCP_UPLOAD
#define OPCODE_COMMON_NTWK_SET_LINK_SPEED (57)    // Refer to
                                                  // IOCTL_COMMON_NTWK_SET_LINK_SPEED
#define OPCODE_COMMON_QUERY_FIRMWARE_CONFIG (58)  // Refer to
                                                  // IOCTL_COMMON_QUERY_FIRMWARE_CONFIG
#define OPCODE_COMMON_NTWK_PMAC_ADD     (59)      // Refer to IOCTL_COMMON_NTWK_PMAC_ADD
#define OPCODE_COMMON_NTWK_PMAC_DEL     (60)      // Refer to IOCTL_COMMON_NTWK_PMAC_DEL
#define OPCODE_COMMON_FUNCTION_RESET    (61)      // Refer to IOCTL_COMMON_FUNCTION_RESET
#define OPCODE_COMMON_ENABLE_DISABLE_PORT (62)    // Refer to
                                                  // IOCTL_COMMON_ENABLE_DISABLE_PORT
#define OPCODE_COMMON_GET_PORT_CAPABILITY (63)    // Refer to
                                                  // IOCTL_COMMON_GET_PORT_CAPABILITY
#define OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG (64) // Refer to
                                                        // IOCTL_COMMON_GET_PHYSICAL_FUNCT
                                                        // ION_CONFIG
#define OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG (65) // Refer to
                                                        // IOCTL_COMMON_SET_PHYSICAL_FUNCT
                                                        // ION_CONFIG
#define OPCODE_COMMON_GET_BOOT_CONFIG   (66)      // Refer to IOCTL_COMMON_GET_BOOT_CONFIG
#define OPCODE_COMMON_SET_BOOT_CONFIG   (67)      // Refer to IOCTL_COMMON_SET_BOOT_CONFIG
#define OPCODE_COMMON_MANAGE_FAT        (68)      // Refer to IOCTL_COMMON_MANAGE_FAT
#define OPCODE_COMMON_ENABLE_DISABLE_BEACON (69)  // Refer to
                                                  // IOCTL_COMMON_ENABLE_DISABLE_BEACON
#define OPCODE_COMMON_GET_BEACON_STATE  (70)      // Refer to
                                                  // IOCTL_COMMON_GET_BEACON_STATE
#define OPCODE_COMMON_GET_PORT_STATUS   (71)      // Refer to IOCTL_COMMON_GET_PORT_STATUS
#define OPCODE_COMMON_READ_PCI_CONFIG_SPACE (72)  // Refer to
                                                  // IOCTL_COMMON_READ_PCI_CONFIG_SPACE
#define OPCODE_COMMON_READ_TRANSRECEIVER_DATA (73) // Refer to
                                                   // IOCTL_COMMON_READ_TRANSRECEIVER_DATA
#define OPCODE_COMMON_GET_OEM_ATTRIBUTES (76)     // Refer to
                                                  // IOCTL_COMMON_GET_OEM_ATTRIBUTES
#define OPCODE_COMMON_GET_PORT_NAME     (77)      // Refer to IOCTL_COMMON_GET_PORT_NAME
#define OPCODE_COMMON_GET_CONFIG_SIGNATURE (78)   // Refer to
                                                  // IOCTL_COMMON_GET_CONFIG_SIGNATURE
#define OPCODE_COMMON_SET_CONFIG_SIGNATURE (79)   // Refer to
                                                  // IOCTL_COMMON_SET_CONFIG_SIGNATURE
#define OPCODE_COMMON_FUNCTION_LINK_CONFIG (80)   // Refer to
                                                  // IOCTL_COMMON_FUNCTION_LINK_CONFIG
#define OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES (81) // Refer to
                                                              // IOCTL_COMMON_GET_BE_CONFI
                                                              // GURATION_AND_RESOURCES
#define OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES (82) // Refer to
                                                              // IOCTL_COMMON_SET_BE_CONFI
                                                              // GURATION_AND_RESOURCES
#define OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING (83) // Refer to
                                                    // IOCTL_COMMON_GET_PCI_FUNCTION_MAPPI
                                                    // NG
#define OPCODE_COMMON_QUERY_PERSONALITY_CHANGE (84) // Refer to
                                                    // IOCTL_COMMON_QUERY_PERSONALITY_CHAN
                                                    // GE
#define OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER (85) // Refer to
                                                    // IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMB
                                                    // ER
#define OPCODE_COMMON_GET_NCSI_CONFIGURATION (86) // Refer to
                                                  // IOCTL_COMMON_GET_NCSI_CONFIGURATION
#define OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION (87) // Refer to
                                                          // IOCTL_COMMON_SET_NCSI_DYNAMIC
                                                          // _CONFIGURATION
#define OPCODE_COMMON_START_MANAGEMENT_SERVICE (88) // Refer to
                                                    // IOCTL_COMMON_START_MANAGEMENT_SERVI
                                                    // CE
#define OPCODE_COMMON_MCC_CREATE_EXT    (90)      // Refer to IOCTL_COMMON_MCC_CREATE_EXT
#define OPCODE_COMMON_GET_VPD_DATA      (91)      // Refer to IOCTL_COMMON_GET_VPD_DATA
#define OPCODE_COMMON_SET_VPD_DATA      (92)      // Refer to IOCTL_COMMON_SET_VPD_DATA
#define OPCODE_COMMON_SET_VF_PRIVILEGE_LEVEL (100) // Refer to
                                                   // IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL
#define OPCODE_COMMON_SET_VF_PORT_TYPE  (101)     // Refer to
                                                  // IOCTL_COMMON_SET_VF_PORT_TYPE
#define OPCODE_COMMON_GET_PHY_DETAILS   (102)     // Refer to IOCTL_COMMON_GET_PHY_DETAILS
#define OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES (103) // Refer to
                                                             // IOCTL_COMMON_SET_DRIVER_FU
                                                             // NCTION_CAPABILITIES
#define OPCODE_COMMON_GET_ADAPTER_ID    (110)     // Refer to IOCTL_COMMON_GET_ADAPTER_ID
#define OPCODE_COMMON_GET_UPGRADE_FEATURES (111)  // Refer to
                                                  // IOCTL_COMMON_GET_UPGRADE_FEATURES
#define OPCODE_COMMON_GET_INSTALLED_FEATURES (112) // Refer to
                                                   // IOCTL_COMMON_GET_INSTALLED_FEATURES
#define OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES (113) // Refer to
                                                        // IOCTL_COMMON_GET_AVAILABLE_PERS
                                                        // ONALITIES
#define OPCODE_COMMON_GET_CONFIGURED_PERSONALITY (114) // Refer to
                                                       // IOCTL_COMMON_GET_CONFIGURED_PERS
                                                       // ONALITY
#define OPCODE_COMMON_SEND_ACTIVATION   (115)     // Refer to IOCTL_COMMON_SEND_ACTIVATION
#define OPCODE_COMMON_RESET_LICENSES    (116)     // Refer to IOCTL_COMMON_RESET_LICENSES
#define OPCODE_COMMON_GET_FUNCTION_NAME_INFO (120) // Refer to
                                                   // IOCTL_COMMON_GET_FUNCTION_NAME_INFO
#define OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES (121) // Refer to
                                                           // IOCTL_COMMON_GET_CNTL_ADDITI
                                                           // ONAL_ATTRIBUTES
#define OPCODE_COMMON_WRITE_PHY_FLASHROM (122)    // Refer to
                                                  // IOCTL_COMMON_WRITE_PHY_FLASHROM
#define OPCODE_COMMON_GET_CAPABILITY    (123)     // Refer to IOCTL_COMMON_GET_CAPABILITY
#define OPCODE_COMMON_SET_SWITCH_TYPE   (124)     // Refer to IOCTL_COMMON_SET_SWITCH_TYPE
#define OPCODE_COMMON_GET_EXT_FAT_CAPABILITES (125) // Refer to
                                                    // IOCTL_COMMON_GET_EXT_FAT_CAPABILITE
                                                    // S
#define OPCODE_COMMON_SET_EXT_FAT_CAPABILITES (126) // Refer to
                                                    // IOCTL_COMMON_SET_EXT_FAT_CAPABILITE
                                                    // S
#define OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT (127) // Refer to
                                                       // IOCTL_COMMON_EXT_FAT_CONFIGURE_S
                                                       // NAPSHOT
#define OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT (128) // Refer to
                                                      // IOCTL_COMMON_EXT_FAT_RETRIEVE_SNA
                                                      // PSHOT
#define OPCODE_COMMON_DMA_HOST_BUFFERS  (129)     // Refer to
                                                  // IOCTL_COMMON_DMA_HOST_BUFFERS
#define OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE (130) // Refer to
                                                      // IOCTL_COMMON_EXT_FAT_READ_STRING_
                                                      // TABLE
#define OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO (131) // Refer to
                                                     // IOCTL_COMMON_POPULATE_SENSOR_CFG_I
                                                     // NFO
#define OPCODE_COMMON_SET_TX_THROTTLE   (132)     // Refer to IOCTL_COMMON_SET_TX_THROTTLE
#define OPCODE_COMMON_GET_TX_THROTTLE   (133)     // Refer to IOCTL_COMMON_GET_TX_THROTTLE

typedef enum {
   ENUM_OPCODE_COMMON_NTWK_MAC_QUERY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_MAC_QUERY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_MAC_SET = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_MULTICAST_SET = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_VLAN_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_LINK_STATUS_QUERY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_READ_FLASHROM = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_WRITE_FLASHROM = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_ADD_PAGE_TABLES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_REMOVE_PAGE_TABLES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_CQ_CREATE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_EQ_CREATE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_MCC_CREATE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_JELL_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_ADD_TEMPLATE_HEADER_BUFFERS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_POST_ZERO_BUFFER = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_QOS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_QOS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_TCP_GET_STATISTICS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SEEPROM_READ = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_TCP_STATE_QUERY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_CNTL_ATTRIBUTES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NOP = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_RX_FILTER = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_FW_VERSION = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_FLOW_CONTROL = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_FLOW_CONTROL = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_TCP_PARAMETERS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_FRAME_SIZE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_FAT = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_MODIFY_EQ_DELAY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_ENABLE_DISABLE_DOMAINS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_DOMAIN_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PORT_EQUALIZATION = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_PORT_EQUALIZATION = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_RED_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_INTERFACE_CREATE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_INTERFACE_DESTROY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_CEV_MODIFY_MSI_MESSAGES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_MCC_DESTROY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_CQ_DESTROY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_EQ_DESTROY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_TCP_UPLOAD = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_SET_LINK_SPEED = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_QUERY_FIRMWARE_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_PMAC_ADD = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_NTWK_PMAC_DEL = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_FUNCTION_RESET = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_ENABLE_DISABLE_PORT = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PORT_CAPABILITY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PHYSICAL_FUNCTION_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_PHYSICAL_FUNCTION_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_BOOT_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_BOOT_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_MANAGE_FAT = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_ENABLE_DISABLE_BEACON = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_BEACON_STATE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PORT_STATUS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_READ_PCI_CONFIG_SPACE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_READ_TRANSRECEIVER_DATA = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_OEM_ATTRIBUTES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PORT_NAME = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_CONFIG_SIGNATURE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_CONFIG_SIGNATURE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_FUNCTION_LINK_CONFIG = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PCI_FUNCTION_MAPPING = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_QUERY_PERSONALITY_CHANGE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_QUERY_CHIP_SERIAL_NUMBER = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_NCSI_CONFIGURATION = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_START_MANAGEMENT_SERVICE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_MCC_CREATE_EXT = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_VPD_DATA = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_VPD_DATA = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_VF_PRIVILEGE_LEVEL = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_VF_PORT_TYPE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_PHY_DETAILS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_ADAPTER_ID = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_UPGRADE_FEATURES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_INSTALLED_FEATURES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_AVAILABLE_PERSONALITIES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_CONFIGURED_PERSONALITY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SEND_ACTIVATION = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_RESET_LICENSES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_FUNCTION_NAME_INFO = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_WRITE_PHY_FLASHROM = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_CAPABILITY = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_SWITCH_TYPE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_EXT_FAT_CAPABILITES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_EXT_FAT_CAPABILITES = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_DMA_HOST_BUFFERS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_EXT_FAT_READ_STRING_TABLE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_POPULATE_SENSOR_CFG_INFO = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_SET_TX_THROTTLE = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_GET_TX_THROTTLE = 0x1UL,
   ENUM_OPCODE_COMMON_NTWK_MAC_SET = 0x2UL,
   ENUM_OPCODE_COMMON_NTWK_MULTICAST_SET = 0x3UL,
   ENUM_OPCODE_COMMON_NTWK_VLAN_CONFIG = 0x4UL,
   ENUM_OPCODE_COMMON_NTWK_LINK_STATUS_QUERY = 0x5UL,
   ENUM_OPCODE_COMMON_READ_FLASHROM = 0x6UL,
   ENUM_OPCODE_COMMON_WRITE_FLASHROM = 0x7UL,
   ENUM_OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE = 0x8UL,
   ENUM_OPCODE_COMMON_ADD_PAGE_TABLES = 0x9UL,
   ENUM_OPCODE_COMMON_REMOVE_PAGE_TABLES = 0xaUL,
   ENUM_OPCODE_COMMON_CQ_CREATE = 0xcUL,
   ENUM_OPCODE_COMMON_EQ_CREATE = 0xdUL,
   ENUM_OPCODE_COMMON_MCC_CREATE = 0x15UL,
   ENUM_OPCODE_COMMON_JELL_CONFIG = 0x16UL,
   ENUM_OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS = 0x18UL,
   ENUM_OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS = 0x19UL,
   ENUM_OPCODE_COMMON_POST_ZERO_BUFFER = 0x1aUL,
   ENUM_OPCODE_COMMON_GET_QOS = 0x1bUL,
   ENUM_OPCODE_COMMON_SET_QOS = 0x1cUL,
   ENUM_OPCODE_COMMON_TCP_GET_STATISTICS = 0x1dUL,
   ENUM_OPCODE_COMMON_SEEPROM_READ = 0x1eUL,
   ENUM_OPCODE_COMMON_TCP_STATE_QUERY = 0x1fUL,
   ENUM_OPCODE_COMMON_GET_CNTL_ATTRIBUTES = 0x20UL,
   ENUM_OPCODE_COMMON_NOP = 0x21UL,
   ENUM_OPCODE_COMMON_NTWK_RX_FILTER = 0x22UL,
   ENUM_OPCODE_COMMON_GET_FW_VERSION = 0x23UL,
   ENUM_OPCODE_COMMON_SET_FLOW_CONTROL = 0x24UL,
   ENUM_OPCODE_COMMON_GET_FLOW_CONTROL = 0x25UL,
   ENUM_OPCODE_COMMON_SET_TCP_PARAMETERS = 0x26UL,
   ENUM_OPCODE_COMMON_SET_FRAME_SIZE = 0x27UL,
   ENUM_OPCODE_COMMON_GET_FAT = 0x28UL,
   ENUM_OPCODE_COMMON_MODIFY_EQ_DELAY = 0x29UL,
   ENUM_OPCODE_COMMON_ENABLE_DISABLE_DOMAINS = 0x2bUL,
   ENUM_OPCODE_COMMON_GET_DOMAIN_CONFIG = 0x2cUL,
   ENUM_OPCODE_COMMON_GET_PORT_EQUALIZATION = 0x2fUL,
   ENUM_OPCODE_COMMON_SET_PORT_EQUALIZATION = 0x30UL,
   ENUM_OPCODE_COMMON_RED_CONFIG = 0x31UL,
   ENUM_OPCODE_COMMON_NTWK_INTERFACE_CREATE = 0x32UL,
   ENUM_OPCODE_COMMON_NTWK_INTERFACE_DESTROY = 0x33UL,
   ENUM_OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES = 0x34UL,
   ENUM_OPCODE_COMMON_MCC_DESTROY = 0x35UL,
   ENUM_OPCODE_COMMON_CQ_DESTROY = 0x36UL,
   ENUM_OPCODE_COMMON_EQ_DESTROY = 0x37UL,
   ENUM_OPCODE_COMMON_TCP_UPLOAD = 0x38UL,
   ENUM_OPCODE_COMMON_NTWK_SET_LINK_SPEED = 0x39UL,
   ENUM_OPCODE_COMMON_QUERY_FIRMWARE_CONFIG = 0x3aUL,
   ENUM_OPCODE_COMMON_NTWK_PMAC_ADD = 0x3bUL,
   ENUM_OPCODE_COMMON_NTWK_PMAC_DEL = 0x3cUL,
   ENUM_OPCODE_COMMON_FUNCTION_RESET = 0x3dUL,
   ENUM_OPCODE_COMMON_ENABLE_DISABLE_PORT = 0x3eUL,
   ENUM_OPCODE_COMMON_GET_PORT_CAPABILITY = 0x3fUL,
   ENUM_OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG = 0x40UL,
   ENUM_OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG = 0x41UL,
   ENUM_OPCODE_COMMON_GET_BOOT_CONFIG = 0x42UL,
   ENUM_OPCODE_COMMON_SET_BOOT_CONFIG = 0x43UL,
   ENUM_OPCODE_COMMON_MANAGE_FAT = 0x44UL,
   ENUM_OPCODE_COMMON_ENABLE_DISABLE_BEACON = 0x45UL,
   ENUM_OPCODE_COMMON_GET_BEACON_STATE = 0x46UL,
   ENUM_OPCODE_COMMON_GET_PORT_STATUS = 0x47UL,
   ENUM_OPCODE_COMMON_READ_PCI_CONFIG_SPACE = 0x48UL,
   ENUM_OPCODE_COMMON_READ_TRANSRECEIVER_DATA = 0x49UL,
   ENUM_OPCODE_COMMON_GET_OEM_ATTRIBUTES = 0x4cUL,
   ENUM_OPCODE_COMMON_GET_PORT_NAME = 0x4dUL,
   ENUM_OPCODE_COMMON_GET_CONFIG_SIGNATURE = 0x4eUL,
   ENUM_OPCODE_COMMON_SET_CONFIG_SIGNATURE = 0x4fUL,
   ENUM_OPCODE_COMMON_FUNCTION_LINK_CONFIG = 0x50UL,
   ENUM_OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES = 0x51UL,
   ENUM_OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES = 0x52UL,
   ENUM_OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING = 0x53UL,
   ENUM_OPCODE_COMMON_QUERY_PERSONALITY_CHANGE = 0x54UL,
   ENUM_OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER = 0x55UL,
   ENUM_OPCODE_COMMON_GET_NCSI_CONFIGURATION = 0x56UL,
   ENUM_OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION = 0x57UL,
   ENUM_OPCODE_COMMON_START_MANAGEMENT_SERVICE = 0x58UL,
   ENUM_OPCODE_COMMON_MCC_CREATE_EXT = 0x5aUL,
   ENUM_OPCODE_COMMON_GET_VPD_DATA = 0x5bUL,
   ENUM_OPCODE_COMMON_SET_VPD_DATA = 0x5cUL,
   ENUM_OPCODE_COMMON_SET_VF_PRIVILEGE_LEVEL = 0x64UL,
   ENUM_OPCODE_COMMON_SET_VF_PORT_TYPE = 0x65UL,
   ENUM_OPCODE_COMMON_GET_PHY_DETAILS = 0x66UL,
   ENUM_OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES = 0x67UL,
   ENUM_OPCODE_COMMON_GET_ADAPTER_ID = 0x6eUL,
   ENUM_OPCODE_COMMON_GET_UPGRADE_FEATURES = 0x6fUL,
   ENUM_OPCODE_COMMON_GET_INSTALLED_FEATURES = 0x70UL,
   ENUM_OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES = 0x71UL,
   ENUM_OPCODE_COMMON_GET_CONFIGURED_PERSONALITY = 0x72UL,
   ENUM_OPCODE_COMMON_SEND_ACTIVATION = 0x73UL,
   ENUM_OPCODE_COMMON_RESET_LICENSES = 0x74UL,
   ENUM_OPCODE_COMMON_GET_FUNCTION_NAME_INFO = 0x78UL,
   ENUM_OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES = 0x79UL,
   ENUM_OPCODE_COMMON_WRITE_PHY_FLASHROM = 0x7aUL,
   ENUM_OPCODE_COMMON_GET_CAPABILITY = 0x7bUL,
   ENUM_OPCODE_COMMON_SET_SWITCH_TYPE = 0x7cUL,
   ENUM_OPCODE_COMMON_GET_EXT_FAT_CAPABILITES = 0x7dUL,
   ENUM_OPCODE_COMMON_SET_EXT_FAT_CAPABILITES = 0x7eUL,
   ENUM_OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT = 0x7fUL,
   ENUM_OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT = 0x80UL,
   ENUM_OPCODE_COMMON_DMA_HOST_BUFFERS = 0x81UL,
   ENUM_OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE = 0x82UL,
   ENUM_OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO = 0x83UL,
   ENUM_OPCODE_COMMON_SET_TX_THROTTLE = 0x84UL,
   ENUM_OPCODE_COMMON_GET_TX_THROTTLE = 0x85UL
} COMMON_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_NTWK_MAC_QUERY:
            return "OPCODE_COMMON_NTWK_MAC_QUERY";
         case OPCODE_COMMON_NTWK_MAC_SET:
            return "OPCODE_COMMON_NTWK_MAC_SET";
         case OPCODE_COMMON_NTWK_MULTICAST_SET:
            return "OPCODE_COMMON_NTWK_MULTICAST_SET";
         case OPCODE_COMMON_NTWK_VLAN_CONFIG:
            return "OPCODE_COMMON_NTWK_VLAN_CONFIG";
         case OPCODE_COMMON_NTWK_LINK_STATUS_QUERY:
            return "OPCODE_COMMON_NTWK_LINK_STATUS_QUERY";
         case OPCODE_COMMON_READ_FLASHROM:
            return "OPCODE_COMMON_READ_FLASHROM";
         case OPCODE_COMMON_WRITE_FLASHROM:
            return "OPCODE_COMMON_WRITE_FLASHROM";
         case OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE:
            return "OPCODE_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE";
         case OPCODE_COMMON_ADD_PAGE_TABLES:
            return "OPCODE_COMMON_ADD_PAGE_TABLES";
         case OPCODE_COMMON_REMOVE_PAGE_TABLES:
            return "OPCODE_COMMON_REMOVE_PAGE_TABLES";
         case OPCODE_COMMON_CQ_CREATE:
            return "OPCODE_COMMON_CQ_CREATE";
         case OPCODE_COMMON_EQ_CREATE:
            return "OPCODE_COMMON_EQ_CREATE";
         case OPCODE_COMMON_MCC_CREATE:
            return "OPCODE_COMMON_MCC_CREATE";
         case OPCODE_COMMON_JELL_CONFIG:
            return "OPCODE_COMMON_JELL_CONFIG";
         case OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS:
            return "OPCODE_COMMON_ADD_TEMPLATE_HEADER_BUFFERS";
         case OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS:
            return "OPCODE_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS";
         case OPCODE_COMMON_POST_ZERO_BUFFER:
            return "OPCODE_COMMON_POST_ZERO_BUFFER";
         case OPCODE_COMMON_GET_QOS:
            return "OPCODE_COMMON_GET_QOS";
         case OPCODE_COMMON_SET_QOS:
            return "OPCODE_COMMON_SET_QOS";
         case OPCODE_COMMON_TCP_GET_STATISTICS:
            return "OPCODE_COMMON_TCP_GET_STATISTICS";
         case OPCODE_COMMON_SEEPROM_READ:
            return "OPCODE_COMMON_SEEPROM_READ";
         case OPCODE_COMMON_TCP_STATE_QUERY:
            return "OPCODE_COMMON_TCP_STATE_QUERY";
         case OPCODE_COMMON_GET_CNTL_ATTRIBUTES:
            return "OPCODE_COMMON_GET_CNTL_ATTRIBUTES";
         case OPCODE_COMMON_NOP:
            return "OPCODE_COMMON_NOP";
         case OPCODE_COMMON_NTWK_RX_FILTER:
            return "OPCODE_COMMON_NTWK_RX_FILTER";
         case OPCODE_COMMON_GET_FW_VERSION:
            return "OPCODE_COMMON_GET_FW_VERSION";
         case OPCODE_COMMON_SET_FLOW_CONTROL:
            return "OPCODE_COMMON_SET_FLOW_CONTROL";
         case OPCODE_COMMON_GET_FLOW_CONTROL:
            return "OPCODE_COMMON_GET_FLOW_CONTROL";
         case OPCODE_COMMON_SET_TCP_PARAMETERS:
            return "OPCODE_COMMON_SET_TCP_PARAMETERS";
         case OPCODE_COMMON_SET_FRAME_SIZE:
            return "OPCODE_COMMON_SET_FRAME_SIZE";
         case OPCODE_COMMON_GET_FAT:
            return "OPCODE_COMMON_GET_FAT";
         case OPCODE_COMMON_MODIFY_EQ_DELAY:
            return "OPCODE_COMMON_MODIFY_EQ_DELAY";
         case OPCODE_COMMON_ENABLE_DISABLE_DOMAINS:
            return "OPCODE_COMMON_ENABLE_DISABLE_DOMAINS";
         case OPCODE_COMMON_GET_DOMAIN_CONFIG:
            return "OPCODE_COMMON_GET_DOMAIN_CONFIG";
         case OPCODE_COMMON_GET_PORT_EQUALIZATION:
            return "OPCODE_COMMON_GET_PORT_EQUALIZATION";
         case OPCODE_COMMON_SET_PORT_EQUALIZATION:
            return "OPCODE_COMMON_SET_PORT_EQUALIZATION";
         case OPCODE_COMMON_RED_CONFIG:
            return "OPCODE_COMMON_RED_CONFIG";
         case OPCODE_COMMON_NTWK_INTERFACE_CREATE:
            return "OPCODE_COMMON_NTWK_INTERFACE_CREATE";
         case OPCODE_COMMON_NTWK_INTERFACE_DESTROY:
            return "OPCODE_COMMON_NTWK_INTERFACE_DESTROY";
         case OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES:
            return "OPCODE_COMMON_CEV_MODIFY_MSI_MESSAGES";
         case OPCODE_COMMON_MCC_DESTROY:
            return "OPCODE_COMMON_MCC_DESTROY";
         case OPCODE_COMMON_CQ_DESTROY:
            return "OPCODE_COMMON_CQ_DESTROY";
         case OPCODE_COMMON_EQ_DESTROY:
            return "OPCODE_COMMON_EQ_DESTROY";
         case OPCODE_COMMON_TCP_UPLOAD:
            return "OPCODE_COMMON_TCP_UPLOAD";
         case OPCODE_COMMON_NTWK_SET_LINK_SPEED:
            return "OPCODE_COMMON_NTWK_SET_LINK_SPEED";
         case OPCODE_COMMON_QUERY_FIRMWARE_CONFIG:
            return "OPCODE_COMMON_QUERY_FIRMWARE_CONFIG";
         case OPCODE_COMMON_NTWK_PMAC_ADD:
            return "OPCODE_COMMON_NTWK_PMAC_ADD";
         case OPCODE_COMMON_NTWK_PMAC_DEL:
            return "OPCODE_COMMON_NTWK_PMAC_DEL";
         case OPCODE_COMMON_FUNCTION_RESET:
            return "OPCODE_COMMON_FUNCTION_RESET";
         case OPCODE_COMMON_ENABLE_DISABLE_PORT:
            return "OPCODE_COMMON_ENABLE_DISABLE_PORT";
         case OPCODE_COMMON_GET_PORT_CAPABILITY:
            return "OPCODE_COMMON_GET_PORT_CAPABILITY";
         case OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG:
            return "OPCODE_COMMON_GET_PHYSICAL_FUNCTION_CONFIG";
         case OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG:
            return "OPCODE_COMMON_SET_PHYSICAL_FUNCTION_CONFIG";
         case OPCODE_COMMON_GET_BOOT_CONFIG:
            return "OPCODE_COMMON_GET_BOOT_CONFIG";
         case OPCODE_COMMON_SET_BOOT_CONFIG:
            return "OPCODE_COMMON_SET_BOOT_CONFIG";
         case OPCODE_COMMON_MANAGE_FAT:
            return "OPCODE_COMMON_MANAGE_FAT";
         case OPCODE_COMMON_ENABLE_DISABLE_BEACON:
            return "OPCODE_COMMON_ENABLE_DISABLE_BEACON";
         case OPCODE_COMMON_GET_BEACON_STATE:
            return "OPCODE_COMMON_GET_BEACON_STATE";
         case OPCODE_COMMON_GET_PORT_STATUS:
            return "OPCODE_COMMON_GET_PORT_STATUS";
         case OPCODE_COMMON_READ_PCI_CONFIG_SPACE:
            return "OPCODE_COMMON_READ_PCI_CONFIG_SPACE";
         case OPCODE_COMMON_READ_TRANSRECEIVER_DATA:
            return "OPCODE_COMMON_READ_TRANSRECEIVER_DATA";
         case OPCODE_COMMON_GET_OEM_ATTRIBUTES:
            return "OPCODE_COMMON_GET_OEM_ATTRIBUTES";
         case OPCODE_COMMON_GET_PORT_NAME:
            return "OPCODE_COMMON_GET_PORT_NAME";
         case OPCODE_COMMON_GET_CONFIG_SIGNATURE:
            return "OPCODE_COMMON_GET_CONFIG_SIGNATURE";
         case OPCODE_COMMON_SET_CONFIG_SIGNATURE:
            return "OPCODE_COMMON_SET_CONFIG_SIGNATURE";
         case OPCODE_COMMON_FUNCTION_LINK_CONFIG:
            return "OPCODE_COMMON_FUNCTION_LINK_CONFIG";
         case OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES:
            return "OPCODE_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES";
         case OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES:
            return "OPCODE_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES";
         case OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING:
            return "OPCODE_COMMON_GET_PCI_FUNCTION_MAPPING";
         case OPCODE_COMMON_QUERY_PERSONALITY_CHANGE:
            return "OPCODE_COMMON_QUERY_PERSONALITY_CHANGE";
         case OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER:
            return "OPCODE_COMMON_QUERY_CHIP_SERIAL_NUMBER";
         case OPCODE_COMMON_GET_NCSI_CONFIGURATION:
            return "OPCODE_COMMON_GET_NCSI_CONFIGURATION";
         case OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION:
            return "OPCODE_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION";
         case OPCODE_COMMON_START_MANAGEMENT_SERVICE:
            return "OPCODE_COMMON_START_MANAGEMENT_SERVICE";
         case OPCODE_COMMON_MCC_CREATE_EXT:
            return "OPCODE_COMMON_MCC_CREATE_EXT";
         case OPCODE_COMMON_GET_VPD_DATA:
            return "OPCODE_COMMON_GET_VPD_DATA";
         case OPCODE_COMMON_SET_VPD_DATA:
            return "OPCODE_COMMON_SET_VPD_DATA";
         case OPCODE_COMMON_SET_VF_PRIVILEGE_LEVEL:
            return "OPCODE_COMMON_SET_VF_PRIVILEGE_LEVEL";
         case OPCODE_COMMON_SET_VF_PORT_TYPE:
            return "OPCODE_COMMON_SET_VF_PORT_TYPE";
         case OPCODE_COMMON_GET_PHY_DETAILS:
            return "OPCODE_COMMON_GET_PHY_DETAILS";
         case OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES:
            return "OPCODE_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES";
         case OPCODE_COMMON_GET_ADAPTER_ID:
            return "OPCODE_COMMON_GET_ADAPTER_ID";
         case OPCODE_COMMON_GET_UPGRADE_FEATURES:
            return "OPCODE_COMMON_GET_UPGRADE_FEATURES";
         case OPCODE_COMMON_GET_INSTALLED_FEATURES:
            return "OPCODE_COMMON_GET_INSTALLED_FEATURES";
         case OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES:
            return "OPCODE_COMMON_GET_AVAILABLE_PERSONALITIES";
         case OPCODE_COMMON_GET_CONFIGURED_PERSONALITY:
            return "OPCODE_COMMON_GET_CONFIGURED_PERSONALITY";
         case OPCODE_COMMON_SEND_ACTIVATION:
            return "OPCODE_COMMON_SEND_ACTIVATION";
         case OPCODE_COMMON_RESET_LICENSES:
            return "OPCODE_COMMON_RESET_LICENSES";
         case OPCODE_COMMON_GET_FUNCTION_NAME_INFO:
            return "OPCODE_COMMON_GET_FUNCTION_NAME_INFO";
         case OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES:
            return "OPCODE_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES";
         case OPCODE_COMMON_WRITE_PHY_FLASHROM:
            return "OPCODE_COMMON_WRITE_PHY_FLASHROM";
         case OPCODE_COMMON_GET_CAPABILITY:
            return "OPCODE_COMMON_GET_CAPABILITY";
         case OPCODE_COMMON_SET_SWITCH_TYPE:
            return "OPCODE_COMMON_SET_SWITCH_TYPE";
         case OPCODE_COMMON_GET_EXT_FAT_CAPABILITES:
            return "OPCODE_COMMON_GET_EXT_FAT_CAPABILITES";
         case OPCODE_COMMON_SET_EXT_FAT_CAPABILITES:
            return "OPCODE_COMMON_SET_EXT_FAT_CAPABILITES";
         case OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT:
            return "OPCODE_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT";
         case OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT:
            return "OPCODE_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT";
         case OPCODE_COMMON_DMA_HOST_BUFFERS:
            return "OPCODE_COMMON_DMA_HOST_BUFFERS";
         case OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE:
            return "OPCODE_COMMON_EXT_FAT_READ_STRING_TABLE";
         case OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO:
            return "OPCODE_COMMON_POPULATE_SENSOR_CFG_INFO";
         case OPCODE_COMMON_SET_TX_THROTTLE:
            return "OPCODE_COMMON_SET_TX_THROTTLE";
         case OPCODE_COMMON_GET_TX_THROTTLE:
            return "OPCODE_COMMON_GET_TX_THROTTLE";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_ISCSI_SUBSYSTEM_OPCODES ---
// IOCTLs used to configure discovery and networking parameters in iSCSI Initiator and
// Target modes. These opcodes all use the IOCTL_SUBSYSTEM_COMMON_ISCSI subsystem code. 
#define OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS (1) // Refer to
                                                                   // IOCTL_COMMON_ISCSI_E
                                                                   // RROR_RECOVERY_INVALI
                                                                   // DATE_COMMANDS
#define SUBSYSTEM_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS (2) 
#define OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES (2) // Refer to
                                                   // IOCTL_COMMON_ISCSI_CFG_POST_SGL_PAGE
                                                   // S
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_SGL_PAGES (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_POST_OOO_BUFFERS (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_PING (2)      
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_NIC_CONFIG (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ARP_TABLE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ARP_TABLE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_CREATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_DELETE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_VLAN (2)  
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_PING_STATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_PING_STATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ALL_IF_ID (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IF_INFO (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES (2) 
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS (2) 
#define SUBSYSTEM_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES (2) 
#define SUBSYSTEM_COMMON_ISCSI_STATS_GET_NIC_STATISTICS (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_DOWNLOAD_XML (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_DELETE_XML (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_RX_STATS (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_TX_STATS (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_GROUP (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_DELETE_GROUP (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_QMSTATS (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_MMSTATS (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_STATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_PSK (2)  
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_GUID (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_PSK (2)  
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_GROUP_PSK (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE (2) 
#define SUBSYSTEM_COMMON_ISCSI_IPSEC_ENABLE_DISABLE (2) 
#define SUBSYSTEM_COMMON_ISCSI_CLEANUP  (2)       
#define SUBSYSTEM_COMMON_ISCSI_ADD_8BYTE_LUN (2)  
#define SUBSYSTEM_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG (2) 
#define SUBSYSTEM_COMMON_ISCSI_CFG_READ_EVENT_LOG (2) 
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_CREATE (2)    
#define SUBSYSTEM_COMMON_ISCSI_DEFQ_DESTROY (2)   
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_CREATE (2)    
#define SUBSYSTEM_COMMON_ISCSI_WRBQ_DESTROY (2)   
#define SUBSYSTEM_COMMON_ISCSI_NTWK_SET_MTU (2)   
#define SUBSYSTEM_COMMON_ISCSI_NTWK_GET_MTU (2)   
#define SUBSYSTEM_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD (2) 
#define SUBSYSTEM_COMMON_ISCSI_TCP_DISCONNECT (2) 
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES (3) // Refer to
                                                     // IOCTL_COMMON_ISCSI_CFG_REMOVE_SGL_
                                                     // PAGES
#define OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS (4) // Refer to
                                                     // IOCTL_COMMON_ISCSI_CFG_POST_OOO_BU
                                                     // FFERS
#define OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS (5) // Refer to
                                                       // IOCTL_COMMON_ISCSI_CFG_REMOVE_OO
                                                       // O_BUFFERS
#define OPCODE_COMMON_ISCSI_NTWK_PING   (6)       // Refer to IOCTL_COMMON_ISCSI_NTWK_PING
#define OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG (7) // Refer to
                                                    // IOCTL_COMMON_ISCSI_NTWK_GET_NIC_CON
                                                    // FIG
#define OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE (8) // Refer to
                                                   // IOCTL_COMMON_ISCSI_NTWK_GET_ARP_TABL
                                                   // E
#define OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE (9) // Refer to
                                                   // IOCTL_COMMON_ISCSI_NTWK_SET_ARP_TABL
                                                   // E
#define OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE (10) // Refer to
                                                      // IOCTL_COMMON_ISCSI_NTWK_GET_ROUTE
                                                      // _TABLE
#define OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE (11) // Refer to
                                                      // IOCTL_COMMON_ISCSI_NTWK_SET_ROUTE
                                                      // _TABLE
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE (12) // Refer to
                                                   // IOCTL_COMMON_ISCSI_NTWK_IFACE_CREATE
#define OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE (13) // Refer to
                                                   // IOCTL_COMMON_ISCSI_NTWK_IFACE_DELETE
#define OPCODE_COMMON_ISCSI_NTWK_SET_VLAN (14)    // Refer to
                                                  // IOCTL_COMMON_ISCSI_NTWK_SET_VLAN
#define OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE (15) // Refer to
                                                     // IOCTL_COMMON_ISCSI_NTWK_SET_PING_S
                                                     // TATE
#define OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE (16) // Refer to
                                                     // IOCTL_COMMON_ISCSI_NTWK_GET_PING_S
                                                     // TATE
#define OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR (17) // Refer to
                                                                  // IOCTL_COMMON_ISCSI_NT
                                                                  // WK_CONFIGURE_STATELES
                                                                  // S_IP_ADDR
#define OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR (18) // Refer to
                                                                // IOCTL_COMMON_ISCSI_NTWK
                                                                // _RELEASE_STATELESS_IP_A
                                                                // DDR
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER (19) // Refer to
                                                           // IOCTL_COMMON_ISCSI_NTWK_GET_
                                                           // DHCP_ISNS_SERVER
#define OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST (20) // Refer to
                                                                // IOCTL_COMMON_ISCSI_NTWK
                                                                // _GET_DHCP_ISNS_SERVER_L
                                                                // IST
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR (21) // Refer to
                                                     // IOCTL_COMMON_ISCSI_NTWK_MODIFY_IP_
                                                     // ADDR
#define OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY (22) // Refer to
                                                          // IOCTL_COMMON_ISCSI_NTWK_GET_D
                                                          // EFAULT_GATEWAY
#define OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY (23) // Refer to
                                                             // IOCTL_COMMON_ISCSI_NTWK_MO
                                                             // DIFY_DEFAULT_GATEWAY
#define OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID (24) // Refer to
                                                    // IOCTL_COMMON_ISCSI_NTWK_GET_ALL_IF_
                                                    // ID
#define OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO (25) // Refer to
                                                  // IOCTL_COMMON_ISCSI_NTWK_GET_IF_INFO
#define OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES (26) // Refer to
                                                          // IOCTL_COMMON_ISCSI_NTWK_GET_I
                                                          // PV6_ATTRIBUTES
#define OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES (27) // Refer to
                                                          // IOCTL_COMMON_ISCSI_NTWK_SET_I
                                                          // PV6_ATTRIBUTES
#define OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS (28) // Refer to
                                                          // IOCTL_COMMON_ISCSI_DISCOVERY_
                                                          // GET_PARAMETERS
#define OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS (29) // Refer to
                                                          // IOCTL_COMMON_ISCSI_DISCOVERY_
                                                          // SET_PARAMETERS
#define OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES (30) // Refer to
                                                           // IOCTL_COMMON_ISCSI_STATS_GET
                                                           // _NODE_ATTRIBUTES
#define OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS (31) // Refer to
                                                          // IOCTL_COMMON_ISCSI_STATS_GET_
                                                          // NIC_STATISTICS
#define OPCODE_COMMON_ISCSI_IPSEC_DOWNLOAD_XML (32) // Refer to
                                                    // IOCTL_COMMON_ISCSI_IPSEC_DOWNLOAD_X
                                                    // ML
#define OPCODE_COMMON_ISCSI_IPSEC_DELETE_XML (33) // Refer to
                                                  // IOCTL_COMMON_ISCSI_IPSEC_DELETE_XML
#define OPCODE_COMMON_ISCSI_IPSEC_GET_RX_STATS (34) // Refer to
                                                    // IOCTL_COMMON_ISCSI_IPSEC_GET_RX_STA
                                                    // TS
#define OPCODE_COMMON_ISCSI_IPSEC_GET_TX_STATS (35) // Refer to
                                                    // IOCTL_COMMON_ISCSI_IPSEC_GET_TX_STA
                                                    // TS
#define OPCODE_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE (36) // Refer to
                                                       // IOCTL_COMMON_ISCSI_IPSEC_ADD_CER
                                                       // TIFICATE
#define OPCODE_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE (37) // Refer to
                                                       // IOCTL_COMMON_ISCSI_IPSEC_DEL_CER
                                                       // TIFICATE
#define OPCODE_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY (38) // Refer to
                                                       // IOCTL_COMMON_ISCSI_IPSEC_ADD_PRI
                                                       // VATE_KEY
#define OPCODE_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY (39) // Refer to
                                                       // IOCTL_COMMON_ISCSI_IPSEC_DEL_PRI
                                                       // VATE_KEY
#define OPCODE_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE (40) // Refer to
                                                      // IOCTL_COMMON_ISCSI_IPSEC_ADD_PASS
                                                      // PHRASE
#define OPCODE_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE (41) // Refer to
                                                      // IOCTL_COMMON_ISCSI_IPSEC_DEL_PASS
                                                      // PHRASE
#define OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION (42) // Refer to
                                                                       // IOCTL_COMMON_ISC
                                                                       // SI_IPSEC_ENABLE_
                                                                       // DISABLE_FLASH_EN
                                                                       // CRYPTION
#define OPCODE_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES (43) // Refer to
                                                       // IOCTL_COMMON_ISCSI_IPSEC_GET_GRO
                                                       // UP_NAMES
#define OPCODE_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME (44) // Refer to
                                                             // IOCTL_COMMON_ISCSI_IPSEC_G
                                                             // ET_SINGLE_GROUP_NAME
#define OPCODE_COMMON_ISCSI_IPSEC_ADD_GROUP (45)  // Refer to
                                                  // IOCTL_COMMON_ISCSI_IPSEC_ADD_GROUP
#define OPCODE_COMMON_ISCSI_IPSEC_DELETE_GROUP (46) // Refer to
                                                    // IOCTL_COMMON_ISCSI_IPSEC_DELETE_GRO
                                                    // UP
#define OPCODE_COMMON_ISCSI_IPSEC_GET_QMSTATS (47) // Refer to
                                                   // IOCTL_COMMON_ISCSI_IPSEC_GET_QMSTATS
#define OPCODE_COMMON_ISCSI_IPSEC_GET_MMSTATS (48) // Refer to
                                                   // IOCTL_COMMON_ISCSI_IPSEC_GET_MMSTATS
#define OPCODE_COMMON_ISCSI_IPSEC_GET_STATE (49)  // Refer to
                                                  // IOCTL_COMMON_ISCSI_IPSEC_GET_STATE
#define OPCODE_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE (50) // Refer to
                                                       // IOCTL_COMMON_ISCSI_IPSEC_CLEAR_P
                                                       // SK_CACHE
#define OPCODE_COMMON_ISCSI_IPSEC_GET_PSK (51)    // Refer to
                                                  // IOCTL_COMMON_ISCSI_IPSEC_GET_PSK
#define OPCODE_COMMON_ISCSI_IPSEC_SET_GUID (52)   // Refer to
                                                  // IOCTL_COMMON_ISCSI_IPSEC_SET_GUID
#define OPCODE_COMMON_ISCSI_IPSEC_SET_PSK (53)    // Refer to
                                                  // IOCTL_COMMON_ISCSI_IPSEC_SET_PSK
#define OPCODE_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS (54) // Refer to
                                                                     // IOCTL_COMMON_ISCSI
                                                                     // _IPSEC_SET_TUNNEL_
                                                                     // MODE_OUTER_ADDRESS
#define OPCODE_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES (55) // Refer to
                                                                 // IOCTL_COMMON_ISCSI_IPS
                                                                 // EC_GET_SECURITY_CAPABI
                                                                 // LITIES
#define OPCODE_COMMON_ISCSI_IPSEC_SET_GROUP_PSK (56) // Refer to
                                                     // IOCTL_COMMON_ISCSI_IPSEC_SET_GROUP
                                                     // _PSK
#define OPCODE_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE (57) // Refer to
                                                            // IOCTL_COMMON_ISCSI_IPSEC_AD
                                                            // D_ROOT_CERTIFICATE
#define OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE (58) // Refer to
                                                      // IOCTL_COMMON_ISCSI_IPSEC_ENABLE_D
                                                      // ISABLE
#define OPCODE_COMMON_ISCSI_CLEANUP     (59)      // Refer to IOCTL_COMMON_ISCSI_CLEANUP
#define OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN (60)    // Refer to
                                                  // IOCTL_COMMON_ISCSI_ADD_8BYTE_LUN
#define OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA (61) // Refer to
                                                              // IOCTL_COMMON_ISCSI_SET_FR
                                                              // AGNUM_BITS_FOR_SGL_CRA
#define OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG (62) // Refer to
                                                     // IOCTL_COMMON_ISCSI_CFG_CLEAR_EVENT
                                                     // _LOG
#define OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG (63) // Refer to
                                                    // IOCTL_COMMON_ISCSI_CFG_READ_EVENT_L
                                                    // OG
#define OPCODE_COMMON_ISCSI_DEFQ_CREATE (64)      // Refer to
                                                  // IOCTL_COMMON_ISCSI_DEFQ_CREATE
#define OPCODE_COMMON_ISCSI_DEFQ_DESTROY (65)     // Refer to
                                                  // IOCTL_COMMON_ISCSI_DEFQ_DESTROY
#define OPCODE_COMMON_ISCSI_WRBQ_CREATE (66)      // Refer to
                                                  // IOCTL_COMMON_ISCSI_WRBQ_CREATE
#define OPCODE_COMMON_ISCSI_WRBQ_DESTROY (67)     // Refer to
                                                  // IOCTL_COMMON_ISCSI_WRBQ_DESTROY
#define OPCODE_COMMON_ISCSI_NTWK_SET_MTU (68)     // Refer to
                                                  // IOCTL_COMMON_ISCSI_NTWK_SET_MTU
#define OPCODE_COMMON_ISCSI_NTWK_GET_MTU (69)     // Refer to
                                                  // IOCTL_COMMON_ISCSI_NTWK_GET_MTU
#define OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD (70) // Refer to
                                                         // IOCTL_COMMON_ISCSI_TCP_CONNECT
                                                         // _AND_OFFLOAD
#define OPCODE_COMMON_ISCSI_TCP_DISCONNECT (71)   // Refer to
                                                  // IOCTL_COMMON_ISCSI_TCP_DISCONNECT

typedef enum {
   ENUM_OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS = 0x1UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS = 0x2UL,
   ENUM_OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CFG_POST_SGL_PAGES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CFG_POST_OOO_BUFFERS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_PING = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_NIC_CONFIG = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ARP_TABLE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ARP_TABLE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_CREATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_IFACE_DELETE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_SET_VLAN = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_SET_PING_STATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_PING_STATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_ALL_IF_ID = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IF_INFO = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_STATS_GET_NIC_STATISTICS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_DOWNLOAD_XML = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_DELETE_XML = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_RX_STATS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_TX_STATS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_GROUP = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_DELETE_GROUP = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_QMSTATS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_MMSTATS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_STATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_PSK = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_GUID = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_PSK = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_SET_GROUP_PSK = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_IPSEC_ENABLE_DISABLE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CLEANUP = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_ADD_8BYTE_LUN = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_CFG_READ_EVENT_LOG = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_DEFQ_CREATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_DEFQ_DESTROY = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_WRBQ_CREATE = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_WRBQ_DESTROY = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_SET_MTU = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_NTWK_GET_MTU = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD = 0x2UL,
   ENUM_SUBSYSTEM_COMMON_ISCSI_TCP_DISCONNECT = 0x2UL,
   ENUM_OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES = 0x3UL,
   ENUM_OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS = 0x4UL,
   ENUM_OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS = 0x5UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_PING = 0x6UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG = 0x7UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE = 0x8UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE = 0x9UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE = 0xaUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE = 0xbUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE = 0xcUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE = 0xdUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_SET_VLAN = 0xeUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE = 0xfUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE = 0x10UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR = 0x11UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR = 0x12UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER = 0x13UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST = 0x14UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR = 0x15UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY = 0x16UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY = 0x17UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID = 0x18UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO = 0x19UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES = 0x1aUL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES = 0x1bUL,
   ENUM_OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS = 0x1cUL,
   ENUM_OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS = 0x1dUL,
   ENUM_OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES = 0x1eUL,
   ENUM_OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS = 0x1fUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_DOWNLOAD_XML = 0x20UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_DELETE_XML = 0x21UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_RX_STATS = 0x22UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_TX_STATS = 0x23UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE = 0x24UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE = 0x25UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY = 0x26UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY = 0x27UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE = 0x28UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE = 0x29UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION = 0x2aUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES = 0x2bUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME = 0x2cUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ADD_GROUP = 0x2dUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_DELETE_GROUP = 0x2eUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_QMSTATS = 0x2fUL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_MMSTATS = 0x30UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_STATE = 0x31UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE = 0x32UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_PSK = 0x33UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_SET_GUID = 0x34UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_SET_PSK = 0x35UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS = 0x36UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES = 0x37UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_SET_GROUP_PSK = 0x38UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE = 0x39UL,
   ENUM_OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE = 0x3aUL,
   ENUM_OPCODE_COMMON_ISCSI_CLEANUP = 0x3bUL,
   ENUM_OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN = 0x3cUL,
   ENUM_OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA = 0x3dUL,
   ENUM_OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG = 0x3eUL,
   ENUM_OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG = 0x3fUL,
   ENUM_OPCODE_COMMON_ISCSI_DEFQ_CREATE = 0x40UL,
   ENUM_OPCODE_COMMON_ISCSI_DEFQ_DESTROY = 0x41UL,
   ENUM_OPCODE_COMMON_ISCSI_WRBQ_CREATE = 0x42UL,
   ENUM_OPCODE_COMMON_ISCSI_WRBQ_DESTROY = 0x43UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_SET_MTU = 0x44UL,
   ENUM_OPCODE_COMMON_ISCSI_NTWK_GET_MTU = 0x45UL,
   ENUM_OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD = 0x46UL,
   ENUM_OPCODE_COMMON_ISCSI_TCP_DISCONNECT = 0x47UL
} COMMON_ISCSI_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_iscsi_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS:
            return "OPCODE_COMMON_ISCSI_ERROR_RECOVERY_INVALIDATE_COMMANDS";
         case OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES:
            return "OPCODE_COMMON_ISCSI_CFG_POST_SGL_PAGES";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_SGL_PAGES";
         case OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS:
            return "OPCODE_COMMON_ISCSI_CFG_POST_OOO_BUFFERS";
         case OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS:
            return "OPCODE_COMMON_ISCSI_CFG_REMOVE_OOO_BUFFERS";
         case OPCODE_COMMON_ISCSI_NTWK_PING:
            return "OPCODE_COMMON_ISCSI_NTWK_PING";
         case OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_NIC_CONFIG";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ARP_TABLE";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ARP_TABLE";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ROUTE_TABLE";
         case OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_ROUTE_TABLE";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_CREATE";
         case OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE:
            return "OPCODE_COMMON_ISCSI_NTWK_IFACE_DELETE";
         case OPCODE_COMMON_ISCSI_NTWK_SET_VLAN:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_VLAN";
         case OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_PING_STATE";
         case OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_PING_STATE";
         case OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR:
            return "OPCODE_COMMON_ISCSI_NTWK_CONFIGURE_STATELESS_IP_ADDR";
         case OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR:
            return "OPCODE_COMMON_ISCSI_NTWK_RELEASE_STATELESS_IP_ADDR";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DHCP_ISNS_SERVER_LIST";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_IP_ADDR";
         case OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_DEFAULT_GATEWAY";
         case OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY:
            return "OPCODE_COMMON_ISCSI_NTWK_MODIFY_DEFAULT_GATEWAY";
         case OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_ALL_IF_ID";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IF_INFO";
         case OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_IPV6_ATTRIBUTES";
         case OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_IPV6_ATTRIBUTES";
         case OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_GET_PARAMETERS";
         case OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS:
            return "OPCODE_COMMON_ISCSI_DISCOVERY_SET_PARAMETERS";
         case OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NODE_ATTRIBUTES";
         case OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS:
            return "OPCODE_COMMON_ISCSI_STATS_GET_NIC_STATISTICS";
         case OPCODE_COMMON_ISCSI_IPSEC_DOWNLOAD_XML:
            return "OPCODE_COMMON_ISCSI_IPSEC_DOWNLOAD_XML";
         case OPCODE_COMMON_ISCSI_IPSEC_DELETE_XML:
            return "OPCODE_COMMON_ISCSI_IPSEC_DELETE_XML";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_RX_STATS:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_RX_STATS";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_TX_STATS:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_TX_STATS";
         case OPCODE_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE:
            return "OPCODE_COMMON_ISCSI_IPSEC_ADD_CERTIFICATE";
         case OPCODE_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE:
            return "OPCODE_COMMON_ISCSI_IPSEC_DEL_CERTIFICATE";
         case OPCODE_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY:
            return "OPCODE_COMMON_ISCSI_IPSEC_ADD_PRIVATE_KEY";
         case OPCODE_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY:
            return "OPCODE_COMMON_ISCSI_IPSEC_DEL_PRIVATE_KEY";
         case OPCODE_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE:
            return "OPCODE_COMMON_ISCSI_IPSEC_ADD_PASSPHRASE";
         case OPCODE_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE:
            return "OPCODE_COMMON_ISCSI_IPSEC_DEL_PASSPHRASE";
         case OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION:
            return "OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE_FLASH_ENCRYPTION";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_GROUP_NAMES";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_SINGLE_GROUP_NAME";
         case OPCODE_COMMON_ISCSI_IPSEC_ADD_GROUP:
            return "OPCODE_COMMON_ISCSI_IPSEC_ADD_GROUP";
         case OPCODE_COMMON_ISCSI_IPSEC_DELETE_GROUP:
            return "OPCODE_COMMON_ISCSI_IPSEC_DELETE_GROUP";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_QMSTATS:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_QMSTATS";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_MMSTATS:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_MMSTATS";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_STATE:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_STATE";
         case OPCODE_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE:
            return "OPCODE_COMMON_ISCSI_IPSEC_CLEAR_PSK_CACHE";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_PSK:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_PSK";
         case OPCODE_COMMON_ISCSI_IPSEC_SET_GUID:
            return "OPCODE_COMMON_ISCSI_IPSEC_SET_GUID";
         case OPCODE_COMMON_ISCSI_IPSEC_SET_PSK:
            return "OPCODE_COMMON_ISCSI_IPSEC_SET_PSK";
         case OPCODE_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS:
            return "OPCODE_COMMON_ISCSI_IPSEC_SET_TUNNEL_MODE_OUTER_ADDRESS";
         case OPCODE_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES:
            return "OPCODE_COMMON_ISCSI_IPSEC_GET_SECURITY_CAPABILITIES";
         case OPCODE_COMMON_ISCSI_IPSEC_SET_GROUP_PSK:
            return "OPCODE_COMMON_ISCSI_IPSEC_SET_GROUP_PSK";
         case OPCODE_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE:
            return "OPCODE_COMMON_ISCSI_IPSEC_ADD_ROOT_CERTIFICATE";
         case OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE:
            return "OPCODE_COMMON_ISCSI_IPSEC_ENABLE_DISABLE";
         case OPCODE_COMMON_ISCSI_CLEANUP:
            return "OPCODE_COMMON_ISCSI_CLEANUP";
         case OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN:
            return "OPCODE_COMMON_ISCSI_ADD_8BYTE_LUN";
         case OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA:
            return "OPCODE_COMMON_ISCSI_SET_FRAGNUM_BITS_FOR_SGL_CRA";
         case OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG:
            return "OPCODE_COMMON_ISCSI_CFG_CLEAR_EVENT_LOG";
         case OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG:
            return "OPCODE_COMMON_ISCSI_CFG_READ_EVENT_LOG";
         case OPCODE_COMMON_ISCSI_DEFQ_CREATE:
            return "OPCODE_COMMON_ISCSI_DEFQ_CREATE";
         case OPCODE_COMMON_ISCSI_DEFQ_DESTROY:
            return "OPCODE_COMMON_ISCSI_DEFQ_DESTROY";
         case OPCODE_COMMON_ISCSI_WRBQ_CREATE:
            return "OPCODE_COMMON_ISCSI_WRBQ_CREATE";
         case OPCODE_COMMON_ISCSI_WRBQ_DESTROY:
            return "OPCODE_COMMON_ISCSI_WRBQ_DESTROY";
         case OPCODE_COMMON_ISCSI_NTWK_SET_MTU:
            return "OPCODE_COMMON_ISCSI_NTWK_SET_MTU";
         case OPCODE_COMMON_ISCSI_NTWK_GET_MTU:
            return "OPCODE_COMMON_ISCSI_NTWK_GET_MTU";
         case OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD:
            return "OPCODE_COMMON_ISCSI_TCP_CONNECT_AND_OFFLOAD";
         case OPCODE_COMMON_ISCSI_TCP_DISCONNECT:
            return "OPCODE_COMMON_ISCSI_TCP_DISCONNECT";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_INI_SUBSYSTEM_OPCODES ---
// Opcodes applicable to the IOCTL_SUBSYSTEM_ISCSI_INI subsystem. 
#define OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG (1) // Refer to
                                                   // IOCTL_ISCSI_INI_NTWK_GET_TCPIP_CONFI
                                                   // G
#define OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG (2) // Refer to
                                                   // IOCTL_ISCSI_INI_NTWK_SET_TCPIP_CONFI
                                                   // G
#define OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES (4) // Refer to
                                                     // IOCTL_ISCSI_INI_CFG_GET_CNTL_ATTRI
                                                     // BUTES
#define OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT (5)    // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_GET_HBA_COUNT
#define SUBSYSTEM_ISCSI_INI_NTWK_GET_TCPIP_CONFIG (6) 
#define SUBSYSTEM_ISCSI_INI_NTWK_SET_TCPIP_CONFIG (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_COUNT (6) 
#define OPCODE_ISCSI_INI_CFG_GET_HBA_NAME (6)     // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_GET_HBA_NAME
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_NAME (6)  
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_NAME (6)  
#define SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_TIME (6)  
#define SUBSYSTEM_ISCSI_INI_CFG_GET_CHAP_SECRET (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_SET_CHAP_SECRET (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_STATUS (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSIONS (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_SESSION_LIST (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_A_SESSION (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_SET_CONFIGURATION (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_CLOSE_CONNECTION (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGIN_TARGET (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_LOGOUT_TARGET (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSION_ID (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_A_TARGET (6) 
#define SUBSYSTEM_ISCSI_INI_DISCOVERY_SEND_TARGETS (6) 
#define SUBSYSTEM_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_SESSION (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_CONN (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_SESSION (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION (6) 
#define SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_CONN (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE (6) 
#define SUBSYSTEM_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_LOGIN_STATISTICS (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION (6) 
#define SUBSYSTEM_ISCSI_INI_STATS_GET_IPSEC_STATISTICS (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_TARGET (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_TARGET (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_LUN (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_LUN (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_READ_WRITE (6)   
#define SUBSYSTEM_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION (6) 
#define SUBSYSTEM_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION (6) 
#define SUBSYSTEM_ISCSI_INI_SCSI_PASS_THRU (6)    
#define SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL (6) 
#define SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST (6) 
#define SUBSYSTEM_ISCSI_INI_CFG_GET_PCIE_INFO (6) 
#define OPCODE_ISCSI_INI_CFG_SET_HBA_NAME (7)     // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_SET_HBA_NAME
#define OPCODE_ISCSI_INI_CFG_SET_HBA_TIME (8)     // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_SET_HBA_TIME
#define OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET (9)  // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_GET_CHAP_SECRET
#define OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET (10) // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_SET_CHAP_SECRET
#define OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS (11)  // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_GET_HBA_STATUS
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS (12) // Refer to
                                                       // IOCTL_ISCSI_INI_SESSION_GET_ALL_
                                                       // SESSIONS
#define OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST (13) // Refer to
                                                       // IOCTL_ISCSI_INI_SESSION_GET_SESS
                                                       // ION_LIST
#define OPCODE_ISCSI_INI_SESSION_GET_A_SESSION (14) // Refer to
                                                    // IOCTL_ISCSI_INI_SESSION_GET_A_SESSI
                                                    // ON
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS (15) // Refer to
                                                          // IOCTL_ISCSI_INI_SESSION_GET_A
                                                          // LL_CONNECTIONS
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION (16) // Refer to
                                                        // IOCTL_ISCSI_INI_SESSION_GET_CON
                                                        // FIGURATION
#define OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION (17) // Refer to
                                                        // IOCTL_ISCSI_INI_SESSION_SET_CON
                                                        // FIGURATION
#define OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST (18) // Refer to
                                                             // IOCTL_ISCSI_INI_SESSION_GE
                                                             // T_CONFIGURATION_LIST
#define OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS (19) // Refer to
                                                               // IOCTL_ISCSI_INI_SESSION_
                                                               // MODIFY_SESSION_LOGINKEYS
#define OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS (20) // Refer to
                                                                  // IOCTL_ISCSI_INI_SESSI
                                                                  // ON_MODIFY_CONNECTION_
                                                                  // LOGINKEYS
#define OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION (21) // Refer to
                                                                // IOCTL_ISCSI_INI_SESSION
                                                                // _ADD_CONNECTION_TO_SESS
                                                                // ION
#define OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION (22) // Refer to
                                                       // IOCTL_ISCSI_INI_SESSION_CLOSE_CO
                                                       // NNECTION
#define OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET (23) // Refer to
                                                   // IOCTL_ISCSI_INI_SESSION_LOGIN_TARGET
#define OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET (24) // Refer to
                                                    // IOCTL_ISCSI_INI_SESSION_LOGOUT_TARG
                                                    // ET
#define OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN (25) // Refer to
                                                               // IOCTL_ISCSI_INI_SESSION_
                                                               // QUERY_A_PERSISTENT_LOGIN
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS (26) // Refer to
                                                              // IOCTL_ISCSI_INI_SESSION_Q
                                                              // UERY_PERSISTENT_LOGINS
#define OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN (27) // Refer to
                                                           // IOCTL_ISCSI_INI_SESSION_ADD_
                                                           // PERSISTENT_LOGIN
#define OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN (28) // Refer to
                                                              // IOCTL_ISCSI_INI_SESSION_D
                                                              // ELETE_PERSISTENT_LOGIN
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID (29) // Refer to
                                                         // IOCTL_ISCSI_INI_SESSION_GET_AL
                                                         // L_SESSION_ID
#define OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID (30) // Refer to
                                                                     // IOCTL_ISCSI_INI_DI
                                                                     // SCOVERY_GET_ALL_DI
                                                                     // SCOVERED_TARGET_ID
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS (31) // Refer to
                                                           // IOCTL_ISCSI_INI_DISCOVERY_RE
                                                           // PORT_ALL_TARGETS
#define OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET (32) // Refer to
                                                        // IOCTL_ISCSI_INI_DISCOVERY_REPOR
                                                        // T_A_TARGET
#define OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS (33) // Refer to
                                                     // IOCTL_ISCSI_INI_DISCOVERY_SEND_TAR
                                                     // GETS
#define OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO (34) // Refer to
                                                          // IOCTL_ISCSI_INI_RETRIEVE_PARS
                                                          // ED_TARGET_INFO
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION (35) // Refer to
                                                      // IOCTL_ISCSI_INI_DRIVER_REOPEN_A_S
                                                      // ESSION
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS (36) // Refer to
                                                         // IOCTL_ISCSI_INI_DRIVER_REOPEN_
                                                         // ALL_SESSIONS
#define OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN (37) // Refer to
                                                   // IOCTL_ISCSI_INI_DRIVER_REOPEN_A_CONN
#define OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS (38) // Refer to
                                                                    // IOCTL_ISCSI_INI_DRI
                                                                    // VER_DEL_ALL_NONPERS
                                                                    // ISTENT_SESSIONS
#define OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS (39) // Refer to
                                                                  // IOCTL_ISCSI_INI_DRIVE
                                                                  // R_STORE_NONPERSISTENT
                                                                  // _SESSIONS
#define OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS (40) // Refer to
                                                        // IOCTL_ISCSI_INI_DRIVER_LOGIN_AL
                                                        // L_SESSIONS
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION (41) // Refer to
                                                     // IOCTL_ISCSI_INI_DRIVER_OFFLOAD_SES
                                                     // SION
#define OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION (42) // Refer to
                                                           // IOCTL_ISCSI_INI_DRIVER_INVAL
                                                           // IDATE_CONNECTION
#define OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN (43) // Refer to
                                                  // IOCTL_ISCSI_INI_DRIVER_OFFLOAD_CONN
#define OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE (44) // Refer to
                                                            // IOCTL_ISCSI_INI_BTL_MAPPING
                                                            // _QUERY_OS_BT_INUSE
#define OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL (45) // Refer to
                                                               // IOCTL_ISCSI_INI_BTL_MAPP
                                                               // ING_MAX_OS_SUPPORTED_BTL
#define OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS (46) // Refer to
                                                            // IOCTL_ISCSI_INI_STATS_GET_I
                                                            // NSTANCE_STATISTICS
#define OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS (47) // Refer to
                                                         // IOCTL_ISCSI_INI_STATS_GET_LOGI
                                                         // N_STATISTICS
#define OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES (48) // Refer to
                                                           // IOCTL_ISCSI_INI_STATS_GET_SE
                                                           // SSION_ATTRIBUTES
#define OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS (49) // Refer to
                                                             // IOCTL_ISCSI_INI_STATS_GET_
                                                             // A_SESSION_STATISTICS
#define OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION (50) // Refer to
                                                                    // IOCTL_ISCSI_INI_STA
                                                                    // TS_GET_CONN_STATIST
                                                                    // ICS_PER_SESSION
#define OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS (51) // Refer to
                                                         // IOCTL_ISCSI_INI_STATS_GET_IPSE
                                                         // C_STATISTICS
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET (52) // Refer to
                                                   // IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET (53) // Refer to
                                                   // IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET
#define OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN (54)   // Refer to
                                                  // IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN
#define OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN (55)   // Refer to
                                                  // IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN
#define OPCODE_ISCSI_INI_BOOT_READ_WRITE (56)     // Refer to
                                                  // IOCTL_ISCSI_INI_BOOT_READ_WRITE
#define OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION (57) // Refer to
                                                          // IOCTL_ISCSI_INI_BOOT_GET_BIOS
                                                          // _CONFIGURATION
#define OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION (58) // Refer to
                                                          // IOCTL_ISCSI_INI_BOOT_SET_BIOS
                                                          // _CONFIGURATION
#define OPCODE_ISCSI_INI_SCSI_PASS_THRU (59)      // Refer to
                                                  // IOCTL_ISCSI_INI_SCSI_PASS_THRU
#define OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL (60) // Refer to
                                                                    // IOCTL_ISCSI_INI_SES
                                                                    // SION_GET_ALL_PLOGIN
                                                                    // _TGTNAME_PORTAL
#define OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST (61) // Refer to
                                                                  // IOCTL_ISCSI_INI_SESSI
                                                                  // ON_QUERY_PERSISTENT_L
                                                                  // OGIN_LIST
#define OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO (62)   // Refer to
                                                  // IOCTL_ISCSI_INI_CFG_GET_PCIE_INFO

typedef enum {
   ENUM_OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG = 0x1UL,
   ENUM_OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG = 0x2UL,
   ENUM_OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES = 0x4UL,
   ENUM_OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT = 0x5UL,
   ENUM_SUBSYSTEM_ISCSI_INI_NTWK_GET_TCPIP_CONFIG = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_NTWK_SET_TCPIP_CONFIG = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_COUNT = 0x6UL,
   ENUM_OPCODE_ISCSI_INI_CFG_GET_HBA_NAME = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_NAME = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_NAME = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_SET_HBA_TIME = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_GET_CHAP_SECRET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_SET_CHAP_SECRET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_GET_HBA_STATUS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSIONS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_SESSION_LIST = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_A_SESSION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_SET_CONFIGURATION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_CLOSE_CONNECTION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_LOGIN_TARGET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_LOGOUT_TARGET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_SESSION_ID = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DISCOVERY_REPORT_A_TARGET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DISCOVERY_SEND_TARGETS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_SESSION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_REOPEN_A_CONN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_SESSION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_DRIVER_OFFLOAD_CONN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_STATS_GET_LOGIN_STATISTICS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_STATS_GET_IPSEC_STATISTICS = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_TARGET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_TARGET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_GET_BOOT_LUN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_SET_BOOT_LUN = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_READ_WRITE = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SCSI_PASS_THRU = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_INI_CFG_GET_PCIE_INFO = 0x6UL,
   ENUM_OPCODE_ISCSI_INI_CFG_SET_HBA_NAME = 0x7UL,
   ENUM_OPCODE_ISCSI_INI_CFG_SET_HBA_TIME = 0x8UL,
   ENUM_OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET = 0x9UL,
   ENUM_OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET = 0xaUL,
   ENUM_OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS = 0xbUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS = 0xcUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST = 0xdUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_A_SESSION = 0xeUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS = 0xfUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION = 0x10UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION = 0x11UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST = 0x12UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS = 0x13UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS = 0x14UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION = 0x15UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION = 0x16UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET = 0x17UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET = 0x18UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN = 0x19UL,
   ENUM_OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS = 0x1aUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN = 0x1bUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN = 0x1cUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID = 0x1dUL,
   ENUM_OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID = 0x1eUL,
   ENUM_OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS = 0x1fUL,
   ENUM_OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET = 0x20UL,
   ENUM_OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS = 0x21UL,
   ENUM_OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO = 0x22UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION = 0x23UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS = 0x24UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN = 0x25UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS = 0x26UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS = 0x27UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS = 0x28UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION = 0x29UL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION = 0x2aUL,
   ENUM_OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN = 0x2bUL,
   ENUM_OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE = 0x2cUL,
   ENUM_OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL = 0x2dUL,
   ENUM_OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS = 0x2eUL,
   ENUM_OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS = 0x2fUL,
   ENUM_OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES = 0x30UL,
   ENUM_OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS = 0x31UL,
   ENUM_OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION = 0x32UL,
   ENUM_OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS = 0x33UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET = 0x34UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET = 0x35UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN = 0x36UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN = 0x37UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_READ_WRITE = 0x38UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION = 0x39UL,
   ENUM_OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION = 0x3aUL,
   ENUM_OPCODE_ISCSI_INI_SCSI_PASS_THRU = 0x3bUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL = 0x3cUL,
   ENUM_OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST = 0x3dUL,
   ENUM_OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO = 0x3eUL
} ISCSI_INI_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_ini_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG:
            return "OPCODE_ISCSI_INI_NTWK_GET_TCPIP_CONFIG";
         case OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG:
            return "OPCODE_ISCSI_INI_NTWK_SET_TCPIP_CONFIG";
         case OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES:
            return "OPCODE_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_COUNT";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_NAME:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_NAME";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_NAME:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_NAME";
         case OPCODE_ISCSI_INI_CFG_SET_HBA_TIME:
            return "OPCODE_ISCSI_INI_CFG_SET_HBA_TIME";
         case OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET:
            return "OPCODE_ISCSI_INI_CFG_GET_CHAP_SECRET";
         case OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET:
            return "OPCODE_ISCSI_INI_CFG_SET_CHAP_SECRET";
         case OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS:
            return "OPCODE_ISCSI_INI_CFG_GET_HBA_STATUS";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSIONS";
         case OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST:
            return "OPCODE_ISCSI_INI_SESSION_GET_SESSION_LIST";
         case OPCODE_ISCSI_INI_SESSION_GET_A_SESSION:
            return "OPCODE_ISCSI_INI_SESSION_GET_A_SESSION";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION";
         case OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION:
            return "OPCODE_ISCSI_INI_SESSION_SET_CONFIGURATION";
         case OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST:
            return "OPCODE_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS";
         case OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS:
            return "OPCODE_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS";
         case OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION:
            return "OPCODE_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION";
         case OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION:
            return "OPCODE_ISCSI_INI_SESSION_CLOSE_CONNECTION";
         case OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET:
            return "OPCODE_ISCSI_INI_SESSION_LOGIN_TARGET";
         case OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET:
            return "OPCODE_ISCSI_INI_SESSION_LOGOUT_TARGET";
         case OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS";
         case OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN:
            return "OPCODE_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN";
         case OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN:
            return "OPCODE_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_SESSION_ID";
         case OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID:
            return "OPCODE_ISCSI_INI_DISCOVERY_GET_ALL_DISCOVERED_TARGET_ID";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_ALL_TARGETS";
         case OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET:
            return "OPCODE_ISCSI_INI_DISCOVERY_REPORT_A_TARGET";
         case OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS:
            return "OPCODE_ISCSI_INI_DISCOVERY_SEND_TARGETS";
         case OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO:
            return "OPCODE_ISCSI_INI_RETRIEVE_PARSED_TARGET_INFO";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_SESSION";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS";
         case OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN:
            return "OPCODE_ISCSI_INI_DRIVER_REOPEN_A_CONN";
         case OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS:
            return "OPCODE_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS";
         case OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS:
            return "OPCODE_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS";
         case OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS:
            return "OPCODE_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_SESSION";
         case OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION:
            return "OPCODE_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION";
         case OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN:
            return "OPCODE_ISCSI_INI_DRIVER_OFFLOAD_CONN";
         case OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE";
         case OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL:
            return "OPCODE_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL";
         case OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS:
            return "OPCODE_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS";
         case OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS:
            return "OPCODE_ISCSI_INI_STATS_GET_LOGIN_STATISTICS";
         case OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES:
            return "OPCODE_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES";
         case OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS:
            return "OPCODE_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS";
         case OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION:
            return "OPCODE_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION";
         case OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS:
            return "OPCODE_ISCSI_INI_STATS_GET_IPSEC_STATISTICS";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_TARGET";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_TARGET";
         case OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN:
            return "OPCODE_ISCSI_INI_BOOT_GET_BOOT_LUN";
         case OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN:
            return "OPCODE_ISCSI_INI_BOOT_SET_BOOT_LUN";
         case OPCODE_ISCSI_INI_BOOT_READ_WRITE:
            return "OPCODE_ISCSI_INI_BOOT_READ_WRITE";
         case OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION:
            return "OPCODE_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION";
         case OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION:
            return "OPCODE_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION";
         case OPCODE_ISCSI_INI_SCSI_PASS_THRU:
            return "OPCODE_ISCSI_INI_SCSI_PASS_THRU";
         case OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL:
            return "OPCODE_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL";
         case OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST:
            return "OPCODE_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST";
         case OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO:
            return "OPCODE_ISCSI_INI_CFG_GET_PCIE_INFO";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ISCSI_TGT_SUBSYSTEM_OPCODES ---
// Opcodes in the IOCTL_SUBSYSTEM_ISCSI_TGT subsystem. 
#define OPCODE_ISCSI_TGT_START_LISTEN_SERVER (1)  // Refer to
                                                  // IOCTL_ISCSI_TGT_START_LISTEN_SERVER
#define OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER (2)   // Refer to
                                                  // IOCTL_ISCSI_TGT_STOP_LISTEN_SERVER
#define OPCODE_ISCSI_TGT_GET_CONNECTION_INFO (3)  // Refer to
                                                  // IOCTL_ISCSI_TGT_GET_CONNECTION_INFO
#define OPCODE_ISCSI_TGT_CONNECTION_REJECT (4)    // Refer to
                                                  // IOCTL_ISCSI_TGT_CONNECTION_REJECT
#define OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION (5)   // Refer to
                                                  // IOCTL_ISCSI_TGT_OFFLOAD_CONNECTION
#define OPCODE_ISCSI_TGT_ISNS_SEND_PACKET (6)     // Refer to
                                                  // IOCTL_ISCSI_TGT_ISNS_SEND_PACKET
#define SUBSYSTEM_ISCSI_TGT_START_LISTEN_SERVER (7) 
#define SUBSYSTEM_ISCSI_TGT_STOP_LISTEN_SERVER (7) 
#define SUBSYSTEM_ISCSI_TGT_GET_CONNECTION_INFO (7) 
#define SUBSYSTEM_ISCSI_TGT_CONNECTION_REJECT (7) 
#define SUBSYSTEM_ISCSI_TGT_OFFLOAD_CONNECTION (7) 
#define SUBSYSTEM_ISCSI_TGT_ISNS_SEND_PACKET (7)  
#define OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION (7) // Refer to
                                                   // IOCTL_ISCSI_TGT_INVALIDATE_CONNECTIO
                                                   // N
#define SUBSYSTEM_ISCSI_TGT_INVALIDATE_CONNECTION (7) 
#define SUBSYSTEM_ISCSI_TGT_ADD_IP_ADDR (7)       
#define SUBSYSTEM_ISCSI_TGT_DELETE_IP_ADDR (7)    
#define SUBSYSTEM_ISCSI_TGT_LIST_IP_ADDR (7)      
#define SUBSYSTEM_ISCSI_TGT_START_ESI_LISTEN (7)  
#define SUBSYSTEM_ISCSI_TGT_STOP_ESI_LISTEN (7)   
#define SUBSYSTEM_ISCSI_TGT_SLP_REGISTER (7)      
#define SUBSYSTEM_ISCSI_TGT_SLP_DEREGISTER (7)    
#define OPCODE_ISCSI_TGT_ADD_IP_ADDR    (8)       // Refer to IOCTL_ISCSI_TGT_ADD_IP_ADDR
#define OPCODE_ISCSI_TGT_DELETE_IP_ADDR (9)       // Refer to
                                                  // IOCTL_ISCSI_TGT_DELETE_IP_ADDR
#define OPCODE_ISCSI_TGT_LIST_IP_ADDR   (10)      // Refer to IOCTL_ISCSI_TGT_LIST_IP_ADDR
#define OPCODE_ISCSI_TGT_START_ESI_LISTEN (11)    // Refer to
                                                  // IOCTL_ISCSI_TGT_START_ESI_LISTEN
#define OPCODE_ISCSI_TGT_STOP_ESI_LISTEN (12)     // Refer to
                                                  // IOCTL_ISCSI_TGT_STOP_ESI_LISTEN
#define OPCODE_ISCSI_TGT_SLP_REGISTER   (13)      // Refer to IOCTL_ISCSI_TGT_SLP_REGISTER
#define OPCODE_ISCSI_TGT_SLP_DEREGISTER (14)      // Refer to
                                                  // IOCTL_ISCSI_TGT_SLP_DEREGISTER

typedef enum {
   ENUM_OPCODE_ISCSI_TGT_START_LISTEN_SERVER = 0x1UL,
   ENUM_OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER = 0x2UL,
   ENUM_OPCODE_ISCSI_TGT_GET_CONNECTION_INFO = 0x3UL,
   ENUM_OPCODE_ISCSI_TGT_CONNECTION_REJECT = 0x4UL,
   ENUM_OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION = 0x5UL,
   ENUM_OPCODE_ISCSI_TGT_ISNS_SEND_PACKET = 0x6UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_START_LISTEN_SERVER = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_STOP_LISTEN_SERVER = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_GET_CONNECTION_INFO = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_CONNECTION_REJECT = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_OFFLOAD_CONNECTION = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_ISNS_SEND_PACKET = 0x7UL,
   ENUM_OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_INVALIDATE_CONNECTION = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_ADD_IP_ADDR = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_DELETE_IP_ADDR = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_LIST_IP_ADDR = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_START_ESI_LISTEN = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_STOP_ESI_LISTEN = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_SLP_REGISTER = 0x7UL,
   ENUM_SUBSYSTEM_ISCSI_TGT_SLP_DEREGISTER = 0x7UL,
   ENUM_OPCODE_ISCSI_TGT_ADD_IP_ADDR = 0x8UL,
   ENUM_OPCODE_ISCSI_TGT_DELETE_IP_ADDR = 0x9UL,
   ENUM_OPCODE_ISCSI_TGT_LIST_IP_ADDR = 0xaUL,
   ENUM_OPCODE_ISCSI_TGT_START_ESI_LISTEN = 0xbUL,
   ENUM_OPCODE_ISCSI_TGT_STOP_ESI_LISTEN = 0xcUL,
   ENUM_OPCODE_ISCSI_TGT_SLP_REGISTER = 0xdUL,
   ENUM_OPCODE_ISCSI_TGT_SLP_DEREGISTER = 0xeUL
} ISCSI_TGT_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* iscsi_tgt_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ISCSI_TGT_START_LISTEN_SERVER:
            return "OPCODE_ISCSI_TGT_START_LISTEN_SERVER";
         case OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER:
            return "OPCODE_ISCSI_TGT_STOP_LISTEN_SERVER";
         case OPCODE_ISCSI_TGT_GET_CONNECTION_INFO:
            return "OPCODE_ISCSI_TGT_GET_CONNECTION_INFO";
         case OPCODE_ISCSI_TGT_CONNECTION_REJECT:
            return "OPCODE_ISCSI_TGT_CONNECTION_REJECT";
         case OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION:
            return "OPCODE_ISCSI_TGT_OFFLOAD_CONNECTION";
         case OPCODE_ISCSI_TGT_ISNS_SEND_PACKET:
            return "OPCODE_ISCSI_TGT_ISNS_SEND_PACKET";
         case OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION:
            return "OPCODE_ISCSI_TGT_INVALIDATE_CONNECTION";
         case OPCODE_ISCSI_TGT_ADD_IP_ADDR:
            return "OPCODE_ISCSI_TGT_ADD_IP_ADDR";
         case OPCODE_ISCSI_TGT_DELETE_IP_ADDR:
            return "OPCODE_ISCSI_TGT_DELETE_IP_ADDR";
         case OPCODE_ISCSI_TGT_LIST_IP_ADDR:
            return "OPCODE_ISCSI_TGT_LIST_IP_ADDR";
         case OPCODE_ISCSI_TGT_START_ESI_LISTEN:
            return "OPCODE_ISCSI_TGT_START_ESI_LISTEN";
         case OPCODE_ISCSI_TGT_STOP_ESI_LISTEN:
            return "OPCODE_ISCSI_TGT_STOP_ESI_LISTEN";
         case OPCODE_ISCSI_TGT_SLP_REGISTER:
            return "OPCODE_ISCSI_TGT_SLP_REGISTER";
         case OPCODE_ISCSI_TGT_SLP_DEREGISTER:
            return "OPCODE_ISCSI_TGT_SLP_DEREGISTER";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_PTL_SUBSYSTEM_OPCODES ---
// Opcodes in the IOCTL_SUBSYSTEM_MILI_PTL subsystem. 
#define OPCODE_MILI_PTL_CREATE_PORTAL   (1)       // Refer to IOCTL_MILI_PTL_CREATE_PORTAL
#define OPCODE_MILI_PTL_DELETE_PORTAL   (2)       // Refer to IOCTL_MILI_PTL_DELETE_PORTAL
#define OPCODE_MILI_PTL_CREATE_PORTAL_GROUP (3)   // Refer to
                                                  // IOCTL_MILI_PTL_CREATE_PORTAL_GROUP
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP (4)   // Refer to
                                                  // IOCTL_MILI_PTL_DELETE_PORTAL_GROUP
#define OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP (5) // Refer to
                                                       // IOCTL_MILI_PTL_ADD_PORTAL_TO_POR
                                                       // TAL_GROUP
#define OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP (6) // Refer to
                                                            // IOCTL_MILI_PTL_DELETE_PORTA
                                                            // L_FROM_PORTAL_GROUP
#define OPCODE_MILI_PTL_ADD_TARGET      (7)       // Refer to IOCTL_MILI_PTL_ADD_TARGET
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL (8)      
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL (8)      
#define SUBSYSTEM_MILI_PTL_CREATE_PORTAL_GROUP (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP (8) 
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP (8) 
#define SUBSYSTEM_MILI_PTL_ADD_TARGET   (8)       
#define OPCODE_MILI_PTL_DELETE_TARGET   (8)       // Refer to IOCTL_MILI_PTL_DELETE_TARGET
#define SUBSYSTEM_MILI_PTL_DELETE_TARGET (8)      
#define SUBSYSTEM_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET (8) 
#define SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET (8) 
#define SUBSYSTEM_MILI_PTL_SET_TARGET_LOGIN_PARAMS (8) 
#define SUBSYSTEM_MILI_PTL_START_LISTEN_SERVER (8) 
#define SUBSYSTEM_MILI_PTL_STOP_LISTEN_SERVER (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS (8) 
#define SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS (8) 
#define SUBSYSTEM_MILI_PTL_GET_ISCSI_SESSION_LIST (8) 
#define SUBSYSTEM_MILI_PTL_KILL_SESSION (8)       
#define OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET (9) // Refer to
                                                       // IOCTL_MILI_PTL_ADD_PORTAL_GROUP_
                                                       // TO_TARGET
#define OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET (10) // Refer to
                                                             // IOCTL_MILI_PTL_DELETE_PORT
                                                             // AL_GROUP_FROM_TARGET
#define OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS (11) // Refer to
                                                     // IOCTL_MILI_PTL_SET_TARGET_LOGIN_PA
                                                     // RAMS
#define OPCODE_MILI_PTL_START_LISTEN_SERVER (12)  // Refer to
                                                  // IOCTL_MILI_PTL_START_LISTEN_SERVER
#define OPCODE_MILI_PTL_STOP_LISTEN_SERVER (13)   // Refer to
                                                  // IOCTL_MILI_PTL_STOP_LISTEN_SERVER
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES (14) // Refer to
                                                               // IOCTL_MILI_PTL_MIB_GET_I
                                                               // SCSI_INSTANCE_ATTRIBUTES
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS (15) // Refer to
                                                                    // IOCTL_MILI_PTL_MIB_
                                                                    // GET_ISCSI_INSTANCE_
                                                                    // SSN_ERROR_STATS
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES (16) // Refer to
                                                             // IOCTL_MILI_PTL_MIB_GET_ISC
                                                             // SI_TARGET_ATTRIBUTES
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS (17) // Refer to
                                                                     // IOCTL_MILI_PTL_MIB
                                                                     // _GET_ISCSI_TARGET_
                                                                     // LOGIN_LOGOUT_STATS
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS (18) // Refer to
                                                                        // IOCTL_MILI_PTL_
                                                                        // MIB_GET_ISCSI_S
                                                                        // ESSION_ATTRIBUT
                                                                        // ES_AND_STATS
#define OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS (19) // Refer to
                                                                           // IOCTL_MILI_P
                                                                           // TL_MIB_GET_I
                                                                           // SCSI_CONNECT
                                                                           // ION_ATTRIBUT
                                                                           // ES_AND_STATS
#define OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST (20) // Refer to
                                                    // IOCTL_MILI_PTL_GET_ISCSI_SESSION_LI
                                                    // ST
#define OPCODE_MILI_PTL_KILL_SESSION    (21)      // Refer to IOCTL_MILI_PTL_KILL_SESSION

typedef enum {
   ENUM_OPCODE_MILI_PTL_CREATE_PORTAL = 0x1UL,
   ENUM_OPCODE_MILI_PTL_DELETE_PORTAL = 0x2UL,
   ENUM_OPCODE_MILI_PTL_CREATE_PORTAL_GROUP = 0x3UL,
   ENUM_OPCODE_MILI_PTL_DELETE_PORTAL_GROUP = 0x4UL,
   ENUM_OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP = 0x5UL,
   ENUM_OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP = 0x6UL,
   ENUM_OPCODE_MILI_PTL_ADD_TARGET = 0x7UL,
   ENUM_SUBSYSTEM_MILI_PTL_CREATE_PORTAL = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_DELETE_PORTAL = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_CREATE_PORTAL_GROUP = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_ADD_TARGET = 0x8UL,
   ENUM_OPCODE_MILI_PTL_DELETE_TARGET = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_DELETE_TARGET = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_SET_TARGET_LOGIN_PARAMS = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_START_LISTEN_SERVER = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_STOP_LISTEN_SERVER = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_GET_ISCSI_SESSION_LIST = 0x8UL,
   ENUM_SUBSYSTEM_MILI_PTL_KILL_SESSION = 0x8UL,
   ENUM_OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET = 0x9UL,
   ENUM_OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET = 0xaUL,
   ENUM_OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS = 0xbUL,
   ENUM_OPCODE_MILI_PTL_START_LISTEN_SERVER = 0xcUL,
   ENUM_OPCODE_MILI_PTL_STOP_LISTEN_SERVER = 0xdUL,
   ENUM_OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES = 0xeUL,
   ENUM_OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS = 0xfUL,
   ENUM_OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES = 0x10UL,
   ENUM_OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS = 0x11UL,
   ENUM_OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS = 0x12UL,
   ENUM_OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS = 0x13UL,
   ENUM_OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST = 0x14UL,
   ENUM_OPCODE_MILI_PTL_KILL_SESSION = 0x15UL
} MILI_PTL_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_ptl_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_PTL_CREATE_PORTAL:
            return "OPCODE_MILI_PTL_CREATE_PORTAL";
         case OPCODE_MILI_PTL_DELETE_PORTAL:
            return "OPCODE_MILI_PTL_DELETE_PORTAL";
         case OPCODE_MILI_PTL_CREATE_PORTAL_GROUP:
            return "OPCODE_MILI_PTL_CREATE_PORTAL_GROUP";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP";
         case OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP:
            return "OPCODE_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP";
         case OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP";
         case OPCODE_MILI_PTL_ADD_TARGET:
            return "OPCODE_MILI_PTL_ADD_TARGET";
         case OPCODE_MILI_PTL_DELETE_TARGET:
            return "OPCODE_MILI_PTL_DELETE_TARGET";
         case OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET:
            return "OPCODE_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET";
         case OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET:
            return "OPCODE_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET";
         case OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS:
            return "OPCODE_MILI_PTL_SET_TARGET_LOGIN_PARAMS";
         case OPCODE_MILI_PTL_START_LISTEN_SERVER:
            return "OPCODE_MILI_PTL_START_LISTEN_SERVER";
         case OPCODE_MILI_PTL_STOP_LISTEN_SERVER:
            return "OPCODE_MILI_PTL_STOP_LISTEN_SERVER";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS";
         case OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS:
            return "OPCODE_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS";
         case OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST:
            return "OPCODE_MILI_PTL_GET_ISCSI_SESSION_LIST";
         case OPCODE_MILI_PTL_KILL_SESSION:
            return "OPCODE_MILI_PTL_KILL_SESSION";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MILI_TMD_SUBSYSTEM_OPCODES ---
// Opcodes in the IOCTL_SUBSYSTEM_MILI_TMD subsystem. 
#define OPCODE_MILI_TMD_ADD_TARGET      (1)       // Refer to IOCTL_MILI_TMD_ADD_TARGET
#define OPCODE_MILI_TMD_DELETE_TARGET   (2)       // Refer to IOCTL_MILI_TMD_DELETE_TARGET
#define OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS (3) // Refer to
                                                      // IOCTL_MILI_TMD_UPDATE_TARGET_AUTH
                                                      // _PARAMS
#define OPCODE_MILI_TMD_ADD_INITIATOR   (4)       // Refer to IOCTL_MILI_TMD_ADD_INITIATOR
#define OPCODE_MILI_TMD_DELETE_INITIATOR (5)      // Refer to
                                                  // IOCTL_MILI_TMD_DELETE_INITIATOR
#define OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS (6) // Refer to
                                                         // IOCTL_MILI_TMD_UPDATE_INITIATO
                                                         // R_AUTH_PARAMS
#define OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET (7) // Refer to
                                                     // IOCTL_MILI_TMD_BIND_INITIATOR_TO_T
                                                     // ARGET
#define OPCODE_MILI_TMD_DELETE_IT_BINDING (8)     // Refer to
                                                  // IOCTL_MILI_TMD_DELETE_IT_BINDING
#define SUBSYSTEM_MILI_TMD_ADD_TARGET   (9)       
#define SUBSYSTEM_MILI_TMD_DELETE_TARGET (9)      
#define SUBSYSTEM_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS (9) 
#define SUBSYSTEM_MILI_TMD_ADD_INITIATOR (9)      
#define SUBSYSTEM_MILI_TMD_DELETE_INITIATOR (9)   
#define SUBSYSTEM_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS (9) 
#define SUBSYSTEM_MILI_TMD_BIND_INITIATOR_TO_TARGET (9) 
#define SUBSYSTEM_MILI_TMD_DELETE_IT_BINDING (9)  
#define OPCODE_MILI_TMD_ACTIVATE_TARGET (9)       // Refer to
                                                  // IOCTL_MILI_TMD_ACTIVATE_TARGET
#define SUBSYSTEM_MILI_TMD_ACTIVATE_TARGET (9)    
#define SUBSYSTEM_MILI_TMD_DEACTIVATE_TARGET (9)  
#define SUBSYSTEM_MILI_TMD_SET_INITIATOR_QOS (9)  
#define OPCODE_MILI_TMD_DEACTIVATE_TARGET (10)    // Refer to
                                                  // IOCTL_MILI_TMD_DEACTIVATE_TARGET
#define OPCODE_MILI_TMD_SET_INITIATOR_QOS (11)    // Refer to
                                                  // IOCTL_MILI_TMD_SET_INITIATOR_QOS

typedef enum {
   ENUM_OPCODE_MILI_TMD_ADD_TARGET = 0x1UL,
   ENUM_OPCODE_MILI_TMD_DELETE_TARGET = 0x2UL,
   ENUM_OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS = 0x3UL,
   ENUM_OPCODE_MILI_TMD_ADD_INITIATOR = 0x4UL,
   ENUM_OPCODE_MILI_TMD_DELETE_INITIATOR = 0x5UL,
   ENUM_OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS = 0x6UL,
   ENUM_OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET = 0x7UL,
   ENUM_OPCODE_MILI_TMD_DELETE_IT_BINDING = 0x8UL,
   ENUM_SUBSYSTEM_MILI_TMD_ADD_TARGET = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_DELETE_TARGET = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_ADD_INITIATOR = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_DELETE_INITIATOR = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_BIND_INITIATOR_TO_TARGET = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_DELETE_IT_BINDING = 0x9UL,
   ENUM_OPCODE_MILI_TMD_ACTIVATE_TARGET = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_ACTIVATE_TARGET = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_DEACTIVATE_TARGET = 0x9UL,
   ENUM_SUBSYSTEM_MILI_TMD_SET_INITIATOR_QOS = 0x9UL,
   ENUM_OPCODE_MILI_TMD_DEACTIVATE_TARGET = 0xaUL,
   ENUM_OPCODE_MILI_TMD_SET_INITIATOR_QOS = 0xbUL
} MILI_TMD_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mili_tmd_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_MILI_TMD_ADD_TARGET:
            return "OPCODE_MILI_TMD_ADD_TARGET";
         case OPCODE_MILI_TMD_DELETE_TARGET:
            return "OPCODE_MILI_TMD_DELETE_TARGET";
         case OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS:
            return "OPCODE_MILI_TMD_UPDATE_TARGET_AUTH_PARAMS";
         case OPCODE_MILI_TMD_ADD_INITIATOR:
            return "OPCODE_MILI_TMD_ADD_INITIATOR";
         case OPCODE_MILI_TMD_DELETE_INITIATOR:
            return "OPCODE_MILI_TMD_DELETE_INITIATOR";
         case OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS:
            return "OPCODE_MILI_TMD_UPDATE_INITIATOR_AUTH_PARAMS";
         case OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET:
            return "OPCODE_MILI_TMD_BIND_INITIATOR_TO_TARGET";
         case OPCODE_MILI_TMD_DELETE_IT_BINDING:
            return "OPCODE_MILI_TMD_DELETE_IT_BINDING";
         case OPCODE_MILI_TMD_ACTIVATE_TARGET:
            return "OPCODE_MILI_TMD_ACTIVATE_TARGET";
         case OPCODE_MILI_TMD_DEACTIVATE_TARGET:
            return "OPCODE_MILI_TMD_DEACTIVATE_TARGET";
         case OPCODE_MILI_TMD_SET_INITIATOR_QOS:
            return "OPCODE_MILI_TMD_SET_INITIATOR_QOS";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- ETH_SUBSYSTEM_OPCODES ---
// These opcodes are used for configuring the Ethernet interfaces. These opcodes all use
// the IOCTL_SUBSYSTEM_ETH subsystem code. 
#define OPCODE_ETH_RSS_CONFIG           (1)       // Refer to IOCTL_ETH_RSS_CONFIG
#define OPCODE_ETH_ACPI_CONFIG          (2)       // Refer to IOCTL_ETH_ACPI_CONFIG
#define SUBSYSTEM_ETH_RSS_CONFIG        (3)       
#define SUBSYSTEM_ETH_ACPI_CONFIG       (3)       
#define OPCODE_ETH_PROMISCUOUS          (3)       // Refer to IOCTL_ETH_PROMISCUOUS
#define SUBSYSTEM_ETH_PROMISCUOUS       (3)       
#define SUBSYSTEM_ETH_GET_STATISTICS    (3)       
#define SUBSYSTEM_ETH_TX_CREATE         (3)       
#define SUBSYSTEM_ETH_RX_CREATE         (3)       
#define SUBSYSTEM_ETH_TX_DESTROY        (3)       
#define SUBSYSTEM_ETH_RX_DESTROY        (3)       
#define SUBSYSTEM_ETH_GET_QPGE_STATISTICS (3)     
#define SUBSYSTEM_ETH_ACPI_WOL_MAGIC_CONFIG (3)   
#define SUBSYSTEM_ETH_NETWORK_STATS     (3)       
#define SUBSYSTEM_ETH_PG_FEATURE_QUERY_REQUEST (3) 
#define SUBSYSTEM_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP (3) 
#define OPCODE_ETH_GET_STATISTICS       (4)       // Refer to IOCTL_ETH_GET_STATISTICS
#define OPCODE_ETH_TX_CREATE            (7)       // Refer to IOCTL_ETH_TX_CREATE
#define OPCODE_ETH_RX_CREATE            (8)       // Refer to IOCTL_ETH_RX_CREATE
#define OPCODE_ETH_TX_DESTROY           (9)       // Refer to IOCTL_ETH_TX_DESTROY
#define OPCODE_ETH_RX_DESTROY           (10)      // Refer to IOCTL_ETH_RX_DESTROY
#define OPCODE_ETH_GET_QPGE_STATISTICS  (11)      // Refer to
                                                  // IOCTL_ETH_GET_QPGE_STATISTICS
#define OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG (12)     // Refer to
                                                  // IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG
#define OPCODE_ETH_NETWORK_STATS        (13)      // Refer to IOCTL_ETH_NETWORK_STATS
#define OPCODE_ETH_PG_FEATURE_QUERY_REQUEST (23)  // Refer to
                                                  // IOCTL_ETH_PG_FEATURE_QUERY_REQUEST
#define OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP (24) // Refer to
                                                       // IOCTL_ETH_QUERY_PRIORITY_CLASS_Q
                                                       // UEUE_MAP

typedef enum {
   ENUM_OPCODE_ETH_RSS_CONFIG = 0x1UL,
   ENUM_OPCODE_ETH_ACPI_CONFIG = 0x2UL,
   ENUM_SUBSYSTEM_ETH_RSS_CONFIG = 0x3UL,
   ENUM_SUBSYSTEM_ETH_ACPI_CONFIG = 0x3UL,
   ENUM_OPCODE_ETH_PROMISCUOUS = 0x3UL,
   ENUM_SUBSYSTEM_ETH_PROMISCUOUS = 0x3UL,
   ENUM_SUBSYSTEM_ETH_GET_STATISTICS = 0x3UL,
   ENUM_SUBSYSTEM_ETH_TX_CREATE = 0x3UL,
   ENUM_SUBSYSTEM_ETH_RX_CREATE = 0x3UL,
   ENUM_SUBSYSTEM_ETH_TX_DESTROY = 0x3UL,
   ENUM_SUBSYSTEM_ETH_RX_DESTROY = 0x3UL,
   ENUM_SUBSYSTEM_ETH_GET_QPGE_STATISTICS = 0x3UL,
   ENUM_SUBSYSTEM_ETH_ACPI_WOL_MAGIC_CONFIG = 0x3UL,
   ENUM_SUBSYSTEM_ETH_NETWORK_STATS = 0x3UL,
   ENUM_SUBSYSTEM_ETH_PG_FEATURE_QUERY_REQUEST = 0x3UL,
   ENUM_SUBSYSTEM_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP = 0x3UL,
   ENUM_OPCODE_ETH_GET_STATISTICS = 0x4UL,
   ENUM_OPCODE_ETH_TX_CREATE = 0x7UL,
   ENUM_OPCODE_ETH_RX_CREATE = 0x8UL,
   ENUM_OPCODE_ETH_TX_DESTROY = 0x9UL,
   ENUM_OPCODE_ETH_RX_DESTROY = 0xaUL,
   ENUM_OPCODE_ETH_GET_QPGE_STATISTICS = 0xbUL,
   ENUM_OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG = 0xcUL,
   ENUM_OPCODE_ETH_NETWORK_STATS = 0xdUL,
   ENUM_OPCODE_ETH_PG_FEATURE_QUERY_REQUEST = 0x17UL,
   ENUM_OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP = 0x18UL
} ETH_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* eth_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_ETH_RSS_CONFIG:
            return "OPCODE_ETH_RSS_CONFIG";
         case OPCODE_ETH_ACPI_CONFIG:
            return "OPCODE_ETH_ACPI_CONFIG";
         case OPCODE_ETH_PROMISCUOUS:
            return "OPCODE_ETH_PROMISCUOUS";
         case OPCODE_ETH_GET_STATISTICS:
            return "OPCODE_ETH_GET_STATISTICS";
         case OPCODE_ETH_TX_CREATE:
            return "OPCODE_ETH_TX_CREATE";
         case OPCODE_ETH_RX_CREATE:
            return "OPCODE_ETH_RX_CREATE";
         case OPCODE_ETH_TX_DESTROY:
            return "OPCODE_ETH_TX_DESTROY";
         case OPCODE_ETH_RX_DESTROY:
            return "OPCODE_ETH_RX_DESTROY";
         case OPCODE_ETH_GET_QPGE_STATISTICS:
            return "OPCODE_ETH_GET_QPGE_STATISTICS";
         case OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG:
            return "OPCODE_ETH_ACPI_WOL_MAGIC_CONFIG";
         case OPCODE_ETH_NETWORK_STATS:
            return "OPCODE_ETH_NETWORK_STATS";
         case OPCODE_ETH_PG_FEATURE_QUERY_REQUEST:
            return "OPCODE_ETH_PG_FEATURE_QUERY_REQUEST";
         case OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP:
            return "OPCODE_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LRO_SUBSYSTEM_OPCODES ---
// These opcodes are used to configure LRO functionality. These opcodes all use
// IOCTL_SUBSYSTEM_LRO sybsystem code. 
#define OPCODE_LRO_RING_CREATE          (1)       // Refer to IOCTL_LRO_RING_CREATE
#define OPCODE_LRO_CONFIG               (2)       // Refer to IOCTL_LRO_CONFIG
#define OPCODE_LRO_GET_STATISTICS       (3)       // Refer to IOCTL_LRO_GET_STATISTICS
#define OPCODE_LRO_RING_DESTROY         (4)       // Refer to IOCTL_LRO_RING_DESTROY
#define SUBSYSTEM_LRO_RING_CREATE       (13)      
#define SUBSYSTEM_LRO_CONFIG            (13)      
#define SUBSYSTEM_LRO_GET_STATISTICS    (13)      
#define SUBSYSTEM_LRO_RING_DESTROY      (13)      

typedef enum {
   ENUM_OPCODE_LRO_RING_CREATE = 0x1UL,
   ENUM_OPCODE_LRO_CONFIG = 0x2UL,
   ENUM_OPCODE_LRO_GET_STATISTICS = 0x3UL,
   ENUM_OPCODE_LRO_RING_DESTROY = 0x4UL,
   ENUM_SUBSYSTEM_LRO_RING_CREATE = 0xdUL,
   ENUM_SUBSYSTEM_LRO_CONFIG = 0xdUL,
   ENUM_SUBSYSTEM_LRO_GET_STATISTICS = 0xdUL,
   ENUM_SUBSYSTEM_LRO_RING_DESTROY = 0xdUL
} LRO_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lro_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LRO_RING_CREATE:
            return "OPCODE_LRO_RING_CREATE";
         case OPCODE_LRO_CONFIG:
            return "OPCODE_LRO_CONFIG";
         case OPCODE_LRO_GET_STATISTICS:
            return "OPCODE_LRO_GET_STATISTICS";
         case OPCODE_LRO_RING_DESTROY:
            return "OPCODE_LRO_RING_DESTROY";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DAL_SUBSYSTEM_OPCODES ---
// These opcodes are used to configure DAL functionality. These opcodes all use
// IOCTL_SUBSYSTEM_DAL sybsystem code. 
#define OPCODE_DAL_GET_PARAMETERS       (1)       // Refer to IOCTL_DAL_GET_PARAMETERS
#define OPCODE_DAL_DRIVER_LOAD          (2)       // Refer to IOCTL_DAL_DRIVER_LOAD
#define OPCODE_DAL_DRIVER_UNLOAD        (3)       // Refer to IOCTL_DAL_DRIVER_UNLOAD
#define OPCODE_DAL_QP_CREATE            (4)       // Refer to IOCTL_DAL_QP_CREATE
#define OPCODE_DAL_QP_DESTROY           (5)       // Refer to IOCTL_DAL_QP_DESTROY
#define OPCODE_DAL_MR_REGISTER          (6)       // Refer to IOCTL_DAL_MR_REGISTER
#define OPCODE_DAL_MR_UNREGISTER        (7)       // Refer to IOCTL_DAL_MR_UNREGISTER
#define OPCODE_DAL_QP_MODIFY_RTS        (8)       // Refer to IOCTL_DAL_QP_MODIFY_RTS
#define OPCODE_DAL_QP_MODIFY_RTR        (9)       // Refer to IOCTL_DAL_QP_MODIFY_RTR
#define OPCODE_DAL_MULTICAST_JOIN       (10)      // Refer to IOCTL_DAL_MULTICAST_JOIN
#define OPCODE_DAL_MULTICAST_LEAVE      (11)      // Refer to IOCTL_DAL_MULTICAST_LEAVE
#define SUBSYSTEM_DAL_GET_PARAMETERS    (14)      
#define SUBSYSTEM_DAL_DRIVER_LOAD       (14)      
#define SUBSYSTEM_DAL_DRIVER_UNLOAD     (14)      
#define SUBSYSTEM_DAL_QP_CREATE         (14)      
#define SUBSYSTEM_DAL_QP_DESTROY        (14)      
#define SUBSYSTEM_DAL_MR_REGISTER       (14)      
#define SUBSYSTEM_DAL_MR_UNREGISTER     (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTS     (14)      
#define SUBSYSTEM_DAL_QP_MODIFY_RTR     (14)      
#define SUBSYSTEM_DAL_MULTICAST_JOIN    (14)      
#define SUBSYSTEM_DAL_MULTICAST_LEAVE   (14)      

typedef enum {
   ENUM_OPCODE_DAL_GET_PARAMETERS = 0x1UL,
   ENUM_OPCODE_DAL_DRIVER_LOAD = 0x2UL,
   ENUM_OPCODE_DAL_DRIVER_UNLOAD = 0x3UL,
   ENUM_OPCODE_DAL_QP_CREATE = 0x4UL,
   ENUM_OPCODE_DAL_QP_DESTROY = 0x5UL,
   ENUM_OPCODE_DAL_MR_REGISTER = 0x6UL,
   ENUM_OPCODE_DAL_MR_UNREGISTER = 0x7UL,
   ENUM_OPCODE_DAL_QP_MODIFY_RTS = 0x8UL,
   ENUM_OPCODE_DAL_QP_MODIFY_RTR = 0x9UL,
   ENUM_OPCODE_DAL_MULTICAST_JOIN = 0xaUL,
   ENUM_OPCODE_DAL_MULTICAST_LEAVE = 0xbUL,
   ENUM_SUBSYSTEM_DAL_GET_PARAMETERS = 0xeUL,
   ENUM_SUBSYSTEM_DAL_DRIVER_LOAD = 0xeUL,
   ENUM_SUBSYSTEM_DAL_DRIVER_UNLOAD = 0xeUL,
   ENUM_SUBSYSTEM_DAL_QP_CREATE = 0xeUL,
   ENUM_SUBSYSTEM_DAL_QP_DESTROY = 0xeUL,
   ENUM_SUBSYSTEM_DAL_MR_REGISTER = 0xeUL,
   ENUM_SUBSYSTEM_DAL_MR_UNREGISTER = 0xeUL,
   ENUM_SUBSYSTEM_DAL_QP_MODIFY_RTS = 0xeUL,
   ENUM_SUBSYSTEM_DAL_QP_MODIFY_RTR = 0xeUL,
   ENUM_SUBSYSTEM_DAL_MULTICAST_JOIN = 0xeUL,
   ENUM_SUBSYSTEM_DAL_MULTICAST_LEAVE = 0xeUL
} DAL_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dal_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DAL_GET_PARAMETERS:
            return "OPCODE_DAL_GET_PARAMETERS";
         case OPCODE_DAL_DRIVER_LOAD:
            return "OPCODE_DAL_DRIVER_LOAD";
         case OPCODE_DAL_DRIVER_UNLOAD:
            return "OPCODE_DAL_DRIVER_UNLOAD";
         case OPCODE_DAL_QP_CREATE:
            return "OPCODE_DAL_QP_CREATE";
         case OPCODE_DAL_QP_DESTROY:
            return "OPCODE_DAL_QP_DESTROY";
         case OPCODE_DAL_MR_REGISTER:
            return "OPCODE_DAL_MR_REGISTER";
         case OPCODE_DAL_MR_UNREGISTER:
            return "OPCODE_DAL_MR_UNREGISTER";
         case OPCODE_DAL_QP_MODIFY_RTS:
            return "OPCODE_DAL_QP_MODIFY_RTS";
         case OPCODE_DAL_QP_MODIFY_RTR:
            return "OPCODE_DAL_QP_MODIFY_RTR";
         case OPCODE_DAL_MULTICAST_JOIN:
            return "OPCODE_DAL_MULTICAST_JOIN";
         case OPCODE_DAL_MULTICAST_LEAVE:
            return "OPCODE_DAL_MULTICAST_LEAVE";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- TOE_SUBSYSTEM_OPCODES ---
// These opcodes are used for configuring TCP offload functionality. These opcodes all use
// the IOCTL_SUBSYSTEM_TOE subsystem code. 
#define OPCODE_TOE_CONNECTION_OFFLOAD   (1)       // Refer to IOCTL_TOE_CONNECTION_OFFLOAD
#define OPCODE_TOE_CONNECTION_UPDATE    (3)       // Refer to IOCTL_TOE_CONNECTION_UPDATE
#define SUBSYSTEM_TOE_CONNECTION_OFFLOAD (4)      
#define SUBSYSTEM_TOE_CONNECTION_UPDATE (4)       
#define OPCODE_TOE_GET_STATISTICS       (4)       // Refer to IOCTL_TOE_GET_STATISTICS
#define SUBSYSTEM_TOE_GET_STATISTICS    (4)       
#define SUBSYSTEM_TOE_CONNECTION_QUERY  (4)       
#define SUBSYSTEM_TOE_WRBQ_CREATE       (4)       
#define SUBSYSTEM_TOE_RQ_CREATE         (4)       
#define SUBSYSTEM_TOE_DEFQ_CREATE       (4)       
#define SUBSYSTEM_TOE_WRBQ_DESTROY      (4)       
#define SUBSYSTEM_TOE_RQ_DESTROY        (4)       
#define SUBSYSTEM_TOE_DEFQ_DESTROY      (4)       
#define OPCODE_TOE_CONNECTION_QUERY     (5)       // Refer to IOCTL_TOE_CONNECTION_QUERY
#define OPCODE_TOE_WRBQ_CREATE          (6)       // Refer to IOCTL_TOE_WRBQ_CREATE
#define OPCODE_TOE_RQ_CREATE            (7)       // Refer to IOCTL_TOE_RQ_CREATE
#define OPCODE_TOE_DEFQ_CREATE          (8)       // Refer to IOCTL_TOE_DEFQ_CREATE
#define OPCODE_TOE_WRBQ_DESTROY         (9)       // Refer to IOCTL_TOE_WRBQ_DESTROY
#define OPCODE_TOE_RQ_DESTROY           (10)      // Refer to IOCTL_TOE_RQ_DESTROY
#define OPCODE_TOE_DEFQ_DESTROY         (11)      // Refer to IOCTL_TOE_DEFQ_DESTROY

typedef enum {
   ENUM_OPCODE_TOE_CONNECTION_OFFLOAD = 0x1UL,
   ENUM_OPCODE_TOE_CONNECTION_UPDATE = 0x3UL,
   ENUM_SUBSYSTEM_TOE_CONNECTION_OFFLOAD = 0x4UL,
   ENUM_SUBSYSTEM_TOE_CONNECTION_UPDATE = 0x4UL,
   ENUM_OPCODE_TOE_GET_STATISTICS = 0x4UL,
   ENUM_SUBSYSTEM_TOE_GET_STATISTICS = 0x4UL,
   ENUM_SUBSYSTEM_TOE_CONNECTION_QUERY = 0x4UL,
   ENUM_SUBSYSTEM_TOE_WRBQ_CREATE = 0x4UL,
   ENUM_SUBSYSTEM_TOE_RQ_CREATE = 0x4UL,
   ENUM_SUBSYSTEM_TOE_DEFQ_CREATE = 0x4UL,
   ENUM_SUBSYSTEM_TOE_WRBQ_DESTROY = 0x4UL,
   ENUM_SUBSYSTEM_TOE_RQ_DESTROY = 0x4UL,
   ENUM_SUBSYSTEM_TOE_DEFQ_DESTROY = 0x4UL,
   ENUM_OPCODE_TOE_CONNECTION_QUERY = 0x5UL,
   ENUM_OPCODE_TOE_WRBQ_CREATE = 0x6UL,
   ENUM_OPCODE_TOE_RQ_CREATE = 0x7UL,
   ENUM_OPCODE_TOE_DEFQ_CREATE = 0x8UL,
   ENUM_OPCODE_TOE_WRBQ_DESTROY = 0x9UL,
   ENUM_OPCODE_TOE_RQ_DESTROY = 0xaUL,
   ENUM_OPCODE_TOE_DEFQ_DESTROY = 0xbUL
} TOE_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* toe_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_TOE_CONNECTION_OFFLOAD:
            return "OPCODE_TOE_CONNECTION_OFFLOAD";
         case OPCODE_TOE_CONNECTION_UPDATE:
            return "OPCODE_TOE_CONNECTION_UPDATE";
         case OPCODE_TOE_GET_STATISTICS:
            return "OPCODE_TOE_GET_STATISTICS";
         case OPCODE_TOE_CONNECTION_QUERY:
            return "OPCODE_TOE_CONNECTION_QUERY";
         case OPCODE_TOE_WRBQ_CREATE:
            return "OPCODE_TOE_WRBQ_CREATE";
         case OPCODE_TOE_RQ_CREATE:
            return "OPCODE_TOE_RQ_CREATE";
         case OPCODE_TOE_DEFQ_CREATE:
            return "OPCODE_TOE_DEFQ_CREATE";
         case OPCODE_TOE_WRBQ_DESTROY:
            return "OPCODE_TOE_WRBQ_DESTROY";
         case OPCODE_TOE_RQ_DESTROY:
            return "OPCODE_TOE_RQ_DESTROY";
         case OPCODE_TOE_DEFQ_DESTROY:
            return "OPCODE_TOE_DEFQ_DESTROY";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- PXE_UNDI_SUBSYSTEM_OPCODES ---
// These opcodes are used for configuring PXE and UNDI functionality. These opcodes use
// the IOCTL_SUBSYSTEM_PXE_UNDI subsystem code. 
#define OPCODE_PXE_UNDI_CONTROL         (1)       // Refer to IOCTL_PXE_UNDI_CONTROL
#define OPCODE_PXE_UNDI_TRANSMIT        (2)       // Refer to IOCTL_PXE_UNDI_TRANSMIT
#define OPCODE_PXE_UNDI_RECEIVE         (3)       // Refer to IOCTL_PXE_UNDI_RECEIVE
#define OPCODE_PXE_UNDI_GET_STATISTICS  (4)       // Refer to
                                                  // IOCTL_PXE_UNDI_GET_STATISTICS
#define SUBSYSTEM_PXE_UNDI_CONTROL      (5)       
#define SUBSYSTEM_PXE_UNDI_TRANSMIT     (5)       
#define SUBSYSTEM_PXE_UNDI_RECEIVE      (5)       
#define SUBSYSTEM_PXE_UNDI_GET_STATISTICS (5)     
#define OPCODE_PXE_UNDI_SET_VLAN        (5)       // Refer to IOCTL_PXE_UNDI_SET_VLAN
#define SUBSYSTEM_PXE_UNDI_SET_VLAN     (5)       
#define SUBSYSTEM_PXE_UNDI_GET_VLAN     (5)       
#define OPCODE_PXE_UNDI_GET_VLAN        (6)       // Refer to IOCTL_PXE_UNDI_GET_VLAN

typedef enum {
   ENUM_OPCODE_PXE_UNDI_CONTROL = 0x1UL,
   ENUM_OPCODE_PXE_UNDI_TRANSMIT = 0x2UL,
   ENUM_OPCODE_PXE_UNDI_RECEIVE = 0x3UL,
   ENUM_OPCODE_PXE_UNDI_GET_STATISTICS = 0x4UL,
   ENUM_SUBSYSTEM_PXE_UNDI_CONTROL = 0x5UL,
   ENUM_SUBSYSTEM_PXE_UNDI_TRANSMIT = 0x5UL,
   ENUM_SUBSYSTEM_PXE_UNDI_RECEIVE = 0x5UL,
   ENUM_SUBSYSTEM_PXE_UNDI_GET_STATISTICS = 0x5UL,
   ENUM_OPCODE_PXE_UNDI_SET_VLAN = 0x5UL,
   ENUM_SUBSYSTEM_PXE_UNDI_SET_VLAN = 0x5UL,
   ENUM_SUBSYSTEM_PXE_UNDI_GET_VLAN = 0x5UL,
   ENUM_OPCODE_PXE_UNDI_GET_VLAN = 0x6UL
} PXE_UNDI_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* pxe_undi_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_PXE_UNDI_CONTROL:
            return "OPCODE_PXE_UNDI_CONTROL";
         case OPCODE_PXE_UNDI_TRANSMIT:
            return "OPCODE_PXE_UNDI_TRANSMIT";
         case OPCODE_PXE_UNDI_RECEIVE:
            return "OPCODE_PXE_UNDI_RECEIVE";
         case OPCODE_PXE_UNDI_GET_STATISTICS:
            return "OPCODE_PXE_UNDI_GET_STATISTICS";
         case OPCODE_PXE_UNDI_SET_VLAN:
            return "OPCODE_PXE_UNDI_SET_VLAN";
         case OPCODE_PXE_UNDI_GET_VLAN:
            return "OPCODE_PXE_UNDI_GET_VLAN";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- RDMA_SUBSYSTEM_OPCODES ---
#define OPCODE_RDMA_QP_CREATE           (1)       // Refer to IOCTL_RDMA_QP_CREATE
#define OPCODE_RDMA_QP_QUERY            (2)       // Refer to IOCTL_RDMA_QP_QUERY
#define OPCODE_RDMA_QP_MODIFY           (3)       // Refer to IOCTL_RDMA_QP_MODIFY
#define OPCODE_RDMA_CXN_OFFLOAD         (4)       // Refer to IOCTL_RDMA_CXN_OFFLOAD
#define OPCODE_RDMA_CXN_UPLOAD          (5)       // Refer to IOCTL_RDMA_CXN_UPLOAD
#define OPCODE_RDMA_CXN_UPDATE          (6)       // Refer to IOCTL_RDMA_CXN_UPDATE
#define OPCODE_RDMA_ALLOC_NSMR_STAG     (7)       // Refer to IOCTL_RDMA_ALLOC_NSMR_STAG
#define OPCODE_RDMA_NSMR_REGISTER       (8)       // Refer to IOCTL_RDMA_NSMR_REGISTER
#define OPCODE_RDMA_NSMR_REREGISTER     (9)       // Refer to IOCTL_RDMA_NSMR_REREGISTER
#define SUBSYSTEM_RDMA_QP_CREATE        (10)      
#define SUBSYSTEM_RDMA_QP_QUERY         (10)      
#define SUBSYSTEM_RDMA_QP_MODIFY        (10)      
#define SUBSYSTEM_RDMA_CXN_OFFLOAD      (10)      
#define SUBSYSTEM_RDMA_CXN_UPLOAD       (10)      
#define SUBSYSTEM_RDMA_CXN_UPDATE       (10)      
#define SUBSYSTEM_RDMA_ALLOC_NSMR_STAG  (10)      
#define SUBSYSTEM_RDMA_NSMR_REGISTER    (10)      
#define SUBSYSTEM_RDMA_NSMR_REREGISTER  (10)      
#define OPCODE_RDMA_ADD_TE              (10)      // Refer to IOCTL_RDMA_ADD_TE
#define SUBSYSTEM_RDMA_ADD_TE           (10)      
#define SUBSYSTEM_RDMA_SMR_REGISTER     (10)      
#define SUBSYSTEM_RDMA_QUERY_MR         (10)      
#define SUBSYSTEM_RDMA_STAG_DEALLOC     (10)      
#define SUBSYSTEM_RDMA_MW_QUERY         (10)      
#define SUBSYSTEM_RDMA_IPADDR_QUERY     (10)      
#define SUBSYSTEM_RDMA_QP_DESTROY       (10)      
#define OPCODE_RDMA_SMR_REGISTER        (11)      // Refer to IOCTL_RDMA_SMR_REGISTER
#define OPCODE_RDMA_QUERY_MR            (12)      // Refer to IOCTL_RDMA_QUERY_MR
#define OPCODE_RDMA_STAG_DEALLOC        (13)      // Refer to IOCTL_RDMA_STAG_DEALLOC
#define OPCODE_RDMA_MW_QUERY            (14)      // Refer to IOCTL_RDMA_MW_QUERY
#define OPCODE_RDMA_IPADDR_QUERY        (15)      // Refer to IOCTL_RDMA_IPADDR_QUERY
#define OPCODE_RDMA_QP_DESTROY          (16)      // Refer to IOCTL_RDMA_QP_DESTROY

typedef enum {
   ENUM_OPCODE_RDMA_QP_CREATE = 0x1UL,
   ENUM_OPCODE_RDMA_QP_QUERY = 0x2UL,
   ENUM_OPCODE_RDMA_QP_MODIFY = 0x3UL,
   ENUM_OPCODE_RDMA_CXN_OFFLOAD = 0x4UL,
   ENUM_OPCODE_RDMA_CXN_UPLOAD = 0x5UL,
   ENUM_OPCODE_RDMA_CXN_UPDATE = 0x6UL,
   ENUM_OPCODE_RDMA_ALLOC_NSMR_STAG = 0x7UL,
   ENUM_OPCODE_RDMA_NSMR_REGISTER = 0x8UL,
   ENUM_OPCODE_RDMA_NSMR_REREGISTER = 0x9UL,
   ENUM_SUBSYSTEM_RDMA_QP_CREATE = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_QP_QUERY = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_QP_MODIFY = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_CXN_OFFLOAD = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_CXN_UPLOAD = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_CXN_UPDATE = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_ALLOC_NSMR_STAG = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_NSMR_REGISTER = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_NSMR_REREGISTER = 0xaUL,
   ENUM_OPCODE_RDMA_ADD_TE = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_ADD_TE = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_SMR_REGISTER = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_QUERY_MR = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_STAG_DEALLOC = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_MW_QUERY = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_IPADDR_QUERY = 0xaUL,
   ENUM_SUBSYSTEM_RDMA_QP_DESTROY = 0xaUL,
   ENUM_OPCODE_RDMA_SMR_REGISTER = 0xbUL,
   ENUM_OPCODE_RDMA_QUERY_MR = 0xcUL,
   ENUM_OPCODE_RDMA_STAG_DEALLOC = 0xdUL,
   ENUM_OPCODE_RDMA_MW_QUERY = 0xeUL,
   ENUM_OPCODE_RDMA_IPADDR_QUERY = 0xfUL,
   ENUM_OPCODE_RDMA_QP_DESTROY = 0x10UL
} RDMA_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* rdma_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_RDMA_QP_CREATE:
            return "OPCODE_RDMA_QP_CREATE";
         case OPCODE_RDMA_QP_QUERY:
            return "OPCODE_RDMA_QP_QUERY";
         case OPCODE_RDMA_QP_MODIFY:
            return "OPCODE_RDMA_QP_MODIFY";
         case OPCODE_RDMA_CXN_OFFLOAD:
            return "OPCODE_RDMA_CXN_OFFLOAD";
         case OPCODE_RDMA_CXN_UPLOAD:
            return "OPCODE_RDMA_CXN_UPLOAD";
         case OPCODE_RDMA_CXN_UPDATE:
            return "OPCODE_RDMA_CXN_UPDATE";
         case OPCODE_RDMA_ALLOC_NSMR_STAG:
            return "OPCODE_RDMA_ALLOC_NSMR_STAG";
         case OPCODE_RDMA_NSMR_REGISTER:
            return "OPCODE_RDMA_NSMR_REGISTER";
         case OPCODE_RDMA_NSMR_REREGISTER:
            return "OPCODE_RDMA_NSMR_REREGISTER";
         case OPCODE_RDMA_ADD_TE:
            return "OPCODE_RDMA_ADD_TE";
         case OPCODE_RDMA_SMR_REGISTER:
            return "OPCODE_RDMA_SMR_REGISTER";
         case OPCODE_RDMA_QUERY_MR:
            return "OPCODE_RDMA_QUERY_MR";
         case OPCODE_RDMA_STAG_DEALLOC:
            return "OPCODE_RDMA_STAG_DEALLOC";
         case OPCODE_RDMA_MW_QUERY:
            return "OPCODE_RDMA_MW_QUERY";
         case OPCODE_RDMA_IPADDR_QUERY:
            return "OPCODE_RDMA_IPADDR_QUERY";
         case OPCODE_RDMA_QP_DESTROY:
            return "OPCODE_RDMA_QP_DESTROY";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LOWLEVEL_SUBSYSTEM_OPCODES ---
// Opcodes used for lowlevel functions common to many subystems. Some of these opcodes are
// used for diagnostic functions only. These opcodes use the IOCTL_SUBSYSTEM_LOWLEVEL
// subsystem code. 
#define OPCODE_LOWLEVEL_CONFIG_DT_ENTRY (1)       // Refer to
                                                  // IOCTL_LOWLEVEL_CONFIG_DT_ENTRY
#define OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY (2)   // Refer to
                                                  // IOCTL_LOWLEVEL_INVALIDATE_PT_ENTRY
#define OPCODE_LOWLEVEL_ACCESS_MEMORY   (3)       // Refer to IOCTL_LOWLEVEL_ACCESS_MEMORY
#define OPCODE_LOWLEVEL_ACCESS_REGISTERS (4)      // Refer to
                                                  // IOCTL_LOWLEVEL_ACCESS_REGISTERS
#define OPCODE_LOWLEVEL_OFFLOAD_ENABLE  (5)       // Refer to
                                                  // IOCTL_LOWLEVEL_OFFLOAD_ENABLE
#define OPCODE_LOWLEVEL_CONFIG_TCP_STATE (6)      // Refer to
                                                  // IOCTL_LOWLEVEL_CONFIG_TCP_STATE
#define OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER (7) // Refer to
                                                   // IOCTL_LOWLEVEL_CONFIG_TEMPLATE_HEADE
                                                   // R
#define OPCODE_LOWLEVEL_CONFIG_ISCSI    (8)       // Refer to IOCTL_LOWLEVEL_CONFIG_ISCSI
#define OPCODE_LOWLEVEL_CONFIG_TOE      (9)       // Refer to IOCTL_LOWLEVEL_CONFIG_TOE
#define OPCODE_LOWLEVEL_ISCSI_OFFLOAD   (10)      // Refer to IOCTL_LOWLEVEL_ISCSI_OFFLOAD
#define SUBSYSTEM_LOWLEVEL_CONFIG_DT_ENTRY (11)   
#define SUBSYSTEM_LOWLEVEL_INVALIDATE_PT_ENTRY (11) 
#define SUBSYSTEM_LOWLEVEL_ACCESS_MEMORY (11)     
#define SUBSYSTEM_LOWLEVEL_ACCESS_REGISTERS (11)  
#define SUBSYSTEM_LOWLEVEL_OFFLOAD_ENABLE (11)    
#define SUBSYSTEM_LOWLEVEL_CONFIG_TCP_STATE (11)  
#define SUBSYSTEM_LOWLEVEL_CONFIG_TEMPLATE_HEADER (11) 
#define SUBSYSTEM_LOWLEVEL_CONFIG_ISCSI (11)      
#define SUBSYSTEM_LOWLEVEL_CONFIG_TOE   (11)      
#define SUBSYSTEM_LOWLEVEL_ISCSI_OFFLOAD (11)     
#define SUBSYSTEM_LOWLEVEL_MAP_UT_PAGES (11)      
#define SUBSYSTEM_LOWLEVEL_UNMAP_UT_PAGES (11)    
#define SUBSYSTEM_LOWLEVEL_MGMT_DEBUG_LEVEL (11)  
#define SUBSYSTEM_LOWLEVEL_MEASURE_DMA_BANDWIDTH (11) 
#define SUBSYSTEM_LOWLEVEL_HOST_DDR_DMA (11)      
#define SUBSYSTEM_LOWLEVEL_LOOPBACK_TEST (11)     
#define SUBSYSTEM_LOWLEVEL_SET_LOOPBACK_MODE (11) 
#define SUBSYSTEM_LOWLEVEL_GET_LOOPBACK_MODE (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_PROPERTIES (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES (11) 
#define SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT (11) 
#define OPCODE_LOWLEVEL_MAP_UT_PAGES    (13)      // Refer to IOCTL_LOWLEVEL_MAP_UT_PAGES
#define OPCODE_LOWLEVEL_UNMAP_UT_PAGES  (14)      // Refer to
                                                  // IOCTL_LOWLEVEL_UNMAP_UT_PAGES
#define OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL (15)     // Refer to
                                                  // IOCTL_LOWLEVEL_MGMT_DEBUG_LEVEL
#define OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH (16) // Refer to
                                                   // IOCTL_LOWLEVEL_MEASURE_DMA_BANDWIDTH
#define OPCODE_LOWLEVEL_HOST_DDR_DMA    (17)      // Refer to IOCTL_LOWLEVEL_HOST_DDR_DMA
#define OPCODE_LOWLEVEL_LOOPBACK_TEST   (18)      // Refer to IOCTL_LOWLEVEL_LOOPBACK_TEST
#define OPCODE_LOWLEVEL_SET_LOOPBACK_MODE (19)    // Refer to
                                                  // IOCTL_LOWLEVEL_SET_LOOPBACK_MODE
#define OPCODE_LOWLEVEL_GET_LOOPBACK_MODE (20)    // Refer to
                                                  // IOCTL_LOWLEVEL_GET_LOOPBACK_MODE
#define OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES (21) // Refer to
                                                     // IOCTL_LOWLEVEL_GET_COREDUMP_PROPER
                                                     // TIES
#define OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES (22) // Refer to
                                                               // IOCTL_LOWLEVEL_GET_CORED
                                                               // UMP_COMPONENT_PROPERTIES
#define OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES (23) // Refer to
                                                             // IOCTL_LOWLEVEL_GET_COREDUM
                                                             // P_SEGMENT_PROPERTIES
#define OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT (24) // Refer to
                                                  // IOCTL_LOWLEVEL_GET_COREDUMP_SEGMENT

typedef enum {
   ENUM_OPCODE_LOWLEVEL_CONFIG_DT_ENTRY = 0x1UL,
   ENUM_OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY = 0x2UL,
   ENUM_OPCODE_LOWLEVEL_ACCESS_MEMORY = 0x3UL,
   ENUM_OPCODE_LOWLEVEL_ACCESS_REGISTERS = 0x4UL,
   ENUM_OPCODE_LOWLEVEL_OFFLOAD_ENABLE = 0x5UL,
   ENUM_OPCODE_LOWLEVEL_CONFIG_TCP_STATE = 0x6UL,
   ENUM_OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER = 0x7UL,
   ENUM_OPCODE_LOWLEVEL_CONFIG_ISCSI = 0x8UL,
   ENUM_OPCODE_LOWLEVEL_CONFIG_TOE = 0x9UL,
   ENUM_OPCODE_LOWLEVEL_ISCSI_OFFLOAD = 0xaUL,
   ENUM_SUBSYSTEM_LOWLEVEL_CONFIG_DT_ENTRY = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_INVALIDATE_PT_ENTRY = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_ACCESS_MEMORY = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_ACCESS_REGISTERS = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_OFFLOAD_ENABLE = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_CONFIG_TCP_STATE = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_CONFIG_TEMPLATE_HEADER = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_CONFIG_ISCSI = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_CONFIG_TOE = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_ISCSI_OFFLOAD = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_MAP_UT_PAGES = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_UNMAP_UT_PAGES = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_MGMT_DEBUG_LEVEL = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_MEASURE_DMA_BANDWIDTH = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_HOST_DDR_DMA = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_LOOPBACK_TEST = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_SET_LOOPBACK_MODE = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_GET_LOOPBACK_MODE = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_GET_COREDUMP_PROPERTIES = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES = 0xbUL,
   ENUM_SUBSYSTEM_LOWLEVEL_GET_COREDUMP_SEGMENT = 0xbUL,
   ENUM_OPCODE_LOWLEVEL_MAP_UT_PAGES = 0xdUL,
   ENUM_OPCODE_LOWLEVEL_UNMAP_UT_PAGES = 0xeUL,
   ENUM_OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL = 0xfUL,
   ENUM_OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH = 0x10UL,
   ENUM_OPCODE_LOWLEVEL_HOST_DDR_DMA = 0x11UL,
   ENUM_OPCODE_LOWLEVEL_LOOPBACK_TEST = 0x12UL,
   ENUM_OPCODE_LOWLEVEL_SET_LOOPBACK_MODE = 0x13UL,
   ENUM_OPCODE_LOWLEVEL_GET_LOOPBACK_MODE = 0x14UL,
   ENUM_OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES = 0x15UL,
   ENUM_OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES = 0x16UL,
   ENUM_OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES = 0x17UL,
   ENUM_OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT = 0x18UL
} LOWLEVEL_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lowlevel_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LOWLEVEL_CONFIG_DT_ENTRY:
            return "OPCODE_LOWLEVEL_CONFIG_DT_ENTRY";
         case OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY:
            return "OPCODE_LOWLEVEL_INVALIDATE_PT_ENTRY";
         case OPCODE_LOWLEVEL_ACCESS_MEMORY:
            return "OPCODE_LOWLEVEL_ACCESS_MEMORY";
         case OPCODE_LOWLEVEL_ACCESS_REGISTERS:
            return "OPCODE_LOWLEVEL_ACCESS_REGISTERS";
         case OPCODE_LOWLEVEL_OFFLOAD_ENABLE:
            return "OPCODE_LOWLEVEL_OFFLOAD_ENABLE";
         case OPCODE_LOWLEVEL_CONFIG_TCP_STATE:
            return "OPCODE_LOWLEVEL_CONFIG_TCP_STATE";
         case OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER:
            return "OPCODE_LOWLEVEL_CONFIG_TEMPLATE_HEADER";
         case OPCODE_LOWLEVEL_CONFIG_ISCSI:
            return "OPCODE_LOWLEVEL_CONFIG_ISCSI";
         case OPCODE_LOWLEVEL_CONFIG_TOE:
            return "OPCODE_LOWLEVEL_CONFIG_TOE";
         case OPCODE_LOWLEVEL_ISCSI_OFFLOAD:
            return "OPCODE_LOWLEVEL_ISCSI_OFFLOAD";
         case OPCODE_LOWLEVEL_MAP_UT_PAGES:
            return "OPCODE_LOWLEVEL_MAP_UT_PAGES";
         case OPCODE_LOWLEVEL_UNMAP_UT_PAGES:
            return "OPCODE_LOWLEVEL_UNMAP_UT_PAGES";
         case OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL:
            return "OPCODE_LOWLEVEL_MGMT_DEBUG_LEVEL";
         case OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH:
            return "OPCODE_LOWLEVEL_MEASURE_DMA_BANDWIDTH";
         case OPCODE_LOWLEVEL_HOST_DDR_DMA:
            return "OPCODE_LOWLEVEL_HOST_DDR_DMA";
         case OPCODE_LOWLEVEL_LOOPBACK_TEST:
            return "OPCODE_LOWLEVEL_LOOPBACK_TEST";
         case OPCODE_LOWLEVEL_SET_LOOPBACK_MODE:
            return "OPCODE_LOWLEVEL_SET_LOOPBACK_MODE";
         case OPCODE_LOWLEVEL_GET_LOOPBACK_MODE:
            return "OPCODE_LOWLEVEL_GET_LOOPBACK_MODE";
         case OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_PROPERTIES";
         case OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_COMPONENT_PROPERTIES";
         case OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT_PROPERTIES";
         case OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT:
            return "OPCODE_LOWLEVEL_GET_COREDUMP_SEGMENT";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- COMMON_FCOE_SUBSYSTEM_OPCODES ---
// Opcodes used for Common FCoE. 
#define OPCODE_COMMON_FCOE_WRBQ_CREATE  (1)       // Refer to
                                                  // IOCTL_COMMON_FCOE_WRBQ_CREATE
#define OPCODE_COMMON_FCOE_WRBQ_DESTROY (2)       // Refer to
                                                  // IOCTL_COMMON_FCOE_WRBQ_DESTROY
#define OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES (3) // Refer to
                                                  // IOCTL_COMMON_FCOE_CFG_POST_SGL_PAGES
#define OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES (4) // Refer to
                                                    // IOCTL_COMMON_FCOE_CFG_REMOVE_SGL_PA
                                                    // GES
#define OPCODE_COMMON_FCOE_DEFQ_CREATE  (5)       // Refer to
                                                  // IOCTL_COMMON_FCOE_DEFQ_CREATE
#define OPCODE_COMMON_FCOE_DEFQ_DESTROY (6)       // Refer to
                                                  // IOCTL_COMMON_FCOE_DEFQ_DESTROY
#define OPCODE_COMMON_FCOE_READ_FCF_TABLE (8)     // Refer to
                                                  // IOCTL_COMMON_FCOE_READ_FCF_TABLE
#define OPCODE_COMMON_FCOE_ADD_FCF      (9)       // Refer to IOCTL_COMMON_FCOE_ADD_FCF
#define OPCODE_COMMON_FCOE_DELETE_FCF   (10)      // Refer to IOCTL_COMMON_FCOE_DELETE_FCF
#define OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES (11) // Refer to
                                                   // IOCTL_COMMON_FCOE_POST_HDR_TEMPLATES
#define SUBSYSTEM_COMMON_FCOE_WRBQ_CREATE (12)    
#define SUBSYSTEM_COMMON_FCOE_WRBQ_DESTROY (12)   
#define SUBSYSTEM_COMMON_FCOE_CFG_POST_SGL_PAGES (12) 
#define SUBSYSTEM_COMMON_FCOE_CFG_REMOVE_SGL_PAGES (12) 
#define SUBSYSTEM_COMMON_FCOE_DEFQ_CREATE (12)    
#define SUBSYSTEM_COMMON_FCOE_DEFQ_DESTROY (12)   
#define SUBSYSTEM_COMMON_FCOE_READ_FCF_TABLE (12) 
#define SUBSYSTEM_COMMON_FCOE_ADD_FCF   (12)      
#define SUBSYSTEM_COMMON_FCOE_DELETE_FCF (12)     
#define SUBSYSTEM_COMMON_FCOE_POST_HDR_TEMPLATES (12) 
#define OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES (12) // Refer to
                                                     // IOCTL_COMMON_FCOE_REMOVE_HDR_TEMPL
                                                     // ATES
#define SUBSYSTEM_COMMON_FCOE_REMOVE_HDR_TEMPLATES (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_IO_INIT (12)   
#define SUBSYSTEM_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST (12) 
#define SUBSYSTEM_COMMON_FCOE_MBOX_REQUEST_COMPLETION (12) 
#define SUBSYSTEM_COMMON_FCOE_REDISCOVER_FCF (12) 
#define OPCODE_COMMON_FCOE_MBOX_IO_INIT (13)      // Refer to
                                                  // IOCTL_COMMON_FCOE_MBOX_IO_INIT
#define OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST (14) // Refer to
                                                       // IOCTL_COMMON_FCOE_MBOX_SUBMIT_IO
                                                       // _REQUEST
#define OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION (15) // Refer to
                                                        // IOCTL_COMMON_FCOE_MBOX_REQUEST_
                                                        // COMPLETION
#define OPCODE_COMMON_FCOE_REDISCOVER_FCF (16)    // Refer to
                                                  // IOCTL_COMMON_FCOE_REDISCOVER_FCF

typedef enum {
   ENUM_OPCODE_COMMON_FCOE_WRBQ_CREATE = 0x1UL,
   ENUM_OPCODE_COMMON_FCOE_WRBQ_DESTROY = 0x2UL,
   ENUM_OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES = 0x3UL,
   ENUM_OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES = 0x4UL,
   ENUM_OPCODE_COMMON_FCOE_DEFQ_CREATE = 0x5UL,
   ENUM_OPCODE_COMMON_FCOE_DEFQ_DESTROY = 0x6UL,
   ENUM_OPCODE_COMMON_FCOE_READ_FCF_TABLE = 0x8UL,
   ENUM_OPCODE_COMMON_FCOE_ADD_FCF = 0x9UL,
   ENUM_OPCODE_COMMON_FCOE_DELETE_FCF = 0xaUL,
   ENUM_OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES = 0xbUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_WRBQ_CREATE = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_WRBQ_DESTROY = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_CFG_POST_SGL_PAGES = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_CFG_REMOVE_SGL_PAGES = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_DEFQ_CREATE = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_DEFQ_DESTROY = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_READ_FCF_TABLE = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_ADD_FCF = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_DELETE_FCF = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_POST_HDR_TEMPLATES = 0xcUL,
   ENUM_OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_REMOVE_HDR_TEMPLATES = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_MBOX_IO_INIT = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_MBOX_REQUEST_COMPLETION = 0xcUL,
   ENUM_SUBSYSTEM_COMMON_FCOE_REDISCOVER_FCF = 0xcUL,
   ENUM_OPCODE_COMMON_FCOE_MBOX_IO_INIT = 0xdUL,
   ENUM_OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST = 0xeUL,
   ENUM_OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION = 0xfUL,
   ENUM_OPCODE_COMMON_FCOE_REDISCOVER_FCF = 0x10UL
} COMMON_FCOE_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* common_fcoe_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_COMMON_FCOE_WRBQ_CREATE:
            return "OPCODE_COMMON_FCOE_WRBQ_CREATE";
         case OPCODE_COMMON_FCOE_WRBQ_DESTROY:
            return "OPCODE_COMMON_FCOE_WRBQ_DESTROY";
         case OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES:
            return "OPCODE_COMMON_FCOE_CFG_POST_SGL_PAGES";
         case OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES:
            return "OPCODE_COMMON_FCOE_CFG_REMOVE_SGL_PAGES";
         case OPCODE_COMMON_FCOE_DEFQ_CREATE:
            return "OPCODE_COMMON_FCOE_DEFQ_CREATE";
         case OPCODE_COMMON_FCOE_DEFQ_DESTROY:
            return "OPCODE_COMMON_FCOE_DEFQ_DESTROY";
         case OPCODE_COMMON_FCOE_READ_FCF_TABLE:
            return "OPCODE_COMMON_FCOE_READ_FCF_TABLE";
         case OPCODE_COMMON_FCOE_ADD_FCF:
            return "OPCODE_COMMON_FCOE_ADD_FCF";
         case OPCODE_COMMON_FCOE_DELETE_FCF:
            return "OPCODE_COMMON_FCOE_DELETE_FCF";
         case OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES:
            return "OPCODE_COMMON_FCOE_POST_HDR_TEMPLATES";
         case OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES:
            return "OPCODE_COMMON_FCOE_REMOVE_HDR_TEMPLATES";
         case OPCODE_COMMON_FCOE_MBOX_IO_INIT:
            return "OPCODE_COMMON_FCOE_MBOX_IO_INIT";
         case OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST:
            return "OPCODE_COMMON_FCOE_MBOX_SUBMIT_IO_REQUEST";
         case OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION:
            return "OPCODE_COMMON_FCOE_MBOX_REQUEST_COMPLETION";
         case OPCODE_COMMON_FCOE_REDISCOVER_FCF:
            return "OPCODE_COMMON_FCOE_REDISCOVER_FCF";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- LLDP_SUBSYSTEM_OPCODES ---
// Opcodes used for LLDP configuration. 
#define OPCODE_LLDP_GET_LLDP_CFG        (1)       // Refer to IOCTL_LLDP_GET_LLDP_CFG
#define OPCODE_LLDP_SET_LLDP_CFG        (2)       // Refer to IOCTL_LLDP_SET_LLDP_CFG
#define OPCODE_LLDP_GET_LLDP_STATS      (3)       // Refer to IOCTL_LLDP_GET_LLDP_STATS
#define SUBSYSTEM_LLDP_GET_LLDP_CFG     (15)      
#define SUBSYSTEM_LLDP_SET_LLDP_CFG     (15)      
#define SUBSYSTEM_LLDP_GET_LLDP_STATS   (15)      

typedef enum {
   ENUM_OPCODE_LLDP_GET_LLDP_CFG = 0x1UL,
   ENUM_OPCODE_LLDP_SET_LLDP_CFG = 0x2UL,
   ENUM_OPCODE_LLDP_GET_LLDP_STATS = 0x3UL,
   ENUM_SUBSYSTEM_LLDP_GET_LLDP_CFG = 0xfUL,
   ENUM_SUBSYSTEM_LLDP_SET_LLDP_CFG = 0xfUL,
   ENUM_SUBSYSTEM_LLDP_GET_LLDP_STATS = 0xfUL
} LLDP_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* lldp_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_LLDP_GET_LLDP_CFG:
            return "OPCODE_LLDP_GET_LLDP_CFG";
         case OPCODE_LLDP_SET_LLDP_CFG:
            return "OPCODE_LLDP_SET_LLDP_CFG";
         case OPCODE_LLDP_GET_LLDP_STATS:
            return "OPCODE_LLDP_GET_LLDP_STATS";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DCBX_SUBSYSTEM_OPCODES ---
// Opcodes used for DCBX. 
#define OPCODE_DCBX_GET_DCBX_CFG        (1)       // Refer to IOCTL_DCBX_GET_DCBX_CFG
#define OPCODE_DCBX_SET_DCBX_CFG        (2)       // Refer to IOCTL_DCBX_SET_DCBX_CFG
#define OPCODE_DCBX_GET_DCBX_MIB_INFO   (3)       // Refer to IOCTL_DCBX_GET_DCBX_MIB_INFO
#define OPCODE_DCBX_GET_DCBX_MODE       (4)       // Refer to IOCTL_DCBX_GET_DCBX_MODE
#define OPCODE_DCBX_SET_DCBX_MODE       (5)       // Refer to IOCTL_DCBX_SET_DCBX_MODE
#define SUBSYSTEM_DCBX_GET_DCBX_CFG     (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_CFG     (16)      
#define SUBSYSTEM_DCBX_GET_DCBX_MIB_INFO (16)     
#define SUBSYSTEM_DCBX_GET_DCBX_MODE    (16)      
#define SUBSYSTEM_DCBX_SET_DCBX_MODE    (16)      

typedef enum {
   ENUM_OPCODE_DCBX_GET_DCBX_CFG = 0x1UL,
   ENUM_OPCODE_DCBX_SET_DCBX_CFG = 0x2UL,
   ENUM_OPCODE_DCBX_GET_DCBX_MIB_INFO = 0x3UL,
   ENUM_OPCODE_DCBX_GET_DCBX_MODE = 0x4UL,
   ENUM_OPCODE_DCBX_SET_DCBX_MODE = 0x5UL,
   ENUM_SUBSYSTEM_DCBX_GET_DCBX_CFG = 0x10UL,
   ENUM_SUBSYSTEM_DCBX_SET_DCBX_CFG = 0x10UL,
   ENUM_SUBSYSTEM_DCBX_GET_DCBX_MIB_INFO = 0x10UL,
   ENUM_SUBSYSTEM_DCBX_GET_DCBX_MODE = 0x10UL,
   ENUM_SUBSYSTEM_DCBX_SET_DCBX_MODE = 0x10UL
} DCBX_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dcbx_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DCBX_GET_DCBX_CFG:
            return "OPCODE_DCBX_GET_DCBX_CFG";
         case OPCODE_DCBX_SET_DCBX_CFG:
            return "OPCODE_DCBX_SET_DCBX_CFG";
         case OPCODE_DCBX_GET_DCBX_MIB_INFO:
            return "OPCODE_DCBX_GET_DCBX_MIB_INFO";
         case OPCODE_DCBX_GET_DCBX_MODE:
            return "OPCODE_DCBX_GET_DCBX_MODE";
         case OPCODE_DCBX_SET_DCBX_MODE:
            return "OPCODE_DCBX_SET_DCBX_MODE";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DMTF_SUBSYSTEM_OPCODES ---
// Opcodes used for DMTF. 
#define OPCODE_DMTF_EXECUTE_CMD         (1)       // Refer to IOCTL_DMTF_EXECUTE_CMD
#define SUBSYSTEM_DMTF_EXECUTE_CMD      (17)      

typedef enum {
   ENUM_OPCODE_DMTF_EXECUTE_CMD = 0x1UL,
   ENUM_SUBSYSTEM_DMTF_EXECUTE_CMD = 0x11UL
} DMTF_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* dmtf_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DMTF_EXECUTE_CMD:
            return "OPCODE_DMTF_EXECUTE_CMD";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- DIAG_SUBSYSTEM_OPCODES ---
// Opcodes used for diag functions common to many subystems. 
#define OPCODE_DIAG_DMA                 (1)       // Refer to IOCTL_DIAG_DMA
#define OPCODE_DIAG_MDIO                (2)       // Refer to IOCTL_DIAG_MDIO
#define OPCODE_DIAG_NLB                 (3)       // Refer to IOCTL_DIAG_NLB
#define OPCODE_DIAG_ATT                 (4)       // Refer to IOCTL_DIAG_ATT
#define OPCODE_DIAG_GETMAC              (5)       // Refer to IOCTL_DIAG_GETMAC
#define OPCODE_DIAG_8051_CMD            (6)       // Refer to IOCTL_DIAG_8051_CMD
#define OPCODE_DIAG_RESET_PHY           (7)       // Refer to IOCTL_DIAG_RESET_PHY
#define SUBSYSTEM_DIAG_DMA              (18)      
#define SUBSYSTEM_DIAG_MDIO             (18)      
#define SUBSYSTEM_DIAG_NLB              (18)      
#define SUBSYSTEM_DIAG_ATT              (18)      
#define SUBSYSTEM_DIAG_GETMAC           (18)      
#define SUBSYSTEM_DIAG_8051_CMD         (18)      
#define SUBSYSTEM_DIAG_RESET_PHY        (18)      

typedef enum {
   ENUM_OPCODE_DIAG_DMA = 0x1UL,
   ENUM_OPCODE_DIAG_MDIO = 0x2UL,
   ENUM_OPCODE_DIAG_NLB = 0x3UL,
   ENUM_OPCODE_DIAG_ATT = 0x4UL,
   ENUM_OPCODE_DIAG_GETMAC = 0x5UL,
   ENUM_OPCODE_DIAG_8051_CMD = 0x6UL,
   ENUM_OPCODE_DIAG_RESET_PHY = 0x7UL,
   ENUM_SUBSYSTEM_DIAG_DMA = 0x12UL,
   ENUM_SUBSYSTEM_DIAG_MDIO = 0x12UL,
   ENUM_SUBSYSTEM_DIAG_NLB = 0x12UL,
   ENUM_SUBSYSTEM_DIAG_ATT = 0x12UL,
   ENUM_SUBSYSTEM_DIAG_GETMAC = 0x12UL,
   ENUM_SUBSYSTEM_DIAG_8051_CMD = 0x12UL,
   ENUM_SUBSYSTEM_DIAG_RESET_PHY = 0x12UL
} DIAG_SUBSYSTEM_OPCODES;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* diag_subsystem_opcodes_get_name (u32 enum_value) {
      switch (enum_value) {
         case OPCODE_DIAG_DMA:
            return "OPCODE_DIAG_DMA";
         case OPCODE_DIAG_MDIO:
            return "OPCODE_DIAG_MDIO";
         case OPCODE_DIAG_NLB:
            return "OPCODE_DIAG_NLB";
         case OPCODE_DIAG_ATT:
            return "OPCODE_DIAG_ATT";
         case OPCODE_DIAG_GETMAC:
            return "OPCODE_DIAG_GETMAC";
         case OPCODE_DIAG_8051_CMD:
            return "OPCODE_DIAG_8051_CMD";
         case OPCODE_DIAG_RESET_PHY:
            return "OPCODE_DIAG_RESET_PHY";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- VENDOR_SUBSYSTEM_OPCODES ---
// Opcodes used for Vendor subsystem. 
#define OPCODE_VENDOR_SLI               (1)       // Refer to IOCTL_VENDOR_SLI
#define SUBSYSTEM_VENDOR_SLI            (19)      

typedef enum {
   ENUM_OPCODE_VENDOR_SLI = 0x1UL,
   ENUM_SUBSYSTEM_VENDOR_SLI = 0x13UL
} VENDOR_SUBSYSTEM_OPCODES;

// --- MGMT_ERROR_CODES ---
// Values for the status field of the IOCTL response header. 
#define MGMT_STATUS_SUCCESS             (0)       // The IOCTL completed without errors. 
#define MGMT_STATUS_FAILED              (1)       // Generic error status 
#define MGMT_STATUS_ILLEGAL_REQUEST     (2)       // Invalid IOCTL opcode.
#define MGMT_STATUS_ILLEGAL_FIELD       (3)       // Invalid parameter in the IOCTL
                                                  // payload. The offset of the invalid
                                                  // parameter is filled in the
                                                  // extended/additional status.
#define MGMT_STATUS_INSUFFICIENT_BUFFER (4)       // A buffer size presented by an IOCTL
                                                  // is insufficient for Firmware/OSM to
                                                  // process and return IOCTL output. 
#define MGMT_STATUS_UNAUTHORIZED_REQUEST (5)      // This domain is not permitted to
                                                  // execute such a request. Applicable to
                                                  // BE-VM only
#define MGMT_STATUS_INVALID_IPADDR      (11)      // The provided IP Address is invalid. 
#define MGMT_STATUS_INVALID_GATEWAY     (12)      // The provided Gateway IP Address is
                                                  // invalid. 
#define MGMT_STATUS_INVALID_SUBNETMASK  (13)      // The provided Subnet IP Address is
                                                  // invalid. 
#define MGMT_STATUS_INVALID_TARGET_IPADDR (16)    // The provided Target IP Address is
                                                  // invalid or Target at this IP is
                                                  // non-existing. 
#define MGMT_STATUS_TGTTBL_FULL         (20)      // The Target count exceeded the
                                                  // configured maximum limit. 
#define MGMT_STATUS_FLASHROM_SAVE_FAILED (23)     // The Flash Write operation failed. 
#define MGMT_STATUS_IOCTLHANDLE_ALLOC_FAILED (27) // The IOCTL failed because the iSCSI
                                                  // driver could not allocate an internal
                                                  // resource for the IOCTL.
#define MGMT_STATUS_INVALID_SESSION     (31)      // Invalid SESSION id 
#define MGMT_STATUS_INVALID_CONNECTION  (32)      // Invalid connection ID 
#define MGMT_STATUS_BTL_PATH_EXCEEDS_OSM_LIMIT (33) // The value of PathID specified in
                                                    // the login IOCTL exceeds the limit.
#define MGMT_STATUS_BTL_TGTID_EXCEEDS_OSM_LIMIT (34) // The value of TargetID specified in
                                                     // the login IOCTL exceeds the limit.
#define MGMT_STATUS_BTL_PATH_TGTID_OCCUPIED (35)  // In the OSM target table, the slot of
                                                  // the specified Path and TargetID is
                                                  // already occupied by another target. 
#define MGMT_STATUS_BTL_NO_FREE_SLOT_PATH (36)    // OSM can't locate a free slot in its
                                                  // target table for the specified path
                                                  // ID.
#define MGMT_STATUS_BTL_NO_FREE_SLOT_TGTID (37)   // OSM can't locate a free slot in its
                                                  // target table for the specified target
                                                  // ID.
#define MGMT_STATUS_POLL_IOCTL_TIMEOUT  (40)      // Polling IOCTL is timeout.
#define MGMT_STATUS_ERROR_ACITISCSI     (41)      // Error returned from ACIT-ISCSI
                                                  // module.
#define MGMT_STATUS_BUFFER_SIZE_EXCEED_OSM_OR_OS_LIMIT (43) // This error indicates that
                                                            // IOCTL buffer size is too
                                                            // big for either the OSM or
                                                            // OS to handle. In Windows,
                                                            // after MILI allocates the
                                                            // buffer, OS will forward the
                                                            // IOCTL request to the driver
                                                            // IF the IOCTL buffer size is
                                                            // less than/equal to the
                                                            // maximum IO size. When the
                                                            // OSM detects this situation,
                                                            // OSM sets this status in the
                                                            // IOCTL header. 
#define MGMT_STATUS_REBOOT_REQUIRED     (44)      // The operation completed successfully,
                                                  // but a reboot is required for the
                                                  // change to take effect.
#define MGMT_STATUS_INSUFFICIENT_TIMEOUT (45)     // The timeout specified for the SCSI
                                                  // PassThrough command was not
                                                  // sufficient.
#define MGMT_STATUS_IPADDR_NOT_SET      (46)      // The interface does not have IP
                                                  // Address configured. 
#define MGMT_STATUS_IPADDR_DUP_DETECTED (47)      // The provided IP Address could not be
                                                  // set on the interface as some other
                                                  // machine is using the same IP Address.
#define MGMT_STATUS_CANT_REMOVE_LAST_CONNECTION (48) // The connection removal failed in
                                                     // multiple connection per session
                                                     // configuration because the
                                                     // connection being removed is the
                                                     // last connection in the session. 
#define MGMT_STATUS_TARGET_BUSY         (49)      // The logout request did not complete
                                                  // because either IOs are pending or the
                                                  // target is in recovery. 
#define MGMT_STATUS_TGT_ERR_LISTEN_SOCKET (50)    // The Listening socket could not be set
                                                  // on the provided portal. 
#define MGMT_STATUS_TGT_ERR_BIND_SOCKET (51)      // The socket could not bind to the
                                                  // provided portal. 
#define MGMT_STATUS_TGT_ERR_NO_SOCKET   (52)      // The socket could not be created. 
#define MGMT_STATUS_TGT_ERR_ISNS_COMM_FAILED (55) // The ISNS server could not be reached.
#define MGMT_STATUS_CANNOT_DELETE_BOOT_TARGET (56) // The persistent target could not be
                                                   // deleted as it happens to be a boot
                                                   // target. 
#define MGMT_STATUS_TGT_PORTAL_MODE_IN_LISTEN (57) // The portal is already in listening
                                                   // state. 
#define MGMT_STATUS_FCF_IN_USE          (58)      
#define MGMT_STATUS_NO_CQE              (59)      
#define MGMT_STATUS_TARGET_NOT_FOUND    (65)      // The SCSI PassThrough IOCTL failed
                                                  // because the target was not present in
                                                  // the driver's list. 
#define MGMT_STATUS_NOT_SUPPORTED       (66)      // A generic status message indicating
                                                  // that the requested operation, though
                                                  // valid, is not supported by the
                                                  // device.
#define MGMT_STATUS_NO_FCF_RECORDS      (67)      // No FCF records available to FCoE
                                                  // driver/BIOS 
#define MGMT_STATUS_FEATURE_NOT_SUPPORTED (68)    // Requested feature in the Ioctl is not
                                                  // supported by currently active
                                                  // firmware 
#define MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE (69) // Function number passed in VPD
                                                   // get/set Ioctl is out of valid range 
#define MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT (70) // Function type passed in VPD
                                                     // get/set Ioctl is invalid 
#define MGMT_STATUS_INVALID_NON_EMBEDDED_WRB (71) // Incoming non-embedded WRB (via
                                                  // Mailbox mode or MCC ring mode)
                                                  // request is corrupted 

typedef enum {
   ENUM_MGMT_STATUS_SUCCESS = 0x0UL,
   ENUM_MGMT_STATUS_FAILED = 0x1UL,
   ENUM_MGMT_STATUS_ILLEGAL_REQUEST = 0x2UL,
   ENUM_MGMT_STATUS_ILLEGAL_FIELD = 0x3UL,
   ENUM_MGMT_STATUS_INSUFFICIENT_BUFFER = 0x4UL,
   ENUM_MGMT_STATUS_UNAUTHORIZED_REQUEST = 0x5UL,
   ENUM_MGMT_STATUS_INVALID_IPADDR = 0xbUL,
   ENUM_MGMT_STATUS_INVALID_GATEWAY = 0xcUL,
   ENUM_MGMT_STATUS_INVALID_SUBNETMASK = 0xdUL,
   ENUM_MGMT_STATUS_INVALID_TARGET_IPADDR = 0x10UL,
   ENUM_MGMT_STATUS_TGTTBL_FULL = 0x14UL,
   ENUM_MGMT_STATUS_FLASHROM_SAVE_FAILED = 0x17UL,
   ENUM_MGMT_STATUS_IOCTLHANDLE_ALLOC_FAILED = 0x1bUL,
   ENUM_MGMT_STATUS_INVALID_SESSION = 0x1fUL,
   ENUM_MGMT_STATUS_INVALID_CONNECTION = 0x20UL,
   ENUM_MGMT_STATUS_BTL_PATH_EXCEEDS_OSM_LIMIT = 0x21UL,
   ENUM_MGMT_STATUS_BTL_TGTID_EXCEEDS_OSM_LIMIT = 0x22UL,
   ENUM_MGMT_STATUS_BTL_PATH_TGTID_OCCUPIED = 0x23UL,
   ENUM_MGMT_STATUS_BTL_NO_FREE_SLOT_PATH = 0x24UL,
   ENUM_MGMT_STATUS_BTL_NO_FREE_SLOT_TGTID = 0x25UL,
   ENUM_MGMT_STATUS_POLL_IOCTL_TIMEOUT = 0x28UL,
   ENUM_MGMT_STATUS_ERROR_ACITISCSI = 0x29UL,
   ENUM_MGMT_STATUS_BUFFER_SIZE_EXCEED_OSM_OR_OS_LIMIT = 0x2bUL,
   ENUM_MGMT_STATUS_REBOOT_REQUIRED = 0x2cUL,
   ENUM_MGMT_STATUS_INSUFFICIENT_TIMEOUT = 0x2dUL,
   ENUM_MGMT_STATUS_IPADDR_NOT_SET = 0x2eUL,
   ENUM_MGMT_STATUS_IPADDR_DUP_DETECTED = 0x2fUL,
   ENUM_MGMT_STATUS_CANT_REMOVE_LAST_CONNECTION = 0x30UL,
   ENUM_MGMT_STATUS_TARGET_BUSY = 0x31UL,
   ENUM_MGMT_STATUS_TGT_ERR_LISTEN_SOCKET = 0x32UL,
   ENUM_MGMT_STATUS_TGT_ERR_BIND_SOCKET = 0x33UL,
   ENUM_MGMT_STATUS_TGT_ERR_NO_SOCKET = 0x34UL,
   ENUM_MGMT_STATUS_TGT_ERR_ISNS_COMM_FAILED = 0x37UL,
   ENUM_MGMT_STATUS_CANNOT_DELETE_BOOT_TARGET = 0x38UL,
   ENUM_MGMT_STATUS_TGT_PORTAL_MODE_IN_LISTEN = 0x39UL,
   ENUM_MGMT_STATUS_FCF_IN_USE = 0x3aUL,
   ENUM_MGMT_STATUS_NO_CQE = 0x3bUL,
   ENUM_MGMT_STATUS_TARGET_NOT_FOUND = 0x41UL,
   ENUM_MGMT_STATUS_NOT_SUPPORTED = 0x42UL,
   ENUM_MGMT_STATUS_NO_FCF_RECORDS = 0x43UL,
   ENUM_MGMT_STATUS_FEATURE_NOT_SUPPORTED = 0x44UL,
   ENUM_MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE = 0x45UL,
   ENUM_MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT = 0x46UL,
   ENUM_MGMT_STATUS_INVALID_NON_EMBEDDED_WRB = 0x47UL
} MGMT_ERROR_CODES;

#ifndef SG_OMIT_DOC_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mgmt_error_codes_get_doc (u32 enum_value) {
      switch (enum_value) {
         case MGMT_STATUS_SUCCESS:
            return "The IOCTL completed without errors.  "            ;
         case MGMT_STATUS_FAILED:
            return "Generic error status  "            ;
         case MGMT_STATUS_ILLEGAL_REQUEST:
            return "Invalid IOCTL opcode. "            ;
         case MGMT_STATUS_ILLEGAL_FIELD:
            return "Invalid parameter in the IOCTL payload. The offset of the invalid "
                   "parameter is filled in the extended/additional status. "            ;
         case MGMT_STATUS_INSUFFICIENT_BUFFER:
            return "A buffer size presented by an IOCTL is insufficient for Firmware/OSM "
                   "to process and return IOCTL output.  "            ;
         case MGMT_STATUS_UNAUTHORIZED_REQUEST:
            return "This domain is not permitted to execute such a request. Applicable "
                   "to BE-VM only "            ;
         case MGMT_STATUS_INVALID_IPADDR:
            return "The provided IP Address is invalid.  "            ;
         case MGMT_STATUS_INVALID_GATEWAY:
            return "The provided Gateway IP Address is invalid.  "            ;
         case MGMT_STATUS_INVALID_SUBNETMASK:
            return "The provided Subnet IP Address is invalid.  "            ;
         case MGMT_STATUS_INVALID_TARGET_IPADDR:
            return "The provided Target IP Address is invalid or Target at this IP is "
                   "non-existing.  "            ;
         case MGMT_STATUS_TGTTBL_FULL:
            return "The Target count exceeded the configured maximum limit.  "            ;
         case MGMT_STATUS_FLASHROM_SAVE_FAILED:
            return "The Flash Write operation failed.  "            ;
         case MGMT_STATUS_IOCTLHANDLE_ALLOC_FAILED:
            return "The IOCTL failed because the iSCSI driver could not allocate an "
                   "internal resource for the IOCTL. "            ;
         case MGMT_STATUS_INVALID_SESSION:
            return "Invalid SESSION id  "            ;
         case MGMT_STATUS_INVALID_CONNECTION:
            return "Invalid connection ID  "            ;
         case MGMT_STATUS_BTL_PATH_EXCEEDS_OSM_LIMIT:
            return "The value of PathID specified in the login IOCTL exceeds the limit. "            ;
         case MGMT_STATUS_BTL_TGTID_EXCEEDS_OSM_LIMIT:
            return "The value of TargetID specified in the login IOCTL exceeds the "
                   "limit. "            ;
         case MGMT_STATUS_BTL_PATH_TGTID_OCCUPIED:
            return "In the OSM target table, the slot of the specified Path and TargetID "
                   "is already occupied by another target.  "            ;
         case MGMT_STATUS_BTL_NO_FREE_SLOT_PATH:
            return "OSM can't locate a free slot in its target table for the specified "
                   "path ID. "            ;
         case MGMT_STATUS_BTL_NO_FREE_SLOT_TGTID:
            return "OSM can't locate a free slot in its target table for the specified "
                   "target ID. "            ;
         case MGMT_STATUS_POLL_IOCTL_TIMEOUT:
            return "Polling IOCTL is timeout. "            ;
         case MGMT_STATUS_ERROR_ACITISCSI:
            return "Error returned from ACIT-ISCSI module. "            ;
         case MGMT_STATUS_BUFFER_SIZE_EXCEED_OSM_OR_OS_LIMIT:
            return "This error indicates that IOCTL buffer size is too big for either "
                   "the OSM or OS to handle. In Windows, after MILI allocates the "
                   "buffer, OS will forward the IOCTL request to the driver IF the IOCTL "
                   "buffer size is less than/equal to the maximum IO size. When the OSM "
                   "detects this situation, OSM sets this status in the IOCTL header.  "            ;
         case MGMT_STATUS_REBOOT_REQUIRED:
            return "The operation completed successfully, but a reboot is required for "
                   "the change to take effect. "            ;
         case MGMT_STATUS_INSUFFICIENT_TIMEOUT:
            return "The timeout specified for the SCSI PassThrough command was not "
                   "sufficient. "            ;
         case MGMT_STATUS_IPADDR_NOT_SET:
            return "The interface does not have IP Address configured.  "            ;
         case MGMT_STATUS_IPADDR_DUP_DETECTED:
            return "The provided IP Address could not be set on the interface as some "
                   "other machine is using the same IP Address.  "            ;
         case MGMT_STATUS_CANT_REMOVE_LAST_CONNECTION:
            return "The connection removal failed in multiple connection per session "
                   "configuration because the connection being removed is the last "
                   "connection in the session.  "            ;
         case MGMT_STATUS_TARGET_BUSY:
            return "The logout request did not complete because either IOs are pending "
                   "or the target is in recovery.  "            ;
         case MGMT_STATUS_TGT_ERR_LISTEN_SOCKET:
            return "The Listening socket could not be set on the provided portal.  "            ;
         case MGMT_STATUS_TGT_ERR_BIND_SOCKET:
            return "The socket could not bind to the provided portal.  "            ;
         case MGMT_STATUS_TGT_ERR_NO_SOCKET:
            return "The socket could not be created.  "            ;
         case MGMT_STATUS_TGT_ERR_ISNS_COMM_FAILED:
            return "The ISNS server could not be reached.  "            ;
         case MGMT_STATUS_CANNOT_DELETE_BOOT_TARGET:
            return "The persistent target could not be deleted as it happens to be a "
                   "boot target.  "            ;
         case MGMT_STATUS_TGT_PORTAL_MODE_IN_LISTEN:
            return "The portal is already in listening state.  "            ;
         case MGMT_STATUS_FCF_IN_USE:
            return "";
         case MGMT_STATUS_NO_CQE:
            return "";
         case MGMT_STATUS_TARGET_NOT_FOUND:
            return "The SCSI PassThrough IOCTL failed because the target was not present "
                   "in the driver's list.  "            ;
         case MGMT_STATUS_NOT_SUPPORTED:
            return "A generic status message indicating that the requested operation, "
                   "though valid, is not supported by the device. "            ;
         case MGMT_STATUS_NO_FCF_RECORDS:
            return "No FCF records available to FCoE driver/BIOS  "            ;
         case MGMT_STATUS_FEATURE_NOT_SUPPORTED:
            return "Requested feature in the Ioctl is not supported by currently active "
                   "firmware  "            ;
         case MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE:
            return "Function number passed in VPD get/set Ioctl is out of valid range  "            ;
         case MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT:
            return "Function type passed in VPD get/set Ioctl is invalid  "            ;
         case MGMT_STATUS_INVALID_NON_EMBEDDED_WRB:
            return "Incoming non-embedded WRB (via Mailbox mode or MCC ring mode) "
                   "request is corrupted  "            ;
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mgmt_error_codes_get_name (u32 enum_value) {
      switch (enum_value) {
         case MGMT_STATUS_SUCCESS:
            return "MGMT_STATUS_SUCCESS";
         case MGMT_STATUS_FAILED:
            return "MGMT_STATUS_FAILED";
         case MGMT_STATUS_ILLEGAL_REQUEST:
            return "MGMT_STATUS_ILLEGAL_REQUEST";
         case MGMT_STATUS_ILLEGAL_FIELD:
            return "MGMT_STATUS_ILLEGAL_FIELD";
         case MGMT_STATUS_INSUFFICIENT_BUFFER:
            return "MGMT_STATUS_INSUFFICIENT_BUFFER";
         case MGMT_STATUS_UNAUTHORIZED_REQUEST:
            return "MGMT_STATUS_UNAUTHORIZED_REQUEST";
         case MGMT_STATUS_INVALID_IPADDR:
            return "MGMT_STATUS_INVALID_IPADDR";
         case MGMT_STATUS_INVALID_GATEWAY:
            return "MGMT_STATUS_INVALID_GATEWAY";
         case MGMT_STATUS_INVALID_SUBNETMASK:
            return "MGMT_STATUS_INVALID_SUBNETMASK";
         case MGMT_STATUS_INVALID_TARGET_IPADDR:
            return "MGMT_STATUS_INVALID_TARGET_IPADDR";
         case MGMT_STATUS_TGTTBL_FULL:
            return "MGMT_STATUS_TGTTBL_FULL";
         case MGMT_STATUS_FLASHROM_SAVE_FAILED:
            return "MGMT_STATUS_FLASHROM_SAVE_FAILED";
         case MGMT_STATUS_IOCTLHANDLE_ALLOC_FAILED:
            return "MGMT_STATUS_IOCTLHANDLE_ALLOC_FAILED";
         case MGMT_STATUS_INVALID_SESSION:
            return "MGMT_STATUS_INVALID_SESSION";
         case MGMT_STATUS_INVALID_CONNECTION:
            return "MGMT_STATUS_INVALID_CONNECTION";
         case MGMT_STATUS_BTL_PATH_EXCEEDS_OSM_LIMIT:
            return "MGMT_STATUS_BTL_PATH_EXCEEDS_OSM_LIMIT";
         case MGMT_STATUS_BTL_TGTID_EXCEEDS_OSM_LIMIT:
            return "MGMT_STATUS_BTL_TGTID_EXCEEDS_OSM_LIMIT";
         case MGMT_STATUS_BTL_PATH_TGTID_OCCUPIED:
            return "MGMT_STATUS_BTL_PATH_TGTID_OCCUPIED";
         case MGMT_STATUS_BTL_NO_FREE_SLOT_PATH:
            return "MGMT_STATUS_BTL_NO_FREE_SLOT_PATH";
         case MGMT_STATUS_BTL_NO_FREE_SLOT_TGTID:
            return "MGMT_STATUS_BTL_NO_FREE_SLOT_TGTID";
         case MGMT_STATUS_POLL_IOCTL_TIMEOUT:
            return "MGMT_STATUS_POLL_IOCTL_TIMEOUT";
         case MGMT_STATUS_ERROR_ACITISCSI:
            return "MGMT_STATUS_ERROR_ACITISCSI";
         case MGMT_STATUS_BUFFER_SIZE_EXCEED_OSM_OR_OS_LIMIT:
            return "MGMT_STATUS_BUFFER_SIZE_EXCEED_OSM_OR_OS_LIMIT";
         case MGMT_STATUS_REBOOT_REQUIRED:
            return "MGMT_STATUS_REBOOT_REQUIRED";
         case MGMT_STATUS_INSUFFICIENT_TIMEOUT:
            return "MGMT_STATUS_INSUFFICIENT_TIMEOUT";
         case MGMT_STATUS_IPADDR_NOT_SET:
            return "MGMT_STATUS_IPADDR_NOT_SET";
         case MGMT_STATUS_IPADDR_DUP_DETECTED:
            return "MGMT_STATUS_IPADDR_DUP_DETECTED";
         case MGMT_STATUS_CANT_REMOVE_LAST_CONNECTION:
            return "MGMT_STATUS_CANT_REMOVE_LAST_CONNECTION";
         case MGMT_STATUS_TARGET_BUSY:
            return "MGMT_STATUS_TARGET_BUSY";
         case MGMT_STATUS_TGT_ERR_LISTEN_SOCKET:
            return "MGMT_STATUS_TGT_ERR_LISTEN_SOCKET";
         case MGMT_STATUS_TGT_ERR_BIND_SOCKET:
            return "MGMT_STATUS_TGT_ERR_BIND_SOCKET";
         case MGMT_STATUS_TGT_ERR_NO_SOCKET:
            return "MGMT_STATUS_TGT_ERR_NO_SOCKET";
         case MGMT_STATUS_TGT_ERR_ISNS_COMM_FAILED:
            return "MGMT_STATUS_TGT_ERR_ISNS_COMM_FAILED";
         case MGMT_STATUS_CANNOT_DELETE_BOOT_TARGET:
            return "MGMT_STATUS_CANNOT_DELETE_BOOT_TARGET";
         case MGMT_STATUS_TGT_PORTAL_MODE_IN_LISTEN:
            return "MGMT_STATUS_TGT_PORTAL_MODE_IN_LISTEN";
         case MGMT_STATUS_FCF_IN_USE:
            return "MGMT_STATUS_FCF_IN_USE";
         case MGMT_STATUS_NO_CQE:
            return "MGMT_STATUS_NO_CQE";
         case MGMT_STATUS_TARGET_NOT_FOUND:
            return "MGMT_STATUS_TARGET_NOT_FOUND";
         case MGMT_STATUS_NOT_SUPPORTED:
            return "MGMT_STATUS_NOT_SUPPORTED";
         case MGMT_STATUS_NO_FCF_RECORDS:
            return "MGMT_STATUS_NO_FCF_RECORDS";
         case MGMT_STATUS_FEATURE_NOT_SUPPORTED:
            return "MGMT_STATUS_FEATURE_NOT_SUPPORTED";
         case MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE:
            return "MGMT_STATUS_VPD_FUNCTION_OUT_OF_RANGE";
         case MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT:
            return "MGMT_STATUS_VPD_FUNCTION_TYPE_INCORRECT";
         case MGMT_STATUS_INVALID_NON_EMBEDDED_WRB:
            return "MGMT_STATUS_INVALID_NON_EMBEDDED_WRB";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif

// --- MGMT_ADDL_STATUS ---
// Values for the additional_status field of the IOCTL response header. 
#define MGMT_ADDI_STATUS_NO_STATUS      (0)       // There is no additional status
                                                  // reported, mostly used to convey that
                                                  // the IOCTL completed without errors. 
#define MGMT_ADDI_STATUS_INVALID_IPTYPE (1)       // The provided IP Type is invalid. It
                                                  // should be either IPv4 or IPv6 type. 
#define MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND (9) // The provided Target handle is
                                                     // invalid. 
#define MGMT_ADDI_STATUS_SESSION_HANDLE_NOT_FOUND (10) // The provided Session handle is
                                                       // invalid. 
#define MGMT_ADDI_STATUS_CONNECTION_HANDLE_NOT_FOUND (11) // The provided Session handle
                                                          // or the Connection ring ID is
                                                          // invalid. 
#define MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT (16) // The erase operation could not be
                                                      // completed, sessions exist. 
#define MGMT_ADDI_STATUS_SESSION_ALREADY_OPENED (17) // The login to target cannot
                                                     // complete as the target is already
                                                     // logged-in. 
#define MGMT_ADDI_STATUS_SESSION_ALREADY_CLOSED (18) // The target is already logged-out
                                                     // or session to target is not open. 
#define MGMT_ADDI_STATUS_DEST_HOST_UNREACHABLE (19) // The login to target cannot complete
                                                    // as the target is not reachable. 
#define MGMT_ADDI_STATUS_LOGIN_IN_PROGRESS (20)   // The remove connection IOCTL failed
                                                  // because the leading connection on the
                                                  // session is being offloaded. 
#define MGMT_ADDI_STATUS_TCP_CONNECT_FAILED (21)  // The login to target cannot complete
                                                  // as the target does not respond to TCP
                                                  // handshake. 
#define MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES (22) // There are insufficient resources
                                                     // on the chip to complete the IOCTL
                                                     // request. 
#define MGMT_ADDI_STATUS_LINK_DOWN      (23)      // Indicates the link down status for
                                                  // port associated with the caller. 
#define MGMT_ADDI_STATUS_DHCP_ERROR     (24)      // Generic DHCP error. 
#define MGMT_ADDI_STATUS_CONNECTION_OFFLOADED (25) // Indicates that ARM received an
                                                   // illegal offload connection request
                                                   // for a connection which is already
                                                   // offloaded.
#define MGMT_ADDI_STATUS_CONNECTION_NOT_OFFLOADED (26) // Indicates that ARM received an
                                                       // illegal request for a
                                                       // non-offloaded connection.
#define MGMT_ADDI_STATUS_CONNECTION_UPLOAD_IN_PROGRESS (27) // Indicates that ARM received
                                                            // an illegal request for a
                                                            // connection which is
                                                            // currently in an upload
                                                            // state.
#define MGMT_ADDI_STATUS_REQUEST_REJECTED (28)    // Used to communicate a flush or
                                                  // upload/close request on a connection
                                                  // was rejected by protocol firmware. 
#define MGMT_ADDI_STATUS_INVALID_SUBSYSTEM (29)   // Indicates that the IOCTL ARM received
                                                  // has an invalid subsystem code.
#define MGMT_ADDI_STATUS_INVALID_OPCODE (30)      // Indicates that the IOCTL ARM received
                                                  // has an invalid opcode.
#define MGMT_ADDI_STATUS_INVALID_MAXCONNECTION_PARAM (31) // The login failed since max
                                                          // connection field in login
                                                          // options was invalid. 
#define MGMT_ADDI_STATUS_INVALID_KEY    (32)      // Indicates that host driver has
                                                  // received invalid key - used in target
                                                  // mode driver.
#define MGMT_ADDI_STATUS_INVALID_DOMAIN (35)      // The domain number in the IOCTL header
                                                  // is invalid or out-of-range. The
                                                  // domain number passed-in to the IOCTL
                                                  // must be <= to the number of domains
                                                  // enabled by the manufacturer. Check
                                                  // the response data from
                                                  // IOCTL_COMMON_GET_CNTL_ATTRIBUTES to
                                                  // determine the actual number of
                                                  // domains supported. 
#define MGMT_ADDI_STATUS_LOGIN_INITIATOR_ERROR (43) // Indicates that the Target rejected
                                                    // the login stating Initiator error.
#define MGMT_ADDI_STATUS_LOGIN_AUTHENTICATION_ERROR (44) // Indicates that the Target
                                                         // rejected the login as
                                                         // Initiator could authenticate
                                                         // itself or Target
                                                         // authentication is not
                                                         // supported. 
#define MGMT_ADDI_STATUS_LOGIN_AUTHORIZATION_ERROR (45) // Indicates that the Target
                                                        // rejected the login as Initiator
                                                        // is not allowed to access this
                                                        // Target.
#define MGMT_ADDI_STATUS_LOGIN_NOT_FOUND (46)     // Indicates that the Target rejected
                                                  // the login as requested ITN not found
                                                  // at this Target address.
#define MGMT_ADDI_STATUS_LOGIN_TARGET_REMOVED (47) // Indicates that the Target rejected
                                                   // the login as the requested ITN is
                                                   // removed and forwarding address is
                                                   // not known. 
#define MGMT_ADDI_STATUS_LOGIN_UNSUPPORTED_VERSION (48) // Indicates that the Target
                                                        // rejected the login as the
                                                        // Initiator iSCSI version is not
                                                        // supported. 
#define MGMT_ADDI_STATUS_LOGIN_TOO_MANY_CONNECTIONS (49) // Indicates that the Target
                                                         // rejected the login as it has
                                                         // too many connections on this
                                                         // session. 
#define MGMT_ADDI_STATUS_LOGIN_MISSING_PARAMETER (50) // Indicates that the Target
                                                      // rejected the login stating that
                                                      // the Initiator missed some
                                                      // parameters while logging. 
#define MGMT_ADDI_STATUS_LOGIN_NO_SESSION_SPANNING (51) // Indicates that the Target
                                                        // rejected the login as Target
                                                        // does not support session
                                                        // spanning. 
#define MGMT_ADDI_STATUS_LOGIN_SESSION_TYPE_NOT_SUPPORTED (52) // Indicates that the
                                                               // Target rejected the
                                                               // login as it does not
                                                               // support this type of
                                                               // session or not from this
                                                               // Initiator. 
#define MGMT_ADDI_STATUS_LOGIN_SESSION_DOES_NOT_EXIST (53) // Indicates that Target
                                                           // rejected the login as
                                                           // Initiator tries to add a
                                                           // connection to a non-existent
                                                           // session. 
#define MGMT_ADDI_STATUS_LOGIN_INVALID_DURING_LOGIN (54) // Indicates that the Target
                                                         // rejected the login as
                                                         // Initiator sends an invalid
                                                         // request. 
#define MGMT_ADDI_STATUS_LOGIN_TARGET_ERROR (55)  // Indicates that the Target rejected
                                                  // the login as Target had some hardware
                                                  // or software error. 
#define MGMT_ADDI_STATUS_LOGIN_SERVICE_UNAVAILABLE (56) // Indicates that the Target
                                                        // rejected the login as the iSCSI
                                                        // service or Target is not
                                                        // operational. 
#define MGMT_ADDI_STATUS_LOGIN_OUT_OF_RESOURCES (57) // Indicates that the Target rejected
                                                     // the login as target has
                                                     // insufficient resources. 
#define MGMT_ADDI_STATUS_SAME_CHAP_SECRET (58)    // Login failed as the Initiator Chap
                                                  // secret is set to be the same as
                                                  // Target Chap secret. 
#define MGMT_ADDI_STATUS_INVALID_SECRET_LENGTH (59) // The provided Chap secret length is
                                                    // invalid according to iSCSI
                                                    // specifications. 
#define MGMT_ADDI_STATUS_DUPLICATE_ENTRY (60)     // An entry with same the attributes
                                                  // already exists with a different key.
#define MGMT_ADDI_STATUS_SETTINGS_MODIFIED_REBOOT_REQD (63) 
#define MGMT_ADDI_STATUS_INVALID_EXTENDED_TIMEOUT (64) // The extendend timeout programmed
                                                       // is invalid.
#define MGMT_ADDI_STATUS_INVALID_INTERFACE_HANDLE (65) // The provided device interface
                                                       // handle is invalid. 
#define MGMT_ADDI_STATUS_ERR_VLAN_ON_DEF_INTERFACE (66) // The VLAN could not be
                                                        // configured as this device
                                                        // cannot be configured with VLAN
                                                        // under the current iSCSI mode. 
#define MGMT_ADDI_STATUS_INTERFACE_DOES_NOT_EXIST (67) // The provided device interface
                                                       // handle is invalid. 
#define MGMT_ADDI_STATUS_INTERFACE_ALREADY_EXISTS (68) // The VLAN device cannot be
                                                       // created as it already exists. 
#define MGMT_ADDI_STATUS_INVALID_VLAN_RANGE (69)  // The VLAN device cannot be created as
                                                  // the VLAN ID is invalid. 
#define MGMT_ADDI_STATUS_ERR_SET_VLAN   (70)      // Indicates that the device could not
                                                  // be configured with the provided VLAN.
#define MGMT_ADDI_STATUS_ERR_DEL_VLAN   (71)      // Indicates that the VLAN could not be
                                                  // from the provided device interface
                                                  // handle. 
#define MGMT_ADDI_STATUS_CANNOT_DEL_DEF_INTERFACE (72) // Indicates that the interface
                                                       // could not be deleted as it is a
                                                       // permanent non-VLAN interface. 
#define MGMT_ADDI_STATUS_DHCP_REQ_ALREADY_PENDING (73) // Indicates that DHCP request
                                                       // could not be processed as DHCP
                                                       // request queue is full. 
#define MGMT_ADDI_STATUS_TOO_MANY_INTERFACES (74) // The VLAN could not be configured as
                                                  // the interface is already configured
                                                  // with the maximum number of VLANs
                                                  // allowed. 
#define MGMT_ADDI_STATUS_INVALID_REQUEST (75)     // Indicates that ARM received an
                                                  // illegal functional request.
#define MGMT_ADDI_STATUS_MAC_COLLISION  (76)      // The MAC address provided for the
                                                  // operation collides with one from the
                                                  // current MAC address list. 
#define MGMT_ADDI_STATUS_FLASH_IMAGE_CRC_MISMATCH (77) // The Flash Image write failed as
                                                       // the CRC is not matching.
#define MGMT_ADDI_STATUS_ISNS_NO_SERVER_FOUND (78) // The iSNS server IP was not found.
#define MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF (79) // The functions
                                                                   // assigned to the
                                                                   // requested PFs cannot
                                                                   // be changed. Check
                                                                   // PF#s in the IOCTL
                                                                   // request
#define MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE (80) // The PCI ID combination did
                                                             // not match any entry in our
                                                             // table 
#define MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED (81) // The PMW for this board
                                                               // does not support a
                                                               // personality change 
#define MGMT_ADDL_STATUS_PERSONALITY_ILLEGAL_REQUEST (82) // A personality change was
                                                          // failed due to one of the
                                                          // following reasons   -
                                                          // Non-storage function
                                                          // assignments were changed  -
                                                          // Storage functions had
                                                          // inconsistent assignments  -
                                                          // Storage functions were
                                                          // assigned an
                                                          // unsupported/unknown PCI
                                                          // function 
#define MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SUPPORTED (83) // Indicates that this loopback
                                                          // type is not supported on this
                                                          // HBA. 
#define MGMT_ADDI_STATUS_LOOPBACK_MODE_ALREADY_IN_LOOPBACK (84) // The port is already in
                                                                // a loopback state,only
                                                                // after exiting this
                                                                // loopback mode, a new
                                                                // loopback type can be
                                                                // applied.. 
#define MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SET (85) // This loopback mode is not
                                                    // set,loopback mode should be set
                                                    // using
                                                    // IOCTL_LOWLEVEL_ENABLE_DISABLE_LOOPB
                                                    // ACK_MODE before issuing this IOCTL.
#define MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE (96) // Applicable for VM-only. The
                                                     // privilege level assigned to the VM
                                                     // is insufficient to perform the
                                                     // requested operation. 
#define MGMT_ADDI_STATUS_NOT_A_PROXY_CALL (97)    // A PF can do some proxy calls for VF's
                                                  // it hosts. Ioctls like
                                                  // IOCTL_COMMON_SET_VF_PRIVILEGE will be
                                                  // initiated by PF in order to set
                                                  // privilege level to a VF. This error
                                                  // reports that fw is expecting a proxy
                                                  // call but thats not the case. 
#define MGMT_ADDI_STATUS_LOGIN_FAILED_OFFLOAD_ERR (98) // The iSCSI login operation was
                                                       // failed because the firmware
                                                       // found a network related problem
                                                       // when offloading the connection. 
#define MGMT_ADDI_STATUS_LOOPBACK_MODE_NO_MODULE (99) // Indicates that the module is not
                                                      // inserted for loopback test. 
#define MGMT_ADDI_STATUS_LOGIN_DIGEST_ERROR (100) // Indicates that the Data/Header Digest
                                                  // negotiation failed.
#define MGMT_ADDI_STATUS_LOGOUT_FAILED_IO_BUSY (101) // Logout was failed by the driver
                                                     // because the target is busy
                                                     // executing I/O requests. 
#define MGMT_ADDI_STATUS_LOGOUT_FAILED_TARGET_IN_RECOVERY (102) // Logout was failed by
                                                                // the driver because the
                                                                // target is in recovery. 

typedef enum {
   ENUM_MGMT_ADDI_STATUS_NO_STATUS = 0x0UL,
   ENUM_MGMT_ADDI_STATUS_INVALID_IPTYPE = 0x1UL,
   ENUM_MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND = 0x9UL,
   ENUM_MGMT_ADDI_STATUS_SESSION_HANDLE_NOT_FOUND = 0xaUL,
   ENUM_MGMT_ADDI_STATUS_CONNECTION_HANDLE_NOT_FOUND = 0xbUL,
   ENUM_MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT = 0x10UL,
   ENUM_MGMT_ADDI_STATUS_SESSION_ALREADY_OPENED = 0x11UL,
   ENUM_MGMT_ADDI_STATUS_SESSION_ALREADY_CLOSED = 0x12UL,
   ENUM_MGMT_ADDI_STATUS_DEST_HOST_UNREACHABLE = 0x13UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_IN_PROGRESS = 0x14UL,
   ENUM_MGMT_ADDI_STATUS_TCP_CONNECT_FAILED = 0x15UL,
   ENUM_MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES = 0x16UL,
   ENUM_MGMT_ADDI_STATUS_LINK_DOWN = 0x17UL,
   ENUM_MGMT_ADDI_STATUS_DHCP_ERROR = 0x18UL,
   ENUM_MGMT_ADDI_STATUS_CONNECTION_OFFLOADED = 0x19UL,
   ENUM_MGMT_ADDI_STATUS_CONNECTION_NOT_OFFLOADED = 0x1aUL,
   ENUM_MGMT_ADDI_STATUS_CONNECTION_UPLOAD_IN_PROGRESS = 0x1bUL,
   ENUM_MGMT_ADDI_STATUS_REQUEST_REJECTED = 0x1cUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_SUBSYSTEM = 0x1dUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_OPCODE = 0x1eUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_MAXCONNECTION_PARAM = 0x1fUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_KEY = 0x20UL,
   ENUM_MGMT_ADDI_STATUS_INVALID_DOMAIN = 0x23UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_INITIATOR_ERROR = 0x2bUL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_AUTHENTICATION_ERROR = 0x2cUL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_AUTHORIZATION_ERROR = 0x2dUL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_NOT_FOUND = 0x2eUL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_TARGET_REMOVED = 0x2fUL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_UNSUPPORTED_VERSION = 0x30UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_TOO_MANY_CONNECTIONS = 0x31UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_MISSING_PARAMETER = 0x32UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_NO_SESSION_SPANNING = 0x33UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_SESSION_TYPE_NOT_SUPPORTED = 0x34UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_SESSION_DOES_NOT_EXIST = 0x35UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_INVALID_DURING_LOGIN = 0x36UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_TARGET_ERROR = 0x37UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_SERVICE_UNAVAILABLE = 0x38UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_OUT_OF_RESOURCES = 0x39UL,
   ENUM_MGMT_ADDI_STATUS_SAME_CHAP_SECRET = 0x3aUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_SECRET_LENGTH = 0x3bUL,
   ENUM_MGMT_ADDI_STATUS_DUPLICATE_ENTRY = 0x3cUL,
   ENUM_MGMT_ADDI_STATUS_SETTINGS_MODIFIED_REBOOT_REQD = 0x3fUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_EXTENDED_TIMEOUT = 0x40UL,
   ENUM_MGMT_ADDI_STATUS_INVALID_INTERFACE_HANDLE = 0x41UL,
   ENUM_MGMT_ADDI_STATUS_ERR_VLAN_ON_DEF_INTERFACE = 0x42UL,
   ENUM_MGMT_ADDI_STATUS_INTERFACE_DOES_NOT_EXIST = 0x43UL,
   ENUM_MGMT_ADDI_STATUS_INTERFACE_ALREADY_EXISTS = 0x44UL,
   ENUM_MGMT_ADDI_STATUS_INVALID_VLAN_RANGE = 0x45UL,
   ENUM_MGMT_ADDI_STATUS_ERR_SET_VLAN = 0x46UL,
   ENUM_MGMT_ADDI_STATUS_ERR_DEL_VLAN = 0x47UL,
   ENUM_MGMT_ADDI_STATUS_CANNOT_DEL_DEF_INTERFACE = 0x48UL,
   ENUM_MGMT_ADDI_STATUS_DHCP_REQ_ALREADY_PENDING = 0x49UL,
   ENUM_MGMT_ADDI_STATUS_TOO_MANY_INTERFACES = 0x4aUL,
   ENUM_MGMT_ADDI_STATUS_INVALID_REQUEST = 0x4bUL,
   ENUM_MGMT_ADDI_STATUS_MAC_COLLISION = 0x4cUL,
   ENUM_MGMT_ADDI_STATUS_FLASH_IMAGE_CRC_MISMATCH = 0x4dUL,
   ENUM_MGMT_ADDI_STATUS_ISNS_NO_SERVER_FOUND = 0x4eUL,
   ENUM_MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF = 0x4fUL,
   ENUM_MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE = 0x50UL,
   ENUM_MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED = 0x51UL,
   ENUM_MGMT_ADDL_STATUS_PERSONALITY_ILLEGAL_REQUEST = 0x52UL,
   ENUM_MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SUPPORTED = 0x53UL,
   ENUM_MGMT_ADDI_STATUS_LOOPBACK_MODE_ALREADY_IN_LOOPBACK = 0x54UL,
   ENUM_MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SET = 0x55UL,
   ENUM_MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE = 0x60UL,
   ENUM_MGMT_ADDI_STATUS_NOT_A_PROXY_CALL = 0x61UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_FAILED_OFFLOAD_ERR = 0x62UL,
   ENUM_MGMT_ADDI_STATUS_LOOPBACK_MODE_NO_MODULE = 0x63UL,
   ENUM_MGMT_ADDI_STATUS_LOGIN_DIGEST_ERROR = 0x64UL,
   ENUM_MGMT_ADDI_STATUS_LOGOUT_FAILED_IO_BUSY = 0x65UL,
   ENUM_MGMT_ADDI_STATUS_LOGOUT_FAILED_TARGET_IN_RECOVERY = 0x66UL
} MGMT_ADDL_STATUS;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* mgmt_addl_status_get_name (u32 enum_value) {
      switch (enum_value) {
         case MGMT_ADDI_STATUS_NO_STATUS:
            return "MGMT_ADDI_STATUS_NO_STATUS";
         case MGMT_ADDI_STATUS_INVALID_IPTYPE:
            return "MGMT_ADDI_STATUS_INVALID_IPTYPE";
         case MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND:
            return "MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND";
         case MGMT_ADDI_STATUS_SESSION_HANDLE_NOT_FOUND:
            return "MGMT_ADDI_STATUS_SESSION_HANDLE_NOT_FOUND";
         case MGMT_ADDI_STATUS_CONNECTION_HANDLE_NOT_FOUND:
            return "MGMT_ADDI_STATUS_CONNECTION_HANDLE_NOT_FOUND";
         case MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT:
            return "MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT";
         case MGMT_ADDI_STATUS_SESSION_ALREADY_OPENED:
            return "MGMT_ADDI_STATUS_SESSION_ALREADY_OPENED";
         case MGMT_ADDI_STATUS_SESSION_ALREADY_CLOSED:
            return "MGMT_ADDI_STATUS_SESSION_ALREADY_CLOSED";
         case MGMT_ADDI_STATUS_DEST_HOST_UNREACHABLE:
            return "MGMT_ADDI_STATUS_DEST_HOST_UNREACHABLE";
         case MGMT_ADDI_STATUS_LOGIN_IN_PROGRESS:
            return "MGMT_ADDI_STATUS_LOGIN_IN_PROGRESS";
         case MGMT_ADDI_STATUS_TCP_CONNECT_FAILED:
            return "MGMT_ADDI_STATUS_TCP_CONNECT_FAILED";
         case MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES:
            return "MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES";
         case MGMT_ADDI_STATUS_LINK_DOWN:
            return "MGMT_ADDI_STATUS_LINK_DOWN";
         case MGMT_ADDI_STATUS_DHCP_ERROR:
            return "MGMT_ADDI_STATUS_DHCP_ERROR";
         case MGMT_ADDI_STATUS_CONNECTION_OFFLOADED:
            return "MGMT_ADDI_STATUS_CONNECTION_OFFLOADED";
         case MGMT_ADDI_STATUS_CONNECTION_NOT_OFFLOADED:
            return "MGMT_ADDI_STATUS_CONNECTION_NOT_OFFLOADED";
         case MGMT_ADDI_STATUS_CONNECTION_UPLOAD_IN_PROGRESS:
            return "MGMT_ADDI_STATUS_CONNECTION_UPLOAD_IN_PROGRESS";
         case MGMT_ADDI_STATUS_REQUEST_REJECTED:
            return "MGMT_ADDI_STATUS_REQUEST_REJECTED";
         case MGMT_ADDI_STATUS_INVALID_SUBSYSTEM:
            return "MGMT_ADDI_STATUS_INVALID_SUBSYSTEM";
         case MGMT_ADDI_STATUS_INVALID_OPCODE:
            return "MGMT_ADDI_STATUS_INVALID_OPCODE";
         case MGMT_ADDI_STATUS_INVALID_MAXCONNECTION_PARAM:
            return "MGMT_ADDI_STATUS_INVALID_MAXCONNECTION_PARAM";
         case MGMT_ADDI_STATUS_INVALID_KEY:
            return "MGMT_ADDI_STATUS_INVALID_KEY";
         case MGMT_ADDI_STATUS_INVALID_DOMAIN:
            return "MGMT_ADDI_STATUS_INVALID_DOMAIN";
         case MGMT_ADDI_STATUS_LOGIN_INITIATOR_ERROR:
            return "MGMT_ADDI_STATUS_LOGIN_INITIATOR_ERROR";
         case MGMT_ADDI_STATUS_LOGIN_AUTHENTICATION_ERROR:
            return "MGMT_ADDI_STATUS_LOGIN_AUTHENTICATION_ERROR";
         case MGMT_ADDI_STATUS_LOGIN_AUTHORIZATION_ERROR:
            return "MGMT_ADDI_STATUS_LOGIN_AUTHORIZATION_ERROR";
         case MGMT_ADDI_STATUS_LOGIN_NOT_FOUND:
            return "MGMT_ADDI_STATUS_LOGIN_NOT_FOUND";
         case MGMT_ADDI_STATUS_LOGIN_TARGET_REMOVED:
            return "MGMT_ADDI_STATUS_LOGIN_TARGET_REMOVED";
         case MGMT_ADDI_STATUS_LOGIN_UNSUPPORTED_VERSION:
            return "MGMT_ADDI_STATUS_LOGIN_UNSUPPORTED_VERSION";
         case MGMT_ADDI_STATUS_LOGIN_TOO_MANY_CONNECTIONS:
            return "MGMT_ADDI_STATUS_LOGIN_TOO_MANY_CONNECTIONS";
         case MGMT_ADDI_STATUS_LOGIN_MISSING_PARAMETER:
            return "MGMT_ADDI_STATUS_LOGIN_MISSING_PARAMETER";
         case MGMT_ADDI_STATUS_LOGIN_NO_SESSION_SPANNING:
            return "MGMT_ADDI_STATUS_LOGIN_NO_SESSION_SPANNING";
         case MGMT_ADDI_STATUS_LOGIN_SESSION_TYPE_NOT_SUPPORTED:
            return "MGMT_ADDI_STATUS_LOGIN_SESSION_TYPE_NOT_SUPPORTED";
         case MGMT_ADDI_STATUS_LOGIN_SESSION_DOES_NOT_EXIST:
            return "MGMT_ADDI_STATUS_LOGIN_SESSION_DOES_NOT_EXIST";
         case MGMT_ADDI_STATUS_LOGIN_INVALID_DURING_LOGIN:
            return "MGMT_ADDI_STATUS_LOGIN_INVALID_DURING_LOGIN";
         case MGMT_ADDI_STATUS_LOGIN_TARGET_ERROR:
            return "MGMT_ADDI_STATUS_LOGIN_TARGET_ERROR";
         case MGMT_ADDI_STATUS_LOGIN_SERVICE_UNAVAILABLE:
            return "MGMT_ADDI_STATUS_LOGIN_SERVICE_UNAVAILABLE";
         case MGMT_ADDI_STATUS_LOGIN_OUT_OF_RESOURCES:
            return "MGMT_ADDI_STATUS_LOGIN_OUT_OF_RESOURCES";
         case MGMT_ADDI_STATUS_SAME_CHAP_SECRET:
            return "MGMT_ADDI_STATUS_SAME_CHAP_SECRET";
         case MGMT_ADDI_STATUS_INVALID_SECRET_LENGTH:
            return "MGMT_ADDI_STATUS_INVALID_SECRET_LENGTH";
         case MGMT_ADDI_STATUS_DUPLICATE_ENTRY:
            return "MGMT_ADDI_STATUS_DUPLICATE_ENTRY";
         case MGMT_ADDI_STATUS_SETTINGS_MODIFIED_REBOOT_REQD:
            return "MGMT_ADDI_STATUS_SETTINGS_MODIFIED_REBOOT_REQD";
         case MGMT_ADDI_STATUS_INVALID_EXTENDED_TIMEOUT:
            return "MGMT_ADDI_STATUS_INVALID_EXTENDED_TIMEOUT";
         case MGMT_ADDI_STATUS_INVALID_INTERFACE_HANDLE:
            return "MGMT_ADDI_STATUS_INVALID_INTERFACE_HANDLE";
         case MGMT_ADDI_STATUS_ERR_VLAN_ON_DEF_INTERFACE:
            return "MGMT_ADDI_STATUS_ERR_VLAN_ON_DEF_INTERFACE";
         case MGMT_ADDI_STATUS_INTERFACE_DOES_NOT_EXIST:
            return "MGMT_ADDI_STATUS_INTERFACE_DOES_NOT_EXIST";
         case MGMT_ADDI_STATUS_INTERFACE_ALREADY_EXISTS:
            return "MGMT_ADDI_STATUS_INTERFACE_ALREADY_EXISTS";
         case MGMT_ADDI_STATUS_INVALID_VLAN_RANGE:
            return "MGMT_ADDI_STATUS_INVALID_VLAN_RANGE";
         case MGMT_ADDI_STATUS_ERR_SET_VLAN:
            return "MGMT_ADDI_STATUS_ERR_SET_VLAN";
         case MGMT_ADDI_STATUS_ERR_DEL_VLAN:
            return "MGMT_ADDI_STATUS_ERR_DEL_VLAN";
         case MGMT_ADDI_STATUS_CANNOT_DEL_DEF_INTERFACE:
            return "MGMT_ADDI_STATUS_CANNOT_DEL_DEF_INTERFACE";
         case MGMT_ADDI_STATUS_DHCP_REQ_ALREADY_PENDING:
            return "MGMT_ADDI_STATUS_DHCP_REQ_ALREADY_PENDING";
         case MGMT_ADDI_STATUS_TOO_MANY_INTERFACES:
            return "MGMT_ADDI_STATUS_TOO_MANY_INTERFACES";
         case MGMT_ADDI_STATUS_INVALID_REQUEST:
            return "MGMT_ADDI_STATUS_INVALID_REQUEST";
         case MGMT_ADDI_STATUS_MAC_COLLISION:
            return "MGMT_ADDI_STATUS_MAC_COLLISION";
         case MGMT_ADDI_STATUS_FLASH_IMAGE_CRC_MISMATCH:
            return "MGMT_ADDI_STATUS_FLASH_IMAGE_CRC_MISMATCH";
         case MGMT_ADDI_STATUS_ISNS_NO_SERVER_FOUND:
            return "MGMT_ADDI_STATUS_ISNS_NO_SERVER_FOUND";
         case MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF:
            return "MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF";
         case MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE:
            return "MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE";
         case MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED:
            return "MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED";
         case MGMT_ADDL_STATUS_PERSONALITY_ILLEGAL_REQUEST:
            return "MGMT_ADDL_STATUS_PERSONALITY_ILLEGAL_REQUEST";
         case MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SUPPORTED:
            return "MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SUPPORTED";
         case MGMT_ADDI_STATUS_LOOPBACK_MODE_ALREADY_IN_LOOPBACK:
            return "MGMT_ADDI_STATUS_LOOPBACK_MODE_ALREADY_IN_LOOPBACK";
         case MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SET:
            return "MGMT_ADDI_STATUS_LOOPBACK_MODE_NOT_SET";
         case MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE:
            return "MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE";
         case MGMT_ADDI_STATUS_NOT_A_PROXY_CALL:
            return "MGMT_ADDI_STATUS_NOT_A_PROXY_CALL";
         case MGMT_ADDI_STATUS_LOGIN_FAILED_OFFLOAD_ERR:
            return "MGMT_ADDI_STATUS_LOGIN_FAILED_OFFLOAD_ERR";
         case MGMT_ADDI_STATUS_LOOPBACK_MODE_NO_MODULE:
            return "MGMT_ADDI_STATUS_LOOPBACK_MODE_NO_MODULE";
         case MGMT_ADDI_STATUS_LOGIN_DIGEST_ERROR:
            return "MGMT_ADDI_STATUS_LOGIN_DIGEST_ERROR";
         case MGMT_ADDI_STATUS_LOGOUT_FAILED_IO_BUSY:
            return "MGMT_ADDI_STATUS_LOGOUT_FAILED_IO_BUSY";
         case MGMT_ADDI_STATUS_LOGOUT_FAILED_TARGET_IN_RECOVERY:
            return "MGMT_ADDI_STATUS_LOGOUT_FAILED_TARGET_IN_RECOVERY";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_opcodes_amap_h__

